/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var X=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/base/common/path","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/platform/log/common/log","vs/base/common/resources","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/base/common/strings","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/platform/userDataSync/common/userDataSync","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/configuration/common/configurationRegistry","vs/base/common/map","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","child_process","vs/base/common/errorMessage","vs/platform/product/common/product","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/codicons","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],Q=function(G){for(var e=[],S=0,L=G.length;S<L;S++)e[S]=X[G[S]];return e};define(X[87],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function S(L,P){if(!L)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=S}),define(X[63],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const S=Object.prototype.hasOwnProperty;function L(n){const y=[];for(let v in n)S.call(n,v)&&y.push(n[v]);return y}e.values=L;function P(n,y){for(let v in n)if(S.call(n,v)&&y({key:v,value:n[v]},function(){delete n[v]})===!1)return}e.forEach=P;function k(n,y){const v=Object.create(null);for(const m of n){const h=y(m);let C=v[h];C||(C=v[h]=[]),C.push(m)}return v}e.groupBy=k;function A(n){const y=Object.create(null);return n&&n.forEach((v,m)=>{y[m]=v}),y}e.fromMap=A;function R(n,y){const v=[],m=[];for(let h of n)y.has(h)||v.push(h);for(let h of y)n.has(h)||m.push(h);return{removed:v,added:m}}e.diffSets=R;function p(n,y){const v=[],m=[];for(let[h,C]of n)y.has(h)||v.push(C);for(let[h,C]of y)n.has(h)||m.push(C);return{removed:v,added:m}}e.diffMaps=p;class E{constructor(){this.map=new Map}add(y,v){let m=this.map.get(y);m||(m=new Set,this.map.set(y,m)),m.add(v)}delete(y,v){const m=this.map.get(y);!m||(m.delete(v),m.size===0&&this.map.delete(y))}forEach(y,v){const m=this.map.get(y);!m||m.forEach(v)}}e.SetMap=E}),define(X[64],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function S(A){return(R,p,E)=>{let n=null,y=null;if(typeof E.value=="function"?(n="value",y=E.value):typeof E.get=="function"&&(n="get",y=E.get),!y)throw new Error("not supported");E[n]=A(y,p)}}e.createDecorator=S;function L(A,R,p){let E=null,n=null;if(typeof p.value=="function"?(E="value",n=p.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(E="get",n=p.get),!n)throw new Error("not supported");const y=`$memoize$${R}`;p[E]=function(...v){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,v)}),this[y]}}e.memoize=L;function P(A,R,p){return S((E,n)=>{const y=`$debounce$${n}`,v=`$debounce$result$${n}`;return function(...m){this[v]||(this[v]=p?p():void 0),clearTimeout(this[y]),R&&(this[v]=R(this[v],...m),m=[this[v]]),this[y]=setTimeout(()=>{E.apply(this,m),this[v]=p?p():void 0},A)}})}e.debounce=P;function k(A,R,p){return S((E,n)=>{const y=`$throttle$timer$${n}`,v=`$throttle$result$${n}`,m=`$throttle$lastRun$${n}`,h=`$throttle$pending$${n}`;return function(...C){if(this[v]||(this[v]=p?p():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),R&&(this[v]=R(this[v],...C)),this[h])return;const D=this[m]+A;D<=Date.now()?(this[m]=Date.now(),E.apply(this,[this[v]]),this[v]=p?p():void 0):(this[h]=!0,this[y]=setTimeout(()=>{this[h]=!1,this[m]=Date.now(),E.apply(this,[this[v]]),this[v]=p?p():void 0},D-Date.now()))}})}e.throttle=k}),define(X[9],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=S,e.errorHandler=new S;function L(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=L;function P(c){p(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=P;function k(c){p(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=k;function A(c){if(c instanceof Error){let{name:t,message:r}=c;const i=c.stacktrace||c.stack;return{$isError:!0,name:t,message:r,stack:i}}return c}e.transformErrorForSerialization=A;const R="Canceled";function p(c){return c instanceof Error&&c.name===R&&c.message===R}e.isPromiseCanceledError=p;class E extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=E;function n(){const c=new Error(R);return c.name=c.message,c}e.canceled=n;function y(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=y;function v(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=v;function m(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function h(c){const t=new Error(`${c} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function C(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=C;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;function f(c){const t=c;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=f;function s(c,t=Object.create(null)){const r=new Error(c);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=s}),define(X[23],Q([0,1,9]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(F,U=0){return F[F.length-(1+U)]}e.tail=L;function P(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=P;function k(F,U,x=(q,H)=>q===H){if(F===U)return!0;if(!F||!U||F.length!==U.length)return!1;for(let q=0,H=F.length;q<H;q++)if(!x(F[q],U[q]))return!1;return!0}e.equals=k;function A(F,U,x){let q=0,H=F.length-1;for(;q<=H;){const Y=(q+H)/2|0,te=x(F[Y],U);if(te<0)q=Y+1;else if(te>0)H=Y-1;else return Y}return-(q+1)}e.binarySearch=A;function R(F,U){let x=0,q=F.length;if(q===0)return 0;for(;x<q;){const H=Math.floor((x+q)/2);U(F[H])?q=H:x=H+1}return x}e.findFirstInSorted=R;function p(F,U,x){if(F=F|0,F>=U.length)throw new TypeError("invalid index");let q=U[Math.floor(U.length*Math.random())],H=[],Y=[],te=[];for(let ne of U){const se=x(ne,q);se<0?H.push(ne):se>0?Y.push(ne):te.push(ne)}return F<H.length?p(F,H,x):F<H.length+te.length?te[0]:p(F-(H.length+te.length),Y,x)}e.quickSelect=p;function E(F,U){const x=[];let q;for(const H of F.slice(0).sort(U))!q||U(q[0],H)!==0?(q=[H],x.push(q)):q.push(H);return x}e.groupBy=E;function n(F,U,x){const q=[];function H(ne,se,ee){if(se===0&&ee.length===0)return;const he=q[q.length-1];he&&he.start+he.deleteCount===ne?(he.deleteCount+=se,he.toInsert.push(...ee)):q.push({start:ne,deleteCount:se,toInsert:ee})}let Y=0,te=0;for(;;){if(Y===F.length){H(Y,0,U.slice(te));break}if(te===U.length){H(Y,F.length-Y,[]);break}const ne=F[Y],se=U[te],ee=x(ne,se);ee===0?(Y+=1,te+=1):ee<0?(H(Y,1,[]),Y+=1):ee>0&&(H(Y,0,[se]),te+=1)}return q}e.sortedDiff=n;function y(F,U,x){const q=n(F,U,x),H=[],Y=[];for(const te of q)H.push(...F.slice(te.start,te.start+te.deleteCount)),Y.push(...te.toInsert);return{removed:H,added:Y}}e.delta=y;function v(F,U,x){if(x===0)return[];const q=F.slice(0,x).sort(U);return h(F,U,q,x,F.length),q}e.top=v;function m(F,U,x,q,H){return x===0?Promise.resolve([]):new Promise((Y,te)=>{(async()=>{const ne=F.length,se=F.slice(0,x).sort(U);for(let ee=x,he=Math.min(x+q,ne);ee<ne;ee=he,he=Math.min(he+q,ne)){if(ee>x&&await new Promise(de=>setTimeout(de)),H&&H.isCancellationRequested)throw(0,S.canceled)();h(F,U,se,ee,he)}return se})().then(Y,te)})}e.topAsync=m;function h(F,U,x,q,H){for(const Y=x.length;q<H;q++){const te=F[q];if(U(te,x[Y-1])<0){x.pop();const ne=R(x,se=>U(te,se)<0);x.splice(ne,0,te)}}}function C(F){return F.filter(U=>!!U)}e.coalesce=C;function D(F){let U=0;for(let x=0;x<F.length;x++)F[x]&&(F[U]=F[x],U+=1);F.length=U}e.coalesceInPlace=D;function b(F,U,x){F.splice(x,0,F.splice(U,1)[0])}e.move=b;function I(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=I;function f(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=f;function s(F,U){if(!U)return F.filter((q,H)=>F.indexOf(q)===H);const x=Object.create(null);return F.filter(q=>{const H=U(q);return x[H]?!1:(x[H]=!0,!0)})}e.distinct=s;function c(F){const U=new Set;return F.filter(x=>U.has(x)?!1:(U.add(x),!0))}e.distinctES6=c;function t(F){const U=Object.create(null);return x=>{const q=F(x);return U[q]?!1:(U[q]=!0,!0)}}e.uniqueFilter=t;function r(F,U){for(let x=F.length-1;x>=0;x--){const q=F[x];if(U(q))return x}return-1}e.lastIndex=r;function i(F,U){return F.length>0?F[0]:U}e.firstOrDefault=i;function a(F,U,x=(q,H)=>q===H){let q=0;for(let H=0,Y=Math.min(F.length,U.length);H<Y&&x(F[H],U[H]);H++)q++;return q}e.commonPrefixLength=a;function l(F){return[].concat(...F)}e.flatten=l;function o(F,U){let x=typeof U=="number"?F:0;typeof U=="number"?x=F:(x=0,U=F);const q=[];if(x<=U)for(let H=x;H<U;H++)q.push(H);else for(let H=x;H>U;H--)q.push(H);return q}e.range=o;function u(F,U,x){return F.reduce((q,H)=>(q[U(H)]=x?x(H):H,q),Object.create(null))}e.index=u;function g(F,U){return F.push(U),()=>w(F,U)}e.insert=g;function w(F,U){const x=F.indexOf(U);if(x>-1)return F.splice(x,1),U}e.remove=w;function d(F,U,x){const q=F.slice(0,U),H=F.slice(U);return q.concat(x,H)}e.arrayInsert=d;function T(F,U){let x;if(typeof U=="number"){let q=U;x=()=>{const H=Math.sin(q++)*179426549;return H-Math.floor(H)}}else x=Math.random;for(let q=F.length-1;q>0;q-=1){const H=Math.floor(x()*(q+1)),Y=F[q];F[q]=F[H],F[H]=Y}}e.shuffle=T;function O(F,U){const x=F.indexOf(U);x>-1&&(F.splice(x,1),F.unshift(U))}e.pushToStart=O;function $(F,U){const x=F.indexOf(U);x>-1&&(F.splice(x,1),F.push(U))}e.pushToEnd=$;function z(F,U){return Array.isArray(F)?F.map(U):U(F)}e.mapArrayOrNot=z;function V(F){return Array.isArray(F)?F:[F]}e.asArray=V;function B(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=B;function M(F,U){for(const x of F){const q=U(x);if(q!==void 0)return q}}e.mapFind=M;function _(F,U){let x=Number.MAX_SAFE_INTEGER,q=0;return F.forEach((H,Y)=>{const te=U(H);te<x&&(x=te,q=Y)}),q}e.minIndex=_;function N(F,U){let x=Number.MIN_SAFE_INTEGER,q=0;return F.forEach((H,Y)=>{const te=U(H);te>x&&(x=te,q=Y)}),q}e.maxIndex=N;class j{constructor(U){this.items=U,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(U){let x=this.firstIdx;for(;x<this.items.length&&U(this.items[x]);)x++;const q=x===this.firstIdx?null:this.items.slice(this.firstIdx,x);return this.firstIdx=x,q}takeFromEndWhile(U){let x=this.lastIdx;for(;x>=0&&U(this.items[x]);)x--;const q=x===this.lastIdx?null:this.items.slice(x+1,this.lastIdx+1);return this.lastIdx=x,q}}e.ArrayQueue=j}),define(X[65],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(L){const P=this;let k=!1,A;return function(){return k||(k=!0,A=L.apply(P,arguments)),A}}e.once=S}),define(X[53],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(L){function P(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}L.is=P;const k=Object.freeze([]);function A(){return k}L.empty=A;function*R(c){yield c}L.single=R;function p(c){return c||k}L.from=p;function E(c){return!c||c[Symbol.iterator]().next().done===!0}L.isEmpty=E;function n(c){return c[Symbol.iterator]().next().value}L.first=n;function y(c,t){for(const r of c)if(t(r))return!0;return!1}L.some=y;function v(c,t){for(const r of c)if(t(r))return r}L.find=v;function*m(c,t){for(const r of c)t(r)&&(yield r)}L.filter=m;function*h(c,t){let r=0;for(const i of c)yield t(i,r++)}L.map=h;function*C(...c){for(const t of c)for(const r of t)yield r}L.concat=C;function*D(c){for(const t of c)for(const r of t)yield r}L.concatNested=D;function b(c,t,r){let i=r;for(const a of c)i=t(i,a);return i}L.reduce=b;function*I(c,t,r=c.length){for(t<0&&(t+=c.length),r<0?r+=c.length:r>c.length&&(r=c.length);t<r;t++)yield c[t]}L.slice=I;function f(c,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,c];const i=c[Symbol.iterator]();for(let a=0;a<t;a++){const l=i.next();if(l.done)return[r,L.empty()];r.push(l.value)}return[r,{[Symbol.iterator](){return i}}]}L.consume=f;function s(c,t,r=(i,a)=>i===a){const i=c[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const l=i.next(),o=a.next();if(l.done!==o.done)return!1;if(l.done)return!0;if(!r(l.value,o.value))return!1}}L.equals=s})(S=e.Iterable||(e.Iterable={}))}),define(X[33],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function A(t,r=!1){let i=0,a=t.length,l="",o=0,u=16,g=0;function w(B){let M=0,_=0;for(;M<B;){const N=t.charCodeAt(i);if(N>=48&&N<=57)_=_*16+N-48;else if(N>=65&&N<=70)_=_*16+N-65+10;else if(N>=97&&N<=102)_=_*16+N-97+10;else break;i++,M++}return M<B&&(_=-1),_}function d(B){i=B,l="",o=0,u=16,g=0}function T(){const B=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&E(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&E(t.charCodeAt(i)))for(i++;i<t.length&&E(t.charCodeAt(i));)i++;else return g=3,t.substring(B,i);let M=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&E(t.charCodeAt(i))){for(i++;i<t.length&&E(t.charCodeAt(i));)i++;M=i}else g=3;return t.substring(B,M)}function O(){let B="",M=i;for(;;){if(i>=a){B+=t.substring(M,i),g=2;break}const _=t.charCodeAt(i);if(_===34){B+=t.substring(M,i),i++;break}if(_===92){if(B+=t.substring(M,i),i++,i>=a){g=2;break}switch(t.charCodeAt(i++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const j=w(4);j>=0?B+=String.fromCharCode(j):g=4;break;default:g=5}M=i;continue}if(_>=0&&_<=31)if(p(_)){B+=t.substring(M,i),g=2;break}else g=6;i++}return B}function $(){if(l="",g=0,o=i,i>=a)return o=a,u=17;let B=t.charCodeAt(i);if(R(B)){do i++,l+=String.fromCharCode(B),B=t.charCodeAt(i);while(R(B));return u=15}if(p(B))return i++,l+=String.fromCharCode(B),B===13&&t.charCodeAt(i)===10&&(i++,l+=`
`),u=14;switch(B){case 123:return i++,u=1;case 125:return i++,u=2;case 91:return i++,u=3;case 93:return i++,u=4;case 58:return i++,u=6;case 44:return i++,u=5;case 34:return i++,l=O(),u=10;case 47:const M=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<a&&!p(t.charCodeAt(i));)i++;return l=t.substring(M,i),u=12}if(t.charCodeAt(i+1)===42){i+=2;const _=a-1;let N=!1;for(;i<_;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,N=!0;break}i++}return N||(i++,g=1),l=t.substring(M,i),u=13}return l+=String.fromCharCode(B),i++,u=16;case 45:if(l+=String.fromCharCode(B),i++,i===a||!E(t.charCodeAt(i)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=T(),u=11;default:for(;i<a&&z(B);)i++,B=t.charCodeAt(i);if(o!==i){switch(l=t.substring(o,i),l){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return l+=String.fromCharCode(B),i++,u=16}}function z(B){if(R(B)||p(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let B;do B=$();while(B>=12&&B<=15);return B}return{setPosition:d,getPosition:()=>i,scan:r?V:$,getToken:()=>u,getTokenValue:()=>l,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>g}}e.createScanner=A;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function y(t,r){const i=[],a=new Object;let l;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function g(w,d,T,O){o.value=w,o.offset=d,o.length=T,o.type=O,o.colonOffset=void 0,l=o}try{f(t,{onObjectBegin:(w,d)=>{if(r<=w)throw a;l=void 0,u=r>w,i.push("")},onObjectProperty:(w,d,T)=>{if(r<d||(g(w,d,T,"property"),i[i.length-1]=w,r<=d+T))throw a},onObjectEnd:(w,d)=>{if(r<=w)throw a;l=void 0,i.pop()},onArrayBegin:(w,d)=>{if(r<=w)throw a;l=void 0,i.push(0)},onArrayEnd:(w,d)=>{if(r<=w)throw a;l=void 0,i.pop()},onLiteralValue:(w,d,T)=>{if(r<d||(g(w,d,T,c(w)),r<=d+T))throw a},onSeparator:(w,d,T)=>{if(r<=d)throw a;if(w===":"&&l&&l.type==="property")l.colonOffset=d,u=!1,l=void 0;else if(w===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(u=!0,i[i.length-1]=""),l=void 0}}})}catch(w){if(w!==a)throw w}return{path:i,previousNode:l,isAtPropertyKey:u,matches:w=>{let d=0;for(let T=0;d<w.length&&T<i.length;T++)if(w[d]===i[T]||w[d]==="*")d++;else if(w[d]!=="**")return!1;return d===w.length}}}e.getLocation=y;function v(t,r=[],i=k.DEFAULT){let a=null,l=[];const o=[];function u(w){Array.isArray(l)?l.push(w):a!==null&&(l[a]=w)}return f(t,{onObjectBegin:()=>{const w={};u(w),o.push(l),l=w,a=null},onObjectProperty:w=>{a=w},onObjectEnd:()=>{l=o.pop()},onArrayBegin:()=>{const w=[];u(w),o.push(l),l=w,a=null},onArrayEnd:()=>{l=o.pop()},onLiteralValue:u,onError:(w,d,T)=>{r.push({error:w,offset:d,length:T})}},i),l[0]}e.parse=v;function m(t,r=[],i=k.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(w){a.type==="property"&&(a.length=w-a.offset,a=a.parent)}function o(w){return a.children.push(w),w}f(t,{onObjectBegin:w=>{a=o({type:"object",offset:w,length:-1,parent:a,children:[]})},onObjectProperty:(w,d,T)=>{a=o({type:"property",offset:d,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:w,offset:d,length:T,parent:a})},onObjectEnd:(w,d)=>{a.length=w+d-a.offset,a=a.parent,l(w+d)},onArrayBegin:(w,d)=>{a=o({type:"array",offset:w,length:-1,parent:a,children:[]})},onArrayEnd:(w,d)=>{a.length=w+d-a.offset,a=a.parent,l(w+d)},onLiteralValue:(w,d,T)=>{o({type:c(w),offset:d,length:T,parent:a,value:w}),l(d+T)},onSeparator:(w,d,T)=>{a.type==="property"&&(w===":"?a.colonOffset=d:w===","&&l(d))},onError:(w,d,T)=>{r.push({error:w,offset:d,length:T})}},i);const g=a.children[0];return g&&delete g.parent,g}e.parseTree=m;function h(t,r){if(!t)return;let i=t;for(let a of r)if(typeof a=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let l=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===a){i=o.children[1],l=!0;break}if(!l)return}else{const l=a;if(i.type!=="array"||l<0||!Array.isArray(i.children)||l>=i.children.length)return;i=i.children[l]}return i}e.findNodeAtLocation=h;function C(t){if(!t.parent||!t.parent.children)return[];const r=C(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=C;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const r=Object.create(null);for(let i of t.children){const a=i.children[1];a&&(r[i.children[0].value]=D(a))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function b(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=b;function I(t,r,i=!1){if(b(t,r,i)){const a=t.children;if(Array.isArray(a))for(let l=0;l<a.length&&a[l].offset<=r;l++){const o=I(a[l],r,i);if(o)return o}return t}}e.findNodeAtOffset=I;function f(t,r,i=k.DEFAULT){const a=A(t,!1);function l(Y){return Y?()=>Y(a.getTokenOffset(),a.getTokenLength()):()=>!0}function o(Y){return Y?te=>Y(te,a.getTokenOffset(),a.getTokenLength()):()=>!0}const u=l(r.onObjectBegin),g=o(r.onObjectProperty),w=l(r.onObjectEnd),d=l(r.onArrayBegin),T=l(r.onArrayEnd),O=o(r.onLiteralValue),$=o(r.onSeparator),z=l(r.onComment),V=o(r.onError),B=i&&i.disallowComments,M=i&&i.allowTrailingComma;function _(){for(;;){const Y=a.scan();switch(a.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:B||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(Y){case 12:case 13:B?N(10):z();break;case 16:N(1);break;case 15:case 14:break;default:return Y}}}function N(Y,te=[],ne=[]){if(V(Y),te.length+ne.length>0){let se=a.getToken();for(;se!==17;){if(te.indexOf(se)!==-1){_();break}else if(ne.indexOf(se)!==-1)break;se=_()}}}function j(Y){const te=a.getTokenValue();return Y?O(te):g(te),_(),!0}function F(){switch(a.getToken()){case 11:let Y=0;try{Y=JSON.parse(a.getTokenValue()),typeof Y!="number"&&(N(2),Y=0)}catch(te){N(2)}O(Y);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return _(),!0}function U(){return a.getToken()!==10?(N(3,[],[2,5]),!1):(j(!1),a.getToken()===6?($(":"),_(),H()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function x(){u(),_();let Y=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(Y||N(4,[],[]),$(","),_(),a.getToken()===2&&M)break}else Y&&N(6,[],[]);U()||N(4,[],[2,5]),Y=!0}return w(),a.getToken()!==2?N(7,[2],[]):_(),!0}function q(){d(),_();let Y=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(Y||N(4,[],[]),$(","),_(),a.getToken()===4&&M)break}else Y&&N(6,[],[]);H()||N(4,[],[4,5]),Y=!0}return T(),a.getToken()!==4?N(8,[4],[]):_(),!0}function H(){switch(a.getToken()){case 3:return q();case 1:return x();case 10:return j(!0);default:return F()}}return _(),a.getToken()===17?i.allowEmptyContent?!0:(N(4,[],[]),!1):H()?(a.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=f;function s(t,r){let i=A(t),a=[],l,o=0,u;do switch(u=i.getPosition(),l=i.scan(),l){case 12:case 13:case 17:o!==u&&a.push(t.substring(o,u)),r!==void 0&&a.push(i.getTokenValue().replace(/[^\r\n]/g,r)),o=i.getPosition();break}while(l!==17);return a.join("")}e.stripComments=s;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(X[47],Q([0,1,33]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(p,E,n){let y,v,m,h,C;if(E){for(h=E.offset,C=h+E.length,m=h;m>0&&!R(p,m-1);)m--;let o=C;for(;o<p.length&&!R(p,o);)o++;v=p.substring(m,o),y=k(v,n)}else v=p,y=0,m=0,h=0,C=p.length;const D=A(n,p);let b=!1,I=0,f;n.insertSpaces?f=P(" ",n.tabSize||4):f="	";const s=(0,S.createScanner)(v,!1);let c=!1;function t(){return D+P(f,y+I)}function r(){let o=s.scan();for(b=!1;o===15||o===14;)b=b||o===14,o=s.scan();return c=o===16||s.getTokenError()!==0,o}const i=[];function a(o,u,g){!c&&u<C&&g>h&&p.substring(u,g)!==o&&i.push({offset:u,length:g-u,content:o})}let l=r();if(l!==17){const o=s.getTokenOffset()+m,u=P(f,y);a(u,m,o)}for(;l!==17;){let o=s.getTokenOffset()+s.getTokenLength()+m,u=r(),g="";for(;!b&&(u===12||u===13);){const d=s.getTokenOffset()+m;a(" ",o,d),o=s.getTokenOffset()+s.getTokenLength()+m,g=u===12?t():"",u=r()}if(u===2)l!==1&&(I--,g=t());else if(u===4)l!==3&&(I--,g=t());else{switch(l){case 3:case 1:I++,g=t();break;case 5:case 12:g=t();break;case 13:b?g=t():g=" ";break;case 6:g=" ";break;case 10:if(u===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?g=" ":u!==5&&u!==17&&(c=!0);break;case 16:c=!0;break}b&&(u===12||u===13)&&(g=t())}const w=s.getTokenOffset()+m;a(g,o,w),l=u}return i}e.format=L;function P(p,E){let n="";for(let y=0;y<E;y++)n+=p;return n}function k(p,E){let n=0,y=0;const v=E.tabSize||4;for(;n<p.length;){const m=p.charAt(n);if(m===" ")y++;else if(m==="	")y+=v;else break;n++}return Math.floor(y/v)}function A(p,E){for(let n=0;n<E.length;n++){const y=E.charAt(n);if(y==="\r")return n+1<E.length&&E.charAt(n+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=A;function R(p,E){return`\r
`.indexOf(p.charAt(E))!==-1}e.isEOL=R}),define(X[40],Q([0,1,33,47]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function P(E,n,y){return k(E,n,void 0,y)}e.removeProperty=P;function k(E,n,y,v,m){const h=n.slice(),C=[],D=(0,S.parseTree)(E,C);let b,I;for(;h.length>0&&(I=h.pop(),b=(0,S.findNodeAtLocation)(D,h),b===void 0&&y!==void 0);)typeof I=="string"?y={[I]:y}:y=[y];if(b)if(b.type==="object"&&typeof I=="string"&&Array.isArray(b.children)){const f=(0,S.findNodeAtLocation)(b,[I]);if(f!==void 0)if(y===void 0){if(!f.parent)throw new Error("Malformed AST");const s=b.children.indexOf(f.parent);let c,t=f.parent.offset+f.parent.length;if(s>0){const r=b.children[s-1];c=r.offset+r.length}else c=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return A(E,{offset:c,length:t-c,content:""},v)}else return A(E,{offset:f.offset,length:f.length,content:JSON.stringify(y)},v);else{if(y===void 0)return[];const s=`${JSON.stringify(I)}: ${JSON.stringify(y)}`,c=m?m(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(c>0){const r=b.children[c-1];t={offset:r.offset+r.length,length:0,content:","+s}}else b.children.length===0?t={offset:b.offset+1,length:0,content:s}:t={offset:b.offset+1,length:0,content:s+","};return A(E,t,v)}}else if(b.type==="array"&&typeof I=="number"&&Array.isArray(b.children))if(y!==void 0){const f=`${JSON.stringify(y)}`;let s;if(b.children.length===0||I===0)s={offset:b.offset+1,length:0,content:b.children.length===0?f:f+","};else{const c=I===-1||I>b.children.length?b.children.length:I,t=b.children[c-1];s={offset:t.offset+t.length,length:0,content:","+f}}return A(E,s,v)}else{const f=I,s=b.children[f];let c;if(b.children.length===1)c={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===f){const t=b.children[f-1],r=t.offset+t.length,i=b.offset+b.length;c={offset:r,length:i-2-r,content:""}}else c={offset:s.offset,length:b.children[f+1].offset-s.offset,content:""};return A(E,c,v)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${b.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return A(E,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(y)},v)}}e.setProperty=k;function A(E,n,y){let v=R(E,n),m=n.offset,h=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;m>0&&!(0,L.isEOL)(v,m-1);)m--;for(;h<v.length&&!(0,L.isEOL)(v,h);)h++}const C=(0,L.format)(v,{offset:m,length:h-m},y);for(let b=C.length-1;b>=0;b--){const I=C[b];v=R(v,I),m=Math.min(m,I.offset),h=Math.max(h,I.offset+I.length),h+=I.content.length-I.length}const D=E.length-(v.length-h)-m;return[{offset:m,length:D,content:v.substring(m,h)}]}e.withFormatting=A;function R(E,n){return E.substring(0,n.offset)+n.content+E.substring(n.offset+n.length)}e.applyEdit=R;function p(E,n){let y=n.slice(0).sort((m,h)=>{const C=m.offset-h.offset;return C===0?m.length-h.length:C}),v=E.length;for(let m=y.length-1;m>=0;m--){let h=y[m];if(h.offset+h.length<=v)E=R(E,h);else throw new Error("Overlapping edit");v=h.offset}return E}e.applyEdits=p}),define(X[2],Q([0,1,65,53]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const P=!1;let k=null;function A(r){k=r}if(e.setDisposableTracker=A,P){const r="__is_disposable_tracked__";A(new class{trackDisposable(i){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[r]||console.log(a)},3e3)}setParent(i,a){if(i&&i!==I.None)try{i[r]=!0}catch{}}markAsDisposed(i){if(i&&i!==I.None)try{i[r]=!0}catch{}}markAsSingleton(i){}})}function R(r){return k?.trackDisposable(r),r}function p(r){k?.markAsDisposed(r)}function E(r,i){k?.setParent(r,i)}function n(r,i){if(!!k)for(const a of r)k.setParent(a,i)}function y(r){return k?.markAsSingleton(r),r}e.markAsSingleton=y;class v extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=v;function m(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=m;function h(r){if(L.Iterable.is(r)){let i=[];for(const a of r)if(a)try{a.dispose()}catch(l){i.push(l)}if(i.length===1)throw i[0];if(i.length>1)throw new v(i);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=h;function C(...r){const i=D(()=>h(r));return n(r,i),i}e.combinedDisposable=C;function D(r){const i=R({dispose:(0,S.once)(()=>{p(i),r()})});return i}e.toDisposable=D;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return E(i,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class I{constructor(){this._store=new b,R(this),E(this._store,this)}dispose(){p(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=I,I.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&E(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&E(i,null),i}}e.MutableDisposable=f;class s{constructor(){this.references=new Map}acquire(i,...a){let l=this.references.get(i);l||(l={counter:0,object:this.createReferencedObject(i,...a)},this.references.set(i,l));const{object:o}=l,u=(0,S.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(i,l.object),this.references.delete(i))});return l.counter++,{object:o,dispose:u}}}e.ReferenceCollection=s;class c{constructor(i){this.referenceCollection=i}async acquire(i,...a){const l=this.referenceCollection.acquire(i,...a);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(o){throw l.dispose(),o}}}e.AsyncReferenceCollection=c;class t{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=t}),define(X[88],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(k){this.element=k,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class L{constructor(){this._first=S.Undefined,this._last=S.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===S.Undefined}clear(){let k=this._first;for(;k!==S.Undefined;){const A=k.next;k.prev=S.Undefined,k.next=S.Undefined,k=A}this._first=S.Undefined,this._last=S.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,A){const R=new S(k);if(this._first===S.Undefined)this._first=R,this._last=R;else if(A){const E=this._last;this._last=R,R.prev=E,E.next=R}else{const E=this._first;this._first=R,R.next=E,E.prev=R}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(R))}}shift(){if(this._first!==S.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==S.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==S.Undefined&&k.next!==S.Undefined){const A=k.prev;A.next=k.next,k.next.prev=A}else k.prev===S.Undefined&&k.next===S.Undefined?(this._first=S.Undefined,this._last=S.Undefined):k.next===S.Undefined?(this._last=this._last.prev,this._last.next=S.Undefined):k.prev===S.Undefined&&(this._first=this._first.next,this._first.prev=S.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==S.Undefined;)yield k.element,k=k.next}}e.LinkedList=L}),function(){function G(P){const k=[];typeof P=="number"&&k.push("code/timeOrigin",P);function A(p){k.push(p,Date.now())}function R(){const p=[];for(let E=0;E<k.length;E+=2)p.push({name:k[E],startTime:k[E+1]});return p}return{mark:A,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))k.push({name:A.name,startTime:Math.round(P+A.startTime)});return k}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function S(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=S(L))}(),define(X[7],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const S="en";let L=!1,P=!1,k=!1,A=!1,R=!1,p=!1,E=!1,n,y=S,v,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const C=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=C&&h?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=h?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!C)m=navigator.userAgent,L=m.indexOf("Windows")>=0,P=m.indexOf("Macintosh")>=0,E=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=m.indexOf("Linux")>=0,p=!0,n=navigator.language,y=n;else if(typeof h=="object"){L=h.platform==="win32",P=h.platform==="darwin",k=h.platform==="linux",A=k&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,n=S,y=S;const i=h.env.VSCODE_NLS_CONFIG;if(i)try{const a=JSON.parse(i),l=a.availableLanguages["*"];n=a.locale,y=l||S,v=a._translationsConfigFile}catch(a){}R=!0}else console.error("Unable to resolve platform.");var D;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function b(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let I=0;P?I=1:L?I=3:k&&(I=2),e.isWindows=L,e.isMacintosh=P,e.isLinux=k,e.isLinuxSnap=A,e.isNative=R,e.isWeb=p,e.isIOS=E,e.platform=I,e.userAgent=m,e.language=y;var f;(function(i){function a(){return e.language}i.value=a;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=l;function o(){return e.language==="en"}i.isDefault=o})(f=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=v,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let g=0,w=l.length;g<w;g++){const d=l[g];if(d.id===u.data.vscodeSetImmediateId){l.splice(g,1),d.callback();return}}});let o=0;return u=>{const g=++o;l.push({id:g,callback:u}),e.globals.postMessage({vscodeSetImmediateId:g},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const a=Promise.resolve();return l=>a.then(l)}();var s;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||E?2:L?1:3;let c=!0,t=!1;function r(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,c=new Uint16Array(i.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=r}),define(X[34],Q([0,1,7]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof S.globals.vscode!="undefined"&&typeof S.globals.vscode.process!="undefined"){const P=S.globals.vscode.process;L={get platform(){return P.platform},get env(){return P.env},cwd(){return P.cwd()},nextTick(k){return(0,S.setImmediate)(k)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(P){return process.nextTick(P)}}:L={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},nextTick(P){return(0,S.setImmediate)(P)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(X[8],Q([0,1,34]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,P=97,k=90,A=122,R=46,p=47,E=92,n=58,y=63;class v extends Error{constructor(s,c,t){let r;typeof c=="string"&&c.indexOf("not ")===0?(r="must not be",c=c.replace(/^not /,"")):r="must be";const i=s.indexOf(".")!==-1?"property":"argument";let a=`The "${s}" ${i} ${r} of type ${c}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function m(f,s){if(typeof f!="string")throw new v(s,"string",f)}function h(f){return f===p||f===E}function C(f){return f===p}function D(f){return f>=L&&f<=k||f>=P&&f<=A}function b(f,s,c,t){let r="",i=0,a=-1,l=0,o=0;for(let u=0;u<=f.length;++u){if(u<f.length)o=f.charCodeAt(u);else{if(t(o))break;o=p}if(t(o)){if(!(a===u-1||l===1))if(l===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==R||r.charCodeAt(r.length-2)!==R){if(r.length>2){const g=r.lastIndexOf(c);g===-1?(r="",i=0):(r=r.slice(0,g),i=r.length-1-r.lastIndexOf(c)),a=u,l=0;continue}else if(r.length!==0){r="",i=0,a=u,l=0;continue}}s&&(r+=r.length>0?`${c}..`:"..",i=2)}else r.length>0?r+=`${c}${f.slice(a+1,u)}`:r=f.slice(a+1,u),i=u-a-1;a=u,l=0}else o===R&&l!==-1?++l:l=-1}return r}function I(f,s){if(s===null||typeof s!="object")throw new v("pathObject","Object",s);const c=s.dir||s.root,t=s.base||`${s.name||""}${s.ext||""}`;return c?c===s.root?`${c}${t}`:`${c}${f}${t}`:t}e.win32={resolve(...f){let s="",c="",t=!1;for(let r=f.length-1;r>=-1;r--){let i;if(r>=0){if(i=f[r],m(i,"path"),i.length===0)continue}else s.length===0?i=S.cwd():(i=S.env[`=${s}`]||S.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==s.toLowerCase()&&i.charCodeAt(2)===E)&&(i=`${s}\\`));const a=i.length;let l=0,o="",u=!1;const g=i.charCodeAt(0);if(a===1)h(g)&&(l=1,u=!0);else if(h(g))if(u=!0,h(i.charCodeAt(1))){let w=2,d=w;for(;w<a&&!h(i.charCodeAt(w));)w++;if(w<a&&w!==d){const T=i.slice(d,w);for(d=w;w<a&&h(i.charCodeAt(w));)w++;if(w<a&&w!==d){for(d=w;w<a&&!h(i.charCodeAt(w));)w++;(w===a||w!==d)&&(o=`\\\\${T}\\${i.slice(d,w)}`,l=w)}}}else l=1;else D(g)&&i.charCodeAt(1)===n&&(o=i.slice(0,2),l=2,a>2&&h(i.charCodeAt(2))&&(u=!0,l=3));if(o.length>0)if(s.length>0){if(o.toLowerCase()!==s.toLowerCase())continue}else s=o;if(t){if(s.length>0)break}else if(c=`${i.slice(l)}\\${c}`,t=u,u&&s.length>0)break}return c=b(c,!t,"\\",h),t?`${s}\\${c}`:`${s}${c}`||"."},normalize(f){m(f,"path");const s=f.length;if(s===0)return".";let c=0,t,r=!1;const i=f.charCodeAt(0);if(s===1)return C(i)?"\\":f;if(h(i))if(r=!0,h(f.charCodeAt(1))){let l=2,o=l;for(;l<s&&!h(f.charCodeAt(l));)l++;if(l<s&&l!==o){const u=f.slice(o,l);for(o=l;l<s&&h(f.charCodeAt(l));)l++;if(l<s&&l!==o){for(o=l;l<s&&!h(f.charCodeAt(l));)l++;if(l===s)return`\\\\${u}\\${f.slice(o)}\\`;l!==o&&(t=`\\\\${u}\\${f.slice(o,l)}`,c=l)}}}else c=1;else D(i)&&f.charCodeAt(1)===n&&(t=f.slice(0,2),c=2,s>2&&h(f.charCodeAt(2))&&(r=!0,c=3));let a=c<s?b(f.slice(c),!r,"\\",h):"";return a.length===0&&!r&&(a="."),a.length>0&&h(f.charCodeAt(s-1))&&(a+="\\"),t===void 0?r?`\\${a}`:a:r?`${t}\\${a}`:`${t}${a}`},isAbsolute(f){m(f,"path");const s=f.length;if(s===0)return!1;const c=f.charCodeAt(0);return h(c)||s>2&&D(c)&&f.charCodeAt(1)===n&&h(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let s,c;for(let i=0;i<f.length;++i){const a=f[i];m(a,"path"),a.length>0&&(s===void 0?s=c=a:s+=`\\${a}`)}if(s===void 0)return".";let t=!0,r=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++r;const i=c.length;i>1&&h(c.charCodeAt(1))&&(++r,i>2&&(h(c.charCodeAt(2))?++r:t=!1))}if(t){for(;r<s.length&&h(s.charCodeAt(r));)r++;r>=2&&(s=`\\${s.slice(r)}`)}return e.win32.normalize(s)},relative(f,s){if(m(f,"from"),m(s,"to"),f===s)return"";const c=e.win32.resolve(f),t=e.win32.resolve(s);if(c===t||(f=c.toLowerCase(),s=t.toLowerCase(),f===s))return"";let r=0;for(;r<f.length&&f.charCodeAt(r)===E;)r++;let i=f.length;for(;i-1>r&&f.charCodeAt(i-1)===E;)i--;const a=i-r;let l=0;for(;l<s.length&&s.charCodeAt(l)===E;)l++;let o=s.length;for(;o-1>l&&s.charCodeAt(o-1)===E;)o--;const u=o-l,g=a<u?a:u;let w=-1,d=0;for(;d<g;d++){const O=f.charCodeAt(r+d);if(O!==s.charCodeAt(l+d))break;O===E&&(w=d)}if(d!==g){if(w===-1)return t}else{if(u>g){if(s.charCodeAt(l+d)===E)return t.slice(l+d+1);if(d===2)return t.slice(l+d)}a>g&&(f.charCodeAt(r+d)===E?w=d:d===2&&(w=3)),w===-1&&(w=0)}let T="";for(d=r+w+1;d<=i;++d)(d===i||f.charCodeAt(d)===E)&&(T+=T.length===0?"..":"\\..");return l+=w,T.length>0?`${T}${t.slice(l,o)}`:(t.charCodeAt(l)===E&&++l,t.slice(l,o))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const s=e.win32.resolve(f);if(s.length<=2)return f;if(s.charCodeAt(0)===E){if(s.charCodeAt(1)===E){const c=s.charCodeAt(2);if(c!==y&&c!==R)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(D(s.charCodeAt(0))&&s.charCodeAt(1)===n&&s.charCodeAt(2)===E)return`\\\\?\\${s}`;return f},dirname(f){m(f,"path");const s=f.length;if(s===0)return".";let c=-1,t=0;const r=f.charCodeAt(0);if(s===1)return h(r)?f:".";if(h(r)){if(c=t=1,h(f.charCodeAt(1))){let l=2,o=l;for(;l<s&&!h(f.charCodeAt(l));)l++;if(l<s&&l!==o){for(o=l;l<s&&h(f.charCodeAt(l));)l++;if(l<s&&l!==o){for(o=l;l<s&&!h(f.charCodeAt(l));)l++;if(l===s)return f;l!==o&&(c=t=l+1)}}}}else D(r)&&f.charCodeAt(1)===n&&(c=s>2&&h(f.charCodeAt(2))?3:2,t=c);let i=-1,a=!0;for(let l=s-1;l>=t;--l)if(h(f.charCodeAt(l))){if(!a){i=l;break}}else a=!1;if(i===-1){if(c===-1)return".";i=c}return f.slice(0,i)},basename(f,s){s!==void 0&&m(s,"ext"),m(f,"path");let c=0,t=-1,r=!0,i;if(f.length>=2&&D(f.charCodeAt(0))&&f.charCodeAt(1)===n&&(c=2),s!==void 0&&s.length>0&&s.length<=f.length){if(s===f)return"";let a=s.length-1,l=-1;for(i=f.length-1;i>=c;--i){const o=f.charCodeAt(i);if(h(o)){if(!r){c=i+1;break}}else l===-1&&(r=!1,l=i+1),a>=0&&(o===s.charCodeAt(a)?--a==-1&&(t=i):(a=-1,t=l))}return c===t?t=l:t===-1&&(t=f.length),f.slice(c,t)}for(i=f.length-1;i>=c;--i)if(h(f.charCodeAt(i))){if(!r){c=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":f.slice(c,t)},extname(f){m(f,"path");let s=0,c=-1,t=0,r=-1,i=!0,a=0;f.length>=2&&f.charCodeAt(1)===n&&D(f.charCodeAt(0))&&(s=t=2);for(let l=f.length-1;l>=s;--l){const o=f.charCodeAt(l);if(h(o)){if(!i){t=l+1;break}continue}r===-1&&(i=!1,r=l+1),o===R?c===-1?c=l:a!==1&&(a=1):c!==-1&&(a=-1)}return c===-1||r===-1||a===0||a===1&&c===r-1&&c===t+1?"":f.slice(c,r)},format:I.bind(null,"\\"),parse(f){m(f,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return s;const c=f.length;let t=0,r=f.charCodeAt(0);if(c===1)return h(r)?(s.root=s.dir=f,s):(s.base=s.name=f,s);if(h(r)){if(t=1,h(f.charCodeAt(1))){let w=2,d=w;for(;w<c&&!h(f.charCodeAt(w));)w++;if(w<c&&w!==d){for(d=w;w<c&&h(f.charCodeAt(w));)w++;if(w<c&&w!==d){for(d=w;w<c&&!h(f.charCodeAt(w));)w++;w===c?t=w:w!==d&&(t=w+1)}}}}else if(D(r)&&f.charCodeAt(1)===n){if(c<=2)return s.root=s.dir=f,s;if(t=2,h(f.charCodeAt(2))){if(c===3)return s.root=s.dir=f,s;t=3}}t>0&&(s.root=f.slice(0,t));let i=-1,a=t,l=-1,o=!0,u=f.length-1,g=0;for(;u>=t;--u){if(r=f.charCodeAt(u),h(r)){if(!o){a=u+1;break}continue}l===-1&&(o=!1,l=u+1),r===R?i===-1?i=u:g!==1&&(g=1):i!==-1&&(g=-1)}return l!==-1&&(i===-1||g===0||g===1&&i===l-1&&i===a+1?s.base=s.name=f.slice(a,l):(s.name=f.slice(a,i),s.base=f.slice(a,l),s.ext=f.slice(i,l))),a>0&&a!==t?s.dir=f.slice(0,a-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let s="",c=!1;for(let t=f.length-1;t>=-1&&!c;t--){const r=t>=0?f[t]:S.cwd();m(r,"path"),r.length!==0&&(s=`${r}/${s}`,c=r.charCodeAt(0)===p)}return s=b(s,!c,"/",C),c?`/${s}`:s.length>0?s:"."},normalize(f){if(m(f,"path"),f.length===0)return".";const s=f.charCodeAt(0)===p,c=f.charCodeAt(f.length-1)===p;return f=b(f,!s,"/",C),f.length===0?s?"/":c?"./":".":(c&&(f+="/"),s?`/${f}`:f)},isAbsolute(f){return m(f,"path"),f.length>0&&f.charCodeAt(0)===p},join(...f){if(f.length===0)return".";let s;for(let c=0;c<f.length;++c){const t=f[c];m(t,"path"),t.length>0&&(s===void 0?s=t:s+=`/${t}`)}return s===void 0?".":e.posix.normalize(s)},relative(f,s){if(m(f,"from"),m(s,"to"),f===s||(f=e.posix.resolve(f),s=e.posix.resolve(s),f===s))return"";const c=1,t=f.length,r=t-c,i=1,a=s.length-i,l=r<a?r:a;let o=-1,u=0;for(;u<l;u++){const w=f.charCodeAt(c+u);if(w!==s.charCodeAt(i+u))break;w===p&&(o=u)}if(u===l)if(a>l){if(s.charCodeAt(i+u)===p)return s.slice(i+u+1);if(u===0)return s.slice(i+u)}else r>l&&(f.charCodeAt(c+u)===p?o=u:u===0&&(o=0));let g="";for(u=c+o+1;u<=t;++u)(u===t||f.charCodeAt(u)===p)&&(g+=g.length===0?"..":"/..");return`${g}${s.slice(i+o)}`},toNamespacedPath(f){return f},dirname(f){if(m(f,"path"),f.length===0)return".";const s=f.charCodeAt(0)===p;let c=-1,t=!0;for(let r=f.length-1;r>=1;--r)if(f.charCodeAt(r)===p){if(!t){c=r;break}}else t=!1;return c===-1?s?"/":".":s&&c===1?"//":f.slice(0,c)},basename(f,s){s!==void 0&&m(s,"ext"),m(f,"path");let c=0,t=-1,r=!0,i;if(s!==void 0&&s.length>0&&s.length<=f.length){if(s===f)return"";let a=s.length-1,l=-1;for(i=f.length-1;i>=0;--i){const o=f.charCodeAt(i);if(o===p){if(!r){c=i+1;break}}else l===-1&&(r=!1,l=i+1),a>=0&&(o===s.charCodeAt(a)?--a==-1&&(t=i):(a=-1,t=l))}return c===t?t=l:t===-1&&(t=f.length),f.slice(c,t)}for(i=f.length-1;i>=0;--i)if(f.charCodeAt(i)===p){if(!r){c=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":f.slice(c,t)},extname(f){m(f,"path");let s=-1,c=0,t=-1,r=!0,i=0;for(let a=f.length-1;a>=0;--a){const l=f.charCodeAt(a);if(l===p){if(!r){c=a+1;break}continue}t===-1&&(r=!1,t=a+1),l===R?s===-1?s=a:i!==1&&(i=1):s!==-1&&(i=-1)}return s===-1||t===-1||i===0||i===1&&s===t-1&&s===c+1?"":f.slice(s,t)},format:I.bind(null,"/"),parse(f){m(f,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return s;const c=f.charCodeAt(0)===p;let t;c?(s.root="/",t=1):t=0;let r=-1,i=0,a=-1,l=!0,o=f.length-1,u=0;for(;o>=t;--o){const g=f.charCodeAt(o);if(g===p){if(!l){i=o+1;break}continue}a===-1&&(l=!1,a=o+1),g===R?r===-1?r=o:u!==1&&(u=1):r!==-1&&(u=-1)}if(a!==-1){const g=i===0&&c?1:i;r===-1||u===0||u===1&&r===a-1&&r===i+1?s.base=s.name=f.slice(g,a):(s.name=f.slice(g,r),s.base=f.slice(g,a),s.ext=f.slice(r,a))}return i>0?s.dir=f.slice(0,i-1):c&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=S.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S.platform==="win32"?e.win32.join:e.posix.join,e.resolve=S.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=S.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=S.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=S.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=S.platform==="win32"?e.win32.extname:e.posix.extname,e.format=S.platform==="win32"?e.win32.format:e.posix.format,e.parse=S.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=S.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=S.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var L in S)(typeof exports=="object"?exports:G)[L]=S[L]}}(typeof self!="undefined"?self:this,function(){return function(G){var e={};function S(L){if(e[L])return e[L].exports;var P=e[L]={i:L,l:!1,exports:{}};return G[L].call(P.exports,P,P.exports,S),P.l=!0,P.exports}return S.m=G,S.c=e,S.d=function(L,P,k){S.o(L,P)||Object.defineProperty(L,P,{enumerable:!0,get:k})},S.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},S.t=function(L,P){if(1&P&&(L=S(L)),8&P||4&P&&typeof L=="object"&&L&&L.__esModule)return L;var k=Object.create(null);if(S.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:L}),2&P&&typeof L!="string")for(var A in L)S.d(k,A,function(R){return L[R]}.bind(null,A));return k},S.n=function(L){var P=L&&L.__esModule?function(){return L.default}:function(){return L};return S.d(P,"a",P),P},S.o=function(L,P){return Object.prototype.hasOwnProperty.call(L,P)},S.p="",S(S.s=0)}([function(G,e,S){(function(L){var P;e=G.exports=ne,P=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],p=e.src=[],E=0,n=E++;p[n]="0|[1-9]\\d*";var y=E++;p[y]="[0-9]+";var v=E++;p[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=E++;p[m]="("+p[n]+")\\.("+p[n]+")\\.("+p[n]+")";var h=E++;p[h]="("+p[y]+")\\.("+p[y]+")\\.("+p[y]+")";var C=E++;p[C]="(?:"+p[n]+"|"+p[v]+")";var D=E++;p[D]="(?:"+p[y]+"|"+p[v]+")";var b=E++;p[b]="(?:-("+p[C]+"(?:\\."+p[C]+")*))";var I=E++;p[I]="(?:-?("+p[D]+"(?:\\."+p[D]+")*))";var f=E++;p[f]="[0-9A-Za-z-]+";var s=E++;p[s]="(?:\\+("+p[f]+"(?:\\."+p[f]+")*))";var c=E++,t="v?"+p[m]+p[b]+"?"+p[s]+"?";p[c]="^"+t+"$";var r="[v=\\s]*"+p[h]+p[I]+"?"+p[s]+"?",i=E++;p[i]="^"+r+"$";var a=E++;p[a]="((?:<|>)?=?)";var l=E++;p[l]=p[y]+"|x|X|\\*";var o=E++;p[o]=p[n]+"|x|X|\\*";var u=E++;p[u]="[v=\\s]*("+p[o]+")(?:\\.("+p[o]+")(?:\\.("+p[o]+")(?:"+p[b]+")?"+p[s]+"?)?)?";var g=E++;p[g]="[v=\\s]*("+p[l]+")(?:\\.("+p[l]+")(?:\\.("+p[l]+")(?:"+p[I]+")?"+p[s]+"?)?)?";var w=E++;p[w]="^"+p[a]+"\\s*"+p[u]+"$";var d=E++;p[d]="^"+p[a]+"\\s*"+p[g]+"$";var T=E++;p[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=E++;p[O]="(?:~>?)";var $=E++;p[$]="(\\s*)"+p[O]+"\\s+",R[$]=new RegExp(p[$],"g");var z=E++;p[z]="^"+p[O]+p[u]+"$";var V=E++;p[V]="^"+p[O]+p[g]+"$";var B=E++;p[B]="(?:\\^)";var M=E++;p[M]="(\\s*)"+p[B]+"\\s+",R[M]=new RegExp(p[M],"g");var _=E++;p[_]="^"+p[B]+p[u]+"$";var N=E++;p[N]="^"+p[B]+p[g]+"$";var j=E++;p[j]="^"+p[a]+"\\s*("+r+")$|^$";var F=E++;p[F]="^"+p[a]+"\\s*("+t+")$|^$";var U=E++;p[U]="(\\s*)"+p[a]+"\\s*("+r+"|"+p[u]+")",R[U]=new RegExp(p[U],"g");var x=E++;p[x]="^\\s*("+p[u]+")\\s+-\\s+("+p[u]+")\\s*$";var q=E++;p[q]="^\\s*("+p[g]+")\\s+-\\s+("+p[g]+")\\s*$";var H=E++;p[H]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)P(Y,p[Y]),R[Y]||(R[Y]=new RegExp(p[Y]));function te(J,ie){if(J instanceof ne)return J;if(typeof J!="string"||J.length>k||!(ie?R[i]:R[c]).test(J))return null;try{return new ne(J,ie)}catch(re){return null}}function ne(J,ie){if(J instanceof ne){if(J.loose===ie)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof ne))return new ne(J,ie);P("SemVer",J,ie),this.loose=ie;var re=J.trim().match(ie?R[i]:R[c]);if(!re)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+re[1],this.minor=+re[2],this.patch=+re[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");re[4]?this.prerelease=re[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var ve=+me;if(ve>=0&&ve<A)return ve}return me}):this.prerelease=[],this.build=re[5]?re[5].split("."):[],this.format()}e.parse=te,e.valid=function(J,ie){var re=te(J,ie);return re?re.version:null},e.clean=function(J,ie){var re=te(J.trim().replace(/^[=v]+/,""),ie);return re?re.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(J){return P("SemVer.compare",this.version,this.loose,J),J instanceof ne||(J=new ne(J,this.loose)),this.compareMain(J)||this.comparePre(J)},ne.prototype.compareMain=function(J){return J instanceof ne||(J=new ne(J,this.loose)),ee(this.major,J.major)||ee(this.minor,J.minor)||ee(this.patch,J.patch)},ne.prototype.comparePre=function(J){if(J instanceof ne||(J=new ne(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var ie=0;do{var re=this.prerelease[ie],me=J.prerelease[ie];if(P("prerelease compare",ie,re,me),re===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(re===void 0)return-1;if(re!==me)return ee(re,me)}while(++ie)},ne.prototype.inc=function(J,ie){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ie);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ie);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ie),this.inc("pre",ie);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ie),this.inc("pre",ie);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var re=this.prerelease.length;--re>=0;)typeof this.prerelease[re]=="number"&&(this.prerelease[re]++,re=-2);re===-1&&this.prerelease.push(0)}ie&&(this.prerelease[0]===ie?isNaN(this.prerelease[1])&&(this.prerelease=[ie,0]):this.prerelease=[ie,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,ie,re,me){typeof re=="string"&&(me=re,re=void 0);try{return new ne(J,re).inc(ie,me).version}catch(ve){return null}},e.diff=function(J,ie){if(pe(J,ie))return null;var re=te(J),me=te(ie);if(re.prerelease.length||me.prerelease.length){for(var ve in re)if((ve==="major"||ve==="minor"||ve==="patch")&&re[ve]!==me[ve])return"pre"+ve;return"prerelease"}for(var ve in re)if((ve==="major"||ve==="minor"||ve==="patch")&&re[ve]!==me[ve])return ve},e.compareIdentifiers=ee;var se=/^[0-9]+$/;function ee(J,ie){var re=se.test(J),me=se.test(ie);return re&&me&&(J=+J,ie=+ie),re&&!me?-1:me&&!re?1:J<ie?-1:J>ie?1:0}function he(J,ie,re){return new ne(J,re).compare(new ne(ie,re))}function de(J,ie,re){return he(J,ie,re)>0}function ye(J,ie,re){return he(J,ie,re)<0}function pe(J,ie,re){return he(J,ie,re)===0}function Pe(J,ie,re){return he(J,ie,re)!==0}function Te(J,ie,re){return he(J,ie,re)>=0}function Me(J,ie,re){return he(J,ie,re)<=0}function Oe(J,ie,re,me){var ve;switch(ie){case"===":typeof J=="object"&&(J=J.version),typeof re=="object"&&(re=re.version),ve=J===re;break;case"!==":typeof J=="object"&&(J=J.version),typeof re=="object"&&(re=re.version),ve=J!==re;break;case"":case"=":case"==":ve=pe(J,re,me);break;case"!=":ve=Pe(J,re,me);break;case">":ve=de(J,re,me);break;case">=":ve=Te(J,re,me);break;case"<":ve=ye(J,re,me);break;case"<=":ve=Me(J,re,me);break;default:throw new TypeError("Invalid operator: "+ie)}return ve}function Le(J,ie){if(J instanceof Le){if(J.loose===ie)return J;J=J.value}if(!(this instanceof Le))return new Le(J,ie);P("comparator",J,ie),this.loose=ie,this.parse(J),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(J,ie){return ee(ie,J)},e.major=function(J,ie){return new ne(J,ie).major},e.minor=function(J,ie){return new ne(J,ie).minor},e.patch=function(J,ie){return new ne(J,ie).patch},e.compare=he,e.compareLoose=function(J,ie){return he(J,ie,!0)},e.rcompare=function(J,ie,re){return he(ie,J,re)},e.sort=function(J,ie){return J.sort(function(re,me){return e.compare(re,me,ie)})},e.rsort=function(J,ie){return J.sort(function(re,me){return e.rcompare(re,me,ie)})},e.gt=de,e.lt=ye,e.eq=pe,e.neq=Pe,e.gte=Te,e.lte=Me,e.cmp=Oe,e.Comparator=Le;var _e={};function be(J,ie){if(J instanceof be)return J.loose===ie?J:new be(J.raw,ie);if(J instanceof Le)return new be(J.value,ie);if(!(this instanceof be))return new be(J,ie);if(this.loose=ie,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(re){return this.parseRange(re.trim())},this).filter(function(re){return re.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function ke(J){return!J||J.toLowerCase()==="x"||J==="*"}function Ke(J,ie,re,me,ve,De,we,Ae,Ce,Re,Ue,W,Z){return((ie=ke(re)?"":ke(me)?">="+re+".0.0":ke(ve)?">="+re+"."+me+".0":">="+ie)+" "+(Ae=ke(Ce)?"":ke(Re)?"<"+(+Ce+1)+".0.0":ke(Ue)?"<"+Ce+"."+(+Re+1)+".0":W?"<="+Ce+"."+Re+"."+Ue+"-"+W:"<="+Ae)).trim()}function Ye(J,ie){for(var re=0;re<J.length;re++)if(!J[re].test(ie))return!1;if(ie.prerelease.length){for(re=0;re<J.length;re++)if(P(J[re].semver),J[re].semver!==_e&&J[re].semver.prerelease.length>0){var me=J[re].semver;if(me.major===ie.major&&me.minor===ie.minor&&me.patch===ie.patch)return!0}return!1}return!0}function $e(J,ie,re){try{ie=new be(ie,re)}catch(me){return!1}return ie.test(J)}function je(J,ie,re,me){var ve,De,we,Ae,Ce;switch(J=new ne(J,me),ie=new be(ie,me),re){case">":ve=de,De=Me,we=ye,Ae=">",Ce=">=";break;case"<":ve=ye,De=Te,we=de,Ae="<",Ce="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(J,ie,me))return!1;for(var Re=0;Re<ie.set.length;++Re){var Ue=ie.set[Re],W=null,Z=null;if(Ue.forEach(function(ae){ae.semver===_e&&(ae=new Le(">=0.0.0")),W=W||ae,Z=Z||ae,ve(ae.semver,W.semver,me)?W=ae:we(ae.semver,Z.semver,me)&&(Z=ae)}),W.operator===Ae||W.operator===Ce||(!Z.operator||Z.operator===Ae)&&De(J,Z.semver)||Z.operator===Ce&&we(J,Z.semver))return!1}return!0}Le.prototype.parse=function(J){var ie=this.loose?R[j]:R[F],re=J.match(ie);if(!re)throw new TypeError("Invalid comparator: "+J);this.operator=re[1],this.operator==="="&&(this.operator=""),re[2]?this.semver=new ne(re[2],this.loose):this.semver=_e},Le.prototype.toString=function(){return this.value},Le.prototype.test=function(J){return P("Comparator.test",J,this.loose),this.semver===_e||(typeof J=="string"&&(J=new ne(J,this.loose)),Oe(J,this.operator,this.semver,this.loose))},Le.prototype.intersects=function(J,ie){if(!(J instanceof Le))throw new TypeError("a Comparator is required");var re;if(this.operator==="")return re=new be(J.value,ie),$e(this.value,re,ie);if(J.operator==="")return re=new be(this.value,ie),$e(J.semver,re,ie);var me=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),De=this.semver.version===J.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Ae=Oe(this.semver,"<",J.semver,ie)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Ce=Oe(this.semver,">",J.semver,ie)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return me||ve||De&&we||Ae||Ce},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(J){var ie=this.loose;J=J.trim(),P("range",J,ie);var re=ie?R[q]:R[x];J=J.replace(re,Ke),P("hyphen replace",J),J=J.replace(R[U],"$1$2$3"),P("comparator trim",J,R[U]),J=(J=(J=J.replace(R[$],"$1~")).replace(R[M],"$1^")).split(/\s+/).join(" ");var me=ie?R[j]:R[F],ve=J.split(" ").map(function(De){return function(we,Ae){return P("comp",we),we=function(Ce,Re){return Ce.trim().split(/\s+/).map(function(Ue){return function(W,Z){P("caret",W,Z);var ae=Z?R[N]:R[_];return W.replace(ae,function(ce,oe,ue,ge,Se){var le;return P("caret",W,ce,oe,ue,ge,Se),ke(oe)?le="":ke(ue)?le=">="+oe+".0.0 <"+(+oe+1)+".0.0":ke(ge)?le=oe==="0"?">="+oe+"."+ue+".0 <"+oe+"."+(+ue+1)+".0":">="+oe+"."+ue+".0 <"+(+oe+1)+".0.0":Se?(P("replaceCaret pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),le=oe==="0"?ue==="0"?">="+oe+"."+ue+"."+ge+Se+" <"+oe+"."+ue+"."+(+ge+1):">="+oe+"."+ue+"."+ge+Se+" <"+oe+"."+(+ue+1)+".0":">="+oe+"."+ue+"."+ge+Se+" <"+(+oe+1)+".0.0"):(P("no pr"),le=oe==="0"?ue==="0"?">="+oe+"."+ue+"."+ge+" <"+oe+"."+ue+"."+(+ge+1):">="+oe+"."+ue+"."+ge+" <"+oe+"."+(+ue+1)+".0":">="+oe+"."+ue+"."+ge+" <"+(+oe+1)+".0.0"),P("caret return",le),le})}(Ue,Re)}).join(" ")}(we,Ae),P("caret",we),we=function(Ce,Re){return Ce.trim().split(/\s+/).map(function(Ue){return function(W,Z){var ae=Z?R[V]:R[z];return W.replace(ae,function(ce,oe,ue,ge,Se){var le;return P("tilde",W,ce,oe,ue,ge,Se),ke(oe)?le="":ke(ue)?le=">="+oe+".0.0 <"+(+oe+1)+".0.0":ke(ge)?le=">="+oe+"."+ue+".0 <"+oe+"."+(+ue+1)+".0":Se?(P("replaceTilde pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),le=">="+oe+"."+ue+"."+ge+Se+" <"+oe+"."+(+ue+1)+".0"):le=">="+oe+"."+ue+"."+ge+" <"+oe+"."+(+ue+1)+".0",P("tilde return",le),le})}(Ue,Re)}).join(" ")}(we,Ae),P("tildes",we),we=function(Ce,Re){return P("replaceXRanges",Ce,Re),Ce.split(/\s+/).map(function(Ue){return function(W,Z){W=W.trim();var ae=Z?R[d]:R[w];return W.replace(ae,function(ce,oe,ue,ge,Se,le){P("xRange",W,ce,oe,ue,ge,Se,le);var Ee=ke(ue),Ie=Ee||ke(ge),Fe=Ie||ke(Se);return oe==="="&&Fe&&(oe=""),Ee?ce=oe===">"||oe==="<"?"<0.0.0":"*":oe&&Fe?(Ie&&(ge=0),Fe&&(Se=0),oe===">"?(oe=">=",Ie?(ue=+ue+1,ge=0,Se=0):Fe&&(ge=+ge+1,Se=0)):oe==="<="&&(oe="<",Ie?ue=+ue+1:ge=+ge+1),ce=oe+ue+"."+ge+"."+Se):Ie?ce=">="+ue+".0.0 <"+(+ue+1)+".0.0":Fe&&(ce=">="+ue+"."+ge+".0 <"+ue+"."+(+ge+1)+".0"),P("xRange return",ce),ce})}(Ue,Re)}).join(" ")}(we,Ae),P("xrange",we),we=function(Ce,Re){return P("replaceStars",Ce,Re),Ce.trim().replace(R[H],"")}(we,Ae),P("stars",we),we}(De,ie)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(De){return!!De.match(me)})),ve=ve.map(function(De){return new Le(De,ie)})},be.prototype.intersects=function(J,ie){if(!(J instanceof be))throw new TypeError("a Range is required");return this.set.some(function(re){return re.every(function(me){return J.set.some(function(ve){return ve.every(function(De){return me.intersects(De,ie)})})})})},e.toComparators=function(J,ie){return new be(J,ie).set.map(function(re){return re.map(function(me){return me.value}).join(" ").trim().split(" ")})},be.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new ne(J,this.loose));for(var ie=0;ie<this.set.length;ie++)if(Ye(this.set[ie],J))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(J,ie,re){var me=null,ve=null;try{var De=new be(ie,re)}catch(we){return null}return J.forEach(function(we){De.test(we)&&(me&&ve.compare(we)!==-1||(ve=new ne(me=we,re)))}),me},e.minSatisfying=function(J,ie,re){var me=null,ve=null;try{var De=new be(ie,re)}catch(we){return null}return J.forEach(function(we){De.test(we)&&(me&&ve.compare(we)!==1||(ve=new ne(me=we,re)))}),me},e.validRange=function(J,ie){try{return new be(J,ie).range||"*"}catch(re){return null}},e.ltr=function(J,ie,re){return je(J,ie,"<",re)},e.gtr=function(J,ie,re){return je(J,ie,">",re)},e.outside=je,e.prerelease=function(J,ie){var re=te(J,ie);return re&&re.prerelease.length?re.prerelease:null},e.intersects=function(J,ie,re){return J=new be(J,re),ie=new be(ie,re),J.intersects(ie)},e.coerce=function(J){if(J instanceof ne)return J;if(typeof J!="string")return null;var ie=J.match(R[T]);return ie==null?null:te((ie[1]||"0")+"."+(ie[2]||"0")+"."+(ie[3]||"0"))}}).call(this,S(1))},function(G,e){var S,L,P=G.exports={};function k(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function R(D){if(S===setTimeout)return setTimeout(D,0);if((S===k||!S)&&setTimeout)return S=setTimeout,setTimeout(D,0);try{return S(D,0)}catch(b){try{return S.call(null,D,0)}catch(I){return S.call(this,D,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:k}catch(D){S=k}try{L=typeof clearTimeout=="function"?clearTimeout:A}catch(D){L=A}})();var p,E=[],n=!1,y=-1;function v(){n&&p&&(n=!1,p.length?E=p.concat(E):y=-1,E.length&&m())}function m(){if(!n){var D=R(v);n=!0;for(var b=E.length;b;){for(p=E,E=[];++y<b;)p&&p[y].run();y=-1,b=E.length}p=null,n=!1,function(I){if(L===clearTimeout)return clearTimeout(I);if((L===A||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(I);try{L(I)}catch(f){try{return L.call(null,I)}catch(s){return L.call(this,I)}}}(D)}}function h(D,b){this.fun=D,this.array=b}function C(){}P.nextTick=function(D){var b=new Array(arguments.length-1);if(arguments.length>1)for(var I=1;I<arguments.length;I++)b[I-1]=arguments[I];E.push(new h(D,b)),E.length!==1||n||R(m)},h.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=C,P.addListener=C,P.once=C,P.off=C,P.removeListener=C,P.removeAllListeners=C,P.emit=C,P.prependListener=C,P.prependOnceListener=C,P.listeners=function(D){return[]},P.binding=function(D){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(D){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(X[89],Q([0,1,7]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=S.globals.performance&&typeof S.globals.performance.now=="function";class P{constructor(A){this._highResolution=L&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new P(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?S.globals.performance.now():Date.now()}}e.StopWatch=P}),define(X[3],Q([0,1,9,65,2,88,89]),function(G,e,S,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(f){f.None=()=>P.Disposable.None;function s(B){return(M,_=null,N)=>{let j=!1,F;return F=B(U=>{if(!j)return F?F.dispose():j=!0,M.call(_,U)},null,N),j&&F.dispose(),F}}f.once=s;function c(B,M){return o((_,N=null,j)=>B(F=>_.call(N,M(F)),null,j))}f.map=c;function t(B,M){return o((_,N=null,j)=>B(F=>{M(F),_.call(N,F)},null,j))}f.forEach=t;function r(B,M){return o((_,N=null,j)=>B(F=>M(F)&&_.call(N,F),null,j))}f.filter=r;function i(B){return B}f.signal=i;function a(...B){return(M,_=null,N)=>(0,P.combinedDisposable)(...B.map(j=>j(F=>M.call(_,F),null,N)))}f.any=a;function l(B,M,_){let N=_;return c(B,j=>(N=M(N,j),N))}f.reduce=l;function o(B){let M;const _=new v({onFirstListenerAdd(){M=B(_.fire,_)},onLastListenerRemove(){M.dispose()}});return _.event}function u(B,M,_=100,N=!1,j){let F,U,x,q=0;const H=new v({leakWarningThreshold:j,onFirstListenerAdd(){F=B(Y=>{q++,U=M(U,Y),N&&!x&&(H.fire(U),U=void 0),clearTimeout(x),x=setTimeout(()=>{const te=U;U=void 0,x=void 0,(!N||q>1)&&H.fire(te),q=0},_)})},onLastListenerRemove(){F.dispose()}});return H.event}f.debounce=u;function g(B,M=(_,N)=>_===N){let _=!0,N;return r(B,j=>{const F=_||!M(j,N);return _=!1,N=j,F})}f.latch=g;function w(B,M){return[f.filter(B,M),f.filter(B,_=>!M(_))]}f.split=w;function d(B,M=!1,_=[]){let N=_.slice(),j=B(x=>{N?N.push(x):U.fire(x)});const F=()=>{N&&N.forEach(x=>U.fire(x)),N=null},U=new v({onFirstListenerAdd(){j||(j=B(x=>U.fire(x)))},onFirstListenerDidAdd(){N&&(M?setTimeout(F):F())},onLastListenerRemove(){j&&j.dispose(),j=null}});return U.event}f.buffer=d;class T{constructor(M){this.event=M}map(M){return new T(c(this.event,M))}forEach(M){return new T(t(this.event,M))}filter(M){return new T(r(this.event,M))}reduce(M,_){return new T(l(this.event,M,_))}latch(){return new T(g(this.event))}debounce(M,_=100,N=!1,j){return new T(u(this.event,M,_,N,j))}on(M,_,N){return this.event(M,_,N)}once(M,_,N){return s(this.event)(M,_,N)}}function O(B){return new T(B)}f.chain=O;function $(B,M,_=N=>N){const N=(...x)=>U.fire(_(...x)),j=()=>B.on(M,N),F=()=>B.removeListener(M,N),U=new v({onFirstListenerAdd:j,onLastListenerRemove:F});return U.event}f.fromNodeEventEmitter=$;function z(B,M,_=N=>N){const N=(...x)=>U.fire(_(...x)),j=()=>B.addEventListener(M,N),F=()=>B.removeEventListener(M,N),U=new v({onFirstListenerAdd:j,onLastListenerRemove:F});return U.event}f.fromDOMEventEmitter=z;function V(B){return new Promise(M=>s(B)(M))}f.toPromise=V})(R=e.Event||(e.Event={}));class p{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${p._idPool++}`}start(s){this._stopWatch=new A.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}p._idPool=0;let E=-1;function n(f){const s=E;return E=f,{dispose(){E=s}}}e.setGlobalLeakWarningThreshold=n;class y{constructor(s,c=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s){let c=E;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),c<=0||s<c)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let i,a=0;for(const[l,o]of this._stacks)(!i||a<o)&&(i=l,a=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${a}):`),console.warn(i)}return()=>{const i=this._stacks.get(t)||0;this._stacks.set(t,i-1)}}}class v{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=E>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new p(this._options._profName):void 0}get event(){return this._event||(this._event=(s,c,t)=>{this._listeners||(this._listeners=new k.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(c?[s,c]:s);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,c);const a=this._leakageMon?.check(this._listeners.size),l=(0,P.toDisposable)(()=>{a&&a(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof P.DisposableStore?t.add(l):Array.isArray(t)&&t.push(l),l}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,s]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,t]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,t):c[0].call(c[1],t)}catch(r){(0,S.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=v;class m extends v{async fireAsync(s,c,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,s]);for(;this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),a=[],l={...i,waitUntil:o=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");t&&(o=t(o,typeof r=="function"?r:r[0])),a.push(o)}};try{typeof r=="function"?r.call(void 0,l):r[0].call(r[1],l)}catch(o){(0,S.onUnexpectedError)(o);continue}Object.freeze(a),await Promise.allSettled(a).then(o=>{for(const u of o)u.status==="rejected"&&(0,S.onUnexpectedError)(u.reason)})}}}}e.AsyncEmitter=m;class h extends v{constructor(s){super(s);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=h;class C extends h{constructor(s){super(s);this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}e.DebounceEmitter=C;class D{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const c={event:s,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const t=()=>{this.hasListeners&&this.unhook(c);const r=this.events.indexOf(c);this.events.splice(r,1)};return(0,P.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(c=>this.emitter.fire(c))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=D;class b{constructor(){this.buffers=[]}wrapEvent(s){return(c,t,r)=>s(i=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>c.call(t,i)):c.call(t,i)},void 0,r)}bufferEvents(s){const c=[];this.buffers.push(c);const t=s();return this.buffers.pop(),c.forEach(r=>r()),t}}e.EventBufferer=b;class I{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=P.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=I}),define(X[29],Q([0,1,3]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(R,p){const E=setTimeout(R.bind(p),0);return{dispose(){clearTimeout(E)}}});var P;(function(R){function p(E){return E===R.None||E===R.Cancelled||E instanceof k?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}R.isCancellationToken=p,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(P=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new S.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=P.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=P.None}}e.CancellationTokenSource=A}),define(X[54],Q([0,1,3]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new S.Emitter}add(y){const v=this._icons.get(y.id);v?y.description?v.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const P=new L;e.iconRegistry=P;function k(n,y){return new R(n,y)}e.registerCodicon=k;function A(n){return n?n.replace(/\$\((.*?)\)/g,(y,v)=>` ${v} `).trim():""}e.getCodiconAriaLabel=A;class R{constructor(y,v,m){this.id=y,this.definition=v,this.description=m,P.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=R;function p(n,y){const v=["codicon","codicon-"+n];return y&&v.push("codicon-modifier-"+y),v}e.getClassNamesArray=p;var E;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const y=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function v(C){if(C instanceof R)return["codicon","codicon-"+C.id];const D=y.exec(C.id);if(!D)return v(R.error);let[,b,I]=D;const f=["codicon","codicon-"+b];return I&&f.push("codicon-modifier-"+I.substr(1)),f}n.asClassNameArray=v;function m(C){return v(C).join(" ")}n.asClassName=m;function h(C){return"."+v(C).join(".")}n.asCSSSelector=h})(E=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(R=e.Codicon||(e.Codicon={}))}),define(X[48],Q([0,1,9,2]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function P(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=P;function k(f){const s=f;return s?P(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=k;function A(f,s){return new R(f,s)}e.newWriteableStream=A;class R{constructor(s,c){this.reducer=s,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(c=>c(s))}emitError(s){this.listeners.error.length===0?(0,S.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(c=>c(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,c){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(s,c){if(this.state.destroyed)return;let t;switch(s){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(c);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(f,s){const c=[];let t;for(;(t=f.read())!==null;)c.push(t);return s(c)}e.consumeReadable=p;function E(f,s,c){const t=[];let r;for(;(r=f.read())!==null&&t.length<c;)t.push(r);return r===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return f.read()}}}e.peekReadable=E;function n(f,s){return new Promise((c,t)=>{const r=[];y(f,{onData:i=>{s&&r.push(i)},onError:i=>{s?t(i):c(void 0)},onEnd:()=>{c(s?s(r):void 0)}})})}e.consumeStream=n;function y(f,s){f.on("error",c=>s.onError(c)),f.on("end",()=>s.onEnd()),f.on("data",c=>s.onData(c))}e.listenStream=y;function v(f,s){return new Promise((c,t)=>{const r=new L.DisposableStore,i=[],a=u=>{if(i.push(u),i.length>s)return r.dispose(),f.pause(),c({stream:f,buffer:i,ended:!1})},l=u=>t(u),o=()=>c({stream:f,buffer:i,ended:!0});r.add((0,L.toDisposable)(()=>f.removeListener("error",l))),f.on("error",l),r.add((0,L.toDisposable)(()=>f.removeListener("end",o))),f.on("end",o),r.add((0,L.toDisposable)(()=>f.removeListener("data",a))),f.on("data",a)})}e.peekStream=v;function m(f,s){const c=A(s);return c.end(f),c}e.toStream=m;function h(){const f=A(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=h;function C(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}e.toReadable=C;function D(f,s,c){const t=A(c);return y(f,{onData:r=>t.write(s.data(r)),onError:r=>t.error(s.error?s.error(r):r),onEnd:()=>t.end()}),t}e.transform=D;function b(f,s,c){let t=!1;return{read:()=>{const r=s.read();return t?r:(t=!0,r!==null?c([f,r]):f)}}}e.prefixedReadable=b;function I(f,s,c){let t=!1;const r=A(c);return y(s,{onData:i=>t?r.write(i):(t=!0,r.write(c([f,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(f)),r.end()}}),r}e.prefixedStream=I}),define(X[19],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function S(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=S;const L=/{(\d+)}/g;function P(W,...Z){return Z.length===0?W:W.replace(L,function(ae,ce){const oe=parseInt(ce,10);return isNaN(oe)||oe<0||oe>=Z.length?ae:Z[oe]})}e.format=P;const k=/{([^}]+)}/g;function A(W,Z){return W.replace(k,(ae,ce)=>Z[ce]??ae)}e.format2=A;function R(W){return W.replace(/[<>&]/g,function(Z){switch(Z){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Z}})}e.escape=R;function p(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=p;function E(W,Z){let ae=0;const ce=Z.charCodeAt(0);for(let oe=W.length-1;oe>=0;oe--)W.charCodeAt(oe)===ce&&ae++;return ae}e.count=E;function n(W,Z,ae="\u2026"){return W.length<=Z?W:`${W.substr(0,Z)}${ae}`}e.truncate=n;function y(W,Z=" "){const ae=v(W,Z);return m(ae,Z)}e.trim=y;function v(W,Z){if(!W||!Z)return W;const ae=Z.length;if(ae===0||W.length===0)return W;let ce=0;for(;W.indexOf(Z,ce)===ce;)ce=ce+ae;return W.substring(ce)}e.ltrim=v;function m(W,Z){if(!W||!Z)return W;const ae=Z.length,ce=W.length;if(ae===0||ce===0)return W;let oe=ce,ue=-1;for(;ue=W.lastIndexOf(Z,oe-1),!(ue===-1||ue+ae!==oe);){if(ue===0)return"";oe=ue}return W.substring(0,oe)}e.rtrim=m;function h(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function C(W){return W.replace(/\*/g,"")}e.stripWildcards=C;function D(W,Z,ae={}){if(!W)throw new Error("Cannot create regex from empty string");Z||(W=p(W)),ae.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let ce="";return ae.global&&(ce+="g"),ae.matchCase||(ce+="i"),ae.multiline&&(ce+="m"),ae.unicode&&(ce+="u"),new RegExp(W,ce)}e.createRegExp=D;function b(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function I(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=I;function f(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=f;function s(W){return W.split(/\r\n|\r|\n/)}e.splitLines=s;function c(W){for(let Z=0,ae=W.length;Z<ae;Z++){const ce=W.charCodeAt(Z);if(ce!==32&&ce!==9)return Z}return-1}e.firstNonWhitespaceIndex=c;function t(W,Z=0,ae=W.length){for(let ce=Z;ce<ae;ce++){const oe=W.charCodeAt(ce);if(oe!==32&&oe!==9)return W.substring(Z,ce)}return W.substring(Z,ae)}e.getLeadingWhitespace=t;function r(W,Z=W.length-1){for(let ae=Z;ae>=0;ae--){const ce=W.charCodeAt(ae);if(ce!==32&&ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=r;function i(W,Z){return W<Z?-1:W>Z?1:0}e.compare=i;function a(W,Z,ae=0,ce=W.length,oe=0,ue=Z.length){for(;ae<ce&&oe<ue;ae++,oe++){let le=W.charCodeAt(ae),Ee=Z.charCodeAt(oe);if(le<Ee)return-1;if(le>Ee)return 1}const ge=ce-ae,Se=ue-oe;return ge<Se?-1:ge>Se?1:0}e.compareSubstring=a;function l(W,Z){return o(W,Z,0,W.length,0,Z.length)}e.compareIgnoreCase=l;function o(W,Z,ae=0,ce=W.length,oe=0,ue=Z.length){for(;ae<ce&&oe<ue;ae++,oe++){let le=W.charCodeAt(ae),Ee=Z.charCodeAt(oe);if(le===Ee)continue;const Ie=le-Ee;if(!(Ie===32&&g(Ee))&&!(Ie===-32&&g(le)))return u(le)&&u(Ee)?Ie:a(W.toLowerCase(),Z.toLowerCase(),ae,ce,oe,ue)}const ge=ce-ae,Se=ue-oe;return ge<Se?-1:ge>Se?1:0}e.compareSubstringIgnoreCase=o;function u(W){return W>=97&&W<=122}e.isLowerAsciiLetter=u;function g(W){return W>=65&&W<=90}e.isUpperAsciiLetter=g;function w(W){return u(W)||g(W)}function d(W,Z){return W.length===Z.length&&T(W,Z)}e.equalsIgnoreCase=d;function T(W,Z,ae=W.length){for(let ce=0;ce<ae;ce++){const oe=W.charCodeAt(ce),ue=Z.charCodeAt(ce);if(oe!==ue){if(w(oe)&&w(ue)){const ge=Math.abs(oe-ue);if(ge!==0&&ge!==32)return!1}else if(String.fromCharCode(oe).toLowerCase()!==String.fromCharCode(ue).toLowerCase())return!1}}return!0}function O(W,Z){const ae=Z.length;return Z.length>W.length?!1:T(W,Z,ae)}e.startsWithIgnoreCase=O;function $(W,Z){let ae,ce=Math.min(W.length,Z.length);for(ae=0;ae<ce;ae++)if(W.charCodeAt(ae)!==Z.charCodeAt(ae))return ae;return ce}e.commonPrefixLength=$;function z(W,Z){let ae,ce=Math.min(W.length,Z.length);const oe=W.length-1,ue=Z.length-1;for(ae=0;ae<ce;ae++)if(W.charCodeAt(oe-ae)!==Z.charCodeAt(ue-ae))return ae;return ce}e.commonSuffixLength=z;function V(W){return 55296<=W&&W<=56319}e.isHighSurrogate=V;function B(W){return 56320<=W&&W<=57343}e.isLowSurrogate=B;function M(W,Z){return(W-55296<<10)+(Z-56320)+65536}e.computeCodePoint=M;function _(W,Z,ae){const ce=W.charCodeAt(ae);if(V(ce)&&ae+1<Z){const oe=W.charCodeAt(ae+1);if(B(oe))return M(ce,oe)}return ce}e.getNextCodePoint=_;function N(W,Z){const ae=W.charCodeAt(Z-1);if(B(ae)&&Z>1){const ce=W.charCodeAt(Z-2);if(V(ce))return M(ce,ae)}return ae}function j(W,Z){const ae=ve.getInstance(),ce=Z,oe=W.length,ue=_(W,oe,Z);Z+=ue>=65536?2:1;let ge=ae.getGraphemeBreakType(ue);for(;Z<oe;){const Se=_(W,oe,Z),le=ae.getGraphemeBreakType(Se);if(re(ge,le))break;Z+=Se>=65536?2:1,ge=le}return Z-ce}e.nextCharLength=j;function F(W,Z){const ae=ve.getInstance(),ce=Z,oe=N(W,Z);Z-=oe>=65536?2:1;let ue=ae.getGraphemeBreakType(oe);for(;Z>0;){const ge=N(W,Z),Se=ae.getGraphemeBreakType(ge);if(re(Se,ue))break;Z-=ge>=65536?2:1,ue=Se}return ce-Z}e.prevCharLength=F;function U(W,Z){const ae=ve.getInstance(),ce=W.length,oe=Z,ue=_(W,ce,Z),ge=ae.getGraphemeBreakType(ue);Z+=ue>=65536?2:1;let Se=ge;for(;Z<ce;){const Ee=_(W,ce,Z),Ie=ae.getGraphemeBreakType(Ee);if(re(Se,Ie))break;Z+=Ee>=65536?2:1,Se=Ie}const le=Z;for(Z=oe,Se=ge;Z>0;){const Ee=N(W,Z),Ie=ae.getGraphemeBreakType(Ee);if(re(Ie,Se))break;Z-=Ee>=65536?2:1,Se=Ie}return[Z,le]}function x(W,Z){return Z>0&&B(W.charCodeAt(Z))?U(W,Z-1):U(W,Z)}e.getCharContainingOffset=x;function q(W){const Z=W.length;let ae=0,ce=0;for(;ce<Z;){const ge=_(W,Z,ce);ce+=ge>=65536?2:1,ge<128?ae+=1:ge<2048?ae+=2:ge<65536?ae+=3:ae+=4}const oe=new Uint8Array(ae);ce=0;let ue=0;for(;ce<Z;){const ge=_(W,Z,ce);ce+=ge>=65536?2:1,ge<128?oe[ue++]=ge:ge<2048?(oe[ue++]=192|(ge&1984)>>>6,oe[ue++]=128|(ge&63)>>>0):ge<65536?(oe[ue++]=224|(ge&61440)>>>12,oe[ue++]=128|(ge&4032)>>>6,oe[ue++]=128|(ge&63)>>>0):(oe[ue++]=240|(ge&1835008)>>>18,oe[ue++]=128|(ge&258048)>>>12,oe[ue++]=128|(ge&4032)>>>6,oe[ue++]=128|(ge&63)>>>0)}return oe}e.encodeUTF8=q;function H(W){const Z=W.byteLength,ae=[];let ce=0;for(;ce<Z;){const oe=W[ce];let ue;if(oe>=240&&ce+3<Z?ue=(W[ce++]&7)<<18>>>0|(W[ce++]&63)<<12>>>0|(W[ce++]&63)<<6>>>0|(W[ce++]&63)<<0>>>0:oe>=224&&ce+2<Z?ue=(W[ce++]&15)<<12>>>0|(W[ce++]&63)<<6>>>0|(W[ce++]&63)<<0>>>0:oe>=192&&ce+1<Z?ue=(W[ce++]&31)<<6>>>0|(W[ce++]&63)<<0>>>0:ue=W[ce++],ue>=0&&ue<=55295||ue>=57344&&ue<=65535)ae.push(String.fromCharCode(ue));else if(ue>=65536&&ue<=1114111){const ge=ue-65536,Se=55296+((ge&1047552)>>>10),le=56320+((ge&1023)>>>0);ae.push(String.fromCharCode(Se)),ae.push(String.fromCharCode(le))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=H;const Y=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function te(W){return Y.test(W)}e.containsRTL=te;const ne=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function se(W){return ne.test(W)}e.containsEmoji=se;const ee=/^[\t\n\r\x20-\x7E]*$/;function he(W){return ee.test(W)}e.isBasicASCII=he,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function de(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=de;function ye(W){for(let Z=0,ae=W.length;Z<ae;Z++)if(pe(W.charCodeAt(Z)))return!0;return!1}e.containsFullWidthCharacter=ye;function pe(W){return W=+W,W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=pe;function Pe(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129003||W>=129280&&W<=129535||W>=129648&&W<=129750}e.isEmojiImprecise=Pe;function Te(W,Z){if(W.length<Z)return W;const ae=/\b/g;let ce=0;for(;ae.test(W)&&!(W.length-ae.lastIndex<Z);)ce=ae.lastIndex,ae.lastIndex+=1;return W.substring(ce).replace(/^\s/,"")}e.lcut=Te;const Me=/\x1B\x5B[12]?K/g,Oe=/\x1b\[\d+m/g,Le=/\x1b\[0?m/g;function _e(W){return W&&(W=W.replace(Me,""),W=W.replace(Oe,""),W=W.replace(Le,"")),W}e.removeAnsiEscapeCodes=_e,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function ke(W){return be(W)?W.substr(1):W}e.stripUTF8BOM=ke;function Ke(W,Z){if(!W||!Z||W.length<Z.length)return!1;const ae=Z.length,ce=W.toLowerCase();let oe=0,ue=-1;for(;oe<ae;){const ge=ce.indexOf(Z[oe],ue+1);if(ge<0)return!1;ue=ge,oe++}return!0}e.fuzzyContains=Ke;function Ye(W,Z=!1){return W?(Z&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=Ye;function $e(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=$e;function je(W,Z=1){if(Z===0)return"";let ae=-1;do ae=W.indexOf(`
`,ae+1),Z--;while(Z>0&&ae>=0);return ae===-1?W:(W[ae-1]==="\r"&&ae--,W.substr(0,ae))}e.getNLines=je;function J(W){const Z=90-65+1;return W=W%(2*Z),W<Z?String.fromCharCode(97+W):String.fromCharCode(65+W-Z)}e.singleLetterHash=J;function ie(W){return ve.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=ie;function re(W,Z){return W===0?Z!==5&&Z!==7:W===2&&Z===3?!1:W===4||W===2||W===3||Z===4||Z===2||Z===3?!0:!(W===8&&(Z===8||Z===9||Z===11||Z===12)||(W===11||W===9)&&(Z===9||Z===10)||(W===12||W===10)&&Z===10||Z===5||Z===13||Z===7||W===1||W===13&&Z===14||W===6&&Z===6)}e.breakBetweenGraphemeBreakType=re;var me;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(me=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ve{constructor(){this._data=De()}static getInstance(){return ve._INSTANCE||(ve._INSTANCE=new ve),ve._INSTANCE}getGraphemeBreakType(Z){if(Z<32)return Z===10?3:Z===13?2:4;if(Z<127)return 0;const ae=this._data,ce=ae.length/3;let oe=1;for(;oe<=ce;)if(Z<ae[3*oe])oe=2*oe;else if(Z>ae[3*oe+1])oe=2*oe+1;else return ae[3*oe+2];return 0}}ve._INSTANCE=null;function De(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function we(W,Z){if(W===0)return 0;const ae=Ae(W,Z);if(ae!==void 0)return ae;const ce=N(Z,W);return W-=Ce(ce),W}e.getLeftDeleteOffset=we;function Ae(W,Z){let ae=N(Z,W);for(W-=Ce(ae);Re(ae)||ae===65039||ae===8419;){if(W===0)return;ae=N(Z,W),W-=Ce(ae)}if(!!Pe(ae)){if(W>=0){const ce=N(Z,W);ce===8205&&(W-=Ce(ce))}return W}}function Ce(W){return W>=65536?2:1}function Re(W){return 127995<=W&&W<=127999}var Ue;(function(W){W[W.zwj=8205]="zwj",W[W.emojiVariantSelector=65039]="emojiVariantSelector",W[W.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={}))}),define(X[25],Q([0,1,19,48]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const P=typeof Buffer!="undefined",k=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let R,p;class E{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return P?new E(Buffer.allocUnsafe(u)):new E(new Uint8Array(u))}static wrap(u){return P&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new E(u)}static fromString(u,g){return!(g?.dontUseNodeBuffer||!1)&&P?new E(Buffer.from(u)):k?(R||(R=new TextEncoder),new E(R.encode(u))):new E(S.encodeUTF8(u))}static concat(u,g){if(typeof g=="undefined"){g=0;for(let T=0,O=u.length;T<O;T++)g+=u[T].byteLength}const w=E.alloc(g);let d=0;for(let T=0,O=u.length;T<O;T++){const $=u[T];w.set($,d),d+=$.byteLength}return w}toString(){return P?this.buffer.toString():A?(p||(p=new TextDecoder),p.decode(this.buffer)):S.decodeUTF8(this.buffer)}slice(u,g){return new E(this.buffer.subarray(u,g))}set(u,g){u instanceof E?this.buffer.set(u.buffer,g):this.buffer.set(u,g)}readUInt32BE(u){return v(this.buffer,u)}writeUInt32BE(u,g){m(this.buffer,u,g)}readUInt32LE(u){return h(this.buffer,u)}writeUInt32LE(u,g){C(this.buffer,u,g)}readUInt8(u){return D(this.buffer,u)}writeUInt8(u,g){b(this.buffer,u,g)}}e.VSBuffer=E;function n(o,u){return o[u+0]<<0>>>0|o[u+1]<<8>>>0}e.readUInt16LE=n;function y(o,u,g){o[g+0]=u&255,u=u>>>8,o[g+1]=u&255}e.writeUInt16LE=y;function v(o,u){return o[u]*2**24+o[u+1]*2**16+o[u+2]*2**8+o[u+3]}e.readUInt32BE=v;function m(o,u,g){o[g+3]=u,u=u>>>8,o[g+2]=u,u=u>>>8,o[g+1]=u,u=u>>>8,o[g]=u}e.writeUInt32BE=m;function h(o,u){return o[u+0]<<0>>>0|o[u+1]<<8>>>0|o[u+2]<<16>>>0|o[u+3]<<24>>>0}e.readUInt32LE=h;function C(o,u,g){o[g+0]=u&255,u=u>>>8,o[g+1]=u&255,u=u>>>8,o[g+2]=u&255,u=u>>>8,o[g+3]=u&255}e.writeUInt32LE=C;function D(o,u){return o[u]}e.readUInt8=D;function b(o,u,g){o[g]=u}e.writeUInt8=b;function I(o){return L.consumeReadable(o,u=>E.concat(u))}e.readableToBuffer=I;function f(o){return L.toReadable(o)}e.bufferToReadable=f;function s(o){return L.consumeStream(o,u=>E.concat(u))}e.streamToBuffer=s;async function c(o){return o.ended?E.concat(o.buffer):E.concat([...o.buffer,await s(o.stream)])}e.bufferedStreamToBuffer=c;function t(o){return L.toStream(o,u=>E.concat(u))}e.bufferToStream=t;function r(o){return L.transform(o,{data:u=>typeof u=="string"?E.fromString(u):E.wrap(u)},u=>E.concat(u))}e.streamToBufferReadableStream=r;function i(o){return L.newWriteableStream(u=>E.concat(u),o)}e.newWriteableBufferStream=i;function a(o,u){return L.prefixedReadable(o,u,g=>E.concat(g))}e.prefixedBufferReadable=a;function l(o,u){return L.prefixedStream(o,u,g=>E.concat(g))}e.prefixedBufferStream=l}),define(X[16],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function S(u){return Array.isArray(u)}e.isArray=S;function L(u){return typeof u=="string"}e.isString=L;function P(u){return Array.isArray(u)&&u.every(g=>L(g))}e.isStringArray=P;function k(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=k;function A(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=A;function R(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=R;function p(u){return u===!0||u===!1}e.isBoolean=p;function E(u){return typeof u=="undefined"}e.isUndefined=E;function n(u){return!y(u)}e.isDefined=n;function y(u){return E(u)||u===null}e.isUndefinedOrNull=y;function v(u,g){if(!u)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}e.assertType=v;function m(u){if(y(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=m;function h(...u){const g=[];for(let w=0;w<u.length;w++){const d=u[w];if(y(d))throw new Error(`Assertion Failed: argument at index ${w} is undefined or null`);g.push(d)}return g}e.assertAllDefined=h;const C=Object.prototype.hasOwnProperty;function D(u){if(!k(u))return!1;for(let g in u)if(C.call(u,g))return!1;return!0}e.isEmptyObject=D;function b(u){return typeof u=="function"}e.isFunction=b;function I(...u){return u.length>0&&u.every(b)}e.areFunctions=I;function f(u,g){const w=Math.min(u.length,g.length);for(let d=0;d<w;d++)s(u[d],g[d])}e.validateConstraints=f;function s(u,g){if(L(g)){if(typeof u!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(b(g)){try{if(u instanceof g)return}catch{}if(!y(u)&&u.constructor===g||g.length===1&&g.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function c(u){let g=[],w=Object.getPrototypeOf(u);for(;Object.prototype!==w;)g=g.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return g}e.getAllPropertyNames=c;function t(u){const g=[];for(const w of c(u))typeof u[w]=="function"&&g.push(w);return g}e.getAllMethodNames=t;function r(u,g){const w=T=>function(){const O=Array.prototype.slice.call(arguments,0);return g(T,O)};let d={};for(const T of u)d[T]=w(T);return d}e.createProxyObject=r;function i(u){return u===null?void 0:u}e.withNullAsUndefined=i;function a(u){return typeof u=="undefined"?null:u}e.withUndefinedAsNull=a;function l(u){return class{constructor(){return new Proxy({},{get(g,w){if(g[w])return g[w];throw new Error(`Not Implemented: ${u}->${String(w)}`)}})}}}e.NotImplementedProxy=l;function o(u){throw new Error("Unreachable")}e.assertNever=o}),define(X[41],Q([0,1,7,19,8,16]),function(G,e,S,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(i){return i===47||i===92}e.isPathSeparator=A;function R(i){return i.replace(/[\\/]/g,P.posix.sep)}e.toSlashes=R;function p(i){return i.indexOf("/")===-1&&(i=R(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=p;function E(i,a=P.posix.sep){if(!i)return"";const l=i.length,o=i.charCodeAt(0);if(A(o)){if(A(i.charCodeAt(1))&&!A(i.charCodeAt(2))){let g=3;const w=g;for(;g<l&&!A(i.charCodeAt(g));g++);if(w!==g&&!A(i.charCodeAt(g+1))){for(g+=1;g<l;g++)if(A(i.charCodeAt(g)))return i.slice(0,g+1).replace(/[\\/]/g,a)}}return a}else if(b(o)&&i.charCodeAt(1)===58)return A(i.charCodeAt(2))?i.slice(0,2)+a:i.slice(0,2);let u=i.indexOf("://");if(u!==-1){for(u+=3;u<l;u++)if(A(i.charCodeAt(u)))return i.slice(0,u+1)}return""}e.getRoot=E;function n(i){if(!S.isWindows||!i||i.length<5)return!1;let a=i.charCodeAt(0);if(a!==92||(a=i.charCodeAt(1),a!==92))return!1;let l=2;const o=l;for(;l<i.length&&(a=i.charCodeAt(l),a!==92);l++);return!(o===l||(a=i.charCodeAt(l+1),isNaN(a)||a===92))}e.isUNC=n;const y=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(i,a=S.isWindows){const l=a?y:v;return!(!i||i.length===0||/^\s+$/.test(i)||(l.lastIndex=0,l.test(i))||a&&m.test(i)||i==="."||i===".."||a&&i[i.length-1]==="."||a&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=h;function C(i,a,l){const o=i===a;return!l||o?o:!i||!a?!1:(0,L.equalsIgnoreCase)(i,a)}e.isEqual=C;function D(i,a,l,o=P.sep){if(i===a)return!0;if(!i||!a||a.length>i.length)return!1;if(l){if(!(0,L.startsWithIgnoreCase)(i,a))return!1;if(a.length===i.length)return!0;let g=a.length;return a.charAt(a.length-1)===o&&g--,i.charAt(g)===o}return a.charAt(a.length-1)!==o&&(a+=o),i.indexOf(a)===0}e.isEqualOrParent=D;function b(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=b;function I(i,a){return S.isWindows&&i.endsWith(":")&&(i+=P.sep),(0,P.isAbsolute)(i)||(i=(0,P.join)(a,i)),i=(0,P.normalize)(i),S.isWindows?(i=(0,L.rtrim)(i,P.sep),i.endsWith(":")&&(i+=P.sep)):(i=(0,L.rtrim)(i,P.sep),i||(i=P.sep)),i}e.sanitizeFilePath=I;function f(i){const a=(0,P.normalize)(i);return S.isWindows?i.length>3?!1:s(a)&&(i.length===2||a.charCodeAt(2)===92):a===P.posix.sep}e.isRootOrDriveLetter=f;function s(i){return S.isWindows?b(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function c(i){return s(i)?i[0]:void 0}e.getDriveLetter=c;function t(i,a,l){return a.length>i.length?-1:i===a?0:(l&&(i=i.toLowerCase(),a=a.toLowerCase()),i.indexOf(a))}e.indexOfPath=t;function r(i){const a=i.split(":");let l,o,u;if(a.forEach(g=>{const w=Number(g);(0,k.isNumber)(w)?o===void 0?o=w:u===void 0&&(u=w):l=l?[l,g].join(":"):g}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:o!==void 0?o:void 0,column:u!==void 0?u:o!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(X[26],Q([0,1,16]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(C){if(!C||typeof C!="object"||C instanceof RegExp)return C;const D=Array.isArray(C)?[]:{};return Object.keys(C).forEach(b=>{C[b]&&typeof C[b]=="object"?D[b]=L(C[b]):D[b]=C[b]}),D}e.deepClone=L;function P(C){if(!C||typeof C!="object")return C;const D=[C];for(;D.length>0;){const b=D.shift();Object.freeze(b);for(const I in b)if(k.call(b,I)){const f=b[I];typeof f=="object"&&!Object.isFrozen(f)&&D.push(f)}}return C}e.deepFreeze=P;const k=Object.prototype.hasOwnProperty;function A(C,D){return R(C,D,new Set)}e.cloneAndChange=A;function R(C,D,b){if((0,S.isUndefinedOrNull)(C))return C;const I=D(C);if(typeof I!="undefined")return I;if((0,S.isArray)(C)){const f=[];for(const s of C)f.push(R(s,D,b));return f}if((0,S.isObject)(C)){if(b.has(C))throw new Error("Cannot clone recursive data-structure");b.add(C);const f={};for(let s in C)k.call(C,s)&&(f[s]=R(C[s],D,b));return b.delete(C),f}return C}function p(C,D,b=!0){return(0,S.isObject)(C)?((0,S.isObject)(D)&&Object.keys(D).forEach(I=>{I in C?b&&((0,S.isObject)(C[I])&&(0,S.isObject)(D[I])?p(C[I],D[I],b):C[I]=D[I]):C[I]=D[I]}),C):D}e.mixin=p;function E(C,D){if(C===D)return!0;if(C==null||D===null||D===void 0||typeof C!=typeof D||typeof C!="object"||Array.isArray(C)!==Array.isArray(D))return!1;let b,I;if(Array.isArray(C)){if(C.length!==D.length)return!1;for(b=0;b<C.length;b++)if(!E(C[b],D[b]))return!1}else{const f=[];for(I in C)f.push(I);f.sort();const s=[];for(I in D)s.push(I);if(s.sort(),!E(f,s))return!1;for(b=0;b<f.length;b++)if(!E(C[f[b]],D[f[b]]))return!1}return!0}e.equals=E;function n(C){const D=new Set;return JSON.stringify(C,(b,I)=>{if((0,S.isObject)(I)||Array.isArray(I)){if(D.has(I))return"[Circular]";D.add(I)}return I})}e.safeStringify=n;function y(C,D,b){const I=D(C);return typeof I=="undefined"?b:I}e.getOrDefault=y;function v(C,D){const b=Object.create(null);return!C||!D||Object.keys(D).forEach(f=>{const s=C[f],c=D[f];E(s,c)||(b[f]=c)}),b}e.distinct=v;function m(C,D){const b=D.toLowerCase(),I=Object.keys(C).find(f=>f.toLowerCase()===b);return I?C[I]:C[D]}e.getCaseInsensitive=m;function h(C,D){const b=Object.create(null);for(const I of Object.keys(C))D(I,C[I])&&(b[I]=C[I]);return b}e.filter=h}),define(X[4],Q([0,1,7,8]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,k=/^\//,A=/^\/\//;function R(i,a){if(!i.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!P.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!k.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(i,a){return!i&&!a?"file":i}function E(i,a){switch(i){case"https":case"http":case"file":a?a[0]!==y&&(a=y+a):a=y;break}return a}const n="",y="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(a,l,o,u,g,w=!1){typeof a=="object"?(this.scheme=a.scheme||n,this.authority=a.authority||n,this.path=a.path||n,this.query=a.query||n,this.fragment=a.fragment||n):(this.scheme=p(a,w),this.authority=l||n,this.path=E(this.scheme,o||n),this.query=u||n,this.fragment=g||n,R(this,w))}static isUri(a){return a instanceof m?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return f(this,!1)}with(a){if(!a)return this;let{scheme:l,authority:o,path:u,query:g,fragment:w}=a;return l===void 0?l=this.scheme:l===null&&(l=n),o===void 0?o=this.authority:o===null&&(o=n),u===void 0?u=this.path:u===null&&(u=n),g===void 0?g=this.query:g===null&&(g=n),w===void 0?w=this.fragment:w===null&&(w=n),l===this.scheme&&o===this.authority&&u===this.path&&g===this.query&&w===this.fragment?this:new C(l,o,u,g,w)}static parse(a,l=!1){const o=v.exec(a);return o?new C(o[2]||n,r(o[4]||n),r(o[5]||n),r(o[7]||n),r(o[9]||n),l):new C(n,n,n,n,n)}static file(a){let l=n;if(S.isWindows&&(a=a.replace(/\\/g,y)),a[0]===y&&a[1]===y){const o=a.indexOf(y,2);o===-1?(l=a.substring(2),a=y):(l=a.substring(2,o),a=a.substring(o)||y)}return new C("file",l,a,n,n)}static from(a){const l=new C(a.scheme,a.authority,a.path,a.query,a.fragment);return R(l,!0),l}static joinPath(a,...l){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return S.isWindows&&a.scheme==="file"?o=m.file(L.win32.join(f(a,!0),...l)).path:o=L.posix.join(a.path,...l),a.with({path:o})}toString(a=!1){return s(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof m)return a;{const l=new C(a);return l._formatted=a.external,l._fsPath=a._sep===h?a.fsPath:null,l}}else return a}}e.URI=m;const h=S.isWindows?1:void 0;class C extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(a=!1){return a?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=h),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(i,a){let l,o=-1;for(let u=0;u<i.length;u++){const g=i.charCodeAt(u);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||a&&g===47)o!==-1&&(l+=encodeURIComponent(i.substring(o,u)),o=-1),l!==void 0&&(l+=i.charAt(u));else{l===void 0&&(l=i.substr(0,u));const w=D[g];w!==void 0?(o!==-1&&(l+=encodeURIComponent(i.substring(o,u)),o=-1),l+=w):o===-1&&(o=u)}}return o!==-1&&(l+=encodeURIComponent(i.substring(o))),l!==void 0?l:i}function I(i){let a;for(let l=0;l<i.length;l++){const o=i.charCodeAt(l);o===35||o===63?(a===void 0&&(a=i.substr(0,l)),a+=D[o]):a!==void 0&&(a+=i[l])}return a!==void 0?a:i}function f(i,a){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?a?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,S.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=f;function s(i,a){const l=a?I:b;let o="",{scheme:u,authority:g,path:w,query:d,fragment:T}=i;if(u&&(o+=u,o+=":"),(g||u==="file")&&(o+=y,o+=y),g){let O=g.indexOf("@");if(O!==-1){const $=g.substr(0,O);g=g.substr(O+1),O=$.indexOf(":"),O===-1?o+=l($,!1):(o+=l($.substr(0,O),!1),o+=":",o+=l($.substr(O+1),!1)),o+="@"}g=g.toLowerCase(),O=g.indexOf(":"),O===-1?o+=l(g,!1):(o+=l(g.substr(0,O),!1),o+=g.substr(O))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const O=w.charCodeAt(1);O>=65&&O<=90&&(w=`/${String.fromCharCode(O+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const O=w.charCodeAt(0);O>=65&&O<=90&&(w=`${String.fromCharCode(O+32)}:${w.substr(2)}`)}o+=l(w,!0)}return d&&(o+="?",o+=l(d,!1)),T&&(o+="#",o+=a?T:b(T,!1)),o}function c(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+c(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,a=>c(a)):i}}),define(X[90],Q([0,1,4]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(E){const n=E;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=L;function P(E){const n=[];let y;try{const v=JSON.parse(E.arguments),m=v[v.length-1];m&&m.__$stack&&(v.pop(),y=m.__$stack),n.push(...v)}catch(v){n.push("Unable to log remote console arguments",E.arguments)}return{args:n,stack:y}}e.parse=P;function k(E){if(typeof E!="string")return k(P(E).stack);const n=E;if(n){const y=A(n),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(v&&v.length===4)return{uri:S.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=k;function A(E){if(!E)return E;const n=E.indexOf(`
`);return n===-1?E:E.substring(0,n)}function R(E,n){const{args:y,stack:v}=P(E),m=typeof y[0]=="string"&&y.length===1;let h=A(v);h&&(h=`(${h.trim()})`);let C=[];if(typeof y[0]=="string"?h&&m?C=[`%c[${n}] %c${y[0]} %c${h}`,p("blue"),p(""),p("grey")]:C=[`%c[${n}] %c${y[0]}`,p("blue"),p(""),...y.slice(1)]:C=[`%c[${n}]%`,p("blue"),...y],h&&!m&&C.push(h),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,C)}e.log=R;function p(E){return`color: ${E}`}});var ut=this&&this.__classPrivateFieldSet||function(G,e,S,L,P){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!P:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?P.call(G,S):P?P.value=S:e.set(G,S),S},xe=this&&this.__classPrivateFieldGet||function(G,e,S,L){if(S==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!L:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return S==="m"?L:S==="a"?L.call(G):L?L.value:e.get(G)};define(X[38],Q([0,1,4,19]),function(G,e,S,L){"use strict";var P,k,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(t,r,i){let a=t.get(r);return a===void 0&&(a=i,t.set(r,a)),a}e.getOrSet=R;function p(t){const r=[];return t.forEach((i,a)=>{r.push(`${a} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=p;function E(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=E;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),a=this._value.charCodeAt(this._pos);return i-a}value(){return this._value[this._pos]}}e.StringIterator=n;class y{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class v{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=v;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class h{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class C{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class D{constructor(r){this._iter=r}static forUris(r=()=>!1){return new D(new h(r))}static forPaths(){return new D(new v)}static forStrings(){return new D(new n)}static forConfigKeys(){return new D(new y)}clear(){this._root=void 0}set(r,i){const a=this._iter.reset(r);let l;for(this._root||(this._root=new C,this._root.segment=a.value()),l=this._root;;){const u=a.cmp(l.segment);if(u>0)l.left||(l.left=new C,l.left.segment=a.value()),l=l.left;else if(u<0)l.right||(l.right=new C,l.right.segment=a.value()),l=l.right;else if(a.hasNext())a.next(),l.mid||(l.mid=new C,l.mid.segment=a.value()),l=l.mid;else break}const o=l.value;return l.value=i,l.key=r,o}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let a=this._root;for(;a;){const l=i.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(i.hasNext())i.next(),a=a.mid;else break}return a}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const a=this._iter.reset(r),l=[];let o=this._root;for(;o;){const u=a.cmp(o.segment);if(u>0)l.push([1,o]),o=o.left;else if(u<0)l.push([-1,o]),o=o.right;else if(a.hasNext())a.next(),l.push([0,o]),o=o.mid;else{for(i?(o.left=void 0,o.mid=void 0,o.right=void 0):o.value=void 0;l.length>0&&o.isEmpty();){let[g,w]=l.pop();switch(g){case 1:w.left=void 0;break;case 0:w.mid=void 0;break;case-1:w.right=void 0;break}o=w}break}}}findSubstr(r){const i=this._iter.reset(r);let a=this._root,l;for(;a;){const o=i.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(i.hasNext())i.next(),l=a.value||l,a=a.mid;else break}return a&&a.value||l}findSuperstr(r){const i=this._iter.reset(r);let a=this._root;for(;a;){const l=i.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(i.hasNext())i.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(r){for(const[i,a]of this)r(a,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const a=i.pop();a&&(a.value&&(yield[a.key,a.value]),a.left&&i.push(a.left),a.mid&&i.push(a.mid),a.right&&i.push(a.right))}}}e.TernarySearchTree=D;class b{constructor(r,i){this[P]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=i??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[a,l]of this.map)r(l,S.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield S.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[S.URI.parse(r[0]),r[1]]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[S.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var I;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class f{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const a=this._map.get(r);if(!!a)return i!==0&&this.touch(a,i),a.value}set(r,i,a=0){let l=this._map.get(r);if(l)l.value=i,a!==0&&this.touch(l,a);else{switch(l={key:r,value:i,next:void 0,previous:void 0},a){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(r,l),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const a=this._state;let l=this._head;for(;l;){if(i?r.bind(i)(l.value,l.key,this):r(l.value,l.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const r=this,i=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const o={value:a.key,done:!1};return a=a.next,o}else return{value:void 0,done:!0}}};return l}values(){const r=this,i=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const o={value:a.value,done:!1};return a=a.next,o}else return{value:void 0,done:!0}}};return l}entries(){const r=this,i=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const o={value:[a.key,a.value],done:!1};return a=a.next,o}else return{value:void 0,done:!0}}};return l}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,a=this.size;for(;i&&a>r;)this._map.delete(i.key),i=i.next,a--;this._head=i,this._size=a,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,a=r.previous;if(!i||!a)throw new Error("Invalid list");i.previous=a,a.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const a=r.next,l=r.previous;r===this._tail?(l.next=void 0,this._tail=l):(a.previous=l,l.next=a),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const a=r.next,l=r.previous;r===this._head?(a.previous=void 0,this._head=a):(a.previous=l,l.next=a),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,a)=>{r.push([a,i])}),r}fromJSON(r){this.clear();for(const[i,a]of r)this.set(i,a)}}e.LinkedMap=f;class s extends f{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class c{constructor(r){A.set(this,void 0),ut(this,A,r,"f")}get size(){return xe(this,A,"f").size}forEach(r,i){xe(this,A,"f").forEach(r,i)}get(r){return xe(this,A,"f").get(r)}has(r){return xe(this,A,"f").has(r)}entries(){return xe(this,A,"f").entries()}keys(){return xe(this,A,"f").keys()}values(){return xe(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return xe(this,A,"f").entries()}}e.ReadonlyMapView=c}),define(X[91],Q([0,1,25,19,4]),function(G,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(n){return JSON.stringify(n,p)}e.stringify=k;function A(n){let y=JSON.parse(n);return y=E(y),y}e.parse=A;var R;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(R=e.MarshalledId||(e.MarshalledId={}));function p(n,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,L.regExpFlags)(y)}:y}function E(n,y=0){if(!n||y>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return P.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof S.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let v=0;v<n.length;++v)n[v]=E(n[v],y+1);else for(const v in n)Object.hasOwnProperty.call(n,v)&&(n[v]=E(n[v],y+1))}return n}e.revive=E}),define(X[17],Q([0,1,4,7]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var P;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp"})(P=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}set(p,E,n){this._hosts[p]=E,this._ports[p]=n}setConnectionToken(p,E){this._connectionTokens[p]=E}rewrite(p){if(this._delegate)return this._delegate(p);const E=p.authority;let n=this._hosts[E];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const y=this._ports[E],v=this._connectionTokens[E];let m=`path=${encodeURIComponent(p.path)}`;return typeof v=="string"&&(m+=`&tkn=${encodeURIComponent(v)}`),S.URI.from({scheme:L.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${n}:${y}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new k;class A{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(p,E,n){const y=this.toUri(p,E);if(y.scheme===P.vscodeRemote)return e.RemoteAuthorities.rewrite(y);let v=!1;return L.isNative&&(n||L.isPreferringBrowserCodeLoad)&&y.scheme===P.file&&(v=!0),y.scheme===P.file&&typeof L.globals.importScripts=="function"&&L.globals.origin==="vscode-file://vscode-app"&&(v=!0),v?y.with({scheme:P.vscodeFileResource,authority:y.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(p,E){const n=this.toUri(p,E);return n.scheme===P.vscodeFileResource?n.with({scheme:P.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(p,E){return S.URI.isUri(p)?p:S.URI.parse(E.toUrl(p))}}e.FileAccess=new A}),define(X[66],Q([0,1,38]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new S.LRUCache(1e4);function P(E){return p(E,"NFC",L)}e.normalizeNFC=P;const k=new S.LRUCache(1e4);function A(E){return p(E,"NFD",k)}e.normalizeNFD=A;const R=/[^\u0000-\u0080]/;function p(E,n,y){if(!E)return E;const v=y.get(E);if(v)return v;let m;return R.test(E)?m=E.normalize(n):m=E,y.set(E,m),m}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(n){return A(n).replace(E,"")}}()}),define(X[15],Q([0,1,41,8,4,19,17,7]),function(G,e,S,L,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(m){return(0,P.uriToFsPath)(m,!0)}e.originalFSPath=p;class E{constructor(h){this._ignorePathCasing=h}compare(h,C,D=!1){return h===C?0:(0,k.compare)(this.getComparisonKey(h,D),this.getComparisonKey(C,D))}isEqual(h,C,D=!1){return h===C?!0:!h||!C?!1:this.getComparisonKey(h,D)===this.getComparisonKey(C,D)}getComparisonKey(h,C=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:C?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,C,D=!1){if(h.scheme===C.scheme){if(h.scheme===A.Schemas.file)return S.isEqualOrParent(p(h),p(C),this._ignorePathCasing(h))&&h.query===C.query&&(D||h.fragment===C.fragment);if((0,e.isEqualAuthority)(h.authority,C.authority))return S.isEqualOrParent(h.path,C.path,this._ignorePathCasing(h),"/")&&h.query===C.query&&(D||h.fragment===C.fragment)}return!1}joinPath(h,...C){return P.URI.joinPath(h,...C)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return L.posix.basename(h.path)}extname(h){return L.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let C;return h.scheme===A.Schemas.file?C=P.URI.file(L.dirname(p(h))).path:(C=L.posix.dirname(h.path),h.authority&&C.length&&C.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),C="/")),h.with({path:C})}normalizePath(h){if(!h.path.length)return h;let C;return h.scheme===A.Schemas.file?C=P.URI.file(L.normalize(p(h))).path:C=L.posix.normalize(h.path),h.with({path:C})}relativePath(h,C){if(h.scheme!==C.scheme||!(0,e.isEqualAuthority)(h.authority,C.authority))return;if(h.scheme===A.Schemas.file){const I=L.relative(p(h),p(C));return R.isWindows?S.toSlashes(I):I}let D=h.path||"/",b=C.path||"/";if(this._ignorePathCasing(h)){let I=0;for(const f=Math.min(D.length,b.length);I<f&&!(D.charCodeAt(I)!==b.charCodeAt(I)&&D.charAt(I).toLowerCase()!==b.charAt(I).toLowerCase());I++);D=b.substr(0,I)+D.substr(I)}return L.posix.relative(D,b)}resolvePath(h,C){if(h.scheme===A.Schemas.file){const D=P.URI.file(L.resolve(p(h),C));return h.with({authority:D.authority,path:D.path})}return C=S.toPosixPath(C),h.with({path:L.posix.resolve(h.path,C)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,C){return h===C||(0,k.equalsIgnoreCase)(h,C)}hasTrailingPathSeparator(h,C=L.sep){if(h.scheme===A.Schemas.file){const D=p(h);return D.length>S.getRoot(D).length&&D[D.length-1]===C}else{const D=h.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,C=L.sep){return(0,e.hasTrailingPathSeparator)(h,C)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,C=L.sep){let D=!1;if(h.scheme===A.Schemas.file){const b=p(h);D=b!==void 0&&b.length===S.getRoot(b).length&&b[b.length-1]===C}else{C="/";const b=h.path;D=b.length===1&&b.charCodeAt(b.length-1)===47}return!D&&!(0,e.hasTrailingPathSeparator)(h,C)?h.with({path:h.path+"/"}):h}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(m=>m.scheme===A.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new E(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(m,h){const C=[];for(let D=0;D<m.length;D++){const b=h(m[D]);m.some((I,f)=>f===D?!1:(0,e.isEqualOrParent)(b,h(I)))||C.push(m[D])}return C}e.distinctParents=n;var y;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function h(C){const D=new Map;C.path.substring(C.path.indexOf(";")+1,C.path.lastIndexOf(";")).split(";").forEach(f=>{const[s,c]=f.split(":");s&&c&&D.set(s,c)});const I=C.path.substring(0,C.path.indexOf(";"));return I&&D.set(m.META_DATA_MIME,I),D}m.parseMetaData=h})(y=e.DataUri||(e.DataUri={}));function v(m,h,C){if(h){let D=m.path;return D&&D[0]!==L.posix.sep&&(D=L.posix.sep+D),m.with({scheme:C,authority:h,path:D})}return m.with({scheme:C})}e.toLocalResource=v}),define(X[6],Q([0,1,29,9,3,2,15]),function(G,e,S,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function R(_){return!!_&&typeof _.then=="function"}e.isThenable=R;function p(_){const N=new S.CancellationTokenSource,j=_(N.token),F=new Promise((U,x)=>{const q=N.token.onCancellationRequested(()=>{q.dispose(),N.dispose(),x((0,L.canceled)())});Promise.resolve(j).then(H=>{q.dispose(),N.dispose(),U(H)},H=>{q.dispose(),N.dispose(),x(H)})});return new class{cancel(){N.cancel()}then(U,x){return F.then(U,x)}catch(U){return this.then(void 0,U)}finally(U){return F.finally(U)}}}e.createCancelablePromise=p;function E(_,N,j){return Promise.race([_,new Promise(F=>N.onCancellationRequested(()=>F(j)))])}e.raceCancellation=E;async function n(_){let N=-1;const j=_.map((U,x)=>U.then(q=>(N=x,q))),F=await Promise.race(j);return _.forEach((U,x)=>{x!==N&&U.cancel()}),F}e.raceCancellablePromises=n;function y(_,N,j){let F;const U=setTimeout(()=>{F?.(void 0),j?.()},N);return Promise.race([_.finally(()=>clearTimeout(U)),new Promise(x=>F=x)])}e.raceTimeout=y;function v(_){return new Promise((N,j)=>{const F=_();R(F)?F.then(N,j):N(F)})}e.asPromise=v;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(j,j).then(F)})}return new Promise((j,F)=>{this.queuedPromise.then(j,F)})}return this.activePromise=N(),new Promise((j,F)=>{this.activePromise.then(U=>{this.activePromise=null,j(U)},U=>{this.activePromise=null,F(U)})})}}e.Throttler=m;class h{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=h;class C{constructor(){this.promiseMap=new Map}queue(N,j){const U=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(N)===U&&this.promiseMap.delete(N)});return this.promiseMap.set(N,U),U}}e.SequencerByKey=C;class D{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,j=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,U)=>{this.doResolve=F,this.doReject=U}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},j),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=D;class b{constructor(N){this.delayer=new D(N),this.throttler=new m}trigger(N,j){return this.delayer.trigger(()=>this.throttler.queue(N),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class I{constructor(){this._isOpen=!1,this._promise=new Promise((N,j)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=I;class f extends I{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function s(_,N){return N?new Promise((j,F)=>{const U=setTimeout(()=>{x.dispose(),j()},_),x=N.onCancellationRequested(()=>{clearTimeout(U),x.dispose(),F((0,L.canceled)())})}):p(j=>s(_,j))}e.timeout=s;function c(_,N=0){const j=setTimeout(_,N);return(0,k.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=c;function t(_){const N=[];let j=0;const F=_.length;function U(){return j<F?_[j++]():null}function x(q){q!=null&&N.push(q);const H=U();return H?H.then(x):Promise.resolve(N)}return Promise.resolve(null).then(x)}e.sequence=t;function r(_,N=F=>!!F,j=null){let F=0;const U=_.length,x=()=>{if(F>=U)return Promise.resolve(j);const q=_[F++];return Promise.resolve(q()).then(Y=>N(Y)?Promise.resolve(Y):x())};return x()}e.first=r;function i(_,N=F=>!!F,j=null){if(_.length===0)return Promise.resolve(j);let F=_.length;const U=()=>{F=-1;for(const x of _)x.cancel?.()};return new Promise((x,q)=>{for(const H of _)H.then(Y=>{--F>=0&&N(Y)?(U(),x(Y)):F===0&&x(j)}).catch(Y=>{--F>=0&&(U(),q(Y))})})}e.firstParallel=i;class a{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new P.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((j,F)=>{this.outstandingPromises.push({factory:N,c:j,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const j=N.factory();j.then(N.c,N.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=a;class l extends a{constructor(){super(1)}}e.Queue=l;class o{constructor(){this.queues=new Map}queueFor(N,j=A.extUri){const F=j.getComparisonKey(N);let U=this.queues.get(F);return U||(U=new l,P.Event.once(U.onFinished)(()=>{U?.dispose(),this.queues.delete(F)}),this.queues.set(F,U)),U}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=o;class u{constructor(N,j){this._token=-1,typeof N=="function"&&typeof j=="number"&&this.setIfNotSet(N,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},j)}setIfNotSet(N,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},j))}}e.TimeoutTimer=u;class g{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,j){this.cancel(),this._token=setInterval(()=>{N()},j)}}e.IntervalTimer=g;class w{constructor(N,j){this.timeoutToken=-1,this.runner=N,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=w;class d extends w{constructor(N,j){super(N,j);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=d;class T extends k.Disposable{constructor(N,j,F,U){super();this.maxWorkChunkSize=N,this.maxPendingWork=j,this.throttleDelay=F,this.handler=U,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.maxPendingWork)return!1}else if(this.pending+N.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...N),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new w(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=T,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const _=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const j=setTimeout(()=>N(_));let F=!1;return{dispose(){F||(F=!0,clearTimeout(j))}}}}else e.runWhenIdle=(_,N)=>{const j=requestIdleCallback(_,typeof N=="number"?{timeout:N}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(j))}}}}();class O{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=O;async function $(_,N,j){let F;for(let U=0;U<j;U++)try{return await _()}catch(x){F=x,await s(N)}throw F}e.retry=$;class z{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(N,j,F){return this._pending={taskId:N,cancel:()=>F?.(),promise:j},j.then(()=>this.donePending(N),()=>this.donePending(N)),j}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let j,F;const U=new Promise((x,q)=>{j=x,F=q});this._next={run:N,promise:U,promiseResolve:j,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=z;class V{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class B{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,j)=>{this.completeCallback=N,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(j=>{this.completeCallback(N),this.resolved=!0,j()})}error(N){return new Promise(j=>{this.errorCallback(N),this.rejected=!0,j()})}cancel(){new Promise(N=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=B;var M;(function(_){async function N(j){let F;const U=await Promise.all(j.map(x=>x.then(q=>q,q=>{F||(F=q)})));if(typeof F!="undefined")throw F;return U}_.settled=N})(M=e.Promises||(e.Promises={}))}),define(X[67],Q([0,1,19,41,8,38,6]),function(G,e,S,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R;const p="**",E="/",n="[/\\\\]",y="[^/\\\\]",v=/\//g;function m(U){switch(U){case 0:return"";case 1:return`${y}*?`;default:return`(?:${n}|${y}+${n}|${n}${y}+)*?`}}function h(U,x){if(!U)return[];const q=[];let H=!1,Y=!1,te="";for(const ne of U){switch(ne){case x:if(!H&&!Y){q.push(te),te="";continue}break;case"{":H=!0;break;case"}":H=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}te+=ne}return te&&q.push(te),q}e.splitGlobAware=h;function C(U){if(!U)return"";let x="";const q=h(U,E);if(q.every(H=>H===p))x=".*";else{let H=!1;q.forEach((Y,te)=>{if(Y===p){H||(x+=m(2),H=!0);return}let ne=!1,se="",ee=!1,he="";for(const de of Y){if(de!=="}"&&ne){se+=de;continue}if(ee&&(de!=="]"||!he)){let ye;de==="-"?ye=de:(de==="^"||de==="!")&&!he?ye="^":de===E?ye="":ye=S.escapeRegExpCharacters(de),he+=ye;continue}switch(de){case"{":ne=!0;continue;case"[":ee=!0;continue;case"}":x+=`(?:${h(se,",").map(Pe=>C(Pe)).join("|")})`,ne=!1,se="";break;case"]":x+="["+he+"]",ee=!1,he="";break;case"?":x+=y;continue;case"*":x+=m(1);continue;default:x+=S.escapeRegExpCharacters(de)}}te<q.length-1&&(q[te+1]!==p||te+2<q.length)&&(x+=n),H=!1})}return x}const D=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new k.LRUCache(1e4),r=function(){return!1},i=function(){return null};function a(U,x){if(!U)return i;let q;typeof U!="string"?q=U.pattern:q=U,q=q.trim();const H=`${q}_${!!x.trimForExclusions}`;let Y=t.get(H);if(Y)return l(Y,U);let te;if(D.test(q)){const ne=q.substr(4);Y=function(se,ee){return typeof se=="string"&&se.endsWith(ne)?q:null}}else(te=b.exec(o(q,x)))?Y=u(te[1],q):(x.trimForExclusions?f:I).test(q)?Y=g(q,x):(te=s.exec(o(q,x)))?Y=w(te[1].substr(1),q,!0):(te=c.exec(o(q,x)))?Y=w(te[1],q,!1):Y=d(q);return t.set(H,Y),l(Y,U)}function l(U,x){return typeof x=="string"?U:function(q,H){return L.isEqualOrParent(q,x.base)?U(P.relative(x.base,q),H):null}}function o(U,x){return x.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function u(U,x){const q=`/${U}`,H=`\\${U}`,Y=function(ne,se){return typeof ne!="string"?null:se?se===U?x:null:ne===U||ne.endsWith(q)||ne.endsWith(H)?x:null},te=[U];return Y.basenames=te,Y.patterns=[x],Y.allBasenames=te,Y}function g(U,x){const q=F(U.slice(1,-1).split(",").map(se=>a(se,x)).filter(se=>se!==i),U),H=q.length;if(!H)return i;if(H===1)return q[0];const Y=function(se,ee){for(let he=0,de=q.length;he<de;he++)if(q[he](se,ee))return U;return null},te=q.find(se=>!!se.allBasenames);te&&(Y.allBasenames=te.allBasenames);const ne=q.reduce((se,ee)=>ee.allPaths?se.concat(ee.allPaths):se,[]);return ne.length&&(Y.allPaths=ne),Y}function w(U,x,q){const H=P.sep===P.posix.sep,Y=H?U:U.replace(v,P.sep),te=P.sep+Y,ne=P.posix.sep+U,se=q?function(ee,he){return typeof ee=="string"&&(ee===Y||ee.endsWith(te)||!H&&(ee===U||ee.endsWith(ne)))?x:null}:function(ee,he){return typeof ee=="string"&&(ee===Y||!H&&ee===U)?x:null};return se.allPaths=[(q?"*/":"./")+U],se}function d(U){try{const x=new RegExp(`^${C(U)}$`);return function(q){return x.lastIndex=0,typeof q=="string"&&x.test(q)?U:null}}catch(x){return i}}function T(U,x,q){return!U||typeof x!="string"?!1:O(U)(x,void 0,q)}e.match=T;function O(U,x={}){if(!U)return r;if(typeof U=="string"||B(U)){const q=a(U,x);if(q===i)return r;const H=function(Y,te){return!!q(Y,te)};return q.allBasenames&&(H.allBasenames=q.allBasenames),q.allPaths&&(H.allPaths=q.allPaths),H}return N(U,x)}e.parse=O;function $(U){if(!U)return;let x;return q=>(x||(x=(U()||Promise.resolve([])).then(H=>H?V(H):{})),x.then(H=>!!H[q]))}e.hasSiblingPromiseFn=$;function z(U){if(!U)return;let x;return q=>{if(!x){const H=U();x=H?V(H):{}}return!!x[q]}}e.hasSiblingFn=z;function V(U){const x={};for(const q of U)x[q]=!0;return x}function B(U){const x=U;return x&&typeof x.base=="string"&&typeof x.pattern=="string"}e.isRelativePattern=B;function M(U){return U.allBasenames||[]}e.getBasenameTerms=M;function _(U){return U.allPaths||[]}e.getPathTerms=_;function N(U,x){const q=F(Object.getOwnPropertyNames(U).map(se=>j(se,U[se],x)).filter(se=>se!==i)),H=q.length;if(!H)return i;if(!q.some(se=>!!se.requiresSiblings)){if(H===1)return q[0];const se=function(de,ye){for(let pe=0,Pe=q.length;pe<Pe;pe++){const Te=q[pe](de,ye);if(Te)return Te}return null},ee=q.find(de=>!!de.allBasenames);ee&&(se.allBasenames=ee.allBasenames);const he=q.reduce((de,ye)=>ye.allPaths?de.concat(ye.allPaths):de,[]);return he.length&&(se.allPaths=he),se}const Y=function(se,ee,he){let de;for(let ye=0,pe=q.length;ye<pe;ye++){const Pe=q[ye];Pe.requiresSiblings&&he&&(ee||(ee=P.basename(se)),de||(de=ee.substr(0,ee.length-P.extname(se).length)));const Te=Pe(se,ee,de,he);if(Te)return Te}return null},te=q.find(se=>!!se.allBasenames);te&&(Y.allBasenames=te.allBasenames);const ne=q.reduce((se,ee)=>ee.allPaths?se.concat(ee.allPaths):se,[]);return ne.length&&(Y.allPaths=ne),Y}function j(U,x,q){if(x===!1)return i;const H=a(U,q);if(H===i)return i;if(typeof x=="boolean")return H;if(x){const Y=x.when;if(typeof Y=="string"){const te=(ne,se,ee,he)=>{if(!he||!H(ne,se))return null;const de=Y.replace("$(basename)",ee),ye=he(de);return(0,A.isThenable)(ye)?ye.then(pe=>pe?U:null):ye?U:null};return te.requiresSiblings=!0,te}}return H}function F(U,x){const q=U.filter(se=>!!se.basenames);if(q.length<2)return U;const H=q.reduce((se,ee)=>{const he=ee.basenames;return he?se.concat(he):se},[]);let Y;if(x){Y=[];for(let se=0,ee=H.length;se<ee;se++)Y.push(x)}else Y=q.reduce((se,ee)=>{const he=ee.patterns;return he?se.concat(he):se},[]);const te=function(se,ee){if(typeof se!="string")return null;if(!ee){let de;for(de=se.length;de>0;de--){const ye=se.charCodeAt(de-1);if(ye===47||ye===92)break}ee=se.substr(de)}const he=H.indexOf(ee);return he!==-1?Y[he]:null};te.basenames=H,te.patterns=Y,te.allBasenames=H;const ne=U.filter(se=>!se.basenames);return ne.push(te),ne}}),define(X[92],Q([0,1,8,19,67,17,15]),function(G,e,S,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var R;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(R=e.Mimes||(e.Mimes={}));let p=[],E=[],n=[];function y(r,i=!1){const a=v(r);p.push(a),a.userConfigured?n.push(a):E.push(a),i&&!a.userConfigured&&p.forEach(l=>{l.mime===a.mime||l.userConfigured||(a.extension&&l.extension===a.extension&&console.warn(`Overwriting extension <<${a.extension}>> to now point to mime <<${a.mime}>>`),a.filename&&l.filename===a.filename&&console.warn(`Overwriting filename <<${a.filename}>> to now point to mime <<${a.mime}>>`),a.filepattern&&l.filepattern===a.filepattern&&console.warn(`Overwriting filepattern <<${a.filepattern}>> to now point to mime <<${a.mime}>>`),a.firstline&&l.firstline===a.firstline&&console.warn(`Overwriting firstline <<${a.firstline}>> to now point to mime <<${a.mime}>>`))})}e.registerTextMime=y;function v(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(S.posix.sep)>=0:!1}}function m(r){r?(p=p.filter(i=>!i.userConfigured),n=[]):(p=[],E=[],n=[])}e.clearTextMimes=m;function h(r,i){let a;if(r)switch(r.scheme){case k.Schemas.file:a=r.fsPath;break;case k.Schemas.data:a=A.DataUri.parseMetaData(r).get(A.DataUri.META_DATA_LABEL);break;default:a=r.path}if(!a)return[R.unknown];a=a.toLowerCase();const l=(0,S.basename)(a),o=C(a,l,n);if(o)return[o,R.text];const u=C(a,l,E);if(u)return[u,R.text];if(i){const g=D(i);if(g)return[g,R.text]}return[R.unknown]}e.guessMimeTypes=h;function C(r,i,a){let l=null,o=null,u=null;for(let g=a.length-1;g>=0;g--){const w=a[g];if(i===w.filenameLowercase){l=w;break}if(w.filepattern&&(!o||w.filepattern.length>o.filepattern.length)){const d=w.filepatternOnPath?r:i;(0,P.match)(w.filepatternLowercase,d)&&(o=w)}w.extension&&(!u||w.extension.length>u.extension.length)&&i.endsWith(w.extensionLowercase)&&(u=w)}return l?l.mime:o?o.mime:u?u.mime:null}function D(r){if((0,L.startsWithUTF8BOM)(r)&&(r=r.substr(1)),r.length>0)for(let i=p.length-1;i>=0;i--){const a=p[i];if(!a.firstline)continue;const l=r.match(a.firstline);if(l&&l.length>0)return a.mime}return null}function b(r){return r?typeof r=="string"?r===R.binary||r===R.text||r===R.unknown:r.length===1&&b(r[0]):!0}e.isUnspecific=b;const I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function f(r){const i=(0,S.extname)(r);return I[i.toLowerCase()]}e.getMediaMime=f;function s(r){for(const i in I)if(I[i]===r)return i}e.getExtensionForMimeType=s;const c=/^(.+)\/(.+?)(;.+)?$/;function t(r,i){const a=c.exec(r);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:i?void 0:r}e.normalizeMimeType=t}),define(X[93],Q([0,1,4]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class P{constructor(y){this._uriTransformer=y}transformIncoming(y){const v=this._uriTransformer.transformIncoming(y);return v===y?y:L(S.URI.from(v))}transformOutgoing(y){const v=this._uriTransformer.transformOutgoing(y);return v===y?y:L(S.URI.from(v))}transformOutgoingURI(y){const v=this._uriTransformer.transformOutgoing(y);return v===y?y:S.URI.from(v)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function k(n,y,v){if(!n||v>200)return null;if(typeof n=="object"){if(n instanceof S.URI)return y.transformOutgoing(n);for(let m in n)if(Object.hasOwnProperty.call(n,m)){const h=k(n[m],y,v+1);h!==null&&(n[m]=h)}}return null}function A(n,y){const v=k(n,y,0);return v===null?n:v}e.transformOutgoingURIs=A;function R(n,y,v,m){if(!n||m>200)return null;if(typeof n=="object"){if(n.$mid===1)return v?S.URI.revive(y.transformIncoming(n)):y.transformIncoming(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const C=R(n[h],y,v,m+1);C!==null&&(n[h]=C)}}return null}function p(n,y){const v=R(n,y,!1,0);return v===null?n:v}e.transformIncomingURIs=p;function E(n,y){const v=R(n,y,!0,0);return v===null?n:v}e.transformAndReviveIncomingURIs=E}),define(X[30],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(p){return S.test(p)}e.isUUID=L;const P=new Uint8Array(16),k=[];for(let p=0;p<256;p++)k.push(p.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(p){for(let E=0;E<p.length;E++)p[E]=Math.floor(Math.random()*256);return p};function R(){A(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let p=0,E="";return E+=k[P[p++]],E+=k[P[p++]],E+=k[P[p++]],E+=k[P[p++]],E+="-",E+=k[P[p++]],E+=k[P[p++]],E+="-",E+=k[P[p++]],E+=k[P[p++]],E+="-",E+=k[P[p++]],E+=k[P[p++]],E+="-",E+=k[P[p++]],E+=k[P[p++]],E+=k[P[p++]],E+=k[P[p++]],E+=k[P[p++]],E+=k[P[p++]],E}e.generateUuid=R}),define(X[68],Q([0,1,209]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(k="utf8"){this.stringDecoder=new S.StringDecoder(k),this.remaining=null}write(k){const A=[],R=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(R.length<1)return A;let p=0,E,n=p;for(;n<R.length;)if(E=R.charCodeAt(n),E===13||E===10){if(A.push(R.substring(p,n)),n++,n<R.length){const y=E;E=R.charCodeAt(n),(y===13&&E===10||y===10&&E===13)&&n++}p=n}else n++;return this.remaining=p<R.length?R.substr(p):null,A}end(){return this.remaining}}e.LineDecoder=L}),define(X[94],Q([0,1,35]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(R){const p=R.replace(/\-/g,":").toLowerCase();return!L.has(p)}function k(){return new Promise(async(R,p)=>{const E=setTimeout(()=>p("Unable to retrieve mac address (timeout after 10s)"),1e4);try{R(await A())}catch(n){p(n)}finally{clearTimeout(E)}})}e.getMac=k;function A(){return new Promise((R,p)=>{try{const E=(0,S.networkInterfaces)();for(let n in E){const y=E[n];if(y){for(const{mac:v}of y)if(P(v))return R(v)}}p("Unable to retrieve mac address (unexpected format)")}catch(E){p(E)}})}}),define(X[95],Q([0,1,9,30,35,38,94]),function(G,e,S,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,y=0;const v=(0,P.networkInterfaces)();for(let m in v){const h=v[m];if(h)for(const{mac:C,internal:D}of h)D||(y+=1,this._isVirtualMachineMacAdress(C.toUpperCase())&&(n+=1))}this._value=y>0?n/y:0}return this._value}};let R;async function p(){return R||(R=(async()=>await E()||L.generateUuid())()),R}e.getMachineId=p;async function E(){try{const n=await new Promise((v,m)=>{G(["crypto"],v,m)}),y=await(0,A.getMac)();return n.createHash("sha256").update(y,"utf8").digest("hex")}catch(n){S.onUnexpectedError(n);return}}}),define(X[18],Q([0,1,49,35,210,8,6,7,41,30,66,15,4]),function(G,e,S,L,P,k,A,R,p,E,n,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function h(M,_=m.UNLINK){if((0,p.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return _===m.UNLINK?D(M):C(M)}async function C(M){try{const _=(0,k.join)((0,L.tmpdir)(),(0,E.generateUuid)());try{await e.Promises.rename(M,_)}catch(N){return D(M)}D(_).catch(N=>{})}catch(_){if(_.code!=="ENOENT")throw _}}async function D(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function b(M){if((0,p.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");S.rmdirSync(M,{recursive:!0})}e.rimrafSync=b;async function I(M,_){return c(await(_?f(M):(0,P.promisify)(S.readdir)(M)))}async function f(M){try{return await(0,P.promisify)(S.readdir)(M,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const _=[],N=await I(M);for(const j of N){let F=!1,U=!1,x=!1;try{const q=await e.Promises.lstat((0,k.join)(M,j));F=q.isFile(),U=q.isDirectory(),x=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}_.push({name:j,isFile:()=>F,isDirectory:()=>U,isSymbolicLink:()=>x})}return _}function s(M){return c(S.readdirSync(M))}e.readdirSync=s;function c(M){return M.map(_=>typeof _=="string"?R.isMacintosh?(0,n.normalizeNFC)(_):_:(_.name=R.isMacintosh?(0,n.normalizeNFC)(_.name):_.name,_))}async function t(M){const _=await I(M),N=[];for(const j of _)await i.existsDirectory((0,k.join)(M,j))&&N.push(j);return N}function r(M,_=1e3){return new Promise(N=>{let j=!1;const F=setInterval(()=>{j||(j=!0,S.access(M,U=>{j=!1,U&&(clearInterval(F),N(void 0))}))},_)})}e.whenDeleted=r;var i;(function(M){async function _(F){let U;try{if(U=await e.Promises.lstat(F),!U.isSymbolicLink())return{stat:U}}catch(x){}try{return{stat:await e.Promises.stat(F),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(R.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw q}throw x}}M.stat=_;async function N(F){try{const{stat:U,symbolicLink:x}=await M.stat(F);return U.isFile()&&x?.dangling!==!0}catch(U){}return!1}M.existsFile=N;async function j(F){try{const{stat:U,symbolicLink:x}=await M.stat(F);return U.isDirectory()&&x?.dangling!==!0}catch(U){}return!1}M.existsDirectory=j})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new A.ResourceQueue;function l(M,_,N){return a.queueFor(v.URI.file(M),y.extUriBiasedIgnorePathCase).queue(()=>{const j=w(N);return new Promise((F,U)=>u(M,_,j,x=>x?U(x):F()))})}let o=!0;function u(M,_,N,j){if(!o)return S.writeFile(M,_,{mode:N.mode,flag:N.flag},j);S.open(M,N.flag,N.mode,(F,U)=>{if(F)return j(F);S.writeFile(U,_,x=>{if(x)return S.close(U,()=>j(x));S.fdatasync(U,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),o=!1),S.close(U,H=>j(H))))})})}function g(M,_,N){const j=w(N);if(!o)return S.writeFileSync(M,_,{mode:j.mode,flag:j.flag});const F=S.openSync(M,j.flag,j.mode);try{S.writeFileSync(F,_);try{S.fdatasyncSync(F)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),o=!1}}finally{S.closeSync(F)}}e.writeFileSync=g;function w(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function d(M,_){if(M===_)return;async function N(j){try{const F=await e.Promises.lstat(j);if(F.isDirectory()||F.isSymbolicLink())return;await e.Promises.utimes(j,F.atime,new Date)}catch(F){}}try{await e.Promises.rename(M,_),await N(_)}catch(j){if(M.toLowerCase()!==_.toLowerCase()&&j.code==="EXDEV"||M.endsWith("."))await T(M,_,{preserveSymlinks:!1}),await h(M,m.MOVE),await N(_);else throw j}}async function T(M,_,N){return $(M,_,{root:{source:M,target:_},options:N,handledSourcePaths:new Set})}const O=511;async function $(M,_,N){if(N.handledSourcePaths.has(M))return;N.handledSourcePaths.add(M);const{stat:j,symbolicLink:F}=await i.stat(M);if(F){if(N.options.preserveSymlinks)try{return await B(M,_,N)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(F.dangling)return}return j.isDirectory()?z(M,_,j.mode&O,N):V(M,_,j.mode&O)}async function z(M,_,N,j){await e.Promises.mkdir(_,{recursive:!0,mode:N});const F=await I(M);for(const U of F)await $((0,k.join)(M,U),(0,k.join)(_,U),j)}async function V(M,_,N){await e.Promises.copyFile(M,_),await e.Promises.chmod(_,N)}async function B(M,_,N){let j=await e.Promises.readlink(M);(0,p.isEqualOrParent)(j,N.root.source,!R.isLinux)&&(j=(0,k.join)(N.root.target,j.substr(N.root.source.length+1))),await e.Promises.symlink(j,_)}e.Promises=new class{get access(){return(0,P.promisify)(S.access)}get stat(){return(0,P.promisify)(S.stat)}get lstat(){return(0,P.promisify)(S.lstat)}get utimes(){return(0,P.promisify)(S.utimes)}get read(){return(0,P.promisify)(S.read)}get readFile(){return(0,P.promisify)(S.readFile)}get write(){return(0,P.promisify)(S.write)}get appendFile(){return(0,P.promisify)(S.appendFile)}get fdatasync(){return(0,P.promisify)(S.fdatasync)}get truncate(){return(0,P.promisify)(S.truncate)}get rename(){return(0,P.promisify)(S.rename)}get copyFile(){return(0,P.promisify)(S.copyFile)}get open(){return(0,P.promisify)(S.open)}get close(){return(0,P.promisify)(S.close)}get symlink(){return(0,P.promisify)(S.symlink)}get readlink(){return(0,P.promisify)(S.readlink)}get chmod(){return(0,P.promisify)(S.chmod)}get mkdir(){return(0,P.promisify)(S.mkdir)}get unlink(){return(0,P.promisify)(S.unlink)}get rmdir(){return(0,P.promisify)(S.rmdir)}get realpath(){return(0,P.promisify)(S.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return I}get readDirsInDir(){return t}get writeFile(){return l}get rm(){return h}get move(){return d}get copy(){return T}}}),define(X[96],Q([0,1,49,19,8,18]),function(G,e,S,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(n){const y=(0,P.dirname)(n);if(n===y)return n;const v=((0,P.basename)(n)||n).toLowerCase();try{const h=(0,k.readdirSync)(y).filter(C=>C.toLowerCase()===v);if(h.length===1){const C=A(y);if(C)return(0,P.join)(C,h[0])}else if(h.length>1){const C=h.indexOf(v);if(C>=0){const D=A(y);if(D)return(0,P.join)(D,h[C])}}}catch(m){}return null}e.realcaseSync=A;async function R(n){try{return await k.Promises.realpath(n)}catch(y){const v=E(n);return await k.Promises.access(v,S.constants.R_OK),v}}e.realpath=R;function p(n){try{return S.realpathSync(n)}catch(y){const v=E(n);return S.accessSync(v,S.constants.R_OK),v}}e.realpathSync=p;function E(n){return(0,L.rtrim)((0,P.normalize)(n),P.sep)}}),define(X[97],Q([0,1,18,35,8]),function(G,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,A=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var p;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(p||(p={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class y{constructor(c,t,r){this.exePath=c,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await S.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function v({useAlternateBitness:s=!1}={}){return s?E===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:s=!1,findPreview:c=!1}={}){const t=v({useAlternateBitness:s});if(!t)return null;const r=P.join(t,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(r))return null;let i=-1,a=null;for(const u of await S.Promises.readdir(r)){let g=-1;if(c){const d=u.indexOf("-");if(d<0)continue;const T=u.substring(0,d);if(!k.test(T)||u.substring(d+1)!=="preview")continue;g=parseInt(T,10)}else{if(!k.test(u))continue;g=parseInt(u,10)}if(g<=i)continue;const w=P.join(r,u,"pwsh.exe");!await S.SymlinkSupport.existsFile(w)||(a=w,i=g)}if(!a)return null;const l=t.includes("x86")?" (x86)":"",o=c?" Preview":"";return new y(a,`PowerShell${o}${l}`,!0)}async function h({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const c=P.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=s?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const i of await S.Promises.readdir(c))if(t.test(i)){const a=P.join(c,i,"pwsh.exe");return new y(a,r)}return null}function C(){const s=P.join(L.homedir(),".dotnet","tools","pwsh.exe");return new y(s,".NET Core PowerShell Global Tool")}function D(){const s=P.join(process.env.windir,E===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(s,"Windows PowerShell",!0)}async function*b(){let s=await m();s&&(yield s),s=await m({useAlternateBitness:!0}),s&&(yield s),s=await h(),s&&(yield s),s=C(),s&&(yield s),s=await m({findPreview:!0}),s&&(yield s),s=await h({findPreview:!0}),s&&(yield s),s=await m({useAlternateBitness:!0,findPreview:!0}),s&&(yield s),s=D(),s&&(yield s)}async function*I(){for await(const s of b())await s.exists()&&(yield s)}e.enumeratePowerShellInstallations=I;async function f(){for await(const s of I())return s;return null}e.getFirstAvailablePowerShellInstallation=f}),define(X[98],Q([0,1,42,17]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function P(A){return new Promise((R,p)=>{let E;const n=new Map;function y(m,h,C,D,b){const I=n.get(h);if(m===A||I){const f={name:v(C),cmd:C,pid:m,ppid:h,load:D,mem:b};n.set(m,f),m===A&&(E=f),I&&(I.children||(I.children=[]),I.children.push(f),I.children.length>1&&(I.children=I.children.sort((s,c)=>s.pid-c.pid)))}}function v(m){const h=/--disable-blink-features=Auxclick/,C=/\\watcher\\win32\\CodeHelper\.exe/,D=/--crashes-directory/,b=/\\pipe\\winpty-control/,I=/conhost\.exe/,f=/--type=([a-zA-Z-]+)/;if(C.exec(m))return"watcherService ";if(D.exec(m))return"electron-crash-reporter";if(b.exec(m))return"winpty-process";if(I.exec(m))return"console-window-host (Windows internal process)";let s=f.exec(m);if(s&&s.length===2)return s[1]==="renderer"?h.exec(m)?"shared-process":"window":s[1];const c=/[a-zA-Z-]+\.js/g;let t="";do s=c.exec(m),s&&(t+=s+" ");while(s);return t&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron_node ${t}`:m}if(process.platform==="win32"){const m=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,C)=>{G(["windows-process-tree"],h,C)}).then(h=>{h.getProcessList(A,C=>{h.getProcessCpuUsage(C,D=>{const b=new Map;D.forEach(I=>{const f=m(I.commandLine||"");b.set(I.pid,{name:v(f),cmd:f,pid:I.pid,ppid:I.ppid,load:I.cpu||0,mem:I.memory||0})}),E=b.get(A),E?(b.forEach(I=>{const f=b.get(I.ppid);f&&(f.children||(f.children=[]),f.children.push(I))}),b.forEach(I=>{I.children&&(I.children=I.children.sort((f,s)=>f.pid-s.pid))}),R(E)):p(new Error(`Root process ${A} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let m=function(){let h=[E];const C=[];for(;h.length;){const b=h.shift();b&&(C.push(b.pid),b.children&&(h=h.concat(b.children)))}let D=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",G).fsPath);D+=" "+C.join(" "),(0,S.exec)(D,{},(b,I,f)=>{if(b||f)p(b||new Error(f.toString()));else{const s=I.toString().split(`
`);for(let c=0;c<C.length;c++){const t=n.get(C[c]);t.load=parseFloat(s[c])}if(!E){p(new Error(`Root process ${A} not found`));return}R(E)}})};(0,S.exec)("which ps",{},(h,C,D)=>{if(h||D)if(process.platform!=="linux")p(h||new Error(D.toString()));else{const b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",G).fsPath);(0,S.exec)(b,{},(I,f,s)=>{I||s?p(I||new Error(s.toString())):(k(f,y),m())})}else{const b=C.toString().trim(),I="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${b} ${I}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,s,c)=>{f||c&&!c.includes("screen size is bogus")?p(f||new Error(c.toString())):(k(s,y),process.platform==="linux"?m():E?R(E):p(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=P;function k(A,R){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=A.toString().split(`
`);for(const n of E){const y=p.exec(n.trim());y&&y.length===6&&R(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(X[99],Q([0,1,8,49,7,66,2,18]),function(G,e,S,L,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function p(y,v,m){return n({path:y,isDirectory:!1},v,m)}e.watchFile=p;function E(y,v,m){return n({path:y,isDirectory:!0},v,m)}e.watchFolder=E,e.CHANGE_BUFFER_DELAY=100;function n(y,v,m){const h=(0,S.basename)(y.path),C=new Map;let D=!1,b=[(0,A.toDisposable)(()=>{C.forEach(I=>(0,A.dispose)(I)),C.clear()})];try{const I=(0,L.watch)(y.path);b.push((0,A.toDisposable)(()=>{I.removeAllListeners(),I.close()}));const f=new Set;y.isDirectory&&R.Promises.readdir(y.path).then(s=>s.forEach(c=>f.add(c))),I.on("error",(s,c)=>{D||m(`Failed to watch ${y.path} for changes using fs.watch() (${s}, ${c})`)}),I.on("change",(s,c)=>{if(D)return;let t="";if(c&&(t=c.toString(),P.isMacintosh&&(t=(0,k.normalizeNFC)(t))),!t||s!=="change"&&s!=="rename")return;const r=y.isDirectory?(0,S.join)(y.path,t):y.path;if(y.isDirectory)if(s==="rename"){const i=C.get(r);i&&(0,A.dispose)(i);const a=setTimeout(async()=>{C.delete(r);const l=await R.Promises.exists(r);if(D)return;let o;l?f.has(t)?o="changed":(o="added",f.add(t)):(f.delete(t),o="deleted"),v(o,r)},e.CHANGE_BUFFER_DELAY);C.set(r,(0,A.toDisposable)(()=>clearTimeout(a)))}else{let i;f.has(t)?i="changed":(i="added",f.add(t)),v(i,r)}else if(s==="rename"||t!==h){const i=setTimeout(async()=>{const a=await R.Promises.exists(r);D||(a?(v("changed",r),b=[n(y,v,m)]):v("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,A.dispose)(b),b=[(0,A.toDisposable)(()=>clearTimeout(i))]}else v("changed",r)})}catch(I){R.Promises.exists(y.path).then(f=>{f&&!D&&m(`Failed to watch ${y.path} for changes using fs.watch() (${I.toString()})`)})}return(0,A.toDisposable)(()=>{D=!0,b=(0,A.dispose)(b)})}});var fe=this&&this.__decorate||function(G,e,S,L){var P=arguments.length,k=P<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,S):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(G,e,S,L);else for(var R=G.length-1;R>=0;R--)(A=G[R])&&(k=(P<3?A(k):P>3?A(e,S,k):A(e,S))||k);return P>3&&k&&Object.defineProperty(e,S,k),k};define(X[36],Q([0,1,3,2,6,29,9,25,23,16,91,19,64]),function(G,e,S,L,P,k,A,R,p,E,n,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function h(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var C;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(C=e.ResponseType||(e.ResponseType={}));function D(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(b||(b={}));class I{constructor(U){this.buffer=U,this.pos=0}read(U){const x=this.buffer.slice(this.pos,this.pos+U);return this.pos+=x.byteLength,x}}class f{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var s;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(s||(s={}));function c(F){const U=R.VSBuffer.alloc(4);return U.writeUInt32BE(F,0),U}function t(F){return F.read(4).readUInt32BE(0)}function r(F){const U=R.VSBuffer.alloc(1);return U.writeUInt8(F,0),U}const i={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object)},a=typeof Buffer!="undefined";function l(F,U){if(typeof U=="undefined")F.write(i.Undefined);else if(typeof U=="string"){const x=R.VSBuffer.fromString(U);F.write(i.String),F.write(c(x.byteLength)),F.write(x)}else if(a&&Buffer.isBuffer(U)){const x=R.VSBuffer.wrap(U);F.write(i.Buffer),F.write(c(x.byteLength)),F.write(x)}else if(U instanceof R.VSBuffer)F.write(i.VSBuffer),F.write(c(U.byteLength)),F.write(U);else if(Array.isArray(U)){F.write(i.Array),F.write(c(U.length));for(const x of U)l(F,x)}else{const x=R.VSBuffer.fromString(JSON.stringify(U));F.write(i.Object),F.write(c(x.byteLength)),F.write(x)}}function o(F){switch(F.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return F.read(t(F)).toString();case s.Buffer:return F.read(t(F)).buffer;case s.VSBuffer:return F.read(t(F));case s.Array:{const x=t(F),q=[];for(let H=0;H<x;H++)q.push(o(F));return q}case s.Object:return JSON.parse(F.read(t(F)).toString())}}class u{constructor(U,x,q=null,H=1e3){this.protocol=U,this.ctx=x,this.logger=q,this.timeoutDelay=H,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Y=>this.onRawMessage(Y)),this.sendResponse({type:200})}registerChannel(U,x){this.channels.set(U,x),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const x=this.send([U.type]);this.logger&&this.logger.logOutgoing(x,0,1,D(U.type));return}case 201:case 202:case 204:case 203:{const x=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(x,U.id,1,D(U.type),U.data);return}}}send(U,x=void 0){const q=new f;return l(q,U),l(q,x),this.sendBuffer(q.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(x){return 0}}onRawMessage(U){const x=new I(U),q=o(x),H=o(x),Y=q[0];switch(Y){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,q[1],1,`${h(Y)}: ${q[2]}.${q[3]}`,H),this.onPromise({type:Y,id:q[1],channelName:q[2],name:q[3],arg:H});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,q[1],1,`${h(Y)}: ${q[2]}.${q[3]}`,H),this.onEventListen({type:Y,id:q[1],channelName:q[2],name:q[3],arg:H});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,q[1],1,`${h(Y)}`),this.disposeActiveRequest({type:Y,id:q[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,q[1],1,`${h(Y)}`),this.disposeActiveRequest({type:Y,id:q[1]})}}onPromise(U){const x=this.channels.get(U.channelName);if(!x){this.collectPendingRequest(U);return}const q=new k.CancellationTokenSource;let H;try{H=x.call(this.ctx,U.name,U.arg,q.token)}catch(ne){H=Promise.reject(ne)}const Y=U.id;H.then(ne=>{this.sendResponse({id:Y,data:ne,type:201}),this.activeRequests.delete(U.id)},ne=>{ne instanceof Error?this.sendResponse({id:Y,data:{message:ne.message,name:ne.name,stack:ne.stack?ne.stack.split?ne.stack.split(`
`):ne.stack:void 0},type:202}):this.sendResponse({id:Y,data:ne,type:203}),this.activeRequests.delete(U.id)});const te=(0,L.toDisposable)(()=>q.cancel());this.activeRequests.set(U.id,te)}onEventListen(U){const x=this.channels.get(U.channelName);if(!x){this.collectPendingRequest(U);return}const q=U.id,Y=x.listen(this.ctx,U.name,U.arg)(te=>this.sendResponse({id:q,data:te,type:204}));this.activeRequests.set(U.id,Y)}disposeActiveRequest(U){const x=this.activeRequests.get(U.id);x&&(x.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let x=this.pendingRequests.get(U.channelName);x||(x=[],this.pendingRequests.set(U.channelName,x));const q=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);x.push({request:U,timeoutTimer:q})}flushPendingRequests(U){const x=this.pendingRequests.get(U);if(x){for(const q of x)switch(clearTimeout(q.timeoutTimer),q.request.type){case 100:this.onPromise(q.request);break;case 102:this.onEventListen(q.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var g;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(U,x=null){this.protocol=U,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(q=>this.onBuffer(q)),this.logger=x}getChannel(U){const x=this;return{call(q,H,Y){return x.isDisposed?Promise.reject(A.canceled()):x.requestPromise(U,q,H,Y)},listen(q,H){return x.isDisposed?Promise.reject(A.canceled()):x.requestEvent(U,q,H)}}}requestPromise(U,x,q,H=k.CancellationToken.None){const Y=this.lastRequestId++,ne={id:Y,type:100,channelName:U,name:x,arg:q};if(H.isCancellationRequested)return Promise.reject(A.canceled());let se;return new Promise((he,de)=>{if(H.isCancellationRequested)return de(A.canceled());const ye=()=>{const Me=Oe=>{switch(Oe.type){case 201:this.handlers.delete(Y),he(Oe.data);break;case 202:this.handlers.delete(Y);const Le=new Error(Oe.data.message);Le.stack=Oe.data.stack,Le.name=Oe.data.name,de(Le);break;case 203:this.handlers.delete(Y),de(Oe.data);break}};this.handlers.set(Y,Me),this.sendRequest(ne)};let pe=null;this.state===b.Idle?ye():(pe=(0,P.createCancelablePromise)(Me=>this.whenInitialized()),pe.then(()=>{pe=null,ye()}));const Pe=()=>{pe?(pe.cancel(),pe=null):this.sendRequest({id:Y,type:101}),de(A.canceled())},Te=H.onCancellationRequested(Pe);se=(0,L.combinedDisposable)((0,L.toDisposable)(Pe),Te),this.activeRequests.add(se)}).finally(()=>{this.activeRequests.delete(se)})}requestEvent(U,x,q){const H=this.lastRequestId++,te={id:H,type:102,channelName:U,name:x,arg:q};let ne=null;const se=new S.Emitter({onFirstListenerAdd:()=>{ne=(0,P.createCancelablePromise)(he=>this.whenInitialized()),ne.then(()=>{ne=null,this.activeRequests.add(se),this.sendRequest(te)})},onLastListenerRemove:()=>{ne?(ne.cancel(),ne=null):(this.activeRequests.delete(se),this.sendRequest({id:H,type:103}))}}),ee=he=>se.fire(he.data);return this.handlers.set(H,ee),se.event}sendRequest(U){switch(U.type){case 100:case 102:{const x=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(x,U.id,0,`${h(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const x=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(x,U.id,0,h(U.type));return}}}send(U,x=void 0){const q=new f;return l(q,U),l(q,x),this.sendBuffer(q.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch(x){return 0}}onBuffer(U){const x=new I(U),q=o(x),H=o(x),Y=q[0];switch(Y){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,D(Y)),this.onResponse({type:q[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,q[1],0,D(Y),H),this.onResponse({type:q[0],id:q[1],data:H})}}onResponse(U){if(U.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const x=this.handlers.get(U.id);x&&x(U)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}fe([v.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class d{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:x,onDidClientDisconnect:q})=>{S.Event.once(x.onMessage)(Y=>{const te=new I(Y),ne=o(te),se=new u(x,ne),ee=new w(x);this.channels.forEach((de,ye)=>se.registerChannel(ye,de));const he={channelServer:se,channelClient:ee,ctx:ne};this._connections.add(he),this._onDidAddConnection.fire(he),q(()=>{se.dispose(),ee.dispose(),this._connections.delete(he),this._onDidRemoveConnection.fire(he)})})})}get connections(){const U=[];return this._connections.forEach(x=>U.push(x)),U}getChannel(U,x){const q=this;return{call(H,Y,te){let ne;if((0,E.isFunction)(x)){let ee=(0,p.getRandomElement)(q.connections.filter(x));ne=ee?Promise.resolve(ee):S.Event.toPromise(S.Event.filter(q.onDidAddConnection,x))}else ne=x.routeCall(q,H,Y);const se=ne.then(ee=>ee.channelClient.getChannel(U));return O(se).call(H,Y,te)},listen(H,Y){if((0,E.isFunction)(x))return q.getMulticastEvent(U,x,H,Y);const te=x.routeEvent(q,H,Y).then(ne=>ne.channelClient.getChannel(U));return O(te).listen(H,Y)}}}getMulticastEvent(U,x,q,H){const Y=this;let te=new L.DisposableStore;const ne=new S.Emitter({onFirstListenerAdd:()=>{te=new L.DisposableStore;const se=new S.EventMultiplexer,ee=new Map,he=ye=>{const Pe=ye.channelClient.getChannel(U).listen(q,H),Te=se.add(Pe);ee.set(ye,Te)},de=ye=>{const pe=ee.get(ye);!pe||(pe.dispose(),ee.delete(ye))};Y.connections.filter(x).forEach(he),S.Event.filter(Y.onDidAddConnection,x)(he,void 0,te),Y.onDidRemoveConnection(de,void 0,te),se.event(ne.fire,ne,te),te.add(se)},onLastListenerRemove:()=>{te.dispose()}});return ne.event}registerChannel(U,x){this.channels.set(U,x),this._connections.forEach(q=>{q.channelServer.registerChannel(U,x)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=d;class T{constructor(U,x,q=null){const H=new f;l(H,x),U.send(H.buffer),this.channelClient=new w(U,q),this.channelServer=new u(U,x,q)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,x){this.channelServer.registerChannel(U,x)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function O(F){return{call(U,x,q){return F.then(H=>H.call(U,x,q))},listen(U,x){const q=new S.Relay;return F.then(H=>q.input=H.listen(U,x)),q.event}}}e.getDelayedChannel=O;function $(F){let U=!1;return{call(x,q,H){return U?F.call(x,q,H):(0,P.timeout)(0).then(()=>U=!0).then(()=>F.call(x,q,H))},listen(x,q){if(U)return F.listen(x,q);const H=new S.Relay;return(0,P.timeout)(0).then(()=>U=!0).then(()=>H.input=F.listen(x,q)),H.event}}}e.getNextTickChannel=$;class z{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const x of U.connections)if(await Promise.resolve(this.fn(x.ctx)))return Promise.resolve(x);return await S.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=z;var V;(function(F){function U(H,Y){const te=H,ne=Y&&Y.disableMarshalling,se=new Map;for(const ee in te)q(ee)&&se.set(ee,S.Event.buffer(te[ee],!0));return new class{listen(ee,he){const de=se.get(he);if(de)return de;throw new Error(`Event not found: ${he}`)}call(ee,he,de){const ye=te[he];if(typeof ye=="function"){if(!ne&&Array.isArray(de))for(let pe=0;pe<de.length;pe++)de[pe]=(0,n.revive)(de[pe]);return ye.apply(te,de)}throw new Error(`Method not found: ${he}`)}}}F.fromService=U;function x(H,Y){const te=Y&&Y.disableMarshalling;return new Proxy({},{get(ne,se){if(typeof se=="string")return Y?.properties?.has(se)?Y.properties.get(se):q(se)?H.listen(se):async function(...ee){let he;Y&&!(0,E.isUndefinedOrNull)(Y.context)?he=[Y.context,...ee]:he=ee;const de=await H.call(se,he);return te?de:(0,n.revive)(de)};throw new Error(`Property not found: ${String(se)}`)}})}F.toService=x;function q(H){return H[0]==="o"&&H[1]==="n"&&y.isUpperAsciiLetter(H.charCodeAt(2))}})(V=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let U=F.toString();if(U!=="[object Object]")return U}return F}function _(F){return Array.isArray(F)?F.map(M):M(F)}function N(F,U,x,q,H,Y,te){te=_(te);const ne=B[H],se=ne[q%ne.length];let ee=[`%c[${F}]%c[${String(U).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${se}`];/\($/.test(Y)?(ee=ee.concat(te),ee.push(")")):ee.push(te),console.log.apply(console,ee)}e.logWithColors=N;class j{constructor(U,x){this._outgoingPrefix=U,this._incomingPrefix=x,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,x,q,H,Y){this._totalOutgoing+=U,N(this._outgoingPrefix,this._totalOutgoing,U,x,q,H,Y)}logIncoming(U,x,q,H,Y){this._totalIncoming+=U,N(this._incomingPrefix,this._totalIncoming,U,x,q,H,Y)}}e.IPCLogger=j}),define(X[100],Q([0,1,3,36,25]),function(G,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(p){this.port=p,this.onMessage=S.Event.fromDOMEventEmitter(this.port,"message",E=>P.VSBuffer.wrap(E.data)),p.start()}send(p){this.port.postMessage(p.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class A extends L.IPCClient{constructor(p,E){const n=new k(p);super(n,E);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=A}),define(X[101],Q([0,1,102,3,36,100]),function(G,e,S,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends P.IPCServer{static getOnDidClientConnect(){const p=L.Event.fromNodeEventEmitter(S.ipcRenderer,"vscode:createMessageChannel",(E,n)=>n);return L.Event.map(p,E=>{const{port1:n,port2:y}=new MessageChannel,m={protocol:new k.Protocol(n),onDidClientDisconnect:L.Event.fromDOMEventEmitter(n,"close")};return S.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[y]),m})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(X[103],Q([0,1,9,25]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function P(R,p){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((n,y)=>{E.open(R.type||"GET",R.url||"",!0,R.user,R.password),k(E,R),E.responseType="arraybuffer",E.onerror=v=>y(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=v=>{n({res:{statusCode:E.status,headers:A(E)},stream:(0,L.bufferToStream)(L.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=v=>y(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(E.timeout=R.timeout),E.send(R.data),p.onCancellationRequested(()=>{E.abort(),y((0,S.canceled)())})})}e.request=P;function k(R,p){if(p.headers){e:for(let E in p.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(E,p.headers[E])}}}function A(R){const p=Object.create(null);for(const E of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const n=E.indexOf(":");p[E.substr(0,n).trim().toLowerCase()]=E.substr(n+1).trim()}return p}}),define(X[69],Q([0,1,2,3,6,16]),function(G,e,S,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var A;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));var R;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(R||(R={}));class p extends S.Disposable{constructor(y,v=Object.create(null)){super();this.database=y,this.options=v,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=R.None,this.cache=new Map,this.flushDelayer=new P.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){y.changed?.forEach((v,m)=>this.accept(m,v)),y.deleted?.forEach(v=>this.accept(v,void 0))}accept(y,v){if(this.state===R.Closed)return;let m=!1;(0,k.isUndefinedOrNull)(v)?m=this.cache.delete(y):this.cache.get(y)!==v&&(this.cache.set(y,v),m=!0),m&&this._onDidChangeStorage.fire(y)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===R.None&&(this.state=R.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,v){const m=this.cache.get(y);return(0,k.isUndefinedOrNull)(m)?v:m}getBoolean(y,v){const m=this.get(y);return(0,k.isUndefinedOrNull)(m)?v:m==="true"}getNumber(y,v){const m=this.get(y);return(0,k.isUndefinedOrNull)(m)?v:parseInt(m,10)}async set(y,v){if(this.state===R.Closed)return;if((0,k.isUndefinedOrNull)(v))return this.delete(y);const m=String(v);if(this.cache.get(y)!==m)return this.cache.set(y,m),this.pendingInserts.set(y,m),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async delete(y){if(!(this.state===R.Closed||!this.cache.delete(y)))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=R.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(y){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert&&y.insert.forEach((v,m)=>this.items.set(m,v)),y.delete&&y.delete.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=E}),define(X[104],Q([10,11]),function(G,e){return G.create("vs/base/common/date",e)}),define(X[55],Q([0,1,104]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,P=L*60,k=P*24,A=k*7,R=k*30,p=k*365;function E(y,v){typeof y!="number"&&(y=y.getTime());const m=Math.round((new Date().getTime()-y)/1e3);if(m<-30)return(0,S.localize)(0,null,E(new Date().getTime()+m*1e3,!1));if(m<30)return(0,S.localize)(1,null);let h;return m<L?(h=m,v?h===1?(0,S.localize)(2,null,h):(0,S.localize)(3,null,h):h===1?(0,S.localize)(4,null,h):(0,S.localize)(5,null,h)):m<P?(h=Math.floor(m/L),v?h===1?(0,S.localize)(6,null,h):(0,S.localize)(7,null,h):h===1?(0,S.localize)(8,null,h):(0,S.localize)(9,null,h)):m<k?(h=Math.floor(m/P),v?h===1?(0,S.localize)(10,null,h):(0,S.localize)(11,null,h):h===1?(0,S.localize)(12,null,h):(0,S.localize)(13,null,h)):m<A?(h=Math.floor(m/k),v?h===1?(0,S.localize)(14,null,h):(0,S.localize)(15,null,h):h===1?(0,S.localize)(16,null,h):(0,S.localize)(17,null,h)):m<R?(h=Math.floor(m/A),v?h===1?(0,S.localize)(18,null,h):(0,S.localize)(19,null,h):h===1?(0,S.localize)(20,null,h):(0,S.localize)(21,null,h)):m<p?(h=Math.floor(m/R),v?h===1?(0,S.localize)(22,null,h):(0,S.localize)(23,null,h):h===1?(0,S.localize)(24,null,h):(0,S.localize)(25,null,h)):(h=Math.floor(m/p),v?h===1?(0,S.localize)(26,null,h):(0,S.localize)(27,null,h):h===1?(0,S.localize)(28,null,h):(0,S.localize)(29,null,h))}e.fromNow=E;function n(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(X[105],Q([10,11]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(X[43],Q([0,1,105,16,23]),function(G,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(E,n){return n&&(E.stack||E.stacktrace)?S.localize(0,null,R(E),A(E.stack)||A(E.stacktrace)):R(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?S.localize(1,null,E.message):E.message||S.localize(2,null)}function p(E=null,n=!1){if(!E)return S.localize(3,null);if(Array.isArray(E)){const y=P.coalesce(E),v=p(y[0],n);return y.length>1?S.localize(4,null,v,y.length):v}if(L.isString(E))return E;if(E.detail){const y=E.detail;if(y.error)return k(y.error,n);if(y.exception)return k(y.exception,n)}return E.stack?k(E,n):E.message?E.message:S.localize(5,null)}e.toErrorMessage=p}),define(X[106],Q([10,11]),function(G,e){return G.create("vs/base/node/processes",e)}),define(X[107],Q([0,1,8,18,42,106,34,16,26,41,7,68,17]),function(G,e,S,L,P,k,A,R,p,E,n,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function m(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(s,c){if(n.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};c&&(t.cwd=c);const r=P.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],t);return new Promise(i=>{r.once("error",a=>{i({success:!1,error:a})}),r.once("exit",(a,l)=>{i(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?m(t.status):1})}else if(n.isLinux||n.isMacintosh)try{const t=v.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(r=>{P.execFile(t,[s.pid.toString()],{encoding:"utf8",shell:!0},(i,a,l)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function C(s=A.env){return s.comspec||"cmd.exe"}e.getWindowsShell=C;class D{constructor(c,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=c,this.args=t,this.shell=r,this.options=i;else{const a=c;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(A.env).forEach(l=>{a[l]=A.env[l]}),Object.keys(this.options.env).forEach(l=>{a[l]=this.options.env[l]}),this.options.env=a}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const t=c.lastIndexOf(S.sep);return t!==-1&&(c=c.substring(t+1)),D.WellKnowCommands[c]?c:"other"}start(c){return n.isWindows&&(this.options&&this.options.cwd&&E.isUNC(this.options.cwd)||!this.options&&E.isUNC(A.cwd()))?Promise.reject(new Error(k.localize(0,null))):this.useExec().then(t=>{let r,i;const a=new Promise((l,o)=>{r=l,i=o});if(t){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=P.exec(l,this.options,(o,u,g)=>{this.childProcess=null;const w=o;w&&w.killed?i({killed:this.terminateRequested,stdout:u.toString(),stderr:g.toString()}):this.handleExec(r,c,o,u,g)})}else{let l=null;const o=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,r,c,i);const g={terminated:this.terminateRequested};R.isNumber(u)&&(g.cmdCode=u),r(g)};if(this.shell&&n.isWindows){const u=p.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let g=!1,w=!1;const d=[];let T=this.ensureQuotes(this.cmd);d.push(T.value),g=T.quoted,this.args&&this.args.forEach($=>{T=this.ensureQuotes($),d.push(T.value),w=w&&T.quoted});const O=["/s","/c"];g?w?O.push('"'+d.join(" ")+'"'):d.length>1?O.push('"'+d[0]+'" '+d.slice(1).join(" ")):O.push('"'+d[0]+'"'):O.push(d.join(" ")),l=P.spawn(C(),O,u)}else this.cmd&&(l=P.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(R.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",u=>{this.childProcess=null,i({terminated:this.terminateRequested,error:u})}),l.pid&&(this.childProcess.on("close",o),this.handleSpawn(l,r,c,i,!0)))}return a})}handleClose(c,t,r,i){}ensureQuotes(c){return D.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,h(c,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!n.isWindows)return c(!1);const t=P.spawn(C(),["/s","/c"]);t.on("error",r=>c(!0)),t.on("exit",r=>c(!1))})}}e.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class b extends D{constructor(c,t,r,i){super(c,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,t,r,i,a){[i,a].forEach((l,o)=>{const u=new y.LineDecoder;u.write(l).forEach(d=>{t({line:d,source:o===0?0:1})});const w=u.end();w&&t({line:w,source:o===0?0:1})}),c({terminated:this.terminateRequested,error:r})}handleSpawn(c,t,r,i,a){const l=new y.LineDecoder,o=new y.LineDecoder;c.stdout.on("data",u=>{l.write(u).forEach(w=>r({line:w,source:0}))}),c.stderr.on("data",u=>{o.write(u).forEach(w=>r({line:w,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=o}handleClose(c,t,r,i){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&r({line:a,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&r({line:l,source:1})}}e.LineProcess=b;function I(s){let c=[],t=!1;const r=function(i){if(t){c.push(i);return}(!s.send(i,l=>{if(l&&console.error(l),t=!1,c.length>0){const o=c.slice(0);c=[],o.forEach(u=>r(u))}})||n.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=I;var f;(function(s){async function c(t,r,i){if(S.isAbsolute(t))return t;if(r===void 0&&(r=A.cwd()),S.dirname(t)!=="."||(i===void 0&&R.isString(A.env.PATH)&&(i=A.env.PATH.split(S.delimiter)),i===void 0||i.length===0))return S.join(r,t);async function l(o){return await L.Promises.exists(o)?!(await L.Promises.stat(o)).isDirectory():!1}for(let o of i){let u;if(S.isAbsolute(o)?u=S.join(o,t):u=S.join(r,o,t),await l(u))return u;let g=u+".com";if(await l(g)||(g=u+".exe",await l(g)))return g}return S.join(r,t)}s.findExecutable=c})(f=e.win32||(e.win32={}))}),define(X[50],Q([0,1,42,2,6,26,3,107,36,90,29,9,25,7]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends p.ChannelServer{constructor(b){super({send:I=>{try{process.send&&process.send(I.buffer.toString("base64"))}catch(f){}},onMessage:A.Event.fromNodeEventEmitter(process,"message",I=>v.VSBuffer.wrap(Buffer.from(I,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=h;class C{constructor(b,I){this.modulePath=b,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new A.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new P.Delayer(f),this.child=null,this._client=null}getChannel(b){const I=this;return{call(f,s,c){return I.requestPromise(b,f,s,c)},listen(f,s){return I.requestEvent(b,f,s)}}}requestPromise(b,I,f,s=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(b),t=(0,P.createCancelablePromise)(a=>c.call(I,f,a)),r=s.onCancellationRequested(()=>t.cancel()),i=(0,L.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,I,f){if(!this.disposeDelayer)return A.Event.None;this.disposeDelayer.cancel();let s;const c=new A.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(b).listen(I,f)(c.fire,c),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env={...(0,k.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(I.env={...I.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),m.isMacintosh&&I.env&&delete I.env.DYLD_LIBRARY_PATH,this.child=(0,S.fork)(this.modulePath,b,I);const f=new A.Emitter;A.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,E.isRemoteConsoleLog)(l)){(0,E.log)(l,`IPC Library: ${this.options.serverName}`);return}f.fire(v.VSBuffer.wrap(Buffer.from(l,"base64")))});const c=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,t=l=>this.child&&this.child.connected&&c.send(l.buffer.toString("base64")),r=f.event,i={send:t,onMessage:r};this._client=new p.ChannelClient(i);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,o)=>{process.removeListener("exit",a),this.activeRequests.forEach(u=>(0,L.dispose)(u)),this.activeRequests.clear(),l!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:o})})}return this._client}getCachedChannel(b){let I=this.channels.get(b);return I||(I=this.client.getChannel(b),this.channels.set(b,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(X[108],Q([10,11]),function(G,e){return G.create("vs/base/node/zip",e)}),define(X[109],Q([10,11]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(X[110],Q([10,11]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(X[111],Q([10,11]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(X[112],Q([10,11]),function(G,e){return G.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(X[113],Q([10,11]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(X[114],Q([10,11]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(X[115],Q([10,11]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(X[116],Q([10,11]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(X[117],Q([10,11]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(X[118],Q([10,11]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(X[119],Q([10,11]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(X[120],Q([10,11]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(X[121],Q([10,11]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(X[122],Q([10,11]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(X[123],Q([10,11]),function(G,e){return G.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(X[124],Q([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(X[125],Q([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(X[126],Q([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/settingsSync",e)}),define(X[127],Q([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(X[128],Q([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSync",e)}),define(X[129],Q([10,11]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(X[130],Q([0,1,8,15,64,55,17,4,34]),function(G,e,S,L,P,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(h,C,D){this._args=h,this.paths=C,this.productService=D}get appRoot(){return(0,S.dirname)(A.FileAccess.asFileUri("",G).fsPath)}get userHome(){return R.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return R.URI.file((0,S.join)(this.userDataPath,"User"))}get tmpDir(){return R.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,L.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,S.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return R.URI.file((0,S.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(R.URI.file((0,S.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return R.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return R.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=p.env.VSCODE_PORTABLE;return h?R.URI.file((0,S.join)(h,"argv.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,L.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return R.URI.file((0,S.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,S.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,S.resolve)(h):(0,S.normalize)((0,S.join)(A.FileAccess.asFileUri("",G).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,S.resolve)(h):(0,S.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,S.resolve)(h);const C=p.env.VSCODE_EXTENSIONS;if(C)return C;const D=p.env.VSCODE_PORTABLE;return D?(0,S.join)(D,"extensions"):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(C=>/^[^:/?#]+?:\/\//.test(C)?R.URI.parse(C):R.URI.file((0,S.normalize)(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?R.URI.parse(h):R.URI.file((0,S.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!p.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,L.joinPath)(R.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return R.URI.file((0,S.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([P.memoize],E.prototype,"appRoot",null),fe([P.memoize],E.prototype,"userHome",null),fe([P.memoize],E.prototype,"userDataPath",null),fe([P.memoize],E.prototype,"appSettingsHome",null),fe([P.memoize],E.prototype,"tmpDir",null),fe([P.memoize],E.prototype,"userRoamingDataHome",null),fe([P.memoize],E.prototype,"settingsResource",null),fe([P.memoize],E.prototype,"userDataSyncHome",null),fe([P.memoize],E.prototype,"userDataSyncLogResource",null),fe([P.memoize],E.prototype,"sync",null),fe([P.memoize],E.prototype,"machineSettingsResource",null),fe([P.memoize],E.prototype,"globalStorageHome",null),fe([P.memoize],E.prototype,"workspaceStorageHome",null),fe([P.memoize],E.prototype,"keybindingsResource",null),fe([P.memoize],E.prototype,"keyboardLayoutResource",null),fe([P.memoize],E.prototype,"argvResource",null),fe([P.memoize],E.prototype,"snippetsHome",null),fe([P.memoize],E.prototype,"isExtensionDevelopment",null),fe([P.memoize],E.prototype,"untitledWorkspacesHome",null),fe([P.memoize],E.prototype,"installSourcePath",null),fe([P.memoize],E.prototype,"builtinExtensionsPath",null),fe([P.memoize],E.prototype,"extensionsPath",null),fe([P.memoize],E.prototype,"extensionDevelopmentLocationURI",null),fe([P.memoize],E.prototype,"extensionDevelopmentKind",null),fe([P.memoize],E.prototype,"extensionTestsLocationURI",null),fe([P.memoize],E.prototype,"debugExtensionHost",null),fe([P.memoize],E.prototype,"serviceMachineIdResource",null),fe([P.memoize],E.prototype,"telemetryLogResource",null),fe([P.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function n(m,h){return v(m["inspect-extensions"],m["inspect-brk-extensions"],5870,h,m.debugId)}e.parseExtensionHostPort=n;function y(m,h){return v(m["inspect-search"],m["inspect-brk-search"],5876,h)}e.parseSearchPort=y;function v(m,h,C,D,b){const f=Number(h||m)||(D?null:C),s=f?Boolean(!!h):!1;return{port:f,break:s,debugId:b}}}),function(){"use strict";function G(e,S,L,P){function k(R){const p=A(R),E=[p];return e.isAbsolute(p)||E.unshift(P),e.resolve(...E)}function A(R){const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");const E=R["user-data-dir"];if(E)return E;let n=process.env.VSCODE_APPDATA;if(!n)switch(process.platform){case"win32":if(n=process.env.APPDATA,!n){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");n=e.join(y,"AppData","Roaming")}break;case"darwin":n=e.join(S.homedir(),"Library","Application Support");break;case"linux":n=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(n,L)}return{getUserDataPath:k}}if(typeof define=="function")define(X[131],Q([0,211,35,17,15,34]),function(e,S,L,P,k,A){const R=k.dirname(P.FileAccess.asFileUri("",e)),p=e.__$__nodeRequire(k.joinPath(R,"package.json").fsPath);return G(S,L,p.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),S=require("path"),L=require("os");module.exports=G(S,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(X[132],Q([0,1,35,131,130]),function(G,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends P.AbstractNativeEnvironmentService{constructor(R,p){super(R,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,L.getUserDataPath)(R)},p)}}e.NativeEnvironmentService=k}),define(X[133],Q([0,1,4]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,P=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,p=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(D){const b=D.match(A);return b?b[1]:null}function n(D){if(D.indexOf("://")===-1){const b=D.match(L);return b?E(b[2]):null}try{const b=S.URI.parse(D);if(b.authority)return E(b.authority)}catch(b){}return null}function y(D,b){const I=new Set;let f;for(;f=R.exec(D);){const c=n(f[1]);c&&I.add(c)}const s=new Set(b);return Array.from(I).map(c=>s.has(c)?c:c.replace(p,"a"))}e.getDomainsOfRemotes=y;function v(D){const b=D.match(k);return b?b[2]:null}function m(D,b,I){return D&&b?(I&&b.endsWith(".git")&&(b=b.substr(0,b.length-4)),b.indexOf("/")===0?`${D}${b}`:`${D}/${b}`):null}function h(D,b){if(D.indexOf("://")===-1){const I=D.match(P);if(I)return m(I[2],I[3],b)}try{const I=S.URI.parse(D);if(I.authority)return m(v(I.authority),I.path,b)}catch(I){}return null}function C(D,b=!1){const I=[];let f;for(;f=R.exec(D);){const s=h(f[1],b);s&&I.push(s)}return I}e.getRemotes=C}),define(X[134],Q([0,1,3,4,93,26,2]),function(G,e,S,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function R(h,C){return L.URI.revive(C?C.transformIncoming(h):h)}function p(h,C){return C?C.transformOutgoingURI(h):h}function E(h,C){C=C||P.DefaultURITransformer;const D=h.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...h,manifest:void 0},C),manifest:D}}function n(h,C){return C?(0,k.cloneAndChange)(h,D=>D instanceof L.URI?C.transformOutgoingURI(D):void 0):h}class y{constructor(C,D){this.service=C,this.getUriTransformer=D,this.onInstallExtension=S.Event.buffer(C.onInstallExtension,!0),this.onDidInstallExtensions=S.Event.buffer(C.onDidInstallExtensions,!0),this.onUninstallExtension=S.Event.buffer(C.onUninstallExtension,!0),this.onDidUninstallExtension=S.Event.buffer(C.onDidUninstallExtension,!0)}listen(C,D){const b=this.getUriTransformer(C);switch(D){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return S.Event.map(this.onDidInstallExtensions,I=>I.map(f=>({...f,local:f.local?n(f.local,b):f.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(C,D,b){const I=this.getUriTransformer(C);switch(D){case"zip":return this.service.zip(E(b[0],I)).then(f=>p(f,I));case"unzip":return this.service.unzip(R(b[0],I));case"install":return this.service.install(R(b[0],I),b[1]);case"getManifest":return this.service.getManifest(R(b[0],I));case"canInstall":return this.service.canInstall(b[0]);case"installFromGallery":return this.service.installFromGallery(b[0],b[1]);case"uninstall":return this.service.uninstall(E(b[0],I),b[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(E(b[0],I));case"getInstalled":return this.service.getInstalled(b[0]).then(f=>f.map(s=>n(s,I)));case"updateMetadata":return this.service.updateMetadata(E(b[0],I),b[1]).then(f=>n(f,I));case"updateExtensionScope":return this.service.updateExtensionScope(E(b[0],I),b[1]).then(f=>n(f,I));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=y;class v extends A.Disposable{constructor(C){super();this.channel=C,this._onInstallExtension=this._register(new S.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new S.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new S.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new S.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(D=>this._onInstallExtension.fire({identifier:D.identifier,source:this.isUriComponents(D.source)?L.URI.revive(D.source):D.source}))),this._register(this.channel.listen("onDidInstallExtensions")(D=>this._onDidInstallExtensions.fire(D.map(b=>({...b,local:b.local?E(b.local,null):b.local,source:this.isUriComponents(b.source)?L.URI.revive(b.source):b.source}))))),this._register(this.channel.listen("onUninstallExtension")(D=>this._onUninstallExtension.fire(D))),this._register(this.channel.listen("onDidUninstallExtension")(D=>this._onDidUninstallExtension.fire(D)))}isUriComponents(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}zip(C){return Promise.resolve(this.channel.call("zip",[C]).then(D=>L.URI.revive(D)))}unzip(C){return Promise.resolve(this.channel.call("unzip",[C]))}install(C,D){return Promise.resolve(this.channel.call("install",[C,D])).then(b=>E(b,null))}getManifest(C){return Promise.resolve(this.channel.call("getManifest",[C]))}async canInstall(C){return!0}installFromGallery(C,D){return Promise.resolve(this.channel.call("installFromGallery",[C,D])).then(b=>E(b,null))}uninstall(C,D){return Promise.resolve(this.channel.call("uninstall",[C,D]))}reinstallFromGallery(C){return Promise.resolve(this.channel.call("reinstallFromGallery",[C]))}getInstalled(C=null){return Promise.resolve(this.channel.call("getInstalled",[C])).then(D=>D.map(b=>E(b,null)))}updateMetadata(C,D){return Promise.resolve(this.channel.call("updateMetadata",[C,D])).then(b=>E(b,null))}updateExtensionScope(C,D){return Promise.resolve(this.channel.call("updateExtensionScope",[C,D])).then(b=>E(b,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=v;class m{constructor(C){this.service=C}listen(C,D){throw new Error("Invalid listen")}call(C,D,b){switch(D){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(b[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=m}),define(X[135],Q([0,1,26]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function P(k,A){const R=p=>{if(typeof p!="string")return;const E=L.exec(p);if(!E)return;const n=A[E[1]]??p;return typeof n=="string"?n:typeof n.message=="string"?n.message:p};return(0,S.cloneAndChange)(k,R)}e.localizeManifest=P}),define(X[136],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class S{constructor(k){this.channel=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,A,R,p){return this.channel.call("promptImportantExtensionsInstallNotification",[k,A,R,p])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=S;class L{constructor(k){this.service=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,R){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(X[70],Q([0,1,116]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function k(v){return v=v.trim(),v==="*"||L.test(v)}e.isValidVersionStr=k;function A(v){if(!k(v))return null;if(v=v.trim(),v==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=v.match(L);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=A;function R(v){if(!v)return null;let m=v.majorBase,h=v.majorMustEqual,C=v.minorBase,D=v.minorMustEqual,b=v.patchBase,I=v.patchMustEqual;v.hasCaret&&(m===0||(D=!1),I=!1);let f=0;if(v.preRelease){const s=P.exec(v.preRelease);if(s){const[,c,t,r]=s;f=Date.UTC(Number(c),Number(t)-1,Number(r))}}return{majorBase:m,majorMustEqual:h,minorBase:C,minorMustEqual:D,patchBase:b,patchMustEqual:I,isMinimum:v.hasGreaterEquals,notBefore:f}}e.normalizeVersion=R;function p(v,m,h){let C;typeof v=="string"?C=R(A(v)):C=v;let D;m instanceof Date?D=m.getTime():typeof m=="string"&&(D=new Date(m).getTime());let b;if(typeof h=="string"?b=R(A(h)):b=h,!C||!b)return!1;let I=C.majorBase,f=C.minorBase,s=C.patchBase,c=b.majorBase,t=b.minorBase,r=b.patchBase,i=b.notBefore,a=b.majorMustEqual,l=b.minorMustEqual,o=b.patchMustEqual;return b.isMinimum?I>c?!0:I<c?!1:f>t?!0:f<t||D&&D<i?!1:s>=r:(I===1&&c===0&&(!a||!l||!o)&&(c=1,t=0,r=0,a=!0,l=!1,o=!1),I<c?!1:I>c?!a:f<t?!1:f>t?!l:s<r?!1:s>r?!o:!(D&&D<i))}e.isValidVersion=p;function E(v,m,h,C){return h.isBuiltin||typeof h.main=="undefined"?!0:y(v,m,h.engines.vscode,C)}e.isValidExtensionVersion=E;function n(v,m,h){return v==="*"||y(m,h,v)}e.isEngineValid=n;function y(v,m,h,C=[]){let D=R(A(h));if(!D)return C.push(S.localize(0,null,h)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return C.push(S.localize(1,null,h)),!1}else if(!D.majorMustEqual)return C.push(S.localize(2,null,h)),!1;return p(v,m,D)?!0:(C.push(S.localize(3,null,v,h)),!1)}}),define(X[137],Q([0,1,36,50,2,17]),function(G,e,S,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends P.Disposable{constructor(p,E,n,y){super();this.folders=p,this.onDidFilesChange=E,this.onLogMessage=n,this.verboseLogging=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new L.Client(k.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(p.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(E=>!this.isDisposed&&this.onDidFilesChange(E))),this._register(this.service.onDidLogMessage(E=>this.onLogMessage(E))),this.setFolders(this.folders)}setVerboseLogging(p){this.verboseLogging=p,!this.isDisposed&&this.service&&this.service.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${p}`})}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(X[138],Q([0,1,36,50,2,17]),function(G,e,S,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends P.Disposable{constructor(p,E,n,y,v={}){super();this.folders=p,this.onDidFilesChange=E,this.onLogMessage=n,this.verboseLogging=y,this.watcherOptions=v,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new L.Client(k.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=S.ProxyChannel.toService((0,S.getNextTickChannel)(p.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(E=>!this.isDisposed&&this.onDidFilesChange(E))),this._register(this.service.onDidLogMessage(E=>this.onLogMessage(E))),this.service.setRoots(this.folders)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${p}`})}setVerboseLogging(p){this.verboseLogging=p,this.service&&this.service.setVerboseLogging(p)}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(X[139],Q([0,1,42,68,67,17]),function(G,e,S,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class A{constructor(p,E,n,y,v){this.watchedFolder=p,this.eventCallback=n,this.logCallback=y,this.verboseLogging=v,this.restartCounter=0,Array.isArray(E)?this.ignored=E.map(m=>(0,P.parse)(m)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${p}, excludes: ${E.join(",")}`),this.startWatcher()}startWatcher(){const p=[this.watchedFolder];this.verboseLogging&&p.push("-verbose"),this.handle=(0,S.spawn)(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",G).fsPath,p);const E=new L.LineDecoder;this.handle.stdout.on("data",n=>{const y=[];for(const v of E.write(n)){const m=v.split("|");if(m.length===2){const h=Number(m[0]),C=m[1];if(h>=0&&h<3){if(this.ignored&&this.ignored.some(D=>D(C))){this.verboseLogging&&this.log(C);continue}y.push({type:A.changeTypeMap[h],path:C})}else this.log(m[1])}}y.length>0&&this.eventCallback(y)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,y)=>this.onExit(n,y))}onError(p){this.error("process error: "+p.toString())}onExit(p,E){this.handle&&(this.error(`terminated unexpectedly (code: ${p}, signal: ${E})`),this.restartCounter<=A.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(p){this.logCallback({type:"error",message:`[File Watcher (C#)] ${p}`})}log(p){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${p}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=A,A.MAX_RESTARTS=5,A.changeTypeMap=[0,1,2]}),define(X[140],Q([0,1,139,8,19]),function(G,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k{constructor(R,p,E,n){this.onDidFilesChange=p,this.onLogMessage=E,this.verboseLogging=n,this.service=void 0,this.folder=R[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(L.posix.sep)&&(this.folder.path=(0,P.rtrim)(this.folder.path,L.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new S.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,R=>this.onFileEvents(R),R=>this.onLogMessage(R),this.verboseLogging)}setVerboseLogging(R){this.verboseLogging=R,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(R){this.isDisposed||R.length>0&&this.onDidFilesChange(R)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=k}),define(X[51],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(P,k=[],A=!1){this.ctor=P,this.staticArguments=k,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=S}),define(X[141],Q([0,1,51]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function P(A,R,p){R instanceof S.SyncDescriptor||(R=new S.SyncDescriptor(R,[],p)),L.push([A,R])}e.registerSingleton=P;function k(){return L}e.getSingletonServiceDescriptors=k}),define(X[142],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=S;class L{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let A of this._nodes.values())A.outgoing.size===0&&k.push(A);return k}insertEdge(k,A){const R=this.lookupOrInsertNode(k),p=this.lookupOrInsertNode(A);R.outgoing.set(this._hashFn(A),p),p.incoming.set(this._hashFn(k),R)}removeNode(k){const A=this._hashFn(k);this._nodes.delete(A);for(let R of this._nodes.values())R.outgoing.delete(A),R.incoming.delete(A)}lookupOrInsertNode(k){const A=this._hashFn(k);let R=this._nodes.get(A);return R||(R=new S(k),this._nodes.set(A,R)),R}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[A,R]of this._nodes)k.push(`${A}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,A]of this._nodes){const R=new Set([k]),p=this._findCycle(A,R);if(p)return p}}_findCycle(k,A){for(let[R,p]of k.outgoing){if(A.has(R))return[...A,R].join(" -> ");A.add(R);const E=this._findCycle(p,A);if(E)return E;A.delete(R)}}}e.Graph=L}),define(X[5],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function p(E){return E[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=p})(S=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function L(R,p,E,n){p[S.DI_TARGET]===p?p[S.DI_DEPENDENCIES].push({id:R,index:E,optional:n}):(p[S.DI_DEPENDENCIES]=[{id:R,index:E,optional:n}],p[S.DI_TARGET]=p)}function P(R){if(S.serviceIds.has(R))return S.serviceIds.get(R);const p=function(E,n,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(p,E,y,!1)};return p.toString=()=>R,S.serviceIds.set(R,p),p}e.createDecorator=P;function k(R){return R}e.refineServiceDecorator=k;function A(R){return function(p,E,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(R,p,n,!0)}}e.optional=A}),define(X[143],Q([0,1,5]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,S.createDecorator)("checksumService")}),define(X[144],Q([0,1,19,5,7]),function(G,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=P.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",P.isMacintosh),A.set("isLinux",P.isLinux),A.set("isWindows",P.isWindows),A.set("isWeb",P.isWeb),A.set("isMacNative",P.isMacintosh&&!P.isWeb),A.set("isEdge",k.indexOf("Edg/")>=0),A.set("isFirefox",k.indexOf("Firefox")>=0),A.set("isChrome",k.indexOf("Chrome")>=0),A.set("isSafari",k.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var p;(function(w){w[w.False=0]="False",w[w.True=1]="True",w[w.Defined=2]="Defined",w[w.Not=3]="Not",w[w.Equals=4]="Equals",w[w.NotEquals=5]="NotEquals",w[w.And=6]="And",w[w.Regex=7]="Regex",w[w.NotRegex=8]="NotRegex",w[w.Or=9]="Or",w[w.In=10]="In",w[w.NotIn=11]="NotIn",w[w.Greater=12]="Greater",w[w.GreaterEquals=13]="GreaterEquals",w[w.Smaller=14]="Smaller",w[w.SmallerEquals=15]="SmallerEquals"})(p=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return y.INSTANCE}static true(){return v.INSTANCE}static has(d){return m.create(d)}static equals(d,T){return h.create(d,T)}static notEquals(d,T){return b.create(d,T)}static regex(d,T){return r.create(d,T)}static in(d,T){return C.create(d,T)}static not(d){return I.create(d)}static and(...d){return a.create(d)}static or(...d){return l.create(d)}static greater(d,T){return f.create(d,T)}static less(d,T){return c.create(d,T)}static deserialize(d,T=!1){if(!!d)return this._deserializeOrExpression(d,T)}static _deserializeOrExpression(d,T){let O=d.split("||");return l.create(O.map($=>this._deserializeAndExpression($,T)))}static _deserializeAndExpression(d,T){let O=d.split("&&");return a.create(O.map($=>this._deserializeOne($,T)))}static _deserializeOne(d,T){if(d=d.trim(),d.indexOf("!=")>=0){let O=d.split("!=");return b.create(O[0].trim(),this._deserializeValue(O[1],T))}if(d.indexOf("==")>=0){let O=d.split("==");return h.create(O[0].trim(),this._deserializeValue(O[1],T))}if(d.indexOf("=~")>=0){let O=d.split("=~");return r.create(O[0].trim(),this._deserializeRegexValue(O[1],T))}if(d.indexOf(" in ")>=0){let O=d.split(" in ");return C.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(d)){const O=d.split(">=");return s.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(d)){const O=d.split(">");return f.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(d)){const O=d.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(d)){const O=d.split("<");return c.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(d)?I.create(d.substr(1).trim()):m.create(d)}static _deserializeValue(d,T){if(d=d.trim(),d==="true")return!0;if(d==="false")return!1;let O=/^'([^']*)'$/.exec(d);return O?O[1].trim():d}static _deserializeRegexValue(d,T){if((0,S.isFalsyOrWhitespace)(d)){if(T)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=d.indexOf("/"),$=d.lastIndexOf("/");if(O===$||O<0){if(T)throw new Error(`bad regexp-value '${d}', missing /-enclosure`);return console.warn(`bad regexp-value '${d}', missing /-enclosure`),null}let z=d.slice(O+1,$),V=d[$+1]==="i"?"i":"";try{return new RegExp(z,V)}catch(B){if(T)throw new Error(`bad regexp-value '${d}', parse error: ${B}`);return console.warn(`bad regexp-value '${d}', parse error: ${B}`),null}}}e.ContextKeyExpr=E;function n(w,d){return w.cmp(d)}class y{constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class v{constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class m{constructor(d){this.key=d,this.type=2}static create(d){const T=A.get(d);return typeof T=="boolean"?T?v.INSTANCE:y.INSTANCE:new m(d)}cmp(d){return d.type!==this.type?this.type-d.type:u(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return I.create(this.key)}}e.ContextKeyDefinedExpr=m;class h{constructor(d,T){this.key=d,this.value=T,this.type=4}static create(d,T){if(typeof T=="boolean")return T?m.create(d):I.create(d);const O=A.get(d);return typeof O=="boolean"?T===(O?"true":"false")?v.INSTANCE:y.INSTANCE:new h(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(d){return d.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=h;class C{constructor(d,T){this.key=d,this.valueKey=T,this.type=10}static create(d,T){return new C(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.valueKey,d.key,d.valueKey)}equals(d){return d.type===this.type?this.key===d.key&&this.valueKey===d.valueKey:!1}evaluate(d){const T=d.getValue(this.valueKey),O=d.getValue(this.key);return Array.isArray(T)?T.indexOf(O)>=0:typeof O=="string"&&typeof T=="object"&&T!==null?R.call(T,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(d){return d.mapIn(this.key,this.valueKey)}negate(){return D.create(this)}}e.ContextKeyInExpr=C;class D{constructor(d){this._actual=d,this.type=11}static create(d){return new D(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new D(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class b{constructor(d,T){this.key=d,this.value=T,this.type=5}static create(d,T){if(typeof T=="boolean")return T?I.create(d):m.create(d);const O=A.get(d);return typeof O=="boolean"?T===(O?"true":"false")?y.INSTANCE:v.INSTANCE:new b(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return d.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(d){return d.mapNotEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class I{constructor(d){this.key=d,this.type=3}static create(d){const T=A.get(d);return typeof T=="boolean"?T?y.INSTANCE:v.INSTANCE:new I(d)}cmp(d){return d.type!==this.type?this.type-d.type:u(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}evaluate(d){return!d.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(d){return d.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=I;class f{constructor(d,T){this.key=d,this.value=T,this.type=12}static create(d,T){return new f(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=f;class s{constructor(d,T){this.key=d,this.value=T,this.type=13}static create(d,T){return new s(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(d){return d.mapGreaterEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=s;class c{constructor(d,T){this.key=d,this.value=T,this.type=14}static create(d,T){return new c(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmaller(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeySmallerExpr=c;class t{constructor(d,T){this.key=d,this.value=T,this.type=15}static create(d,T){return new t(d,T)}cmp(d){return d.type!==this.type?this.type-d.type:g(this.key,this.value,d.key,d.value)}equals(d){return d.type===this.type?this.key===d.key&&this.value===d.value:!1}evaluate(d){return parseFloat(d.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(d){return d.mapSmallerEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(d,T){this.key=d,this.regexp=T,this.type=7}static create(d,T){return new r(d,T)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.key<d.key)return-1;if(this.key>d.key)return 1;const T=this.regexp?this.regexp.source:"",O=d.regexp?d.regexp.source:"";return T<O?-1:T>O?1:0}equals(d){if(d.type===this.type){const T=this.regexp?this.regexp.source:"",O=d.regexp?d.regexp.source:"";return this.key===d.key&&T===O}return!1}evaluate(d){let T=d.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const d=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${d}`}keys(){return[this.key]}map(d){return d.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(d){this._actual=d,this.type=8}static create(d){return new i(d)}cmp(d){return d.type!==this.type?this.type-d.type:this._actual.cmp(d._actual)}equals(d){return d.type===this.type?this._actual.equals(d._actual):!1}evaluate(d){return!this._actual.evaluate(d)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(d){return new i(this._actual.map(d))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class a{constructor(d){this.expr=d,this.type=6}static create(d){return a._normalizeArr(d)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const $=n(this.expr[T],d.expr[T]);if($!==0)return $}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(d.expr[T]))return!1;return!0}return!1}evaluate(d){for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].evaluate(d))return!1;return!0}static _normalizeArr(d){const T=[];let O=!1;for(const $ of d)if(!!$){if($.type===1){O=!0;continue}if($.type===0)return y.INSTANCE;if($.type===6){T.push(...$.expr);continue}T.push($)}if(T.length===0&&O)return v.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];for(T.sort(n);T.length>1;){const $=T[T.length-1];if($.type!==9)break;T.pop();const z=T.pop(),V=l.create($.expr.map(B=>a.create([B,z])));V&&(T.push(V),T.sort(n))}return T.length===1?T[0]:new a(T)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(let T of this.expr)d.push(...T.keys());return d}map(d){return new a(this.expr.map(T=>T.map(d)))}negate(){let d=[];for(let T of this.expr)d.push(T.negate());return l.create(d)}}e.ContextKeyAndExpr=a;class l{constructor(d){this.expr=d,this.type=9}static create(d){const T=l._normalizeArr(d);if(T.length!==0)return T.length===1?T[0]:new l(T)}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const $=n(this.expr[T],d.expr[T]);if($!==0)return $}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(d.expr[T]))return!1;return!0}return!1}evaluate(d){for(let T=0,O=this.expr.length;T<O;T++)if(this.expr[T].evaluate(d))return!0;return!1}static _normalizeArr(d){let T=[],O=!1;if(d){for(let $=0,z=d.length;$<z;$++){const V=d[$];if(!!V){if(V.type===0){O=!0;continue}if(V.type===1)return[v.INSTANCE];if(V.type===9){T=T.concat(V.expr);continue}T.push(V)}}if(T.length===0&&O)return[y.INSTANCE];T.sort(n)}return T}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(let T of this.expr)d.push(...T.keys());return d}map(d){return new l(this.expr.map(T=>T.map(d)))}negate(){let d=[];for(let O of this.expr)d.push(O.negate());const T=O=>O.type===9?O.expr:[O];for(;d.length>1;){const O=d.shift(),$=d.shift(),z=[];for(const V of T(O))for(const B of T($))z.push(E.and(V,B));d.unshift(E.or(...z))}return d[0]}}e.ContextKeyOrExpr=l;class o extends m{constructor(d,T,O){super(d);this._defaultValue=T,typeof O=="object"?o._info.push({...O,key:d}):O!==!0&&o._info.push({key:d,description:O,type:T!=null?typeof T:void 0})}static all(){return o._info.values()}bindTo(d){return d.createKey(this.key,this._defaultValue)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return E.not(this.key)}isEqualTo(d){return E.equals(this.key,d)}notEqualsTo(d){return E.notEquals(this.key,d)}}e.RawContextKey=o,o._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(w,d){return w<d?-1:w>d?1:0}function g(w,d,T,O){return w<T?-1:w>T?1:d<O?-1:d>O?1:0}}),define(X[71],Q([0,1,5]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function L(P){return!!P.hostName&&!!P.errorMessage}e.isRemoteDiagnosticError=L}),define(X[72],Q([0,1,5]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,S.createDecorator)("downloadService")}),define(X[12],Q([0,1,5]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(X[27],Q([0,1,111,5,17]),function(G,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=k;var A;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=5]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var R;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(R=e.SortOrder||(e.SortOrder={}));var p;(function(y){y.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var E;(function(y){y[y.None=0]="None",y[y.Install=1]="Install",y[y.Update=2]="Update"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(v,m){super(v);this.code=m,this.name=m}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=P.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,S.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,L.createDecorator)("IExtensionManagementCLIService")});var K=this&&this.__param||function(G,e){return function(S,L){e(S,L,G)}};define(X[145],Q([0,1,2,27]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let P=class extends S.Disposable{constructor(A){super();this.extensionManagementService=A,this._register(A),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};P=fe([K(0,L.IExtensionManagementService)],P),e.DeprecatedExtensionsCleaner=P}),define(X[73],Q([0,1,5]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function P(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=P;var k;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,S.createDecorator)("IExtensionRecommendationNotificationService")}),define(X[74],Q([0,1,19,5]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function P(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=P;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class R{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,v){if(typeof y=="undefined"||y===null)return typeof v=="undefined"||v===null;if(typeof v=="undefined"||v===null)return!1;if(typeof y=="string"||typeof v=="string"){let m=typeof y=="string"?y:y.value,h=typeof v=="string"?v:v.value;return S.equalsIgnoreCase(m,h)}return y._lower===v._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=R;function p(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function E(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=E,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(X[31],Q([0,1,19,74]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function P(h,C){return h.uuid&&C.uuid?h.uuid===C.uuid:h.id===C.id?!0:(0,S.compareIgnoreCase)(h.id,C.id)===0}e.areSameExtensions=P;class k{constructor(C,D){this.version=D,this.id=C.id,this.uuid=C.uuid}key(){return`${this.id}-${this.version}`}equals(C){return C instanceof k?P(this,C)&&this.version===C.version:!1}}e.ExtensionIdentifierWithVersion=k;function A(h,C){return`${h}.${C}`}e.getExtensionId=A;function R(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function p(h,C){return R(A(h,C))}e.getGalleryExtensionId=p;function E(h,C){const D=[],b=I=>{for(const f of D)if(f.some(s=>P(C(s),C(I))))return f;return null};for(const I of h){const f=b(I);f?f.push(I):D.push([I])}return D}e.groupByExtension=E;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function y(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function v(h){const C=new Set;for(const D of h)D.malicious&&C.add(D.id.id);return C}e.getMaliciousExtensionsSet=v;function m(h,C){const D=[],b=C.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const I=b.shift();if(I&&D.every(f=>!P(f.identifier,{id:I}))){const f=h.filter(s=>P(s.identifier,{id:I}));f.length===1&&(D.push(f[0]),b.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return D}e.getExtensionDependencies=m}),define(X[146],Q([0,1,2,8,74,18]),function(G,e,S,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends S.Disposable{constructor(p,E){super();this.environmentService=p,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,P.MANIFEST_CACHE_FOLDER,P.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this._register(E.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtensions(p){p.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(p){p.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(X[13],Q([0,1,118,8,4,5,19,16,38]),function(G,e,S,L,P,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,k.createDecorator)("fileService");function E(M){return M.create===!0}e.isFileOpenForWriteOptions=E;var n;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var y;(function(M){M[M.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var v;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(v=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=m;function h(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=h;function C(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function D(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=D;var b;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor(_,N){super(_);this.code=N}}e.FileSystemProviderError=I;function f(M,_){const N=new I(M.toString(),_);return c(N,_),N}e.createFileSystemProviderError=f;function s(M){return M||f((0,S.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=s;function c(M,_){return M.name=_?`${_} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=c;function t(M){if(!M)return b.Unknown;if(M instanceof I)return M.code;const _=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!_)return b.Unknown;switch(_[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(M){if(M instanceof g)return M.fileOperationResult;switch(t(M)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class a{constructor(_,N,j){this.resource=_,this.operation=N,this.target=j}isOperation(_){return this.operation===_}}e.FileOperationEvent=a;var l;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class o{constructor(_,N){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const j of _)switch(j.type){case 1:this.added||(this.added=p.TernarySearchTree.forUris(()=>N)),this.added.set(j.resource,j);break;case 0:this.updated||(this.updated=p.TernarySearchTree.forUris(()=>N)),this.updated.set(j.resource,j);break;case 2:this.deleted||(this.deleted=p.TernarySearchTree.forUris(()=>N)),this.deleted.set(j.resource,j);break}}contains(_,...N){return this.doContains(_,{includeChildren:!1},...N)}affects(_,...N){return this.doContains(_,{includeChildren:!0},...N)}doContains(_,N,...j){if(!_)return!1;const F=j.length>0;return!!((!F||j.includes(1))&&(this.added?.get(_)||N.includeChildren&&this.added?.findSuperstr(_))||(!F||j.includes(0))&&(this.updated?.get(_)||N.includeChildren&&this.updated?.findSuperstr(_))||(!F||j.includes(2))&&(this.deleted?.findSubstr(_)||N.includeChildren&&this.deleted?.findSuperstr(_)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=o;function u(M,_,N){return!M||!_||M===_||_.length>M.length?!1:(_.charAt(_.length-1)!==L.sep&&(_+=L.sep),N?(0,A.startsWithIgnoreCase)(M,_):M.indexOf(_)===0)}e.isParent=u;class g extends Error{constructor(_,N,j){super(_);this.fileOperationResult=N,this.options=j}}e.FileOperationError=g;class w extends g{constructor(_,N,j){super(_,2,j);this.stat=N}}e.NotModifiedSinceFileOperationError=w;var d;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(d=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=O;async function $(M,_){if(!_.canHandleResource(P.URI.from({scheme:M.scheme})))return new Promise(N=>{const j=_.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===M.scheme&&F.added&&(j.dispose(),N())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(_){return(0,R.isNumber)(_)||(_=0),_<z.KB?(0,S.localize)(1,null,_.toFixed(0)):_<z.MB?(0,S.localize)(2,null,(_/z.KB).toFixed(2)):_<z.GB?(0,S.localize)(3,null,(_/z.MB).toFixed(2)):_<z.TB?(0,S.localize)(4,null,(_/z.GB).toFixed(2)):(0,S.localize)(5,null,(_/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var V;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function B(M){return{maxFileSize:M===0?300*z.MB:16*z.GB,maxHeapSize:M===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=B}),define(X[147],Q([0,1,148,48,13]),function(G,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(R){this.fileService=R}checksum(R){return new Promise(async(p,E)=>{const n=(0,S.createHash)("md5"),y=(await this.fileService.readFileStream(R)).value;(0,L.listenStream)(y,{onData:v=>n.update(v.buffer),onError:v=>E(v),onEnd:()=>p(n.digest("base64").replace(/=+$/,""))})})}};k=fe([K(0,P.IFileService)],k),e.ChecksumService=k}),define(X[75],Q([0,1,4,13,7]),function(G,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function k(p){return p.map(E=>({type:E.type,resource:S.URI.file(E.path)}))}e.toFileChanges=k;function A(p){const E=new R;for(const n of p)E.processEvent(n);return E.normalize()}e.normalizeFileChanges=A;class R{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(E){const n=this.mapPathToChange.get(E.path);if(n){const y=n.type,v=E.type;y===1&&v===2?(this.mapPathToChange.delete(E.path),this.normalized.splice(this.normalized.indexOf(n),1)):y===2&&v===1?n.type=0:y===1&&v===0||(n.type=v)}else this.normalized.push(E),this.mapPathToChange.set(E.path,E)}normalize(){const E=[],n=[];return this.normalized.filter(y=>y.type!==2?(E.push(y),!1):!0).sort((y,v)=>y.path.length-v.path.length).filter(y=>n.some(v=>(0,L.isParent)(y.path,v,!P.isLinux))?!1:(n.push(y.path),!0)).concat(E)}}}),define(X[149],Q([0,1,75,2,18,96,99,6,8]),function(G,e,S,L,P,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends L.Disposable{constructor(y,v,m,h){super();this.path=y,this.onDidFilesChange=v,this.onLogMessage=m,this.verboseLogging=h,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(A.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(y){this.verboseLogging=y}async startWatching(){try{const{stat:y,symbolicLink:v}=await P.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let m=this.path;if(v)try{m=await(0,k.realpath)(m)}catch(h){if(this.onError(h),v.dangling)return}y.isDirectory()?this._register((0,A.watchFolder)(m,(h,C)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,p.join)(this.path,(0,p.basename)(C))})},h=>this.onError(h))):this._register((0,A.watchFile)(m,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(y){y.code!=="ENOENT"&&this.onError(y)}}onFileChange(y){this.fileChangesBuffer.push(y),this.verboseLogging&&this.onVerbose(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const m=(0,S.normalizeFileChanges)(v);if(this.verboseLogging)for(const h of m)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);m.length>0&&this.onDidFilesChange(m)})}onError(y){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${y}`})}onVerbose(y){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E}),define(X[76],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...P){this._entries=new Map;for(let[k,A]of P)this.set(k,A)}set(P,k){const A=this._entries.get(P);return this._entries.set(P,k),A}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=S}),define(X[150],Q([0,1,9,142,51,5,76,6]),function(G,e,S,L,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const p=!1;class E extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class n{constructor(h=new A.ServiceCollection,C=!1,D){this._activeInstantiations=new Set,this._services=h,this._strict=C,this._parent=D,this._services.set(k.IInstantiationService,this)}createChild(h){return new n(h,this._strict,this)}invokeFunction(h,...C){let D=v.traceInvocation(h),b=!1;try{return h({get:(f,s)=>{if(b)throw(0,S.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(f,D);if(!c&&s!==k.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return c}},...C)}finally{b=!0,D.stop()}}createInstance(h,...C){let D,b;return h instanceof P.SyncDescriptor?(D=v.traceCreation(h.ctor),b=this._createInstance(h.ctor,h.staticArguments.concat(C),D)):(D=v.traceCreation(h),b=this._createInstance(h,C,D)),D.stop(),b}_createInstance(h,C=[],D){let b=k._util.getServiceDependencies(h).sort((s,c)=>s.index-c.index),I=[];for(const s of b){let c=this._getOrCreateServiceInstance(s.id,D);if(!c&&this._strict&&!s.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${s.id}.`);I.push(c)}let f=b.length>0?b[0].index:C.length;if(C.length!==f){console.warn(`[createInstance] First service dependency of ${h.name} at position ${f+1} conflicts with ${C.length} static arguments`);let s=f-C.length;s>0?C=C.concat(new Array(s)):C=C.slice(0,f)}return new h(...[...C,...I])}_setServiceInstance(h,C){if(this._services.get(h)instanceof P.SyncDescriptor)this._services.set(h,C);else if(this._parent)this._parent._setServiceInstance(h,C);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let C=this._services.get(h);return!C&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):C}_getOrCreateServiceInstance(h,C){let D=this._getServiceInstanceOrDescriptor(h);return D instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,D,C.branch(h,!0)):(C.branch(h,!1),D)}_safeCreateAndCacheServiceInstance(h,C,D){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,C,D)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,C,D){const b=new L.Graph(s=>s.id.toString());let I=0;const f=[{id:h,desc:C,_trace:D}];for(;f.length;){const s=f.pop();if(b.lookupOrInsertNode(s),I++>1e3)throw new E(b);for(let c of k._util.getServiceDependencies(s.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${h} depends on ${c.id} which is NOT registered.`),t instanceof P.SyncDescriptor){const r={id:c.id,desc:t,_trace:s._trace.branch(c.id,!0)};b.insertEdge(s,r),f.push(r)}}}for(;;){const s=b.roots();if(s.length===0){if(!b.isEmpty())throw new E(b);break}for(const{data:c}of s){if(this._getServiceInstanceOrDescriptor(c.id)instanceof P.SyncDescriptor){const r=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,r)}b.removeNode(c)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,C,D=[],b,I){if(this._services.get(h)instanceof P.SyncDescriptor)return this._createServiceInstance(C,D,b,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,C,D,b,I);throw new Error(`illegalState - creating UNKNOWN service instance ${C.name}`)}_createServiceInstance(h,C=[],D,b){if(D){const I=new R.IdleValue(()=>this._createInstance(h,C,b));return new Proxy(Object.create(null),{get(f,s){if(s in f)return f[s];let c=I.value,t=c[s];return typeof t!="function"||(t=t.bind(c),f[s]=t),t},set(f,s,c){return I.value[s]=c,!0}})}else return this._createInstance(h,C,b)}}e.InstantiationService=n;var y;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(y||(y={}));class v{constructor(h,C){this.type=h,this.name=C,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return p?new v(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(h){return p?new v(0,h.name):v._None}branch(h,C){let D=new v(2,h.toString());return this._dep.push([h,C,D]),D}stop(){let h=Date.now()-this._start;v._totals+=h;let C=!1;function D(I,f){let s=[],c=new Array(I+1).join("	");for(const[t,r,i]of f._dep)if(r&&i){C=!0,s.push(`${c}CREATES -> ${t}`);let a=D(I+1,i);a&&s.push(a)}else s.push(`${c}uses -> ${t}`);return s.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(h>2||C)&&console.log(b.join(`
`))}}v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(X[151],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class S{constructor(P,k){this.server=P,this.router=k}getChannel(P){return this.server.getChannel(P,this.router)}registerChannel(P,k){this.server.registerChannel(P,k)}}e.MessagePortMainProcessService=S}),define(X[152],Q([0,1,36,51,141,5]),function(G,e,S,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(m,h,C){const D=C.getChannel(m);return R(h)?new h.channelClientCtor(D):S.ProxyChannel.toService(D,h?.proxyOptions)}}function R(v){return!!v?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let p=class extends A{constructor(m,h,C){super(m,h,C)}};p=fe([K(2,e.IMainProcessService)],p);function E(v,m,h){(0,P.registerSingleton)(v,new L.SyncDescriptor(p,[m,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let n=class extends A{constructor(m,h,C){super(m,h,C)}};n=fe([K(2,e.ISharedProcessService)],n);function y(v,m,h){(0,P.registerSingleton)(v,new L.SyncDescriptor(n,[m,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=y}),define(X[56],Q([0,1,5]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,S.createDecorator)("localizationsService");function L(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const k of P.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}e.isValidLocalization=L}),define(X[153],Q([0,1,2,56]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let P=class extends S.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};P=fe([K(0,L.ILocalizationsService)],P),e.LocalizationsUpdater=P}),define(X[14],Q([0,1,5,2,7,3,43]),function(G,e,S,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function R(){return new Date().toISOString()}var p;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;class E extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class n extends E{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(p.Trace)&&this.log(p.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(p.Debug)&&this.log(p.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(p.Info)&&this.log(p.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(p.Warning)&&this.log(p.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(p.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(p.Error,this.format(i))}else this.log(p.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(p.Critical)&&this.log(p.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let a=t[i];if(typeof a=="object")try{a=JSON.stringify(a)}catch(l){}r+=(i>0?" ":"")+a}return r}}e.AbstractMessageLogger=n;class y extends E{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!P.isWindows}trace(t,...r){this.getLevel()<=p.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}debug(t,...r){this.getLevel()<=p.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}info(t,...r){this.getLevel()<=p.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,t,...r):console.log(`[main ${R()}]`,t,...r))}warn(t,...r){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,t,...r):console.warn(`[main ${R()}]`,t,...r))}error(t,...r){this.getLevel()<=p.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,t,...r):console.error(`[main ${R()}]`,t,...r))}critical(t,...r){this.getLevel()<=p.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,t,...r):console.error(`[main ${R()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class v extends E{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=v;class m extends E{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=p.Trace&&this.adapter.log(p.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=p.Debug&&this.adapter.log(p.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=p.Info&&this.adapter.log(p.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=p.Warning&&this.adapter.log(p.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=p.Error&&this.adapter.log(p.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=p.Critical&&this.adapter.log(p.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,A.toErrorMessage)(t,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class h extends E{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class C extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=C;class D extends L.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(i))}))}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,r?.always?p.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),r?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class b{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(t){}getLevel(){return p.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function I(c){if(c.verbose)return p.Trace;if(typeof c.logLevel=="string"){const t=f(c.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function f(c){switch(c){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=f;function s(c){switch(c){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=s}),define(X[154],Q([0,1,12,8,18,9,2,6,14]),function(G,e,S,L,P,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends A.Disposable{constructor(y,v){super();this.environmentService=y,this.logService=v,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const y=(0,L.basename)(this.environmentService.logsPath),v=(0,L.dirname)(this.environmentService.logsPath),C=(await P.Promises.readdir(v)).filter(b=>/^\d{8}T\d{6}$/.test(b)).sort().filter(b=>b!==y),D=C.slice(0,Math.max(0,C.length-9));D.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${D.join(", ")}'`),await Promise.all(D.map(b=>P.Promises.rm((0,L.join)(v,b)))))}catch(y){(0,k.onUnexpectedError)(y)}}};E=fe([K(0,S.IEnvironmentService),K(1,p.ILogService)],E),e.LogsDataCleaner=E}),define(X[155],Q([0,1,12,8,18,9,2,6,14]),function(G,e,S,L,P,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let E=class lt extends A.Disposable{constructor(y,v,m){super();this.backupWorkspacesPath=y,this.environmentService=v,this.logService=m,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const y=await P.Promises.readFile(this.backupWorkspacesPath,"utf8"),m=JSON.parse(y).emptyWorkspaceInfos.map(C=>C.backupFolder),h=await P.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async C=>{C.length!==lt.NON_EMPTY_WORKSPACE_ID_LENGTH&&m.indexOf(C)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${C}.`),await P.Promises.rm((0,L.join)(this.environmentService.workspaceStorageHome.fsPath,C)))}))}catch(y){(0,k.onUnexpectedError)(y)}}};E.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,E=fe([K(1,S.INativeEnvironmentService),K(2,p.ILogService)],E),e.StorageDataCleaner=E}),define(X[156],Q([0,1,18,2,13,27,12,4,15,31,14,30,57,7,6,9]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends L.Disposable{constructor(f,s,c,t){super();this.fileService=s,this.extensionGalleryService=c,this.logService=t,this.extensionsDownloadDir=R.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,s){await this.cleanUpPromise;const c=this.getName(f),t=(0,p.joinPath)(this.extensionsDownloadDir,c);if(!await this.fileService.exists(t)){const r=(0,p.joinPath)(this.extensionsDownloadDir,`.${(0,y.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(f,r,s);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(a){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,C.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,r.path),i}}return t}async delete(f){}async rename(f,s,c){try{await S.Promises.rename(f.fsPath,s.fsPath)}catch(t){if(m.isWindows&&t&&t.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${f} to ${s} with 'EPERM' error. Trying again...`),this.rename(f,s,c);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const s=[],c=[];for(const i of f.children){const a=this.parse(i.name);a&&c.push([a,i])}const t=(0,E.groupByExtension)(c,([i])=>i),r=[];for(const i of t)i.sort((a,l)=>v.rcompare(a[0].version,l[0].version)),s.push(...i.slice(1).map(a=>a[1].resource)),r.push(i[0][1]);r.sort((i,a)=>i.mtime-a.mtime),s.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await h.Promises.settled(s.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?new E.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase():(0,y.generateUuid)()}parse(f){const s=D.exec(f);return s&&s[1]&&s[2]?new E.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};b=fe([K(0,A.INativeEnvironmentService),K(1,P.IFileService),K(2,k.IExtensionGalleryService),K(3,n.ILogService)],b),e.ExtensionsDownloader=b}),define(X[157],Q([0,1,2,14,42,43,8,6,3,17,18,12]),function(G,e,S,L,P,k,A,R,p,E,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends S.Disposable{constructor(h,C){super();this.environmentService=h,this.logService=C,this.processesLimiter=new R.Limiter(5)}async postUninstall(h){const C=this.parseScript(h,"uninstall");return C&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(C.script,"uninstall",C.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),D=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${D}`)))),n.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,D=>this.logService.error("Error while removing extension storage path",D))}parseScript(h,C){const D=`vscode:${C}`;if(h.location.scheme===E.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[D]=="string"){const b=h.manifest.scripts[D].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${D} should be a node script`),null):{script:(0,A.join)(h.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}runLifecycleHook(h,C,D,b,I){return new Promise((f,s)=>{const c=this.start(h,C,D,I);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?s(i):f(void 0)};c.on("error",i=>{r((0,k.toErrorMessage)(i)||"Unknown")}),c.on("exit",(i,a)=>{r(i?`post-${C} process exited with code ${i}`:void 0)}),b&&(t=setTimeout(()=>{t=null,c.kill(),s("timed out")},5e3))})}start(h,C,D,b){const I={silent:!0,execArgv:void 0},f=(0,P.fork)(h,[`--type=extension-post-${C}`,...D],I);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const s=p.Event.fromNodeEventEmitter(f.stdout,"data"),c=p.Event.fromNodeEventEmitter(f.stderr,"data");s(i=>this.logService.info(b.identifier.id,b.manifest.version,`post-${C}`,i)),c(i=>this.logService.error(b.identifier.id,b.manifest.version,`post-${C}`,i));const t=p.Event.any(p.Event.map(s,i=>({data:`%c${i}`,format:[""]})),p.Event.map(c,i=>({data:`%c${i}`,format:["color: red"]})));return p.Event.debounce(t,(i,a)=>i?{data:i.data+a.data,format:[...i.format,...a.format]}:{data:a.data,format:a.format},100)(i=>{console.group(b.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),f}getExtensionStoragePath(h){return(0,A.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};v=fe([K(0,y.IEnvironmentService),K(1,L.ILogService)],v),e.ExtensionsLifecycle=v}),define(X[158],Q([0,1,2,12,3,13,4,31,15,14]),function(G,e,S,L,P,k,A,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends S.Disposable{constructor(v,m,h,C){super();this.extensionsManagementService=v,this.logService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new P.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(I=>{this.installedExtensions=I.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(v.onInstallExtension(I=>this.onInstallExtension(I))),this._register(v.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(v.onDidUninstallExtension(I=>this.onDidUninstallExtension(I)));const D=A.URI.file(h.extensionsPath),b=new p.ExtUri(I=>!m.hasCapability(I,1024));this._register(m.watch(D)),this._register(P.Event.filter(m.onDidChangeFilesRaw,I=>I.changes.some(f=>this.doesChangeAffects(f,D,b)))(()=>this.onDidChange()))}doesChangeAffects(v,m,h){return h.isEqual(h.dirname(v.resource),m)?h.isEqual(v.resource,h.joinPath(m,".obsolete"))?!0:!(v.type!==1&&v.type!==2||h.basename(v.resource).startsWith(".")):!1}onInstallExtension(v){this.addInstallingExtension(v.identifier)}onDidInstallExtensions(v){for(const m of v)this.removeInstallingExtension(m.identifier),m.local&&this.addInstalledExtension(m.identifier)}onDidUninstallExtension(v){v.error||this.removeInstalledExtension(v.identifier)}addInstallingExtension(v){this.removeInstallingExtension(v),this.installingExtensions.push(v)}removeInstallingExtension(v){this.installingExtensions=this.installingExtensions.filter(m=>!(0,R.areSameExtensions)(m,v))}addInstalledExtension(v){this.installedExtensions&&(this.removeInstalledExtension(v),this.installedExtensions.push(v))}removeInstalledExtension(v){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(m=>!(0,R.areSameExtensions)(m,v)))}async onDidChange(){if(this.installedExtensions){const v=await this.extensionsManagementService.getInstalled(1),m=v.filter(C=>[...this.installingExtensions,...this.installedExtensions].some(D=>(0,R.areSameExtensions)(D,C.identifier))?!1:C.installedTimestamp&&C.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",C.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",C.identifier.id),!1)),h=this.installedExtensions.filter(C=>this.installingExtensions.some(D=>(0,R.areSameExtensions)(D,C))?!1:v.every(D=>!(0,R.areSameExtensions)(D.identifier,C))?(this.logService.info("Detected extension removed from another source",C.id),!0):!1);this.installedExtensions=v.map(C=>C.identifier),(m.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:m,removed:h})}}};n=fe([K(1,k.IFileService),K(2,L.INativeEnvironmentService),K(3,E.ILogService)],n),e.ExtensionsWatcher=n}),define(X[159],Q([0,1,18,148,27,2,12,6,31,14,56,23,3,17,8]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let C=class extends k.Disposable{constructor(I,f,s){super();this.extensionManagementService=I,this.logService=s,this._onDidLanguagesChange=this._register(new v.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new D(f,s)),this._register(I.onDidInstallExtensions(c=>this.onDidInstallExtensions(c))),this._register(I.onDidUninstallExtension(({identifier:c})=>this.onDidUninstallExtension(c)))}getLanguageIds(){return this.cache.getLanguagePacks().then(I=>{const f=["en",...Object.keys(I)];return(0,y.distinct)(f)})}onDidInstallExtensions(I){for(const{local:f}of I)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",f.identifier.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(I){this.cache.getLanguagePacks().then(f=>{Object.keys(f).some(s=>f[s]&&f[s].extensions.some(c=>(0,p.areSameExtensions)(c.extensionIdentifier,I)))&&(this.logService.debug("Removing language packs from the extension",I.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))})}async update(){const[I,f]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),s=await this.cache.update(f);return!(0,y.equals)(Object.keys(I),Object.keys(s))}};C=fe([K(0,P.IExtensionManagementService),K(1,A.INativeEnvironmentService),K(2,E.ILogService)],C),e.LocalizationsService=C;let D=class extends k.Disposable{constructor(I,f){super();this.logService=f,this.languagePacks={},this.languagePacksFilePath=(0,h.join)(I.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(I){return this.withLanguagePacks(f=>{Object.keys(f).forEach(s=>delete f[s]),this.createLanguagePacksFromExtensions(f,...I)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(I,...f){for(const s of f)s&&s.manifest&&s.manifest.contributes&&s.manifest.contributes.localizations&&s.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(I,s);Object.keys(I).forEach(s=>this.updateHash(I[s]))}createLanguagePacksFromExtension(I,f){const s=f.identifier,c=f.manifest.contributes&&f.manifest.contributes.localizations?f.manifest.contributes.localizations:[];for(const t of c)if(f.location.scheme===m.Schemas.file&&(0,n.isValidLocalization)(t)){let r=I[t.languageId];r||(r={hash:"",extensions:[],translations:{}},I[t.languageId]=r);let i=r.extensions.filter(a=>(0,p.areSameExtensions)(a.extensionIdentifier,s))[0];i?i.version=f.manifest.version:r.extensions.push({extensionIdentifier:s,version:f.manifest.version});for(const a of t.translations)r.translations[a.id]=(0,h.join)(f.location.fsPath,a.path)}}updateHash(I){if(I){const f=(0,L.createHash)("md5");for(const s of I.extensions)f.update(s.extensionIdentifier.uuid||s.extensionIdentifier.id).update(s.version);I.hash=f.digest("hex")}}withLanguagePacks(I=()=>null){return this.languagePacksFileLimiter.queue(()=>{let f=null;return S.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,s=>s.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(s)).then(s=>{try{return JSON.parse(s)}catch(c){return{}}}).then(s=>(f=I(s),s)).then(s=>{for(const t of Object.keys(s))s[t]||delete s[t];this.languagePacks=s,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),S.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>f,s=>this.logService.error(s))})}};D=fe([K(0,A.INativeEnvironmentService),K(1,E.ILogService)],D)}),define(X[77],Q([0,1,14,3,4]),function(G,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(v){this.service=v,this.onDidChangeLogLevel=L.Event.buffer(v.onDidChangeLogLevel,!0)}listen(v,m){switch(m){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${m}`)}async call(v,m,h){switch(m){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${m}`)}}e.LogLevelChannel=k;class A{constructor(v){this.channel=v}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(v){A.setLevel(this.channel,v)}static setLevel(v,m){return v.call("setLevel",m)}}e.LogLevelChannelClient=A;class R{constructor(v){this.loggerService=v,this.loggers=new Map}listen(v,m){throw new Error(`Event not found: ${m}`)}async call(v,m,h){switch(m){case"createLogger":this.createLogger(P.URI.revive(h[0]),h[1]);return;case"log":return this.log(P.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${m}`)}createLogger(v,m){this.loggers.set(v.toString(),this.loggerService.createLogger(v,m))}consoleLog(v,m){let h=console.log;switch(v){case S.LogLevel.Error:h=console.error;break;case S.LogLevel.Warning:h=console.warn;break;case S.LogLevel.Info:h=console.info;break}h.call(console,...m)}log(v,m){const h=this.loggers.get(v.toString());if(!h)throw new Error("Create the logger before logging");for(const[C,D]of m)switch(C){case S.LogLevel.Trace:h.trace(D);break;case S.LogLevel.Debug:h.debug(D);break;case S.LogLevel.Info:h.info(D);break;case S.LogLevel.Warning:h.warn(D);break;case S.LogLevel.Error:h.error(D);break;case S.LogLevel.Critical:h.critical(D);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=R;class p extends S.AbstractLoggerService{constructor(v,m,h){super(v,m);this.channel=h}createConsoleMainLogger(){return new S.AdapterLogger({log:(v,m)=>{this.channel.call("consoleLog",[v,m])}})}doCreateLogger(v,m,h){return new E(this.channel,v,m,h)}}e.LoggerChannelClient=p;class E extends S.AbstractMessageLogger{constructor(v,m,h,C){super(C?.always);this.channel=v,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[m,C]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(v,m){const h=[[v,m]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(v){this.channel.call("log",[this.file,v])}}class n extends S.LogService{constructor(v,m){super(m);this.parent=v,this._register(v.onDidChangeLogLevel(h=>m.setLevel(h)))}setLevel(v){super.setLevel(v),this.parent.setLevel(v)}}e.FollowerLogService=n}),define(X[58],Q([0,1,5]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,S.createDecorator)("nativeHostService")}),define(X[44],Q([0,1,17,7,34,15]),function(G,e,S,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const R=L.globals.vscode.context.configuration();if(R)A=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof G?.__$__nodeRequire=="function"){const R=(0,k.dirname)(S.FileAccess.asFileUri("",G));A=G.__$__nodeRequire((0,k.joinPath)(R,"product.json").fsPath);const p=G.__$__nodeRequire((0,k.joinPath)(R,"package.json").fsPath);P.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:p.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.59.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(X[78],Q([0,1,119,25,13,9,44]),function(G,e,S,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(y,v,m,h,C,D){let b;try{await p(y,v,m,h,C,D)}catch(I){b=I}finally{b&&C.errorTransformer&&(b=C.errorTransformer(b)),typeof b!="undefined"&&m.error(b),m.end()}}e.readFileIntoStream=R;async function p(y,v,m,h,C,D){E(D);const b=await y.open(v,{create:!1});try{E(D);let I=0,f=0,s=C&&typeof C.length=="number"?C.length:void 0,c=L.VSBuffer.alloc(Math.min(C.bufferSize,typeof s=="number"?s:C.bufferSize)),t=C&&typeof C.position=="number"?C.position:0,r=0;do f=await y.read(b,t,c.buffer,r,c.byteLength-r),t+=f,r+=f,I+=f,typeof s=="number"&&(s-=f),r===c.byteLength&&(await m.write(h(c)),c=L.VSBuffer.alloc(Math.min(C.bufferSize,typeof s=="number"?s:C.bufferSize)),r=0);while(f>0&&(typeof s!="number"||s>0)&&E(D)&&n(I,C));if(r>0){let i=r;typeof s=="number"&&(i=Math.min(r,s)),m.write(h(c.slice(0,i)))}}catch(I){throw(0,P.ensureFileSystemProviderError)(I)}finally{await y.close(b)}}function E(y){if(y.isCancellationRequested)throw(0,k.canceled)();return!0}function n(y,v){if(v?.limits){if(typeof v.limits.memory=="number"&&y>v.limits.memory)throw(0,P.createFileSystemProviderError)((0,S.localize)(0,null,A.default.nameShort),P.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&y>v.limits.size)throw(0,P.createFileSystemProviderError)((0,S.localize)(1,null),P.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(X[160],Q([0,1,117,161,2,13,3,15,38,23,14,25,48,6,29,17,78,53]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=class ze extends P.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new A.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new m.ThrottledWorker(ze.FILE_EVENTS_THROTTLING.maxChangesChunkSize,ze.FILE_EVENTS_THROTTLING.maxChangesBufferSize,ze.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new k.FileChangesEvent(c,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new m.ThrottledWorker(ze.FILE_EVENTS_THROTTLING.maxChangesChunkSize,ze.FILE_EVENTS_THROTTLING.maxChangesBufferSize,ze.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new k.FileChangesEvent(c,!0)))),this.watchedResources=p.TernarySearchTree.forUris(c=>{const t=this.getProvider(c.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new m.ResourceQueue)}registerProvider(s,c){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,L.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:c});const t=new P.DisposableStore;return t.add(c.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(c)))),t.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:s}))),typeof c.onDidErrorOccur=="function"&&t.add(c.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,P.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:c}),this.provider.delete(s),(0,P.dispose)(t)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(t){c.push(t)}}),!this.provider.has(s)&&await m.Promises.settled(c)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,c){const t=this.provider.get(s.scheme);return!!(t&&t.capabilities&c)}listCapabilities(){return b.Iterable.map(this.provider,([s,c])=>({scheme:s,capabilities:c.capabilities}))}async withProvider(s){if(!(0,R.isAbsolutePath)(s))throw new k.FileOperationError((0,S.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const c=this.provider.get(s.scheme);if(!c){const t=new Error;throw t.name="ENOPRO",t.message=(0,S.localize)(1,null,s.toString()),t}return c}async withReadProvider(s){const c=await this.withProvider(s);if((0,k.hasOpenReadWriteCloseCapability)(c)||(0,k.hasReadWriteCapability)(c)||(0,k.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const c=await this.withProvider(s);if((0,k.hasOpenReadWriteCloseCapability)(c)||(0,k.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,c){try{return await this.doResolveFile(s,c)}catch(t){throw(0,k.toFileSystemProviderErrorCode)(t)===k.FileSystemProviderErrorCode.FileNotFound?new k.FileOperationError((0,S.localize)(2,null,this.resourceForError(s)),1):(0,k.ensureFileSystemProviderError)(t)}}async doResolveFile(s,c){const t=await this.withProvider(s),r=this.isPathCaseSensitive(t),i=c?.resolveTo,a=c?.resolveSingleChildDescendants,l=c?.resolveMetadata,o=await t.stat(s);let u;return this.toFileStat(t,s,o,void 0,!!l,(g,w)=>(u||(u=p.TernarySearchTree.forUris(()=>!r),u.set(s,!0),(0,E.isNonEmptyArray)(i)&&i.forEach(d=>u.set(d,!0))),Boolean(u.findSuperstr(g.resource)||u.get(g.resource))?!0:g.isDirectory&&a?w===1:!1))}async toFileStat(s,c,t,r,i,a){const{providerExtUri:l}=this.getExtUri(s),o={resource:c,name:l.basename(c),isFile:(t.type&k.FileType.File)!=0,isDirectory:(t.type&k.FileType.Directory)!=0,isSymbolicLink:(t.type&k.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&k.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,k.etag)({mtime:t.mtime,size:t.size})};if(o.isDirectory&&a(o,r)){try{const u=await s.readdir(c),g=await m.Promises.settled(u.map(async([w,d])=>{try{const T=l.joinPath(c,w),O=i?await s.stat(T):{type:d};return await this.toFileStat(s,T,O,u.length,i,a)}catch(T){return this.logService.trace(T),null}}));o.children=(0,E.coalesce)(g)}catch(u){this.logService.trace(u),o.children=[]}return o}return o}async resolveAll(s){return m.Promises.settled(s.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(s){const c=await this.withProvider(s);try{return!!await c.stat(s)}catch(t){return!1}}async canCreateFile(s,c){try{await this.doValidateCreateFile(s,c)}catch(t){return t}return!0}async doValidateCreateFile(s,c){if(!c?.overwrite&&await this.exists(s))throw new k.FileOperationError((0,S.localize)(3,null,this.resourceForError(s)),3,c)}async createFile(s,c=y.VSBuffer.fromString(""),t){await this.doValidateCreateFile(s,t);const r=await this.writeFile(s,c);return this._onDidRunOperation.fire(new k.FileOperationEvent(s,0,r)),r}async writeFile(s,c,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,s,t)||await this.mkdirp(r,i.dirname(s));let l;if((0,k.hasReadWriteCapability)(r)&&!(c instanceof y.VSBuffer))if((0,v.isReadableStream)(c)){const o=await(0,v.peekStream)(c,3);o.ended?l=y.VSBuffer.concat(o.buffer):l=o}else l=(0,v.peekReadable)(c,o=>y.VSBuffer.concat(o),3);else l=c;!(0,k.hasOpenReadWriteCloseCapability)(r)||(0,k.hasReadWriteCapability)(r)&&l instanceof y.VSBuffer?await this.doWriteUnbuffered(r,s,t,l):await this.doWriteBuffered(r,s,t,l instanceof y.VSBuffer?(0,y.bufferToReadable)(l):l)}catch(a){throw new k.FileOperationError((0,S.localize)(4,null,this.resourceForError(s),(0,k.ensureFileSystemProviderError)(a).toString()),(0,k.toFileOperationResult)(a),t)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,c,t){if(!!t?.unlock&&!(s.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(c)));let i;try{i=await s.stat(c)}catch(a){return}if((i.type&k.FileType.Directory)!=0)throw new k.FileOperationError((0,S.localize)(6,null,this.resourceForError(c)),0,t);if(this.throwIfFileIsReadonly(c,i),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==(0,k.etag)({mtime:t.mtime,size:i.size}))throw new k.FileOperationError((0,S.localize)(7,null),3,t);return i}async readFile(s,c){const t=await this.withReadProvider(s);return c?.atomic?this.doReadFileAtomic(t,s,c):this.doReadFile(t,s,c)}async doReadFileAtomic(s,c,t){return new Promise((r,i)=>{this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(s,c,t);r(a)}catch(a){i(a)}})})}async doReadFile(s,c,t){const r=await this.doReadFileStream(s,c,{...t,preferUnbuffered:!0});return{...r,value:await(0,y.streamToBuffer)(r.value)}}async readFileStream(s,c){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,c)}async doReadFileStream(s,c,t){const r=new h.CancellationTokenSource,i=this.validateReadFile(c,t).then(l=>l,l=>{throw r.cancel(),l});let a;try{return t&&typeof t.etag=="string"&&t.etag!==k.ETAG_DISABLED&&await i,!((0,k.hasOpenReadWriteCloseCapability)(s)||(0,k.hasFileReadStreamCapability)(s))||(0,k.hasReadWriteCapability)(s)&&t?.preferUnbuffered?a=this.readFileUnbuffered(s,c,t):(0,k.hasFileReadStreamCapability)(s)?a=this.readFileStreamed(s,c,r.token,t):a=this.readFileBuffered(s,c,r.token,t),{...await i,value:a}}catch(l){a&&await(0,v.consumeStream)(a);const o=(0,S.localize)(8,null,this.resourceForError(c),(0,k.ensureFileSystemProviderError)(l).toString());throw l instanceof k.NotModifiedSinceFileOperationError?new k.NotModifiedSinceFileOperationError(o,l.stat,t):new k.FileOperationError(o,(0,k.toFileOperationResult)(l),t)}}readFileStreamed(s,c,t,r=Object.create(null)){const i=s.readFileStream(c,r,t);return(0,v.transform)(i,{data:a=>a instanceof y.VSBuffer?a:y.VSBuffer.wrap(a),error:a=>new k.FileOperationError((0,S.localize)(9,null,this.resourceForError(c),(0,k.ensureFileSystemProviderError)(a).toString()),(0,k.toFileOperationResult)(a),r)},a=>y.VSBuffer.concat(a))}readFileBuffered(s,c,t,r=Object.create(null)){const i=(0,y.newWriteableBufferStream)();return(0,D.readFileIntoStream)(s,c,i,a=>a,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new k.FileOperationError((0,S.localize)(10,null,this.resourceForError(c),(0,k.ensureFileSystemProviderError)(a).toString()),(0,k.toFileOperationResult)(a),r)},t),i}readFileUnbuffered(s,c,t){const r=(0,v.newWriteableStream)(i=>y.VSBuffer.concat(i));return(async()=>{try{let i=await s.readFile(c);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(c,i.byteLength,t),r.end(y.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(s,c){const t=await this.resolve(s,{resolveMetadata:!0});if(t.isDirectory)throw new k.FileOperationError((0,S.localize)(11,null,this.resourceForError(s)),0,c);if(c&&typeof c.etag=="string"&&c.etag!==k.ETAG_DISABLED&&c.etag===t.etag)throw new k.NotModifiedSinceFileOperationError((0,S.localize)(12,null),t,c);return this.validateReadFileLimits(s,t.size,c),t}validateReadFileLimits(s,c,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&c>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&c>t.limits.size&&(r=7),typeof r=="number")throw new k.FileOperationError((0,S.localize)(13,null,this.resourceForError(s)),r)}}async canMove(s,c,t){return this.doCanMoveCopy(s,c,"move",t)}async canCopy(s,c,t){return this.doCanMoveCopy(s,c,"copy",t)}async doCanMoveCopy(s,c,t,r){if(s.toString()!==c.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(i,s,a,c,t,r)}catch(i){return i}return!0}async move(s,c,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),a=await this.doMoveCopy(r,s,i,c,"move",!!t),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(s,a==="move"?2:3,l)),l}async copy(s,c,t){const r=await this.withReadProvider(s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),a=await this.doMoveCopy(r,s,i,c,"copy",!!t),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(s,a==="copy"?3:2,l)),l}async doMoveCopy(s,c,t,r,i,a){if(c.toString()===r.toString())return i;const{exists:l,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(s,c,t,r,i,a);if(l&&!o&&a&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(s===t&&(0,k.hasFileFolderCopyCapability)(s))await s.copy(c,r,{overwrite:a});else{const u=await this.resolve(c);u.isDirectory?await this.doCopyFolder(s,u,t,r):await this.doCopyFile(s,c,t,r)}return i}else return s===t?(await s.rename(c,r,{overwrite:a}),i):(await this.doMoveCopy(s,c,t,r,"copy",a),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(s,c,t,r){if((0,k.hasOpenReadWriteCloseCapability)(s)&&(0,k.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(s,c,t,r);if((0,k.hasOpenReadWriteCloseCapability)(s)&&(0,k.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(s,c,t,r);if((0,k.hasReadWriteCapability)(s)&&(0,k.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(s,c,t,r);if((0,k.hasReadWriteCapability)(s)&&(0,k.hasReadWriteCapability)(t))return this.doPipeUnbuffered(s,c,t,r)}async doCopyFolder(s,c,t,r){await t.mkdir(r),Array.isArray(c.children)&&await m.Promises.settled(c.children.map(async i=>{const a=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(s,await this.resolve(i.resource),t,a):this.doCopyFile(s,i.resource,t,a)}))}async doValidateMoveCopy(s,c,t,r,i,a){let l=!1;if(s===t){const{providerExtUri:u,isPathCaseSensitive:g}=this.getExtUri(s);if(g||(l=u.isEqual(c,r)),l&&i==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(c),this.resourceForError(r)));if(!l&&u.isEqualOrParent(r,c))throw new Error((0,S.localize)(15,null,this.resourceForError(c),this.resourceForError(r)))}const o=await this.exists(r);if(o&&!l){if(!a)throw new k.FileOperationError((0,S.localize)(16,null,this.resourceForError(c),this.resourceForError(r)),4);if(s===t){const{providerExtUri:u}=this.getExtUri(s);if(u.isEqualOrParent(c,r))throw new Error((0,S.localize)(17,null,this.resourceForError(c),this.resourceForError(r)))}}return{exists:o,isSameResourceWithDifferentPathCase:l}}getExtUri(s){const c=this.isPathCaseSensitive(s);return{providerExtUri:c?R.extUri:R.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(c,s);const t=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new k.FileOperationEvent(s,0,t)),t}async mkdirp(s,c){const t=[],{providerExtUri:r}=this.getExtUri(s);for(;!r.isEqual(c,r.dirname(c));)try{if(((await s.stat(c)).type&k.FileType.Directory)==0)throw new Error((0,S.localize)(18,null,this.resourceForError(c)));break}catch(i){if((0,k.toFileSystemProviderErrorCode)(i)!==k.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(c)),c=r.dirname(c)}for(let i=t.length-1;i>=0;i--){c=r.joinPath(c,t[i]);try{await s.mkdir(c)}catch(a){if((0,k.toFileSystemProviderErrorCode)(a)!==k.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(s,c){try{await this.doValidateDelete(s,c)}catch(t){return t}return!0}async doValidateDelete(s,c){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!c?.useTrash&&!(t.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(s)));let i;try{i=await t.stat(s)}catch(l){}if(i)this.throwIfFileIsReadonly(s,i);else throw new k.FileOperationError((0,S.localize)(20,null,this.resourceForError(s)),1);if(!!!c?.recursive){const l=await this.resolve(s);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(s)))}return t}async del(s,c){const t=await this.doValidateDelete(s,c),r=!!c?.useTrash,i=!!c?.recursive;await t.delete(s,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new k.FileOperationEvent(s,1))}onDidChangeFile(s,c){this._onDidChangeFilesRaw.fire({changes:s});let t,r;{for(const i of s)this.watchedResources.has(i.resource)?(t||(t=[]),t.push(i)):(r||(r=[]),r.push(i));t&&this._onDidFilesChange.fire(new k.FileChangesEvent(t,!c))}if(r){const i=c?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(r)&&ze.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(s,c={recursive:!1,excludes:[]}){const t=new P.DisposableStore;{let r=!1,i=()=>{r=!0};t.add((0,P.toDisposable)(()=>i())),this.doWatch(s,c).then(a=>{r?(0,P.dispose)(a):i=()=>(0,P.dispose)(a)},a=>this.logService.error(a))}return c.recursive||(this.watchedResources.set(s,(this.watchedResources.get(s)??0)+1),t.add((0,P.toDisposable)(()=>{const r=this.watchedResources.get(s);typeof r=="number"&&(r<=1?this.watchedResources.delete(s):this.watchedResources.set(s,r-1))}))),t}async doWatch(s,c){const t=await this.withProvider(s),r=this.toWatchKey(t,s,c),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(s,c)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,(0,P.toDisposable)(()=>{i.count--,i.count===0&&((0,P.dispose)(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(s,c,t){const{providerExtUri:r}=this.getExtUri(s);return[r.getComparisonKey(c),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(s=>(0,P.dispose)(s.disposable)),this.activeWatchers.clear()}async doWriteBuffered(s,c,t,r){return this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(async()=>{const i=await s.open(c,{create:!0,unlock:t?.unlock??!1});try{(0,v.isReadableStream)(r)||(0,v.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(s,i,r):await this.doWriteReadableBufferedQueued(s,i,r)}catch(a){throw(0,k.ensureFileSystemProviderError)(a)}finally{await s.close(i)}})}async doWriteStreamBufferedQueued(s,c,t){let r=0,i;if((0,v.isReadableBufferedStream)(t)){if(t.buffer.length>0){const a=y.VSBuffer.concat(t.buffer);await this.doWriteBuffer(s,c,a,a.byteLength,r,0),r+=a.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(a,l)=>{(0,v.listenStream)(i,{onData:async o=>{i.pause();try{await this.doWriteBuffer(s,c,o,o.byteLength,r,0)}catch(u){return l(u)}r+=o.byteLength,setTimeout(()=>i.resume())},onError:o=>l(o),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(s,c,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(s,c,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(s,c,t,r,i,a){let l=0;for(;l<r;)l+=await s.write(c,i+l,t.buffer,a+l,r-l)}async doWriteUnbuffered(s,c,t,r){return this.writeQueue.queueFor(c,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,c,t,r))}async doWriteUnbufferedQueued(s,c,t,r){let i;r instanceof y.VSBuffer?i=r:(0,v.isReadableStream)(r)?i=await(0,y.streamToBuffer)(r):(0,v.isReadableBufferedStream)(r)?i=await(0,y.bufferedStreamToBuffer)(r):i=(0,y.readableToBuffer)(r),await s.writeFile(c,i.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(s,c,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,c,t,r))}async doPipeBufferedQueued(s,c,t,r){let i,a;try{i=await s.open(c,{create:!1}),a=await t.open(r,{create:!0,unlock:!1});const l=y.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,u=0,g=0;do g=await s.read(i,o,l.buffer,u,l.byteLength-u),await this.doWriteBuffer(t,a,l,g,o,u),o+=g,u+=g,u===l.byteLength&&(u=0);while(g>0)}catch(l){throw(0,k.ensureFileSystemProviderError)(l)}finally{await m.Promises.settled([typeof i=="number"?s.close(i):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(s,c,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,c,t,r))}async doPipeUnbufferedQueued(s,c,t,r){return t.writeFile(r,await s.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,c,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,c,t,r))}async doPipeUnbufferedToBufferedQueued(s,c,t,r){const i=await t.open(r,{create:!0,unlock:!1});try{const a=await s.readFile(c);await this.doWriteBuffer(t,i,y.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,k.ensureFileSystemProviderError)(a)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(s,c,t,r){const i=await(0,y.streamToBuffer)(this.readFileBuffered(s,c,h.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,i)}throwIfFileSystemIsReadonly(s,c){if(s.capabilities&2048)throw new k.FileOperationError((0,S.localize)(22,null,this.resourceForError(c)),6);return s}throwIfFileIsReadonly(s,c){if((c.permissions??0)&k.FilePermission.Readonly)throw new k.FileOperationError((0,S.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===C.Schemas.file?s.fsPath:s.toString(!0)}};I.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},I=fe([K(0,n.ILogService)],I),e.FileService=I}),define(X[162],Q([0,1,2,13,3,7,18,8,15,41,6,14,120,75,138,140,137,149,48,78,23,25]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h,C,D,b,I,f,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends S.Disposable{constructor(i,a){super();this.logService=i,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=P.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new P.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,k.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:a,symbolicLink:l}=await A.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(a,l),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(i){try{const a=await A.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),l=[];return await Promise.all(a.map(async o=>{try{let u;o.isSymbolicLink()?u=(await this.stat((0,p.joinPath)(i,o.name))).type:u=this.toType(o),l.push([o.name,u])}catch(u){this.logService.trace(u)}})),l}catch(a){throw this.toFileSystemProviderError(a)}}toType(i,a){let l;return a?.dangling?l=L.FileType.Unknown:i.isFile()?l=L.FileType.File:i.isDirectory()?l=L.FileType.Directory:l=L.FileType.Unknown,a&&(l|=L.FileType.SymbolicLink),l}async readFile(i){try{const a=this.toFilePath(i);return await A.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(i,a,l){const o=(0,I.newWriteableStream)(u=>c.VSBuffer.concat(u.map(g=>c.VSBuffer.wrap(g))).buffer);return(0,f.readFileIntoStream)(this,i,o,u=>u.buffer,{...a,bufferSize:this.BUFFER_SIZE},l),o}async writeFile(i,a,l){let o;try{const u=this.toFilePath(i);if(!l.create||!l.overwrite){if(await A.Promises.exists(u)){if(!l.overwrite)throw(0,L.createFileSystemProviderError)((0,v.localize)(0,null),L.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,L.createFileSystemProviderError)((0,v.localize)(1,null),L.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:l.unlock}),await this.write(o,0,a,0,a.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(i,u)}finally{typeof o=="number"&&await this.close(o)}}async open(i,a){try{const l=this.toFilePath(i);if((0,L.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:g}=await A.SymlinkSupport.stat(l);g.mode&128||await A.Promises.chmod(l,g.mode|128)}catch(g){this.logService.trace(g)}let o;if((0,L.isFileOpenForWriteOptions)(a)){if(k.isWindows)try{await A.Promises.truncate(l,0),o="r+"}catch(g){g.code!=="ENOENT"&&this.logService.trace(g)}o||(o="w")}else o="r";const u=await A.Promises.open(l,o);return this.mapHandleToPos.set(u,0),(0,L.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(u,i),u}catch(l){throw(0,L.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(i,l):this.toFileSystemProviderError(l)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await A.Promises.fdatasync(i)}catch(a){this.canFlush=!1,this.logService.error(a)}return await A.Promises.close(i)}catch(a){throw this.toFileSystemProviderError(a)}}async read(i,a,l,o,u){const g=this.normalizePos(i,a);let w=null;try{const d=await A.Promises.read(i,l,o,u,g);return typeof d=="number"?w=d:w=d.bytesRead,w}catch(d){throw this.toFileSystemProviderError(d)}finally{this.updatePos(i,g,w)}}normalizePos(i,a){return a===this.mapHandleToPos.get(i)?null:a}updatePos(i,a,l){const o=this.mapHandleToPos.get(i);typeof o=="number"&&(typeof a=="number"||(typeof l=="number"?this.mapHandleToPos.set(i,o+l):this.mapHandleToPos.delete(i)))}async write(i,a,l,o,u){return(0,n.retry)(()=>this.doWrite(i,a,l,o,u),100,3)}async doWrite(i,a,l,o,u){const g=this.normalizePos(i,a);let w=null;try{const d=await A.Promises.write(i,l,o,u,g);return typeof d=="number"?w=d:w=d.bytesWritten,w}catch(d){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),d)}finally{this.updatePos(i,g,w)}}async mkdir(i){try{await A.Promises.mkdir(this.toFilePath(i))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(i,a){try{const l=this.toFilePath(i);await this.doDelete(l,a)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(i,a){a.recursive?await A.Promises.rm(i,A.RimRafMode.MOVE):await A.Promises.unlink(i)}async rename(i,a,l){const o=this.toFilePath(i),u=this.toFilePath(a);if(o!==u)try{await this.validateTargetDeleted(i,a,"move",l.overwrite),await A.Promises.move(o,u)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,v.localize)(2,null,(0,R.basename)(o),(0,R.basename)((0,R.dirname)(u)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(i,a,l){const o=this.toFilePath(i),u=this.toFilePath(a);if(o!==u)try{await this.validateTargetDeleted(i,a,"copy",l.overwrite),await A.Promises.copy(o,u,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,v.localize)(3,null,(0,R.basename)(o),(0,R.basename)((0,R.dirname)(u)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(i,a,l,o){const u=this.toFilePath(i),g=this.toFilePath(a);let w=!1;if(!!(this.capabilities&1024)||(w=(0,E.isEqual)(u,g,!0)),w&&l==="copy")throw(0,L.createFileSystemProviderError)((0,v.localize)(4,null),L.FileSystemProviderErrorCode.FileExists);if(!w&&await A.Promises.exists(g)){if(!o)throw(0,L.createFileSystemProviderError)((0,v.localize)(5,null),L.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(i,a){return a.recursive?this.watchRecursive(i,a.excludes):this.watchNonRecursive(i)}watchRecursive(i,a){const l={path:this.toFilePath(i),excludes:a},o=(0,s.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,S.toDisposable)(()=>{o(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,S.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,a;this.options?.watcher?.usePolling?(i=h.FileWatcher,a=this.options?.watcher):this.recursiveFoldersToWatch.length===1?k.isWindows?i=C.FileWatcher:i=h.FileWatcher:i=D.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,m.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===y.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)}))}}watchNonRecursive(i){const a=new b.FileWatcher(this.toFilePath(i),o=>this._onDidChangeFile.fire((0,m.toFileChanges)(o)),o=>{o.type==="error"&&this._onDidWatchErrorOccur.fire(o.message),this.logService[o.type](o.message)},this.logService.getLevel()===y.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)});return(0,S.combinedDisposable)(a,l)}toFilePath(i){return(0,R.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof L.FileSystemProviderError)return i;let a;switch(i.code){case"ENOENT":a=L.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=L.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=L.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=L.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=L.FileSystemProviderErrorCode.NoPermissions;break;default:a=L.FileSystemProviderErrorCode.Unknown}return(0,L.createFileSystemProviderError)(i,a)}async toFileSystemProviderWriteError(i,a){let l=this.toFileSystemProviderError(a);if(i&&l.code===L.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await A.SymlinkSupport.stat(this.toFilePath(i));o.mode&128||(l=(0,L.createFileSystemProviderError)(a,L.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return l}dispose(){super.dispose(),(0,S.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,S.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(X[28],Q([0,1,5]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService")}),define(X[163],Q([0,1,8,9,2,18,28,6,14]),function(G,e,S,L,P,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends P.Disposable{constructor(y,v,m){super();this.productService=v,this.logService=m,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,y&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(y)},30*1e3)).schedule()}async cleanUpCodeCaches(y){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const v=Date.now(),m=(0,S.dirname)(y),h=(0,S.basename)(y),C=await k.Promises.readdir(m);await Promise.all(C.map(async D=>{if(D===h)return;const b=(0,S.join)(m,D),I=await k.Promises.stat(b);if(I.isDirectory()&&v-I.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${D}.`),k.Promises.rm(b)}))}catch(v){(0,L.onUnexpectedError)(v)}}};E=fe([K(1,A.IProductService),K(2,p.ILogService)],E),e.CodeCacheCleaner=E}),define(X[164],Q([0,1,8,18,28,2,9,14,12,6]),function(G,e,S,L,P,k,A,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends k.Disposable{constructor(v,m,h){super();this.environmentService=v,this.logService=m,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new E.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const v=Object.create(null),m=JSON.parse(await L.Promises.readFile((0,S.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let I of Object.keys(m)){const f=m[I];v[`${f.hash}.${I}`]=!0}const h=(0,S.join)(this.environmentService.userDataPath,"clp");if(!await L.Promises.exists(h))return;const D=await L.Promises.readdir(h);for(const I of D){if(v[I]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${I}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${I}`),await L.Promises.rm((0,S.join)(h,I))}const b=Date.now();for(const I of Object.keys(v)){const f=(0,S.join)(h,I),s=await L.Promises.readdir(f);for(const c of s){if(c==="tcf.json")continue;const t=(0,S.join)(f,c),r=await L.Promises.stat(t);r.isDirectory()&&b-r.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,S.join)(I,c)}`),await L.Promises.rm(t))}}}catch(v){(0,A.onUnexpectedError)(v)}}};n=fe([K(0,p.INativeEnvironmentService),K(1,R.ILogService),K(2,P.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(X[32],Q([0,1,16,87]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.data=new Map}add(A,R){L.ok(S.isString(A)),L.ok(S.isObject(R)),L.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,R)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new P}),define(X[79],Q([0,1,32,3]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class k{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,E){this.schemasById[P(p)]=E,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new k;S.Registry.add(e.Extensions.JSONContribution,A)}),define(X[37],Q([0,1,109,3,32,16,79]),function(G,e,S,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var R;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(R=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var p;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const E=P.Registry.as(A.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(I,f=!0){this.registerConfigurations([I],f)}registerConfigurations(I,f=!0){const s=[];I.forEach(c=>{s.push(...this.validateAndRegisterProperties(c,f,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(I){const f=[],s=c=>{if(c.properties)for(const t in c.properties)f.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,c.properties[t]);c.allOf&&c.allOf.forEach(t=>s(t))};for(const c of I){s(c);const t=this.configurationContributors.indexOf(c);t!==-1&&this.configurationContributors.splice(t,1)}E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}registerDefaultConfigurations(I){const f=[],s=[];for(const c of I)for(const t in c)if(f.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...c[t]};const r={type:"object",default:this.defaultValues[t],description:S.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};s.push(v(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=c[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterDefaultConfigurations(I){const f=[];for(const s of I)for(const c in s)if(f.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const t=this.configurationProperties[c];t&&(this.updatePropertyDefaultValue(c,t),this.updateSchema(c,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}notifyConfigurationSchemaUpdated(...I){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(I){for(const f of I)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(I,f=!0,s,c=3){c=k.isUndefinedOrNull(I.scope)?c:I.scope;let t=[],r=I.properties;if(r)for(let a in r){if(f&&C(a)){delete r[a];continue}const l=r[a];if(this.updatePropertyDefaultValue(a,l),e.OVERRIDE_PROPERTY_PATTERN.test(a)?l.scope=void 0:(l.scope=k.isUndefinedOrNull(l.scope)?c:l.scope,l.restricted=k.isUndefinedOrNull(l.restricted)?!!s?.restrictedConfigurations?.includes(a):l.restricted),r[a].hasOwnProperty("included")&&!r[a].included){this.excludedConfigurationProperties[a]=r[a],delete r[a];continue}else this.configurationProperties[a]=r[a];!r[a].deprecationMessage&&r[a].markdownDeprecationMessage&&(r[a].deprecationMessage=r[a].markdownDeprecationMessage),t.push(a)}let i=I.allOf;if(i)for(let a of i)t.push(...this.validateAndRegisterProperties(a,f,s,c));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(I){const f=s=>{let c=s.properties;if(c)for(const r in c)this.updateSchema(r,c[r]);let t=s.allOf;t&&t.forEach(f)};f(I)}updateSchema(I,f){switch(e.allSettings.properties[I]=f,f.scope){case 1:e.applicationSettings.properties[I]=f;break;case 2:e.machineSettings.properties[I]=f;break;case 6:e.machineOverridableSettings.properties[I]=f;break;case 3:e.windowSettings.properties[I]=f;break;case 4:e.resourceSettings.properties[I]=f;break;case 5:e.resourceSettings.properties[I]=f,this.resourceLanguageSettingsSchema.properties[I]=f;break}}removeFromSchema(I,f){switch(delete e.allSettings.properties[I],f.scope){case 1:delete e.applicationSettings.properties[I];break;case 2:delete e.machineSettings.properties[I];break;case 6:delete e.machineOverridableSettings.properties[I];break;case 3:delete e.windowSettings.properties[I];break;case 4:case 5:delete e.resourceSettings.properties[I];break}}updateOverridePropertyPatternKey(){for(const I of this.overrideIdentifiers.values()){const f=`[${I}]`,s={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,s),e.allSettings.properties[f]=s,e.applicationSettings.properties[f]=s,e.machineSettings.properties[f]=s,e.machineOverridableSettings.properties[f]=s,e.windowSettings.properties[f]=s,e.resourceSettings.properties[f]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(I,f){let s=this.defaultValues[I];k.isUndefined(s)&&(s=f.default),k.isUndefined(s)&&(s=m(f.type)),f.default=s}}const y="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(y);function v(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=v;function m(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const h=new n;P.Registry.add(e.Extensions.Configuration,h);function C(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?S.localize(5,null,b):h.getConfigurationProperties()[b]!==void 0?S.localize(6,null,b):null:S.localize(4,null)}e.validateProperty=C;function D(){const b=[],I=h.getConfigurationProperties();for(const f of Object.keys(I))b.push([f,I[f].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=D}),define(X[24],Q([0,1,26,16,4,32,5,37]),function(G,e,S,L,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function p(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof P.URI)}e.isConfigurationOverrides=p;var E;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function y(r,i){const a=i?r?i.keys.filter(T=>r.keys.indexOf(T)===-1):[...i.keys]:[],l=r?i?r.keys.filter(T=>i.keys.indexOf(T)===-1):[...r.keys]:[],o=[];if(i&&r){for(const T of r.keys)if(i.keys.indexOf(T)!==-1){const O=b(r.contents,T),$=b(i.contents,T);S.equals(O,$)||o.push(T)}}const u=[],g=T=>{const O={};for(const $ of T)for(const z of $.identifiers)O[c(z)]=$;return O},w=i?g(i.overrides):{},d=r?g(r.overrides):{};if(Object.keys(w).length)for(const T of a){const O=w[T];O&&u.push([(0,R.overrideIdentifierFromKey)(T),O.keys])}if(Object.keys(d).length)for(const T of l){const O=d[T];O&&u.push([(0,R.overrideIdentifierFromKey)(T),O.keys])}if(Object.keys(w).length&&Object.keys(d).length)for(const T of o){const O=d[T],$=w[T];if(O&&$){const z=y({contents:O.contents,keys:O.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});u.push([(0,R.overrideIdentifierFromKey)(T),[...z.added,...z.removed,...z.updated]])}}return{added:a,removed:l,updated:o,overrides:u}}e.compare=y;function v(r,i){const a=[];for(const l of Object.keys(r))if(R.OVERRIDE_PROPERTY_PATTERN.test(l)){const o={};for(const u in r[l])o[u]=r[l][u];a.push({identifiers:[(0,R.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(o),contents:m(o,i)})}return a}e.toOverrides=v;function m(r,i){const a=Object.create(null);for(let l in r)h(a,l,r[l],i);return a}e.toValuesTree=m;function h(r,i,a,l){const o=i.split("."),u=o.pop();let g=r;for(let w=0;w<o.length;w++){let d=o[w],T=g[d];switch(typeof T){case"undefined":T=g[d]=Object.create(null);break;case"object":break;default:l(`Ignoring ${i} as ${o.slice(0,w+1).join(".")} is ${JSON.stringify(T)}`);return}g=T}if(typeof g=="object"&&g!==null)try{g[u]=a}catch(w){l(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(g)}`)}else l(`Ignoring ${i} as ${o.join(".")} is ${JSON.stringify(g)}`)}e.addToValueTree=h;function C(r,i){const a=i.split(".");D(r,a)}e.removeFromValueTree=C;function D(r,i){const a=i.shift();if(i.length===0){delete r[a];return}if(Object.keys(r).indexOf(a)!==-1){const l=r[a];typeof l=="object"&&!Array.isArray(l)&&(D(l,i),Object.keys(l).length===0&&delete r[a])}}function b(r,i,a){function l(g,w){let d=g;for(const T of w){if(typeof d!="object"||d===null)return;d=d[T]}return d}const o=i.split("."),u=l(r,o);return typeof u=="undefined"?a:u}e.getConfigurationValue=b;function I(r,i,a){Object.keys(i).forEach(l=>{l!=="__proto__"&&(l in r?L.isObject(r[l])&&L.isObject(i[l])?I(r[l],i[l],a):a&&(r[l]=i[l]):r[l]=i[l])})}e.merge=I;function f(){const r=k.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=f;function s(){const r=Object.create(null),i=k.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let a in i){let l=i[a].default;h(r,a,l,o=>console.error(`Conflict in default settings: ${o}`))}return r}e.getDefaultValues=s;function c(r){return`[${r}]`}e.keyFromOverrideIdentifier=c;function t(r,i,a){const l=r.inspect(i),o=r.inspect(a);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:l.defaultValue}e.getMigratedSettingValue=t}),define(X[165],Q([0,1,33,38,23,16,26,4,37,24,32,2,3]),function(G,e,S,L,P,k,A,R,p,E,n,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,E.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?(0,E.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const a of P.distinct([...Object.keys(this.contents),...Object.keys(r)])){let l=this.contents[a],o=r[a];o&&(typeof l=="object"&&typeof o=="object"?(l=A.deepClone(l),this.mergeContents(l,o)):l=o),i[a]=l}return new m(i,this.keys,this.overrides)}merge(...t){const r=A.deepClone(this.contents),i=A.deepClone(this.overrides),a=[...this.keys];for(const l of t){this.mergeContents(r,l.contents);for(const o of l.overrides){const[u]=i.filter(g=>P.equals(g.identifiers,o.identifiers));u?this.mergeContents(u.contents,o.contents):i.push(A.deepClone(o))}for(const o of l.keys)a.indexOf(o)===-1&&a.push(o)}return new m(r,a,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&k.isObject(t[i])&&k.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=A.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,E.addToValueTree)(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,E.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=m;class h extends m{constructor(){const t=(0,E.getDefaultValues)(),r=(0,E.getConfigurationKeys)(),i=[];for(const a of Object.keys(t))p.OVERRIDE_PROPERTY_PATTERN.test(a)&&i.push({identifiers:[(0,p.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(t[a]),contents:(0,E.toValuesTree)(t[a],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,r,i)}}e.DefaultConfigurationModel=h;class C{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!k.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:a,overrides:l,restricted:o}=this.doParseRaw(t,r);this._configurationModel=new m(i,a,l),this._restrictedConfigurations=o||[]}doParseContent(t){let r={},i=null,a=[],l=[],o=[];function u(w){Array.isArray(a)?a.push(w):i&&(a[i]=w)}let g={onObjectBegin:()=>{let w={};u(w),l.push(a),a=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{let w=[];u(w),l.push(a),a=w,i=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:u,onError:(w,d,T)=>{o.push({error:w,offset:d,length:T})}};if(t)try{S.visit(t,g),r=a[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return r}doParseRaw(t,r){const i=n.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,i,!0,r);t=a.raw;const l=(0,E.toValuesTree)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`)),o=Object.keys(t),u=(0,E.toOverrides)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`));return{contents:l,keys:o,overrides:u,restricted:a.restricted}}filter(t,r,i,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:t,restricted:[]};const l={},o=[];for(let u in t)if(p.OVERRIDE_PROPERTY_PATTERN.test(u)&&i){const g=this.filter(t[u],r,!1,a);l[u]=g.raw,o.push(...g.restricted)}else{const g=r[u],w=g?typeof g.scope!="undefined"?g.scope:3:void 0;g?.restricted&&o.push(u),(w===void 0||a.scopes===void 0||a.scopes.includes(w))&&(a.skipRestricted&&g?.restricted||(l[u]=t[u]))}return{raw:l,restricted:o}}}e.ConfigurationModelParser=C;class D extends y.Disposable{constructor(t,r,i,a){super();this.userSettingsResource=t,this.scopes=r,this.fileService=a,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new C(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(v.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class b{constructor(t,r,i=new m,a=new m,l=new L.ResourceMap,o=new m,u=new L.ResourceMap,g=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=a,this._folderConfigurations=l,this._memoryConfiguration=o,this._memoryConfigurationByResource=u,this._freeze=g,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let a;i.resource?(a=this._memoryConfigurationByResource.get(i.resource),a||(a=new m,this._memoryConfigurationByResource.set(i.resource,a))):a=this._memoryConfiguration,r===void 0?a.removeValue(t):a.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const a=this.getConsolidateConfigurationModel(r,i),l=this.getFolderConfigurationModelForResource(r.resource,i),o=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,u=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),g=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),w=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),d=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=l?r.overrideIdentifier?l.freeze().override(r.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,$=r.overrideIdentifier?o.override(r.overrideIdentifier).getValue(t):o.getValue(t),z=a.getValue(t),V=P.distinct(P.flatten(a.overrides.map(B=>B.identifiers))).filter(B=>a.getOverrideValue(t,B)!==void 0);return{defaultValue:u,userValue:g,userLocalValue:w,userRemoteValue:d,workspaceValue:T,workspaceFolderValue:O,memoryValue:$,value:z,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:g!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:w!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:d!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:l?.freeze().getValue(t),override:r.overrideIdentifier?l?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:o.getValue(t),override:r.overrideIdentifier?o.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(a=>p.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const l=(0,p.overrideIdentifierFromKey)(a),o=this._defaultConfiguration.getKeysForOverrideIdentifier(l),u=t.getKeysForOverrideIdentifier(l),g=[...u.filter(w=>o.indexOf(w)===-1),...o.filter(w=>u.indexOf(w)===-1),...o.filter(w=>!A.equals(this._defaultConfiguration.override(l).getValue(w),t.override(l).getValue(w)))];return[l,g]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:a,overrides:l}=(0,E.compare)(this.localUserConfiguration,t),o=[...r,...i,...a];return o.length&&this.updateLocalUserConfiguration(t),{keys:o,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:a,overrides:l}=(0,E.compare)(this.remoteUserConfiguration,t);let o=[...r,...i,...a];return o.length&&this.updateRemoteUserConfiguration(t),{keys:o,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:a,overrides:l}=(0,E.compare)(this.workspaceConfiguration,t);let o=[...r,...i,...a];return o.length&&this.updateWorkspaceConfiguration(t),{keys:o,overrides:l}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:a,updated:l,removed:o,overrides:u}=(0,E.compare)(i,r);let g=[...a,...l,...o];return(g.length||!i)&&this.updateFolderConfiguration(t,r),{keys:g,overrides:u}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:a,removed:l,overrides:o}=(0,E.compare)(r,void 0);return{keys:[...i,...a,...l],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const a=r.getFolder(t);a&&(i=this.getFolderConsolidatedConfiguration(a.uri)||i);const l=this._memoryConfigurationByResource.get(t);l&&(i=i.merge(l))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(r=i.merge(a),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:a,keys:l}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:a,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(a=>r.add(a))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((o,u)=>(o.set(R.URI.revive(u[0]),this.parseConfigurationModel(u[1])),o),new L.ResourceMap);return new b(r,i,new m,a,l,new m,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function I(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,r=new Map;for(const a of c)a.keys.forEach(l=>t.add(l)),a.overrides.forEach(([l,o])=>{const u=(0,L.getOrSet)(r,l,new Set);o.forEach(g=>u.add(g))});const i=[];return r.forEach((a,l)=>i.push([l,[...a.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=I;class f{constructor(t,r,i,a){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=a,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(u=>l.add(u)),t.overrides.forEach(([,u])=>u.forEach(g=>l.add(g))),this.affectedKeys=[...l.values()];const o=new m;this.affectedKeys.forEach(u=>o.setValue(u,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!A.equals(i,a)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=(0,E.toValuesTree)({[r]:!0},()=>{}),a;for(;typeof i=="object"&&(a=Object.keys(i)[0]);){if(t=t[a],!t)return!1;i=i[a]}return!0}}e.ConfigurationChangeEvent=f;class s extends f{constructor(t,r,i,a){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=s}),define(X[166],Q([0,1,32,37,2,24,165,3,6,15]),function(G,e,S,L,P,k,A,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends P.Disposable{constructor(v,m){super();this.settingsResource=v,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new A.UserSettings(this.settingsResource,void 0,E.extUriBiasedIgnorePathCase,m)),this.configuration=new A.Configuration(new A.DefaultConfigurationModel,new A.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(S.Registry.as(L.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const v=await this.userConfiguration.loadConfiguration();this.configuration=new A.Configuration(new A.DefaultConfigurationModel,v)}getConfigurationData(){return this.configuration.toData()}getValue(v,m){const h=typeof v=="string"?v:void 0,C=(0,k.isConfigurationOverrides)(v)?v:(0,k.isConfigurationOverrides)(m)?m:{};return this.configuration.getValue(h,C,void 0)}updateValue(v,m,h,C){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const m=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(h,m,1)}onDidDefaultConfigurationChange(v){const m=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new A.DefaultConfigurationModel,v);this.trigger(h,m,6)}trigger(v,m,h){const C=new A.ConfigurationChangeEvent(v,{data:m},this.configuration);C.source=h,C.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(C)}getTargetConfiguration(v){switch(v){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(X[167],Q([0,1,24,14,103]),function(G,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(R,p){this.configurationService=R,this.logService=p}request(R,p){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,P.request)(R,p)}async resolveProxy(R){}};k=fe([K(0,S.IConfigurationService),K(1,L.ILogService)],k),e.RequestService=k}),define(X[39],Q([0,1,121,5,37,32,25]),function(G,e,S,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function R(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=R;function p(h){return h.res.statusCode===204}async function E(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);return p(h)?null:(await(0,A.streamToBuffer)(h.stream)).toString()}e.asText=E;async function n(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);if(p(h))return null;const D=(await(0,A.streamToBuffer)(h.stream)).toString();try{return JSON.parse(D)}catch(b){throw b.message+=`:
`+D,b}}e.asJson=n;function y(h){m(h)}e.updateProxyConfigurationsScope=y;let v;function m(h){const C=k.Registry.as(P.Extensions.Configuration);v&&C.deregisterConfigurations([v]),v={id:"http",order:15,title:(0,S.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,S.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,S.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,S.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,S.localize)(4,null),(0,S.localize)(5,null),(0,S.localize)(6,null),(0,S.localize)(7,null)],default:"override",description:(0,S.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,S.localize)(9,null),restricted:!0}}},C.registerConfiguration(v)}m(2)}),define(X[168],Q([0,1,39,29,13,17]),function(G,e,S,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(p,E){this.requestService=p,this.fileService=E}async download(p,E,n=L.CancellationToken.None){if(p.scheme===k.Schemas.file||p.scheme===k.Schemas.vscodeRemote){await this.fileService.copy(p,E);return}const y={type:"GET",url:p.toString()},v=await this.requestService.request(y,n);if(v.res.statusCode===200)await this.fileService.writeFile(E,v.stream);else{const m=await(0,S.asText)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${m}`)}}};A=fe([K(0,S.IRequestService),K(1,P.IFileService)],A),e.DownloadService=A}),define(X[169],Q([0,1,28,13,23,63,39,29,14,15,133,2]),function(G,e,S,L,P,k,A,R,p,E,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let v=class extends y.Disposable{constructor(h,C,D,b){super();this.fileService=h,this.productService=C,this.requestService=D,this.logService=b,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,k.forEach)(this.productService.configBasedExtensionTips,({value:I})=>this.allConfigBasedTips.set(I.configPath,I))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const C=[];for(const[D,b]of this.allConfigBasedTips)try{const I=await this.fileService.readFile((0,E.joinPath)(h,D)),f=new Map;(0,k.forEach)(b.recommendations,({key:c,value:t})=>{if((0,P.isNonEmptyArray)(t.remotes))for(const r of t.remotes)f.set(r,{extensionId:c,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else C.push({extensionId:c,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const s=(0,n.getDomainsOfRemotes)(I.value.toString(),[...f.keys()]);for(const c of s){const t=f.get(c);t&&C.push(t)}}catch(I){}return C}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},R.CancellationToken.None);if(h.res.statusCode!==200)return[];const C=await(0,A.asJson)(h);return C?C.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};v=fe([K(0,L.IFileService),K(1,S.IProductService),K(2,A.IRequestService),K(3,p.ILogService)],v),e.ExtensionTipsService=v}),define(X[45],Q([0,1,30,25]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function P(k,A,R){let p=R&&R.get("storage.serviceMachineId",0)||null;if(p)return p;try{const n=(await A.readFile(k.serviceMachineIdResource)).value.toString();p=(0,S.isUUID)(n)?n:null}catch(E){p=null}if(!p){p=(0,S.generateUuid)();try{await A.writeFile(k.serviceMachineIdResource,L.VSBuffer.fromString(p))}catch(E){}}return R&&R.store("storage.serviceMachineId",p,0,1),p}e.getServiceMachineId=P}),define(X[20],Q([0,1,5,3,2,16,69,6]),function(G,e,S,L,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const p="__$__targetStorageMarker";e.IStorageService=(0,S.createDecorator)("storageService");var E;(function(C){C[C.NONE=0]="NONE",C[C.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(C){C[C.GLOBAL=0]="GLOBAL",C[C.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var y;(function(C){C[C.USER=0]="USER",C[C.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));class v extends P.Disposable{constructor(D={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super();this.options=D,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,b){b===p?(D===0?this._globalKeyTargets=void 0:D===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:D})):this._onDidChangeValue.fire({scope:D,key:b,target:this.getKeyTargets(D)[b]})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,b,I){return this.getStorage(b)?.get(D,I)}getBoolean(D,b,I){return this.getStorage(b)?.getBoolean(D,I)}getNumber(D,b,I){return this.getStorage(b)?.getNumber(D,I)}store(D,b,I,f){if((0,k.isUndefinedOrNull)(b)){this.remove(D,I);return}this.withPausedEmitters(()=>{this.updateKeyTarget(D,I,f),this.getStorage(I)?.set(D,b)})}remove(D,b){this.withPausedEmitters(()=>{this.updateKeyTarget(D,b,void 0),this.getStorage(b)?.delete(D)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,b){const I=[],f=this.getKeyTargets(D);for(const s of Object.keys(f))f[s]===b&&I.push(s);return I}updateKeyTarget(D,b,I){const f=this.getKeyTargets(b);typeof I=="number"?f[D]!==I&&(f[D]=I,this.getStorage(b)?.set(p,JSON.stringify(f))):typeof f[D]=="number"&&(delete f[D],this.getStorage(b)?.set(p,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(D){return D===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(D){const b=this.get(p,D);if(b)try{return JSON.parse(b)}catch(I){}return Object.create(null)}isNew(D){return this.getBoolean(e.IS_NEW_KEY,D)===!0}async flush(){this._onWillSaveState.fire({reason:E.NONE}),await R.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const D=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return h(D,b,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=v,v.DEFAULT_FLUSH_INTERVAL=60*1e3;class m extends v{constructor(){super();this.globalStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(1,D))),this._register(this.globalStorage.onDidChangeStorage(D=>this.emitDidChangeValue(0,D)))}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(D){}}e.InMemoryStorageService=m;async function h(C,D,b,I){const f=l=>{try{return JSON.parse(l)}catch(o){return l}},s=new Map,c=new Map;C.forEach((l,o)=>{s.set(o,l),c.set(o,f(l))});const t=new Map,r=new Map;D.forEach((l,o)=>{t.set(o,l),r.set(o,f(l))}),console.group(`Storage: Global (path: ${b})`);let i=[];s.forEach((l,o)=>{i.push({key:o,value:l})}),console.table(i),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${I})`);let a=[];t.forEach((l,o)=>{a.push({key:o,value:l})}),console.table(a),console.groupEnd(),console.log(r)}e.logStorage=h}),define(X[170],Q([0,1,3,2,27,31,20,16]),function(G,e,S,L,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let p=class extends L.Disposable{constructor(y){super();this._onDidChangeEnablement=new S.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(y)),this._register(this.storageManger.onDidChange(v=>this._onDidChangeEnablement.fire({extensions:v,source:"storage"})))}async enableExtension(y,v){return this._removeFromDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:v}),!0):!1}async disableExtension(y,v){return this._addToDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:v}),!0):!1}getDisabledExtensions(){return this._getExtensions(P.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(y){let v=this.getDisabledExtensions();return v.every(m=>!(0,k.areSameExtensions)(m,y))?(v.push(y),this._setDisabledExtensions(v),!0):!1}_removeFromDisabledExtensions(y){let v=this.getDisabledExtensions();for(let m=0;m<v.length;m++){const h=v[m];if((0,k.areSameExtensions)(h,y))return v.splice(m,1),this._setDisabledExtensions(v),!0}return!1}_setDisabledExtensions(y){this._setExtensions(P.DISABLED_EXTENSIONS_STORAGE_PATH,y)}_getExtensions(y){return this.storageManger.get(y,0)}_setExtensions(y,v){this.storageManger.set(y,v,0)}};p=fe([K(0,A.IStorageService)],p),e.GlobalExtensionEnablementService=p;class E extends L.Disposable{constructor(y){super();this.storageService=y,this.storage=Object.create(null),this._onDidChange=this._register(new S.Emitter),this.onDidChange=this._onDidChange.event,this._register(y.onDidChangeValue(v=>this.onDidStorageChange(v)))}get(y,v){let m;return v===0?((0,R.isUndefinedOrNull)(this.storage[y])&&(this.storage[y]=this._get(y,v)),m=this.storage[y]):m=this._get(y,v),JSON.parse(m)}set(y,v,m){let h=JSON.stringify(v.map(({id:D,uuid:b})=>({id:D,uuid:b})));this._get(y,m)!==h&&(m===0&&(v.length?this.storage[y]=h:delete this.storage[y]),this._set(y,v.length?h:void 0,m))}onDidStorageChange(y){if(y.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[y.key])&&this._get(y.key,y.scope)!==this.storage[y.key]){const m=this.get(y.key,y.scope);delete this.storage[y.key];const h=this.get(y.key,y.scope),C=m.filter(b=>!h.some(I=>(0,k.areSameExtensions)(b,I))),D=h.filter(b=>!m.some(I=>(0,k.areSameExtensions)(I,b)));(C.length||D.length)&&this._onDidChange.fire([...C,...D])}}_get(y,v){return this.storageService.get(y,v,"[]")}_set(y,v,m){v?this.storageService.store(y,v,m,1):this.storageService.remove(y,m)}}e.StorageManager=E}),define(X[171],Q([0,1,3,2]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class P extends L.Disposable{constructor(E,n){super();this.channel=E,this.workspace=n}async getItems(){const E={workspace:this.workspace},n=await this.channel.call("getItems",E);return new Map(n)}updateItems(E){const n={workspace:this.workspace};return E.insert&&(n.insert=Array.from(E.insert.entries())),E.delete&&(n.delete=Array.from(E.delete.values())),this.channel.call("updateItems",n)}}class k extends P{constructor(E){super(E,void 0);this._onDidChangeItemsExternal=this._register(new S.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(E=>this.onDidChangeGlobalStorage(E)))}onDidChangeGlobalStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}async close(){this.dispose()}}class A extends P{constructor(E,n){super(E,n);this.onDidChangeItemsExternal=S.Event.None}async close(){const E={workspace:this.workspace};return this.channel.call("close",E)}}class R extends L.Disposable{constructor(E,n){super();this.channel=E,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new k(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(X[172],Q([0,1,2,20,69,6,161,171,15]),function(G,e,S,L,P,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends L.AbstractStorageService{constructor(y,v,m){super();this.mainProcessService=v,this.environmentService=m,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new S.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(y)}createGlobalStorage(){const y=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),v=new P.Storage(y.globalStorage);return this._register(v.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),v}createWorkspaceStorage(y){const v=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),y);if(v.workspaceStorage){const m=new P.Storage(v.workspaceStorage);return this.workspaceStorageDisposable.value=m.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)),this.workspaceStorageId=y?.id,m}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,A.mark)("code/willInitStorage");try{await k.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,A.mark)("code/didInitStorage")}}getStorage(y){return y===0?this.globalStorage:this.workspaceStorage}getLogDetails(y){return y===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,p.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(L.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(y){const v=this.workspaceStorage,m=v?.items??new Map;v&&(await v.close(),v.dispose()),this.workspaceStorage=this.createWorkspaceStorage(y),await this.workspaceStorage.init();for(const[h,C]of m)this.workspaceStorage.set(h,C)}}e.NativeStorageService=E}),define(X[173],Q([0,1,7,34,30,4]),function(G,e,S,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(E){if(S.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function R(E,n,y,v,m,h,C,D,b,I){const f=Object.create(null);f["common.machineId"]=C,f.sessionID=(0,P.generateUuid)()+Date.now(),f.commitHash=m,f.version=h,f["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,S.PlatformToString)(S.platform),f["common.nodePlatform"]=L.platform,f["common.nodeArch"]=v,f["common.product"]=I||"desktop";const s=p(D||[]);s&&(f["common.msftInternal"]=s);let c=0;const t=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),S.isLinuxSnap&&(f["common.snap"]="true");const r=A(y);r&&(f["common.platformDetail"]=r);try{const i=await E.readFile(k.URI.file(b));f["common.source"]=i.value.toString().slice(0,30)}catch(i){}return f}e.resolveCommonProperties=R;function p(E){const n=L.env.USERDNSDOMAIN;if(!n)return!1;const y=n.toLowerCase();return E.some(v=>y===v)}e.verifyMicrosoftInternalDomain=p}),define(X[21],Q([0,1,5]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(X[174],Q([0,1,35,95,71,8,33,98,28,7,4,21,53,17,13,18]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function D(c,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,a=new Map,l=2e4;function o(w,d,T,O){const $=d.substring(w.length+1);return new Promise(async z=>{let V;try{V=await C.Promises.readdir(d,{withFileTypes:!0})}catch(_){z();return}if(O.count>=l){O.count+=V.length,O.maxReached=!0,z();return}let B=V.length;if(B===0){z();return}let M=V;O.count+V.length>l&&(O.maxReached=!0,B=l-O.count,M=V.slice(0,B)),O.count+=V.length;for(const _ of M)if(_.isDirectory()){if(T.includes(_.name)||await o(w,(0,k.join)(d,_.name),T,O),--B==0){z();return}}else{const N=_.name.lastIndexOf(".");if(N>=0){const j=_.name.substring(N+1);j&&i.set(j,(i.get(j)??0)+1)}for(const j of r)j.relativePathPattern?.test($)!==!1&&j.filePattern.test(_.name)&&a.set(j.tag,(a.get(j.tag)??0)+1);if(--B==0){z();return}}})}const u={count:0,maxReached:!1};await o(c,c,t,u);const g=await f(c);return{configFiles:b(a),fileTypes:b(i),fileCount:u.count,maxFilesReached:u.maxReached,launchConfigFiles:g}}e.collectWorkspaceStats=D;function b(c){return[...v.Iterable.map(c.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function I(){const c={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(L.virtualMachineHint.value()*100)}%`},t=S.cpus();return t&&t.length>0&&(c.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),c}e.getMachineInfo=I;async function f(c){try{const t=new Map,r=(0,k.join)(c,".vscode","launch.json"),i=await C.Promises.readFile(r),a=[],l=(0,A.parse)(i.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if((0,A.getNodeType)(l)==="object"&&l.configurations)for(const o of l.configurations){const u=o.type;u&&(t.has(u)?t.set(u,t.get(u)+1):t.set(u,1))}return b(t)}catch(t){return[]}}e.collectLaunchConfigs=f;let s=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const i=S.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(S.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),E.isWindows||r.push(`Load (avg):       ${S.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(L.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([(0,R.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async i=>{let[a,l]=i,o=this.formatProcessList(t,a);return r.forEach(u=>{if((0,P.isRemoteDiagnosticError)(u))o+=`
${u.errorMessage}`,l+=`
${u.errorMessage}`;else if(o+=`

Remote: ${u.hostName}`,u.processes&&(o+=`
${this.formatProcessList(t,u.processes)}`),u.workspaceMetadata){l+=`
|  Remote: ${u.hostName}`;for(const g of Object.keys(u.workspaceMetadata)){const w=u.workspaceMetadata[g];let d=`${w.fileCount} files`;w.maxFilesReached&&(d=`more than ${d}`),l+=`|    Folder (${g}): ${d}`,l+=this.formatWorkspaceStats(w)}}}),{processInfo:o,workspaceInfo:l}})}async getSystemInfo(t,r){const{memory:i,vmHint:a,os:l,cpus:o}=I(),u={os:l,memory:i,cpus:o,vmHint:a,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return E.isWindows||(u.load=`${S.loadavg().map(g=>Math.round(g)).join(", ")}`),E.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(t,r){const i=[];return(0,R.listProcesses)(t.mainPID).then(async a=>(i.push(""),i.push(this.formatEnvironment(t)),i.push(""),i.push(this.formatProcessList(t,a)),t.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(t))),r.forEach(l=>{if((0,P.isRemoteDiagnosticError)(l))i.push(`
${l.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${l.hostName}`),i.push(this.formatMachineInfo(l.machineInfo)),l.processes&&i.push(this.formatProcessList(t,l.processes)),l.workspaceMetadata)for(const o of Object.keys(l.workspaceMetadata)){const u=l.workspaceMetadata[o];let g=`${u.fileCount} files`;u.maxFilesReached&&(g=`more than ${g}`),i.push(`Folder (${o}): ${g}`),i.push(this.formatWorkspaceStats(u))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(t){const r=[],i=60;let a=0;const l=(w,d)=>{const T=` ${w}(${d})`;a+T.length>i?(r.push(o),o="|                 ",a=o.length):a+=T.length,o+=T};let o="|      File types:";const u=10;let g=t.fileTypes.length>u?u:t.fileTypes.length;for(let w=0;w<g;w++){const d=t.fileTypes[w];l(d.name,d.count)}if(r.push(o),t.configFiles.length>=0&&(o="|      Conf files:",a=0,t.configFiles.forEach(w=>{l(w.name,w.count)}),r.push(o)),t.launchConfigFiles.length>0){let w="|      Launch Configs:";t.launchConfigFiles.forEach(d=>{w+=d.count>1?` ${d.name}(${d.count})`:` ${d.name}`}),r.push(w)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(i=>i.length));return Object.keys(t).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${t[i]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],i=[];return t.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(l=>{const o=n.URI.revive(l);if(o.scheme===m.Schemas.file){const u=o.fsPath;i.push(D(u,["node_modules",".git"]).then(g=>{let w=`${g.fileCount} files`;g.maxFilesReached&&(w=`more than ${w}`),r.push(`|    Folder (${(0,k.basename)(u)}): ${w}`),r.push(this.formatWorkspaceStats(g))}).catch(g=>{r.push(`|      Error: Unable to collect workspace stats for folder ${u} (${g.toString()})`)}))}else r.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(t,r){const i=new Map;t.windows.forEach(l=>i.set(l.pid,l.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,i,a,r,0),a.join(`
`)}formatProcessItem(t,r,i,a,l){const o=l===0;let u;o?u=a.pid===t?`${this.productService.applicationName} main`:"remote agent":(u=`${"  ".repeat(l)} ${a.name}`,a.name==="window"&&(u=`${u} (${r.get(a.pid)})`));const g=process.platform==="win32"?a.mem:S.totalmem()*(a.mem/100);i.push(`${a.load.toFixed(0).padStart(5," ")}	${(g/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(a.children)&&a.children.forEach(w=>this.formatProcessItem(t,r,i,w,l+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const i=n.URI.revive(r);if(i.scheme!==m.Schemas.file)continue;const a=i.fsPath;try{const l=await D(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),l.fileTypes.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:o.name,count:o.count})}),l.launchConfigFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:o.name,count:o.count})}),l.configFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};s=fe([K(0,y.ITelemetryService),K(1,p.IProductService)],s),e.DiagnosticsService=s}),define(X[175],Q([0,1,110,2,27,31,3,44,14,21,29,9,4,6]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let h=class extends L.Disposable{constructor(f,s,c){super();this.galleryService=f,this.telemetryService=s,this.logService=c,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register((0,L.toDisposable)(()=>{this.installingExtensions.forEach(t=>t.cancel()),this.uninstallingExtensions.forEach(t=>t.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(f,s={}){if(!this.galleryService.isEnabled())throw new Error(S.localize(0,null));try{f=await this.checkAndGetCompatibleVersion(f)}catch(t){throw this.logService.error((0,y.getErrorMessage)(t)),D(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(f),void 0,t),t}if(!await this.canInstall(f)){const t=new P.ExtensionManagementError("Not supported",e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",f.identifier.id,t.message),D(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(f),void 0,t),t}const c=await this.galleryService.getManifest(f,n.CancellationToken.None);if(c===null){const t=new P.ExtensionManagementError(`Missing manifest for extension ${f.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",f.identifier.id,t.message),D(this.telemetryService,"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(f),void 0,t),t}return this.installExtension(c,f,s)}async uninstall(f,s={}){return this.logService.trace("ExtensionManagementService#uninstall",f.identifier.id),this.unininstallExtension(f,s)}async reinstallFromGallery(f){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",f.identifier.id),!this.galleryService.isEnabled())throw new Error(S.localize(1,null));const s=await this.findGalleryExtension(f);if(!s)throw new Error(S.localize(2,null));await this.createUninstallExtensionTask(f,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(s)}getExtensionsReport(){const f=new Date().getTime();return(!this.reportedExtensions||f-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=f),this.reportedExtensions}async installExtension(f,s,c){if(!v.URI.isUri(s)){let l=this.installingExtensions.get(new k.ExtensionIdentifierWithVersion(s.identifier,s.version).key());if(l)return this.logService.info("Extensions is already requested to install",s.identifier.id),l.waitUntilTaskIsFinished();c={...c,installOnlyNewlyAddedFromExtensionPack:!0}}const t=[],r=[],i=this.createInstallExtensionTask(f,s,c);v.URI.isUri(s)||this.installingExtensions.set(new k.ExtensionIdentifierWithVersion(i.identifier,f.version).key(),i),this._onInstallExtension.fire({identifier:i.identifier,source:s}),this.logService.info("Installing extension:",i.identifier.id),t.push({task:i,manifest:f});let a=!1;try{if(c.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",i.identifier.id);else try{const o=await this.getAllDepsAndPackExtensionsToInstall(i.identifier,f,!!c.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:u,manifest:g}of o)if(a=a||!!g.extensionDependencies?.some(w=>(0,k.areSameExtensions)({id:w},i.identifier)),this.installingExtensions.has(new k.ExtensionIdentifierWithVersion(u.identifier,u.version).key()))this.logService.info("Extension is already requested to install",u.identifier.id);else{const w=this.createInstallExtensionTask(g,u,{...c,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new k.ExtensionIdentifierWithVersion(w.identifier,g.version).key(),w),this._onInstallExtension.fire({identifier:w.identifier,source:u}),this.logService.info("Installing extension:",w.identifier.id),t.push({task:w,manifest:g})}}catch(o){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",i.identifier.id),this.logService.error(o),o}const l=t.reduce((o,{task:u,manifest:g})=>(o.set(u.identifier.id.toLowerCase(),{task:u,manifest:g}),o),new Map);for(;l.size;){let o;const u=[...l.values()].filter(({manifest:d})=>!d.extensionDependencies?.some(T=>l.has(T.toLowerCase())));u.length?o=l.size===1?u:u.filter(({task:d})=>!(d===i&&!a)):(this.logService.info("Found extensions with circular dependencies",u.map(({task:d})=>d.identifier.id)),o=[...l.values()]);const w=(await Promise.allSettled(o.map(async({task:d})=>{const T=new Date().getTime();try{const O=await d.run();v.URI.isUri(d.source)||D(this.telemetryService,d.operation===2?"extensionGallery:update":"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(d.source),new Date().getTime()-T,void 0),r.push({local:O,identifier:d.identifier,operation:d.operation,source:d.source})}catch(O){throw v.URI.isUri(d.source)||D(this.telemetryService,d.operation===2?"extensionGallery:update":"extensionGallery:install",(0,k.getGalleryExtensionTelemetryData)(d.source),new Date().getTime()-T,O),this.logService.error("Error while installing the extension:",d.identifier.id),this.logService.error(O),O}finally{l.delete(d.identifier.id.toLowerCase())}}))).reduce((d,T)=>(T.status==="rejected"&&d.push(T.reason),d),[]);if(w.length)throw C(w)}return r.forEach(({identifier:o})=>this.logService.info("Extension installed successfully:",o.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:o})=>(0,k.areSameExtensions)(o,i.identifier))[0].local}catch(l){if(t.forEach(({task:o})=>o.cancel()),r.length)try{const o=await Promise.allSettled(r.map(({local:u})=>this.createUninstallExtensionTask(u,{versionOnly:!0}).run()));for(let u=0;u<o.length;u++){const g=o[u],{identifier:w}=r[u];g.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",w.id):this.logService.warn("Rollback: Error while uninstalling extension",w.id,(0,y.getErrorMessage)(g.reason))}}catch(o){this.logService.warn("Error while rolling back extensions",(0,y.getErrorMessage)(o),r.map(({identifier:u})=>u.id))}throw this.logService.error("Failed to install extension:",i.identifier.id,(0,y.getErrorMessage)(l)),this._onDidInstallExtensions.fire(t.map(({task:o})=>({identifier:o.identifier,operation:1,source:o.source}))),l instanceof Error&&(l.name=l&&l.code?l.code:e.ERROR_UNKNOWN),l}finally{for(const{task:l,manifest:o}of t)if(!v.URI.isUri(l.source)){const u=new k.ExtensionIdentifierWithVersion(l.identifier,o.version).key();this.installingExtensions.delete(u)||this.logService.warn("Installation task is not found in the cache",u)}}}async getAllDepsAndPackExtensionsToInstall(f,s,c){if(!this.galleryService.isEnabled())return[];let t=await this.getInstalled();const r=[f,...t.map(l=>l.identifier)],i=[],a=async(l,o)=>{const u=o.extensionDependencies||[];if(o.extensionPack){const g=c?t.find(w=>(0,k.areSameExtensions)(w.identifier,l)):void 0;for(const w of o.extensionPack)g&&g.manifest.extensionPack&&g.manifest.extensionPack.some(d=>(0,k.areSameExtensions)({id:d},{id:w}))||u.every(d=>!(0,k.areSameExtensions)({id:d},{id:w}))&&u.push(w)}if(u.length){const g=[...r,...i.map(d=>d.gallery.identifier)],w=u.filter(d=>g.every(T=>!(0,k.areSameExtensions)(T,{id:d})));if(w.length){const d=await this.galleryService.query({names:w,pageSize:u.length},n.CancellationToken.None);for(const T of d.firstPage){if(g.find(z=>(0,k.areSameExtensions)(z,T.identifier)))continue;const O=await this.checkAndGetCompatibleVersion(T);if(!await this.canInstall(O)){this.logService.info("Skipping the extension as it cannot be installed",O.identifier.id);continue}const $=await this.galleryService.getManifest(O,n.CancellationToken.None);if($===null)throw new P.ExtensionManagementError(`Missing manifest for extension ${O.identifier.id}`,e.INSTALL_ERROR_VALIDATING);i.push({gallery:O,manifest:$}),await a(O.identifier,$)}}}};return await a(f,s),t=await this.getInstalled(),i.filter(l=>!t.some(o=>(0,k.areSameExtensions)(o.identifier,l.gallery.identifier)))}async checkAndGetCompatibleVersion(f){if(await this.isMalicious(f))throw new P.ExtensionManagementError(S.localize(3,null,f.identifier.id),P.INSTALL_ERROR_MALICIOUS);const s=await this.galleryService.getCompatibleExtension(f);if(!s)throw new P.ExtensionManagementError(S.localize(4,null,f.identifier.id,R.default.version),P.INSTALL_ERROR_INCOMPATIBLE);return s}async isMalicious(f){const s=await this.getExtensionsReport();return(0,k.getMaliciousExtensionsSet)(s).has(f.identifier.id)}async unininstallExtension(f,s){const c=this.uninstallingExtensions.get(f.identifier.id.toLowerCase());if(c)return this.logService.info("Extensions is already requested to uninstall",f.identifier.id),c.waitUntilTaskIsFinished();const t=(l,o)=>{const u=this.createUninstallExtensionTask(l,o);return this.uninstallingExtensions.set(u.extension.identifier.id.toLowerCase(),u),this.logService.info("Uninstalling extension:",l.identifier.id),this._onUninstallExtension.fire(l.identifier),u},r=(l,o)=>{o?this.logService.error("Failed to uninstall extension:",l.identifier.id,o.message):this.logService.info("Successfully uninstalled extension:",l.identifier.id),D(this.telemetryService,"extensionGallery:uninstall",(0,k.getLocalExtensionTelemetryData)(l),void 0,o),this._onDidUninstallExtension.fire({identifier:l.identifier,error:o?.code})},i=[],a=[];try{i.push(t(f,{}));const l=await this.getInstalled(1);if(s.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",f.identifier.id);else{const g=this.getAllPackExtensionsToUninstall(f,l);for(const w of g)this.uninstallingExtensions.has(w.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",w.identifier.id):i.push(t(w,{}))}s.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",f.identifier.id):this.checkForDependents(i.map(g=>g.extension),l,f);const u=(await Promise.allSettled(i.map(async g=>{try{if(await g.run(),g.extension.identifier.uuid)try{await this.galleryService.reportStatistic(g.extension.manifest.publisher,g.extension.manifest.name,g.extension.manifest.version,"uninstall")}catch(w){}r(g.extension)}catch(w){const d=w instanceof P.ExtensionManagementError?w:new P.ExtensionManagementError((0,y.getErrorMessage)(w),e.ERROR_UNKNOWN);throw r(g.extension,d),d}finally{a.push(g)}}))).reduce((g,w)=>(w.status==="rejected"&&g.push(w.reason),g),[]);if(u.length)throw C(u)}catch(l){const o=l instanceof P.ExtensionManagementError?l:new P.ExtensionManagementError((0,y.getErrorMessage)(l),e.ERROR_UNKNOWN);for(const u of i){try{u.cancel()}catch(g){}a.includes(u)||r(u.extension,o)}throw o}finally{for(const l of i)this.uninstallingExtensions.delete(l.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",l.extension.identifier.id)}}checkForDependents(f,s,c){for(const t of f){const r=this.getDependents(t,s);if(r.length){const i=r.filter(a=>f.indexOf(a)===-1);if(i.length)throw new Error(this.getDependentsErrorMessage(t,i,c))}}}getDependentsErrorMessage(f,s,c){return c===f?s.length===1?S.localize(5,null,c.manifest.displayName||c.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?S.localize(6,null,c.manifest.displayName||c.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):S.localize(7,null,c.manifest.displayName||c.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?S.localize(8,null,c.manifest.displayName||c.manifest.name,f.manifest.displayName||f.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?S.localize(9,null,c.manifest.displayName||c.manifest.name,f.manifest.displayName||f.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):S.localize(10,null,c.manifest.displayName||c.manifest.name,f.manifest.displayName||f.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(f,s,c=[]){if(c.indexOf(f)!==-1)return[];c.push(f);const t=f.manifest.extensionPack?f.manifest.extensionPack:[];if(t.length){const r=s.filter(a=>!a.isBuiltin&&t.some(l=>(0,k.areSameExtensions)({id:l},a.identifier))),i=[];for(const a of r)i.push(...this.getAllPackExtensionsToUninstall(a,s,c));return[...r,...i]}return[]}getDependents(f,s){return s.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(t=>(0,k.areSameExtensions)({id:t},f.identifier)))}async findGalleryExtension(f){if(f.identifier.uuid){const s=await this.findGalleryExtensionById(f.identifier.uuid);return s||this.findGalleryExtensionByName(f.identifier.id)}return this.findGalleryExtensionByName(f.identifier.id)}async findGalleryExtensionById(f){return(await this.galleryService.query({ids:[f],pageSize:1},n.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(f){return(await this.galleryService.query({names:[f],pageSize:1},n.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const f=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${f.length} reported extensions from service`),f}catch(f){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};h=fe([K(0,P.IExtensionGalleryService),K(1,E.ITelemetryService),K(2,p.ILogService)],h),e.AbstractExtensionManagementService=h;function C(I){const f=Array.isArray(I)?I:[I];return f.length===1?f[0]instanceof Error?f[0]:new Error(f[0]):f.reduce((s,c)=>new Error(`${s.message}${s.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.joinErrors=C;function D(I,f,s,c,t){const r=t?t instanceof P.ExtensionManagementError?t.code:e.ERROR_UNKNOWN:void 0;I.publicLogError(f,{...s,success:!t,duration:c,errorcode:r})}e.reportTelemetry=D;class b{constructor(){this.barrier=new m.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,m.createCancelablePromise)(f=>this.doRun(f))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,m.createCancelablePromise)(f=>new Promise((s,c)=>{const t=f.onCancellationRequested(()=>{t.dispose(),c((0,y.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=b}),define(X[176],Q([0,1,9,27,31,26,21,39,70,12,29,14,13,4,28,20,45,5]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var I;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished"})(I||(I={}));function f(..._){return String(_.reduce((N,j)=>N|j,0))}var s;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const c={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},t={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},i={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:I.None,criteria:[],assetTypes:[]};class a{constructor(N=i){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,j=this.state.pageSize){return new a({...this.state,pageNumber:N,pageSize:j})}withFilter(N,...j){const F=[...this.state.criteria,...j.length?j.map(U=>({filterType:N,value:U})):[{filterType:N}]];return new a({...this.state,criteria:F})}withSortBy(N){return new a({...this.state,sortBy:N})}withSortOrder(N){return new a({...this.state,sortOrder:N})}withFlags(...N){return new a({...this.state,flags:N.reduce((j,F)=>j|F,0)})}withAssetTypes(...N){return new a({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:j,pageSize:F,sortBy:U,sortOrder:x,flags:q,assetTypes:H}=this.state;return{filters:[{criteria:N,pageNumber:j,pageSize:F,sortBy:U,sortOrder:x}],assetTypes:H,flags:q}}get searchText(){const N=this.state.criteria.filter(j=>j.filterType===s.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function l(_,N){const j=(_||[]).filter(F=>F.statisticName===N)[0];return j?j.value:0}function o(_){const N="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(F=>F.assetType.indexOf(N)===0).reduce((F,U)=>{const x=d(_,U.assetType);return x&&F.push([U.assetType.substring(N.length),x]),F},[])}function u(_){if(_.properties){const N=_.properties.filter(U=>U.key===c.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=N.filter(U=>j.test(U.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return d(_,c.Repository)}function g(_){return{uri:`${_.fallbackAssetUri}/${c.VSIX}?redirect=true`,fallbackUri:`${_.fallbackAssetUri}/${c.VSIX}`}}function w(_){const N=d(_,c.Icon);if(N)return N;const j=L.DefaultIconPath;return{uri:j,fallbackUri:j}}function d(_,N){return _.files.filter(F=>F.assetType===N)[0]?{uri:`${_.assetUri}/${N}`,fallbackUri:`${_.fallbackAssetUri}/${N}`}:null}function T(_,N){const j=_.properties?_.properties.filter(U=>U.key===N):[],F=j.length>0&&j[0].value;return F?F.split(",").map(U=>(0,P.adoptToGalleryExtensionId)(U)):[]}function O(_){const N=_.properties?_.properties.filter(j=>j.key===t.Engine):[];return N.length>0&&N[0].value||""}function $(_){const N=_.properties?_.properties.filter(F=>F.key===t.LocalizedLanguages):[],j=N.length>0&&N[0].value||"";return j?j.split(","):[]}function z(_){return _.indexOf("preview")!==-1}function V(_,N,j,F,U){const x={manifest:d(N,c.Manifest),readme:d(N,c.Details),changelog:d(N,c.Changelog),license:d(N,c.License),repository:u(N),download:g(N),icon:w(N),coreTranslations:o(N)};return{identifier:{id:(0,P.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:N.version,date:N.lastUpdated,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,description:_.shortDescription||"",installCount:l(_.statistics,"install"),rating:l(_.statistics,"averagerating"),ratingCount:l(_.statistics,"ratingcount"),assetUri:m.URI.parse(N.assetUri),webExtension:!!_.tags?.includes(L.WEB_EXTENSION_TAG),assetTypes:N.files.map(({assetType:q})=>q),assets:x,properties:{dependencies:T(N,t.Dependency),extensionPack:T(N,t.ExtensionPack),engine:O(N),localizedLanguages:$(N)},telemetryData:{index:(F.pageNumber-1)*F.pageSize+j,querySource:U},preview:z(_.flags)}}let B=class{constructor(N,j,F,U,x,q,H){this.requestService=N,this.logService=j,this.environmentService=F,this.telemetryService=U,this.fileService=x,this.productService=q;const Y=q.extensionsGallery;this.extensionsGalleryUrl=Y&&Y.serviceUrl,this.extensionsControlUrl=Y&&Y.controlUrl,this.commonHeadersPromise=M(q.version,this.environmentService,this.fileService,H)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,j){const F=[];let{total:U,firstPage:x,getPage:q}=await this.query({names:N,pageSize:N.length},j);F.push(...x);for(let H=1;F.length<U&&(x=await q(H,j),x.length);H++)F.push(...x);return F}async getCompatibleExtension(N,j){return this.getCompatibleExtensionByEngine(N,j)}async getCompatibleExtensionByEngine(N,j){const F=(0,L.isIExtensionIdentifier)(N)?null:N;if(F&&F.properties.engine&&(0,p.isEngineValid)(F.properties.engine,this.productService.version,this.productService.date))return F;const{id:U,uuid:x}=F?F.identifier:N;let q=new a().withFlags(I.IncludeAssetUri,I.IncludeStatistics,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");x?q=q.withFilter(s.ExtensionId,x):q=q.withFilter(s.ExtensionName,U);const{galleryExtensions:H}=await this.queryGallery(q,n.CancellationToken.None),[Y]=H;if(!Y||!Y.versions.length)return null;if(j){const ne=Y.versions.filter(se=>se.version===j)[0];if(ne){const se=V(Y,ne,0,q);if(se.properties.engine&&(0,p.isEngineValid)(se.properties.engine,this.productService.version,this.productService.date))return se}return null}const te=await this.getLastValidExtensionVersion(Y,Y.versions);return te?V(Y,te,0,q):null}async query(N,j){const F=n.CancellationToken.isCancellationToken(N)?{}:N,U=n.CancellationToken.isCancellationToken(N)?N:j;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let x=F.text||"";const q=(0,k.getOrDefault)(F,ee=>ee.pageSize,50);let H=new a().withFlags(I.IncludeLatestVersionOnly,I.IncludeAssetUri,I.IncludeStatistics,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,q).withFilter(s.Target,"Microsoft.VisualStudio.Code");x?(x=x.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ee,he,de)=>(H=H.withFilter(s.Category,de||he),"")),x=x.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ee,he,de)=>(H=H.withFilter(s.Tag,de||he),"")),x=x.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(s.Featured),"")),x=x.trim(),x&&(x=x.length<200?x:x.substring(0,200),H=H.withFilter(s.SearchText,x)),H=H.withSortBy(0)):F.ids?H=H.withFilter(s.ExtensionId,...F.ids):F.names?H=H.withFilter(s.ExtensionName,...F.names):H=H.withSortBy(4),typeof F.sortBy=="number"&&(H=H.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(H=H.withSortOrder(F.sortOrder));const{galleryExtensions:Y,total:te}=await this.queryGallery(H,U),ne=Y.map((ee,he)=>V(ee,ee.versions[0],he,H,F.source)),se=async(ee,he)=>{if(he.isCancellationRequested)throw(0,S.canceled)();const de=H.withPage(ee+1),{galleryExtensions:ye}=await this.queryGallery(de,he);return ye.map((pe,Pe)=>V(pe,pe.versions[0],Pe,de,F.source))};return{firstPage:ne,total:te,pageSize:H.pageSize,getPage:se}}async queryGallery(N,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,I.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,f(I.Unpublished));const F=await this.commonHeadersPromise,U=JSON.stringify(N.raw),x={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(U.length)},q=new Date().getTime();let H,Y,te=0;try{if(H=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:U,headers:x},j),H.res.statusCode&&H.res.statusCode>=400&&H.res.statusCode<500)return{galleryExtensions:[],total:te};const ne=await(0,R.asJson)(H);if(ne){const se=ne.results[0],ee=se.extensions,he=se.resultMetadata&&se.resultMetadata.filter(de=>de.metadataType==="ResultCount")[0];return te=he&&he.metadataItems.filter(de=>de.name==="TotalCount")[0].count||0,{galleryExtensions:ee,total:te}}return{galleryExtensions:[],total:te}}catch(ne){throw Y=ne,ne}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(U.length),duration:new Date().getTime()-q,success:!!H&&(0,R.isSuccess)(H),responseBodySize:H?.res.headers["Content-Length"],statusCode:H?String(H.res.statusCode):void 0,errorCode:Y?(0,S.isPromiseCanceledError)(Y)?"canceled":(0,S.getErrorMessage)(Y).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(te)})}}async reportStatistic(N,j,F,U){if(!this.isEnabled())return;const q={...await this.commonHeadersPromise,Accept:"*/*;api-version=4.0-preview.1"};try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${N}/extensions/${j}/${F}/stats?statType=${U}`),headers:q},n.CancellationToken.None)}catch(H){}}async download(N,j,F){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const U=(0,P.getGalleryExtensionTelemetryData)(N),x=new Date().getTime(),q=ne=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...U,duration:ne}),H=F===1?"install":F===2?"update":"",Y=H?{uri:`${N.assets.download.uri}&${H}=true`,fallbackUri:`${N.assets.download.fallbackUri}?${H}=true`}:N.assets.download,te=await this.getAsset(Y);await this.fileService.writeFile(j,te.stream),q(new Date().getTime()-x)}async getReadme(N,j){if(N.assets.readme){const F=await this.getAsset(N.assets.readme,{},j);return await(0,R.asText)(F)||""}return""}async getManifest(N,j){if(N.assets.manifest){const F=await this.getAsset(N.assets.manifest,{},j),U=await(0,R.asText)(F);return U?JSON.parse(U):null}return null}async getCoreTranslation(N,j){const F=N.assets.coreTranslations.filter(U=>U[0]===j.toUpperCase())[0];if(F){const U=await this.getAsset(F[1]),x=await(0,R.asText)(U);return x?JSON.parse(x):null}return null}async getChangelog(N,j){if(N.assets.changelog){const F=await this.getAsset(N.assets.changelog,{},j);return await(0,R.asText)(F)||""}return""}async getAllVersions(N,j){let F=new a().withFlags(I.IncludeVersions,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?F=F.withFilter(s.ExtensionId,N.identifier.uuid):F=F.withFilter(s.ExtensionName,N.identifier.id);const U=[],{galleryExtensions:x}=await this.queryGallery(F,n.CancellationToken.None);return x.length&&(j?await Promise.all(x[0].versions.map(async q=>{let H;try{H=await this.getEngine(q)}catch(Y){}H&&(0,p.isEngineValid)(H,this.productService.version,this.productService.date)&&U.push({version:q.version,date:q.lastUpdated})})):U.push(...x[0].versions.map(q=>({version:q.version,date:q.lastUpdated})))),U}async getAsset(N,j={},F=n.CancellationToken.None){const U=await this.commonHeadersPromise,x={type:"GET"},q={...U,...j.headers||{}};j={...j,...x,headers:q};const H=N.uri,Y=N.fallbackUri,te={...j,url:H};try{const ne=await this.requestService.request(te,F);if(ne.res.statusCode===200)return ne;const se=await(0,R.asText)(ne);throw new Error(`Expected 200, got back ${ne.res.statusCode} instead.

${se}`)}catch(ne){if((0,S.isPromiseCanceledError)(ne))throw ne;const se=(0,S.getErrorMessage)(ne);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:H,message:se});const ee={...j,url:Y};return this.requestService.request(ee,F)}}async getLastValidExtensionVersion(N,j){const F=this.getLastValidExtensionVersionFromProperties(N,j);return F||this.getLastValidExtensionVersionRecursively(N,j)}getLastValidExtensionVersionFromProperties(N,j){for(const F of j){const U=O(F);if(!U)return null;if((0,p.isEngineValid)(U,this.productService.version,this.productService.date))return F}return null}async getEngine(N){const j=O(N);if(j)return j;const F=d(N,c.Manifest);if(!F)throw new Error("Manifest was not found");const U={"Accept-Encoding":"gzip"},x=await this.getAsset(F,{headers:U}),q=await(0,R.asJson)(x);if(q)return q.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(N,j){if(!j.length)return null;const F=j[0],U=await this.getEngine(F);return(0,p.isEngineValid)(U,this.productService.version,this.productService.date)?{...F,properties:[...F.properties||[],{key:t.Engine,value:U}]}:this.getLastValidExtensionVersionRecursively(N,j.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,R.asJson)(N),F=new Map;if(j)for(const U of j.malicious){const x=F.get(U)||{id:{id:U},malicious:!0,slow:!1};x.malicious=!0,F.set(U,x)}return[...F.values()]}};B=fe([K(0,R.IRequestService),K(1,y.ILogService),K(2,E.IEnvironmentService),K(3,A.ITelemetryService),K(4,v.IFileService),K(5,h.IProductService),K(6,(0,b.optional)(C.IStorageService))],B),e.ExtensionGalleryService=B;async function M(_,N,j,F){const U={"X-Market-Client-Id":`VSCode ${_}`,"User-Agent":`VSCode ${_}`},x=await(0,D.getServiceMachineId)(N,j,F);return U["X-Market-User-Id"]=x,U}e.resolveMarketplaceHeaders=M}),define(X[177],Q([0,1,4,8,28,12,34,13,7,23,27,63,39,14,169,6,21,73,112,20,3,58]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h,C,D,b,I,f,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let i=class extends h.ExtensionTipsService{constructor(l,o,u,g,w,d,T,O,$,z){super(T,O,$,z);this.environmentService=l,this.telemetryService=o,this.extensionManagementService=u,this.storageService=g,this.nativeHostService=w,this.extensionRecommendationNotificationService=d,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,y.forEach)(O.exeBasedExtensionTips,({key:V,value:B})=>{const M=[],_=[],N=[];(0,y.forEach)(B.recommendations,({key:j,value:F})=>{F.important?B.important?M.push({extensionId:j,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):_.push({extensionId:j,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):N.push({extensionId:j,extensionName:F.name,isExtensionPack:!!F.isExtensionPack})}),M.length&&this.highImportanceExecutableTips.set(V,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:M}),_.length&&this.mediumImportanceExecutableTips.set(V,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:_}),N.length&&this.allOtherExecutableTips.set(V,{exeFriendlyName:B.friendlyName,windowsPath:B.windowsPath,recommendations:N})}),(0,C.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const l=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...l,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const l=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(l,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,u)}groupImportantTipsByExe(l,o){const u=new Map;l.forEach(O=>u.set(O.extensionId.toLowerCase(),O));const{installed:g,uninstalled:w}=this.groupByInstalled([...u.keys()],o);for(const O of g){const $=u.get(O);$&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:$.exeName})}for(const O of w){const $=u.get(O);$&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:$.exeName})}const d=this.getPromptedExecutableTips(),T=new Map;for(const O of w){const $=u.get(O);if($&&(!d[$.exeName]||!d[$.exeName].includes($.extensionId))){let z=T.get($.exeName);z||(z=[],T.set($.exeName,z)),z.push($)}}return T}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[l,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(l);break;case"incompatibleWindow":const g=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const w=this._register((0,C.disposableTimeout)(()=>{w.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const l=this.getLastPromptedMediumExeTime(),o=Date.now()-l,u=7*24*60*60*1e3;if(o<u){const d=this._register((0,C.disposableTimeout)(()=>{d.dispose(),this.promptMediumImportanceExeBasedTip()},u-o));return}const[g,w]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(w).then(d=>{switch(d){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(w[0].exeName,w);const T=this._register((0,C.disposableTimeout)(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const $=this._register((0,C.disposableTimeout)(()=>{$.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(l){const o=l.map(({extensionId:g})=>g.toLowerCase()),u=(0,I.localize)(0,null,l[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,u,`@exe:"${l[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let l=this.storageService.getNumber(r,0);return l||(l=Date.now(),this.updateLastPromptedMediumExeTime(l)),l}updateLastPromptedMediumExeTime(l){this.storageService.store(r,l,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(l,o){const u=this.getPromptedExecutableTips();u[l]=o.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(t,JSON.stringify(u),0,0)}groupByInstalled(l,o){const u=[],g=[],w=o.reduce((d,T)=>(d.add(T.identifier.id.toLowerCase()),d),new Set);return l.forEach(d=>{w.has(d.toLowerCase())?u.push(d):g.push(d)}),{installed:u,uninstalled:g}}async getValidExecutableBasedExtensionTips(l){const o=[],u=new Map;for(const g of l.keys()){const w=l.get(g);if(!w||!(0,E.isNonEmptyArray)(w.recommendations))continue;const d=[];p.isWindows?w.windowsPath&&d.push(w.windowsPath.replace("%USERPROFILE%",A.env.USERPROFILE).replace("%ProgramFiles(x86)%",A.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",A.env.ProgramFiles).replace("%APPDATA%",A.env.APPDATA).replace("%WINDIR%",A.env.WINDIR)):(d.push((0,L.join)("/usr/local/bin",g)),d.push((0,L.join)("/usr/bin",g)),d.push((0,L.join)(this.environmentService.userHome.fsPath,g)));for(const T of d){let O=u.get(T);if(O===void 0&&(O=await this.fileService.exists(S.URI.file(T)),u.set(T,O)),O)for(const{extensionId:$,extensionName:z,isExtensionPack:V}of w.recommendations)o.push({extensionId:$,extensionName:z,isExtensionPack:V,exeName:g,exeFriendlyName:w.exeFriendlyName,windowsPath:w.windowsPath})}}return o}};i=fe([K(0,k.INativeEnvironmentService),K(1,D.ITelemetryService),K(2,n.IExtensionManagementService),K(3,f.IStorageService),K(4,c.INativeHostService),K(5,b.IExtensionRecommendationNotificationService),K(6,R.IFileService),K(7,P.IProductService),K(8,v.IRequestService),K(9,m.ILogService)],i),e.ExtensionTipsService=i}),define(X[80],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class S{constructor(k){this.appender=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,{eventName:R,data:p}){return this.appender.log(R,p),Promise.resolve(null)}}e.TelemetryAppenderChannel=S;class L{constructor(k){this.channel=k}log(k,A){return this.channel.call("log",{eventName:k,data:A}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(X[81],Q([0,1,44,122,19,5,24,37,2,26,32]),function(G,e,S,L,P,k,A,R,p,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(h,C){this._configurationService=C,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appender=h.appender,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let D of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,P.escapeRegExpCharacters)(D),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(D=>{const b=/^[a-f0-9]+$/i.test(D["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(h,C){this._experimentProperties[h]=C}setEnabled(h){this._enabled=h}_updateUserOptIn(){const h=this._configurationService?.getValue(v);this._userOptIn=h?h.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const h=await this._commonProperties;let C=h.sessionID,D=h["common.instanceId"],b=h["common.machineId"],I=h["common.firstSessionDate"],f=h["common.msftInternal"];return{sessionId:C,instanceId:D,machineId:b,firstSessionDate:I,msftInternal:f}}dispose(){this._disposables.dispose()}publicLog(h,C,D){return this.isOptedIn?this._commonProperties.then(b=>{C=(0,E.mixin)(C,b),C=(0,E.mixin)(C,this._experimentProperties),C=(0,E.cloneAndChange)(C,I=>{if(typeof I=="string")return this._cleanupInfo(I,D)}),this._appender.log(h,C)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(h,C,D){return this.publicLog(h,C,D)}publicLogError(h,C){return this.sendErrorTelemetry?this.publicLog(h,C,!0):Promise.resolve(void 0)}publicLogError2(h,C){return this.publicLogError(h,C)}_cleanupInfo(h,C){let D=h;if(C){const b=[];for(let c of this._cleanupPatterns)for(;;){const t=c.exec(h);if(!t)break;b.push([t.index,c.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(D="";;){const c=f.exec(h);if(!c)break;!I.test(c[0])&&b.every(([t,r])=>c.index<t||c.index>=r)&&(D+=h.substring(s,c.index)+"<REDACTED: user-file-path>",s=f.lastIndex)}s<h.length&&(D+=h.substr(s))}for(let b of this._cleanupPatterns)D=D.replace(b,"");return D}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=fe([K(1,(0,k.optional)(A.IConfigurationService))],y),e.TelemetryService=y;const v="telemetry";n.Registry.as(R.Extensions.Configuration).registerConfiguration({id:v,order:110,type:"object",title:(0,L.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,L.localize)(2,null,S.default.privacyStatementUrl):(0,L.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(X[59],Q([0,1,24,26,16,6]),function(G,e,S,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(h,C){return Promise.resolve(void 0)}publicLog2(h,C){return this.publicLog(h,C)}publicLogError(h,C){return Promise.resolve(void 0)}publicLogError2(h,C){return this.publicLogError(h,C)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class A{async publicLog(C,D,b){}async publicLogError(C,D,b){}}e.NullEndpointTelemetryService=A;function R(...h){return{log:(C,D)=>h.forEach(b=>b.log(C,D)),flush:()=>k.Promises.settled(h.map(C=>C.flush()))}}e.combinedAppender=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(h,C){return C.onDidChangeConfiguration(D=>{D.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:(0,S.ConfigurationTargetToString)(D.source),configurationKeys:v(D.sourceConfig)})})}e.configurationTelemetry=p;function E(h){const C=Object.create(null),D=Object.create(null),b=Object.create(null);y(h,b);for(let I in b){I=I.length>150?I.substr(I.length-149):I;const f=b[I];typeof f=="number"?D[I]=f:typeof f=="boolean"?D[I]=f?1:0:typeof f=="string"?C[I]=f.substring(0,1023):typeof f!="undefined"&&f!==null&&(C[I]=f)}return{properties:C,measurements:D}}e.validateTelemetryData=E;function n(h){if(!h)return"none";let C="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(b=>{h.indexOf(`${b}+`)===0&&(C=b)}),C}e.cleanRemoteAuthority=n;function y(h,C,D=0,b){if(!!h)for(let I of Object.getOwnPropertyNames(h)){const f=h[I],s=b?b+I:I;Array.isArray(f)?C[s]=(0,L.safeStringify)(f):f instanceof Date?C[s]=f.toISOString():(0,P.isObject)(f)?D<2?y(f,C,D+1,s+"."):C[s]=(0,L.safeStringify)(f):C[s]=f}}function v(h){if(!h)return[];const C=[];return m(C,"",h),C}function m(h,C,D){D&&typeof D=="object"&&!Array.isArray(D)?Object.keys(D).forEach(b=>m(h,C?`${C}.${b}`:b,D[b])):h.push(C)}}),define(X[178],Q([0,1,2,12,14,59]),function(G,e,S,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends S.Disposable{constructor(p,E){super();this.logger=this._register(p.createLogger(E.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(p,E){this.logger.trace(`telemetry/${p}`,(0,k.validateTelemetryData)(E))}};A=fe([K(0,P.ILoggerService),K(1,L.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(X[179],Q([0,1,9,26,59]),function(G,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function k(R){const p=await new Promise((n,y)=>{G(["applicationinsights"],n,y)});let E;return p.defaultClient?(E=new p.TelemetryClient(R),E.channel.setUseDiskRetryCaching(!0)):(p.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),E=p.defaultClient),R.indexOf("AIF-")===0&&(E.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),E}class A{constructor(p,E,n){this._eventPrefix=p,this._defaultData=E,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(p){if(!!this._aiClient){if(typeof this._aiClient!="string"){p(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient)),this._asyncAIClient.then(E=>{p(E)},E=>{(0,S.onUnexpectedError)(E),console.error(E)})}}log(p,E){!this._aiClient||(E=(0,L.mixin)(E,this._defaultData),E=(0,P.validateTelemetryData)(E),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+p,properties:E.properties,measurements:E.measurements})))}flush(){return this._aiClient?new Promise(p=>{this._withAIClient(E=>{E.flush({callback:()=>{this._aiClient=void 0,p(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(X[180],Q([0,1,50,80,17,81,24,21]),function(G,e,S,L,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let p=class{constructor(n,y){this.configurationService=n,this.telemetryService=y,this.customTelemetryServices=new Map}async getCustomTelemetryService(n){if(!this.customTelemetryServices.has(n.id)){const{machineId:y,sessionId:v}=await this.telemetryService.getTelemetryInfo(),m=Object.create(null);m["common.vscodemachineid"]=y,m["common.vscodesessionid"]=v;const h=[n.id,JSON.stringify(m),n.aiKey],D=new S.Client(P.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:h,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),b=new L.TelemetryAppenderClient(D);this.customTelemetryServices.set(n.id,new k.TelemetryService({appender:b,sendErrorTelemetry:n.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(n.id)}async publicLog(n,y,v){await(await this.getCustomTelemetryService(n)).publicLog(y,v)}async publicLogError(n,y,v){await(await this.getCustomTelemetryService(n)).publicLogError(y,v)}};p=fe([K(0,A.IConfigurationService),K(1,R.ITelemetryService)],p),e.CustomEndpointTelemetryService=p}),define(X[82],Q([0,1,5]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(m){m.Shell="terminal.integrated.shell.",m.ShellArgs="terminal.integrated.shellArgs.",m.DefaultProfile="terminal.integrated.defaultProfile.",m.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var P;(function(m){m.ShellLinux="terminal.integrated.shell.linux",m.ShellMacOs="terminal.integrated.shell.osx",m.ShellWindows="terminal.integrated.shell.windows",m.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",m.AutomationShellLinux="terminal.integrated.automationShell.linux",m.AutomationShellMacOs="terminal.integrated.automationShell.osx",m.AutomationShellWindows="terminal.integrated.automationShell.windows",m.ShellArgsLinux="terminal.integrated.shellArgs.linux",m.ShellArgsMacOs="terminal.integrated.shellArgs.osx",m.ShellArgsWindows="terminal.integrated.shellArgs.windows",m.ProfilesWindows="terminal.integrated.profiles.windows",m.ProfilesMacOs="terminal.integrated.profiles.osx",m.ProfilesLinux="terminal.integrated.profiles.linux",m.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",m.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",m.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",m.UseWslProfiles="terminal.integrated.useWslProfiles",m.TabsEnabled="terminal.integrated.tabs.enabled",m.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",m.TabsHideCondition="terminal.integrated.tabs.hideCondition",m.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",m.TabsShowActions="terminal.integrated.tabs.showActions",m.TabsLocation="terminal.integrated.tabs.location",m.TabsFocusMode="terminal.integrated.tabs.focusMode",m.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",m.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",m.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",m.CopyOnSelection="terminal.integrated.copyOnSelection",m.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",m.FontFamily="terminal.integrated.fontFamily",m.FontSize="terminal.integrated.fontSize",m.LetterSpacing="terminal.integrated.letterSpacing",m.LineHeight="terminal.integrated.lineHeight",m.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",m.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",m.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",m.BellDuration="terminal.integrated.bellDuration",m.FontWeight="terminal.integrated.fontWeight",m.FontWeightBold="terminal.integrated.fontWeightBold",m.CursorBlinking="terminal.integrated.cursorBlinking",m.CursorStyle="terminal.integrated.cursorStyle",m.CursorWidth="terminal.integrated.cursorWidth",m.Scrollback="terminal.integrated.scrollback",m.DetectLocale="terminal.integrated.detectLocale",m.DefaultLocation="terminal.integrated.defaultLocation",m.GpuAcceleration="terminal.integrated.gpuAcceleration",m.RightClickBehavior="terminal.integrated.rightClickBehavior",m.Cwd="terminal.integrated.cwd",m.ConfirmOnExit="terminal.integrated.confirmOnExit",m.EnableBell="terminal.integrated.enableBell",m.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",m.AllowChords="terminal.integrated.allowChords",m.AllowMnemonics="terminal.integrated.allowMnemonics",m.EnvMacOs="terminal.integrated.env.osx",m.EnvLinux="terminal.integrated.env.linux",m.EnvWindows="terminal.integrated.env.windows",m.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",m.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",m.ShowExitAlert="terminal.integrated.showExitAlert",m.SplitCwd="terminal.integrated.splitCwd",m.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",m.WordSeparators="terminal.integrated.wordSeparators",m.TitleMode="terminal.integrated.titleMode",m.EnableFileLinks="terminal.integrated.enableFileLinks",m.UnicodeVersion="terminal.integrated.unicodeVersion",m.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",m.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",m.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",m.LocalEchoStyle="terminal.integrated.localEchoStyle",m.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",m.InheritEnv="terminal.integrated.inheritEnv",m.ShowLinkHover="terminal.integrated.showLinkHover"})(P=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(m){m.CommandPrompt="cmd",m.PowerShell="pwsh",m.Wsl="wsl",m.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(m){m[m.Api=0]="Api",m[m.Process=1]="Process",m[m.Sequence=2]="Sequence"})(A=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(m){m.LocalPty="localPty",m.PtyHost="ptyHost",m.Log="log",m.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,S.createDecorator)("ptyService");var p;(function(m){m[m.BeatInterval=5e3]="BeatInterval",m[m.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",m[m.SecondWaitMultiplier=1]="SecondWaitMultiplier",m[m.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p=e.HeartbeatConstants||(e.HeartbeatConstants={}));var E;(function(m){m.TerminalView="view",m.Editor="editor"})(E=e.TerminalLocation||(e.TerminalLocation={}));var n;(function(m){m[m.GraceTime=6e4]="GraceTime",m[m.ShortGraceTime=6e3]="ShortGraceTime"})(n=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var y;(function(m){m[m.HighWatermarkChars=1e5]="HighWatermarkChars",m[m.LowWatermarkChars=5e3]="LowWatermarkChars",m[m.CharCountAckSize=5e3]="CharCountAckSize"})(y=e.FlowControlConstants||(e.FlowControlConstants={}));var v;(function(m){m.GitBash="Git Bash",m.Pwsh="PowerShell"})(v=e.ProfileSource||(e.ProfileSource={}))}),define(X[181],Q([0,1,5]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,S.createDecorator)("localPtyService")}),define(X[182],Q([0,1,35,8,34,18,16,26,7]),function(G,e,S,L,P,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let v=0;return y&&y.length===4&&(v=parseInt(y[3])),v}e.getWindowsBuildNumber=E;async function n(y,v,m,h=P.env,C=k.Promises.exists){if(L.isAbsolute(y))return await C(y)?y:void 0;if(v===void 0&&(v=P.cwd()),L.dirname(y)!=="."){const f=L.join(v,y);return await C(f)?f:void 0}const b=(0,R.getCaseInsensitive)(h,"PATH");if(m===void 0&&(0,A.isString)(b)&&(m=b.split(L.delimiter)),m===void 0||m.length===0){const f=L.join(v,y);return await C(f)?f:void 0}for(let f of m){let s;if(L.isAbsolute(f)?s=L.join(f,y):s=L.join(v,f,y),await C(s))return s;if(p.isWindows){let c=s+".com";if(await C(c)||(c=s+".exe",await C(c)))return c}}const I=L.join(v,y);return await C(I)?I:void 0}e.findExecutable=n}),define(X[183],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var S;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(S=e.ColorScheme||(e.ColorScheme={}))}),define(X[83],Q([0,1,5,2,32,3,183,54]),function(G,e,S,L,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,S.createDecorator)("themeService");var p;(function(D){function b(I){return I&&typeof I=="object"&&typeof I.id=="string"}D.isThemeColor=b})(p=e.ThemeColor||(e.ThemeColor={}));function E(D){return{id:D}}e.themeColorFromId=E;var n;(function(D){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||p.isThemeColor(r.color))}D.isThemeIcon=b;const I=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function f(r){const i=I.exec(r);if(!i)return;let[,a]=i;return{id:a}}D.fromString=f;function s(r,i){let a=r.id;const l=a.lastIndexOf("~");return l!==-1&&(a=a.substring(0,l)),i&&(a=`${a}~${i}`),{id:a}}D.modify=s;function c(r,i){return r.id===i.id&&r.color?.id===i.color?.id}D.isEqual=c;function t(r,i){return{id:r.id,color:i?E(i):void 0}}D.asThemeIcon=t,D.asClassNameArray=R.CSSIcon.asClassNameArray,D.asClassName=R.CSSIcon.asClassName,D.asCSSSelector=R.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function y(D){switch(D){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new k.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,L.toDisposable)(()=>{const I=this.themingParticipants.indexOf(b);this.themingParticipants.splice(I,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new v;P.Registry.add(e.Extensions.ThemingContribution,m);function h(D){return m.onColorThemeChange(D)}e.registerThemingParticipant=h;class C extends L.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(I=>this.onThemeChange(I)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,I){let f=this.theme.getColor(b);return f&&I&&(f=I(f,this.theme)),f?f.toString():null}}e.Themable=C}),define(X[184],Q([0,1,37,123,32,54,83]),function(G,e,S,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(k.iconRegistry.all,b=>b.id),markdownEnumDescriptions:Array.from(k.iconRegistry.all,b=>`$(${b.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},p={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},E=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),y=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),v={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:y},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...R}},{type:"null"},p]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(23,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},p]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(24,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},p]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(26,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(27,null),type:"boolean",default:!0}}};function m(){P.Registry.as(S.Extensions.Configuration).registerConfiguration(v),C()}e.registerTerminalPlatformConfiguration=m;let h;function C(b){const I=P.Registry.as(S.Extensions.Configuration);h&&I.deregisterConfigurations([h]);let f,s;if(b){const c=b.profiles.map(t=>({name:t.profileName,description:D(t)}));f=c.map(t=>t.name),s=c.map(t=>t.description)}h={id:"terminal",order:100,title:(0,L.localize)(28,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(29,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:b?.os===3?f:void 0,markdownEnumDescriptions:b?.os===3?s:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:b?.os===2?f:void 0,markdownEnumDescriptions:b?.os===2?s:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(31,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:b?.os===1?f:void 0,markdownEnumDescriptions:b?.os===1?s:void 0}}},I.registerConfiguration(h)}e.registerTerminalDefaultProfileConfiguration=C;function D(b){let I=`$(${A.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:k.Codicon.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?I+=`
- args: "${b.args}"`:I+=`
- args: [${b.args.length===0?"":b.args.join("','")}]`),b.overrideName!==void 0&&(I+=`
- overrideName: ${b.overrideName}`),b.color&&(I+=`
- color: ${b.color}`),b.env&&(I+=`
- env: ${JSON.stringify(b.env)}`),I}}),define(X[185],Q([0,1,8,97,182,42,18,54,7,83]),function(G,e,S,L,P,k,A,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function y(t,r,i,a,l,o,u,g){return l=l||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},p.isWindows?v(i,l,o,a.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:a.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:a.getValue("terminal.integrated.defaultProfile.windows"),g,u):f(l,o,i,t&&typeof t=="object"?{...t}:a.getValue(p.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:a.getValue(p.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),g,u)}e.detectAvailableProfiles=y;async function v(t,r,i,a,l,o,u,g){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),d=`${process.env.windir}\\${w?"Sysnative":"System32"}`;let T=!1;(0,P.getWindowsBuildNumber)()>=16299&&(T=!0),await C(u);const O=new Map;t&&(O.set("PowerShell",{source:"PowerShell",icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),O.set("Windows PowerShell",{path:`${d}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.Codicon.terminalPowershell,isAutoDetected:!0}),O.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),O.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),O.set("Command Prompt",{path:`${d}\\cmd.exe`,icon:R.Codicon.terminalCmd,isAutoDetected:!0})),s(l,O);const $=await m(O.entries(),o,r,i,g);if(t||!t&&a)try{const z=await b(`${d}\\${T?"wsl":"bash"}.exe`,o);for(const V of z)(!l||!(V.profileName in l))&&$.push(V)}catch(z){i?.info("WSL is not installed, so could not detect WSL profiles")}return $}async function m(t,r,i,a,l){const o=[];for(const[u,g]of t){if(g===null)continue;let w,d,T;if("source"in g){const z=n?.get(g.source);if(!z)continue;w=z.paths,d=g.args||z.args,g.icon?T=h(g.icon):z.icon&&(T=z.icon)}else w=Array.isArray(g.path)?g.path:[g.path],d=p.isWindows||Array.isArray(g.args)?g.args:void 0,T=h(g.icon)||void 0;const O=await l?.(w)||w.slice(),$=await c(u,r,O,i,d,g.env,g.overrideName,g.isAutoDetected,a);$?($.isAutoDetected=g.isAutoDetected,$.icon=T,$.color=g.color,o.push($)):a?.trace("profile not validated",u,w)}return o}function h(t){return typeof t=="string"?{id:t}:t}async function C(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await D(),icon:E.ThemeIcon.asThemeIcon(R.Codicon.terminalPowershell)}))}async function D(){const t=[];for await(const r of(0,L.enumeratePowerShellInstallations)())t.push(r.exePath);return t}async function b(t,r){const i=[],a=await new Promise((u,g)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le"},(w,d)=>{if(w)return g("Problem occurred when getting wsl distros");u(d)})});if(!a)return[];const l=new RegExp(/[\r?\n]/),o=a.split(l).filter(u=>u.trim().length>0&&u!=="");for(const u of o){if(u===""||u.startsWith("docker-desktop"))continue;const g=`${u} (WSL)`,w={profileName:g,path:t,args:["-d",`${u}`],isDefault:g===r,icon:I(u)};i.push(w)}return i}function I(t){return t.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(R.Codicon.terminalUbuntu):t.includes("Debian")?E.ThemeIcon.asThemeIcon(R.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(R.Codicon.terminalLinux)}async function f(t,r,i,a,l,o,u){const g=new Map;if(i){const w=(await t.readFile("/etc/shells")).toString(),d=o||w.split(`
`).filter(O=>O.trim().indexOf("#")!==0&&O.trim().length>0),T=new Map;for(const O of d){let $=(0,S.basename)(O),z=T.get($)||0;z++,z>1&&($=`${$} (${z})`),T.set($,z),g.set($,{path:O,isAutoDetected:!0})}}return s(a,g),await m(g.entries(),l,t,r,u)}function s(t,r){if(!!t)for(const[i,a]of Object.entries(t))a===null||!("path"in a)&&!("source"in a)?r.delete(i):r.set(i,a)}async function c(t,r,i,a,l,o,u,g,w){if(i.length===0)return Promise.resolve(void 0);const d=i.shift();if(d==="")return c(t,r,i,a,l,o,u,g);const T={profileName:t,path:d,args:l,env:o,overrideName:u,isAutoDetected:g,isDefault:t===r};if((0,S.basename)(d)===d){const $=process.env.PATH?process.env.PATH.split(S.delimiter):void 0;return await(0,P.findExecutable)(d,void 0,$,void 0,a.existsFile)?T:c(t,r,i,a,l)}return await a.existsFile((0,S.normalize)(d))?T:c(t,r,i,a,l,o,u,g)}}),define(X[186],Q([0,1,2,14,82,50,17,36,3,77,21,185,24,184]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var h;(function(I){I[I.MaxRestarts=5]="MaxRestarts"})(h||(h={}));let C=0,D=0,b=class extends S.Disposable{constructor(f,s,c,t){super();this._reconnectConstants=f,this._configurationService=s,this._logService=c,this._telemetryService=t,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new p.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new p.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new p.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new p.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new p.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new p.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new p.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new p.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new p.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new p.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new p.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new p.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new p.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new p.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._pendingResolveVariablesRequests=new Map,(0,m.registerTerminalPlatformConfiguration)(),this._register((0,S.toDisposable)(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const f=new k.Client(A.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:C,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.GraceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.ShortGraceTime}});this._onPtyHostStart.fire(),R.ProxyChannel.toService(f.getChannel(P.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(f.onDidProcessExit(r=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(r.code),this._isDisposed||(this._restartCount<=h.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const c=f.getChannel(P.TerminalIpcChannels.Log);E.LogLevelChannelClient.setLevel(c,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{E.LogLevelChannelClient.setLevel(c,this._logService.getLevel())}));const t=R.ProxyChannel.toService(f.getChannel(P.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(r=>this._onProcessData.fire(r))),this._register(t.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(t.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(t.onProcessTitleChanged(r=>this._onProcessTitleChanged.fire(r))),this._register(t.onProcessShellTypeChanged(r=>this._onProcessShellTypeChanged.fire(r))),this._register(t.onProcessOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r))),this._register(t.onProcessResolvedShellLaunchConfig(r=>this._onProcessResolvedShellLaunchConfig.fire(r))),this._register(t.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(t.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),[f,t]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(f,s,c,t,r,i,a,l,o,u){const g=setTimeout(()=>this._handleUnresponsiveCreateProcess(),P.HeartbeatConstants.CreateProcessTimeout),w=await this._proxy.createProcess(f,s,c,t,r,i,a,l,o,u);return clearTimeout(g),C=Math.max(C,w),w}updateTitle(f,s,c){return this._proxy.updateTitle(f,s,c)}updateIcon(f,s,c){return this._proxy.updateIcon(f,s,c)}attachToProcess(f){return this._proxy.attachToProcess(f)}detachFromProcess(f){return this._proxy.detachFromProcess(f)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(f){return this._proxy.start(f)}shutdown(f,s){return this._proxy.shutdown(f,s)}input(f,s){return this._proxy.input(f,s)}processBinary(f,s){return this._proxy.processBinary(f,s)}resize(f,s,c){return this._proxy.resize(f,s,c)}acknowledgeDataEvent(f,s){return this._proxy.acknowledgeDataEvent(f,s)}getInitialCwd(f){return this._proxy.getInitialCwd(f)}getCwd(f){return this._proxy.getCwd(f)}getLatency(f){return this._proxy.getLatency(f)}orphanQuestionReply(f){return this._proxy.orphanQuestionReply(f)}getDefaultSystemShell(f){return this._proxy.getDefaultSystemShell(f)}async getProfiles(f,s,c,t=!1){return(0,y.detectAvailableProfiles)(s,c,t,this._configurationService,void 0,this._logService,this._resolveVariables.bind(this,f))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(f){return this._proxy.getWslPath(f)}setTerminalLayoutInfo(f){return this._proxy.setTerminalLayoutInfo(f)}async getTerminalLayoutInfo(f){return await this._proxy.getTerminalLayoutInfo(f)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),P.HeartbeatConstants.BeatInterval*P.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${P.HeartbeatConstants.BeatInterval*P.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),P.HeartbeatConstants.BeatInterval*P.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(P.HeartbeatConstants.BeatInterval*P.HeartbeatConstants.FirstWaitMultiplier+P.HeartbeatConstants.BeatInterval*P.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${P.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(f,s){return new Promise(c=>{const t=++D;this._pendingResolveVariablesRequests.set(t,c),this._onPtyHostRequestResolveVariables.fire({id:t,workspaceId:f,originalText:s})})}async acceptPtyHostResolvedVariables(f,s){const c=this._pendingResolveVariablesRequests.get(f);c?(c(s),this._pendingResolveVariablesRequests.delete(f)):this._logService.warn(`Resolved variables received without matching request ${f}`)}};b=fe([K(1,v.IConfigurationService),K(2,L.ILogService),K(3,n.ITelemetryService)],b),e.PtyHostService=b}),define(X[52],Q([0,1,40]),function(G,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(A,R,p,E){const n=(0,S.setProperty)(A,R,p,E)[0];return n&&(A=A.substring(0,n.offset)+n.content+A.substring(n.offset+n.length)),A}e.edit=L;function P(A,R,p){let E=p;for(;E>=0;){if(A.charAt(E)===R.charAt(R.length-1)&&R.length===1)return E+1;if(E--,R.length===2&&E>=0&&A.charAt(E)===R.charAt(0))return E+2}return 0}e.getLineStartOffset=P;function k(A,R,p){let E=p;for(;E>=0;)if(A.charAt(E)===R.charAt(R.length-1)&&R.length===1||(E++,R.length===2&&E>=0&&A.charAt(E)===R.charAt(1)))return E;return A.length-1}e.getLineEndOffset=k}),define(X[187],Q([0,1,26,57]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function P(y,v,m,h,C){const D=[],b=[],I=[];if(!v){const T=y.filter(({identifier:O})=>C.every($=>$.toLowerCase()!==O.id.toLowerCase()));return{local:{added:D,removed:b,updated:I},remote:T.length>0?{added:T,updated:[],removed:[],all:T}:null}}y=y.map(E),v=v.map(E),m=m?m.map(E):null;const f=new Map,s=T=>{T.uuid&&f.set(T.id.toLowerCase(),T.uuid)};y.forEach(({identifier:T})=>s(T)),v.forEach(({identifier:T})=>s(T)),m&&m.forEach(({identifier:T})=>s(T));const c=T=>{const O=T.identifier.uuid||f.get(T.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${T.identifier.id.toLowerCase()}`},t=(T,O)=>(T.set(c(O),O),T),r=y.reduce(t,new Map),i=v.reduce(t,new Map),a=v.reduce((T,O)=>{const $=c(O);O=(0,S.deepClone)(O);const z=r.get($);return z&&(z.installed&&(O.installed=!0),O.version||(O.version=z.version)),t(T,O)},new Map),l=m?m.reduce(t,new Map):null,o=h.reduce(t,new Map),u=C.reduce((T,O)=>{const $=f.get(O.toLowerCase());return T.add($?`uuid:${$}`:`id:${O.toLowerCase()}`)},new Set),g=k(r,i,u);if(g.added.size>0||g.removed.size>0||g.updated.size>0){const T=k(l,r,u),O=k(l,i,u),$=(z,V)=>{const B=r.get(z);if(B){const M=i.get(z);return{...V?M:B,version:(M.version&&L.gt(M.version,B.version),B.version),state:A(B,M,l?.get(z))}}};for(const z of O.removed.values()){const V=r.get(z);V&&b.push(V.identifier)}for(const z of O.added.values())if(T.added.has(z)){if(g.updated.has(z)){const V=$(z,!0);V&&(I.push(n(V,z)),a.set(z,V))}}else{const V=i.get(z);V.installed&&D.push(n(V,z))}for(const z of O.updated.values()){const V=$(z,!0);V&&(I.push(n(V,z)),a.set(z,V))}for(const z of T.added.values())O.added.has(z)||a.set(z,r.get(z));for(const z of T.updated.values())if(!O.removed.has(z)&&!O.updated.has(z)){const V=$(z,!1);V&&(a.get(z)?.installed&&(V.installed=!0),a.set(z,V))}for(const z of T.removed.values())!o.has(z)&&!O.updated.has(z)&&l?.get(z)?.installed&&a.delete(z)}const w=[],d=k(i,a,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(d.added.size>0||d.updated.size>0||d.removed.size>0)&&a.forEach((T,O)=>w.push(n(T,O))),{local:{added:D,removed:b,updated:I},remote:w.length?{added:[...d.added].map(T=>a.get(T)),updated:[...d.updated].map(T=>a.get(T)),removed:[...d.removed].map(T=>i.get(T)),all:w}:null}}e.merge=P;function k(y,v,m,{checkInstalledProperty:h,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const D=y?[...y.keys()].filter(c=>!m.has(c)):[],b=[...v.keys()].filter(c=>!m.has(c)),I=b.filter(c=>D.indexOf(c)===-1).reduce((c,t)=>(c.add(t),c),new Set),f=D.filter(c=>b.indexOf(c)===-1).reduce((c,t)=>(c.add(t),c),new Set),s=new Set;for(const c of D){if(f.has(c))continue;const t=y.get(c),r=v.get(c);(!r||t.disabled!==r.disabled||!p(t.state,r.state)||C&&t.version!==r.version||h&&t.installed!==r.installed)&&s.add(c)}return{added:I,removed:f,updated:s}}function A(y,v,m){const h=y.state,C=v.state,D=m?.state;if(!v.version||h&&L.gt(y.version,v.version))return h;if(C&&L.gt(v.version,y.version)||!h)return C;if(!C)return h;const b=(0,S.deepClone)(h),I=D?R(D,C):{added:Object.keys(C).reduce((s,c)=>(s.add(c),s),new Set),removed:new Set,updated:new Set},f=D?R(D,h):{added:Object.keys(h).reduce((s,c)=>(s.add(c),s),new Set),removed:new Set,updated:new Set};for(const s of[...I.added.values(),...I.updated.values()])b[s]=C[s];for(const s of I.removed.values())f.updated.has(s)||delete b[s];return b}function R(y,v){const m=Object.keys(y),h=Object.keys(v),C=h.filter(I=>m.indexOf(I)===-1).reduce((I,f)=>(I.add(f),I),new Set),D=m.filter(I=>h.indexOf(I)===-1).reduce((I,f)=>(I.add(f),I),new Set),b=new Set;for(const I of m){if(D.has(I))continue;const f=y[I],s=v[I];(0,S.equals)(f,s)||b.add(I)}return{added:C,removed:D,updated:b}}function p(y={},v={}){const{added:m,removed:h,updated:C}=R(y,v);return m.size===0&&h.size===0&&C.size===0}function E(y){return{...y,disabled:!!y.disabled,installed:!!y.installed}}function n(y,v){const m={identifier:{id:y.identifier.id,uuid:v.startsWith("uuid:")?v.substring("uuid:".length):void 0}};return y.version&&(m.version=y.version),y.disabled&&(m.disabled=!0),y.installed&&(m.installed=!0),y.state&&(m.state=y.state),m}}),define(X[84],Q([0,1,23,3,2,31,5,28,20]),function(G,e,S,L,P,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,A.createDecorator)("IExtensionsStorageSyncService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class Ze extends P.Disposable{constructor(v,m){super();this.storageService=v,this.productService=m,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(v){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(v.id)}@${v.version}`}static fromKey(v){const m=E.exec(v);if(m&&m[1])return{id:m[1],version:m[2]}}initialize(){const v=this.storageService.keys(0,1);for(const m of v){const h=Ze.fromKey(m);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(v){if(v.scope!==0)return;if(this.extensionsWithKeysForSync.has(v.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const m=Ze.fromKey(v.key);if(m){this.extensionsWithKeysForSync.add(m.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(v,m){this.storageService.store(Ze.toKey(v),JSON.stringify(m),0,1)}getKeysForSync(v){const m=this.productService.extensionSyncedKeys?.[v.id.toLowerCase()],h=this.storageService.get(Ze.toKey(v),0),C=h?JSON.parse(h):void 0;return C&&m?(0,S.distinct)([...C,...m]):C||m}};n=fe([K(0,p.IStorageService),K(1,R.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(X[85],Q([0,1,23,24,5]),function(G,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,P.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,p){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return E=E.filter(n=>n!==R&&n!==`-${R}`),p&&E.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}updateSynchronizedExtensions(R,p){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return E=E.filter(n=>n!==R&&n!==`-${R}`),p&&E.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}getIgnoredExtensions(R){const p=R.filter(v=>v.isMachineScoped).map(v=>v.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(v=>v.toLowerCase()),n=[],y=[];if(Array.isArray(E))for(const v of E)v.startsWith("-")?y.push(v.substring(1)):n.push(v);return(0,S.distinct)([...p,...n].filter(v=>y.indexOf(v)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(p=>p.toLowerCase())}};k=fe([K(0,L.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(X[188],Q([0,1,26,33,23,144,52]),function(G,e,S,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(s){return(0,L.parse)(s)||[]}e.parseKeybindings=R;async function p(s,c,t,r,i){const a=R(s),l=R(c),o=t?R(t):null,u=[...a,...l,...o||[]].map(_=>_.key),g=await i.resolveUserBindings(u);let w=n(a,l,o,g);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:s,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};const d=v(a),T=v(l),O=o?v(o):null,$=h(d,T,g),z=O?h(O,d,g):{added:[...d.keys()].reduce((_,N)=>(_.add(N),_),new Set),removed:new Set,updated:new Set},V=O?h(O,T,g):{added:[...T.keys()].reduce((_,N)=>(_.add(N),_),new Set),removed:new Set,updated:new Set},B=E($,z,V);let M=s;for(const _ of B.removed.values())B.conflicts.has(_)||(M=I(M,_,r));for(const _ of B.added.values()){if(B.conflicts.has(_))continue;const N=T.get(_);if(N.some(j=>j.command!==`-${_}`&&w.conflicts.has(g[j.key]))){B.conflicts.add(_);continue}M=b(M,N,r)}for(const _ of B.updated.values()){if(B.conflicts.has(_))continue;const N=T.get(_);if(N.some(j=>j.command!==`-${_}`&&w.conflicts.has(g[j.key]))){B.conflicts.add(_);continue}M=f(M,_,N,r)}return{mergeContent:M,hasChanges:!0,hasConflicts:B.conflicts.size>0}}e.merge=p;function E(s,c,t){const r=new Set,i=new Set,a=new Set,l=new Set;for(const o of c.removed.values())t.updated.has(o)&&l.add(o);for(const o of t.removed.values())l.has(o)||(c.updated.has(o)?l.add(o):i.add(o));for(const o of c.added.values())l.has(o)||t.added.has(o)&&s.updated.has(o)&&l.add(o);for(const o of t.added.values())l.has(o)||(c.added.has(o)?s.updated.has(o)&&l.add(o):r.add(o));for(const o of c.updated.values())l.has(o)||t.updated.has(o)&&s.updated.has(o)&&l.add(o);for(const o of t.updated.values())l.has(o)||(c.updated.has(o)?s.updated.has(o)&&l.add(o):a.add(o));return{added:r,removed:i,updated:a,conflicts:l}}function n(s,c,t,r){const i=new Set,a=y(s,r),l=y(c,r),o=t?y(t,r):null,u=m(a,l);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const g=o?m(o,a):{added:[...a.keys()].reduce((z,V)=>(z.add(V),z),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const w=o?m(o,l):{added:[...l.keys()].reduce((z,V)=>(z.add(V),z),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:d,removed:T,updated:O,conflicts:$}=E(u,g,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:d,removed:T,updated:O,conflicts:$}}function y(s,c){const t=new Map;for(const r of s){const i=c[r.key];let a=t.get(i);a||(a=[],t.set(i,a)),a.push(r)}return t}function v(s){const c=new Map;for(const t of s){const r=t.command[0]==="-"?t.command.substring(1):t.command;let i=c.get(r);i||(i=[],c.set(r,i)),i.push(t)}return c}function m(s,c){const t=[...s.keys()],r=[...c.keys()],i=r.filter(o=>t.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),a=t.filter(o=>r.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),l=new Set;for(const o of t){if(a.has(o))continue;const u=s.get(o).map(w=>({...w,key:o})),g=c.get(o).map(w=>({...w,key:o}));(0,P.equals)(u,g,(w,d)=>D(w,d))||l.add(o)}return{added:i,removed:a,updated:l}}function h(s,c,t){const r=[...s.keys()],i=[...c.keys()],a=i.filter(u=>r.indexOf(u)===-1).reduce((u,g)=>(u.add(g),u),new Set),l=r.filter(u=>i.indexOf(u)===-1).reduce((u,g)=>(u.add(g),u),new Set),o=new Set;for(const u of r){if(l.has(u))continue;const g=s.get(u).map(d=>({...d,key:t[d.key]})),w=c.get(u).map(d=>({...d,key:t[d.key]}));C(g,w)||o.add(u)}return{added:a,removed:l,updated:o}}function C(s,c){return!(!(0,P.equals)(s.filter(({command:t})=>t[0]!=="-"),c.filter(({command:t})=>t[0]!=="-"),(t,r)=>D(t,r))||!(0,P.equals)(s.filter(({command:t})=>t[0]==="-"),c.filter(({command:t})=>t[0]==="-"),(t,r)=>D(t,r)))}function D(s,c){if(s.command!==c.command||s.key!==c.key)return!1;const t=k.ContextKeyExpr.deserialize(s.when),r=k.ContextKeyExpr.deserialize(c.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!S.equals(s.args,c.args))}function b(s,c,t){for(const r of c)s=A.edit(s,[-1],r,t);return s}function I(s,c,t){const r=R(s);for(let i=r.length-1;i>=0;i--)(r[i].command===c||r[i].command===`-${c}`)&&(s=A.edit(s,[i],void 0,t));return s}function f(s,c,t,r){const i=R(s),a=i.findIndex(l=>l.command===c||l.command===`-${c}`);for(let l=i.length-1;l>=0;l--)(i[l].command===c||i[l].command===`-${c}`)&&(s=A.edit(s,[l],void 0,r));for(let l=t.length-1;l>=0;l--)s=A.edit(s,[a],t[l],r);return s}}),define(X[189],Q([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function S(k,A,R){const p={},E={},n=new Set;if(!A)return{local:{added:p,updated:E,removed:[...n.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const y=L(k,A);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{local:{added:p,updated:E,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const v=L(R,k),m=L(R,A),h={},C={},D=new Set,b=new Set;for(const I of v.removed.values())m.updated.has(I)?p[I]=A[I]:D.add(I);for(const I of m.removed.values())b.has(I)||(v.updated.has(I)?b.add(I):n.add(I));for(const I of v.updated.values())b.has(I)||(m.updated.has(I)?y.updated.has(I)&&b.add(I):C[I]=k[I]);for(const I of m.updated.values())b.has(I)||(v.updated.has(I)?y.updated.has(I)&&b.add(I):k[I]!==void 0&&(E[I]=A[I]));for(const I of v.added.values())b.has(I)||(m.added.has(I)?y.updated.has(I)&&b.add(I):h[I]=k[I]);for(const I of m.added.values())b.has(I)||(v.added.has(I)?y.updated.has(I)&&b.add(I):p[I]=A[I]);return{local:{added:p,removed:[...n.values()],updated:E},remote:{added:h,removed:[...D.values()],updated:C},conflicts:[...b.values()]}}e.merge=S;function L(k,A){const R=k?Object.keys(k):[],p=A?Object.keys(A):[],E=p.filter(v=>R.indexOf(v)===-1).reduce((v,m)=>(v.add(m),v),new Set),n=R.filter(v=>p.indexOf(v)===-1).reduce((v,m)=>(v.add(m),v),new Set),y=new Set;for(const v of R){if(n.has(v))continue;const m=k[v],h=A[v];m!==h&&y.add(v)}return{added:E,removed:n,updated:y}}function P(k,A){const{added:R,removed:p,updated:E}=L(k,A);return R.size===0&&p.size===0&&E.size===0}e.areSame=P}),define(X[22],Q([0,1,5,27,32,37,128,79,15,23,16]),function(G,e,S,L,P,k,A,R,p,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function y(){const o=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(u=>!!o[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=y;function v(){const o=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(o).filter(d=>!!o[d].ignoreSync),g=Object.keys(o).filter(d=>o[d].scope===2||o[d].scope===6),w=y();return(0,E.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...g,...w])}e.getDefaultIgnoredSettings=v;function m(){const o="vscode://schemas/ignoredSettings",u=P.Registry.as(k.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const g=P.Registry.as(R.Extensions.JSONContribution),w=()=>{const d=y(),T=v().filter(V=>V!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(k.allSettings.properties).filter(V=>T.indexOf(V)===-1),$=T.filter(V=>d.indexOf(V)===-1),z={items:{type:"string",enum:[...O,...$.map(V=>`-${V}`)]}};g.registerSchema(o,z)};return u.onDidUpdateConfiguration(()=>w())}e.registerConfiguration=m;function h(o){return o&&(0,n.isObject)(o)&&(0,n.isString)(o.id)&&(0,n.isArray)(o.scopes)}e.isAuthenticationProvider=h;var C;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(C=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function D(o,u,g){return g.joinPath(u.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=D,e.IUserDataSyncStoreManagementService=(0,S.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,S.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,S.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function b(o){const u={};return u[e.HEADER_EXECUTION_ID]=o,u}e.createSyncHeaders=b;var I;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.NoRef="NoRef",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(I=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class f extends Error{constructor(u,g,w,d){super(u);this.code=g,this.resource=w,this.operationId=d,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=f;class s extends f{constructor(u,g,w,d){super(u,w,void 0,d);this.url=g}}e.UserDataSyncStoreError=s;class c extends f{constructor(u,g){super(u,g)}}e.UserDataAutoSyncError=c,function(o){function u(g){if(g instanceof o)return g;const w=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(g.name);if(w&&w[1]){const d=w[2]==="unknown"?void 0:w[2],T=w[3]==="unknown"?void 0:w[3];return new o(g.message,w[1],d,T)}return new o(g.message,I.Unknown)}o.toUserDataSyncError=u}(f=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var i;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function a(o){return`sync.enable.${o}`}e.getEnablementKey=a,e.IUserDataSyncResourceEnablementService=(0,S.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,S.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,S.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,S.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,S.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,S.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function l(o,u){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(g=>(0,p.isEqualOrParent)(o,(0,p.joinPath)(u.userDataSyncHome,g,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=l}),define(X[46],Q([0,1,2,13,25,4,22,12,15,6,3,21,33,124,24,16,19,23,45,20,29]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h,C,D,b,I,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function c(l){return!!(l&&l.version!==void 0&&typeof l.version=="number"&&l.content!==void 0&&typeof l.content=="string"&&(Object.keys(l).length===2||Object.keys(l).length===3&&l.machineId!==void 0&&typeof l.machineId=="string"))}e.isSyncData=c;let t=class extends S.Disposable{constructor(o,u,g,w,d,T,O,$,z,V){super();this.resource=o,this.fileService=u,this.environmentService=g,this.userDataSyncStoreService=d,this.userDataSyncBackupStoreService=T,this.userDataSyncResourceEnablementService=O,this.telemetryService=$,this.logService=z,this.configurationService=V,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new n.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new n.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new E.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new n.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,D.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(g.userDataSyncHome,1024)?p.extUri:p.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(g.userDataSyncHome,o),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,A.PREVIEW_DIR_NAME),this.lastSyncResource=(0,A.getLastSyncResourceUri)(o,g,this.extUri),this.currentMachineIdPromise=(0,I.getServiceMachineId)(g,u,w)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const o=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(o.remoteUserData,o.lastSyncUserData,!0);this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const o=await this.getLastSyncUserData();(o?(await this.doGenerateSyncResourcePreview(o,o,!0,s.CancellationToken.None)).resourcePreviews.some(({remoteChange:g})=>g!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(o){if(this._status!==o){const u=this._status;o==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&o==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=o,this._onDidChangStatus.fire(o)}}async sync(o,u={}){await this._sync(o,!0,u)}async preview(o,u={}){return this._sync(o,!1,u)}async apply(o,u={}){try{this.syncHeaders={...u};const g=await this.doApply(o);return this.setStatus(g),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(o,u,g){try{if(this.syncHeaders={...g},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let w="idle";try{const d=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(o,d);return w=await this.performSync(T,d,u),w==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):w==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(w)}}finally{this.syncHeaders={}}}async replace(o){const u=await this.resolveContent(o);if(!u)return!1;const g=this.parseSyncData(u);if(!g)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const w=await this.getLastSyncUserData(),d=await this.getLatestRemoteUserData(null,w),T=await this.isRemoteDataFromCurrentMachine(d),O=await this.generateSyncPreview({ref:d.ref,syncData:g},w,T,s.CancellationToken.None),$=[];for(const z of O){const V=await this.getAcceptResult(z,z.remoteResource,void 0,s.CancellationToken.None),{remoteChange:B}=await this.getAcceptResult(z,z.previewResource,z.remoteContent,s.CancellationToken.None);$.push([z,{...V,remoteChange:B!==0?B:2}])}await this.applyResult(d,w,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(o){const u=await this.currentMachineIdPromise;return!!o.syncData?.machineId&&o.syncData.machineId===u}async getLatestRemoteUserData(o,u){if(u){const g=o&&o.latest?o.latest[this.resource]:void 0;if(u.ref===g||g===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(o,u,g){if(o.syncData&&o.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new A.UserDataSyncError((0,m.localize)(0,null,this.resource,this.version,o.syncData.version),A.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(o,u,g)}catch(w){if(w instanceof A.UserDataSyncError)switch(w.code){case A.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(o,u,g);case A.UserDataSyncErrorCode.Conflict:case A.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),o=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(o,u,g)}throw w}}async doSync(o,u,g){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,E.createCancelablePromise)(d=>this.doGenerateSyncResourcePreview(o,u,g,d)));const w=await this.syncPreviewPromise;return this.updateConflicts(w.resourcePreviews),w.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":g?await this.doApply(!1):"syncing"}catch(w){throw this.syncPreviewPromise=null,w}}async merge(o){return await this.updateSyncResourcePreview(o,async u=>{const g=await this.getMergeResult(u,s.CancellationToken.None);await this.fileService.writeFile(u.previewResource,P.VSBuffer.fromString(g?.content||""));const w=g&&!g.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,s.CancellationToken.None):void 0;return u.acceptResult=w,u.mergeState=g.hasConflicts?"conflict":w?"accepted":"preview",u.localChange=w?w.localChange:g.localChange,u.remoteChange=w?w.remoteChange:g.remoteChange,u}),this.syncPreviewPromise}async accept(o,u){return await this.updateSyncResourcePreview(o,async g=>{const w=await this.getAcceptResult(g,o,u,s.CancellationToken.None);return g.acceptResult=w,g.mergeState="accepted",g.localChange=w.localChange,g.remoteChange=w.remoteChange,g}),this.syncPreviewPromise}async discard(o){return await this.updateSyncResourcePreview(o,async u=>{const g=await this.getMergeResult(u,s.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,P.VSBuffer.fromString(g.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=g.localChange,u.remoteChange=g.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(o,u){if(!this.syncPreviewPromise)return;let g=await this.syncPreviewPromise;const w=g.resourcePreviews.findIndex(({localResource:d,remoteResource:T,previewResource:O})=>this.extUri.isEqual(d,o)||this.extUri.isEqual(T,o)||this.extUri.isEqual(O,o));w!==-1&&(this.syncPreviewPromise=(0,E.createCancelablePromise)(async d=>{const T=[...g.resourcePreviews];return T[w]=await u(T[w]),{...g,resourcePreviews:T}}),g=await this.syncPreviewPromise,this.updateConflicts(g.resourcePreviews),g.resourcePreviews.some(({mergeState:d})=>d==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(o){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:g})=>g!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(g=>[g,g.acceptResult]),o),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(o){}}updateConflicts(o){const u=o.filter(({mergeState:g})=>g==="conflict");(0,b.equals)(this._conflicts,u,(g,w)=>this.extUri.isEqual(g.previewResource,w.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:g})=>({created:u,uri:this.toRemoteBackupResource(g)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:g})=>({created:u,uri:this.toLocalBackupResource(g)}))}toRemoteBackupResource(o){return k.URI.from({scheme:A.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${o}`})}toLocalBackupResource(o){return k.URI.from({scheme:A.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${o}`})}async getMachineId({uri:o}){const u=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(u))){const{content:g}=await this.getUserData(u);if(g)return this.parseSyncData(g)?.machineId}}async resolveContent(o){const u=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(u))){const{content:g}=await this.getUserData(u);return g}return this.extUri.isEqual(o,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(o){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const g of u.resourcePreviews){if(this.extUri.isEqual(g.acceptedResource,o))return g.acceptResult?g.acceptResult.content:null;if(this.extUri.isEqual(g.remoteResource,o))return g.remoteContent;if(this.extUri.isEqual(g.localResource,o))return g.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(o){}}async doGenerateSyncResourcePreview(o,u,g,w){const d=await this.isRemoteDataFromCurrentMachine(o),T=await this.generateSyncPreview(o,u,d,w),O=[];for(const $ of T){const z=$.previewResource.with({scheme:A.USER_DATA_SYNC_SCHEME,authority:"accepted"});if($.localChange===0&&$.remoteChange===0)O.push({...$,acceptedResource:z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const V=g?await this.getMergeResult($,w):void 0;if(w.isCancellationRequested)break;await this.fileService.writeFile($.previewResource,P.VSBuffer.fromString(V?.content||""));const B=V&&!V.hasConflicts?await this.getAcceptResult($,$.previewResource,void 0,w):void 0;O.push({...$,acceptResult:B,mergeState:V?.hasConflicts?"conflict":B?"accepted":"preview",localChange:B?B.localChange:V?V.localChange:$.localChange,remoteChange:B?B.remoteChange:V?V.remoteChange:$.remoteChange})}}return{remoteUserData:o,lastSyncUserData:u,resourcePreviews:O,isLastSyncFromCurrentMachine:d}}async getLastSyncUserData(){try{const o=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(o.value.toString()),g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&g&&u.version!==g,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${g}.`),await this.resetLocal(),null;const w=u;if(w.content===null)return{ref:u.ref,syncData:null};const d=JSON.parse(w.content);if(c(d))return{...u,syncData:d,content:void 0}}catch(o){o instanceof L.FileOperationError&&o.fileOperationResult===1||this.logService.error(o)}return null}async updateLastSyncUserData(o,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),w={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,version:g,...u};await this.fileService.writeFile(this.lastSyncResource,P.VSBuffer.fromString(JSON.stringify(w)))}async getRemoteUserData(o){const{ref:u,content:g}=await this.getUserData(o);let w=null;return g!==null&&(w=this.parseSyncData(g)),{ref:u,syncData:w}}parseSyncData(o){try{const u=JSON.parse(o);if(c(u))return u}catch(u){this.logService.error(u)}throw new A.UserDataSyncError((0,m.localize)(1,null),A.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(o){if((0,C.isString)(o)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,o);return{ref:o,content:u}}else{const u=o?{ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(o,u){const g=await this.currentMachineIdPromise,w={version:this.version,machineId:g,content:o};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(w),u,this.syncHeaders),{ref:u,syncData:w}}async backupLocal(o){const u={version:this.version,content:o};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=fe([K(1,L.IFileService),K(2,R.IEnvironmentService),K(3,f.IStorageService),K(4,A.IUserDataSyncStoreService),K(5,A.IUserDataSyncBackupStoreService),K(6,A.IUserDataSyncResourceEnablementService),K(7,y.ITelemetryService),K(8,A.IUserDataSyncLogService),K(9,h.IConfigurationService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(o,u,g,w,d,T,O,$,z,V,B){super(u,g,w,d,T,O,$,z,V,B);this.file=o,this._register(this.fileService.watch(this.extUri.dirname(o))),this._register(this.fileService.onDidFilesChange(M=>this.onFileChanges(M)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(o){return null}}async updateLocalFileContent(o,u,g){try{u?await this.fileService.writeFile(this.file,P.VSBuffer.fromString(o),g?void 0:u):await this.fileService.createFile(this.file,P.VSBuffer.fromString(o),{overwrite:g})}catch(w){throw w instanceof L.FileOperationError&&w.fileOperationResult===1||w instanceof L.FileOperationError&&w.fileOperationResult===3?new A.UserDataSyncError(w.message,A.UserDataSyncErrorCode.LocalPreconditionFailed):w}}onFileChanges(o){!o.contains(this.file)||this.triggerLocalChange()}};r=fe([K(2,L.IFileService),K(3,R.IEnvironmentService),K(4,f.IStorageService),K(5,A.IUserDataSyncStoreService),K(6,A.IUserDataSyncBackupStoreService),K(7,A.IUserDataSyncResourceEnablementService),K(8,y.ITelemetryService),K(9,A.IUserDataSyncLogService),K(10,h.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let i=class extends r{constructor(o,u,g,w,d,T,O,$,z,V,B,M){super(o,u,g,w,d,T,O,$,z,V,M);this.userDataSyncUtilService=B,this._formattingOptions=void 0}hasErrors(o){const u=[];return(0,v.parse)(o,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};i=fe([K(2,L.IFileService),K(3,R.IEnvironmentService),K(4,f.IStorageService),K(5,A.IUserDataSyncStoreService),K(6,A.IUserDataSyncBackupStoreService),K(7,A.IUserDataSyncResourceEnablementService),K(8,y.ITelemetryService),K(9,A.IUserDataSyncLogService),K(10,A.IUserDataSyncUtilService),K(11,h.IConfigurationService)],i),e.AbstractJsonFileSynchroniser=i;let a=class{constructor(o,u,g,w){this.resource=o,this.environmentService=u,this.logService=g,this.fileService=w,this.extUri=this.fileService.hasCapability(u.userDataSyncHome,1024)?p.extUri:p.extUriIgnorePathCase,this.lastSyncResource=(0,A.getLastSyncResourceUri)(this.resource,u,p.extUri)}async initialize({ref:o,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const g=this.parseSyncData(u);if(!g)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:o,syncData:g})}catch(d){this.logService.error(d)}}parseSyncData(o){try{const u=JSON.parse(o);if(c(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(o,u={}){const g={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,P.VSBuffer.fromString(JSON.stringify(g)))}};a=fe([K(1,R.IEnvironmentService),K(2,A.IUserDataSyncLogService),K(3,L.IFileService)],a),e.AbstractInitializer=a}),define(X[190],Q([0,1,22,3,12,27,31,13,24,187,46,21,4,47,40,19,20,85,9,84,6]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h,C,D,b,I,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function c(l,o){const u=JSON.parse(l.content);if(l.version===1||l.version===2){const g=(await o.getInstalled(0)).filter(w=>w.isBuiltin);for(const w of u)l.version===1&&(w.enabled===!1&&(w.disabled=!0),delete w.enabled),l.version===2&&g.every(d=>!(0,A.areSameExtensions)(d.identifier,w.identifier))&&(w.installed=!0)}return u}function t(l,o,u){const g=u.get((0,A.getExtensionId)(l,o),0)||"{}";return JSON.parse(g)}e.getExtensionStorageState=t;function r(l,o,u,g){g.store((0,A.getExtensionId)(l,o),JSON.stringify(u),0,1)}e.storeExtensionStorageState=r;let i=class at extends n.AbstractSynchroniser{constructor(o,u,g,w,d,T,O,$,z,V,B,M,_,N){super("extensions",u,o,g,w,d,M,_,z,B);this.storageService=g,this.extensionManagementService=T,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=$,this.extensionGalleryService=V,this.extensionsStorageSyncService=N,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.debounce(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,j=>j.some(({local:F})=>!!F)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,j=>!j.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(o,u){const g=o.syncData?await c(o.syncData,this.extensionManagementService):null,w=u?.skippedExtensions||[],d=u?.syncData?await c(u.syncData,this.extensionManagementService):null,T=await this.extensionManagementService.getInstalled(),O=this.getLocalExtensions(T),$=this.ignoredExtensionsManagementService.getIgnoredExtensions(T);g?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:V}=(0,E.merge)(O,g,d,w,$),B={local:z,remote:V,content:this.getPreviewContent(O,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:V!==null?2:0};return[{skippedExtensions:w,localResource:this.localResource,localContent:this.format(O),localExtensions:O,remoteResource:this.remoteResource,remoteContent:g?this.format(g):null,previewResource:this.previewResource,previewResult:B,localChange:B.localChange,remoteChange:B.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(o,u,g,w){const d=[...u,...g],T=new Set,O=$=>{T.add($.id.toLowerCase()),$.uuid&&T.add($.uuid)};d.forEach(({identifier:$})=>O($)),w.forEach(O);for(const $ of o)T.has($.identifier.id.toLowerCase())||$.identifier.uuid&&T.has($.identifier.uuid)||d.push($);return this.format(d)}async getMergeResult(o,u){return{...o.previewResult,hasConflicts:!1}}async getAcceptResult(o,u,g,w){if(this.extUri.isEqual(u,this.localResource))return this.acceptLocal(o);if(this.extUri.isEqual(u,this.remoteResource))return this.acceptRemote(o);if(this.extUri.isEqual(u,this.previewResource))return o.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async acceptLocal(o){const u=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),w=(0,E.merge)(o.localExtensions,null,null,o.skippedExtensions,g),{local:d,remote:T}=w;return{content:o.localContent,local:d,remote:T,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:T!==null?2:0}}async acceptRemote(o){const u=await this.extensionManagementService.getInstalled(),g=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),w=o.remoteContent?JSON.parse(o.remoteContent):null;if(w!==null){const d=(0,E.merge)(o.localExtensions,w,o.localExtensions,[],g),{local:T,remote:O}=d;return{content:o.remoteContent,local:T,remote:O,localChange:T.added.length>0||T.removed.length>0||T.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:o.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(o,u,g,w){let{skippedExtensions:d,localExtensions:T}=g[0][0],{local:O,remote:$,localChange:z,remoteChange:V}=g[0][1];if(z===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),z!==0&&(await this.backupLocal(JSON.stringify(T)),d=await this.updateLocalExtensions(O.added,O.removed,O.updated,d)),$){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const B=JSON.stringify($.all);o=await this.updateRemoteUserData(B,w?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${$.added.length?` Added: ${JSON.stringify($.added.map(M=>M.identifier.id))}.`:""}${$.updated.length?` Updated: ${JSON.stringify($.updated.map(M=>M.identifier.id))}.`:""}${$.removed.length?` Removed: ${JSON.stringify($.removed.map(M=>M.identifier.id))}.`:""}`)}u?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(o,{skippedExtensions:d}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${d.length?` Skipped: ${JSON.stringify(d.map(B=>B.identifier.id))}.`:""}`))}async getAssociatedResources({uri:o}){return[{resource:this.extUri.joinPath(o,"extensions.json"),comparableResource:at.EXTENSIONS_DATA_URI}]}async resolveContent(o){if(this.extUri.isEqual(o,at.EXTENSIONS_DATA_URI)){const g=await this.extensionManagementService.getInstalled(),w=this.ignoredExtensionsManagementService.getIgnoredExtensions(g),d=this.getLocalExtensions(g).filter(T=>!w.some(O=>(0,A.areSameExtensions)({id:O},T.identifier)));return this.format(d)}if(this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o))return this.resolvePreviewContent(o);let u=await super.resolveContent(o);if(u)return u;if(u=await super.resolveContent(this.extUri.dirname(o)),u){const g=this.parseSyncData(u);if(g)switch(this.extUri.basename(o)){case"extensions.json":return this.format(this.parseExtensions(g))}}return null}format(o){o.sort((w,d)=>!w.identifier.uuid&&d.identifier.uuid?-1:w.identifier.uuid&&!d.identifier.uuid?1:(0,C.compare)(w.identifier.id,d.identifier.id));const u=JSON.stringify(o),g=(0,m.format)(u,void 0,{});return(0,h.applyEdits)(u,g)}async hasLocalData(){try{const o=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(o).some(g=>g.installed||g.disabled))return!0}catch(o){}return!1}async updateLocalExtensions(o,u,g,w){const d=[],T=[],O=await this.extensionManagementService.getInstalled();if(u.length){const z=O.filter(({identifier:V,isBuiltin:B})=>!B&&u.some(M=>(0,A.areSameExtensions)(V,M)));await s.Promises.settled(z.map(async V=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,V.identifier.id),await this.extensionManagementService.uninstall(V,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,V.identifier.id),d.push(V.identifier)}))}(o.length||g.length)&&await s.Promises.settled([...o,...g].map(async z=>{const V=O.find(M=>(0,A.areSameExtensions)(M.identifier,z.identifier));if(V&&V.isBuiltin){z.state&&V.manifest.version===z.version&&this.updateExtensionState(z.state,V.manifest.publisher,V.manifest.name,V.manifest.version),z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id),await this.extensionEnablementService.disableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id),await this.extensionEnablementService.enableExtension(z.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id)),d.push(z.identifier);return}const B=await this.extensionGalleryService.getCompatibleExtension(z.identifier);if(z.state&&(V?V.manifest.version===z.version:!!B)){const M=V?V.manifest.publisher:B.publisher,_=V?V.manifest.name:B.name;this.updateExtensionState(z.state,M,_,V?.manifest.version)}if(B)try{z.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,z.identifier.id,B.version),await this.extensionEnablementService.disableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,z.identifier.id,B.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,z.identifier.id,B.version),await this.extensionEnablementService.enableExtension(B.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,z.identifier.id,B.version)),V||(await this.extensionManagementService.canInstall(B)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,z.identifier.id,B.version),await this.extensionManagementService.installFromGallery(B,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,z.identifier.id,B.version),d.push(B.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,B.displayName||B.identifier.id),T.push(z)))}catch(M){T.push(z),this.logService.error(M),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,B.displayName||B.identifier.id)}else this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,z.identifier.id),T.push(z)}));const $=[];for(const z of w)d.some(V=>(0,A.areSameExtensions)(V,z.identifier))||$.push(z);for(const z of T)$.some(V=>(0,A.areSameExtensions)(V.identifier,z.identifier))||$.push(z);return $}updateExtensionState(o,u,g,w){const d=t(u,g,this.storageService),T=w?this.extensionsStorageSyncService.getKeysForSync({id:(0,A.getGalleryExtensionId)(u,g),version:w}):void 0;T?T.forEach(O=>{d[O]=o[O]}):Object.keys(o).forEach(O=>d[O]=o[O]),r(u,g,d,this.storageService)}parseExtensions(o){return JSON.parse(o.content)}getLocalExtensions(o){const u=this.extensionEnablementService.getDisabledExtensions();return o.map(({identifier:g,isBuiltin:w,manifest:d})=>{const T={identifier:g,version:d.version};u.some(O=>(0,A.areSameExtensions)(O,g))&&(T.disabled=!0),w||(T.installed=!0);try{const O=this.extensionsStorageSyncService.getKeysForSync({id:g.id,version:d.version});if(O){const $=t(d.publisher,d.name,this.storageService);T.state=Object.keys($).reduce((z,V)=>(O.includes(V)&&(z[V]=$[V]),z),{})}}catch(O){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,I.getErrorMessage)(O))}return T})}};i.EXTENSIONS_DATA_URI=v.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=fe([K(0,P.IEnvironmentService),K(1,R.IFileService),K(2,D.IStorageService),K(3,S.IUserDataSyncStoreService),K(4,S.IUserDataSyncBackupStoreService),K(5,k.IExtensionManagementService),K(6,k.IGlobalExtensionEnablementService),K(7,b.IIgnoredExtensionsManagementService),K(8,S.IUserDataSyncLogService),K(9,k.IExtensionGalleryService),K(10,p.IConfigurationService),K(11,S.IUserDataSyncResourceEnablementService),K(12,y.ITelemetryService),K(13,f.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let a=class extends n.AbstractInitializer{constructor(o,u,g,w,d){super("extensions",w,d,g);this.extensionManagementService=o,this.ignoredExtensionsManagementService=u}async parseExtensions(o){return o.syncData?await c(o.syncData,this.extensionManagementService):null}generatePreview(o,u){const g=[],w=[],d=[];for(const T of o){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(T.identifier.id))continue;const O=u.find($=>(0,A.areSameExtensions)($.identifier,T.identifier));O?(g.push(O),T.disabled&&d.push(T.identifier)):T.installed&&(w.push(T.identifier),T.disabled&&d.push(T.identifier))}return{installedExtensions:g,newExtensions:w,disabledExtensions:d,remoteExtensions:o}}};a=fe([K(0,k.IExtensionManagementService),K(1,b.IIgnoredExtensionsManagementService),K(2,R.IFileService),K(3,P.IEnvironmentService),K(4,S.IUserDataSyncLogService)],a),e.AbstractExtensionsInitializer=a}),define(X[191],Q([0,1,26,22]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function P(R,p,E,n,y){if(!p)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const v=k(R,p);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const m=E?k(E,p):{added:Object.keys(p).reduce((I,f)=>(I.add(f),I),new Set),removed:new Set,updated:new Set},h=E?k(E,R):{added:Object.keys(R).reduce((I,f)=>(I.add(f),I),new Set),removed:new Set,updated:new Set},C={added:{},removed:[],updated:{}},D=S.deepClone(p),b=!E;for(const I of h.added.values())I!==L.SYNC_SERVICE_URL_TYPE&&b&&m.added.has(I)||(D[I]=R[I]);for(const I of h.updated.values())D[I]=R[I];for(const I of h.removed.values())n.unregistered.includes(I)||delete D[I];for(const I of m.added.values()){const f=p[I];if(n.machine.includes(I)){y.info(`GlobalState: Skipped adding ${I} in local storage because it is declared as machine scoped.`);continue}if(E&&h.added.has(I))continue;const s=R[I];s&&s.value===f.value||I===L.SYNC_SERVICE_URL_TYPE&&b&&h.added.has(I)||(s?C.updated[I]=f:C.added[I]=f)}for(const I of m.updated.values()){const f=p[I];if(n.machine.includes(I)){y.info(`GlobalState: Skipped updating ${I} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(I)||h.removed.has(I))continue;const s=R[I];s&&s.value===f.value||(C.updated[I]=f)}for(const I of m.removed.values()){if(n.machine.includes(I)){y.trace(`GlobalState: Skipped removing ${I} in local storage because it is declared as machine scoped.`);continue}h.updated.has(I)||h.removed.has(I)||C.removed.push(I)}return{local:C,remote:A(D,p)?null:D}}e.merge=P;function k(R,p){const E=Object.keys(R),n=Object.keys(p),y=n.filter(h=>E.indexOf(h)===-1).reduce((h,C)=>(h.add(C),h),new Set),v=E.filter(h=>n.indexOf(h)===-1).reduce((h,C)=>(h.add(C),h),new Set),m=new Set;for(const h of E){if(v.has(h))continue;const C=R[h],D=p[h];S.equals(C,D)||m.add(h)}return{added:y,removed:v,updated:m}}function A(R,p){const{added:E,removed:n,updated:y}=k(R,p);return E.size===0&&n.size===0&&y.size===0}}),define(X[192],Q([0,1,22,25,3,12,13,52,191,33,46,21,24,4,47,40,20,7,45,30,14]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h,C,D,b,I,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const c="globalState.argv.",t=["locale"];function r(u){const g=u.storage?Object.keys(u.storage).sort():[],w={};g.forEach(O=>w[O]=u.storage[O]),u.storage=w;const d=JSON.stringify(u),T=(0,h.format)(d,void 0,{});return(0,C.applyEdits)(d,T)}const i=1;let a=class ot extends n.AbstractSynchroniser{constructor(g,w,d,T,O,$,z,V,B){super("globalState",g,O,B,w,d,$,z,T,V);this.storageService=B,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(g.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(P.Event.any(P.Event.filter(g.onDidFilesChange,M=>M.contains(this.environmentService.argvResource)),P.Event.filter(B.onDidChangeValue,M=>M.scope===0&&M.target!==void 0?M.target===0:B.keys(0,0).includes(M.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(g,w,d,T){const O=g.syncData?JSON.parse(g.syncData.content):null;w=w===null&&d?g:w;const $=w&&w.syncData?JSON.parse(w.syncData.content):null,z=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const V=this.getStorageKeys($),{local:B,remote:M}=(0,p.merge)(z.storage,O?O.storage:null,$?$.storage:null,V,this.logService),_={content:null,local:B,remote:M,localChange:Object.keys(B.added).length>0||Object.keys(B.updated).length>0||B.removed.length>0?2:0,remoteChange:M!==null?2:0};return[{localResource:this.localResource,localContent:r(z),localUserData:z,remoteResource:this.remoteResource,remoteContent:O?r(O):null,previewResource:this.previewResource,previewResult:_,localChange:_.localChange,remoteChange:_.remoteChange,acceptedResource:this.acceptedResource,storageKeys:V}]}async getMergeResult(g,w){return{...g.previewResult,hasConflicts:!1}}async getAcceptResult(g,w,d,T){if(this.extUri.isEqual(w,this.localResource))return this.acceptLocal(g);if(this.extUri.isEqual(w,this.remoteResource))return this.acceptRemote(g);if(this.extUri.isEqual(w,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async acceptLocal(g){return{content:g.localContent,local:{added:{},removed:[],updated:{}},remote:g.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(g){if(g.remoteContent!==null){const w=JSON.parse(g.remoteContent),{local:d,remote:T}=(0,p.merge)(g.localUserData.storage,w.storage,null,g.storageKeys,this.logService);return{content:g.remoteContent,local:d,remote:T,localChange:Object.keys(d.added).length>0||Object.keys(d.updated).length>0||d.removed.length>0?2:0,remoteChange:T!==null?2:0}}else return{content:g.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(g,w,d,T){let{localUserData:O}=d[0][0],{local:$,remote:z,localChange:V,remoteChange:B}=d[0][1];if(V===0&&B===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),V!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(O)),await this.writeLocalGlobalState($),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),B!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const M=JSON.stringify({storage:z});g=await this.updateRemoteUserData(M,T?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}w?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:g}){return[{resource:this.extUri.joinPath(g,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(g){if(this.extUri.isEqual(g,ot.GLOBAL_STATE_DATA_URI)){const d=await this.getLocalGlobalState();return r(d)}if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g))return this.resolvePreviewContent(g);let w=await super.resolveContent(g);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(g)),w){const d=this.parseSyncData(w);if(d)switch(this.extUri.basename(g)){case"globalState.json":return r(JSON.parse(d.content))}}return null}async hasLocalData(){try{const{storage:g}=await this.getLocalGlobalState();if(Object.keys(g).length>1||g[`${c}.locale`]?.value!=="en")return!0}catch(g){}return!1}async getLocalGlobalState(){const g={},w=await this.getLocalArgvContent(),d=(0,E.parse)(w);for(const T of t)d[T]!==void 0&&(g[`${c}${T}`]={version:1,value:d[T]});for(const T of this.storageService.keys(0,0)){const O=this.storageService.get(T,0);O&&(g[T]={version:1,value:O})}return{storage:g}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(g){}return"{}"}async writeLocalGlobalState({added:g,removed:w,updated:d}){const T={},O={},$=(V,B)=>{for(const M of V){if(M.startsWith(c)){T[M.substring(c.length)]=B?B[M].value:void 0;continue}if(B){const _=B[M];_.value!==String(this.storageService.get(M,0))&&(O[M]=_.value)}else this.storageService.get(M,0)!==void 0&&(O[M]=void 0)}};if($(Object.keys(g),g),$(Object.keys(d),d),$(w),Object.keys(T).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(T),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(O).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const V of Object.keys(O))this.storageService.store(V,O[V],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(O))}}async updateArgv(g){const w=await this.getLocalArgvContent();let d=w;for(const T of Object.keys(g))d=(0,R.edit)(d,[T],g[T],{});w!==d&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(d)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(g){const w=this.storageService.keys(0,0),d=this.storageService.keys(0,1),T=[...w,...d],O=g?.storage?Object.keys(g.storage).filter($=>!$.startsWith(c)&&!T.includes($)&&this.storageService.get($,0)!==void 0):[];if(!b.isWeb){const $=[...S.ALL_SYNC_RESOURCES.map(z=>(0,S.getEnablementKey)(z)),S.SYNC_SERVICE_URL_TYPE];O.push(...$),d.push(...$)}return{user:w,machine:d,unregistered:O}}};a.GLOBAL_STATE_DATA_URI=m.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),a=fe([K(0,A.IFileService),K(1,S.IUserDataSyncStoreService),K(2,S.IUserDataSyncBackupStoreService),K(3,S.IUserDataSyncLogService),K(4,k.IEnvironmentService),K(5,S.IUserDataSyncResourceEnablementService),K(6,y.ITelemetryService),K(7,v.IConfigurationService),K(8,D.IStorageService)],a),e.GlobalStateSynchroniser=a;let l=class extends n.AbstractInitializer{constructor(g,w,d,T){super("globalState",d,T,w);this.storageService=g}async doInitialize(g){const w=g.syncData?JSON.parse(g.syncData.content):null;if(!w){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const d={},T={};for(const O of Object.keys(w.storage))O.startsWith(c)?d[O.substring(c.length)]=w.storage[O].value:this.storageService.get(O,0)===void 0&&(T[O]=w.storage[O].value);if(Object.keys(d).length){let O="{}";try{O=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch($){}for(const $ of Object.keys(d))O=(0,R.edit)(O,[$],d[$],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(O))}if(Object.keys(T).length)for(const O of Object.keys(T))this.storageService.store(O,T[O],0,0)}};l=fe([K(0,D.IStorageService),K(1,A.IFileService),K(2,k.IEnvironmentService),K(3,S.IUserDataSyncLogService)],l),e.GlobalStateInitializer=l;let o=class{constructor(g,w,d,T,O){this.userDataSyncStoreClient=g,this.storageService=w,this.environmentService=d,this.fileService=T,this.logService=O}getSyncStoreType(g){return this.parseGlobalState(g)?.storage[S.SYNC_SERVICE_URL_TYPE]?.value}async sync(g){const w=(0,S.createSyncHeaders)((0,f.generateUuid)());try{return await this.doSync(g,w)}catch(d){if(d instanceof S.UserDataSyncError)switch(d.code){case S.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(g,w)}throw d}}async doSync(g,w){const d=await this.userDataSyncStoreClient.read("globalState",null,w),T=this.parseGlobalState(d)||{storage:{}};T.storage[S.SYNC_SERVICE_URL_TYPE]={value:g,version:i};const O=await(0,I.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:i,machineId:O,content:r(T)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify($),d.ref,w)}parseGlobalState({content:g}){if(!g)return null;const w=JSON.parse(g);if((0,n.isSyncData)(w))return w?JSON.parse(w.content):null;throw new Error("Invalid remote data")}};o=fe([K(1,D.IStorageService),K(2,k.IEnvironmentService),K(3,A.IFileService),K(4,s.ILogService)],o),e.UserDataSyncStoreTypeSynchronizer=o}),define(X[193],Q([0,1,13,22,188,33,125,12,24,7,16,23,46,21,20,25,3]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function b(s,c){const t=JSON.parse(s);if(!c)return(0,n.isUndefined)(t.all)?null:t.all;switch(E.OS){case 2:return(0,n.isUndefined)(t.mac)?null:t.mac;case 3:return(0,n.isUndefined)(t.linux)?null:t.linux;case 1:return(0,n.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=b;let I=class extends v.AbstractJsonFileSynchroniser{constructor(c,t,r,i,a,l,o,u,g,w){super(o.keybindingsResource,"keybindings",l,o,u,c,t,a,w,r,g,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(i.onDidChangeConfiguration,d=>d.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(c,t,r,i){const a=c.syncData?this.getKeybindingsContentFromSyncContent(c.syncData.content):null;t=t===null&&r?c:t;const l=t?this.getKeybindingsContentFromLastSyncUserData(t):null,o=await this.getLocalFileContent(),u=await this.getFormattingOptions();let g=null,w=!1,d=!1,T=!1;if(a){let $=o?o.value.toString():"[]";if($=$||"[]",this.hasErrors($))throw new L.UserDataSyncError((0,A.localize)(0,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!l||l!==$||l!==a){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const z=await(0,P.merge)($,a,l,u,this.userDataSyncUtilService);z.hasChanges&&(g=z.mergeContent,T=z.hasConflicts,w=T||z.mergeContent!==$,d=T||z.mergeContent!==a)}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),g=o.value.toString(),d=!0);const O={content:g,localChange:w?o?2:1:0,remoteChange:d?2:0,hasConflicts:T};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:a,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(c,t){return c.previewResult}async getAcceptResult(c,t,r,i){if(this.extUri.isEqual(t,this.localResource))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(c,t,r,i){const{fileContent:a}=r[0][0];let{content:l,localChange:o,remoteChange:u}=r[0][1];if(o===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.hasErrors(l)))throw new L.UserDataSyncError((0,A.localize)(1,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),a&&await this.backupLocal(this.toSyncContent(a.value.toString())),await this.updateLocalFileContent(l||"[]",a,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const g=this.toSyncContent(l||"[]",c.syncData?.content);c=await this.updateRemoteUserData(g,i?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(g){}t?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(c,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const c=await this.getLocalFileContent();if(c){const t=(0,k.parse)(c.value.toString());if((0,y.isNonEmptyArray)(t))return!0}}catch(c){if(c.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:c}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(c,"keybindings.json"),comparableResource:t}]}async resolveContent(c){if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let t=await super.resolveContent(c);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(c)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(c)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(c){return!c.syncData||c.platformSpecific!==void 0&&c.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(c.syncData.content)}getKeybindingsContentFromSyncContent(c){try{return b(c,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(c,t){let r={};try{r=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=c,E.OS){case 2:r.mac=c;break;case 3:r.linux=c;break;case 1:r.windows=c;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){let c=!!this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return c!==void 0||(c=!!this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,c!==void 0)?c:!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};I=fe([K(0,L.IUserDataSyncStoreService),K(1,L.IUserDataSyncBackupStoreService),K(2,L.IUserDataSyncLogService),K(3,p.IConfigurationService),K(4,L.IUserDataSyncResourceEnablementService),K(5,S.IFileService),K(6,R.IEnvironmentService),K(7,h.IStorageService),K(8,L.IUserDataSyncUtilService),K(9,m.ITelemetryService)],I),e.KeybindingsSynchroniser=I;let f=class extends v.AbstractInitializer{constructor(c,t,r){super("keybindings",t,r,c)}async doInitialize(c){const t=c.syncData?this.getKeybindingsContentFromSyncContent(c.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,C.VSBuffer.fromString(t)),await this.updateLastSyncUserData(c)}async isEmpty(){try{const c=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,k.parse)(c.value.toString());return!(0,y.isNonEmptyArray)(t)}catch(c){return c.fileOperationResult===1}}getKeybindingsContentFromSyncContent(c){try{return b(c,!0)}catch(t){return this.logService.error(t),null}}};f=fe([K(0,S.IFileService),K(1,R.IEnvironmentService),K(2,L.IUserDataSyncLogService)],f),e.KeybindingsInitializer=f}),define(X[194],Q([0,1,26,33,40,47,52,22,23]),function(G,e,S,L,P,k,A,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function E(o,u,g){let w=[];g?w=y(g):w=n(u);const d=[],T=[...(0,R.getDisallowedIgnoredSettings)()];if(Array.isArray(w))for(const O of w)O.startsWith("-")?T.push(O.substring(1)):d.push(O);return(0,p.distinct)([...o,...d].filter(O=>T.indexOf(O)===-1))}e.getIgnoredSettings=E;function n(o){let u=o.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=o.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:o.getValue("settingsSync.ignoredSettings")||[]}function y(o){const u=(0,L.parse)(o);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function v(o,u,g,w){if(g.length){const d=l(u),T=(0,L.parse)(u),O=(0,L.parse)(o),$=[];for(const z of g){const V=T[z],B=O[z];V===void 0?o=A.edit(o,[z],void 0,w):B!==void 0?o=A.edit(o,[z],V,w):$.push(c(z,d))}$.sort((z,V)=>z.startOffset-V.startOffset),$.forEach(z=>o=b(z.setting.key,u,o,w))}return o}e.updateIgnoredSettings=v;function m(o,u,g,w,d,T){const O=v(o,u,w,T),$=g!==O,z=g!==u;if(!$&&!z)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if($&&!z)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(z&&!$)return{conflictsSettings:[],localContent:v(u,o,w,T),remoteContent:null,hasConflicts:!1};if(g===null&&C(o)){const ee=h(o,u,w)?null:v(u,o,w,T);return{conflictsSettings:[],localContent:ee,remoteContent:null,hasConflicts:!1}}let V=o,B=u;const M=(0,L.parse)(o),_=(0,L.parse)(u),N=g?(0,L.parse)(g):null,j=w.reduce((ee,he)=>(ee.add(he),ee),new Set),F=D(M,_,j),U=D(N,M,j),x=D(N,_,j),q=new Map,H=new Set,Y=ee=>{H.add(ee);const he=d.filter(({key:de})=>de===ee)[0];he?(V=A.edit(V,[ee],he.value,T),B=A.edit(B,[ee],he.value,T)):q.set(ee,{key:ee,localValue:M[ee],remoteValue:_[ee]})};for(const ee of U.removed.values())x.updated.has(ee)?Y(ee):B=A.edit(B,[ee],void 0,T);for(const ee of x.removed.values())H.has(ee)||(U.updated.has(ee)?Y(ee):V=A.edit(V,[ee],void 0,T));for(const ee of U.updated.values())H.has(ee)||(x.updated.has(ee)?F.updated.has(ee)&&Y(ee):B=A.edit(B,[ee],M[ee],T));for(const ee of x.updated.values())H.has(ee)||(U.updated.has(ee)?F.updated.has(ee)&&Y(ee):V=A.edit(V,[ee],_[ee],T));for(const ee of U.added.values())H.has(ee)||(x.added.has(ee)?F.updated.has(ee)&&Y(ee):B=b(ee,V,B,T));for(const ee of x.added.values())H.has(ee)||(U.added.has(ee)?F.updated.has(ee)&&Y(ee):V=b(ee,B,V,T));const te=q.size>0||!h(V,B,w),ne=te||!h(V,o,[]),se=te||!h(B,u,[]);return{localContent:ne?V:null,remoteContent:se?B:null,conflictsSettings:[...q.values()],hasConflicts:te}}e.merge=m;function h(o,u,g){if(o===u)return!0;const w=(0,L.parse)(o),d=(0,L.parse)(u),T=g.reduce((z,V)=>(z.add(V),z),new Set),O=l(o).filter(z=>!(z.setting&&T.has(z.setting.key))),$=l(u).filter(z=>!(z.setting&&T.has(z.setting.key)));if(O.length!==$.length)return!1;for(let z=0;z<O.length;z++){const V=O[z],B=$[z];if(V.setting&&B.setting){if(V.setting.key!==B.setting.key||!S.equals(w[V.setting.key],d[V.setting.key]))return!1}else if(!V.setting&&!B.setting){if(V.value!==B.value)return!1}else return!1}return!0}e.areSame=h;function C(o){return o?l(o).length===0:!0}e.isEmpty=C;function D(o,u,g){const w=o?Object.keys(o).filter(z=>!g.has(z)):[],d=Object.keys(u).filter(z=>!g.has(z)),T=d.filter(z=>w.indexOf(z)===-1).reduce((z,V)=>(z.add(V),z),new Set),O=w.filter(z=>d.indexOf(z)===-1).reduce((z,V)=>(z.add(V),z),new Set),$=new Set;if(o)for(const z of w){if(O.has(z))continue;const V=o[z],B=u[z];S.equals(V,B)||$.add(z)}return{added:T,removed:O,updated:$}}function b(o,u,g,w){const d=(0,L.parse)(u),T=l(u),O=l(g),$=I(o,T,O);return f(g,o,d[o],$,O,w)}e.addSetting=b;function I(o,u,g){const w=u.findIndex(T=>T.setting?.key===o),d=u[w-1];if(d){if(d.setting){const O=c(d.setting.key,g);if(O)return{index:g.indexOf(O),insertAfter:!0}}else{const O=t(w,u);if(O){const $=c(O.setting.key,g);if($){const z=r(g.indexOf($),g),V=i(u,O,u[w]);if(z){const B=i(g,$,z),M=a(V,B);return M?{index:g.indexOf(M),insertAfter:!0}:{index:g.indexOf(z),insertAfter:!1}}else{const B=i(g,$,g[g.length-1]),M=a(V,B);return M?{index:g.indexOf(M),insertAfter:!0}:{index:g.length-1,insertAfter:!0}}}}}const T=u[w+1];if(T)if(T.setting){const O=c(T.setting.key,g);if(O)return{index:g.indexOf(O),insertAfter:!1}}else{const O=r(w,u);if(O){const $=c(O.setting.key,g);if($){const z=t(g.indexOf($),g),V=i(u,u[w],O);if(z){const B=i(g,z,$),M=a(V.reverse(),B.reverse());return M?{index:g.indexOf(M),insertAfter:!1}:{index:g.indexOf(z),insertAfter:!0}}else{const B=i(g,g[0],$),M=a(V.reverse(),B.reverse());return M?{index:g.indexOf(M),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:g.length-1,insertAfter:!0}}function f(o,u,g,w,d,T){let O;return w.index===-1?O=(0,P.setProperty)(o,[u],g,T):O=s(o,u,g,w,d,T).map($=>(0,P.withFormatting)(o,$,T)[0]),(0,P.applyEdits)(o,O)}function s(o,u,g,w,d,T){const O=`${JSON.stringify(u)}: ${JSON.stringify(g)}`,$=(0,k.getEOL)(T,o),z=d[w.index];if(w.insertAfter){const V=[];if(z.setting)V.push({offset:z.endOffset,length:0,content:","+O});else{const B=r(w.index,d),M=t(w.index,d),_=M?.setting?.commaOffset;M&&_===void 0&&V.push({offset:M.endOffset,length:0,content:","});const N=_!==void 0&&_>z.endOffset;V.push({offset:N?_+1:z.endOffset,length:0,content:B?$+O+",":$+O})}return V}else{if(z.setting)return[{offset:z.startOffset,length:0,content:O+","}];const V=(d[w.index-1]&&!d[w.index-1].setting?$:"")+O+(r(w.index,d)?",":"")+$;return[{offset:z.startOffset,length:0,content:V}]}}function c(o,u){return u.filter(g=>g.setting?.key===o)[0]}function t(o,u){for(let g=o-1;g>=0;g--)if(u[g].setting)return u[g]}function r(o,u){for(let g=o+1;g<u.length;g++)if(u[g].setting)return u[g]}function i(o,u,g){const w=o.indexOf(u),d=o.indexOf(g);return o.filter((T,O)=>w<O&&O<d)}function a(o,u){if(o.length&&u.length){let g=0;for(;g<u.length&&g<o.length;g++)if(o[g].value!==u[g].value)return u[g-1];return u[g-1]}}function l(o){const u=[];let g=-1,w,d;const T={onObjectBegin:O=>{g++},onObjectProperty:(O,$,z)=>{g===0&&(w=$,d=O)},onObjectEnd:(O,$)=>{g--,g===0&&u.push({startOffset:w,endOffset:O+$,value:o.substring(w,O+$),setting:{key:d,commaOffset:void 0}})},onArrayBegin:(O,$)=>{g++},onArrayEnd:(O,$)=>{g--,g===0&&u.push({startOffset:w,endOffset:O+$,value:o.substring(w,O+$),setting:{key:d,commaOffset:void 0}})},onLiteralValue:(O,$,z)=>{g===0&&u.push({startOffset:w,endOffset:$+z,value:o.substring(w,$+z),setting:{key:d,commaOffset:void 0}})},onSeparator:(O,$,z)=>{if(g===0&&O===","){let V=u.length-1;for(;V>=0&&!u[V].setting;V--);const B=u[V];B&&u.splice(V,1,{startOffset:B.startOffset,endOffset:B.endOffset,value:B.value,setting:{key:B.setting.key,commaOffset:$}})}},onComment:(O,$)=>{g===0&&u.push({startOffset:O,endOffset:O+$,value:o.substring(O,O+$)})}};return(0,L.visit)(o,T),u}}),define(X[195],Q([0,1,13,22,25,126,3,12,24,194,52,46,21,27,20,40]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function D(c){return c&&c.settings&&typeof c.settings=="string"&&Object.keys(c).length===1}function b(c){const t=JSON.parse(c);return D(t)?t:{settings:c}}e.parseSettingsSyncContent=b;let I=class extends y.AbstractJsonFileSynchroniser{constructor(t,r,i,a,l,o,u,g,w,d,T){super(r.settingsResource,"settings",t,r,i,a,l,w,d,o,u,g);this.extensionManagementService=T,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,i,a){const l=await this.getLocalFileContent(),o=await this.getFormattingOptions(),u=this.getSettingsSyncContent(t);r=r===null&&i?t:r;const g=r?this.getSettingsSyncContent(r):null,w=await this.getIgnoredSettings();let d=null,T=!1,O=!1,$=!1;if(u){let V=l?l.value.toString().trim():"{}";V=V||"{}",this.validateContent(V),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const B=(0,E.merge)(V,u.settings,g?g.settings:null,w,[],o);d=B.localContent||B.remoteContent,T=B.localContent!==null,O=B.remoteContent!==null,$=B.hasConflicts}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),d=l.value.toString(),O=!0);const z={content:d,localChange:T?2:0,remoteChange:O?2:0,hasConflicts:$};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,E.updateIgnoredSettings)(t.previewResult.content,"{}",a,i):null}}async getAcceptResult(t,r,i,a){const l=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,E.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",o,l):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,E.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",o,l):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?(0,E.updateIgnoredSettings)(i,t.fileContent?t.fileContent.value.toString():"{}",o,l):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,a){const{fileContent:l}=i[0][0];let{content:o,localChange:u,remoteChange:g}=i[0][1];if(u===0&&g===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),l&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(l.value.toString()))),await this.updateLocalFileContent(o,l,a),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),g!==0){const w=await this.getFormattingOptions(),d=this.getSettingsSyncContent(t),T=await this.getIgnoredSettings(o);o=(0,E.updateIgnoredSettings)(o,d?d.settings:"{}",T,w),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),a?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(w){}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),i=(0,n.edit)(t.value.toString(),[L.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,E.isEmpty)(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i){const a=this.parseSettingsSyncContent(i.content);if(a)switch(this.extUri.basename(t)){case"settings.json":return a.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();r=(0,E.updateIgnoredSettings)(r,"{}",a,i)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,a=>a.some(({local:l})=>!!l)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,a=>!a.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,E.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new L.UserDataSyncError((0,k.localize)(0,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!s(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let a=i.settings;const l=await this.getFormattingOptions();for(const o in r)if(["version","content","machineId"].indexOf(o)===-1&&r[o]!==void 0){const u=(0,C.setProperty)(a,[o],r[o],l);u.length&&(a=(0,C.applyEdits)(a,u))}await this.fileService.writeFile(this.file,P.VSBuffer.fromString(a))}catch(t){}}};I=fe([K(0,S.IFileService),K(1,R.IEnvironmentService),K(2,h.IStorageService),K(3,L.IUserDataSyncStoreService),K(4,L.IUserDataSyncBackupStoreService),K(5,L.IUserDataSyncLogService),K(6,L.IUserDataSyncUtilService),K(7,p.IConfigurationService),K(8,L.IUserDataSyncResourceEnablementService),K(9,v.ITelemetryService),K(10,m.IExtensionManagementService)],I),e.SettingsSynchroniser=I;let f=class extends y.AbstractInitializer{constructor(t,r,i){super("settings",r,i,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,P.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,E.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}};f=fe([K(0,S.IFileService),K(1,R.IEnvironmentService),K(2,L.IUserDataSyncLogService)],f),e.SettingsInitializer=f;function s(c){return!!(c&&c.version!==void 0&&typeof c.version=="number"&&c.content!==void 0&&typeof c.content=="string"&&c.machineId!==void 0&&typeof c.machineId=="string")}}),define(X[196],Q([0,1,22,12,13,24,46,21,25,189,20,26,3]),function(G,e,S,L,P,k,A,R,p,E,n,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let m=class extends A.AbstractSynchroniser{constructor(D,b,I,f,s,c,t,r,i){super("snippets",b,D,I,f,s,r,i,c,t);this.version=1,this.snippetsFolder=D.snippetsHome,this._register(this.fileService.watch(D.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(v.Event.filter(this.fileService.onDidFilesChange,a=>a.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(D,b,I,f){const s=await this.getSnippetsFileContents(),c=this.toSnippetsContents(s),t=D.syncData?this.parseSnippets(D.syncData):null;b=b===null&&I?D:b;const r=b&&b.syncData?this.parseSnippets(b.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,E.merge)(c,t,r);return this.getResourcePreviews(i,s,t||{})}async getMergeResult(D,b){return D.previewResult}async getAcceptResult(D,b,I,f){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:D.fileContent?D.fileContent.value.toString():null,localChange:0,remoteChange:D.fileContent?D.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:D.remoteContent,localChange:D.remoteContent!==null?D.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder))return I===void 0?{content:D.previewResult.content,localChange:D.previewResult.localChange,remoteChange:D.previewResult.remoteChange}:{content:I,localChange:I===null?D.fileContent!==null?3:0:2,remoteChange:I===null?D.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async applyResult(D,b,I,f){const s=I.map(([c,t])=>({...c,acceptResult:t}));s.every(({localChange:c,remoteChange:t})=>c===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),s.some(({localChange:c})=>c!==0)&&(await this.updateLocalBackup(s),await this.updateLocalSnippets(s,f)),s.some(({remoteChange:c})=>c!==0)&&(D=await this.updateRemoteSnippets(s,D,f)),b?.ref!==D.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(D),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:c}of s)try{await this.fileService.del(c)}catch(t){}}getResourcePreviews(D,b,I){const f=new Map;for(const s of Object.keys(D.local.added)){const c={content:D.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};f.set(s,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(D.local.updated)){const c={content:D.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of D.local.removed){const c={content:null,hasConflicts:!1,localChange:3,remoteChange:0};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(D.remote.added)){const c={content:D.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(D.remote.updated)){const c={content:D.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of D.remote.removed){const c={content:null,hasConflicts:!1,localChange:0,remoteChange:3};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of D.conflicts){const c={content:b[s]?b[s].value.toString():null,hasConflicts:!0,localChange:b[s]?2:1,remoteChange:I[s]?2:1};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s]||null,localContent:b[s]?b[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(b))if(!f.has(s)){const c={content:b[s]?b[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};f.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s]||null,localContent:b[s]?b[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...f.values()]}async getAssociatedResources({uri:D}){let b=await super.resolveContent(D);if(b){const I=this.parseSyncData(b);if(I){const f=this.parseSnippets(I),s=[];for(const c of Object.keys(f)){const t=this.extUri.joinPath(D,c),r=this.extUri.joinPath(this.snippetsFolder,c),i=await this.fileService.exists(r);s.push({resource:t,comparableResource:i?r:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})})}return s}}return[]}async resolveContent(D){if(this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(D);let b=await super.resolveContent(D);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(D)),b){const I=this.parseSyncData(b);if(I)return this.parseSnippets(I)[this.extUri.basename(D)]||null}return null}async hasLocalData(){try{const D=await this.getSnippetsFileContents();if(Object.keys(D).length)return!0}catch(D){}return!1}async updateLocalBackup(D){const b={};for(const I of D)I.fileContent&&(b[this.extUri.basename(I.localResource)]=I.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(b)))}async updateLocalSnippets(D,b){for(const{fileContent:I,acceptResult:f,localResource:s,remoteResource:c,localChange:t}of D)if(t!==0){const r=c?this.extUri.basename(c):this.extUri.basename(s),i=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,p.VSBuffer.fromString(f.content),{overwrite:b}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,p.VSBuffer.fromString(f.content),b?void 0:I),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(D,b,I){const f=b.syncData?this.parseSnippets(b.syncData):{},s=(0,y.deepClone)(f);for(const{acceptResult:c,localResource:t,remoteResource:r,remoteChange:i}of D)if(i!==0){const a=t?this.extUri.basename(t):this.extUri.basename(r);i===3?delete s[a]:s[a]=c.content}return(0,E.areSame)(f,s)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),b=await this.updateRemoteUserData(JSON.stringify(s),I?null:b.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),b}parseSnippets(D){return JSON.parse(D.content)}toSnippetsContents(D){const b={};for(const I of Object.keys(D))b[I]=D[I].value.toString();return b}async getSnippetsFileContents(){const D={};let b;try{b=await this.fileService.resolve(this.snippetsFolder)}catch(I){if(I instanceof P.FileOperationError&&I.fileOperationResult===1)return D;throw I}for(const I of b.children||[]){const f=I.resource,s=this.extUri.extname(f);if(s===".json"||s===".code-snippets"){const c=this.extUri.relativePath(this.snippetsFolder,f),t=await this.fileService.readFile(f);D[c]=t}}return D}};m=fe([K(0,L.IEnvironmentService),K(1,P.IFileService),K(2,n.IStorageService),K(3,S.IUserDataSyncStoreService),K(4,S.IUserDataSyncBackupStoreService),K(5,S.IUserDataSyncLogService),K(6,k.IConfigurationService),K(7,S.IUserDataSyncResourceEnablementService),K(8,R.ITelemetryService)],m),e.SnippetsSynchroniser=m;let h=class extends A.AbstractInitializer{constructor(D,b,I){super("snippets",b,I,D)}async doInitialize(D){const b=D.syncData?JSON.parse(D.syncData.content):null;if(!b){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const f of Object.keys(b)){const s=b[f];if(s){const c=this.extUri.joinPath(this.environmentService.snippetsHome,f);await this.fileService.createFile(c,p.VSBuffer.fromString(s)),this.logService.info("Created snippet",this.extUri.basename(c))}}await this.updateLastSyncUserData(D)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(D){return D.fileOperationResult===1}}};h=fe([K(0,P.IFileService),K(1,L.IEnvironmentService),K(2,S.IUserDataSyncLogService)],h),e.SnippetsInitializer=h}),define(X[60],Q([0,1,5,3,2,22]),function(G,e,S,L,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,S.createDecorator)("IUserDataSyncAccountService");let A=class extends P.Disposable{constructor(p){super();this.userDataSyncStoreService=p,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(p.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(p.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(p){(p&&this._account?p.token!==this._account.token||p.authenticationProviderId!==this._account.authenticationProviderId:p!==this._account)&&(this._account=p,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(p))}};A=fe([K(0,k.IUserDataSyncStoreService)],A),e.UserDataSyncAccountService=A}),define(X[197],Q([0,1,2,22,15,24,13,12,55,25,6]),function(G,e,S,L,P,k,A,R,p,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let y=class extends S.Disposable{constructor(m,h,C,D){super();this.environmentService=m,this.fileService=h,this.configurationService=C,this.logService=D,L.ALL_SYNC_RESOURCES.forEach(b=>this.cleanUpBackup(b))}async getAllRefs(m){const h=(0,P.joinPath)(this.environmentService.userDataSyncHome,m),C=await this.fileService.resolve(h);return C.children?C.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort().reverse().map(b=>({ref:b.name,created:this.getCreationTime(b)})):[]}async resolveContent(m,h){if(!h){const C=await this.getAllRefs(m);C.length&&(h=C[C.length-1].ref)}if(h){const C=(0,P.joinPath)(this.environmentService.userDataSyncHome,m,h);return(await this.fileService.readFile(C)).value.toString()}return null}async backup(m,h){const C=(0,P.joinPath)(this.environmentService.userDataSyncHome,m),D=(0,P.joinPath)(C,`${(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(D,E.VSBuffer.fromString(h))}catch(b){this.logService.error(b)}try{this.cleanUpBackup(m)}catch(b){}}async cleanUpBackup(m){const h=(0,P.joinPath)(this.environmentService.userDataSyncHome,m);try{try{if(!await this.fileService.exists(h))return}catch(D){return}const C=await this.fileService.resolve(h);if(C.children){const D=C.children.filter(s=>s.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(s.name)).sort(),b=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let I=D.filter(s=>Date.now()-this.getCreationTime(s)>b);const f=D.length-I.length;f<10&&(I=I.slice(10-f)),await n.Promises.settled(I.map(async s=>{this.logService.info("Deleting from backup",s.resource.path),await this.fileService.del(s.resource)}))}}catch(C){this.logService.error(C)}}getCreationTime(m){return m.ctime||new Date(parseInt(m.name.substring(0,4)),parseInt(m.name.substring(4,6))-1,parseInt(m.name.substring(6,8)),parseInt(m.name.substring(9,11)),parseInt(m.name.substring(11,13)),parseInt(m.name.substring(13,15))).getTime()}};y=fe([K(0,R.IEnvironmentService),K(1,A.IFileService),K(2,k.IConfigurationService),K(3,L.IUserDataSyncLogService)],y),e.UserDataSyncBackupStoreService=y}),define(X[198],Q([0,1,4,2]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class P{constructor(v){this.service=v}listen(v,m){switch(m){case"onError":return this.service.onError}throw new Error(`Event not found: ${m}`)}call(v,m,h){switch(m){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=P;class k{constructor(v){this.service=v}listen(v,m){throw new Error(`Event not found: ${m}`)}call(v,m,h){switch(m){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(S.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class A{constructor(v){this.channel=v}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(v){return this.channel.call("resolveUserKeybindings",[v])}async resolveFormattingOptions(v){return this.channel.call("resolveFormattingOptions",[v])}}e.UserDataSyncUtilServiceClient=A;class R{constructor(v){this.service=v}listen(v,m){switch(m){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${m}`)}async call(v,m,h){switch(m){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class p{constructor(v){this.service=v}listen(v,m){switch(m){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${m}`)}call(v,m,h){switch(m){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=p;class E{constructor(v){this.service=v}listen(v,m){switch(m){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${m}`)}call(v,m,h){switch(m){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class n extends L.Disposable{constructor(v){super();this.channel=v,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(v){return this.channel.call("switch",[v])}async getPreviousUserDataSyncStore(){const v=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(v)}revive(v){return{url:S.URI.revive(v.url),type:v.type,defaultUrl:S.URI.revive(v.defaultUrl),insidersUrl:S.URI.revive(v.insidersUrl),stableUrl:S.URI.revive(v.stableUrl),canSwitch:v.canSwitch,authenticationProviders:v.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(X[199],Q([0,1,14,12]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let P=class extends S.AbstractLogger{constructor(A,R){super();this.logger=this._register(A.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...R){this.logger.trace(A,...R)}debug(A,...R){this.logger.debug(A,...R)}info(A,...R){this.logger.info(A,...R)}warn(A,...R){this.logger.warn(A,...R)}error(A,...R){this.logger.error(A,...R)}critical(A,...R){this.logger.critical(A,...R)}flush(){this.logger.flush()}};P=fe([K(0,S.ILoggerService),K(1,L.IEnvironmentService)],P),e.UserDataSyncLogService=P}),define(X[61],Q([0,1,5,2,45,12,13,20,22,129,28,7,19,3]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let C=class Ge extends L.Disposable{constructor(b,I,f,s,c,t){super();this.storageService=f,this.userDataSyncStoreService=s,this.logService=c,this.productService=t,this._onDidChange=this._register(new m.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,P.getServiceMachineId)(b,I,f)}async getMachines(b){const I=await this.currentMachineIdPromise;return(await this.readMachinesData(b)).machines.map(s=>({...s,isCurrent:s.id===I}))}async addCurrentMachine(b){const I=await this.currentMachineIdPromise,f=await this.readMachinesData(b);f.machines.some(({id:s})=>s===I)||(f.machines.push({id:I,name:this.computeCurrentMachineName(f.machines)}),await this.writeMachinesData(f))}async removeCurrentMachine(b){const I=await this.currentMachineIdPromise,f=await this.readMachinesData(b),s=f.machines.filter(({id:c})=>c!==I);s.length!==f.machines.length&&(f.machines=s,await this.writeMachinesData(f))}async renameMachine(b,I,f){const s=await this.currentMachineIdPromise,c=await this.readMachinesData(f),t=c.machines.find(({id:r})=>r===b);t&&(t.name=I,await this.writeMachinesData(c),c.machines.some(({id:r})=>r===s)&&this.storageService.store(h,I,0,1))}async setEnablement(b,I){const f=await this.readMachinesData(),s=f.machines.find(({id:c})=>c===b);s&&(s.disabled=I?void 0:!0,await this.writeMachinesData(f))}computeCurrentMachineName(b){const I=this.storageService.get(h,0);if(I)return I;const f=`${this.productService.nameLong} (${(0,y.PlatformToString)(y.isWeb?0:y.platform)})`,s=new RegExp(`${(0,v.escapeRegExpCharacters)(f)}\\s#(\\d+)`);let c=0;for(const t of b){const r=s.exec(t.name),i=r?parseInt(r[1]):0;c=i>c?i:c}return`${f} #${c+1}`}async readMachinesData(b){this.userData=await this.readUserData(b);const I=this.parse(this.userData);if(I.version!==Ge.VERSION)throw new Error((0,E.localize)(0,null,this.productService.nameLong));return I}async writeMachinesData(b){const I=JSON.stringify(b),f=await this.userDataSyncStoreService.write(Ge.RESOURCE,I,this.userData?.ref||null);this.userData={ref:f,content:I},this._onDidChange.fire()}async readUserData(b){if(this.userData){const I=b&&b.latest?b.latest[Ge.RESOURCE]:void 0;if(this.userData.ref===I)return this.userData;if(I===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ge.RESOURCE,this.userData)}parse(b){if(b.content!==null)try{return JSON.parse(b.content)}catch(I){this.logService.error(I)}return{version:Ge.VERSION,machines:[]}}};C.VERSION=1,C.RESOURCE="machines",C=fe([K(0,k.IEnvironmentService),K(1,A.IFileService),K(2,R.IStorageService),K(3,p.IUserDataSyncStoreService),K(4,p.IUserDataSyncLogService),K(5,n.IProductService)],C),e.UserDataSyncMachinesService=C}),define(X[86],Q([0,1,6,3,2,22,60,21,9,20,12,61,127,55,4,15,7,28]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const I="sync.enable",f="sync.disableMachineEventually",s="sync.sessionId",c="sync.storeUrl",t="sync.productQuality";let r=class extends P.Disposable{constructor(o,u,g){super();this.storageService=o,this.environmentService=u,this.userDataSyncStoreManagementService=g,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(o.onDidChangeValue(w=>this.onDidStorageChange(w)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(I,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(o){o&&!this.canToggleEnablement()||this.storageService.store(I,o,0,1)}onDidStorageChange(o){if(o.scope===0&&I===o.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=fe([K(0,E.IStorageService),K(1,n.IEnvironmentService),K(2,k.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let i=class extends P.Disposable{constructor(o,u,g,w,d,T,O,$,z,V,B){super();this.userDataSyncStoreManagementService=u,this.userDataSyncStoreService=g,this.userDataSyncResourceEnablementService=w,this.userDataSyncService=d,this.logService=T,this.userDataSyncAccountService=O,this.telemetryService=$,this.userDataSyncMachinesService=z,this.storageService=V,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=B,this.syncTriggerDelayer=this._register(new S.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=u.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=o.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(u.onDidChangeUserDataSyncStore(()=>{(0,C.isEqual)(this.syncUrl,u.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=u.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(O.onDidChangeAccount(()=>this.updateAutoSync())),this._register(g.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(L.Event.debounce(d.onDidChangeLocal,(M,_)=>M?[...M,_]:[_],1e3)(M=>this.triggerSync(M,!1,!1))),this._register(L.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const o=this.storageService.get(c,0);return o?h.URI.parse(o):void 0}set syncUrl(o){o?this.storageService.store(c,o.toString(),0,1):this.storageService.remove(c,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(o){o?this.storageService.store(t,o,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:o,message:u}=this.isAutoSyncEnabled();o?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(g=>this.onDidFinishSync(g))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(u&&this.logService.info(u),this.autoSync.clear()):u&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(u))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,m.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(o,u,g){try{this.userDataSyncAccountService.account&&!g&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(s,0),o?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(w){if(u)this.logService.error(w),this.updateEnablement(!1);else throw w}}updateEnablement(o){this.userDataAutoSyncEnablementService.isEnabled()!==o&&(this.telemetryService.publicLog2(I,{enabled:o}),this.userDataAutoSyncEnablementService.setEnablement(o),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(o){if(!o){this.successiveFailures=0;return}const u=k.UserDataSyncError.toUserDataSyncError(o);u instanceof k.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:u.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),u.code===k.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):u.code===k.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):u.code===k.UserDataSyncErrorCode.LocalTooManyRequests||u.code===k.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):u.code===k.UserDataSyncErrorCode.UpgradeRequired||u.code===k.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):u.code===k.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${u.resource} content with newer version than of client. Requires client upgrade.`)):u.code===k.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${u.resource} content with older version than of client. Requires server reset.`)):u.code===k.UserDataSyncErrorCode.ServiceChanged||u.code===k.UserDataSyncErrorCode.DefaultServiceChanged?D.isWeb&&u.code===k.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(u),this.successiveFailures++),this._onError.fire(u)}async disableMachineEventually(){this.storageService.store(f,!0,0,1),await(0,S.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(f,0,!1)}stopDisableMachineEventually(){this.storageService.remove(f,0)}async triggerSync(o,u,g){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(u&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...o),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",g)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};i=fe([K(0,b.IProductService),K(1,k.IUserDataSyncStoreManagementService),K(2,k.IUserDataSyncStoreService),K(3,k.IUserDataSyncResourceEnablementService),K(4,k.IUserDataSyncService),K(5,k.IUserDataSyncLogService),K(6,A.IUserDataSyncAccountService),K(7,R.ITelemetryService),K(8,y.IUserDataSyncMachinesService),K(9,E.IStorageService),K(10,k.IUserDataAutoSyncEnablementService)],i),e.UserDataAutoSyncService=i;class a extends P.Disposable{constructor(o,u,g,w,d,T,O,$){super();this.lastSyncUrl=o,this.interval=u,this.userDataSyncStoreManagementService=g,this.userDataSyncStoreService=w,this.userDataSyncService=d,this.userDataSyncMachinesService=T,this.logService=O,this.storageService=$,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new L.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new L.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,S.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(o,u){const g=(0,S.createCancelablePromise)(async w=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(d){if((0,p.isPromiseCanceledError)(d))return}return this.doSync(o,u,w)});return this.syncPromise=g,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const o=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),u=this.userDataSyncStoreManagementService.userDataSyncStore;return!!u&&!!o&&(!(0,C.isEqual)(u.defaultUrl,o.defaultUrl)||!(0,C.isEqual)(u.insidersUrl,o.insidersUrl)||!(0,C.isEqual)(u.stableUrl,o.stableUrl))}async doSync(o,u,g){this.logService.info(`Auto Sync: Triggered by ${o}`),this._onDidStartSync.fire();let w;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(u),g.isCancellationRequested)return;let d=this.syncTask.manifest;if(d===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError((0,v.localize)(0,null),k.UserDataSyncErrorCode.DefaultServiceChanged):new k.UserDataAutoSyncError((0,v.localize)(1,null),k.UserDataSyncErrorCode.ServiceChanged):new k.UserDataAutoSyncError((0,v.localize)(2,null),k.UserDataSyncErrorCode.TurnedOff);const T=this.storageService.get(s,0);if(T&&d&&T!==d.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new k.UserDataAutoSyncError((0,v.localize)(3,null),k.UserDataSyncErrorCode.DefaultServiceChanged):new k.UserDataAutoSyncError((0,v.localize)(4,null),k.UserDataSyncErrorCode.ServiceChanged):new k.UserDataAutoSyncError((0,v.localize)(5,null),k.UserDataSyncErrorCode.SessionExpired);const O=await this.userDataSyncMachinesService.getMachines(d||void 0);if(g.isCancellationRequested)return;const $=O.find(z=>z.isCurrent);if($?.disabled)throw new k.UserDataAutoSyncError((0,v.localize)(6,null),k.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),d===null&&(d=await this.userDataSyncStoreService.manifest()),d&&d.session!==T&&this.storageService.store(s,d.session,0,1),g.isCancellationRequested)return;$||await this.userDataSyncMachinesService.addCurrentMachine(d||void 0)}catch(d){this.logService.error(d),w=d}this._onDidFinishSync.fire(w)}register(o){return super._register(o)}}a.INTERVAL_SYNCING="Interval"}),define(X[200],Q([0,1,22,2,3,20,21,7]),function(G,e,S,L,P,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let p=class extends L.Disposable{constructor(n,y){super();this.storageService=n,this.telemetryService=y,this._onDidChangeResourceEnablement=new P.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(v=>this.onDidStorageChange(v)))}isResourceEnabled(n){return this.storageService.getBoolean((0,S.getEnablementKey)(n),0,!0)}setResourceEnablement(n,y){if(this.isResourceEnabled(n)!==y){const v=(0,S.getEnablementKey)(n);this.telemetryService.publicLog2(v,{enabled:y}),this.storeResourceEnablement(v,y)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,y){this.storageService.store(n,y,0,R.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const y=S.ALL_SYNC_RESOURCES.filter(v=>(0,S.getEnablementKey)(v)===n.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}}};p=fe([K(0,k.IStorageService),K(1,A.ITelemetryService)],p),e.UserDataSyncResourceEnablementService=p}),define(X[201],Q([0,1,22,2,5,3,190,193,192,43,21,23,20,195,15,196,30,6,9]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h,C,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const f="sync.lastSyncTime";let s=class extends L.Disposable{constructor(i,a,l,o,u,g){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=a,this.instantiationService=l,this.logService=o,this.telemetryService=u,this.storageService=g,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(m.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(R.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(C.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(p.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(A.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(w=>k.Event.map(w.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(w=>k.Event.map(w.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(f,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(w=>k.Event.map(w.onDidChangeLocal,()=>w.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i){await this.checkEnablement();const a=(0,D.generateUuid)();let l;try{const w=(0,S.createSyncHeaders)(a);i&&(w["Cache-Control"]="no-cache"),l=await this.userDataSyncStoreService.manifest(w)}catch(w){const d=S.UserDataSyncError.toUserDataSyncError(w);throw this.reportUserDataSyncError(d,a),d}let o=!1;const u=this;let g;return{manifest:l,run(){if(o)throw new Error("Can run a task only once");return g=(0,b.createCancelablePromise)(w=>u.sync(l,a,w)),g.finally(()=>g=void 0)},async stop(){if(g&&g.cancel(),u.status!=="idle")return u.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=(0,D.generateUuid)(),a=(0,S.createSyncHeaders)(i);let l;try{l=await this.userDataSyncStoreService.manifest(a)}catch(o){const u=S.UserDataSyncError.toUserDataSyncError(o);throw this.reportUserDataSyncError(u,i),u}return new c(i,l,a,this.synchronisers,this.logService)}async sync(i,a,l){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),l.isCancellationRequested)return;const o=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const u=(0,S.createSyncHeaders)(a);for(const g of this.synchronisers){if(l.isCancellationRequested)return;try{await g.sync(i,u)}catch(w){if(w instanceof S.UserDataSyncError)switch(w.code){case S.UserDataSyncErrorCode.TooLarge:throw new S.UserDataSyncError(w.message,w.code,g.resource);case S.UserDataSyncErrorCode.TooManyRequests:case S.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case S.UserDataSyncErrorCode.LocalTooManyRequests:case S.UserDataSyncErrorCode.Gone:case S.UserDataSyncErrorCode.UpgradeRequired:case S.UserDataSyncErrorCode.IncompatibleRemoteContent:case S.UserDataSyncErrorCode.IncompatibleLocalContent:throw w}const d=S.UserDataSyncError.toUserDataSyncError(w);this.reportUserDataSyncError(d,a),this.logService.error(w),this.logService.error(`${g.resource}: ${(0,E.toErrorMessage)(w)}`),this._syncErrors.push([g.resource,d])}}this.logService.info(`Sync done. Took ${new Date().getTime()-o}ms`),this.updateLastSyncTime()}catch(u){const g=S.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(g,a),g}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(a){this.logService.error(a)}}async replace(i){await this.checkEnablement();for(const a of this.synchronisers)if(await a.replace(i))return}async accept(i,a,l,o){await this.checkEnablement();const u=this.getSynchroniser(i);await u.accept(a,l),o&&await u.apply(!1,(0,S.createSyncHeaders)((0,D.generateUuid)()))}async resolveContent(i){for(const a of this.synchronisers){const l=await a.resolveContent(i);if(l)return l}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,a){return this.getSynchroniser(i).getAssociatedResources(a)}getMachineId(i,a){return this.getSynchroniser(i).getMachineId(a)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const a of i)if(await a.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(f,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(a){this.logService.error(`${i.resource}: ${(0,E.toErrorMessage)(a)}`),this.logService.error(a)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const a=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),a==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();(0,y.equals)(this._conflicts,i,([a,l],[o,u])=>a===a&&(0,y.equals)(l,u,(g,w)=>(0,h.isEqual)(g.previewResource,w.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(f,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,a){this.telemetryService.publicLog2("sync/error",{code:i.code,url:i instanceof S.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:a,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(t)])}getSynchroniser(i){return this.synchronisers.find(a=>a.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};s=fe([K(0,S.IUserDataSyncStoreService),K(1,S.IUserDataSyncStoreManagementService),K(2,P.IInstantiationService),K(3,S.IUserDataSyncLogService),K(4,n.ITelemetryService),K(5,v.IStorageService)],s),e.UserDataSyncService=s;class c extends L.Disposable{constructor(i,a,l,o,u){super();this.id=i,this.manifest=a,this.syncHeaders=l,this.synchronisers=o,this.logService=u,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,b.createCancelablePromise)(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,a){try{return await this.performAction(i,l=>l.accept(i,a))}catch(l){throw this.logService.error(l),l}}async merge(i){try{return i?await this.performAction(i,a=>a.merge(i)):await this.mergeAll()}catch(a){throw this.logService.error(a),a}}async discard(i){try{return await this.performAction(i,a=>a.discard(i))}catch(a){throw this.logService.error(a),a}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,a]of this.previews)for(const l of a.resourcePreviews)l.mergeState==="conflict"&&i.push(l.previewResource);for(const a of i)await this.discard(a);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[a,l]of this.previews){this.synchronizingResources.push([a,l.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(g=>g.resource===a);for(const g of l.resourcePreviews)(g.localChange!==0||g.remoteChange!==0)&&g.mergeState==="preview"&&await o.merge(g.previewResource);const u=await o.apply(!1,this.syncHeaders);u&&i.push(this.toSyncResourcePreview(o.resource,u)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,a]of this.previews){this.synchronizingResources.push([i,a.resourcePreviews.map(o=>o.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(o=>o.resource===i);for(const o of a.resourcePreviews)await l.accept(o.remoteResource);await l.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(o=>o[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,a]of this.previews){this.synchronizingResources.push([i,a.resourcePreviews.map(o=>o.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(o=>o.resource===i);for(const o of a.resourcePreviews)await l.accept(o.localResource);await l.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(o=>o[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(a){(0,I.isPromiseCanceledError)(a)||this.logService.error(a)}this.reset()}async performAction(i,a){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const l=this.previews.findIndex(([,$])=>$.resourcePreviews.some(({localResource:z,previewResource:V,remoteResource:B})=>(0,h.isEqual)(i,z)||(0,h.isEqual)(i,V)||(0,h.isEqual)(i,B)));if(l===-1)return this.previews;const[o,u]=this.previews[l],g=u.resourcePreviews.find(({localResource:$,remoteResource:z,previewResource:V})=>(0,h.isEqual)($,i)||(0,h.isEqual)(z,i)||(0,h.isEqual)(V,i));if(!g)return this.previews;let w=this.synchronizingResources.find($=>$[0]===o);w||(w=[o,[]],this.synchronizingResources.push(w)),w[1].some($=>(0,h.isEqual)($,g.localResource))||(w[1].push(g.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const d=this.synchronisers.find($=>$.resource===this.previews[l][0]),T=await a(d);T?this.previews.splice(l,1,this.toSyncResourcePreview(d.resource,T)):this.previews.splice(l,1);const O=this.synchronizingResources.findIndex($=>$[0]===o);return this.synchronizingResources[O][1].splice(w[1].findIndex($=>(0,h.isEqual)($,g.localResource)),1),w[1].length||(this.synchronizingResources.splice(O,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[a,l]of this.previews){this.synchronizingResources.push([a,l.resourcePreviews.map(g=>g.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(g=>g.resource===a);let u=l;for(const g of l.resourcePreviews)(g.localChange!==0||g.remoteChange!==0)&&g.mergeState==="preview"&&(u=await o.merge(g.previewResource));u&&i.push(this.toSyncResourcePreview(o.resource,u)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(g=>g[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const a=[];for(const l of this.synchronisers){if(i.isCancellationRequested)return[];const o=await l.preview(this.manifest,this.syncHeaders);o&&a.push(this.toSyncResourcePreview(l.resource,o))}return a}toSyncResourcePreview(i,a){return[i,{isLastSyncFromCurrentMachine:a.isLastSyncFromCurrentMachine,resourcePreviews:a.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(X[202],Q([0,1,3,22,4,2,16]),function(G,e,S,L,P,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(y,v){this.service=y,this.logService=v,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new S.Emitter}listen(y,v){switch(v){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${v}`)}async call(y,v,m){try{return await this._call(y,v,m)}catch(h){throw this.logService.error(h),h}}async _call(y,v,m){switch(v){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(P.URI.revive(m[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(m[0],P.URI.revive(m[1]),m[2],m[3]);case"resolveContent":return this.service.resolveContent(P.URI.revive(m[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(m[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(m[0]);case"getAssociatedResources":return this.service.getAssociatedResources(m[0],{created:m[1].created,uri:P.URI.revive(m[1].uri)});case"getMachineId":return this.service.getMachineId(m[0],{created:m[1].created,uri:P.URI.revive(m[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(v.startsWith("manualSync/")){const h=v.substring("manualSync/".length),C=m[0],D=this.getManualSyncTask(C);switch(m=m.slice(1),h){case"preview":return D.preview();case"accept":return D.accept(P.URI.revive(m[0]),m[1]);case"merge":return D.merge(P.URI.revive(m[0]));case"discard":return D.discard(P.URI.revive(m[0]));case"discardConflicts":return D.discardConflicts();case"apply":return D.apply();case"pull":return D.pull();case"push":return D.push();case"stop":return D.stop();case"_getStatus":return D.status;case"dispose":return this.disposeManualSyncTask(D)}}throw new Error("Invalid call")}getManualSyncTask(y){const v=this.manualSyncTasks.get(this.createKey(y));if(!v)throw new Error(`Manual sync taks not found: ${y}`);return v.manualSyncTask}async createManualSyncTask(){const y=new k.DisposableStore,v=y.add(await this.service.createManualSyncTask());return y.add(v.onSynchronizeResources(m=>this.onManualSynchronizeResources.fire({manualSyncTaskId:v.id,data:m}))),this.manualSyncTasks.set(this.createKey(v.id),{manualSyncTask:v,disposables:y}),{id:v.id,manifest:v.manifest,status:v.status}}disposeManualSyncTask(y){y.dispose();const v=this.createKey(y.id);this.manualSyncTasks.get(v)?.disposables.dispose(),this.manualSyncTasks.delete(v)}createKey(y){return`manualSyncTask-${y}`}}e.UserDataSyncChannel=R;class p extends k.Disposable{constructor(y){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new S.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new S.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new S.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new S.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(v,m,h){return y.call(v,m,h).then(null,C=>{throw L.UserDataSyncError.toUserDataSyncError(C)})},listen(v,m){return y.listen(v,m)}},this.channel.call("_getInitialData").then(([v,m,h])=>{this.updateStatus(v),this.updateConflicts(m),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(C=>this.updateStatus(C))),this._register(this.channel.listen("onDidChangeLastSyncTime")(C=>this.updateLastSyncTime(C)))}),this._register(this.channel.listen("onDidChangeConflicts")(v=>this.updateConflicts(v))),this._register(this.channel.listen("onSyncErrors")(v=>this._onSyncErrors.fire(v.map(([m,h])=>[m,L.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:y,manifest:v,status:m}=await this.channel.call("createManualSyncTask"),h=this,C=new E(y,v,m,{async call(D,b,I){return h.channel.call(`manualSync/${D}`,[y,...(0,A.isArray)(b)?b:[b]],I)},listen(D,b){return S.Event.map(S.Event.filter(h.channel.listen(`manualSync/${D}`,b),I=>!C.isDiposed()&&I.manualSyncTaskId===y),I=>I.data)}});return C}replace(y){return this.channel.call("replace",[y])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(y,v,m,h){return this.channel.call("accept",[y,v,m,h])}resolveContent(y){return this.channel.call("resolveContent",[y])}async getLocalSyncResourceHandles(y){return(await this.channel.call("getLocalSyncResourceHandles",[y])).map(({created:m,uri:h})=>({created:m,uri:P.URI.revive(h)}))}async getRemoteSyncResourceHandles(y){return(await this.channel.call("getRemoteSyncResourceHandles",[y])).map(({created:m,uri:h})=>({created:m,uri:P.URI.revive(h)}))}async getAssociatedResources(y,v){return(await this.channel.call("getAssociatedResources",[y,v])).map(({resource:h,comparableResource:C})=>({resource:P.URI.revive(h),comparableResource:P.URI.revive(C)}))}async getMachineId(y,v){return this.channel.call("getMachineId",[y,v])}async updateStatus(y){this._status=y,this._onDidChangeStatus.fire(y)}async updateConflicts(y){this._conflicts=y.map(([v,m])=>[v,m.map(h=>({...h,localResource:P.URI.revive(h.localResource),remoteResource:P.URI.revive(h.remoteResource),previewResource:P.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(y){this._lastSyncTime!==y&&(this._lastSyncTime=y,this._onDidChangeLastSyncTime.fire(y))}}e.UserDataSyncChannelClient=p;class E extends k.Disposable{constructor(y,v,m,h){super();this.id=y,this.manifest=v,this._disposed=!1,this._status=m;const C=this;this.channel={async call(D,b,I){try{const f=await h.call(D,b,I);return C.isDiposed()||(C._status=await h.call("_getStatus")),f}catch(f){throw L.UserDataSyncError.toUserDataSyncError(f)}},listen(D,b){return h.listen(D,b)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const y=await this.channel.call("preview");return this.deserializePreviews(y)}async accept(y,v){const m=await this.channel.call("accept",[y,v]);return this.deserializePreviews(m)}async merge(y){const v=await this.channel.call("merge",[y]);return this.deserializePreviews(v)}async discard(y){const v=await this.channel.call("discard",[y]);return this.deserializePreviews(v)}async discardConflicts(){const y=await this.channel.call("discardConflicts");return this.deserializePreviews(y)}async apply(){const y=await this.channel.call("apply");return this.deserializePreviews(y)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(y){return y.map(([v,m])=>[v,{isLastSyncFromCurrentMachine:m.isLastSyncFromCurrentMachine,resourcePreviews:m.resourcePreviews.map(h=>({...h,localResource:P.URI.revive(h.localResource),remoteResource:P.URI.revive(h.remoteResource),previewResource:P.URI.revive(h.previewResource),acceptedResource:P.URI.revive(h.acceptedResource)}))}])}}}),define(X[203],Q([0,1,2,22,39,15,29,24,28,45,12,13,20,30,7,3,6,16,4,9,92]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h,C,D,b,I,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const c="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",a=100,l=1e3*60*5;let o=class extends S.Disposable{constructor(O,$,z){super();this.productService=O,this.configurationService=$,this.storageService=z,this._onDidChangeUserDataSyncStore=this._register(new C.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(C.Event.filter(z.onDidChangeValue,V=>V.key===L.SYNC_SERVICE_URL_TYPE&&V.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(L.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(L.SYNC_SERVICE_URL_TYPE,O,0,h.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[L.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(L.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,$){O=h.isWeb&&O?.web?{...O,...O.web}:O;const z={...O||{},...$||{}};if(z&&(0,b.isString)(z.url)&&(0,b.isObject)(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(V=>(0,b.isArray)(z.authenticationProviders[V].scopes))){const V=z,B=!!V.canSwitch&&!$?.url,M=V.url===V.insidersUrl?"insiders":"stable",_=(B?this.userDataSyncStoreType:void 0)||M,N=$?.url||(_==="insiders"?V.insidersUrl:_==="stable"?V.stableUrl:V.url);return{url:I.URI.parse(N),type:_,defaultType:M,defaultUrl:I.URI.parse(V.url),stableUrl:I.URI.parse(V.stableUrl),insidersUrl:I.URI.parse(V.insidersUrl),canSwitch:B,authenticationProviders:Object.keys(V.authenticationProviders).reduce((j,F)=>(j.push({id:F,scopes:V.authenticationProviders[F].scopes}),j),[])}}}};o=fe([K(0,p.IProductService),K(1,R.IConfigurationService),K(2,v.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let u=class extends o{constructor(O,$,z){super(O,$,z);const V=this.storageService.get(c,0);V&&(this.previousConfigurationSyncStore=JSON.parse(V));const B=this.productService[L.CONFIGURATION_SYNC_STORE_KEY];B?this.storageService.store(c,JSON.stringify(B),0,1):this.storageService.remove(c,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=fe([K(0,p.IProductService),K(1,R.IConfigurationService),K(2,v.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let g=class extends S.Disposable{constructor(O,$,z,V,B,M,_){super();this.requestService=z,this.logService=V,this.storageService=_,this._onTokenFailed=this._register(new C.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new C.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new C.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,E.getServiceMachineId)(B,M,_).then(N=>{const j={"X-Client-Name":`${$.applicationName}${h.isWeb?"-web":""}`,"X-Client-Version":$.version,"X-Machine-Id":N};return $.commit&&(j["X-Client-Commit"]=$.commit),j}),this.session=new d(a,l,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,S.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,$){this.authToken={token:O,type:$}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,k.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(t,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)($=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),$).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,$=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O),z={},V=await this.request($.toString(),{type:"GET",headers:z},[],A.CancellationToken.None);return(await(0,P.asJson)(V)||[]).map(({url:M,created:_})=>({ref:(0,k.relativePath)($,$.with({path:M})),created:_*1e3}))}async resolveContent(O,$){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O,$).toString(),V={};V["Cache-Control"]="no-cache";const B=await this.request(z,{type:"GET",headers:V},[],A.CancellationToken.None);return await(0,P.asText)(B)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),z={};await this.request($,{type:"DELETE",headers:z},[],A.CancellationToken.None)}async read(O,$,z={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();z={...z},z["Cache-Control"]="no-cache",$&&(z["If-None-Match"]=$.ref);const B=await this.request(V,{type:"GET",headers:z},[304],A.CancellationToken.None);if(B.res.statusCode===304)return $;const M=B.res.headers.etag;if(!M)throw new L.UserDataSyncStoreError("Server did not return the ref",V,L.UserDataSyncErrorCode.NoRef,B.res.headers[L.HEADER_OPERATION_ID]);const _=await(0,P.asText)(B);return{ref:M,content:_}}async write(O,$,z,V={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();V={...V},V["Content-Type"]=s.Mimes.text,z&&(V["If-Match"]=z);const M=await this.request(B,{type:"POST",data:$,headers:V},[],A.CancellationToken.None),_=M.res.headers.etag;if(!_)throw new L.UserDataSyncStoreError("Server did not return the ref",B,L.UserDataSyncErrorCode.NoRef,M.res.headers[L.HEADER_OPERATION_ID]);return _}async manifest(O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,k.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();O={...O},O["Content-Type"]="application/json";const z=await this.request($,{type:"GET",headers:O},[],A.CancellationToken.None),V=await(0,P.asJson)(z),B=this.storageService.get(r,0);return B&&V&&B!==V.session&&this.clearSession(),V===null&&B&&this.clearSession(),V&&this.storageService.store(r,V.session,0,1),V}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,k.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),$={"Content-Type":s.Mimes.text};await this.request(O,{type:"DELETE",headers:$},[],A.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(i,0)}async request(O,$,z,V){if(!this.authToken)throw new L.UserDataSyncStoreError("No Auth Token Available",O,L.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of too many requests (429).`,O,L.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const B=await this.commonHeadersPromise;$.headers={...$.headers||{},...B,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders($.headers),this.logService.trace("Sending request to server",{url:O,type:$.type,headers:{...$.headers,authorization:void 0}});let M;try{M=await this.session.request(O,$,V)}catch(F){if(!(F instanceof L.UserDataSyncStoreError)){const U=(0,f.isPromiseCanceledError)(F)?L.UserDataSyncErrorCode.RequestCanceled:(0,f.getErrorMessage)(F).startsWith("XHR timeout")?L.UserDataSyncErrorCode.RequestTimeout:L.UserDataSyncErrorCode.RequestFailed;F=new L.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,U,void 0)}throw this.logService.info("Request failed",O),F}const _=M.res.headers[L.HEADER_OPERATION_ID],N={url:O,status:M.res.statusCode,"execution-id":$.headers[L.HEADER_EXECUTION_ID],"operation-id":_},j=(0,P.isSuccess)(M)||M.res.statusCode&&z.indexOf(M.res.statusCode)!==-1;if(j?this.logService.trace("Request succeeded",N):this.logService.info("Request failed",N),M.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new L.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,L.UserDataSyncErrorCode.Unauthorized,_);if(this._onTokenSucceed.fire(),M.res.statusCode===409)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,L.UserDataSyncErrorCode.Conflict,_);if(M.res.statusCode===410)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because the requested resource is not longer available (410).`,O,L.UserDataSyncErrorCode.Gone,_);if(M.res.statusCode===412)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,L.UserDataSyncErrorCode.PreconditionFailed,_);if(M.res.statusCode===413)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of too large payload (413).`,O,L.UserDataSyncErrorCode.TooLarge,_);if(M.res.statusCode===426)throw new L.UserDataSyncStoreError(`${$.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,L.UserDataSyncErrorCode.UpgradeRequired,_);if(M.res.statusCode===429){const F=M.res.headers["retry-after"];throw F?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(F)*1e3)),new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of too many requests (429).`,O,L.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,_)):new L.UserDataSyncStoreError(`${$.type} request '${O}' failed because of too many requests (429).`,O,L.UserDataSyncErrorCode.TooManyRequests,_)}if(!j)throw new L.UserDataSyncStoreError("Server returned "+M.res.statusCode,O,L.UserDataSyncErrorCode.Unknown,_);return M}addSessionHeaders(O){let $=this.storageService.get(i,0);$===void 0&&($=(0,m.generateUuid)(),this.storageService.store(i,$,0,1)),O["X-Machine-Session-Id"]=$;const z=this.storageService.get(r,0);z!==void 0&&(O["X-User-Session-Id"]=z)}};g=fe([K(1,p.IProductService),K(2,P.IRequestService),K(3,L.IUserDataSyncLogService),K(4,n.IEnvironmentService),K(5,y.IFileService),K(6,v.IStorageService)],g),e.UserDataSyncStoreClient=g;let w=class extends g{constructor(O,$,z,V,B,M,_){super(O.userDataSyncStore?.url,$,z,V,B,M,_);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};w=fe([K(0,L.IUserDataSyncStoreManagementService),K(1,p.IProductService),K(2,P.IRequestService),K(3,L.IUserDataSyncLogService),K(4,n.IEnvironmentService),K(5,y.IFileService),K(6,v.IStorageService)],w),e.UserDataSyncStoreService=w;class d{constructor(O,$,z,V){this.limit=O,this.interval=$,this.requestService=z,this.logService=V,this.requests=[],this.startTime=void 0}request(O,$,z){if(this.isExpired()&&this.reset(),$.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new L.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,L.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request($,z)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=d}),define(X[204],Q([0,1,22,3,58,86,60,21,20,61,28]),function(G,e,S,L,P,k,A,R,p,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let y=class extends k.UserDataAutoSyncService{constructor(m,h,C,D,b,I,f,s,c,t,r,i){super(m,h,C,D,b,f,s,c,t,r,i);this._register(L.Event.debounce(L.Event.any(L.Event.map(I.onDidFocusWindow,()=>"windowFocus"),L.Event.map(I.onDidOpenWindow,()=>"windowOpen")),(a,l)=>a?[...a,l]:[l],1e3)(a=>this.triggerSync(a,!0,!1)))}};y=fe([K(0,n.IProductService),K(1,S.IUserDataSyncStoreManagementService),K(2,S.IUserDataSyncStoreService),K(3,S.IUserDataSyncResourceEnablementService),K(4,S.IUserDataSyncService),K(5,P.INativeHostService),K(6,S.IUserDataSyncLogService),K(7,A.IUserDataSyncAccountService),K(8,R.ITelemetryService),K(9,E.IUserDataSyncMachinesService),K(10,p.IStorageService),K(11,S.IUserDataAutoSyncEnablementService)],y),e.UserDataAutoSyncService=y}),define(X[205],Q([0,1,3,2,6]),function(G,e,S,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends L.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:p,getActiveWindowId:E}){super();this.disposables=this._register(new L.DisposableStore),S.Event.latch(S.Event.any(R,p))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,P.createCancelablePromise)(()=>E()),(async()=>{try{const y=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:y}catch(y){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(X[62],Q([0,1,108,8,49,6,18,212,213,16]),function(G,e,S,L,P,k,A,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=n;function y(c){const t=c.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function v(c){if(c instanceof n)return c;let t;return/end of central directory record signature not found/.test(c.message)&&(t="CorruptZip"),new n(t,c)}function m(c,t,r,i,a,l){const o=L.dirname(t),u=L.join(i,o);if(!u.startsWith(i))return Promise.reject(new Error(S.localize(0,null,t)));const g=L.join(i,t);let w;return l.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(A.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((d,T)=>{if(!l.isCancellationRequested)try{w=(0,P.createWriteStream)(g,{mode:r}),w.once("close",()=>d()),w.once("error",T),c.once("error",T),c.pipe(w)}catch(O){T(O)}}))}function h(c,t,r,i){let a=(0,k.createCancelablePromise)(()=>Promise.resolve()),l=0;return i.onCancellationRequested(()=>{a.cancel(),c.close()}),new Promise((o,u)=>{const g=new k.Sequencer,w=d=>{d.isCancellationRequested||(l++,c.readEntry())};c.once("error",u),c.once("close",()=>a.then(()=>{i.isCancellationRequested||c.entryCount===l?o():u(new n("Incomplete",new Error(S.localize(1,null,l,c.entryCount))))},u)),c.readEntry(),c.on("entry",d=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(d.fileName)){w(i);return}const T=d.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(T)){const z=L.join(t,T);a=(0,k.createCancelablePromise)(V=>A.Promises.mkdir(z,{recursive:!0}).then(()=>w(V)).then(void 0,u));return}const O=D(c,d),$=y(d);a=(0,k.createCancelablePromise)(z=>g.queue(()=>O.then(V=>m(V,T,$,t,r,z).then(()=>w(z)))).then(null,u))})})}function C(c,t=!1){return new Promise((r,i)=>{(0,R.open)(c,t?{lazyEntries:!0}:void 0,(a,l)=>{a?i(v(a)):r((0,E.assertIsDefined)(l))})})}function D(c,t){return new Promise((r,i)=>{c.openReadStream(t,(a,l)=>{a?i(v(a)):r((0,E.assertIsDefined)(l))})})}function b(c,t){return new Promise((r,i)=>{const a=new p.ZipFile;t.forEach(o=>{o.contents?a.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&a.addFile(o.localPath,o.path)}),a.end();const l=(0,P.createWriteStream)(c);a.outputStream.pipe(l),a.outputStream.once("error",i),l.once("error",i),l.once("finish",()=>r(c))})}e.zip=b;function I(c,t,r={},i){const a=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let l=C(c,!0);return r.overwrite&&(l=l.then(o=>A.Promises.rm(t).then(()=>o))),l.then(o=>h(o,t,{sourcePathRegex:a},i))}e.extract=I;function f(c,t){return C(c).then(r=>new Promise((i,a)=>{r.on("entry",l=>{l.fileName===t&&D(r,l).then(o=>i(o),o=>a(o))}),r.once("close",()=>a(new Error(S.localize(2,null,t))))}))}function s(c,t){return f(c,t).then(r=>new Promise((i,a)=>{const l=[];r.once("error",a),r.on("data",o=>l.push(o)),r.on("end",()=>i(Buffer.concat(l)))}))}e.buffer=s}),define(X[206],Q([0,1,62,114]),function(G,e,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function P(k){return(0,S.buffer)(k,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch(R){throw new Error((0,L.localize)(0,null))}})}e.getManifest=P}),define(X[207],Q([0,1,57,2,18,8,14,27,31,6,4,12,135,115,28,62,7,23,17,13,15,30,9]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h,C,D,b,I,f,s,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",i="scanningUser",a="extracting",l="deleting",o="renaming";let u=class extends L.Disposable{constructor(w,d,T,O,$){super();this.beforeRemovingExtension=w,this.fileService=d,this.logService=T,this.environmentService=O,this.productService=$,this._devSystemExtensionsPath=null,this.systemExtensionsPath=O.builtinExtensionsPath,this.extensionsPath=O.extensionsPath,this.uninstalledPath=k.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new E.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(w){const d=[];(w===null||w===0)&&d.push(this.scanSystemExtensions().then(null,T=>Promise.reject(new R.ExtensionManagementError(this.joinErrors(T).message,r)))),(w===null||w===1)&&d.push(this.scanUserExtensions(!0).then(null,T=>Promise.reject(new R.ExtensionManagementError(this.joinErrors(T).message,i))));try{const T=await Promise.all(d);return(0,b.flatten)(T)}catch(T){throw this.joinErrors(T)}}async scanUserExtensions(w){this.logService.trace("Started scanning user extensions");let[d,T]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return T=T.filter(O=>!d[new p.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),w&&(T=(0,p.groupByExtension)(T,$=>$.identifier).map($=>$.sort((z,V)=>S.rcompare(z.manifest.version,V.manifest.version))[0])),this.logService.trace("Scanned user extensions:",T.length),T}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(w,d,T){const O=w.key(),$=k.join(this.extensionsPath,`.${(0,c.generateUuid)()}`),z=k.join(this.extensionsPath,O);try{await P.Promises.rm(z)}catch(B){try{await P.Promises.rm(z)}catch(M){}throw new R.ExtensionManagementError((0,m.localize)(0,null,z,w.id),l)}await this.extractAtLocation(w,d,$,T);let V=await this.scanExtension(n.URI.file($),1);if(!V)throw new Error((0,m.localize)(1,null,$));await this.storeMetadata(V,{installedTimestamp:Date.now()});try{await this.rename(w,$,z,Date.now()+2*60*1e3),this.logService.info("Renamed to",z)}catch(B){try{await P.Promises.rm($)}catch(M){}if(B.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",w.id);else throw this.logService.info(`Rename failed because of ${(0,t.getErrorMessage)(B)}. Deleted from extracted location`,$),B}try{V=await this.scanExtension(n.URI.file(z),1)}catch(B){}if(V)return V;throw new Error((0,m.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(w,d){return this.setMetadata(w,d),await this.storeMetadata(w,{...d,installedTimestamp:w.installedTimestamp}),w}async storeMetadata(w,d){d.isMachineScoped=d.isMachineScoped||void 0,d.isBuiltin=d.isBuiltin||void 0,d.installedTimestamp=d.installedTimestamp||void 0;const T=k.join(w.location.fsPath,"package.json"),O=await P.Promises.readFile(T,"utf8"),{manifest:$}=await this.parseManifest(O);return $.__metadata=d,await P.Promises.writeFile(T,JSON.stringify($,null,"	")),w}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...w){const d=w.map(T=>new p.ExtensionIdentifierWithVersion(T.identifier,T.manifest.version));await this.withUninstalledExtensions(T=>{d.forEach(O=>T[O.key()]=!0)})}async setInstalled(w){await this.withUninstalledExtensions(O=>delete O[w.key()]);const T=(await this.scanExtensions(1)).find(O=>new p.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).equals(w))||null;return T?(await this.storeMetadata(T,{installedTimestamp:Date.now()}),this.scanExtension(T.location,1)):null}async withUninstalledExtensions(w){return this.uninstalledFileLimiter.queue(async()=>{let d;try{d=await P.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let T={};if(d)try{T=JSON.parse(d)}catch(O){}return w&&(w(T),Object.keys(T).length?await P.Promises.writeFile(this.uninstalledPath,JSON.stringify(T)):await P.Promises.rm(this.uninstalledPath)),T})}async removeExtension(w,d){this.logService.trace(`Deleting ${d} extension from disk`,w.identifier.id,w.location.fsPath),await P.Promises.rm(w.location.fsPath),this.logService.info("Deleted from disk",w.identifier.id,w.location.fsPath)}async removeUninstalledExtension(w){await this.removeExtension(w,"uninstalled"),await this.withUninstalledExtensions(d=>delete d[new p.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()])}async extractAtLocation(w,d,T,O){this.logService.trace(`Started extracting the extension from ${d} to ${T}`);try{await P.Promises.rm(T)}catch($){throw new R.ExtensionManagementError(this.joinErrors($).message,l)}try{await(0,C.extract)(d,T,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${T}:`,w.id)}catch($){try{await P.Promises.rm(T)}catch(z){}throw new R.ExtensionManagementError($.message,$ instanceof C.ExtractError&&$.type?$.type:a)}}async rename(w,d,T,O){try{await P.Promises.rename(d,T)}catch($){if(D.isWindows&&$&&$.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${d} to ${T} with 'EPERM' error. Trying again...`,w.id),this.rename(w,d,T,O);throw new R.ExtensionManagementError($.message||(0,m.localize)(3,null,d,T),$.code||o)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const w=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return w;const d=this.scanDevSystemExtensions(),[T,O]=await Promise.all([w,d]);return[...T,...O]}async scanExtensionsInDir(w,d){const T=new E.Limiter(10),O=await this.fileService.resolve(n.URI.file(w));return O.children?(await Promise.all(O.children.filter(z=>z.isDirectory).map(z=>T.queue(async()=>d===1&&(0,s.basename)(z.resource).indexOf(".")===0?null:this.scanExtension(z.resource,d))))).filter(z=>z&&z.identifier):[]}async scanExtension(w,d){try{const T=await this.fileService.resolve(w);if(T.children){const{manifest:O,metadata:$}=await this.readManifest(w.fsPath),z=T.children.find(({name:_})=>/^readme(\.txt|\.md|)$/i.test(_))?.resource,V=T.children.find(({name:_})=>/^changelog(\.txt|\.md|)$/i.test(_))?.resource,B={id:(0,p.getGalleryExtensionId)(O.publisher,O.name)},M={type:d,identifier:B,manifest:O,location:w,readmeUrl:z,changelogUrl:V,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:d===0};return $&&(this.setMetadata(M,$),M.installedTimestamp=$.installedTimestamp),M}}catch(T){d!==0&&this.logService.trace(T)}return null}async scanDefaultSystemExtensions(){const w=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",w.length),w}async scanDevSystemExtensions(){const w=this.getDevSystemExtensionsList();if(w.length){const d=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",d.length),d.filter(T=>w.some(O=>(0,p.areSameExtensions)(T.identifier,{id:O})))}else return[]}setMetadata(w,d){w.publisherDisplayName=d.publisherDisplayName||null,w.publisherId=d.publisherId||null,w.identifier.uuid=d.id,w.isMachineScoped=!!d.isMachineScoped,w.isBuiltin=w.type===0||!!d.isBuiltin}async removeUninstalledExtensions(){const w=await this.getUninstalledExtensions(),d=await this.scanAllUserExtensions(),T=new Set;for(const z of d)w[new p.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]||T.add(z.identifier.id.toLowerCase());const O=(0,p.groupByExtension)(d,z=>z.identifier);await E.Promises.settled(O.map(async z=>{const V=z.sort((B,M)=>S.rcompare(B.manifest.version,M.manifest.version))[0];T.has(V.identifier.id.toLowerCase())||await this.beforeRemovingExtension(V)}));const $=d.filter(z=>w[new p.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version).key()]);await E.Promises.settled($.map(z=>this.removeUninstalledExtension(z)))}async removeOutdatedExtensions(){const w=await this.scanAllUserExtensions(),d=[],T=(0,p.groupByExtension)(w,O=>O.identifier);d.push(...(0,b.flatten)(T.map(O=>O.sort(($,z)=>S.rcompare($.manifest.version,z.manifest.version)).slice(1)))),await E.Promises.settled(d.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(w=>w.name)}joinErrors(w){const d=Array.isArray(w)?w:[w];return d.length===1?d[0]instanceof Error?d[0]:new Error(d[0]):d.reduce((T,O)=>new Error(`${T.message}${T.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=k.normalize(k.join(I.FileAccess.asFileUri("",G).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(w){const d=[P.Promises.readFile(k.join(w,"package.json"),"utf8").then(z=>this.parseManifest(z)),P.Promises.readFile(k.join(w,"package.nls.json"),"utf8").then(void 0,z=>z.code!=="ENOENT"?Promise.reject(z):"{}").then(z=>JSON.parse(z))],[{manifest:T,metadata:O},$]=await Promise.all(d);return{manifest:(0,v.localizeManifest)(T,$),metadata:O}}parseManifest(w){return new Promise((d,T)=>{try{const O=JSON.parse(w),$=O.__metadata||null;d({manifest:O,metadata:$})}catch(O){T(new Error((0,m.localize)(4,null)))}})}};u=fe([K(1,f.IFileService),K(2,A.ILogService),K(3,y.INativeEnvironmentService),K(4,h.IProductService)],u),e.ExtensionsScanner=u}),define(X[208],Q([0,1,113,8,18,62,27,31,12,57,4,44,7,14,146,43,21,70,15,30,72,5,17,206,156,207,157,158,13,175]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h,C,D,b,I,f,s,c,t,r,i,a,l,o,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const w="unsetUninstalled",d="downloading";let T=class extends g.AbstractExtensionManagementService{constructor(M,_,N,j,F,U,x){super(M,_,N);this.environmentService=j,this.downloadService=F;const q=this._register(U.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(U.createInstance(a.ExtensionsScanner,Y=>q.postUninstall(Y))),this.manifestCache=this._register(new h.ExtensionsManifestCache(j,this)),this.extensionsDownloader=this._register(U.createInstance(i.ExtensionsDownloader));const H=this._register(new o.ExtensionsWatcher(this,x,j,N));this._register(H.onDidChangeExtensionsByAnotherSource(({added:Y,removed:te})=>{Y.length&&this._onDidInstallExtensions.fire(Y.map(ne=>({identifier:ne.identifier,operation:0,local:ne}))),te.forEach(ne=>this._onDidUninstallExtension.fire({identifier:ne}))}))}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const _=await this.collectFiles(M),N=await(0,k.zip)((0,I.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)()).fsPath,_);return n.URI.file(N)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const _=await this.downloadVsix(M),N=L.resolve(_.fsPath);return(0,r.getManifest)(N)}getInstalled(M=null){return this.extensionsScanner.scanExtensions(M)}async canInstall(M){return!0}async install(M,_={}){this.logService.trace("ExtensionManagementService#install",M.toString());const N=await this.downloadVsix(M),j=await(0,r.getManifest)(L.resolve(N.fsPath));if(j.engines&&j.engines.vscode&&!(0,b.isEngineValid)(j.engines.vscode,y.default.version,y.default.date))throw new Error(S.localize(0,null,(0,R.getGalleryExtensionId)(j.publisher,j.name),y.default.version));return this.installExtension(j,N,_)}async updateMetadata(M,_){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},..._}),this.manifestCache.invalidate(),M}async updateExtensionScope(M,_){return this.logService.trace("ExtensionManagementService#updateExtensionScope",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},isMachineScoped:_}),this.manifestCache.invalidate(),M}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(M){if(M.scheme===t.Schemas.file)return M;if(!this.downloadService)throw new Error("Download service is not available");const _=(0,I.joinPath)(this.environmentService.tmpDir,(0,f.generateUuid)());return await this.downloadService.download(M,_),_}createInstallExtensionTask(M,_,N){return n.URI.isUri(_)?new z(M,_,N,this.galleryService,this.extensionsScanner,this.logService):new $(_,N,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(M,_){return new V(M,_,this.extensionsScanner)}async collectFiles(M){const _=async j=>{let F=await P.Promises.readdir(j);F=F.map(q=>L.join(j,q));const U=await Promise.all(F.map(q=>P.Promises.stat(q)));let x=Promise.resolve([]);return U.forEach((q,H)=>{const Y=F[H];q.isFile()&&(x=x.then(te=>[...te,Y])),q.isDirectory()&&(x=x.then(te=>_(Y).then(ne=>[...te,...ne])))}),x};return(await _(M.location.fsPath)).map(j=>({path:`extension/${L.relative(M.location.fsPath,j)}`,localPath:j}))}};T=fe([K(0,A.IExtensionGalleryService),K(1,D.ITelemetryService),K(2,m.ILogService),K(3,p.INativeEnvironmentService),K(4,(0,c.optional)(s.IDownloadService)),K(5,c.IInstantiationService),K(6,u.IFileService)],T),e.ExtensionManagementService=T;class O extends g.AbstractExtensionTask{constructor(M,_,N,j){super();this.identifier=M,this.source=_,this.extensionsScanner=N,this.logService=j,this._operation=1}get operation(){return this._operation}async installExtension(M,_){try{const N=await this.unsetUninstalledAndGetLocal(M.identifierWithVersion);if(N)return M.metadata?this.extensionsScanner.saveMetadataForLocalExtension(N,M.metadata):N}catch(N){throw v.isMacintosh?new A.ExtensionManagementError(S.localize(1,null),w):new A.ExtensionManagementError(S.localize(2,null),w)}return this.extract(M,_)}async unsetUninstalledAndGetLocal(M){if(!await this.isUninstalled(M))return null;this.logService.trace("Removing the extension from uninstalled list:",M.id);const N=await this.extensionsScanner.setInstalled(M);return this.logService.info("Removed the extension from uninstalled list:",M.id),N}async isUninstalled(M){return!!(await this.extensionsScanner.getUninstalledExtensions())[M.key()]}async extract({zipPath:M,identifierWithVersion:_,metadata:N},j){let F=await this.extensionsScanner.extractUserExtension(_,M,j);return this.logService.info("Extracting completed.",_.id),N&&(F=await this.extensionsScanner.saveMetadataForLocalExtension(F,N)),F}}class $ extends O{constructor(M,_,N,j,F){super(M.identifier,M,j,F);this.gallery=M,this.options=_,this.extensionsDownloader=N}async doRun(M){const N=(await this.extensionsScanner.scanExtensions(null)).find(U=>(0,R.areSameExtensions)(U.identifier,this.gallery.identifier));N&&(this._operation=2);const j=await this.downloadInstallableExtension(this.gallery,this._operation);j.metadata.isMachineScoped=this.options.isMachineScoped||N?.isMachineScoped,j.metadata.isBuiltin=this.options.isBuiltin||N?.isBuiltin;const F=await this.installExtension(j,M);N&&E.neq(N.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(N);try{await this.extensionsDownloader.delete(n.URI.file(j.zipPath))}catch(U){}return F}async downloadInstallableExtension(M,_){const N={id:M.identifier.uuid,publisherId:M.publisherId,publisherDisplayName:M.publisherDisplayName};let j;try{this.logService.trace("Started downloading extension:",M.identifier.id),j=(await this.extensionsDownloader.downloadExtension(M,_)).fsPath,this.logService.info("Downloaded extension:",M.identifier.id,j)}catch(F){throw new A.ExtensionManagementError((0,g.joinErrors)(F).message,d)}try{const F=await(0,r.getManifest)(j);return{zipPath:j,identifierWithVersion:new R.ExtensionIdentifierWithVersion(M.identifier,F.version),metadata:N}}catch(F){throw new A.ExtensionManagementError((0,g.joinErrors)(F).message,g.INSTALL_ERROR_VALIDATING)}}}class z extends O{constructor(M,_,N,j,F,U){super({id:(0,R.getGalleryExtensionId)(M.publisher,M.name)},_,F,U);this.manifest=M,this.location=_,this.options=N,this.galleryService=j}async doRun(M){const _=new R.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),j=(await this.extensionsScanner.scanExtensions(1)).find(U=>(0,R.areSameExtensions)(this.identifier,U.identifier)),F=await this.getMetadata(this.identifier.id,M);if(j)if(F.isMachineScoped=this.options.isMachineScoped||j.isMachineScoped,F.isBuiltin=this.options.isBuiltin||j.isBuiltin,this._operation=2,_.equals(new R.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version)))try{await this.extensionsScanner.removeExtension(j,"existing")}catch(U){throw new Error(S.localize(3,null,this.manifest.displayName||this.manifest.name))}else E.gt(j.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(j);else{const U=await this.unsetUninstalledAndGetLocal(_);if(U)try{await this.extensionsScanner.removeExtension(U,"existing")}catch(x){throw new Error(S.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:L.resolve(this.location.fsPath),identifierWithVersion:_,metadata:F},M)}async getMetadata(M,_){try{const N=(await this.galleryService.query({names:[M],pageSize:1},_)).firstPage[0];if(N)return{id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId}}catch(N){}return{}}}class V extends g.AbstractExtensionTask{constructor(M,_,N){super();this.extension=M,this.options=_,this.extensionsScanner=N}async doRun(M){const _=[],N=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const j=new R.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);_.push(...N.filter(F=>j.equals(new R.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version))))}else _.push(...N.filter(j=>(0,R.areSameExtensions)(j.identifier,this.extension.identifier)));if(!_.length)throw new Error(S.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(..._),this.options.remove)for(const j of _)try{M.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(j)}catch(F){throw new Error(S.localize(6,null,(0,C.toErrorMessage)(F)))}}}}),define(X[214],Q([0,1,49,35,215,102,44,101,36,76,51,150,12,132,134,27,208,176,24,166,39,167,21,59,173,80,81,179,14,77,159,56,2,168,72,163,164,155,154,152,151,174,71,160,13,162,17,28,22,201,203,198,58,199,204,172,20,170,200,60,197,177,61,73,136,205,178,86,85,84,5,153,145,9,43,82,186,181,202,143,147,180,4,15]),function(G,e,S,L,P,k,A,R,p,E,n,y,v,m,h,C,D,b,I,f,s,c,t,r,i,a,l,o,u,g,w,d,T,O,$,z,V,B,M,_,N,j,F,U,x,q,H,Y,te,ne,se,ee,he,de,ye,pe,Pe,Te,Me,Oe,Le,_e,be,ke,Ke,Ye,$e,je,J,ie,re,me,ve,De,we,Ae,Ce,Re,Ue,W,Z,ae,ce,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ue extends T.Disposable{constructor(le){super();this.configuration=le,this.server=this._register(new R.Server),(0,P.gracefulify)(S),this.registerListeners()}registerListeners(){const le=()=>this.dispose();process.once("exit",le),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",le)}async open(){const le=await this.initServices();(0,te.registerConfiguration)(),le.invokeFunction(Ee=>{const Ie=Ee.get(u.ILogService);Ie.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ee),this.registerErrorHandler(Ie)}),this._register((0,T.combinedDisposable)(le.createInstance(z.CodeCacheCleaner,this.configuration.codeCachePath),le.createInstance(V.LanguagePackCachedDataCleaner),le.createInstance(B.StorageDataCleaner,this.configuration.backupWorkspacesPath),le.createInstance(M.LogsDataCleaner),le.createInstance(me.LocalizationsUpdater),le.createInstance(ve.DeprecatedExtensionsCleaner)))}async initServices(){const le=new E.ServiceCollection,Ee={_serviceBrand:void 0,...A.default};le.set(Y.IProductService,Ee);const Ie=new p.StaticRouter(We=>We==="main"),Fe=new N.MessagePortMainProcessService(this.server,Ie);le.set(_.IMainProcessService,Fe);const Ne=new m.NativeEnvironmentService(this.configuration.args,Ee);le.set(v.INativeEnvironmentService,Ne);const et=new g.LogLevelChannelClient(this.server.getChannel("logLevel",Ie)),Je=new g.LoggerChannelClient(this.configuration.logLevel,et.onDidChangeLogLevel,Fe.getChannel("logger"));le.set(u.ILoggerService,Je);const nt=this._register(new u.MultiplexLogService([this._register(new u.ConsoleLogger(this.configuration.logLevel)),this._register(Je.createLogger((0,oe.joinPath)(ce.URI.file(Ne.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Be=this._register(new g.FollowerLogService(et,nt));le.set(u.ILogService,Be);const Ve=this._register(new U.FileService(Be));le.set(x.IFileService,Ve);const it=this._register(new q.DiskFileSystemProvider(Be));Ve.registerProvider(H.Schemas.file,it);const qe=this._register(new f.ConfigurationService(Ne.settingsResource,Ve));le.set(I.IConfigurationService,qe),await qe.initialize();const Xe=new pe.NativeStorageService(void 0,Fe,Ne);le.set(Pe.IStorageService,Xe),await Xe.initialize(),this._register((0,T.toDisposable)(()=>Xe.flush())),le.set(s.IRequestService,new n.SyncDescriptor(c.RequestService)),le.set(W.IChecksumService,new n.SyncDescriptor(Z.ChecksumService));const tt=p.ProxyChannel.toService(Fe.getChannel("nativeHost"),{context:this.configuration.windowId});le.set(he.INativeHostService,tt),le.set($.IDownloadService,new n.SyncDescriptor(O.DownloadService));const rt=this._register(new Ye.ActiveWindowManager(tt)),ht=new p.StaticRouter(We=>rt.getActiveClientId().then(st=>We===st));le.set(ke.IExtensionRecommendationNotificationService,new Ke.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));let Qe,He;if(!Ne.isExtensionDevelopment&&!Ne.disableTelemetry&&Ee.enableTelemetry){He=new $e.TelemetryLogAppender(Je,Ne);const{appRoot:We,extensionsPath:st,isBuilt:dt,installSourcePath:gt}=Ne;if(Ee.aiConfig&&Ee.aiConfig.asimovKey&&dt){const ct=new o.AppInsightsAppender("monacoworkbench",null,Ee.aiConfig.asimovKey);this._register((0,T.toDisposable)(()=>ct.flush())),He=(0,r.combinedAppender)(ct,He)}Qe=new l.TelemetryService({appender:He,commonProperties:(0,i.resolveCommonProperties)(Ve,(0,L.release)(),(0,L.hostname)(),process.arch,Ee.commit,Ee.version,this.configuration.machineId,Ee.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:[We,st]},qe)}else Qe=r.NullTelemetryService,He=r.NullAppender;this.server.registerChannel("telemetryAppender",new a.TelemetryAppenderChannel(He)),le.set(t.ITelemetryService,Qe);const ft=new ae.CustomEndpointTelemetryService(qe,Qe);return le.set(t.ICustomEndpointTelemetryService,ft),le.set(C.IExtensionManagementService,new n.SyncDescriptor(D.ExtensionManagementService)),le.set(C.IExtensionGalleryService,new n.SyncDescriptor(b.ExtensionGalleryService)),le.set(C.IExtensionTipsService,new n.SyncDescriptor(_e.ExtensionTipsService)),le.set(d.ILocalizationsService,new n.SyncDescriptor(w.LocalizationsService)),le.set(F.IDiagnosticsService,new n.SyncDescriptor(j.DiagnosticsService)),le.set(Oe.IUserDataSyncAccountService,new n.SyncDescriptor(Oe.UserDataSyncAccountService)),le.set(te.IUserDataSyncLogService,new n.SyncDescriptor(de.UserDataSyncLogService)),le.set(te.IUserDataSyncUtilService,new ee.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),le.set(C.IGlobalExtensionEnablementService,new n.SyncDescriptor(Te.GlobalExtensionEnablementService)),le.set(J.IIgnoredExtensionsManagementService,new n.SyncDescriptor(J.IgnoredExtensionsManagementService)),le.set(ie.IExtensionsStorageSyncService,new n.SyncDescriptor(ie.ExtensionsStorageSyncService)),le.set(te.IUserDataSyncStoreManagementService,new n.SyncDescriptor(se.UserDataSyncStoreManagementService)),le.set(te.IUserDataSyncStoreService,new n.SyncDescriptor(se.UserDataSyncStoreService)),le.set(be.IUserDataSyncMachinesService,new n.SyncDescriptor(be.UserDataSyncMachinesService)),le.set(te.IUserDataSyncBackupStoreService,new n.SyncDescriptor(Le.UserDataSyncBackupStoreService)),le.set(te.IUserDataAutoSyncEnablementService,new n.SyncDescriptor(je.UserDataAutoSyncEnablementService)),le.set(te.IUserDataSyncResourceEnablementService,new n.SyncDescriptor(Me.UserDataSyncResourceEnablementService)),le.set(te.IUserDataSyncService,new n.SyncDescriptor(ne.UserDataSyncService)),le.set(Re.ILocalPtyService,this._register(new Ce.PtyHostService({GraceTime:6e4,ShortGraceTime:6e3},qe,Be,Qe))),new y.InstantiationService(le)}initChannels(le){const Ee=new h.ExtensionManagementChannel(le.get(C.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ee);const Ie=p.ProxyChannel.fromService(le.get(d.ILocalizationsService));this.server.registerChannel("localizations",Ie);const Fe=p.ProxyChannel.fromService(le.get(F.IDiagnosticsService));this.server.registerChannel("diagnostics",Fe);const Ne=new h.ExtensionTipsChannel(le.get(C.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ne);const et=p.ProxyChannel.fromService(le.get(W.IChecksumService));this.server.registerChannel("checksum",et);const Je=new ee.UserDataSyncMachinesServiceChannel(le.get(be.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Je);const nt=p.ProxyChannel.fromService(le.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",nt);const Be=new ee.UserDataSyncAccountServiceChannel(le.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Be);const Ve=new ee.UserDataSyncStoreManagementServiceChannel(le.get(te.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ve);const it=new Ue.UserDataSyncChannel(le.get(te.IUserDataSyncService),le.get(u.ILogService));this.server.registerChannel("userDataSync",it);const qe=this._register(le.get(re.IInstantiationService).createInstance(ye.UserDataAutoSyncService)),Xe=new ee.UserDataAutoSyncChannel(qe);this.server.registerChannel("userDataAutoSync",Xe);const tt=le.get(Re.ILocalPtyService),rt=p.ProxyChannel.fromService(tt);this.server.registerChannel(Ae.TerminalIpcChannels.LocalPty,rt)}registerErrorHandler(le){window.addEventListener("unhandledrejection",Ee=>{(0,De.onUnexpectedError)(Ee.reason),Ee.preventDefault()}),(0,De.setUnexpectedErrorHandler)(Ee=>{const Ie=(0,we.toErrorMessage)(Ee,!0);!Ie||le.error(`[uncaught exception in sharedProcess]: ${Ie}`)})}}async function ge(Se){const le=new ue(Se);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await le.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/807dfb817fef0d0c5729c1924bd4889b04fa405b/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
