/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","fs","vs/base/common/extpath","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/tunnel","vs/platform/sign/common/sign","vs/platform/webview/common/webviewManagerService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],Z=function(j){for(var e=[],g=0,M=j.length;g<M;g++)e[g]=J[j[g]];return e};define(J[103],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(M,D){if(!M)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=g}),define(J[47],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(E){return(n,p,m)=>{let i=null,b=null;if(typeof m.value=="function"?(i="value",b=m.value):typeof m.get=="function"&&(i="get",b=m.get),!b)throw new Error("not supported");m[i]=E(b,p)}}e.createDecorator=g;function M(E,n,p){let m=null,i=null;if(typeof p.value=="function"?(m="value",i=p.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(m="get",i=p.get),!i)throw new Error("not supported");const b=`$memoize$${n}`;p[m]=function(...k){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,k)}),this[b]}}e.memoize=M;function D(E,n,p){return g((m,i)=>{const b=`$debounce$${i}`,k=`$debounce$result$${i}`;return function(...y){this[k]||(this[k]=p?p():void 0),clearTimeout(this[b]),n&&(this[k]=n(this[k],...y),y=[this[k]]),this[b]=setTimeout(()=>{m.apply(this,y),this[k]=p?p():void 0},E)}})}e.debounce=D;function S(E,n,p){return g((m,i)=>{const b=`$throttle$timer$${i}`,k=`$throttle$result$${i}`,y=`$throttle$lastRun$${i}`,d=`$throttle$pending$${i}`;return function(...w){if(this[k]||(this[k]=p?p():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),n&&(this[k]=n(this[k],...w)),this[d])return;const P=this[y]+E;P<=Date.now()?(this[y]=Date.now(),m.apply(this,[this[k]]),this[k]=p?p():void 0):(this[d]=!0,this[b]=setTimeout(()=>{this[d]=!1,this[y]=Date.now(),m.apply(this,[this[k]]),this[k]=p?p():void 0},P-Date.now()))}})}e.throttle=S}),define(J[16],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function M(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=M;function D(u){p(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=D;function S(u){p(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=S;function E(u){if(u instanceof Error){let{name:t,message:s}=u;const r=u.stacktrace||u.stack;return{$isError:!0,name:t,message:s,stack:r}}return u}e.transformErrorForSerialization=E;const n="Canceled";function p(u){return u instanceof Error&&u.name===n&&u.message===n}e.isPromiseCanceledError=p;class m extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=m;function i(){const u=new Error(n);return u.name=u.message,u}e.canceled=i;function b(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=b;function k(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=k;function y(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function d(u){const t=new Error(`${u} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function w(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=w;class P extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=P;class I extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=I;class l extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=l;function h(u){const t=u;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=h;function o(u,t=Object.create(null)){const s=new Error(u);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=o}),define(J[36],Z([0,1,16]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(W,R=0){return W[W.length-(1+R)]}e.tail=M;function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=D;function S(W,R,C=(_,A)=>_===A){if(W===R)return!0;if(!W||!R||W.length!==R.length)return!1;for(let _=0,A=W.length;_<A;_++)if(!C(W[_],R[_]))return!1;return!0}e.equals=S;function E(W,R,C){let _=0,A=W.length-1;for(;_<=A;){const z=(_+A)/2|0,K=C(W[z],R);if(K<0)_=z+1;else if(K>0)A=z-1;else return z}return-(_+1)}e.binarySearch=E;function n(W,R){let C=0,_=W.length;if(_===0)return 0;for(;C<_;){const A=Math.floor((C+_)/2);R(W[A])?_=A:C=A+1}return C}e.findFirstInSorted=n;function p(W,R,C){if(W=W|0,W>=R.length)throw new TypeError("invalid index");let _=R[Math.floor(R.length*Math.random())],A=[],z=[],K=[];for(let X of R){const G=C(X,_);G<0?A.push(X):G>0?z.push(X):K.push(X)}return W<A.length?p(W,A,C):W<A.length+K.length?K[0]:p(W-(A.length+K.length),z,C)}e.quickSelect=p;function m(W,R){const C=[];let _;for(const A of W.slice(0).sort(R))!_||R(_[0],A)!==0?(_=[A],C.push(_)):_.push(A);return C}e.groupBy=m;function i(W,R,C){const _=[];function A(X,G,Q){if(G===0&&Q.length===0)return;const ne=_[_.length-1];ne&&ne.start+ne.deleteCount===X?(ne.deleteCount+=G,ne.toInsert.push(...Q)):_.push({start:X,deleteCount:G,toInsert:Q})}let z=0,K=0;for(;;){if(z===W.length){A(z,0,R.slice(K));break}if(K===R.length){A(z,W.length-z,[]);break}const X=W[z],G=R[K],Q=C(X,G);Q===0?(z+=1,K+=1):Q<0?(A(z,1,[]),z+=1):Q>0&&(A(z,0,[G]),K+=1)}return _}e.sortedDiff=i;function b(W,R,C){const _=i(W,R,C),A=[],z=[];for(const K of _)A.push(...W.slice(K.start,K.start+K.deleteCount)),z.push(...K.toInsert);return{removed:A,added:z}}e.delta=b;function k(W,R,C){if(C===0)return[];const _=W.slice(0,C).sort(R);return d(W,R,_,C,W.length),_}e.top=k;function y(W,R,C,_,A){return C===0?Promise.resolve([]):new Promise((z,K)=>{(async()=>{const X=W.length,G=W.slice(0,C).sort(R);for(let Q=C,ne=Math.min(C+_,X);Q<X;Q=ne,ne=Math.min(ne+_,X)){if(Q>C&&await new Promise(se=>setTimeout(se)),A&&A.isCancellationRequested)throw(0,g.canceled)();d(W,R,G,Q,ne)}return G})().then(z,K)})}e.topAsync=y;function d(W,R,C,_,A){for(const z=C.length;_<A;_++){const K=W[_];if(R(K,C[z-1])<0){C.pop();const X=n(C,G=>R(K,G)<0);C.splice(X,0,K)}}}function w(W){return W.filter(R=>!!R)}e.coalesce=w;function P(W){let R=0;for(let C=0;C<W.length;C++)W[C]&&(W[R]=W[C],R+=1);W.length=R}e.coalesceInPlace=P;function I(W,R,C){W.splice(C,0,W.splice(R,1)[0])}e.move=I;function l(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=l;function h(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=h;function o(W,R){if(!R)return W.filter((_,A)=>W.indexOf(_)===A);const C=Object.create(null);return W.filter(_=>{const A=R(_);return C[A]?!1:(C[A]=!0,!0)})}e.distinct=o;function u(W){const R=new Set;return W.filter(C=>R.has(C)?!1:(R.add(C),!0))}e.distinctES6=u;function t(W){const R=Object.create(null);return C=>{const _=W(C);return R[_]?!1:(R[_]=!0,!0)}}e.uniqueFilter=t;function s(W,R){for(let C=W.length-1;C>=0;C--){const _=W[C];if(R(_))return C}return-1}e.lastIndex=s;function r(W,R){return W.length>0?W[0]:R}e.firstOrDefault=r;function a(W,R,C=(_,A)=>_===A){let _=0;for(let A=0,z=Math.min(W.length,R.length);A<z&&C(W[A],R[A]);A++)_++;return _}e.commonPrefixLength=a;function c(W){return[].concat(...W)}e.flatten=c;function v(W,R){let C=typeof R=="number"?W:0;typeof R=="number"?C=W:(C=0,R=W);const _=[];if(C<=R)for(let A=C;A<R;A++)_.push(A);else for(let A=C;A>R;A--)_.push(A);return _}e.range=v;function f(W,R,C){return W.reduce((_,A)=>(_[R(A)]=C?C(A):A,_),Object.create(null))}e.index=f;function L(W,R){return W.push(R),()=>T(W,R)}e.insert=L;function T(W,R){const C=W.indexOf(R);if(C>-1)return W.splice(C,1),R}e.remove=T;function O(W,R,C){const _=W.slice(0,R),A=W.slice(R);return _.concat(C,A)}e.arrayInsert=O;function B(W,R){let C;if(typeof R=="number"){let _=R;C=()=>{const A=Math.sin(_++)*179426549;return A-Math.floor(A)}}else C=Math.random;for(let _=W.length-1;_>0;_-=1){const A=Math.floor(C()*(_+1)),z=W[_];W[_]=W[A],W[A]=z}}e.shuffle=B;function q(W,R){const C=W.indexOf(R);C>-1&&(W.splice(C,1),W.unshift(R))}e.pushToStart=q;function x(W,R){const C=W.indexOf(R);C>-1&&(W.splice(C,1),W.push(R))}e.pushToEnd=x;function ie(W,R){return Array.isArray(W)?W.map(R):R(W)}e.mapArrayOrNot=ie;function V(W){return Array.isArray(W)?W:[W]}e.asArray=V;function Y(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=Y;function U(W,R){for(const C of W){const _=R(C);if(_!==void 0)return _}}e.mapFind=U;function N(W,R){let C=Number.MAX_SAFE_INTEGER,_=0;return W.forEach((A,z)=>{const K=R(A);K<C&&(C=K,_=z)}),_}e.minIndex=N;function F(W,R){let C=Number.MIN_SAFE_INTEGER,_=0;return W.forEach((A,z)=>{const K=R(A);K>C&&(C=K,_=z)}),_}e.maxIndex=F;class ${constructor(R){this.items=R,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(R){let C=this.firstIdx;for(;C<this.items.length&&R(this.items[C]);)C++;const _=C===this.firstIdx?null:this.items.slice(this.firstIdx,C);return this.firstIdx=C,_}takeFromEndWhile(R){let C=this.lastIdx;for(;C>=0&&R(this.items[C]);)C--;const _=C===this.lastIdx?null:this.items.slice(C+1,this.lastIdx+1);return this.lastIdx=C,_}}e.ArrayQueue=$}),define(J[43],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(M){const D=this;let S=!1,E;return function(){return S||(S=!0,E=M.apply(D,arguments)),E}}e.once=g}),define(J[63],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(M){function D(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}M.is=D;const S=Object.freeze([]);function E(){return S}M.empty=E;function*n(u){yield u}M.single=n;function p(u){return u||S}M.from=p;function m(u){return!u||u[Symbol.iterator]().next().done===!0}M.isEmpty=m;function i(u){return u[Symbol.iterator]().next().value}M.first=i;function b(u,t){for(const s of u)if(t(s))return!0;return!1}M.some=b;function k(u,t){for(const s of u)if(t(s))return s}M.find=k;function*y(u,t){for(const s of u)t(s)&&(yield s)}M.filter=y;function*d(u,t){let s=0;for(const r of u)yield t(r,s++)}M.map=d;function*w(...u){for(const t of u)for(const s of t)yield s}M.concat=w;function*P(u){for(const t of u)for(const s of t)yield s}M.concatNested=P;function I(u,t,s){let r=s;for(const a of u)r=t(r,a);return r}M.reduce=I;function*l(u,t,s=u.length){for(t<0&&(t+=u.length),s<0?s+=u.length:s>u.length&&(s=u.length);t<s;t++)yield u[t]}M.slice=l;function h(u,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,u];const r=u[Symbol.iterator]();for(let a=0;a<t;a++){const c=r.next();if(c.done)return[s,M.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return r}}]}M.consume=h;function o(u,t,s=(r,a)=>r===a){const r=u[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const c=r.next(),v=a.next();if(c.done!==v.done)return!1;if(c.done)return!0;if(!s(c.value,v.value))return!1}}M.equals=o})(g=e.Iterable||(e.Iterable={}))}),define(J[40],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function E(t,s=!1){let r=0,a=t.length,c="",v=0,f=16,L=0;function T(Y){let U=0,N=0;for(;U<Y;){const F=t.charCodeAt(r);if(F>=48&&F<=57)N=N*16+F-48;else if(F>=65&&F<=70)N=N*16+F-65+10;else if(F>=97&&F<=102)N=N*16+F-97+10;else break;r++,U++}return U<Y&&(N=-1),N}function O(Y){r=Y,c="",v=0,f=16,L=0}function B(){const Y=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&m(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&m(t.charCodeAt(r)))for(r++;r<t.length&&m(t.charCodeAt(r));)r++;else return L=3,t.substring(Y,r);let U=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&m(t.charCodeAt(r))){for(r++;r<t.length&&m(t.charCodeAt(r));)r++;U=r}else L=3;return t.substring(Y,U)}function q(){let Y="",U=r;for(;;){if(r>=a){Y+=t.substring(U,r),L=2;break}const N=t.charCodeAt(r);if(N===34){Y+=t.substring(U,r),r++;break}if(N===92){if(Y+=t.substring(U,r),r++,r>=a){L=2;break}switch(t.charCodeAt(r++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:const $=T(4);$>=0?Y+=String.fromCharCode($):L=4;break;default:L=5}U=r;continue}if(N>=0&&N<=31)if(p(N)){Y+=t.substring(U,r),L=2;break}else L=6;r++}return Y}function x(){if(c="",L=0,v=r,r>=a)return v=a,f=17;let Y=t.charCodeAt(r);if(n(Y)){do r++,c+=String.fromCharCode(Y),Y=t.charCodeAt(r);while(n(Y));return f=15}if(p(Y))return r++,c+=String.fromCharCode(Y),Y===13&&t.charCodeAt(r)===10&&(r++,c+=`
`),f=14;switch(Y){case 123:return r++,f=1;case 125:return r++,f=2;case 91:return r++,f=3;case 93:return r++,f=4;case 58:return r++,f=6;case 44:return r++,f=5;case 34:return r++,c=q(),f=10;case 47:const U=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<a&&!p(t.charCodeAt(r));)r++;return c=t.substring(U,r),f=12}if(t.charCodeAt(r+1)===42){r+=2;const N=a-1;let F=!1;for(;r<N;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,F=!0;break}r++}return F||(r++,L=1),c=t.substring(U,r),f=13}return c+=String.fromCharCode(Y),r++,f=16;case 45:if(c+=String.fromCharCode(Y),r++,r===a||!m(t.charCodeAt(r)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=B(),f=11;default:for(;r<a&&ie(Y);)r++,Y=t.charCodeAt(r);if(v!==r){switch(c=t.substring(v,r),c){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return c+=String.fromCharCode(Y),r++,f=16}}function ie(Y){if(n(Y)||p(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let Y;do Y=x();while(Y>=12&&Y<=15);return Y}return{setPosition:O,getPosition:()=>r,scan:s?V:x,getToken:()=>f,getTokenValue:()=>c,getTokenOffset:()=>v,getTokenLength:()=>r-v,getTokenError:()=>L}}e.createScanner=E;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function m(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function b(t,s){const r=[],a=new Object;let c;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function L(T,O,B,q){v.value=T,v.offset=O,v.length=B,v.type=q,v.colonOffset=void 0,c=v}try{h(t,{onObjectBegin:(T,O)=>{if(s<=T)throw a;c=void 0,f=s>T,r.push("")},onObjectProperty:(T,O,B)=>{if(s<O||(L(T,O,B,"property"),r[r.length-1]=T,s<=O+B))throw a},onObjectEnd:(T,O)=>{if(s<=T)throw a;c=void 0,r.pop()},onArrayBegin:(T,O)=>{if(s<=T)throw a;c=void 0,r.push(0)},onArrayEnd:(T,O)=>{if(s<=T)throw a;c=void 0,r.pop()},onLiteralValue:(T,O,B)=>{if(s<O||(L(T,O,B,u(T)),s<=O+B))throw a},onSeparator:(T,O,B)=>{if(s<=O)throw a;if(T===":"&&c&&c.type==="property")c.colonOffset=O,f=!1,c=void 0;else if(T===","){const q=r[r.length-1];typeof q=="number"?r[r.length-1]=q+1:(f=!0,r[r.length-1]=""),c=void 0}}})}catch(T){if(T!==a)throw T}return{path:r,previousNode:c,isAtPropertyKey:f,matches:T=>{let O=0;for(let B=0;O<T.length&&B<r.length;B++)if(T[O]===r[B]||T[O]==="*")O++;else if(T[O]!=="**")return!1;return O===T.length}}}e.getLocation=b;function k(t,s=[],r=S.DEFAULT){let a=null,c=[];const v=[];function f(T){Array.isArray(c)?c.push(T):a!==null&&(c[a]=T)}return h(t,{onObjectBegin:()=>{const T={};f(T),v.push(c),c=T,a=null},onObjectProperty:T=>{a=T},onObjectEnd:()=>{c=v.pop()},onArrayBegin:()=>{const T=[];f(T),v.push(c),c=T,a=null},onArrayEnd:()=>{c=v.pop()},onLiteralValue:f,onError:(T,O,B)=>{s.push({error:T,offset:O,length:B})}},r),c[0]}e.parse=k;function y(t,s=[],r=S.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(T){a.type==="property"&&(a.length=T-a.offset,a=a.parent)}function v(T){return a.children.push(T),T}h(t,{onObjectBegin:T=>{a=v({type:"object",offset:T,length:-1,parent:a,children:[]})},onObjectProperty:(T,O,B)=>{a=v({type:"property",offset:O,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:T,offset:O,length:B,parent:a})},onObjectEnd:(T,O)=>{a.length=T+O-a.offset,a=a.parent,c(T+O)},onArrayBegin:(T,O)=>{a=v({type:"array",offset:T,length:-1,parent:a,children:[]})},onArrayEnd:(T,O)=>{a.length=T+O-a.offset,a=a.parent,c(T+O)},onLiteralValue:(T,O,B)=>{v({type:u(T),offset:O,length:B,parent:a,value:T}),c(O+B)},onSeparator:(T,O,B)=>{a.type==="property"&&(T===":"?a.colonOffset=O:T===","&&c(O))},onError:(T,O,B)=>{s.push({error:T,offset:O,length:B})}},r);const L=a.children[0];return L&&delete L.parent,L}e.parseTree=y;function d(t,s){if(!t)return;let r=t;for(let a of s)if(typeof a=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let c=!1;for(const v of r.children)if(Array.isArray(v.children)&&v.children[0].value===a){r=v.children[1],c=!0;break}if(!c)return}else{const c=a;if(r.type!=="array"||c<0||!Array.isArray(r.children)||c>=r.children.length)return;r=r.children[c]}return r}e.findNodeAtLocation=d;function w(t){if(!t.parent||!t.parent.children)return[];const s=w(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=w;function P(t){switch(t.type){case"array":return t.children.map(P);case"object":const s=Object.create(null);for(let r of t.children){const a=r.children[1];a&&(s[r.children[0].value]=P(a))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=P;function I(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=I;function l(t,s,r=!1){if(I(t,s,r)){const a=t.children;if(Array.isArray(a))for(let c=0;c<a.length&&a[c].offset<=s;c++){const v=l(a[c],s,r);if(v)return v}return t}}e.findNodeAtOffset=l;function h(t,s,r=S.DEFAULT){const a=E(t,!1);function c(z){return z?()=>z(a.getTokenOffset(),a.getTokenLength()):()=>!0}function v(z){return z?K=>z(K,a.getTokenOffset(),a.getTokenLength()):()=>!0}const f=c(s.onObjectBegin),L=v(s.onObjectProperty),T=c(s.onObjectEnd),O=c(s.onArrayBegin),B=c(s.onArrayEnd),q=v(s.onLiteralValue),x=v(s.onSeparator),ie=c(s.onComment),V=v(s.onError),Y=r&&r.disallowComments,U=r&&r.allowTrailingComma;function N(){for(;;){const z=a.scan();switch(a.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:Y||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(z){case 12:case 13:Y?F(10):ie();break;case 16:F(1);break;case 15:case 14:break;default:return z}}}function F(z,K=[],X=[]){if(V(z),K.length+X.length>0){let G=a.getToken();for(;G!==17;){if(K.indexOf(G)!==-1){N();break}else if(X.indexOf(G)!==-1)break;G=N()}}}function $(z){const K=a.getTokenValue();return z?q(K):L(K),N(),!0}function W(){switch(a.getToken()){case 11:let z=0;try{z=JSON.parse(a.getTokenValue()),typeof z!="number"&&(F(2),z=0)}catch(K){F(2)}q(z);break;case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return N(),!0}function R(){return a.getToken()!==10?(F(3,[],[2,5]),!1):($(!1),a.getToken()===6?(x(":"),N(),A()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function C(){f(),N();let z=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(z||F(4,[],[]),x(","),N(),a.getToken()===2&&U)break}else z&&F(6,[],[]);R()||F(4,[],[2,5]),z=!0}return T(),a.getToken()!==2?F(7,[2],[]):N(),!0}function _(){O(),N();let z=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(z||F(4,[],[]),x(","),N(),a.getToken()===4&&U)break}else z&&F(6,[],[]);A()||F(4,[],[4,5]),z=!0}return B(),a.getToken()!==4?F(8,[4],[]):N(),!0}function A(){switch(a.getToken()){case 3:return _();case 1:return C();case 10:return $(!0);default:return W()}}return N(),a.getToken()===17?r.allowEmptyContent?!0:(F(4,[],[]),!1):A()?(a.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=h;function o(t,s){let r=E(t),a=[],c,v=0,f;do switch(f=r.getPosition(),c=r.scan(),c){case 12:case 13:case 17:v!==f&&a.push(t.substring(v,f)),s!==void 0&&a.push(r.getTokenValue().replace(/[^\r\n]/g,s)),v=r.getPosition();break}while(c!==17);return a.join("")}e.stripComments=o;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(J[104],Z([0,1,40]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function M(p,m,i){let b,k,y,d,w;if(m){for(d=m.offset,w=d+m.length,y=d;y>0&&!n(p,y-1);)y--;let v=w;for(;v<p.length&&!n(p,v);)v++;k=p.substring(y,v),b=S(k,i)}else k=p,b=0,y=0,d=0,w=p.length;const P=E(i,p);let I=!1,l=0,h;i.insertSpaces?h=D(" ",i.tabSize||4):h="	";const o=(0,g.createScanner)(k,!1);let u=!1;function t(){return P+D(h,b+l)}function s(){let v=o.scan();for(I=!1;v===15||v===14;)I=I||v===14,v=o.scan();return u=v===16||o.getTokenError()!==0,v}const r=[];function a(v,f,L){!u&&f<w&&L>d&&p.substring(f,L)!==v&&r.push({offset:f,length:L-f,content:v})}let c=s();if(c!==17){const v=o.getTokenOffset()+y,f=D(h,b);a(f,y,v)}for(;c!==17;){let v=o.getTokenOffset()+o.getTokenLength()+y,f=s(),L="";for(;!I&&(f===12||f===13);){const O=o.getTokenOffset()+y;a(" ",v,O),v=o.getTokenOffset()+o.getTokenLength()+y,L=f===12?t():"",f=s()}if(f===2)c!==1&&(l--,L=t());else if(f===4)c!==3&&(l--,L=t());else{switch(c){case 3:case 1:l++,L=t();break;case 5:case 12:L=t();break;case 13:I?L=t():L=" ";break;case 6:L=" ";break;case 10:if(f===6){L="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?L=" ":f!==5&&f!==17&&(u=!0);break;case 16:u=!0;break}I&&(f===12||f===13)&&(L=t())}const T=o.getTokenOffset()+y;a(L,v,T),c=f}return r}e.format=M;function D(p,m){let i="";for(let b=0;b<m;b++)i+=p;return i}function S(p,m){let i=0,b=0;const k=m.tabSize||4;for(;i<p.length;){const y=p.charAt(i);if(y===" ")b++;else if(y==="	")b+=k;else break;i++}return Math.floor(b/k)}function E(p,m){for(let i=0;i<m.length;i++){const b=m.charAt(i);if(b==="\r")return i+1<m.length&&m.charAt(i+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return p&&p.eol||`
`}e.getEOL=E;function n(p,m){return`\r
`.indexOf(p.charAt(m))!==-1}e.isEOL=n}),define(J[78],Z([0,1,40,104]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(m,i,b){return S(m,i,void 0,b)}e.removeProperty=D;function S(m,i,b,k,y){const d=i.slice(),w=[],P=(0,g.parseTree)(m,w);let I,l;for(;d.length>0&&(l=d.pop(),I=(0,g.findNodeAtLocation)(P,d),I===void 0&&b!==void 0);)typeof l=="string"?b={[l]:b}:b=[b];if(I)if(I.type==="object"&&typeof l=="string"&&Array.isArray(I.children)){const h=(0,g.findNodeAtLocation)(I,[l]);if(h!==void 0)if(b===void 0){if(!h.parent)throw new Error("Malformed AST");const o=I.children.indexOf(h.parent);let u,t=h.parent.offset+h.parent.length;if(o>0){const s=I.children[o-1];u=s.offset+s.length}else u=I.offset+1,I.children.length>1&&(t=I.children[1].offset);return E(m,{offset:u,length:t-u,content:""},k)}else return E(m,{offset:h.offset,length:h.length,content:JSON.stringify(b)},k);else{if(b===void 0)return[];const o=`${JSON.stringify(l)}: ${JSON.stringify(b)}`,u=y?y(I.children.map(s=>s.children[0].value)):I.children.length;let t;if(u>0){const s=I.children[u-1];t={offset:s.offset+s.length,length:0,content:","+o}}else I.children.length===0?t={offset:I.offset+1,length:0,content:o}:t={offset:I.offset+1,length:0,content:o+","};return E(m,t,k)}}else if(I.type==="array"&&typeof l=="number"&&Array.isArray(I.children))if(b!==void 0){const h=`${JSON.stringify(b)}`;let o;if(I.children.length===0||l===0)o={offset:I.offset+1,length:0,content:I.children.length===0?h:h+","};else{const u=l===-1||l>I.children.length?I.children.length:l,t=I.children[u-1];o={offset:t.offset+t.length,length:0,content:","+h}}return E(m,o,k)}else{const h=l,o=I.children[h];let u;if(I.children.length===1)u={offset:I.offset+1,length:I.length-2,content:""};else if(I.children.length-1===h){const t=I.children[h-1],s=t.offset+t.length,r=I.offset+I.length;u={offset:s,length:r-2-s,content:""}}else u={offset:o.offset,length:I.children[h+1].offset-o.offset,content:""};return E(m,u,k)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${I.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return E(m,{offset:P?P.offset:0,length:P?P.length:0,content:JSON.stringify(b)},k)}}e.setProperty=S;function E(m,i,b){let k=n(m,i),y=i.offset,d=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;y>0&&!(0,M.isEOL)(k,y-1);)y--;for(;d<k.length&&!(0,M.isEOL)(k,d);)d++}const w=(0,M.format)(k,{offset:y,length:d-y},b);for(let I=w.length-1;I>=0;I--){const l=w[I];k=n(k,l),y=Math.min(y,l.offset),d=Math.max(d,l.offset+l.length),d+=l.content.length-l.length}const P=m.length-(k.length-d)-y;return[{offset:y,length:P,content:k.substring(y,d)}]}e.withFormatting=E;function n(m,i){return m.substring(0,i.offset)+i.content+m.substring(i.offset+i.length)}e.applyEdit=n;function p(m,i){let b=i.slice(0).sort((y,d)=>{const w=y.offset-d.offset;return w===0?y.length-d.length:w}),k=m.length;for(let y=b.length-1;y>=0;y--){let d=b[y];if(d.offset+d.length<=k)m=n(m,d);else throw new Error("Overlapping edit");k=d.offset}return m}e.applyEdits=p}),define(J[57],Z([0,1,16]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var M;(function(l){l[l.DependsOnKbLayout=-1]="DependsOnKbLayout",l[l.Unknown=0]="Unknown",l[l.Backspace=1]="Backspace",l[l.Tab=2]="Tab",l[l.Enter=3]="Enter",l[l.Shift=4]="Shift",l[l.Ctrl=5]="Ctrl",l[l.Alt=6]="Alt",l[l.PauseBreak=7]="PauseBreak",l[l.CapsLock=8]="CapsLock",l[l.Escape=9]="Escape",l[l.Space=10]="Space",l[l.PageUp=11]="PageUp",l[l.PageDown=12]="PageDown",l[l.End=13]="End",l[l.Home=14]="Home",l[l.LeftArrow=15]="LeftArrow",l[l.UpArrow=16]="UpArrow",l[l.RightArrow=17]="RightArrow",l[l.DownArrow=18]="DownArrow",l[l.Insert=19]="Insert",l[l.Delete=20]="Delete",l[l.KEY_0=21]="KEY_0",l[l.KEY_1=22]="KEY_1",l[l.KEY_2=23]="KEY_2",l[l.KEY_3=24]="KEY_3",l[l.KEY_4=25]="KEY_4",l[l.KEY_5=26]="KEY_5",l[l.KEY_6=27]="KEY_6",l[l.KEY_7=28]="KEY_7",l[l.KEY_8=29]="KEY_8",l[l.KEY_9=30]="KEY_9",l[l.KEY_A=31]="KEY_A",l[l.KEY_B=32]="KEY_B",l[l.KEY_C=33]="KEY_C",l[l.KEY_D=34]="KEY_D",l[l.KEY_E=35]="KEY_E",l[l.KEY_F=36]="KEY_F",l[l.KEY_G=37]="KEY_G",l[l.KEY_H=38]="KEY_H",l[l.KEY_I=39]="KEY_I",l[l.KEY_J=40]="KEY_J",l[l.KEY_K=41]="KEY_K",l[l.KEY_L=42]="KEY_L",l[l.KEY_M=43]="KEY_M",l[l.KEY_N=44]="KEY_N",l[l.KEY_O=45]="KEY_O",l[l.KEY_P=46]="KEY_P",l[l.KEY_Q=47]="KEY_Q",l[l.KEY_R=48]="KEY_R",l[l.KEY_S=49]="KEY_S",l[l.KEY_T=50]="KEY_T",l[l.KEY_U=51]="KEY_U",l[l.KEY_V=52]="KEY_V",l[l.KEY_W=53]="KEY_W",l[l.KEY_X=54]="KEY_X",l[l.KEY_Y=55]="KEY_Y",l[l.KEY_Z=56]="KEY_Z",l[l.Meta=57]="Meta",l[l.ContextMenu=58]="ContextMenu",l[l.F1=59]="F1",l[l.F2=60]="F2",l[l.F3=61]="F3",l[l.F4=62]="F4",l[l.F5=63]="F5",l[l.F6=64]="F6",l[l.F7=65]="F7",l[l.F8=66]="F8",l[l.F9=67]="F9",l[l.F10=68]="F10",l[l.F11=69]="F11",l[l.F12=70]="F12",l[l.F13=71]="F13",l[l.F14=72]="F14",l[l.F15=73]="F15",l[l.F16=74]="F16",l[l.F17=75]="F17",l[l.F18=76]="F18",l[l.F19=77]="F19",l[l.NumLock=78]="NumLock",l[l.ScrollLock=79]="ScrollLock",l[l.US_SEMICOLON=80]="US_SEMICOLON",l[l.US_EQUAL=81]="US_EQUAL",l[l.US_COMMA=82]="US_COMMA",l[l.US_MINUS=83]="US_MINUS",l[l.US_DOT=84]="US_DOT",l[l.US_SLASH=85]="US_SLASH",l[l.US_BACKTICK=86]="US_BACKTICK",l[l.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",l[l.US_BACKSLASH=88]="US_BACKSLASH",l[l.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",l[l.US_QUOTE=90]="US_QUOTE",l[l.OEM_8=91]="OEM_8",l[l.OEM_102=92]="OEM_102",l[l.NUMPAD_0=93]="NUMPAD_0",l[l.NUMPAD_1=94]="NUMPAD_1",l[l.NUMPAD_2=95]="NUMPAD_2",l[l.NUMPAD_3=96]="NUMPAD_3",l[l.NUMPAD_4=97]="NUMPAD_4",l[l.NUMPAD_5=98]="NUMPAD_5",l[l.NUMPAD_6=99]="NUMPAD_6",l[l.NUMPAD_7=100]="NUMPAD_7",l[l.NUMPAD_8=101]="NUMPAD_8",l[l.NUMPAD_9=102]="NUMPAD_9",l[l.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",l[l.NUMPAD_ADD=104]="NUMPAD_ADD",l[l.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",l[l.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",l[l.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",l[l.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",l[l.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",l[l.ABNT_C1=110]="ABNT_C1",l[l.ABNT_C2=111]="ABNT_C2",l[l.MAX_VALUE=112]="MAX_VALUE"})(M=e.KeyCode||(e.KeyCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,o){this._keyCodeToStr[h]=o,this._strToKeyCode[o.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const S=new D,E=new D,n=new D;(function(){function l(h,o,u=o,t=u){S.define(h,o),E.define(h,u),n.define(h,t)}l(0,"unknown"),l(1,"Backspace"),l(2,"Tab"),l(3,"Enter"),l(4,"Shift"),l(5,"Ctrl"),l(6,"Alt"),l(7,"PauseBreak"),l(8,"CapsLock"),l(9,"Escape"),l(10,"Space"),l(11,"PageUp"),l(12,"PageDown"),l(13,"End"),l(14,"Home"),l(15,"LeftArrow","Left"),l(16,"UpArrow","Up"),l(17,"RightArrow","Right"),l(18,"DownArrow","Down"),l(19,"Insert"),l(20,"Delete"),l(21,"0"),l(22,"1"),l(23,"2"),l(24,"3"),l(25,"4"),l(26,"5"),l(27,"6"),l(28,"7"),l(29,"8"),l(30,"9"),l(31,"A"),l(32,"B"),l(33,"C"),l(34,"D"),l(35,"E"),l(36,"F"),l(37,"G"),l(38,"H"),l(39,"I"),l(40,"J"),l(41,"K"),l(42,"L"),l(43,"M"),l(44,"N"),l(45,"O"),l(46,"P"),l(47,"Q"),l(48,"R"),l(49,"S"),l(50,"T"),l(51,"U"),l(52,"V"),l(53,"W"),l(54,"X"),l(55,"Y"),l(56,"Z"),l(57,"Meta"),l(58,"ContextMenu"),l(59,"F1"),l(60,"F2"),l(61,"F3"),l(62,"F4"),l(63,"F5"),l(64,"F6"),l(65,"F7"),l(66,"F8"),l(67,"F9"),l(68,"F10"),l(69,"F11"),l(70,"F12"),l(71,"F13"),l(72,"F14"),l(73,"F15"),l(74,"F16"),l(75,"F17"),l(76,"F18"),l(77,"F19"),l(78,"NumLock"),l(79,"ScrollLock"),l(80,";",";","OEM_1"),l(81,"=","=","OEM_PLUS"),l(82,",",",","OEM_COMMA"),l(83,"-","-","OEM_MINUS"),l(84,".",".","OEM_PERIOD"),l(85,"/","/","OEM_2"),l(86,"`","`","OEM_3"),l(110,"ABNT_C1"),l(111,"ABNT_C2"),l(87,"[","[","OEM_4"),l(88,"\\","\\","OEM_5"),l(89,"]","]","OEM_6"),l(90,"'","'","OEM_7"),l(91,"OEM_8"),l(92,"OEM_102"),l(93,"NumPad0"),l(94,"NumPad1"),l(95,"NumPad2"),l(96,"NumPad3"),l(97,"NumPad4"),l(98,"NumPad5"),l(99,"NumPad6"),l(100,"NumPad7"),l(101,"NumPad8"),l(102,"NumPad9"),l(103,"NumPad_Multiply"),l(104,"NumPad_Add"),l(105,"NumPad_Separator"),l(106,"NumPad_Subtract"),l(107,"NumPad_Decimal"),l(108,"NumPad_Divide")})();var p;(function(l){function h(r){return S.keyCodeToStr(r)}l.toString=h;function o(r){return S.strToKeyCode(r)}l.fromString=o;function u(r){return E.keyCodeToStr(r)}l.toUserSettingsUS=u;function t(r){return n.keyCodeToStr(r)}l.toUserSettingsGeneral=t;function s(r){return E.strToKeyCode(r)||n.strToKeyCode(r)}l.fromUserSettings=s})(p=e.KeyCodeUtils||(e.KeyCodeUtils={}));var m;(function(l){l[l.CtrlCmd=2048]="CtrlCmd",l[l.Shift=1024]="Shift",l[l.Alt=512]="Alt",l[l.WinCtrl=256]="WinCtrl",l[l.KeyCode=255]="KeyCode"})(m||(m={}));var i;(function(l){l[l.CtrlCmd=2048]="CtrlCmd",l[l.Shift=1024]="Shift",l[l.Alt=512]="Alt",l[l.WinCtrl=256]="WinCtrl"})(i=e.KeyMod||(e.KeyMod={}));function b(l,h){const o=(h&65535)<<16>>>0;return(l|o)>>>0}e.KeyChord=b;function k(l,h){if(l===0)return null;const o=(l&65535)>>>0,u=(l&4294901760)>>>16;return u!==0?new w([y(o,h),y(u,h)]):new w([y(o,h)])}e.createKeybinding=k;function y(l,h){const o=!!(l&2048),u=!!(l&256),t=h===2?u:o,s=!!(l&1024),r=!!(l&512),a=h===2?o:u,c=l&255;return new d(t,s,r,a,c)}e.createSimpleKeybinding=y;class d{constructor(h,o,u,t,s){this.ctrlKey=h,this.shiftKey=o,this.altKey=u,this.metaKey=t,this.keyCode=s}equals(h){return this.ctrlKey===h.ctrlKey&&this.shiftKey===h.shiftKey&&this.altKey===h.altKey&&this.metaKey===h.metaKey&&this.keyCode===h.keyCode}getHashCode(){const h=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",u=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${h}${o}${u}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new w([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class w{constructor(h){if(h.length===0)throw(0,g.illegalArgument)("parts");this.parts=h}getHashCode(){let h="";for(let o=0,u=this.parts.length;o<u;o++)o!==0&&(h+=";"),h+=this.parts[o].getHashCode();return h}equals(h){if(h===null||this.parts.length!==h.parts.length)return!1;for(let o=0;o<this.parts.length;o++)if(!this.parts[o].equals(h.parts[o]))return!1;return!0}}e.ChordKeybinding=w;class P{constructor(h,o,u,t,s,r){this.ctrlKey=h,this.shiftKey=o,this.altKey=u,this.metaKey=t,this.keyLabel=s,this.keyAriaLabel=r}}e.ResolvedKeybindingPart=P;class I{}e.ResolvedKeybinding=I}),define(J[2],Z([0,1,43,63]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let S=null;function E(s){S=s}if(e.setDisposableTracker=E,D){const s="__is_disposable_tracked__";E(new class{trackDisposable(r){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[s]||console.log(a)},3e3)}setParent(r,a){if(r&&r!==l.None)try{r[s]=!0}catch{}}markAsDisposed(r){if(r&&r!==l.None)try{r[s]=!0}catch{}}markAsSingleton(r){}})}function n(s){return S?.trackDisposable(s),s}function p(s){S?.markAsDisposed(s)}function m(s,r){S?.setParent(s,r)}function i(s,r){if(!!S)for(const a of s)S.setParent(a,r)}function b(s){return S?.markAsSingleton(s),s}e.markAsSingleton=b;class k extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=k;function y(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=y;function d(s){if(M.Iterable.is(s)){let r=[];for(const a of s)if(a)try{a.dispose()}catch(c){r.push(c)}if(r.length===1)throw r[0];if(r.length>1)throw new k(r);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=d;function w(...s){const r=P(()=>d(s));return i(s,r),r}e.combinedDisposable=w;function P(s){const r=n({dispose:(0,g.once)(()=>{p(r),s()})});return r}e.toDisposable=P;class I{constructor(){this._toDispose=new Set,this._isDisposed=!1,n(this)}dispose(){this._isDisposed||(p(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return m(r,this),this._isDisposed?I.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=I,I.DISABLE_DISPOSED_WARNING=!1;class l{constructor(){this._store=new I,n(this),m(this._store,this)}dispose(){p(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=l,l.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,n(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&m(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,p(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&m(r,null),r}}e.MutableDisposable=h;class o{constructor(){this.references=new Map}acquire(r,...a){let c=this.references.get(r);c||(c={counter:0,object:this.createReferencedObject(r,...a)},this.references.set(r,c));const{object:v}=c,f=(0,g.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(r,c.object),this.references.delete(r))});return c.counter++,{object:v,dispose:f}}}e.ReferenceCollection=o;class u{constructor(r){this.referenceCollection=r}async acquire(r,...a){const c=this.referenceCollection.acquire(r,...a);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(v){throw c.dispose(),v}}}e.AsyncReferenceCollection=u;class t{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=t}),define(J[105],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(S){this.element=S,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class M{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let S=this._first;for(;S!==g.Undefined;){const E=S.next;S.prev=g.Undefined,S.next=g.Undefined,S=E}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,E){const n=new g(S);if(this._first===g.Undefined)this._first=n,this._last=n;else if(E){const m=this._last;this._last=n,n.prev=m,m.next=n}else{const m=this._first;this._first=n,n.next=m,m.prev=n}this._size+=1;let p=!1;return()=>{p||(p=!0,this._remove(n))}}shift(){if(this._first!==g.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==g.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==g.Undefined&&S.next!==g.Undefined){const E=S.prev;E.next=S.next,S.next.prev=E}else S.prev===g.Undefined&&S.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):S.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):S.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==g.Undefined;)yield S.element,S=S.next}}e.LinkedList=M}),function(){function j(D){const S=[];typeof D=="number"&&S.push("code/timeOrigin",D);function E(p){S.push(p,Date.now())}function n(){const p=[];for(let m=0;m<S.length;m+=2)p.push({name:S[m],startTime:S[m+1]});return p}return{mark:E,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const E of performance.getEntriesByType("mark"))S.push({name:E.name,startTime:Math.round(D+E.startTime)});return S}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function g(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=g(M))}(),define(J[3],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const g="en";let M=!1,D=!1,S=!1,E=!1,n=!1,p=!1,m=!1,i,b=g,k,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const w=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=w&&d?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=d?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!w)y=navigator.userAgent,M=y.indexOf("Windows")>=0,D=y.indexOf("Macintosh")>=0,m=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=y.indexOf("Linux")>=0,p=!0,i=navigator.language,b=i;else if(typeof d=="object"){M=d.platform==="win32",D=d.platform==="darwin",S=d.platform==="linux",E=S&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,i=g,b=g;const r=d.env.VSCODE_NLS_CONFIG;if(r)try{const a=JSON.parse(r),c=a.availableLanguages["*"];i=a.locale,b=c||g,k=a._translationsConfigFile}catch(a){}n=!0}else console.error("Unable to resolve platform.");var P;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function I(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=I;let l=0;D?l=1:M?l=3:S&&(l=2),e.isWindows=M,e.isMacintosh=D,e.isLinux=S,e.isLinuxSnap=E,e.isNative=n,e.isWeb=p,e.isIOS=m,e.platform=l,e.userAgent=y,e.language=b;var h;(function(r){function a(){return e.language}r.value=a;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=c;function v(){return e.language==="en"}r.isDefault=v})(h=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=k,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeSetImmediateId)for(let L=0,T=c.length;L<T;L++){const O=c[L];if(O.id===f.data.vscodeSetImmediateId){c.splice(L,1),O.callback();return}}});let v=0;return f=>{const L=++v;c.push({id:L,callback:f}),e.globals.postMessage({vscodeSetImmediateId:L},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const a=Promise.resolve();return c=>a.then(c)}();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||m?2:M?1:3;let u=!0,t=!1;function s(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,u=new Uint16Array(r.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=s}),define(J[33],Z([0,1,3]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let M;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const D=g.globals.vscode.process;M={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(S){return(0,g.setImmediate)(S)}}}else typeof process!="undefined"?M={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:M={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},nextTick(D){return(0,g.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=M.cwd,e.env=M.env,e.platform=M.platform,e.nextTick=M.nextTick}),define(J[8],Z([0,1,33]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const M=65,D=97,S=90,E=122,n=46,p=47,m=92,i=58,b=63;class k extends Error{constructor(o,u,t){let s;typeof u=="string"&&u.indexOf("not ")===0?(s="must not be",u=u.replace(/^not /,"")):s="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${s} of type ${u}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function y(h,o){if(typeof h!="string")throw new k(o,"string",h)}function d(h){return h===p||h===m}function w(h){return h===p}function P(h){return h>=M&&h<=S||h>=D&&h<=E}function I(h,o,u,t){let s="",r=0,a=-1,c=0,v=0;for(let f=0;f<=h.length;++f){if(f<h.length)v=h.charCodeAt(f);else{if(t(v))break;v=p}if(t(v)){if(!(a===f-1||c===1))if(c===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==n||s.charCodeAt(s.length-2)!==n){if(s.length>2){const L=s.lastIndexOf(u);L===-1?(s="",r=0):(s=s.slice(0,L),r=s.length-1-s.lastIndexOf(u)),a=f,c=0;continue}else if(s.length!==0){s="",r=0,a=f,c=0;continue}}o&&(s+=s.length>0?`${u}..`:"..",r=2)}else s.length>0?s+=`${u}${h.slice(a+1,f)}`:s=h.slice(a+1,f),r=f-a-1;a=f,c=0}else v===n&&c!==-1?++c:c=-1}return s}function l(h,o){if(o===null||typeof o!="object")throw new k("pathObject","Object",o);const u=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return u?u===o.root?`${u}${t}`:`${u}${h}${t}`:t}e.win32={resolve(...h){let o="",u="",t=!1;for(let s=h.length-1;s>=-1;s--){let r;if(s>=0){if(r=h[s],y(r,"path"),r.length===0)continue}else o.length===0?r=g.cwd():(r=g.env[`=${o}`]||g.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===m)&&(r=`${o}\\`));const a=r.length;let c=0,v="",f=!1;const L=r.charCodeAt(0);if(a===1)d(L)&&(c=1,f=!0);else if(d(L))if(f=!0,d(r.charCodeAt(1))){let T=2,O=T;for(;T<a&&!d(r.charCodeAt(T));)T++;if(T<a&&T!==O){const B=r.slice(O,T);for(O=T;T<a&&d(r.charCodeAt(T));)T++;if(T<a&&T!==O){for(O=T;T<a&&!d(r.charCodeAt(T));)T++;(T===a||T!==O)&&(v=`\\\\${B}\\${r.slice(O,T)}`,c=T)}}}else c=1;else P(L)&&r.charCodeAt(1)===i&&(v=r.slice(0,2),c=2,a>2&&d(r.charCodeAt(2))&&(f=!0,c=3));if(v.length>0)if(o.length>0){if(v.toLowerCase()!==o.toLowerCase())continue}else o=v;if(t){if(o.length>0)break}else if(u=`${r.slice(c)}\\${u}`,t=f,f&&o.length>0)break}return u=I(u,!t,"\\",d),t?`${o}\\${u}`:`${o}${u}`||"."},normalize(h){y(h,"path");const o=h.length;if(o===0)return".";let u=0,t,s=!1;const r=h.charCodeAt(0);if(o===1)return w(r)?"\\":h;if(d(r))if(s=!0,d(h.charCodeAt(1))){let c=2,v=c;for(;c<o&&!d(h.charCodeAt(c));)c++;if(c<o&&c!==v){const f=h.slice(v,c);for(v=c;c<o&&d(h.charCodeAt(c));)c++;if(c<o&&c!==v){for(v=c;c<o&&!d(h.charCodeAt(c));)c++;if(c===o)return`\\\\${f}\\${h.slice(v)}\\`;c!==v&&(t=`\\\\${f}\\${h.slice(v,c)}`,u=c)}}}else u=1;else P(r)&&h.charCodeAt(1)===i&&(t=h.slice(0,2),u=2,o>2&&d(h.charCodeAt(2))&&(s=!0,u=3));let a=u<o?I(h.slice(u),!s,"\\",d):"";return a.length===0&&!s&&(a="."),a.length>0&&d(h.charCodeAt(o-1))&&(a+="\\"),t===void 0?s?`\\${a}`:a:s?`${t}\\${a}`:`${t}${a}`},isAbsolute(h){y(h,"path");const o=h.length;if(o===0)return!1;const u=h.charCodeAt(0);return d(u)||o>2&&P(u)&&h.charCodeAt(1)===i&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let o,u;for(let r=0;r<h.length;++r){const a=h[r];y(a,"path"),a.length>0&&(o===void 0?o=u=a:o+=`\\${a}`)}if(o===void 0)return".";let t=!0,s=0;if(typeof u=="string"&&d(u.charCodeAt(0))){++s;const r=u.length;r>1&&d(u.charCodeAt(1))&&(++s,r>2&&(d(u.charCodeAt(2))?++s:t=!1))}if(t){for(;s<o.length&&d(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.win32.normalize(o)},relative(h,o){if(y(h,"from"),y(o,"to"),h===o)return"";const u=e.win32.resolve(h),t=e.win32.resolve(o);if(u===t||(h=u.toLowerCase(),o=t.toLowerCase(),h===o))return"";let s=0;for(;s<h.length&&h.charCodeAt(s)===m;)s++;let r=h.length;for(;r-1>s&&h.charCodeAt(r-1)===m;)r--;const a=r-s;let c=0;for(;c<o.length&&o.charCodeAt(c)===m;)c++;let v=o.length;for(;v-1>c&&o.charCodeAt(v-1)===m;)v--;const f=v-c,L=a<f?a:f;let T=-1,O=0;for(;O<L;O++){const q=h.charCodeAt(s+O);if(q!==o.charCodeAt(c+O))break;q===m&&(T=O)}if(O!==L){if(T===-1)return t}else{if(f>L){if(o.charCodeAt(c+O)===m)return t.slice(c+O+1);if(O===2)return t.slice(c+O)}a>L&&(h.charCodeAt(s+O)===m?T=O:O===2&&(T=3)),T===-1&&(T=0)}let B="";for(O=s+T+1;O<=r;++O)(O===r||h.charCodeAt(O)===m)&&(B+=B.length===0?"..":"\\..");return c+=T,B.length>0?`${B}${t.slice(c,v)}`:(t.charCodeAt(c)===m&&++c,t.slice(c,v))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const o=e.win32.resolve(h);if(o.length<=2)return h;if(o.charCodeAt(0)===m){if(o.charCodeAt(1)===m){const u=o.charCodeAt(2);if(u!==b&&u!==n)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(P(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===m)return`\\\\?\\${o}`;return h},dirname(h){y(h,"path");const o=h.length;if(o===0)return".";let u=-1,t=0;const s=h.charCodeAt(0);if(o===1)return d(s)?h:".";if(d(s)){if(u=t=1,d(h.charCodeAt(1))){let c=2,v=c;for(;c<o&&!d(h.charCodeAt(c));)c++;if(c<o&&c!==v){for(v=c;c<o&&d(h.charCodeAt(c));)c++;if(c<o&&c!==v){for(v=c;c<o&&!d(h.charCodeAt(c));)c++;if(c===o)return h;c!==v&&(u=t=c+1)}}}}else P(s)&&h.charCodeAt(1)===i&&(u=o>2&&d(h.charCodeAt(2))?3:2,t=u);let r=-1,a=!0;for(let c=o-1;c>=t;--c)if(d(h.charCodeAt(c))){if(!a){r=c;break}}else a=!1;if(r===-1){if(u===-1)return".";r=u}return h.slice(0,r)},basename(h,o){o!==void 0&&y(o,"ext"),y(h,"path");let u=0,t=-1,s=!0,r;if(h.length>=2&&P(h.charCodeAt(0))&&h.charCodeAt(1)===i&&(u=2),o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let a=o.length-1,c=-1;for(r=h.length-1;r>=u;--r){const v=h.charCodeAt(r);if(d(v)){if(!s){u=r+1;break}}else c===-1&&(s=!1,c=r+1),a>=0&&(v===o.charCodeAt(a)?--a==-1&&(t=r):(a=-1,t=c))}return u===t?t=c:t===-1&&(t=h.length),h.slice(u,t)}for(r=h.length-1;r>=u;--r)if(d(h.charCodeAt(r))){if(!s){u=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":h.slice(u,t)},extname(h){y(h,"path");let o=0,u=-1,t=0,s=-1,r=!0,a=0;h.length>=2&&h.charCodeAt(1)===i&&P(h.charCodeAt(0))&&(o=t=2);for(let c=h.length-1;c>=o;--c){const v=h.charCodeAt(c);if(d(v)){if(!r){t=c+1;break}continue}s===-1&&(r=!1,s=c+1),v===n?u===-1?u=c:a!==1&&(a=1):u!==-1&&(a=-1)}return u===-1||s===-1||a===0||a===1&&u===s-1&&u===t+1?"":h.slice(u,s)},format:l.bind(null,"\\"),parse(h){y(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const u=h.length;let t=0,s=h.charCodeAt(0);if(u===1)return d(s)?(o.root=o.dir=h,o):(o.base=o.name=h,o);if(d(s)){if(t=1,d(h.charCodeAt(1))){let T=2,O=T;for(;T<u&&!d(h.charCodeAt(T));)T++;if(T<u&&T!==O){for(O=T;T<u&&d(h.charCodeAt(T));)T++;if(T<u&&T!==O){for(O=T;T<u&&!d(h.charCodeAt(T));)T++;T===u?t=T:T!==O&&(t=T+1)}}}}else if(P(s)&&h.charCodeAt(1)===i){if(u<=2)return o.root=o.dir=h,o;if(t=2,d(h.charCodeAt(2))){if(u===3)return o.root=o.dir=h,o;t=3}}t>0&&(o.root=h.slice(0,t));let r=-1,a=t,c=-1,v=!0,f=h.length-1,L=0;for(;f>=t;--f){if(s=h.charCodeAt(f),d(s)){if(!v){a=f+1;break}continue}c===-1&&(v=!1,c=f+1),s===n?r===-1?r=f:L!==1&&(L=1):r!==-1&&(L=-1)}return c!==-1&&(r===-1||L===0||L===1&&r===c-1&&r===a+1?o.base=o.name=h.slice(a,c):(o.name=h.slice(a,r),o.base=h.slice(a,c),o.ext=h.slice(r,c))),a>0&&a!==t?o.dir=h.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let o="",u=!1;for(let t=h.length-1;t>=-1&&!u;t--){const s=t>=0?h[t]:g.cwd();y(s,"path"),s.length!==0&&(o=`${s}/${o}`,u=s.charCodeAt(0)===p)}return o=I(o,!u,"/",w),u?`/${o}`:o.length>0?o:"."},normalize(h){if(y(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===p,u=h.charCodeAt(h.length-1)===p;return h=I(h,!o,"/",w),h.length===0?o?"/":u?"./":".":(u&&(h+="/"),o?`/${h}`:h)},isAbsolute(h){return y(h,"path"),h.length>0&&h.charCodeAt(0)===p},join(...h){if(h.length===0)return".";let o;for(let u=0;u<h.length;++u){const t=h[u];y(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(h,o){if(y(h,"from"),y(o,"to"),h===o||(h=e.posix.resolve(h),o=e.posix.resolve(o),h===o))return"";const u=1,t=h.length,s=t-u,r=1,a=o.length-r,c=s<a?s:a;let v=-1,f=0;for(;f<c;f++){const T=h.charCodeAt(u+f);if(T!==o.charCodeAt(r+f))break;T===p&&(v=f)}if(f===c)if(a>c){if(o.charCodeAt(r+f)===p)return o.slice(r+f+1);if(f===0)return o.slice(r+f)}else s>c&&(h.charCodeAt(u+f)===p?v=f:f===0&&(v=0));let L="";for(f=u+v+1;f<=t;++f)(f===t||h.charCodeAt(f)===p)&&(L+=L.length===0?"..":"/..");return`${L}${o.slice(r+v)}`},toNamespacedPath(h){return h},dirname(h){if(y(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===p;let u=-1,t=!0;for(let s=h.length-1;s>=1;--s)if(h.charCodeAt(s)===p){if(!t){u=s;break}}else t=!1;return u===-1?o?"/":".":o&&u===1?"//":h.slice(0,u)},basename(h,o){o!==void 0&&y(o,"ext"),y(h,"path");let u=0,t=-1,s=!0,r;if(o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let a=o.length-1,c=-1;for(r=h.length-1;r>=0;--r){const v=h.charCodeAt(r);if(v===p){if(!s){u=r+1;break}}else c===-1&&(s=!1,c=r+1),a>=0&&(v===o.charCodeAt(a)?--a==-1&&(t=r):(a=-1,t=c))}return u===t?t=c:t===-1&&(t=h.length),h.slice(u,t)}for(r=h.length-1;r>=0;--r)if(h.charCodeAt(r)===p){if(!s){u=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":h.slice(u,t)},extname(h){y(h,"path");let o=-1,u=0,t=-1,s=!0,r=0;for(let a=h.length-1;a>=0;--a){const c=h.charCodeAt(a);if(c===p){if(!s){u=a+1;break}continue}t===-1&&(s=!1,t=a+1),c===n?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||t===-1||r===0||r===1&&o===t-1&&o===u+1?"":h.slice(o,t)},format:l.bind(null,"/"),parse(h){y(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const u=h.charCodeAt(0)===p;let t;u?(o.root="/",t=1):t=0;let s=-1,r=0,a=-1,c=!0,v=h.length-1,f=0;for(;v>=t;--v){const L=h.charCodeAt(v);if(L===p){if(!c){r=v+1;break}continue}a===-1&&(c=!1,a=v+1),L===n?s===-1?s=v:f!==1&&(f=1):s!==-1&&(f=-1)}if(a!==-1){const L=r===0&&u?1:r;s===-1||f===0||f===1&&s===a-1&&s===r+1?o.base=o.name=h.slice(L,a):(o.name=h.slice(L,s),o.base=h.slice(L,a),o.ext=h.slice(s,a))}return r>0?o.dir=h.slice(0,r-1):u&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[106],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var M;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(M=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(S,...E){const n=E.reduce((i,b)=>(i[b]=!0,i),{}),p=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(i=>!n[i]).forEach(i=>{for(let b=0;b<p.length;b++)if(i.search(p[b])!==-1){delete S[i];break}})}e.sanitizeProcessEnvironment=D}),define(J[79],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var g;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(g=e.ScanCode||(e.ScanCode={}));const M=[],D=Object.create(null),S=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>S[n]||0,toEnum:n=>D[n]||0,toString:n=>M[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class E{constructor(p,m,i,b,k){this.ctrlKey=p,this.shiftKey=m,this.altKey=i,this.metaKey=b,this.scanCode=k}equals(p){return this.ctrlKey===p.ctrlKey&&this.shiftKey===p.shiftKey&&this.altKey===p.altKey&&this.metaKey===p.metaKey&&this.scanCode===p.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=E,function(){function n(p,m){M[p]=m,D[m]=p,S[m.toLowerCase()]=p}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let p=0;p<=193;p++)e.IMMUTABLE_CODE_TO_KEY_CODE[p]=-1;for(let p=0;p<=112;p++)e.IMMUTABLE_KEY_CODE_TO_CODE[p]=-1;function n(p,m){e.IMMUTABLE_CODE_TO_KEY_CODE[p]=m,m!==0&&m!==3&&m!==5&&m!==4&&m!==6&&m!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[m]=p)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(J[107],Z([0,1,57,79]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(E){E=E.toLowerCase().trim();let n=!1,p=!1,m=!1,i=!1,b;do b=!1,/^ctrl(\+|\-)/.test(E)&&(n=!0,E=E.substr("ctrl-".length),b=!0),/^shift(\+|\-)/.test(E)&&(p=!0,E=E.substr("shift-".length),b=!0),/^alt(\+|\-)/.test(E)&&(m=!0,E=E.substr("alt-".length),b=!0),/^meta(\+|\-)/.test(E)&&(i=!0,E=E.substr("meta-".length),b=!0),/^win(\+|\-)/.test(E)&&(i=!0,E=E.substr("win-".length),b=!0),/^cmd(\+|\-)/.test(E)&&(i=!0,E=E.substr("cmd-".length),b=!0);while(b);let k;const y=E.indexOf(" ");return y>0?(k=E.substring(0,y),E=E.substring(y)):(k=E,E=""),{remains:E,ctrl:n,shift:p,alt:m,meta:i,key:k}}static parseSimpleKeybinding(E){const n=this._readModifiers(E),p=g.KeyCodeUtils.fromUserSettings(n.key);return[new g.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,p),n.remains]}static parseKeybinding(E,n){if(!E)return null;const p=[];let m;do[m,E]=this.parseSimpleKeybinding(E),p.push(m);while(E.length>0);return new g.ChordKeybinding(p)}static parseSimpleUserBinding(E){const n=this._readModifiers(E),p=n.key.match(/^\[([^\]]+)\]$/);if(p){const i=p[1],b=M.ScanCodeUtils.lowerCaseToEnum(i);return[new M.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,b),n.remains]}const m=g.KeyCodeUtils.fromUserSettings(n.key);return[new g.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,m),n.remains]}static parseUserBinding(E){if(!E)return[];const n=[];let p;for(;E.length>0;)[p,E]=this.parseSimpleUserBinding(E),n.push(p);return n}}e.KeybindingParser=D}),define(J[108],Z([0,1,3]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const M=g.globals.performance&&typeof g.globals.performance.now=="function";class D{constructor(E){this._highResolution=M&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new D(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=D}),define(J[5],Z([0,1,16,43,2,105,108]),function(j,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(h){h.None=()=>D.Disposable.None;function o(Y){return(U,N=null,F)=>{let $=!1,W;return W=Y(R=>{if(!$)return W?W.dispose():$=!0,U.call(N,R)},null,F),$&&W.dispose(),W}}h.once=o;function u(Y,U){return v((N,F=null,$)=>Y(W=>N.call(F,U(W)),null,$))}h.map=u;function t(Y,U){return v((N,F=null,$)=>Y(W=>{U(W),N.call(F,W)},null,$))}h.forEach=t;function s(Y,U){return v((N,F=null,$)=>Y(W=>U(W)&&N.call(F,W),null,$))}h.filter=s;function r(Y){return Y}h.signal=r;function a(...Y){return(U,N=null,F)=>(0,D.combinedDisposable)(...Y.map($=>$(W=>U.call(N,W),null,F)))}h.any=a;function c(Y,U,N){let F=N;return u(Y,$=>(F=U(F,$),F))}h.reduce=c;function v(Y){let U;const N=new k({onFirstListenerAdd(){U=Y(N.fire,N)},onLastListenerRemove(){U.dispose()}});return N.event}function f(Y,U,N=100,F=!1,$){let W,R,C,_=0;const A=new k({leakWarningThreshold:$,onFirstListenerAdd(){W=Y(z=>{_++,R=U(R,z),F&&!C&&(A.fire(R),R=void 0),clearTimeout(C),C=setTimeout(()=>{const K=R;R=void 0,C=void 0,(!F||_>1)&&A.fire(K),_=0},N)})},onLastListenerRemove(){W.dispose()}});return A.event}h.debounce=f;function L(Y,U=(N,F)=>N===F){let N=!0,F;return s(Y,$=>{const W=N||!U($,F);return N=!1,F=$,W})}h.latch=L;function T(Y,U){return[h.filter(Y,U),h.filter(Y,N=>!U(N))]}h.split=T;function O(Y,U=!1,N=[]){let F=N.slice(),$=Y(C=>{F?F.push(C):R.fire(C)});const W=()=>{F&&F.forEach(C=>R.fire(C)),F=null},R=new k({onFirstListenerAdd(){$||($=Y(C=>R.fire(C)))},onFirstListenerDidAdd(){F&&(U?setTimeout(W):W())},onLastListenerRemove(){$&&$.dispose(),$=null}});return R.event}h.buffer=O;class B{constructor(U){this.event=U}map(U){return new B(u(this.event,U))}forEach(U){return new B(t(this.event,U))}filter(U){return new B(s(this.event,U))}reduce(U,N){return new B(c(this.event,U,N))}latch(){return new B(L(this.event))}debounce(U,N=100,F=!1,$){return new B(f(this.event,U,N,F,$))}on(U,N,F){return this.event(U,N,F)}once(U,N,F){return o(this.event)(U,N,F)}}function q(Y){return new B(Y)}h.chain=q;function x(Y,U,N=F=>F){const F=(...C)=>R.fire(N(...C)),$=()=>Y.on(U,F),W=()=>Y.removeListener(U,F),R=new k({onFirstListenerAdd:$,onLastListenerRemove:W});return R.event}h.fromNodeEventEmitter=x;function ie(Y,U,N=F=>F){const F=(...C)=>R.fire(N(...C)),$=()=>Y.addEventListener(U,F),W=()=>Y.removeEventListener(U,F),R=new k({onFirstListenerAdd:$,onLastListenerRemove:W});return R.event}h.fromDOMEventEmitter=ie;function V(Y){return new Promise(U=>o(Y)(U))}h.toPromise=V})(n=e.Event||(e.Event={}));class p{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${p._idPool++}`}start(o){this._stopWatch=new E.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}p._idPool=0;let m=-1;function i(h){const o=m;return m=h,{dispose(){m=o}}}e.setGlobalLeakWarningThreshold=i;class b{constructor(o,u=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let u=m;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||o<u)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(t)||0;if(this._stacks.set(t,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let r,a=0;for(const[c,v]of this._stacks)(!r||a<v)&&(r=c,a=v);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${a}):`),console.warn(r)}return()=>{const r=this._stacks.get(t)||0;this._stacks.set(t,r-1)}}}class k{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=m>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new p(this._options._profName):void 0}get event(){return this._event||(this._event=(o,u,t)=>{this._listeners||(this._listeners=new S.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(u?[o,u]:o);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,u);const a=this._leakageMon?.check(this._listeners.size),c=(0,D.toDisposable)(()=>{a&&a(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof D.DisposableStore?t.add(c):Array.isArray(t)&&t.push(c),c}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let u of this._listeners)this._deliveryQueue.push([u,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[u,t]=this._deliveryQueue.shift();try{typeof u=="function"?u.call(void 0,t):u[0].call(u[1],t)}catch(s){(0,g.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=k;class y extends k{async fireAsync(o,u,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,o]);for(;this._asyncDeliveryQueue.size>0&&!u.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),a=[],c={...r,waitUntil:v=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");t&&(v=t(v,typeof s=="function"?s:s[0])),a.push(v)}};try{typeof s=="function"?s.call(void 0,c):s[0].call(s[1],c)}catch(v){(0,g.onUnexpectedError)(v);continue}Object.freeze(a),await Promise.allSettled(a).then(v=>{for(const f of v)f.status==="rejected"&&(0,g.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=y;class d extends k{constructor(o){super(o);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=d;class w extends d{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=w;class P{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new k({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const u={event:o,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const t=()=>{this.hasListeners&&this.unhook(u);const s=this.events.indexOf(u);this.events.splice(s,1)};return(0,D.toDisposable)((0,M.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(u=>this.emitter.fire(u))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=P;class I{constructor(){this.buffers=[]}wrapEvent(o){return(u,t,s)=>o(r=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>u.call(t,r)):u.call(t,r)},void 0,s)}bufferEvents(o){const u=[];this.buffers.push(u);const t=o();return this.buffers.pop(),u.forEach(s=>s()),t}}e.EventBufferer=I;class l{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=D.Disposable.None,this.emitter=new k({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=l}),define(J[25],Z([0,1,5]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const M=Object.freeze(function(n,p){const m=setTimeout(n.bind(p),0);return{dispose(){clearTimeout(m)}}});var D;(function(n){function p(m){return m===n.None||m===n.Cancelled||m instanceof S?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}n.isCancellationToken=p,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(D=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?M:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(p){this._token=void 0,this._parentListener=void 0,this._parentListener=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=D.Cancelled}dispose(p=!1){p&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=E}),define(J[109],Z([0,1,5]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(b){const k=this._icons.get(b.id);k?b.description?k.description=b.description:console.error(`Duplicate registration of codicon ${b.id}`):(this._icons.set(b.id,b),this._onDidRegister.fire(b))}get(b){return this._icons.get(b)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new M;e.iconRegistry=D;function S(i,b){return new n(i,b)}e.registerCodicon=S;function E(i){return i?i.replace(/\$\((.*?)\)/g,(b,k)=>` ${k} `).trim():""}e.getCodiconAriaLabel=E;class n{constructor(b,k,y){this.id=b,this.definition=k,this.description=y,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function p(i,b){const k=["codicon","codicon-"+i];return b&&k.push("codicon-modifier-"+b),k}e.getClassNamesArray=p;var m;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const b=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function k(w){if(w instanceof n)return["codicon","codicon-"+w.id];const P=b.exec(w.id);if(!P)return k(n.error);let[,I,l]=P;const h=["codicon","codicon-"+I];return l&&h.push("codicon-modifier-"+l.substr(1)),h}i.asClassNameArray=k;function y(w){return k(w).join(" ")}i.asClassName=y;function d(w){return"."+k(w).join(".")}i.asCSSSelector=d})(m=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(J[64],Z([0,1,16,2]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=D;function S(h){const o=h;return o?D(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=S;function E(h,o){return new n(h,o)}e.newWriteableStream=E;class n{constructor(o,u){this.reducer=o,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(u=>u(o))}emitError(o){this.listeners.error.length===0?(0,g.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(u=>u(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,u){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(o,u){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(u);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function p(h,o){const u=[];let t;for(;(t=h.read())!==null;)u.push(t);return o(u)}e.consumeReadable=p;function m(h,o,u){const t=[];let s;for(;(s=h.read())!==null&&t.length<u;)t.push(s);return s===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return h.read()}}}e.peekReadable=m;function i(h,o){return new Promise((u,t)=>{const s=[];b(h,{onData:r=>{o&&s.push(r)},onError:r=>{o?t(r):u(void 0)},onEnd:()=>{u(o?o(s):void 0)}})})}e.consumeStream=i;function b(h,o){h.on("error",u=>o.onError(u)),h.on("end",()=>o.onEnd()),h.on("data",u=>o.onData(u))}e.listenStream=b;function k(h,o){return new Promise((u,t)=>{const s=new M.DisposableStore,r=[],a=f=>{if(r.push(f),r.length>o)return s.dispose(),h.pause(),u({stream:h,buffer:r,ended:!1})},c=f=>t(f),v=()=>u({stream:h,buffer:r,ended:!0});s.add((0,M.toDisposable)(()=>h.removeListener("error",c))),h.on("error",c),s.add((0,M.toDisposable)(()=>h.removeListener("end",v))),h.on("end",v),s.add((0,M.toDisposable)(()=>h.removeListener("data",a))),h.on("data",a)})}e.peekStream=k;function y(h,o){const u=E(o);return u.end(h),u}e.toStream=y;function d(){const h=E(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=d;function w(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}e.toReadable=w;function P(h,o,u){const t=E(u);return b(h,{onData:s=>t.write(o.data(s)),onError:s=>t.error(o.error?o.error(s):s),onEnd:()=>t.end()}),t}e.transform=P;function I(h,o,u){let t=!1;return{read:()=>{const s=o.read();return t?s:(t=!0,s!==null?u([h,s]):h)}}}e.prefixedReadable=I;function l(h,o,u){let t=!1;const s=E(u);return b(o,{onData:r=>t?s.write(r):(t=!0,s.write(u([h,r]))),onError:r=>s.error(r),onEnd:()=>{t||(t=!0,s.write(h)),s.end()}}),s}e.prefixedStream=l}),define(J[23],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=g;const M=/{(\d+)}/g;function D(H,...te){return te.length===0?H:H.replace(M,function(re,ae){const de=parseInt(ae,10);return isNaN(de)||de<0||de>=te.length?re:te[de]})}e.format=D;const S=/{([^}]+)}/g;function E(H,te){return H.replace(S,(re,ae)=>te[ae]??re)}e.format2=E;function n(H){return H.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=n;function p(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=p;function m(H,te){let re=0;const ae=te.charCodeAt(0);for(let de=H.length-1;de>=0;de--)H.charCodeAt(de)===ae&&re++;return re}e.count=m;function i(H,te,re="\u2026"){return H.length<=te?H:`${H.substr(0,te)}${re}`}e.truncate=i;function b(H,te=" "){const re=k(H,te);return y(re,te)}e.trim=b;function k(H,te){if(!H||!te)return H;const re=te.length;if(re===0||H.length===0)return H;let ae=0;for(;H.indexOf(te,ae)===ae;)ae=ae+re;return H.substring(ae)}e.ltrim=k;function y(H,te){if(!H||!te)return H;const re=te.length,ae=H.length;if(re===0||ae===0)return H;let de=ae,Se=-1;for(;Se=H.lastIndexOf(te,de-1),!(Se===-1||Se+re!==de);){if(Se===0)return"";de=Se}return H.substring(0,de)}e.rtrim=y;function d(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function w(H){return H.replace(/\*/g,"")}e.stripWildcards=w;function P(H,te,re={}){if(!H)throw new Error("Cannot create regex from empty string");te||(H=p(H)),re.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let ae="";return re.global&&(ae+="g"),re.matchCase||(ae+="i"),re.multiline&&(ae+="m"),re.unicode&&(ae+="u"),new RegExp(H,ae)}e.createRegExp=P;function I(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=I;function l(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function h(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=h;function o(H){return H.split(/\r\n|\r|\n/)}e.splitLines=o;function u(H){for(let te=0,re=H.length;te<re;te++){const ae=H.charCodeAt(te);if(ae!==32&&ae!==9)return te}return-1}e.firstNonWhitespaceIndex=u;function t(H,te=0,re=H.length){for(let ae=te;ae<re;ae++){const de=H.charCodeAt(ae);if(de!==32&&de!==9)return H.substring(te,ae)}return H.substring(te,re)}e.getLeadingWhitespace=t;function s(H,te=H.length-1){for(let re=te;re>=0;re--){const ae=H.charCodeAt(re);if(ae!==32&&ae!==9)return re}return-1}e.lastNonWhitespaceIndex=s;function r(H,te){return H<te?-1:H>te?1:0}e.compare=r;function a(H,te,re=0,ae=H.length,de=0,Se=te.length){for(;re<ae&&de<Se;re++,de++){let le=H.charCodeAt(re),ge=te.charCodeAt(de);if(le<ge)return-1;if(le>ge)return 1}const Pe=ae-re,We=Se-de;return Pe<We?-1:Pe>We?1:0}e.compareSubstring=a;function c(H,te){return v(H,te,0,H.length,0,te.length)}e.compareIgnoreCase=c;function v(H,te,re=0,ae=H.length,de=0,Se=te.length){for(;re<ae&&de<Se;re++,de++){let le=H.charCodeAt(re),ge=te.charCodeAt(de);if(le===ge)continue;const pe=le-ge;if(!(pe===32&&L(ge))&&!(pe===-32&&L(le)))return f(le)&&f(ge)?pe:a(H.toLowerCase(),te.toLowerCase(),re,ae,de,Se)}const Pe=ae-re,We=Se-de;return Pe<We?-1:Pe>We?1:0}e.compareSubstringIgnoreCase=v;function f(H){return H>=97&&H<=122}e.isLowerAsciiLetter=f;function L(H){return H>=65&&H<=90}e.isUpperAsciiLetter=L;function T(H){return f(H)||L(H)}function O(H,te){return H.length===te.length&&B(H,te)}e.equalsIgnoreCase=O;function B(H,te,re=H.length){for(let ae=0;ae<re;ae++){const de=H.charCodeAt(ae),Se=te.charCodeAt(ae);if(de!==Se){if(T(de)&&T(Se)){const Pe=Math.abs(de-Se);if(Pe!==0&&Pe!==32)return!1}else if(String.fromCharCode(de).toLowerCase()!==String.fromCharCode(Se).toLowerCase())return!1}}return!0}function q(H,te){const re=te.length;return te.length>H.length?!1:B(H,te,re)}e.startsWithIgnoreCase=q;function x(H,te){let re,ae=Math.min(H.length,te.length);for(re=0;re<ae;re++)if(H.charCodeAt(re)!==te.charCodeAt(re))return re;return ae}e.commonPrefixLength=x;function ie(H,te){let re,ae=Math.min(H.length,te.length);const de=H.length-1,Se=te.length-1;for(re=0;re<ae;re++)if(H.charCodeAt(de-re)!==te.charCodeAt(Se-re))return re;return ae}e.commonSuffixLength=ie;function V(H){return 55296<=H&&H<=56319}e.isHighSurrogate=V;function Y(H){return 56320<=H&&H<=57343}e.isLowSurrogate=Y;function U(H,te){return(H-55296<<10)+(te-56320)+65536}e.computeCodePoint=U;function N(H,te,re){const ae=H.charCodeAt(re);if(V(ae)&&re+1<te){const de=H.charCodeAt(re+1);if(Y(de))return U(ae,de)}return ae}e.getNextCodePoint=N;function F(H,te){const re=H.charCodeAt(te-1);if(Y(re)&&te>1){const ae=H.charCodeAt(te-2);if(V(ae))return U(ae,re)}return re}function $(H,te){const re=Ue.getInstance(),ae=te,de=H.length,Se=N(H,de,te);te+=Se>=65536?2:1;let Pe=re.getGraphemeBreakType(Se);for(;te<de;){const We=N(H,de,te),le=re.getGraphemeBreakType(We);if(Be(Pe,le))break;te+=We>=65536?2:1,Pe=le}return te-ae}e.nextCharLength=$;function W(H,te){const re=Ue.getInstance(),ae=te,de=F(H,te);te-=de>=65536?2:1;let Se=re.getGraphemeBreakType(de);for(;te>0;){const Pe=F(H,te),We=re.getGraphemeBreakType(Pe);if(Be(We,Se))break;te-=Pe>=65536?2:1,Se=We}return ae-te}e.prevCharLength=W;function R(H,te){const re=Ue.getInstance(),ae=H.length,de=te,Se=N(H,ae,te),Pe=re.getGraphemeBreakType(Se);te+=Se>=65536?2:1;let We=Pe;for(;te<ae;){const ge=N(H,ae,te),pe=re.getGraphemeBreakType(ge);if(Be(We,pe))break;te+=ge>=65536?2:1,We=pe}const le=te;for(te=de,We=Pe;te>0;){const ge=F(H,te),pe=re.getGraphemeBreakType(ge);if(Be(pe,We))break;te-=ge>=65536?2:1,We=pe}return[te,le]}function C(H,te){return te>0&&Y(H.charCodeAt(te))?R(H,te-1):R(H,te)}e.getCharContainingOffset=C;function _(H){const te=H.length;let re=0,ae=0;for(;ae<te;){const Pe=N(H,te,ae);ae+=Pe>=65536?2:1,Pe<128?re+=1:Pe<2048?re+=2:Pe<65536?re+=3:re+=4}const de=new Uint8Array(re);ae=0;let Se=0;for(;ae<te;){const Pe=N(H,te,ae);ae+=Pe>=65536?2:1,Pe<128?de[Se++]=Pe:Pe<2048?(de[Se++]=192|(Pe&1984)>>>6,de[Se++]=128|(Pe&63)>>>0):Pe<65536?(de[Se++]=224|(Pe&61440)>>>12,de[Se++]=128|(Pe&4032)>>>6,de[Se++]=128|(Pe&63)>>>0):(de[Se++]=240|(Pe&1835008)>>>18,de[Se++]=128|(Pe&258048)>>>12,de[Se++]=128|(Pe&4032)>>>6,de[Se++]=128|(Pe&63)>>>0)}return de}e.encodeUTF8=_;function A(H){const te=H.byteLength,re=[];let ae=0;for(;ae<te;){const de=H[ae];let Se;if(de>=240&&ae+3<te?Se=(H[ae++]&7)<<18>>>0|(H[ae++]&63)<<12>>>0|(H[ae++]&63)<<6>>>0|(H[ae++]&63)<<0>>>0:de>=224&&ae+2<te?Se=(H[ae++]&15)<<12>>>0|(H[ae++]&63)<<6>>>0|(H[ae++]&63)<<0>>>0:de>=192&&ae+1<te?Se=(H[ae++]&31)<<6>>>0|(H[ae++]&63)<<0>>>0:Se=H[ae++],Se>=0&&Se<=55295||Se>=57344&&Se<=65535)re.push(String.fromCharCode(Se));else if(Se>=65536&&Se<=1114111){const Pe=Se-65536,We=55296+((Pe&1047552)>>>10),le=56320+((Pe&1023)>>>0);re.push(String.fromCharCode(We)),re.push(String.fromCharCode(le))}else re.push(String.fromCharCode(65533))}return re.join("")}e.decodeUTF8=A;const z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(H){return z.test(H)}e.containsRTL=K;const X=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function G(H){return X.test(H)}e.containsEmoji=G;const Q=/^[\t\n\r\x20-\x7E]*$/;function ne(H){return Q.test(H)}e.isBasicASCII=ne,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=se;function ue(H){for(let te=0,re=H.length;te<re;te++)if(he(H.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ue;function he(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=he;function ve(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=ve;function oe(H,te){if(H.length<te)return H;const re=/\b/g;let ae=0;for(;re.test(H)&&!(H.length-re.lastIndex<te);)ae=re.lastIndex,re.lastIndex+=1;return H.substring(ae).replace(/^\s/,"")}e.lcut=oe;const fe=/\x1B\x5B[12]?K/g,me=/\x1b\[\d+m/g,Ie=/\x1b\[0?m/g;function Me(H){return H&&(H=H.replace(fe,""),H=H.replace(me,""),H=H.replace(Ie,"")),H}e.removeAnsiEscapeCodes=Me,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function ye(H){return Ee(H)?H.substr(1):H}e.stripUTF8BOM=ye;function be(H,te){if(!H||!te||H.length<te.length)return!1;const re=te.length,ae=H.toLowerCase();let de=0,Se=-1;for(;de<re;){const Pe=ae.indexOf(te[de],Se+1);if(Pe<0)return!1;Se=Pe,de++}return!0}e.fuzzyContains=be;function De(H,te=!1){return H?(te&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=De;function Fe(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=Fe;function Ce(H,te=1){if(te===0)return"";let re=-1;do re=H.indexOf(`
`,re+1),te--;while(te>0&&re>=0);return re===-1?H:(H[re-1]==="\r"&&re--,H.substr(0,re))}e.getNLines=Ce;function je(H){const te=90-65+1;return H=H%(2*te),H<te?String.fromCharCode(97+H):String.fromCharCode(65+H-te)}e.singleLetterHash=je;function Ne(H){return Ue.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=Ne;function Be(H,te){return H===0?te!==5&&te!==7:H===2&&te===3?!1:H===4||H===2||H===3||te===4||te===2||te===3?!0:!(H===8&&(te===8||te===9||te===11||te===12)||(H===11||H===9)&&(te===9||te===10)||(H===12||H===10)&&te===10||te===5||te===13||te===7||H===1||H===13&&te===14||H===6&&te===6)}e.breakBetweenGraphemeBreakType=Be;var Ge;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ue{constructor(){this._data=ct()}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const re=this._data,ae=re.length/3;let de=1;for(;de<=ae;)if(te<re[3*de])de=2*de;else if(te>re[3*de+1])de=2*de+1;else return re[3*de+2];return 0}}Ue._INSTANCE=null;function ct(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ze(H,te){if(H===0)return 0;const re=ut(H,te);if(re!==void 0)return re;const ae=F(te,H);return H-=Ye(ae),H}e.getLeftDeleteOffset=Ze;function ut(H,te){let re=F(te,H);for(H-=Ye(re);rt(re)||re===65039||re===8419;){if(H===0)return;re=F(te,H),H-=Ye(re)}if(!!ve(re)){if(H>=0){const ae=F(te,H);ae===8205&&(H-=Ye(ae))}return H}}function Ye(H){return H>=65536?2:1}function rt(H){return 127995<=H&&H<=127999}var st;(function(H){H[H.zwj=8205]="zwj",H[H.emojiVariantSelector=65039]="emojiVariantSelector",H[H.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={}))}),define(J[17],Z([0,1,23,64]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",E=typeof TextDecoder!="undefined";let n,p;class m{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return D?new m(Buffer.allocUnsafe(f)):new m(new Uint8Array(f))}static wrap(f){return D&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new m(f)}static fromString(f,L){return!(L?.dontUseNodeBuffer||!1)&&D?new m(Buffer.from(f)):S?(n||(n=new TextEncoder),new m(n.encode(f))):new m(g.encodeUTF8(f))}static concat(f,L){if(typeof L=="undefined"){L=0;for(let B=0,q=f.length;B<q;B++)L+=f[B].byteLength}const T=m.alloc(L);let O=0;for(let B=0,q=f.length;B<q;B++){const x=f[B];T.set(x,O),O+=x.byteLength}return T}toString(){return D?this.buffer.toString():E?(p||(p=new TextDecoder),p.decode(this.buffer)):g.decodeUTF8(this.buffer)}slice(f,L){return new m(this.buffer.subarray(f,L))}set(f,L){f instanceof m?this.buffer.set(f.buffer,L):this.buffer.set(f,L)}readUInt32BE(f){return k(this.buffer,f)}writeUInt32BE(f,L){y(this.buffer,f,L)}readUInt32LE(f){return d(this.buffer,f)}writeUInt32LE(f,L){w(this.buffer,f,L)}readUInt8(f){return P(this.buffer,f)}writeUInt8(f,L){I(this.buffer,f,L)}}e.VSBuffer=m;function i(v,f){return v[f+0]<<0>>>0|v[f+1]<<8>>>0}e.readUInt16LE=i;function b(v,f,L){v[L+0]=f&255,f=f>>>8,v[L+1]=f&255}e.writeUInt16LE=b;function k(v,f){return v[f]*2**24+v[f+1]*2**16+v[f+2]*2**8+v[f+3]}e.readUInt32BE=k;function y(v,f,L){v[L+3]=f,f=f>>>8,v[L+2]=f,f=f>>>8,v[L+1]=f,f=f>>>8,v[L]=f}e.writeUInt32BE=y;function d(v,f){return v[f+0]<<0>>>0|v[f+1]<<8>>>0|v[f+2]<<16>>>0|v[f+3]<<24>>>0}e.readUInt32LE=d;function w(v,f,L){v[L+0]=f&255,f=f>>>8,v[L+1]=f&255,f=f>>>8,v[L+2]=f&255,f=f>>>8,v[L+3]=f&255}e.writeUInt32LE=w;function P(v,f){return v[f]}e.readUInt8=P;function I(v,f,L){v[L]=f}e.writeUInt8=I;function l(v){return M.consumeReadable(v,f=>m.concat(f))}e.readableToBuffer=l;function h(v){return M.toReadable(v)}e.bufferToReadable=h;function o(v){return M.consumeStream(v,f=>m.concat(f))}e.streamToBuffer=o;async function u(v){return v.ended?m.concat(v.buffer):m.concat([...v.buffer,await o(v.stream)])}e.bufferedStreamToBuffer=u;function t(v){return M.toStream(v,f=>m.concat(f))}e.bufferToStream=t;function s(v){return M.transform(v,{data:f=>typeof f=="string"?m.fromString(f):m.wrap(f)},f=>m.concat(f))}e.streamToBufferReadableStream=s;function r(v){return M.newWriteableStream(f=>m.concat(f),v)}e.newWriteableBufferStream=r;function a(v,f){return M.prefixedReadable(v,f,L=>m.concat(L))}e.prefixedBufferReadable=a;function c(v,f){return M.prefixedStream(v,f,L=>m.concat(L))}e.prefixedBufferStream=c}),define(J[80],Z([0,1,23]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function M(I){return D(I,0)}e.hash=M;function D(I,l){switch(typeof I){case"object":return I===null?S(349,l):Array.isArray(I)?p(I,l):m(I,l);case"string":return n(I,l);case"boolean":return E(I,l);case"number":return S(I,l);case"undefined":return S(937,l);default:return S(617,l)}}e.doHash=D;function S(I,l){return(l<<5)-l+I|0}function E(I,l){return S(I?433:863,l)}function n(I,l){l=S(149417,l);for(let h=0,o=I.length;h<o;h++)l=S(I.charCodeAt(h),l);return l}e.stringHash=n;function p(I,l){return l=S(104579,l),I.reduce((h,o)=>D(o,h),l)}function m(I,l){return l=S(181387,l),Object.keys(I).sort().reduce((h,o)=>(h=n(o,h),D(I[o],h)),l)}class i{constructor(){this._value=0}get value(){return this._value}hash(l){return this._value=D(l,this._value),this._value}}e.Hasher=i;var b;(function(I){I[I.BLOCK_SIZE=64]="BLOCK_SIZE",I[I.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function k(I,l,h=32){const o=h-l,u=~((1<<o)-1);return(I<<l|(u&I)>>>o)>>>0}function y(I,l=0,h=I.byteLength,o=0){for(let u=0;u<h;u++)I[l+u]=o}function d(I,l,h="0"){for(;I.length<l;)I=h+I;return I}function w(I,l=32){return I instanceof ArrayBuffer?Array.from(new Uint8Array(I)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((I>>>0).toString(16),l/4)}e.toHexString=w;class P{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(l){const h=l.length;if(h===0)return;const o=this._buff;let u=this._buffLen,t=this._leftoverHighSurrogate,s,r;for(t!==0?(s=t,r=-1,t=0):(s=l.charCodeAt(0),r=0);;){let a=s;if(g.isHighSurrogate(s))if(r+1<h){const c=l.charCodeAt(r+1);g.isLowSurrogate(c)?(r++,a=g.computeCodePoint(s,c)):a=65533}else{t=s;break}else g.isLowSurrogate(s)&&(a=65533);if(u=this._push(o,u,a),r++,r<h)s=l.charCodeAt(r);else break}this._buffLen=u,this._leftoverHighSurrogate=t}_push(l,h,o){return o<128?l[h++]=o:o<2048?(l[h++]=192|(o&1984)>>>6,l[h++]=128|(o&63)>>>0):o<65536?(l[h++]=224|(o&61440)>>>12,l[h++]=128|(o&4032)>>>6,l[h++]=128|(o&63)>>>0):(l[h++]=240|(o&1835008)>>>18,l[h++]=128|(o&258048)>>>12,l[h++]=128|(o&4032)>>>6,l[h++]=128|(o&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const l=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(l/4294967296),!1),this._buffDV.setUint32(60,l%4294967296,!1),this._step()}_step(){const l=P._bigBlock32,h=this._buffDV;for(let f=0;f<64;f+=4)l.setUint32(f,h.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)l.setUint32(f,k(l.getUint32(f-12,!1)^l.getUint32(f-32,!1)^l.getUint32(f-56,!1)^l.getUint32(f-64,!1),1),!1);let o=this._h0,u=this._h1,t=this._h2,s=this._h3,r=this._h4,a,c,v;for(let f=0;f<80;f++)f<20?(a=u&t|~u&s,c=1518500249):f<40?(a=u^t^s,c=1859775393):f<60?(a=u&t|u&s|t&s,c=2400959708):(a=u^t^s,c=3395469782),v=k(o,5)+a+r+c+l.getUint32(f*4,!1)&4294967295,r=s,s=t,t=k(u,30),u=o,o=v;this._h0=this._h0+o&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=P,P._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[13],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(f){return Array.isArray(f)}e.isArray=g;function M(f){return typeof f=="string"}e.isString=M;function D(f){return Array.isArray(f)&&f.every(L=>M(L))}e.isStringArray=D;function S(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=S;function E(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=E;function n(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=n;function p(f){return f===!0||f===!1}e.isBoolean=p;function m(f){return typeof f=="undefined"}e.isUndefined=m;function i(f){return!b(f)}e.isDefined=i;function b(f){return m(f)||f===null}e.isUndefinedOrNull=b;function k(f,L){if(!f)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}e.assertType=k;function y(f){if(b(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=y;function d(...f){const L=[];for(let T=0;T<f.length;T++){const O=f[T];if(b(O))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);L.push(O)}return L}e.assertAllDefined=d;const w=Object.prototype.hasOwnProperty;function P(f){if(!S(f))return!1;for(let L in f)if(w.call(f,L))return!1;return!0}e.isEmptyObject=P;function I(f){return typeof f=="function"}e.isFunction=I;function l(...f){return f.length>0&&f.every(I)}e.areFunctions=l;function h(f,L){const T=Math.min(f.length,L.length);for(let O=0;O<T;O++)o(f[O],L[O])}e.validateConstraints=h;function o(f,L){if(M(L)){if(typeof f!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(I(L)){try{if(f instanceof L)return}catch{}if(!b(f)&&f.constructor===L||L.length===1&&L.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function u(f){let L=[],T=Object.getPrototypeOf(f);for(;Object.prototype!==T;)L=L.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return L}e.getAllPropertyNames=u;function t(f){const L=[];for(const T of u(f))typeof f[T]=="function"&&L.push(T);return L}e.getAllMethodNames=t;function s(f,L){const T=B=>function(){const q=Array.prototype.slice.call(arguments,0);return L(B,q)};let O={};for(const B of f)O[B]=T(B);return O}e.createProxyObject=s;function r(f){return f===null?void 0:f}e.withNullAsUndefined=r;function a(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=a;function c(f){return class{constructor(){return new Proxy({},{get(L,T){if(L[T])return L[T];throw new Error(`Not Implemented: ${f}->${String(T)}`)}})}}}e.NotImplementedProxy=c;function v(f){throw new Error("Unreachable")}e.assertNever=v}),define(J[30],Z([0,1,3,23,8,13]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(r){return r===47||r===92}e.isPathSeparator=E;function n(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=n;function p(r){return r.indexOf("/")===-1&&(r=n(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=p;function m(r,a=D.posix.sep){if(!r)return"";const c=r.length,v=r.charCodeAt(0);if(E(v)){if(E(r.charCodeAt(1))&&!E(r.charCodeAt(2))){let L=3;const T=L;for(;L<c&&!E(r.charCodeAt(L));L++);if(T!==L&&!E(r.charCodeAt(L+1))){for(L+=1;L<c;L++)if(E(r.charCodeAt(L)))return r.slice(0,L+1).replace(/[\\/]/g,a)}}return a}else if(I(v)&&r.charCodeAt(1)===58)return E(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<c;f++)if(E(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.getRoot=m;function i(r){if(!g.isWindows||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let c=2;const v=c;for(;c<r.length&&(a=r.charCodeAt(c),a!==92);c++);return!(v===c||(a=r.charCodeAt(c+1),isNaN(a)||a===92))}e.isUNC=i;const b=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,a=g.isWindows){const c=a?b:k;return!(!r||r.length===0||/^\s+$/.test(r)||(c.lastIndex=0,c.test(r))||a&&y.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function w(r,a,c){const v=r===a;return!c||v?v:!r||!a?!1:(0,M.equalsIgnoreCase)(r,a)}e.isEqual=w;function P(r,a,c,v=D.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(c){if(!(0,M.startsWithIgnoreCase)(r,a))return!1;if(a.length===r.length)return!0;let L=a.length;return a.charAt(a.length-1)===v&&L--,r.charAt(L)===v}return a.charAt(a.length-1)!==v&&(a+=v),r.indexOf(a)===0}e.isEqualOrParent=P;function I(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=I;function l(r,a){return g.isWindows&&r.endsWith(":")&&(r+=D.sep),(0,D.isAbsolute)(r)||(r=(0,D.join)(a,r)),r=(0,D.normalize)(r),g.isWindows?(r=(0,M.rtrim)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,M.rtrim)(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=l;function h(r){const a=(0,D.normalize)(r);return g.isWindows?r.length>3?!1:o(a)&&(r.length===2||a.charCodeAt(2)===92):a===D.posix.sep}e.isRootOrDriveLetter=h;function o(r){return g.isWindows?I(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function u(r){return o(r)?r[0]:void 0}e.getDriveLetter=u;function t(r,a,c){return a.length>r.length?-1:r===a?0:(c&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.indexOfPath=t;function s(r){const a=r.split(":");let c,v,f;if(a.forEach(L=>{const T=Number(L);(0,S.isNumber)(T)?v===void 0?v=T:f===void 0&&(f=T):c=c?[c,L].join(":"):L}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:v!==void 0?v:void 0,column:f!==void 0?f:v!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(J[44],Z([0,1,13]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const P=Array.isArray(w)?[]:{};return Object.keys(w).forEach(I=>{w[I]&&typeof w[I]=="object"?P[I]=M(w[I]):P[I]=w[I]}),P}e.deepClone=M;function D(w){if(!w||typeof w!="object")return w;const P=[w];for(;P.length>0;){const I=P.shift();Object.freeze(I);for(const l in I)if(S.call(I,l)){const h=I[l];typeof h=="object"&&!Object.isFrozen(h)&&P.push(h)}}return w}e.deepFreeze=D;const S=Object.prototype.hasOwnProperty;function E(w,P){return n(w,P,new Set)}e.cloneAndChange=E;function n(w,P,I){if((0,g.isUndefinedOrNull)(w))return w;const l=P(w);if(typeof l!="undefined")return l;if((0,g.isArray)(w)){const h=[];for(const o of w)h.push(n(o,P,I));return h}if((0,g.isObject)(w)){if(I.has(w))throw new Error("Cannot clone recursive data-structure");I.add(w);const h={};for(let o in w)S.call(w,o)&&(h[o]=n(w[o],P,I));return I.delete(w),h}return w}function p(w,P,I=!0){return(0,g.isObject)(w)?((0,g.isObject)(P)&&Object.keys(P).forEach(l=>{l in w?I&&((0,g.isObject)(w[l])&&(0,g.isObject)(P[l])?p(w[l],P[l],I):w[l]=P[l]):w[l]=P[l]}),w):P}e.mixin=p;function m(w,P){if(w===P)return!0;if(w==null||P===null||P===void 0||typeof w!=typeof P||typeof w!="object"||Array.isArray(w)!==Array.isArray(P))return!1;let I,l;if(Array.isArray(w)){if(w.length!==P.length)return!1;for(I=0;I<w.length;I++)if(!m(w[I],P[I]))return!1}else{const h=[];for(l in w)h.push(l);h.sort();const o=[];for(l in P)o.push(l);if(o.sort(),!m(h,o))return!1;for(I=0;I<h.length;I++)if(!m(w[h[I]],P[h[I]]))return!1}return!0}e.equals=m;function i(w){const P=new Set;return JSON.stringify(w,(I,l)=>{if((0,g.isObject)(l)||Array.isArray(l)){if(P.has(l))return"[Circular]";P.add(l)}return l})}e.safeStringify=i;function b(w,P,I){const l=P(w);return typeof l=="undefined"?I:l}e.getOrDefault=b;function k(w,P){const I=Object.create(null);return!w||!P||Object.keys(P).forEach(h=>{const o=w[h],u=P[h];m(o,u)||(I[h]=u)}),I}e.distinct=k;function y(w,P){const I=P.toLowerCase(),l=Object.keys(w).find(h=>h.toLowerCase()===I);return l?w[l]:w[P]}e.getCaseInsensitive=y;function d(w,P){const I=Object.create(null);for(const l of Object.keys(w))P(l,w[l])&&(I[l]=w[l]);return I}e.filter=d}),define(J[7],Z([0,1,3,8]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,S=/^\//,E=/^\/\//;function n(r,a){if(!r.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!D.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!S.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(r,a){return!r&&!a?"file":r}function m(r,a){switch(r){case"https":case"http":case"file":a?a[0]!==b&&(a=b+a):a=b;break}return a}const i="",b="/",k=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(a,c,v,f,L,T=!1){typeof a=="object"?(this.scheme=a.scheme||i,this.authority=a.authority||i,this.path=a.path||i,this.query=a.query||i,this.fragment=a.fragment||i):(this.scheme=p(a,T),this.authority=c||i,this.path=m(this.scheme,v||i),this.query=f||i,this.fragment=L||i,n(this,T))}static isUri(a){return a instanceof y?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return h(this,!1)}with(a){if(!a)return this;let{scheme:c,authority:v,path:f,query:L,fragment:T}=a;return c===void 0?c=this.scheme:c===null&&(c=i),v===void 0?v=this.authority:v===null&&(v=i),f===void 0?f=this.path:f===null&&(f=i),L===void 0?L=this.query:L===null&&(L=i),T===void 0?T=this.fragment:T===null&&(T=i),c===this.scheme&&v===this.authority&&f===this.path&&L===this.query&&T===this.fragment?this:new w(c,v,f,L,T)}static parse(a,c=!1){const v=k.exec(a);return v?new w(v[2]||i,s(v[4]||i),s(v[5]||i),s(v[7]||i),s(v[9]||i),c):new w(i,i,i,i,i)}static file(a){let c=i;if(g.isWindows&&(a=a.replace(/\\/g,b)),a[0]===b&&a[1]===b){const v=a.indexOf(b,2);v===-1?(c=a.substring(2),a=b):(c=a.substring(2,v),a=a.substring(v)||b)}return new w("file",c,a,i,i)}static from(a){const c=new w(a.scheme,a.authority,a.path,a.query,a.fragment);return n(c,!0),c}static joinPath(a,...c){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return g.isWindows&&a.scheme==="file"?v=y.file(M.win32.join(h(a,!0),...c)).path:v=M.posix.join(a.path,...c),a.with({path:v})}toString(a=!1){return o(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof y)return a;{const c=new w(a);return c._formatted=a.external,c._fsPath=a._sep===d?a.fsPath:null,c}}else return a}}e.URI=y;const d=g.isWindows?1:void 0;class w extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(a=!1){return a?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=d),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const P={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function I(r,a){let c,v=-1;for(let f=0;f<r.length;f++){const L=r.charCodeAt(f);if(L>=97&&L<=122||L>=65&&L<=90||L>=48&&L<=57||L===45||L===46||L===95||L===126||a&&L===47)v!==-1&&(c+=encodeURIComponent(r.substring(v,f)),v=-1),c!==void 0&&(c+=r.charAt(f));else{c===void 0&&(c=r.substr(0,f));const T=P[L];T!==void 0?(v!==-1&&(c+=encodeURIComponent(r.substring(v,f)),v=-1),c+=T):v===-1&&(v=f)}}return v!==-1&&(c+=encodeURIComponent(r.substring(v))),c!==void 0?c:r}function l(r){let a;for(let c=0;c<r.length;c++){const v=r.charCodeAt(c);v===35||v===63?(a===void 0&&(a=r.substr(0,c)),a+=P[v]):a!==void 0&&(a+=r[c])}return a!==void 0?a:r}function h(r,a){let c;return r.authority&&r.path.length>1&&r.scheme==="file"?c=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?a?c=r.path.substr(1):c=r.path[1].toLowerCase()+r.path.substr(2):c=r.path,g.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=h;function o(r,a){const c=a?l:I;let v="",{scheme:f,authority:L,path:T,query:O,fragment:B}=r;if(f&&(v+=f,v+=":"),(L||f==="file")&&(v+=b,v+=b),L){let q=L.indexOf("@");if(q!==-1){const x=L.substr(0,q);L=L.substr(q+1),q=x.indexOf(":"),q===-1?v+=c(x,!1):(v+=c(x.substr(0,q),!1),v+=":",v+=c(x.substr(q+1),!1)),v+="@"}L=L.toLowerCase(),q=L.indexOf(":"),q===-1?v+=c(L,!1):(v+=c(L.substr(0,q),!1),v+=L.substr(q))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const q=T.charCodeAt(1);q>=65&&q<=90&&(T=`/${String.fromCharCode(q+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const q=T.charCodeAt(0);q>=65&&q<=90&&(T=`${String.fromCharCode(q+32)}:${T.substr(2)}`)}v+=c(T,!0)}return O&&(v+="?",v+=c(O,!1)),B&&(v+="#",v+=a?B:I(B,!1)),v}function u(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+u(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,a=>u(a)):r}}),define(J[110],Z([0,1,7]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function M(m){const i=m;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=M;function D(m){const i=[];let b;try{const k=JSON.parse(m.arguments),y=k[k.length-1];y&&y.__$stack&&(k.pop(),b=y.__$stack),i.push(...k)}catch(k){i.push("Unable to log remote console arguments",m.arguments)}return{args:i,stack:b}}e.parse=D;function S(m){if(typeof m!="string")return S(D(m).stack);const i=m;if(i){const b=E(i),k=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(k&&k.length===4)return{uri:g.URI.file(k[1]),line:Number(k[2]),column:Number(k[3])}}}e.getFirstFrame=S;function E(m){if(!m)return m;const i=m.indexOf(`
`);return i===-1?m:m.substring(0,i)}function n(m,i){const{args:b,stack:k}=D(m),y=typeof b[0]=="string"&&b.length===1;let d=E(k);d&&(d=`(${d.trim()})`);let w=[];if(typeof b[0]=="string"?d&&y?w=[`%c[${i}] %c${b[0]} %c${d}`,p("blue"),p(""),p("grey")]:w=[`%c[${i}] %c${b[0]}`,p("blue"),p(""),...b.slice(1)]:w=[`%c[${i}]%`,p("blue"),...b],d&&!y&&w.push(d),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,w)}e.log=n;function p(m){return`color: ${m}`}});var bt=this&&this.__classPrivateFieldSet||function(j,e,g,M,D){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!D:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?D.call(j,g):D?D.value=g:e.set(j,g),g},qe=this&&this.__classPrivateFieldGet||function(j,e,g,M){if(g==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!M:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?M:g==="a"?M.call(j):M?M.value:e.get(j)};define(J[37],Z([0,1,7,23]),function(j,e,g,M){"use strict";var D,S,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function n(t,s,r){let a=t.get(s);return a===void 0&&(a=r,t.set(s,a)),a}e.getOrSet=n;function p(t){const s=[];return t.forEach((r,a)=>{s.push(`${a} => ${r}`)}),`Map(${t.size}) {${s.join(", ")}}`}e.mapToString=p;function m(t){const s=[];return t.forEach(r=>{s.push(r)}),`Set(${t.size}) {${s.join(", ")}}`}e.setToString=m;class i{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const r=s.charCodeAt(0),a=this._value.charCodeAt(this._pos);return r-a}value(){return this._value[this._pos]}}e.StringIterator=i;class b{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,M.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class k{constructor(s=!0,r=!0){this._splitOnBackslash=s,this._caseSensitive=r}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,M.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var y;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(y||(y={}));class d{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,M.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class w{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class P{constructor(s){this._iter=s}static forUris(s=()=>!1){return new P(new d(s))}static forPaths(){return new P(new k)}static forStrings(){return new P(new i)}static forConfigKeys(){return new P(new b)}clear(){this._root=void 0}set(s,r){const a=this._iter.reset(s);let c;for(this._root||(this._root=new w,this._root.segment=a.value()),c=this._root;;){const f=a.cmp(c.segment);if(f>0)c.left||(c.left=new w,c.left.segment=a.value()),c=c.left;else if(f<0)c.right||(c.right=new w,c.right.segment=a.value()),c=c.right;else if(a.hasNext())a.next(),c.mid||(c.mid=new w,c.mid.segment=a.value()),c=c.mid;else break}const v=c.value;return c.value=r,c.key=s,v}get(s){return this._getNode(s)?.value}_getNode(s){const r=this._iter.reset(s);let a=this._root;for(;a;){const c=r.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else break}return a}has(s){const r=this._getNode(s);return!(r?.value===void 0&&r?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,r){const a=this._iter.reset(s),c=[];let v=this._root;for(;v;){const f=a.cmp(v.segment);if(f>0)c.push([1,v]),v=v.left;else if(f<0)c.push([-1,v]),v=v.right;else if(a.hasNext())a.next(),c.push([0,v]),v=v.mid;else{for(r?(v.left=void 0,v.mid=void 0,v.right=void 0):v.value=void 0;c.length>0&&v.isEmpty();){let[L,T]=c.pop();switch(L){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}v=T}break}}}findSubstr(s){const r=this._iter.reset(s);let a=this._root,c;for(;a;){const v=r.cmp(a.segment);if(v>0)a=a.left;else if(v<0)a=a.right;else if(r.hasNext())r.next(),c=a.value||c,a=a.mid;else break}return a&&a.value||c}findSuperstr(s){const r=this._iter.reset(s);let a=this._root;for(;a;){const c=r.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(r.hasNext())r.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(s){for(const[r,a]of this)s(a,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const r=[s];for(;r.length>0;){const a=r.pop();a&&(a.value&&(yield[a.key,a.value]),a.left&&r.push(a.left),a.mid&&r.push(a.mid),a.right&&r.push(a.right))}}}e.TernarySearchTree=P;class I{constructor(s,r){this[D]="ResourceMap",s instanceof I?(this.map=new Map(s.map),this.toKey=r??I.defaultToKey):(this.map=new Map,this.toKey=s??I.defaultToKey)}set(s,r){return this.map.set(this.toKey(s),r),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,r){typeof r!="undefined"&&(s=s.bind(r));for(let[a,c]of this.map)s(c,g.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield g.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[g.URI.parse(s[0]),s[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[g.URI.parse(s[0]),s[1]]}}e.ResourceMap=I,I.defaultToKey=t=>t.toString();var l;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class h{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,r=0){const a=this._map.get(s);if(!!a)return r!==0&&this.touch(a,r),a.value}set(s,r,a=0){let c=this._map.get(s);if(c)c.value=r,a!==0&&this.touch(c,a);else{switch(c={key:s,value:r,next:void 0,previous:void 0},a){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(s,c),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const r=this._map.get(s);if(!!r)return this._map.delete(s),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,r){const a=this._state;let c=this._head;for(;c;){if(r?s.bind(r)(c.value,c.key,this):s(c.value,c.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const s=this,r=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const v={value:a.key,done:!1};return a=a.next,v}else return{value:void 0,done:!0}}};return c}values(){const s=this,r=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const v={value:a.value,done:!1};return a=a.next,v}else return{value:void 0,done:!0}}};return c}entries(){const s=this,r=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const v={value:[a.key,a.value],done:!1};return a=a.next,v}else return{value:void 0,done:!0}}};return c}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let r=this._head,a=this.size;for(;r&&a>s;)this._map.delete(r.key),r=r.next,a--;this._head=r,this._size=a,r&&(r.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const r=s.next,a=s.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}s.next=void 0,s.previous=void 0,this._state++}touch(s,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(s===this._head)return;const a=s.next,c=s.previous;s===this._tail?(c.next=void 0,this._tail=c):(a.previous=c,c.next=a),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(r===2){if(s===this._tail)return;const a=s.next,c=s.previous;s===this._head?(a.previous=void 0,this._head=a):(a.previous=c,c.next=a),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((r,a)=>{s.push([a,r])}),s}fromJSON(s){this.clear();for(const[r,a]of s)this.set(r,a)}}e.LinkedMap=h;class o extends h{constructor(s,r=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,r=2){return super.get(s,r)}peek(s){return super.get(s,0)}set(s,r){return super.set(s,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class u{constructor(s){E.set(this,void 0),bt(this,E,s,"f")}get size(){return qe(this,E,"f").size}forEach(s,r){qe(this,E,"f").forEach(s,r)}get(s){return qe(this,E,"f").get(s)}has(s){return qe(this,E,"f").has(s)}entries(){return qe(this,E,"f").entries()}keys(){return qe(this,E,"f").keys()}values(){return qe(this,E,"f").values()}[(E=new WeakMap,Symbol.iterator)](){return qe(this,E,"f").entries()}}e.ReadonlyMapView=u}),define(J[111],Z([0,1,17,23,7]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function S(i){return JSON.stringify(i,p)}e.stringify=S;function E(i){let b=JSON.parse(i);return b=m(b),b}e.parse=E;var n;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(n=e.MarshalledId||(e.MarshalledId={}));function p(i,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,M.regExpFlags)(b)}:b}function m(i,b=0){if(!i||b>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return D.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof g.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let k=0;k<i.length;++k)i[k]=m(i[k],b+1);else for(const k in i)Object.hasOwnProperty.call(i,k)&&(i[k]=m(i[k],b+1))}return i}e.revive=m}),define(J[10],Z([0,1,7,3]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractive="vscode-interactive",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}set(p,m,i){this._hosts[p]=m,this._ports[p]=i}setConnectionToken(p,m){this._connectionTokens[p]=m}rewrite(p){if(this._delegate)return this._delegate(p);const m=p.authority;let i=this._hosts[m];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const b=this._ports[m],k=this._connectionTokens[m];let y=`path=${encodeURIComponent(p.path)}`;return typeof k=="string"&&(y+=`&tkn=${encodeURIComponent(k)}`),g.URI.from({scheme:M.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${i}:${b}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new S;class E{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(p,m,i){const b=this.toUri(p,m);if(b.scheme===D.vscodeRemote)return e.RemoteAuthorities.rewrite(b);let k=!1;return M.isNative&&(i||M.isPreferringBrowserCodeLoad)&&b.scheme===D.file&&(k=!0),b.scheme===D.file&&typeof M.globals.importScripts=="function"&&M.globals.origin==="vscode-file://vscode-app"&&(k=!0),k?b.with({scheme:D.vscodeFileResource,authority:b.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(p,m){const i=this.toUri(p,m);return i.scheme===D.vscodeFileResource?i.with({scheme:D.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(p,m){return g.URI.isUri(p)?p:g.URI.parse(m.toUrl(p))}}e.FileAccess=new E}),define(J[65],Z([0,1,37]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const M=new g.LRUCache(1e4);function D(m){return p(m,"NFC",M)}e.normalizeNFC=D;const S=new g.LRUCache(1e4);function E(m){return p(m,"NFD",S)}e.normalizeNFD=E;const n=/[^\u0000-\u0080]/;function p(m,i,b){if(!m)return m;const k=b.get(m);if(k)return k;let y;return n.test(m)?y=m.normalize(i):y=m,b.set(m,y),y}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(i){return E(i).replace(m,"")}}()}),define(J[15],Z([0,1,30,8,7,23,10,3]),function(j,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function p(y){return(0,D.uriToFsPath)(y,!0)}e.originalFSPath=p;class m{constructor(d){this._ignorePathCasing=d}compare(d,w,P=!1){return d===w?0:(0,S.compare)(this.getComparisonKey(d,P),this.getComparisonKey(w,P))}isEqual(d,w,P=!1){return d===w?!0:!d||!w?!1:this.getComparisonKey(d,P)===this.getComparisonKey(w,P)}getComparisonKey(d,w=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,w,P=!1){if(d.scheme===w.scheme){if(d.scheme===E.Schemas.file)return g.isEqualOrParent(p(d),p(w),this._ignorePathCasing(d))&&d.query===w.query&&(P||d.fragment===w.fragment);if((0,e.isEqualAuthority)(d.authority,w.authority))return g.isEqualOrParent(d.path,w.path,this._ignorePathCasing(d),"/")&&d.query===w.query&&(P||d.fragment===w.fragment)}return!1}joinPath(d,...w){return D.URI.joinPath(d,...w)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return M.posix.basename(d.path)}extname(d){return M.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let w;return d.scheme===E.Schemas.file?w=D.URI.file(M.dirname(p(d))).path:(w=M.posix.dirname(d.path),d.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),w="/")),d.with({path:w})}normalizePath(d){if(!d.path.length)return d;let w;return d.scheme===E.Schemas.file?w=D.URI.file(M.normalize(p(d))).path:w=M.posix.normalize(d.path),d.with({path:w})}relativePath(d,w){if(d.scheme!==w.scheme||!(0,e.isEqualAuthority)(d.authority,w.authority))return;if(d.scheme===E.Schemas.file){const l=M.relative(p(d),p(w));return n.isWindows?g.toSlashes(l):l}let P=d.path||"/",I=w.path||"/";if(this._ignorePathCasing(d)){let l=0;for(const h=Math.min(P.length,I.length);l<h&&!(P.charCodeAt(l)!==I.charCodeAt(l)&&P.charAt(l).toLowerCase()!==I.charAt(l).toLowerCase());l++);P=I.substr(0,l)+P.substr(l)}return M.posix.relative(P,I)}resolvePath(d,w){if(d.scheme===E.Schemas.file){const P=D.URI.file(M.resolve(p(d),w));return d.with({authority:P.authority,path:P.path})}return w=g.toPosixPath(w),d.with({path:M.posix.resolve(d.path,w)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,w){return d===w||(0,S.equalsIgnoreCase)(d,w)}hasTrailingPathSeparator(d,w=M.sep){if(d.scheme===E.Schemas.file){const P=p(d);return P.length>g.getRoot(P).length&&P[P.length-1]===w}else{const P=d.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,w=M.sep){return(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,w=M.sep){let P=!1;if(d.scheme===E.Schemas.file){const I=p(d);P=I!==void 0&&I.length===g.getRoot(I).length&&I[I.length-1]===w}else{w="/";const I=d.path;P=I.length===1&&I.charCodeAt(I.length-1)===47}return!P&&!(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path+"/"}):d}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(y=>y.scheme===E.Schemas.file?!n.isLinux:!0),e.extUriIgnorePathCase=new m(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(y,d){const w=[];for(let P=0;P<y.length;P++){const I=d(y[P]);y.some((l,h)=>h===P?!1:(0,e.isEqualOrParent)(I,d(l)))||w.push(y[P])}return w}e.distinctParents=i;var b;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function d(w){const P=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(h=>{const[o,u]=h.split(":");o&&u&&P.set(o,u)});const l=w.path.substring(0,w.path.indexOf(";"));return l&&P.set(y.META_DATA_MIME,l),P}y.parseMetaData=d})(b=e.DataUri||(e.DataUri={}));function k(y,d,w){if(d){let P=y.path;return P&&P[0]!==M.posix.sep&&(P=M.posix.sep+P),y.with({scheme:w,authority:d,path:P})}return y.with({scheme:w})}e.toLocalResource=k}),define(J[9],Z([0,1,25,16,5,2,15]),function(j,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function n(N){return!!N&&typeof N.then=="function"}e.isThenable=n;function p(N){const F=new g.CancellationTokenSource,$=N(F.token),W=new Promise((R,C)=>{const _=F.token.onCancellationRequested(()=>{_.dispose(),F.dispose(),C((0,M.canceled)())});Promise.resolve($).then(A=>{_.dispose(),F.dispose(),R(A)},A=>{_.dispose(),F.dispose(),C(A)})});return new class{cancel(){F.cancel()}then(R,C){return W.then(R,C)}catch(R){return this.then(void 0,R)}finally(R){return W.finally(R)}}}e.createCancelablePromise=p;function m(N,F,$){return Promise.race([N,new Promise(W=>F.onCancellationRequested(()=>W($)))])}e.raceCancellation=m;async function i(N){let F=-1;const $=N.map((R,C)=>R.then(_=>(F=C,_))),W=await Promise.race($);return N.forEach((R,C)=>{C!==F&&R.cancel()}),W}e.raceCancellablePromises=i;function b(N,F,$){let W;const R=setTimeout(()=>{W?.(void 0),$?.()},F);return Promise.race([N.finally(()=>clearTimeout(R)),new Promise(C=>W=C)])}e.raceTimeout=b;function k(N){return new Promise((F,$)=>{const W=N();n(W)?W.then(F,$):F(W)})}e.asPromise=k;class y{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then($,$).then(W)})}return new Promise(($,W)=>{this.queuedPromise.then($,W)})}return this.activePromise=F(),new Promise(($,W)=>{this.activePromise.then(R=>{this.activePromise=null,$(R)},R=>{this.activePromise=null,W(R)})})}}e.Throttler=y;class d{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=d;class w{constructor(){this.promiseMap=new Map}queue(F,$){const R=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(F)===R&&this.promiseMap.delete(F)});return this.promiseMap.set(F,R),R}}e.SequencerByKey=w;class P{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,$=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((W,R)=>{this.doResolve=W,this.doReject=R}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const W=this.task;return this.task=null,W()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},$),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=P;class I{constructor(F){this.delayer=new P(F),this.throttler=new y}trigger(F,$){return this.delayer.trigger(()=>this.throttler.queue(F),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=I;class l{constructor(){this._isOpen=!1,this._promise=new Promise((F,$)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class h extends l{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function o(N,F){return F?new Promise(($,W)=>{const R=setTimeout(()=>{C.dispose(),$()},N),C=F.onCancellationRequested(()=>{clearTimeout(R),C.dispose(),W((0,M.canceled)())})}):p($=>o(N,$))}e.timeout=o;function u(N,F=0){const $=setTimeout(N,F);return(0,S.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=u;function t(N){const F=[];let $=0;const W=N.length;function R(){return $<W?N[$++]():null}function C(_){_!=null&&F.push(_);const A=R();return A?A.then(C):Promise.resolve(F)}return Promise.resolve(null).then(C)}e.sequence=t;function s(N,F=W=>!!W,$=null){let W=0;const R=N.length,C=()=>{if(W>=R)return Promise.resolve($);const _=N[W++];return Promise.resolve(_()).then(z=>F(z)?Promise.resolve(z):C())};return C()}e.first=s;function r(N,F=W=>!!W,$=null){if(N.length===0)return Promise.resolve($);let W=N.length;const R=()=>{W=-1;for(const C of N)C.cancel?.()};return new Promise((C,_)=>{for(const A of N)A.then(z=>{--W>=0&&F(z)?(R(),C(z)):W===0&&C($)}).catch(z=>{--W>=0&&(R(),_(z))})})}e.firstParallel=r;class a{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise(($,W)=>{this.outstandingPromises.push({factory:F,c:$,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const $=F.factory();$.then(F.c,F.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=a;class c extends a{constructor(){super(1)}}e.Queue=c;class v{constructor(){this.queues=new Map}queueFor(F,$=E.extUri){const W=$.getComparisonKey(F);let R=this.queues.get(W);return R||(R=new c,D.Event.once(R.onFinished)(()=>{R?.dispose(),this.queues.delete(W)}),this.queues.set(W,R)),R}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=v;class f{constructor(F,$){this._token=-1,typeof F=="function"&&typeof $=="number"&&this.setIfNotSet(F,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},$)}setIfNotSet(F,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},$))}}e.TimeoutTimer=f;class L{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,$){this.cancel(),this._token=setInterval(()=>{F()},$)}}e.IntervalTimer=L;class T{constructor(F,$){this.timeoutToken=-1,this.runner=F,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class O extends T{constructor(F,$){super(F,$);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class B extends S.Disposable{constructor(F,$,W,R){super();this.maxWorkChunkSize=F,this.maxPendingWork=$,this.throttleDelay=W,this.handler=R,this.pendingWork=[],this.throttler=this._register(new S.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new T(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const $=setTimeout(()=>F(N));let W=!1;return{dispose(){W||(W=!0,clearTimeout($))}}}}else e.runWhenIdle=(N,F)=>{const $=requestIdleCallback(N,typeof F=="number"?{timeout:F}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback($))}}}}();class q{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=q;async function x(N,F,$){let W;for(let R=0;R<$;R++)try{return await N()}catch(C){W=C,await o(F)}throw W}e.retry=x;class ie{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,$,W){return this._pending={taskId:F,cancel:()=>W?.(),promise:$},$.then(()=>this.donePending(F),()=>this.donePending(F)),$}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let $,W;const R=new Promise((C,_)=>{$=C,W=_});this._next={run:F,promise:R,promiseResolve:$,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=ie;class V{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class Y{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,$)=>{this.completeCallback=F,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise($=>{this.completeCallback(F),this.resolved=!0,$()})}error(F){return new Promise($=>{this.errorCallback(F),this.rejected=!0,$()})}cancel(){new Promise(F=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=Y;var U;(function(N){async function F($){let W;const R=await Promise.all($.map(C=>C.then(_=>_,_=>{W||(W=_)})));if(typeof W!="undefined")throw W;return R}N.settled=F})(U=e.Promises||(e.Promises={}))}),define(J[112],Z([0,1,23,30,8,37,9]),function(j,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const p="**",m="/",i="[/\\\\]",b="[^/\\\\]",k=/\//g;function y(R){switch(R){case 0:return"";case 1:return`${b}*?`;default:return`(?:${i}|${b}+${i}|${i}${b}+)*?`}}function d(R,C){if(!R)return[];const _=[];let A=!1,z=!1,K="";for(const X of R){switch(X){case C:if(!A&&!z){_.push(K),K="";continue}break;case"{":A=!0;break;case"}":A=!1;break;case"[":z=!0;break;case"]":z=!1;break}K+=X}return K&&_.push(K),_}e.splitGlobAware=d;function w(R){if(!R)return"";let C="";const _=d(R,m);if(_.every(A=>A===p))C=".*";else{let A=!1;_.forEach((z,K)=>{if(z===p){A||(C+=y(2),A=!0);return}let X=!1,G="",Q=!1,ne="";for(const se of z){if(se!=="}"&&X){G+=se;continue}if(Q&&(se!=="]"||!ne)){let ue;se==="-"?ue=se:(se==="^"||se==="!")&&!ne?ue="^":se===m?ue="":ue=g.escapeRegExpCharacters(se),ne+=ue;continue}switch(se){case"{":X=!0;continue;case"[":Q=!0;continue;case"}":C+=`(?:${d(G,",").map(ve=>w(ve)).join("|")})`,X=!1,G="";break;case"]":C+="["+ne+"]",Q=!1,ne="";break;case"?":C+=b;continue;case"*":C+=y(1);continue;default:C+=g.escapeRegExpCharacters(se)}}K<_.length-1&&(_[K+1]!==p||K+2<_.length)&&(C+=i),A=!1})}return C}const P=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),s=function(){return!1},r=function(){return null};function a(R,C){if(!R)return r;let _;typeof R!="string"?_=R.pattern:_=R,_=_.trim();const A=`${_}_${!!C.trimForExclusions}`;let z=t.get(A);if(z)return c(z,R);let K;if(P.test(_)){const X=_.substr(4);z=function(G,Q){return typeof G=="string"&&G.endsWith(X)?_:null}}else(K=I.exec(v(_,C)))?z=f(K[1],_):(C.trimForExclusions?h:l).test(_)?z=L(_,C):(K=o.exec(v(_,C)))?z=T(K[1].substr(1),_,!0):(K=u.exec(v(_,C)))?z=T(K[1],_,!1):z=O(_);return t.set(A,z),c(z,R)}function c(R,C){return typeof C=="string"?R:function(_,A){return M.isEqualOrParent(_,C.base)?R(D.relative(C.base,_),A):null}}function v(R,C){return C.trimForExclusions&&R.endsWith("/**")?R.substr(0,R.length-2):R}function f(R,C){const _=`/${R}`,A=`\\${R}`,z=function(X,G){return typeof X!="string"?null:G?G===R?C:null:X===R||X.endsWith(_)||X.endsWith(A)?C:null},K=[R];return z.basenames=K,z.patterns=[C],z.allBasenames=K,z}function L(R,C){const _=W(R.slice(1,-1).split(",").map(G=>a(G,C)).filter(G=>G!==r),R),A=_.length;if(!A)return r;if(A===1)return _[0];const z=function(G,Q){for(let ne=0,se=_.length;ne<se;ne++)if(_[ne](G,Q))return R;return null},K=_.find(G=>!!G.allBasenames);K&&(z.allBasenames=K.allBasenames);const X=_.reduce((G,Q)=>Q.allPaths?G.concat(Q.allPaths):G,[]);return X.length&&(z.allPaths=X),z}function T(R,C,_){const A=D.sep===D.posix.sep,z=A?R:R.replace(k,D.sep),K=D.sep+z,X=D.posix.sep+R,G=_?function(Q,ne){return typeof Q=="string"&&(Q===z||Q.endsWith(K)||!A&&(Q===R||Q.endsWith(X)))?C:null}:function(Q,ne){return typeof Q=="string"&&(Q===z||!A&&Q===R)?C:null};return G.allPaths=[(_?"*/":"./")+R],G}function O(R){try{const C=new RegExp(`^${w(R)}$`);return function(_){return C.lastIndex=0,typeof _=="string"&&C.test(_)?R:null}}catch(C){return r}}function B(R,C,_){return!R||typeof C!="string"?!1:q(R)(C,void 0,_)}e.match=B;function q(R,C={}){if(!R)return s;if(typeof R=="string"||Y(R)){const _=a(R,C);if(_===r)return s;const A=function(z,K){return!!_(z,K)};return _.allBasenames&&(A.allBasenames=_.allBasenames),_.allPaths&&(A.allPaths=_.allPaths),A}return F(R,C)}e.parse=q;function x(R){if(!R)return;let C;return _=>(C||(C=(R()||Promise.resolve([])).then(A=>A?V(A):{})),C.then(A=>!!A[_]))}e.hasSiblingPromiseFn=x;function ie(R){if(!R)return;let C;return _=>{if(!C){const A=R();C=A?V(A):{}}return!!C[_]}}e.hasSiblingFn=ie;function V(R){const C={};for(const _ of R)C[_]=!0;return C}function Y(R){const C=R;return C&&typeof C.base=="string"&&typeof C.pattern=="string"}e.isRelativePattern=Y;function U(R){return R.allBasenames||[]}e.getBasenameTerms=U;function N(R){return R.allPaths||[]}e.getPathTerms=N;function F(R,C){const _=W(Object.getOwnPropertyNames(R).map(G=>$(G,R[G],C)).filter(G=>G!==r)),A=_.length;if(!A)return r;if(!_.some(G=>!!G.requiresSiblings)){if(A===1)return _[0];const G=function(se,ue){for(let he=0,ve=_.length;he<ve;he++){const oe=_[he](se,ue);if(oe)return oe}return null},Q=_.find(se=>!!se.allBasenames);Q&&(G.allBasenames=Q.allBasenames);const ne=_.reduce((se,ue)=>ue.allPaths?se.concat(ue.allPaths):se,[]);return ne.length&&(G.allPaths=ne),G}const z=function(G,Q,ne){let se;for(let ue=0,he=_.length;ue<he;ue++){const ve=_[ue];ve.requiresSiblings&&ne&&(Q||(Q=D.basename(G)),se||(se=Q.substr(0,Q.length-D.extname(G).length)));const oe=ve(G,Q,se,ne);if(oe)return oe}return null},K=_.find(G=>!!G.allBasenames);K&&(z.allBasenames=K.allBasenames);const X=_.reduce((G,Q)=>Q.allPaths?G.concat(Q.allPaths):G,[]);return X.length&&(z.allPaths=X),z}function $(R,C,_){if(C===!1)return r;const A=a(R,_);if(A===r)return r;if(typeof C=="boolean")return A;if(C){const z=C.when;if(typeof z=="string"){const K=(X,G,Q,ne)=>{if(!ne||!A(X,G))return null;const se=z.replace("$(basename)",Q),ue=ne(se);return(0,E.isThenable)(ue)?ue.then(he=>he?R:null):ue?R:null};return K.requiresSiblings=!0,K}}return A}function W(R,C){const _=R.filter(G=>!!G.basenames);if(_.length<2)return R;const A=_.reduce((G,Q)=>{const ne=Q.basenames;return ne?G.concat(ne):G},[]);let z;if(C){z=[];for(let G=0,Q=A.length;G<Q;G++)z.push(C)}else z=_.reduce((G,Q)=>{const ne=Q.patterns;return ne?G.concat(ne):G},[]);const K=function(G,Q){if(typeof G!="string")return null;if(!Q){let se;for(se=G.length;se>0;se--){const ue=G.charCodeAt(se-1);if(ue===47||ue===92)break}Q=G.substr(se)}const ne=A.indexOf(Q);return ne!==-1?z[ne]:null};K.basenames=A,K.patterns=z,K.allBasenames=A;const X=R.filter(G=>!G.basenames);return X.push(K),X}}),define(J[31],Z([0,1,7,8,23,10,3,15,30]),function(j,e,g,M,D,S,E,n,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function m(a,c,v){if(typeof a=="string"&&(a=g.URI.file(a)),v){const L=v.getWorkspaceFolder(a);if(L){const T=v.getWorkspace().folders.length>1;let O;if((0,n.isEqual)(L.uri,a)?O="":O=(0,n.relativePath)(L.uri,a),T){const B=L.name?L.name:(0,n.basename)(L.uri);O=O?B+" \u2022 "+O:B}return O}}if(a.scheme!==S.Schemas.file&&a.scheme!==S.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(a.fsPath))return(0,M.normalize)(b(a.fsPath));let f=(0,M.normalize)(a.fsPath);return!E.isWindows&&c?.userHome&&(f=y(f,c.userHome.fsPath)),f}e.getPathLabel=m;function i(a){if(!a)return;typeof a=="string"&&(a=g.URI.file(a));const c=(0,n.basename)(a)||(a.scheme===S.Schemas.file?a.fsPath:a.path);return E.isWindows&&(0,p.isRootOrDriveLetter)(c)?b(c):c}e.getBaseLabel=i;function b(a){return(0,p.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=b;let k=Object.create(null);function y(a,c){if(E.isWindows||!a||!c)return a;let v=k.original===c?k.normalized:void 0;return v||(v=`${(0,D.rtrim)(c,M.posix.sep)}${M.posix.sep}`,k={original:c,normalized:v}),(E.isLinux?a.startsWith(v):(0,D.startsWithIgnoreCase)(a,v))&&(a=`~/${a.substr(v.length)}`),a}e.tildify=y;function d(a,c){return a.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=d;const w="\u2026",P="\\\\",I="~";function l(a,c=M.sep){const v=new Array(a.length);let f=!1;for(let L=0;L<a.length;L++){let T=a[L];if(T===""){v[L]=`.${c}`;continue}if(!T){v[L]=T;continue}f=!0;let O="";T.indexOf(P)===0?(O=T.substr(0,T.indexOf(P)+P.length),T=T.substr(T.indexOf(P)+P.length)):T.indexOf(c)===0?(O=T.substr(0,T.indexOf(c)+c.length),T=T.substr(T.indexOf(c)+c.length)):T.indexOf(I)===0&&(O=T.substr(0,T.indexOf(I)+I.length),T=T.substr(T.indexOf(I)+I.length));const B=T.split(c);for(let q=1;f&&q<=B.length;q++)for(let x=B.length-q;f&&x>=0;x--){f=!1;let ie=B.slice(x,x+q).join(c);for(let V=0;!f&&V<a.length;V++)if(V!==L&&a[V]&&a[V].indexOf(ie)>-1){const Y=x+q===B.length,U=x>0&&a[V].indexOf(c)>-1?c+ie:ie,N=a[V].endsWith(U);f=!Y||N}if(!f){let V="";(B[0].endsWith(":")||O!=="")&&(x===1&&(x=0,q++,ie=B[0]+c+ie),x>0&&(V=B[0]+c),V=O+V),x>0&&(V=V+w+c),V=V+ie,x+q<B.length&&(V=V+c+w),v[L]=V}}f&&(v[L]=T)}return v}e.shorten=l;var h;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(a,c=Object.create(null)){const v=[];let f=!1,L="";for(const T of a)if(T==="$"||f&&T==="{")L&&v.push({value:L,type:h.TEXT}),L="",f=!0;else if(T==="}"&&f){const O=c[L];if(typeof O=="string")O.length&&v.push({value:O,type:h.VARIABLE});else if(O){const B=v[v.length-1];(!B||B.type!==h.SEPARATOR)&&v.push({value:O.label,type:h.SEPARATOR})}L="",f=!1}else L+=T;return L&&!f&&v.push({value:L,type:h.TEXT}),v.filter((T,O)=>{if(T.type===h.SEPARATOR){const B=v[O-1],q=v[O+1];return[B,q].every(x=>x&&(x.type===h.VARIABLE||x.type===h.TEXT)&&x.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=o;function u(a,c){return E.isMacintosh||c?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,E.isMacintosh?"&":"&&"):a.replace(/&&|&/g,v=>v==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function t(a,c){return E.isMacintosh||c?a.replace(/\(&&\w\)|&&/g,""):E.isWindows?a.replace(/&&|&/g,v=>v==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function s(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(a){const c=a.indexOf("/")!==-1?M.posix:M.win32,v=c.basename(a),f=c.dirname(a);return v.length?{name:v,parentPath:f}:{name:f,parentPath:""}}e.splitName=r}),define(J[28],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(p){return g.test(p)}e.isUUID=M;const D=new Uint8Array(16),S=[];for(let p=0;p<256;p++)S.push(p.toString(16).padStart(2,"0"));let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(p){for(let m=0;m<p.length;m++)p[m]=Math.floor(Math.random()*256);return p};function n(){E(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let p=0,m="";return m+=S[D[p++]],m+=S[D[p++]],m+=S[D[p++]],m+=S[D[p++]],m+="-",m+=S[D[p++]],m+=S[D[p++]],m+="-",m+=S[D[p++]],m+=S[D[p++]],m+="-",m+=S[D[p++]],m+=S[D[p++]],m+="-",m+=S[D[p++]],m+=S[D[p++]],m+=S[D[p++]],m+=S[D[p++]],m+=S[D[p++]],m+=S[D[p++]],m}e.generateUuid=n}),define(J[113],Z([0,1,29,58,43]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function S(E,n){if(await new Promise((i,b)=>{const k=g.createReadStream(E),y=M.createHash("sha1");k.pipe(y);const d=(0,D.once)((w,P)=>{k.removeAllListeners(),y.removeAllListeners(),w?b(w):i(P)});k.once("error",d),k.once("end",d),y.once("error",d),y.once("data",w=>d(void 0,w.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=S}),define(J[81],Z([0,1,239]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class M{constructor(S="utf8"){this.stringDecoder=new g.StringDecoder(S),this.remaining=null}write(S){const E=[],n=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(n.length<1)return E;let p=0,m,i=p;for(;i<n.length;)if(m=n.charCodeAt(i),m===13||m===10){if(E.push(n.substring(p,i)),i++,i<n.length){const b=m;m=n.charCodeAt(i),(b===13&&m===10||b===10&&m===13)&&i++}p=i}else i++;return this.remaining=p<n.length?n.substr(p):null,E}end(){return this.remaining}}e.LineDecoder=M}),define(J[114],Z([0,1,26]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const M=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(n){const p=n.replace(/\-/g,":").toLowerCase();return!M.has(p)}function S(){return new Promise(async(n,p)=>{const m=setTimeout(()=>p("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await E())}catch(i){p(i)}finally{clearTimeout(m)}})}e.getMac=S;function E(){return new Promise((n,p)=>{try{const m=(0,g.networkInterfaces)();for(let i in m){const b=m[i];if(b){for(const{mac:k}of b)if(D(k))return n(k)}}p("Unable to retrieve mac address (unexpected format)")}catch(m){p(m)}})}}),define(J[66],Z([0,1,16,28,26,37,114]),function(j,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=S.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,b=0;const k=(0,D.networkInterfaces)();for(let y in k){const d=k[y];if(d)for(const{mac:w,internal:P}of d)P||(b+=1,this._isVirtualMachineMacAdress(w.toUpperCase())&&(i+=1))}this._value=b>0?i/b:0}return this._value}};let n;async function p(){return n||(n=(async()=>await m()||M.generateUuid())()),n}e.getMachineId=p;async function m(){try{const i=await new Promise((k,y)=>{j(["crypto"],k,y)}),b=await(0,E.getMac)();return i.createHash("sha256").update(b,"utf8").digest("hex")}catch(i){g.onUnexpectedError(i);return}}}),define(J[18],Z([0,1,29,26,115,8,9,3,30,28,65,15,7]),function(j,e,g,M,D,S,E,n,p,m,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function d(U,N=y.UNLINK){if((0,p.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return N===y.UNLINK?P(U):w(U)}async function w(U){try{const N=(0,S.join)((0,M.tmpdir)(),(0,m.generateUuid)());try{await e.Promises.rename(U,N)}catch(F){return P(U)}P(N).catch(F=>{})}catch(N){if(N.code!=="ENOENT")throw N}}async function P(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function I(U){if((0,p.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(U,{recursive:!0})}e.rimrafSync=I;async function l(U,N){return u(await(N?h(U):(0,D.promisify)(g.readdir)(U)))}async function h(U){try{return await(0,D.promisify)(g.readdir)(U,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const N=[],F=await l(U);for(const $ of F){let W=!1,R=!1,C=!1;try{const _=await e.Promises.lstat((0,S.join)(U,$));W=_.isFile(),R=_.isDirectory(),C=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}N.push({name:$,isFile:()=>W,isDirectory:()=>R,isSymbolicLink:()=>C})}return N}function o(U){return u(g.readdirSync(U))}e.readdirSync=o;function u(U){return U.map(N=>typeof N=="string"?n.isMacintosh?(0,i.normalizeNFC)(N):N:(N.name=n.isMacintosh?(0,i.normalizeNFC)(N.name):N.name,N))}async function t(U){const N=await l(U),F=[];for(const $ of N)await r.existsDirectory((0,S.join)(U,$))&&F.push($);return F}function s(U,N=1e3){return new Promise(F=>{let $=!1;const W=setInterval(()=>{$||($=!0,g.access(U,R=>{$=!1,R&&(clearInterval(W),F(void 0))}))},N)})}e.whenDeleted=s;var r;(function(U){async function N(W){let R;try{if(R=await e.Promises.lstat(W),!R.isSymbolicLink())return{stat:R}}catch(C){}try{return{stat:await e.Promises.stat(W),symbolicLink:R?.isSymbolicLink()?{dangling:!1}:void 0}}catch(C){if(C.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};if(n.isWindows&&C.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};throw _}throw C}}U.stat=N;async function F(W){try{const{stat:R,symbolicLink:C}=await U.stat(W);return R.isFile()&&C?.dangling!==!0}catch(R){}return!1}U.existsFile=F;async function $(W){try{const{stat:R,symbolicLink:C}=await U.stat(W);return R.isDirectory()&&C?.dangling!==!0}catch(R){}return!1}U.existsDirectory=$})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new E.ResourceQueue;function c(U,N,F){return a.queueFor(k.URI.file(U),b.extUriBiasedIgnorePathCase).queue(()=>{const $=T(F);return new Promise((W,R)=>f(U,N,$,C=>C?R(C):W()))})}let v=!0;function f(U,N,F,$){if(!v)return g.writeFile(U,N,{mode:F.mode,flag:F.flag},$);g.open(U,F.flag,F.mode,(W,R)=>{if(W)return $(W);g.writeFile(R,N,C=>{if(C)return g.close(R,()=>$(C));g.fdatasync(R,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),v=!1),g.close(R,A=>$(A))))})})}function L(U,N,F){const $=T(F);if(!v)return g.writeFileSync(U,N,{mode:$.mode,flag:$.flag});const W=g.openSync(U,$.flag,$.mode);try{g.writeFileSync(W,N);try{g.fdatasyncSync(W)}catch(R){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",R),v=!1}}finally{g.closeSync(W)}}e.writeFileSync=L;function T(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function O(U,N){if(U===N)return;async function F($){try{const W=await e.Promises.lstat($);if(W.isDirectory()||W.isSymbolicLink())return;await e.Promises.utimes($,W.atime,new Date)}catch(W){}}try{await e.Promises.rename(U,N),await F(N)}catch($){if(U.toLowerCase()!==N.toLowerCase()&&$.code==="EXDEV"||U.endsWith("."))await B(U,N,{preserveSymlinks:!1}),await d(U,y.MOVE),await F(N);else throw $}}async function B(U,N,F){return x(U,N,{root:{source:U,target:N},options:F,handledSourcePaths:new Set})}const q=511;async function x(U,N,F){if(F.handledSourcePaths.has(U))return;F.handledSourcePaths.add(U);const{stat:$,symbolicLink:W}=await r.stat(U);if(W){if(F.options.preserveSymlinks)try{return await Y(U,N,F)}catch(R){console.warn("[node.js fs] copy of symlink failed: ",R)}if(W.dangling)return}return $.isDirectory()?ie(U,N,$.mode&q,F):V(U,N,$.mode&q)}async function ie(U,N,F,$){await e.Promises.mkdir(N,{recursive:!0,mode:F});const W=await l(U);for(const R of W)await x((0,S.join)(U,R),(0,S.join)(N,R),$)}async function V(U,N,F){await e.Promises.copyFile(U,N),await e.Promises.chmod(N,F)}async function Y(U,N,F){let $=await e.Promises.readlink(U);(0,p.isEqualOrParent)($,F.root.source,!n.isLinux)&&($=(0,S.join)(F.root.target,$.substr(F.root.source.length+1))),await e.Promises.symlink($,N)}e.Promises=new class{get access(){return(0,D.promisify)(g.access)}get stat(){return(0,D.promisify)(g.stat)}get lstat(){return(0,D.promisify)(g.lstat)}get utimes(){return(0,D.promisify)(g.utimes)}get read(){return(0,D.promisify)(g.read)}get readFile(){return(0,D.promisify)(g.readFile)}get write(){return(0,D.promisify)(g.write)}get appendFile(){return(0,D.promisify)(g.appendFile)}get fdatasync(){return(0,D.promisify)(g.fdatasync)}get truncate(){return(0,D.promisify)(g.truncate)}get rename(){return(0,D.promisify)(g.rename)}get copyFile(){return(0,D.promisify)(g.copyFile)}get open(){return(0,D.promisify)(g.open)}get close(){return(0,D.promisify)(g.close)}get symlink(){return(0,D.promisify)(g.symlink)}get readlink(){return(0,D.promisify)(g.readlink)}get chmod(){return(0,D.promisify)(g.chmod)}get mkdir(){return(0,D.promisify)(g.mkdir)}get unlink(){return(0,D.promisify)(g.unlink)}get rmdir(){return(0,D.promisify)(g.rmdir)}get realpath(){return(0,D.promisify)(g.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return t}get writeFile(){return c}get rm(){return d}get move(){return O}get copy(){return B}}}),define(J[82],Z([0,1,29,23,8,18]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function E(i){const b=(0,D.dirname)(i);if(i===b)return i;const k=((0,D.basename)(i)||i).toLowerCase();try{const d=(0,S.readdirSync)(b).filter(w=>w.toLowerCase()===k);if(d.length===1){const w=E(b);if(w)return(0,D.join)(w,d[0])}else if(d.length>1){const w=d.indexOf(k);if(w>=0){const P=E(b);if(P)return(0,D.join)(P,d[w])}}}catch(y){}return null}e.realcaseSync=E;async function n(i){try{return await S.Promises.realpath(i)}catch(b){const k=m(i);return await S.Promises.access(k,g.constants.R_OK),k}}e.realpath=n;function p(i){try{return g.realpathSync(i)}catch(b){const k=m(i);return g.accessSync(k,g.constants.R_OK),k}}e.realpathSync=p;function m(i){return(0,M.rtrim)((0,D.normalize)(i),D.sep)}}),define(J[116],Z([0,1,59]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function M(n,p,m){let i=!1;return new Promise(b=>{const k=setTimeout(()=>{if(!i)return i=!0,b(0)},m);D(n,p,y=>{if(!i)return i=!0,clearTimeout(k),b(y)})})}e.findFreePort=M;function D(n,p,m){if(p===0)return m(0);const i=new g.Socket;i.once("connect",()=>(E(i),D(n+1,p-1,m))),i.once("data",()=>{}),i.once("error",b=>(E(i),b.code!=="ECONNREFUSED"?D(n+1,p-1,m):m(n))),i.connect(n,"127.0.0.1")}function S(n,p,m){let i=!1,b,k=1;const y=g.createServer({pauseOnConnect:!0});function d(w,P){i||(i=!0,y.removeAllListeners(),y.close(),b&&clearTimeout(b),P(w))}return new Promise(w=>{b=setTimeout(()=>{d(0,w)},m),y.on("listening",()=>{d(n,w)}),y.on("error",P=>{P&&(P.code==="EADDRINUSE"||P.code==="EACCES")&&k<p?(n++,k++,y.listen(n,"127.0.0.1")):d(0,w)}),y.on("close",()=>{d(0,w)}),y.listen(n,"127.0.0.1")})}e.findFreePortFaster=S;function E(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(p){console.error(p)}}}),define(J[117],Z([0,1,18,26,8]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,E=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var p;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(p||(p={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class b{constructor(u,t,s){this.exePath=u,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await g.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function k({useAlternateBitness:o=!1}={}){return o?m===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:o=!1,findPreview:u=!1}={}){const t=k({useAlternateBitness:o});if(!t)return null;const s=D.join(t,"PowerShell");if(!await g.SymlinkSupport.existsDirectory(s))return null;let r=-1,a=null;for(const f of await g.Promises.readdir(s)){let L=-1;if(u){const O=f.indexOf("-");if(O<0)continue;const B=f.substring(0,O);if(!S.test(B)||f.substring(O+1)!=="preview")continue;L=parseInt(B,10)}else{if(!S.test(f))continue;L=parseInt(f,10)}if(L<=r)continue;const T=D.join(s,f,"pwsh.exe");!await g.SymlinkSupport.existsFile(T)||(a=T,r=L)}if(!a)return null;const c=t.includes("x86")?" (x86)":"",v=u?" Preview":"";return new b(a,`PowerShell${v}${c}`,!0)}async function d({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const u=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await g.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=o?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:E,pwshMsixName:"PowerShell (Store)"};for(const r of await g.Promises.readdir(u))if(t.test(r)){const a=D.join(u,r,"pwsh.exe");return new b(a,s)}return null}function w(){const o=D.join(M.homedir(),".dotnet","tools","pwsh.exe");return new b(o,".NET Core PowerShell Global Tool")}function P(){const o=D.join(process.env.windir,m===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(o,"Windows PowerShell",!0)}async function*I(){let o=await y();o&&(yield o),o=await y({useAlternateBitness:!0}),o&&(yield o),o=await d(),o&&(yield o),o=w(),o&&(yield o),o=await y({findPreview:!0}),o&&(yield o),o=await d({findPreview:!0}),o&&(yield o),o=await y({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=P(),o&&(yield o)}async function*l(){for await(const o of I())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=l;async function h(){for await(const o of l())return o;return null}e.getFirstAvailablePowerShellInstallation=h}),define(J[83],Z([0,1,41,10]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(E){return new Promise((n,p)=>{let m;const i=new Map;function b(y,d,w,P,I){const l=i.get(d);if(y===E||l){const h={name:k(w),cmd:w,pid:y,ppid:d,load:P,mem:I};i.set(y,h),y===E&&(m=h),l&&(l.children||(l.children=[]),l.children.push(h),l.children.length>1&&(l.children=l.children.sort((o,u)=>o.pid-u.pid)))}}function k(y){const d=/--disable-blink-features=Auxclick/,w=/\\watcher\\win32\\CodeHelper\.exe/,P=/--crashes-directory/,I=/\\pipe\\winpty-control/,l=/conhost\.exe/,h=/--type=([a-zA-Z-]+)/;if(w.exec(y))return"watcherService ";if(P.exec(y))return"electron-crash-reporter";if(I.exec(y))return"winpty-process";if(l.exec(y))return"console-window-host (Windows internal process)";let o=h.exec(y);if(o&&o.length===2)return o[1]==="renderer"?d.exec(y)?"shared-process":"window":o[1];const u=/[a-zA-Z-]+\.js/g;let t="";do o=u.exec(y),o&&(t+=o+" ");while(o);return t&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${t}`:y}if(process.platform==="win32"){const y=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,w)=>{j(["windows-process-tree"],d,w)}).then(d=>{d.getProcessList(E,w=>{d.getProcessCpuUsage(w,P=>{const I=new Map;P.forEach(l=>{const h=y(l.commandLine||"");I.set(l.pid,{name:k(h),cmd:h,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),m=I.get(E),m?(I.forEach(l=>{const h=I.get(l.ppid);h&&(h.children||(h.children=[]),h.children.push(l))}),I.forEach(l=>{l.children&&(l.children=l.children.sort((h,o)=>h.pid-o.pid))}),n(m)):p(new Error(`Root process ${E} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let y=function(){let d=[m];const w=[];for(;d.length;){const I=d.shift();I&&(w.push(I.pid),I.children&&(d=d.concat(I.children)))}let P=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);P+=" "+w.join(" "),(0,g.exec)(P,{},(I,l,h)=>{if(I||h)p(I||new Error(h.toString()));else{const o=l.toString().split(`
`);for(let u=0;u<w.length;u++){const t=i.get(w[u]);t.load=parseFloat(o[u])}if(!m){p(new Error(`Root process ${E} not found`));return}n(m)}})};(0,g.exec)("which ps",{},(d,w,P)=>{if(d||P)if(process.platform!=="linux")p(d||new Error(P.toString()));else{const I=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,g.exec)(I,{},(l,h,o)=>{l||o?p(l||new Error(o.toString())):(S(h,b),y())})}else{const I=w.toString().trim(),l="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,g.exec)(`${I} ${l}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,o,u)=>{h||u&&!u.includes("screen size is bogus")?p(h||new Error(u.toString())):(S(o,b),process.platform==="linux"?y():m?n(m):p(new Error(`Root process ${E} not found`)))})}})}})}e.listProcesses=D;function S(E,n){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=E.toString().split(`
`);for(const i of m){const b=p.exec(i.trim());b&&b.length===6&&n(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(J[118],Z([0,1,8,29,3,65,2,18]),function(j,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function p(b,k,y){return i({path:b,isDirectory:!1},k,y)}e.watchFile=p;function m(b,k,y){return i({path:b,isDirectory:!0},k,y)}e.watchFolder=m,e.CHANGE_BUFFER_DELAY=100;function i(b,k,y){const d=(0,g.basename)(b.path),w=new Map;let P=!1,I=[(0,E.toDisposable)(()=>{w.forEach(l=>(0,E.dispose)(l)),w.clear()})];try{const l=(0,M.watch)(b.path);I.push((0,E.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const h=new Set;b.isDirectory&&n.Promises.readdir(b.path).then(o=>o.forEach(u=>h.add(u))),l.on("error",(o,u)=>{P||y(`Failed to watch ${b.path} for changes using fs.watch() (${o}, ${u})`)}),l.on("change",(o,u)=>{if(P)return;let t="";if(u&&(t=u.toString(),D.isMacintosh&&(t=(0,S.normalizeNFC)(t))),!t||o!=="change"&&o!=="rename")return;const s=b.isDirectory?(0,g.join)(b.path,t):b.path;if(b.isDirectory)if(o==="rename"){const r=w.get(s);r&&(0,E.dispose)(r);const a=setTimeout(async()=>{w.delete(s);const c=await n.Promises.exists(s);if(P)return;let v;c?h.has(t)?v="changed":(v="added",h.add(t)):(h.delete(t),v="deleted"),k(v,s)},e.CHANGE_BUFFER_DELAY);w.set(s,(0,E.toDisposable)(()=>clearTimeout(a)))}else{let r;h.has(t)?r="changed":(r="added",h.add(t)),k(r,s)}else if(o==="rename"||t!==d){const r=setTimeout(async()=>{const a=await n.Promises.exists(s);P||(a?(k("changed",s),I=[i(b,k,y)]):k("deleted",s))},e.CHANGE_BUFFER_DELAY);(0,E.dispose)(I),I=[(0,E.toDisposable)(()=>clearTimeout(r))]}else k("changed",s)})}catch(l){n.Promises.exists(b.path).then(h=>{h&&!P&&y(`Failed to watch ${b.path} for changes using fs.watch() (${l.toString()})`)})}return(0,E.toDisposable)(()=>{P=!0,I=(0,E.dispose)(I)})}}),define(J[119],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[120],Z([0,1,14,119,13]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function S(){g.ipcMain.on(M.CONTEXT_MENU_CHANNEL,(n,p,m,i,b)=>{const k=E(n,i,m);k.popup({window:(0,D.withNullAsUndefined)(g.BrowserWindow.fromWebContents(n.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{k&&n.sender.send(M.CONTEXT_MENU_CLOSE_CHANNEL,p)}})})}e.registerContextMenuListener=S;function E(n,p,m){const i=new g.Menu;return m.forEach(b=>{let k;b.type==="separator"?k=new g.MenuItem({type:b.type}):Array.isArray(b.submenu)?k=new g.MenuItem({submenu:E(n,p,b.submenu),label:b.label}):k=new g.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(y,d,w)=>n.sender.send(p,b.id,w)}),i.append(k)}),i}});var ce=this&&this.__decorate||function(j,e,g,M){var D=arguments.length,S=D<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,g):M,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(j,e,g,M);else for(var n=j.length-1;n>=0;n--)(E=j[n])&&(S=(D<3?E(S):D>3?E(e,g,S):E(e,g))||S);return D>3&&S&&Object.defineProperty(e,g,S),S};define(J[34],Z([0,1,5,2,9,25,16,17,36,13,111,23,47]),function(j,e,g,M,D,S,E,n,p,m,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function d(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function P(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var I;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(I||(I={}));class l{constructor(R){this.buffer=R,this.pos=0}read(R){const C=this.buffer.slice(this.pos,this.pos+R);return this.pos+=C.byteLength,C}}class h{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(R){this.buffers.push(R)}}var o;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(o||(o={}));function u(W){const R=n.VSBuffer.alloc(4);return R.writeUInt32BE(W,0),R}function t(W){return W.read(4).readUInt32BE(0)}function s(W){const R=n.VSBuffer.alloc(1);return R.writeUInt8(W,0),R}const r={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object)},a=typeof Buffer!="undefined";function c(W,R){if(typeof R=="undefined")W.write(r.Undefined);else if(typeof R=="string"){const C=n.VSBuffer.fromString(R);W.write(r.String),W.write(u(C.byteLength)),W.write(C)}else if(a&&Buffer.isBuffer(R)){const C=n.VSBuffer.wrap(R);W.write(r.Buffer),W.write(u(C.byteLength)),W.write(C)}else if(R instanceof n.VSBuffer)W.write(r.VSBuffer),W.write(u(R.byteLength)),W.write(R);else if(Array.isArray(R)){W.write(r.Array),W.write(u(R.length));for(const C of R)c(W,C)}else{const C=n.VSBuffer.fromString(JSON.stringify(R));W.write(r.Object),W.write(u(C.byteLength)),W.write(C)}}function v(W){switch(W.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return W.read(t(W)).toString();case o.Buffer:return W.read(t(W)).buffer;case o.VSBuffer:return W.read(t(W));case o.Array:{const C=t(W),_=[];for(let A=0;A<C;A++)_.push(v(W));return _}case o.Object:return JSON.parse(W.read(t(W)).toString())}}class f{constructor(R,C,_=null,A=1e3){this.protocol=R,this.ctx=C,this.logger=_,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(z=>this.onRawMessage(z)),this.sendResponse({type:200})}registerChannel(R,C){this.channels.set(R,C),setTimeout(()=>this.flushPendingRequests(R),0)}sendResponse(R){switch(R.type){case 200:{const C=this.send([R.type]);this.logger&&this.logger.logOutgoing(C,0,1,P(R.type));return}case 201:case 202:case 204:case 203:{const C=this.send([R.type,R.id],R.data);this.logger&&this.logger.logOutgoing(C,R.id,1,P(R.type),R.data);return}}}send(R,C=void 0){const _=new h;return c(_,R),c(_,C),this.sendBuffer(_.buffer)}sendBuffer(R){try{return this.protocol.send(R),R.byteLength}catch(C){return 0}}onRawMessage(R){const C=new l(R),_=v(C),A=v(C),z=_[0];switch(z){case 100:return this.logger&&this.logger.logIncoming(R.byteLength,_[1],1,`${d(z)}: ${_[2]}.${_[3]}`,A),this.onPromise({type:z,id:_[1],channelName:_[2],name:_[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(R.byteLength,_[1],1,`${d(z)}: ${_[2]}.${_[3]}`,A),this.onEventListen({type:z,id:_[1],channelName:_[2],name:_[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(R.byteLength,_[1],1,`${d(z)}`),this.disposeActiveRequest({type:z,id:_[1]});case 103:return this.logger&&this.logger.logIncoming(R.byteLength,_[1],1,`${d(z)}`),this.disposeActiveRequest({type:z,id:_[1]})}}onPromise(R){const C=this.channels.get(R.channelName);if(!C){this.collectPendingRequest(R);return}const _=new S.CancellationTokenSource;let A;try{A=C.call(this.ctx,R.name,R.arg,_.token)}catch(X){A=Promise.reject(X)}const z=R.id;A.then(X=>{this.sendResponse({id:z,data:X,type:201}),this.activeRequests.delete(R.id)},X=>{X instanceof Error?this.sendResponse({id:z,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.sendResponse({id:z,data:X,type:203}),this.activeRequests.delete(R.id)});const K=(0,M.toDisposable)(()=>_.cancel());this.activeRequests.set(R.id,K)}onEventListen(R){const C=this.channels.get(R.channelName);if(!C){this.collectPendingRequest(R);return}const _=R.id,z=C.listen(this.ctx,R.name,R.arg)(K=>this.sendResponse({id:_,data:K,type:204}));this.activeRequests.set(R.id,z)}disposeActiveRequest(R){const C=this.activeRequests.get(R.id);C&&(C.dispose(),this.activeRequests.delete(R.id))}collectPendingRequest(R){let C=this.pendingRequests.get(R.channelName);C||(C=[],this.pendingRequests.set(R.channelName,C));const _=setTimeout(()=>{console.error(`Unknown channel: ${R.channelName}`),R.type===100&&this.sendResponse({id:R.id,data:{name:"Unknown channel",message:`Channel name '${R.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);C.push({request:R,timeoutTimer:_})}flushPendingRequests(R){const C=this.pendingRequests.get(R);if(C){for(const _ of C)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.onPromise(_.request);break;case 102:this.onEventListen(_.request);break}this.pendingRequests.delete(R)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(R=>R.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var L;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(L=e.RequestInitiator||(e.RequestInitiator={}));class T{constructor(R,C=null){this.protocol=R,this.isDisposed=!1,this.state=I.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(_=>this.onBuffer(_)),this.logger=C}getChannel(R){const C=this;return{call(_,A,z){return C.isDisposed?Promise.reject(E.canceled()):C.requestPromise(R,_,A,z)},listen(_,A){return C.isDisposed?Promise.reject(E.canceled()):C.requestEvent(R,_,A)}}}requestPromise(R,C,_,A=S.CancellationToken.None){const z=this.lastRequestId++,X={id:z,type:100,channelName:R,name:C,arg:_};if(A.isCancellationRequested)return Promise.reject(E.canceled());let G;return new Promise((ne,se)=>{if(A.isCancellationRequested)return se(E.canceled());const ue=()=>{const fe=me=>{switch(me.type){case 201:this.handlers.delete(z),ne(me.data);break;case 202:this.handlers.delete(z);const Ie=new Error(me.data.message);Ie.stack=me.data.stack,Ie.name=me.data.name,se(Ie);break;case 203:this.handlers.delete(z),se(me.data);break}};this.handlers.set(z,fe),this.sendRequest(X)};let he=null;this.state===I.Idle?ue():(he=(0,D.createCancelablePromise)(fe=>this.whenInitialized()),he.then(()=>{he=null,ue()}));const ve=()=>{he?(he.cancel(),he=null):this.sendRequest({id:z,type:101}),se(E.canceled())},oe=A.onCancellationRequested(ve);G=(0,M.combinedDisposable)((0,M.toDisposable)(ve),oe),this.activeRequests.add(G)}).finally(()=>{this.activeRequests.delete(G)})}requestEvent(R,C,_){const A=this.lastRequestId++,K={id:A,type:102,channelName:R,name:C,arg:_};let X=null;const G=new g.Emitter({onFirstListenerAdd:()=>{X=(0,D.createCancelablePromise)(ne=>this.whenInitialized()),X.then(()=>{X=null,this.activeRequests.add(G),this.sendRequest(K)})},onLastListenerRemove:()=>{X?(X.cancel(),X=null):(this.activeRequests.delete(G),this.sendRequest({id:A,type:103}))}}),Q=ne=>G.fire(ne.data);return this.handlers.set(A,Q),G.event}sendRequest(R){switch(R.type){case 100:case 102:{const C=this.send([R.type,R.id,R.channelName,R.name],R.arg);this.logger&&this.logger.logOutgoing(C,R.id,0,`${d(R.type)}: ${R.channelName}.${R.name}`,R.arg);return}case 101:case 103:{const C=this.send([R.type,R.id]);this.logger&&this.logger.logOutgoing(C,R.id,0,d(R.type));return}}}send(R,C=void 0){const _=new h;return c(_,R),c(_,C),this.sendBuffer(_.buffer)}sendBuffer(R){try{return this.protocol.send(R),R.byteLength}catch(C){return 0}}onBuffer(R){const C=new l(R),_=v(C),A=v(C),z=_[0];switch(z){case 200:return this.logger&&this.logger.logIncoming(R.byteLength,0,0,P(z)),this.onResponse({type:_[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(R.byteLength,_[1],0,P(z),A),this.onResponse({type:_[0],id:_[1],data:A})}}onResponse(R){if(R.type===200){this.state=I.Idle,this._onDidInitialize.fire();return}const C=this.handlers.get(R.id);C&&C(R)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===I.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(R=>R.dispose()),this.activeRequests.clear()}}ce([k.memoize],T.prototype,"onDidInitializePromise",null),e.ChannelClient=T;class O{constructor(R){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,R(({protocol:C,onDidClientDisconnect:_})=>{g.Event.once(C.onMessage)(z=>{const K=new l(z),X=v(K),G=new f(C,X),Q=new T(C);this.channels.forEach((se,ue)=>G.registerChannel(ue,se));const ne={channelServer:G,channelClient:Q,ctx:X};this._connections.add(ne),this._onDidAddConnection.fire(ne),_(()=>{G.dispose(),Q.dispose(),this._connections.delete(ne),this._onDidRemoveConnection.fire(ne)})})})}get connections(){const R=[];return this._connections.forEach(C=>R.push(C)),R}getChannel(R,C){const _=this;return{call(A,z,K){let X;if((0,m.isFunction)(C)){let Q=(0,p.getRandomElement)(_.connections.filter(C));X=Q?Promise.resolve(Q):g.Event.toPromise(g.Event.filter(_.onDidAddConnection,C))}else X=C.routeCall(_,A,z);const G=X.then(Q=>Q.channelClient.getChannel(R));return q(G).call(A,z,K)},listen(A,z){if((0,m.isFunction)(C))return _.getMulticastEvent(R,C,A,z);const K=C.routeEvent(_,A,z).then(X=>X.channelClient.getChannel(R));return q(K).listen(A,z)}}}getMulticastEvent(R,C,_,A){const z=this;let K=new M.DisposableStore;const X=new g.Emitter({onFirstListenerAdd:()=>{K=new M.DisposableStore;const G=new g.EventMultiplexer,Q=new Map,ne=ue=>{const ve=ue.channelClient.getChannel(R).listen(_,A),oe=G.add(ve);Q.set(ue,oe)},se=ue=>{const he=Q.get(ue);!he||(he.dispose(),Q.delete(ue))};z.connections.filter(C).forEach(ne),g.Event.filter(z.onDidAddConnection,C)(ne,void 0,K),z.onDidRemoveConnection(se,void 0,K),G.event(X.fire,X,K),K.add(G)},onLastListenerRemove:()=>{K.dispose()}});return X.event}registerChannel(R,C){this.channels.set(R,C),this._connections.forEach(_=>{_.channelServer.registerChannel(R,C)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=O;class B{constructor(R,C,_=null){const A=new h;c(A,C),R.send(A.buffer),this.channelClient=new T(R,_),this.channelServer=new f(R,C,_)}getChannel(R){return this.channelClient.getChannel(R)}registerChannel(R,C){this.channelServer.registerChannel(R,C)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=B;function q(W){return{call(R,C,_){return W.then(A=>A.call(R,C,_))},listen(R,C){const _=new g.Relay;return W.then(A=>_.input=A.listen(R,C)),_.event}}}e.getDelayedChannel=q;function x(W){let R=!1;return{call(C,_,A){return R?W.call(C,_,A):(0,D.timeout)(0).then(()=>R=!0).then(()=>W.call(C,_,A))},listen(C,_){if(R)return W.listen(C,_);const A=new g.Relay;return(0,D.timeout)(0).then(()=>R=!0).then(()=>A.input=W.listen(C,_)),A.event}}}e.getNextTickChannel=x;class ie{constructor(R){this.fn=R}routeCall(R){return this.route(R)}routeEvent(R){return this.route(R)}async route(R){for(const C of R.connections)if(await Promise.resolve(this.fn(C.ctx)))return Promise.resolve(C);return await g.Event.toPromise(R.onDidAddConnection),await this.route(R)}}e.StaticRouter=ie;var V;(function(W){function R(A,z){const K=A,X=z&&z.disableMarshalling,G=new Map;for(const Q in K)_(Q)&&G.set(Q,g.Event.buffer(K[Q],!0));return new class{listen(Q,ne){const se=G.get(ne);if(se)return se;throw new Error(`Event not found: ${ne}`)}call(Q,ne,se){const ue=K[ne];if(typeof ue=="function"){if(!X&&Array.isArray(se))for(let he=0;he<se.length;he++)se[he]=(0,i.revive)(se[he]);return ue.apply(K,se)}throw new Error(`Method not found: ${ne}`)}}}W.fromService=R;function C(A,z){const K=z&&z.disableMarshalling;return new Proxy({},{get(X,G){if(typeof G=="string")return z?.properties?.has(G)?z.properties.get(G):_(G)?A.listen(G):async function(...Q){let ne;z&&!(0,m.isUndefinedOrNull)(z.context)?ne=[z.context,...Q]:ne=Q;const se=await A.call(G,ne);return K?se:(0,i.revive)(se)};throw new Error(`Property not found: ${String(G)}`)}})}W.toService=C;function _(A){return A[0]==="o"&&A[1]==="n"&&b.isUpperAsciiLetter(A.charCodeAt(2))}})(V=e.ProxyChannel||(e.ProxyChannel={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){let R=W.toString();if(R!=="[object Object]")return R}return W}function N(W){return Array.isArray(W)?W.map(U):U(W)}function F(W,R,C,_,A,z,K){K=N(K);const X=Y[A],G=X[_%X.length];let Q=[`%c[${W}]%c[${String(R).padStart(7," ")}]%c[len: ${String(C).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${z}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(z)?(Q=Q.concat(K),Q.push(")")):Q.push(K),console.log.apply(console,Q)}e.logWithColors=F;class ${constructor(R,C){this._outgoingPrefix=R,this._incomingPrefix=C,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(R,C,_,A,z){this._totalOutgoing+=R,F(this._outgoingPrefix,this._totalOutgoing,R,C,_,A,z)}logIncoming(R,C,_,A,z){this._totalIncoming+=R,F(this._incomingPrefix,this._totalIncoming,R,C,_,A,z)}}e.IPCLogger=$}),define(J[121],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class g{constructor(D,S){this.sender=D,this.onMessage=S}send(D){try{this.sender.send("vscode:message",D.buffer)}catch(S){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=g}),define(J[122],Z([0,1,5,34,17]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class S{constructor(p){this.port=p,this.onMessage=g.Event.fromDOMEventEmitter(this.port,"message",m=>D.VSBuffer.wrap(m.data)),p.start()}send(p){this.port.postMessage(p.buffer)}disconnect(){this.port.close()}}e.Protocol=S;class E extends M.IPCClient{constructor(p,m){const i=new S(p);super(i,m);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=E}),define(J[84],Z([0,1,5,34,2,17,3,33]),function(j,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var p;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function i(){return m||(m=S.VSBuffer.alloc(0)),m}class b{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(a){this._chunks.push(a),this._totalLength+=a.byteLength}read(a){return this._read(a,!0)}peek(a){return this._read(a,!1)}_read(a,c){if(a===0)return i();if(a>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===a){const T=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=a),T}if(this._chunks[0].byteLength>a){const T=this._chunks[0].slice(0,a);return c&&(this._chunks[0]=this._chunks[0].slice(a),this._totalLength-=a),T}let v=S.VSBuffer.alloc(a),f=0,L=0;for(;a>0;){const T=this._chunks[L];if(T.byteLength>a){const O=T.slice(0,a);v.set(O,f),f+=a,c&&(this._chunks[L]=T.slice(a),this._totalLength-=a),a-=a}else v.set(T,f),f+=T.byteLength,c?(this._chunks.shift(),this._totalLength-=T.byteLength):L++,a-=T.byteLength}return v}}e.ChunkStream=b;var k;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(k||(k={}));var y;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(y=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(a,c,v,f){this.type=a,this.id=c,this.ack=v,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends D.Disposable{constructor(a){super();this._onMessage=this._register(new g.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=a,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5);else{const v=this._state.messageType,f=this._state.id,L=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(v,f,L,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class P{constructor(a){this._isDisposed=!1,this._socket=a,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(a){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(a){if(this._isDisposed)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=S.VSBuffer.alloc(13);c.writeUInt8(a.type,0),c.writeUInt32BE(a.id,1),c.writeUInt32BE(a.ack,5),c.writeUInt32BE(a.data.byteLength,9),this._writeSoon(c,a.data)}_bufferAdd(a,c){const v=this._totalLength===0;return this._data.push(a,c),this._totalLength+=a.byteLength+c.byteLength,v}_bufferTake(){const a=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,a}_writeSoon(a,c){this._bufferAdd(a,c)&&E.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class I extends D.Disposable{constructor(a){super();this._onMessage=new g.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new g.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=a,this._socketWriter=this._register(new P(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(a){this._socketWriter.write(new d(1,0,0,a))}}e.Protocol=I;class l extends M.IPCClient{constructor(a,c,v=null){super(a,c,v);this.protocol=a}static fromSocket(a,c){return new l(new I(a),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const a=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),a.end()}}e.Client=l;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new g.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(a){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(a):this._emitter.fire(a):this._bufferedMessages.push(a)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class o{constructor(a){this.data=a,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let a=[],c=0,v=this._first;for(;v;)a[c++]=v.data,v=v.next;return a}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(a){const c=new o(a);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class t{constructor(){this.lastRuns=[];const a=Date.now();for(let c=0;c<t._HISTORY_LENGTH;c++)this.lastRuns[c]=a-1e3*c;setInterval(()=>{for(let c=t._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const a=Date.now(),c=(1+t._HISTORY_LENGTH)*1e3;let v=0;for(let f=0;f<t._HISTORY_LENGTH;f++)a-this.lastRuns[f]<=c&&v++;return 1-v/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(a,c=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=a,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),c&&this._socketReader.acceptChunk(c),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const a=new d(5,0,0,i());this._socketWriter.write(a),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const a=Date.now()-this._socketWriter.lastWriteTime;if(a>=5e3){const c=new d(4,0,0,i());this._socketWriter.write(c),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-a+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const a=Date.now()-this._socketReader.lastReadTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-a,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(a,c){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=a,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1;const a=this._outgoingUnackMsg.toArray();for(let c=0,v=a.length;c<v;c++)this._socketWriter.write(a[c]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(a){if(a.ack>this._outgoingAckId){this._outgoingAckId=a.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=a.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(a.type===1){if(a.id>this._incomingMsgId)if(a.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new d(6,0,0,i())))}else this._incomingMsgId=a.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(a.data)}else if(a.type===2)this._onControlMessage.fire(a.data);else if(a.type===5)this._onDidDispose.fire();else if(a.type===6){const c=this._outgoingUnackMsg.toArray();for(let v=0,f=c.length;v<f;v++)this._socketWriter.write(c[v]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(a){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const v=new d(1,c,this._incomingAckId,a);this._outgoingUnackMsg.push(v),this._isReconnecting||(this._socketWriter.write(v),this._recvAckCheck())}sendControl(a){const c=new d(2,0,0,a);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const a=Date.now()-this._incomingMsgLastTime;if(a>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-a+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const a=this._outgoingUnackMsg.peek(),c=Date.now()-a.writtenTime;if(c>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-c,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const a=new d(3,0,this._incomingAckId,i());this._socketWriter.write(a)}}e.PersistentProtocol=s}),define(J[123],Z([0,1,14,5,34,121,2,17]),function(j,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function p(i,b){const k=M.Event.fromNodeEventEmitter(g.ipcMain,b,(d,w)=>({event:d,message:w})),y=M.Event.filter(k,({event:d})=>d.sender.id===i);return M.Event.map(y,({message:d})=>d&&n.VSBuffer.wrap(d))}class m extends D.IPCServer{constructor(){super(m.getOnDidClientConnect())}static getOnDidClientConnect(){const b=M.Event.fromNodeEventEmitter(g.ipcMain,"vscode:hello",({sender:k})=>k);return M.Event.map(b,k=>{const y=k.id,d=m.Clients.get(y);d&&d.dispose();const w=new M.Emitter;m.Clients.set(y,(0,E.toDisposable)(()=>w.fire()));const P=p(y,"vscode:message"),I=M.Event.any(M.Event.signal(p(y,"vscode:disconnect")),w.event);return{protocol:new S.Protocol(k,P),onDidClientDisconnect:I}})}}e.Server=m,m.Clients=new Map}),define(J[85],Z([0,1,14,5,28,122]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class E extends S.Client{constructor(m,i){super({addEventListener:(b,k)=>m.addListener(b,k),removeEventListener:(b,k)=>m.removeListener(b,k),postMessage:b=>m.postMessage(b),start:()=>m.start(),close:()=>m.close()},i)}}e.Client=E;async function n(p){if(p.isDestroyed()||p.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,D.generateUuid)();p.webContents.send("vscode:createMessageChannel",m);const i=M.Event.fromNodeEventEmitter(g.ipcMain,"vscode:createMessageChannelResult",(k,y)=>({nonce:y,port:k.ports[0]})),{port:b}=await M.Event.toPromise(M.Event.once(M.Event.filter(i,k=>k.nonce===m)));return b}e.connect=n}),define(J[86],Z([0,1,2,5,9,13]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var E;(function(i){i[i.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(E=e.StorageHint||(e.StorageHint={}));var n;(function(i){i[i.None=0]="None",i[i.Initialized=1]="Initialized",i[i.Closed=2]="Closed"})(n||(n={}));class p extends g.Disposable{constructor(b,k=Object.create(null)){super();this.database=b,this.options=k,this._onDidChangeStorage=this._register(new M.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(p.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){b.changed?.forEach((k,y)=>this.accept(y,k)),b.deleted?.forEach(k=>this.accept(k,void 0))}accept(b,k){if(this.state===n.Closed)return;let y=!1;(0,S.isUndefinedOrNull)(k)?y=this.cache.delete(b):this.cache.get(b)!==k&&(this.cache.set(b,k),y=!0),y&&this._onDidChangeStorage.fire(b)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,k){const y=this.cache.get(b);return(0,S.isUndefinedOrNull)(y)?k:y}getBoolean(b,k){const y=this.get(b);return(0,S.isUndefinedOrNull)(y)?k:y==="true"}getNumber(b,k){const y=this.get(b);return(0,S.isUndefinedOrNull)(y)?k:parseInt(y,10)}async set(b,k){if(this.state===n.Closed)return;if((0,S.isUndefinedOrNull)(k))return this.delete(b);const y=String(k);if(this.cache.get(b)!==y)return this.cache.set(b,y),this.pendingInserts.set(b,y),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async delete(b){if(!(this.state===n.Closed||!this.cache.delete(b)))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(b){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=p,p.DEFAULT_FLUSH_DELAY=100;class m{constructor(){this.onDidChangeItemsExternal=M.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert&&b.insert.forEach((k,y)=>this.items.set(y,k)),b.delete&&b.delete.forEach(k=>this.items.delete(k))}async close(){}}e.InMemoryStorageDatabase=m}),define(J[124],Z([0,1,5,9,37,8,18]),function(j,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(i,b=Object.create(null)){this.path=i,this.options=b,this.name=(0,S.basename)(this.path),this.logger=new p(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return g.Event.None}async getItems(){const i=await this.whenConnected,b=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(y=>b.set(y.key,y.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${b.size} rows`),b}async updateItems(i){const b=await this.whenConnected;return this.doUpdateItems(b,i)}doUpdateItems(i,b){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${b.insert?(0,D.mapToString)(b.insert):"0"}), delete(${b.delete?(0,D.setToString)(b.delete):"0"})`),this.transaction(i,()=>{const k=b.insert,y=b.delete;if(k&&k.size>0){const d=[];d.push([]);let w=0;k.forEach((P,I)=>{let l=d[w];l.length>n.MAX_HOST_PARAMETERS&&(w++,l=[],d.push(l)),l.push(I,P)}),d.forEach(P=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(P.length/2).fill("(?,?)").join(",")}`,I=>I.run(P),()=>{const I=[];let l=0;return k.forEach((h,o)=>{I.push(o),l+=h.length}),`Keys: ${I.join(", ")} Length: ${l}`})})}if(y&&y.size){const d=[];d.push([]);let w=0;y.forEach(P=>{let I=d[w];I.length>n.MAX_HOST_PARAMETERS&&(w++,I=[],d.push(I)),I.push(P)}),d.forEach(P=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(P.length).fill("?").join(",")})`,I=>I.run(P),()=>{const I=[];return y.forEach(l=>{I.push(l)}),`Keys: ${I.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const b=await this.whenConnected;return this.doClose(b,i)}doClose(i,b){return new Promise((k,y)=>{i.db.close(d=>(d&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${d}`),this.path===n.IN_MEMORY_PATH?k():!i.isErroneous&&!i.isInMemory?this.backup().then(k,w=>(this.logger.error(`[storage ${this.name}] backup(): ${w}`),k())):typeof b=="function"?E.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(w=>{const P=()=>this.doClose(w,void 0);return this.doUpdateItems(w,{insert:b()}).then(()=>P(),I=>(P(),Promise.reject(I)))})).then(k,y):y(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return E.Promises.copy(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const b=await this.whenConnected,k=await this.get(b,i?"PRAGMA integrity_check":"PRAGMA quick_check"),y=i?k.integrity_check:k.quick_check;return b.isErroneous?`${y} (last error: ${b.lastError})`:b.isInMemory?`${y} (in-memory!)`:y}async connect(i,b=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${b})`);try{return await this.doConnect(i)}catch(k){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${k}`),k.code==="SQLITE_BUSY"&&b)return await(0,M.timeout)(n.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await E.Promises.unlink(i);try{await E.Promises.rename(this.toBackupPath(i),i)}catch(y){}return await this.doConnect(i)}catch(y){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${y}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(i,b){i.isErroneous=!0,i.lastError=b,this.logger.error(b)}doConnect(i){return new Promise((b,k)=>{new Promise((y,d)=>{j(["vscode-sqlite3"],y,d)}).then(y=>{const d={db:new(this.logger.isTracing?y.verbose().Database:y.Database)(i,w=>w?d.db?d.db.close(()=>k(w)):k(w):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(d),P=>d.db.close(()=>k(P)))),isInMemory:i===n.IN_MEMORY_PATH};d.db.on("error",w=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${w}`)),this.logger.isTracing&&d.db.on("trace",w=>this.logger.trace(`[storage ${this.name}] Trace (event): ${w}`))},k)})}exec(i,b){return new Promise((k,y)=>{i.db.exec(b,d=>d?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${d}`),y(d)):k())})}get(i,b){return new Promise((k,y)=>{i.db.get(b,(d,w)=>d?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${d}`),y(d)):k(w))})}all(i,b){return new Promise((k,y)=>{i.db.all(b,(d,w)=>d?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${d}`),y(d)):k(w))})}transaction(i,b){return new Promise((k,y)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),b(),i.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${d}`),y(d)):k())})})}prepare(i,b,k,y){const d=i.db.prepare(b),w=P=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${P} (${b}). Details: ${y()}`)};d.on("error",w),k(d),d.finalize(P=>{P&&w(P),d.removeListener("error",w)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class p{constructor(i){i&&typeof i.logTrace=="function"&&process.env[p.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}p.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[125],Z([12,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(J[126],Z([0,1,125]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const M=60,D=M*60,S=D*24,E=S*7,n=S*30,p=S*365;function m(b,k){typeof b!="number"&&(b=b.getTime());const y=Math.round((new Date().getTime()-b)/1e3);if(y<-30)return(0,g.localize)(0,null,m(new Date().getTime()+y*1e3,!1));if(y<30)return(0,g.localize)(1,null);let d;return y<M?(d=y,k?d===1?(0,g.localize)(2,null,d):(0,g.localize)(3,null,d):d===1?(0,g.localize)(4,null,d):(0,g.localize)(5,null,d)):y<D?(d=Math.floor(y/M),k?d===1?(0,g.localize)(6,null,d):(0,g.localize)(7,null,d):d===1?(0,g.localize)(8,null,d):(0,g.localize)(9,null,d)):y<S?(d=Math.floor(y/D),k?d===1?(0,g.localize)(10,null,d):(0,g.localize)(11,null,d):d===1?(0,g.localize)(12,null,d):(0,g.localize)(13,null,d)):y<E?(d=Math.floor(y/S),k?d===1?(0,g.localize)(14,null,d):(0,g.localize)(15,null,d):d===1?(0,g.localize)(16,null,d):(0,g.localize)(17,null,d)):y<n?(d=Math.floor(y/E),k?d===1?(0,g.localize)(18,null,d):(0,g.localize)(19,null,d):d===1?(0,g.localize)(20,null,d):(0,g.localize)(21,null,d)):y<p?(d=Math.floor(y/n),k?d===1?(0,g.localize)(22,null,d):(0,g.localize)(23,null,d):d===1?(0,g.localize)(24,null,d):(0,g.localize)(25,null,d)):(d=Math.floor(y/p),k?d===1?(0,g.localize)(26,null,d):(0,g.localize)(27,null,d):d===1?(0,g.localize)(28,null,d):(0,g.localize)(29,null,d))}e.fromNow=m;function i(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(J[127],Z([12,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(J[67],Z([0,1,127,13,36]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(m,i){return i&&(m.stack||m.stacktrace)?g.localize(0,null,n(m),E(m.stack)||E(m.stacktrace)):n(m)}function E(m){return Array.isArray(m)?m.join(`
`):m}function n(m){return typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?g.localize(1,null,m.message):m.message||g.localize(2,null)}function p(m=null,i=!1){if(!m)return g.localize(3,null);if(Array.isArray(m)){const b=D.coalesce(m),k=p(b[0],i);return b.length>1?g.localize(4,null,k,b.length):k}if(M.isString(m))return m;if(m.detail){const b=m.detail;if(b.error)return S(b.error,i);if(b.exception)return S(b.exception,i)}return m.stack?S(m,i):m.message?m.message:g.localize(5,null)}e.toErrorMessage=p}),define(J[128],Z([12,11]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(J[129],Z([0,1,128]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class M{constructor(E,n,p=n){this.modifierLabels=[null],this.modifierLabels[2]=E,this.modifierLabels[1]=n,this.modifierLabels[3]=p}toLabel(E,n,p){if(n.length===0)return null;const m=[];for(let i=0,b=n.length;i<b;i++){const k=n[i],y=p(k);if(y===null)return null;m[i]=D(k,y,this.modifierLabels[E])}return m.join(" ")}}e.ModifierLabelProvider=M,e.UILabelProvider=new M({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:g.localize(0,null),shiftKey:g.localize(1,null),altKey:g.localize(2,null),metaKey:g.localize(3,null),separator:"+"},{ctrlKey:g.localize(4,null),shiftKey:g.localize(5,null),altKey:g.localize(6,null),metaKey:g.localize(7,null),separator:"+"}),e.AriaLabelProvider=new M({ctrlKey:g.localize(8,null),shiftKey:g.localize(9,null),altKey:g.localize(10,null),metaKey:g.localize(11,null),separator:"+"},{ctrlKey:g.localize(12,null),shiftKey:g.localize(13,null),altKey:g.localize(14,null),metaKey:g.localize(15,null),separator:"+"},{ctrlKey:g.localize(16,null),shiftKey:g.localize(17,null),altKey:g.localize(18,null),metaKey:g.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new M({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new M({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(S,E,n){if(E===null)return"";const p=[];return S.ctrlKey&&p.push(n.ctrlKey),S.shiftKey&&p.push(n.shiftKey),S.altKey&&p.push(n.altKey),S.metaKey&&p.push(n.metaKey),E!==""&&p.push(E),p.join(n.separator)}}),define(J[130],Z([12,11]),function(j,e){return j.create("vs/base/node/processes",e)}),define(J[68],Z([0,1,8,18,41,130,33,13,44,30,3,81,10]),function(j,e,g,M,D,S,E,n,p,m,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function y(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(o,u){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};u&&(t.cwd=u);const s=D.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(r=>{s.once("error",a=>{r({success:!1,error:a})}),s.once("exit",(a,c)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?y(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(s=>{D.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,a,c)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function w(o=E.env){return o.comspec||"cmd.exe"}e.getWindowsShell=w;class P{constructor(u,t,s,r){if(t!==void 0&&s!==void 0&&r!==void 0)this.cmd=u,this.args=t,this.shell=s,this.options=r;else{const a=u;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(E.env).forEach(c=>{a[c]=E.env[c]}),Object.keys(this.options.env).forEach(c=>{a[c]=this.options.env[c]}),this.options.env=a}}getSanitizedCommand(){let u=this.cmd.toLowerCase();const t=u.lastIndexOf(g.sep);return t!==-1&&(u=u.substring(t+1)),P.WellKnowCommands[u]?u:"other"}start(u){return i.isWindows&&(this.options&&this.options.cwd&&m.isUNC(this.options.cwd)||!this.options&&m.isUNC(E.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(t=>{let s,r;const a=new Promise((c,v)=>{s=c,r=v});if(t){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=D.exec(c,this.options,(v,f,L)=>{this.childProcess=null;const T=v;T&&T.killed?r({killed:this.terminateRequested,stdout:f.toString(),stderr:L.toString()}):this.handleExec(s,u,v,f,L)})}else{let c=null;const v=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,s,u,r);const L={terminated:this.terminateRequested};n.isNumber(f)&&(L.cmdCode=f),s(L)};if(this.shell&&i.isWindows){const f=p.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let L=!1,T=!1;const O=[];let B=this.ensureQuotes(this.cmd);O.push(B.value),L=B.quoted,this.args&&this.args.forEach(x=>{B=this.ensureQuotes(x),O.push(B.value),T=T&&B.quoted});const q=["/s","/c"];L?T?q.push('"'+O.join(" ")+'"'):O.length>1?q.push('"'+O[0]+'" '+O.slice(1).join(" ")):q.push('"'+O[0]+'"'):q.push(O.join(" ")),c=D.spawn(w(),q,f)}else this.cmd&&(c=D.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(n.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",f=>{this.childProcess=null,r({terminated:this.terminateRequested,error:f})}),c.pid&&(this.childProcess.on("close",v),this.handleSpawn(c,s,u,r,!0)))}return a})}handleClose(u,t,s,r){}ensureQuotes(u){return P.regexp.test(u)?{value:'"'+u+'"',quoted:!0}:{value:u,quoted:u.length>0&&u[0]==='"'&&u[u.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(u=>u.pid,u=>-1):new Promise(u=>{this.pidResolve=u})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(u=>(this.terminateRequested=!0,d(u,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),u=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(u=>{if(!this.shell||!i.isWindows)return u(!1);const t=D.spawn(w(),["/s","/c"]);t.on("error",s=>u(!0)),t.on("exit",s=>u(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class I extends P{constructor(u,t,s,r){super(u,t,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(u,t,s,r,a){[r,a].forEach((c,v)=>{const f=new b.LineDecoder;f.write(c).forEach(O=>{t({line:O,source:v===0?0:1})});const T=f.end();T&&t({line:T,source:v===0?0:1})}),u({terminated:this.terminateRequested,error:s})}handleSpawn(u,t,s,r,a){const c=new b.LineDecoder,v=new b.LineDecoder;u.stdout.on("data",f=>{c.write(f).forEach(T=>s({line:T,source:0}))}),u.stderr.on("data",f=>{v.write(f).forEach(T=>s({line:T,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=v}handleClose(u,t,s,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&s({line:a,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&s({line:c,source:1})}}e.LineProcess=I;function l(o){let u=[],t=!1;const s=function(r){if(t){u.push(r);return}(!o.send(r,c=>{if(c&&console.error(c),t=!1,u.length>0){const v=u.slice(0);u=[],v.forEach(f=>s(f))}})||i.isWindows)&&(t=!0)};return{send:s}}e.createQueuedSender=l;var h;(function(o){async function u(t,s,r){if(g.isAbsolute(t))return t;if(s===void 0&&(s=E.cwd()),g.dirname(t)!=="."||(r===void 0&&n.isString(E.env.PATH)&&(r=E.env.PATH.split(g.delimiter)),r===void 0||r.length===0))return g.join(s,t);async function c(v){return await M.Promises.exists(v)?!(await M.Promises.stat(v)).isDirectory():!1}for(let v of r){let f;if(g.isAbsolute(v)?f=g.join(v,t):f=g.join(s,v,t),await c(f))return f;let L=f+".com";if(await c(L)||(L=f+".exe",await c(L)))return L}return g.join(s,t)}o.findExecutable=u})(h=e.win32||(e.win32={}))}),define(J[131],Z([0,1,26,3,117,68]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function E(y,d){return y===1?M.isWindows?b():S.getWindowsShell(d):m(y,d)}e.getSystemShell=E;function n(y,d){return y===1?M.isWindows?k(d):S.getWindowsShell(d):m(y,d)}e.getSystemShellSync=n;let p=null;function m(y,d){if(M.isLinux&&y===2||M.isMacintosh&&y===3)return"/bin/bash";if(!p){let w;if(M.isWindows)w="/bin/bash";else{if(w=d.SHELL,!w)try{w=(0,g.userInfo)().shell}catch(P){}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}p=w}return p}let i=null;async function b(){return i||(i=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),i}function k(y){if(i)return i;const d=M.isWindows&&parseFloat((0,g.release)())>=10,w=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),P=`${y.windir}\\${w?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?P:S.getWindowsShell(y)}}),define(J[87],Z([0,1,41,2,9,44,5,68,34,110,25,16,17,3]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends p.ChannelServer{constructor(I){super({send:l=>{try{process.send&&process.send(l.buffer.toString("base64"))}catch(h){}},onMessage:E.Event.fromNodeEventEmitter(process,"message",l=>k.VSBuffer.wrap(Buffer.from(l,"base64")))},I);process.once("disconnect",()=>this.dispose())}}e.Server=d;class w{constructor(I,l){this.modulePath=I,this.options=l,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=l&&l.timeout?l.timeout:6e4;this.disposeDelayer=new D.Delayer(h),this.child=null,this._client=null}getChannel(I){const l=this;return{call(h,o,u){return l.requestPromise(I,h,o,u)},listen(h,o){return l.requestEvent(I,h,o)}}}requestPromise(I,l,h,o=i.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(I),t=(0,D.createCancelablePromise)(a=>u.call(l,h,a)),s=o.onCancellationRequested(()=>t.cancel()),r=(0,M.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{s.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(I,l,h){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let o;const u=new E.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(I).listen(l,h)(u.fire,u),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const I=this.options&&this.options.args?this.options.args:[],l=Object.create(null);l.env={...(0,S.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(l.env={...l.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(l.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),y.isMacintosh&&l.env&&delete l.env.DYLD_LIBRARY_PATH,this.child=(0,g.fork)(this.modulePath,I,l);const h=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,m.isRemoteConsoleLog)(c)){(0,m.log)(c,`IPC Library: ${this.options.serverName}`);return}h.fire(k.VSBuffer.wrap(Buffer.from(c,"base64")))});const u=this.options.useQueue?(0,n.createQueuedSender)(this.child):this.child,t=c=>this.child&&this.child.connected&&u.send(c.buffer.toString("base64")),s=h.event,r={send:t,onMessage:s};this._client=new p.ChannelClient(r);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,v)=>{process.removeListener("exit",a),this.activeRequests.forEach(f=>(0,M.dispose)(f)),this.activeRequests.clear(),c!==0&&v!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+v),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:v})})}return this._client}getCachedChannel(I){let l=this.channels.get(I);return l||(l=this.client.getChannel(I),this.channels.set(I,l)),l}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=w}),define(J[132],Z([12,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(J[133],Z([12,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[134],Z([12,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[135],Z([12,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(J[136],Z([12,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(J[137],Z([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[138],Z([12,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[139],Z([12,11]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[140],Z([12,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(J[141],Z([12,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(J[142],Z([12,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(J[143],Z([12,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[144],Z([12,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[145],Z([12,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[146],Z([12,11]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[147],Z([12,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(J[148],Z([12,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[149],Z([12,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(J[150],Z([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(J[151],Z([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[152],Z([12,11]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(J[153],Z([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[154],Z([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[155],Z([0,1,5,2]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new g.Emitter,this._onReloadEmitter=new g.Emitter,this._onTerminateEmitter=new g.Emitter,this._onAttachEmitter=new g.Emitter}call(n,p,m){switch(p){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(n,p,m){switch(p){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class S extends M.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,p,m){this.channel.call("attach",[n,p,m])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,p){this.channel.call("terminate",[n,p])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,p,m){return this.channel.call("openExtensionDevelopmentHostWindow",[n,p||{},m])}}e.ExtensionHostDebugChannelClient=S}),define(J[156],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class g{constructor(E){this.driver=E}listen(E,n){throw new Error(`No event found: ${n}`)}call(E,n,p){switch(n){case"click":return this.driver.click(p[0],p[1],p[2]);case"doubleClick":return this.driver.doubleClick(p);case"setValue":return this.driver.setValue(p[0],p[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(p);case"getElements":return this.driver.getElements(p[0],p[1]);case"getElementXY":return this.driver.getElementXY(p[0],p[1],p[2]);case"typeInEditor":return this.driver.typeInEditor(p[0],p[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(p);case"writeInTerminal":return this.driver.writeInTerminal(p[0],p[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=g;class M{constructor(E){this.channel=E}click(E,n,p){return this.channel.call("click",[E,n,p])}doubleClick(E){return this.channel.call("doubleClick",E)}setValue(E,n){return this.channel.call("setValue",[E,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(E){return this.channel.call("isActiveElement",E)}getElements(E,n){return this.channel.call("getElements",[E,n])}getElementXY(E,n,p){return this.channel.call("getElementXY",[E,n,p])}typeInEditor(E,n){return this.channel.call("typeInEditor",[E,n])}getTerminalBuffer(E){return this.channel.call("getTerminalBuffer",E)}writeInTerminal(E,n){return this.channel.call("writeInTerminal",[E,n])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=M;class D{constructor(E){this.channel=E}registerWindowDriver(E){return this.channel.call("registerWindowDriver",E)}reloadWindowDriver(E){return this.channel.call("reloadWindowDriver",E)}}e.WindowDriverRegistryChannelClient=D}),define(J[157],Z([0,1,8,15,47,126,10,7,33]),function(j,e,g,M,D,S,E,n,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class m{constructor(d,w,P){this._args=d,this.paths=w,this.productService=P}get appRoot(){return(0,g.dirname)(E.FileAccess.asFileUri("",j).fsPath)}get userHome(){return n.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return n.URI.file((0,g.join)(this.userDataPath,"User"))}get tmpDir(){return n.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,M.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,M.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,g.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return n.URI.file((0,g.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,M.joinPath)(n.URI.file((0,g.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return n.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return n.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,M.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,M.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=p.env.VSCODE_PORTABLE;return d?n.URI.file((0,g.join)(d,"argv.json")):(0,M.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,M.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return n.URI.file((0,g.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,g.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,g.resolve)(d):(0,g.normalize)((0,g.join)(E.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,g.resolve)(d):(0,g.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,g.resolve)(d);const w=p.env.VSCODE_EXTENSIONS;if(w)return w;const P=p.env.VSCODE_PORTABLE;return P?(0,g.join)(P,"extensions"):(0,M.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(w=>/^[^:/?#]+?:\/\//.test(w)?n.URI.parse(w):n.URI.file((0,g.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?n.URI.parse(d):n.URI.file((0,g.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!p.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,M.joinPath)(n.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return n.URI.file((0,g.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ce([D.memoize],m.prototype,"appRoot",null),ce([D.memoize],m.prototype,"userHome",null),ce([D.memoize],m.prototype,"userDataPath",null),ce([D.memoize],m.prototype,"appSettingsHome",null),ce([D.memoize],m.prototype,"tmpDir",null),ce([D.memoize],m.prototype,"userRoamingDataHome",null),ce([D.memoize],m.prototype,"settingsResource",null),ce([D.memoize],m.prototype,"userDataSyncHome",null),ce([D.memoize],m.prototype,"userDataSyncLogResource",null),ce([D.memoize],m.prototype,"sync",null),ce([D.memoize],m.prototype,"machineSettingsResource",null),ce([D.memoize],m.prototype,"globalStorageHome",null),ce([D.memoize],m.prototype,"workspaceStorageHome",null),ce([D.memoize],m.prototype,"keybindingsResource",null),ce([D.memoize],m.prototype,"keyboardLayoutResource",null),ce([D.memoize],m.prototype,"argvResource",null),ce([D.memoize],m.prototype,"snippetsHome",null),ce([D.memoize],m.prototype,"isExtensionDevelopment",null),ce([D.memoize],m.prototype,"untitledWorkspacesHome",null),ce([D.memoize],m.prototype,"installSourcePath",null),ce([D.memoize],m.prototype,"builtinExtensionsPath",null),ce([D.memoize],m.prototype,"extensionsPath",null),ce([D.memoize],m.prototype,"extensionDevelopmentLocationURI",null),ce([D.memoize],m.prototype,"extensionDevelopmentKind",null),ce([D.memoize],m.prototype,"extensionTestsLocationURI",null),ce([D.memoize],m.prototype,"debugExtensionHost",null),ce([D.memoize],m.prototype,"serviceMachineIdResource",null),ce([D.memoize],m.prototype,"telemetryLogResource",null),ce([D.memoize],m.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=m;function i(y,d){return k(y["inspect-extensions"],y["inspect-brk-extensions"],5870,d,y.debugId)}e.parseExtensionHostPort=i;function b(y,d){return k(y["inspect-search"],y["inspect-brk-search"],5876,d)}e.parseSearchPort=b;function k(y,d,w,P,I){const h=Number(d||y)||(P?null:w),o=h?Boolean(!!d):!1;return{port:h,break:o,debugId:I}}}),define(J[88],Z([0,1,240,135,3]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const S={o:(0,M.localize)(0,null),e:(0,M.localize)(1,null),t:(0,M.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,M.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,M.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,M.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,M.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,M.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,M.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,M.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,M.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,M.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,M.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,M.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,M.localize)(14,null)},category:{type:"string",cat:"e",description:(0,M.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,M.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,M.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,M.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,M.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,M.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,M.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,M.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,M.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,M.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,M.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,M.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,M.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,M.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,M.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const E={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(d,w,P=E){const I={},l=[],h=[];for(let s in w){const r=w[s];r.alias&&(I[s]=r.alias),r.type==="string"||r.type==="string[]"?(l.push(s),r.deprecates&&l.push(r.deprecates)):r.type==="boolean"&&(h.push(s),r.deprecates&&h.push(r.deprecates))}const o=g(d,{string:l,boolean:h,alias:I}),u={},t=o;u._=o._.map(s=>String(s)).filter(s=>s.length>0),delete t._;for(let s in w){const r=w[s];r.alias&&delete t[r.alias];let a=t[s];r.deprecates&&t.hasOwnProperty(r.deprecates)&&(a||(a=t[r.deprecates]),delete t[r.deprecates]),typeof a!="undefined"&&(r.type==="string[]"?a&&!Array.isArray(a)&&(a=[a]):r.type==="string"&&Array.isArray(a)&&(a=a.pop(),P.onMultipleValues(s,a)),u[s]=a),delete t[s]}for(let s in t)P.onUnknownOption(s);return u}e.parseArgs=n;function p(d,w){let P="";return w.args&&(Array.isArray(w.args)?P=` <${w.args.join("> <")}>`:P=` <${w.args}>`),w.alias?`-${w.alias} --${d}${P}`:`--${d}${P}`}function m(d,w){let P=0,I=[];for(const u in d){const t=d[u],s=p(u,t);P=Math.max(P,s.length),I.push([s,t.description])}let l=P+2+1;if(w-l<25)return I.reduce((u,t)=>u.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let h=w-l-1,o=[];for(const u of I){let t=u[0],s=b(u[1],h),r=i(l-t.length-2);o.push("  "+t+r+s[0]);for(let a=1;a<s.length;a++)o.push(i(l)+s[a])}return o}e.formatOptions=m;function i(d){return" ".repeat(d)}function b(d,w){let P=[];for(;d.length;){let I=d.length<w?d.length:d.lastIndexOf(" ",w),l=d.slice(0,I).trim();d=d.slice(I),P.push(l)}return P}function k(d,w,P,I,l=!0){const h=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${d} ${P}`];o.push(""),o.push(`${(0,M.localize)(32,null)}: ${w} [${(0,M.localize)(33,null)}][${(0,M.localize)(34,null)}...]`),o.push(""),l&&(D.isWindows?o.push((0,M.localize)(35,null,w)):o.push((0,M.localize)(36,null,w)),o.push(""));const u={};for(const t in I){const s=I[t];if(s.description&&s.cat){let r=u[s.cat];r||(u[s.cat]=r={}),r[t]=s}}for(let t in u){const s=t;let r=u[s];r&&(o.push(S[s]),o.push(...m(r,h)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=k;function y(d,w){return`${d||(0,M.localize)(37,null)}
${w||(0,M.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=y}),define(J[158],Z([0,1,88,59,155]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class S extends D.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,p,m){return p==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(m[0],m[1],m[2]):super.call(n,p,m)}async openExtensionDevelopmentHostWindow(n,p,m){const i=(0,g.parseArgs)(n,g.OPTIONS);i.debugRenderer=m;const b=i.extensionDevelopmentPath;if(!b)return{success:!1};let k;const y=Object.keys(p);for(let h of y){let o=p[h];o===null||(k||(k=Object.create(null)),k[h]=o)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(b,{context:5,cli:i,userEnv:k});if(!m)return{success:!0};const w=d.win;if(!w)return{success:!0};const P=w.webContents.debugger;let I=P.isAttached()?Infinity:0;const l=(0,M.createServer)(h=>{I++==0&&P.attach();let o=!1;const u=r=>{o||h.write(JSON.stringify(r)+"\0")},t=(r,a,c,v)=>u({method:a,params:c,sessionId:v});w.on("close",()=>{P.removeListener("message",t),h.end(),o=!0}),P.addListener("message",t);let s=Buffer.alloc(0);h.on("data",r=>{s=Buffer.concat([s,r]);for(let a=s.indexOf(0);a!==-1;a=s.indexOf(0)){let c;try{const v=s.slice(0,a).toString("utf8");s=s.slice(a+1),c=JSON.parse(v)}catch(v){console.error("error reading cdp line",v)}P.sendCommand(c.method,c.params,c.sessionId).then(v=>u({id:c.id,sessionId:c.sessionId,result:v})).catch(v=>u({id:c.id,sessionId:c.sessionId,error:{code:0,message:v.message}}))}}),h.on("error",r=>{console.error("error on cdp pipe:",r)}),h.on("close",()=>{o=!0,--I==0&&P.detach()})});return await new Promise(h=>l.listen(0,h)),w.on("close",()=>l.close()),{rendererDebugPort:l.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=S}),function(){"use strict";function j(e,g,M,D){function S(n){const p=E(n),m=[p];return e.isAbsolute(p)||m.unshift(D),e.resolve(...m)}function E(n){const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");const m=n["user-data-dir"];if(m)return m;let i=process.env.VSCODE_APPDATA;if(!i)switch(process.platform){case"win32":if(i=process.env.APPDATA,!i){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");i=e.join(b,"AppData","Roaming")}break;case"darwin":i=e.join(g.homedir(),"Library","Application Support");break;case"linux":i=process.env.XDG_CONFIG_HOME||e.join(g.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(i,M)}return{getUserDataPath:S}}if(typeof define=="function")define(J[159],Z([0,160,26,10,15,33]),function(e,g,M,D,S,E){const n=S.dirname(D.FileAccess.asFileUri("",e)),p=e.__$__nodeRequire(S.joinPath(n,"package.json").fsPath);return j(g,M,p.name,E.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),g=require("path"),M=require("os");module.exports=j(g,M,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[161],Z([0,1,26,159,157]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class S extends D.AbstractNativeEnvironmentService{constructor(n,p){super(n,{homeDir:(0,g.homedir)(),tmpDir:(0,g.tmpdir)(),userDataDir:(0,M.getUserDataPath)(n)},p)}}e.NativeEnvironmentService=S}),define(J[162],Z([0,1,29,26,8]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function S(E){const n=(0,D.join)((0,M.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return g.writeFileSync(n,""),E&&console.log(`Marker file for --wait created: ${n}`),n}catch(p){E&&console.error(`Failed to create marker file for --wait: ${p}`);return}}e.createWaitMarkerFile=S}),define(J[163],Z([0,1,138]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function S(k){return k=k.trim(),k==="*"||M.test(k)}e.isValidVersionStr=S;function E(k){if(!S(k))return null;if(k=k.trim(),k==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=k.match(M);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=E;function n(k){if(!k)return null;let y=k.majorBase,d=k.majorMustEqual,w=k.minorBase,P=k.minorMustEqual,I=k.patchBase,l=k.patchMustEqual;k.hasCaret&&(y===0||(P=!1),l=!1);let h=0;if(k.preRelease){const o=D.exec(k.preRelease);if(o){const[,u,t,s]=o;h=Date.UTC(Number(u),Number(t)-1,Number(s))}}return{majorBase:y,majorMustEqual:d,minorBase:w,minorMustEqual:P,patchBase:I,patchMustEqual:l,isMinimum:k.hasGreaterEquals,notBefore:h}}e.normalizeVersion=n;function p(k,y,d){let w;typeof k=="string"?w=n(E(k)):w=k;let P;y instanceof Date?P=y.getTime():typeof y=="string"&&(P=new Date(y).getTime());let I;if(typeof d=="string"?I=n(E(d)):I=d,!w||!I)return!1;let l=w.majorBase,h=w.minorBase,o=w.patchBase,u=I.majorBase,t=I.minorBase,s=I.patchBase,r=I.notBefore,a=I.majorMustEqual,c=I.minorMustEqual,v=I.patchMustEqual;return I.isMinimum?l>u?!0:l<u?!1:h>t?!0:h<t||P&&P<r?!1:o>=s:(l===1&&u===0&&(!a||!c||!v)&&(u=1,t=0,s=0,a=!0,c=!1,v=!1),l<u?!1:l>u?!a:h<t?!1:h>t?!c:o<s?!1:o>s?!v:!(P&&P<r))}e.isValidVersion=p;function m(k,y,d,w){return d.isBuiltin||typeof d.main=="undefined"?!0:b(k,y,d.engines.vscode,w)}e.isValidExtensionVersion=m;function i(k,y,d){return k==="*"||b(y,d,k)}e.isEngineValid=i;function b(k,y,d,w=[]){let P=n(E(d));if(!P)return w.push(g.localize(0,null,d)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return w.push(g.localize(1,null,d)),!1}else if(!P.majorMustEqual)return w.push(g.localize(2,null,d)),!1;return p(k,y,P)?!0:(w.push(g.localize(3,null,k,d)),!1)}}),define(J[164],Z([0,1,34,87,2,10]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends D.Disposable{constructor(p,m,i,b){super();this.folders=p,this.onDidFilesChange=m,this.onLogMessage=i,this.verboseLogging=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new M.Client(S.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=g.ProxyChannel.toService((0,g.getNextTickChannel)(p.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(m=>!this.isDisposed&&this.onDidFilesChange(m))),this._register(this.service.onDidLogMessage(m=>this.onLogMessage(m))),this.setFolders(this.folders)}setVerboseLogging(p){this.verboseLogging=p,!this.isDisposed&&this.service&&this.service.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${p}`})}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[165],Z([0,1,34,87,2,10]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends D.Disposable{constructor(p,m,i,b,k={}){super();this.folders=p,this.onDidFilesChange=m,this.onLogMessage=i,this.verboseLogging=b,this.watcherOptions=k,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const p=this._register(new M.Client(S.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(p.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=g.ProxyChannel.toService((0,g.getNextTickChannel)(p.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(m=>!this.isDisposed&&this.onDidFilesChange(m))),this._register(this.service.onDidLogMessage(m=>this.onLogMessage(m))),this.service.setRoots(this.folders)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${p}`})}setVerboseLogging(p){this.verboseLogging=p,this.service&&this.service.setVerboseLogging(p)}setFolders(p){this.folders=p,this.service&&this.service.setRoots(p)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[166],Z([0,1,41,81,112,10]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class E{constructor(p,m,i,b,k){this.watchedFolder=p,this.eventCallback=i,this.logCallback=b,this.verboseLogging=k,this.restartCounter=0,Array.isArray(m)?this.ignored=m.map(y=>(0,D.parse)(y)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${p}, excludes: ${m.join(",")}`),this.startWatcher()}startWatcher(){const p=[this.watchedFolder];this.verboseLogging&&p.push("-verbose"),this.handle=(0,g.spawn)(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",j).fsPath,p);const m=new M.LineDecoder;this.handle.stdout.on("data",i=>{const b=[];for(const k of m.write(i)){const y=k.split("|");if(y.length===2){const d=Number(y[0]),w=y[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(P=>P(w))){this.verboseLogging&&this.log(w);continue}b.push({type:E.changeTypeMap[d],path:w})}else this.log(y[1])}}b.length>0&&this.eventCallback(b)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,b)=>this.onExit(i,b))}onError(p){this.error("process error: "+p.toString())}onExit(p,m){this.handle&&(this.error(`terminated unexpectedly (code: ${p}, signal: ${m})`),this.restartCounter<=E.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(p){this.logCallback({type:"error",message:`[File Watcher (C#)] ${p}`})}log(p){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${p}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=E,E.MAX_RESTARTS=5,E.changeTypeMap=[0,1,2]}),define(J[167],Z([0,1,166,8,23]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S{constructor(n,p,m,i){this.onDidFilesChange=p,this.onLogMessage=m,this.verboseLogging=i,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(M.posix.sep)&&(this.folder.path=(0,D.rtrim)(this.folder.path,M.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new g.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=S}),define(J[69],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(D,S=[],E=!1){this.ctor=D,this.staticArguments=S,this.supportsDelayedInstantiation=E}}e.SyncDescriptor=g}),define(J[168],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=g;class M{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let E of this._nodes.values())E.outgoing.size===0&&S.push(E);return S}insertEdge(S,E){const n=this.lookupOrInsertNode(S),p=this.lookupOrInsertNode(E);n.outgoing.set(this._hashFn(E),p),p.incoming.set(this._hashFn(S),n)}removeNode(S){const E=this._hashFn(S);this._nodes.delete(E);for(let n of this._nodes.values())n.outgoing.delete(E),n.incoming.delete(E)}lookupOrInsertNode(S){const E=this._hashFn(S);let n=this._nodes.get(E);return n||(n=new g(S),this._nodes.set(E,n)),n}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[E,n]of this._nodes)S.push(`${E}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,E]of this._nodes){const n=new Set([S]),p=this._findCycle(E,n);if(p)return p}}_findCycle(S,E){for(let[n,p]of S.outgoing){if(E.has(n))return[...E,n].join(" -> ");E.add(n);const m=this._findCycle(p,E);if(m)return m;E.delete(n)}}}e.Graph=M}),define(J[4],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function p(m){return m[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=p})(g=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function M(n,p,m,i){p[g.DI_TARGET]===p?p[g.DI_DEPENDENCIES].push({id:n,index:m,optional:i}):(p[g.DI_DEPENDENCIES]=[{id:n,index:m,optional:i}],p[g.DI_TARGET]=p)}function D(n){if(g.serviceIds.has(n))return g.serviceIds.get(n);const p=function(m,i,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(p,m,b,!1)};return p.toString=()=>n,g.serviceIds.set(n,p),p}e.createDecorator=D;function S(n){return n}e.refineServiceDecorator=S;function E(n){return function(p,m,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(n,p,i,!0)}}e.optional=E}),define(J[70],Z([0,1,4]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,g.createDecorator)(e.ID);function M(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=M}),define(J[89],Z([0,1,4]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,g.createDecorator)("encryptionMainService");class M{constructor(S){this.machineId=S}encryption(){return new Promise((S,E)=>j(["vscode-encrypt"],S,E))}async encrypt(S){try{return(await this.encryption()).encrypt(this.machineId,S)}catch(E){return S}}async decrypt(S){try{return(await this.encryption()).decrypt(this.machineId,S)}catch(E){return S}}}e.EncryptionMainService=M}),define(J[48],Z([0,1,4]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(J[169],Z([0,1,137,4,10]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function S(b){return b&&typeof b=="object"&&typeof b.id=="string"&&(!b.uuid||typeof b.uuid=="string")}e.isIExtensionIdentifier=S;var E;(function(b){b[b.NoneOrRelevance=0]="NoneOrRelevance",b[b.LastUpdatedDate=1]="LastUpdatedDate",b[b.Title=2]="Title",b[b.PublisherName=3]="PublisherName",b[b.InstallCount=4]="InstallCount",b[b.PublishedDate=5]="PublishedDate",b[b.AverageRating=6]="AverageRating",b[b.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var n;(function(b){b[b.Default=0]="Default",b[b.Ascending=1]="Ascending",b[b.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var p;(function(b){b.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var m;(function(b){b[b.None=0]="None",b[b.Install=1]="Install",b[b.Update=2]="Update"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,M.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(k,y){super(k);this.code=y,this.name=y}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,M.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,M.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,M.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,g.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,g.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,M.createDecorator)("IExtensionManagementCLIService")}),define(J[170],Z([0,1,4]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,g.createDecorator)("extensionUrlTrustService")}),define(J[171],Z([0,1,23,4]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=D;function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class n{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,k){if(typeof b=="undefined"||b===null)return typeof k=="undefined"||k===null;if(typeof k=="undefined"||k===null)return!1;if(typeof b=="string"||typeof k=="string"){let y=typeof b=="string"?b:b.value,d=typeof k=="string"?k:k.value;return g.equalsIgnoreCase(y,d)}return b._lower===k._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=n;function p(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=p;function m(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=m,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[172],Z([0,1,23,171]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(d,w){return d.uuid&&w.uuid?d.uuid===w.uuid:d.id===w.id?!0:(0,g.compareIgnoreCase)(d.id,w.id)===0}e.areSameExtensions=D;class S{constructor(w,P){this.version=P,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof S?D(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=S;function E(d,w){return`${d}.${w}`}e.getExtensionId=E;function n(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function p(d,w){return n(E(d,w))}e.getGalleryExtensionId=p;function m(d,w){const P=[],I=l=>{for(const h of P)if(h.some(o=>D(w(o),w(l))))return h;return null};for(const l of d){const h=I(l);h?h.push(l):P.push([l])}return P}e.groupByExtension=m;function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function b(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function k(d){const w=new Set;for(const P of d)P.malicious&&w.add(P.id.id);return w}e.getMaliciousExtensionsSet=k;function y(d,w){const P=[],I=w.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const l=I.shift();if(l&&P.every(h=>!D(h.identifier,{id:l}))){const h=d.filter(o=>D(o.identifier,{id:l}));h.length===1&&(P.push(h[0]),I.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return P}e.getExtensionDependencies=y}),define(J[90],Z([0,1,4]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(J[173],Z([0,1,41,8,68,139,18,3,90,10,106]),function(j,e,g,M,D,S,E,n,p,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=S.localize(0,null);class k{async getDefaultTerminalForPlatforms(){const o=await w.getDefaultTerminalLinuxReady();return{windows:y.getDefaultTerminalWindows(),linux:o,osx:"xterm"}}}class y extends k{openTerminal(o,u){return this.spawnTerminal(g,o,D.getWindowsShell(),u)}spawnTerminal(o,u,t,s){const r=u.windowsExec||y.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const a=M.basename(r).toLowerCase();if(a==="cmder"||a==="cmder.exe")return o.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return r.indexOf(" ")>=0&&c.push('""'),c.push(r),(a==="wt"||a==="wt.exe")&&c.push("-d ."),new Promise((v,f)=>{const L=P(process),T=o.spawn(t,c,{cwd:s,env:L});T.on("error",f),T.on("exit",()=>v())})}runInTerminal(o,u,t,s,r){const a="windowsExec"in r&&r.windowsExec?r.windowsExec:y.getDefaultTerminalWindows();return new Promise((c,v)=>{const f=`"${u} - ${b}"`,L=`""${t.join('" "')}" & pause"`,T=["/c","start",f,"/wait",a,"/c",L],O=Object.assign({},P(process),s);Object.keys(O).filter(x=>O[x]===null).forEach(x=>delete O[x]);const B={cwd:u,env:O,windowsVerbatimArguments:!0};g.spawn(y.CMD,T,B).on("error",x=>{v(I(x))}),c(void 0)})}static getDefaultTerminalWindows(){if(!y._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return y._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=y,y.CMD="cmd.exe";class d extends k{openTerminal(o,u){return this.spawnTerminal(g,o,u)}runInTerminal(o,u,t,s,r){const a=r.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((c,v)=>{if(a===p.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const f=a===p.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",T=[m.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${f}.scpt`,j).fsPath,"-t",o||b,"-w",u];for(let q of t)T.push("-a"),T.push(q);if(s)for(let q in s){const x=s[q];x===null?(T.push("-u"),T.push(q)):(T.push("-e"),T.push(`${q}=${x}`))}let O="";const B=g.spawn(d.OSASCRIPT,T);B.on("error",q=>{v(I(q))}),B.stderr.on("data",q=>{O+=q.toString()}),B.on("exit",q=>{if(q===0)c(void 0);else if(O){const x=O.split(`
`,1);v(new Error(x[0]))}else v(new Error(S.localize(1,null,f,q)))})}else v(new Error(S.localize(2,null,a)))})}spawnTerminal(o,u,t){const s=u.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((r,a)=>{const c=["-a",s];t&&c.push(t);const v=o.spawn("/usr/bin/open",c);v.on("error",a),v.on("exit",()=>r())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class w extends k{openTerminal(o,u){return this.spawnTerminal(g,o,u)}runInTerminal(o,u,t,s,r){const a=r.linuxExec?Promise.resolve(r.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((c,v)=>{let f=[];a.then(L=>{L.indexOf("gnome-terminal")>=0?f.push("-x"):f.push("-e"),f.push("bash"),f.push("-c");const T=`${l(t)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;f.push(`''${T}''`);const O=Object.assign({},process.env,s);Object.keys(O).filter(ie=>O[ie]===null).forEach(ie=>delete O[ie]);const B={cwd:u,env:O};let q="";const x=g.spawn(L,f,B);x.on("error",ie=>{v(I(ie))}),x.stderr.on("data",ie=>{q+=ie.toString()}),x.on("exit",ie=>{if(ie===0)c(void 0);else if(q){const V=q.split(`
`,1);v(new Error(V[0]))}else v(new Error(S.localize(4,null,L,ie)))})})})}static async getDefaultTerminalLinuxReady(){return w._DEFAULT_TERMINAL_LINUX_READY||(w._DEFAULT_TERMINAL_LINUX_READY=new Promise(async o=>{n.isLinux?await E.Promises.exists("/etc/debian_version")?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm"):o("xterm")})),w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,u,t){const s=u.linuxExec?Promise.resolve(u.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{s.then(c=>{const v=P(process),f=o.spawn(c,[],{cwd:t,env:v});f.on("error",a),f.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=S.localize(3,null);function P(h){const o=h.env;return(0,i.sanitizeProcessEnvironment)(o),o}function I(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(S.localize(5,null,h.path)):h}function l(h){let o="";for(let u of h)u.indexOf(" ")>=0?o+='"'+u+'"':o+=u,o+=" ";return o}}),define(J[19],Z([0,1,141,8,7,4,23,13,37]),function(j,e,g,M,D,S,E,n,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function m(U){return U.create===!0}e.isFileOpenForWriteOptions=m;var i;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var b;(function(U){U[U.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var k;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(k=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=y;function d(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=d;function w(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function P(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=P;var I;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor(N,F){super(N);this.code=F}}e.FileSystemProviderError=l;function h(U,N){const F=new l(U.toString(),N);return u(F,N),F}e.createFileSystemProviderError=h;function o(U){return U||h((0,g.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=o;function u(U,N){return U.name=N?`${N} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=u;function t(U){if(!U)return I.Unknown;if(U instanceof l)return U.code;const N=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!N)return I.Unknown;switch(N[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=t;function s(U){if(U instanceof L)return U.fileOperationResult;switch(t(U)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class a{constructor(N,F,$){this.resource=N,this.operation=F,this.target=$}isOperation(N){return this.operation===N}}e.FileOperationEvent=a;var c;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class v{constructor(N,F){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const $ of N)switch($.type){case 1:this.added||(this.added=p.TernarySearchTree.forUris(()=>F)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=p.TernarySearchTree.forUris(()=>F)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=p.TernarySearchTree.forUris(()=>F)),this.deleted.set($.resource,$);break}}contains(N,...F){return this.doContains(N,{includeChildren:!1},...F)}affects(N,...F){return this.doContains(N,{includeChildren:!0},...F)}doContains(N,F,...$){if(!N)return!1;const W=$.length>0;return!!((!W||$.includes(1))&&(this.added?.get(N)||F.includeChildren&&this.added?.findSuperstr(N))||(!W||$.includes(0))&&(this.updated?.get(N)||F.includeChildren&&this.updated?.findSuperstr(N))||(!W||$.includes(2))&&(this.deleted?.findSubstr(N)||F.includeChildren&&this.deleted?.findSuperstr(N)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=v;function f(U,N,F){return!U||!N||U===N||N.length>U.length?!1:(N.charAt(N.length-1)!==M.sep&&(N+=M.sep),F?(0,E.startsWithIgnoreCase)(U,N):U.indexOf(N)===0)}e.isParent=f;class L extends Error{constructor(N,F,$){super(N);this.fileOperationResult=F,this.options=$}}e.FileOperationError=L;class T extends L{constructor(N,F,$){super(N,2,$);this.stat=F}}e.NotModifiedSinceFileOperationError=T;var O;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(O=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var B;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(B=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function q(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=q;async function x(U,N){if(!N.canHandleResource(D.URI.from({scheme:U.scheme})))return new Promise(F=>{const $=N.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===U.scheme&&W.added&&($.dispose(),F())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ie{static formatSize(N){return(0,n.isNumber)(N)||(N=0),N<ie.KB?(0,g.localize)(1,null,N.toFixed(0)):N<ie.MB?(0,g.localize)(2,null,(N/ie.KB).toFixed(2)):N<ie.GB?(0,g.localize)(3,null,(N/ie.MB).toFixed(2)):N<ie.TB?(0,g.localize)(4,null,(N/ie.GB).toFixed(2)):(0,g.localize)(5,null,(N/ie.TB).toFixed(2))}}e.ByteSize=ie,ie.KB=1024,ie.MB=ie.KB*ie.KB,ie.GB=ie.MB*ie.KB,ie.TB=ie.GB*ie.KB;var V;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function Y(U){return{maxFileSize:U===0?300*ie.MB:16*ie.GB,maxHeapSize:U===0?700*ie.MB:2*700*ie.MB}}e.getPlatformLimits=Y}),define(J[54],Z([0,1,241,136,19,88]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function E(k,y){const d={onUnknownOption:P=>{console.warn((0,M.localize)(0,null,P))},onMultipleValues:(P,I)=>{console.warn((0,M.localize)(1,null,P,I))}},w=(0,S.parseArgs)(k,S.OPTIONS,y?d:void 0);return w.goto&&w._.forEach(P=>g(/^(\w:)?[^:]+(:\d*){0,2}$/.test(P),(0,M.localize)(2,null))),w["max-memory"]&&g(parseInt(w["max-memory"])>=D.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${D.MIN_MAX_MEMORY_SIZE_MB} MB.`),w}function n(k){const y=k.findIndex(d=>!/^-/.test(d));if(y>-1)return[...k.slice(0,y),...k.slice(y+1)]}function p(k){let[,...y]=k;process.env.VSCODE_DEV&&(y=n(y)||[]);const d=!b(process.env);return E(y,d)}e.parseMainProcessArgv=p;function m(k){const[,,...y]=k;return E(y,!0)}e.parseCLIProcessArgv=m;function i(k,...y){const d=k.indexOf("--");return d===-1?k.push(...y):k.splice(d,0,...y),k}e.addArg=i;function b(k){return k.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),define(J[91],Z([0,1,160,41,28,3,54,67,131,25,16]),function(j,e,g,M,D,S,E,n,p,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function b(d,w,P){return w["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(P)&&!w["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(P)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),k||(k=new Promise(async I=>{const l=new m.CancellationTokenSource,h=setTimeout(()=>{d.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),l.dispose(!0),I({})},1e4);try{const o=await y(d,l.token);I(o)}catch(o){(0,i.isPromiseCanceledError)(o)||d.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),I({})}finally{clearTimeout(h),l.dispose()}})),k)}e.resolveShellEnv=b;let k;async function y(d,w){const P=new Promise(async(I,l)=>{const h=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",h);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",o);const u=(0,D.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(u+"(.*)"+u),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",s);const r=await(0,p.getSystemShell)(S.OS,s);if(d.trace("getUnixShellEnvironment#shell",r),w.isCancellationRequested)return l(i.canceled);const a=g.basename(r);let c,v;/^pwsh(-preview)?$/.test(a)?(c=`& '${process.execPath}' -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,v=["-Login","-Command"]):(c=`'${process.execPath}' -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,v=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(v),c);const f=(0,M.spawn)(r,[...v,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});w.onCancellationRequested(()=>(f.kill(),l(i.canceled))),f.on("error",O=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,n.toErrorMessage)(O)),I({})});const L=[];f.stdout.on("data",O=>L.push(O));const T=[];f.stderr.on("data",O=>T.push(O)),f.on("close",(O,B)=>{const q=Buffer.concat(L).toString("utf8");d.trace("getUnixShellEnvironment#raw",q);const x=Buffer.concat(T).toString("utf8");if(x.trim()&&d.trace("getUnixShellEnvironment#stderr",x),O||B)return l(new Error(`Failed to get environment (code ${O}, signal ${B})`));const ie=t.exec(q),V=ie?ie[1]:"{}";try{const Y=JSON.parse(V);h?Y.ELECTRON_RUN_AS_NODE=h:delete Y.ELECTRON_RUN_AS_NODE,o?Y.ELECTRON_NO_ATTACH_CONSOLE=o:delete Y.ELECTRON_NO_ATTACH_CONSOLE,delete Y.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",Y),I(Y)}catch(Y){d.error("getUnixShellEnvironment#errorCaught",(0,n.toErrorMessage)(Y)),l(Y)}})});try{return await P}catch(I){return d.error("getUnixShellEnvironment#error",(0,n.toErrorMessage)(I)),{}}}}),define(J[92],Z([0,1,7,19,3]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function S(p){return p.map(m=>({type:m.type,resource:g.URI.file(m.path)}))}e.toFileChanges=S;function E(p){const m=new n;for(const i of p)m.processEvent(i);return m.normalize()}e.normalizeFileChanges=E;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(m){const i=this.mapPathToChange.get(m.path);if(i){const b=i.type,k=m.type;b===1&&k===2?(this.mapPathToChange.delete(m.path),this.normalized.splice(this.normalized.indexOf(i),1)):b===2&&k===1?i.type=0:b===1&&k===0||(i.type=k)}else this.normalized.push(m),this.mapPathToChange.set(m.path,m)}normalize(){const m=[],i=[];return this.normalized.filter(b=>b.type!==2?(m.push(b),!1):!0).sort((b,k)=>b.path.length-k.path.length).filter(b=>i.some(k=>(0,M.isParent)(b.path,k,!D.isLinux))?!1:(i.push(b.path),!0)).concat(m)}}}),define(J[174],Z([0,1,92,2,18,82,118,9,8]),function(j,e,g,M,D,S,E,n,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class m extends M.Disposable{constructor(b,k,y,d){super();this.path=b,this.onDidFilesChange=k,this.onLogMessage=y,this.verboseLogging=d,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(E.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(b){this.verboseLogging=b}async startWatching(){try{const{stat:b,symbolicLink:k}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let y=this.path;if(k)try{y=await(0,S.realpath)(y)}catch(d){if(this.onError(d),k.dangling)return}b.isDirectory()?this._register((0,E.watchFolder)(y,(d,w)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,p.join)(this.path,(0,p.basename)(w))})},d=>this.onError(d))):this._register((0,E.watchFile)(y,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(b){b.code!=="ENOENT"&&this.onError(b)}}onFileChange(b){this.fileChangesBuffer.push(b),this.verboseLogging&&this.onVerbose(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),this.fileChangesDelayer.trigger(async()=>{const k=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=(0,g.normalizeFileChanges)(k);if(this.verboseLogging)for(const d of y)this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);y.length>0&&this.onDidFilesChange(y)})}onError(b){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${b}`})}onVerbose(b){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=m}),define(J[71],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...D){this._entries=new Map;for(let[S,E]of D)this.set(S,E)}set(D,S){const E=this._entries.get(D);return this._entries.set(D,S),E}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=g}),define(J[175],Z([0,1,16,168,69,4,71,9]),function(j,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const p=!1;class m extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class i{constructor(d=new E.ServiceCollection,w=!1,P){this._activeInstantiations=new Set,this._services=d,this._strict=w,this._parent=P,this._services.set(S.IInstantiationService,this)}createChild(d){return new i(d,this._strict,this)}invokeFunction(d,...w){let P=k.traceInvocation(d),I=!1;try{return d({get:(h,o)=>{if(I)throw(0,g.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(h,P);if(!u&&o!==S.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return u}},...w)}finally{I=!0,P.stop()}}createInstance(d,...w){let P,I;return d instanceof D.SyncDescriptor?(P=k.traceCreation(d.ctor),I=this._createInstance(d.ctor,d.staticArguments.concat(w),P)):(P=k.traceCreation(d),I=this._createInstance(d,w,P)),P.stop(),I}_createInstance(d,w=[],P){let I=S._util.getServiceDependencies(d).sort((o,u)=>o.index-u.index),l=[];for(const o of I){let u=this._getOrCreateServiceInstance(o.id,P);if(!u&&this._strict&&!o.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${o.id}.`);l.push(u)}let h=I.length>0?I[0].index:w.length;if(w.length!==h){console.warn(`[createInstance] First service dependency of ${d.name} at position ${h+1} conflicts with ${w.length} static arguments`);let o=h-w.length;o>0?w=w.concat(new Array(o)):w=w.slice(0,h)}return new d(...[...w,...l])}_setServiceInstance(d,w){if(this._services.get(d)instanceof D.SyncDescriptor)this._services.set(d,w);else if(this._parent)this._parent._setServiceInstance(d,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let w=this._services.get(d);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):w}_getOrCreateServiceInstance(d,w){let P=this._getServiceInstanceOrDescriptor(d);return P instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,P,w.branch(d,!0)):(w.branch(d,!1),P)}_safeCreateAndCacheServiceInstance(d,w,P){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,w,P)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,w,P){const I=new M.Graph(o=>o.id.toString());let l=0;const h=[{id:d,desc:w,_trace:P}];for(;h.length;){const o=h.pop();if(I.lookupOrInsertNode(o),l++>1e3)throw new m(I);for(let u of S._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(u.id);if(!t&&!u.optional&&console.warn(`[createInstance] ${d} depends on ${u.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const s={id:u.id,desc:t,_trace:o._trace.branch(u.id,!0)};I.insertEdge(o,s),h.push(s)}}}for(;;){const o=I.roots();if(o.length===0){if(!I.isEmpty())throw new m(I);break}for(const{data:u}of o){if(this._getServiceInstanceOrDescriptor(u.id)instanceof D.SyncDescriptor){const s=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,s)}I.removeNode(u)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,w,P=[],I,l){if(this._services.get(d)instanceof D.SyncDescriptor)return this._createServiceInstance(w,P,I,l);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,w,P,I,l);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(d,w=[],P,I){if(P){const l=new n.IdleValue(()=>this._createInstance(d,w,I));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let u=l.value,t=u[o];return typeof t!="function"||(t=t.bind(u),h[o]=t),t},set(h,o,u){return l.value[o]=u,!0}})}else return this._createInstance(d,w,I)}}e.InstantiationService=i;var b;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(b||(b={}));class k{constructor(d,w){this.type=d,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return p?new k(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):k._None}static traceCreation(d){return p?new k(0,d.name):k._None}branch(d,w){let P=new k(2,d.toString());return this._dep.push([d,w,P]),P}stop(){let d=Date.now()-this._start;k._totals+=d;let w=!1;function P(l,h){let o=[],u=new Array(l+1).join("	");for(const[t,s,r]of h._dep)if(s&&r){w=!0,o.push(`${u}CREATES -> ${t}`);let a=P(l+1,r);a&&o.push(a)}else o.push(`${u}uses -> ${t}`);return o.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${k._totals.toFixed(2)}ms)`];(d>2||w)&&console.log(I.join(`
`))}}k._None=new class extends k{constructor(){super(-1,null)}stop(){}branch(){return this}},k._totals=0}),define(J[176],Z([0,1,16,129,57]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class S extends D.ResolvedKeybinding{constructor(n,p){super();if(p.length===0)throw(0,g.illegalArgument)("parts");this._os=n,this._parts=p}getLabel(){return M.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return M.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:M.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return M.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new D.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=S}),define(J[177],Z([0,1,57,176]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class D extends M.BaseResolvedKeybinding{constructor(E,n){super(n,E.parts)}_keyCodeToUILabel(E){if(this._os===2)switch(E){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return g.KeyCodeUtils.toString(E)}_getLabel(E){return E.isDuplicateModifierCase()?"":this._keyCodeToUILabel(E.keyCode)}_getAriaLabel(E){return E.isDuplicateModifierCase()?"":g.KeyCodeUtils.toString(E.keyCode)}_keyCodeToElectronAccelerator(E){if(E>=93&&E<=108)return null;switch(E){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return g.KeyCodeUtils.toString(E)}_getElectronAccelerator(E){return E.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(E.keyCode)}_getUserSettingsLabel(E){if(E.isDuplicateModifierCase())return"";const n=g.KeyCodeUtils.toUserSettingsUS(E.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(E){return D.getDispatchStr(E)}static getDispatchStr(E){if(E.isModifierKey())return null;let n="";return E.ctrlKey&&(n+="ctrl+"),E.shiftKey&&(n+="shift+"),E.altKey&&(n+="alt+"),E.metaKey&&(n+="meta+"),n+=g.KeyCodeUtils.toString(E.keyCode),n}_getSingleModifierDispatchPart(E){return E.keyCode===5&&!E.shiftKey&&!E.altKey&&!E.metaKey?"ctrl":E.keyCode===4&&!E.ctrlKey&&!E.altKey&&!E.metaKey?"shift":E.keyCode===6&&!E.ctrlKey&&!E.shiftKey&&!E.metaKey?"alt":E.keyCode===57&&!E.ctrlKey&&!E.shiftKey&&!E.altKey?"meta":null}}e.USLayoutResolvedKeybinding=D}),define(J[178],Z([0,1,9]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function M(D,S){if(D.length===0)return Promise.resolve(!1);const E=[];let n=!1;for(let p of D){if(p===!0)return Promise.resolve(!0);(0,g.isThenable)(p)&&E.push(p.then(m=>{m&&(n=!0)},m=>{S(m),n=!0}))}return g.Promises.settled(E).then(()=>n)}e.handleVetos=M}),define(J[6],Z([0,1,4,2,3,5,67]),function(j,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function n(){return new Date().toISOString()}var p;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;class m extends M.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=m;class i extends m{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(p.Trace)&&this.log(p.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(p.Debug)&&this.log(p.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(p.Info)&&this.log(p.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(p.Warning)&&this.log(p.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(p.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(p.Error,this.format(r))}else this.log(p.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(p.Critical)&&this.log(p.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let r=0;r<t.length;r++){let a=t[r];if(typeof a=="object")try{a=JSON.stringify(a)}catch(c){}s+=(r>0?" ":"")+a}return s}}e.AbstractMessageLogger=i;class b extends m{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!D.isWindows}trace(t,...s){this.getLevel()<=p.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...s):console.log(`[main ${n()}]`,t,...s))}debug(t,...s){this.getLevel()<=p.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...s):console.log(`[main ${n()}]`,t,...s))}info(t,...s){this.getLevel()<=p.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...s):console.log(`[main ${n()}]`,t,...s))}warn(t,...s){this.getLevel()<=p.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,t,...s):console.warn(`[main ${n()}]`,t,...s))}error(t,...s){this.getLevel()<=p.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,t,...s):console.error(`[main ${n()}]`,t,...s))}critical(t,...s){this.getLevel()<=p.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,t,...s):console.error(`[main ${n()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class k extends m{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=p.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=p.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=p.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=p.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=p.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=p.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=k;class y extends m{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=p.Trace&&this.adapter.log(p.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=p.Debug&&this.adapter.log(p.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=p.Info&&this.adapter.log(p.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=p.Warning&&this.adapter.log(p.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=p.Error&&this.adapter.log(p.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=p.Critical&&this.adapter.log(p.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,E.toErrorMessage)(t,this.getLevel()<=p.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class d extends m{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const r of this.logServices)r.trace(t,...s)}debug(t,...s){for(const r of this.logServices)r.debug(t,...s)}info(t,...s){for(const r of this.logServices)r.info(t,...s)}warn(t,...s){for(const r of this.logServices)r.warn(t,...s)}error(t,...s){for(const r of this.logServices)r.error(t,...s)}critical(t,...s){for(const r of this.logServices)r.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class w extends M.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=w;class P extends M.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(r))}))}createLogger(t,s){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,s?.always?p.Trace:this.logLevel,s),this.loggers.set(t.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class I{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(t){}getLevel(){return p.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=I;function l(u){if(u.verbose)return p.Trace;if(typeof u.logLevel=="string"){const t=h(u.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function h(u){switch(u){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Critical;case"off":return p.Off}}e.parseLogLevel=h;function o(u){switch(u){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Critical:return"critical";case p.Off:return"off"}}e.LogLevelToString=o});var ee=this&&this.__param||function(j,e){return function(g,M){e(g,M,j)}};define(J[179],Z([0,1,9,17,40,78,48,19,4,6]),function(j,e,g,M,D,S,E,n,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var i;(function(k){k.ERROR_INVALID_FILE="ERROR_INVALID_FILE",k.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(i=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,p.createDecorator)(e.UserConfigurationFileServiceId);let b=class{constructor(y,d,w){this.environmentService=y,this.fileService=d,this.logService=w,this.queue=new g.Queue}async updateSettings(y,d){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,y,d))}async doWrite(y,d,w){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,y.toString(),d);const{value:P,mtime:I,etag:l}=await this.fileService.readFile(y,{atomic:!0});let h=P.toString();const o=[];if((0,D.parse)(h,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length)throw new Error("ERROR_INVALID_FILE");const u=this.getEdits(d,h,w)[0];if(u){h=h.substring(0,u.offset)+u.content+h.substring(u.offset+u.length);try{await this.fileService.writeFile(y,M.VSBuffer.fromString(h),{etag:l,mtime:I})}catch(t){if(t.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:y,path:d},w,P){return d.length?(0,S.setProperty)(w,d,y,P):[{content:JSON.stringify(y,null,P.insertSpaces&&P.tabSize?" ".repeat(P.tabSize):"	"),length:w.length,offset:0}]}};b=ce([ee(0,E.IEnvironmentService),ee(1,n.IFileService),ee(2,m.ILogService)],b),e.UserConfigurationFileService=b}),define(J[93],Z([0,1,6]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function M(S,E){switch(E){case g.LogLevel.Trace:return S.trace;case g.LogLevel.Debug:return S.debug;case g.LogLevel.Info:return S.info;case g.LogLevel.Warning:return S.warn;case g.LogLevel.Error:return S.error;case g.LogLevel.Critical:return S.critical;default:throw new Error("Invalid log level")}}class D extends g.AbstractLogger{constructor(E=g.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(E),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(E){this._logger=E;for(const{level:n,args:p}of this.buffer)M(E,n).apply(E,p);this.buffer=[]}_log(E,...n){this._logger?M(this._logger,E).apply(this._logger,n):this.getLevel()<=E&&this.buffer.push({level:E,args:n})}trace(E,...n){this._log(g.LogLevel.Trace,E,...n)}debug(E,...n){this._log(g.LogLevel.Debug,E,...n)}info(E,...n){this._log(g.LogLevel.Info,E,...n)}warn(E,...n){this._log(g.LogLevel.Warning,E,...n)}error(E,...n){this._log(g.LogLevel.Error,E,...n)}critical(E,...n){this._log(g.LogLevel.Critical,E,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(J[180],Z([0,1,6,19,9,17,15,4,93]),function(j,e,g,M,D,S,E,n,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const m=5*M.ByteSize.MB;let i=class extends g.AbstractLogger{constructor(y,d,w,P){super();this.name=y,this.resource=d,this.fileService=P,this.backupIndex=1,this.setLevel(w),this.queue=this._register(new D.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=g.LogLevel.Trace&&this._log(g.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=g.LogLevel.Debug&&this._log(g.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=g.LogLevel.Info&&this._log(g.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=g.LogLevel.Warning&&this._log(g.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=g.LogLevel.Error){const y=arguments[0];if(y instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=y.stack,this._log(g.LogLevel.Error,this.format(d))}else this._log(g.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=g.LogLevel.Critical&&this._log(g.LogLevel.Critical,this.format(arguments))}flush(){}log(y,d){this._log(y,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(y){if(y.fileOperationResult!==3)throw y}}_log(y,d){this.queue.queue(async()=>{await this.initializePromise;let w=await this.loadContent();w.length>m&&(await this.fileService.writeFile(this.getBackupResource(),S.VSBuffer.fromString(w)),w=""),w+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(y)}] ${d}
`,await this.fileService.writeFile(this.resource,S.VSBuffer.fromString(w))})}getCurrentTimestamp(){const y=P=>P<10?`0${P}`:P,d=P=>P<10?`00${P}`:P<100?`0${P}`:P,w=new Date;return`${w.getFullYear()}-${y(w.getMonth()+1)}-${y(w.getDate())} ${y(w.getHours())}:${y(w.getMinutes())}:${y(w.getSeconds())}.${d(w.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,E.joinPath)((0,E.dirname)(this.resource),`${(0,E.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(y){return""}}stringifyLogLevel(y){switch(y){case g.LogLevel.Critical:return"critical";case g.LogLevel.Debug:return"debug";case g.LogLevel.Error:return"error";case g.LogLevel.Info:return"info";case g.LogLevel.Trace:return"trace";case g.LogLevel.Warning:return"warning"}return""}format(y){let d="";for(let w=0;w<y.length;w++){let P=y[w];if(typeof P=="object")try{P=JSON.stringify(P)}catch(I){}d+=(w>0?" ":"")+P}return d}};i=ce([ee(3,M.IFileService)],i),e.FileLogger=i;let b=class extends g.AbstractLoggerService{constructor(y,d,w){super(y.getLevel(),y.onDidChangeLogLevel);this.instantiationService=d,this.fileService=w}doCreateLogger(y,d){const w=new p.BufferLogService(d);return(0,M.whenProviderRegistered)(y,this.fileService).then(()=>w.logger=this.instantiationService.createInstance(i,(0,E.basename)(y),y,w.getLevel())),w}};b=ce([ee(0,g.ILogService),ee(1,n.IInstantiationService),ee(2,M.IFileService)],b),e.FileLoggerService=b}),define(J[181],Z([0,1,6,5,7]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class S{constructor(k){this.service=k,this.onDidChangeLogLevel=M.Event.buffer(k.onDidChangeLogLevel,!0)}listen(k,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(k,y,d){switch(y){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=S;class E{constructor(k){this.channel=k}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(k){E.setLevel(this.channel,k)}static setLevel(k,y){return k.call("setLevel",y)}}e.LogLevelChannelClient=E;class n{constructor(k){this.loggerService=k,this.loggers=new Map}listen(k,y){throw new Error(`Event not found: ${y}`)}async call(k,y,d){switch(y){case"createLogger":this.createLogger(D.URI.revive(d[0]),d[1]);return;case"log":return this.log(D.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${y}`)}createLogger(k,y){this.loggers.set(k.toString(),this.loggerService.createLogger(k,y))}consoleLog(k,y){let d=console.log;switch(k){case g.LogLevel.Error:d=console.error;break;case g.LogLevel.Warning:d=console.warn;break;case g.LogLevel.Info:d=console.info;break}d.call(console,...y)}log(k,y){const d=this.loggers.get(k.toString());if(!d)throw new Error("Create the logger before logging");for(const[w,P]of y)switch(w){case g.LogLevel.Trace:d.trace(P);break;case g.LogLevel.Debug:d.debug(P);break;case g.LogLevel.Info:d.info(P);break;case g.LogLevel.Warning:d.warn(P);break;case g.LogLevel.Error:d.error(P);break;case g.LogLevel.Critical:d.critical(P);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class p extends g.AbstractLoggerService{constructor(k,y,d){super(k,y);this.channel=d}createConsoleMainLogger(){return new g.AdapterLogger({log:(k,y)=>{this.channel.call("consoleLog",[k,y])}})}doCreateLogger(k,y,d){return new m(this.channel,k,y,d)}}e.LoggerChannelClient=p;class m extends g.AbstractMessageLogger{constructor(k,y,d,w){super(w?.always);this.channel=k,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[y,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(k,y){const d=[[k,y]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(k){this.channel.call("log",[this.file,k])}}class i extends g.LogService{constructor(k,y){super(y);this.parent=k,this._register(k.onDidChangeLogLevel(d=>y.setLevel(d)))}setLevel(k){super.setLevel(k),this.parent.setLevel(k)}}e.FollowerLogService=i}),define(J[94],Z([0,1,6,19]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function D(p,m,i,b){try{const k=await new Promise((y,d)=>{j(["spdlog"],y,d)});return k.setFlushOn(g.LogLevel.Trace),k.createAsyncRotatingLogger(p,m,i,b)}catch(k){console.error(k)}return null}function S(p,m,i,b){const k=j.__$__nodeRequire("spdlog");return k.setFlushOn(g.LogLevel.Trace),k.createRotatingLogger(p,m,i,b)}e.createRotatingLogger=S;function E(p,m,i){switch(m){case g.LogLevel.Trace:p.trace(i);break;case g.LogLevel.Debug:p.debug(i);break;case g.LogLevel.Info:p.info(i);break;case g.LogLevel.Warning:p.warn(i);break;case g.LogLevel.Error:p.error(i);break;case g.LogLevel.Critical:p.critical(i);break;default:throw new Error("Invalid log level")}}class n extends g.AbstractMessageLogger{constructor(m,i,b,k){super();this.name=m,this.filepath=i,this.rotating=b,this.buffer=[],this.setLevel(k),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}_createSpdLogLogger(){const m=this.rotating?6:1,i=30/m*M.ByteSize.MB;return D(this.name,this.filepath,i,m).then(b=>{if(b){this._logger=b,this._logger.setLevel(this.getLevel());for(const{level:k,message:y}of this.buffer)E(this._logger,k,y);this.buffer=[]}})}log(m,i){this._logger?E(this._logger,m,i):this.getLevel()<=m&&this.buffer.push({level:m,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(J[182],Z([0,1,6,15,10,180,94,19,28]),function(j,e,g,M,D,S,E,n,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let m=class extends g.AbstractLoggerService{constructor(b,k){super(b.getLevel(),b.onDidChangeLogLevel);this.fileService=k}doCreateLogger(b,k,y){if(b.scheme===D.Schemas.file){const d=new E.SpdLogLogger(y?.name||(0,p.generateUuid)(),b.fsPath,!y?.donotRotate,k);return y?.donotUseFormatters&&d.clearFormatters(),d}else return new S.FileLogger(y?.name??(0,M.basename)(b),b,k,this.fileService)}};m=ce([ee(0,g.ILogService),ee(1,n.IFileService)],m),e.LoggerService=m}),define(J[183],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function g(E){return E.submenu!==void 0}e.isMenubarMenuItemSubmenu=g;function M(E){return E.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=M;function D(E){return E.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function S(E){return!g(E)&&!M(E)&&!D(E)}e.isMenubarMenuItemAction=S}),define(J[49],Z([0,1,10,3,33,15]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let E;if(typeof M.globals.vscode!="undefined"&&typeof M.globals.vscode.context!="undefined"){const n=M.globals.vscode.context.configuration();if(n)E=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof j?.__$__nodeRequire=="function"){const n=(0,S.dirname)(g.FileAccess.asFileUri("",j));E=j.__$__nodeRequire((0,S.joinPath)(n,"product.json").fsPath);const p=j.__$__nodeRequire((0,S.joinPath)(n,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(E,{nameShort:`${E.nameShort} Dev`,nameLong:`${E.nameLong} Dev`,dataFolderName:`${E.dataFolderName}-dev`}),Object.assign(E,{version:p.version})}else E={},Object.keys(E).length===0&&Object.assign(E,{version:"1.59.0-dev",nameShort:M.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:M.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=E}),define(J[95],Z([0,1,142,17,19,16,49]),function(j,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(b,k,y,d,w,P){let I;try{await p(b,k,y,d,w,P)}catch(l){I=l}finally{I&&w.errorTransformer&&(I=w.errorTransformer(I)),typeof I!="undefined"&&y.error(I),y.end()}}e.readFileIntoStream=n;async function p(b,k,y,d,w,P){m(P);const I=await b.open(k,{create:!1});try{m(P);let l=0,h=0,o=w&&typeof w.length=="number"?w.length:void 0,u=M.VSBuffer.alloc(Math.min(w.bufferSize,typeof o=="number"?o:w.bufferSize)),t=w&&typeof w.position=="number"?w.position:0,s=0;do h=await b.read(I,t,u.buffer,s,u.byteLength-s),t+=h,s+=h,l+=h,typeof o=="number"&&(o-=h),s===u.byteLength&&(await y.write(d(u)),u=M.VSBuffer.alloc(Math.min(w.bufferSize,typeof o=="number"?o:w.bufferSize)),s=0);while(h>0&&(typeof o!="number"||o>0)&&m(P)&&i(l,w));if(s>0){let r=s;typeof o=="number"&&(r=Math.min(s,o)),y.write(d(u.slice(0,r)))}}catch(l){throw(0,D.ensureFileSystemProviderError)(l)}finally{await b.close(I)}}function m(b){if(b.isCancellationRequested)throw(0,S.canceled)();return!0}function i(b,k){if(k?.limits){if(typeof k.limits.memory=="number"&&b>k.limits.memory)throw(0,D.createFileSystemProviderError)((0,g.localize)(0,null,E.default.nameShort),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof k.limits.size=="number"&&b>k.limits.size)throw(0,D.createFileSystemProviderError)((0,g.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[184],Z([0,1,140,72,2,19,5,15,37,36,6,17,64,9,25,10,95,63]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let l=class Ve extends D.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new E.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new E.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new E.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new E.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new E.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new E.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new y.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new S.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new y.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new S.FileChangesEvent(u,!0)))),this.watchedResources=p.TernarySearchTree.forUris(u=>{const t=this.getProvider(u.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new y.ResourceQueue)}registerProvider(o,u){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,M.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:u});const t=new D.DisposableStore;return t.add(u.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(u)))),t.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:o}))),typeof u.onDidErrorOccur=="function"&&t.add(u.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,D.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:u}),this.provider.delete(o),(0,D.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){u.push(t)}}),!this.provider.has(o)&&await y.Promises.settled(u)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,u){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&u)}listCapabilities(){return I.Iterable.map(this.provider,([o,u])=>({scheme:o,capabilities:u.capabilities}))}async withProvider(o){if(!(0,n.isAbsolutePath)(o))throw new S.FileOperationError((0,g.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const u=this.provider.get(o.scheme);if(!u){const t=new Error;throw t.name="ENOPRO",t.message=(0,g.localize)(1,null,o.toString()),t}return u}async withReadProvider(o){const u=await this.withProvider(o);if((0,S.hasOpenReadWriteCloseCapability)(u)||(0,S.hasReadWriteCapability)(u)||(0,S.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const u=await this.withProvider(o);if((0,S.hasOpenReadWriteCloseCapability)(u)||(0,S.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,u){try{return await this.doResolveFile(o,u)}catch(t){throw(0,S.toFileSystemProviderErrorCode)(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,g.localize)(2,null,this.resourceForError(o)),1):(0,S.ensureFileSystemProviderError)(t)}}async doResolveFile(o,u){const t=await this.withProvider(o),s=this.isPathCaseSensitive(t),r=u?.resolveTo,a=u?.resolveSingleChildDescendants,c=u?.resolveMetadata,v=await t.stat(o);let f;return this.toFileStat(t,o,v,void 0,!!c,(L,T)=>(f||(f=p.TernarySearchTree.forUris(()=>!s),f.set(o,!0),(0,m.isNonEmptyArray)(r)&&r.forEach(O=>f.set(O,!0))),Boolean(f.findSuperstr(L.resource)||f.get(L.resource))?!0:L.isDirectory&&a?T===1:!1))}async toFileStat(o,u,t,s,r,a){const{providerExtUri:c}=this.getExtUri(o),v={resource:u,name:c.basename(u),isFile:(t.type&S.FileType.File)!=0,isDirectory:(t.type&S.FileType.Directory)!=0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&S.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,S.etag)({mtime:t.mtime,size:t.size})};if(v.isDirectory&&a(v,s)){try{const f=await o.readdir(u),L=await y.Promises.settled(f.map(async([T,O])=>{try{const B=c.joinPath(u,T),q=r?await o.stat(B):{type:O};return await this.toFileStat(o,B,q,f.length,r,a)}catch(B){return this.logService.trace(B),null}}));v.children=(0,m.coalesce)(L)}catch(f){this.logService.trace(f),v.children=[]}return v}return v}async resolveAll(o){return y.Promises.settled(o.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const u=await this.withProvider(o);try{return!!await u.stat(o)}catch(t){return!1}}async canCreateFile(o,u){try{await this.doValidateCreateFile(o,u)}catch(t){return t}return!0}async doValidateCreateFile(o,u){if(!u?.overwrite&&await this.exists(o))throw new S.FileOperationError((0,g.localize)(3,null,this.resourceForError(o)),3,u)}async createFile(o,u=b.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const s=await this.writeFile(o,u);return this._onDidRunOperation.fire(new S.FileOperationEvent(o,0,s)),s}async writeFile(o,u,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:r}=this.getExtUri(s);try{await this.validateWriteFile(s,o,t)||await this.mkdirp(s,r.dirname(o));let c;if((0,S.hasReadWriteCapability)(s)&&!(u instanceof b.VSBuffer))if((0,k.isReadableStream)(u)){const v=await(0,k.peekStream)(u,3);v.ended?c=b.VSBuffer.concat(v.buffer):c=v}else c=(0,k.peekReadable)(u,v=>b.VSBuffer.concat(v),3);else c=u;!(0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasReadWriteCapability)(s)&&c instanceof b.VSBuffer?await this.doWriteUnbuffered(s,o,t,c):await this.doWriteBuffered(s,o,t,c instanceof b.VSBuffer?(0,b.bufferToReadable)(c):c)}catch(a){throw new S.FileOperationError((0,g.localize)(4,null,this.resourceForError(o),(0,S.ensureFileSystemProviderError)(a).toString()),(0,S.toFileOperationResult)(a),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,u,t){if(!!t?.unlock&&!(o.capabilities&8192))throw new Error((0,g.localize)(5,null,this.resourceForError(u)));let r;try{r=await o.stat(u)}catch(a){return}if((r.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,g.localize)(6,null,this.resourceForError(u)),0,t);if(this.throwIfFileIsReadonly(u,r),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,S.etag)({mtime:t.mtime,size:r.size}))throw new S.FileOperationError((0,g.localize)(7,null),3,t);return r}async readFile(o,u){const t=await this.withReadProvider(o);return u?.atomic?this.doReadFileAtomic(t,o,u):this.doReadFile(t,o,u)}async doReadFileAtomic(o,u,t){return new Promise((s,r)=>{this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(o,u,t);s(a)}catch(a){r(a)}})})}async doReadFile(o,u,t){const s=await this.doReadFileStream(o,u,{...t,preferUnbuffered:!0});return{...s,value:await(0,b.streamToBuffer)(s.value)}}async readFileStream(o,u){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,u)}async doReadFileStream(o,u,t){const s=new d.CancellationTokenSource,r=this.validateReadFile(u,t).then(c=>c,c=>{throw s.cancel(),c});let a;try{return t&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&await r,!((0,S.hasOpenReadWriteCloseCapability)(o)||(0,S.hasFileReadStreamCapability)(o))||(0,S.hasReadWriteCapability)(o)&&t?.preferUnbuffered?a=this.readFileUnbuffered(o,u,t):(0,S.hasFileReadStreamCapability)(o)?a=this.readFileStreamed(o,u,s.token,t):a=this.readFileBuffered(o,u,s.token,t),{...await r,value:a}}catch(c){a&&await(0,k.consumeStream)(a);const v=(0,g.localize)(8,null,this.resourceForError(u),(0,S.ensureFileSystemProviderError)(c).toString());throw c instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(v,c.stat,t):new S.FileOperationError(v,(0,S.toFileOperationResult)(c),t)}}readFileStreamed(o,u,t,s=Object.create(null)){const r=o.readFileStream(u,s,t);return(0,k.transform)(r,{data:a=>a instanceof b.VSBuffer?a:b.VSBuffer.wrap(a),error:a=>new S.FileOperationError((0,g.localize)(9,null,this.resourceForError(u),(0,S.ensureFileSystemProviderError)(a).toString()),(0,S.toFileOperationResult)(a),s)},a=>b.VSBuffer.concat(a))}readFileBuffered(o,u,t,s=Object.create(null)){const r=(0,b.newWriteableBufferStream)();return(0,P.readFileIntoStream)(o,u,r,a=>a,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new S.FileOperationError((0,g.localize)(10,null,this.resourceForError(u),(0,S.ensureFileSystemProviderError)(a).toString()),(0,S.toFileOperationResult)(a),s)},t),r}readFileUnbuffered(o,u,t){const s=(0,k.newWriteableStream)(r=>b.VSBuffer.concat(r));return(async()=>{try{let r=await o.readFile(u);t&&typeof t.position=="number"&&(r=r.slice(t.position)),t&&typeof t.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(u,r.byteLength,t),s.end(b.VSBuffer.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async validateReadFile(o,u){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new S.FileOperationError((0,g.localize)(11,null,this.resourceForError(o)),0,u);if(u&&typeof u.etag=="string"&&u.etag!==S.ETAG_DISABLED&&u.etag===t.etag)throw new S.NotModifiedSinceFileOperationError((0,g.localize)(12,null),t,u);return this.validateReadFileLimits(o,t.size,u),t}validateReadFileLimits(o,u,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&u>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&u>t.limits.size&&(s=7),typeof s=="number")throw new S.FileOperationError((0,g.localize)(13,null,this.resourceForError(o)),s)}}async canMove(o,u,t){return this.doCanMoveCopy(o,u,"move",t)}async canCopy(o,u,t){return this.doCanMoveCopy(o,u,"copy",t)}async doCanMoveCopy(o,u,t,s){if(o.toString()!==u.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(r,o,a,u,t,s)}catch(r){return r}return!0}async move(o,u,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),a=await this.doMoveCopy(s,o,r,u,"move",!!t),c=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,a==="move"?2:3,c)),c}async copy(o,u,t){const s=await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),a=await this.doMoveCopy(s,o,r,u,"copy",!!t),c=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,a==="copy"?3:2,c)),c}async doMoveCopy(o,u,t,s,r,a){if(u.toString()===s.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:v}=await this.doValidateMoveCopy(o,u,t,s,r,a);if(c&&!v&&a&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),r==="copy"){if(o===t&&(0,S.hasFileFolderCopyCapability)(o))await o.copy(u,s,{overwrite:a});else{const f=await this.resolve(u);f.isDirectory?await this.doCopyFolder(o,f,t,s):await this.doCopyFile(o,u,t,s)}return r}else return o===t?(await o.rename(u,s,{overwrite:a}),r):(await this.doMoveCopy(o,u,t,s,"copy",a),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(o,u,t,s){if((0,S.hasOpenReadWriteCloseCapability)(o)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,u,t,s);if((0,S.hasOpenReadWriteCloseCapability)(o)&&(0,S.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,u,t,s);if((0,S.hasReadWriteCapability)(o)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,u,t,s);if((0,S.hasReadWriteCapability)(o)&&(0,S.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,u,t,s)}async doCopyFolder(o,u,t,s){await t.mkdir(s),Array.isArray(u.children)&&await y.Promises.settled(u.children.map(async r=>{const a=this.getExtUri(t).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.doCopyFolder(o,await this.resolve(r.resource),t,a):this.doCopyFile(o,r.resource,t,a)}))}async doValidateMoveCopy(o,u,t,s,r,a){let c=!1;if(o===t){const{providerExtUri:f,isPathCaseSensitive:L}=this.getExtUri(o);if(L||(c=f.isEqual(u,s)),c&&r==="copy")throw new Error((0,g.localize)(14,null,this.resourceForError(u),this.resourceForError(s)));if(!c&&f.isEqualOrParent(s,u))throw new Error((0,g.localize)(15,null,this.resourceForError(u),this.resourceForError(s)))}const v=await this.exists(s);if(v&&!c){if(!a)throw new S.FileOperationError((0,g.localize)(16,null,this.resourceForError(u),this.resourceForError(s)),4);if(o===t){const{providerExtUri:f}=this.getExtUri(o);if(f.isEqualOrParent(u,s))throw new Error((0,g.localize)(17,null,this.resourceForError(u),this.resourceForError(s)))}}return{exists:v,isSameResourceWithDifferentPathCase:c}}getExtUri(o){const u=this.isPathCaseSensitive(o);return{providerExtUri:u?n.extUri:n.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(u,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,0,t)),t}async mkdirp(o,u){const t=[],{providerExtUri:s}=this.getExtUri(o);for(;!s.isEqual(u,s.dirname(u));)try{if(((await o.stat(u)).type&S.FileType.Directory)==0)throw new Error((0,g.localize)(18,null,this.resourceForError(u)));break}catch(r){if((0,S.toFileSystemProviderErrorCode)(r)!==S.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(s.basename(u)),u=s.dirname(u)}for(let r=t.length-1;r>=0;r--){u=s.joinPath(u,t[r]);try{await o.mkdir(u)}catch(a){if((0,S.toFileSystemProviderErrorCode)(a)!==S.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,u){try{await this.doValidateDelete(o,u)}catch(t){return t}return!0}async doValidateDelete(o,u){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!u?.useTrash&&!(t.capabilities&4096))throw new Error((0,g.localize)(19,null,this.resourceForError(o)));let r;try{r=await t.stat(o)}catch(c){}if(r)this.throwIfFileIsReadonly(o,r);else throw new S.FileOperationError((0,g.localize)(20,null,this.resourceForError(o)),1);if(!!!u?.recursive){const c=await this.resolve(o);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,g.localize)(21,null,this.resourceForError(o)))}return t}async del(o,u){const t=await this.doValidateDelete(o,u),s=!!u?.useTrash,r=!!u?.recursive;await t.delete(o,{recursive:r,useTrash:s}),this._onDidRunOperation.fire(new S.FileOperationEvent(o,1))}onDidChangeFile(o,u){this._onDidChangeFilesRaw.fire({changes:o});let t,s;{for(const r of o)this.watchedResources.has(r.resource)?(t||(t=[]),t.push(r)):(s||(s=[]),s.push(r));t&&this._onDidFilesChange.fire(new S.FileChangesEvent(t,!u))}if(s){const r=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(s)&&Ve.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,u={recursive:!1,excludes:[]}){const t=new D.DisposableStore;{let s=!1,r=()=>{s=!0};t.add((0,D.toDisposable)(()=>r())),this.doWatch(o,u).then(a=>{s?(0,D.dispose)(a):r=()=>(0,D.dispose)(a)},a=>this.logService.error(a))}return u.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),t.add((0,D.toDisposable)(()=>{const s=this.watchedResources.get(o);typeof s=="number"&&(s<=1?this.watchedResources.delete(o):this.watchedResources.set(o,s-1))}))),t}async doWatch(o,u){const t=await this.withProvider(o),s=this.toWatchKey(t,o,u),r=this.activeWatchers.get(s)||{count:0,disposable:t.watch(o,u)};return this.activeWatchers.has(s)||this.activeWatchers.set(s,r),r.count+=1,(0,D.toDisposable)(()=>{r.count--,r.count===0&&((0,D.dispose)(r.disposable),this.activeWatchers.delete(s))})}toWatchKey(o,u,t){const{providerExtUri:s}=this.getExtUri(o);return[s.getComparisonKey(u),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>(0,D.dispose)(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,u,t,s){return this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(async()=>{const r=await o.open(u,{create:!0,unlock:t?.unlock??!1});try{(0,k.isReadableStream)(s)||(0,k.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(o,r,s):await this.doWriteReadableBufferedQueued(o,r,s)}catch(a){throw(0,S.ensureFileSystemProviderError)(a)}finally{await o.close(r)}})}async doWriteStreamBufferedQueued(o,u,t){let s=0,r;if((0,k.isReadableBufferedStream)(t)){if(t.buffer.length>0){const a=b.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,u,a,a.byteLength,s,0),s+=a.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise(async(a,c)=>{(0,k.listenStream)(r,{onData:async v=>{r.pause();try{await this.doWriteBuffer(o,u,v,v.byteLength,s,0)}catch(f){return c(f)}s+=v.byteLength,setTimeout(()=>r.resume())},onError:v=>c(v),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(o,u,t){let s=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(o,u,r,r.byteLength,s,0),s+=r.byteLength}async doWriteBuffer(o,u,t,s,r,a){let c=0;for(;c<s;)c+=await o.write(u,r+c,t.buffer,a+c,s-c)}async doWriteUnbuffered(o,u,t,s){return this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,u,t,s))}async doWriteUnbufferedQueued(o,u,t,s){let r;s instanceof b.VSBuffer?r=s:(0,k.isReadableStream)(s)?r=await(0,b.streamToBuffer)(s):(0,k.isReadableBufferedStream)(s)?r=await(0,b.bufferedStreamToBuffer)(s):r=(0,b.readableToBuffer)(s),await o.writeFile(u,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(o,u,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,u,t,s))}async doPipeBufferedQueued(o,u,t,s){let r,a;try{r=await o.open(u,{create:!1}),a=await t.open(s,{create:!0,unlock:!1});const c=b.VSBuffer.alloc(this.BUFFER_SIZE);let v=0,f=0,L=0;do L=await o.read(r,v,c.buffer,f,c.byteLength-f),await this.doWriteBuffer(t,a,c,L,v,f),v+=L,f+=L,f===c.byteLength&&(f=0);while(L>0)}catch(c){throw(0,S.ensureFileSystemProviderError)(c)}finally{await y.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,u,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,u,t,s))}async doPipeUnbufferedQueued(o,u,t,s){return t.writeFile(s,await o.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,u,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,u,t,s))}async doPipeUnbufferedToBufferedQueued(o,u,t,s){const r=await t.open(s,{create:!0,unlock:!1});try{const a=await o.readFile(u);await this.doWriteBuffer(t,r,b.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,S.ensureFileSystemProviderError)(a)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(o,u,t,s){const r=await(0,b.streamToBuffer)(this.readFileBuffered(o,u,d.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,r)}throwIfFileSystemIsReadonly(o,u){if(o.capabilities&2048)throw new S.FileOperationError((0,g.localize)(22,null,this.resourceForError(u)),6);return o}throwIfFileIsReadonly(o,u){if((u.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,g.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===w.Schemas.file?o.fsPath:o.toString(!0)}};l.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},l=ce([ee(0,i.ILogService)],l),e.FileService=l}),define(J[185],Z([0,1,2,19,5,3,18,8,15,30,9,6,143,92,165,167,164,174,64,95,36,17]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w,P,I,l,h,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends g.Disposable{constructor(r,a){super();this.logService=r,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=D.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new D.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,S.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:c}=await E.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,c),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await E.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),c=[];return await Promise.all(a.map(async v=>{try{let f;v.isSymbolicLink()?f=(await this.stat((0,p.joinPath)(r,v.name))).type:f=this.toType(v),c.push([v.name,f])}catch(f){this.logService.trace(f)}})),c}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let c;return a?.dangling?c=M.FileType.Unknown:r.isFile()?c=M.FileType.File:r.isDirectory()?c=M.FileType.Directory:c=M.FileType.Unknown,a&&(c|=M.FileType.SymbolicLink),c}async readFile(r){try{const a=this.toFilePath(r);return await E.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,c){const v=(0,l.newWriteableStream)(f=>u.VSBuffer.concat(f.map(L=>u.VSBuffer.wrap(L))).buffer);return(0,h.readFileIntoStream)(this,r,v,f=>f.buffer,{...a,bufferSize:this.BUFFER_SIZE},c),v}async writeFile(r,a,c){let v;try{const f=this.toFilePath(r);if(!c.create||!c.overwrite){if(await E.Promises.exists(f)){if(!c.overwrite)throw(0,M.createFileSystemProviderError)((0,k.localize)(0,null),M.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,M.createFileSystemProviderError)((0,k.localize)(1,null),M.FileSystemProviderErrorCode.FileNotFound)}v=await this.open(r,{create:!0,unlock:c.unlock}),await this.write(v,0,a,0,a.byteLength)}catch(f){throw await this.toFileSystemProviderWriteError(r,f)}finally{typeof v=="number"&&await this.close(v)}}async open(r,a){try{const c=this.toFilePath(r);if((0,M.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:L}=await E.SymlinkSupport.stat(c);L.mode&128||await E.Promises.chmod(c,L.mode|128)}catch(L){this.logService.trace(L)}let v;if((0,M.isFileOpenForWriteOptions)(a)){if(S.isWindows)try{await E.Promises.truncate(c,0),v="r+"}catch(L){L.code!=="ENOENT"&&this.logService.trace(L)}v||(v="w")}else v="r";const f=await E.Promises.open(c,v);return this.mapHandleToPos.set(f,0),(0,M.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(f,r),f}catch(c){throw(0,M.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,c):this.toFileSystemProviderError(c)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await E.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await E.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,c,v,f){const L=this.normalizePos(r,a);let T=null;try{const O=await E.Promises.read(r,c,v,f,L);return typeof O=="number"?T=O:T=O.bytesRead,T}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(r,L,T)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,c){const v=this.mapHandleToPos.get(r);typeof v=="number"&&(typeof a=="number"||(typeof c=="number"?this.mapHandleToPos.set(r,v+c):this.mapHandleToPos.delete(r)))}async write(r,a,c,v,f){return(0,i.retry)(()=>this.doWrite(r,a,c,v,f),100,3)}async doWrite(r,a,c,v,f){const L=this.normalizePos(r,a);let T=null;try{const O=await E.Promises.write(r,c,v,f,L);return typeof O=="number"?T=O:T=O.bytesWritten,T}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),O)}finally{this.updatePos(r,L,T)}}async mkdir(r){try{await E.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const c=this.toFilePath(r);await this.doDelete(c,a)}catch(c){throw this.toFileSystemProviderError(c)}}async doDelete(r,a){a.recursive?await E.Promises.rm(r,E.RimRafMode.MOVE):await E.Promises.unlink(r)}async rename(r,a,c){const v=this.toFilePath(r),f=this.toFilePath(a);if(v!==f)try{await this.validateTargetDeleted(r,a,"move",c.overwrite),await E.Promises.move(v,f)}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,k.localize)(2,null,(0,n.basename)(v),(0,n.basename)((0,n.dirname)(f)),L.toString()))),this.toFileSystemProviderError(L)}}async copy(r,a,c){const v=this.toFilePath(r),f=this.toFilePath(a);if(v!==f)try{await this.validateTargetDeleted(r,a,"copy",c.overwrite),await E.Promises.copy(v,f,{preserveSymlinks:!0})}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,k.localize)(3,null,(0,n.basename)(v),(0,n.basename)((0,n.dirname)(f)),L.toString()))),this.toFileSystemProviderError(L)}}async validateTargetDeleted(r,a,c,v){const f=this.toFilePath(r),L=this.toFilePath(a);let T=!1;if(!!(this.capabilities&1024)||(T=(0,m.isEqual)(f,L,!0)),T&&c==="copy")throw(0,M.createFileSystemProviderError)((0,k.localize)(4,null),M.FileSystemProviderErrorCode.FileExists);if(!T&&await E.Promises.exists(L)){if(!v)throw(0,M.createFileSystemProviderError)((0,k.localize)(5,null),M.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(r,a){return a.recursive?this.watchRecursive(r,a.excludes):this.watchNonRecursive(r)}watchRecursive(r,a){const c={path:this.toFilePath(r),excludes:a},v=(0,o.insert)(this.recursiveFoldersToWatch,c);return this.refreshRecursiveWatchers(),(0,g.toDisposable)(()=>{v(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof P.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,g.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,a;this.options?.watcher?.usePolling?(r=d.FileWatcher,a=this.options?.watcher):this.recursiveFoldersToWatch.length===1?S.isWindows?r=w.FileWatcher:r=d.FileWatcher:r=P.FileWatcher,this.recursiveWatcher=new r(this.recursiveFoldersToWatch,c=>this._onDidChangeFile.fire((0,y.toFileChanges)(c)),c=>{c.type==="error"&&this._onDidWatchErrorOccur.fire(c.message),this.logService[c.type](c.message)},this.logService.getLevel()===b.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))}}watchNonRecursive(r){const a=new I.FileWatcher(this.toFilePath(r),v=>this._onDidChangeFile.fire((0,y.toFileChanges)(v)),v=>{v.type==="error"&&this._onDidWatchErrorOccur.fire(v.message),this.logService[v.type](v.message)},this.logService.getLevel()===b.LogLevel.Trace),c=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)});return(0,g.combinedDisposable)(a,c)}toFilePath(r){return(0,n.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof M.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=M.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=M.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=M.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=M.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=M.FileSystemProviderErrorCode.NoPermissions;break;default:a=M.FileSystemProviderErrorCode.Unknown}return(0,M.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let c=this.toFileSystemProviderError(a);if(r&&c.code===M.FileSystemProviderErrorCode.NoPermissions)try{const{stat:v}=await E.SymlinkSupport.stat(this.toFilePath(r));v.mode&128||(c=(0,M.createFileSystemProviderError)(a,M.FileSystemProviderErrorCode.FileWriteLocked))}catch(v){this.logService.trace(v)}return c}dispose(){super.dispose(),(0,g.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,g.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(J[20],Z([0,1,4]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,g.createDecorator)("productService")}),define(J[186],Z([0,1,58,6,20]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let S=class{constructor(n,p){this.productService=n,this.logService=p,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,p){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(p);if(!m)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",p),!1;const[,i,b]=m;let k=this.trustedExtensionUrlPublicKeys.get(n);if(!k){if(k=this.productService.trustedExtensionUrlPublicKeys[n],!k||k.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...k])}const y=Buffer.from(decodeURIComponent(b),"base64");if(y.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",p),!1;const d=y.slice(0,6),w=y.readUIntBE(0,6),P=Date.now()-w;if(P<0||P>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",p),!1;const I=y.slice(6),l=g.createVerify("SHA256");l.write(d),l.write(Buffer.from(i)),l.end();for(let h=0;h<k.length;h++){let o=k[h];if(o!==null){if(typeof o=="string")try{o=g.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),k[h]=o}catch(u){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${n}:`,u),k[h]=null;continue}if(l.verify(o,I))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",p),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",p),!1}};S=ce([ee(0,D.IProductService),ee(1,M.ILogService)],S),e.ExtensionUrlTrustService=S}),define(J[55],Z([0,1,4]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,g.createDecorator)("protocolMainService")}),define(J[187],Z([0,1,2,10,7,48,14,6,37,3,15,28]),function(j,e,g,M,D,S,E,n,p,m,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let k=class extends g.Disposable{constructor(d,w){super();this.logService=w,this.validRoots=p.TernarySearchTree.forUris(()=>!m.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(D.URI.file(d.appRoot)),this.addValidFileRoot(D.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=E.session;d.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(w,P)=>this.handleResourceRequest(w,P)),d.protocol.interceptFileProtocol(M.Schemas.file,(w,P)=>this.handleFileRequest(w,P)),this._register((0,g.toDisposable)(()=>{d.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?g.Disposable.None:(this.validRoots.set(d,!0),(0,g.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,w){const P=D.URI.parse(d.url);return m.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${P.fsPath} from ${M.Schemas.file}: protocol (original URL: ${d.url})`),w({error:-3})):this.validRoots.findSubstr(P)?w({path:P.fsPath}):this.validExtensions.has((0,i.extname)(P))?w({path:P.fsPath}):(this.logService.error(`${M.Schemas.file}: Refused to load resource ${P.fsPath} from ${M.Schemas.file}: protocol (original URL: ${d.url})`),w({error:-3}))}handleResourceRequest(d,w){const P=D.URI.parse(d.url),I=M.FileAccess.asFileUri(P);return this.validRoots.findSubstr(I)?w({path:I.fsPath}):this.validExtensions.has((0,i.extname)(I))?w({path:I.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${I.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),w({error:-3}))}createIPCObjectUrl(){let d;const w=D.URI.from({scheme:"vscode",path:(0,b.generateUuid)()}),P=w.toString(),I=async()=>d;return E.ipcMain.handle(P,I),this.logService.trace(`IPC Object URL: Registered new channel ${P}.`),{resource:w,update:l=>d=l,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${P}.`),E.ipcMain.removeHandler(P)}}}};k=ce([ee(0,S.INativeEnvironmentService),ee(1,n.ILogService)],k),e.ProtocolMainService=k}),define(J[38],Z([0,1,13,103]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(E,n){M.ok(g.isString(E)),M.ok(g.isObject(n)),M.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,n)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new D}),define(J[188],Z([0,1,38,5]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class S{constructor(){this._onDidChangeSchema=new M.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(p,m){this.schemasById[D(p)]=m,this._onDidChangeSchema.fire(p)}notifySchemaChanged(p){this._onDidChangeSchema.fire(p)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new S;g.Registry.add(e.Extensions.JSONContribution,E)}),define(J[50],Z([0,1,133,5,38,13,188]),function(j,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var n;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(n=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var p;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const m=D.Registry.as(E.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:g.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(l,h=!0){this.registerConfigurations([l],h)}registerConfigurations(l,h=!0){const o=[];l.forEach(u=>{o.push(...this.validateAndRegisterProperties(u,h,u.extensionInfo)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(l){const h=[],o=u=>{if(u.properties)for(const t in u.properties)h.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,u.properties[t]);u.allOf&&u.allOf.forEach(t=>o(t))};for(const u of l){o(u);const t=this.configurationContributors.indexOf(u);t!==-1&&this.configurationContributors.splice(t,1)}m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}registerDefaultConfigurations(l){const h=[],o=[];for(const u of l)for(const t in u)if(h.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...u[t]};const s={type:"object",default:this.defaultValues[t],description:g.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};o.push(k(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.defaultValues[t]=u[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterDefaultConfigurations(l){const h=[];for(const o of l)for(const u in o)if(h.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const t=this.configurationProperties[u];t&&(this.updatePropertyDefaultValue(u,t),this.updateSchema(u,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const h of l)this.overrideIdentifiers.add(h);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(l,h=!0,o,u=3){u=S.isUndefinedOrNull(l.scope)?u:l.scope;let t=[],s=l.properties;if(s)for(let a in s){if(h&&w(a)){delete s[a];continue}const c=s[a];if(this.updatePropertyDefaultValue(a,c),e.OVERRIDE_PROPERTY_PATTERN.test(a)?c.scope=void 0:(c.scope=S.isUndefinedOrNull(c.scope)?u:c.scope,c.restricted=S.isUndefinedOrNull(c.restricted)?!!o?.restrictedConfigurations?.includes(a):c.restricted),s[a].hasOwnProperty("included")&&!s[a].included){this.excludedConfigurationProperties[a]=s[a],delete s[a];continue}else this.configurationProperties[a]=s[a];!s[a].deprecationMessage&&s[a].markdownDeprecationMessage&&(s[a].deprecationMessage=s[a].markdownDeprecationMessage),t.push(a)}let r=l.allOf;if(r)for(let a of r)t.push(...this.validateAndRegisterProperties(a,h,o,u));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(l){const h=o=>{let u=o.properties;if(u)for(const s in u)this.updateSchema(s,u[s]);let t=o.allOf;t&&t.forEach(h)};h(l)}updateSchema(l,h){switch(e.allSettings.properties[l]=h,h.scope){case 1:e.applicationSettings.properties[l]=h;break;case 2:e.machineSettings.properties[l]=h;break;case 6:e.machineOverridableSettings.properties[l]=h;break;case 3:e.windowSettings.properties[l]=h;break;case 4:e.resourceSettings.properties[l]=h;break;case 5:e.resourceSettings.properties[l]=h,this.resourceLanguageSettingsSchema.properties[l]=h;break}}removeFromSchema(l,h){switch(delete e.allSettings.properties[l],h.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const h=`[${l}]`,o={type:"object",description:g.localize(2,null),errorMessage:g.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(h,o),e.allSettings.properties[h]=o,e.applicationSettings.properties[h]=o,e.machineSettings.properties[h]=o,e.machineOverridableSettings.properties[h]=o,e.windowSettings.properties[h]=o,e.resourceSettings.properties[h]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,h){let o=this.defaultValues[l];S.isUndefined(o)&&(o=h.default),S.isUndefined(o)&&(o=y(h.type)),h.default=o}}const b="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(b);function k(I){return I.substring(1,I.length-1)}e.overrideIdentifierFromKey=k;function y(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const d=new i;D.Registry.add(e.Extensions.Configuration,d);function w(I){return I.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(I)?g.localize(5,null,I):d.getConfigurationProperties()[I]!==void 0?g.localize(6,null,I):null:g.localize(4,null)}e.validateProperty=w;function P(){const I=[],l=d.getConfigurationProperties();for(const h of Object.keys(l))I.push([h,l[h].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=P}),define(J[21],Z([0,1,44,13,7,38,4,50]),function(j,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,E.createDecorator)("configurationService");function p(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof D.URI)}e.isConfigurationOverrides=p;var m;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(m=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function b(s,r){const a=r?s?r.keys.filter(B=>s.keys.indexOf(B)===-1):[...r.keys]:[],c=s?r?s.keys.filter(B=>r.keys.indexOf(B)===-1):[...s.keys]:[],v=[];if(r&&s){for(const B of s.keys)if(r.keys.indexOf(B)!==-1){const q=I(s.contents,B),x=I(r.contents,B);g.equals(q,x)||v.push(B)}}const f=[],L=B=>{const q={};for(const x of B)for(const ie of x.identifiers)q[u(ie)]=x;return q},T=r?L(r.overrides):{},O=s?L(s.overrides):{};if(Object.keys(T).length)for(const B of a){const q=T[B];q&&f.push([(0,n.overrideIdentifierFromKey)(B),q.keys])}if(Object.keys(O).length)for(const B of c){const q=O[B];q&&f.push([(0,n.overrideIdentifierFromKey)(B),q.keys])}if(Object.keys(T).length&&Object.keys(O).length)for(const B of v){const q=O[B],x=T[B];if(q&&x){const ie=b({contents:q.contents,keys:q.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});f.push([(0,n.overrideIdentifierFromKey)(B),[...ie.added,...ie.removed,...ie.updated]])}}return{added:a,removed:c,updated:v,overrides:f}}e.compare=b;function k(s,r){const a=[];for(const c of Object.keys(s))if(n.OVERRIDE_PROPERTY_PATTERN.test(c)){const v={};for(const f in s[c])v[f]=s[c][f];a.push({identifiers:[(0,n.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(v),contents:y(v,r)})}return a}e.toOverrides=k;function y(s,r){const a=Object.create(null);for(let c in s)d(a,c,s[c],r);return a}e.toValuesTree=y;function d(s,r,a,c){const v=r.split("."),f=v.pop();let L=s;for(let T=0;T<v.length;T++){let O=v[T],B=L[O];switch(typeof B){case"undefined":B=L[O]=Object.create(null);break;case"object":break;default:c(`Ignoring ${r} as ${v.slice(0,T+1).join(".")} is ${JSON.stringify(B)}`);return}L=B}if(typeof L=="object"&&L!==null)try{L[f]=a}catch(T){c(`Ignoring ${r} as ${v.join(".")} is ${JSON.stringify(L)}`)}else c(`Ignoring ${r} as ${v.join(".")} is ${JSON.stringify(L)}`)}e.addToValueTree=d;function w(s,r){const a=r.split(".");P(s,a)}e.removeFromValueTree=w;function P(s,r){const a=r.shift();if(r.length===0){delete s[a];return}if(Object.keys(s).indexOf(a)!==-1){const c=s[a];typeof c=="object"&&!Array.isArray(c)&&(P(c,r),Object.keys(c).length===0&&delete s[a])}}function I(s,r,a){function c(L,T){let O=L;for(const B of T){if(typeof O!="object"||O===null)return;O=O[B]}return O}const v=r.split("."),f=c(s,v);return typeof f=="undefined"?a:f}e.getConfigurationValue=I;function l(s,r,a){Object.keys(r).forEach(c=>{c!=="__proto__"&&(c in s?M.isObject(s[c])&&M.isObject(r[c])?l(s[c],r[c],a):a&&(s[c]=r[c]):s[c]=r[c])})}e.merge=l;function h(){const s=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=h;function o(){const s=Object.create(null),r=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();for(let a in r){let c=r[a].default;d(s,a,c,v=>console.error(`Conflict in default settings: ${v}`))}return s}e.getDefaultValues=o;function u(s){return`[${s}]`}e.keyFromOverrideIdentifier=u;function t(s,r,a){const c=s.inspect(r),v=s.inspect(a);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:c.defaultValue}e.getMigratedSettingValue=t}),define(J[189],Z([0,1,40,37,36,13,44,7,50,21,38,2,5]),function(j,e,g,M,D,S,E,n,p,m,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(t={},s=[],r=[]){this._contents=t,this._keys=s,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,m.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const r=this.getContentsForOverrideIdentifer(s);return r?t?(0,m.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const a of D.distinct([...Object.keys(this.contents),...Object.keys(s)])){let c=this.contents[a],v=s[a];v&&(typeof c=="object"&&typeof v=="object"?(c=E.deepClone(c),this.mergeContents(c,v)):c=v),r[a]=c}return new y(r,this.keys,this.overrides)}merge(...t){const s=E.deepClone(this.contents),r=E.deepClone(this.overrides),a=[...this.keys];for(const c of t){this.mergeContents(s,c.contents);for(const v of c.overrides){const[f]=r.filter(L=>D.equals(L.identifiers,v.identifiers));f?this.mergeContents(f.contents,v.contents):r.push(E.deepClone(v))}for(const v of c.keys)a.indexOf(v)===-1&&a.push(v)}return new y(s,a,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const r of Object.keys(s)){if(r in t&&S.isObject(t[r])&&S.isObject(s[r])){this.mergeContents(t[r],s[r]);continue}t[r]=E.deepClone(s[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?E.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,m.addToValueTree)(this.contents,t,s,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,m.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let r=0;r<s;r++)t.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=y;class d extends y{constructor(){const t=(0,m.getDefaultValues)(),s=(0,m.getConfigurationKeys)(),r=[];for(const a of Object.keys(t))p.OVERRIDE_PROPERTY_PATTERN.test(a)&&r.push({identifiers:[(0,p.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(t[a]),contents:(0,m.toValuesTree)(t[a],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,s,r)}}e.DefaultConfigurationModel=d;class w{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!S.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:r,keys:a,overrides:c,restricted:v}=this.doParseRaw(t,s);this._configurationModel=new y(r,a,c),this._restrictedConfigurations=v||[]}doParseContent(t){let s={},r=null,a=[],c=[],v=[];function f(T){Array.isArray(a)?a.push(T):r&&(a[r]=T)}let L={onObjectBegin:()=>{let T={};f(T),c.push(a),a=T,r=null},onObjectProperty:T=>{r=T},onObjectEnd:()=>{a=c.pop()},onArrayBegin:()=>{let T=[];f(T),c.push(a),a=T,r=null},onArrayEnd:()=>{a=c.pop()},onLiteralValue:f,onError:(T,O,B)=>{v.push({error:T,offset:O,length:B})}};if(t)try{g.visit(t,L),s=a[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return s}doParseRaw(t,s){const r=i.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,r,!0,s);t=a.raw;const c=(0,m.toValuesTree)(t,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),v=Object.keys(t),f=(0,m.toOverrides)(t,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:c,keys:v,overrides:f,restricted:a.restricted}}filter(t,s,r,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:t,restricted:[]};const c={},v=[];for(let f in t)if(p.OVERRIDE_PROPERTY_PATTERN.test(f)&&r){const L=this.filter(t[f],s,!1,a);c[f]=L.raw,v.push(...L.restricted)}else{const L=s[f],T=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&v.push(f),(T===void 0||a.scopes===void 0||a.scopes.includes(T))&&(a.skipRestricted&&L?.restricted||(c[f]=t[f]))}return{raw:c,restricted:v}}}e.ConfigurationModelParser=w;class P extends b.Disposable{constructor(t,s,r,a){super();this.userSettingsResource=t,this.scopes=s,this.fileService=a,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(k.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class I{constructor(t,s,r=new y,a=new y,c=new M.ResourceMap,v=new y,f=new M.ResourceMap,L=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=a,this._folderConfigurations=c,this._memoryConfiguration=v,this._memoryConfigurationByResource=f,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(t,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(t)}updateValue(t,s,r={}){let a;r.resource?(a=this._memoryConfigurationByResource.get(r.resource),a||(a=new y,this._memoryConfigurationByResource.set(r.resource,a))):a=this._memoryConfiguration,s===void 0?a.removeValue(t):a.setValue(t,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,r){const a=this.getConsolidateConfigurationModel(s,r),c=this.getFolderConfigurationModelForResource(s.resource,r),v=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,f=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),L=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),T=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),O=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),B=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,q=c?s.overrideIdentifier?c.freeze().override(s.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,x=s.overrideIdentifier?v.override(s.overrideIdentifier).getValue(t):v.getValue(t),ie=a.getValue(t),V=D.distinct(D.flatten(a.overrides.map(Y=>Y.identifiers))).filter(Y=>a.getOverrideValue(t,Y)!==void 0);return{defaultValue:f,userValue:L,userLocalValue:T,userRemoteValue:O,workspaceValue:B,workspaceFolderValue:q,memoryValue:x,value:ie,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:B!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:q!==void 0?{value:c?.freeze().getValue(t),override:s.overrideIdentifier?c?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:v.getValue(t),override:s.overrideIdentifier?v.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=s.filter(a=>p.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const c=(0,p.overrideIdentifierFromKey)(a),v=this._defaultConfiguration.getKeysForOverrideIdentifier(c),f=t.getKeysForOverrideIdentifier(c),L=[...f.filter(T=>v.indexOf(T)===-1),...v.filter(T=>f.indexOf(T)===-1),...v.filter(T=>!E.equals(this._defaultConfiguration.override(c).getValue(T),t.override(c).getValue(T)))];return[c,L]});return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:a,overrides:c}=(0,m.compare)(this.localUserConfiguration,t),v=[...s,...r,...a];return v.length&&this.updateLocalUserConfiguration(t),{keys:v,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:a,overrides:c}=(0,m.compare)(this.remoteUserConfiguration,t);let v=[...s,...r,...a];return v.length&&this.updateRemoteUserConfiguration(t),{keys:v,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:a,overrides:c}=(0,m.compare)(this.workspaceConfiguration,t);let v=[...s,...r,...a];return v.length&&this.updateWorkspaceConfiguration(t),{keys:v,overrides:c}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:a,updated:c,removed:v,overrides:f}=(0,m.compare)(r,s);let L=[...a,...c,...v];return(L.length||!r)&&this.updateFolderConfiguration(t,s),{keys:L,overrides:f}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:a,removed:c,overrides:v}=(0,m.compare)(s,void 0);return{keys:[...r,...a,...c],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let r=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const a=s.getFolder(t);a&&(r=this.getFolderConsolidatedConfiguration(a.uri)||r);const c=this._memoryConfigurationByResource.get(t);c&&(r=r.merge(c))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(s=r.merge(a),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=r}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:r,overrides:a,keys:c}=this._folderConfigurations.get(s);return t.push([s,{contents:r,overrides:a,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(a=>s.add(a))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((v,f)=>(v.set(n.URI.revive(f[0]),this.parseConfigurationModel(f[1])),v),new M.ResourceMap);return new I(s,r,new y,a,c,new y,new M.ResourceMap,!1)}static parseConfigurationModel(t){return new y(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=I;function l(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const t=new Set,s=new Map;for(const a of u)a.keys.forEach(c=>t.add(c)),a.overrides.forEach(([c,v])=>{const f=(0,M.getOrSet)(s,c,new Set);v.forEach(L=>f.add(L))});const r=[];return s.forEach((a,c)=>r.push([c,[...a.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=l;class h{constructor(t,s,r,a){this.change=t,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=a,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(f=>c.add(f)),t.overrides.forEach(([,f])=>f.forEach(L=>c.add(L))),this.affectedKeys=[...c.values()];const v=new y;this.affectedKeys.forEach(f=>v.setValue(f,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!E.equals(r,a)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let r=(0,m.toValuesTree)({[s]:!0},()=>{}),a;for(;typeof r=="object"&&(a=Object.keys(r)[0]);){if(t=t[a],!t)return!1;r=r[a]}return!0}}e.ConfigurationChangeEvent=h;class o extends h{constructor(t,s,r,a){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=r,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=o}),define(J[190],Z([0,1,38,50,2,21,189,5,9,15]),function(j,e,g,M,D,S,E,n,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends D.Disposable{constructor(k,y){super();this.settingsResource=k,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,m.extUriBiasedIgnorePathCase,y)),this.configuration=new E.Configuration(new E.DefaultConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(M.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const k=await this.userConfiguration.loadConfiguration();this.configuration=new E.Configuration(new E.DefaultConfigurationModel,k)}getConfigurationData(){return this.configuration.toData()}getValue(k,y){const d=typeof k=="string"?k:void 0,w=(0,S.isConfigurationOverrides)(k)?k:(0,S.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(d,w,void 0)}updateValue(k,y,d,w){return Promise.reject(new Error("not supported"))}inspect(k){return this.configuration.inspect(k,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const k=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(k)}onDidChangeUserConfiguration(k){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(k);this.trigger(d,y,1)}onDidDefaultConfigurationChange(k){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new E.DefaultConfigurationModel,k);this.trigger(d,y,6)}trigger(k,y,d){const w=new E.ConfigurationChangeEvent(k,{data:y},this.configuration);w.source=d,w.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(k){switch(k){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(J[191],Z([0,1,4]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var M;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(E,n=M.Unknown,p){super(E);this._message=E,this._code=n,this._detail=p,this.isHandled=n===M.NotAvailable&&p===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(E){return E instanceof D&&E._code===M.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof D&&E._code===M.NoResolverFound}static isHandled(E){return E instanceof D&&E.isHandled}}e.RemoteAuthorityResolverError=D}),define(J[192],Z([0,1,84,28,2,17,5,191,16,9,25]),function(j,e,g,M,D,S,E,n,p,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var k;(function(_){_[_.Management=1]="Management",_[_.ExtensionHost=2]="ExtensionHost",_[_.Tunnel=3]="Tunnel"})(k=e.ConnectionType||(e.ConnectionType={}));function y(_){switch(_){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(_){const A=new i.CancellationTokenSource;return setTimeout(()=>A.cancel(),_),A.token}function w(_,A){if(_.isCancellationRequested||A.isCancellationRequested)return i.CancellationToken.Cancelled;const z=new i.CancellationTokenSource;return _.onCancellationRequested(()=>z.cancel()),A.onCancellationRequested(()=>z.cancel()),z.token}class P{constructor(A){this._state="pending",this._disposables=new D.DisposableStore,this.promise=new Promise((z,K)=>{this._resolvePromise=z,this._rejectPromise=K}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function I(_,A){const z=new P(A);return z.registerDisposable(_.onControlMessage(K=>{const X=JSON.parse(K.toString()),G=F(X);G?z.reject(G):z.resolve(X)})),z.promise}function l(_,A,z,K,X,G){const Q=new P(G);return A.connect(z,K,X,(ne,se)=>{Q.didTimeout?(ne&&_.error(ne),se?.dispose()):ne||!se?Q.reject(ne):Q.resolve(se)}),Q.promise}function h(_,A){const z=new P(A);return _.then(K=>{z.didTimeout||z.resolve(K)},K=>{z.didTimeout||z.reject(K)}),z.promise}async function o(_,A,z,K){const X=R(_,A);_.logService.trace(`${X} 1/6. invoking socketFactory.connect().`);let G;try{G=await l(_.logService,_.socketFactory,_.host,_.port,`reconnectionToken=${_.reconnectionToken}&reconnection=${_.reconnectionProtocol?"true":"false"}`,K)}catch(ue){throw _.logService.error(`${X} socketFactory.connect() failed or timed out. Error:`),_.logService.error(ue),ue}_.logService.trace(`${X} 2/6. socketFactory.connect() was successful.`);let Q,ne;_.reconnectionProtocol?(_.reconnectionProtocol.beginAcceptReconnection(G,null),Q=_.reconnectionProtocol,ne=!1):(Q=new g.PersistentProtocol(G,null),ne=!0),_.logService.trace(`${X} 3/6. sending AuthRequest control message.`);const se={type:"auth",auth:_.connectionToken||"00000000000000000000"};Q.sendControl(S.VSBuffer.fromString(JSON.stringify(se)));try{const ue=await I(Q,w(K,d(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const oe=new Error("Unexpected handshake message");throw oe.code="VSCODE_CONNECTION_ERROR",oe}_.logService.trace(`${X} 4/6. received SignRequest control message.`);const he=await h(_.signService.sign(ue.data),K),ve={type:"connectionType",commit:_.commit,signedData:he,desiredConnectionType:A};return z&&(ve.args=z),_.logService.trace(`${X} 5/6. sending ConnectionTypeRequest control message.`),Q.sendControl(S.VSBuffer.fromString(JSON.stringify(ve))),{protocol:Q,ownsProtocol:ne}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(_.logService.error(`${X} the handshake timed out. Error:`),_.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(_.logService.error(`${X} received error control message when negotiating connection. Error:`),_.logService.error(ue)),ne&&N(Q),ue}}async function u(_,A,z,K){const X=Date.now(),G=R(_,A),{protocol:Q,ownsProtocol:ne}=await o(_,A,z,K),se=new P(K);return se.registerDisposable(Q.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),ve=F(he);ve?(_.logService.error(`${G} received error control message when negotiating connection. Error:`),_.logService.error(ve),ne&&N(Q),se.reject(ve)):(_.reconnectionProtocol&&_.reconnectionProtocol.endAcceptReconnection(),_.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${C(X)}!`),se.resolve({protocol:Q,firstMessage:he}))})),se.promise}async function t(_,A){const{protocol:z}=await u(_,1,void 0,A);return{protocol:z}}async function s(_,A,z){const{protocol:K,firstMessage:X}=await u(_,2,A,z),G=X&&X.debugPort;return{protocol:K,debugPort:G}}async function r(_,A,z){const K=Date.now(),X=R(_,3),{protocol:G}=await o(_,3,A,z);return _.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${C(K)}!`),G}async function a(_,A,z){const{host:K,port:X,connectionToken:G}=await _.addressProvider.getAddress();return{commit:_.commit,host:K,port:X,connectionToken:G,reconnectionToken:A,reconnectionProtocol:z,socketFactory:_.socketFactory,signService:_.signService,logService:_.logService}}async function c(_,A,z){try{const K=(0,M.generateUuid)(),X=await a(_,K,null),{protocol:G}=await t(X,i.CancellationToken.None);return new Y(_,A,z,K,G)}catch(K){throw _.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),_.logService.error(K),V.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(K)),K}}e.connectRemoteAgentManagement=c;async function v(_,A){try{const z=(0,M.generateUuid)(),K=await a(_,z,null),{protocol:X,debugPort:G}=await s(K,A,i.CancellationToken.None);return new U(_,A,z,X,G)}catch(z){throw _.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),_.logService.error(z),V.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(z)),z}}e.connectRemoteAgentExtensionHost=v;async function f(_,A){const z=await a(_,(0,M.generateUuid)(),null);return await r(z,{port:A},i.CancellationToken.None)}e.connectRemoteAgentTunnel=f;function L(_){return(0,m.createCancelablePromise)(A=>new Promise((z,K)=>{const X=setTimeout(z,_*1e3);A.onCancellationRequested(()=>{clearTimeout(X),z()})}))}var T;(function(_){_[_.ConnectionLost=0]="ConnectionLost",_[_.ReconnectionWait=1]="ReconnectionWait",_[_.ReconnectionRunning=2]="ReconnectionRunning",_[_.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",_[_.ConnectionGain=4]="ConnectionGain"})(T=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class O{constructor(A,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=z,this.type=0}}e.ConnectionLostEvent=O;class B{constructor(A,z,K,X){this.reconnectionToken=A,this.millisSinceLastIncomingData=z,this.durationSeconds=K,this.cancellableTimer=X,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=B;class q{constructor(A,z,K){this.reconnectionToken=A,this.millisSinceLastIncomingData=z,this.attempt=K,this.type=2}}e.ReconnectionRunningEvent=q;class x{constructor(A,z,K){this.reconnectionToken=A,this.millisSinceLastIncomingData=z,this.attempt=K,this.type=4}}e.ConnectionGainEvent=x;class ie{constructor(A,z,K,X){this.reconnectionToken=A,this.millisSinceLastIncomingData=z,this.attempt=K,this.handled=X,this.type=3}}e.ReconnectionPermanentFailureEvent=ie;class V extends D.Disposable{constructor(A,z,K,X){super();this._connectionType=A,this._onDidStateChange=this._register(new E.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=z,this.reconnectionToken=K,this.protocol=X,this._isReconnecting=!1,this._onDidStateChange.fire(new x(this.reconnectionToken,0,0)),this._register(X.onSocketClose(G=>{const Q=W(this._connectionType,this.reconnectionToken,!0);G?G.type===0?(this._options.logService.info(`${Q} received socket close event (hadError: ${G.hadError}).`),G.error&&this._options.logService.error(G.error)):(this._options.logService.info(`${Q} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this._options.logService.error(G.event)):this._options.logService.info(`${Q} received socket close event.`),this._beginReconnecting()})),this._register(X.onSocketTimeout(()=>{const G=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${G} received socket timeout event.`),this._beginReconnecting()})),V._instances.push(this),V._permanentFailure&&this._gotoPermanentFailure(V._permanentFailureMillisSinceLastIncomingData,V._permanentFailureAttempt,V._permanentFailureHandled)}static triggerPermanentFailure(A,z,K){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=z,this._permanentFailureHandled=K,this._instances.forEach(X=>X._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(V._permanentFailure)return;const A=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const z=[0,5,5,10,10,10,10,10,30];let K=-1;do{K++;const X=K<z.length?z[K]:z[z.length-1];try{if(X>0){const Q=L(X);this._onDidStateChange.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X,Q)),this._options.logService.info(`${A} waiting for ${X} seconds before reconnecting...`);try{await Q}catch{}}if(V._permanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K+1)),this._options.logService.info(`${A} resolving connection...`);const G=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${G.host}:${G.port}...`),await this._reconnect(G,d(b)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K+1));break}catch(G){if(G.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(G),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),K+1,!1);break}if(K>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(G),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),K+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(G)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((G.code==="ETIMEDOUT"||G.code==="ENETUNREACH"||G.code==="ECONNREFUSED"||G.code==="ECONNRESET")&&G.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((0,p.isPromiseCanceledError)(G)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if(G instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(G),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),K+1,n.RemoteAuthorityResolverError.isHandled(G));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(G),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),K+1,!1);break}}while(!V._permanentFailure)}_gotoPermanentFailure(A,z,K){this._onDidStateChange.fire(new ie(this.reconnectionToken,A,z,K)),N(this.protocol)}}V._permanentFailure=!1,V._permanentFailureMillisSinceLastIncomingData=0,V._permanentFailureAttempt=0,V._permanentFailureHandled=!1,V._instances=[];class Y extends V{constructor(A,z,K,X,G){super(1,A,X,G);this.client=this._register(new g.Client(G,{remoteAuthority:z,clientId:K},A.ipcLogger))}async _reconnect(A,z){await t(A,z)}}e.ManagementPersistentConnection=Y;class U extends V{constructor(A,z,K,X,G){super(2,A,K,X);this._startArguments=z,this.debugPort=G}async _reconnect(A,z){await s(A,this._startArguments,z)}}e.ExtensionHostPersistentConnection=U;function N(_){try{_.acceptDisconnect();const A=_.getSocket();_.dispose(),A.dispose()}catch(A){(0,p.onUnexpectedError)(A)}}function F(_){if(_&&_.type==="error"){const A=new Error(`Connection error: ${_.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function $(_,A){for(;_.length<A;)_+=" ";return _}function W(_,A,z){return`[remote-connection][${$(y(_),13)}][${A.substr(0,5)}\u2026][${z?"reconnect":"initial"}]`}function R(_,A){return`${W(A,_.reconnectionToken,!!_.reconnectionProtocol)}[${_.host}:${_.port}]`}function C(_){return`${Date.now()-_} ms`}}),define(J[73],Z([0,1,10]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(m){return m.scheme===g.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=M;function D(m){if(!m)return;const i=m.indexOf("+");return i<0?m:m.substr(0,i)}e.getRemoteName=D;function S(m){return m.scheme!==g.Schemas.file&&m.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=S;function E(m){if(m.folders.length)return m.folders.every(i=>S(i.uri))?m.folders[0].uri:void 0;if(m.configuration&&S(m.configuration))return m.configuration}e.getVirtualWorkspaceLocation=E;function n(m){return E(m)?.scheme}e.getVirtualWorkspaceScheme=n;function p(m){return E(m)!==void 0}e.isVirtualWorkspace=p}),define(J[74],Z([0,1,5,3,4,6]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService");var E;(function(y){y.Http="http",y.Https="https"})(E=e.TunnelProtocol||(e.TunnelProtocol={}));var n;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(n=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function p(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=p,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=m,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=i;function b(y,d){return d?d!==1&&y<1024:!M.isWindows&&y<1024}e.isPortPrivileged=b;let k=class{constructor(d){this.logService=d,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d,w){return this._tunnelProvider=d,d?(this._canElevate=w.elevation,this._canMakePublic=w.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async d=>{const w=[],P=Array.from(this._tunnels.values());for(let I of P){const l=Array.from(I.values());for(let h of l){const o=await h.value;o&&w.push(o)}}d(w)})}async dispose(){for(const d of this._tunnels.values()){for(const{value:w}of d.values())await w.then(P=>P?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,w,P,I,l=!1,h=!1,o){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${w}:${P} on local port ${I}.`),!d)return;w||(w="localhost");const u=this.retainOrCreateTunnel(d,w,P,I,l,h,o);return u?u.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(w,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(t);return(t.tunnelRemoteHost!==w||t.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,public:d.public,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const w=this._tunnels.get(d.tunnelRemoteHost);if(w){const P=w.get(d.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,P))}}}}async tryDisposeTunnel(d,w,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${w}.`);const I=P.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(w),I}}async closeTunnel(d,w){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${w} `);const P=this._tunnels.get(d);if(P&&P.has(w)){const I=P.get(w);I.refcount=0,await this.tryDisposeTunnel(d,w,I)}}addTunnelToMap(d,w,P){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(w,{refcount:1,value:P})}async removeEmptyTunnelFromMap(d,w){const P=this._tunnels.get(d);P&&(await P.get(w)||P.delete(w),P.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,w){let P=[d];m(d)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):i(d)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const I=P.map(l=>this._tunnels.get(l));for(const l of I){const h=l?.get(w);if(h)return h}}canTunnel(d){return!!p(d)}createWithProvider(d,w,P,I,l,h,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${w}:${P} on local port ${I}.`);const t={elevationRequired:l?b(I===void 0?P:I):!1},s={remoteAddress:{host:w,port:P},localAddressPort:I,public:h,protocol:o},r=d.forwardPort(s,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(w,P,r),r}};k=ce([ee(0,S.ILogService)],k),e.AbstractTunnelService=k}),define(J[51],Z([0,1,147,4,50,38,17]),function(j,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function n(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=n;function p(d){return d.res.statusCode===204}async function m(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);return p(d)?null:(await(0,E.streamToBuffer)(d.stream)).toString()}e.asText=m;async function i(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);if(p(d))return null;const P=(await(0,E.streamToBuffer)(d.stream)).toString();try{return JSON.parse(P)}catch(I){throw I.message+=`:
`+P,I}}e.asJson=i;function b(d){y(d)}e.updateProxyConfigurationsScope=b;let k;function y(d){const w=S.Registry.as(D.Extensions.Configuration);k&&w.deregisterConfigurations([k]),k={id:"http",order:15,title:(0,g.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,g.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,g.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,g.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,g.localize)(4,null),(0,g.localize)(5,null),(0,g.localize)(6,null),(0,g.localize)(7,null)],default:"override",description:(0,g.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,g.localize)(9,null),restricted:!0}}},w.registerConfiguration(k)}y(2)}),define(J[193],Z([0,1,194,13]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(E,n){return E.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:E.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function S(E,n,p={}){const m=(0,g.parse)(E),i=p.proxyUrl||D(m,n);if(!i)return null;const b=(0,g.parse)(i);if(!/^https?:$/.test(b.protocol||""))return null;const k={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,M.isBoolean)(p.strictSSL)?p.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((y,d)=>{j(["http-proxy-agent"],y,d)}))(k):new(await new Promise((y,d)=>{j(["https-proxy-agent"],y,d)}))(k)}e.getProxyAgent=S}),define(J[195],Z([0,1,28,17]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(S,E,n){let p=n&&n.get("storage.serviceMachineId",0)||null;if(p)return p;try{const i=(await E.readFile(S.serviceMachineIdResource)).value.toString();p=(0,g.isUUID)(i)?i:null}catch(m){p=null}if(!p){p=(0,g.generateUuid)();try{await E.writeFile(S.serviceMachineIdResource,M.VSBuffer.fromString(p))}catch(m){}}return n&&n.store("storage.serviceMachineId",p,0,1),p}e.getServiceMachineId=D}),define(J[75],Z([0,1,4]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,g.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[196],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{vsda(){return new Promise((D,S)=>j(["vsda"],D,S))}async sign(D){try{const S=await this.vsda(),E=new S.signer;if(E)return E.sign(D)}catch(S){}return D}}e.SignService=g}),define(J[39],Z([0,1,4]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,g.createDecorator)("stateMainService")}),define(J[22],Z([0,1,14,6,39,5,4,178,3,2,9,13,33]),function(j,e,g,M,D,S,E,n,p,m,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,E.createDecorator)("lifecycleMainService");var y;(function(w){w[w.Starting=1]="Starting",w[w.Ready=2]="Ready",w[w.AfterWindowOpen=3]="AfterWindowOpen"})(y=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let d=class at extends m.Disposable{constructor(P,I){super();this.logService=P,this.stateMainService=I,this._onBeforeShutdown=this._register(new S.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new S.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new S.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new S.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new S.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(at.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(at.QUIT_AND_RESTART_KEY)}registerListeners(){const P=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),p.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};g.app.addListener("before-quit",P);const I=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!p.isMacintosh)&&g.app.quit()};g.app.addListener("window-all-closed",I),g.app.once("will-quit",l=>{this.logService.trace("Lifecycle#app.on(will-quit)"),l.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),g.app.removeListener("before-quit",P),g.app.removeListener("window-all-closed",I),g.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const P=[];return this._onWillShutdown.fire({join(I){P.push(I)}}),this.pendingWillShutdownPromise=(async()=>{try{await i.Promises.settled(P)}catch(I){this.logService.error(I)}try{await this.stateMainService.close()}catch(I){this.logService.error(I)}})(),this.pendingWillShutdownPromise}set phase(P){if(P<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===P)return;this.logService.trace(`lifecycle (main): phase changed (value: ${P})`),this._phase=P;const I=this.phaseWhen.get(this._phase);I&&(I.open(),this.phaseWhen.delete(this._phase))}async when(P){if(P<=this._phase)return;let I=this.phaseWhen.get(P);I||(I=new i.Barrier,this.phaseWhen.set(P,I)),await I.wait()}registerWindow(P){const I=new m.DisposableStore;this.windowCounter++,I.add(P.onWillLoad(h=>this._onWillLoadWindow.fire({window:P,workspace:h.workspace,reason:h.reason})));const l=(0,b.assertIsDefined)(P.win);l.on("close",h=>{const o=P.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${P.id}`),h.preventDefault(),this.unload(P,1).then(u=>{if(u){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(P),P.close()})}),l.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${P.id}`),this.windowCounter--,I.dispose(),this.windowCounter===0&&(!p.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(P,I){await this.unload(P,3)||P.reload(I)}async unload(P,I){if(!P.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${P.id}`);const l=this._quitRequested?2:I;let h=await this.onBeforeUnloadWindowInRenderer(P,l);return h?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${P.id})`),this.handleWindowUnloadVeto(h)):(h=await this.onBeforeUnloadWindowInMain(P,l),h?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${P.id})`),this.handleWindowUnloadVeto(h)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${P.id})`),await this.onWillUnloadWindowInRenderer(P,l),!1))}handleWindowUnloadVeto(P){return P?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(P){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(P),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(P,I){return new Promise(l=>{const h=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${h}`,u=`vscode:cancel${h}`;g.ipcMain.once(o,()=>{l(!1)}),g.ipcMain.once(u,()=>{l(!0)}),P.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:u,reason:I})})}onBeforeUnloadWindowInMain(P,I){const l=[];return this._onBeforeUnloadWindow.fire({reason:I,window:P,veto(h){l.push(h)}}),(0,n.handleVetos)(l,h=>this.logService.error(h))}onWillUnloadWindowInRenderer(P,I){return new Promise(l=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;g.ipcMain.once(o,()=>l()),P.send("vscode:onWillUnload",{replyChannel:o,reason:I})})}quit(P){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${P}`),P&&this.stateMainService.setItem(at.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(I=>{this.pendingQuitPromiseResolve=I,this.logService.trace("Lifecycle#quit() - calling app.quit()"),g.app.quit()}),this.pendingQuitPromise)}async relaunch(P){this.logService.trace("Lifecycle#relaunch()");const I=process.argv.slice(1);if(P?.addArgs&&I.push(...P.addArgs),P?.removeArgs)for(const o of P.removeArgs){const u=I.indexOf(o);u>=0&&I.splice(u,1)}const l=()=>{try{if(p.isWindows){const o=(0,k.cwd)();o!==process.cwd()&&process.chdir(o)}}catch(o){this.logService.error(o)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),g.app.relaunch({args:I})};g.app.once("quit",l),await this.quit(!0)&&g.app.removeListener("quit",l)}async kill(P){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,i.timeout)(1e3),(async()=>{for(const I of g.BrowserWindow.getAllWindows())if(I&&!I.isDestroyed()){let l;I.webContents&&!I.webContents.isDestroyed()?l=new Promise(h=>I.once("closed",h)):l=Promise.resolve(),I.destroy(),await l}})()]),g.app.exit(P)}};d.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",d=ce([ee(0,M.ILogService),ee(1,D.IStateMainService)],d),e.LifecycleMainService=d}),define(J[197],Z([0,1,4,5,2,22]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,g.createDecorator)("keyboardLayoutMainService");let E=class extends D.Disposable{constructor(m){super();this._onDidChangeKeyboardLayout=this._register(new M.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,m.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const m=await new Promise((i,b)=>{j(["native-keymap"],i,b)});this._keyboardLayoutData=n(m),m.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(m),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};E=ce([ee(0,S.ILifecycleMainService)],E),e.KeyboardLayoutMainService=E;function n(p){const m=p.getKeyMap(),i=p.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:i}}}),define(J[96],Z([0,1,4,5,2,13,86,9]),function(j,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const p="__$__targetStorageMarker";e.IStorageService=(0,g.createDecorator)("storageService");var m;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(m=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(w){w[w.GLOBAL=0]="GLOBAL",w[w.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var b;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));class k extends D.Disposable{constructor(P={flushInterval:k.DEFAULT_FLUSH_INTERVAL}){super();this.options=P,this._onDidChangeValue=this._register(new M.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new M.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new M.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,n.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(P,I){I===p?(P===0?this._globalKeyTargets=void 0:P===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:P})):this._onDidChangeValue.fire({scope:P,key:I,target:this.getKeyTargets(P)[I]})}emitWillSaveState(P){this._onWillSaveState.fire({reason:P})}get(P,I,l){return this.getStorage(I)?.get(P,l)}getBoolean(P,I,l){return this.getStorage(I)?.getBoolean(P,l)}getNumber(P,I,l){return this.getStorage(I)?.getNumber(P,l)}store(P,I,l,h){if((0,S.isUndefinedOrNull)(I)){this.remove(P,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(P,l,h),this.getStorage(l)?.set(P,I)})}remove(P,I){this.withPausedEmitters(()=>{this.updateKeyTarget(P,I,void 0),this.getStorage(I)?.delete(P)})}withPausedEmitters(P){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{P()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(P,I){const l=[],h=this.getKeyTargets(P);for(const o of Object.keys(h))h[o]===I&&l.push(o);return l}updateKeyTarget(P,I,l){const h=this.getKeyTargets(I);typeof l=="number"?h[P]!==l&&(h[P]=l,this.getStorage(I)?.set(p,JSON.stringify(h))):typeof h[P]=="number"&&(delete h[P],this.getStorage(I)?.set(p,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(P){return P===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(P){const I=this.get(p,P);if(I)try{return JSON.parse(I)}catch(l){}return Object.create(null)}isNew(P){return this.getBoolean(e.IS_NEW_KEY,P)===!0}async flush(){this._onWillSaveState.fire({reason:m.NONE}),await n.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const P=this.getStorage(0)?.items??new Map,I=this.getStorage(1)?.items??new Map;return d(P,I,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=k,k.DEFAULT_FLUSH_INTERVAL=60*1e3;class y extends k{constructor(){super();this.globalStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new E.Storage(new E.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(P=>this.emitDidChangeValue(1,P))),this._register(this.globalStorage.onDidChangeStorage(P=>this.emitDidChangeValue(0,P)))}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(P){}}e.InMemoryStorageService=y;async function d(w,P,I,l){const h=c=>{try{return JSON.parse(c)}catch(v){return c}},o=new Map,u=new Map;w.forEach((c,v)=>{o.set(v,c),u.set(v,h(c))});const t=new Map,s=new Map;P.forEach((c,v)=>{t.set(v,c),s.set(v,h(c))}),console.group(`Storage: Global (path: ${I})`);let r=[];o.forEach((c,v)=>{r.push({key:v,value:c})}),console.table(r),console.groupEnd(),console.log(u),console.group(`Storage: Workspace (path: ${l})`);let a=[];t.forEach((c,v)=>{a.push({key:v,value:c})}),console.table(a),console.groupEnd(),console.log(s)}e.logStorage=d}),define(J[198],Z([0,1,3,33,28,7]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function E(m){if(g.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function n(m,i,b,k,y,d,w,P,I,l){const h=Object.create(null);h["common.machineId"]=w,h.sessionID=(0,D.generateUuid)()+Date.now(),h.commitHash=y,h.version=d,h["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,g.PlatformToString)(g.platform),h["common.nodePlatform"]=M.platform,h["common.nodeArch"]=k,h["common.product"]=l||"desktop";const o=p(P||[]);o&&(h["common.msftInternal"]=o);let u=0;const t=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),g.isLinuxSnap&&(h["common.snap"]="true");const s=E(b);s&&(h["common.platformDetail"]=s);try{const r=await m.readFile(S.URI.file(I));h["common.source"]=r.value.toString().slice(0,30)}catch(r){}return h}e.resolveCommonProperties=n;function p(m){const i=M.env.USERDNSDOMAIN;if(!i)return!1;const b=i.toLowerCase();return m.some(k=>b===k)}e.verifyMicrosoftInternalDomain=p}),define(J[32],Z([0,1,4]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,g.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,g.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(J[199],Z([0,1,26,66,70,8,40,83,20,3,7,32,63,10,19,18]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function P(u,t){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,a=new Map,c=2e4;function v(T,O,B,q){const x=O.substring(T.length+1);return new Promise(async ie=>{let V;try{V=await w.Promises.readdir(O,{withFileTypes:!0})}catch(N){ie();return}if(q.count>=c){q.count+=V.length,q.maxReached=!0,ie();return}let Y=V.length;if(Y===0){ie();return}let U=V;q.count+V.length>c&&(q.maxReached=!0,Y=c-q.count,U=V.slice(0,Y)),q.count+=V.length;for(const N of U)if(N.isDirectory()){if(B.includes(N.name)||await v(T,(0,S.join)(O,N.name),B,q),--Y==0){ie();return}}else{const F=N.name.lastIndexOf(".");if(F>=0){const $=N.name.substring(F+1);$&&r.set($,(r.get($)??0)+1)}for(const $ of s)$.relativePathPattern?.test(x)!==!1&&$.filePattern.test(N.name)&&a.set($.tag,(a.get($.tag)??0)+1);if(--Y==0){ie();return}}})}const f={count:0,maxReached:!1};await v(u,u,t,f);const L=await h(u);return{configFiles:I(a),fileTypes:I(r),fileCount:f.count,maxFilesReached:f.maxReached,launchConfigFiles:L}}e.collectWorkspaceStats=P;function I(u){return[...k.Iterable.map(u.entries(),([t,s])=>({name:t,count:s}))].sort((t,s)=>s.count-t.count)}function l(){const u={os:`${g.type()} ${g.arch()} ${g.release()}`,memory:`${(g.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(g.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(M.virtualMachineHint.value()*100)}%`},t=g.cpus();return t&&t.length>0&&(u.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),u}e.getMachineInfo=l;async function h(u){try{const t=new Map,s=(0,S.join)(u,".vscode","launch.json"),r=await w.Promises.readFile(s),a=[],c=(0,E.parse)(r.toString(),a);if(a.length)return console.log(`Unable to parse ${s}`),[];if((0,E.getNodeType)(c)==="object"&&c.configurations)for(const v of c.configurations){const f=v.type;f&&(t.has(f)?t.set(f,t.get(f)+1):t.set(f,1))}return I(t)}catch(t){return[]}}e.collectLaunchConfigs=h;let o=class{constructor(t,s){this.telemetryService=t,this.productService=s}formatMachineInfo(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}formatEnvironment(t){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${g.type()} ${g.arch()} ${g.release()}`);const r=g.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(g.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(g.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),m.isWindows||s.push(`Load (avg):       ${g.loadavg().map(a=>Math.round(a)).join(", ")}`),s.push(`VM:               ${Math.round(M.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,n.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async r=>{let[a,c]=r,v=this.formatProcessList(t,a);return s.forEach(f=>{if((0,D.isRemoteDiagnosticError)(f))v+=`
${f.errorMessage}`,c+=`
${f.errorMessage}`;else if(v+=`

Remote: ${f.hostName}`,f.processes&&(v+=`
${this.formatProcessList(t,f.processes)}`),f.workspaceMetadata){c+=`
|  Remote: ${f.hostName}`;for(const L of Object.keys(f.workspaceMetadata)){const T=f.workspaceMetadata[L];let O=`${T.fileCount} files`;T.maxFilesReached&&(O=`more than ${O}`),c+=`|    Folder (${L}): ${O}`,c+=this.formatWorkspaceStats(T)}}}),{processInfo:v,workspaceInfo:c}})}async getSystemInfo(t,s){const{memory:r,vmHint:a,os:c,cpus:v}=l(),f={os:c,memory:r,cpus:v,vmHint:a,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return m.isWindows||(f.load=`${g.loadavg().map(L=>Math.round(L)).join(", ")}`),m.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(t,s){const r=[];return(0,n.listProcesses)(t.mainPID).then(async a=>(r.push(""),r.push(this.formatEnvironment(t)),r.push(""),r.push(this.formatProcessList(t,a)),t.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(t))),s.forEach(c=>{if((0,D.isRemoteDiagnosticError)(c))r.push(`
${c.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${c.hostName}`),r.push(this.formatMachineInfo(c.machineInfo)),c.processes&&r.push(this.formatProcessList(t,c.processes)),c.workspaceMetadata)for(const v of Object.keys(c.workspaceMetadata)){const f=c.workspaceMetadata[v];let L=`${f.fileCount} files`;f.maxFilesReached&&(L=`more than ${L}`),r.push(`Folder (${v}): ${L}`),r.push(this.formatWorkspaceStats(f))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(t){const s=[],r=60;let a=0;const c=(T,O)=>{const B=` ${T}(${O})`;a+B.length>r?(s.push(v),v="|                 ",a=v.length):a+=B.length,v+=B};let v="|      File types:";const f=10;let L=t.fileTypes.length>f?f:t.fileTypes.length;for(let T=0;T<L;T++){const O=t.fileTypes[T];c(O.name,O.count)}if(s.push(v),t.configFiles.length>=0&&(v="|      Conf files:",a=0,t.configFiles.forEach(T=>{c(T.name,T.count)}),s.push(v)),t.launchConfigFiles.length>0){let T="|      Launch Configs:";t.launchConfigFiles.forEach(O=>{T+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),s.push(T)}return s.join(`
`)}expandGPUFeatures(t){const s=Math.max(...Object.keys(t).map(r=>r.length));return Object.keys(t).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${t[r]}`).join(`
                  `)}formatWorkspaceMetadata(t){const s=[],r=[];return t.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(s.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const v=i.URI.revive(c);if(v.scheme===y.Schemas.file){const f=v.fsPath;r.push(P(f,["node_modules",".git"]).then(L=>{let T=`${L.fileCount} files`;L.maxFilesReached&&(T=`more than ${T}`),s.push(`|    Folder (${(0,S.basename)(f)}): ${T}`),s.push(this.formatWorkspaceStats(L))}).catch(L=>{s.push(`|      Error: Unable to collect workspace stats for folder ${f} (${L.toString()})`)}))}else s.push(`|    Folder (${v.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(a=>s.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(t,s){const r=new Map;t.windows.forEach(c=>r.set(c.pid,c.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(t.mainPID,r,a,s,0),a.join(`
`)}formatProcessItem(t,s,r,a,c){const v=c===0;let f;v?f=a.pid===t?`${this.productService.applicationName} main`:"remote agent":(f=`${"  ".repeat(c)} ${a.name}`,a.name==="window"&&(f=`${f} (${s.get(a.pid)})`));const L=process.platform==="win32"?a.mem:g.totalmem()*(a.mem/100);r.push(`${a.load.toFixed(0).padStart(5," ")}	${(L/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(a.children)&&a.children.forEach(T=>this.formatProcessItem(t,s,r,T,c+1))}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const r=i.URI.revive(s);if(r.scheme!==y.Schemas.file)continue;const a=r.fsPath;try{const c=await P(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),c.fileTypes.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:v.name,count:v.count})}),c.launchConfigFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:v.name,count:v.count})}),c.configFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:v.name,count:v.count})})}catch{}}}};o=ce([ee(0,b.ITelemetryService),ee(1,p.IProductService)],o),e.DiagnosticsService=o}),define(J[200],Z([0,1,16,169,172,44,32,51,163,48,25,6,19,7,20,96,195,4]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var l;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished"})(l||(l={}));function h(...N){return String(N.reduce((F,$)=>F|$,0))}var o;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const u={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},t={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},r={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:l.None,criteria:[],assetTypes:[]};class a{constructor(F=r){this.state=F}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(F,$=this.state.pageSize){return new a({...this.state,pageNumber:F,pageSize:$})}withFilter(F,...$){const W=[...this.state.criteria,...$.length?$.map(R=>({filterType:F,value:R})):[{filterType:F}]];return new a({...this.state,criteria:W})}withSortBy(F){return new a({...this.state,sortBy:F})}withSortOrder(F){return new a({...this.state,sortOrder:F})}withFlags(...F){return new a({...this.state,flags:F.reduce(($,W)=>$|W,0)})}withAssetTypes(...F){return new a({...this.state,assetTypes:F})}get raw(){const{criteria:F,pageNumber:$,pageSize:W,sortBy:R,sortOrder:C,flags:_,assetTypes:A}=this.state;return{filters:[{criteria:F,pageNumber:$,pageSize:W,sortBy:R,sortOrder:C}],assetTypes:A,flags:_}}get searchText(){const F=this.state.criteria.filter($=>$.filterType===o.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(F=>String(F.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function c(N,F){const $=(N||[]).filter(W=>W.statisticName===F)[0];return $?$.value:0}function v(N){const F="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(W=>W.assetType.indexOf(F)===0).reduce((W,R)=>{const C=O(N,R.assetType);return C&&W.push([R.assetType.substring(F.length),C]),W},[])}function f(N){if(N.properties){const F=N.properties.filter(R=>R.key===u.Repository),$=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=F.filter(R=>$.test(R.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return O(N,u.Repository)}function L(N){return{uri:`${N.fallbackAssetUri}/${u.VSIX}?redirect=true`,fallbackUri:`${N.fallbackAssetUri}/${u.VSIX}`}}function T(N){const F=O(N,u.Icon);if(F)return F;const $=M.DefaultIconPath;return{uri:$,fallbackUri:$}}function O(N,F){return N.files.filter(W=>W.assetType===F)[0]?{uri:`${N.assetUri}/${F}`,fallbackUri:`${N.fallbackAssetUri}/${F}`}:null}function B(N,F){const $=N.properties?N.properties.filter(R=>R.key===F):[],W=$.length>0&&$[0].value;return W?W.split(",").map(R=>(0,D.adoptToGalleryExtensionId)(R)):[]}function q(N){const F=N.properties?N.properties.filter($=>$.key===t.Engine):[];return F.length>0&&F[0].value||""}function x(N){const F=N.properties?N.properties.filter(W=>W.key===t.LocalizedLanguages):[],$=F.length>0&&F[0].value||"";return $?$.split(","):[]}function ie(N){return N.indexOf("preview")!==-1}function V(N,F,$,W,R){const C={manifest:O(F,u.Manifest),readme:O(F,u.Details),changelog:O(F,u.Changelog),license:O(F,u.License),repository:f(F),download:L(F),icon:T(F),coreTranslations:v(F)};return{identifier:{id:(0,D.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:F.version,date:F.lastUpdated,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,description:N.shortDescription||"",installCount:c(N.statistics,"install"),rating:c(N.statistics,"averagerating"),ratingCount:c(N.statistics,"ratingcount"),assetUri:y.URI.parse(F.assetUri),webExtension:!!N.tags?.includes(M.WEB_EXTENSION_TAG),assetTypes:F.files.map(({assetType:_})=>_),assets:C,properties:{dependencies:B(F,t.Dependency),extensionPack:B(F,t.ExtensionPack),engine:q(F),localizedLanguages:x(F)},telemetryData:{index:(W.pageNumber-1)*W.pageSize+$,querySource:R},preview:ie(N.flags)}}let Y=class{constructor(F,$,W,R,C,_,A){this.requestService=F,this.logService=$,this.environmentService=W,this.telemetryService=R,this.fileService=C,this.productService=_;const z=_.extensionsGallery;this.extensionsGalleryUrl=z&&z.serviceUrl,this.extensionsControlUrl=z&&z.controlUrl,this.commonHeadersPromise=U(_.version,this.environmentService,this.fileService,A)}api(F=""){return`${this.extensionsGalleryUrl}${F}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(F,$){const W=[];let{total:R,firstPage:C,getPage:_}=await this.query({names:F,pageSize:F.length},$);W.push(...C);for(let A=1;W.length<R&&(C=await _(A,$),C.length);A++)W.push(...C);return W}async getCompatibleExtension(F,$){return this.getCompatibleExtensionByEngine(F,$)}async getCompatibleExtensionByEngine(F,$){const W=(0,M.isIExtensionIdentifier)(F)?null:F;if(W&&W.properties.engine&&(0,p.isEngineValid)(W.properties.engine,this.productService.version,this.productService.date))return W;const{id:R,uuid:C}=W?W.identifier:F;let _=new a().withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");C?_=_.withFilter(o.ExtensionId,C):_=_.withFilter(o.ExtensionName,R);const{galleryExtensions:A}=await this.queryGallery(_,i.CancellationToken.None),[z]=A;if(!z||!z.versions.length)return null;if($){const X=z.versions.filter(G=>G.version===$)[0];if(X){const G=V(z,X,0,_);if(G.properties.engine&&(0,p.isEngineValid)(G.properties.engine,this.productService.version,this.productService.date))return G}return null}const K=await this.getLastValidExtensionVersion(z,z.versions);return K?V(z,K,0,_):null}async query(F,$){const W=i.CancellationToken.isCancellationToken(F)?{}:F,R=i.CancellationToken.isCancellationToken(F)?F:$;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let C=W.text||"";const _=(0,S.getOrDefault)(W,Q=>Q.pageSize,50);let A=new a().withFlags(l.IncludeLatestVersionOnly,l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,_).withFilter(o.Target,"Microsoft.VisualStudio.Code");C?(C=C.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Q,ne,se)=>(A=A.withFilter(o.Category,se||ne),"")),C=C.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Q,ne,se)=>(A=A.withFilter(o.Tag,se||ne),"")),C=C.replace(/\bfeatured(\s+|\b|$)/g,()=>(A=A.withFilter(o.Featured),"")),C=C.trim(),C&&(C=C.length<200?C:C.substring(0,200),A=A.withFilter(o.SearchText,C)),A=A.withSortBy(0)):W.ids?A=A.withFilter(o.ExtensionId,...W.ids):W.names?A=A.withFilter(o.ExtensionName,...W.names):A=A.withSortBy(4),typeof W.sortBy=="number"&&(A=A.withSortBy(W.sortBy)),typeof W.sortOrder=="number"&&(A=A.withSortOrder(W.sortOrder));const{galleryExtensions:z,total:K}=await this.queryGallery(A,R),X=z.map((Q,ne)=>V(Q,Q.versions[0],ne,A,W.source)),G=async(Q,ne)=>{if(ne.isCancellationRequested)throw(0,g.canceled)();const se=A.withPage(Q+1),{galleryExtensions:ue}=await this.queryGallery(se,ne);return ue.map((he,ve)=>V(he,he.versions[0],ve,se,W.source))};return{firstPage:X,total:K,pageSize:A.pageSize,getPage:G}}async queryGallery(F,$){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,l.ExcludeNonValidated).withFilter(o.ExcludeWithFlags,h(l.Unpublished));const W=await this.commonHeadersPromise,R=JSON.stringify(F.raw),C={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(R.length)},_=new Date().getTime();let A,z,K=0;try{if(A=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:R,headers:C},$),A.res.statusCode&&A.res.statusCode>=400&&A.res.statusCode<500)return{galleryExtensions:[],total:K};const X=await(0,n.asJson)(A);if(X){const G=X.results[0],Q=G.extensions,ne=G.resultMetadata&&G.resultMetadata.filter(se=>se.metadataType==="ResultCount")[0];return K=ne&&ne.metadataItems.filter(se=>se.name==="TotalCount")[0].count||0,{galleryExtensions:Q,total:K}}return{galleryExtensions:[],total:K}}catch(X){throw z=X,X}finally{this.telemetryService.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(R.length),duration:new Date().getTime()-_,success:!!A&&(0,n.isSuccess)(A),responseBodySize:A?.res.headers["Content-Length"],statusCode:A?String(A.res.statusCode):void 0,errorCode:z?(0,g.isPromiseCanceledError)(z)?"canceled":(0,g.getErrorMessage)(z).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(K)})}}async reportStatistic(F,$,W,R){if(!this.isEnabled())return;const _={...await this.commonHeadersPromise,Accept:"*/*;api-version=4.0-preview.1"};try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${F}/extensions/${$}/${W}/stats?statType=${R}`),headers:_},i.CancellationToken.None)}catch(A){}}async download(F,$,W){this.logService.trace("ExtensionGalleryService#download",F.identifier.id);const R=(0,D.getGalleryExtensionTelemetryData)(F),C=new Date().getTime(),_=X=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...R,duration:X}),A=W===1?"install":W===2?"update":"",z=A?{uri:`${F.assets.download.uri}&${A}=true`,fallbackUri:`${F.assets.download.fallbackUri}?${A}=true`}:F.assets.download,K=await this.getAsset(z);await this.fileService.writeFile($,K.stream),_(new Date().getTime()-C)}async getReadme(F,$){if(F.assets.readme){const W=await this.getAsset(F.assets.readme,{},$);return await(0,n.asText)(W)||""}return""}async getManifest(F,$){if(F.assets.manifest){const W=await this.getAsset(F.assets.manifest,{},$),R=await(0,n.asText)(W);return R?JSON.parse(R):null}return null}async getCoreTranslation(F,$){const W=F.assets.coreTranslations.filter(R=>R[0]===$.toUpperCase())[0];if(W){const R=await this.getAsset(W[1]),C=await(0,n.asText)(R);return C?JSON.parse(C):null}return null}async getChangelog(F,$){if(F.assets.changelog){const W=await this.getAsset(F.assets.changelog,{},$);return await(0,n.asText)(W)||""}return""}async getAllVersions(F,$){let W=new a().withFlags(l.IncludeVersions,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");F.identifier.uuid?W=W.withFilter(o.ExtensionId,F.identifier.uuid):W=W.withFilter(o.ExtensionName,F.identifier.id);const R=[],{galleryExtensions:C}=await this.queryGallery(W,i.CancellationToken.None);return C.length&&($?await Promise.all(C[0].versions.map(async _=>{let A;try{A=await this.getEngine(_)}catch(z){}A&&(0,p.isEngineValid)(A,this.productService.version,this.productService.date)&&R.push({version:_.version,date:_.lastUpdated})})):R.push(...C[0].versions.map(_=>({version:_.version,date:_.lastUpdated})))),R}async getAsset(F,$={},W=i.CancellationToken.None){const R=await this.commonHeadersPromise,C={type:"GET"},_={...R,...$.headers||{}};$={...$,...C,headers:_};const A=F.uri,z=F.fallbackUri,K={...$,url:A};try{const X=await this.requestService.request(K,W);if(X.res.statusCode===200)return X;const G=await(0,n.asText)(X);throw new Error(`Expected 200, got back ${X.res.statusCode} instead.

${G}`)}catch(X){if((0,g.isPromiseCanceledError)(X))throw X;const G=(0,g.getErrorMessage)(X);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:A,message:G});const Q={...$,url:z};return this.requestService.request(Q,W)}}async getLastValidExtensionVersion(F,$){const W=this.getLastValidExtensionVersionFromProperties(F,$);return W||this.getLastValidExtensionVersionRecursively(F,$)}getLastValidExtensionVersionFromProperties(F,$){for(const W of $){const R=q(W);if(!R)return null;if((0,p.isEngineValid)(R,this.productService.version,this.productService.date))return W}return null}async getEngine(F){const $=q(F);if($)return $;const W=O(F,u.Manifest);if(!W)throw new Error("Manifest was not found");const R={"Accept-Encoding":"gzip"},C=await this.getAsset(W,{headers:R}),_=await(0,n.asJson)(C);if(_)return _.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(F,$){if(!$.length)return null;const W=$[0],R=await this.getEngine(W);return(0,p.isEngineValid)(R,this.productService.version,this.productService.date)?{...W,properties:[...W.properties||[],{key:t.Engine,value:R}]}:this.getLastValidExtensionVersionRecursively(F,$.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const F=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const $=await(0,n.asJson)(F),W=new Map;if($)for(const R of $.malicious){const C=W.get(R)||{id:{id:R},malicious:!0,slow:!1};C.malicious=!0,W.set(R,C)}return[...W.values()]}};Y=ce([ee(0,n.IRequestService),ee(1,b.ILogService),ee(2,m.IEnvironmentService),ee(3,E.ITelemetryService),ee(4,k.IFileService),ee(5,d.IProductService),ee(6,(0,I.optional)(w.IStorageService))],Y),e.ExtensionGalleryService=Y;async function U(N,F,$,W){const R={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N}`},C=await(0,P.getServiceMachineId)(F,$,W);return R["X-Market-User-Id"]=C,R}e.resolveMarketplaceHeaders=U}),define(J[201],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class g{constructor(S){this.appender=S}listen(S,E){throw new Error(`Event not found: ${E}`)}call(S,E,{eventName:n,data:p}){return this.appender.log(n,p),Promise.resolve(null)}}e.TelemetryAppenderChannel=g;class M{constructor(S){this.channel=S}log(S,E){return this.channel.call("log",{eventName:S,data:E}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=M}),define(J[202],Z([0,1,49,148,23,4,21,50,2,44,38]),function(j,e,g,M,D,S,E,n,p,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{constructor(d,w){this._configurationService=w,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appender=d.appender,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(P),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(P=>{const I=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!I})}))}setExperimentProperty(d,w){this._experimentProperties[d]=w}setEnabled(d){this._enabled=d}_updateUserOptIn(){const d=this._configurationService?.getValue(k);this._userOptIn=d?d.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const d=await this._commonProperties;let w=d.sessionID,P=d["common.instanceId"],I=d["common.machineId"],l=d["common.firstSessionDate"],h=d["common.msftInternal"];return{sessionId:w,instanceId:P,machineId:I,firstSessionDate:l,msftInternal:h}}dispose(){this._disposables.dispose()}publicLog(d,w,P){return this.isOptedIn?this._commonProperties.then(I=>{w=(0,m.mixin)(w,I),w=(0,m.mixin)(w,this._experimentProperties),w=(0,m.cloneAndChange)(w,l=>{if(typeof l=="string")return this._cleanupInfo(l,P)}),this._appender.log(d,w)},I=>{console.error(I)}):Promise.resolve(void 0)}publicLog2(d,w,P){return this.publicLog(d,w,P)}publicLogError(d,w){return this.sendErrorTelemetry?this.publicLog(d,w,!0):Promise.resolve(void 0)}publicLogError2(d,w){return this.publicLogError(d,w)}_cleanupInfo(d,w){let P=d;if(w){const I=[];for(let u of this._cleanupPatterns)for(;;){const t=u.exec(d);if(!t)break;I.push([t.index,u.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(P="";;){const u=h.exec(d);if(!u)break;!l.test(u[0])&&I.every(([t,s])=>u.index<t||u.index>=s)&&(P+=d.substring(o,u.index)+"<REDACTED: user-file-path>",o=h.lastIndex)}o<d.length&&(P+=d.substr(o))}for(let I of this._cleanupPatterns)P=P.replace(I,"");return P}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=ce([ee(1,(0,S.optional)(E.IConfigurationService))],b),e.TelemetryService=b;const k="telemetry";i.Registry.as(n.Extensions.Configuration).registerConfiguration({id:k,order:110,type:"object",title:(0,M.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,M.localize)(2,null,g.default.privacyStatementUrl):(0,M.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[97],Z([0,1,21,44,13,9]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(d,w){return Promise.resolve(void 0)}publicLog2(d,w){return this.publicLog(d,w)}publicLogError(d,w){return Promise.resolve(void 0)}publicLogError2(d,w){return this.publicLogError(d,w)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class E{async publicLog(w,P,I){}async publicLogError(w,P,I){}}e.NullEndpointTelemetryService=E;function n(...d){return{log:(w,P)=>d.forEach(I=>I.log(w,P)),flush:()=>S.Promises.settled(d.map(w=>w.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function p(d,w){return w.onDidChangeConfiguration(P=>{P.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,g.ConfigurationTargetToString)(P.source),configurationKeys:k(P.sourceConfig)})})}e.configurationTelemetry=p;function m(d){const w=Object.create(null),P=Object.create(null),I=Object.create(null);b(d,I);for(let l in I){l=l.length>150?l.substr(l.length-149):l;const h=I[l];typeof h=="number"?P[l]=h:typeof h=="boolean"?P[l]=h?1:0:typeof h=="string"?w[l]=h.substring(0,1023):typeof h!="undefined"&&h!==null&&(w[l]=h)}return{properties:w,measurements:P}}e.validateTelemetryData=m;function i(d){if(!d)return"none";let w="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(I=>{d.indexOf(`${I}+`)===0&&(w=I)}),w}e.cleanRemoteAuthority=i;function b(d,w,P=0,I){if(!!d)for(let l of Object.getOwnPropertyNames(d)){const h=d[l],o=I?I+l:l;Array.isArray(h)?w[o]=(0,M.safeStringify)(h):h instanceof Date?w[o]=h.toISOString():(0,D.isObject)(h)?P<2?b(h,w,P+1,o+"."):w[o]=(0,M.safeStringify)(h):w[o]=h}}function k(d){if(!d)return[];const w=[];return y(w,"",d),w}function y(d,w,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(I=>y(d,w?`${w}.${I}`:I,P[I])):d.push(w)}}),define(J[203],Z([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(J[204],Z([0,1,4,2,38,5,203,109]),function(j,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,g.createDecorator)("themeService");var p;(function(P){function I(l){return l&&typeof l=="object"&&typeof l.id=="string"}P.isThemeColor=I})(p=e.ThemeColor||(e.ThemeColor={}));function m(P){return{id:P}}e.themeColorFromId=m;var i;(function(P){function I(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||p.isThemeColor(s.color))}P.isThemeIcon=I;const l=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function h(s){const r=l.exec(s);if(!r)return;let[,a]=r;return{id:a}}P.fromString=h;function o(s,r){let a=s.id;const c=a.lastIndexOf("~");return c!==-1&&(a=a.substring(0,c)),r&&(a=`${a}~${r}`),{id:a}}P.modify=o;function u(s,r){return s.id===r.id&&s.color?.id===r.color?.id}P.isEqual=u;function t(s,r){return{id:s.id,color:r?m(r):void 0}}P.asThemeIcon=t,P.asClassNameArray=n.CSSIcon.asClassNameArray,P.asClassName=n.CSSIcon.asClassName,P.asCSSSelector=n.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function b(P){switch(P){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class k{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new S.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,M.toDisposable)(()=>{const l=this.themingParticipants.indexOf(I);this.themingParticipants.splice(l,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new k;D.Registry.add(e.Extensions.ThemingContribution,y);function d(P){return y.onColorThemeChange(P)}e.registerThemingParticipant=d;class w extends M.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(l=>this.onThemeChange(l)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,l){let h=this.theme.getColor(I);return h&&l&&(h=l(h,this.theme)),h?h.toString():null}}e.Themable=w}),define(J[60],Z([0,1,14,3,39,4]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const E="#FFFFFF",n="#1E1E1E",p="#000000",m="theme",i="themeBackground",b="windowSplash";e.IThemeMainService=(0,S.createDecorator)("themeMainService");let k=class{constructor(d){this.stateMainService=d}getBackgroundColor(){if((M.isWindows||M.isMacintosh)&&g.nativeTheme.shouldUseInvertedColorScheme)return p;let d=this.stateMainService.getItem(i,null);if(!d){let w;(M.isWindows||M.isMacintosh)&&g.nativeTheme.shouldUseInvertedColorScheme?w="hc-black":w=this.stateMainService.getItem(m,"vs-dark").split(" ")[0],d=w==="hc-black"?p:w==="vs"?E:n}return M.isMacintosh&&d.toUpperCase()===n&&(d="#171717"),d}saveWindowSplash(d,w){this.stateMainService.setItems([{key:m,data:w.baseTheme},{key:i,data:w.colorInfo.background},{key:b,data:w}]),typeof d=="number"&&this.updateBackgroundColor(d,w)}updateBackgroundColor(d,w){for(const P of g.BrowserWindow.getAllWindows())if(P.id===d){P.setBackgroundColor(w.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(b)}};k=ce([ee(0,D.IStateMainService)],k),e.ThemeMainService=k}),define(J[42],Z([0,1,4]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var M;(function(S){S.Uninitialized="uninitialized",S.Idle="idle",S.CheckingForUpdates="checking for updates",S.AvailableForDownload="available for download",S.Downloading="downloading",S.Downloaded="downloaded",S.Updating="updating",S.Ready="ready"})(M=e.StateType||(e.StateType={}));var D;(function(S){S[S.Setup=0]="Setup",S[S.Archive=1]="Archive",S[S.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(S,E)=>({type:"idle",updateType:S,error:E}),CheckingForUpdates:S=>({type:"checking for updates",explicit:S}),AvailableForDownload:S=>({type:"available for download",update:S}),Downloading:S=>({type:"downloading",update:S}),Downloaded:S=>({type:"downloaded",update:S}),Updating:S=>({type:"updating",update:S}),Ready:S=>({type:"ready",update:S})},e.IUpdateService=(0,g.createDecorator)("updateService")}),define(J[205],Z([0,1,38,50,149,3]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),g.Registry.as(M.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[206],Z([0,1,5,42]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(n){this.service=n}listen(n,p){switch(p){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${p}`)}call(n,p,m){switch(p){case"checkForUpdates":return this.service.checkForUpdates(m);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${p}`)}}e.UpdateChannel=D;class S{constructor(n){this.channel=n,this._onStateChange=new g.Emitter,this.onStateChange=this._onStateChange.event,this._state=M.State.Uninitialized,this.channel.listen("onStateChange")(p=>this.state=p),this.channel.call("_getInitialState").then(p=>this.state=p)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=S}),define(J[98],Z([0,1,4]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,g.createDecorator)("urlService")}),define(J[207],Z([0,1,7]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class M{constructor(n){this.handler=n}listen(n,p){throw new Error(`Event not found: ${p}`)}call(n,p,m){switch(p){case"handleURL":return this.handler.handleURL(g.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${p}`)}}e.URLHandlerChannel=M;class D{constructor(n){this.channel=n}handleURL(n,p){return this.channel.call("handleURL",[n.toJSON(),p])}}e.URLHandlerChannelClient=D;class S{constructor(n){this.next=n}async routeCall(n,p,m,i){if(p!=="handleURL")throw new Error(`Call not found: ${p}`);if(m){const b=g.URI.revive(m);if(b&&b.query){const k=/\bwindowId=(\d+)/.exec(b.query);if(k){const y=k[1],d=new RegExp(`window:${y}`),w=n.connections.find(P=>d.test(P.ctx));if(w)return w}}}return this.next.routeCall(n,p,m,i)}routeEvent(n,p){throw new Error(`Event not found: ${p}`)}}e.URLHandlerRouter=S}),define(J[208],Z([0,1,7,9,2,20]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class E extends D.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(m,i){const b=[...this.handlers.values()];return(0,M.first)(b.map(k=>()=>k.handleURL(m,i)),void 0,!1).then(k=>k||!1)}registerHandler(m){return this.handlers.add(m),(0,D.toDisposable)(()=>this.handlers.delete(m))}}e.AbstractURLService=E;let n=class extends E{constructor(m){super();this.productService=m}create(m){let{authority:i,path:b,query:k,fragment:y}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&b&&b.indexOf("/")!==0&&(b=`/${b}`),g.URI.from({scheme:this.productService.urlProtocol,authority:i,path:b,query:k,fragment:y})}};n=ce([ee(0,S.IProductService)],n),e.NativeURLService=n}),define(J[209],Z([0,1,5,14,7,2,3,9]),function(j,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function p(i){try{return D.URI.parse(i)}catch(b){return null}}class m{constructor(b,k,y,d,w){if(this.urlService=k,this.uris=[],this.retryCount=0,this.flushDisposable=S.Disposable.None,this.disposables=new S.DisposableStore,this.uris=b,E.isWindows){const l=d.isBuilt?[]:[`"${d.appRoot}"`];l.push("--open-url","--"),M.app.setAsDefaultProtocolClient(w.urlProtocol,process.execPath,l)}const P=g.Event.map(g.Event.fromNodeEventEmitter(M.app,"open-url",(l,h)=>({event:l,url:h})),({event:l,url:h})=>(l.preventDefault(),h));this.disposables.add(P(l=>{const h=p(l);!h||this.urlService.open(h,{originalUrl:l})})),y.getWindows().filter(l=>l.isReady).length>0?this.flush():g.Event.once(y.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const b=[];for(const k of this.uris)await this.urlService.open(k.uri,{originalUrl:k.url})||b.push(k);b.length!==0&&(this.uris=b,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=m}),define(J[76],Z([0,1,4]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewPartitionId=e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,g.createDecorator)("webviewManagerService"),e.webviewPartitionId="webview"}),define(J[210],Z([0,1,14,2,10,7,76]),function(j,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class n extends M.Disposable{constructor(){super();const m=g.session.fromPartition(E.webviewPartitionId),i=this.handleWebviewRequest.bind(this);g.protocol.registerFileProtocol(D.Schemas.vscodeWebview,i),m.protocol.registerFileProtocol(D.Schemas.vscodeWebview,i)}async handleWebviewRequest(m,i){try{const b=S.URI.parse(m.url),k=n.validWebviewFilePaths.get(b.path);if(typeof k=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${k}`,d=D.FileAccess.asFileUri(y,j);return i(decodeURIComponent(d.fsPath))}}catch{}i({error:-10})}}e.WebviewProtocolProvider=n,n.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(J[61],Z([0,1,3]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function M(m){return!!m.workspaceUri}e.isWorkspaceToOpen=M;function D(m){return!!m.folderUri}e.isFolderToOpen=D;function S(m){return!!m.fileUri}e.isFileToOpen=S;function E(m){const i=n(m),b=m.getValue("window.menuBarVisibility");return b==="default"||i==="native"&&b==="compact"||g.isMacintosh&&g.isNative?"classic":b}e.getMenuBarVisibility=E;function n(m){if(g.isWeb)return"custom";const i=m.getValue("window");if(i){if(g.isMacintosh&&i.nativeTabs===!0||g.isMacintosh&&i.nativeFullScreen===!1)return"native";const y=i.titleBarStyle;if(y==="native"||y==="custom")return y}return g.isLinux?"native":"custom"}e.getTitleBarStyle=n;function p(m=0){return Math.pow(1.2,m)}e.zoomLevelToZoomFactor=p}),define(J[35],Z([0,1,4]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var M;(function(m){m[m.INITIAL=1]="INITIAL",m[m.LOAD=2]="LOAD",m[m.RELOAD=3]="RELOAD"})(M=e.LoadReason||(e.LoadReason={}));var D;(function(m){m[m.CLOSE=1]="CLOSE",m[m.QUIT=2]="QUIT",m[m.RELOAD=3]="RELOAD",m[m.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));var S;(function(m){m[m.CLI=0]="CLI",m[m.DOCK=1]="DOCK",m[m.MENU=2]="MENU",m[m.DIALOG=3]="DIALOG",m[m.DESKTOP=4]="DESKTOP",m[m.API=5]="API"})(S=e.OpenContext||(e.OpenContext={}));const E=function(m=1){return{width:1024,height:768,mode:m}};e.defaultWindowState=E;var n;(function(m){m[m.Maximized=0]="Maximized",m[m.Normal=1]="Normal",m[m.Minimized=2]="Minimized",m[m.Fullscreen=3]="Fullscreen"})(n=e.WindowMode||(e.WindowMode={}));var p;(function(m){m[m.UNRESPONSIVE=1]="UNRESPONSIVE",m[m.CRASHED=2]="CRASHED",m[m.LOAD=3]="LOAD"})(p=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,g.createDecorator)("windowsMainService")}),define(J[211],Z([0,1,14,5,2,74,76,210,35]),function(j,e,g,M,D,S,E,n,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let m=class extends D.Disposable{constructor(b,k){super();this.windowsMainService=k,this._onFoundInFrame=this._register(new M.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new n.WebviewProtocolProvider);const y=g.session.fromPartition(E.webviewPartitionId);y.setPermissionRequestHandler((d,w,P)=>P(w==="clipboard-read")),y.setPermissionCheckHandler((d,w)=>w==="clipboard-read")}async setIgnoreMenuShortcuts(b,k){let y;if(typeof b.windowId=="number"){const{windowId:d}=b,w=this.windowsMainService.getWindowById(d);if(!w?.win)throw new Error(`Invalid windowId: ${d}`);y=w.win.webContents}else{const{webContentsId:d}=b;if(y=g.webContents.fromId(d),!y)throw new Error(`Invalid webContentsId: ${d}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(k)}async findInFrame(b,k,y,d){const w=this.getFrameByName(b,k),P=w;if(typeof P.findInFrame=="function"){P.findInFrame(y,{findNext:d.findNext,forward:d.forward});const I=(l,h)=>{h.finalUpdate&&(this._onFoundInFrame.fire(h),w.removeListener("found-in-frame",I))};w.on("found-in-frame",I)}}async stopFindInFrame(b,k,y){const w=this.getFrameByName(b,k);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}getFrameByName(b,k){const y=this.windowsMainService.getWindowById(b.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${b}`);const d=y.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===k);if(!d)throw new Error(`Unknown frame: ${k}`);return d}};m=ce([ee(0,S.ITunnelService),ee(1,p.IWindowsMainService)],m),e.WebviewMainService=m}),define(J[212],Z([0,1,5,2,9]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class S extends M.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:p,getActiveWindowId:m}){super();this.disposables=this._register(new M.DisposableStore),g.Event.latch(g.Event.any(n,p))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>m()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch(b){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=S}),define(J[213],Z([0,1,7,15,4,37]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var E;(function(k){k[k.EMPTY=1]="EMPTY",k[k.FOLDER=2]="FOLDER",k[k.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function n(k){const y=k;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.isWorkspace=n;function p(k){const y=k;return!!(y&&typeof y=="object"&&g.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.isWorkspaceFolder=p;class m{constructor(y,d,w,P){this._id=y,this._configuration=w,this._ignorePathCasing=P,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(y){this._id=y.id,this._configuration=y.configuration,this._ignorePathCasing=y._ignorePathCasing,this.folders=y.folders}get folders(){return this._folders}set folders(y){this._folders=y,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(y){this._configuration=y}getFolder(y){return y&&this._foldersMap.findSubstr(y.with({scheme:y.scheme,authority:y.authority,path:y.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const y of this.folders)this._foldersMap.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=m;class i{constructor(y,d){this.raw=d,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,M.joinPath)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function b(k){return new i({uri:k,index:0,name:(0,M.basenameOrAuthority)(k)},{uri:k.toString()})}e.toWorkspaceFolder=b}),define(J[27],Z([0,1,4,152,213,7,3,8,15,78,40,10,31,30,73]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,M.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(U){return(typeof U=="string"?(0,n.extname)(U):(0,p.extname)(U))===w}e.hasWorkspaceFileExtension=P,e.IWorkspacesService=(0,g.createDecorator)("workspacesService");function I(U){return U.hasOwnProperty("workspace")}e.isRecentWorkspace=I;function l(U){return U.hasOwnProperty("folderUri")}e.isRecentFolder=l;function h(U){return U.hasOwnProperty("fileUri")}e.isRecentFile=h;function o(U){const N=U;return typeof N?.id=="string"&&S.URI.isUri(N.uri)}e.isSingleFolderWorkspaceIdentifier=o;function u(U){if(U.configuration)return{id:U.id,configPath:U.configuration};if(U.folders.length===1)return{id:U.id,uri:U.folders[0].uri}}e.toWorkspaceIdentifier=u;function t(U){const N=U;return typeof N?.id=="string"&&S.URI.isUri(N.configPath)}e.isWorkspaceIdentifier=t;function s(U){const N=U;if(N?.uri)return{id:N.id,uri:S.URI.revive(N.uri)};const F=U;if(F?.configPath)return{id:F.id,configPath:S.URI.revive(F.configPath)};if(U?.id)return{id:U.id}}e.reviveIdentifier=s;function r(U,N){return p.extUriBiasedIgnorePathCase.isEqualOrParent(U,N.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function a(U){return c(U)||v(U)}e.isStoredWorkspaceFolder=a;function c(U){const N=U;return typeof N?.path=="string"&&(!N.name||typeof N.name=="string")}e.isRawFileWorkspaceFolder=c;function v(U){const N=U;return typeof N?.uri=="string"&&(!N.name||typeof N.name=="string")}e.isRawUriWorkspaceFolder=v;function f(U,N,F,$,W=!E.isWindows,R){if(U.scheme!==$.scheme)return{name:F,uri:U.toString(!0)};let C=N?void 0:R.relativePath($,U);if(C!==void 0)C.length===0?C=".":E.isWindows&&U.scheme===b.Schemas.file&&!W&&(C=C.replace(/\//g,"\\"));else if(U.scheme===b.Schemas.file)C=U.fsPath,E.isWindows&&(C=(0,k.normalizeDriveLetter)(C),W&&(C=(0,y.toSlashes)(C)));else{if(!R.isEqualAuthority(U.authority,$.authority))return{name:F,uri:U.toString(!0)};C=U.path}return{name:F,path:C}}e.getStoredWorkspaceFolder=f;function L(U,N,F){let $=[],W=new Set;const R=F.dirname(N);for(let C of U){let _;if(c(C))C.path&&(_=F.resolvePath(R,C.path));else if(v(C))try{_=S.URI.parse(C.uri),_.path[0]!=="/"&&(_=_.with({path:"/"+_.path}))}catch(A){console.warn(A)}if(_){let A=F.getComparisonKey(_);if(!W.has(A)){W.add(A);const z=C.name||F.basenameOrAuthority(_);$.push(new D.WorkspaceFolder({uri:_,name:z,index:$.length},C))}}}return $}e.toWorkspaceFolders=L;function T(U,N,F,$,W){let R=O(N,U);const C=W.dirname(N),_=W.dirname($),A=[],z=B(R.folders);for(const Q of R.folders){const ne=c(Q)?W.resolvePath(C,Q.path):S.URI.parse(Q.uri);let se;F?se=!1:se=!c(Q)||(0,n.isAbsolute)(Q.path),A.push(f(ne,se,Q.name,_,z,W))}const K={insertSpaces:!1,tabSize:4,eol:E.isLinux||E.isMacintosh?`
`:`\r
`},X=m.setProperty(U,["folders"],A,K);let G=m.applyEdits(U,X);return R.remoteAuthority===(0,d.getRemoteAuthority)($)&&(G=m.applyEdits(G,m.removeProperty(G,["remoteAuthority"],K))),G}e.rewriteWorkspaceFileForNewLocation=T;function O(U,N){let F=i.parse(N);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter($=>a($));else throw new Error(`${U} looks like an invalid workspace file.`);return F}function B(U){return E.isWindows?U.some(N=>c(N)&&N.path.indexOf("/")>=0):!0}e.useSlashForPath=B;function q(U){return U.workspace&&typeof U.workspace=="object"&&typeof U.workspace.id=="string"&&typeof U.workspace.configPath=="string"}function x(U){return typeof U.folderUri=="string"}function ie(U){return typeof U.fileUri=="string"}function V(U,N){const F={workspaces:[],files:[]};if(U){const $=function(R,C){for(let _=0;_<R.length;_++)try{C(R[_],_)}catch(A){N.warn(`Error restoring recent entry ${JSON.stringify(R[_])}: ${A.toString()}. Skip entry.`)}},W=U;if(Array.isArray(W.entries))$(W.entries,R=>{const C=R.label,_=R.remoteAuthority;q(R)?F.workspaces.push({label:C,remoteAuthority:_,workspace:{id:R.workspace.id,configPath:S.URI.parse(R.workspace.configPath)}}):x(R)?F.workspaces.push({label:C,remoteAuthority:_,folderUri:S.URI.parse(R.folderUri)}):ie(R)&&F.files.push({label:C,remoteAuthority:_,fileUri:S.URI.parse(R.fileUri)})});else{const R=U;Array.isArray(R.workspaces3)&&$(R.workspaces3,(C,_)=>{const A=Array.isArray(R.workspaceLabels)&&R.workspaceLabels[_]||void 0;typeof C=="object"&&typeof C.id=="string"&&typeof C.configURIPath=="string"?F.workspaces.push({label:A,workspace:{id:C.id,configPath:S.URI.parse(C.configURIPath)}}):typeof C=="string"&&F.workspaces.push({label:A,folderUri:S.URI.parse(C)})}),Array.isArray(R.files2)&&$(R.files2,(C,_)=>{const A=Array.isArray(R.fileLabels)&&R.fileLabels[_]||void 0;typeof C=="string"&&F.files.push({label:A,fileUri:S.URI.parse(C)})})}}return F}e.restoreRecentlyOpened=V;function Y(U){const N={entries:[]};for(const F of U.workspaces)l(F)?N.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):N.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of U.files)N.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return N}e.toStoreData=Y}),define(J[52],Z([0,1,4,27]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,g.createDecorator)("backupMainService");function D(S){const E=S;return E&&(0,M.isWorkspaceIdentifier)(E.workspace)}e.isWorkspaceBackupInfo=D}),define(J[53],Z([0,1,4,14,9,39,3,8,65,18,13,134,27,31,2,80]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,g.createDecorator)("dialogMainService");let P=class gt{constructor(l){this.stateMainService=l,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new D.Queue}pickFileFolder(l,h){return this.doPick({...l,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},h)}pickFolder(l,h){return this.doPick({...l,pickFolders:!0,title:(0,b.localize)(1,null)},h)}pickFile(l,h){return this.doPick({...l,pickFiles:!0,title:(0,b.localize)(2,null)},h)}pickWorkspace(l,h){const o=(0,b.localize)(3,null),u=(0,y.mnemonicButtonLabel)((0,b.localize)(4,null)),t=k.WORKSPACE_FILTER;return this.doPick({...l,pickFiles:!0,title:o,filters:t,buttonLabel:u},h)}async doPick(l,h){const o={title:l.title,buttonLabel:l.buttonLabel,filters:l.filters};o.defaultPath=l.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof l.pickFiles=="boolean"||typeof l.pickFolders=="boolean")&&(o.properties=void 0,l.pickFiles&&l.pickFolders&&(o.properties=["multiSelections","openDirectory","openFile","createDirectory"])),o.properties||(o.properties=["multiSelections",l.pickFolders?"openDirectory":"openFile","createDirectory"]),E.isMacintosh&&o.properties.push("treatPackageAsDirectory");const u=h||M.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(o,(0,i.withNullAsUndefined)(u));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,(0,n.dirname)(t.filePaths[0])),t.filePaths}getWindowDialogQueue(l){if(l){let h=this.windowDialogQueues.get(l.id);return h||(h=new D.Queue,this.windowDialogQueues.set(l.id,h)),h}else return this.noWindowDialogueQueue}showMessageBox(l,h){return this.getWindowDialogQueue(h).queue(async()=>h?M.dialog.showMessageBox(h,l):M.dialog.showMessageBox(l))}async showSaveDialog(l,h){const o=this.acquireFileDialogLock(l,h);if(!o)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(h).queue(async()=>{let u;return h?u=await M.dialog.showSaveDialog(h,l):u=await M.dialog.showSaveDialog(l),u.filePath=this.normalizePath(u.filePath),u})}finally{(0,d.dispose)(o)}}normalizePath(l){return l&&E.isMacintosh&&(l=(0,p.normalizeNFC)(l)),l}normalizePaths(l){return l.map(h=>this.normalizePath(h))}async showOpenDialog(l,h){l.defaultPath&&(await m.Promises.exists(l.defaultPath)||(l.defaultPath=void 0));const o=this.acquireFileDialogLock(l,h);if(!o)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(h).queue(async()=>{let u;return h?u=await M.dialog.showOpenDialog(h,l):u=await M.dialog.showOpenDialog(l),u.filePaths=this.normalizePaths(u.filePaths),u})}finally{(0,d.dispose)(o)}}acquireFileDialogLock(l,h){if(!h)return d.Disposable.None;let o=this.windowFileDialogLocks.get(h.id);o||(o=new Set,this.windowFileDialogLocks.set(h.id,o));const u=(0,w.hash)(l);if(!o.has(u))return o.add(u),(0,d.toDisposable)(()=>{o?.delete(u),o?.size===0&&this.windowFileDialogLocks.delete(h.id)})}};P.workingDirPickerStorageKey="pickerWorkingDir",P=ce([ee(0,S.IStateMainService)],P),e.DialogMainService=P}),define(J[214],Z([0,1,5,2,27]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class S extends M.Disposable{constructor(n,p){super();this.logService=n,this.storageMainService=p,this._onDidChangeGlobalStorage=this._register(new g.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(g.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,p)=>(n?n.push(p):n=[p],n),S.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const p=new Map,m=new Set;return n.forEach(i=>{const b=this.storageMainService.globalStorage.get(i.key);typeof b=="string"?p.set(i.key,b):m.add(i.key)}),{changed:Array.from(p.entries()),deleted:Array.from(m.values())}}listen(n,p){switch(p){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${p}`)}async call(n,p,m){const i=(0,D.reviveIdentifier)(m.workspace),b=await this.withStorageInitialized(i);switch(p){case"getItems":return Array.from(b.items.entries());case"updateItems":{const k=m;if(k.insert)for(const[y,d]of k.insert)b.set(y,d);k.delete&&k.delete.forEach(y=>b.delete(y));break}case"close":{if(i)return b.close();break}default:throw new Error(`Call not found: ${p}`)}}async withStorageInitialized(n){const p=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await p.init()}catch(m){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${m}`)}return p}}e.StorageDatabaseChannel=S,S.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[215],Z([0,1,18,5,2,6,124,86,8,96,32,28,27]),function(j,e,g,M,D,S,E,n,p,m,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class y extends D.Disposable{constructor(I){super();this.logService=I,this._onDidChangeStorage=this._register(new M.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new M.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const I=await this.doCreate();this.storage.dispose(),this.storage=I,this._register(I.onDidChangeStorage(h=>this._onDidChangeStorage.fire({key:h}))),await this.doInit(I);const l=I.getBoolean(m.IS_NEW_KEY);l===void 0?I.set(m.IS_NEW_KEY,!0):l&&I.set(m.IS_NEW_KEY,!1)}catch(I){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${I}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?I=>this.logService.trace(I):void 0,logError:I=>this.logService.error(I)}}doInit(I){return I.init()}get items(){return this.storage.items}get(I,l){return this.storage.get(I,l)}set(I,l){return this.storage.set(I,l)}delete(I){return this.storage.delete(I)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class d extends y{constructor(I,l,h){super(l);this.options=I,this.environmentService=h}async doCreate(){let I;return this.options.useInMemoryStorage?I=E.SQLiteStorageDatabase.IN_MEMORY_PATH:I=(0,p.join)(this.environmentService.globalStorageHome.fsPath,d.STORAGE_NAME),new n.Storage(new E.SQLiteStorageDatabase(I,{logging:this.createLogginOptions()}))}async doInit(I){await super.doInit(I),this.updateTelemetryState(I)}updateTelemetryState(I){I.get(i.instanceStorageKey,void 0)===void 0&&I.set(i.instanceStorageKey,(0,b.generateUuid)()),I.get(i.firstSessionDateStorageKey,void 0)===void 0&&I.set(i.firstSessionDateStorageKey,new Date().toUTCString());const o=I.get(i.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();I.set(i.lastSessionDateStorageKey,typeof o=="undefined"?null:o),I.set(i.currentSessionDateStorageKey,u)}}e.GlobalStorageMain=d,d.STORAGE_NAME="state.vscdb";class w extends y{constructor(I,l,h,o){super(h);this.workspace=I,this.options=l,this.environmentService=o}async doCreate(){const{storageFilePath:I,wasCreated:l}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new E.SQLiteStorageDatabase(I,{logging:this.createLogginOptions()}),{hint:l?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:E.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const I=(0,p.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),l=(0,p.join)(I,w.WORKSPACE_STORAGE_NAME);return await g.Promises.exists(I)?{storageFilePath:l,wasCreated:!1}:(await g.Promises.mkdir(I,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(I),{storageFilePath:l,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(I){let l;if((0,k.isSingleFolderWorkspaceIdentifier)(this.workspace)?l={folder:this.workspace.uri.toString()}:(0,k.isWorkspaceIdentifier)(this.workspace)&&(l={workspace:this.workspace.configPath.toString()}),l)try{const h=(0,p.join)(I,w.WORKSPACE_META_NAME);await g.Promises.exists(h)||await g.Promises.writeFile(h,JSON.stringify(l,void 0,2))}catch(h){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${h}`)}}}e.WorkspaceStorageMain=w,w.WORKSPACE_STORAGE_NAME="state.vscdb",w.WORKSPACE_META_NAME="workspace.json"}),define(J[99],Z([0,1,43,2,48,4,22,6,215]),function(j,e,g,M,D,S,E,n,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,S.createDecorator)("storageMainService");let m=class extends M.Disposable{constructor(b,k,y){super();this.logService=b,this.environmentService=k,this.lifecycleMainService=y,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async b=>{if(b.workspace){if(b.reason!==1)return;this.workspaceStorage(b.workspace).init()}})),this._register(this.lifecycleMainService.onWillShutdown(b=>{b.join(this.globalStorage.close());for(const[,k]of this.mapWorkspaceToStorage)b.join(k.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const b=new p.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,g.once)(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),b}createWorkspaceStorage(b){return new p.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(b){let k=this.mapWorkspaceToStorage.get(b.id);return k||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),k=this.createWorkspaceStorage(b),this.mapWorkspaceToStorage.set(b.id,k),(0,g.once)(k.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)})),k}};m=ce([ee(0,n.ILogService),ee(1,D.IEnvironmentService),ee(2,E.ILifecycleMainService)],m),e.StorageMainService=m}),define(J[100],Z([0,1,7,27,15]),function(j,e,g,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function S(p,m,i){for(const k of p){const y=k.openedWorkspace;if((0,M.isWorkspaceIdentifier)(y)){const d=i(y);if(d){if(d.folders.some(w=>D.extUriBiasedIgnorePathCase.isEqualOrParent(m,w.uri)))return k}else if(D.extUriBiasedIgnorePathCase.isEqualOrParent(m,y.configPath))return k}}const b=p.filter(k=>(0,M.isSingleFolderWorkspaceIdentifier)(k.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqualOrParent(m,k.openedWorkspace.uri));if(b.length)return b.sort((k,y)=>-(k.openedWorkspace.uri.path.length-y.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=S;function E(p,m){for(const i of p)if((0,M.isWorkspaceIdentifier)(i.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,m)||(0,M.isSingleFolderWorkspaceIdentifier)(i.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,m))return i}e.findWindowOnWorkspaceOrFolder=E;function n(p,m){const i=b=>m.some(k=>D.extUriBiasedIgnorePathCase.isEqual(g.URI.file(k),g.URI.file(b)));for(const b of p)if(b.config?.extensionDevelopmentPath?.some(k=>i(k)))return b}e.findWindowOnExtensionDevelopmentPath=n}),define(J[216],Z([0,1,14,2,3,15,7,21,22,6,39,35,27]),function(j,e,g,M,D,S,E,n,p,m,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class mt extends M.Disposable{constructor(h,o,u,t,s){super();this.windowsMainService=h,this.stateMainService=o,this.lifecycleMainService=u,this.logService=t,this.configurationService=s,this._state=d(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){g.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(s=>!s.isExtensionDevelopmentHost)),t&&(h.lastActiveWindow=this.toWindowState(t))}const o=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const u=P(h);this.stateMainService.setItem(mt.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const o=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(u=>{const t=(0,k.isWorkspaceIdentifier)(h.openedWorkspace)&&u.workspace?.id===h.openedWorkspace.id,s=(0,k.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&u.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(u.folderUri,h.openedWorkspace.uri);(t||s)&&(u.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}toWindowState(h){return{workspace:(0,k.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,k.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const o=this.doGetNewWindowState(h),u=this.configurationService.getValue("window");let t;return o.hasDefaultState?t=!!(u?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||u?.restoreFullscreen),t&&D.isMacintosh&&this.windowsMainService.getWindows().some(s=>s.isFullScreen)&&(t=!1)),o.mode===3&&!t&&(o.mode=1),o}doGetNewWindowState(h){const o=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=h.workspace;if((0,k.isWorkspaceIdentifier)(c)){const f=this.state.openedWindows.filter(L=>L.workspace&&L.workspace.id===c.id).map(L=>L.uiState);if(f.length)return f[0]}if((0,k.isSingleFolderWorkspaceIdentifier)(c)){const f=this.state.openedWindows.filter(L=>L.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(L.folderUri,c.uri)).map(L=>L.uiState);if(f.length)return f[0]}else if(h.backupPath){const f=this.state.openedWindows.filter(L=>L.backupPath===h.backupPath).map(L=>L.uiState);if(f.length)return f[0]}const v=this.lastClosedState||this.state.lastActiveWindow;if(!o&&v)return v.uiState}let u;const t=g.screen.getAllDisplays();if(t.length===1)u=t[0];else{if(D.isMacintosh){const c=g.screen.getCursorScreenPoint();u=g.screen.getDisplayNearestPoint(c)}!u&&o&&(u=g.screen.getDisplayMatching(o.getBounds())),u||(u=g.screen.getPrimaryDisplay()||t[0])}let s=(0,b.defaultWindowState)();s.x=Math.round(u.bounds.x+u.bounds.width/2-s.width/2),s.y=Math.round(u.bounds.y+u.bounds.height/2-s.height/2);const r=this.configurationService.getValue("window");let a=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")s.mode=0,a=!1;else if(r.newWindowDimensions==="fullscreen")s.mode=3,a=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&o){const c=o.serializeWindowState();c.mode===3?s.mode=3:s=c,a=s.mode!==3&&r.newWindowDimensions==="offset"}}return a&&(s=this.ensureNoOverlap(s)),s.hasDefaultState=!0,s}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const o=this.windowsMainService.getWindows().map(u=>u.getBounds());for(;o.some(u=>u.x===h.x||u.y===h.y);)h.x+=30,h.y+=30;return h}};y.windowsStateStorageKey="windowsState",y=ce([ee(0,b.IWindowsMainService),ee(1,i.IStateMainService),ee(2,p.ILifecycleMainService),ee(3,m.ILogService),ee(4,n.IConfigurationService)],y),e.WindowsStateHandler=y;function d(l){const h={openedWindows:[]},o=l||{openedWindows:[]};return o.lastActiveWindow&&(h.lastActiveWindow=w(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=w(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(h.openedWindows=o.openedWindows.map(u=>w(u))),h}e.restoreWindowsState=d;function w(l){const h={uiState:l.uiState};return l.backupPath&&(h.backupPath=l.backupPath),l.remoteAuthority&&(h.remoteAuthority=l.remoteAuthority),l.folder&&(h.folderUri=E.URI.parse(l.folder)),l.workspaceIdentifier&&(h.workspace={id:l.workspaceIdentifier.id,configPath:E.URI.parse(l.workspaceIdentifier.configURIPath)}),h}function P(l){return{lastActiveWindow:l.lastActiveWindow&&I(l.lastActiveWindow),lastPluginDevelopmentHostWindow:l.lastPluginDevelopmentHostWindow&&I(l.lastPluginDevelopmentHostWindow),openedWindows:l.openedWindows.map(h=>I(h))}}e.getWindowsStateStoreData=P;function I(l){return{workspaceIdentifier:l.workspace&&{id:l.workspace.id,configURIPath:l.workspace.configPath.toString()},folder:l.folderUri&&l.folderUri.toString(),backupPath:l.backupPath,remoteAuthority:l.remoteAuthority,uiState:l.uiState}}}),define(J[101],Z([0,1,29,3,58,10,15]),function(j,e,g,M,D,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function n(m){function i(){let b=m.scheme===S.Schemas.file?(0,E.originalFSPath)(m):m.toString();return M.isLinux||(b=b.toLowerCase()),(0,D.createHash)("md5").update(b).digest("hex")}return{id:i(),configPath:m}}e.getWorkspaceIdentifier=n;function p(m,i){function b(){if(m.scheme!==S.Schemas.file)return(0,D.createHash)("md5").update(m.toString()).digest("hex");if(!i)try{i=(0,g.statSync)(m.fsPath)}catch(d){return}let y;return M.isLinux?y=i.ino:M.isMacintosh?y=i.birthtime.getTime():M.isWindows&&(typeof i.birthtimeMs=="number"?y=Math.floor(i.birthtimeMs):y=i.birthtime.getTime()),(0,D.createHash)("md5").update(m.fsPath).update(y?String(y):"").digest("hex")}const k=b();if(typeof k=="string")return{id:k,uri:m}}e.getSingleFolderWorkspaceIdentifier=p}),define(J[56],Z([0,1,58,59,217,5,34,8,26,28,2,17,84,16,3]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(f){this.socket=f,this._errorListener=L=>{if(L){if(L.code==="EPIPE")return;(0,y.onUnexpectedError)(L)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(f){const L=T=>f(b.VSBuffer.wrap(T));return this.socket.on("data",L),{dispose:()=>this.socket.off("data",L)}}onClose(f){const L=T=>{f({type:0,hadError:T,error:void 0})};return this.socket.on("close",L),{dispose:()=>this.socket.off("close",L)}}onEnd(f){return this.socket.on("end",f),{dispose:()=>this.socket.off("end",f)}}write(f){if(!this.socket.destroyed)try{this.socket.write(f.buffer,L=>{if(L){if(L.code==="EPIPE")return;(0,y.onUnexpectedError)(L)}})}catch(L){if(L.code==="EPIPE")return;(0,y.onUnexpectedError)(L)}}end(){this.socket.end()}drain(){return new Promise((f,L)=>{if(this.socket.bufferSize===0){f();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),f()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=w;var P;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize"})(P||(P={}));var I;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(I||(I={}));class l extends i.Disposable{constructor(f,L,T,O){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=f,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=L,this._recordInflateBytes=O,L?(this._zlibInflate=D.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",B=>{console.error(B),(0,y.onUnexpectedError)(B),this._onClose.fire({type:0,hadError:!0,error:B})}),this._zlibInflate.on("data",B=>{this._pendingInflateData.push(B)}),T&&(this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=D.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",B=>{console.error(B),(0,y.onUnexpectedError)(B),this._onClose.fire({type:0,hadError:!0,error:B})}),this._zlibDeflate.on("data",B=>{this._pendingDeflateData.push(B)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new k.ChunkStream,this._register(this.socket.onData(B=>this._acceptChunk(B))),this._register(this.socket.onClose(B=>this._onClose.fire(B)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?b.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):b.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this._onData.event(f)}onClose(f){return this._onClose.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){this._totalOutgoingDataBytes+=f.byteLength,this._zlibDeflate?(this._zlibDeflate.write(f.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let L=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,L=L.slice(0,L.length-4),this._isEnded||this._write(b.VSBuffer.wrap(L),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(f,!1)}_write(f,L){let T=2;f.byteLength<126?T+=0:f.byteLength<2**16?T+=2:T+=8;const O=b.VSBuffer.alloc(T);if(L?O.writeUInt8(194,0):O.writeUInt8(130,0),f.byteLength<126)O.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){O.writeUInt8(126,1);let B=1;O.writeUInt8(f.byteLength>>>8&255,++B),O.writeUInt8(f.byteLength>>>0&255,++B)}else{O.writeUInt8(127,1);let B=1;O.writeUInt8(0,++B),O.writeUInt8(0,++B),O.writeUInt8(0,++B),O.writeUInt8(0,++B),O.writeUInt8(f.byteLength>>>24&255,++B),O.writeUInt8(f.byteLength>>>16&255,++B),O.writeUInt8(f.byteLength>>>8&255,++B),O.writeUInt8(f.byteLength>>>0&255,++B)}this._totalOutgoingWireBytes+=O.byteLength+f.byteLength,this.socket.write(b.VSBuffer.concat([O,f]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(f){if(f.byteLength!==0){for(this._totalIncomingWireBytes+=f.byteLength,this._incomingData.acceptChunk(f);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const L=this._incomingData.peek(this._state.readLen),O=(L.readUInt8(0)&128)>>>7,B=L.readUInt8(1),q=(B&128)>>>7,x=B&127;this._state.state=2,this._state.readLen=2+(q?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=O,this._state.mask=0}else if(this._state.state===2){const L=this._incomingData.read(this._state.readLen),T=L.readUInt8(1),O=(T&128)>>>7;let B=T&127,q=1;B===126?B=L.readUInt8(++q)*2**8+L.readUInt8(++q):B===127&&(B=L.readUInt8(++q)*0+L.readUInt8(++q)*0+L.readUInt8(++q)*0+L.readUInt8(++q)*0+L.readUInt8(++q)*2**24+L.readUInt8(++q)*2**16+L.readUInt8(++q)*2**8+L.readUInt8(++q));let x=0;O&&(x=L.readUInt8(++q)*2**24+L.readUInt8(++q)*2**16+L.readUInt8(++q)*2**8+L.readUInt8(++q)),this._state.state=3,this._state.readLen=B,this._state.mask=x}else if(this._state.state===3){const L=this._incomingData.read(this._state.readLen);h(L,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(L.buffer)),this._zlibInflate.write(L.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const T=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=T.length,this._onData.fire(b.VSBuffer.wrap(T))})):(this._totalIncomingDataBytes+=L.byteLength,this._onData.fire(L))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=l;function h(v,f){if(f===0)return;let L=v.byteLength>>>2;for(let ie=0;ie<L;ie++){const V=v.readUInt32BE(ie*4);v.writeUInt32BE(V^f,ie*4)}let T=L*4,O=v.byteLength-T;const B=f>>>24&255,q=f>>>16&255,x=f>>>8&255;O>=1&&v.writeUInt8(v.readUInt8(T)^B,T),O>=2&&v.writeUInt8(v.readUInt8(T+1)^q,T+1),O>=3&&v.writeUInt8(v.readUInt8(T+2)^x,T+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function u(){const v=(0,m.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;let f;return e.XDG_RUNTIME_DIR?f=(0,n.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${v}.sock`):f=(0,n.join)((0,p.tmpdir)(),`vscode-ipc-${v}.sock`),s(f),f}e.createRandomIPCHandle=u;function t(v,f,L){const T=(0,g.createHash)("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${L}-${f}-sock`;let O;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?O=(0,n.join)(e.XDG_RUNTIME_DIR,`vscode-${T.substr(0,8)}-${L}-${f}.sock`):O=(0,n.join)(v,`${L}-${f}.sock`),s(O),O}e.createStaticIPCHandle=t;function s(v){const f=o[d.platform];typeof f=="number"&&v.length>=f&&console.warn(`WARNING: IPC handle "${v}" is longer than ${f} chars, try a shorter --user-data-dir`)}class r extends E.IPCServer{constructor(f){super(r.toClientConnectionEvent(f));this.server=f}static toClientConnectionEvent(f){const L=S.Event.fromNodeEventEmitter(f,"connection");return S.Event.map(L,T=>({protocol:new k.Protocol(new w(T)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(T,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function a(v){return new Promise((f,L)=>{const T=(0,M.createServer)();T.on("error",L),T.listen(v,()=>{T.removeListener("error",L),f(new r(T))})})}e.serve=a;function c(v,f){return new Promise((L,T)=>{const O=(0,M.createConnection)(v,()=>{O.removeListener("error",T),L(k.Client.fromSocket(new w(O),f))});O.once("error",T)})}e.connect=c}),define(J[218],Z([0,1,56]),function(j,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class M{constructor(p){this.driver=p}listen(p,m){throw new Error("No event found")}call(p,m,i){switch(m){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(i);case"getLocalizedStrings":return this.driver.getLocalizedStrings(i)}throw new Error(`Call not found: ${m}`)}}e.DriverChannel=M;class D{constructor(p){this.channel=p}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(p){return this.channel.call("capturePage",p)}reloadWindow(p){return this.channel.call("reloadWindow",p)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(p,m){return this.channel.call("dispatchKeybinding",[p,m])}click(p,m,i,b){return this.channel.call("click",[p,m,i,b])}doubleClick(p,m){return this.channel.call("doubleClick",[p,m])}setValue(p,m,i){return this.channel.call("setValue",[p,m,i])}getTitle(p){return this.channel.call("getTitle",[p])}isActiveElement(p,m){return this.channel.call("isActiveElement",[p,m])}getElements(p,m,i){return this.channel.call("getElements",[p,m,i])}getElementXY(p,m,i,b){return this.channel.call("getElementXY",[p,m,i,b])}typeInEditor(p,m,i){return this.channel.call("typeInEditor",[p,m,i])}getTerminalBuffer(p,m){return this.channel.call("getTerminalBuffer",[p,m])}writeInTerminal(p,m,i){return this.channel.call("writeInTerminal",[p,m,i])}getLocaleInfo(p){return this.channel.call("getLocaleInfo",p)}getLocalizedStrings(p){return this.channel.call("getLocalizedStrings",p)}}e.DriverChannelClient=D;class S{constructor(p){this.registry=p}listen(p,m){throw new Error(`Event not found: ${m}`)}call(p,m,i){switch(m){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${m}`)}}e.WindowDriverRegistryChannel=S;async function E(n){const p=await(0,g.connect)(n,"driverClient"),m=p.getChannel("driver"),i=new D(m);return{client:p,driver:i}}e.connect=E}),define(J[24],Z([0,1,8,47,4,48,161,56]),function(j,e,g,M,D,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,D.refineServiceDecorator)(S.IEnvironmentService);class p extends E.NativeEnvironmentService{get cachedLanguagesPath(){return(0,g.join)(this.userDataPath,"clp")}get backupHome(){return(0,g.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,g.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,n.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,g.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}}ce([M.memoize],p.prototype,"cachedLanguagesPath",null),ce([M.memoize],p.prototype,"backupHome",null),ce([M.memoize],p.prototype,"backupWorkspacesPath",null),ce([M.memoize],p.prototype,"mainIPCHandle",null),ce([M.memoize],p.prototype,"mainLockfile",null),ce([M.memoize],p.prototype,"sandbox",null),ce([M.memoize],p.prototype,"driverVerbose",null),ce([M.memoize],p.prototype,"disableUpdates",null),ce([M.memoize],p.prototype,"disableKeytar",null),ce([M.memoize],p.prototype,"codeCachePath",null),e.EnvironmentMainService=p}),define(J[219],Z([0,1,29,58,8,3,18,52,24,21,19,6,27,7,30,10,15]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let I=class{constructor(h,o,u){this.configurationService=o,this.logService=u,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=P.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,s)=>(0,d.isEqual)(t,s,!S.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await E.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let o=[];try{Array.isArray(h.rootURIWorkspaces)&&(o=h.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:y.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(o);let u=[];try{Array.isArray(h.folderURIWorkspaces)&&(u=h.folderURIWorkspaces.map(t=>y.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(u),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==i.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===i.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||i.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,o){this.workspaces.some(t=>h.workspace.id===t.workspace.id)||(this.workspaces.push(h),this.saveSync());const u=this.getBackupPath(h.workspace.id);return o&&this.moveBackupFolderSync(u,o),u}moveBackupFolderSync(h,o){if(g.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),g.existsSync(o))try{g.renameSync(o,h)}catch(u){this.logService.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}unregisterWorkspaceBackupSync(h){const o=h.id,u=this.workspaces.findIndex(t=>t.workspace.id===o);u!==-1&&(this.workspaces.splice(u,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(o=>this.backupUriComparer.isEqual(h,o))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const o=this.folders.findIndex(u=>this.backupUriComparer.isEqual(h,u));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(h,o){const u=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,u))||(this.emptyWindows.push({backupFolder:u,remoteAuthority:o}),this.saveSync()),this.getBackupPath(u)}unregisterEmptyWindowBackupSync(h){const o=this.emptyWindows.findIndex(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,h));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(h){return(0,D.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const o=new Set,u=[];for(let t of h){const s=t.workspace;if(!(0,k.isWorkspaceIdentifier)(s))return[];if(!o.has(s.id)){o.add(s.id);const r=this.getBackupPath(s.id);await this.doHasBackups(r)?s.configPath.scheme!==w.Schemas.file||await E.Promises.exists(s.configPath.fsPath)?u.push(t):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return u}async validateFolders(h){if(!Array.isArray(h))return[];const o=[],u=new Set;for(let t of h){const s=this.backupUriComparer.getComparisonKey(t);if(!u.has(s)){u.add(s);const r=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(r)?t.scheme!==w.Schemas.file||await E.Promises.exists(t.fsPath)?o.push(t):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return o}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const o=[],u=new Set;for(let t of h){const s=t.backupFolder;if(typeof s!="string")return[];if(!u.has(s)){u.add(s);const r=this.getBackupPath(s);await this.doHasBackups(r)?o.push(t):await this.deleteStaleBackup(r)}}return o}async deleteStaleBackup(h){try{await E.Promises.exists(h)&&await E.Promises.rm(h,E.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const u=this.getBackupPath(o);try{await E.Promises.rename(h,u)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const u=this.getBackupPath(o);try{g.renameSync(h,u)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const h=[];for(const o of this.workspaces)await this.hasBackups(o)&&h.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&h.push(o);return h}hasBackups(h){let o;return y.URI.isUri(h)?o=this.getBackupPath(this.getFolderHash(h)):(0,n.isWorkspaceBackupInfo)(h)?o=this.getBackupPath(h.workspace.id):o=h.backupFolder,this.doHasBackups(o)}async doHasBackups(h){try{const o=await E.Promises.readdir(h);for(const u of o)try{if((await E.Promises.readdir((0,D.join)(h,u))).length>0)return!0}catch(t){}}catch(o){}return!1}saveSync(){try{(0,E.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await E.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderURIWorkspaces:this.folders.map(h=>h.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){let o;return h.scheme===w.Schemas.file?o=S.isLinux?h.fsPath:h.fsPath.toLowerCase():o=h.toString().toLowerCase(),(0,M.createHash)("md5").update(o).digest("hex")}};I=ce([ee(0,p.IEnvironmentMainService),ee(1,m.IConfigurationService),ee(2,b.ILogService)],I),e.BackupMainService=I}),define(J[220],Z([0,1,59,56]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,S,E,n){const p=i=>n(i,void 0),m=g.createConnection({host:D,port:S},()=>{m.removeListener("error",p);const i=Buffer.alloc(16);for(let d=0;d<16;d++)i[d]=Math.round(Math.random()*256);const b=i.toString("base64");let k=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${S}/?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${b}`];m.write(k.join(`\r
`)+`\r
\r
`);const y=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",y),n(void 0,new M.NodeSocket(m)))};m.on("data",y)});m.once("error",p)}}}),define(J[221],Z([0,1,59,9,2,116,21,6,20,192,74,220,75]),function(j,e,g,M,D,S,E,n,p,m,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function y(I,l,h,o,u){return new d(I,l,h,o,u).waitForReady()}class d extends D.Disposable{constructor(l,h,o,u,t){super();this.defaultTunnelHost=h,this.suggestedLocalPort=t,this.public=!1,this._socketsDispose=new Map,this._options=l,this._server=g.createServer(),this._barrier=new M.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=u,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let l=await(0,S.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(l=0,this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(l){l.pause();const h=await(0,m.connectRemoteAgentTunnel)(this._options,this.tunnelRemotePort),o=h.getSocket().socket,u=h.readEntireBuffer();h.dispose(),u.byteLength>0&&l.write(u.buffer),l.on("end",()=>{this._socketsDispose.delete(l.localAddress),o.end()}),l.on("close",()=>o.end()),l.on("error",()=>{this._socketsDispose.delete(l.localAddress),o.destroy()}),o.on("end",()=>l.end()),o.on("close",()=>l.end()),o.on("error",()=>{l.destroy()}),l.pipe(o),o.pipe(l),this._socketsDispose.set(l.localAddress,()=>{l.end(),o.end()})}}let w=class extends i.AbstractTunnelService{constructor(l,h,o,u,t){super(h);this.socketFactory=l,this.signService=o,this.productService=u,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(l,h,o,u,t,s,r){const a=this.getTunnelFromMap(h,o);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,o,u,t,s,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${o} on local port ${u}.`);const c={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:l,signService:this.signService,logService:this.logService,ipcLogger:null},v=y(c,this.defaultTunnelHost,h,o,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,o,v),v}}};w=ce([ee(1,n.ILogService),ee(2,k.ISignService),ee(3,p.IProductService),ee(4,E.IConfigurationService)],w),e.BaseTunnelService=w;let P=class extends w{constructor(l,h,o,u){super(b.nodeSocketFactory,l,h,o,u)}};P=ce([ee(0,n.ILogService),ee(1,k.ISignService),ee(2,p.IProductService),ee(3,E.IConfigurationService)],P),e.TunnelService=P}),define(J[222],Z([0,1,217,194,2,13,16,193,21,6,17,48,91]),function(j,e,g,M,D,S,E,n,p,m,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let y=class extends D.Disposable{constructor(w,P,I){super();this.environmentService=P,this.logService=I,this.configure(w.getValue()),this._register(w.onDidChangeConfiguration(()=>this.configure(w.getValue()),this))}configure(w){this.proxyUrl=w.http&&w.http.proxy,this.strictSSL=!!(w.http&&w.http.proxyStrictSSL),this.authorization=w.http&&w.http.proxyAuthorization}async request(w,P){this.logService.trace("RequestService#request",w.url);const{proxyUrl:I,strictSSL:l}=this,h={...process.env,...await(0,k.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},o=w.agent?w.agent:await(0,n.getProxyAgent)(w.url||"",h,{proxyUrl:I,strictSSL:l});return w.agent=o,w.strictSSL=l,this.authorization&&(w.headers={...w.headers||{},"Proxy-Authorization":this.authorization}),this._request(w,P)}async getNodeRequest(w){return((0,M.parse)(w.url).protocol==="https:"?await new Promise((l,h)=>{j(["https"],l,h)}):await new Promise((l,h)=>{j(["http"],l,h)})).request}_request(w,P){return new Promise(async(I,l)=>{let h;const o=(0,M.parse)(w.url),u=w.getRawRequest?w.getRawRequest(w):await this.getNodeRequest(w),t={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:w.type||"GET",headers:w.headers,agent:w.agent,rejectUnauthorized:(0,S.isBoolean)(w.strictSSL)?w.strictSSL:!0};w.user&&w.password&&(t.auth=w.user+":"+w.password),h=u(t,s=>{const r=(0,S.isNumber)(w.followRedirects)?w.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&r>0&&s.headers.location)this._request({...w,url:s.headers.location,followRedirects:r-1},P).then(I,l);else{let a=s;s.headers["content-encoding"]==="gzip"&&(a=s.pipe((0,g.createGunzip)())),I({res:s,stream:(0,i.streamToBufferReadableStream)(a)})}}),h.on("error",l),w.timeout&&h.setTimeout(w.timeout),w.data&&typeof w.data=="string"&&h.write(w.data),h.end(),P.onCancellationRequested(()=>{h.abort(),l((0,E.canceled)())})})}async resolveProxy(w){}};y=ce([ee(0,p.IConfigurationService),ee(1,b.INativeEnvironmentService),ee(2,m.ILogService)],y),e.RequestService=y}),define(J[223],Z([0,1,222,14]),function(j,e,g,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(E){return M.net.request}class S extends g.RequestService{request(n,p){return super.request({...n||{},getRawRequest:D},p)}}e.RequestMainService=S}),define(J[224],Z([0,1,49,14,24,9,6,22,60,10,3,2,85,13,5,55]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let P=class extends b.Disposable{constructor(l,h,o,u,t,s,r){super();this.machineId=l,this.userEnv=h,this.environmentMainService=o,this.lifecycleMainService=u,this.logService=t,this.themeMainService=s,this.protocolMainService=r,this.firstWindowConnectionBarrier=new S.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new d.Emitter),this.onDidError=d.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),M.ipcMain.on("vscode:createSharedProcessMessageChannel",async(l,h)=>this.onWindowConnection(l,h))}async onWindowConnection(l,h){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const o=await this.connect();if(l.sender.isDestroyed())return o.close();l.sender.postMessage("vscode:createSharedProcessMessageChannelResult",h,[o])}onWillShutdown(){const l=this.window;!l||(!l.isDestroyed()&&!l.webContents.isDestroyed()&&l.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(l.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{l.close()}catch(h){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(l=>M.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),l()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(l=>M.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),l()}))})()),this._whenIpcReady}createWindow(){const l=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new M.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`],v8CacheOptions:i.browserCodeLoadingCacheStrategy,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),l.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:g.default}),this.window.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=l=>{this.logService.trace("SharedProcess#close prevented"),l.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(l,h)=>this._onDidError.fire({type:2,details:h})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(l,h,o)=>this._onDidError.fire({type:3,details:{reason:o,exitCode:h}})))}async connect(){await this.whenIpcReady;const l=(0,y.assertIsDefined)(this.window);return(0,k.connect)(l)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};P=ce([ee(2,D.IEnvironmentMainService),ee(3,n.ILifecycleMainService),ee(4,E.ILogService),ee(5,p.IThemeMainService),ee(6,w.IProtocolMainService)],P),e.SharedProcess=P}),define(J[225],Z([0,1,7,8,13,6,24,9,19,17]),function(j,e,g,M,D,S,E,n,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(y,d,w){this.storagePath=y,this.logService=d,this.fileService=w,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new n.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,d){const w=this.storage[y];return(0,D.isUndefinedOrNull)(w)?d:w}setItem(y,d){this.setItems([{key:y,data:d}])}setItems(y){let d=!1;for(const{key:w,data:P}of y)this.storage[w]!==P&&((0,D.isUndefinedOrNull)(P)?(0,D.isUndefined)(this.storage[w])||(this.storage[w]=void 0,d=!0):(this.storage[w]=P,d=!0));d&&this.save()}removeItem(y){(0,D.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(y){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),y)}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,m.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(d){this.logService.error(d)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let b=class yt{constructor(y,d,w){this.fileStorage=new i(g.URI.file((0,M.join)(y.userDataPath,yt.STATE_FILE)),d,w)}async init(){return this.fileStorage.init()}getItem(y,d){return this.fileStorage.getItem(y,d)}setItem(y,d){this.fileStorage.setItem(y,d)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}};b.STATE_FILE="storage.json",b=ce([ee(0,E.IEnvironmentMainService),ee(1,S.ILogService),ee(2,p.IFileService)],b),e.StateMainService=b}),define(J[77],Z([0,1,5,9,21,22,20,42,24,6,51,25]),function(j,e,g,M,D,S,E,n,p,m,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function k(d,w,P){return`${P.updateUrl}/api/update/${d}/${w}/${P.commit}`}e.createUpdateURL=k;let y=class{constructor(w,P,I,l,h,o){this.lifecycleMainService=w,this.configurationService=P,this.environmentMainService=I,this.requestService=l,this.logService=h,this.productService=o,this._state=n.State.Uninitialized,this._onStateChange=new g.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const w=(0,D.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),P=this.getProductQuality(w);if(!P){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(P),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(n.State.Idle(this.getUpdateType())),w==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,I=>this.logService.error(I))}getProductQuality(w){return w==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(w=60*60*1e3){return(0,M.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(w){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},b.CancellationToken.None).then(w=>w.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};y=ce([ee(0,S.ILifecycleMainService),ee(1,D.IConfigurationService),ee(2,p.IEnvironmentMainService),ee(3,i.IRequestService),ee(4,m.ILogService),ee(5,E.IProductService)],y),e.AbstractUpdateService=y}),define(J[226],Z([0,1,14,2,5,47,21,22,42,32,24,6,77,51,20]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=class extends k.AbstractUpdateService{constructor(I,l,h,o,u,t,s){super(I,l,o,u,t,s);this.telemetryService=h,this.disposables=new M.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(g.autoUpdater,"error",(I,l)=>l)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(g.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(g.autoUpdater,"update-available",(I,l,h)=>({url:l,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(g.autoUpdater,"update-downloaded",(I,l,h,o)=>({releaseNotes:l,version:h,productVersion:h,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(I){this.logService.error("UpdateService error:",I);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?I:void 0;this.setState(p.State.Idle(1,h))}buildUpdateFeedUrl(I){let l;this.productService.darwinUniversalAssetId?l=this.productService.darwinUniversalAssetId:l=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,k.createUpdateURL)(l,I,this.productService);try{g.autoUpdater.setFeedURL({url:h})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return h}doCheckForUpdates(I){this.setState(p.State.CheckingForUpdates(I)),g.autoUpdater.checkForUpdates()}onUpdateAvailable(I){this.state.type==="checking for updates"&&this.setState(p.State.Downloading(I))}onUpdateDownloaded(I){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:I.version}),this.setState(p.State.Ready(I)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(p.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),g.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ce([S.memoize],w.prototype,"onRawError",null),ce([S.memoize],w.prototype,"onRawUpdateNotAvailable",null),ce([S.memoize],w.prototype,"onRawUpdateAvailable",null),ce([S.memoize],w.prototype,"onRawUpdateDownloaded",null),w=ce([ee(0,n.ILifecycleMainService),ee(1,E.IConfigurationService),ee(2,m.ITelemetryService),ee(3,i.IEnvironmentMainService),ee(4,y.IRequestService),ee(5,b.ILogService),ee(6,d.IProductService)],w),e.DarwinUpdateService=w}),define(J[227],Z([0,1,5,9,22,42,24,6,8,29,41,32]),function(j,e,g,M,D,S,E,n,p,m,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let k=class{constructor(w,P,I){if(this.lifecycleMainService=w,this.logService=I,this._state=S.State.Uninitialized,this._onStateChange=new g.Emitter,this.onStateChange=this._onStateChange.event,P.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(S.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,l=>this.logService.error(l))}get state(){return this._state}setState(w){this.logService.info("update#setState",w.type),this._state=w,this._onStateChange.fire(w)}scheduleCheckForUpdates(w=60*60*1e3){return(0,M.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(w){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(w)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(w){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(w=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};k=ce([ee(0,D.ILifecycleMainService),ee(1,E.IEnvironmentMainService),ee(2,n.ILogService)],k);let y=class extends k{constructor(w,P,I,l,h,o){super(I,l,h);this.snap=w,this.snapRevision=P,this.telemetryService=o;const u=(0,m.watch)(p.dirname(this.snap)),t=g.Event.fromNodeEventEmitter(u,"change",(c,v)=>v),s=g.Event.filter(t,c=>c==="current"),a=g.Event.debounce(s,(c,v)=>v,2e3)(()=>this.checkForUpdates(!1));I.onWillShutdown(()=>{a.dispose(),u.close()})}doCheckForUpdates(){this.setState(S.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(w=>{w?this.setState(S.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2)))},w=>{this.logService.error(w),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2,w.message||w))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,i.spawn)("sleep 3 && "+p.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const w=await new Promise((I,l)=>(0,m.realpath)(`${p.dirname(this.snap)}/current`,(h,o)=>h?l(h):I(o))),P=p.basename(w);return this.snapRevision!==P}isLatestVersion(){return this.isUpdateAvailable().then(void 0,w=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};y=ce([ee(2,D.ILifecycleMainService),ee(3,E.IEnvironmentMainService),ee(4,n.ILogService),ee(5,b.ITelemetryService)],y),e.SnapUpdateService=y}),define(J[45],Z([0,1,27,24,8,18,29,3,5,6,101,40,10,2,15,4,154,20,14,13,52,53,100,31]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w,P,I,l,h,o,u,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,w.createDecorator)("workspacesManagementMainService");let r=class extends y.Disposable{constructor(c,v,f,L,T){super();this.environmentMainService=c,this.logService=v,this.backupMainService=f,this.dialogMainService=L,this.productService=T,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new p.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new p.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(c){return this.doResolveLocalWorkspace(c,v=>(0,E.readFileSync)(v,"utf8"))}resolveLocalWorkspace(c){return this.doResolveLocalWorkspace(c,v=>S.Promises.readFile(v,"utf8"))}doResolveLocalWorkspace(c,v){if(!!this.isWorkspacePath(c)&&c.scheme===k.Schemas.file)try{const f=v(c.fsPath);return f instanceof Promise?f.then(L=>this.doResolveWorkspace(c,L),L=>{}):this.doResolveWorkspace(c,f)}catch{return}}isWorkspacePath(c){return(0,g.isUntitledWorkspace)(c,this.environmentMainService)||(0,g.hasWorkspaceFileExtension)(c)}doResolveWorkspace(c,v){try{const f=this.doParseStoredWorkspace(c,v),L=(0,i.getWorkspaceIdentifier)(c);return{id:L.id,configPath:L.configPath,folders:(0,g.toWorkspaceFolders)(f.folders,L.configPath,d.extUriBiasedIgnorePathCase),remoteAuthority:f.remoteAuthority,transient:f.transient}}catch(f){this.logService.warn(f.toString())}}doParseStoredWorkspace(c,v){const f=(0,b.parse)(v);if(f&&Array.isArray(f.folders))f.folders=f.folders.filter(L=>(0,g.isStoredWorkspaceFolder)(L));else throw new Error(`${c.toString(!0)} looks like an invalid workspace file.`);return f}async createUntitledWorkspace(c,v){const{workspace:f,storedWorkspace:L}=this.newUntitledWorkspace(c,v),T=f.configPath.fsPath;return await S.Promises.mkdir((0,D.dirname)(T),{recursive:!0}),await S.Promises.writeFile(T,JSON.stringify(L,null,"	")),f}createUntitledWorkspaceSync(c,v){const{workspace:f,storedWorkspace:L}=this.newUntitledWorkspace(c,v),T=f.configPath.fsPath;return(0,E.mkdirSync)((0,D.dirname)(T),{recursive:!0}),(0,S.writeFileSync)(T,JSON.stringify(L,null,"	")),f}newUntitledWorkspace(c=[],v){const f=(Date.now()+Math.round(Math.random()*1e3)).toString(),L=(0,d.joinPath)(this.untitledWorkspacesHome,f),T=(0,d.joinPath)(L,g.UNTITLED_WORKSPACE_NAME),O=[];for(const B of c)O.push((0,g.getStoredWorkspaceFolder)(B.uri,!0,B.name,L,!n.isWindows,d.extUriBiasedIgnorePathCase));return{workspace:(0,i.getWorkspaceIdentifier)(T),storedWorkspace:{folders:O,remoteAuthority:v}}}async getWorkspaceIdentifier(c){return(0,i.getWorkspaceIdentifier)(c)}isUntitledWorkspace(c){return(0,g.isUntitledWorkspace)(c.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(c){!this.isUntitledWorkspace(c)||(this.doDeleteUntitledWorkspaceSync(c),this._onDidDeleteUntitledWorkspace.fire(c))}async deleteUntitledWorkspace(c){this.deleteUntitledWorkspaceSync(c)}doDeleteUntitledWorkspaceSync(c){const v=(0,d.originalFSPath)(c.configPath);try{(0,S.rimrafSync)((0,D.dirname)(v));const f=(0,D.join)(this.environmentMainService.workspaceStorageHome.fsPath,c.id);(0,E.existsSync)(f)&&(0,S.writeFileSync)((0,D.join)(f,"obsolete"),"")}catch(f){this.logService.warn(`Unable to delete untitled workspace ${v} (${f}).`)}}getUntitledWorkspacesSync(){const c=[];try{const v=(0,S.readdirSync)(this.untitledWorkspacesHome.fsPath).map(f=>(0,d.joinPath)(this.untitledWorkspacesHome,f,g.UNTITLED_WORKSPACE_NAME));for(const f of v){const L=(0,i.getWorkspaceIdentifier)(f),T=this.resolveLocalWorkspaceSync(f);T?c.push({workspace:L,remoteAuthority:T.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(L)}}catch(v){v.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${v}).`)}return c}async enterWorkspace(c,v,f){if(!c||!c.win||!c.isReady||!await this.isValidTargetWorkspacePath(c,v,f))return;const T=this.doEnterWorkspace(c,(0,i.getWorkspaceIdentifier)(f));if(!!T)return this._onDidEnterWorkspace.fire({window:c,workspace:T.workspace}),T}async isValidTargetWorkspacePath(c,v,f){if(!f)return!0;if((0,g.isWorkspaceIdentifier)(c.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(c.openedWorkspace.configPath,f))return!1;if((0,t.findWindowOnWorkspaceOrFolder)(v,f)){const L={title:this.productService.nameLong,type:"info",buttons:[(0,s.mnemonicButtonLabel)((0,P.localize)(0,null))],message:(0,P.localize)(1,null,(0,d.basename)(f)),detail:(0,P.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(L,(0,h.withNullAsUndefined)(l.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(c,v){if(!c.config)return;c.focus();let f;return c.config.extensionDevelopmentPath||(f=this.backupMainService.registerWorkspaceBackupSync({workspace:v,remoteAuthority:c.remoteAuthority},c.config.backupPath)),(0,g.isWorkspaceIdentifier)(c.openedWorkspace)&&this.isUntitledWorkspace(c.openedWorkspace)&&this.deleteUntitledWorkspaceSync(c.openedWorkspace),c.config.workspace=v,c.config.backupPath=f,{workspace:v,backupPath:f}}};r=ce([ee(0,M.IEnvironmentMainService),ee(1,m.ILogService),ee(2,o.IBackupMainService),ee(3,u.IDialogMainService),ee(4,I.IProductService)],r),e.WorkspacesManagementMainService=r}),define(J[102],Z([0,1,6,98,3,4,35,18,45,21,7,14,36,54,25,27,13]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,S.createDecorator)(e.ID);let I=class{constructor(h,o,u,t,s){this.logService=h,this.windowsMainService=o,this.urlService=u,this.workspacesManagementMainService=t,this.configurationService=s}async start(h,o){this.logService.trace("Received data from other instance: ",h,o),D.isMacintosh&&b.app.focus({steal:!0});const u=this.parseOpenUrl(h);if(u.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:s,url:r}of u)this.urlService.open(s,{originalUrl:r})})}else return this.startOpenWindow(h,o)}parseOpenUrl(h){return h["open-url"]&&h._urls&&h._urls.length>0?(0,k.coalesce)(h._urls.map(o=>{try{return{uri:i.URI.parse(o),url:o}}catch(u){return null}})):[]}async startOpenWindow(h,o){const u=(0,y.isLaunchedFromCli)(o)?0:4;let t=[];const s=h.wait&&h.waitMarkerFilePath?i.URI.file(h.waitMarkerFilePath):void 0,r=h.remote||void 0;if(h.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(h.extensionDevelopmentPath,{context:u,cli:h,userEnv:o,waitMarkerFileURI:s,remoteAuthority:r});else if(!h._.length&&!h["folder-uri"]&&!h["file-uri"]){let a=!1;if(h["new-window"]||h["unity-launch"])a=!0;else if(h["reuse-window"])a=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!D.isMacintosh}if(a)t=this.windowsMainService.open({context:u,cli:h,userEnv:o,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:s,remoteAuthority:r});else{const c=this.windowsMainService.getLastActiveWindow();c?(c.focus(),t=[c]):t=this.windowsMainService.open({context:u,cli:h,forceEmpty:!0,remoteAuthority:r})}}else t=this.windowsMainService.open({context:u,cli:h,userEnv:o,forceNewWindow:h["new-window"],preferNewWindow:!h["reuse-window"]&&!h.wait,forceReuseWindow:h["reuse-window"],diffMode:h.diff,addMode:h.add,noRecentEntry:!!h["skip-add-to-recently-opened"],waitMarkerFileURI:s,gotoLineMode:h.goto,remoteAuthority:r});if(s&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,n.whenDeleted)(s.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const h=[];return b.BrowserWindow.getAllWindows().forEach(o=>{const u=this.windowsMainService.getWindowById(o.id);u?h.push(this.codeWindowToInfo(u)):h.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!b.app.accessibilitySupportEnabled,gpuFeatureStatus:b.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(h){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(t=>new Promise(s=>{const r=t.remoteAuthority;if(r){const a=`vscode:getDiagnosticInfoResponse${t.id}`,c={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",d.CancellationToken.None,{replyChannel:a,args:c}),b.ipcMain.once(a,(v,f)=>{f||s({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),s(f)}),setTimeout(()=>{s({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else s(void 0)})))).filter(t=>!!t)}getFolderURIs(h){const o=[],u=h.openedWorkspace;if((0,w.isSingleFolderWorkspaceIdentifier)(u))o.push(u.uri);else if((0,w.isWorkspaceIdentifier)(u)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);t&&t.folders.forEach(r=>{o.push(r.uri)})}return o}codeWindowToInfo(h){const o=this.getFolderURIs(h),u=(0,P.assertIsDefined)(h.win);return this.browserWindowToInfo(u,o,h.remoteAuthority)}browserWindowToInfo(h,o=[],u){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:o,remoteAuthority:u}}};I=ce([ee(0,g.ILogService),ee(1,E.IWindowsMainService),ee(2,M.IURLService),ee(3,p.IWorkspacesManagementMainService),ee(4,m.IConfigurationService)],I),e.LaunchMainService=I}),define(J[46],Z([0,1,41,115,146,82,5,35,14,22,3,24,53,18,7,32,4,26,66,6,8,20,47,2,60,31,27,10,45]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w,P,I,l,h,o,u,t,s,r,a,c,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,P.createDecorator)("nativeHostMainService");let L=class lt extends s.Disposable{constructor(O,B,q,x,ie,V,Y,U,N,F){super();this.sharedProcess=O,this.windowsMainService=B,this.dialogMainService=q,this.lifecycleMainService=x,this.environmentMainService=ie,this.telemetryService=V,this.logService=Y,this.productService=U,this.themeMainService=N,this.workspacesManagementMainService=F,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,$=>$.id),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(p.app,"browser-window-maximize",($,W)=>W.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(p.app,"browser-window-unmaximize",($,W)=>W.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(p.app,"browser-window-blur",($,W)=>W.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),$=>!!$),$=>$.id),E.Event.filter(E.Event.fromNodeEventEmitter(p.app,"browser-window-focus",($,W)=>W.id),$=>!!this.windowsMainService.getWindowById($))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(p.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new E.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(p.screen,"display-metrics-changed",($,W,R)=>R),$=>!(Array.isArray($)&&$.length===1&&$[0]==="workArea")),E.Event.fromNodeEventEmitter(p.screen,"display-added"),E.Event.fromNodeEventEmitter(p.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){p.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors,dark:p.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(B=>({id:B.id,workspace:B.openedWorkspace,title:B.win?.getTitle()??"",filename:B.getRepresentedFilename(),dirty:B.isDocumentEdited()}))}async getWindowCount(O){return this.windowsMainService.getWindowCount()}async getActiveWindowId(O){const B=p.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(B)return B.id}openWindow(O,B,q){return Array.isArray(B)?this.doOpenWindow(O,B,q):this.doOpenEmptyWindow(O,B)}async doOpenWindow(O,B,q=Object.create(null)){B.length>0&&this.windowsMainService.open({context:5,contextWindowId:O,urisToOpen:B,cli:this.environmentMainService.args,forceNewWindow:q.forceNewWindow,forceReuseWindow:q.forceReuseWindow,preferNewWindow:q.preferNewWindow,diffMode:q.diffMode,addMode:q.addMode,gotoLineMode:q.gotoLineMode,noRecentEntry:q.noRecentEntry,waitMarkerFileURI:q.waitMarkerFileURI,remoteAuthority:q.remoteAuthority||void 0})}async doOpenEmptyWindow(O,B){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:O},B)}async toggleFullScreen(O){const B=this.windowById(O);B&&B.toggleFullScreen()}async handleTitleDoubleClick(O){const B=this.windowById(O);B&&B.handleTitleDoubleClick()}async isMaximized(O){const B=this.windowById(O);return B?.win?B.win.isMaximized():!1}async maximizeWindow(O){const B=this.windowById(O);B?.win&&B.win.maximize()}async unmaximizeWindow(O){const B=this.windowById(O);B?.win&&B.win.unmaximize()}async minimizeWindow(O){const B=this.windowById(O);B?.win&&B.win.minimize()}async focusWindow(O,B){B&&typeof B.windowId=="number"&&(O=B.windowId);const q=this.windowById(O);q&&q.focus({force:B?.force??!1})}async setMinimumSize(O,B,q){const x=this.windowById(O);if(x?.win){const[ie,V]=x.win.getSize(),[Y,U]=x.win.getMinimumSize(),[N,F]=[B??Y,q??U],[$,W]=[Math.max(ie,N),Math.max(V,F)];(Y!==N||U!==F)&&x.win.setMinimumSize(N,F),(ie!==$||V!==W)&&x.win.setSize($,W)}}async saveWindowSplash(O,B){this.themeMainService.saveWindowSplash(O,B)}async installShellCommand(O){const{source:B,target:q}=await this.getShellCommandLink();try{const{symbolicLink:x}=await y.SymlinkSupport.stat(B);if(x&&!x.dangling){const ie=await(0,S.realpath)(B);if(q===ie)return}await y.Promises.unlink(B)}catch(x){if(x.code!=="ENOENT")throw x}try{await y.Promises.symlink(q,B)}catch(x){if(x.code!=="EACCES"&&x.code!=="ENOENT")throw x;const{response:ie}=await this.showMessageBox(O,{title:this.productService.nameLong,type:"info",message:(0,D.localize)(0,null,this.productService.nameShort),buttons:[(0,a.mnemonicButtonLabel)((0,D.localize)(1,null)),(0,a.mnemonicButtonLabel)((0,D.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ie===0)try{const V=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${q}' '${B}'\\" with administrator privileges"`;await(0,M.promisify)(g.exec)(V)}catch(V){throw new Error((0,D.localize)(3,null,B))}}}async uninstallShellCommand(O){const{source:B}=await this.getShellCommandLink();try{await y.Promises.unlink(B)}catch(q){switch(q.code){case"EACCES":const{response:x}=await this.showMessageBox(O,{title:this.productService.nameLong,type:"info",message:(0,D.localize)(4,null,this.productService.nameShort),buttons:[(0,a.mnemonicButtonLabel)((0,D.localize)(5,null)),(0,a.mnemonicButtonLabel)((0,D.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(x===0)try{const ie=`osascript -e "do shell script \\"rm '${B}'\\" with administrator privileges"`;await(0,M.promisify)(g.exec)(ie)}catch(ie){throw new Error((0,D.localize)(7,null,B))}break;case"ENOENT":break;default:throw q}}}async getShellCommandLink(){const O=(0,o.resolve)(this.environmentMainService.appRoot,"bin","code"),B=`/usr/local/bin/${this.productService.applicationName}`;if(!await y.Promises.exists(O))throw new Error((0,D.localize)(8,null,O));return{source:B,target:O}}async showMessageBox(O,B){return this.dialogMainService.showMessageBox(B,this.toBrowserWindow(O))}async showSaveDialog(O,B){return this.dialogMainService.showSaveDialog(B,this.toBrowserWindow(O))}async showOpenDialog(O,B){return this.dialogMainService.showOpenDialog(B,this.toBrowserWindow(O))}toBrowserWindow(O){const B=this.windowById(O);if(B?.win)return B.win}async pickFileFolderAndOpen(O,B){const q=await this.dialogMainService.pickFileFolder(B);q&&(this.sendPickerTelemetry(q,B.telemetryEventName||"openFileFolder",B.telemetryExtraData),this.doOpenPicked(await Promise.all(q.map(async x=>await y.SymlinkSupport.existsDirectory(x)?{folderUri:d.URI.file(x)}:{fileUri:d.URI.file(x)})),B,O))}async pickFolderAndOpen(O,B){const q=await this.dialogMainService.pickFolder(B);q&&(this.sendPickerTelemetry(q,B.telemetryEventName||"openFolder",B.telemetryExtraData),this.doOpenPicked(q.map(x=>({folderUri:d.URI.file(x)})),B,O))}async pickFileAndOpen(O,B){const q=await this.dialogMainService.pickFile(B);q&&(this.sendPickerTelemetry(q,B.telemetryEventName||"openFile",B.telemetryExtraData),this.doOpenPicked(q.map(x=>({fileUri:d.URI.file(x)})),B,O))}async pickWorkspaceAndOpen(O,B){const q=await this.dialogMainService.pickWorkspace(B);q&&(this.sendPickerTelemetry(q,B.telemetryEventName||"openWorkspace",B.telemetryExtraData),this.doOpenPicked(q.map(x=>({workspaceUri:d.URI.file(x)})),B,O))}doOpenPicked(O,B,q){this.windowsMainService.open({context:3,contextWindowId:q,cli:this.environmentMainService.args,urisToOpen:O,forceNewWindow:B.forceNewWindow})}sendPickerTelemetry(O,B,q){const x=O?O.length:0;this.telemetryService.publicLog(B,{...q,outcome:x?"success":"canceled",numberOfPaths:x})}async showItemInFolder(O,B){p.shell.showItemInFolder(B)}async setRepresentedFilename(O,B){const q=this.windowById(O);q&&q.setRepresentedFilename(B)}async setDocumentEdited(O,B){const q=this.windowById(O);q&&q.setDocumentEdited(B)}async openExternal(O,B){return i.isLinuxSnap?this.safeSnapOpenExternal(B):p.shell.openExternal(B),!0}safeSnapOpenExternal(O){const B=process.env.GDK_PIXBUF_MODULE_FILE,q=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,p.shell.openExternal(O),process.env.GDK_PIXBUF_MODULE_FILE=B,process.env.GDK_PIXBUF_MODULEDIR=q}moveItemToTrash(O,B){return p.shell.trashItem(B)}async isAdmin(){let O;return i.isWindows?O=(await new Promise((B,q)=>{j(["native-is-elevated"],B,q)}))():O=process.getuid()===0,O}async writeElevated(O,B,q,x){const ie=await new Promise((V,Y)=>{j(["sudo-prompt"],V,Y)});return new Promise((V,Y)=>{const U=[`"${this.cliPath}"`];x?.unlock&&U.push("--file-chmod"),U.push("--file-write",`"${B.fsPath}"`,`"${q.fsPath}"`);const N={name:this.productService.nameLong.replace("-",""),icns:i.isMacintosh&&this.environmentMainService.isBuilt?(0,o.join)((0,o.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ie.exec(U.join(" "),N,(F,$,W)=>{$&&this.logService.trace(`[sudo-prompt] received stdout: ${$}`),W&&this.logService.trace(`[sudo-prompt] received stderr: ${W}`),F?Y(F):V(void 0)})})}get cliPath(){return i.isWindows?this.environmentMainService.isBuilt?(0,o.join)((0,o.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,o.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):i.isLinux?this.environmentMainService.isBuilt?(0,o.join)((0,o.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,o.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,o.join)(this.environmentMainService.appRoot,"bin","code"):(0,o.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,I.totalmem)(),freemem:(0,I.freemem)(),loadavg:(0,I.loadavg)()}}async getOSProperties(){return{arch:(0,I.arch)(),platform:(0,I.platform)(),release:(0,I.release)(),type:(0,I.type)(),cpus:(0,I.cpus)()}}async getOSVirtualMachineHint(){return l.virtualMachineHint.value()}async killProcess(O,B,q){process.kill(B,q)}async readClipboardText(O,B){return p.clipboard.readText(B)}async writeClipboardText(O,B,q){return p.clipboard.writeText(B,q)}async readClipboardFindText(O){return p.clipboard.readFindText()}async writeClipboardFindText(O,B){return p.clipboard.writeFindText(B)}async writeClipboardBuffer(O,B,q,x){return p.clipboard.writeBuffer(B,Buffer.from(q),x)}async readClipboardBuffer(O,B){return p.clipboard.readBuffer(B)}async hasClipboard(O,B,q){return p.clipboard.has(B,q)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){p.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){p.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){p.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){p.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){p.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(O,B){const q=this.windowById(O);q&&q.updateTouchBar(B)}async notifyReady(O){const B=this.windowById(O);B&&B.setReady()}async relaunch(O,B){return this.lifecycleMainService.relaunch(B)}async reload(O,B){const q=this.windowById(O);if(q){if((0,c.isWorkspaceIdentifier)(q.openedWorkspace)){const x=q.openedWorkspace.configPath;if(x.scheme===v.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(x))?.transient)return this.openWindow(q.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(q,B?.disableExtensions!==void 0?{_:[],"disable-extensions":B.disableExtensions}:void 0)}}async closeWindow(O){this.closeWindowById(O,O)}async closeWindowById(O,B){const q=this.windowById(B);if(q?.win)return q.win.close()}async quit(O){const B=this.windowsMainService.getLastActiveWindow();B?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&B.win?B.win.close():this.lifecycleMainService.quit()}async exit(O,B){await this.lifecycleMainService.kill(B)}async resolveProxy(O,B){const x=this.windowById(O)?.win?.webContents?.session;if(x)return x.resolveProxy(B)}async openDevTools(O,B){const q=this.windowById(O);q?.win&&q.win.webContents.openDevTools(B)}async toggleDevTools(O){const B=this.windowById(O);B?.win&&B.win.webContents.toggleDevTools()}async sendInputEvent(O,B){const q=this.windowById(O);q?.win&&(B.type==="mouseDown"||B.type==="mouseUp")&&q.win.webContents.sendInputEvent(B)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(O,B,q,x){if(!i.isWindows)return;const ie=await new Promise((V,Y)=>{j(["vscode-windows-registry"],V,Y)});try{return ie.GetStringRegKey(B,q,x)}catch{return}}async getPassword(O,B,q){const x=await this.withKeytar(),ie=await x.getPassword(B,q);if(ie)try{let{content:V,hasNextChunk:Y}=JSON.parse(ie);if(!V||!Y)return ie;let U=1;for(;Y;){const N=await x.getPassword(B,`${q}-${U}`),F=JSON.parse(N);V+=F.content,Y=F.hasNextChunk,U++}return V}catch{return ie}return ie}async setPassword(O,B,q,x){const ie=await this.withKeytar(),V=3,Y=async(U,N,F)=>{let $=0,W;for(;$<V;)try{await ie.setPassword(U,N,F);return}catch(R){W=R,this.logService.warn("Error attempting to set a password: ",R),$++,await new Promise(C=>setTimeout(C,200))}throw W};if(i.isWindows&&x.length>lt.MAX_PASSWORD_LENGTH){let U=0,N=0,F=!0;for(;F;){const $=x.substring(U,U+lt.PASSWORD_CHUNK_SIZE);U+=lt.PASSWORD_CHUNK_SIZE,F=x.length-U>0;const W={content:$,hasNextChunk:F};await Y(B,N?`${q}-${N}`:q,JSON.stringify(W)),N++}}else await Y(B,q,x);this._onDidChangePassword.fire({service:B,account:q})}async deletePassword(O,B,q){const ie=await(await this.withKeytar()).deletePassword(B,q);return ie&&this._onDidChangePassword.fire({service:B,account:q}),ie}async findPassword(O,B){return(await this.withKeytar()).findPassword(B)}async findCredentials(O,B){return(await this.withKeytar()).findCredentials(B)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((O,B)=>{j(["keytar"],O,B)})}windowById(O){if(typeof O=="number")return this.windowsMainService.getWindowById(O)}};L.MAX_PASSWORD_LENGTH=2500,L.PASSWORD_CHUNK_SIZE=L.MAX_PASSWORD_LENGTH-100,ce([t.memoize],L.prototype,"cliPath",null),L=ce([ee(1,n.IWindowsMainService),ee(2,k.IDialogMainService),ee(3,m.ILifecycleMainService),ee(4,b.IEnvironmentMainService),ee(5,w.ITelemetryService),ee(6,h.ILogService),ee(7,u.IProductService),ee(8,r.IThemeMainService),ee(9,f.IWorkspacesManagementMainService)],L),e.NativeHostMainService=L}),define(J[228],Z([0,1,2,5,80,14,6,35,46,89,28,20,25]),function(j,e,g,M,D,S,E,n,p,m,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(w){w[w.Initial=1]="Initial",w[w.StoredCredentialsUsed=2]="StoredCredentialsUsed",w[w.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let d=class extends g.Disposable{constructor(P,I,l,h,o){super();this.logService=P,this.windowsMainService=I,this.nativeHostMainService=l,this.encryptionMainService=h,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const P=M.Event.fromNodeEventEmitter(S.app,"login",(I,l,h,o,u)=>({event:I,webContents:l,req:h,authInfo:o,callback:u}));this._register(P(this.onLogin,this))}async onLogin({event:P,authInfo:I,req:l,callback:h}){if(!I.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&l.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}P.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(I);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(o?.username,o?.password)}async resolveProxyCredentials(P){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const I=await this.doResolveProxyCredentials(P);if(I)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),I;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(P){this.logService.trace("auth#doResolveProxyCredentials - enter",P);const I=String((0,D.hash)({scheme:P.scheme,host:P.host,port:P.port}));let l,h;try{const s=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,I);if(s){const r=JSON.parse(await this.encryptionMainService.decrypt(s));l=r.username,h=r.password}}catch(s){this.logService.error(s)}if(this.state!==y.StoredCredentialsUsed&&typeof l=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:l,password:h};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const u={authInfo:P,username:this.sessionCredentials?.username??l,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,i.generateUuid)()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",k.CancellationToken.None,u),this.state=y.LoginDialogShown;const t=await new Promise(s=>{const r=async(a,c,v)=>{if(c===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),o.win?.webContents.off("ipc-message",r),v){const f={username:v.username,password:v.password};try{if(v.remember){const L=await this.encryptionMainService.encrypt(JSON.stringify(f));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,I,L)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,I)}catch(L){this.logService.error(L)}s({username:f.username,password:f.password})}else s(void 0)};o.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=t,t}};d=ce([ee(0,E.ILogService),ee(1,n.IWindowsMainService),ee(2,p.INativeHostMainService),ee(3,m.IEncryptionMainService),ee(4,b.IProductService)],d),e.ProxyAuthHandler=d}),define(J[229],Z([0,1,218,156,35,56,2,34,57,177,3,5,79,107,9,22,46]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function I(o){return o<21}let l=class{constructor(u,t,s,r,a){this.windowServer=u,this.options=t,this.windowsMainService=s,this.lifecycleMainService=r,this.nativeHostMainService=a,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new b.Emitter}async registerWindowDriver(u){return this.registeredWindowIds.add(u),this.reloadingWindowIds.delete(u),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(u){this.reloadingWindowIds.add(u)}async getWindowIds(){return this.windowsMainService.getWindows().map(u=>u.id).filter(u=>this.registeredWindowIds.has(u)&&!this.reloadingWindowIds.has(u))}async capturePage(u){await this.whenUnfrozen(u);const t=this.windowsMainService.getWindowById(u);if(!t?.win)throw new Error("Invalid window");return(await t.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(u){await this.whenUnfrozen(u);const t=this.windowsMainService.getWindowById(u);if(!t)throw new Error("Invalid window");this.reloadingWindowIds.add(u),this.lifecycleMainService.reload(t)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(u,t){await this.whenUnfrozen(u);const s=y.KeybindingParser.parseUserBinding(t);for(let r of s)await this._dispatchKeybinding(u,r)}async _dispatchKeybinding(u,t){if(t instanceof k.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const s=this.windowsMainService.getWindowById(u);if(!s?.win)throw new Error("Invalid window");const r=s.win.webContents,a=new p.SimpleKeybinding(!1,!1,!1,!1,t.keyCode),v=new m.USLayoutResolvedKeybinding(a.toChord(),i.OS).getElectronAccelerator(),f=[];t.ctrlKey&&f.push("ctrl"),t.metaKey&&f.push("meta"),t.shiftKey&&f.push("shift"),t.altKey&&f.push("alt"),r.sendInputEvent({type:"keyDown",keyCode:v,modifiers:f}),I(t.keyCode)||r.sendInputEvent({type:"char",keyCode:v,modifiers:f}),r.sendInputEvent({type:"keyUp",keyCode:v,modifiers:f}),await(0,d.timeout)(100)}async click(u,t,s,r){await(await this.getWindowDriver(u)).click(t,s,r)}async doubleClick(u,t){await(await this.getWindowDriver(u)).doubleClick(t)}async setValue(u,t,s){await(await this.getWindowDriver(u)).setValue(t,s)}async getTitle(u){return await(await this.getWindowDriver(u)).getTitle()}async isActiveElement(u,t){return await(await this.getWindowDriver(u)).isActiveElement(t)}async getElements(u,t,s){return await(await this.getWindowDriver(u)).getElements(t,s)}async getElementXY(u,t,s,r){return await(await this.getWindowDriver(u)).getElementXY(t,s,r)}async typeInEditor(u,t,s){await(await this.getWindowDriver(u)).typeInEditor(t,s)}async getTerminalBuffer(u,t){return await(await this.getWindowDriver(u)).getTerminalBuffer(t)}async writeInTerminal(u,t,s){await(await this.getWindowDriver(u)).writeInTerminal(t,s)}async getLocaleInfo(u){return await(await this.getWindowDriver(u)).getLocaleInfo()}async getLocalizedStrings(u){return await(await this.getWindowDriver(u)).getLocalizedStrings()}async getWindowDriver(u){await this.whenUnfrozen(u);const t=`window:${u}`,s=new n.StaticRouter(a=>a===t),r=this.windowServer.getChannel("windowDriver",s);return new M.WindowDriverChannelClient(r)}async whenUnfrozen(u){for(;this.reloadingWindowIds.has(u);)await b.Event.toPromise(this.onDidReloadingChange.event)}};l=ce([ee(2,D.IWindowsMainService),ee(3,w.ILifecycleMainService),ee(4,P.INativeHostMainService)],l),e.Driver=l;async function h(o,u,t,s){const r=t.driverVerbose,a=s.createInstance(l,o,{verbose:r}),c=new g.WindowDriverRegistryChannel(a);o.registerChannel("windowDriverRegistry",c);const v=await(0,S.serve)(u),f=new g.DriverChannel(a);return v.registerChannel("driver",f),(0,E.combinedDisposable)(v,o)}e.serve=h}),define(J[230],Z([0,1,144,26,49,14,102,70,24,3,6,83,53,4,61,10,46,55,2,31,20]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w,P,I,l,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,y.createDecorator)("issueMainService");let u=class St{constructor(s,r,a,c,v,f,L,T,O){this.userEnv=s,this.environmentMainService=r,this.launchMainService=a,this.logService=c,this.diagnosticsService=v,this.dialogMainService=f,this.nativeHostMainService=L,this.protocolMainService=T,this.productService=O,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){S.ipcMain.on("vscode:issueSystemInfoRequest",async s=>{const[r,a]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),c=await this.diagnosticsService.getSystemInfo(r,a);this.safeSend(s,"vscode:issueSystemInfoResponse",c)}),S.ipcMain.on("vscode:listProcesses",async s=>{const r=[];try{const a=await this.launchMainService.getMainProcessId();r.push({name:(0,g.localize)(0,null),rootProcess:await(0,b.listProcesses)(a)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(v=>{(0,n.isRemoteDiagnosticError)(v)?r.push({name:v.hostName,rootProcess:v}):v.processes&&r.push({name:v.hostName,rootProcess:v.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(s,"vscode:listProcessesResponse",r)}),S.ipcMain.on("vscode:issueReporterClipboard",async s=>{const r={title:this.productService.nameLong,message:(0,g.localize)(1,null),type:"warning",buttons:[(0,h.mnemonicButtonLabel)((0,g.localize)(2,null)),(0,h.mnemonicButtonLabel)((0,g.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",a.response===0)}}),S.ipcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const r=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",r)}),S.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,g.localize)(4,null),type:"warning",buttons:[(0,h.mnemonicButtonLabel)((0,g.localize)(5,null)),(0,h.mnemonicButtonLabel)((0,g.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),S.ipcMain.on("vscode:workbenchCommand",(s,r)=>{const{id:a,from:c,args:v}=r;let f;switch(c){case"issueReporter":f=this.issueReporterParentWindow;break;case"processExplorer":f=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${c}`)}f&&f.webContents.send("vscode:runAction",{id:a,from:c,args:v})}),S.ipcMain.on("vscode:openExternal",(s,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),S.ipcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),S.ipcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),S.ipcMain.on("vscode:windowsInfoRequest",async s=>{const r=await this.launchMainService.getMainProcessInfo();this.safeSend(s,"vscode:windowsInfoResponse",r.windows)})}safeSend(s,r,...a){s.sender.isDestroyed()||s.sender.send(r,...a)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=S.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new l.DisposableStore,a=r.add(this.protocolMainService.createIPCObjectUrl()),c=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(c,a,{backgroundColor:s.styles.backgroundColor,title:(0,g.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1}),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,M.type)(),arch:(0,M.arch)(),release:(0,M.release)()},product:D.default}),this.issueReporterWindow.loadURL(w.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=S.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new l.DisposableStore,a=r.add(this.protocolMainService.createIPCObjectUrl()),c=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(c,a,{backgroundColor:s.styles.backgroundColor,title:(0,g.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0}),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:D.default}),this.processExplorerWindow.loadURL(w.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(s,r,a){const c=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:a.title,backgroundColor:a.backgroundColor||St.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:w.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`,"--context-isolation"],v8CacheOptions:m.browserCodeLoadingCacheStrategy,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,d.zoomLevelToZoomFactor)(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop});return c.setMenuBarVisibility(!1),c}async getSystemStatus(){const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,r)}getWindowPosition(s,r,a){let c;const v=S.screen.getAllDisplays();if(v.length===1)c=v[0];else{if(m.isMacintosh){const T=S.screen.getCursorScreenPoint();c=S.screen.getDisplayNearestPoint(T)}!c&&s&&(c=S.screen.getDisplayMatching(s.getBounds())),c||(c=S.screen.getPrimaryDisplay()||v[0])}const f={width:r,height:a},L=c.bounds;return f.x=L.x+L.width/2-f.width/2,f.y=L.y+L.height/2-f.height/2,L.width>0&&L.height>0&&(f.x<L.x&&(f.x=L.x),f.y<L.y&&(f.y=L.y),f.x>L.x+L.width&&(f.x=L.x),f.y>L.y+L.height&&(f.y=L.y),f.width>L.width&&(f.width=L.width),f.height>L.height&&(f.height=L.height)),f}async getPerformanceInfo(){try{const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,r)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=ce([ee(1,p.IEnvironmentMainService),ee(2,E.ILaunchMainService),ee(3,i.ILogService),ee(4,n.IDiagnosticsService),ee(5,k.IDialogMainService),ee(6,P.INativeHostMainService),ee(7,I.IProtocolMainService),ee(8,o.IProductService)],u),e.IssueMainService=u}),define(J[231],Z([0,1,20,21,22,42,32,24,6,77,51,25,46]),function(j,e,g,M,D,S,E,n,p,m,i,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let y=class extends m.AbstractUpdateService{constructor(w,P,I,l,h,o,u,t){super(w,P,l,h,o,t);this.telemetryService=I,this.nativeHostMainService=u}buildUpdateFeedUrl(w){return(0,m.createUpdateURL)(`linux-${process.arch}`,w,this.productService)}doCheckForUpdates(w){!this.url||(this.setState(S.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},b.CancellationToken.None).then(i.asJson).then(P=>{!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(S.State.Idle(1))):this.setState(S.State.AvailableForDownload(P))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const I=w?P.message||P:void 0;this.setState(S.State.Idle(1,I))}))}async doDownloadUpdate(w){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(S.State.Idle(1))}};y=ce([ee(0,D.ILifecycleMainService),ee(1,M.IConfigurationService),ee(2,E.ITelemetryService),ee(3,n.IEnvironmentMainService),ee(4,i.IRequestService),ee(5,p.ILogService),ee(6,k.INativeHostMainService),ee(7,g.IProductService)],y),e.LinuxUpdateService=y}),define(J[232],Z([0,1,29,8,18,47,21,22,20,42,32,24,6,77,51,113,26,41,25,9,19,7,46]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w,P,I,l,h,o,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function s(v,f=1e3){for(;!v();)await(0,h.timeout)(f)}let r;function a(){return typeof r=="undefined"&&(r=g.existsSync(M.join(M.dirname(process.execPath),"unins000.exe"))?0:1),r}let c=class extends y.AbstractUpdateService{constructor(f,L,T,O,B,q,x,ie,V){super(f,L,O,B,q,V);this.telemetryService=T,this.fileService=x,this.nativeHostMainService=ie}get cachePath(){const f=M.join((0,P.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return D.Promises.mkdir(f,{recursive:!0}).then(()=>f)}initialize(){super.initialize(),a()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(f){let L="win32";return process.arch!=="ia32"&&(L+=`-${process.arch}`),a()===1?L+="-archive":this.productService.target==="user"&&(L+="-user"),(0,y.createUpdateURL)(L,f,this.productService)}doCheckForUpdates(f){!this.url||(this.setState(m.State.CheckingForUpdates(f)),this.requestService.request({url:this.url},l.CancellationToken.None).then(d.asJson).then(L=>{const T=a();return!L||!L.url||!L.version||!L.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f}),this.setState(m.State.Idle(T)),Promise.resolve(null)):T===1?(this.setState(m.State.AvailableForDownload(L)),Promise.resolve(null)):(this.setState(m.State.Downloading(L)),this.cleanup(L.version).then(()=>this.getUpdatePackagePath(L.version).then(O=>D.Promises.exists(O).then(B=>{if(B)return Promise.resolve(O);const q=L.url,x=L.hash,ie=`${O}.tmp`;return this.requestService.request({url:q},l.CancellationToken.None).then(V=>this.fileService.writeFile(u.URI.file(ie),V.stream)).then(x?()=>(0,w.checksum)(ie,L.hash):()=>{}).then(()=>D.Promises.rename(ie,O)).then(()=>O)})).then(O=>{const B=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:O},B&&L.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(m.State.Downloaded(L)):this.setState(m.State.Ready(L))})))}).then(void 0,L=>{this.logService.error(L),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!f});const T=f?L.message||L:void 0;this.setState(m.State.Idle(a(),T))}))}async doDownloadUpdate(f){f.update.url&&this.nativeHostMainService.openExternal(void 0,f.update.url),this.setState(m.State.Idle(a()))}async getUpdatePackagePath(f){const L=await this.cachePath;return M.join(L,`CodeSetup-${this.productService.quality}-${f}.exe`)}async cleanup(f=null){const L=f?q=>!new RegExp(`${this.productService.quality}-${f}\\.exe$`).test(q):()=>!0,T=await this.cachePath,B=(await D.Promises.readdir(T)).filter(L).map(async q=>{try{await D.Promises.unlink(M.join(T,q))}catch(x){}});await Promise.all(B)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const f=this.state.update;this.setState(m.State.Updating(f));const L=await this.cachePath;this.availableUpdate.updateFilePath=M.join(L,`CodeSetup-${this.productService.quality}-${f.version}.flag`),await D.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,I.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(m.State.Idle(a()))});const O=`${this.productService.win32MutexName}-ready`,B=await new Promise((q,x)=>{j(["windows-mutex"],q,x)});s(()=>B.isActive(O)).then(()=>this.setState(m.State.Ready(f)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?g.unlinkSync(this.availableUpdate.updateFilePath):(0,I.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return a()}};ce([S.memoize],c.prototype,"cachePath",null),c=ce([ee(0,n.ILifecycleMainService),ee(1,E.IConfigurationService),ee(2,i.ITelemetryService),ee(3,b.IEnvironmentMainService),ee(4,d.IRequestService),ee(5,k.ILogService),ee(6,o.IFileService),ee(7,t.INativeHostMainService),ee(8,p.IProductService)],c),e.Win32UpdateService=c}),define(J[233],Z([0,1,8,150,72,5,7,14,24,6,21,20,61,2,3,35,27,45,52,200,60,32,53,31,204,22,99,19,10,54,25,55,9]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w,P,I,l,h,o,u,t,s,r,a,c,v,f,L,T,O,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var q;(function(ie){ie[ie.NONE=0]="NONE",ie[ie.LOADING=1]="LOADING",ie[ie.NAVIGATING=2]="NAVIGATING",ie[ie.READY=3]="READY"})(q||(q={}));let x=class extends y.Disposable{constructor(V,Y,U,N,F,$,W,R,C,_,A,z,K,X){super();this.logService=Y,this.environmentMainService=U,this.fileService=N,this.configurationService=$,this.themeMainService=W,this.workspacesManagementMainService=R,this.backupMainService=C,this.telemetryService=_,this.dialogMainService=A,this.lifecycleMainService=z,this.productService=K,this.protocolMainService=X,this._onWillLoad=this._register(new S.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new S.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new S.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new S.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[G,Q]=this.restoreWindowState(V.state);this.windowState=G,this.logService.trace("window#ctor: using window state",G);const ne=this.windowState.mode===0||this.windowState.mode===3,se=this.configurationService.getValue("window"),ue={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:k.WindowMinimumSize.WIDTH,minHeight:k.WindowMinimumSize.HEIGHT,show:!ne,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:this.environmentMainService.sandbox?[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`,"--context-isolation"]:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:d.browserCodeLoadingCacheStrategy,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,k.zoomLevelToZoomFactor)(se?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};d.browserCodeLoadingCacheStrategy?this.logService.info(`window: using vscode-file:// protocol and V8 cache options: ${d.browserCodeLoadingCacheStrategy}`):this.logService.info("window: vscode-file:// protocol is explicitly disabled"),d.isLinux?ue.icon=(0,g.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):d.isWindows&&!this.environmentMainService.isBuilt&&(ue.icon=(0,g.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),d.isMacintosh&&!this.useNativeFullScreen()&&(ue.fullscreenable=!1),d.isMacintosh&&(ue.acceptFirstMouse=!0,se?.clickThroughInactive===!1&&(ue.acceptFirstMouse=!1));const he=d.isMacintosh&&se?.nativeTabs===!0;he&&(ue.tabbingIdentifier=this.productService.nameShort);const ve=(0,k.getTitleBarStyle)(this.configurationService)==="custom";if(ve&&(ue.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,d.isMacintosh||(ue.frame=!1)),(0,D.mark)("code/willCreateCodeBrowserWindow"),this._win=new n.BrowserWindow(ue),(0,D.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),d.isMacintosh&&ve&&this._win.setSheetOffset(22),d.isMacintosh&&Q&&(!he||n.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(oe=>typeof oe=="number")){const oe=this.windowState;this._win.setBounds({width:oe.width,height:oe.height,x:oe.x,y:oe.y})}ne&&((0,D.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,D.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,h.resolveMarketplaceHeaders)(this.productService.version,this.environmentMainService,this.fileService,{get:G=>F.globalStorage.get(G),store:(G,Q)=>F.globalStorage.set(G,Q)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(V){d.isMacintosh?this._win.setRepresentedFilename(V):this.representedFilename=V}getRepresentedFilename(){return d.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(V){d.isMacintosh&&this._win.setDocumentEdited(V),this.documentEdited=V}isDocumentEdited(){return d.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(V){d.isMacintosh&&V?.force&&n.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(V=>{if(this.isReady)return V(this);this.whenReadyCallbacks.push(V)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(V=>{function Y(){U.dispose(),N.dispose(),V()}const U=this.onDidClose(()=>Y()),N=this.onWillLoad(()=>Y())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(F,$)=>this.onWindowError(2,$)),this._win.webContents.on("did-fail-load",(F,$,W)=>this.onWindowError(3,{reason:W,exitCode:$})),this._win.webContents.on("will-prevent-unload",F=>{F.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const V=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),Y=F=>{for(let $=F;$;$=$.parent)if($.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},U=F=>F.resourceType==="xhr"||Y(F.frame);this._win.webContents.session.webRequest.onBeforeRequest((F,$)=>{const W=E.URI.parse(F.url);return W.path.endsWith(".svg")&&!(V.has(W.scheme)||W.path.includes(f.Schemas.vscodeRemoteResource))?$({cancel:!U(F)}):$({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((F,$)=>{const W=F.responseHeaders,R=W["content-type"]||W["Content-Type"];if(R&&Array.isArray(R)){const C=E.URI.parse(F.url);if(C.path.endsWith(".svg")&&V.has(C.scheme))return W["Content-Type"]=["image/svg+xml"],$({cancel:!1,responseHeaders:W});if(!C.path.includes(f.Schemas.vscodeRemoteResource)&&R.some(_=>_.toLowerCase().includes("image/svg")))return $({cancel:!U(F)})}return $({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",F=>{this.currentConfig&&(this.currentConfig.maximized=!0),n.app.emit("browser-window-maximize",F,this._win)}),this._win.on("unmaximize",F=>{this.currentConfig&&(this.currentConfig.maximized=!1),n.app.emit("browser-window-unmaximize",F,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",T.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",T.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(F=>this.onDidDeleteUntitledWorkspace(F)));const N=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:N},async(F,$)=>{const W=await this.marketplaceHeadersPromise;$({cancel:!1,requestHeaders:Object.assign(F.requestHeaders,W)})})}async onWindowError(V,Y){switch(V){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${Y?.reason||"<unknown>"}, code: ${Y?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${Y?.reason||"<unknown>"}, code: ${Y?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:V,reason:Y?.reason,code:Y?.exitCode}),V){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(V===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const U=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,s.mnemonicButtonLabel)((0,M.localize)(0,null)),(0,s.mnemonicButtonLabel)((0,M.localize)(1,null)),(0,s.mnemonicButtonLabel)((0,M.localize)(2,null))],message:(0,M.localize)(3,null),detail:(0,M.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;U.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):U.response===2&&this.destroyWindow()}else if(V===2){let U;Y?U=(0,M.localize)(6,null,Y.reason,Y.exitCode??"<unknown>"):U=(0,M.localize)(5,null);const N=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,s.mnemonicButtonLabel)((0,M.localize)(7,null)),(0,s.mnemonicButtonLabel)((0,M.localize)(8,null))],message:U,detail:(0,M.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;N.response===0?this.reload():N.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(V){this.openedWorkspace?.id===V.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const V=this.getMenuBarVisibility();V!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=V,this.setMenuBarVisibility(V));let Y=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;Y?.endsWith("/")&&(Y=Y.substr(0,Y.length-1));const U=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Y||"").indexOf("@")===-1&&(Y!==this.currentHttpProxy||U!==this.currentNoProxy)){this.currentHttpProxy=Y,this.currentNoProxy=U;const N=Y||"",F=U?`${U},<local>`:"<local>";this.logService.trace(`Setting proxy to '${N}', bypassing '${F}'`),this._win.webContents.session.setProxy({proxyRules:N,proxyBypassRules:F,pacScript:""})}}addTabbedWindow(V){d.isMacintosh&&V.win&&this._win.addTabbedWindow(V.win)}load(V,Y=Object.create(null)){this.isDocumentEdited()&&(!Y.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),Y.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(V,Y),this.readyState===0?this.currentConfig=V:(this.pendingLoadConfig=V,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0));const U=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new B.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:V.workspace,reason:Y.isReload?3:U?2:1})}updateConfiguration(V,Y){const U=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(U){const N=(0,L.isLaunchedFromCli)(U)&&!(0,L.isLaunchedFromCli)(V.userEnv),F=this.isExtensionDevelopmentHost;(N||F)&&(V.userEnv={...U,...V.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(V.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),Y.disableExtensions!==void 0&&(V["disable-extensions"]=Y.disableExtensions),V.fullscreen=this.isFullScreen,V.maximized=this._win.isMaximized(),V.partsSplash=this.themeMainService.getWindowSplash(),(0,D.mark)("code/willOpenNewWindow"),V.perfMarks=(0,D.getMarks)(),this.configObjectUrl.update(V)}async reload(V){const Y=Object.assign({},this.currentConfig);Y.workspace=await this.validateWorkspaceBeforeReload(Y),delete Y.filesToOpenOrCreate,delete Y.filesToDiff,delete Y.filesToWait,this.isExtensionDevelopmentHost&&V&&(Y.verbose=V.verbose,Y.debugId=V.debugId,Y["inspect-extensions"]=V["inspect-extensions"],Y["inspect-brk-extensions"]=V["inspect-brk-extensions"],Y["extensions-dir"]=V["extensions-dir"]),Y.isInitialStartup=!1,this.load(Y,{isReload:!0,disableExtensions:V?.["disable-extensions"]})}async validateWorkspaceBeforeReload(V){if((0,P.isWorkspaceIdentifier)(V.workspace)){const Y=V.workspace.configPath;if(Y.scheme===f.Schemas.file&&!await this.fileService.exists(Y))return}else if((0,P.isSingleFolderWorkspaceIdentifier)(V.workspace)){const Y=V.workspace.uri;if(Y.scheme===f.Schemas.file&&!await this.fileService.exists(Y))return}return V.workspace}serializeWindowState(){if(!this._win)return(0,w.defaultWindowState)();if(this.isFullScreen){let U;try{U=n.screen.getDisplayMatching(this.getBounds())}catch($){}const N=(0,w.defaultWindowState)();return{mode:3,display:U?U.id:void 0,width:this.windowState.width||N.width,height:this.windowState.height||N.height,x:this.windowState.x||0,y:this.windowState.y||0}}const V=Object.create(null);let Y;if(!d.isMacintosh&&this._win.isMaximized()?Y=0:Y=1,Y===0?V.mode=0:V.mode=1,Y===1||Y===0){let U;Y===1?U=this.getBounds():U=this._win.getNormalBounds(),V.x=U.x,V.y=U.y,V.width=U.width,V.height=U.height}return V}restoreWindowState(V){(0,D.mark)("code/willRestoreCodeWindowState");let Y=!1;if(V)try{const U=n.screen.getAllDisplays();Y=U.length>1,V=this.validateWindowState(V,U)}catch(U){this.logService.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}return(0,D.mark)("code/didRestoreCodeWindowState"),[V||(0,w.defaultWindowState)(),Y]}validateWindowState(V,Y){if(this.logService.trace(`window#validateWindowState: validating window state on ${Y.length} display(s)`,V),typeof V.x!="number"||typeof V.y!="number"||typeof V.width!="number"||typeof V.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(V.width<=0||V.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(Y.length===1){const F=this.getWorkingArea(Y[0]);if(F){let $=function(){!V||typeof V.x!="number"||typeof V.y!="number"||!F||(V.x<F.x&&(V.x=F.x),V.y<F.y&&(V.y=F.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",F),$(),V.width>F.width&&(V.width=F.width),V.height>F.height&&(V.height=F.height),V.x>F.x+F.width-128&&(V.x=F.x+F.width-V.width),V.y>F.y+F.height-128&&(V.y=F.y+F.height-V.height),$()}return V}if(V.display&&V.mode===3){const F=Y.find($=>$.id===V.display);if(F&&typeof F.bounds?.x=="number"&&typeof F.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,w.defaultWindowState)(3);return $.x=F.bounds.x,$.y=F.bounds.y,$}}let U,N;try{U=n.screen.getDisplayMatching({x:V.x,y:V.y,width:V.width,height:V.height}),N=this.getWorkingArea(U)}catch(F){}if(U&&N&&V.x+V.width>N.x&&V.y+V.height>N.y&&V.x<N.x+N.width&&V.y<N.y+N.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",N),V}getWorkingArea(V){if(V.workArea.width>0&&V.workArea.height>0)return V.workArea;if(V.bounds.width>0&&V.bounds.height>0)return V.bounds}getBounds(){const[V,Y]=this._win.getPosition(),[U,N]=this._win.getSize();return{x:V,y:Y,width:U,height:N}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(V){this.useNativeFullScreen()?this.setNativeFullScreen(V):this.setSimpleFullScreen(V),this.sendWhenReady(V?"vscode:enterFullScreen":"vscode:leaveFullScreen",T.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(V){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(V)}setSimpleFullScreen(V){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(V),this._win.webContents.focus()}useNativeFullScreen(){const V=this.configurationService.getValue("window");return!V||typeof V.nativeFullScreen!="boolean"||V.nativeTabs?!0:V.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let V=(0,k.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(V)<0&&(V="classic"),V}setMenuBarVisibility(V,Y=!0){d.isMacintosh||(V==="toggle"&&Y&&this.send("vscode:showInfoMessage",(0,M.localize)(10,null)),V==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(V)}):this.doSetMenuBarVisibility(V))}doSetMenuBarVisibility(V){const Y=this.isFullScreen;switch(V){case"classic":this._win.setMenuBarVisibility(!Y),this._win.autoHideMenuBar=Y;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(d.isMacintosh)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(V,Y,...U){this.isReady?this.send(V,...U):this.ready().then(()=>{Y.isCancellationRequested||this.send(V,...U)})}send(V,...Y){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${V} for window that is destroyed`);return}this._win.webContents.send(V,...Y)}}updateTouchBar(V){!d.isMacintosh||this.touchBarGroups.forEach((Y,U)=>{const N=V[U];Y.segments=this.createTouchBarGroupSegments(N)})}createTouchBar(){if(!!d.isMacintosh){for(let V=0;V<10;V++){const Y=this.createTouchBarGroup();this.touchBarGroups.push(Y)}this._win.setTouchBar(new n.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(V=[]){const Y=this.createTouchBarGroupSegments(V),U=new n.TouchBar.TouchBarSegmentedControl({segments:Y,mode:"buttons",segmentStyle:"automatic",change:N=>{this.sendWhenReady("vscode:runAction",T.CancellationToken.None,{id:U.segments[N].id,from:"touchbar"})}});return U}createTouchBarGroupSegments(V=[]){return V.map(U=>{let N;U.icon&&!r.ThemeIcon.isThemeIcon(U.icon)&&U.icon?.dark?.scheme===f.Schemas.file&&(N=n.nativeImage.createFromPath(E.URI.revive(U.icon.dark).fsPath),N.isEmpty()&&(N=void 0));let F;return typeof U.title=="string"?F=U.title:F=U.title.value,{id:U.id,label:N?void 0:F,icon:N}})}dispose(){super.dispose(),this._win=null}};x=ce([ee(1,m.ILogService),ee(2,p.IEnvironmentMainService),ee(3,v.IFileService),ee(4,c.IStorageMainService),ee(5,i.IConfigurationService),ee(6,o.IThemeMainService),ee(7,I.IWorkspacesManagementMainService),ee(8,l.IBackupMainService),ee(9,u.ITelemetryService),ee(10,t.IDialogMainService),ee(11,a.ILifecycleMainService),ee(12,b.IProductService),ee(13,O.IProtocolMainService)],x),e.CodeWindow=x}),define(J[62],Z([0,1,153,36,39,14,6,31,5,3,27,45,9,15,7,10,18,22,4,2]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w,P,I,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,l.createDecorator)("workspacesHistoryMainService");let o=class He extends h.Disposable{constructor(v,f,L,T){super();this.stateMainService=v,this.logService=f,this.workspacesManagementMainService=L,this.lifecycleMainService=T,this._onDidChangeRecentlyOpened=this._register(new p.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(v=>this.addRecentlyOpened([{workspace:v.workspace}])))}handleWindowsJumpList(){!m.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(v){const f=[],L=[];for(let T of v)if((0,i.isRecentWorkspace)(T))!this.workspacesManagementMainService.isUntitledWorkspace(T.workspace)&&s(f,T.workspace)===-1&&f.push(T);else if((0,i.isRecentFolder)(T))r(f,T.folderUri)===-1&&f.push(T);else{const O=a(L,T.fileUri)>=0,B=T.fileUri.scheme===w.Schemas.file&&He.COMMON_FILES_FILTER.indexOf((0,y.basename)(T.fileUri))>=0;!O&&!B&&(L.push(T),m.isWindows&&T.fileUri.scheme===w.Schemas.file&&S.app.addRecentDocument(T.fileUri.fsPath))}this.addEntriesFromStorage(f,L),f.length>He.MAX_TOTAL_RECENT_ENTRIES&&(f.length=He.MAX_TOTAL_RECENT_ENTRIES),L.length>He.MAX_TOTAL_RECENT_ENTRIES&&(L.length=He.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:f,files:L}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(v){const f=B=>{const q=t(B);for(const x of v)if(y.extUriBiasedIgnorePathCase.isEqual(x,q))return!1;return!0},L=this.getRecentlyOpened(),T=L.workspaces.filter(f),O=L.files.filter(f);(T.length!==L.workspaces.length||O.length!==L.files.length)&&(this.saveRecentlyOpened({files:O,workspaces:T}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!m.isMacintosh)return;S.app.clearRecentDocuments();const v=this.getRecentlyOpened(),f=[];let L=0;for(let O=0;O<v.workspaces.length&&L<He.MAX_MACOS_DOCK_RECENT_WORKSPACES;O++){const B=t(v.workspaces[O]);if(B.scheme===w.Schemas.file){const q=(0,y.originalFSPath)(B);await P.Promises.exists(q)&&(f.push(q),L++)}}const T=[];for(let O=0;O<v.files.length&&L<He.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;O++){const B=t(v.files[O]);if(B.scheme===w.Schemas.file){const q=(0,y.originalFSPath)(B);if(He.COMMON_FILES_FILTER.includes((0,y.basename)(B))||f.includes(q))continue;await P.Promises.exists(q)&&(T.push(q),L++)}}T.reverse().forEach(O=>S.app.addRecentDocument(O)),f.reverse().forEach(O=>S.app.addRecentDocument(O))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(v){const f=[],L=[],T=v?.config?.workspace;(0,i.isWorkspaceIdentifier)(T)&&!this.workspacesManagementMainService.isUntitledWorkspace(T)?f.push({workspace:T}):(0,i.isSingleFolderWorkspaceIdentifier)(T)&&f.push({folderUri:T.uri});const O=v?.config?.filesToOpenOrCreate;if(O)for(let B of O){const q=B.fileUri;q&&a(L,q)===-1&&L.push({fileUri:q})}return this.addEntriesFromStorage(f,L),{workspaces:f,files:L}}addEntriesFromStorage(v,f){let L=this.getRecentlyOpenedFromStorage();for(let T of L.workspaces){let O=(0,i.isRecentFolder)(T)?r(v,T.folderUri):s(v,T.workspace);O>=0?v[O].label=v[O].label||T.label:v.push(T)}for(let T of L.files){let O=a(f,T.fileUri);O>=0?f[O].label=f[O].label||T.label:f.push(T)}}getRecentlyOpenedFromStorage(){const v=this.stateMainService.getItem(He.recentlyOpenedStorageKey);return(0,i.restoreRecentlyOpened)(v,this.logService)}saveRecentlyOpened(v){const f=(0,i.toStoreData)(v);this.stateMainService.setItem(He.recentlyOpenedStorageKey,f)}updateWindowsJumpList(){if(!m.isWindows)return;const v=[];if(v.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(0,null),description:(0,g.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let f=[];for(let O of S.app.getJumpListSettings().removedItems){const B=O.args;if(B){const q=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(B);q&&f.push(d.URI.parse(q[2]))}}this.removeRecentlyOpened(f);let L=!1;const T=(0,M.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(O=>{const B=(0,i.isRecentWorkspace)(O)?O.workspace:O.folderUri,{title:q,description:x}=this.getWindowsJumpListLabel(B,O.label);let ie;return d.URI.isUri(B)?ie=`--folder-uri "${B.toString()}"`:(L=!0,ie=`--file-uri "${B.configPath.toString()}"`),{type:"task",title:q.substr(0,255),description:x.substr(0,255),program:process.execPath,args:ie,iconPath:"explorer.exe",iconIndex:0}}));T.length>0&&v.push({type:"custom",name:L?(0,g.localize)(2,null):(0,g.localize)(3,null),items:T})}v.push({type:"recent"});try{S.app.setJumpList(v)}catch(f){this.logService.warn("updateWindowsJumpList#setJumpList",f)}}getWindowsJumpListLabel(v,f){if(f)return{title:(0,n.splitName)(f).name,description:f};if(d.URI.isUri(v))return{title:(0,y.basename)(v),description:u(v)};if(this.workspacesManagementMainService.isUntitledWorkspace(v))return{title:(0,g.localize)(4,null),description:""};let L=(0,y.basename)(v.configPath);return L.endsWith(i.WORKSPACE_EXTENSION)&&(L=L.substr(0,L.length-i.WORKSPACE_EXTENSION.length-1)),{title:(0,g.localize)(5,null,L),description:u(v.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=ce([ee(0,D.IStateMainService),ee(1,E.ILogService),ee(2,b.IWorkspacesManagementMainService),ee(3,I.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function u(c){return c.scheme==="file"?(0,n.normalizeDriveLetter)(c.fsPath):c.toString()}function t(c){return(0,i.isRecentFolder)(c)?c.folderUri:(0,i.isRecentFile)(c)?c.fileUri:c.workspace.configPath}function s(c,v){return c.findIndex(f=>(0,i.isRecentWorkspace)(f)&&f.workspace.id===v.id)}function r(c,v){return c.findIndex(f=>(0,i.isRecentFolder)(f)&&y.extUriBiasedIgnorePathCase.isEqual(f.folderUri,v))}function a(c,v){return c.findIndex(f=>y.extUriBiasedIgnorePathCase.isEqual(f.fileUri,v))}}),define(J[234],Z([0,1,145,3,24,14,61,21,32,42,20,9,6,31,35,62,183,7,39,22,46,25]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w,P,I,l,h,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let s=class wt{constructor(c,v,f,L,T,O,B,q,x,ie,V){this.updateService=c,this.configurationService=v,this.windowsMainService=f,this.environmentMainService=L,this.telemetryService=T,this.workspacesHistoryMainService=O,this.stateMainService=B,this.lifecycleMainService=q,this.logService=x,this.nativeHostMainService=ie,this.productService=V,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new b.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new b.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,E.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const c=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);c&&(c.menus&&(this.menubarMenus=c.menus),c.keybindings&&(this.keybindings=c.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(O,B,q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:B?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(O,B,q)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:B?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(O,B,q)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(q),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(O,B,q)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(q),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const c=this.productService.twitterUrl;c&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(c,"openTwitterUrl"));const v=this.productService.requestFeatureUrl;v&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(v,"openUserVoiceUrl"));const f=this.productService.reportIssueUrl;f&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(f,"openReportIssues"));const L=this.productService.licenseUrl;L&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const O=L.indexOf("?")>0?"&":"?";this.openUrl(`${L}${O}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(L,"openLicenseUrl")});const T=this.productService.privacyStatementUrl;T&&L&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(M.language){const O=L.indexOf("?")>0?"&":"?";this.openUrl(`${T}${O}lang=${M.language}`,"openPrivacyStatement")}else this.openUrl(T,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(c=>this.onDidChangeWindowsCount(c)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let c=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof c!="boolean"?!0:c}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;let c=this.configurationService.getValue("window.nativeTabs");return typeof c!="boolean"?!1:c}updateMenu(c,v){this.menubarMenus=c.menus,this.keybindings=c.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,c),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(c){!M.isMacintosh||(c.oldCount===0&&c.newCount>0||c.oldCount>0&&c.newCount===0)&&(this.closedLastWindow=c.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!S.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const c=S.Menu.getApplicationMenu();if(c&&this.oldMenus.push(c),Object.keys(this.menubarMenus).length===0){S.Menu.setApplicationMenu(M.isMacintosh?new S.Menu:null);return}const v=new S.Menu;let f;if(M.isMacintosh){const T=new S.Menu;f=new S.MenuItem({label:this.productService.nameShort,submenu:T}),this.setMacApplicationMenu(T),v.append(f)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const T=new S.Menu;T.append(new S.MenuItem({label:this.mnemonicLabel(g.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),S.app.dock.setMenu(T)}if(this.shouldDrawMenu("File")){const T=new S.Menu,O=new S.MenuItem({label:this.mnemonicLabel(g.localize(1,null)),submenu:T});this.setMenuById(T,"File"),v.append(O)}if(this.shouldDrawMenu("Edit")){const T=new S.Menu,O=new S.MenuItem({label:this.mnemonicLabel(g.localize(2,null)),submenu:T});this.setMenuById(T,"Edit"),v.append(O)}if(this.shouldDrawMenu("Selection")){const T=new S.Menu,O=new S.MenuItem({label:this.mnemonicLabel(g.localize(3,null)),submenu:T});this.setMenuById(T,"Selection"),v.append(O)}if(this.shouldDrawMenu("View")){const T=new S.Menu,O=new S.MenuItem({label:this.mnemonicLabel(g.localize(4,null)),submenu:T});this.setMenuById(T,"View"),v.append(O)}if(this.shouldDrawMenu("Go")){const T=new S.Menu,O=new S.MenuItem({label:this.mnemonicLabel(g.localize(5,null)),submenu:T});this.setMenuById(T,"Go"),v.append(O)}if(this.shouldDrawMenu("Run")){const T=new S.Menu,O=new S.MenuItem({label:this.mnemonicLabel(g.localize(6,null)),submenu:T});this.setMenuById(T,"Run"),v.append(O)}if(this.shouldDrawMenu("Terminal")){const T=new S.Menu,O=new S.MenuItem({label:this.mnemonicLabel(g.localize(7,null)),submenu:T});this.setMenuById(T,"Terminal"),v.append(O)}let L;if(this.shouldDrawMenu("Window")){const T=new S.Menu;L=new S.MenuItem({label:this.mnemonicLabel(g.localize(8,null)),submenu:T,role:"window"}),this.setMacWindowMenu(T)}if(L&&v.append(L),this.shouldDrawMenu("Help")){const T=new S.Menu,O=new S.MenuItem({label:this.mnemonicLabel(g.localize(9,null)),submenu:T,role:"help"});this.setMenuById(T,"Help"),v.append(O)}v.items&&v.items.length>0?S.Menu.setApplicationMenu(v):S.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(c){const v=this.createMenuItem(g.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),f=this.getUpdateMenuItems();let L;if(this.shouldDrawMenu("Preferences")){const Y=new S.Menu;this.setMenuById(Y,"Preferences"),L=new S.MenuItem({label:this.mnemonicLabel(g.localize(11,null)),submenu:Y})}const T=new S.Menu,O=new S.MenuItem({label:g.localize(12,null),role:"services",submenu:T}),B=new S.MenuItem({label:g.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),q=new S.MenuItem({label:g.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new S.MenuItem({label:g.localize(15,null),role:"unhide"}),ie=new S.MenuItem(this.likeAction("workbench.action.quit",{label:g.localize(16,null,this.productService.nameLong),click:()=>{const Y=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||Y?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),V=[v];V.push(...f),L&&V.push(r(),L),V.push(r(),O,r(),B,q,x,r(),ie),V.forEach(Y=>c.append(Y))}shouldDrawMenu(c){if(!M.isMacintosh&&(0,E.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(c){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[c];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[c]}}setMenu(c,v){v.forEach(f=>{if((0,P.isMenubarMenuItemSeparator)(f))c.append(r());else if((0,P.isMenubarMenuItemSubmenu)(f)){const L=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(f.label),submenu:L});this.setMenu(L,f.submenu.items),c.append(T)}else(0,P.isMenubarMenuItemRecentAction)(f)?c.append(this.createOpenRecentMenuItem(f)):(0,P.isMenubarMenuItemAction)(f)&&(f.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(c),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[f.id]?c.append(new S.MenuItem(this.likeAction(f.id,{label:this.mnemonicLabel(f.label),click:this.fallbackMenuHandlers[f.id]}))):c.append(this.createMenuItem(f.label,f.id,!1,f.checked)):c.append(this.createMenuItem(f.label,f.id,f.enabled!==!1,!!f.checked)):c.append(this.createMenuItem(f.label,f.id,f.enabled!==!1,!!f.checked)))})}setMenuById(c,v){this.menubarMenus&&this.menubarMenus[v]&&this.setMenu(c,this.menubarMenus[v].items)}insertCheckForUpdatesItems(c){const v=this.getUpdateMenuItems();v.length&&(v.forEach(f=>c.append(f)),c.append(r()))}createOpenRecentMenuItem(c){const v=I.URI.revive(c.uri),f=c.id,L=f==="openRecentFile"?{fileUri:v}:f==="openRecentWorkspace"?{workspaceUri:v}:{folderUri:v};return new S.MenuItem(this.likeAction(f,{label:c.label,click:(T,O,B)=>{const q=this.isOptionClick(B);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[L],forceNewWindow:q,gotoLineMode:!1,remoteAuthority:c.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([v])}},!1))}isOptionClick(c){return!!(c&&(!M.isMacintosh&&(c.ctrlKey||c.shiftKey)||M.isMacintosh&&(c.metaKey||c.altKey)))}createRoleMenuItem(c,v,f){const L={label:this.mnemonicLabel(c),role:f,enabled:!0};return new S.MenuItem(this.withKeybinding(v,L))}setMacWindowMenu(c){const v=new S.MenuItem({label:g.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),f=new S.MenuItem({label:g.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),L=new S.MenuItem({label:g.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),T=this.createMenuItem(g.localize(20,null),"workbench.action.switchWindow"),O=[];this.currentEnableNativeTabs&&(O.push(r()),O.push(this.createMenuItem(g.localize(21,null),"workbench.action.newWindowTab")),O.push(this.createRoleMenuItem(g.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),O.push(this.createRoleMenuItem(g.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),O.push(this.createRoleMenuItem(g.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),O.push(this.createRoleMenuItem(g.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[v,f,r(),T,...O,r(),L].forEach(B=>c.append(B))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.mnemonicLabel(g.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:g.localize(27,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.mnemonicLabel(g.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:g.localize(29,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.mnemonicLabel(g.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new S.MenuItem({label:g.localize(31,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.mnemonicLabel(g.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(c,v,f,L){const T=this.mnemonicLabel(c),O=typeof v=="function"?v:(V,Y,U)=>{const N=V?V.userSettingsLabel:null;let F=v;Array.isArray(v)&&(F=this.isOptionClick(U)?v[1]:v[0]),N&&U.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:N}):this.runActionInRenderer({type:"commandId",commandId:F})},B=typeof f=="boolean"?f:this.windowsMainService.getWindowCount()>0,q=typeof L=="boolean"?L:!1,x={label:T,click:O,enabled:B};q&&(x.type="checkbox",x.checked=q);let ie;return typeof v=="string"?ie=v:Array.isArray(v)&&(ie=v[0]),M.isMacintosh&&(ie==="editor.action.clipboardCutAction"?x.role="cut":ie==="editor.action.clipboardCopyAction"?x.role="copy":ie==="editor.action.clipboardPasteAction"&&(x.role="paste"),ie==="undo"?x.click=this.makeContextAwareClickHandler(O,{inDevTools:V=>V.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):ie==="redo"?x.click=this.makeContextAwareClickHandler(O,{inDevTools:V=>V.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):ie==="editor.action.selectAll"&&(x.click=this.makeContextAwareClickHandler(O,{inDevTools:V=>V.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.withKeybinding(ie,x))}makeContextAwareClickHandler(c,v){return(f,L,T)=>{const O=S.BrowserWindow.getFocusedWindow();if(!O)return v.inNoWindow();if(O.webContents.isDevToolsFocused()&&O.webContents.devToolsWebContents)return v.inDevTools(O.webContents.devToolsWebContents);c(f,L||O,T)}}runActionInRenderer(c){let v=S.BrowserWindow.getFocusedWindow();if(!v){const L=this.windowsMainService.getLastActiveWindow();L?.isMinimized()&&(v=L.win)}const f=v?this.windowsMainService.getWindowById(v.id):void 0;if(f){if(this.logService.trace("menubar#runActionInRenderer",c),M.isMacintosh&&!this.environmentMainService.isBuilt&&!f.isReady&&(c.type==="commandId"&&c.commandId==="workbench.action.toggleDevTools"||c.type!=="commandId"&&c.userSettingsLabel==="alt+cmd+i"))return;if(c.type==="commandId"){const L={id:c.commandId,from:"menu"};f.sendWhenReady("vscode:runAction",u.CancellationToken.None,L)}else{const L={userSettingsLabel:c.userSettingsLabel};f.sendWhenReady("vscode:runKeybinding",u.CancellationToken.None,L)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",c)}withKeybinding(c,v){const f=typeof c=="string"?this.keybindings[c]:void 0;if(f?.label){if(f.isNative!==!1)v.accelerator=f.label,v.userSettingsLabel=f.userSettingsLabel;else if(typeof v.label=="string"){const L=v.label.indexOf("[");L>=0?v.label=`${v.label.substr(0,L)} [${f.label}]`:v.label=`${v.label} [${f.label}]`}}else v.accelerator=void 0;return v}likeAction(c,v,f=!v.accelerator){f&&(v=this.withKeybinding(c,v));const L=v.click;return v.click=(T,O,B)=>{this.reportMenuActionTelemetry(c),L&&L(T,O,B)},v}openUrl(c,v){this.nativeHostMainService.openExternal(void 0,c),this.reportMenuActionTelemetry(v)}reportMenuActionTelemetry(c){this.telemetryService.publicLog2("workbenchActionExecuted",{id:c,from:t})}mnemonicLabel(c){return(0,y.mnemonicMenuLabel)(c,!this.currentEnableMenuBarMnemonics)}};s.lastKnownMenubarStorageKey="lastKnownMenubarData",s=ce([ee(0,m.IUpdateService),ee(1,n.IConfigurationService),ee(2,d.IWindowsMainService),ee(3,D.IEnvironmentMainService),ee(4,p.ITelemetryService),ee(5,w.IWorkspacesHistoryMainService),ee(6,l.IStateMainService),ee(7,h.ILifecycleMainService),ee(8,k.ILogService),ee(9,o.INativeHostMainService),ee(10,i.IProductService)],s),e.Menubar=s;function r(){return new S.MenuItem({type:"separator"})}}),define(J[235],Z([0,1,234,6,4,22]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,D.createDecorator)("menubarMainService");let E=class{constructor(p,m,i){this.instantiationService=p,this.lifecycleMainService=m,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(g.Menubar)}async updateMenubar(p,m){this.logService.trace("menubarService#updateMenubar",p),(await this.menubar).updateMenu(m,p)}};E=ce([ee(0,D.IInstantiationService),ee(1,S.ILifecycleMainService),ee(2,M.ILogService)],E),e.MenubarMainService=E}),define(J[236],Z([0,1,29,26,49,72,8,151,36,52,24,39,233,14,22,21,6,61,100,5,20,62,3,27,4,10,7,15,73,216,45,101,43,2,53,13,30,31,25,19,33,55]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w,P,I,l,h,o,u,t,s,r,a,c,v,f,L,T,O,B,q,x,ie,V,Y,U,N,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function W(_){return(0,s.isWorkspaceIdentifier)(_?.workspace)}function R(_){return(0,s.isSingleFolderWorkspaceIdentifier)(_?.workspace)}let C=class Je extends q.Disposable{constructor(A,z,K,X,G,Q,ne,se,ue,he,ve,oe,fe,me,Ie){super();this.machineId=A,this.initialUserEnv=z,this.logService=K,this.stateMainService=X,this.environmentMainService=G,this.lifecycleMainService=Q,this.backupMainService=ne,this.configurationService=se,this.workspacesHistoryMainService=ue,this.workspacesManagementMainService=he,this.instantiationService=ve,this.dialogMainService=oe,this.fileService=fe,this.productService=me,this.protocolMainService=Ie,this._onDidOpenWindow=this._register(new h.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new h.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new h.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new h.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new L.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const z=new q.DisposableStore;if(z.add(h.Event.any(A.onDidClose,A.onDidDestroy)(()=>z.dispose())),A.config.extensionDevelopmentPath)for(const K of A.config.extensionDevelopmentPath)z.add(this.protocolMainService.addValidFileRoot(c.URI.file(K)));A.config.extensionTestsPath&&z.add(this.protocolMainService.addValidFileRoot(c.URI.file(A.config.extensionTestsPath)))}}))}openEmptyWindow(A,z){let K=this.environmentMainService.args;const X=z?.remoteAuthority||void 0,G=!0,Q=z?.forceReuseWindow,ne=!Q;return this.open({...A,cli:K,forceEmpty:G,forceNewWindow:ne,forceReuseWindow:Q,remoteAuthority:X})}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const z=[],K=[],X=[],G=[],Q=[];let ne,se=0;const ue=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",ue);for(const me of ue)R(me)?A.addMode?z.push(me):K.push(me):W(me)?X.push(me):me.fileUri?(ne||(ne={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:me.remoteAuthority}),ne.filesToOpenOrCreate.push(me)):me.backupPath?Q.push({backupFolder:(0,E.basename)(me.backupPath),remoteAuthority:me.remoteAuthority}):se++;A.diffMode&&ne?.filesToOpenOrCreate.length===2&&(ne.filesToDiff=ne.filesToOpenOrCreate,ne.filesToOpenOrCreate=[]),ne&&A.waitMarkerFileURI&&(ne.filesToWait={paths:[...ne.filesToDiff,...ne.filesToOpenOrCreate],waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(G.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),X.push(...G),Q.push(...this.backupMainService.getEmptyWindowBackupPaths())):Q.length=0;const{windows:he,filesOpenedInWindow:ve}=this.doOpen(A,X,K,Q,se,ne,z);if(this.logService.trace(`windowsManager#open used window count ${he.length} (workspacesToOpen: ${X.length}, foldersToOpen: ${K.length}, emptyToRestore: ${Q.length}, emptyToOpen: ${se})`),he.length>1)if(ve)ve.focus();else{const me=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let Ie=!0,Me=!0;if(me){const Ee=he.filter(ye=>this.windowsStateHandler.state.lastActiveWindow&&ye.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ee.length&&(Ee[0].focus(),Ie=!1,Me=!1)}if(Ie)for(let Ee=he.length-1;Ee>=0;Ee--){const ye=he[Ee];if(!(ye.openedWorkspace&&G.some(be=>ye.openedWorkspace&&be.workspace.id===ye.openedWorkspace.id)||ye.backupPath&&Q.some(be=>ye.backupPath&&be.backupFolder===(0,E.basename)(ye.backupPath)))){ye.focus(),Me=!1;break}}Me&&he[he.length-1].focus()}const oe=ne&&ne.filesToDiff.length>0;if(!he.some(me=>me.isExtensionDevelopmentHost)&&!oe&&!A.noRecentEntry){const me=[];for(const Ie of ue)W(Ie)&&!Ie.transient?me.push({label:Ie.label,workspace:Ie.workspace,remoteAuthority:Ie.remoteAuthority}):R(Ie)?me.push({label:Ie.label,folderUri:Ie.workspace.uri,remoteAuthority:Ie.remoteAuthority}):Ie.fileUri&&me.push({label:Ie.label,fileUri:Ie.fileUri,remoteAuthority:Ie.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(me)}const fe=A.waitMarkerFileURI;return A.context===0&&fe&&he.length===1&&he[0]&&(async()=>{await he[0].whenClosedOrLoaded;try{await this.fileService.del(fe)}catch(me){}})(),he}doOpen(A,z,K,X,G,Q,ne){const se=[];let ue;function he(Ee,ye){se.push(Ee),ye&&(ue=Ee,Q=void 0)}let{openFolderInNewWindow:ve,openFilesInNewWindow:oe}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&ne.length>0){const Ee=ne[0].remoteAuthority,ye=this.getLastActiveWindowForAuthority(Ee);ye&&he(this.doAddFoldersToExistingWindow(ye,ne.map(be=>be.workspace.uri)))}const fe=K.length+z.length+X.length;if(Q&&fe===0){const Ee=Q.filesToOpenOrCreate[0]||Q.filesToDiff[0],ye=this.getWindows().filter(De=>Q&&De.remoteAuthority===Q.remoteAuthority);let be;Ee?.fileUri&&!oe&&((A.context===4||A.context===0||A.context===1)&&(be=(0,l.findWindowOnFile)(ye,Ee.fileUri,De=>De.configPath.scheme===a.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(De.configPath):void 0)),be||(be=this.doGetLastActiveWindow(ye))),be?(0,s.isWorkspaceIdentifier)(be.openedWorkspace)?z.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,s.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?K.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):he(this.doOpenFilesInExistingWindow(A,be,Q),!0):he(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:Q,forceNewWindow:!0,remoteAuthority:Q.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const me=(0,p.distinct)(z,Ee=>Ee.workspace.id);if(me.length>0){const Ee=(0,p.coalesce)(me.map(ye=>(0,l.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.configPath)));if(Ee.length>0){const ye=Ee[0],be=Q?.remoteAuthority===ye.remoteAuthority?Q:void 0;he(this.doOpenFilesInExistingWindow(A,ye,be),!!be),ve=!0}me.forEach(ye=>{if(Ee.some(Fe=>Fe.openedWorkspace&&Fe.openedWorkspace.id===ye.workspace.id))return;const be=ye.remoteAuthority,De=Q?.remoteAuthority===be?Q:void 0;he(this.doOpenFolderOrWorkspace(A,ye,ve,De),!!De),ve=!0})}const Ie=(0,p.distinct)(K,Ee=>v.extUriBiasedIgnorePathCase.getComparisonKey(Ee.workspace.uri));if(Ie.length>0){const Ee=(0,p.coalesce)(Ie.map(ye=>(0,l.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.uri)));if(Ee.length>0){const ye=Ee[0],be=Q?.remoteAuthority===ye.remoteAuthority?Q:void 0;he(this.doOpenFilesInExistingWindow(A,ye,be),!!be),ve=!0}Ie.forEach(ye=>{if(Ee.some(Fe=>(0,s.isSingleFolderWorkspaceIdentifier)(Fe.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Fe.openedWorkspace.uri,ye.workspace.uri)))return;const be=ye.remoteAuthority,De=Q?.remoteAuthority===be?Q:void 0;he(this.doOpenFolderOrWorkspace(A,ye,ve,De),!!De),ve=!0})}const Me=(0,p.distinct)(X,Ee=>Ee.backupFolder);if(Me.length>0&&Me.forEach(Ee=>{const ye=Ee.remoteAuthority,be=Q?.remoteAuthority===ye?Q:void 0;he(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:be,remoteAuthority:ye,forceNewWindow:!0,forceNewTabbedWindow:A.forceNewTabbedWindow,emptyWindowBackupInfo:Ee}),!!be),ve=!0}),se.length===0||Q){Q&&!G&&G++;const Ee=Q?Q.remoteAuthority:A.remoteAuthority;for(let ye=0;ye<G;ye++)he(this.doOpenEmpty(A,ve,Ee,Q),!!Q),ve=!0}return{windows:(0,p.distinct)(se),filesOpenedInWindow:ue}}doOpenFilesInExistingWindow(A,z,K){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),z.focus();const X={filesToOpenOrCreate:K?.filesToOpenOrCreate,filesToDiff:K?.filesToDiff,filesToWait:K?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return z.sendWhenReady("vscode:openFiles",U.CancellationToken.None,X),z}doAddFoldersToExistingWindow(A,z){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),A.focus();const K={foldersToAdd:z};return A.sendWhenReady("vscode:addFolders",U.CancellationToken.None,K),A}doOpenEmpty(A,z,K,X,G){return!z&&!G&&typeof A.contextWindowId=="number"&&(G=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:K,forceNewWindow:z,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:X,windowToUse:G})}doOpenFolderOrWorkspace(A,z,K,X,G){return!K&&!G&&typeof A.contextWindowId=="number"&&(G=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:z.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:z.remoteAuthority,forceNewWindow:K,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:X,windowToUse:G})}getPathsToOpen(A){let z,K=!1,X=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(z=this.doExtractPathsFromAPI(A),K=!0):A.forceEmpty?z=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(z=this.doExtractPathsFromCLI(A.cli),z.length===0&&z.push(Object.create(null)),K=!0):(z=this.doGetPathsFromLastSession(),z.length===0&&z.push(Object.create(null)),X=!0),!A.addMode&&K){const G=z.filter(Q=>R(Q));if(G.length>1){const Q=G[0].remoteAuthority;if(G.every(ne=>ne.remoteAuthority===Q)){const ne=this.workspacesManagementMainService.createUntitledWorkspaceSync(G.map(se=>({uri:se.workspace.uri})));z.push({workspace:ne,remoteAuthority:Q}),z=z.filter(se=>!R(se))}}}return A.initialStartup&&!X&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&z.unshift(...this.doGetPathsFromLastSession().filter(G=>W(G)||R(G)||G.backupPath)),z}doExtractPathsFromAPI(A){const z=[],K={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const X of(0,p.coalesce)(A.urisToOpen||[])){const G=this.resolveOpenable(X,K);if(G)G.label=X.label,z.push(G);else{const Q=this.resourceFromOpenable(X),ne={title:this.productService.nameLong,type:"info",buttons:[(0,Y.mnemonicButtonLabel)((0,n.localize)(0,null))],defaultId:0,message:Q.scheme===a.Schemas.file?(0,n.localize)(1,null):(0,n.localize)(2,null),detail:Q.scheme===a.Schemas.file?(0,n.localize)(3,null,(0,Y.getPathLabel)(Q.fsPath,this.environmentMainService)):(0,n.localize)(4,null,Q.toString()),noLink:!0};this.dialogMainService.showMessageBox(ne,(0,ie.withNullAsUndefined)(y.BrowserWindow.getFocusedWindow()))}}return z}doExtractPathsFromCLI(A){const z=[],K={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:!1},X=A["folder-uri"];if(X)for(const ne of X){const se=this.cliArgToUri(ne);if(se){const ue=this.resolveOpenable({folderUri:se},K);ue&&z.push(ue)}}const G=A["file-uri"];if(G)for(const ne of G){const se=this.cliArgToUri(ne);if(se){const ue=this.resolveOpenable((0,s.hasWorkspaceFileExtension)(ne)?{workspaceUri:se}:{fileUri:se},K);ue&&z.push(ue)}}const Q=A._;for(const ne of Q){const se=K.remoteAuthority?this.doResolvePathRemote(ne,K):this.doResolveFilePath(ne,K);se&&z.push(se)}return z}cliArgToUri(A){try{const z=c.URI.parse(A);if(!z.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return z}catch(z){this.logService.error(`Invalid URI input string: ${A}, ${z.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":const z=[];A!=="one"&&z.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&z.push(this.windowsStateHandler.state.lastActiveWindow);const K=[];for(const X of z)if(X.workspace){const G=this.resolveOpenable({workspaceUri:X.workspace.configPath},{remoteAuthority:X.remoteAuthority,rejectTransientWorkspaces:!0});W(G)&&K.push(G)}else if(X.folderUri){const G=this.resolveOpenable({folderUri:X.folderUri},{remoteAuthority:X.remoteAuthority});R(G)&&K.push(G)}else A!=="folders"&&X.backupPath&&K.push({backupPath:X.backupPath,remoteAuthority:X.remoteAuthority});return K}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,z=Object.create(null)){let K=this.resourceFromOpenable(A);return K.scheme===a.Schemas.file?((0,I.isFileToOpen)(A)&&(z={...z,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(K.fsPath,z)):this.doResolveRemoteOpenable(A,z)}doResolveRemoteOpenable(A,z){let K=this.resourceFromOpenable(A);const X=(0,f.getRemoteAuthority)(K)||z.remoteAuthority;if(K=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(K)),(0,I.isFileToOpen)(A)){if(z.gotoLineMode){const{path:G,line:Q,column:ne}=(0,V.parseLineAndColumnAware)(K.path);return{fileUri:K.with({path:G}),lineNumber:Q,columnNumber:ne,remoteAuthority:X}}return{fileUri:K,remoteAuthority:X}}else if((0,I.isWorkspaceToOpen)(A))return{workspace:(0,O.getWorkspaceIdentifier)(K),remoteAuthority:X};return{workspace:(0,O.getSingleFolderWorkspaceIdentifier)(K),remoteAuthority:X}}resourceFromOpenable(A){return(0,I.isWorkspaceToOpen)(A)?A.workspaceUri:(0,I.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,z){let K,X;z.gotoLineMode&&({path:A,line:K,column:X}=(0,V.parseLineAndColumnAware)(A)),A=(0,V.sanitizeFilePath)((0,E.normalize)(A),(0,F.cwd)());try{const G=(0,g.statSync)(A);if(G.isFile()){if(!z.forceOpenWorkspaceAsFile){const Q=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.URI.file(A));if(Q)return Q.transient&&z.rejectTransientWorkspaces?void 0:{workspace:{id:Q.id,configPath:Q.configPath},remoteAuthority:Q.remoteAuthority,exists:!0,transient:Q.transient}}return{fileUri:c.URI.file(A),lineNumber:K,columnNumber:X,exists:!0}}else if(G.isDirectory())return{workspace:(0,O.getSingleFolderWorkspaceIdentifier)(c.URI.file(A),G),exists:!0}}catch(G){const Q=c.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([Q]),z.ignoreFileNotFound)return{fileUri:Q,exists:!1}}}doResolvePathRemote(A,z){const K=A.charCodeAt(0),X=z.remoteAuthority;let G,Q;z.gotoLineMode&&({path:A,line:G,column:Q}=(0,V.parseLineAndColumnAware)(A)),K!==47&&((0,V.isWindowsDriveLetter)(K)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,V.toSlashes)(A)),A=`/${A}`);const ne=c.URI.from({scheme:a.Schemas.vscodeRemote,authority:X,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,s.hasWorkspaceFileExtension)(A))return z.forceOpenWorkspaceAsFile?{fileUri:ne,lineNumber:G,columnNumber:Q,remoteAuthority:z.remoteAuthority}:{workspace:(0,O.getWorkspaceIdentifier)(ne),remoteAuthority:X};if(z.gotoLineMode||E.posix.basename(A).indexOf(".")!==-1)return{fileUri:ne,lineNumber:G,columnNumber:Q,remoteAuthority:X}}return{workspace:(0,O.getSingleFolderWorkspaceIdentifier)(ne),remoteAuthority:X}}shouldOpenNewWindow(A){const z=this.configurationService.getValue("window"),K=z?.openFoldersInNewWindow||"default",X=z?.openFilesInNewWindow||"off";let G=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(K==="on"||K==="off")&&(G=K==="on");let Q=!1;return A.forceNewWindow||A.forceReuseWindow?Q=!!A.forceNewWindow&&!A.forceReuseWindow:(t.isMacintosh?A.context===1&&(Q=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(Q=!0),!A.cli.extensionDevelopmentPath&&(X==="on"||X==="off")&&(Q=X==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:Q}}openExtensionDevelopmentHostWindow(A,z){const K=(0,l.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(K)return this.lifecycleMainService.reload(K,z.cli),K.focus(),[K];let X=z.cli["folder-uri"]||[],G=z.cli["file-uri"]||[],Q=z.cli._;if(!Q.length&&!X.length&&!G.length&&!z.cli.extensionTestsPath){const he=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ve=he&&(he.workspace||he.folderUri);ve&&(c.URI.isUri(ve)?ve.scheme===a.Schemas.file?Q=[ve.fsPath]:X=[ve.toString()]:ve.configPath.scheme===a.Schemas.file?Q=[(0,v.originalFSPath)(ve.configPath)]:G=[ve.configPath.toString()])}let ne=z.remoteAuthority;for(const he of A)if(he.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ve=c.URI.parse(he),oe=(0,f.getRemoteAuthority)(ve);oe&&(ne?oe!==ne&&this.logService.error("more than one extension development path authority"):ne=oe)}Q=Q.filter(he=>{const ve=c.URI.file(he);return(0,l.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve)?!1:(0,f.getRemoteAuthority)(ve)===ne}),X=X.filter(he=>{const ve=this.cliArgToUri(he);return ve&&!!(0,l.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve)?!1:ve?(0,f.getRemoteAuthority)(ve)===ne:!1}),G=G.filter(he=>{const ve=this.cliArgToUri(he);return ve&&!!(0,l.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve)?!1:ve?(0,f.getRemoteAuthority)(ve)===ne:!1}),z.cli._=Q,z.cli["folder-uri"]=X,z.cli["file-uri"]=G;const se=!Q.length&&!X.length&&!G.length,ue={context:z.context,cli:z.cli,forceNewWindow:!0,forceEmpty:se,userEnv:z.userEnv,noRecentEntry:!0,waitMarkerFileURI:z.waitMarkerFileURI,remoteAuthority:ne};return this.open(ue)}openInBrowserWindow(A){const z=this.configurationService.getValue("window"),K={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,E.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:D.default,isInitialStartup:A.initialStartup,perfMarks:(0,S.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)()},zoomLevel:typeof z?.zoomLevel=="number"?z.zoomLevel:void 0,autoDetectHighContrast:z?.autoDetectHighContrast??!0,accessibilitySupport:y.app.accessibilitySupportEnabled,colorScheme:{dark:y.nativeTheme.shouldUseDarkColors,highContrast:y.nativeTheme.shouldUseInvertedColorScheme||y.nativeTheme.shouldUseHighContrastColors}};let X;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(X=A.windowToUse||this.getLastActiveWindow(),X&&X.focus()),X){const G=X.config;!K.extensionDevelopmentPath&&G&&!!G.extensionDevelopmentPath&&(K.extensionDevelopmentPath=G.extensionDevelopmentPath,K.verbose=G.verbose,K["inspect-brk-extensions"]=G["inspect-brk-extensions"],K.debugId=G.debugId,K["inspect-extensions"]=G["inspect-extensions"],K["extensions-dir"]=G["extensions-dir"])}else{const G=this.windowsStateHandler.getNewWindowState(K);(0,S.mark)("code/willCreateCodeWindow");const Q=X=this.instantiationService.createInstance(k.CodeWindow,{state:G,extensionDevelopmentPath:K.extensionDevelopmentPath,isExtensionTestHost:!!K.extensionTestsPath});if((0,S.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow){const se=this.getLastActiveWindow();se&&se.addTabbedWindow(Q)}Je.WINDOWS.push(Q),this._onDidOpenWindow.fire(Q),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,B.once)(Q.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(Q)),(0,B.once)(Q.onDidClose)(()=>this.onWindowClosed(Q)),(0,B.once)(Q.onDidDestroy)(()=>this._onDidDestroyWindow.fire(Q));const ne=(0,ie.assertIsDefined)(Q.win?.webContents);ne.removeAllListeners("devtools-reload-page"),ne.on("devtools-reload-page",()=>this.lifecycleMainService.reload(Q)),this.lifecycleMainService.registerWindow(Q)}return K.windowId=X.id,X.isReady?this.lifecycleMainService.unload(X,4).then(G=>{G||this.doOpenInBrowserWindow(X,K,A)}):this.doOpenInBrowserWindow(X,K,A),X}doOpenInBrowserWindow(A,z,K){if(!z.extensionDevelopmentPath)if((0,s.isWorkspaceIdentifier)(z.workspace))z.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:z.workspace,remoteAuthority:z.remoteAuthority});else if((0,s.isSingleFolderWorkspaceIdentifier)(z.workspace))z.backupPath=this.backupMainService.registerFolderBackupSync(z.workspace.uri);else{const X=K.emptyWindowBackupInfo&&K.emptyWindowBackupInfo.backupFolder;z.backupPath=this.backupMainService.registerEmptyWindowBackupSync(X,z.remoteAuthority)}A.load(z)}onWindowClosed(A){const z=Je.WINDOWS.indexOf(A);Je.WINDOWS.splice(z,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=y.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(z=>z.remoteAuthority===A))}doGetLastActiveWindow(A){const z=Math.max.apply(Math,A.map(K=>K.lastFocusTime));return A.find(K=>K.lastFocusTime===z)}sendToFocused(A,...z){const K=this.getFocusedWindow()||this.getLastActiveWindow();K&&K.sendWhenReady(A,U.CancellationToken.None,...z)}sendToAll(A,z,K){for(const X of this.getWindows())K&&K.indexOf(X.id)>=0||X.sendWhenReady(A,U.CancellationToken.None,z)}getWindows(){return Je.WINDOWS}getWindowCount(){return Je.WINDOWS.length}getWindowById(A){const z=this.getWindows().filter(K=>K.id===A);return(0,p.firstOrDefault)(z)}getWindowByWebContents(A){const z=y.BrowserWindow.fromWebContents(A);if(!!z)return this.getWindowById(z.id)}};C.WINDOWS=[],C=ce([ee(2,P.ILogService),ee(3,b.IStateMainService),ee(4,i.IEnvironmentMainService),ee(5,d.ILifecycleMainService),ee(6,m.IBackupMainService),ee(7,w.IConfigurationService),ee(8,u.IWorkspacesHistoryMainService),ee(9,T.IWorkspacesManagementMainService),ee(10,r.IInstantiationService),ee(11,x.IDialogMainService),ee(12,N.IFileService),ee(13,o.IProductService),ee(14,$.IProtocolMainService)],C),e.WindowsMainService=C}),define(J[237],Z([0,1,45,35,62,52]),function(j,e,g,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let E=class{constructor(p,m,i,b){this.workspacesManagementMainService=p,this.windowsMainService=m,this.workspacesHistoryMainService=i,this.backupMainService=b,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(p,m){const i=this.windowsMainService.getWindowById(p);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),m)}createUntitledWorkspace(p,m,i){return this.workspacesManagementMainService.createUntitledWorkspace(m,i)}deleteUntitledWorkspace(p,m){return this.workspacesManagementMainService.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(p,m){return this.workspacesManagementMainService.getWorkspaceIdentifier(m)}async getRecentlyOpened(p){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(p))}async addRecentlyOpened(p,m){return this.workspacesHistoryMainService.addRecentlyOpened(m)}async removeRecentlyOpened(p,m){return this.workspacesHistoryMainService.removeRecentlyOpened(m)}async clearRecentlyOpened(p){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};E=ce([ee(0,g.IWorkspacesManagementMainService),ee(1,M.IWindowsMainService),ee(2,D.IWorkspacesHistoryMainService),ee(3,S.IBackupMainService)],E),e.WorkspacesMainService=E}),define(J[238],Z([0,1,26,29,14,3,236,22,91,42,206,34,123,85,224,102,4,71,69,6,39,24,21,98,207,32,97,201,202,198,20,228,2,35,7,27,237,66,232,231,226,230,181,16,209,229,235,120,8,15,132,10,227,99,214,219,52,62,208,45,70,158,46,53,13,31,211,76,19,40,28,17,89,212,197,54,30,170,186,43,73,75,90,173,179]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w,P,I,l,h,o,u,t,s,r,a,c,v,f,L,T,O,B,q,x,ie,V,Y,U,N,F,$,W,R,C,_,A,z,K,X,G,Q,ne,se,ue,he,ve,oe,fe,me,Ie,Me,Ee,ye,be,De,Fe,Ce,je,Ne,Be,Ge,Ue,ct,Ze,ut,Ye,rt,st,H,te,re,ae,de,Se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Pe=class extends B.Disposable{constructor(le,ge,pe,we,ke,Le,Ae,Re,Te,ze){super();this.mainProcessNodeIpcServer=le,this.userEnv=ge,this.mainInstantiationService=pe,this.logService=we,this.environmentMainService=ke,this.lifecycleMainService=Le,this.configurationService=Ae,this.stateMainService=Re,this.fileService=Te,this.productService=ze,this.configureSession(),this.registerListeners()}configureSession(){const le=pe=>pe.startsWith(`${Q.Schemas.vscodeWebview}://`);D.session.defaultSession.setPermissionRequestHandler((pe,we,ke,Le)=>le(Le.requestingUrl)?ke(we==="clipboard-read"):ke(!1)),D.session.defaultSession.setPermissionCheckHandler((pe,we,ke,Le)=>le(Le.requestingUrl)?we==="clipboard-read":!1);const ge=D.session.defaultSession;typeof ge.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&ge.setCodeCachePath((0,K.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,R.setUnexpectedErrorHandler)(pe=>this.onUnexpectedError(pe)),process.on("uncaughtException",pe=>this.onUnexpectedError(pe)),process.on("unhandledRejection",pe=>(0,R.onUnexpectedError)(pe)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,z.registerContextMenuListener)(),D.app.on("accessibility-support-changed",(pe,we)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",we)}),D.app.on("activate",(pe,we)=>{this.logService.trace("app#activate"),we||this.windowsMainService?.openEmptyWindow({context:1})}),D.app.on("web-contents-created",(pe,we)=>{we.on("will-navigate",ke=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),we.setWindowOpenHandler(({url:ke})=>(this.nativeHostMainService?.openExternal(void 0,ke),{action:"deny"}))});let le=[],ge;D.app.on("open-file",(pe,we)=>{this.logService.trace("app#open-file: ",we),pe.preventDefault(),le.push(this.getWindowOpenableFromPathSync(we)),ge!==void 0&&(clearTimeout(ge),ge=void 0),ge=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:le,gotoLineMode:!1,preferNewWindow:!0}),le=[],ge=void 0},100)}),D.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),D.ipcMain.handle("vscode:fetchShellEnv",pe=>{const we=this.windowsMainService?.getWindowByWebContents(pe.sender);let ke,Le;return we?.config?(ke=we.config,Le={...process.env,...we.config.userEnv}):(ke=this.environmentMainService.args,Le=process.env),(0,p.resolveShellEnv)(this.logService,ke,Le)}),D.ipcMain.handle("vscode:writeNlsFile",(pe,we,ke)=>{const Le=this.validateNlsPath([we]);if(!Le||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Le,Ge.VSBuffer.fromString(ke))}),D.ipcMain.handle("vscode:readNlsFile",async(pe,...we)=>{const ke=this.validateNlsPath(we);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(ke)).value.toString()}),D.ipcMain.on("vscode:toggleDevTools",pe=>pe.sender.toggleDevTools()),D.ipcMain.on("vscode:openDevTools",pe=>pe.sender.openDevTools()),D.ipcMain.on("vscode:reloadWindow",pe=>pe.sender.reload())}validateNlsPath(le){let ge;for(const pe of le)typeof pe=="string"&&(typeof ge!="string"?ge=pe:ge=(0,K.join)(ge,pe));if(!(typeof ge!="string"||!(0,K.isAbsolute)(ge)||!(0,Ye.isEqualOrParent)(ge,this.environmentMainService.cachedLanguagesPath,!S.isLinux)))return x.URI.file(ge)}onUnexpectedError(le){if(le){const ge={message:`[uncaught exception in main]: ${le.message}`,stack:le.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ge))}this.logService.error(`[uncaught exception in main]: ${le}`),le.stack&&this.logService.error(le.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const le=this.productService.win32AppUserModelId;S.isWindows&&le&&D.app.setAppUserModelId(le);try{S.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!D.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&D.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.logService.error(Te)}const ge=new k.Server;this.logService.trace("Resolving machine identifier...");const pe=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${pe}`);const{sharedProcess:we,sharedProcessReady:ke,sharedProcessClient:Le}=this.setupSharedProcess(pe),Ae=await this.initServices(pe,we,ke);if(this.environmentMainService.driverHandle){const Te=await(0,_.serve)(ge,this.environmentMainService.driverHandle,this.environmentMainService,Ae);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Te)}this._register(Ae.createInstance(O.ProxyAuthHandler)),Ae.invokeFunction(Te=>this.initChannels(Te,ge,Le));const Re=Ae.invokeFunction(Te=>this.openFirstWindow(Te,ge));Ae.invokeFunction(Te=>this.afterWindowOpen(Te,we)),this.environmentMainService.args.trace&&Ae.invokeFunction(Te=>this.stopTracingEventually(Te,Re))}async resolveMachineId(){let le=this.stateMainService.getItem(a.machineIdKey);return(!le||S.isMacintosh&&le==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(le=await(0,Y.getMachineId)(),this.stateMainService.setItem(a.machineIdKey,le)),le}setupSharedProcess(le){const ge=this._register(this.mainInstantiationService.createInstance(d.SharedProcess,le,this.userEnv)),pe=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ke=await ge.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new y.Client(ke,"main")})(),we=(async()=>(await ge.whenReady(),pe))();return{sharedProcess:ge,sharedProcessReady:we,sharedProcessClient:pe}}async initServices(le,ge,pe){const we=new I.ServiceCollection;switch(process.platform){case"win32":we.set(m.IUpdateService,new l.SyncDescriptor(U.Win32UpdateService));break;case"linux":S.isLinuxSnap?we.set(m.IUpdateService,new l.SyncDescriptor(ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(m.IUpdateService,new l.SyncDescriptor(N.LinuxUpdateService));break;case"darwin":we.set(m.IUpdateService,new l.SyncDescriptor(F.DarwinUpdateService));break}we.set(q.IWindowsMainService,new l.SyncDescriptor(E.WindowsMainService,[le,this.userEnv])),we.set(ye.IDialogMainService,new l.SyncDescriptor(ye.DialogMainService)),we.set(w.ILaunchMainService,new l.SyncDescriptor(w.LaunchMainService)),we.set(Ie.IDiagnosticsService,b.ProxyChannel.toService((0,b.getDelayedChannel)(pe.then(Le=>Le.getChannel("diagnostics"))))),we.set($.IIssueMainService,new l.SyncDescriptor($.IssueMainService,[this.userEnv])),we.set(Ue.IEncryptionMainService,new l.SyncDescriptor(Ue.EncryptionMainService,[le])),we.set(Ze.IKeyboardLayoutMainService,new l.SyncDescriptor(Ze.KeyboardLayoutMainService)),we.set(Ee.INativeHostMainService,new l.SyncDescriptor(Ee.NativeHostMainService,[ge])),we.set(Ce.IWebviewManagerService,new l.SyncDescriptor(Fe.WebviewMainService)),we.set(ie.IWorkspacesService,new l.SyncDescriptor(V.WorkspacesMainService)),we.set(me.IWorkspacesManagementMainService,new l.SyncDescriptor(me.WorkspacesManagementMainService)),we.set(oe.IWorkspacesHistoryMainService,new l.SyncDescriptor(oe.WorkspacesHistoryMainService)),we.set(A.IMenubarMainService,new l.SyncDescriptor(A.MenubarMainService)),we.set(rt.IExtensionUrlTrustService,new l.SyncDescriptor(st.ExtensionUrlTrustService)),we.set(se.IStorageMainService,new l.SyncDescriptor(se.StorageMainService)),S.isWindows?we.set(ae.IExternalTerminalMainService,new l.SyncDescriptor(de.WindowsExternalTerminalService)):S.isMacintosh?we.set(ae.IExternalTerminalMainService,new l.SyncDescriptor(de.MacExternalTerminalService)):S.isLinux&&we.set(ae.IExternalTerminalMainService,new l.SyncDescriptor(de.LinuxExternalTerminalService));const ke=new he.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(we.set(ve.IBackupMainService,ke),we.set(s.IURLService,new l.SyncDescriptor(fe.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const Le=(0,b.getDelayedChannel)(pe.then(Ke=>Ke.getChannel("telemetryAppender"))),Ae=new v.TelemetryAppenderClient(Le),Re=(0,L.resolveCommonProperties)(this.fileService,(0,g.release)(),(0,g.hostname)(),process.arch,this.productService.commit,this.productService.version,le,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Te=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],ze={appender:Ae,commonProperties:Re,piiPaths:Te,sendErrorTelemetry:!0};we.set(a.ITelemetryService,new l.SyncDescriptor(f.TelemetryService,[ze]))}else we.set(a.ITelemetryService,c.NullTelemetryService);return await ke.initialize(),this.mainInstantiationService.createChild(we)}initChannels(le,ge,pe){const we=b.ProxyChannel.fromService(le.get(w.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",we),ge.registerChannel(Se.UserConfigurationFileServiceId,b.ProxyChannel.fromService(new Se.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const ke=new i.UpdateChannel(le.get(m.IUpdateService));ge.registerChannel("update",ke);const Le=b.ProxyChannel.fromService(le.get($.IIssueMainService));ge.registerChannel("issue",Le);const Ae=b.ProxyChannel.fromService(le.get(Ue.IEncryptionMainService));ge.registerChannel("encryption",Ae);const Re=b.ProxyChannel.fromService(le.get(re.ISignService));ge.registerChannel("sign",Re);const Te=b.ProxyChannel.fromService(le.get(Ze.IKeyboardLayoutMainService));ge.registerChannel("keyboardLayout",Te),this.nativeHostMainService=le.get(Ee.INativeHostMainService);const ze=b.ProxyChannel.fromService(this.nativeHostMainService);ge.registerChannel("nativeHost",ze),pe.then($e=>$e.registerChannel("nativeHost",ze));const Ke=b.ProxyChannel.fromService(le.get(ie.IWorkspacesService));ge.registerChannel("workspaces",Ke);const xe=b.ProxyChannel.fromService(le.get(A.IMenubarMainService));ge.registerChannel("menubar",xe);const et=b.ProxyChannel.fromService(le.get(s.IURLService));ge.registerChannel("url",et);const ht=b.ProxyChannel.fromService(le.get(rt.IExtensionUrlTrustService));ge.registerChannel("extensionUrlTrust",ht);const _e=b.ProxyChannel.fromService(le.get(Ce.IWebviewManagerService));ge.registerChannel("webview",_e);const tt=this._register(new ue.StorageDatabaseChannel(this.logService,le.get(se.IStorageMainService)));ge.registerChannel("storage",tt),pe.then($e=>$e.registerChannel("storage",tt));const it=b.ProxyChannel.fromService(le.get(ae.IExternalTerminalMainService));ge.registerChannel("externalTerminal",it);const Xe=new W.LogLevelChannel(le.get(h.ILogService));ge.registerChannel("logLevel",Xe),pe.then($e=>$e.registerChannel("logLevel",Xe));const nt=new W.LoggerChannel(le.get(h.ILoggerService));ge.registerChannel("logger",nt),pe.then($e=>$e.registerChannel("logger",nt));const ot=new Me.ElectronExtensionHostDebugBroadcastChannel(le.get(q.IWindowsMainService));ge.registerChannel("extensionhostdebugservice",ot)}openFirstWindow(le,ge){const pe=this.windowsMainService=le.get(q.IWindowsMainService),we=le.get(s.IURLService),ke=le.get(Ee.INativeHostMainService);this.lifecycleMainService.phase=2;const Le=[],Ae=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Oe=>{try{return{uri:x.URI.parse(Oe),url:Oe}}catch{return}}).filter(Oe=>{if(!Oe||this.shouldBlockURI(Oe.uri))return!1;const Qe=this.getWindowOpenableFromProtocolLink(Oe.uri);return Qe?(Le.push(Qe),!1):!0}),Re=this,Te=this.environmentMainService,ze=this.productService;we.registerHandler({async handleURL(Oe,Qe){if(Oe.scheme===ze.urlProtocol&&Oe.path==="workspace"&&(Oe=Oe.with({authority:"file",path:x.URI.parse(Oe.query).path,query:""})),Re.shouldBlockURI(Oe))return!0;const vt=Re.getWindowOpenableFromProtocolLink(Oe);if(vt){const[ft]=pe.open({context:5,cli:{...Te.args},urisToOpen:[vt],gotoLineMode:!0});return ft.focus(),!0}if(S.isMacintosh&&pe.getWindowCount()===0){const[ft]=pe.open({context:5,cli:{...Te.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,te.getRemoteAuthority)(Oe)});return await ft.ready(),we.open(Oe,Qe)}return!1}});const Ke=this._register(new ct.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),xe=new b.StaticRouter(Oe=>Ke.getActiveClientId().then(Qe=>Oe===Qe)),et=new r.URLHandlerRouter(xe),ht=ge.getChannel("urlHandler",et);we.registerHandler(new r.URLHandlerChannelClient(ht)),this._register(new C.ElectronURLListener(Ae,we,pe,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,tt=global.macOpenFiles,it=(0,ut.isLaunchedFromCli)(process.env)?0:4,Xe=_e._.length,nt=!!_e["folder-uri"],ot=!!_e["file-uri"],$e=_e["skip-add-to-recently-opened"]===!0,dt=_e.wait&&_e.waitMarkerFilePath?x.URI.file(_e.waitMarkerFilePath):void 0,pt=_e.remote||void 0;return Le.length>0?pe.open({context:it,cli:_e,urisToOpen:Le,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!Xe&&!nt&&!ot?pe.open({context:it,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:$e,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:pt}):tt.length&&!Xe&&!nt&&!ot?pe.open({context:1,cli:_e,urisToOpen:tt.map(Oe=>this.getWindowOpenableFromPathSync(Oe)),noRecentEntry:$e,waitMarkerFileURI:dt,initialStartup:!0}):pe.open({context:it,cli:_e,forceNewWindow:_e["new-window"]||!Xe&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:$e,waitMarkerFileURI:dt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:pt})}shouldBlockURI(le){return!!(le.authority===Q.Schemas.file&&S.isWindows&&D.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,De.mnemonicButtonLabel)((0,G.localize)(0,null)),(0,De.mnemonicButtonLabel)((0,G.localize)(1,null))],defaultId:0,cancelId:1,message:(0,G.localize)(2,null,(0,De.getPathLabel)(le.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,G.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(le){if(!!le.path){if(le.authority===Q.Schemas.file)return{fileUri:x.URI.file(le.fsPath)};if(le.authority===Q.Schemas.vscodeRemote){const ge=le.path.indexOf(K.posix.sep,1);if(ge!==-1){const pe=le.path.substring(1,ge),we=le.path.substring(ge),ke=x.URI.from({scheme:Q.Schemas.vscodeRemote,authority:pe,path:we,query:le.query,fragment:le.fragment});return(0,ie.hasWorkspaceFileExtension)(we)?{workspaceUri:ke}:/:[\d]+$/.test(we)?{fileUri:ke}:{folderUri:ke}}}}}getWindowOpenableFromPathSync(le){try{if((0,M.statSync)(le).isDirectory())return{folderUri:x.URI.file(le)};if((0,ie.hasWorkspaceFileExtension)(le))return{workspaceUri:x.URI.file(le)}}catch(ge){}return{fileUri:x.URI.file(le)}}async afterWindowOpen(le,ge){this.lifecycleMainService.phase=3;let pe=!1;(0,H.once)(this.lifecycleMainService.onWillShutdown)(()=>pe=!0);const we=le.get(a.ITelemetryService);this._register(ge.onDidError(({type:Ae,details:Re})=>{let Te;switch(Ae){case 1:Te="SharedProcess: detected unresponsive window";break;case 2:Te=`SharedProcess: crashed (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break;case 3:Te=`SharedProcess: failed to load (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break}(0,R.onUnexpectedError)(new Error(Te)),we.publicLog2("sharedprocesserror",{type:Ae,reason:Re?.reason,code:Re?.exitCode,visible:ge.isVisible(),shuttingdown:pe})}));const ke=this.productService.win32MutexName;if(S.isWindows&&ke)try{const Ae=j.__$__nodeRequire("windows-mutex").Mutex,Re=new Ae(ke);(0,H.once)(this.lifecycleMainService.onWillShutdown)(()=>Re.release())}catch(Ae){this.logService.error(Ae)}D.protocol.registerHttpProtocol(Q.Schemas.vscodeRemoteResource,(Ae,Re)=>{Re({url:Ae.url.replace(/^vscode-remote-resource:/,"http:"),method:Ae.method})});const Le=le.get(m.IUpdateService);(Le instanceof U.Win32UpdateService||Le instanceof N.LinuxUpdateService||Le instanceof F.DarwinUpdateService)&&Le.initialize(),(0,p.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const Re=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,Ne.stripComments)(Re))["enable-crash-reporter"]===void 0){const ze=this.configurationService.getValue("telemetry.enableCrashReporter"),Ke=typeof ze=="boolean"?ze:!0,xe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,Be.generateUuid)()}"`,"}"],et=Re.substring(0,Re.length-2).concat(`,
`,xe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,Ge.VSBuffer.fromString(et))}}catch(Ae){this.logService.error(Ae)}}stopTracingEventually(le,ge){this.logService.info("Tracing: waiting for windows to get ready...");const pe=le.get(ye.IDialogMainService);let we=!1;const ke=async Ae=>{if(we)return;we=!0;const Re=await D.contentTracing.stopRecording((0,X.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Ae?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Re}`):pe.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,G.localize)(4,null),detail:(0,G.localize)(5,null,Re),buttons:[(0,De.mnemonicButtonLabel)((0,G.localize)(6,null))],defaultId:0,noLink:!0},(0,be.withNullAsUndefined)(D.BrowserWindow.getFocusedWindow()))},Le=setTimeout(()=>ke(!0),3e4);Promise.all(ge.map(Ae=>Ae.ready())).then(()=>{clearTimeout(Le),ke(!1)})}};Pe=ce([ee(2,P.IInstantiationService),ee(3,h.ILogService),ee(4,u.IEnvironmentMainService),ee(5,n.ILifecycleMainService),ee(6,t.IConfigurationService),ee(7,o.IStateMainService),ee(8,je.IFileService),ee(9,T.IProductService)],Pe),e.CodeApplication=Pe}),define(J[242],Z([0,1,14,29,18,11,3,72,49,54,162,22,34,56,175,71,69,6,225,39,21,190,51,223,238,31,94,93,16,60,43,75,196,199,184,185,10,19,74,221,20,30,23,8,36,24,67,97,182,33,55,187,9,2,205]),function(j,e,g,M,D,S,E,n,p,m,i,b,k,y,d,w,P,I,l,h,o,u,t,s,r,a,c,v,f,L,T,O,B,q,x,ie,V,Y,U,N,F,$,W,R,C,_,A,z,K,X,G,Q,ne,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ue{main(){try{this.startup()}catch(oe){console.error(oe.message),g.app.exit(1)}}async startup(){(0,f.setUnexpectedErrorHandler)(be=>console.error(be));const[oe,fe,me,Ie,Me,Ee,ye]=this.createServices();try{try{await this.initServices(me,Ie,Me)}catch(be){throw this.handleStartupDataDirError(me,ye.nameLong,be),be}await oe.invokeFunction(async be=>{const De=be.get(I.ILogService),Fe=be.get(b.ILifecycleMainService),Ce=be.get(Y.IFileService),je=await this.claimInstance(De,me,Fe,oe,ye,!0);return Ee.logger=new c.SpdLogLogger("main",(0,R.join)(me.logsPath,"main.log"),!0,Ee.getLevel()),(0,T.once)(Fe.onWillShutdown)(()=>{Ce.dispose(),Ie.dispose()}),oe.createInstance(r.CodeApplication,je,fe).startup()})}catch(be){oe.invokeFunction(this.quit,be)}}createServices(){const oe=new w.ServiceCollection,fe={_serviceBrand:void 0,...p.default};oe.set(F.IProductService,fe);const me=new _.EnvironmentMainService(this.resolveArgs(),fe),Ie=this.patchEnvironment(me);oe.set(_.IEnvironmentMainService,me);const Me=new v.BufferLogService,Ee=new I.MultiplexLogService([new I.ConsoleMainLogger((0,I.getLogLevel)(me)),Me]);process.once("exit",()=>Ee.dispose()),oe.set(I.ILogService,Ee);const ye=new x.FileService(Ee);oe.set(Y.IFileService,ye);const be=new ie.DiskFileSystemProvider(Ee);ye.registerProvider(V.Schemas.file,be),oe.set(I.ILoggerService,new K.LoggerService(Ee,ye));const De=new u.ConfigurationService(me.settingsResource,ye);oe.set(o.IConfigurationService,De),oe.set(b.ILifecycleMainService,new P.SyncDescriptor(b.LifecycleMainService));const Fe=new l.StateMainService(me,Ee,ye);return oe.set(h.IStateMainService,Fe),oe.set(t.IRequestService,new P.SyncDescriptor(s.RequestMainService)),oe.set(L.IThemeMainService,new P.SyncDescriptor(L.ThemeMainService)),oe.set(O.ISignService,new P.SyncDescriptor(B.SignService)),oe.set(U.ITunnelService,new P.SyncDescriptor(N.TunnelService)),oe.set(G.IProtocolMainService,new P.SyncDescriptor(Q.ProtocolMainService)),[new d.InstantiationService(oe,!0),Ie,me,De,Fe,Me,fe]}patchEnvironment(oe){const fe={VSCODE_IPC_HOOK:oe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(me=>{const Ie=process.env[me];typeof Ie=="string"&&(fe[me]=Ie)}),Object.assign(process.env,fe),fe}initServices(oe,fe,me){return ne.Promises.settled([Promise.all([oe.extensionsPath,oe.codeCachePath,oe.logsPath,oe.globalStorageHome.fsPath,oe.workspaceStorageHome.fsPath,oe.backupHome].map(Ie=>Ie?D.Promises.mkdir(Ie,{recursive:!0}):void 0)),fe.initialize(),me.init()])}async claimInstance(oe,fe,me,Ie,Me,Ee){let ye;try{(0,n.mark)("code/willStartMainServer"),ye=await(0,y.serve)(fe.mainIPCHandle),(0,n.mark)("code/didStartMainServer"),(0,T.once)(me.onWillShutdown)(()=>ye.dispose())}catch(De){if(De.code!=="EADDRINUSE")throw this.handleStartupDataDirError(fe,Me.nameLong,De),De;let Fe;try{Fe=await(0,y.connect)(fe.mainIPCHandle,"main")}catch(Ne){if(!Ee||E.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,S.localize)(0,null,Me.nameShort),(0,S.localize)(1,null),Me.nameLong),Ne;try{(0,M.unlinkSync)(fe.mainIPCHandle)}catch(Be){throw oe.warn("Could not delete obsolete instance handle",Be),Be}return this.claimInstance(oe,fe,me,Ie,Me,!1)}if(fe.extensionTestsLocationURI&&!fe.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw oe.error(Ne),Fe.dispose(),new Error(Ne)}let Ce;!fe.args.wait&&!fe.args.status&&(Ce=setTimeout(()=>{this.showStartupWarningDialog((0,S.localize)(2,null,Me.nameShort),(0,S.localize)(3,null),Me.nameLong)},1e4));const je=k.ProxyChannel.toService(Fe.getChannel("launch"),{disableMarshalling:!0});if(fe.args.status)return Ie.invokeFunction(async()=>{const Ne=new q.DiagnosticsService(z.NullTelemetryService,Me),Be=await je.getMainProcessInfo(),Ge=await je.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ue=await Ne.getDiagnostics(Be,Ge);throw console.log(Ue),new f.ExpectedError});throw E.isWindows&&await this.windowsAllowSetForegroundWindow(je,oe),oe.trace("Sending env to running instance..."),await je.start(fe.args,process.env),Fe.dispose(),Ce&&clearTimeout(Ce),new f.ExpectedError("Sent env to running instance. Terminating...")}const be=await this.createLockfile(fe);if((0,T.once)(me.onWillShutdown)(()=>be.dispose()),fe.args.status)throw oe.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),ye}handleStartupDataDirError(oe,fe,me){if(me.code==="EACCES"||me.code==="EPERM"){const Ie=(0,C.coalesce)([oe.userDataPath,oe.extensionsPath,y.XDG_RUNTIME_DIR]).map(Me=>(0,a.getPathLabel)(Me,oe));this.showStartupWarningDialog((0,S.localize)(4,null),(0,S.localize)(5,null,(0,A.toErrorMessage)(me),Ie.join(`
`)),fe)}}showStartupWarningDialog(oe,fe,me){g.dialog.showMessageBoxSync({title:me,type:"warning",buttons:[(0,a.mnemonicButtonLabel)((0,S.localize)(6,null))],message:oe,detail:fe,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(oe,fe){if(E.isWindows){const me=await oe.getMainProcessId();fe.trace("Sending some foreground love to the running instance:",me);try{(await new Promise((Ie,Me)=>{j(["windows-foreground-love"],Ie,Me)})).allowSetForegroundWindow(me)}catch(Ie){fe.error(Ie)}}}quit(oe,fe){const me=oe.get(I.ILogService),Ie=oe.get(b.ILifecycleMainService);let Me=0;fe&&(fe.isExpected?fe.message&&me.trace(fe.message):(Me=1,fe.stack?me.error(fe.stack):me.error(`Startup error: ${fe.toString()}`))),Ie.kill(Me)}async createLockfile(oe){return await D.Promises.writeFile(oe.mainLockfile,String(process.pid)),(0,se.toDisposable)(()=>{try{(0,M.unlinkSync)(oe.mainLockfile)}catch{}})}resolveArgs(){const oe=this.validatePaths((0,m.parseMainProcessArgv)(process.argv));if(oe.wait&&!oe.waitMarkerFilePath){const fe=(0,i.createWaitMarkerFile)(oe.verbose);fe&&((0,m.addArg)(process.argv,"--waitMarkerFilePath",fe),oe.waitMarkerFilePath=fe)}return oe}validatePaths(oe){if(oe["open-url"]&&(oe._urls=oe._,oe._=[]),!oe.remote){const fe=this.doValidatePaths(oe._,oe.goto);oe._=fe}return oe}doValidatePaths(oe,fe){const me=(0,X.cwd)(),Ie=oe.map(ye=>{let be=String(ye),De;fe&&(De=(0,$.parseLineAndColumnAware)(be),be=De.path),be&&(be=this.preparePath(me,be));const Fe=(0,$.sanitizeFilePath)(be,me),Ce=(0,R.basename)(Fe);return Ce&&!(0,$.isValidBasename)(Ce)?null:fe&&De?(De.path=Fe,this.toPath(De)):Fe}),Me=E.isWindows||E.isMacintosh,Ee=(0,C.distinct)(Ie,ye=>ye&&Me?ye.toLowerCase():ye||"");return(0,C.coalesce)(Ee)}preparePath(oe,fe){return E.isWindows&&(fe=(0,W.rtrim)(fe,'"')),fe=(0,W.trim)((0,W.trim)(fe," "),"	"),E.isWindows&&(fe=(0,R.resolve)(oe,fe),fe=(0,W.rtrim)(fe,".")),fe}toPath(oe){const fe=[oe.path];return typeof oe.line=="number"&&fe.push(String(oe.line)),typeof oe.column=="number"&&fe.push(String(oe.column)),fe.join(":")}}new ue().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/807dfb817fef0d0c5729c1924bd4889b04fa405b/core/vs/code/electron-main/main.js.map
