/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/errors","vs/base/common/network","vs/base/node/pfs","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/arrays","vs/platform/registry/common/platform","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/base/common/process","vs/platform/product/common/product","vs/platform/telemetry/common/telemetry","vs/base/common/stream","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/performance","vs/base/common/iterator","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],ee=function(_){for(var t=[],m=0,O=_.length;m<O;m++)t[m]=Y[_[m]];return t};define(Y[57],ee([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function m(O,E){if(!O)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}t.ok=m}),define(Y[44],ee([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function m(T){return(L,u,g)=>{let y=null,v=null;if(typeof g.value=="function"?(y="value",v=g.value):typeof g.get=="function"&&(y="get",v=g.get),!v)throw new Error("not supported");g[y]=T(v,u)}}t.createDecorator=m;function O(T,L,u){let g=null,y=null;if(typeof u.value=="function"?(g="value",y=u.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(g="get",y=u.get),!y)throw new Error("not supported");const v=`$memoize$${L}`;u[g]=function(...w){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,w)}),this[v]}}t.memoize=O;function E(T,L,u){return m((g,y)=>{const v=`$debounce$${y}`,w=`$debounce$result$${y}`;return function(...F){this[w]||(this[w]=u?u():void 0),clearTimeout(this[v]),L&&(this[w]=L(this[w],...F),F=[this[w]]),this[v]=setTimeout(()=>{g.apply(this,F),this[w]=u?u():void 0},T)}})}t.debounce=E;function P(T,L,u){return m((g,y)=>{const v=`$throttle$timer$${y}`,w=`$throttle$result$${y}`,F=`$throttle$lastRun$${y}`,c=`$throttle$pending$${y}`;return function(...f){if(this[w]||(this[w]=u?u():void 0),(this[F]===null||this[F]===void 0)&&(this[F]=-Number.MAX_VALUE),L&&(this[w]=L(this[w],...f)),this[c])return;const I=this[F]+T;I<=Date.now()?(this[F]=Date.now(),g.apply(this,[this[w]]),this[w]=u?u():void 0):(this[c]=!0,this[v]=setTimeout(()=>{this[c]=!1,this[F]=Date.now(),g.apply(this,[this[w]]),this[w]=u?u():void 0},I-Date.now()))}})}t.throttle=P}),define(Y[24],ee([0,1,8]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayQueue=t.maxIndex=t.minIndex=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function O(S,d=0){return S[S.length-(1+d)]}t.tail=O;function E(S){if(S.length===0)throw new Error("Invalid tail call");return[S.slice(0,S.length-1),S[S.length-1]]}t.tail2=E;function P(S,d,D=(A,N)=>A===N){if(S===d)return!0;if(!S||!d||S.length!==d.length)return!1;for(let A=0,N=S.length;A<N;A++)if(!D(S[A],d[A]))return!1;return!0}t.equals=P;function T(S,d,D){let A=0,N=S.length-1;for(;A<=N;){const U=(A+N)/2|0,B=D(S[U],d);if(B<0)A=U+1;else if(B>0)N=U-1;else return U}return-(A+1)}t.binarySearch=T;function L(S,d){let D=0,A=S.length;if(A===0)return 0;for(;D<A;){const N=Math.floor((D+A)/2);d(S[N])?A=N:D=N+1}return D}t.findFirstInSorted=L;function u(S,d,D){if(S=S|0,S>=d.length)throw new TypeError("invalid index");let A=d[Math.floor(d.length*Math.random())],N=[],U=[],B=[];for(let $ of d){const H=D($,A);H<0?N.push($):H>0?U.push($):B.push($)}return S<N.length?u(S,N,D):S<N.length+B.length?B[0]:u(S-(N.length+B.length),U,D)}t.quickSelect=u;function g(S,d){const D=[];let A;for(const N of S.slice(0).sort(d))!A||d(A[0],N)!==0?(A=[N],D.push(A)):A.push(N);return D}t.groupBy=g;function y(S,d,D){const A=[];function N($,H,J){if(H===0&&J.length===0)return;const te=A[A.length-1];te&&te.start+te.deleteCount===$?(te.deleteCount+=H,te.toInsert.push(...J)):A.push({start:$,deleteCount:H,toInsert:J})}let U=0,B=0;for(;;){if(U===S.length){N(U,0,d.slice(B));break}if(B===d.length){N(U,S.length-U,[]);break}const $=S[U],H=d[B],J=D($,H);J===0?(U+=1,B+=1):J<0?(N(U,1,[]),U+=1):J>0&&(N(U,0,[H]),B+=1)}return A}t.sortedDiff=y;function v(S,d,D){const A=y(S,d,D),N=[],U=[];for(const B of A)N.push(...S.slice(B.start,B.start+B.deleteCount)),U.push(...B.toInsert);return{removed:N,added:U}}t.delta=v;function w(S,d,D){if(D===0)return[];const A=S.slice(0,D).sort(d);return c(S,d,A,D,S.length),A}t.top=w;function F(S,d,D,A,N){return D===0?Promise.resolve([]):new Promise((U,B)=>{(async()=>{const $=S.length,H=S.slice(0,D).sort(d);for(let J=D,te=Math.min(D+A,$);J<$;J=te,te=Math.min(te+A,$)){if(J>D&&await new Promise(ne=>setTimeout(ne)),N&&N.isCancellationRequested)throw(0,m.canceled)();c(S,d,H,J,te)}return H})().then(U,B)})}t.topAsync=F;function c(S,d,D,A,N){for(const U=D.length;A<N;A++){const B=S[A];if(d(B,D[U-1])<0){D.pop();const $=L(D,H=>d(B,H)<0);D.splice($,0,B)}}}function f(S){return S.filter(d=>!!d)}t.coalesce=f;function I(S){let d=0;for(let D=0;D<S.length;D++)S[D]&&(S[d]=S[D],d+=1);S.length=d}t.coalesceInPlace=I;function C(S,d,D){S.splice(D,0,S.splice(d,1)[0])}t.move=C;function b(S){return!Array.isArray(S)||S.length===0}t.isFalsyOrEmpty=b;function l(S){return Array.isArray(S)&&S.length>0}t.isNonEmptyArray=l;function r(S,d){if(!d)return S.filter((A,N)=>S.indexOf(A)===N);const D=Object.create(null);return S.filter(A=>{const N=d(A);return D[N]?!1:(D[N]=!0,!0)})}t.distinct=r;function o(S){const d=new Set;return S.filter(D=>d.has(D)?!1:(d.add(D),!0))}t.distinctES6=o;function e(S){const d=Object.create(null);return D=>{const A=S(D);return d[A]?!1:(d[A]=!0,!0)}}t.uniqueFilter=e;function i(S,d){for(let D=S.length-1;D>=0;D--){const A=S[D];if(d(A))return D}return-1}t.lastIndex=i;function n(S,d){return S.length>0?S[0]:d}t.firstOrDefault=n;function s(S,d,D=(A,N)=>A===N){let A=0;for(let N=0,U=Math.min(S.length,d.length);N<U&&D(S[N],d[N]);N++)A++;return A}t.commonPrefixLength=s;function a(S){return[].concat(...S)}t.flatten=a;function h(S,d){let D=typeof d=="number"?S:0;typeof d=="number"?D=S:(D=0,d=S);const A=[];if(D<=d)for(let N=D;N<d;N++)A.push(N);else for(let N=D;N>d;N--)A.push(N);return A}t.range=h;function p(S,d,D){return S.reduce((A,N)=>(A[d(N)]=D?D(N):N,A),Object.create(null))}t.index=p;function M(S,d){return S.push(d),()=>R(S,d)}t.insert=M;function R(S,d){const D=S.indexOf(d);if(D>-1)return S.splice(D,1),d}t.remove=R;function k(S,d,D){const A=S.slice(0,d),N=S.slice(d);return A.concat(D,N)}t.arrayInsert=k;function z(S,d){let D;if(typeof d=="number"){let A=d;D=()=>{const N=Math.sin(A++)*179426549;return N-Math.floor(N)}}else D=Math.random;for(let A=S.length-1;A>0;A-=1){const N=Math.floor(D()*(A+1)),U=S[A];S[A]=S[N],S[N]=U}}t.shuffle=z;function W(S,d){const D=S.indexOf(d);D>-1&&(S.splice(D,1),S.unshift(d))}t.pushToStart=W;function Q(S,d){const D=S.indexOf(d);D>-1&&(S.splice(D,1),S.push(d))}t.pushToEnd=Q;function ie(S,d){return Array.isArray(S)?S.map(d):d(S)}t.mapArrayOrNot=ie;function re(S){return Array.isArray(S)?S:[S]}t.asArray=re;function Z(S){return S[Math.floor(Math.random()*S.length)]}t.getRandomElement=Z;function X(S,d){for(const D of S){const A=d(D);if(A!==void 0)return A}}t.mapFind=X;function j(S,d){let D=Number.MAX_SAFE_INTEGER,A=0;return S.forEach((N,U)=>{const B=d(N);B<D&&(D=B,A=U)}),A}t.minIndex=j;function x(S,d){let D=Number.MIN_SAFE_INTEGER,A=0;return S.forEach((N,U)=>{const B=d(N);B>D&&(D=B,A=U)}),A}t.maxIndex=x;class q{constructor(d){this.items=d,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(d){let D=this.firstIdx;for(;D<this.items.length&&d(this.items[D]);)D++;const A=D===this.firstIdx?null:this.items.slice(this.firstIdx,D);return this.firstIdx=D,A}takeFromEndWhile(d){let D=this.lastIdx;for(;D>=0&&d(this.items[D]);)D--;const A=D===this.lastIdx?null:this.items.slice(D+1,this.lastIdx+1);return this.lastIdx=D,A}}t.ArrayQueue=q}),define(Y[58],ee([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var m;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(m=t.ScanError||(t.ScanError={}));var O;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(O=t.SyntaxKind||(t.SyntaxKind={}));var E;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(E=t.ParseErrorCode||(t.ParseErrorCode={}));var P;(function(e){e.DEFAULT={allowTrailingComma:!0}})(P=t.ParseOptions||(t.ParseOptions={}));function T(e,i=!1){let n=0,s=e.length,a="",h=0,p=16,M=0;function R(Z){let X=0,j=0;for(;X<Z;){const x=e.charCodeAt(n);if(x>=48&&x<=57)j=j*16+x-48;else if(x>=65&&x<=70)j=j*16+x-65+10;else if(x>=97&&x<=102)j=j*16+x-97+10;else break;n++,X++}return X<Z&&(j=-1),j}function k(Z){n=Z,a="",h=0,p=16,M=0}function z(){const Z=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&g(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&g(e.charCodeAt(n)))for(n++;n<e.length&&g(e.charCodeAt(n));)n++;else return M=3,e.substring(Z,n);let X=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&g(e.charCodeAt(n))){for(n++;n<e.length&&g(e.charCodeAt(n));)n++;X=n}else M=3;return e.substring(Z,X)}function W(){let Z="",X=n;for(;;){if(n>=s){Z+=e.substring(X,n),M=2;break}const j=e.charCodeAt(n);if(j===34){Z+=e.substring(X,n),n++;break}if(j===92){if(Z+=e.substring(X,n),n++,n>=s){M=2;break}switch(e.charCodeAt(n++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:const q=R(4);q>=0?Z+=String.fromCharCode(q):M=4;break;default:M=5}X=n;continue}if(j>=0&&j<=31)if(u(j)){Z+=e.substring(X,n),M=2;break}else M=6;n++}return Z}function Q(){if(a="",M=0,h=n,n>=s)return h=s,p=17;let Z=e.charCodeAt(n);if(L(Z)){do n++,a+=String.fromCharCode(Z),Z=e.charCodeAt(n);while(L(Z));return p=15}if(u(Z))return n++,a+=String.fromCharCode(Z),Z===13&&e.charCodeAt(n)===10&&(n++,a+=`
`),p=14;switch(Z){case 123:return n++,p=1;case 125:return n++,p=2;case 91:return n++,p=3;case 93:return n++,p=4;case 58:return n++,p=6;case 44:return n++,p=5;case 34:return n++,a=W(),p=10;case 47:const X=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<s&&!u(e.charCodeAt(n));)n++;return a=e.substring(X,n),p=12}if(e.charCodeAt(n+1)===42){n+=2;const j=s-1;let x=!1;for(;n<j;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,M=1),a=e.substring(X,n),p=13}return a+=String.fromCharCode(Z),n++,p=16;case 45:if(a+=String.fromCharCode(Z),n++,n===s||!g(e.charCodeAt(n)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=z(),p=11;default:for(;n<s&&ie(Z);)n++,Z=e.charCodeAt(n);if(h!==n){switch(a=e.substring(h,n),a){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return a+=String.fromCharCode(Z),n++,p=16}}function ie(Z){if(L(Z)||u(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let Z;do Z=Q();while(Z>=12&&Z<=15);return Z}return{setPosition:k,getPosition:()=>n,scan:i?re:Q,getToken:()=>p,getTokenValue:()=>a,getTokenOffset:()=>h,getTokenLength:()=>n-h,getTokenError:()=>M}}t.createScanner=T;function L(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function u(e){return e===10||e===13||e===8232||e===8233}function g(e){return e>=48&&e<=57}var y;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(y||(y={}));function v(e,i){const n=[],s=new Object;let a;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function M(R,k,z,W){h.value=R,h.offset=k,h.length=z,h.type=W,h.colonOffset=void 0,a=h}try{l(e,{onObjectBegin:(R,k)=>{if(i<=R)throw s;a=void 0,p=i>R,n.push("")},onObjectProperty:(R,k,z)=>{if(i<k||(M(R,k,z,"property"),n[n.length-1]=R,i<=k+z))throw s},onObjectEnd:(R,k)=>{if(i<=R)throw s;a=void 0,n.pop()},onArrayBegin:(R,k)=>{if(i<=R)throw s;a=void 0,n.push(0)},onArrayEnd:(R,k)=>{if(i<=R)throw s;a=void 0,n.pop()},onLiteralValue:(R,k,z)=>{if(i<k||(M(R,k,z,o(R)),i<=k+z))throw s},onSeparator:(R,k,z)=>{if(i<=k)throw s;if(R===":"&&a&&a.type==="property")a.colonOffset=k,p=!1,a=void 0;else if(R===","){const W=n[n.length-1];typeof W=="number"?n[n.length-1]=W+1:(p=!0,n[n.length-1]=""),a=void 0}}})}catch(R){if(R!==s)throw R}return{path:n,previousNode:a,isAtPropertyKey:p,matches:R=>{let k=0;for(let z=0;k<R.length&&z<n.length;z++)if(R[k]===n[z]||R[k]==="*")k++;else if(R[k]!=="**")return!1;return k===R.length}}}t.getLocation=v;function w(e,i=[],n=P.DEFAULT){let s=null,a=[];const h=[];function p(R){Array.isArray(a)?a.push(R):s!==null&&(a[s]=R)}return l(e,{onObjectBegin:()=>{const R={};p(R),h.push(a),a=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const R=[];p(R),h.push(a),a=R,s=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:p,onError:(R,k,z)=>{i.push({error:R,offset:k,length:z})}},n),a[0]}t.parse=w;function F(e,i=[],n=P.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(R){s.type==="property"&&(s.length=R-s.offset,s=s.parent)}function h(R){return s.children.push(R),R}l(e,{onObjectBegin:R=>{s=h({type:"object",offset:R,length:-1,parent:s,children:[]})},onObjectProperty:(R,k,z)=>{s=h({type:"property",offset:k,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:R,offset:k,length:z,parent:s})},onObjectEnd:(R,k)=>{s.length=R+k-s.offset,s=s.parent,a(R+k)},onArrayBegin:(R,k)=>{s=h({type:"array",offset:R,length:-1,parent:s,children:[]})},onArrayEnd:(R,k)=>{s.length=R+k-s.offset,s=s.parent,a(R+k)},onLiteralValue:(R,k,z)=>{h({type:o(R),offset:k,length:z,parent:s,value:R}),a(k+z)},onSeparator:(R,k,z)=>{s.type==="property"&&(R===":"?s.colonOffset=k:R===","&&a(k))},onError:(R,k,z)=>{i.push({error:R,offset:k,length:z})}},n);const M=s.children[0];return M&&delete M.parent,M}t.parseTree=F;function c(e,i){if(!e)return;let n=e;for(let s of i)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const h of n.children)if(Array.isArray(h.children)&&h.children[0].value===s){n=h.children[1],a=!0;break}if(!a)return}else{const a=s;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}t.findNodeAtLocation=c;function f(e){if(!e.parent||!e.parent.children)return[];const i=f(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=f;function I(e){switch(e.type){case"array":return e.children.map(I);case"object":const i=Object.create(null);for(let n of e.children){const s=n.children[1];s&&(i[n.children[0].value]=I(s))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=I;function C(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=C;function b(e,i,n=!1){if(C(e,i,n)){const s=e.children;if(Array.isArray(s))for(let a=0;a<s.length&&s[a].offset<=i;a++){const h=b(s[a],i,n);if(h)return h}return e}}t.findNodeAtOffset=b;function l(e,i,n=P.DEFAULT){const s=T(e,!1);function a(U){return U?()=>U(s.getTokenOffset(),s.getTokenLength()):()=>!0}function h(U){return U?B=>U(B,s.getTokenOffset(),s.getTokenLength()):()=>!0}const p=a(i.onObjectBegin),M=h(i.onObjectProperty),R=a(i.onObjectEnd),k=a(i.onArrayBegin),z=a(i.onArrayEnd),W=h(i.onLiteralValue),Q=h(i.onSeparator),ie=a(i.onComment),re=h(i.onError),Z=n&&n.disallowComments,X=n&&n.allowTrailingComma;function j(){for(;;){const U=s.scan();switch(s.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:Z||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(U){case 12:case 13:Z?x(10):ie();break;case 16:x(1);break;case 15:case 14:break;default:return U}}}function x(U,B=[],$=[]){if(re(U),B.length+$.length>0){let H=s.getToken();for(;H!==17;){if(B.indexOf(H)!==-1){j();break}else if($.indexOf(H)!==-1)break;H=j()}}}function q(U){const B=s.getTokenValue();return U?W(B):M(B),j(),!0}function S(){switch(s.getToken()){case 11:let U=0;try{U=JSON.parse(s.getTokenValue()),typeof U!="number"&&(x(2),U=0)}catch(B){x(2)}W(U);break;case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return j(),!0}function d(){return s.getToken()!==10?(x(3,[],[2,5]),!1):(q(!1),s.getToken()===6?(Q(":"),j(),N()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function D(){p(),j();let U=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(U||x(4,[],[]),Q(","),j(),s.getToken()===2&&X)break}else U&&x(6,[],[]);d()||x(4,[],[2,5]),U=!0}return R(),s.getToken()!==2?x(7,[2],[]):j(),!0}function A(){k(),j();let U=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(U||x(4,[],[]),Q(","),j(),s.getToken()===4&&X)break}else U&&x(6,[],[]);N()||x(4,[],[4,5]),U=!0}return z(),s.getToken()!==4?x(8,[4],[]):j(),!0}function N(){switch(s.getToken()){case 3:return A();case 1:return D();case 10:return q(!0);default:return S()}}return j(),s.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):N()?(s.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}t.visit=l;function r(e,i){let n=T(e),s=[],a,h=0,p;do switch(p=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:h!==p&&s.push(e.substring(h,p)),i!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,i)),h=n.getPosition();break}while(a!==17);return s.join("")}t.stripComments=r;function o(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=o}),function(){function _(E){const P=[];typeof E=="number"&&P.push("code/timeOrigin",E);function T(u){P.push(u,Date.now())}function L(){const u=[];for(let g=0;g<P.length;g+=2)u.push({name:P[g],startTime:P[g+1]});return u}return{mark:T,getMarks:L}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const T of performance.getEntriesByType("mark"))P.push({name:T.name,startTime:Math.round(E+T.startTime)});return P}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function m(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=t()),E.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=m(O))}(),function(_,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var m=t();for(var O in m)(typeof exports=="object"?exports:_)[O]=m[O]}}(typeof self!="undefined"?self:this,function(){return function(_){var t={};function m(O){if(t[O])return t[O].exports;var E=t[O]={i:O,l:!1,exports:{}};return _[O].call(E.exports,E,E.exports,m),E.l=!0,E.exports}return m.m=_,m.c=t,m.d=function(O,E,P){m.o(O,E)||Object.defineProperty(O,E,{enumerable:!0,get:P})},m.r=function(O){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},m.t=function(O,E){if(1&E&&(O=m(O)),8&E||4&E&&typeof O=="object"&&O&&O.__esModule)return O;var P=Object.create(null);if(m.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:O}),2&E&&typeof O!="string")for(var T in O)m.d(P,T,function(L){return O[L]}.bind(null,T));return P},m.n=function(O){var E=O&&O.__esModule?function(){return O.default}:function(){return O};return m.d(E,"a",E),E},m.o=function(O,E){return Object.prototype.hasOwnProperty.call(O,E)},m.p="",m(m.s=0)}([function(_,t,m){(function(O){var E;t=_.exports=$,E=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var P=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,L=t.re=[],u=t.src=[],g=0,y=g++;u[y]="0|[1-9]\\d*";var v=g++;u[v]="[0-9]+";var w=g++;u[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var F=g++;u[F]="("+u[y]+")\\.("+u[y]+")\\.("+u[y]+")";var c=g++;u[c]="("+u[v]+")\\.("+u[v]+")\\.("+u[v]+")";var f=g++;u[f]="(?:"+u[y]+"|"+u[w]+")";var I=g++;u[I]="(?:"+u[v]+"|"+u[w]+")";var C=g++;u[C]="(?:-("+u[f]+"(?:\\."+u[f]+")*))";var b=g++;u[b]="(?:-?("+u[I]+"(?:\\."+u[I]+")*))";var l=g++;u[l]="[0-9A-Za-z-]+";var r=g++;u[r]="(?:\\+("+u[l]+"(?:\\."+u[l]+")*))";var o=g++,e="v?"+u[F]+u[C]+"?"+u[r]+"?";u[o]="^"+e+"$";var i="[v=\\s]*"+u[c]+u[b]+"?"+u[r]+"?",n=g++;u[n]="^"+i+"$";var s=g++;u[s]="((?:<|>)?=?)";var a=g++;u[a]=u[v]+"|x|X|\\*";var h=g++;u[h]=u[y]+"|x|X|\\*";var p=g++;u[p]="[v=\\s]*("+u[h]+")(?:\\.("+u[h]+")(?:\\.("+u[h]+")(?:"+u[C]+")?"+u[r]+"?)?)?";var M=g++;u[M]="[v=\\s]*("+u[a]+")(?:\\.("+u[a]+")(?:\\.("+u[a]+")(?:"+u[b]+")?"+u[r]+"?)?)?";var R=g++;u[R]="^"+u[s]+"\\s*"+u[p]+"$";var k=g++;u[k]="^"+u[s]+"\\s*"+u[M]+"$";var z=g++;u[z]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=g++;u[W]="(?:~>?)";var Q=g++;u[Q]="(\\s*)"+u[W]+"\\s+",L[Q]=new RegExp(u[Q],"g");var ie=g++;u[ie]="^"+u[W]+u[p]+"$";var re=g++;u[re]="^"+u[W]+u[M]+"$";var Z=g++;u[Z]="(?:\\^)";var X=g++;u[X]="(\\s*)"+u[Z]+"\\s+",L[X]=new RegExp(u[X],"g");var j=g++;u[j]="^"+u[Z]+u[p]+"$";var x=g++;u[x]="^"+u[Z]+u[M]+"$";var q=g++;u[q]="^"+u[s]+"\\s*("+i+")$|^$";var S=g++;u[S]="^"+u[s]+"\\s*("+e+")$|^$";var d=g++;u[d]="(\\s*)"+u[s]+"\\s*("+i+"|"+u[p]+")",L[d]=new RegExp(u[d],"g");var D=g++;u[D]="^\\s*("+u[p]+")\\s+-\\s+("+u[p]+")\\s*$";var A=g++;u[A]="^\\s*("+u[M]+")\\s+-\\s+("+u[M]+")\\s*$";var N=g++;u[N]="(<|>)?=?\\s*\\*";for(var U=0;U<35;U++)E(U,u[U]),L[U]||(L[U]=new RegExp(u[U]));function B(V,G){if(V instanceof $)return V;if(typeof V!="string"||V.length>P||!(G?L[n]:L[o]).test(V))return null;try{return new $(V,G)}catch(K){return null}}function $(V,G){if(V instanceof $){if(V.loose===G)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof $))return new $(V,G);E("SemVer",V,G),this.loose=G;var K=V.trim().match(G?L[n]:L[o]);if(!K)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var oe=+se;if(oe>=0&&oe<T)return oe}return se}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}t.parse=B,t.valid=function(V,G){var K=B(V,G);return K?K.version:null},t.clean=function(V,G){var K=B(V.trim().replace(/^[=v]+/,""),G);return K?K.version:null},t.SemVer=$,$.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$.prototype.toString=function(){return this.version},$.prototype.compare=function(V){return E("SemVer.compare",this.version,this.loose,V),V instanceof $||(V=new $(V,this.loose)),this.compareMain(V)||this.comparePre(V)},$.prototype.compareMain=function(V){return V instanceof $||(V=new $(V,this.loose)),J(this.major,V.major)||J(this.minor,V.minor)||J(this.patch,V.patch)},$.prototype.comparePre=function(V){if(V instanceof $||(V=new $(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var G=0;do{var K=this.prerelease[G],se=V.prerelease[G];if(E("prerelease compare",G,K,se),K===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(K===void 0)return-1;if(K!==se)return J(K,se)}while(++G)},$.prototype.inc=function(V,G){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},t.inc=function(V,G,K,se){typeof K=="string"&&(se=K,K=void 0);try{return new $(V,K).inc(G,se).version}catch(oe){return null}},t.diff=function(V,G){if(he(V,G))return null;var K=B(V),se=B(G);if(K.prerelease.length||se.prerelease.length){for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return"pre"+oe;return"prerelease"}for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return oe},t.compareIdentifiers=J;var H=/^[0-9]+$/;function J(V,G){var K=H.test(V),se=H.test(G);return K&&se&&(V=+V,G=+G),K&&!se?-1:se&&!K?1:V<G?-1:V>G?1:0}function te(V,G,K){return new $(V,K).compare(new $(G,K))}function ne(V,G,K){return te(V,G,K)>0}function ae(V,G,K){return te(V,G,K)<0}function he(V,G,K){return te(V,G,K)===0}function ve(V,G,K){return te(V,G,K)!==0}function De(V,G,K){return te(V,G,K)>=0}function ke(V,G,K){return te(V,G,K)<=0}function Te(V,G,K,se){var oe;switch(G){case"===":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),oe=V===K;break;case"!==":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),oe=V!==K;break;case"":case"=":case"==":oe=he(V,K,se);break;case"!=":oe=ve(V,K,se);break;case">":oe=ne(V,K,se);break;case">=":oe=De(V,K,se);break;case"<":oe=ae(V,K,se);break;case"<=":oe=ke(V,K,se);break;default:throw new TypeError("Invalid operator: "+G)}return oe}function we(V,G){if(V instanceof we){if(V.loose===G)return V;V=V.value}if(!(this instanceof we))return new we(V,G);E("comparator",V,G),this.loose=G,this.parse(V),this.semver===Fe?this.value="":this.value=this.operator+this.semver.version,E("comp",this)}t.rcompareIdentifiers=function(V,G){return J(G,V)},t.major=function(V,G){return new $(V,G).major},t.minor=function(V,G){return new $(V,G).minor},t.patch=function(V,G){return new $(V,G).patch},t.compare=te,t.compareLoose=function(V,G){return te(V,G,!0)},t.rcompare=function(V,G,K){return te(G,V,K)},t.sort=function(V,G){return V.sort(function(K,se){return t.compare(K,se,G)})},t.rsort=function(V,G){return V.sort(function(K,se){return t.rcompare(K,se,G)})},t.gt=ne,t.lt=ae,t.eq=he,t.neq=ve,t.gte=De,t.lte=ke,t.cmp=Te,t.Comparator=we;var Fe={};function pe(V,G){if(V instanceof pe)return V.loose===G?V:new pe(V.raw,G);if(V instanceof we)return new pe(V.value,G);if(!(this instanceof pe))return new pe(V,G);if(this.loose=G,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function Re(V){return!V||V.toLowerCase()==="x"||V==="*"}function je(V,G,K,se,oe,Se,de,Le,ye,Pe,Ae,Ee,be){return((G=Re(K)?"":Re(se)?">="+K+".0.0":Re(oe)?">="+K+"."+se+".0":">="+G)+" "+(Le=Re(ye)?"":Re(Pe)?"<"+(+ye+1)+".0.0":Re(Ae)?"<"+ye+"."+(+Pe+1)+".0":Ee?"<="+ye+"."+Pe+"."+Ae+"-"+Ee:"<="+Le)).trim()}function Be(V,G){for(var K=0;K<V.length;K++)if(!V[K].test(G))return!1;if(G.prerelease.length){for(K=0;K<V.length;K++)if(E(V[K].semver),V[K].semver!==Fe&&V[K].semver.prerelease.length>0){var se=V[K].semver;if(se.major===G.major&&se.minor===G.minor&&se.patch===G.patch)return!0}return!1}return!0}function xe(V,G,K){try{G=new pe(G,K)}catch(se){return!1}return G.test(V)}function ze(V,G,K,se){var oe,Se,de,Le,ye;switch(V=new $(V,se),G=new pe(G,se),K){case">":oe=ne,Se=ke,de=ae,Le=">",ye=">=";break;case"<":oe=ae,Se=De,de=ne,Le="<",ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(V,G,se))return!1;for(var Pe=0;Pe<G.set.length;++Pe){var Ae=G.set[Pe],Ee=null,be=null;if(Ae.forEach(function(Ce){Ce.semver===Fe&&(Ce=new we(">=0.0.0")),Ee=Ee||Ce,be=be||Ce,oe(Ce.semver,Ee.semver,se)?Ee=Ce:de(Ce.semver,be.semver,se)&&(be=Ce)}),Ee.operator===Le||Ee.operator===ye||(!be.operator||be.operator===Le)&&Se(V,be.semver)||be.operator===ye&&de(V,be.semver))return!1}return!0}we.prototype.parse=function(V){var G=this.loose?L[q]:L[S],K=V.match(G);if(!K)throw new TypeError("Invalid comparator: "+V);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new $(K[2],this.loose):this.semver=Fe},we.prototype.toString=function(){return this.value},we.prototype.test=function(V){return E("Comparator.test",V,this.loose),this.semver===Fe||(typeof V=="string"&&(V=new $(V,this.loose)),Te(V,this.operator,this.semver,this.loose))},we.prototype.intersects=function(V,G){if(!(V instanceof we))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new pe(V.value,G),xe(this.value,K,G);if(V.operator==="")return K=new pe(this.value,G),xe(V.semver,K,G);var se=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),oe=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Se=this.semver.version===V.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Le=Te(this.semver,"<",V.semver,G)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),ye=Te(this.semver,">",V.semver,G)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return se||oe||Se&&de||Le||ye},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(V){var G=this.loose;V=V.trim(),E("range",V,G);var K=G?L[A]:L[D];V=V.replace(K,je),E("hyphen replace",V),V=V.replace(L[d],"$1$2$3"),E("comparator trim",V,L[d]),V=(V=(V=V.replace(L[Q],"$1~")).replace(L[X],"$1^")).split(/\s+/).join(" ");var se=G?L[q]:L[S],oe=V.split(" ").map(function(Se){return function(de,Le){return E("comp",de),de=function(ye,Pe){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,be){E("caret",Ee,be);var Ce=be?L[x]:L[j];return Ee.replace(Ce,function(Oe,le,fe,ge,me){var Ie;return E("caret",Ee,Oe,le,fe,ge,me),Re(le)?Ie="":Re(fe)?Ie=">="+le+".0.0 <"+(+le+1)+".0.0":Re(ge)?Ie=le==="0"?">="+le+"."+fe+".0 <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+".0 <"+(+le+1)+".0.0":me?(E("replaceCaret pr",me),me.charAt(0)!=="-"&&(me="-"+me),Ie=le==="0"?fe==="0"?">="+le+"."+fe+"."+ge+me+" <"+le+"."+fe+"."+(+ge+1):">="+le+"."+fe+"."+ge+me+" <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+"."+ge+me+" <"+(+le+1)+".0.0"):(E("no pr"),Ie=le==="0"?fe==="0"?">="+le+"."+fe+"."+ge+" <"+le+"."+fe+"."+(+ge+1):">="+le+"."+fe+"."+ge+" <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+"."+ge+" <"+(+le+1)+".0.0"),E("caret return",Ie),Ie})}(Ae,Pe)}).join(" ")}(de,Le),E("caret",de),de=function(ye,Pe){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,be){var Ce=be?L[re]:L[ie];return Ee.replace(Ce,function(Oe,le,fe,ge,me){var Ie;return E("tilde",Ee,Oe,le,fe,ge,me),Re(le)?Ie="":Re(fe)?Ie=">="+le+".0.0 <"+(+le+1)+".0.0":Re(ge)?Ie=">="+le+"."+fe+".0 <"+le+"."+(+fe+1)+".0":me?(E("replaceTilde pr",me),me.charAt(0)!=="-"&&(me="-"+me),Ie=">="+le+"."+fe+"."+ge+me+" <"+le+"."+(+fe+1)+".0"):Ie=">="+le+"."+fe+"."+ge+" <"+le+"."+(+fe+1)+".0",E("tilde return",Ie),Ie})}(Ae,Pe)}).join(" ")}(de,Le),E("tildes",de),de=function(ye,Pe){return E("replaceXRanges",ye,Pe),ye.split(/\s+/).map(function(Ae){return function(Ee,be){Ee=Ee.trim();var Ce=be?L[k]:L[R];return Ee.replace(Ce,function(Oe,le,fe,ge,me,Ie){E("xRange",Ee,Oe,le,fe,ge,me,Ie);var Ve=Re(fe),Me=Ve||Re(ge),Ue=Me||Re(me);return le==="="&&Ue&&(le=""),Ve?Oe=le===">"||le==="<"?"<0.0.0":"*":le&&Ue?(Me&&(ge=0),Ue&&(me=0),le===">"?(le=">=",Me?(fe=+fe+1,ge=0,me=0):Ue&&(ge=+ge+1,me=0)):le==="<="&&(le="<",Me?fe=+fe+1:ge=+ge+1),Oe=le+fe+"."+ge+"."+me):Me?Oe=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ue&&(Oe=">="+fe+"."+ge+".0 <"+fe+"."+(+ge+1)+".0"),E("xRange return",Oe),Oe})}(Ae,Pe)}).join(" ")}(de,Le),E("xrange",de),de=function(ye,Pe){return E("replaceStars",ye,Pe),ye.trim().replace(L[N],"")}(de,Le),E("stars",de),de}(Se,G)}).join(" ").split(/\s+/);return this.loose&&(oe=oe.filter(function(Se){return!!Se.match(se)})),oe=oe.map(function(Se){return new we(Se,G)})},pe.prototype.intersects=function(V,G){if(!(V instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(se){return V.set.some(function(oe){return oe.every(function(Se){return se.intersects(Se,G)})})})})},t.toComparators=function(V,G){return new pe(V,G).set.map(function(K){return K.map(function(se){return se.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new $(V,this.loose));for(var G=0;G<this.set.length;G++)if(Be(this.set[G],V))return!0;return!1},t.satisfies=xe,t.maxSatisfying=function(V,G,K){var se=null,oe=null;try{var Se=new pe(G,K)}catch(de){return null}return V.forEach(function(de){Se.test(de)&&(se&&oe.compare(de)!==-1||(oe=new $(se=de,K)))}),se},t.minSatisfying=function(V,G,K){var se=null,oe=null;try{var Se=new pe(G,K)}catch(de){return null}return V.forEach(function(de){Se.test(de)&&(se&&oe.compare(de)!==1||(oe=new $(se=de,K)))}),se},t.validRange=function(V,G){try{return new pe(V,G).range||"*"}catch(K){return null}},t.ltr=function(V,G,K){return ze(V,G,"<",K)},t.gtr=function(V,G,K){return ze(V,G,">",K)},t.outside=ze,t.prerelease=function(V,G){var K=B(V,G);return K&&K.prerelease.length?K.prerelease:null},t.intersects=function(V,G,K){return V=new pe(V,K),G=new pe(G,K),V.intersects(G)},t.coerce=function(V){if(V instanceof $)return V;if(typeof V!="string")return null;var G=V.match(L[z]);return G==null?null:B((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,m(1))},function(_,t){var m,O,E=_.exports={};function P(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function L(I){if(m===setTimeout)return setTimeout(I,0);if((m===P||!m)&&setTimeout)return m=setTimeout,setTimeout(I,0);try{return m(I,0)}catch(C){try{return m.call(null,I,0)}catch(b){return m.call(this,I,0)}}}(function(){try{m=typeof setTimeout=="function"?setTimeout:P}catch(I){m=P}try{O=typeof clearTimeout=="function"?clearTimeout:T}catch(I){O=T}})();var u,g=[],y=!1,v=-1;function w(){y&&u&&(y=!1,u.length?g=u.concat(g):v=-1,g.length&&F())}function F(){if(!y){var I=L(w);y=!0;for(var C=g.length;C;){for(u=g,g=[];++v<C;)u&&u[v].run();v=-1,C=g.length}u=null,y=!1,function(b){if(O===clearTimeout)return clearTimeout(b);if((O===T||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(b);try{O(b)}catch(l){try{return O.call(null,b)}catch(r){return O.call(this,b)}}}(I)}}function c(I,C){this.fun=I,this.array=C}function f(){}E.nextTick=function(I){var C=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)C[b-1]=arguments[b];g.push(new c(I,C)),g.length!==1||y||L(F)},c.prototype.run=function(){this.fun.apply(null,this.array)},E.title="browser",E.browser=!0,E.env={},E.argv=[],E.version="",E.versions={},E.on=f,E.addListener=f,E.once=f,E.off=f,E.removeListener=f,E.removeAllListeners=f,E.emit=f,E.prependListener=f,E.prependOnceListener=f,E.listeners=function(I){return[]},E.binding=function(I){throw new Error("process.binding is not supported")},E.cwd=function(){return"/"},E.chdir=function(I){throw new Error("process.chdir is not supported")},E.umask=function(){return 0}}])}),define(Y[36],ee([0,1,8,2]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function E(l){const r=l;return r?[r.on,r.pause,r.resume,r.destroy].every(o=>typeof o=="function"):!1}t.isReadableStream=E;function P(l){const r=l;return r?E(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}t.isReadableBufferedStream=P;function T(l,r){return new L(l,r)}t.newWriteableStream=T;class L{constructor(r,o){this.reducer=r,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(o=>o(r))}emitError(r){this.listeners.error.length===0?(0,m.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(o=>o(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,o){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(r,o){if(this.state.destroyed)return;let e;switch(r){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(o);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(l,r){const o=[];let e;for(;(e=l.read())!==null;)o.push(e);return r(o)}t.consumeReadable=u;function g(l,r,o){const e=[];let i;for(;(i=l.read())!==null&&e.length<o;)e.push(i);return i===null&&e.length>0?r(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return l.read()}}}t.peekReadable=g;function y(l,r){return new Promise((o,e)=>{const i=[];v(l,{onData:n=>{r&&i.push(n)},onError:n=>{r?e(n):o(void 0)},onEnd:()=>{o(r?r(i):void 0)}})})}t.consumeStream=y;function v(l,r){l.on("error",o=>r.onError(o)),l.on("end",()=>r.onEnd()),l.on("data",o=>r.onData(o))}t.listenStream=v;function w(l,r){return new Promise((o,e)=>{const i=new O.DisposableStore,n=[],s=p=>{if(n.push(p),n.length>r)return i.dispose(),l.pause(),o({stream:l,buffer:n,ended:!1})},a=p=>e(p),h=()=>o({stream:l,buffer:n,ended:!0});i.add((0,O.toDisposable)(()=>l.removeListener("error",a))),l.on("error",a),i.add((0,O.toDisposable)(()=>l.removeListener("end",h))),l.on("end",h),i.add((0,O.toDisposable)(()=>l.removeListener("data",s))),l.on("data",s)})}t.peekStream=w;function F(l,r){const o=T(r);return o.end(l),o}t.toStream=F;function c(){const l=T(()=>{throw new Error("not supported")});return l.end(),l}t.emptyStream=c;function f(l){let r=!1;return{read:()=>r?null:(r=!0,l)}}t.toReadable=f;function I(l,r,o){const e=T(o);return v(l,{onData:i=>e.write(r.data(i)),onError:i=>e.error(r.error?r.error(i):i),onEnd:()=>e.end()}),e}t.transform=I;function C(l,r,o){let e=!1;return{read:()=>{const i=r.read();return e?i:(e=!0,i!==null?o([l,i]):l)}}}t.prefixedReadable=C;function b(l,r,o){let e=!1;const i=T(o);return v(r,{onData:n=>e?i.write(n):(e=!0,i.write(o([l,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(l)),i.end()}}),i}t.prefixedStream=b}),define(Y[16],ee([0,1,18,36]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const E=typeof Buffer!="undefined",P=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let L,u;class g{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return E?new g(Buffer.allocUnsafe(p)):new g(new Uint8Array(p))}static wrap(p){return E&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new g(p)}static fromString(p,M){return!(M?.dontUseNodeBuffer||!1)&&E?new g(Buffer.from(p)):P?(L||(L=new TextEncoder),new g(L.encode(p))):new g(m.encodeUTF8(p))}static concat(p,M){if(typeof M=="undefined"){M=0;for(let z=0,W=p.length;z<W;z++)M+=p[z].byteLength}const R=g.alloc(M);let k=0;for(let z=0,W=p.length;z<W;z++){const Q=p[z];R.set(Q,k),k+=Q.byteLength}return R}toString(){return E?this.buffer.toString():T?(u||(u=new TextDecoder),u.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(p,M){return new g(this.buffer.subarray(p,M))}set(p,M){p instanceof g?this.buffer.set(p.buffer,M):this.buffer.set(p,M)}readUInt32BE(p){return w(this.buffer,p)}writeUInt32BE(p,M){F(this.buffer,p,M)}readUInt32LE(p){return c(this.buffer,p)}writeUInt32LE(p,M){f(this.buffer,p,M)}readUInt8(p){return I(this.buffer,p)}writeUInt8(p,M){C(this.buffer,p,M)}}t.VSBuffer=g;function y(h,p){return h[p+0]<<0>>>0|h[p+1]<<8>>>0}t.readUInt16LE=y;function v(h,p,M){h[M+0]=p&255,p=p>>>8,h[M+1]=p&255}t.writeUInt16LE=v;function w(h,p){return h[p]*2**24+h[p+1]*2**16+h[p+2]*2**8+h[p+3]}t.readUInt32BE=w;function F(h,p,M){h[M+3]=p,p=p>>>8,h[M+2]=p,p=p>>>8,h[M+1]=p,p=p>>>8,h[M]=p}t.writeUInt32BE=F;function c(h,p){return h[p+0]<<0>>>0|h[p+1]<<8>>>0|h[p+2]<<16>>>0|h[p+3]<<24>>>0}t.readUInt32LE=c;function f(h,p,M){h[M+0]=p&255,p=p>>>8,h[M+1]=p&255,p=p>>>8,h[M+2]=p&255,p=p>>>8,h[M+3]=p&255}t.writeUInt32LE=f;function I(h,p){return h[p]}t.readUInt8=I;function C(h,p,M){h[M]=p}t.writeUInt8=C;function b(h){return O.consumeReadable(h,p=>g.concat(p))}t.readableToBuffer=b;function l(h){return O.toReadable(h)}t.bufferToReadable=l;function r(h){return O.consumeStream(h,p=>g.concat(p))}t.streamToBuffer=r;async function o(h){return h.ended?g.concat(h.buffer):g.concat([...h.buffer,await r(h.stream)])}t.bufferedStreamToBuffer=o;function e(h){return O.toStream(h,p=>g.concat(p))}t.bufferToStream=e;function i(h){return O.transform(h,{data:p=>typeof p=="string"?g.fromString(p):g.wrap(p)},p=>g.concat(p))}t.streamToBufferReadableStream=i;function n(h){return O.newWriteableStream(p=>g.concat(p),h)}t.newWriteableBufferStream=n;function s(h,p){return O.prefixedReadable(h,p,M=>g.concat(M))}t.prefixedBufferReadable=s;function a(h,p){return O.prefixedStream(h,p,M=>g.concat(M))}t.prefixedBufferStream=a}),define(Y[19],ee([0,1,13]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function O(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const I=Array.isArray(f)?[]:{};return Object.keys(f).forEach(C=>{f[C]&&typeof f[C]=="object"?I[C]=O(f[C]):I[C]=f[C]}),I}t.deepClone=O;function E(f){if(!f||typeof f!="object")return f;const I=[f];for(;I.length>0;){const C=I.shift();Object.freeze(C);for(const b in C)if(P.call(C,b)){const l=C[b];typeof l=="object"&&!Object.isFrozen(l)&&I.push(l)}}return f}t.deepFreeze=E;const P=Object.prototype.hasOwnProperty;function T(f,I){return L(f,I,new Set)}t.cloneAndChange=T;function L(f,I,C){if((0,m.isUndefinedOrNull)(f))return f;const b=I(f);if(typeof b!="undefined")return b;if((0,m.isArray)(f)){const l=[];for(const r of f)l.push(L(r,I,C));return l}if((0,m.isObject)(f)){if(C.has(f))throw new Error("Cannot clone recursive data-structure");C.add(f);const l={};for(let r in f)P.call(f,r)&&(l[r]=L(f[r],I,C));return C.delete(f),l}return f}function u(f,I,C=!0){return(0,m.isObject)(f)?((0,m.isObject)(I)&&Object.keys(I).forEach(b=>{b in f?C&&((0,m.isObject)(f[b])&&(0,m.isObject)(I[b])?u(f[b],I[b],C):f[b]=I[b]):f[b]=I[b]}),f):I}t.mixin=u;function g(f,I){if(f===I)return!0;if(f==null||I===null||I===void 0||typeof f!=typeof I||typeof f!="object"||Array.isArray(f)!==Array.isArray(I))return!1;let C,b;if(Array.isArray(f)){if(f.length!==I.length)return!1;for(C=0;C<f.length;C++)if(!g(f[C],I[C]))return!1}else{const l=[];for(b in f)l.push(b);l.sort();const r=[];for(b in I)r.push(b);if(r.sort(),!g(l,r))return!1;for(C=0;C<l.length;C++)if(!g(f[l[C]],I[l[C]]))return!1}return!0}t.equals=g;function y(f){const I=new Set;return JSON.stringify(f,(C,b)=>{if((0,m.isObject)(b)||Array.isArray(b)){if(I.has(b))return"[Circular]";I.add(b)}return b})}t.safeStringify=y;function v(f,I,C){const b=I(f);return typeof b=="undefined"?C:b}t.getOrDefault=v;function w(f,I){const C=Object.create(null);return!f||!I||Object.keys(I).forEach(l=>{const r=f[l],o=I[l];g(r,o)||(C[l]=o)}),C}t.distinct=w;function F(f,I){const C=I.toLowerCase(),b=Object.keys(f).find(l=>l.toLowerCase()===C);return b?f[b]:f[I]}t.getCaseInsensitive=F;function c(f,I){const C=Object.create(null);for(const b of Object.keys(f))I(b,f[b])&&(C[b]=f[b]);return C}t.filter=c}),define(Y[59],ee([0,1,7]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function O(g){const y=g;return y&&typeof y.type=="string"&&typeof y.severity=="string"}t.isRemoteConsoleLog=O;function E(g){const y=[];let v;try{const w=JSON.parse(g.arguments),F=w[w.length-1];F&&F.__$stack&&(w.pop(),v=F.__$stack),y.push(...w)}catch(w){y.push("Unable to log remote console arguments",g.arguments)}return{args:y,stack:v}}t.parse=E;function P(g){if(typeof g!="string")return P(E(g).stack);const y=g;if(y){const v=T(y),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(w&&w.length===4)return{uri:m.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}t.getFirstFrame=P;function T(g){if(!g)return g;const y=g.indexOf(`
`);return y===-1?g:g.substring(0,y)}function L(g,y){const{args:v,stack:w}=E(g),F=typeof v[0]=="string"&&v.length===1;let c=T(w);c&&(c=`(${c.trim()})`);let f=[];if(typeof v[0]=="string"?c&&F?f=[`%c[${y}] %c${v[0]} %c${c}`,u("blue"),u(""),u("grey")]:f=[`%c[${y}] %c${v[0]}`,u("blue"),u(""),...v.slice(1)]:f=[`%c[${y}]%`,u("blue"),...v],c&&!F&&f.push(c),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,f)}t.log=L;function u(g){return`color: ${g}`}}),define(Y[60],ee([0,1,16,18,7]),function(_,t,m,O,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function P(y){return JSON.stringify(y,u)}t.stringify=P;function T(y){let v=JSON.parse(y);return v=g(v),v}t.parse=T;var L;(function(y){y[y.Uri=1]="Uri",y[y.Regexp=2]="Regexp",y[y.ScmResource=3]="ScmResource",y[y.ScmResourceGroup=4]="ScmResourceGroup",y[y.ScmProvider=5]="ScmProvider",y[y.CommentController=6]="CommentController",y[y.CommentThread=7]="CommentThread",y[y.CommentThreadReply=8]="CommentThreadReply",y[y.CommentNode=9]="CommentNode",y[y.CommentThreadNode=10]="CommentThreadNode",y[y.TimelineActionContext=11]="TimelineActionContext",y[y.NotebookCellActionContext=12]="NotebookCellActionContext",y[y.TestItemContext=13]="TestItemContext"})(L=t.MarshalledId||(t.MarshalledId={}));function u(y,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:(0,O.regExpFlags)(v)}:v}function g(y,v=0){if(!y||v>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return E.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof m.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let w=0;w<y.length;++w)y[w]=g(y[w],v+1);else for(const w in y)Object.hasOwnProperty.call(y,w)&&(y[w]=g(y[w],v+1))}return y}t.revive=g}),define(Y[61],ee([0,1,18,37,3,45,4]),function(_,t,m,O,E,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function L(){return Object.create(null)}t.getEmptyExpression=L;const u="**",g="/",y="[/\\\\]",v="[^/\\\\]",w=/\//g;function F(d){switch(d){case 0:return"";case 1:return`${v}*?`;default:return`(?:${y}|${v}+${y}|${y}${v}+)*?`}}function c(d,D){if(!d)return[];const A=[];let N=!1,U=!1,B="";for(const $ of d){switch($){case D:if(!N&&!U){A.push(B),B="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":U=!0;break;case"]":U=!1;break}B+=$}return B&&A.push(B),A}t.splitGlobAware=c;function f(d){if(!d)return"";let D="";const A=c(d,g);if(A.every(N=>N===u))D=".*";else{let N=!1;A.forEach((U,B)=>{if(U===u){N||(D+=F(2),N=!0);return}let $=!1,H="",J=!1,te="";for(const ne of U){if(ne!=="}"&&$){H+=ne;continue}if(J&&(ne!=="]"||!te)){let ae;ne==="-"?ae=ne:(ne==="^"||ne==="!")&&!te?ae="^":ne===g?ae="":ae=m.escapeRegExpCharacters(ne),te+=ae;continue}switch(ne){case"{":$=!0;continue;case"[":J=!0;continue;case"}":D+=`(?:${c(H,",").map(ve=>f(ve)).join("|")})`,$=!1,H="";break;case"]":D+="["+te+"]",J=!1,te="";break;case"?":D+=v;continue;case"*":D+=F(1);continue;default:D+=m.escapeRegExpCharacters(ne)}}B<A.length-1&&(A[B+1]!==u||B+2<A.length)&&(D+=y),N=!1})}return D}const I=/^\*\*\/\*\.[\w\.-]+$/,C=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new P.LRUCache(1e4),i=function(){return!1},n=function(){return null};function s(d,D){if(!d)return n;let A;typeof d!="string"?A=d.pattern:A=d,A=A.trim();const N=`${A}_${!!D.trimForExclusions}`;let U=e.get(N);if(U)return a(U,d);let B;if(I.test(A)){const $=A.substr(4);U=function(H,J){return typeof H=="string"&&H.endsWith($)?A:null}}else(B=C.exec(h(A,D)))?U=p(B[1],A):(D.trimForExclusions?l:b).test(A)?U=M(A,D):(B=r.exec(h(A,D)))?U=R(B[1].substr(1),A,!0):(B=o.exec(h(A,D)))?U=R(B[1],A,!1):U=k(A);return e.set(N,U),a(U,d)}function a(d,D){return typeof D=="string"?d:function(A,N){return O.isEqualOrParent(A,D.base)?d(E.relative(D.base,A),N):null}}function h(d,D){return D.trimForExclusions&&d.endsWith("/**")?d.substr(0,d.length-2):d}function p(d,D){const A=`/${d}`,N=`\\${d}`,U=function($,H){return typeof $!="string"?null:H?H===d?D:null:$===d||$.endsWith(A)||$.endsWith(N)?D:null},B=[d];return U.basenames=B,U.patterns=[D],U.allBasenames=B,U}function M(d,D){const A=S(d.slice(1,-1).split(",").map(H=>s(H,D)).filter(H=>H!==n),d),N=A.length;if(!N)return n;if(N===1)return A[0];const U=function(H,J){for(let te=0,ne=A.length;te<ne;te++)if(A[te](H,J))return d;return null},B=A.find(H=>!!H.allBasenames);B&&(U.allBasenames=B.allBasenames);const $=A.reduce((H,J)=>J.allPaths?H.concat(J.allPaths):H,[]);return $.length&&(U.allPaths=$),U}function R(d,D,A){const N=E.sep===E.posix.sep,U=N?d:d.replace(w,E.sep),B=E.sep+U,$=E.posix.sep+d,H=A?function(J,te){return typeof J=="string"&&(J===U||J.endsWith(B)||!N&&(J===d||J.endsWith($)))?D:null}:function(J,te){return typeof J=="string"&&(J===U||!N&&J===d)?D:null};return H.allPaths=[(A?"*/":"./")+d],H}function k(d){try{const D=new RegExp(`^${f(d)}$`);return function(A){return D.lastIndex=0,typeof A=="string"&&D.test(A)?d:null}}catch(D){return n}}function z(d,D,A){return!d||typeof D!="string"?!1:W(d)(D,void 0,A)}t.match=z;function W(d,D={}){if(!d)return i;if(typeof d=="string"||Z(d)){const A=s(d,D);if(A===n)return i;const N=function(U,B){return!!A(U,B)};return A.allBasenames&&(N.allBasenames=A.allBasenames),A.allPaths&&(N.allPaths=A.allPaths),N}return x(d,D)}t.parse=W;function Q(d){if(!d)return;let D;return A=>(D||(D=(d()||Promise.resolve([])).then(N=>N?re(N):{})),D.then(N=>!!N[A]))}t.hasSiblingPromiseFn=Q;function ie(d){if(!d)return;let D;return A=>{if(!D){const N=d();D=N?re(N):{}}return!!D[A]}}t.hasSiblingFn=ie;function re(d){const D={};for(const A of d)D[A]=!0;return D}function Z(d){const D=d;return D&&typeof D.base=="string"&&typeof D.pattern=="string"}t.isRelativePattern=Z;function X(d){return d.allBasenames||[]}t.getBasenameTerms=X;function j(d){return d.allPaths||[]}t.getPathTerms=j;function x(d,D){const A=S(Object.getOwnPropertyNames(d).map(H=>q(H,d[H],D)).filter(H=>H!==n)),N=A.length;if(!N)return n;if(!A.some(H=>!!H.requiresSiblings)){if(N===1)return A[0];const H=function(ne,ae){for(let he=0,ve=A.length;he<ve;he++){const De=A[he](ne,ae);if(De)return De}return null},J=A.find(ne=>!!ne.allBasenames);J&&(H.allBasenames=J.allBasenames);const te=A.reduce((ne,ae)=>ae.allPaths?ne.concat(ae.allPaths):ne,[]);return te.length&&(H.allPaths=te),H}const U=function(H,J,te){let ne;for(let ae=0,he=A.length;ae<he;ae++){const ve=A[ae];ve.requiresSiblings&&te&&(J||(J=E.basename(H)),ne||(ne=J.substr(0,J.length-E.extname(H).length)));const De=ve(H,J,ne,te);if(De)return De}return null},B=A.find(H=>!!H.allBasenames);B&&(U.allBasenames=B.allBasenames);const $=A.reduce((H,J)=>J.allPaths?H.concat(J.allPaths):H,[]);return $.length&&(U.allPaths=$),U}function q(d,D,A){if(D===!1)return n;const N=s(d,A);if(N===n)return n;if(typeof D=="boolean")return N;if(D){const U=D.when;if(typeof U=="string"){const B=($,H,J,te)=>{if(!te||!N($,H))return null;const ne=U.replace("$(basename)",J),ae=te(ne);return(0,T.isThenable)(ae)?ae.then(he=>he?d:null):ae?d:null};return B.requiresSiblings=!0,B}}return N}function S(d,D){const A=d.filter(H=>!!H.basenames);if(A.length<2)return d;const N=A.reduce((H,J)=>{const te=J.basenames;return te?H.concat(te):H},[]);let U;if(D){U=[];for(let H=0,J=N.length;H<J;H++)U.push(D)}else U=A.reduce((H,J)=>{const te=J.patterns;return te?H.concat(te):H},[]);const B=function(H,J){if(typeof H!="string")return null;if(!J){let ne;for(ne=H.length;ne>0;ne--){const ae=H.charCodeAt(ne-1);if(ae===47||ae===92)break}J=H.substr(ne)}const te=N.indexOf(J);return te!==-1?U[te]:null};B.basenames=N,B.patterns=U,B.allBasenames=N;const $=d.filter(H=>!H.basenames);return $.push(B),$}}),define(Y[62],ee([0,1,7,3,18,9,15,20,37]),function(_,t,m,O,E,P,T,L,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function g(s,a,h){if(typeof s=="string"&&(s=m.URI.file(s)),h){const M=h.getWorkspaceFolder(s);if(M){const R=h.getWorkspace().folders.length>1;let k;if((0,L.isEqual)(M.uri,s)?k="":k=(0,L.relativePath)(M.uri,s),R){const z=M.name?M.name:(0,L.basename)(M.uri);k=k?z+" \u2022 "+k:z}return k}}if(s.scheme!==P.Schemas.file&&s.scheme!==P.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,u.hasDriveLetter)(s.fsPath))return(0,O.normalize)(v(s.fsPath));let p=(0,O.normalize)(s.fsPath);return!T.isWindows&&a?.userHome&&(p=F(p,a.userHome.fsPath)),p}t.getPathLabel=g;function y(s){if(!s)return;typeof s=="string"&&(s=m.URI.file(s));const a=(0,L.basename)(s)||(s.scheme===P.Schemas.file?s.fsPath:s.path);return T.isWindows&&(0,u.isRootOrDriveLetter)(a)?v(a):a}t.getBaseLabel=y;function v(s){return(0,u.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}t.normalizeDriveLetter=v;let w=Object.create(null);function F(s,a){if(T.isWindows||!s||!a)return s;let h=w.original===a?w.normalized:void 0;return h||(h=`${(0,E.rtrim)(a,O.posix.sep)}${O.posix.sep}`,w={original:a,normalized:h}),(T.isLinux?s.startsWith(h):(0,E.startsWithIgnoreCase)(s,h))&&(s=`~/${s.substr(h.length)}`),s}t.tildify=F;function c(s,a){return s.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=c;const f="\u2026",I="\\\\",C="~";function b(s,a=O.sep){const h=new Array(s.length);let p=!1;for(let M=0;M<s.length;M++){let R=s[M];if(R===""){h[M]=`.${a}`;continue}if(!R){h[M]=R;continue}p=!0;let k="";R.indexOf(I)===0?(k=R.substr(0,R.indexOf(I)+I.length),R=R.substr(R.indexOf(I)+I.length)):R.indexOf(a)===0?(k=R.substr(0,R.indexOf(a)+a.length),R=R.substr(R.indexOf(a)+a.length)):R.indexOf(C)===0&&(k=R.substr(0,R.indexOf(C)+C.length),R=R.substr(R.indexOf(C)+C.length));const z=R.split(a);for(let W=1;p&&W<=z.length;W++)for(let Q=z.length-W;p&&Q>=0;Q--){p=!1;let ie=z.slice(Q,Q+W).join(a);for(let re=0;!p&&re<s.length;re++)if(re!==M&&s[re]&&s[re].indexOf(ie)>-1){const Z=Q+W===z.length,X=Q>0&&s[re].indexOf(a)>-1?a+ie:ie,j=s[re].endsWith(X);p=!Z||j}if(!p){let re="";(z[0].endsWith(":")||k!=="")&&(Q===1&&(Q=0,W++,ie=z[0]+a+ie),Q>0&&(re=z[0]+a),re=k+re),Q>0&&(re=re+f+a),re=re+ie,Q+W<z.length&&(re=re+a+f),h[M]=re}}p&&(h[M]=R)}return h}t.shorten=b;var l;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function r(s,a=Object.create(null)){const h=[];let p=!1,M="";for(const R of s)if(R==="$"||p&&R==="{")M&&h.push({value:M,type:l.TEXT}),M="",p=!0;else if(R==="}"&&p){const k=a[M];if(typeof k=="string")k.length&&h.push({value:k,type:l.VARIABLE});else if(k){const z=h[h.length-1];(!z||z.type!==l.SEPARATOR)&&h.push({value:k.label,type:l.SEPARATOR})}M="",p=!1}else M+=R;return M&&!p&&h.push({value:M,type:l.TEXT}),h.filter((R,k)=>{if(R.type===l.SEPARATOR){const z=h[k-1],W=h[k+1];return[z,W].every(Q=>Q&&(Q.type===l.VARIABLE||Q.type===l.TEXT)&&Q.value.length>0)}return!0}).map(R=>R.value).join("")}t.template=r;function o(s,a){return T.isMacintosh||a?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):s.replace(/&&|&/g,h=>h==="&"?"&&":"&")}t.mnemonicMenuLabel=o;function e(s,a){return T.isMacintosh||a?s.replace(/\(&&\w\)|&&/g,""):T.isWindows?s.replace(/&&|&/g,h=>h==="&"?"&&":"&"):s.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(s){return s.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(s){const a=s.indexOf("/")!==-1?O.posix:O.win32,h=a.basename(s),p=a.dirname(s);return h.length?{name:h,parentPath:p}:{name:p,parentPath:""}}t.splitName=n}),define(Y[46],ee([0,1,126]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class O{constructor(P="utf8"){this.stringDecoder=new m.StringDecoder(P),this.remaining=null}write(P){const T=[],L=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(L.length<1)return T;let u=0,g,y=u;for(;y<L.length;)if(g=L.charCodeAt(y),g===13||g===10){if(T.push(L.substring(u,y)),y++,y<L.length){const v=g;g=L.charCodeAt(y),(v===13&&g===10||v===10&&g===13)&&y++}u=y}else y++;return this.remaining=u<L.length?L.substr(u):null,T}end(){return this.remaining}}t.LineDecoder=O}),define(Y[63],ee([0,1,38,18,3,10]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function T(y){const v=(0,E.dirname)(y);if(y===v)return y;const w=((0,E.basename)(y)||y).toLowerCase();try{const c=(0,P.readdirSync)(v).filter(f=>f.toLowerCase()===w);if(c.length===1){const f=T(v);if(f)return(0,E.join)(f,c[0])}else if(c.length>1){const f=c.indexOf(w);if(f>=0){const I=T(v);if(I)return(0,E.join)(I,c[f])}}}catch(F){}return null}t.realcaseSync=T;async function L(y){try{return await P.Promises.realpath(y)}catch(v){const w=g(y);return await P.Promises.access(w,m.constants.R_OK),w}}t.realpath=L;function u(y){try{return m.realpathSync(y)}catch(v){const w=g(y);return m.accessSync(w,m.constants.R_OK),w}}t.realpathSync=u;function g(y){return(0,O.rtrim)((0,E.normalize)(y),E.sep)}}),define(Y[64],ee([0,1,10,31,3]),function(_,t,m,O,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const P=/^\d+$/,T=/^Microsoft.PowerShell_.*/,L=/^Microsoft.PowerShellPreview_.*/;var u;(function(r){r[r.x64=0]="x64",r[r.x86=1]="x86",r[r.ARM=2]="ARM"})(u||(u={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class v{constructor(o,e,i){this.exePath=o,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:r=!1}={}){return r?g===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function F({useAlternateBitness:r=!1,findPreview:o=!1}={}){const e=w({useAlternateBitness:r});if(!e)return null;const i=E.join(e,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(i))return null;let n=-1,s=null;for(const p of await m.Promises.readdir(i)){let M=-1;if(o){const k=p.indexOf("-");if(k<0)continue;const z=p.substring(0,k);if(!P.test(z)||p.substring(k+1)!=="preview")continue;M=parseInt(z,10)}else{if(!P.test(p))continue;M=parseInt(p,10)}if(M<=n)continue;const R=E.join(i,p,"pwsh.exe");!await m.SymlinkSupport.existsFile(R)||(s=R,n=M)}if(!s)return null;const a=e.includes("x86")?" (x86)":"",h=o?" Preview":"";return new v(s,`PowerShell${h}${a}`,!0)}async function c({findPreview:r}={}){if(!process.env.LOCALAPPDATA)return null;const o=E.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=r?{pwshMsixDirRegex:L,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const n of await m.Promises.readdir(o))if(e.test(n)){const s=E.join(o,n,"pwsh.exe");return new v(s,i)}return null}function f(){const r=E.join(O.homedir(),".dotnet","tools","pwsh.exe");return new v(r,".NET Core PowerShell Global Tool")}function I(){const r=E.join(process.env.windir,g===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(r,"Windows PowerShell",!0)}async function*C(){let r=await F();r&&(yield r),r=await F({useAlternateBitness:!0}),r&&(yield r),r=await c(),r&&(yield r),r=f(),r&&(yield r),r=await F({findPreview:!0}),r&&(yield r),r=await c({findPreview:!0}),r&&(yield r),r=await F({useAlternateBitness:!0,findPreview:!0}),r&&(yield r),r=I(),r&&(yield r)}async function*b(){for await(const r of C())await r.exists()&&(yield r)}t.enumeratePowerShellInstallations=b;async function l(){for await(const r of b())return r;return null}t.getFirstAvailablePowerShellInstallation=l}),define(Y[65],ee([0,1,3,38,15,127,2,10]),function(_,t,m,O,E,P,T,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function u(v,w,F){return y({path:v,isDirectory:!1},w,F)}t.watchFile=u;function g(v,w,F){return y({path:v,isDirectory:!0},w,F)}t.watchFolder=g,t.CHANGE_BUFFER_DELAY=100;function y(v,w,F){const c=(0,m.basename)(v.path),f=new Map;let I=!1,C=[(0,T.toDisposable)(()=>{f.forEach(b=>(0,T.dispose)(b)),f.clear()})];try{const b=(0,O.watch)(v.path);C.push((0,T.toDisposable)(()=>{b.removeAllListeners(),b.close()}));const l=new Set;v.isDirectory&&L.Promises.readdir(v.path).then(r=>r.forEach(o=>l.add(o))),b.on("error",(r,o)=>{I||F(`Failed to watch ${v.path} for changes using fs.watch() (${r}, ${o})`)}),b.on("change",(r,o)=>{if(I)return;let e="";if(o&&(e=o.toString(),E.isMacintosh&&(e=(0,P.normalizeNFC)(e))),!e||r!=="change"&&r!=="rename")return;const i=v.isDirectory?(0,m.join)(v.path,e):v.path;if(v.isDirectory)if(r==="rename"){const n=f.get(i);n&&(0,T.dispose)(n);const s=setTimeout(async()=>{f.delete(i);const a=await L.Promises.exists(i);if(I)return;let h;a?l.has(e)?h="changed":(h="added",l.add(e)):(l.delete(e),h="deleted"),w(h,i)},t.CHANGE_BUFFER_DELAY);f.set(i,(0,T.toDisposable)(()=>clearTimeout(s)))}else{let n;l.has(e)?n="changed":(n="added",l.add(e)),w(n,i)}else if(r==="rename"||e!==c){const n=setTimeout(async()=>{const s=await L.Promises.exists(i);I||(s?(w("changed",i),C=[y(v,w,F)]):w("deleted",i))},t.CHANGE_BUFFER_DELAY);(0,T.dispose)(C),C=[(0,T.toDisposable)(()=>clearTimeout(n))]}else w("changed",i)})}catch(b){L.Promises.exists(v.path).then(l=>{l&&!I&&F(`Failed to watch ${v.path} for changes using fs.watch() (${b.toString()})`)})}return(0,T.toDisposable)(()=>{I=!0,C=(0,T.dispose)(C)})}});var ce=this&&this.__decorate||function(_,t,m,O){var E=arguments.length,P=E<3?t:O===null?O=Object.getOwnPropertyDescriptor(t,m):O,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(_,t,m,O);else for(var L=_.length-1;L>=0;L--)(T=_[L])&&(P=(E<3?T(P):E>3?T(t,m,P):T(t,m))||P);return E>3&&P&&Object.defineProperty(t,m,P),P};define(Y[39],ee([0,1,11,2,4,26,8,16,24,13,60,18,44]),function(_,t,m,O,E,P,T,L,u,g,y,v,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var F;(function(S){S[S.Promise=100]="Promise",S[S.PromiseCancel=101]="PromiseCancel",S[S.EventListen=102]="EventListen",S[S.EventDispose=103]="EventDispose"})(F=t.RequestType||(t.RequestType={}));function c(S){switch(S){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(S){S[S.Initialize=200]="Initialize",S[S.PromiseSuccess=201]="PromiseSuccess",S[S.PromiseError=202]="PromiseError",S[S.PromiseErrorObj=203]="PromiseErrorObj",S[S.EventFire=204]="EventFire"})(f=t.ResponseType||(t.ResponseType={}));function I(S){switch(S){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var C;(function(S){S[S.Uninitialized=0]="Uninitialized",S[S.Idle=1]="Idle"})(C||(C={}));class b{constructor(d){this.buffer=d,this.pos=0}read(d){const D=this.buffer.slice(this.pos,this.pos+d);return this.pos+=D.byteLength,D}}class l{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(d){this.buffers.push(d)}}var r;(function(S){S[S.Undefined=0]="Undefined",S[S.String=1]="String",S[S.Buffer=2]="Buffer",S[S.VSBuffer=3]="VSBuffer",S[S.Array=4]="Array",S[S.Object=5]="Object"})(r||(r={}));function o(S){const d=L.VSBuffer.alloc(4);return d.writeUInt32BE(S,0),d}function e(S){return S.read(4).readUInt32BE(0)}function i(S){const d=L.VSBuffer.alloc(1);return d.writeUInt8(S,0),d}const n={Undefined:i(r.Undefined),String:i(r.String),Buffer:i(r.Buffer),VSBuffer:i(r.VSBuffer),Array:i(r.Array),Object:i(r.Object)},s=typeof Buffer!="undefined";function a(S,d){if(typeof d=="undefined")S.write(n.Undefined);else if(typeof d=="string"){const D=L.VSBuffer.fromString(d);S.write(n.String),S.write(o(D.byteLength)),S.write(D)}else if(s&&Buffer.isBuffer(d)){const D=L.VSBuffer.wrap(d);S.write(n.Buffer),S.write(o(D.byteLength)),S.write(D)}else if(d instanceof L.VSBuffer)S.write(n.VSBuffer),S.write(o(d.byteLength)),S.write(d);else if(Array.isArray(d)){S.write(n.Array),S.write(o(d.length));for(const D of d)a(S,D)}else{const D=L.VSBuffer.fromString(JSON.stringify(d));S.write(n.Object),S.write(o(D.byteLength)),S.write(D)}}function h(S){switch(S.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return S.read(e(S)).toString();case r.Buffer:return S.read(e(S)).buffer;case r.VSBuffer:return S.read(e(S));case r.Array:{const D=e(S),A=[];for(let N=0;N<D;N++)A.push(h(S));return A}case r.Object:return JSON.parse(S.read(e(S)).toString())}}class p{constructor(d,D,A=null,N=1e3){this.protocol=d,this.ctx=D,this.logger=A,this.timeoutDelay=N,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(U=>this.onRawMessage(U)),this.sendResponse({type:200})}registerChannel(d,D){this.channels.set(d,D),setTimeout(()=>this.flushPendingRequests(d),0)}sendResponse(d){switch(d.type){case 200:{const D=this.send([d.type]);this.logger&&this.logger.logOutgoing(D,0,1,I(d.type));return}case 201:case 202:case 204:case 203:{const D=this.send([d.type,d.id],d.data);this.logger&&this.logger.logOutgoing(D,d.id,1,I(d.type),d.data);return}}}send(d,D=void 0){const A=new l;return a(A,d),a(A,D),this.sendBuffer(A.buffer)}sendBuffer(d){try{return this.protocol.send(d),d.byteLength}catch(D){return 0}}onRawMessage(d){const D=new b(d),A=h(D),N=h(D),U=A[0];switch(U){case 100:return this.logger&&this.logger.logIncoming(d.byteLength,A[1],1,`${c(U)}: ${A[2]}.${A[3]}`,N),this.onPromise({type:U,id:A[1],channelName:A[2],name:A[3],arg:N});case 102:return this.logger&&this.logger.logIncoming(d.byteLength,A[1],1,`${c(U)}: ${A[2]}.${A[3]}`,N),this.onEventListen({type:U,id:A[1],channelName:A[2],name:A[3],arg:N});case 101:return this.logger&&this.logger.logIncoming(d.byteLength,A[1],1,`${c(U)}`),this.disposeActiveRequest({type:U,id:A[1]});case 103:return this.logger&&this.logger.logIncoming(d.byteLength,A[1],1,`${c(U)}`),this.disposeActiveRequest({type:U,id:A[1]})}}onPromise(d){const D=this.channels.get(d.channelName);if(!D){this.collectPendingRequest(d);return}const A=new P.CancellationTokenSource;let N;try{N=D.call(this.ctx,d.name,d.arg,A.token)}catch($){N=Promise.reject($)}const U=d.id;N.then($=>{this.sendResponse({id:U,data:$,type:201}),this.activeRequests.delete(d.id)},$=>{$ instanceof Error?this.sendResponse({id:U,data:{message:$.message,name:$.name,stack:$.stack?$.stack.split?$.stack.split(`
`):$.stack:void 0},type:202}):this.sendResponse({id:U,data:$,type:203}),this.activeRequests.delete(d.id)});const B=(0,O.toDisposable)(()=>A.cancel());this.activeRequests.set(d.id,B)}onEventListen(d){const D=this.channels.get(d.channelName);if(!D){this.collectPendingRequest(d);return}const A=d.id,U=D.listen(this.ctx,d.name,d.arg)(B=>this.sendResponse({id:A,data:B,type:204}));this.activeRequests.set(d.id,U)}disposeActiveRequest(d){const D=this.activeRequests.get(d.id);D&&(D.dispose(),this.activeRequests.delete(d.id))}collectPendingRequest(d){let D=this.pendingRequests.get(d.channelName);D||(D=[],this.pendingRequests.set(d.channelName,D));const A=setTimeout(()=>{console.error(`Unknown channel: ${d.channelName}`),d.type===100&&this.sendResponse({id:d.id,data:{name:"Unknown channel",message:`Channel name '${d.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);D.push({request:d,timeoutTimer:A})}flushPendingRequests(d){const D=this.pendingRequests.get(d);if(D){for(const A of D)switch(clearTimeout(A.timeoutTimer),A.request.type){case 100:this.onPromise(A.request);break;case 102:this.onEventListen(A.request);break}this.pendingRequests.delete(d)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(d=>d.dispose()),this.activeRequests.clear()}}t.ChannelServer=p;var M;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(M=t.RequestInitiator||(t.RequestInitiator={}));class R{constructor(d,D=null){this.protocol=d,this.isDisposed=!1,this.state=C.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(A=>this.onBuffer(A)),this.logger=D}getChannel(d){const D=this;return{call(A,N,U){return D.isDisposed?Promise.reject(T.canceled()):D.requestPromise(d,A,N,U)},listen(A,N){return D.isDisposed?Promise.reject(T.canceled()):D.requestEvent(d,A,N)}}}requestPromise(d,D,A,N=P.CancellationToken.None){const U=this.lastRequestId++,$={id:U,type:100,channelName:d,name:D,arg:A};if(N.isCancellationRequested)return Promise.reject(T.canceled());let H;return new Promise((te,ne)=>{if(N.isCancellationRequested)return ne(T.canceled());const ae=()=>{const ke=Te=>{switch(Te.type){case 201:this.handlers.delete(U),te(Te.data);break;case 202:this.handlers.delete(U);const we=new Error(Te.data.message);we.stack=Te.data.stack,we.name=Te.data.name,ne(we);break;case 203:this.handlers.delete(U),ne(Te.data);break}};this.handlers.set(U,ke),this.sendRequest($)};let he=null;this.state===C.Idle?ae():(he=(0,E.createCancelablePromise)(ke=>this.whenInitialized()),he.then(()=>{he=null,ae()}));const ve=()=>{he?(he.cancel(),he=null):this.sendRequest({id:U,type:101}),ne(T.canceled())},De=N.onCancellationRequested(ve);H=(0,O.combinedDisposable)((0,O.toDisposable)(ve),De),this.activeRequests.add(H)}).finally(()=>{this.activeRequests.delete(H)})}requestEvent(d,D,A){const N=this.lastRequestId++,B={id:N,type:102,channelName:d,name:D,arg:A};let $=null;const H=new m.Emitter({onFirstListenerAdd:()=>{$=(0,E.createCancelablePromise)(te=>this.whenInitialized()),$.then(()=>{$=null,this.activeRequests.add(H),this.sendRequest(B)})},onLastListenerRemove:()=>{$?($.cancel(),$=null):(this.activeRequests.delete(H),this.sendRequest({id:N,type:103}))}}),J=te=>H.fire(te.data);return this.handlers.set(N,J),H.event}sendRequest(d){switch(d.type){case 100:case 102:{const D=this.send([d.type,d.id,d.channelName,d.name],d.arg);this.logger&&this.logger.logOutgoing(D,d.id,0,`${c(d.type)}: ${d.channelName}.${d.name}`,d.arg);return}case 101:case 103:{const D=this.send([d.type,d.id]);this.logger&&this.logger.logOutgoing(D,d.id,0,c(d.type));return}}}send(d,D=void 0){const A=new l;return a(A,d),a(A,D),this.sendBuffer(A.buffer)}sendBuffer(d){try{return this.protocol.send(d),d.byteLength}catch(D){return 0}}onBuffer(d){const D=new b(d),A=h(D),N=h(D),U=A[0];switch(U){case 200:return this.logger&&this.logger.logIncoming(d.byteLength,0,0,I(U)),this.onResponse({type:A[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(d.byteLength,A[1],0,I(U),N),this.onResponse({type:A[0],id:A[1],data:N})}}onResponse(d){if(d.type===200){this.state=C.Idle,this._onDidInitialize.fire();return}const D=this.handlers.get(d.id);D&&D(d)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===C.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(d=>d.dispose()),this.activeRequests.clear()}}ce([w.memoize],R.prototype,"onDidInitializePromise",null),t.ChannelClient=R;class k{constructor(d){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,d(({protocol:D,onDidClientDisconnect:A})=>{m.Event.once(D.onMessage)(U=>{const B=new b(U),$=h(B),H=new p(D,$),J=new R(D);this.channels.forEach((ne,ae)=>H.registerChannel(ae,ne));const te={channelServer:H,channelClient:J,ctx:$};this._connections.add(te),this._onDidAddConnection.fire(te),A(()=>{H.dispose(),J.dispose(),this._connections.delete(te),this._onDidRemoveConnection.fire(te)})})})}get connections(){const d=[];return this._connections.forEach(D=>d.push(D)),d}getChannel(d,D){const A=this;return{call(N,U,B){let $;if((0,g.isFunction)(D)){let J=(0,u.getRandomElement)(A.connections.filter(D));$=J?Promise.resolve(J):m.Event.toPromise(m.Event.filter(A.onDidAddConnection,D))}else $=D.routeCall(A,N,U);const H=$.then(J=>J.channelClient.getChannel(d));return W(H).call(N,U,B)},listen(N,U){if((0,g.isFunction)(D))return A.getMulticastEvent(d,D,N,U);const B=D.routeEvent(A,N,U).then($=>$.channelClient.getChannel(d));return W(B).listen(N,U)}}}getMulticastEvent(d,D,A,N){const U=this;let B=new O.DisposableStore;const $=new m.Emitter({onFirstListenerAdd:()=>{B=new O.DisposableStore;const H=new m.EventMultiplexer,J=new Map,te=ae=>{const ve=ae.channelClient.getChannel(d).listen(A,N),De=H.add(ve);J.set(ae,De)},ne=ae=>{const he=J.get(ae);!he||(he.dispose(),J.delete(ae))};U.connections.filter(D).forEach(te),m.Event.filter(U.onDidAddConnection,D)(te,void 0,B),U.onDidRemoveConnection(ne,void 0,B),H.event($.fire,$,B),B.add(H)},onLastListenerRemove:()=>{B.dispose()}});return $.event}registerChannel(d,D){this.channels.set(d,D),this._connections.forEach(A=>{A.channelServer.registerChannel(d,D)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=k;class z{constructor(d,D,A=null){const N=new l;a(N,D),d.send(N.buffer),this.channelClient=new R(d,A),this.channelServer=new p(d,D,A)}getChannel(d){return this.channelClient.getChannel(d)}registerChannel(d,D){this.channelServer.registerChannel(d,D)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=z;function W(S){return{call(d,D,A){return S.then(N=>N.call(d,D,A))},listen(d,D){const A=new m.Relay;return S.then(N=>A.input=N.listen(d,D)),A.event}}}t.getDelayedChannel=W;function Q(S){let d=!1;return{call(D,A,N){return d?S.call(D,A,N):(0,E.timeout)(0).then(()=>d=!0).then(()=>S.call(D,A,N))},listen(D,A){if(d)return S.listen(D,A);const N=new m.Relay;return(0,E.timeout)(0).then(()=>d=!0).then(()=>N.input=S.listen(D,A)),N.event}}}t.getNextTickChannel=Q;class ie{constructor(d){this.fn=d}routeCall(d){return this.route(d)}routeEvent(d){return this.route(d)}async route(d){for(const D of d.connections)if(await Promise.resolve(this.fn(D.ctx)))return Promise.resolve(D);return await m.Event.toPromise(d.onDidAddConnection),await this.route(d)}}t.StaticRouter=ie;var re;(function(S){function d(N,U){const B=N,$=U&&U.disableMarshalling,H=new Map;for(const J in B)A(J)&&H.set(J,m.Event.buffer(B[J],!0));return new class{listen(J,te){const ne=H.get(te);if(ne)return ne;throw new Error(`Event not found: ${te}`)}call(J,te,ne){const ae=B[te];if(typeof ae=="function"){if(!$&&Array.isArray(ne))for(let he=0;he<ne.length;he++)ne[he]=(0,y.revive)(ne[he]);return ae.apply(B,ne)}throw new Error(`Method not found: ${te}`)}}}S.fromService=d;function D(N,U){const B=U&&U.disableMarshalling;return new Proxy({},{get($,H){if(typeof H=="string")return U?.properties?.has(H)?U.properties.get(H):A(H)?N.listen(H):async function(...J){let te;U&&!(0,g.isUndefinedOrNull)(U.context)?te=[U.context,...J]:te=J;const ne=await N.call(H,te);return B?ne:(0,y.revive)(ne)};throw new Error(`Property not found: ${String(H)}`)}})}S.toService=D;function A(N){return N[0]==="o"&&N[1]==="n"&&v.isUpperAsciiLetter(N.charCodeAt(2))}})(re=t.ProxyChannel||(t.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function X(S){if(Array.isArray(S))return S;if(S&&typeof S=="object"&&typeof S.toString=="function"){let d=S.toString();if(d!=="[object Object]")return d}return S}function j(S){return Array.isArray(S)?S.map(X):X(S)}function x(S,d,D,A,N,U,B){B=j(B);const $=Z[N],H=$[A%$.length];let J=[`%c[${S}]%c[${String(d).padStart(7," ")}]%c[len: ${String(D).padStart(5," ")}]%c${String(A).padStart(5," ")} - ${U}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(U)?(J=J.concat(B),J.push(")")):J.push(B),console.log.apply(console,J)}t.logWithColors=x;class q{constructor(d,D){this._outgoingPrefix=d,this._incomingPrefix=D,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(d,D,A,N,U){this._totalOutgoing+=d,x(this._outgoingPrefix,this._totalOutgoing,d,D,A,N,U)}logIncoming(d,D,A,N,U){this._totalIncoming+=d,x(this._incomingPrefix,this._totalIncoming,d,D,A,N,U)}}t.IPCLogger=q}),define(Y[66],ee([0,1,2,11,4,13]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var T;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=t.StorageHint||(t.StorageHint={}));var L;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(L||(L={}));class u extends m.Disposable{constructor(v,w=Object.create(null)){super();this.database=v,this.options=w,this._onDidChangeStorage=this._register(new O.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=L.None,this.cache=new Map,this.flushDelayer=new E.ThrottledDelayer(u.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){v.changed?.forEach((w,F)=>this.accept(F,w)),v.deleted?.forEach(w=>this.accept(w,void 0))}accept(v,w){if(this.state===L.Closed)return;let F=!1;(0,P.isUndefinedOrNull)(w)?F=this.cache.delete(v):this.cache.get(v)!==w&&(this.cache.set(v,w),F=!0),F&&this._onDidChangeStorage.fire(v)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===L.None&&(this.state=L.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,w){const F=this.cache.get(v);return(0,P.isUndefinedOrNull)(F)?w:F}getBoolean(v,w){const F=this.get(v);return(0,P.isUndefinedOrNull)(F)?w:F==="true"}getNumber(v,w){const F=this.get(v);return(0,P.isUndefinedOrNull)(F)?w:parseInt(F,10)}async set(v,w){if(this.state===L.Closed)return;if((0,P.isUndefinedOrNull)(w))return this.delete(v);const F=String(w);if(this.cache.get(v)!==F)return this.cache.set(v,F),this.pendingInserts.set(v,F),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}async delete(v){if(!(this.state===L.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire(v),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=L.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(v){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=u,u.DEFAULT_FLUSH_DELAY=100;class g{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert&&v.insert.forEach((w,F)=>this.items.set(F,w)),v.delete&&v.delete.forEach(w=>this.items.delete(w))}async close(){}}t.InMemoryStorageDatabase=g}),define(Y[67],ee([5,6]),function(_,t){return _.create("vs/base/common/date",t)}),define(Y[68],ee([0,1,67]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const O=60,E=O*60,P=E*24,T=P*7,L=P*30,u=P*365;function g(v,w){typeof v!="number"&&(v=v.getTime());const F=Math.round((new Date().getTime()-v)/1e3);if(F<-30)return(0,m.localize)(0,null,g(new Date().getTime()+F*1e3,!1));if(F<30)return(0,m.localize)(1,null);let c;return F<O?(c=F,w?c===1?(0,m.localize)(2,null,c):(0,m.localize)(3,null,c):c===1?(0,m.localize)(4,null,c):(0,m.localize)(5,null,c)):F<E?(c=Math.floor(F/O),w?c===1?(0,m.localize)(6,null,c):(0,m.localize)(7,null,c):c===1?(0,m.localize)(8,null,c):(0,m.localize)(9,null,c)):F<P?(c=Math.floor(F/E),w?c===1?(0,m.localize)(10,null,c):(0,m.localize)(11,null,c):c===1?(0,m.localize)(12,null,c):(0,m.localize)(13,null,c)):F<T?(c=Math.floor(F/P),w?c===1?(0,m.localize)(14,null,c):(0,m.localize)(15,null,c):c===1?(0,m.localize)(16,null,c):(0,m.localize)(17,null,c)):F<L?(c=Math.floor(F/T),w?c===1?(0,m.localize)(18,null,c):(0,m.localize)(19,null,c):c===1?(0,m.localize)(20,null,c):(0,m.localize)(21,null,c)):F<u?(c=Math.floor(F/L),w?c===1?(0,m.localize)(22,null,c):(0,m.localize)(23,null,c):c===1?(0,m.localize)(24,null,c):(0,m.localize)(25,null,c)):(c=Math.floor(F/u),w?c===1?(0,m.localize)(26,null,c):(0,m.localize)(27,null,c):c===1?(0,m.localize)(28,null,c):(0,m.localize)(29,null,c))}t.fromNow=g;function y(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=y}),define(Y[69],ee([5,6]),function(_,t){return _.create("vs/base/common/errorMessage",t)}),define(Y[28],ee([0,1,69,13,24]),function(_,t,m,O,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function P(g,y){return y&&(g.stack||g.stacktrace)?m.localize(0,null,L(g),T(g.stack)||T(g.stacktrace)):L(g)}function T(g){return Array.isArray(g)?g.join(`
`):g}function L(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?m.localize(1,null,g.message):g.message||m.localize(2,null)}function u(g=null,y=!1){if(!g)return m.localize(3,null);if(Array.isArray(g)){const v=E.coalesce(g),w=u(v[0],y);return v.length>1?m.localize(4,null,w,v.length):w}if(O.isString(g))return g;if(g.detail){const v=g.detail;if(v.error)return P(v.error,y);if(v.exception)return P(v.exception,y)}return g.stack?P(g,y):g.message?g.message:m.localize(5,null)}t.toErrorMessage=u}),define(Y[70],ee([5,6]),function(_,t){return _.create("vs/base/node/processes",t)}),define(Y[47],ee([0,1,3,10,32,70,33,13,19,37,15,46,9]),function(_,t,m,O,E,P,T,L,u,g,y,v,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function F(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(r,o){if(y.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};o&&(e.cwd=o);const i=E.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],e);return new Promise(n=>{i.once("error",s=>{n({success:!1,error:s})}),i.once("exit",(s,a)=>{n(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?F(e.status):1})}else if(y.isLinux||y.isMacintosh)try{const e=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",_).fsPath;return new Promise(i=>{E.execFile(e,[r.pid.toString()],{encoding:"utf8",shell:!0},(n,s,a)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function f(r=T.env){return r.comspec||"cmd.exe"}t.getWindowsShell=f;class I{constructor(o,e,i,n){if(e!==void 0&&i!==void 0&&n!==void 0)this.cmd=o,this.args=e,this.shell=i,this.options=n;else{const s=o;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(T.env).forEach(a=>{s[a]=T.env[a]}),Object.keys(this.options.env).forEach(a=>{s[a]=this.options.env[a]}),this.options.env=s}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const e=o.lastIndexOf(m.sep);return e!==-1&&(o=o.substring(e+1)),I.WellKnowCommands[o]?o:"other"}start(o){return y.isWindows&&(this.options&&this.options.cwd&&g.isUNC(this.options.cwd)||!this.options&&g.isUNC(T.cwd()))?Promise.reject(new Error(P.localize(0,null))):this.useExec().then(e=>{let i,n;const s=new Promise((a,h)=>{i=a,n=h});if(e){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=E.exec(a,this.options,(h,p,M)=>{this.childProcess=null;const R=h;R&&R.killed?n({killed:this.terminateRequested,stdout:p.toString(),stderr:M.toString()}):this.handleExec(i,o,h,p,M)})}else{let a=null;const h=p=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(p,i,o,n);const M={terminated:this.terminateRequested};L.isNumber(p)&&(M.cmdCode=p),i(M)};if(this.shell&&y.isWindows){const p=u.deepClone(this.options);p.windowsVerbatimArguments=!0,p.detached=!1;let M=!1,R=!1;const k=[];let z=this.ensureQuotes(this.cmd);k.push(z.value),M=z.quoted,this.args&&this.args.forEach(Q=>{z=this.ensureQuotes(Q),k.push(z.value),R=R&&z.quoted});const W=["/s","/c"];M?R?W.push('"'+k.join(" ")+'"'):k.length>1?W.push('"'+k[0]+'" '+k.slice(1).join(" ")):W.push('"'+k[0]+'"'):W.push(k.join(" ")),a=E.spawn(f(),W,p)}else this.cmd&&(a=E.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(L.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",p=>{this.childProcess=null,n({terminated:this.terminateRequested,error:p})}),a.pid&&(this.childProcess.on("close",h),this.handleSpawn(a,i,o,n,!0)))}return s})}handleClose(o,e,i,n){}ensureQuotes(o){return I.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,c(o,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!y.isWindows)return o(!1);const e=E.spawn(f(),["/s","/c"]);e.on("error",i=>o(!0)),e.on("exit",i=>o(!1))})}}t.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class C extends I{constructor(o,e,i,n){super(o,e,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,e,i,n,s){[n,s].forEach((a,h)=>{const p=new v.LineDecoder;p.write(a).forEach(k=>{e({line:k,source:h===0?0:1})});const R=p.end();R&&e({line:R,source:h===0?0:1})}),o({terminated:this.terminateRequested,error:i})}handleSpawn(o,e,i,n,s){const a=new v.LineDecoder,h=new v.LineDecoder;o.stdout.on("data",p=>{a.write(p).forEach(R=>i({line:R,source:0}))}),o.stderr.on("data",p=>{h.write(p).forEach(R=>i({line:R,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=h}handleClose(o,e,i,n){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&i({line:s,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&i({line:a,source:1})}}t.LineProcess=C;function b(r){let o=[],e=!1;const i=function(n){if(e){o.push(n);return}(!r.send(n,a=>{if(a&&console.error(a),e=!1,o.length>0){const h=o.slice(0);o=[],h.forEach(p=>i(p))}})||y.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=b;var l;(function(r){async function o(e,i,n){if(m.isAbsolute(e))return e;if(i===void 0&&(i=T.cwd()),m.dirname(e)!=="."||(n===void 0&&L.isString(T.env.PATH)&&(n=T.env.PATH.split(m.delimiter)),n===void 0||n.length===0))return m.join(i,e);async function a(h){return await O.Promises.exists(h)?!(await O.Promises.stat(h)).isDirectory():!1}for(let h of n){let p;if(m.isAbsolute(h)?p=m.join(h,e):p=m.join(i,h,e),await a(p))return p;let M=p+".com";if(await a(M)||(M=p+".exe",await a(M)))return M}return m.join(i,e)}r.findExecutable=o})(l=t.win32||(t.win32={}))}),define(Y[71],ee([0,1,31,15,64,47]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function T(F,c){return F===1?O.isWindows?v():P.getWindowsShell(c):g(F,c)}t.getSystemShell=T;function L(F,c){return F===1?O.isWindows?w(c):P.getWindowsShell(c):g(F,c)}t.getSystemShellSync=L;let u=null;function g(F,c){if(O.isLinux&&F===2||O.isMacintosh&&F===3)return"/bin/bash";if(!u){let f;if(O.isWindows)f="/bin/bash";else{if(f=c.SHELL,!f)try{f=(0,m.userInfo)().shell}catch(I){}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}u=f}return u}let y=null;async function v(){return y||(y=(await(0,E.getFirstAvailablePowerShellInstallation)()).exePath),y}function w(F){if(y)return y;const c=O.isWindows&&parseFloat((0,m.release)())>=10,f=F.hasOwnProperty("PROCESSOR_ARCHITEW6432"),I=`${F.windir}\\${f?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?I:P.getWindowsShell(F)}}),define(Y[48],ee([0,1,32,2,4,19,11,47,39,59,26,8,16,15]),function(_,t,m,O,E,P,T,L,u,g,y,v,w,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class c extends u.ChannelServer{constructor(C){super({send:b=>{try{process.send&&process.send(b.buffer.toString("base64"))}catch(l){}},onMessage:T.Event.fromNodeEventEmitter(process,"message",b=>w.VSBuffer.wrap(Buffer.from(b,"base64")))},C);process.once("disconnect",()=>this.dispose())}}t.Server=c;class f{constructor(C,b){this.modulePath=C,this.options=b,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new T.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const l=b&&b.timeout?b.timeout:6e4;this.disposeDelayer=new E.Delayer(l),this.child=null,this._client=null}getChannel(C){const b=this;return{call(l,r,o){return b.requestPromise(C,l,r,o)},listen(l,r){return b.requestEvent(C,l,r)}}}requestPromise(C,b,l,r=y.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(v.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(C),e=(0,E.createCancelablePromise)(s=>o.call(b,l,s)),i=r.onCancellationRequested(()=>e.cancel()),n=(0,O.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(C,b,l){if(!this.disposeDelayer)return T.Event.None;this.disposeDelayer.cancel();let r;const o=new T.Emitter({onFirstListenerAdd:()=>{r=this.getCachedChannel(C).listen(b,l)(o.fire,o),this.activeRequests.add(r)},onLastListenerRemove:()=>{this.activeRequests.delete(r),r.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const C=this.options&&this.options.args?this.options.args:[],b=Object.create(null);b.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(b.env={...b.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(b.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(b.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(b.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),b.execArgv===void 0&&(b.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),F.isMacintosh&&b.env&&delete b.env.DYLD_LIBRARY_PATH,this.child=(0,m.fork)(this.modulePath,C,b);const l=new T.Emitter;T.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,g.isRemoteConsoleLog)(a)){(0,g.log)(a,`IPC Library: ${this.options.serverName}`);return}l.fire(w.VSBuffer.wrap(Buffer.from(a,"base64")))});const o=this.options.useQueue?(0,L.createQueuedSender)(this.child):this.child,e=a=>this.child&&this.child.connected&&o.send(a.buffer.toString("base64")),i=l.event,n={send:e,onMessage:i};this._client=new u.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,h)=>{process.removeListener("exit",s),this.activeRequests.forEach(p=>(0,O.dispose)(p)),this.activeRequests.clear(),a!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+h),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:h})})}return this._client}getCachedChannel(C){let b=this.channels.get(C);return b||(b=this.client.getChannel(C),this.channels.set(C,b)),b}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=f}),define(Y[72],ee([5,6]),function(_,t){return _.create("vs/base/node/zip",t)}),define(Y[73],ee([5,6]),function(_,t){return _.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Y[74],ee([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Y[75],ee([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Y[76],ee([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Y[77],ee([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Y[78],ee([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Y[79],ee([5,6]),function(_,t){return _.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Y[80],ee([5,6]),function(_,t){return _.create("vs/platform/extensions/common/extensionValidator",t)}),define(Y[81],ee([5,6]),function(_,t){return _.create("vs/platform/files/common/fileService",t)}),define(Y[82],ee([5,6]),function(_,t){return _.create("vs/platform/files/common/io",t)}),define(Y[83],ee([5,6]),function(_,t){return _.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Y[84],ee([5,6]),function(_,t){return _.create("vs/platform/request/common/request",t)}),define(Y[85],ee([5,6]),function(_,t){return _.create("vs/platform/telemetry/common/telemetryService",t)}),define(Y[86],ee([0,1,3,20,44,68,9,7,33]),function(_,t,m,O,E,P,T,L,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class g{constructor(c,f,I){this._args=c,this.paths=f,this.productService=I}get appRoot(){return(0,m.dirname)(T.FileAccess.asFileUri("",_).fsPath)}get userHome(){return L.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return L.URI.file((0,m.join)(this.userDataPath,"User"))}get tmpDir(){return L.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,O.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,O.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const c=(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,m.join)(this.userDataPath,"logs",c)}return this.args.logsPath}get userDataSyncLogResource(){return L.URI.file((0,m.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,O.joinPath)(L.URI.file((0,m.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return L.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return L.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,O.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,O.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=u.env.VSCODE_PORTABLE;return c?L.URI.file((0,m.join)(c,"argv.json")):(0,O.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,O.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return L.URI.file((0,m.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,m.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,m.resolve)(c):(0,m.normalize)((0,m.join)(T.FileAccess.asFileUri("",_).fsPath,"..","extensions"))}get extensionsDownloadPath(){const c=this.args["extensions-download-dir"];return c?(0,m.resolve)(c):(0,m.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,m.resolve)(c);const f=u.env.VSCODE_EXTENSIONS;if(f)return f;const I=u.env.VSCODE_PORTABLE;return I?(0,m.join)(I,"extensions"):(0,O.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(f=>/^[^:/?#]+?:\/\//.test(f)?L.URI.parse(f):L.URI.file((0,m.normalize)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?L.URI.parse(c):L.URI.file((0,m.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!u.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,O.joinPath)(L.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return L.URI.file((0,m.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ce([E.memoize],g.prototype,"appRoot",null),ce([E.memoize],g.prototype,"userHome",null),ce([E.memoize],g.prototype,"userDataPath",null),ce([E.memoize],g.prototype,"appSettingsHome",null),ce([E.memoize],g.prototype,"tmpDir",null),ce([E.memoize],g.prototype,"userRoamingDataHome",null),ce([E.memoize],g.prototype,"settingsResource",null),ce([E.memoize],g.prototype,"userDataSyncHome",null),ce([E.memoize],g.prototype,"userDataSyncLogResource",null),ce([E.memoize],g.prototype,"sync",null),ce([E.memoize],g.prototype,"machineSettingsResource",null),ce([E.memoize],g.prototype,"globalStorageHome",null),ce([E.memoize],g.prototype,"workspaceStorageHome",null),ce([E.memoize],g.prototype,"keybindingsResource",null),ce([E.memoize],g.prototype,"keyboardLayoutResource",null),ce([E.memoize],g.prototype,"argvResource",null),ce([E.memoize],g.prototype,"snippetsHome",null),ce([E.memoize],g.prototype,"isExtensionDevelopment",null),ce([E.memoize],g.prototype,"untitledWorkspacesHome",null),ce([E.memoize],g.prototype,"installSourcePath",null),ce([E.memoize],g.prototype,"builtinExtensionsPath",null),ce([E.memoize],g.prototype,"extensionsPath",null),ce([E.memoize],g.prototype,"extensionDevelopmentLocationURI",null),ce([E.memoize],g.prototype,"extensionDevelopmentKind",null),ce([E.memoize],g.prototype,"extensionTestsLocationURI",null),ce([E.memoize],g.prototype,"debugExtensionHost",null),ce([E.memoize],g.prototype,"serviceMachineIdResource",null),ce([E.memoize],g.prototype,"telemetryLogResource",null),ce([E.memoize],g.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=g;function y(F,c){return w(F["inspect-extensions"],F["inspect-brk-extensions"],5870,c,F.debugId)}t.parseExtensionHostPort=y;function v(F,c){return w(F["inspect-search"],F["inspect-brk-search"],5876,c)}t.parseSearchPort=v;function w(F,c,f,I,C){const l=Number(c||F)||(I?null:f),r=l?Boolean(!!c):!1;return{port:l,break:r,debugId:C}}}),function(){"use strict";function _(t,m,O,E){function P(L){const u=T(L),g=[u];return t.isAbsolute(u)||g.unshift(E),t.resolve(...g)}function T(L){const u=process.env.VSCODE_PORTABLE;if(u)return t.join(u,"user-data");const g=L["user-data-dir"];if(g)return g;let y=process.env.VSCODE_APPDATA;if(!y)switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=t.join(v,"AppData","Roaming")}break;case"darwin":y=t.join(m.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||t.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(y,O)}return{getUserDataPath:P}}if(typeof define=="function")define(Y[87],ee([0,88,31,9,20,33]),function(t,m,O,E,P,T){const L=P.dirname(E.FileAccess.asFileUri("",t)),u=t.__$__nodeRequire(P.joinPath(L,"package.json").fsPath);return _(m,O,u.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),m=require("path"),O=require("os");module.exports=_(m,O,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[89],ee([0,1,31,87,86]),function(_,t,m,O,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class P extends E.AbstractNativeEnvironmentService{constructor(L,u){super(L,{homeDir:(0,m.homedir)(),tmpDir:(0,m.tmpdir)(),userDataDir:(0,O.getUserDataPath)(L)},u)}}t.NativeEnvironmentService=P}),define(Y[90],ee([0,1,19]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const O=/^%([\w\d.-]+)%$/i;function E(P,T){const L=u=>{if(typeof u!="string")return;const g=O.exec(u);if(!g)return;const y=T[g[1]]??u;return typeof y=="string"?y:typeof y.message=="string"?y.message:u};return(0,m.cloneAndChange)(P,L)}t.localizeManifest=E}),define(Y[49],ee([0,1,80]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function P(w){return w=w.trim(),w==="*"||O.test(w)}t.isValidVersionStr=P;function T(w){if(!P(w))return null;if(w=w.trim(),w==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let F=w.match(O);return F?{hasCaret:F[1]==="^",hasGreaterEquals:F[1]===">=",majorBase:F[2]==="x"?0:parseInt(F[2],10),majorMustEqual:F[2]!=="x",minorBase:F[4]==="x"?0:parseInt(F[4],10),minorMustEqual:F[4]!=="x",patchBase:F[6]==="x"?0:parseInt(F[6],10),patchMustEqual:F[6]!=="x",preRelease:F[8]||null}:null}t.parseVersion=T;function L(w){if(!w)return null;let F=w.majorBase,c=w.majorMustEqual,f=w.minorBase,I=w.minorMustEqual,C=w.patchBase,b=w.patchMustEqual;w.hasCaret&&(F===0||(I=!1),b=!1);let l=0;if(w.preRelease){const r=E.exec(w.preRelease);if(r){const[,o,e,i]=r;l=Date.UTC(Number(o),Number(e)-1,Number(i))}}return{majorBase:F,majorMustEqual:c,minorBase:f,minorMustEqual:I,patchBase:C,patchMustEqual:b,isMinimum:w.hasGreaterEquals,notBefore:l}}t.normalizeVersion=L;function u(w,F,c){let f;typeof w=="string"?f=L(T(w)):f=w;let I;F instanceof Date?I=F.getTime():typeof F=="string"&&(I=new Date(F).getTime());let C;if(typeof c=="string"?C=L(T(c)):C=c,!f||!C)return!1;let b=f.majorBase,l=f.minorBase,r=f.patchBase,o=C.majorBase,e=C.minorBase,i=C.patchBase,n=C.notBefore,s=C.majorMustEqual,a=C.minorMustEqual,h=C.patchMustEqual;return C.isMinimum?b>o?!0:b<o?!1:l>e?!0:l<e||I&&I<n?!1:r>=i:(b===1&&o===0&&(!s||!a||!h)&&(o=1,e=0,i=0,s=!0,a=!1,h=!1),b<o?!1:b>o?!s:l<e?!1:l>e?!a:r<i?!1:r>i?!h:!(I&&I<n))}t.isValidVersion=u;function g(w,F,c,f){return c.isBuiltin||typeof c.main=="undefined"?!0:v(w,F,c.engines.vscode,f)}t.isValidExtensionVersion=g;function y(w,F,c){return w==="*"||v(F,c,w)}t.isEngineValid=y;function v(w,F,c,f=[]){let I=L(T(c));if(!I)return f.push(m.localize(0,null,c)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return f.push(m.localize(1,null,c)),!1}else if(!I.majorMustEqual)return f.push(m.localize(2,null,c)),!1;return u(w,F,I)?!0:(f.push(m.localize(3,null,w,c)),!1)}}),define(Y[91],ee([0,1,39,48,2,9]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends E.Disposable{constructor(u,g,y,v){super();this.folders=u,this.onDidFilesChange=g,this.onLogMessage=y,this.verboseLogging=v,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new O.Client(P.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(u.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.setFolders(this.folders)}setVerboseLogging(u){this.verboseLogging=u,!this.isDisposed&&this.service&&this.service.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${u}`})}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(Y[92],ee([0,1,39,48,2,9]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends E.Disposable{constructor(u,g,y,v,w={}){super();this.folders=u,this.onDidFilesChange=g,this.onLogMessage=y,this.verboseLogging=v,this.watcherOptions=w,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new O.Client(P.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(u.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.service.setRoots(this.folders)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${u}`})}setVerboseLogging(u){this.verboseLogging=u,this.service&&this.service.setVerboseLogging(u)}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(Y[93],ee([0,1,32,46,61,9]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class T{constructor(u,g,y,v,w){this.watchedFolder=u,this.eventCallback=y,this.logCallback=v,this.verboseLogging=w,this.restartCounter=0,Array.isArray(g)?this.ignored=g.map(F=>(0,E.parse)(F)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${u}, excludes: ${g.join(",")}`),this.startWatcher()}startWatcher(){const u=[this.watchedFolder];this.verboseLogging&&u.push("-verbose"),this.handle=(0,m.spawn)(P.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",_).fsPath,u);const g=new O.LineDecoder;this.handle.stdout.on("data",y=>{const v=[];for(const w of g.write(y)){const F=w.split("|");if(F.length===2){const c=Number(F[0]),f=F[1];if(c>=0&&c<3){if(this.ignored&&this.ignored.some(I=>I(f))){this.verboseLogging&&this.log(f);continue}v.push({type:T.changeTypeMap[c],path:f})}else this.log(F[1])}}v.length>0&&this.eventCallback(v)}),this.handle.on("error",y=>this.onError(y)),this.handle.stderr.on("data",y=>this.onError(y)),this.handle.on("exit",(y,v)=>this.onExit(y,v))}onError(u){this.error("process error: "+u.toString())}onExit(u,g){this.handle&&(this.error(`terminated unexpectedly (code: ${u}, signal: ${g})`),this.restartCounter<=T.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(u){this.logCallback({type:"error",message:`[File Watcher (C#)] ${u}`})}log(u){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${u}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=T,T.MAX_RESTARTS=5,T.changeTypeMap=[0,1,2]}),define(Y[94],ee([0,1,93,3,18]),function(_,t,m,O,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class P{constructor(L,u,g,y){this.onDidFilesChange=u,this.onLogMessage=g,this.verboseLogging=y,this.service=void 0,this.folder=L[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(O.posix.sep)&&(this.folder.path=(0,E.rtrim)(this.folder.path,O.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,L=>this.onFileEvents(L),L=>this.onLogMessage(L),this.verboseLogging)}setVerboseLogging(L){this.verboseLogging=L,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(L){this.isDisposed||L.length>0&&this.onDidFilesChange(L)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=P}),define(Y[50],ee([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class m{constructor(E,P=[],T=!1){this.ctor=E,this.staticArguments=P,this.supportsDelayedInstantiation=T}}t.SyncDescriptor=m}),define(Y[95],ee([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class m{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}t.Node=m;class O{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let T of this._nodes.values())T.outgoing.size===0&&P.push(T);return P}insertEdge(P,T){const L=this.lookupOrInsertNode(P),u=this.lookupOrInsertNode(T);L.outgoing.set(this._hashFn(T),u),u.incoming.set(this._hashFn(P),L)}removeNode(P){const T=this._hashFn(P);this._nodes.delete(T);for(let L of this._nodes.values())L.outgoing.delete(T),L.incoming.delete(T)}lookupOrInsertNode(P){const T=this._hashFn(P);let L=this._nodes.get(T);return L||(L=new m(P),this._nodes.set(T,L)),L}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[T,L]of this._nodes)P.push(`${T}, (incoming)[${[...L.incoming.keys()].join(", ")}], (outgoing)[${[...L.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,T]of this._nodes){const L=new Set([P]),u=this._findCycle(T,L);if(u)return u}}_findCycle(P,T){for(let[L,u]of P.outgoing){if(T.has(L))return[...T,L].join(" -> ");T.add(L);const g=this._findCycle(u,T);if(g)return g;T.delete(L)}}}t.Graph=O}),define(Y[96],ee([0,1,12]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,m.createDecorator)("downloadService")}),define(Y[21],ee([0,1,12]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,m.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,m.refineServiceDecorator)(t.IEnvironmentService)}),define(Y[22],ee([0,1,75,12,9]),function(_,t,m,O,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";function P(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}t.isIExtensionIdentifier=P;var T;(function(v){v[v.NoneOrRelevance=0]="NoneOrRelevance",v[v.LastUpdatedDate=1]="LastUpdatedDate",v[v.Title=2]="Title",v[v.PublisherName=3]="PublisherName",v[v.InstallCount=4]="InstallCount",v[v.PublishedDate=5]="PublishedDate",v[v.AverageRating=6]="AverageRating",v[v.WeightedRating=12]="WeightedRating"})(T=t.SortBy||(t.SortBy={}));var L;(function(v){v[v.Default=0]="Default",v[v.Ascending=1]="Ascending",v[v.Descending=2]="Descending"})(L=t.SortOrder||(t.SortOrder={}));var u;(function(v){v.Uninstall="uninstall"})(u=t.StatisticType||(t.StatisticType={}));var g;(function(v){v[v.None=0]="None",v[v.Install=1]="Install",v[v.Update=2]="Update"})(g=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class y extends Error{constructor(w,F){super(w);this.code=F,this.name=F}}t.ExtensionManagementError=y,t.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=E.FileAccess.asBrowserUri("./media/defaultIcon.png",_).toString(!0),t.ExtensionsLabel=(0,m.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,m.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,O.createDecorator)("IExtensionManagementCLIService")}),define(Y[40],ee([0,1,18,12]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function E(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}t.getWorkspaceSupportTypeMessage=E;function P(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}t.isIExtensionIdentifier=P,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(T=t.ExtensionType||(t.ExtensionType={}));class L{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,w){if(typeof v=="undefined"||v===null)return typeof w=="undefined"||w===null;if(typeof w=="undefined"||w===null)return!1;if(typeof v=="string"||typeof w=="string"){let F=typeof v=="string"?v:v.value,c=typeof w=="string"?w:w.value;return m.equalsIgnoreCase(F,c)}return v._lower===w._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}t.ExtensionIdentifier=L;function u(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}t.isLanguagePackExtension=u;function g(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=g,t.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[23],ee([0,1,18,40]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function E(c,f){return c.uuid&&f.uuid?c.uuid===f.uuid:c.id===f.id?!0:(0,m.compareIgnoreCase)(c.id,f.id)===0}t.areSameExtensions=E;class P{constructor(f,I){this.version=I,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof P?E(this,f)&&this.version===f.version:!1}}t.ExtensionIdentifierWithVersion=P;function T(c,f){return`${c}.${f}`}t.getExtensionId=T;function L(c){return c.toLocaleLowerCase()}t.adoptToGalleryExtensionId=L;function u(c,f){return L(T(c,f))}t.getGalleryExtensionId=u;function g(c,f){const I=[],C=b=>{for(const l of I)if(l.some(r=>E(f(r),f(b))))return l;return null};for(const b of c){const l=C(b);l?l.push(b):I.push([b])}return I}t.groupByExtension=g;function y(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=y;function v(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}t.getGalleryExtensionTelemetryData=v,t.BetterMergeId=new O.ExtensionIdentifier("pprice.better-merge");function w(c){const f=new Set;for(const I of c)I.malicious&&f.add(I.id.id);return f}t.getMaliciousExtensionsSet=w;function F(c,f){const I=[],C=f.manifest.extensionDependencies?.slice(0)??[];for(;C.length;){const b=C.shift();if(b&&I.every(l=>!E(l.identifier,{id:b}))){const l=c.filter(r=>E(r.identifier,{id:b}));l.length===1&&(I.push(l[0]),C.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return I}t.getExtensionDependencies=F});var ue=this&&this.__param||function(_,t){return function(m,O){t(m,O,_)}};define(Y[97],ee([0,1,76,8,7,41,22,23,40,62,26,9]),function(_,t,m,O,E,P,T,L,u,g,y,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const w=b=>(0,m.localize)(0,null,b),F=(0,m.localize)(1,null,"ms-dotnettools.csharp");function c(b,l){return l?`${b.publisher}.${b.name}@${b.version}`:`${b.publisher}.${b.name}`}const f=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function I(b){const l=f.exec(b);return l&&l[1]?[(0,L.adoptToGalleryExtensionId)(l[1]),l[2]]:[(0,L.adoptToGalleryExtensionId)(b),void 0]}t.getIdAndVersion=I;let C=class{constructor(l,r){this.extensionManagementService=l,this.extensionGalleryService=r}get location(){}async listExtensions(l,r,o=console){let e=await this.extensionManagementService.getInstalled(1);const i=u.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(r&&r!==""){if(i.indexOf(r.toLowerCase())<0){o.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(s=>s.manifest.categories?s.manifest.categories.map(h=>h.toLowerCase()).indexOf(r.toLowerCase())>-1:!1)}else if(r===""){o.log("Possible Categories: "),i.forEach(s=>{o.log(s)});return}this.location&&o.log((0,m.localize)(2,null,this.location)),e=e.sort((s,a)=>s.identifier.id.localeCompare(a.identifier.id));let n;for(let s of e)n!==s.identifier.id&&(n=s.identifier.id,o.log(c(s.manifest,l)))}async installExtensions(l,r,o,e,i=console){const n=[],s=[];l.length&&i.log(this.location?(0,m.localize)(3,null,this.location):(0,m.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),h=(R,k)=>{const z=a.find(W=>(0,L.areSameExtensions)(W.identifier,{id:R}));if(z){if(!k&&!e)return i.log((0,m.localize)(5,null,R,z.manifest.version,R)),!1;if(k&&z.manifest.version===k)return i.log((0,m.localize)(6,null,`${R}@${k}`)),!1}return!0},p=[],M=[];for(const R of l)if(R instanceof E.URI)p.push(R);else{const[k,z]=I(R);h(k,z)&&M.push({id:k,version:z,installOptions:{isBuiltin:!1,isMachineScoped:o}})}for(const R of r){const[k,z]=I(R);h(k,z)&&M.push({id:k,version:z,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(p.length&&await Promise.all(p.map(async R=>{try{const k=await this.installVSIX(R,{isBuiltin:!1,isMachineScoped:o},e,i);k&&s.push(k)}catch(k){i.error(k.message||k.stack||k),n.push(R.toString())}})),M.length){const R=await this.getGalleryExtensions(M);await Promise.all(M.map(async k=>{const z=R.get(k.id.toLowerCase());if(z)try{const W=await this.installFromGallery(k,z,a,e,i);W&&s.push(W)}catch(W){i.error(W.message||W.stack||W),n.push(k.id)}else i.error(`${w(k.version?`${k.id}@${k.version}`:k.id)}
${F}`),n.push(k.id)}))}if(n.length)throw new Error((0,m.localize)(7,null,n.join(", ")))}async installVSIX(l,r,o,e){const i=await this.extensionManagementService.getManifest(l);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,o,e))try{return await this.extensionManagementService.install(l,r),e.log((0,m.localize)(8,null,(0,g.getBaseLabel)(l))),i}catch(s){if((0,O.isPromiseCanceledError)(s))return e.log((0,m.localize)(9,null,(0,g.getBaseLabel)(l))),null;throw s}return null}async getGalleryExtensions(l){const r=l.filter(({version:i})=>i===void 0).map(({id:i})=>i),o=l.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(r,y.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(o.map(async({id:i,version:n})=>{const s=await this.extensionGalleryService.getCompatibleExtension({id:i},n);s&&e.set(s.identifier.id.toLowerCase(),s)}))]),e}async installFromGallery({id:l,version:r,installOptions:o},e,i,n,s){const a=await this.extensionGalleryService.getManifest(e,y.CancellationToken.None);if(a&&!this.validateExtensionKind(a,s))return null;const h=i.find(p=>(0,L.areSameExtensions)(p.identifier,e.identifier));if(h){if(e.version===h.manifest.version)return s.log((0,m.localize)(10,null,r?`${l}@${r}`:l)),null;s.log((0,m.localize)(11,null,l,e.version))}try{return o.isBuiltin?s.log(r?(0,m.localize)(12,null,l,r):(0,m.localize)(13,null,l)):s.log(r?(0,m.localize)(14,null,l,r):(0,m.localize)(15,null,l)),await this.extensionManagementService.installFromGallery(e,o),s.log((0,m.localize)(16,null,l,e.version)),a}catch(p){if((0,O.isPromiseCanceledError)(p))return s.log((0,m.localize)(17,null,l)),null;throw p}}validateExtensionKind(l,r){return!0}async validateVSIX(l,r,o){const e={id:(0,L.getGalleryExtensionId)(l.publisher,l.name)},n=(await this.extensionManagementService.getInstalled(1)).find(s=>(0,L.areSameExtensions)(e,s.identifier)&&(0,P.gt)(s.manifest.version,l.version));return n&&!r?(o.log((0,m.localize)(18,null,n.identifier.id,n.manifest.version,l.version)),!1):this.validateExtensionKind(l,o)}async uninstallExtensions(l,r,o=console){const e=async n=>{if(n instanceof E.URI){const s=await this.extensionManagementService.getManifest(n);return c(s)}return n},i=[];for(const n of l){const s=await e(n),h=(await this.extensionManagementService.getInstalled()).filter(p=>(0,L.areSameExtensions)(p.identifier,{id:s}));if(!h.length)throw new Error(`${this.notInstalled(s)}
${F}`);if(h.some(p=>p.type===0)){o.log((0,m.localize)(19,null,s));return}if(!r&&h.some(p=>p.isBuiltin)){o.log((0,m.localize)(20,null,s));return}o.log((0,m.localize)(21,null,s));for(const p of h)await this.extensionManagementService.uninstall(p),i.push(p);this.location?o.log((0,m.localize)(22,null,s,this.location)):o.log((0,m.localize)(23,null,s))}}async locateExtension(l,r=console){const o=await this.extensionManagementService.getInstalled();l.forEach(e=>{o.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===v.Schemas.file){r.log(i.location.fsPath);return}})})}notInstalled(l){return this.location?(0,m.localize)(24,null,l,this.location):(0,m.localize)(25,null,l)}};C=ce([ue(0,T.IExtensionManagementService),ue(1,T.IExtensionGalleryService)],C),t.ExtensionManagementCLIService=C}),define(Y[98],ee([0,1,2,3,40,10]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class T extends m.Disposable{constructor(u,g){super();this.environmentService=u,this.extensionsManifestCache=(0,O.join)(this.environmentService.userDataPath,E.MANIFEST_CACHE_FOLDER,E.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(g.onDidUninstallExtension(y=>this.onDidUnInstallExtension(y)))}onDidInstallExtensions(u){u.some(g=>!!g.local)&&this.invalidate()}onDidUnInstallExtension(u){u.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=T}),define(Y[99],ee([0,1,88,32,29,15,128,28,71,26,8]),function(_,t,m,O,E,P,T,L,u,g,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function v(c,f,I){return f["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,T.isLaunchedFromCli)(I)&&!f["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,T.isLaunchedFromCli)(I)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=new Promise(async C=>{const b=new g.CancellationTokenSource,l=setTimeout(()=>{c.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),b.dispose(!0),C({})},1e4);try{const r=await F(c,b.token);C(r)}catch(r){(0,y.isPromiseCanceledError)(r)||c.error(`[resolve shell env] Unable to resolve shell environment (${r}). Proceeding without shell environment...`),C({})}finally{clearTimeout(l),b.dispose()}})),w)}t.resolveShellEnv=v;let w;async function F(c,f){const I=new Promise(async(C,b)=>{const l=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",l);const r=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",r);const o=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(o+"(.*)"+o),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};c.trace("getUnixShellEnvironment#env",i);const n=await(0,u.getSystemShell)(P.OS,i);if(c.trace("getUnixShellEnvironment#shell",n),f.isCancellationRequested)return b(y.canceled);const s=m.basename(n);let a,h;/^pwsh(-preview)?$/.test(s)?(a=`& '${process.execPath}' -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,h=["-ilc"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const p=(0,O.spawn)(n,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});f.onCancellationRequested(()=>(p.kill(),b(y.canceled))),p.on("error",k=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(k)),C({})});const M=[];p.stdout.on("data",k=>M.push(k));const R=[];p.stderr.on("data",k=>R.push(k)),p.on("close",(k,z)=>{const W=Buffer.concat(M).toString("utf8");c.trace("getUnixShellEnvironment#raw",W);const Q=Buffer.concat(R).toString("utf8");if(Q.trim()&&c.trace("getUnixShellEnvironment#stderr",Q),k||z)return b(new Error(`Failed to get environment (code ${k}, signal ${z})`));const ie=e.exec(W),re=ie?ie[1]:"{}";try{const Z=JSON.parse(re);l?Z.ELECTRON_RUN_AS_NODE=l:delete Z.ELECTRON_RUN_AS_NODE,r?Z.ELECTRON_NO_ATTACH_CONSOLE=r:delete Z.ELECTRON_NO_ATTACH_CONSOLE,delete Z.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",Z),C(Z)}catch(Z){c.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(Z)),b(Z)}})});try{return await I}catch(C){return c.error("getUnixShellEnvironment#error",(0,L.toErrorMessage)(C)),{}}}}),define(Y[51],ee([0,1,7,17,15]),function(_,t,m,O,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function P(u){return u.map(g=>({type:g.type,resource:m.URI.file(g.path)}))}t.toFileChanges=P;function T(u){const g=new L;for(const y of u)g.processEvent(y);return g.normalize()}t.normalizeFileChanges=T;class L{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(g){const y=this.mapPathToChange.get(g.path);if(y){const v=y.type,w=g.type;v===1&&w===2?(this.mapPathToChange.delete(g.path),this.normalized.splice(this.normalized.indexOf(y),1)):v===2&&w===1?y.type=0:v===1&&w===0||(y.type=w)}else this.normalized.push(g),this.mapPathToChange.set(g.path,g)}normalize(){const g=[],y=[];return this.normalized.filter(v=>v.type!==2?(g.push(v),!1):!0).sort((v,w)=>v.path.length-w.path.length).filter(v=>y.some(w=>(0,O.isParent)(v.path,w,!E.isLinux))?!1:(y.push(v.path),!0)).concat(g)}}}),define(Y[100],ee([0,1,51,2,10,63,65,4,3]),function(_,t,m,O,E,P,T,L,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class g extends O.Disposable{constructor(v,w,F,c){super();this.path=v,this.onDidFilesChange=w,this.onLogMessage=F,this.verboseLogging=c,this.fileChangesDelayer=this._register(new L.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(v){this.verboseLogging=v}async startWatching(){try{const{stat:v,symbolicLink:w}=await E.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let F=this.path;if(w)try{F=await(0,P.realpath)(F)}catch(c){if(this.onError(c),w.dangling)return}v.isDirectory()?this._register((0,T.watchFolder)(F,(c,f)=>{this.onFileChange({type:c==="changed"?0:c==="added"?1:2,path:(0,u.join)(this.path,(0,u.basename)(f))})},c=>this.onError(c))):this._register((0,T.watchFile)(F,c=>{this.onFileChange({type:c==="changed"?0:2,path:this.path})},c=>this.onError(c)))}catch(v){v.code!=="ENOENT"&&this.onError(v)}}onFileChange(v){this.fileChangesBuffer.push(v),this.verboseLogging&&this.onVerbose(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),this.fileChangesDelayer.trigger(async()=>{const w=this.fileChangesBuffer;this.fileChangesBuffer=[];const F=(0,m.normalizeFileChanges)(w);if(this.verboseLogging)for(const c of F)this.onVerbose(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);F.length>0&&this.onDidFilesChange(F)})}onError(v){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${v}`})}onVerbose(v){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=g}),define(Y[52],ee([0,1]),function(_,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class m{constructor(...E){this._entries=new Map;for(let[P,T]of E)this.set(P,T)}set(E,P){const T=this._entries.get(E);return this._entries.set(E,P),T}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}t.ServiceCollection=m}),define(Y[101],ee([0,1,8,95,50,12,52,4]),function(_,t,m,O,E,P,T,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const u=!1;class g extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class y{constructor(c=new T.ServiceCollection,f=!1,I){this._activeInstantiations=new Set,this._services=c,this._strict=f,this._parent=I,this._services.set(P.IInstantiationService,this)}createChild(c){return new y(c,this._strict,this)}invokeFunction(c,...f){let I=w.traceInvocation(c),C=!1;try{return c({get:(l,r)=>{if(C)throw(0,m.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(l,I);if(!o&&r!==P.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return o}},...f)}finally{C=!0,I.stop()}}createInstance(c,...f){let I,C;return c instanceof E.SyncDescriptor?(I=w.traceCreation(c.ctor),C=this._createInstance(c.ctor,c.staticArguments.concat(f),I)):(I=w.traceCreation(c),C=this._createInstance(c,f,I)),I.stop(),C}_createInstance(c,f=[],I){let C=P._util.getServiceDependencies(c).sort((r,o)=>r.index-o.index),b=[];for(const r of C){let o=this._getOrCreateServiceInstance(r.id,I);if(!o&&this._strict&&!r.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${r.id}.`);b.push(o)}let l=C.length>0?C[0].index:f.length;if(f.length!==l){console.warn(`[createInstance] First service dependency of ${c.name} at position ${l+1} conflicts with ${f.length} static arguments`);let r=l-f.length;r>0?f=f.concat(new Array(r)):f=f.slice(0,l)}return new c(...[...f,...b])}_setServiceInstance(c,f){if(this._services.get(c)instanceof E.SyncDescriptor)this._services.set(c,f);else if(this._parent)this._parent._setServiceInstance(c,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let f=this._services.get(c);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):f}_getOrCreateServiceInstance(c,f){let I=this._getServiceInstanceOrDescriptor(c);return I instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,I,f.branch(c,!0)):(f.branch(c,!1),I)}_safeCreateAndCacheServiceInstance(c,f,I){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,f,I)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,f,I){const C=new O.Graph(r=>r.id.toString());let b=0;const l=[{id:c,desc:f,_trace:I}];for(;l.length;){const r=l.pop();if(C.lookupOrInsertNode(r),b++>1e3)throw new g(C);for(let o of P._util.getServiceDependencies(r.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(o.id);if(!e&&!o.optional&&console.warn(`[createInstance] ${c} depends on ${o.id} which is NOT registered.`),e instanceof E.SyncDescriptor){const i={id:o.id,desc:e,_trace:r._trace.branch(o.id,!0)};C.insertEdge(r,i),l.push(i)}}}for(;;){const r=C.roots();if(r.length===0){if(!C.isEmpty())throw new g(C);break}for(const{data:o}of r){if(this._getServiceInstanceOrDescriptor(o.id)instanceof E.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}C.removeNode(o)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,f,I=[],C,b){if(this._services.get(c)instanceof E.SyncDescriptor)return this._createServiceInstance(f,I,C,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,f,I,C,b);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(c,f=[],I,C){if(I){const b=new L.IdleValue(()=>this._createInstance(c,f,C));return new Proxy(Object.create(null),{get(l,r){if(r in l)return l[r];let o=b.value,e=o[r];return typeof e!="function"||(e=e.bind(o),l[r]=e),e},set(l,r,o){return b.value[r]=o,!0}})}else return this._createInstance(c,f,C)}}t.InstantiationService=y;var v;(function(F){F[F.Creation=0]="Creation",F[F.Invocation=1]="Invocation",F[F.Branch=2]="Branch"})(v||(v={}));class w{constructor(c,f){this.type=c,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return u?new w(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):w._None}static traceCreation(c){return u?new w(0,c.name):w._None}branch(c,f){let I=new w(2,c.toString());return this._dep.push([c,f,I]),I}stop(){let c=Date.now()-this._start;w._totals+=c;let f=!1;function I(b,l){let r=[],o=new Array(b+1).join("	");for(const[e,i,n]of l._dep)if(i&&n){f=!0,r.push(`${o}CREATES -> ${e}`);let s=I(b+1,n);s&&r.push(s)}else r.push(`${o}uses -> ${e}`);return r.join(`
`)}let C=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${I(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(c>2||f)&&console.log(C.join(`
`))}}w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(Y[53],ee([0,1,12]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,m.createDecorator)("localizationsService");function O(E){if(typeof E.languageId!="string"||!Array.isArray(E.translations)||E.translations.length===0)return!1;for(const P of E.translations)if(typeof P.id!="string"||typeof P.path!="string")return!1;return!(E.languageName&&typeof E.languageName!="string"||E.localizedLanguageName&&typeof E.localizedLanguageName!="string")}t.isValidLocalization=O}),define(Y[14],ee([0,1,12,2,15,11,28]),function(_,t,m,O,E,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,m.createDecorator)("logService"),t.ILoggerService=(0,m.createDecorator)("loggerService");function L(){return new Date().toISOString()}var u;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(u=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=u.Info;class g extends O.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=g;class y extends g{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(u.Trace)&&this.log(u.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(u.Debug)&&this.log(u.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(u.Info)&&this.log(u.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(u.Warning)&&this.log(u.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(u.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(u.Error,this.format(n))}else this.log(u.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(u.Critical)&&this.log(u.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let s=e[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(a){}i+=(n>0?" ":"")+s}return i}}t.AbstractMessageLogger=y;class v extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!E.isWindows}trace(e,...i){this.getLevel()<=u.Trace&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}debug(e,...i){this.getLevel()<=u.Debug&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}info(e,...i){this.getLevel()<=u.Info&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}warn(e,...i){this.getLevel()<=u.Warning&&(this.useColors?console.warn(`[93m[main ${L()}][0m`,e,...i):console.warn(`[main ${L()}]`,e,...i))}error(e,...i){this.getLevel()<=u.Error&&(this.useColors?console.error(`[91m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}critical(e,...i){this.getLevel()<=u.Critical&&(this.useColors?console.error(`[90m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=v;class w extends g{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=u.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=u.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=u.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=u.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=u.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=u.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=w;class F extends g{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=u.Trace&&this.adapter.log(u.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=u.Debug&&this.adapter.log(u.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=u.Info&&this.adapter.log(u.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=u.Warning&&this.adapter.log(u.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=u.Error&&this.adapter.log(u.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=u.Critical&&this.adapter.log(u.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=u.Trace)}dispose(){}flush(){}}t.AdapterLogger=F;class c extends g{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=c;class f extends O.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=f;class I extends O.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(n))}))}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?u.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=I;class C{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(e){}getLevel(){return u.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=C;function b(o){if(o.verbose)return u.Trace;if(typeof o.logLevel=="string"){const e=l(o.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=b;function l(o){switch(o){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Critical;case"off":return u.Off}}t.parseLogLevel=l;function r(o){switch(o){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Critical:return"critical";case u.Off:return"off"}}t.LogLevelToString=r}),define(Y[102],ee([0,1,10,2,17,22,21,7,20,23,14,29,41,15,4,8]),function(_,t,m,O,E,P,T,L,u,g,y,v,w,F,c,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let C=class extends O.Disposable{constructor(l,r,o,e){super();this.fileService=r,this.extensionGalleryService=o,this.logService=e,this.extensionsDownloadDir=L.URI.file(l.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(l,r){await this.cleanUpPromise;const o=this.getName(l),e=(0,u.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(e)){const i=(0,u.joinPath)(this.extensionsDownloadDir,`.${(0,v.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(l,i,r);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(s){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",l.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,f.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(l){}async rename(l,r,o){try{await m.Promises.rename(l.fsPath,r.fsPath)}catch(e){if(F.isWindows&&e&&e.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${l} to ${r} with 'EPERM' error. Trying again...`),this.rename(l,r,o);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const l=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(l.children){const r=[],o=[];for(const n of l.children){const s=this.parse(n.name);s&&o.push([s,n])}const e=(0,g.groupByExtension)(o,([n])=>n),i=[];for(const n of e)n.sort((s,a)=>w.rcompare(s[0].version,a[0].version)),r.push(...n.slice(1).map(s=>s[1].resource)),i.push(n[0][1]);i.sort((n,s)=>n.mtime-s.mtime),r.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await c.Promises.settled(r.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(l){this.logService.error(l)}}getName(l){return this.cache?new g.ExtensionIdentifierWithVersion(l.identifier,l.version).key().toLowerCase():(0,v.generateUuid)()}parse(l){const r=I.exec(l);return r&&r[1]&&r[2]?new g.ExtensionIdentifierWithVersion({id:r[1]},r[2]):null}};C=ce([ue(0,T.INativeEnvironmentService),ue(1,E.IFileService),ue(2,P.IExtensionGalleryService),ue(3,y.ILogService)],C),t.ExtensionsDownloader=C}),define(Y[103],ee([0,1,2,14,32,28,3,4,11,9,10,21]),function(_,t,m,O,E,P,T,L,u,g,y,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let w=class extends m.Disposable{constructor(c,f){super();this.environmentService=c,this.logService=f,this.processesLimiter=new L.Limiter(5)}async postUninstall(c){const f=this.parseScript(c,"uninstall");return f&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(f.script,"uninstall",f.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),I=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${I}`)))),y.Promises.rm(this.getExtensionStoragePath(c)).then(void 0,I=>this.logService.error("Error while removing extension storage path",I))}parseScript(c,f){const I=`vscode:${f}`;if(c.location.scheme===g.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[I]=="string"){const C=c.manifest.scripts[I].split(" ");return C.length<2||C[0]!=="node"||!C[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${I} should be a node script`),null):{script:(0,T.join)(c.location.fsPath,C[1]),args:C.slice(2)||[]}}return null}runLifecycleHook(c,f,I,C,b){return new Promise((l,r)=>{const o=this.start(c,f,I,b);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?r(n):l(void 0)};o.on("error",n=>{i((0,P.toErrorMessage)(n)||"Unknown")}),o.on("exit",(n,s)=>{i(n?`post-${f} process exited with code ${n}`:void 0)}),C&&(e=setTimeout(()=>{e=null,o.kill(),r("timed out")},5e3))})}start(c,f,I,C){const b={silent:!0,execArgv:void 0},l=(0,E.fork)(c,[`--type=extension-post-${f}`,...I],b);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const r=u.Event.fromNodeEventEmitter(l.stdout,"data"),o=u.Event.fromNodeEventEmitter(l.stderr,"data");r(n=>this.logService.info(C.identifier.id,C.manifest.version,`post-${f}`,n)),o(n=>this.logService.error(C.identifier.id,C.manifest.version,`post-${f}`,n));const e=u.Event.any(u.Event.map(r,n=>({data:`%c${n}`,format:[""]})),u.Event.map(o,n=>({data:`%c${n}`,format:["color: red"]})));return u.Event.debounce(e,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(C.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),l}getExtensionStoragePath(c){return(0,T.join)(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};w=ce([ue(0,v.IEnvironmentService),ue(1,O.ILogService)],w),t.ExtensionsLifecycle=w}),define(Y[104],ee([0,1,2,21,11,17,7,23,20,14]),function(_,t,m,O,E,P,T,L,u,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let y=class extends m.Disposable{constructor(w,F,c,f){super();this.extensionsManagementService=w,this.logService=f,this._onDidChangeExtensionsByAnotherSource=this._register(new E.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(b=>{this.installedExtensions=b.map(l=>l.identifier),this.startTimestamp=Date.now()}),this._register(w.onInstallExtension(b=>this.onInstallExtension(b))),this._register(w.onDidInstallExtensions(b=>this.onDidInstallExtensions(b))),this._register(w.onDidUninstallExtension(b=>this.onDidUninstallExtension(b)));const I=T.URI.file(c.extensionsPath),C=new u.ExtUri(b=>!F.hasCapability(b,1024));this._register(F.watch(I)),this._register(E.Event.filter(F.onDidChangeFilesRaw,b=>b.changes.some(l=>this.doesChangeAffects(l,I,C)))(()=>this.onDidChange()))}doesChangeAffects(w,F,c){return c.isEqual(c.dirname(w.resource),F)?c.isEqual(w.resource,c.joinPath(F,".obsolete"))?!0:!(w.type!==1&&w.type!==2||c.basename(w.resource).startsWith(".")):!1}onInstallExtension(w){this.addInstallingExtension(w.identifier)}onDidInstallExtensions(w){for(const F of w)this.removeInstallingExtension(F.identifier),F.local&&this.addInstalledExtension(F.identifier)}onDidUninstallExtension(w){w.error||this.removeInstalledExtension(w.identifier)}addInstallingExtension(w){this.removeInstallingExtension(w),this.installingExtensions.push(w)}removeInstallingExtension(w){this.installingExtensions=this.installingExtensions.filter(F=>!(0,L.areSameExtensions)(F,w))}addInstalledExtension(w){this.installedExtensions&&(this.removeInstalledExtension(w),this.installedExtensions.push(w))}removeInstalledExtension(w){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(F=>!(0,L.areSameExtensions)(F,w)))}async onDidChange(){if(this.installedExtensions){const w=await this.extensionsManagementService.getInstalled(1),F=w.filter(f=>[...this.installingExtensions,...this.installedExtensions].some(I=>(0,L.areSameExtensions)(I,f.identifier))?!1:f.installedTimestamp&&f.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",f.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",f.identifier.id),!1)),c=this.installedExtensions.filter(f=>this.installingExtensions.some(I=>(0,L.areSameExtensions)(I,f))?!1:w.every(I=>!(0,L.areSameExtensions)(I.identifier,f))?(this.logService.info("Detected extension removed from another source",f.id),!0):!1);this.installedExtensions=w.map(f=>f.identifier),(F.length||c.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:F,removed:c})}}};y=ce([ue(1,P.IFileService),ue(2,O.INativeEnvironmentService),ue(3,g.ILogService)],y),t.ExtensionsWatcher=y}),define(Y[105],ee([0,1,10,129,22,2,21,4,23,14,53,24,11,9,3]),function(_,t,m,O,E,P,T,L,u,g,y,v,w,F,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let f=class extends P.Disposable{constructor(b,l,r){super();this.extensionManagementService=b,this.logService=r,this._onDidLanguagesChange=this._register(new w.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new I(l,r)),this._register(b.onDidInstallExtensions(o=>this.onDidInstallExtensions(o))),this._register(b.onDidUninstallExtension(({identifier:o})=>this.onDidUninstallExtension(o)))}getLanguageIds(){return this.cache.getLanguagePacks().then(b=>{const l=["en",...Object.keys(b)];return(0,v.distinct)(l)})}onDidInstallExtensions(b){for(const{local:l}of b)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",l.identifier.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(b){this.cache.getLanguagePacks().then(l=>{Object.keys(l).some(r=>l[r]&&l[r].extensions.some(o=>(0,u.areSameExtensions)(o.extensionIdentifier,b)))&&(this.logService.debug("Removing language packs from the extension",b.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))})}async update(){const[b,l]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),r=await this.cache.update(l);return!(0,v.equals)(Object.keys(b),Object.keys(r))}};f=ce([ue(0,E.IExtensionManagementService),ue(1,T.INativeEnvironmentService),ue(2,g.ILogService)],f),t.LocalizationsService=f;let I=class extends P.Disposable{constructor(b,l){super();this.logService=l,this.languagePacks={},this.languagePacksFilePath=(0,c.join)(b.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(b){return this.withLanguagePacks(l=>{Object.keys(l).forEach(r=>delete l[r]),this.createLanguagePacksFromExtensions(l,...b)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(b,...l){for(const r of l)r&&r.manifest&&r.manifest.contributes&&r.manifest.contributes.localizations&&r.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(b,r);Object.keys(b).forEach(r=>this.updateHash(b[r]))}createLanguagePacksFromExtension(b,l){const r=l.identifier,o=l.manifest.contributes&&l.manifest.contributes.localizations?l.manifest.contributes.localizations:[];for(const e of o)if(l.location.scheme===F.Schemas.file&&(0,y.isValidLocalization)(e)){let i=b[e.languageId];i||(i={hash:"",extensions:[],translations:{}},b[e.languageId]=i);let n=i.extensions.filter(s=>(0,u.areSameExtensions)(s.extensionIdentifier,r))[0];n?n.version=l.manifest.version:i.extensions.push({extensionIdentifier:r,version:l.manifest.version});for(const s of e.translations)i.translations[s.id]=(0,c.join)(l.location.fsPath,s.path)}}updateHash(b){if(b){const l=(0,O.createHash)("md5");for(const r of b.extensions)l.update(r.extensionIdentifier.uuid||r.extensionIdentifier.id).update(r.version);b.hash=l.digest("hex")}}withLanguagePacks(b=()=>null){return this.languagePacksFileLimiter.queue(()=>{let l=null;return m.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,r=>r.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(r)).then(r=>{try{return JSON.parse(r)}catch(o){return{}}}).then(r=>(l=b(r),r)).then(r=>{for(const e of Object.keys(r))r[e]||delete r[e];this.languagePacks=r,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),m.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>l,r=>this.logService.error(r))})}};I=ce([ue(0,T.INativeEnvironmentService),ue(1,g.ILogService)],I)}),define(Y[106],ee([0,1,14,17]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function E(u,g,y,v){try{const w=await new Promise((F,c)=>{_(["spdlog"],F,c)});return w.setFlushOn(m.LogLevel.Trace),w.createAsyncRotatingLogger(u,g,y,v)}catch(w){console.error(w)}return null}function P(u,g,y,v){const w=_.__$__nodeRequire("spdlog");return w.setFlushOn(m.LogLevel.Trace),w.createRotatingLogger(u,g,y,v)}t.createRotatingLogger=P;function T(u,g,y){switch(g){case m.LogLevel.Trace:u.trace(y);break;case m.LogLevel.Debug:u.debug(y);break;case m.LogLevel.Info:u.info(y);break;case m.LogLevel.Warning:u.warn(y);break;case m.LogLevel.Error:u.error(y);break;case m.LogLevel.Critical:u.critical(y);break;default:throw new Error("Invalid log level")}}class L extends m.AbstractMessageLogger{constructor(g,y,v,w){super();this.name=g,this.filepath=y,this.rotating=v,this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(F=>{this._logger&&this._logger.setLevel(F)}))}_createSpdLogLogger(){const g=this.rotating?6:1,y=30/g*O.ByteSize.MB;return E(this.name,this.filepath,y,g).then(v=>{if(v){this._logger=v,this._logger.setLevel(this.getLevel());for(const{level:w,message:F}of this.buffer)T(this._logger,w,F);this.buffer=[]}})}log(g,y){this._logger?T(this._logger,g,y):this.getLevel()<=g&&this.buffer.push({level:g,message:y})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=L}),define(Y[54],ee([0,1,82,16,17,8,34]),function(_,t,m,O,E,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function L(v,w,F,c,f,I){let C;try{await u(v,w,F,c,f,I)}catch(b){C=b}finally{C&&f.errorTransformer&&(C=f.errorTransformer(C)),typeof C!="undefined"&&F.error(C),F.end()}}t.readFileIntoStream=L;async function u(v,w,F,c,f,I){g(I);const C=await v.open(w,{create:!1});try{g(I);let b=0,l=0,r=f&&typeof f.length=="number"?f.length:void 0,o=O.VSBuffer.alloc(Math.min(f.bufferSize,typeof r=="number"?r:f.bufferSize)),e=f&&typeof f.position=="number"?f.position:0,i=0;do l=await v.read(C,e,o.buffer,i,o.byteLength-i),e+=l,i+=l,b+=l,typeof r=="number"&&(r-=l),i===o.byteLength&&(await F.write(c(o)),o=O.VSBuffer.alloc(Math.min(f.bufferSize,typeof r=="number"?r:f.bufferSize)),i=0);while(l>0&&(typeof r!="number"||r>0)&&g(I)&&y(b,f));if(i>0){let n=i;typeof r=="number"&&(n=Math.min(i,r)),F.write(c(o.slice(0,n)))}}catch(b){throw(0,E.ensureFileSystemProviderError)(b)}finally{await v.close(C)}}function g(v){if(v.isCancellationRequested)throw(0,P.canceled)();return!0}function y(v,w){if(w?.limits){if(typeof w.limits.memory=="number"&&v>w.limits.memory)throw(0,E.createFileSystemProviderError)((0,m.localize)(0,null,T.default.nameShort),E.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&v>w.limits.size)throw(0,E.createFileSystemProviderError)((0,m.localize)(1,null),E.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[107],ee([0,1,81,130,2,17,11,20,45,24,14,16,36,4,26,9,54,131]),function(_,t,m,O,E,P,T,L,u,g,y,v,w,F,c,f,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let b=class Ne extends E.Disposable{constructor(r){super();this.logService=r,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new T.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new F.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new P.FileChangesEvent(o,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new F.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new P.FileChangesEvent(o,!0)))),this.watchedResources=u.TernarySearchTree.forUris(o=>{const e=this.getProvider(o.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new F.ResourceQueue)}registerProvider(r,o){if(this.provider.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,O.mark)(`code/registerFilesystem/${r}`),this.provider.set(r,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:r,provider:o});const e=new E.DisposableStore;return e.add(o.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(o)))),e.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:r}))),typeof o.onDidErrorOccur=="function"&&e.add(o.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:r,provider:o}),this.provider.delete(r),(0,E.dispose)(e)})}getProvider(r){return this.provider.get(r)}async activateProvider(r){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:r,join(e){o.push(e)}}),!this.provider.has(r)&&await F.Promises.settled(o)}canHandleResource(r){return this.provider.has(r.scheme)}hasCapability(r,o){const e=this.provider.get(r.scheme);return!!(e&&e.capabilities&o)}listCapabilities(){return C.Iterable.map(this.provider,([r,o])=>({scheme:r,capabilities:o.capabilities}))}async withProvider(r){if(!(0,L.isAbsolutePath)(r))throw new P.FileOperationError((0,m.localize)(0,null,this.resourceForError(r)),8);await this.activateProvider(r.scheme);const o=this.provider.get(r.scheme);if(!o){const e=new Error;throw e.name="ENOPRO",e.message=(0,m.localize)(1,null,r.toString()),e}return o}async withReadProvider(r){const o=await this.withProvider(r);if((0,P.hasOpenReadWriteCloseCapability)(o)||(0,P.hasReadWriteCapability)(o)||(0,P.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(r){const o=await this.withProvider(r);if((0,P.hasOpenReadWriteCloseCapability)(o)||(0,P.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,o){try{return await this.doResolveFile(r,o)}catch(e){throw(0,P.toFileSystemProviderErrorCode)(e)===P.FileSystemProviderErrorCode.FileNotFound?new P.FileOperationError((0,m.localize)(2,null,this.resourceForError(r)),1):(0,P.ensureFileSystemProviderError)(e)}}async doResolveFile(r,o){const e=await this.withProvider(r),i=this.isPathCaseSensitive(e),n=o?.resolveTo,s=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,h=await e.stat(r);let p;return this.toFileStat(e,r,h,void 0,!!a,(M,R)=>(p||(p=u.TernarySearchTree.forUris(()=>!i),p.set(r,!0),(0,g.isNonEmptyArray)(n)&&n.forEach(k=>p.set(k,!0))),Boolean(p.findSuperstr(M.resource)||p.get(M.resource))?!0:M.isDirectory&&s?R===1:!1))}async toFileStat(r,o,e,i,n,s){const{providerExtUri:a}=this.getExtUri(r),h={resource:o,name:a.basename(o),isFile:(e.type&P.FileType.File)!=0,isDirectory:(e.type&P.FileType.Directory)!=0,isSymbolicLink:(e.type&P.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&P.FilePermission.Readonly)||Boolean(r.capabilities&2048),etag:(0,P.etag)({mtime:e.mtime,size:e.size})};if(h.isDirectory&&s(h,i)){try{const p=await r.readdir(o),M=await F.Promises.settled(p.map(async([R,k])=>{try{const z=a.joinPath(o,R),W=n?await r.stat(z):{type:k};return await this.toFileStat(r,z,W,p.length,n,s)}catch(z){return this.logService.trace(z),null}}));h.children=(0,g.coalesce)(M)}catch(p){this.logService.trace(p),h.children=[]}return h}return h}async resolveAll(r){return F.Promises.settled(r.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(r){const o=await this.withProvider(r);try{return!!await o.stat(r)}catch(e){return!1}}async canCreateFile(r,o){try{await this.doValidateCreateFile(r,o)}catch(e){return e}return!0}async doValidateCreateFile(r,o){if(!o?.overwrite&&await this.exists(r))throw new P.FileOperationError((0,m.localize)(3,null,this.resourceForError(r)),3,o)}async createFile(r,o=v.VSBuffer.fromString(""),e){await this.doValidateCreateFile(r,e);const i=await this.writeFile(r,o);return this._onDidRunOperation.fire(new P.FileOperationEvent(r,0,i)),i}async writeFile(r,o,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,r,e)||await this.mkdirp(i,n.dirname(r));let a;if((0,P.hasReadWriteCapability)(i)&&!(o instanceof v.VSBuffer))if((0,w.isReadableStream)(o)){const h=await(0,w.peekStream)(o,3);h.ended?a=v.VSBuffer.concat(h.buffer):a=h}else a=(0,w.peekReadable)(o,h=>v.VSBuffer.concat(h),3);else a=o;!(0,P.hasOpenReadWriteCloseCapability)(i)||(0,P.hasReadWriteCapability)(i)&&a instanceof v.VSBuffer?await this.doWriteUnbuffered(i,r,e,a):await this.doWriteBuffered(i,r,e,a instanceof v.VSBuffer?(0,v.bufferToReadable)(a):a)}catch(s){throw new P.FileOperationError((0,m.localize)(4,null,this.resourceForError(r),(0,P.ensureFileSystemProviderError)(s).toString()),(0,P.toFileOperationResult)(s),e)}return this.resolve(r,{resolveMetadata:!0})}async validateWriteFile(r,o,e){if(!!e?.unlock&&!(r.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(o)));let n;try{n=await r.stat(o)}catch(s){return}if((n.type&P.FileType.Directory)!=0)throw new P.FileOperationError((0,m.localize)(6,null,this.resourceForError(o)),0,e);if(this.throwIfFileIsReadonly(o,n),e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==P.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,P.etag)({mtime:e.mtime,size:n.size}))throw new P.FileOperationError((0,m.localize)(7,null),3,e);return n}async readFile(r,o){const e=await this.withReadProvider(r);return o?.atomic?this.doReadFileAtomic(e,r,o):this.doReadFile(e,r,o)}async doReadFileAtomic(r,o,e){return new Promise((i,n)=>{this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(r,o,e);i(s)}catch(s){n(s)}})})}async doReadFile(r,o,e){const i=await this.doReadFileStream(r,o,{...e,preferUnbuffered:!0});return{...i,value:await(0,v.streamToBuffer)(i.value)}}async readFileStream(r,o){const e=await this.withReadProvider(r);return this.doReadFileStream(e,r,o)}async doReadFileStream(r,o,e){const i=new c.CancellationTokenSource,n=this.validateReadFile(o,e).then(a=>a,a=>{throw i.cancel(),a});let s;try{return e&&typeof e.etag=="string"&&e.etag!==P.ETAG_DISABLED&&await n,!((0,P.hasOpenReadWriteCloseCapability)(r)||(0,P.hasFileReadStreamCapability)(r))||(0,P.hasReadWriteCapability)(r)&&e?.preferUnbuffered?s=this.readFileUnbuffered(r,o,e):(0,P.hasFileReadStreamCapability)(r)?s=this.readFileStreamed(r,o,i.token,e):s=this.readFileBuffered(r,o,i.token,e),{...await n,value:s}}catch(a){s&&await(0,w.consumeStream)(s);const h=(0,m.localize)(8,null,this.resourceForError(o),(0,P.ensureFileSystemProviderError)(a).toString());throw a instanceof P.NotModifiedSinceFileOperationError?new P.NotModifiedSinceFileOperationError(h,a.stat,e):new P.FileOperationError(h,(0,P.toFileOperationResult)(a),e)}}readFileStreamed(r,o,e,i=Object.create(null)){const n=r.readFileStream(o,i,e);return(0,w.transform)(n,{data:s=>s instanceof v.VSBuffer?s:v.VSBuffer.wrap(s),error:s=>new P.FileOperationError((0,m.localize)(9,null,this.resourceForError(o),(0,P.ensureFileSystemProviderError)(s).toString()),(0,P.toFileOperationResult)(s),i)},s=>v.VSBuffer.concat(s))}readFileBuffered(r,o,e,i=Object.create(null)){const n=(0,v.newWriteableBufferStream)();return(0,I.readFileIntoStream)(r,o,n,s=>s,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new P.FileOperationError((0,m.localize)(10,null,this.resourceForError(o),(0,P.ensureFileSystemProviderError)(s).toString()),(0,P.toFileOperationResult)(s),i)},e),n}readFileUnbuffered(r,o,e){const i=(0,w.newWriteableStream)(n=>v.VSBuffer.concat(n));return(async()=>{try{let n=await r.readFile(o);e&&typeof e.position=="number"&&(n=n.slice(e.position)),e&&typeof e.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(o,n.byteLength,e),i.end(v.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(r,o){const e=await this.resolve(r,{resolveMetadata:!0});if(e.isDirectory)throw new P.FileOperationError((0,m.localize)(11,null,this.resourceForError(r)),0,o);if(o&&typeof o.etag=="string"&&o.etag!==P.ETAG_DISABLED&&o.etag===e.etag)throw new P.NotModifiedSinceFileOperationError((0,m.localize)(12,null),e,o);return this.validateReadFileLimits(r,e.size,o),e}validateReadFileLimits(r,o,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&o>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&o>e.limits.size&&(i=7),typeof i=="number")throw new P.FileOperationError((0,m.localize)(13,null,this.resourceForError(r)),i)}}async canMove(r,o,e){return this.doCanMoveCopy(r,o,"move",e)}async canCopy(r,o,e){return this.doCanMoveCopy(r,o,"copy",e)}async doCanMoveCopy(r,o,e,i){if(r.toString()!==o.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r):await this.withReadProvider(r),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(n,r,s,o,e,i)}catch(n){return n}return!0}async move(r,o,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(i,r,n,o,"move",!!e),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(r,s==="move"?2:3,a)),a}async copy(r,o,e){const i=await this.withReadProvider(r),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=await this.doMoveCopy(i,r,n,o,"copy",!!e),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(r,s==="copy"?3:2,a)),a}async doMoveCopy(r,o,e,i,n,s){if(o.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(r,o,e,i,n,s);if(a&&!h&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(r===e&&(0,P.hasFileFolderCopyCapability)(r))await r.copy(o,i,{overwrite:s});else{const p=await this.resolve(o);p.isDirectory?await this.doCopyFolder(r,p,e,i):await this.doCopyFile(r,o,e,i)}return n}else return r===e?(await r.rename(o,i,{overwrite:s}),n):(await this.doMoveCopy(r,o,e,i,"copy",s),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(r,o,e,i){if((0,P.hasOpenReadWriteCloseCapability)(r)&&(0,P.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(r,o,e,i);if((0,P.hasOpenReadWriteCloseCapability)(r)&&(0,P.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(r,o,e,i);if((0,P.hasReadWriteCapability)(r)&&(0,P.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(r,o,e,i);if((0,P.hasReadWriteCapability)(r)&&(0,P.hasReadWriteCapability)(e))return this.doPipeUnbuffered(r,o,e,i)}async doCopyFolder(r,o,e,i){await e.mkdir(i),Array.isArray(o.children)&&await F.Promises.settled(o.children.map(async n=>{const s=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(r,await this.resolve(n.resource),e,s):this.doCopyFile(r,n.resource,e,s)}))}async doValidateMoveCopy(r,o,e,i,n,s){let a=!1;if(r===e){const{providerExtUri:p,isPathCaseSensitive:M}=this.getExtUri(r);if(M||(a=p.isEqual(o,i)),a&&n==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(o),this.resourceForError(i)));if(!a&&p.isEqualOrParent(i,o))throw new Error((0,m.localize)(15,null,this.resourceForError(o),this.resourceForError(i)))}const h=await this.exists(i);if(h&&!a){if(!s)throw new P.FileOperationError((0,m.localize)(16,null,this.resourceForError(o),this.resourceForError(i)),4);if(r===e){const{providerExtUri:p}=this.getExtUri(r);if(p.isEqualOrParent(o,i))throw new Error((0,m.localize)(17,null,this.resourceForError(o),this.resourceForError(i)))}}return{exists:h,isSameResourceWithDifferentPathCase:a}}getExtUri(r){const o=this.isPathCaseSensitive(r);return{providerExtUri:o?L.extUri:L.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(r){return!!(r.capabilities&1024)}async createFolder(r){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);await this.mkdirp(o,r);const e=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(r,0,e)),e}async mkdirp(r,o){const e=[],{providerExtUri:i}=this.getExtUri(r);for(;!i.isEqual(o,i.dirname(o));)try{if(((await r.stat(o)).type&P.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(o)));break}catch(n){if((0,P.toFileSystemProviderErrorCode)(n)!==P.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(o)),o=i.dirname(o)}for(let n=e.length-1;n>=0;n--){o=i.joinPath(o,e[n]);try{await r.mkdir(o)}catch(s){if((0,P.toFileSystemProviderErrorCode)(s)!==P.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(r,o){try{await this.doValidateDelete(r,o)}catch(e){return e}return!0}async doValidateDelete(r,o){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);if(!!o?.useTrash&&!(e.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(r)));let n;try{n=await e.stat(r)}catch(a){}if(n)this.throwIfFileIsReadonly(r,n);else throw new P.FileOperationError((0,m.localize)(20,null,this.resourceForError(r)),1);if(!!!o?.recursive){const a=await this.resolve(r);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(r)))}return e}async del(r,o){const e=await this.doValidateDelete(r,o),i=!!o?.useTrash,n=!!o?.recursive;await e.delete(r,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new P.FileOperationEvent(r,1))}onDidChangeFile(r,o){this._onDidChangeFilesRaw.fire({changes:r});let e,i;{for(const n of r)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new P.FileChangesEvent(e,!o))}if(i){const n=o?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(r,o={recursive:!1,excludes:[]}){const e=new E.DisposableStore;{let i=!1,n=()=>{i=!0};e.add((0,E.toDisposable)(()=>n())),this.doWatch(r,o).then(s=>{i?(0,E.dispose)(s):n=()=>(0,E.dispose)(s)},s=>this.logService.error(s))}return o.recursive||(this.watchedResources.set(r,(this.watchedResources.get(r)??0)+1),e.add((0,E.toDisposable)(()=>{const i=this.watchedResources.get(r);typeof i=="number"&&(i<=1?this.watchedResources.delete(r):this.watchedResources.set(r,i-1))}))),e}async doWatch(r,o){const e=await this.withProvider(r),i=this.toWatchKey(e,r,o),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(r,o)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,E.toDisposable)(()=>{n.count--,n.count===0&&((0,E.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(r,o,e){const{providerExtUri:i}=this.getExtUri(r);return[i.getComparisonKey(o),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(r=>(0,E.dispose)(r.disposable)),this.activeWatchers.clear()}async doWriteBuffered(r,o,e,i){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(async()=>{const n=await r.open(o,{create:!0,unlock:e?.unlock??!1});try{(0,w.isReadableStream)(i)||(0,w.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(r,n,i):await this.doWriteReadableBufferedQueued(r,n,i)}catch(s){throw(0,P.ensureFileSystemProviderError)(s)}finally{await r.close(n)}})}async doWriteStreamBufferedQueued(r,o,e){let i=0,n;if((0,w.isReadableBufferedStream)(e)){if(e.buffer.length>0){const s=v.VSBuffer.concat(e.buffer);await this.doWriteBuffer(r,o,s,s.byteLength,i,0),i+=s.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(s,a)=>{(0,w.listenStream)(n,{onData:async h=>{n.pause();try{await this.doWriteBuffer(r,o,h,h.byteLength,i,0)}catch(p){return a(p)}i+=h.byteLength,setTimeout(()=>n.resume())},onError:h=>a(h),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(r,o,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(r,o,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(r,o,e,i,n,s){let a=0;for(;a<i;)a+=await r.write(o,n+a,e.buffer,s+a,i-a)}async doWriteUnbuffered(r,o,e,i){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(r,o,e,i))}async doWriteUnbufferedQueued(r,o,e,i){let n;i instanceof v.VSBuffer?n=i:(0,w.isReadableStream)(i)?n=await(0,v.streamToBuffer)(i):(0,w.isReadableBufferedStream)(i)?n=await(0,v.bufferedStreamToBuffer)(i):n=(0,v.readableToBuffer)(i),await r.writeFile(o,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(r,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(r,o,e,i))}async doPipeBufferedQueued(r,o,e,i){let n,s;try{n=await r.open(o,{create:!1}),s=await e.open(i,{create:!0,unlock:!1});const a=v.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,p=0,M=0;do M=await r.read(n,h,a.buffer,p,a.byteLength-p),await this.doWriteBuffer(e,s,a,M,h,p),h+=M,p+=M,p===a.byteLength&&(p=0);while(M>0)}catch(a){throw(0,P.ensureFileSystemProviderError)(a)}finally{await F.Promises.settled([typeof n=="number"?r.close(n):Promise.resolve(),typeof s=="number"?e.close(s):Promise.resolve()])}}async doPipeUnbuffered(r,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(r,o,e,i))}async doPipeUnbufferedQueued(r,o,e,i){return e.writeFile(i,await r.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(r,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(r,o,e,i))}async doPipeUnbufferedToBufferedQueued(r,o,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const s=await r.readFile(o);await this.doWriteBuffer(e,n,v.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,P.ensureFileSystemProviderError)(s)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(r,o,e,i){const n=await(0,v.streamToBuffer)(this.readFileBuffered(r,o,c.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(r,o){if(r.capabilities&2048)throw new P.FileOperationError((0,m.localize)(22,null,this.resourceForError(o)),6);return r}throwIfFileIsReadonly(r,o){if((o.permissions??0)&P.FilePermission.Readonly)throw new P.FileOperationError((0,m.localize)(23,null,this.resourceForError(r)),6)}resourceForError(r){return r.scheme===f.Schemas.file?r.fsPath:r.toString(!0)}};b.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},b=ce([ue(0,y.ILogService)],b),t.FileService=b}),define(Y[108],ee([0,1,2,17,11,15,10,3,20,37,4,14,83,51,92,94,91,100,36,54,24,16]),function(_,t,m,O,E,P,T,L,u,g,y,v,w,F,c,f,I,C,b,l,r,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends m.Disposable{constructor(n,s){super();this.logService=n,this.options=s,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=E.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new E.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new E.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new y.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,P.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:a}=await T.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,a),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(n){try{const s=await T.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),a=[];return await Promise.all(s.map(async h=>{try{let p;h.isSymbolicLink()?p=(await this.stat((0,u.joinPath)(n,h.name))).type:p=this.toType(h),a.push([h.name,p])}catch(p){this.logService.trace(p)}})),a}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let a;return s?.dangling?a=O.FileType.Unknown:n.isFile()?a=O.FileType.File:n.isDirectory()?a=O.FileType.Directory:a=O.FileType.Unknown,s&&(a|=O.FileType.SymbolicLink),a}async readFile(n){try{const s=this.toFilePath(n);return await T.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(n,s,a){const h=(0,b.newWriteableStream)(p=>o.VSBuffer.concat(p.map(M=>o.VSBuffer.wrap(M))).buffer);return(0,l.readFileIntoStream)(this,n,h,p=>p.buffer,{...s,bufferSize:this.BUFFER_SIZE},a),h}async writeFile(n,s,a){let h;try{const p=this.toFilePath(n);if(!a.create||!a.overwrite){if(await T.Promises.exists(p)){if(!a.overwrite)throw(0,O.createFileSystemProviderError)((0,w.localize)(0,null),O.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,O.createFileSystemProviderError)((0,w.localize)(1,null),O.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(n,{create:!0,unlock:a.unlock}),await this.write(h,0,s,0,s.byteLength)}catch(p){throw await this.toFileSystemProviderWriteError(n,p)}finally{typeof h=="number"&&await this.close(h)}}async open(n,s){try{const a=this.toFilePath(n);if((0,O.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:M}=await T.SymlinkSupport.stat(a);M.mode&128||await T.Promises.chmod(a,M.mode|128)}catch(M){this.logService.trace(M)}let h;if((0,O.isFileOpenForWriteOptions)(s)){if(P.isWindows)try{await T.Promises.truncate(a,0),h="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}h||(h="w")}else h="r";const p=await T.Promises.open(a,h);return this.mapHandleToPos.set(p,0),(0,O.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(p,n),p}catch(a){throw(0,O.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(n,a):this.toFileSystemProviderError(a)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await T.Promises.fdatasync(n)}catch(s){this.canFlush=!1,this.logService.error(s)}return await T.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}}async read(n,s,a,h,p){const M=this.normalizePos(n,s);let R=null;try{const k=await T.Promises.read(n,a,h,p,M);return typeof k=="number"?R=k:R=k.bytesRead,R}catch(k){throw this.toFileSystemProviderError(k)}finally{this.updatePos(n,M,R)}}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,a){const h=this.mapHandleToPos.get(n);typeof h=="number"&&(typeof s=="number"||(typeof a=="number"?this.mapHandleToPos.set(n,h+a):this.mapHandleToPos.delete(n)))}async write(n,s,a,h,p){return(0,y.retry)(()=>this.doWrite(n,s,a,h,p),100,3)}async doWrite(n,s,a,h,p){const M=this.normalizePos(n,s);let R=null;try{const k=await T.Promises.write(n,a,h,p,M);return typeof k=="number"?R=k:R=k.bytesWritten,R}catch(k){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),k)}finally{this.updatePos(n,M,R)}}async mkdir(n){try{await T.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const a=this.toFilePath(n);await this.doDelete(a,s)}catch(a){throw this.toFileSystemProviderError(a)}}async doDelete(n,s){s.recursive?await T.Promises.rm(n,T.RimRafMode.MOVE):await T.Promises.unlink(n)}async rename(n,s,a){const h=this.toFilePath(n),p=this.toFilePath(s);if(h!==p)try{await this.validateTargetDeleted(n,s,"move",a.overwrite),await T.Promises.move(h,p)}catch(M){throw(M.code==="EINVAL"||M.code==="EBUSY"||M.code==="ENAMETOOLONG")&&(M=new Error((0,w.localize)(2,null,(0,L.basename)(h),(0,L.basename)((0,L.dirname)(p)),M.toString()))),this.toFileSystemProviderError(M)}}async copy(n,s,a){const h=this.toFilePath(n),p=this.toFilePath(s);if(h!==p)try{await this.validateTargetDeleted(n,s,"copy",a.overwrite),await T.Promises.copy(h,p,{preserveSymlinks:!0})}catch(M){throw(M.code==="EINVAL"||M.code==="EBUSY"||M.code==="ENAMETOOLONG")&&(M=new Error((0,w.localize)(3,null,(0,L.basename)(h),(0,L.basename)((0,L.dirname)(p)),M.toString()))),this.toFileSystemProviderError(M)}}async validateTargetDeleted(n,s,a,h){const p=this.toFilePath(n),M=this.toFilePath(s);let R=!1;if(!!(this.capabilities&1024)||(R=(0,g.isEqual)(p,M,!0)),R&&a==="copy")throw(0,O.createFileSystemProviderError)((0,w.localize)(4,null),O.FileSystemProviderErrorCode.FileExists);if(!R&&await T.Promises.exists(M)){if(!h)throw(0,O.createFileSystemProviderError)((0,w.localize)(5,null),O.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(n,s){return s.recursive?this.watchRecursive(n,s.excludes):this.watchNonRecursive(n)}watchRecursive(n,s){const a={path:this.toFilePath(n),excludes:s},h=(0,r.insert)(this.recursiveFoldersToWatch,a);return this.refreshRecursiveWatchers(),(0,m.toDisposable)(()=>{h(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof I.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,m.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,s;this.options?.watcher?.usePolling?(n=c.FileWatcher,s=this.options?.watcher):this.recursiveFoldersToWatch.length===1?P.isWindows?n=f.FileWatcher:n=c.FileWatcher:n=I.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,a=>this._onDidChangeFile.fire((0,F.toFileChanges)(a)),a=>{a.type==="error"&&this._onDidWatchErrorOccur.fire(a.message),this.logService[a.type](a.message)},this.logService.getLevel()===v.LogLevel.Trace,s),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))}}watchNonRecursive(n){const s=new C.FileWatcher(this.toFilePath(n),h=>this._onDidChangeFile.fire((0,F.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===v.LogLevel.Trace),a=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)});return(0,m.combinedDisposable)(s,a)}toFilePath(n){return(0,L.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof O.FileSystemProviderError)return n;let s;switch(n.code){case"ENOENT":s=O.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=O.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=O.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=O.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=O.FileSystemProviderErrorCode.NoPermissions;break;default:s=O.FileSystemProviderErrorCode.Unknown}return(0,O.createFileSystemProviderError)(n,s)}async toFileSystemProviderWriteError(n,s){let a=this.toFileSystemProviderError(s);if(n&&a.code===O.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await T.SymlinkSupport.stat(this.toFilePath(n));h.mode&128||(a=(0,O.createFileSystemProviderError)(s,O.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.logService.trace(h)}return a}dispose(){super.dispose(),(0,m.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,m.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(Y[42],ee([0,1,12]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,m.createDecorator)("productService")}),define(Y[25],ee([0,1,13,57]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class E{constructor(){this.data=new Map}add(T,L){O.ok(m.isString(T)),O.ok(m.isObject(L)),O.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,L)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}t.Registry=new E}),define(Y[109],ee([0,1,25,11]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function E(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class P{constructor(){this._onDidChangeSchema=new O.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,g){this.schemasById[E(u)]=g,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new P;m.Registry.add(t.Extensions.JSONContribution,T)}),define(Y[30],ee([0,1,73,11,25,13,109]),function(_,t,m,O,E,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var L;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(L=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var u;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(u=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const g=E.Registry.as(T.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},g.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,l=!0){this.registerConfigurations([b],l)}registerConfigurations(b,l=!0){const r=[];b.forEach(o=>{r.push(...this.validateAndRegisterProperties(o,l,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),g.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterConfigurations(b){const l=[],r=o=>{if(o.properties)for(const e in o.properties)l.push(e),delete this.configurationProperties[e],this.removeFromSchema(e,o.properties[e]);o.allOf&&o.allOf.forEach(e=>r(e))};for(const o of b){r(o);const e=this.configurationContributors.indexOf(o);e!==-1&&this.configurationContributors.splice(e,1)}g.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}registerDefaultConfigurations(b){const l=[],r=[];for(const o of b)for(const e in o)if(l.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]={...this.defaultValues[e]||{},...o[e]};const i={type:"object",default:this.defaultValues[e],description:m.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};r.push(w(e)),this.configurationProperties[e]=i,this.defaultLanguageConfigurationOverridesNode.properties[e]=i}else{this.defaultValues[e]=o[e];const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(b){const l=[];for(const r of b)for(const o in r)if(l.push(o),delete this.defaultValues[o],t.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const e=this.configurationProperties[o];e&&(this.updatePropertyDefaultValue(o,e),this.updateSchema(o,e))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const l of b)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,l=!0,r,o=3){o=P.isUndefinedOrNull(b.scope)?o:b.scope;let e=[],i=b.properties;if(i)for(let s in i){if(l&&f(s)){delete i[s];continue}const a=i[s];if(this.updatePropertyDefaultValue(s,a),t.OVERRIDE_PROPERTY_PATTERN.test(s)?a.scope=void 0:(a.scope=P.isUndefinedOrNull(a.scope)?o:a.scope,a.restricted=P.isUndefinedOrNull(a.restricted)?!!r?.restrictedConfigurations?.includes(s):a.restricted),i[s].hasOwnProperty("included")&&!i[s].included){this.excludedConfigurationProperties[s]=i[s],delete i[s];continue}else this.configurationProperties[s]=i[s];!i[s].deprecationMessage&&i[s].markdownDeprecationMessage&&(i[s].deprecationMessage=i[s].markdownDeprecationMessage),e.push(s)}let n=b.allOf;if(n)for(let s of n)e.push(...this.validateAndRegisterProperties(s,l,r,o));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const l=r=>{let o=r.properties;if(o)for(const i in o)this.updateSchema(i,o[i]);let e=r.allOf;e&&e.forEach(l)};l(b)}updateSchema(b,l){switch(t.allSettings.properties[b]=l,l.scope){case 1:t.applicationSettings.properties[b]=l;break;case 2:t.machineSettings.properties[b]=l;break;case 6:t.machineOverridableSettings.properties[b]=l;break;case 3:t.windowSettings.properties[b]=l;break;case 4:t.resourceSettings.properties[b]=l;break;case 5:t.resourceSettings.properties[b]=l,this.resourceLanguageSettingsSchema.properties[b]=l;break}}removeFromSchema(b,l){switch(delete t.allSettings.properties[b],l.scope){case 1:delete t.applicationSettings.properties[b];break;case 2:delete t.machineSettings.properties[b];break;case 6:delete t.machineOverridableSettings.properties[b];break;case 3:delete t.windowSettings.properties[b];break;case 4:case 5:delete t.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const l=`[${b}]`,r={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,r),t.allSettings.properties[l]=r,t.applicationSettings.properties[l]=r,t.machineSettings.properties[l]=r,t.machineOverridableSettings.properties[l]=r,t.windowSettings.properties[l]=r,t.resourceSettings.properties[l]=r}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,l){let r=this.defaultValues[b];P.isUndefined(r)&&(r=l.default),P.isUndefined(r)&&(r=F(l.type)),l.default=r}}const v="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(v);function w(C){return C.substring(1,C.length-1)}t.overrideIdentifierFromKey=w;function F(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=F;const c=new y;E.Registry.add(t.Extensions.Configuration,c);function f(C){return C.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(C)?m.localize(5,null,C):c.getConfigurationProperties()[C]!==void 0?m.localize(6,null,C):null:m.localize(4,null)}t.validateProperty=f;function I(){const C=[],b=c.getConfigurationProperties();for(const l of Object.keys(b))C.push([l,b[l].scope]);return C.push(["launch",4]),C.push(["task",4]),C}t.getScopes=I}),define(Y[27],ee([0,1,19,13,7,25,12,30]),function(_,t,m,O,E,P,T,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,T.createDecorator)("configurationService");function u(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof E.URI)}t.isConfigurationOverrides=u;var g;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(g=t.ConfigurationTarget||(t.ConfigurationTarget={}));function y(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=y;function v(i,n){const s=n?i?n.keys.filter(z=>i.keys.indexOf(z)===-1):[...n.keys]:[],a=i?n?i.keys.filter(z=>n.keys.indexOf(z)===-1):[...i.keys]:[],h=[];if(n&&i){for(const z of i.keys)if(n.keys.indexOf(z)!==-1){const W=C(i.contents,z),Q=C(n.contents,z);m.equals(W,Q)||h.push(z)}}const p=[],M=z=>{const W={};for(const Q of z)for(const ie of Q.identifiers)W[o(ie)]=Q;return W},R=n?M(n.overrides):{},k=i?M(i.overrides):{};if(Object.keys(R).length)for(const z of s){const W=R[z];W&&p.push([(0,L.overrideIdentifierFromKey)(z),W.keys])}if(Object.keys(k).length)for(const z of a){const W=k[z];W&&p.push([(0,L.overrideIdentifierFromKey)(z),W.keys])}if(Object.keys(R).length&&Object.keys(k).length)for(const z of h){const W=k[z],Q=R[z];if(W&&Q){const ie=v({contents:W.contents,keys:W.keys,overrides:[]},{contents:Q.contents,keys:Q.keys,overrides:[]});p.push([(0,L.overrideIdentifierFromKey)(z),[...ie.added,...ie.removed,...ie.updated]])}}return{added:s,removed:a,updated:h,overrides:p}}t.compare=v;function w(i,n){const s=[];for(const a of Object.keys(i))if(L.OVERRIDE_PROPERTY_PATTERN.test(a)){const h={};for(const p in i[a])h[p]=i[a][p];s.push({identifiers:[(0,L.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(h),contents:F(h,n)})}return s}t.toOverrides=w;function F(i,n){const s=Object.create(null);for(let a in i)c(s,a,i[a],n);return s}t.toValuesTree=F;function c(i,n,s,a){const h=n.split("."),p=h.pop();let M=i;for(let R=0;R<h.length;R++){let k=h[R],z=M[k];switch(typeof z){case"undefined":z=M[k]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${h.slice(0,R+1).join(".")} is ${JSON.stringify(z)}`);return}M=z}if(typeof M=="object"&&M!==null)try{M[p]=s}catch(R){a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(M)}`)}else a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(M)}`)}t.addToValueTree=c;function f(i,n){const s=n.split(".");I(i,s)}t.removeFromValueTree=f;function I(i,n){const s=n.shift();if(n.length===0){delete i[s];return}if(Object.keys(i).indexOf(s)!==-1){const a=i[s];typeof a=="object"&&!Array.isArray(a)&&(I(a,n),Object.keys(a).length===0&&delete i[s])}}function C(i,n,s){function a(M,R){let k=M;for(const z of R){if(typeof k!="object"||k===null)return;k=k[z]}return k}const h=n.split("."),p=a(i,h);return typeof p=="undefined"?s:p}t.getConfigurationValue=C;function b(i,n,s){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?O.isObject(i[a])&&O.isObject(n[a])?b(i[a],n[a],s):s&&(i[a]=n[a]):i[a]=n[a])})}t.merge=b;function l(){const i=P.Registry.as(L.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=l;function r(){const i=Object.create(null),n=P.Registry.as(L.Extensions.Configuration).getConfigurationProperties();for(let s in n){let a=n[s].default;c(i,s,a,h=>console.error(`Conflict in default settings: ${h}`))}return i}t.getDefaultValues=r;function o(i){return`[${i}]`}t.keyFromOverrideIdentifier=o;function e(i,n,s){const a=i.inspect(n),h=i.inspect(s);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:a.defaultValue}t.getMigratedSettingValue=e}),define(Y[110],ee([0,1,58,45,24,13,19,7,30,27,25,2,11]),function(_,t,m,O,E,P,T,L,u,g,y,v,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class F{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,g.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,g.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const s of E.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[s],h=i[s];h&&(typeof a=="object"&&typeof h=="object"?(a=T.deepClone(a),this.mergeContents(a,h)):a=h),n[s]=a}return new F(n,this.keys,this.overrides)}merge(...e){const i=T.deepClone(this.contents),n=T.deepClone(this.overrides),s=[...this.keys];for(const a of e){this.mergeContents(i,a.contents);for(const h of a.overrides){const[p]=n.filter(M=>E.equals(M.identifiers,h.identifiers));p?this.mergeContents(p.contents,h.contents):n.push(T.deepClone(h))}for(const h of a.keys)s.indexOf(h)===-1&&s.push(h)}return new F(i,s,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&P.isObject(e[n])&&P.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=T.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?T.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,g.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,g.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=F;class c extends F{constructor(){const e=(0,g.getDefaultValues)(),i=(0,g.getConfigurationKeys)(),n=[];for(const s of Object.keys(e))u.OVERRIDE_PROPERTY_PATTERN.test(s)&&n.push({identifiers:[(0,u.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(e[s]),contents:(0,g.toValuesTree)(e[s],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,i,n)}}t.DefaultConfigurationModel=c;class f{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new F}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!P.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:s,overrides:a,restricted:h}=this.doParseRaw(e,i);this._configurationModel=new F(n,s,a),this._restrictedConfigurations=h||[]}doParseContent(e){let i={},n=null,s=[],a=[],h=[];function p(R){Array.isArray(s)?s.push(R):n&&(s[n]=R)}let M={onObjectBegin:()=>{let R={};p(R),a.push(s),s=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{let R=[];p(R),a.push(s),s=R,n=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:p,onError:(R,k,z)=>{h.push({error:R,offset:k,length:z})}};if(e)try{m.visit(e,M),i=s[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return i}doParseRaw(e,i){const n=y.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),s=this.filter(e,n,!0,i);e=s.raw;const a=(0,g.toValuesTree)(e,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),h=Object.keys(e),p=(0,g.toOverrides)(e,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:a,keys:h,overrides:p,restricted:s.restricted}}filter(e,i,n,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:e,restricted:[]};const a={},h=[];for(let p in e)if(u.OVERRIDE_PROPERTY_PATTERN.test(p)&&n){const M=this.filter(e[p],i,!1,s);a[p]=M.raw,h.push(...M.restricted)}else{const M=i[p],R=M?typeof M.scope!="undefined"?M.scope:3:void 0;M?.restricted&&h.push(p),(R===void 0||s.scopes===void 0||s.scopes.includes(R))&&(s.skipRestricted&&M?.restricted||(a[p]=e[p]))}return{raw:a,restricted:h}}}t.ConfigurationModelParser=f;class I extends v.Disposable{constructor(e,i,n,s){super();this.userSettingsResource=e,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(w.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new F}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=I;class C{constructor(e,i,n=new F,s=new F,a=new O.ResourceMap,h=new F,p=new O.ResourceMap,M=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=a,this._memoryConfiguration=h,this._memoryConfigurationByResource=p,this._freeze=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new O.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new F,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(e):s.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const s=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),h=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,p=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),M=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),R=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),k=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),z=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,W=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,Q=i.overrideIdentifier?h.override(i.overrideIdentifier).getValue(e):h.getValue(e),ie=s.getValue(e),re=E.distinct(E.flatten(s.overrides.map(Z=>Z.identifiers))).filter(Z=>s.getOverrideValue(e,Z)!==void 0);return{defaultValue:p,userValue:M,userLocalValue:R,userRemoteValue:k,workspaceValue:z,workspaceFolderValue:W,memoryValue:Q,value:ie,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:M!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:k!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:z!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:W!==void 0?{value:a?.freeze().getValue(e),override:i.overrideIdentifier?a?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:Q!==void 0?{value:h.getValue(e),override:i.overrideIdentifier?h.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:re.length?re:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(s=>u.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const a=(0,u.overrideIdentifierFromKey)(s),h=this._defaultConfiguration.getKeysForOverrideIdentifier(a),p=e.getKeysForOverrideIdentifier(a),M=[...p.filter(R=>h.indexOf(R)===-1),...h.filter(R=>p.indexOf(R)===-1),...h.filter(R=>!T.equals(this._defaultConfiguration.override(a).getValue(R),e.override(a).getValue(R)))];return[a,M]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:a}=(0,g.compare)(this.localUserConfiguration,e),h=[...i,...n,...s];return h.length&&this.updateLocalUserConfiguration(e),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:s,overrides:a}=(0,g.compare)(this.remoteUserConfiguration,e);let h=[...i,...n,...s];return h.length&&this.updateRemoteUserConfiguration(e),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:s,overrides:a}=(0,g.compare)(this.workspaceConfiguration,e);let h=[...i,...n,...s];return h.length&&this.updateWorkspaceConfiguration(e),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:s,updated:a,removed:h,overrides:p}=(0,g.compare)(n,i);let M=[...s,...a,...h];return(M.length||!n)&&this.updateFolderConfiguration(e,i),{keys:M,overrides:p}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:s,removed:a,overrides:h}=(0,g.compare)(i,void 0);return{keys:[...n,...s,...a],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const s=i.getFolder(e);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const a=this._memoryConfigurationByResource.get(e);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(e);s?(i=n.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:s,keys:a}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:s,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),s=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((h,p)=>(h.set(L.URI.revive(p[0]),this.parseConfigurationModel(p[1])),h),new O.ResourceMap);return new C(i,n,new F,s,a,new F,new O.ResourceMap,!1)}static parseConfigurationModel(e){return new F(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=C;function b(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const e=new Set,i=new Map;for(const s of o)s.keys.forEach(a=>e.add(a)),s.overrides.forEach(([a,h])=>{const p=(0,O.getOrSet)(i,a,new Set);h.forEach(M=>p.add(M))});const n=[];return i.forEach((s,a)=>n.push([a,[...s.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=b;class l{constructor(e,i,n,s){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=s,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(p=>a.add(p)),e.overrides.forEach(([,p])=>p.forEach(M=>a.add(M))),this.affectedKeys=[...a.values()];const h=new F;this.affectedKeys.forEach(p=>h.setValue(p,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!T.equals(n,s)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,g.toValuesTree)({[i]:!0},()=>{}),s;for(;typeof n=="object"&&(s=Object.keys(n)[0]);){if(e=e[s],!e)return!1;n=n[s]}return!0}}t.ConfigurationChangeEvent=l;class r extends l{constructor(e,i,n,s){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=s}}t.AllKeysConfigurationChangeEvent=r}),define(Y[111],ee([0,1,25,30,2,27,110,11,4,20]),function(_,t,m,O,E,P,T,L,u,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class y extends E.Disposable{constructor(w,F){super();this.settingsResource=w,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,g.extUriBiasedIgnorePathCase,F)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new u.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(O.Extensions.Configuration).onDidUpdateConfiguration(c=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const w=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,w)}getConfigurationData(){return this.configuration.toData()}getValue(w,F){const c=typeof w=="string"?w:void 0,f=(0,P.isConfigurationOverrides)(w)?w:(0,P.isConfigurationOverrides)(F)?F:{};return this.configuration.getValue(c,f,void 0)}updateValue(w,F,c,f){return Promise.reject(new Error("not supported"))}inspect(w){return this.configuration.inspect(w,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const w=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(w)}onDidChangeUserConfiguration(w){const F=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(w);this.trigger(c,F,1)}onDidDefaultConfigurationChange(w){const F=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,w);this.trigger(c,F,6)}trigger(w,F,c){const f=new T.ConfigurationChangeEvent(w,{data:F},this.configuration);f.source=c,f.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(f)}getTargetConfiguration(w){switch(w){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=y}),define(Y[55],ee([0,1,84,12,30,25,16]),function(_,t,m,O,E,P,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,O.createDecorator)("requestService");function L(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}t.isSuccess=L;function u(c){return c.res.statusCode===204}async function g(c){if(!L(c))throw new Error("Server returned "+c.res.statusCode);return u(c)?null:(await(0,T.streamToBuffer)(c.stream)).toString()}t.asText=g;async function y(c){if(!L(c))throw new Error("Server returned "+c.res.statusCode);if(u(c))return null;const I=(await(0,T.streamToBuffer)(c.stream)).toString();try{return JSON.parse(I)}catch(C){throw C.message+=`:
`+I,C}}t.asJson=y;function v(c){F(c)}t.updateProxyConfigurationsScope=v;let w;function F(c){const f=P.Registry.as(E.Extensions.Configuration);w&&f.deregisterConfigurations([w]),w={id:"http",order:15,title:(0,m.localize)(0,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,m.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,m.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,m.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,m.localize)(4,null),(0,m.localize)(5,null),(0,m.localize)(6,null),(0,m.localize)(7,null)],default:"override",description:(0,m.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,m.localize)(9,null),restricted:!0}}},f.registerConfiguration(w)}F(2)}),define(Y[112],ee([0,1,113,13]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function E(T,L){return T.protocol==="http:"?L.HTTP_PROXY||L.http_proxy||null:T.protocol==="https:"&&(L.HTTPS_PROXY||L.https_proxy||L.HTTP_PROXY||L.http_proxy)||null}async function P(T,L,u={}){const g=(0,m.parse)(T),y=u.proxyUrl||E(g,L);if(!y)return null;const v=(0,m.parse)(y);if(!/^https?:$/.test(v.protocol||""))return null;const w={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,O.isBoolean)(u.strictSSL)?u.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((F,c)=>{_(["http-proxy-agent"],F,c)}))(w):new(await new Promise((F,c)=>{_(["https-proxy-agent"],F,c)}))(w)}t.getProxyAgent=P}),define(Y[114],ee([0,1,29,16]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function E(P,T,L){let u=L&&L.get("storage.serviceMachineId",0)||null;if(u)return u;try{const y=(await T.readFile(P.serviceMachineIdResource)).value.toString();u=(0,m.isUUID)(y)?y:null}catch(g){u=null}if(!u){u=(0,m.generateUuid)();try{await T.writeFile(P.serviceMachineIdResource,O.VSBuffer.fromString(u))}catch(g){}}return L&&L.store("storage.serviceMachineId",u,0,1),u}t.getServiceMachineId=E}),define(Y[115],ee([0,1,12,11,2,13,66,4]),function(_,t,m,O,E,P,T,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const u="__$__targetStorageMarker";t.IStorageService=(0,m.createDecorator)("storageService");var g;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(g=t.WillSaveStateReason||(t.WillSaveStateReason={}));var y;(function(f){f[f.GLOBAL=0]="GLOBAL",f[f.WORKSPACE=1]="WORKSPACE"})(y=t.StorageScope||(t.StorageScope={}));var v;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(v=t.StorageTarget||(t.StorageTarget={}));class w extends E.Disposable{constructor(I={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=I,this._onDidChangeValue=this._register(new O.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new O.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new O.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new E.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,E.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,C){C===u?(I===0?this._globalKeyTargets=void 0:I===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:I})):this._onDidChangeValue.fire({scope:I,key:C,target:this.getKeyTargets(I)[C]})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,C,b){return this.getStorage(C)?.get(I,b)}getBoolean(I,C,b){return this.getStorage(C)?.getBoolean(I,b)}getNumber(I,C,b){return this.getStorage(C)?.getNumber(I,b)}store(I,C,b,l){if((0,P.isUndefinedOrNull)(C)){this.remove(I,b);return}this.withPausedEmitters(()=>{this.updateKeyTarget(I,b,l),this.getStorage(b)?.set(I,C)})}remove(I,C){this.withPausedEmitters(()=>{this.updateKeyTarget(I,C,void 0),this.getStorage(C)?.delete(I)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,C){const b=[],l=this.getKeyTargets(I);for(const r of Object.keys(l))l[r]===C&&b.push(r);return b}updateKeyTarget(I,C,b){const l=this.getKeyTargets(C);typeof b=="number"?l[I]!==b&&(l[I]=b,this.getStorage(C)?.set(u,JSON.stringify(l))):typeof l[I]=="number"&&(delete l[I],this.getStorage(C)?.set(u,JSON.stringify(l)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(I){return I===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(I){const C=this.get(u,I);if(C)try{return JSON.parse(C)}catch(b){}return Object.create(null)}isNew(I){return this.getBoolean(t.IS_NEW_KEY,I)===!0}async flush(){this._onWillSaveState.fire({reason:g.NONE}),await L.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const I=this.getStorage(0)?.items??new Map,C=this.getStorage(1)?.items??new Map;return c(I,C,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class F extends w{constructor(){super();this.globalStorage=this._register(new T.Storage(new T.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new T.Storage(new T.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(1,I))),this._register(this.globalStorage.onDidChangeStorage(I=>this.emitDidChangeValue(0,I)))}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(I){}}t.InMemoryStorageService=F;async function c(f,I,C,b){const l=a=>{try{return JSON.parse(a)}catch(h){return a}},r=new Map,o=new Map;f.forEach((a,h)=>{r.set(h,a),o.set(h,l(a))});const e=new Map,i=new Map;I.forEach((a,h)=>{e.set(h,a),i.set(h,l(a))}),console.group(`Storage: Global (path: ${C})`);let n=[];r.forEach((a,h)=>{n.push({key:h,value:a})}),console.table(n),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${b})`);let s=[];e.forEach((a,h)=>{s.push({key:h,value:a})}),console.table(s),console.groupEnd(),console.log(i)}t.logStorage=c}),define(Y[116],ee([0,1,15,33,29,7]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function T(g){if(m.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function L(g,y,v,w,F,c,f,I,C,b){const l=Object.create(null);l["common.machineId"]=f,l.sessionID=(0,E.generateUuid)()+Date.now(),l.commitHash=F,l.version=c,l["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,m.PlatformToString)(m.platform),l["common.nodePlatform"]=O.platform,l["common.nodeArch"]=w,l["common.product"]=b||"desktop";const r=u(I||[]);r&&(l["common.msftInternal"]=r);let o=0;const e=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),m.isLinuxSnap&&(l["common.snap"]="true");const i=T(v);i&&(l["common.platformDetail"]=i);try{const n=await g.readFile(P.URI.file(C));l["common.source"]=n.value.toString().slice(0,30)}catch(n){}return l}t.resolveCommonProperties=L;function u(g){const y=O.env.USERDNSDOMAIN;if(!y)return!1;const v=y.toLowerCase();return g.some(w=>v===w)}t.verifyMicrosoftInternalDomain=u}),define(Y[35],ee([0,1,12]),function(_,t,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,m.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,m.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Y[117],ee([0,1,74,2,22,23,11,34,14,35,26,8,7,4]),function(_,t,m,O,E,P,T,L,u,g,y,v,w,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let c=class extends O.Disposable{constructor(l,r,o){super();this.galleryService=l,this.telemetryService=r,this.logService=o,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register((0,O.toDisposable)(()=>{this.installingExtensions.forEach(e=>e.cancel()),this.uninstallingExtensions.forEach(e=>e.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(l,r={}){if(!this.galleryService.isEnabled())throw new Error(m.localize(0,null));try{l=await this.checkAndGetCompatibleVersion(l)}catch(e){throw this.logService.error((0,v.getErrorMessage)(e)),I(this.telemetryService,"extensionGallery:install",(0,P.getGalleryExtensionTelemetryData)(l),void 0,e),e}if(!await this.canInstall(l)){const e=new E.ExtensionManagementError("Not supported",t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",l.identifier.id,e.message),I(this.telemetryService,"extensionGallery:install",(0,P.getGalleryExtensionTelemetryData)(l),void 0,e),e}const o=await this.galleryService.getManifest(l,y.CancellationToken.None);if(o===null){const e=new E.ExtensionManagementError(`Missing manifest for extension ${l.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",l.identifier.id,e.message),I(this.telemetryService,"extensionGallery:install",(0,P.getGalleryExtensionTelemetryData)(l),void 0,e),e}return this.installExtension(o,l,r)}async uninstall(l,r={}){return this.logService.trace("ExtensionManagementService#uninstall",l.identifier.id),this.unininstallExtension(l,r)}async reinstallFromGallery(l){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",l.identifier.id),!this.galleryService.isEnabled())throw new Error(m.localize(1,null));const r=await this.findGalleryExtension(l);if(!r)throw new Error(m.localize(2,null));await this.createUninstallExtensionTask(l,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(r)}getExtensionsReport(){const l=new Date().getTime();return(!this.reportedExtensions||l-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=l),this.reportedExtensions}async installExtension(l,r,o){if(!w.URI.isUri(r)){let a=this.installingExtensions.get(new P.ExtensionIdentifierWithVersion(r.identifier,r.version).key());if(a)return this.logService.info("Extensions is already requested to install",r.identifier.id),a.waitUntilTaskIsFinished();o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const e=[],i=[],n=this.createInstallExtensionTask(l,r,o);w.URI.isUri(r)||this.installingExtensions.set(new P.ExtensionIdentifierWithVersion(n.identifier,l.version).key(),n),this._onInstallExtension.fire({identifier:n.identifier,source:r}),this.logService.info("Installing extension:",n.identifier.id),e.push({task:n,manifest:l});let s=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",n.identifier.id);else try{const h=await this.getAllDepsAndPackExtensionsToInstall(n.identifier,l,!!o.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:p,manifest:M}of h)if(s=s||!!M.extensionDependencies?.some(R=>(0,P.areSameExtensions)({id:R},n.identifier)),this.installingExtensions.has(new P.ExtensionIdentifierWithVersion(p.identifier,p.version).key()))this.logService.info("Extension is already requested to install",p.identifier.id);else{const R=this.createInstallExtensionTask(M,p,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new P.ExtensionIdentifierWithVersion(R.identifier,M.version).key(),R),this._onInstallExtension.fire({identifier:R.identifier,source:p}),this.logService.info("Installing extension:",R.identifier.id),e.push({task:R,manifest:M})}}catch(h){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",n.identifier.id),this.logService.error(h),h}const a=e.reduce((h,{task:p,manifest:M})=>(h.set(p.identifier.id.toLowerCase(),{task:p,manifest:M}),h),new Map);for(;a.size;){let h;const p=[...a.values()].filter(({manifest:k})=>!k.extensionDependencies?.some(z=>a.has(z.toLowerCase())));p.length?h=a.size===1?p:p.filter(({task:k})=>!(k===n&&!s)):(this.logService.info("Found extensions with circular dependencies",p.map(({task:k})=>k.identifier.id)),h=[...a.values()]);const R=(await Promise.allSettled(h.map(async({task:k})=>{const z=new Date().getTime();try{const W=await k.run();w.URI.isUri(k.source)||I(this.telemetryService,k.operation===2?"extensionGallery:update":"extensionGallery:install",(0,P.getGalleryExtensionTelemetryData)(k.source),new Date().getTime()-z,void 0),i.push({local:W,identifier:k.identifier,operation:k.operation,source:k.source})}catch(W){throw w.URI.isUri(k.source)||I(this.telemetryService,k.operation===2?"extensionGallery:update":"extensionGallery:install",(0,P.getGalleryExtensionTelemetryData)(k.source),new Date().getTime()-z,W),this.logService.error("Error while installing the extension:",k.identifier.id),this.logService.error(W),W}finally{a.delete(k.identifier.id.toLowerCase())}}))).reduce((k,z)=>(z.status==="rejected"&&k.push(z.reason),k),[]);if(R.length)throw f(R)}return i.forEach(({identifier:h})=>this.logService.info("Extension installed successfully:",h.id)),this._onDidInstallExtensions.fire(i),i.filter(({identifier:h})=>(0,P.areSameExtensions)(h,n.identifier))[0].local}catch(a){if(e.forEach(({task:h})=>h.cancel()),i.length)try{const h=await Promise.allSettled(i.map(({local:p})=>this.createUninstallExtensionTask(p,{versionOnly:!0}).run()));for(let p=0;p<h.length;p++){const M=h[p],{identifier:R}=i[p];M.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",R.id):this.logService.warn("Rollback: Error while uninstalling extension",R.id,(0,v.getErrorMessage)(M.reason))}}catch(h){this.logService.warn("Error while rolling back extensions",(0,v.getErrorMessage)(h),i.map(({identifier:p})=>p.id))}throw this.logService.error("Failed to install extension:",n.identifier.id,(0,v.getErrorMessage)(a)),this._onDidInstallExtensions.fire(e.map(({task:h})=>({identifier:h.identifier,operation:1,source:h.source}))),a instanceof Error&&(a.name=a&&a.code?a.code:t.ERROR_UNKNOWN),a}finally{for(const{task:a,manifest:h}of e)if(!w.URI.isUri(a.source)){const p=new P.ExtensionIdentifierWithVersion(a.identifier,h.version).key();this.installingExtensions.delete(p)||this.logService.warn("Installation task is not found in the cache",p)}}}async getAllDepsAndPackExtensionsToInstall(l,r,o){if(!this.galleryService.isEnabled())return[];let e=await this.getInstalled();const i=[l,...e.map(a=>a.identifier)],n=[],s=async(a,h)=>{const p=h.extensionDependencies||[];if(h.extensionPack){const M=o?e.find(R=>(0,P.areSameExtensions)(R.identifier,a)):void 0;for(const R of h.extensionPack)M&&M.manifest.extensionPack&&M.manifest.extensionPack.some(k=>(0,P.areSameExtensions)({id:k},{id:R}))||p.every(k=>!(0,P.areSameExtensions)({id:k},{id:R}))&&p.push(R)}if(p.length){const M=[...i,...n.map(k=>k.gallery.identifier)],R=p.filter(k=>M.every(z=>!(0,P.areSameExtensions)(z,{id:k})));if(R.length){const k=await this.galleryService.query({names:R,pageSize:p.length},y.CancellationToken.None);for(const z of k.firstPage){if(M.find(ie=>(0,P.areSameExtensions)(ie,z.identifier)))continue;const W=await this.checkAndGetCompatibleVersion(z);if(!await this.canInstall(W)){this.logService.info("Skipping the extension as it cannot be installed",W.identifier.id);continue}const Q=await this.galleryService.getManifest(W,y.CancellationToken.None);if(Q===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${W.identifier.id}`,t.INSTALL_ERROR_VALIDATING);n.push({gallery:W,manifest:Q}),await s(W.identifier,Q)}}}};return await s(l,r),e=await this.getInstalled(),n.filter(a=>!e.some(h=>(0,P.areSameExtensions)(h.identifier,a.gallery.identifier)))}async checkAndGetCompatibleVersion(l){if(await this.isMalicious(l))throw new E.ExtensionManagementError(m.localize(3,null,l.identifier.id),E.INSTALL_ERROR_MALICIOUS);const r=await this.galleryService.getCompatibleExtension(l);if(!r)throw new E.ExtensionManagementError(m.localize(4,null,l.identifier.id,L.default.version),E.INSTALL_ERROR_INCOMPATIBLE);return r}async isMalicious(l){const r=await this.getExtensionsReport();return(0,P.getMaliciousExtensionsSet)(r).has(l.identifier.id)}async unininstallExtension(l,r){const o=this.uninstallingExtensions.get(l.identifier.id.toLowerCase());if(o)return this.logService.info("Extensions is already requested to uninstall",l.identifier.id),o.waitUntilTaskIsFinished();const e=(a,h)=>{const p=this.createUninstallExtensionTask(a,h);return this.uninstallingExtensions.set(p.extension.identifier.id.toLowerCase(),p),this.logService.info("Uninstalling extension:",a.identifier.id),this._onUninstallExtension.fire(a.identifier),p},i=(a,h)=>{h?this.logService.error("Failed to uninstall extension:",a.identifier.id,h.message):this.logService.info("Successfully uninstalled extension:",a.identifier.id),I(this.telemetryService,"extensionGallery:uninstall",(0,P.getLocalExtensionTelemetryData)(a),void 0,h),this._onDidUninstallExtension.fire({identifier:a.identifier,error:h?.code})},n=[],s=[];try{n.push(e(l,{}));const a=await this.getInstalled(1);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",l.identifier.id);else{const M=this.getAllPackExtensionsToUninstall(l,a);for(const R of M)this.uninstallingExtensions.has(R.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",R.identifier.id):n.push(e(R,{}))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",l.identifier.id):this.checkForDependents(n.map(M=>M.extension),a,l);const p=(await Promise.allSettled(n.map(async M=>{try{if(await M.run(),M.extension.identifier.uuid)try{await this.galleryService.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch(R){}i(M.extension)}catch(R){const k=R instanceof E.ExtensionManagementError?R:new E.ExtensionManagementError((0,v.getErrorMessage)(R),t.ERROR_UNKNOWN);throw i(M.extension,k),k}finally{s.push(M)}}))).reduce((M,R)=>(R.status==="rejected"&&M.push(R.reason),M),[]);if(p.length)throw f(p)}catch(a){const h=a instanceof E.ExtensionManagementError?a:new E.ExtensionManagementError((0,v.getErrorMessage)(a),t.ERROR_UNKNOWN);for(const p of n){try{p.cancel()}catch(M){}s.includes(p)||i(p.extension,h)}throw h}finally{for(const a of n)this.uninstallingExtensions.delete(a.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",a.extension.identifier.id)}}checkForDependents(l,r,o){for(const e of l){const i=this.getDependents(e,r);if(i.length){const n=i.filter(s=>l.indexOf(s)===-1);if(n.length)throw new Error(this.getDependentsErrorMessage(e,n,o))}}}getDependentsErrorMessage(l,r,o){return o===l?r.length===1?m.localize(5,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?m.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):m.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?m.localize(8,null,o.manifest.displayName||o.manifest.name,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?m.localize(9,null,o.manifest.displayName||o.manifest.name,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):m.localize(10,null,o.manifest.displayName||o.manifest.name,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(l,r,o=[]){if(o.indexOf(l)!==-1)return[];o.push(l);const e=l.manifest.extensionPack?l.manifest.extensionPack:[];if(e.length){const i=r.filter(s=>!s.isBuiltin&&e.some(a=>(0,P.areSameExtensions)({id:a},s.identifier))),n=[];for(const s of i)n.push(...this.getAllPackExtensionsToUninstall(s,r,o));return[...i,...n]}return[]}getDependents(l,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(e=>(0,P.areSameExtensions)({id:e},l.identifier)))}async findGalleryExtension(l){if(l.identifier.uuid){const r=await this.findGalleryExtensionById(l.identifier.uuid);return r||this.findGalleryExtensionByName(l.identifier.id)}return this.findGalleryExtensionByName(l.identifier.id)}async findGalleryExtensionById(l){return(await this.galleryService.query({ids:[l],pageSize:1},y.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(l){return(await this.galleryService.query({names:[l],pageSize:1},y.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const l=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${l.length} reported extensions from service`),l}catch(l){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};c=ce([ue(0,E.IExtensionGalleryService),ue(1,g.ITelemetryService),ue(2,u.ILogService)],c),t.AbstractExtensionManagementService=c;function f(b){const l=Array.isArray(b)?b:[b];return l.length===1?l[0]instanceof Error?l[0]:new Error(l[0]):l.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}t.joinErrors=f;function I(b,l,r,o,e){const i=e?e instanceof E.ExtensionManagementError?e.code:t.ERROR_UNKNOWN:void 0;b.publicLogError(l,{...r,success:!e,duration:o,errorcode:i})}t.reportTelemetry=I;class C{constructor(){this.barrier=new F.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,F.createCancelablePromise)(l=>this.doRun(l))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,F.createCancelablePromise)(l=>new Promise((r,o)=>{const e=l.onCancellationRequested(()=>{e.dispose(),o((0,v.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=C}),define(Y[118],ee([0,1,8,22,23,19,35,55,49,21,26,14,17,7,42,115,114,12]),function(_,t,m,O,E,P,T,L,u,g,y,v,w,F,c,f,I,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var b;(function(j){j[j.None=0]="None",j[j.IncludeVersions=1]="IncludeVersions",j[j.IncludeFiles=2]="IncludeFiles",j[j.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",j[j.IncludeSharedAccounts=8]="IncludeSharedAccounts",j[j.IncludeVersionProperties=16]="IncludeVersionProperties",j[j.ExcludeNonValidated=32]="ExcludeNonValidated",j[j.IncludeInstallationTargets=64]="IncludeInstallationTargets",j[j.IncludeAssetUri=128]="IncludeAssetUri",j[j.IncludeStatistics=256]="IncludeStatistics",j[j.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",j[j.Unpublished=4096]="Unpublished"})(b||(b={}));function l(...j){return String(j.reduce((x,q)=>x|q,0))}var r;(function(j){j[j.Tag=1]="Tag",j[j.ExtensionId=4]="ExtensionId",j[j.Category=5]="Category",j[j.ExtensionName=7]="ExtensionName",j[j.Target=8]="Target",j[j.Featured=9]="Featured",j[j.SearchText=10]="SearchText",j[j.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},e={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},n={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:b.None,criteria:[],assetTypes:[]};class s{constructor(x=n){this.state=x}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(x,q=this.state.pageSize){return new s({...this.state,pageNumber:x,pageSize:q})}withFilter(x,...q){const S=[...this.state.criteria,...q.length?q.map(d=>({filterType:x,value:d})):[{filterType:x}]];return new s({...this.state,criteria:S})}withSortBy(x){return new s({...this.state,sortBy:x})}withSortOrder(x){return new s({...this.state,sortOrder:x})}withFlags(...x){return new s({...this.state,flags:x.reduce((q,S)=>q|S,0)})}withAssetTypes(...x){return new s({...this.state,assetTypes:x})}get raw(){const{criteria:x,pageNumber:q,pageSize:S,sortBy:d,sortOrder:D,flags:A,assetTypes:N}=this.state;return{filters:[{criteria:x,pageNumber:q,pageSize:S,sortBy:d,sortOrder:D}],assetTypes:N,flags:A}}get searchText(){const x=this.state.criteria.filter(q=>q.filterType===r.SearchText)[0];return x&&x.value?x.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(x=>String(x.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function a(j,x){const q=(j||[]).filter(S=>S.statisticName===x)[0];return q?q.value:0}function h(j){const x="Microsoft.VisualStudio.Code.Translation.";return j.files.filter(S=>S.assetType.indexOf(x)===0).reduce((S,d)=>{const D=k(j,d.assetType);return D&&S.push([d.assetType.substring(x.length),D]),S},[])}function p(j){if(j.properties){const x=j.properties.filter(d=>d.key===o.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),S=x.filter(d=>q.test(d.value))[0];return S?{uri:S.value,fallbackUri:S.value}:null}return k(j,o.Repository)}function M(j){return{uri:`${j.fallbackAssetUri}/${o.VSIX}?redirect=true`,fallbackUri:`${j.fallbackAssetUri}/${o.VSIX}`}}function R(j){const x=k(j,o.Icon);if(x)return x;const q=O.DefaultIconPath;return{uri:q,fallbackUri:q}}function k(j,x){return j.files.filter(S=>S.assetType===x)[0]?{uri:`${j.assetUri}/${x}`,fallbackUri:`${j.fallbackAssetUri}/${x}`}:null}function z(j,x){const q=j.properties?j.properties.filter(d=>d.key===x):[],S=q.length>0&&q[0].value;return S?S.split(",").map(d=>(0,E.adoptToGalleryExtensionId)(d)):[]}function W(j){const x=j.properties?j.properties.filter(q=>q.key===e.Engine):[];return x.length>0&&x[0].value||""}function Q(j){const x=j.properties?j.properties.filter(S=>S.key===e.LocalizedLanguages):[],q=x.length>0&&x[0].value||"";return q?q.split(","):[]}function ie(j){return j.indexOf("preview")!==-1}function re(j,x,q,S,d){const D={manifest:k(x,o.Manifest),readme:k(x,o.Details),changelog:k(x,o.Changelog),license:k(x,o.License),repository:p(x),download:M(x),icon:R(x),coreTranslations:h(x)};return{identifier:{id:(0,E.getGalleryExtensionId)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},name:j.extensionName,version:x.version,date:x.lastUpdated,displayName:j.displayName,publisherId:j.publisher.publisherId,publisher:j.publisher.publisherName,publisherDisplayName:j.publisher.displayName,description:j.shortDescription||"",installCount:a(j.statistics,"install"),rating:a(j.statistics,"averagerating"),ratingCount:a(j.statistics,"ratingcount"),assetUri:F.URI.parse(x.assetUri),webExtension:!!j.tags?.includes(O.WEB_EXTENSION_TAG),assetTypes:x.files.map(({assetType:A})=>A),assets:D,properties:{dependencies:z(x,e.Dependency),extensionPack:z(x,e.ExtensionPack),engine:W(x),localizedLanguages:Q(x)},telemetryData:{index:(S.pageNumber-1)*S.pageSize+q,querySource:d},preview:ie(j.flags)}}let Z=class{constructor(x,q,S,d,D,A,N){this.requestService=x,this.logService=q,this.environmentService=S,this.telemetryService=d,this.fileService=D,this.productService=A;const U=A.extensionsGallery;this.extensionsGalleryUrl=U&&U.serviceUrl,this.extensionsControlUrl=U&&U.controlUrl,this.commonHeadersPromise=X(A.version,this.environmentService,this.fileService,N)}api(x=""){return`${this.extensionsGalleryUrl}${x}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(x,q){const S=[];let{total:d,firstPage:D,getPage:A}=await this.query({names:x,pageSize:x.length},q);S.push(...D);for(let N=1;S.length<d&&(D=await A(N,q),D.length);N++)S.push(...D);return S}async getCompatibleExtension(x,q){return this.getCompatibleExtensionByEngine(x,q)}async getCompatibleExtensionByEngine(x,q){const S=(0,O.isIExtensionIdentifier)(x)?null:x;if(S&&S.properties.engine&&(0,u.isEngineValid)(S.properties.engine,this.productService.version,this.productService.date))return S;const{id:d,uuid:D}=S?S.identifier:x;let A=new s().withFlags(b.IncludeAssetUri,b.IncludeStatistics,b.IncludeCategoryAndTags,b.IncludeFiles,b.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");D?A=A.withFilter(r.ExtensionId,D):A=A.withFilter(r.ExtensionName,d);const{galleryExtensions:N}=await this.queryGallery(A,y.CancellationToken.None),[U]=N;if(!U||!U.versions.length)return null;if(q){const $=U.versions.filter(H=>H.version===q)[0];if($){const H=re(U,$,0,A);if(H.properties.engine&&(0,u.isEngineValid)(H.properties.engine,this.productService.version,this.productService.date))return H}return null}const B=await this.getLastValidExtensionVersion(U,U.versions);return B?re(U,B,0,A):null}async query(x,q){const S=y.CancellationToken.isCancellationToken(x)?{}:x,d=y.CancellationToken.isCancellationToken(x)?x:q;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let D=S.text||"";const A=(0,P.getOrDefault)(S,J=>J.pageSize,50);let N=new s().withFlags(b.IncludeLatestVersionOnly,b.IncludeAssetUri,b.IncludeStatistics,b.IncludeCategoryAndTags,b.IncludeFiles,b.IncludeVersionProperties).withPage(1,A).withFilter(r.Target,"Microsoft.VisualStudio.Code");D?(D=D.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(J,te,ne)=>(N=N.withFilter(r.Category,ne||te),"")),D=D.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(J,te,ne)=>(N=N.withFilter(r.Tag,ne||te),"")),D=D.replace(/\bfeatured(\s+|\b|$)/g,()=>(N=N.withFilter(r.Featured),"")),D=D.trim(),D&&(D=D.length<200?D:D.substring(0,200),N=N.withFilter(r.SearchText,D)),N=N.withSortBy(0)):S.ids?N=N.withFilter(r.ExtensionId,...S.ids):S.names?N=N.withFilter(r.ExtensionName,...S.names):N=N.withSortBy(4),typeof S.sortBy=="number"&&(N=N.withSortBy(S.sortBy)),typeof S.sortOrder=="number"&&(N=N.withSortOrder(S.sortOrder));const{galleryExtensions:U,total:B}=await this.queryGallery(N,d),$=U.map((J,te)=>re(J,J.versions[0],te,N,S.source)),H=async(J,te)=>{if(te.isCancellationRequested)throw(0,m.canceled)();const ne=N.withPage(J+1),{galleryExtensions:ae}=await this.queryGallery(ne,te);return ae.map((he,ve)=>re(he,he.versions[0],ve,ne,S.source))};return{firstPage:$,total:B,pageSize:N.pageSize,getPage:H}}async queryGallery(x,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");x=x.withFlags(x.flags,b.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,l(b.Unpublished));const S=await this.commonHeadersPromise,d=JSON.stringify(x.raw),D={...S,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(d.length)},A=new Date().getTime();let N,U,B=0;try{if(N=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:d,headers:D},q),N.res.statusCode&&N.res.statusCode>=400&&N.res.statusCode<500)return{galleryExtensions:[],total:B};const $=await(0,L.asJson)(N);if($){const H=$.results[0],J=H.extensions,te=H.resultMetadata&&H.resultMetadata.filter(ne=>ne.metadataType==="ResultCount")[0];return B=te&&te.metadataItems.filter(ne=>ne.name==="TotalCount")[0].count||0,{galleryExtensions:J,total:B}}return{galleryExtensions:[],total:B}}catch($){throw U=$,$}finally{this.telemetryService.publicLog2("galleryService:query",{...x.telemetryData,requestBodySize:String(d.length),duration:new Date().getTime()-A,success:!!N&&(0,L.isSuccess)(N),responseBodySize:N?.res.headers["Content-Length"],statusCode:N?String(N.res.statusCode):void 0,errorCode:U?(0,m.isPromiseCanceledError)(U)?"canceled":(0,m.getErrorMessage)(U).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(B)})}}async reportStatistic(x,q,S,d){if(!this.isEnabled())return;const A={...await this.commonHeadersPromise,Accept:"*/*;api-version=4.0-preview.1"};try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${x}/extensions/${q}/${S}/stats?statType=${d}`),headers:A},y.CancellationToken.None)}catch(N){}}async download(x,q,S){this.logService.trace("ExtensionGalleryService#download",x.identifier.id);const d=(0,E.getGalleryExtensionTelemetryData)(x),D=new Date().getTime(),A=$=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...d,duration:$}),N=S===1?"install":S===2?"update":"",U=N?{uri:`${x.assets.download.uri}&${N}=true`,fallbackUri:`${x.assets.download.fallbackUri}?${N}=true`}:x.assets.download,B=await this.getAsset(U);await this.fileService.writeFile(q,B.stream),A(new Date().getTime()-D)}async getReadme(x,q){if(x.assets.readme){const S=await this.getAsset(x.assets.readme,{},q);return await(0,L.asText)(S)||""}return""}async getManifest(x,q){if(x.assets.manifest){const S=await this.getAsset(x.assets.manifest,{},q),d=await(0,L.asText)(S);return d?JSON.parse(d):null}return null}async getCoreTranslation(x,q){const S=x.assets.coreTranslations.filter(d=>d[0]===q.toUpperCase())[0];if(S){const d=await this.getAsset(S[1]),D=await(0,L.asText)(d);return D?JSON.parse(D):null}return null}async getChangelog(x,q){if(x.assets.changelog){const S=await this.getAsset(x.assets.changelog,{},q);return await(0,L.asText)(S)||""}return""}async getAllVersions(x,q){let S=new s().withFlags(b.IncludeVersions,b.IncludeCategoryAndTags,b.IncludeFiles,b.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");x.identifier.uuid?S=S.withFilter(r.ExtensionId,x.identifier.uuid):S=S.withFilter(r.ExtensionName,x.identifier.id);const d=[],{galleryExtensions:D}=await this.queryGallery(S,y.CancellationToken.None);return D.length&&(q?await Promise.all(D[0].versions.map(async A=>{let N;try{N=await this.getEngine(A)}catch(U){}N&&(0,u.isEngineValid)(N,this.productService.version,this.productService.date)&&d.push({version:A.version,date:A.lastUpdated})})):d.push(...D[0].versions.map(A=>({version:A.version,date:A.lastUpdated})))),d}async getAsset(x,q={},S=y.CancellationToken.None){const d=await this.commonHeadersPromise,D={type:"GET"},A={...d,...q.headers||{}};q={...q,...D,headers:A};const N=x.uri,U=x.fallbackUri,B={...q,url:N};try{const $=await this.requestService.request(B,S);if($.res.statusCode===200)return $;const H=await(0,L.asText)($);throw new Error(`Expected 200, got back ${$.res.statusCode} instead.

${H}`)}catch($){if((0,m.isPromiseCanceledError)($))throw $;const H=(0,m.getErrorMessage)($);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:N,message:H});const J={...q,url:U};return this.requestService.request(J,S)}}async getLastValidExtensionVersion(x,q){const S=this.getLastValidExtensionVersionFromProperties(x,q);return S||this.getLastValidExtensionVersionRecursively(x,q)}getLastValidExtensionVersionFromProperties(x,q){for(const S of q){const d=W(S);if(!d)return null;if((0,u.isEngineValid)(d,this.productService.version,this.productService.date))return S}return null}async getEngine(x){const q=W(x);if(q)return q;const S=k(x,o.Manifest);if(!S)throw new Error("Manifest was not found");const d={"Accept-Encoding":"gzip"},D=await this.getAsset(S,{headers:d}),A=await(0,L.asJson)(D);if(A)return A.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(x,q){if(!q.length)return null;const S=q[0],d=await this.getEngine(S);return(0,u.isEngineValid)(d,this.productService.version,this.productService.date)?{...S,properties:[...S.properties||[],{key:e.Engine,value:d}]}:this.getLastValidExtensionVersionRecursively(x,q.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const x=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},y.CancellationToken.None);if(x.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,L.asJson)(x),S=new Map;if(q)for(const d of q.malicious){const D=S.get(d)||{id:{id:d},malicious:!0,slow:!1};D.malicious=!0,S.set(d,D)}return[...S.values()]}};Z=ce([ue(0,L.IRequestService),ue(1,v.ILogService),ue(2,g.IEnvironmentService),ue(3,T.ITelemetryService),ue(4,w.IFileService),ue(5,c.IProductService),ue(6,(0,C.optional)(f.IStorageService))],Z),t.ExtensionGalleryService=Z;async function X(j,x,q,S){const d={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j}`},D=await(0,I.getServiceMachineId)(x,q,S);return d["X-Market-User-Id"]=D,d}t.resolveMarketplaceHeaders=X}),define(Y[119],ee([0,1,34,85,18,12,27,30,2,19,25]),function(_,t,m,O,E,P,T,L,u,g,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let v=class{constructor(c,f){this._configurationService=f,this._experimentProperties={},this._disposables=new u.DisposableStore,this._cleanupPatterns=[],this._appender=c.appender,this._commonProperties=c.commonProperties||Promise.resolve({}),this._piiPaths=c.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let I of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,E.escapeRegExpCharacters)(I),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(I=>{const C=/^[a-f0-9]+$/i.test(I["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!C})}))}setExperimentProperty(c,f){this._experimentProperties[c]=f}setEnabled(c){this._enabled=c}_updateUserOptIn(){const c=this._configurationService?.getValue(w);this._userOptIn=c?c.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const c=await this._commonProperties;let f=c.sessionID,I=c["common.instanceId"],C=c["common.machineId"],b=c["common.firstSessionDate"],l=c["common.msftInternal"];return{sessionId:f,instanceId:I,machineId:C,firstSessionDate:b,msftInternal:l}}dispose(){this._disposables.dispose()}publicLog(c,f,I){return this.isOptedIn?this._commonProperties.then(C=>{f=(0,g.mixin)(f,C),f=(0,g.mixin)(f,this._experimentProperties),f=(0,g.cloneAndChange)(f,b=>{if(typeof b=="string")return this._cleanupInfo(b,I)}),this._appender.log(c,f)},C=>{console.error(C)}):Promise.resolve(void 0)}publicLog2(c,f,I){return this.publicLog(c,f,I)}publicLogError(c,f){return this.sendErrorTelemetry?this.publicLog(c,f,!0):Promise.resolve(void 0)}publicLogError2(c,f){return this.publicLogError(c,f)}_cleanupInfo(c,f){let I=c;if(f){const C=[];for(let o of this._cleanupPatterns)for(;;){const e=o.exec(c);if(!e)break;C.push([e.index,o.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(I="";;){const o=l.exec(c);if(!o)break;!b.test(o[0])&&C.every(([e,i])=>o.index<e||o.index>=i)&&(I+=c.substring(r,o.index)+"<REDACTED: user-file-path>",r=l.lastIndex)}r<c.length&&(I+=c.substr(r))}for(let C of this._cleanupPatterns)I=I.replace(C,"");return I}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=ce([ue(1,(0,P.optional)(T.IConfigurationService))],v),t.TelemetryService=v;const w="telemetry";y.Registry.as(L.Extensions.Configuration).registerConfiguration({id:w,order:110,type:"object",title:(0,O.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,O.localize)(2,null,m.default.privacyStatementUrl):(0,O.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[56],ee([0,1,27,19,13,4]),function(_,t,m,O,E,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(c,f){return Promise.resolve(void 0)}publicLog2(c,f){return this.publicLog(c,f)}publicLogError(c,f){return Promise.resolve(void 0)}publicLogError2(c,f){return this.publicLogError(c,f)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class T{async publicLog(f,I,C){}async publicLogError(f,I,C){}}t.NullEndpointTelemetryService=T;function L(...c){return{log:(f,I)=>c.forEach(C=>C.log(f,I)),flush:()=>P.Promises.settled(c.map(f=>f.flush()))}}t.combinedAppender=L,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function u(c,f){return f.onDidChangeConfiguration(I=>{I.source!==6&&c.publicLog2("updateConfiguration",{configurationSource:(0,m.ConfigurationTargetToString)(I.source),configurationKeys:w(I.sourceConfig)})})}t.configurationTelemetry=u;function g(c){const f=Object.create(null),I=Object.create(null),C=Object.create(null);v(c,C);for(let b in C){b=b.length>150?b.substr(b.length-149):b;const l=C[b];typeof l=="number"?I[b]=l:typeof l=="boolean"?I[b]=l?1:0:typeof l=="string"?f[b]=l.substring(0,1023):typeof l!="undefined"&&l!==null&&(f[b]=l)}return{properties:f,measurements:I}}t.validateTelemetryData=g;function y(c){if(!c)return"none";let f="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(C=>{c.indexOf(`${C}+`)===0&&(f=C)}),f}t.cleanRemoteAuthority=y;function v(c,f,I=0,C){if(!!c)for(let b of Object.getOwnPropertyNames(c)){const l=c[b],r=C?C+b:b;Array.isArray(l)?f[r]=(0,O.safeStringify)(l):l instanceof Date?f[r]=l.toISOString():(0,E.isObject)(l)?I<2?v(l,f,I+1,r+"."):f[r]=(0,O.safeStringify)(l):f[r]=l}}function w(c){if(!c)return[];const f=[];return F(f,"",c),f}function F(c,f,I){I&&typeof I=="object"&&!Array.isArray(I)?Object.keys(I).forEach(C=>F(c,f?`${f}.${C}`:C,I[C])):c.push(f)}}),define(Y[120],ee([0,1,8,19,56]),function(_,t,m,O,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function P(L){const u=await new Promise((y,v)=>{_(["applicationinsights"],y,v)});let g;return u.defaultClient?(g=new u.TelemetryClient(L),g.channel.setUseDiskRetryCaching(!0)):(u.setup(L).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),g=u.defaultClient),L.indexOf("AIF-")===0&&(g.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),g}class T{constructor(u,g,y){this._eventPrefix=u,this._defaultData=g,this._defaultData||(this._defaultData=Object.create(null)),typeof y=="function"?this._aiClient=y():this._aiClient=y,this._asyncAIClient=null}_withAIClient(u){if(!!this._aiClient){if(typeof this._aiClient!="string"){u(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=P(this._aiClient)),this._asyncAIClient.then(g=>{u(g)},g=>{(0,m.onUnexpectedError)(g),console.error(g)})}}log(u,g){!this._aiClient||(g=(0,O.mixin)(g,this._defaultData),g=(0,E.validateTelemetryData)(g),this._withAIClient(y=>y.trackEvent({name:this._eventPrefix+"/"+u,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(u=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,u(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=T}),define(Y[121],ee([0,1,10,3]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function E(P,T){const L=Object.create(null),u=(y,v)=>{const w=JSON.parse(y);L[v]=w};if(T){const y=[],v=await m.Promises.readdir(T);for(const F of v)try{(await m.Promises.stat((0,O.join)(T,F))).isDirectory()&&y.push(F)}catch{}const w=[];for(const F of y)(await m.Promises.readdir((0,O.join)(T,F))).filter(f=>f==="telemetry.json").length===1&&w.push(F);for(const F of w){const c=(await m.Promises.readFile((0,O.join)(T,F,"telemetry.json"))).toString();u(c,F)}}let g=(await m.Promises.readFile((0,O.join)(P,"telemetry-core.json"))).toString();return u(g,"vscode-core"),g=(await m.Promises.readFile((0,O.join)(P,"telemetry-extensions.json"))).toString(),u(g,"vscode-extensions"),JSON.stringify(L,null,4)}t.buildTelemetryMessage=E}),define(Y[43],ee([0,1,72,3,38,4,10,132,133,13]),function(_,t,m,O,E,P,T,L,u,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class y extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=y;function v(o){const e=o.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function w(o){if(o instanceof y)return o;let e;return/end of central directory record signature not found/.test(o.message)&&(e="CorruptZip"),new y(e,o)}function F(o,e,i,n,s,a){const h=O.dirname(e),p=O.join(n,h);if(!p.startsWith(n))return Promise.reject(new Error(m.localize(0,null,e)));const M=O.join(n,e);let R;return a.onCancellationRequested(()=>{R&&R.destroy()}),Promise.resolve(T.Promises.mkdir(p,{recursive:!0})).then(()=>new Promise((k,z)=>{if(!a.isCancellationRequested)try{R=(0,E.createWriteStream)(M,{mode:i}),R.once("close",()=>k()),R.once("error",z),o.once("error",z),o.pipe(R)}catch(W){z(W)}}))}function c(o,e,i,n){let s=(0,P.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{s.cancel(),o.close()}),new Promise((h,p)=>{const M=new P.Sequencer,R=k=>{k.isCancellationRequested||(a++,o.readEntry())};o.once("error",p),o.once("close",()=>s.then(()=>{n.isCancellationRequested||o.entryCount===a?h():p(new y("Incomplete",new Error(m.localize(1,null,a,o.entryCount))))},p)),o.readEntry(),o.on("entry",k=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(k.fileName)){R(n);return}const z=k.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(z)){const ie=O.join(e,z);s=(0,P.createCancelablePromise)(re=>T.Promises.mkdir(ie,{recursive:!0}).then(()=>R(re)).then(void 0,p));return}const W=I(o,k),Q=v(k);s=(0,P.createCancelablePromise)(ie=>M.queue(()=>W.then(re=>F(re,z,Q,e,i,ie).then(()=>R(ie)))).then(null,p))})})}function f(o,e=!1){return new Promise((i,n)=>{(0,L.open)(o,e?{lazyEntries:!0}:void 0,(s,a)=>{s?n(w(s)):i((0,g.assertIsDefined)(a))})})}function I(o,e){return new Promise((i,n)=>{o.openReadStream(e,(s,a)=>{s?n(w(s)):i((0,g.assertIsDefined)(a))})})}function C(o,e){return new Promise((i,n)=>{const s=new u.ZipFile;e.forEach(h=>{h.contents?s.addBuffer(typeof h.contents=="string"?Buffer.from(h.contents,"utf8"):h.contents,h.path):h.localPath&&s.addFile(h.localPath,h.path)}),s.end();const a=(0,E.createWriteStream)(o);s.outputStream.pipe(a),s.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(o))})}t.zip=C;function b(o,e,i={},n){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=f(o,!0);return i.overwrite&&(a=a.then(h=>T.Promises.rm(e).then(()=>h))),a.then(h=>c(h,e,{sourcePathRegex:s},n))}t.extract=b;function l(o,e){return f(o).then(i=>new Promise((n,s)=>{i.on("entry",a=>{a.fileName===e&&I(i,a).then(h=>n(h),h=>s(h))}),i.once("close",()=>s(new Error(m.localize(2,null,e))))}))}function r(o,e){return l(o,e).then(i=>new Promise((n,s)=>{const a=[];i.once("error",s),i.on("data",h=>a.push(h)),i.on("end",()=>n(Buffer.concat(a)))}))}t.buffer=r}),define(Y[122],ee([0,1,43,78]),function(_,t,m,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function E(P){return(0,m.buffer)(P,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch(L){throw new Error((0,O.localize)(0,null))}})}t.getManifest=E}),define(Y[123],ee([0,1,41,2,10,3,14,22,23,4,7,21,90,79,42,43,15,24,9,17,20,29,8]),function(_,t,m,O,E,P,T,L,u,g,y,v,w,F,c,f,I,C,b,l,r,o,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",s="extracting",a="deleting",h="renaming";let p=class extends O.Disposable{constructor(R,k,z,W,Q){super();this.beforeRemovingExtension=R,this.fileService=k,this.logService=z,this.environmentService=W,this.productService=Q,this._devSystemExtensionsPath=null,this.systemExtensionsPath=W.builtinExtensionsPath,this.extensionsPath=W.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new g.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(R){const k=[];(R===null||R===0)&&k.push(this.scanSystemExtensions().then(null,z=>Promise.reject(new L.ExtensionManagementError(this.joinErrors(z).message,i)))),(R===null||R===1)&&k.push(this.scanUserExtensions(!0).then(null,z=>Promise.reject(new L.ExtensionManagementError(this.joinErrors(z).message,n))));try{const z=await Promise.all(k);return(0,C.flatten)(z)}catch(z){throw this.joinErrors(z)}}async scanUserExtensions(R){this.logService.trace("Started scanning user extensions");let[k,z]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return z=z.filter(W=>!k[new u.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version).key()]),R&&(z=(0,u.groupByExtension)(z,Q=>Q.identifier).map(Q=>Q.sort((ie,re)=>m.rcompare(ie.manifest.version,re.manifest.version))[0])),this.logService.trace("Scanned user extensions:",z.length),z}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(R,k,z){const W=R.key(),Q=P.join(this.extensionsPath,`.${(0,o.generateUuid)()}`),ie=P.join(this.extensionsPath,W);try{await E.Promises.rm(ie)}catch(Z){try{await E.Promises.rm(ie)}catch(X){}throw new L.ExtensionManagementError((0,F.localize)(0,null,ie,R.id),a)}await this.extractAtLocation(R,k,Q,z);let re=await this.scanExtension(y.URI.file(Q),1);if(!re)throw new Error((0,F.localize)(1,null,Q));await this.storeMetadata(re,{installedTimestamp:Date.now()});try{await this.rename(R,Q,ie,Date.now()+2*60*1e3),this.logService.info("Renamed to",ie)}catch(Z){try{await E.Promises.rm(Q)}catch(X){}if(Z.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",R.id);else throw this.logService.info(`Rename failed because of ${(0,e.getErrorMessage)(Z)}. Deleted from extracted location`,Q),Z}try{re=await this.scanExtension(y.URI.file(ie),1)}catch(Z){}if(re)return re;throw new Error((0,F.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(R,k){return this.setMetadata(R,k),await this.storeMetadata(R,{...k,installedTimestamp:R.installedTimestamp}),R}async storeMetadata(R,k){k.isMachineScoped=k.isMachineScoped||void 0,k.isBuiltin=k.isBuiltin||void 0,k.installedTimestamp=k.installedTimestamp||void 0;const z=P.join(R.location.fsPath,"package.json"),W=await E.Promises.readFile(z,"utf8"),{manifest:Q}=await this.parseManifest(W);return Q.__metadata=k,await E.Promises.writeFile(z,JSON.stringify(Q,null,"	")),R}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...R){const k=R.map(z=>new u.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version));await this.withUninstalledExtensions(z=>{k.forEach(W=>z[W.key()]=!0)})}async setInstalled(R){await this.withUninstalledExtensions(W=>delete W[R.key()]);const z=(await this.scanExtensions(1)).find(W=>new u.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version).equals(R))||null;return z?(await this.storeMetadata(z,{installedTimestamp:Date.now()}),this.scanExtension(z.location,1)):null}async withUninstalledExtensions(R){return this.uninstalledFileLimiter.queue(async()=>{let k;try{k=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(W){if(W.code!=="ENOENT")throw W}let z={};if(k)try{z=JSON.parse(k)}catch(W){}return R&&(R(z),Object.keys(z).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(z)):await E.Promises.rm(this.uninstalledPath)),z})}async removeExtension(R,k){this.logService.trace(`Deleting ${k} extension from disk`,R.identifier.id,R.location.fsPath),await E.Promises.rm(R.location.fsPath),this.logService.info("Deleted from disk",R.identifier.id,R.location.fsPath)}async removeUninstalledExtension(R){await this.removeExtension(R,"uninstalled"),await this.withUninstalledExtensions(k=>delete k[new u.ExtensionIdentifierWithVersion(R.identifier,R.manifest.version).key()])}async extractAtLocation(R,k,z,W){this.logService.trace(`Started extracting the extension from ${k} to ${z}`);try{await E.Promises.rm(z)}catch(Q){throw new L.ExtensionManagementError(this.joinErrors(Q).message,a)}try{await(0,f.extract)(k,z,{sourcePath:"extension",overwrite:!0},W),this.logService.info(`Extracted extension to ${z}:`,R.id)}catch(Q){try{await E.Promises.rm(z)}catch(ie){}throw new L.ExtensionManagementError(Q.message,Q instanceof f.ExtractError&&Q.type?Q.type:s)}}async rename(R,k,z,W){try{await E.Promises.rename(k,z)}catch(Q){if(I.isWindows&&Q&&Q.code==="EPERM"&&Date.now()<W)return this.logService.info(`Failed renaming ${k} to ${z} with 'EPERM' error. Trying again...`,R.id),this.rename(R,k,z,W);throw new L.ExtensionManagementError(Q.message||(0,F.localize)(3,null,k,z),Q.code||h)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const R=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return R;const k=this.scanDevSystemExtensions(),[z,W]=await Promise.all([R,k]);return[...z,...W]}async scanExtensionsInDir(R,k){const z=new g.Limiter(10),W=await this.fileService.resolve(y.URI.file(R));return W.children?(await Promise.all(W.children.filter(ie=>ie.isDirectory).map(ie=>z.queue(async()=>k===1&&(0,r.basename)(ie.resource).indexOf(".")===0?null:this.scanExtension(ie.resource,k))))).filter(ie=>ie&&ie.identifier):[]}async scanExtension(R,k){try{const z=await this.fileService.resolve(R);if(z.children){const{manifest:W,metadata:Q}=await this.readManifest(R.fsPath),ie=z.children.find(({name:j})=>/^readme(\.txt|\.md|)$/i.test(j))?.resource,re=z.children.find(({name:j})=>/^changelog(\.txt|\.md|)$/i.test(j))?.resource,Z={id:(0,u.getGalleryExtensionId)(W.publisher,W.name)},X={type:k,identifier:Z,manifest:W,location:R,readmeUrl:ie,changelogUrl:re,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:k===0};return Q&&(this.setMetadata(X,Q),X.installedTimestamp=Q.installedTimestamp),X}}catch(z){k!==0&&this.logService.trace(z)}return null}async scanDefaultSystemExtensions(){const R=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",R.length),R}async scanDevSystemExtensions(){const R=this.getDevSystemExtensionsList();if(R.length){const k=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",k.length),k.filter(z=>R.some(W=>(0,u.areSameExtensions)(z.identifier,{id:W})))}else return[]}setMetadata(R,k){R.publisherDisplayName=k.publisherDisplayName||null,R.publisherId=k.publisherId||null,R.identifier.uuid=k.id,R.isMachineScoped=!!k.isMachineScoped,R.isBuiltin=R.type===0||!!k.isBuiltin}async removeUninstalledExtensions(){const R=await this.getUninstalledExtensions(),k=await this.scanAllUserExtensions(),z=new Set;for(const ie of k)R[new u.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]||z.add(ie.identifier.id.toLowerCase());const W=(0,u.groupByExtension)(k,ie=>ie.identifier);await g.Promises.settled(W.map(async ie=>{const re=ie.sort((Z,X)=>m.rcompare(Z.manifest.version,X.manifest.version))[0];z.has(re.identifier.id.toLowerCase())||await this.beforeRemovingExtension(re)}));const Q=k.filter(ie=>R[new u.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]);await g.Promises.settled(Q.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const R=await this.scanAllUserExtensions(),k=[],z=(0,u.groupByExtension)(R,W=>W.identifier);k.push(...(0,C.flatten)(z.map(W=>W.sort((Q,ie)=>m.rcompare(Q.manifest.version,ie.manifest.version)).slice(1)))),await g.Promises.settled(k.map(W=>this.removeExtension(W,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(R=>R.name)}joinErrors(R){const k=Array.isArray(R)?R:[R];return k.length===1?k[0]instanceof Error?k[0]:new Error(k[0]):k.reduce((z,W)=>new Error(`${z.message}${z.message?",":""}${W instanceof Error?W.message:W}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(b.FileAccess.asFileUri("",_).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(R){const k=[E.Promises.readFile(P.join(R,"package.json"),"utf8").then(ie=>this.parseManifest(ie)),E.Promises.readFile(P.join(R,"package.nls.json"),"utf8").then(void 0,ie=>ie.code!=="ENOENT"?Promise.reject(ie):"{}").then(ie=>JSON.parse(ie))],[{manifest:z,metadata:W},Q]=await Promise.all(k);return{manifest:(0,w.localizeManifest)(z,Q),metadata:W}}parseManifest(R){return new Promise((k,z)=>{try{const W=JSON.parse(R),Q=W.__metadata||null;k({manifest:W,metadata:Q})}catch(W){z(new Error((0,F.localize)(4,null)))}})}};p=ce([ue(1,l.IFileService),ue(2,T.ILogService),ue(3,v.INativeEnvironmentService),ue(4,c.IProductService)],p),t.ExtensionsScanner=p}),define(Y[124],ee([0,1,77,3,10,43,22,23,21,41,7,34,15,14,98,28,35,49,20,29,96,12,9,122,102,123,103,104,17,117]),function(_,t,m,O,E,P,T,L,u,g,y,v,w,F,c,f,I,C,b,l,r,o,e,i,n,s,a,h,p,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const R="unsetUninstalled",k="downloading";let z=class extends M.AbstractExtensionManagementService{constructor(X,j,x,q,S,d,D){super(X,j,x);this.environmentService=q,this.downloadService=S;const A=this._register(d.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(d.createInstance(s.ExtensionsScanner,U=>A.postUninstall(U))),this.manifestCache=this._register(new c.ExtensionsManifestCache(q,this)),this.extensionsDownloader=this._register(d.createInstance(n.ExtensionsDownloader));const N=this._register(new h.ExtensionsWatcher(this,D,q,x));this._register(N.onDidChangeExtensionsByAnotherSource(({added:U,removed:B})=>{U.length&&this._onDidInstallExtensions.fire(U.map($=>({identifier:$.identifier,operation:0,local:$}))),B.forEach($=>this._onDidUninstallExtension.fire({identifier:$}))}))}async zip(X){this.logService.trace("ExtensionManagementService#zip",X.identifier.id);const j=await this.collectFiles(X),x=await(0,P.zip)((0,b.joinPath)(this.environmentService.tmpDir,(0,l.generateUuid)()).fsPath,j);return y.URI.file(x)}async unzip(X){return this.logService.trace("ExtensionManagementService#unzip",X.toString()),(await this.install(X)).identifier}async getManifest(X){const j=await this.downloadVsix(X),x=O.resolve(j.fsPath);return(0,i.getManifest)(x)}getInstalled(X=null){return this.extensionsScanner.scanExtensions(X)}async canInstall(X){return!0}async install(X,j={}){this.logService.trace("ExtensionManagementService#install",X.toString());const x=await this.downloadVsix(X),q=await(0,i.getManifest)(O.resolve(x.fsPath));if(q.engines&&q.engines.vscode&&!(0,C.isEngineValid)(q.engines.vscode,v.default.version,v.default.date))throw new Error(m.localize(0,null,(0,L.getGalleryExtensionId)(q.publisher,q.name),v.default.version));return this.installExtension(q,x,j)}async updateMetadata(X,j){return this.logService.trace("ExtensionManagementService#updateMetadata",X.identifier.id),X=await this.extensionsScanner.saveMetadataForLocalExtension(X,{...X.manifest.__metadata||{},...j}),this.manifestCache.invalidate(),X}async updateExtensionScope(X,j){return this.logService.trace("ExtensionManagementService#updateExtensionScope",X.identifier.id),X=await this.extensionsScanner.saveMetadataForLocalExtension(X,{...X.manifest.__metadata||{},isMachineScoped:j}),this.manifestCache.invalidate(),X}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(X){if(X.scheme===e.Schemas.file)return X;if(!this.downloadService)throw new Error("Download service is not available");const j=(0,b.joinPath)(this.environmentService.tmpDir,(0,l.generateUuid)());return await this.downloadService.download(X,j),j}createInstallExtensionTask(X,j,x){return y.URI.isUri(j)?new ie(X,j,x,this.galleryService,this.extensionsScanner,this.logService):new Q(j,x,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(X,j){return new re(X,j,this.extensionsScanner)}async collectFiles(X){const j=async q=>{let S=await E.Promises.readdir(q);S=S.map(A=>O.join(q,A));const d=await Promise.all(S.map(A=>E.Promises.stat(A)));let D=Promise.resolve([]);return d.forEach((A,N)=>{const U=S[N];A.isFile()&&(D=D.then(B=>[...B,U])),A.isDirectory()&&(D=D.then(B=>j(U).then($=>[...B,...$])))}),D};return(await j(X.location.fsPath)).map(q=>({path:`extension/${O.relative(X.location.fsPath,q)}`,localPath:q}))}};z=ce([ue(0,T.IExtensionGalleryService),ue(1,I.ITelemetryService),ue(2,F.ILogService),ue(3,u.INativeEnvironmentService),ue(4,(0,o.optional)(r.IDownloadService)),ue(5,o.IInstantiationService),ue(6,p.IFileService)],z),t.ExtensionManagementService=z;class W extends M.AbstractExtensionTask{constructor(X,j,x,q){super();this.identifier=X,this.source=j,this.extensionsScanner=x,this.logService=q,this._operation=1}get operation(){return this._operation}async installExtension(X,j){try{const x=await this.unsetUninstalledAndGetLocal(X.identifierWithVersion);if(x)return X.metadata?this.extensionsScanner.saveMetadataForLocalExtension(x,X.metadata):x}catch(x){throw w.isMacintosh?new T.ExtensionManagementError(m.localize(1,null),R):new T.ExtensionManagementError(m.localize(2,null),R)}return this.extract(X,j)}async unsetUninstalledAndGetLocal(X){if(!await this.isUninstalled(X))return null;this.logService.trace("Removing the extension from uninstalled list:",X.id);const x=await this.extensionsScanner.setInstalled(X);return this.logService.info("Removed the extension from uninstalled list:",X.id),x}async isUninstalled(X){return!!(await this.extensionsScanner.getUninstalledExtensions())[X.key()]}async extract({zipPath:X,identifierWithVersion:j,metadata:x},q){let S=await this.extensionsScanner.extractUserExtension(j,X,q);return this.logService.info("Extracting completed.",j.id),x&&(S=await this.extensionsScanner.saveMetadataForLocalExtension(S,x)),S}}class Q extends W{constructor(X,j,x,q,S){super(X.identifier,X,q,S);this.gallery=X,this.options=j,this.extensionsDownloader=x}async doRun(X){const x=(await this.extensionsScanner.scanExtensions(null)).find(d=>(0,L.areSameExtensions)(d.identifier,this.gallery.identifier));x&&(this._operation=2);const q=await this.downloadInstallableExtension(this.gallery,this._operation);q.metadata.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,q.metadata.isBuiltin=this.options.isBuiltin||x?.isBuiltin;const S=await this.installExtension(q,X);x&&g.neq(x.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(x);try{await this.extensionsDownloader.delete(y.URI.file(q.zipPath))}catch(d){}return S}async downloadInstallableExtension(X,j){const x={id:X.identifier.uuid,publisherId:X.publisherId,publisherDisplayName:X.publisherDisplayName};let q;try{this.logService.trace("Started downloading extension:",X.identifier.id),q=(await this.extensionsDownloader.downloadExtension(X,j)).fsPath,this.logService.info("Downloaded extension:",X.identifier.id,q)}catch(S){throw new T.ExtensionManagementError((0,M.joinErrors)(S).message,k)}try{const S=await(0,i.getManifest)(q);return{zipPath:q,identifierWithVersion:new L.ExtensionIdentifierWithVersion(X.identifier,S.version),metadata:x}}catch(S){throw new T.ExtensionManagementError((0,M.joinErrors)(S).message,M.INSTALL_ERROR_VALIDATING)}}}class ie extends W{constructor(X,j,x,q,S,d){super({id:(0,L.getGalleryExtensionId)(X.publisher,X.name)},j,S,d);this.manifest=X,this.location=j,this.options=x,this.galleryService=q}async doRun(X){const j=new L.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),q=(await this.extensionsScanner.scanExtensions(1)).find(d=>(0,L.areSameExtensions)(this.identifier,d.identifier)),S=await this.getMetadata(this.identifier.id,X);if(q)if(S.isMachineScoped=this.options.isMachineScoped||q.isMachineScoped,S.isBuiltin=this.options.isBuiltin||q.isBuiltin,this._operation=2,j.equals(new L.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version)))try{await this.extensionsScanner.removeExtension(q,"existing")}catch(d){throw new Error(m.localize(3,null,this.manifest.displayName||this.manifest.name))}else g.gt(q.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(q);else{const d=await this.unsetUninstalledAndGetLocal(j);if(d)try{await this.extensionsScanner.removeExtension(d,"existing")}catch(D){throw new Error(m.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:O.resolve(this.location.fsPath),identifierWithVersion:j,metadata:S},X)}async getMetadata(X,j){try{const x=(await this.galleryService.query({names:[X],pageSize:1},j)).firstPage[0];if(x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId}}catch(x){}return{}}}class re extends M.AbstractExtensionTask{constructor(X,j,x){super();this.extension=X,this.options=j,this.extensionsScanner=x}async doRun(X){const j=[],x=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const q=new L.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);j.push(...x.filter(S=>q.equals(new L.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version))))}else j.push(...x.filter(q=>(0,L.areSameExtensions)(q.identifier,this.extension.identifier)));if(!j.length)throw new Error(m.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...j),this.options.remove)for(const q of j)try{X.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(q)}catch(S){throw new Error(m.localize(6,null,(0,f.toErrorMessage)(S)))}}}}),define(Y[125],ee([0,1,134,113,2,13,8,112,27,14,16,21,99]),function(_,t,m,O,E,P,T,L,u,g,y,v,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let F=class extends E.Disposable{constructor(f,I,C){super();this.environmentService=I,this.logService=C,this.configure(f.getValue()),this._register(f.onDidChangeConfiguration(()=>this.configure(f.getValue()),this))}configure(f){this.proxyUrl=f.http&&f.http.proxy,this.strictSSL=!!(f.http&&f.http.proxyStrictSSL),this.authorization=f.http&&f.http.proxyAuthorization}async request(f,I){this.logService.trace("RequestService#request",f.url);const{proxyUrl:C,strictSSL:b}=this,l={...process.env,...await(0,w.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},r=f.agent?f.agent:await(0,L.getProxyAgent)(f.url||"",l,{proxyUrl:C,strictSSL:b});return f.agent=r,f.strictSSL=b,this.authorization&&(f.headers={...f.headers||{},"Proxy-Authorization":this.authorization}),this._request(f,I)}async getNodeRequest(f){return((0,O.parse)(f.url).protocol==="https:"?await new Promise((b,l)=>{_(["https"],b,l)}):await new Promise((b,l)=>{_(["http"],b,l)})).request}_request(f,I){return new Promise(async(C,b)=>{let l;const r=(0,O.parse)(f.url),o=f.getRawRequest?f.getRawRequest(f):await this.getNodeRequest(f),e={hostname:r.hostname,port:r.port?parseInt(r.port):r.protocol==="https:"?443:80,protocol:r.protocol,path:r.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,P.isBoolean)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(e.auth=f.user+":"+f.password),l=o(e,i=>{const n=(0,P.isNumber)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...f,url:i.headers.location,followRedirects:n-1},I).then(C,b);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,m.createGunzip)())),C({res:i,stream:(0,y.streamToBufferReadableStream)(s)})}}),l.on("error",b),f.timeout&&l.setTimeout(f.timeout),f.data&&typeof f.data=="string"&&l.write(f.data),l.end(),I.onCancellationRequested(()=>{l.abort(),b((0,T.canceled)())})})}async resolveProxy(f){}};F=ce([ue(0,u.IConfigurationService),ue(1,v.INativeEnvironmentService),ue(2,g.ILogService)],F),t.RequestService=F}),define(Y[135],ee([0,1,31,38,136,10,3,4,34,52,50,101,21,89,22,124,118,35,56,119,116,55,125,27,111,120,14,9,106,121,107,17,108,2,42,97,7,105,53,8,28,16,33]),function(_,t,m,O,E,P,T,L,u,g,y,v,w,F,c,f,I,C,b,l,r,o,e,i,n,s,a,h,p,M,R,k,z,W,Q,ie,re,Z,X,j,x,q,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class d extends W.Disposable{constructor(N){super();this.argv=N,(0,E.gracefulify)(O),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[N,U]=await this.initServices();return N.invokeFunction(async B=>{const $=B.get(a.ILogService),H=B.get(k.IFileService),J=B.get(w.INativeEnvironmentService),te=B.get(c.IExtensionManagementCLIService);return $.info("CLI main",this.argv),this.registerErrorHandler($),await this.doRun(J,te,H),(0,L.raceTimeout)((0,b.combinedAppender)(...U).flush(),1e3)})}async initServices(){const N=new g.ServiceCollection,U={_serviceBrand:void 0,...u.default};N.set(Q.IProductService,U);const B=new F.NativeEnvironmentService(this.argv,U);N.set(w.INativeEnvironmentService,B),await Promise.all([B.appSettingsHome.fsPath,B.extensionsPath].map(ve=>ve?P.Promises.mkdir(ve,{recursive:!0}):void 0));const $=(0,a.getLogLevel)(B),H=[];H.push(new p.SpdLogLogger("cli",(0,T.join)(B.logsPath,"cli.log"),!0,$)),$===a.LogLevel.Trace&&H.push(new a.ConsoleLogger($));const J=this._register(new a.MultiplexLogService(H));N.set(a.ILogService,J);const te=this._register(new R.FileService(J));N.set(k.IFileService,te);const ne=this._register(new z.DiskFileSystemProvider(J));te.registerProvider(h.Schemas.file,ne);const ae=this._register(new n.ConfigurationService(B.settingsResource,te));N.set(i.IConfigurationService,ae),await ae.initialize(),N.set(o.IRequestService,new y.SyncDescriptor(e.RequestService)),N.set(c.IExtensionManagementService,new y.SyncDescriptor(f.ExtensionManagementService)),N.set(c.IExtensionGalleryService,new y.SyncDescriptor(I.ExtensionGalleryService)),N.set(c.IExtensionManagementCLIService,new y.SyncDescriptor(ie.ExtensionManagementCLIService)),N.set(X.ILocalizationsService,new y.SyncDescriptor(Z.LocalizationsService));const he=[];if(B.isBuilt&&!B.isExtensionDevelopment&&!B.disableTelemetry&&U.enableTelemetry){U.aiConfig&&U.aiConfig.asimovKey&&he.push(new s.AppInsightsAppender("monacoworkbench",null,U.aiConfig.asimovKey));const{appRoot:ve,extensionsPath:De,installSourcePath:ke}=B,Te={appender:(0,b.combinedAppender)(...he),sendErrorTelemetry:!1,commonProperties:(async()=>{let we;try{const Fe=await P.Promises.readFile((0,T.join)(B.userDataPath,"storage.json"));we=JSON.parse(Fe.toString())[C.machineIdKey]}catch(Fe){Fe.code!=="ENOENT"&&J.error(Fe)}return(0,r.resolveCommonProperties)(te,(0,m.release)(),(0,m.hostname)(),process.arch,U.commit,U.version,we,U.msftInternalDomains,ke)})(),piiPaths:[ve,De]};N.set(C.ITelemetryService,new y.SyncDescriptor(l.TelemetryService,[Te]))}else N.set(C.ITelemetryService,b.NullTelemetryService);return[new v.InstantiationService(N),he]}registerErrorHandler(N){(0,j.setUnexpectedErrorHandler)(U=>{const B=(0,x.toErrorMessage)(U,!0);!B||N.error(`[uncaught exception in CLI]: ${B}`)})}async doRun(N,U,B){if(this.argv["install-source"])return this.setInstallSource(N,B,this.argv["install-source"]);if(this.argv["list-extensions"])return U.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return U.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return U.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return U.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(N.appRoot,N.extensionsPath))}asExtensionIdOrVSIX(N){return N.map(U=>/\.vsix$/i.test(U)?re.URI.file((0,T.isAbsolute)(U)?U:(0,T.join)((0,S.cwd)(),U)):U)}async setInstallSource(N,U,B){await U.writeFile(re.URI.file(N.installSourcePath),q.VSBuffer.fromString(B.slice(0,30)))}}async function D(A){const N=new d(A);try{await N.run()}finally{N.dispose()}}t.main=D})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/807dfb817fef0d0c5729c1924bd4889b04fa405b/core/vs/code/node/cliProcessMain.js.map
