/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","fs","vs/editor/common/core/position","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/json","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/codicons","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","path","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],fe=function(X){for(var e=[],g=0,R=X.length;g<R;g++)e[g]=he[X[g]];return e};define(he[52],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(R,k){if(!R)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=g}),define(he[69],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function R(i){const P=[];for(let u in i)g.call(i,u)&&P.push(i[u]);return P}e.values=R;function k(i,P){for(let u in i)if(g.call(i,u)&&P({key:u,value:i[u]},function(){delete i[u]})===!1)return}e.forEach=k;function y(i,P){const u=Object.create(null);for(const p of i){const l=P(p);let c=u[l];c||(c=u[l]=[]),c.push(p)}return u}e.groupBy=y;function T(i){const P=Object.create(null);return i&&i.forEach((u,p)=>{P[p]=u}),P}e.fromMap=T;function I(i,P){const u=[],p=[];for(let l of i)P.has(l)||u.push(l);for(let l of P)i.has(l)||p.push(l);return{removed:u,added:p}}e.diffSets=I;function D(i,P){const u=[],p=[];for(let[l,c]of i)P.has(l)||u.push(c);for(let[l,c]of P)i.has(l)||p.push(c);return{removed:u,added:p}}e.diffMaps=D;class C{constructor(){this.map=new Map}add(P,u){let p=this.map.get(P);p||(p=new Set,this.map.set(P,p)),p.add(u)}delete(P,u){const p=this.map.get(P);!p||(p.delete(u),p.size===0&&this.map.delete(P))}forEach(P,u){const p=this.map.get(P);!p||p.forEach(u)}}e.SetMap=C}),define(he[53],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(T){return(I,D,C)=>{let i=null,P=null;if(typeof C.value=="function"?(i="value",P=C.value):typeof C.get=="function"&&(i="get",P=C.get),!P)throw new Error("not supported");C[i]=T(P,D)}}e.createDecorator=g;function R(T,I,D){let C=null,i=null;if(typeof D.value=="function"?(C="value",i=D.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(C="get",i=D.get),!i)throw new Error("not supported");const P=`$memoize$${I}`;D[C]=function(...u){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,u)}),this[P]}}e.memoize=R;function k(T,I,D){return g((C,i)=>{const P=`$debounce$${i}`,u=`$debounce$result$${i}`;return function(...p){this[u]||(this[u]=D?D():void 0),clearTimeout(this[P]),I&&(this[u]=I(this[u],...p),p=[this[u]]),this[P]=setTimeout(()=>{C.apply(this,p),this[u]=D?D():void 0},T)}})}e.debounce=k;function y(T,I,D){return g((C,i)=>{const P=`$throttle$timer$${i}`,u=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,l=`$throttle$pending$${i}`;return function(...c){if(this[u]||(this[u]=D?D():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),I&&(this[u]=I(this[u],...c)),this[l])return;const S=this[p]+T;S<=Date.now()?(this[p]=Date.now(),C.apply(this,[this[u]]),this[u]=D?D():void 0):(this[l]=!0,this[P]=setTimeout(()=>{this[l]=!1,this[p]=Date.now(),C.apply(this,[this[u]]),this[u]=D?D():void 0},S-Date.now()))}})}e.throttle=y}),define(he[15],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function R(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=R;function k(v){D(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=k;function y(v){D(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=y;function T(v){if(v instanceof Error){let{name:t,message:s}=v;const r=v.stacktrace||v.stack;return{$isError:!0,name:t,message:s,stack:r}}return v}e.transformErrorForSerialization=T;const I="Canceled";function D(v){return v instanceof Error&&v.name===I&&v.message===I}e.isPromiseCanceledError=D;class C extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=C;function i(){const v=new Error(I);return v.name=v.message,v}e.canceled=i;function P(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=P;function u(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=u;function p(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function l(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=l;function c(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=c;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function d(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function h(v,t=Object.create(null)){const s=new Error(v);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=h}),define(he[18],fe([0,1,15]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(M,O=0){return M[M.length-(1+O)]}e.tail=R;function k(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.tail2=k;function y(M,O,B=(z,J)=>z===J){if(M===O)return!0;if(!M||!O||M.length!==O.length)return!1;for(let z=0,J=M.length;z<J;z++)if(!B(M[z],O[z]))return!1;return!0}e.equals=y;function T(M,O,B){let z=0,J=M.length-1;for(;z<=J;){const ce=(z+J)/2|0,ye=B(M[ce],O);if(ye<0)z=ce+1;else if(ye>0)J=ce-1;else return ce}return-(z+1)}e.binarySearch=T;function I(M,O){let B=0,z=M.length;if(z===0)return 0;for(;B<z;){const J=Math.floor((B+z)/2);O(M[J])?z=J:B=J+1}return B}e.findFirstInSorted=I;function D(M,O,B){if(M=M|0,M>=O.length)throw new TypeError("invalid index");let z=O[Math.floor(O.length*Math.random())],J=[],ce=[],ye=[];for(let Fe of O){const Re=B(Fe,z);Re<0?J.push(Fe):Re>0?ce.push(Fe):ye.push(Fe)}return M<J.length?D(M,J,B):M<J.length+ye.length?ye[0]:D(M-(J.length+ye.length),ce,B)}e.quickSelect=D;function C(M,O){const B=[];let z;for(const J of M.slice(0).sort(O))!z||O(z[0],J)!==0?(z=[J],B.push(z)):z.push(J);return B}e.groupBy=C;function i(M,O,B){const z=[];function J(Fe,Re,Ne){if(Re===0&&Ne.length===0)return;const Ve=z[z.length-1];Ve&&Ve.start+Ve.deleteCount===Fe?(Ve.deleteCount+=Re,Ve.toInsert.push(...Ne)):z.push({start:Fe,deleteCount:Re,toInsert:Ne})}let ce=0,ye=0;for(;;){if(ce===M.length){J(ce,0,O.slice(ye));break}if(ye===O.length){J(ce,M.length-ce,[]);break}const Fe=M[ce],Re=O[ye],Ne=B(Fe,Re);Ne===0?(ce+=1,ye+=1):Ne<0?(J(ce,1,[]),ce+=1):Ne>0&&(J(ce,0,[Re]),ye+=1)}return z}e.sortedDiff=i;function P(M,O,B){const z=i(M,O,B),J=[],ce=[];for(const ye of z)J.push(...M.slice(ye.start,ye.start+ye.deleteCount)),ce.push(...ye.toInsert);return{removed:J,added:ce}}e.delta=P;function u(M,O,B){if(B===0)return[];const z=M.slice(0,B).sort(O);return l(M,O,z,B,M.length),z}e.top=u;function p(M,O,B,z,J){return B===0?Promise.resolve([]):new Promise((ce,ye)=>{(async()=>{const Fe=M.length,Re=M.slice(0,B).sort(O);for(let Ne=B,Ve=Math.min(B+z,Fe);Ne<Fe;Ne=Ve,Ve=Math.min(Ve+z,Fe)){if(Ne>B&&await new Promise(ze=>setTimeout(ze)),J&&J.isCancellationRequested)throw(0,g.canceled)();l(M,O,Re,Ne,Ve)}return Re})().then(ce,ye)})}e.topAsync=p;function l(M,O,B,z,J){for(const ce=B.length;z<J;z++){const ye=M[z];if(O(ye,B[ce-1])<0){B.pop();const Fe=I(B,Re=>O(ye,Re)<0);B.splice(Fe,0,ye)}}}function c(M){return M.filter(O=>!!O)}e.coalesce=c;function S(M){let O=0;for(let B=0;B<M.length;B++)M[B]&&(M[O]=M[B],O+=1);M.length=O}e.coalesceInPlace=S;function w(M,O,B){M.splice(B,0,M.splice(O,1)[0])}e.move=w;function E(M){return!Array.isArray(M)||M.length===0}e.isFalsyOrEmpty=E;function d(M){return Array.isArray(M)&&M.length>0}e.isNonEmptyArray=d;function h(M,O){if(!O)return M.filter((z,J)=>M.indexOf(z)===J);const B=Object.create(null);return M.filter(z=>{const J=O(z);return B[J]?!1:(B[J]=!0,!0)})}e.distinct=h;function v(M){const O=new Set;return M.filter(B=>O.has(B)?!1:(O.add(B),!0))}e.distinctES6=v;function t(M){const O=Object.create(null);return B=>{const z=M(B);return O[z]?!1:(O[z]=!0,!0)}}e.uniqueFilter=t;function s(M,O){for(let B=M.length-1;B>=0;B--){const z=M[B];if(O(z))return B}return-1}e.lastIndex=s;function r(M,O){return M.length>0?M[0]:O}e.firstOrDefault=r;function n(M,O,B=(z,J)=>z===J){let z=0;for(let J=0,ce=Math.min(M.length,O.length);J<ce&&B(M[J],O[J]);J++)z++;return z}e.commonPrefixLength=n;function a(M){return[].concat(...M)}e.flatten=a;function f(M,O){let B=typeof O=="number"?M:0;typeof O=="number"?B=M:(B=0,O=M);const z=[];if(B<=O)for(let J=B;J<O;J++)z.push(J);else for(let J=B;J>O;J--)z.push(J);return z}e.range=f;function m(M,O,B){return M.reduce((z,J)=>(z[O(J)]=B?B(J):J,z),Object.create(null))}e.index=m;function b(M,O){return M.push(O),()=>_(M,O)}e.insert=b;function _(M,O){const B=M.indexOf(O);if(B>-1)return M.splice(B,1),O}e.remove=_;function o(M,O,B){const z=M.slice(0,O),J=M.slice(O);return z.concat(B,J)}e.arrayInsert=o;function A(M,O){let B;if(typeof O=="number"){let z=O;B=()=>{const J=Math.sin(z++)*179426549;return J-Math.floor(J)}}else B=Math.random;for(let z=M.length-1;z>0;z-=1){const J=Math.floor(B()*(z+1)),ce=M[z];M[z]=M[J],M[J]=ce}}e.shuffle=A;function F(M,O){const B=M.indexOf(O);B>-1&&(M.splice(B,1),M.unshift(O))}e.pushToStart=F;function $(M,O){const B=M.indexOf(O);B>-1&&(M.splice(B,1),M.push(O))}e.pushToEnd=$;function W(M,O){return Array.isArray(M)?M.map(O):O(M)}e.mapArrayOrNot=W;function Q(M){return Array.isArray(M)?M:[M]}e.asArray=Q;function H(M){return M[Math.floor(Math.random()*M.length)]}e.getRandomElement=H;function N(M,O){for(const B of M){const z=O(B);if(z!==void 0)return z}}e.mapFind=N;function x(M,O){let B=Number.MAX_SAFE_INTEGER,z=0;return M.forEach((J,ce)=>{const ye=O(J);ye<B&&(B=ye,z=ce)}),z}e.minIndex=x;function L(M,O){let B=Number.MIN_SAFE_INTEGER,z=0;return M.forEach((J,ce)=>{const ye=O(J);ye>B&&(B=ye,z=ce)}),z}e.maxIndex=L;class G{constructor(O){this.items=O,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(O){let B=this.firstIdx;for(;B<this.items.length&&O(this.items[B]);)B++;const z=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,z}takeFromEndWhile(O){let B=this.lastIdx;for(;B>=0&&O(this.items[B]);)B--;const z=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,z}}e.ArrayQueue=G}),define(he[70],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(R){const k=this;let y=!1,T;return function(){return y||(y=!0,T=R.apply(k,arguments)),T}}e.once=g}),define(he[71],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(he[54],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(R){function k(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}R.is=k;const y=Object.freeze([]);function T(){return y}R.empty=T;function*I(v){yield v}R.single=I;function D(v){return v||y}R.from=D;function C(v){return!v||v[Symbol.iterator]().next().done===!0}R.isEmpty=C;function i(v){return v[Symbol.iterator]().next().value}R.first=i;function P(v,t){for(const s of v)if(t(s))return!0;return!1}R.some=P;function u(v,t){for(const s of v)if(t(s))return s}R.find=u;function*p(v,t){for(const s of v)t(s)&&(yield s)}R.filter=p;function*l(v,t){let s=0;for(const r of v)yield t(r,s++)}R.map=l;function*c(...v){for(const t of v)for(const s of t)yield s}R.concat=c;function*S(v){for(const t of v)for(const s of t)yield s}R.concatNested=S;function w(v,t,s){let r=s;for(const n of v)r=t(r,n);return r}R.reduce=w;function*E(v,t,s=v.length){for(t<0&&(t+=v.length),s<0?s+=v.length:s>v.length&&(s=v.length);t<s;t++)yield v[t]}R.slice=E;function d(v,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,v];const r=v[Symbol.iterator]();for(let n=0;n<t;n++){const a=r.next();if(a.done)return[s,R.empty()];s.push(a.value)}return[s,{[Symbol.iterator](){return r}}]}R.consume=d;function h(v,t,s=(r,n)=>r===n){const r=v[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const a=r.next(),f=n.next();if(a.done!==f.done)return!1;if(a.done)return!0;if(!s(a.value,f.value))return!1}}R.equals=h})(g=e.Iterable||(e.Iterable={}))}),define(he[55],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function T(t,s=!1){let r=0,n=t.length,a="",f=0,m=16,b=0;function _(H){let N=0,x=0;for(;N<H;){const L=t.charCodeAt(r);if(L>=48&&L<=57)x=x*16+L-48;else if(L>=65&&L<=70)x=x*16+L-65+10;else if(L>=97&&L<=102)x=x*16+L-97+10;else break;r++,N++}return N<H&&(x=-1),x}function o(H){r=H,a="",f=0,m=16,b=0}function A(){const H=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&C(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&C(t.charCodeAt(r)))for(r++;r<t.length&&C(t.charCodeAt(r));)r++;else return b=3,t.substring(H,r);let N=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&C(t.charCodeAt(r))){for(r++;r<t.length&&C(t.charCodeAt(r));)r++;N=r}else b=3;return t.substring(H,N)}function F(){let H="",N=r;for(;;){if(r>=n){H+=t.substring(N,r),b=2;break}const x=t.charCodeAt(r);if(x===34){H+=t.substring(N,r),r++;break}if(x===92){if(H+=t.substring(N,r),r++,r>=n){b=2;break}switch(t.charCodeAt(r++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:const G=_(4);G>=0?H+=String.fromCharCode(G):b=4;break;default:b=5}N=r;continue}if(x>=0&&x<=31)if(D(x)){H+=t.substring(N,r),b=2;break}else b=6;r++}return H}function $(){if(a="",b=0,f=r,r>=n)return f=n,m=17;let H=t.charCodeAt(r);if(I(H)){do r++,a+=String.fromCharCode(H),H=t.charCodeAt(r);while(I(H));return m=15}if(D(H))return r++,a+=String.fromCharCode(H),H===13&&t.charCodeAt(r)===10&&(r++,a+=`
`),m=14;switch(H){case 123:return r++,m=1;case 125:return r++,m=2;case 91:return r++,m=3;case 93:return r++,m=4;case 58:return r++,m=6;case 44:return r++,m=5;case 34:return r++,a=F(),m=10;case 47:const N=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<n&&!D(t.charCodeAt(r));)r++;return a=t.substring(N,r),m=12}if(t.charCodeAt(r+1)===42){r+=2;const x=n-1;let L=!1;for(;r<x;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,L=!0;break}r++}return L||(r++,b=1),a=t.substring(N,r),m=13}return a+=String.fromCharCode(H),r++,m=16;case 45:if(a+=String.fromCharCode(H),r++,r===n||!C(t.charCodeAt(r)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=A(),m=11;default:for(;r<n&&W(H);)r++,H=t.charCodeAt(r);if(f!==r){switch(a=t.substring(f,r),a){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return a+=String.fromCharCode(H),r++,m=16}}function W(H){if(I(H)||D(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Q(){let H;do H=$();while(H>=12&&H<=15);return H}return{setPosition:o,getPosition:()=>r,scan:s?Q:$,getToken:()=>m,getTokenValue:()=>a,getTokenOffset:()=>f,getTokenLength:()=>r-f,getTokenError:()=>b}}e.createScanner=T;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function P(t,s){const r=[],n=new Object;let a;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function b(_,o,A,F){f.value=_,f.offset=o,f.length=A,f.type=F,f.colonOffset=void 0,a=f}try{d(t,{onObjectBegin:(_,o)=>{if(s<=_)throw n;a=void 0,m=s>_,r.push("")},onObjectProperty:(_,o,A)=>{if(s<o||(b(_,o,A,"property"),r[r.length-1]=_,s<=o+A))throw n},onObjectEnd:(_,o)=>{if(s<=_)throw n;a=void 0,r.pop()},onArrayBegin:(_,o)=>{if(s<=_)throw n;a=void 0,r.push(0)},onArrayEnd:(_,o)=>{if(s<=_)throw n;a=void 0,r.pop()},onLiteralValue:(_,o,A)=>{if(s<o||(b(_,o,A,v(_)),s<=o+A))throw n},onSeparator:(_,o,A)=>{if(s<=o)throw n;if(_===":"&&a&&a.type==="property")a.colonOffset=o,m=!1,a=void 0;else if(_===","){const F=r[r.length-1];typeof F=="number"?r[r.length-1]=F+1:(m=!0,r[r.length-1]=""),a=void 0}}})}catch(_){if(_!==n)throw _}return{path:r,previousNode:a,isAtPropertyKey:m,matches:_=>{let o=0;for(let A=0;o<_.length&&A<r.length;A++)if(_[o]===r[A]||_[o]==="*")o++;else if(_[o]!=="**")return!1;return o===_.length}}}e.getLocation=P;function u(t,s=[],r=y.DEFAULT){let n=null,a=[];const f=[];function m(_){Array.isArray(a)?a.push(_):n!==null&&(a[n]=_)}return d(t,{onObjectBegin:()=>{const _={};m(_),f.push(a),a=_,n=null},onObjectProperty:_=>{n=_},onObjectEnd:()=>{a=f.pop()},onArrayBegin:()=>{const _=[];m(_),f.push(a),a=_,n=null},onArrayEnd:()=>{a=f.pop()},onLiteralValue:m,onError:(_,o,A)=>{s.push({error:_,offset:o,length:A})}},r),a[0]}e.parse=u;function p(t,s=[],r=y.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(_){n.type==="property"&&(n.length=_-n.offset,n=n.parent)}function f(_){return n.children.push(_),_}d(t,{onObjectBegin:_=>{n=f({type:"object",offset:_,length:-1,parent:n,children:[]})},onObjectProperty:(_,o,A)=>{n=f({type:"property",offset:o,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:_,offset:o,length:A,parent:n})},onObjectEnd:(_,o)=>{n.length=_+o-n.offset,n=n.parent,a(_+o)},onArrayBegin:(_,o)=>{n=f({type:"array",offset:_,length:-1,parent:n,children:[]})},onArrayEnd:(_,o)=>{n.length=_+o-n.offset,n=n.parent,a(_+o)},onLiteralValue:(_,o,A)=>{f({type:v(_),offset:o,length:A,parent:n,value:_}),a(o+A)},onSeparator:(_,o,A)=>{n.type==="property"&&(_===":"?n.colonOffset=o:_===","&&a(o))},onError:(_,o,A)=>{s.push({error:_,offset:o,length:A})}},r);const b=n.children[0];return b&&delete b.parent,b}e.parseTree=p;function l(t,s){if(!t)return;let r=t;for(let n of s)if(typeof n=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const f of r.children)if(Array.isArray(f.children)&&f.children[0].value===n){r=f.children[1],a=!0;break}if(!a)return}else{const a=n;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}e.findNodeAtLocation=l;function c(t){if(!t.parent||!t.parent.children)return[];const s=c(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=c;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const s=Object.create(null);for(let r of t.children){const n=r.children[1];n&&(s[r.children[0].value]=S(n))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function w(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=w;function E(t,s,r=!1){if(w(t,s,r)){const n=t.children;if(Array.isArray(n))for(let a=0;a<n.length&&n[a].offset<=s;a++){const f=E(n[a],s,r);if(f)return f}return t}}e.findNodeAtOffset=E;function d(t,s,r=y.DEFAULT){const n=T(t,!1);function a(ce){return ce?()=>ce(n.getTokenOffset(),n.getTokenLength()):()=>!0}function f(ce){return ce?ye=>ce(ye,n.getTokenOffset(),n.getTokenLength()):()=>!0}const m=a(s.onObjectBegin),b=f(s.onObjectProperty),_=a(s.onObjectEnd),o=a(s.onArrayBegin),A=a(s.onArrayEnd),F=f(s.onLiteralValue),$=f(s.onSeparator),W=a(s.onComment),Q=f(s.onError),H=r&&r.disallowComments,N=r&&r.allowTrailingComma;function x(){for(;;){const ce=n.scan();switch(n.getTokenError()){case 4:L(14);break;case 5:L(15);break;case 3:L(13);break;case 1:H||L(11);break;case 2:L(12);break;case 6:L(16);break}switch(ce){case 12:case 13:H?L(10):W();break;case 16:L(1);break;case 15:case 14:break;default:return ce}}}function L(ce,ye=[],Fe=[]){if(Q(ce),ye.length+Fe.length>0){let Re=n.getToken();for(;Re!==17;){if(ye.indexOf(Re)!==-1){x();break}else if(Fe.indexOf(Re)!==-1)break;Re=x()}}}function G(ce){const ye=n.getTokenValue();return ce?F(ye):b(ye),x(),!0}function M(){switch(n.getToken()){case 11:let ce=0;try{ce=JSON.parse(n.getTokenValue()),typeof ce!="number"&&(L(2),ce=0)}catch(ye){L(2)}F(ce);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return x(),!0}function O(){return n.getToken()!==10?(L(3,[],[2,5]),!1):(G(!1),n.getToken()===6?($(":"),x(),J()||L(4,[],[2,5])):L(5,[],[2,5]),!0)}function B(){m(),x();let ce=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ce||L(4,[],[]),$(","),x(),n.getToken()===2&&N)break}else ce&&L(6,[],[]);O()||L(4,[],[2,5]),ce=!0}return _(),n.getToken()!==2?L(7,[2],[]):x(),!0}function z(){o(),x();let ce=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ce||L(4,[],[]),$(","),x(),n.getToken()===4&&N)break}else ce&&L(6,[],[]);J()||L(4,[],[4,5]),ce=!0}return A(),n.getToken()!==4?L(8,[4],[]):x(),!0}function J(){switch(n.getToken()){case 3:return z();case 1:return B();case 10:return G(!0);default:return M()}}return x(),n.getToken()===17?r.allowEmptyContent?!0:(L(4,[],[]),!1):J()?(n.getToken()!==17&&L(9,[],[]),!0):(L(4,[],[]),!1)}e.visit=d;function h(t,s){let r=T(t),n=[],a,f=0,m;do switch(m=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:f!==m&&n.push(t.substring(f,m)),s!==void 0&&n.push(r.getTokenValue().replace(/[^\r\n]/g,s)),f=r.getPosition();break}while(a!==17);return n.join("")}e.stripComments=h;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(he[133],fe([0,1,55]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(D,C,i){let P,u,p,l,c;if(C){for(l=C.offset,c=l+C.length,p=l;p>0&&!I(D,p-1);)p--;let f=c;for(;f<D.length&&!I(D,f);)f++;u=D.substring(p,f),P=y(u,i)}else u=D,P=0,p=0,l=0,c=D.length;const S=T(i,D);let w=!1,E=0,d;i.insertSpaces?d=k(" ",i.tabSize||4):d="	";const h=(0,g.createScanner)(u,!1);let v=!1;function t(){return S+k(d,P+E)}function s(){let f=h.scan();for(w=!1;f===15||f===14;)w=w||f===14,f=h.scan();return v=f===16||h.getTokenError()!==0,f}const r=[];function n(f,m,b){!v&&m<c&&b>l&&D.substring(m,b)!==f&&r.push({offset:m,length:b-m,content:f})}let a=s();if(a!==17){const f=h.getTokenOffset()+p,m=k(d,P);n(m,p,f)}for(;a!==17;){let f=h.getTokenOffset()+h.getTokenLength()+p,m=s(),b="";for(;!w&&(m===12||m===13);){const o=h.getTokenOffset()+p;n(" ",f,o),f=h.getTokenOffset()+h.getTokenLength()+p,b=m===12?t():"",m=s()}if(m===2)a!==1&&(E--,b=t());else if(m===4)a!==3&&(E--,b=t());else{switch(a){case 3:case 1:E++,b=t();break;case 5:case 12:b=t();break;case 13:w?b=t():b=" ";break;case 6:b=" ";break;case 10:if(m===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?b=" ":m!==5&&m!==17&&(v=!0);break;case 16:v=!0;break}w&&(m===12||m===13)&&(b=t())}const _=h.getTokenOffset()+p;n(b,f,_),a=m}return r}e.format=R;function k(D,C){let i="";for(let P=0;P<C;P++)i+=D;return i}function y(D,C){let i=0,P=0;const u=C.tabSize||4;for(;i<D.length;){const p=D.charAt(i);if(p===" ")P++;else if(p==="	")P+=u;else break;i++}return Math.floor(P/u)}function T(D,C){for(let i=0;i<C.length;i++){const P=C.charAt(i);if(P==="\r")return i+1<C.length&&C.charAt(i+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=T;function I(D,C){return`\r
`.indexOf(D.charAt(C))!==-1}e.isEOL=I}),define(he[134],fe([0,1,55,133]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(C,i,P){return y(C,i,void 0,P)}e.removeProperty=k;function y(C,i,P,u,p){const l=i.slice(),c=[],S=(0,g.parseTree)(C,c);let w,E;for(;l.length>0&&(E=l.pop(),w=(0,g.findNodeAtLocation)(S,l),w===void 0&&P!==void 0);)typeof E=="string"?P={[E]:P}:P=[P];if(w)if(w.type==="object"&&typeof E=="string"&&Array.isArray(w.children)){const d=(0,g.findNodeAtLocation)(w,[E]);if(d!==void 0)if(P===void 0){if(!d.parent)throw new Error("Malformed AST");const h=w.children.indexOf(d.parent);let v,t=d.parent.offset+d.parent.length;if(h>0){const s=w.children[h-1];v=s.offset+s.length}else v=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return T(C,{offset:v,length:t-v,content:""},u)}else return T(C,{offset:d.offset,length:d.length,content:JSON.stringify(P)},u);else{if(P===void 0)return[];const h=`${JSON.stringify(E)}: ${JSON.stringify(P)}`,v=p?p(w.children.map(s=>s.children[0].value)):w.children.length;let t;if(v>0){const s=w.children[v-1];t={offset:s.offset+s.length,length:0,content:","+h}}else w.children.length===0?t={offset:w.offset+1,length:0,content:h}:t={offset:w.offset+1,length:0,content:h+","};return T(C,t,u)}}else if(w.type==="array"&&typeof E=="number"&&Array.isArray(w.children))if(P!==void 0){const d=`${JSON.stringify(P)}`;let h;if(w.children.length===0||E===0)h={offset:w.offset+1,length:0,content:w.children.length===0?d:d+","};else{const v=E===-1||E>w.children.length?w.children.length:E,t=w.children[v-1];h={offset:t.offset+t.length,length:0,content:","+d}}return T(C,h,u)}else{const d=E,h=w.children[d];let v;if(w.children.length===1)v={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===d){const t=w.children[d-1],s=t.offset+t.length,r=w.offset+w.length;v={offset:s,length:r-2-s,content:""}}else v={offset:h.offset,length:w.children[d+1].offset-h.offset,content:""};return T(C,v,u)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${w.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return T(C,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(P)},u)}}e.setProperty=y;function T(C,i,P){let u=I(C,i),p=i.offset,l=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!(0,R.isEOL)(u,p-1);)p--;for(;l<u.length&&!(0,R.isEOL)(u,l);)l++}const c=(0,R.format)(u,{offset:p,length:l-p},P);for(let w=c.length-1;w>=0;w--){const E=c[w];u=I(u,E),p=Math.min(p,E.offset),l=Math.max(l,E.offset+E.length),l+=E.content.length-E.length}const S=C.length-(u.length-l)-p;return[{offset:p,length:S,content:u.substring(p,l)}]}e.withFormatting=T;function I(C,i){return C.substring(0,i.offset)+i.content+C.substring(i.offset+i.length)}e.applyEdit=I;function D(C,i){let P=i.slice(0).sort((p,l)=>{const c=p.offset-l.offset;return c===0?p.length-l.length:c}),u=C.length;for(let p=P.length-1;p>=0;p--){let l=P[p];if(l.offset+l.length<=u)C=I(C,l);else throw new Error("Overlapping edit");u=l.offset}return C}e.applyEdits=D}),define(he[135],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new g(()=>k(this.getValue()))}}e.Lazy=g}),define(he[6],fe([0,1,70,54]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let y=null;function T(s){y=s}if(e.setDisposableTracker=T,k){const s="__is_disposable_tracked__";T(new class{trackDisposable(r){const n=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[s]||console.log(n)},3e3)}setParent(r,n){if(r&&r!==E.None)try{r[s]=!0}catch{}}markAsDisposed(r){if(r&&r!==E.None)try{r[s]=!0}catch{}}markAsSingleton(r){}})}function I(s){return y?.trackDisposable(s),s}function D(s){y?.markAsDisposed(s)}function C(s,r){y?.setParent(s,r)}function i(s,r){if(!!y)for(const n of s)y.setParent(n,r)}function P(s){return y?.markAsSingleton(s),s}e.markAsSingleton=P;class u extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=u;function p(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=p;function l(s){if(R.Iterable.is(s)){let r=[];for(const n of s)if(n)try{n.dispose()}catch(a){r.push(a)}if(r.length===1)throw r[0];if(r.length>1)throw new u(r);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=l;function c(...s){const r=S(()=>l(s));return i(s,r),r}e.combinedDisposable=c;function S(s){const r=I({dispose:(0,g.once)(()=>{D(r),s()})});return r}e.toDisposable=S;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{l(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return C(r,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new w,I(this),C(this._store,this)}dispose(){D(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&C(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,D(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&C(r,null),r}}e.MutableDisposable=d;class h{constructor(){this.references=new Map}acquire(r,...n){let a=this.references.get(r);a||(a={counter:0,object:this.createReferencedObject(r,...n)},this.references.set(r,a));const{object:f}=a,m=(0,g.once)(()=>{--a.counter==0&&(this.destroyReferencedObject(r,a.object),this.references.delete(r))});return a.counter++,{object:f,dispose:m}}}e.ReferenceCollection=h;class v{constructor(r){this.referenceCollection=r}async acquire(r,...n){const a=this.referenceCollection.acquire(r,...n);try{return{object:await a.object,dispose:()=>a.dispose()}}catch(f){throw a.dispose(),f}}}e.AsyncReferenceCollection=v;class t{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=t}),define(he[91],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(y){this.element=y,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class R{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let y=this._first;for(;y!==g.Undefined;){const T=y.next;y.prev=g.Undefined,y.next=g.Undefined,y=T}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,T){const I=new g(y);if(this._first===g.Undefined)this._first=I,this._last=I;else if(T){const C=this._last;this._last=I,I.prev=C,C.next=I}else{const C=this._first;this._first=I,I.next=C,C.prev=I}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(I))}}shift(){if(this._first!==g.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==g.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==g.Undefined&&y.next!==g.Undefined){const T=y.prev;T.next=y.next,y.next.prev=T}else y.prev===g.Undefined&&y.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):y.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):y.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==g.Undefined;)yield y.element,y=y.next}}e.LinkedList=R}),function(X,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(X=typeof globalThis!="undefined"?globalThis:X||self,X.marked=e())}(this,function(){"use strict";function X(Pe,Ce){for(var Ae=0;Ae<Ce.length;Ae++){var se=Ce[Ae];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Pe,se.key,se)}}function e(Pe,Ce,Ae){return Ce&&X(Pe.prototype,Ce),Ae&&X(Pe,Ae),Pe}function g(Pe,Ce){if(!!Pe){if(typeof Pe=="string")return R(Pe,Ce);var Ae=Object.prototype.toString.call(Pe).slice(8,-1);if(Ae==="Object"&&Pe.constructor&&(Ae=Pe.constructor.name),Ae==="Map"||Ae==="Set")return Array.from(Pe);if(Ae==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ae))return R(Pe,Ce)}}function R(Pe,Ce){(Ce==null||Ce>Pe.length)&&(Ce=Pe.length);for(var Ae=0,se=new Array(Ce);Ae<Ce;Ae++)se[Ae]=Pe[Ae];return se}function k(Pe,Ce){var Ae;if(typeof Symbol=="undefined"||Pe[Symbol.iterator]==null){if(Array.isArray(Pe)||(Ae=g(Pe))||Ce&&Pe&&typeof Pe.length=="number"){Ae&&(Pe=Ae);var se=0;return function(){return se>=Pe.length?{done:!0}:{done:!1,value:Pe[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ae=Pe[Symbol.iterator](),Ae.next.bind(Ae)}function y(Pe){var Ce={exports:{}};return Pe(Ce,Ce.exports),Ce.exports}var T=y(function(Pe){function Ce(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ae(se){Pe.exports.defaults=se}Pe.exports={defaults:Ce(),getDefaults:Ce,changeDefaults:Ae}}),I=/[&<>"']/,D=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},u=function(Ce){return P[Ce]};function p(Pe,Ce){if(Ce){if(I.test(Pe))return Pe.replace(D,u)}else if(C.test(Pe))return Pe.replace(i,u);return Pe}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(Pe){return Pe.replace(l,function(Ce,Ae){return Ae=Ae.toLowerCase(),Ae==="colon"?":":Ae.charAt(0)==="#"?Ae.charAt(1)==="x"?String.fromCharCode(parseInt(Ae.substring(2),16)):String.fromCharCode(+Ae.substring(1)):""})}var S=/(^|[^\[])\^/g;function w(Pe,Ce){Pe=Pe.source||Pe,Ce=Ce||"";var Ae={replace:function(le,me){return me=me.source||me,me=me.replace(S,"$1"),Pe=Pe.replace(le,me),Ae},getRegex:function(){return new RegExp(Pe,Ce)}};return Ae}var E=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Pe,Ce,Ae){if(Pe){var se;try{se=decodeURIComponent(c(Ae)).replace(E,"").toLowerCase()}catch(le){return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Ce&&!d.test(Ae)&&(Ae=n(Ce,Ae));try{Ae=encodeURI(Ae).replace(/%25/g,"%")}catch(le){return null}return Ae}var v={},t=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(Pe,Ce){v[" "+Pe]||(t.test(Pe)?v[" "+Pe]=Pe+"/":v[" "+Pe]=b(Pe,"/",!0)),Pe=v[" "+Pe];var Ae=Pe.indexOf(":")===-1;return Ce.substring(0,2)==="//"?Ae?Ce:Pe.replace(s,"$1")+Ce:Ce.charAt(0)==="/"?Ae?Ce:Pe.replace(r,"$1")+Ce:Pe+Ce}var a={exec:function(){}};function f(Pe){for(var Ce=1,Ae,se;Ce<arguments.length;Ce++){Ae=arguments[Ce];for(se in Ae)Object.prototype.hasOwnProperty.call(Ae,se)&&(Pe[se]=Ae[se])}return Pe}function m(Pe,Ce){var Ae=Pe.replace(/\|/g,function(me,we,q){for(var ge=!1,_e=we;--_e>=0&&q[_e]==="\\";)ge=!ge;return ge?"|":" |"}),se=Ae.split(/ \|/),le=0;if(se.length>Ce)se.splice(Ce);else for(;se.length<Ce;)se.push("");for(;le<se.length;le++)se[le]=se[le].trim().replace(/\\\|/g,"|");return se}function b(Pe,Ce,Ae){var se=Pe.length;if(se===0)return"";for(var le=0;le<se;){var me=Pe.charAt(se-le-1);if(me===Ce&&!Ae)le++;else if(me!==Ce&&Ae)le++;else break}return Pe.substr(0,se-le)}function _(Pe,Ce){if(Pe.indexOf(Ce[1])===-1)return-1;for(var Ae=Pe.length,se=0,le=0;le<Ae;le++)if(Pe[le]==="\\")le++;else if(Pe[le]===Ce[0])se++;else if(Pe[le]===Ce[1]&&(se--,se<0))return le;return-1}function o(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Pe,Ce){if(Ce<1)return"";for(var Ae="";Ce>1;)Ce&1&&(Ae+=Pe),Ce>>=1,Pe+=Pe;return Ae+Pe}var F={escape:p,unescape:c,edit:w,cleanUrl:h,resolveUrl:n,noopTest:a,merge:f,splitCells:m,rtrim:b,findClosingBracket:_,checkSanitizeDeprecation:o,repeatString:A},$=T.defaults,W=F.rtrim,Q=F.splitCells,H=F.escape,N=F.findClosingBracket;function x(Pe,Ce,Ae){var se=Ce.href,le=Ce.title?H(Ce.title):null,me=Pe[1].replace(/\\([\[\]])/g,"$1");return Pe[0].charAt(0)!=="!"?{type:"link",raw:Ae,href:se,title:le,text:me}:{type:"image",raw:Ae,href:se,title:le,text:H(me)}}function L(Pe,Ce){var Ae=Pe.match(/^(\s+)(?:```)/);if(Ae===null)return Ce;var se=Ae[1];return Ce.split(`
`).map(function(le){var me=le.match(/^\s+/);if(me===null)return le;var we=me[0];return we.length>=se.length?le.slice(se.length):le}).join(`
`)}var G=function(){function Pe(Ae){this.options=Ae||$}var Ce=Pe.prototype;return Ce.space=function(se){var le=this.rules.block.newline.exec(se);if(le)return le[0].length>1?{type:"space",raw:le[0]}:{raw:`
`}},Ce.code=function(se){var le=this.rules.block.code.exec(se);if(le){var me=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?me:W(me,`
`)}}},Ce.fences=function(se){var le=this.rules.block.fences.exec(se);if(le){var me=le[0],we=L(me,le[3]||"");return{type:"code",raw:me,lang:le[2]?le[2].trim():le[2],text:we}}},Ce.heading=function(se){var le=this.rules.block.heading.exec(se);if(le){var me=le[2].trim();if(/#$/.test(me)){var we=W(me,"#");(this.options.pedantic||!we||/ $/.test(we))&&(me=we.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:me}}},Ce.nptable=function(se){var le=this.rules.block.nptable.exec(se);if(le){var me={type:"table",header:Q(le[1].replace(/^ *| *\| *$/g,"")),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:le[3]?le[3].replace(/\n$/,"").split(`
`):[],raw:le[0]};if(me.header.length===me.align.length){var we=me.align.length,q;for(q=0;q<we;q++)/^ *-+: *$/.test(me.align[q])?me.align[q]="right":/^ *:-+: *$/.test(me.align[q])?me.align[q]="center":/^ *:-+ *$/.test(me.align[q])?me.align[q]="left":me.align[q]=null;for(we=me.cells.length,q=0;q<we;q++)me.cells[q]=Q(me.cells[q],me.header.length);return me}}},Ce.hr=function(se){var le=this.rules.block.hr.exec(se);if(le)return{type:"hr",raw:le[0]}},Ce.blockquote=function(se){var le=this.rules.block.blockquote.exec(se);if(le){var me=le[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:le[0],text:me}}},Ce.list=function(se){var le=this.rules.block.list.exec(se);if(le){var me=le[0],we=le[2],q=we.length>1,ge={type:"list",raw:me,ordered:q,start:q?+we.slice(0,-1):"",loose:!1,items:[]},_e=le[0].match(this.rules.block.item),Te=!1,Oe,Ge,et,Qe,Xe,lt,ut,Ee,Se=_e.length;et=this.rules.block.listItemStart.exec(_e[0]);for(var ae=0;ae<Se;ae++){if(Oe=_e[ae],me=Oe,ae!==Se-1){if(Qe=this.rules.block.listItemStart.exec(_e[ae+1]),this.options.pedantic?Qe[1].length>et[1].length:Qe[1].length>et[0].length||Qe[1].length>3){_e.splice(ae,2,_e[ae]+`
`+_e[ae+1]),ae--,Se--;continue}else(!this.options.pedantic||this.options.smartLists?Qe[2][Qe[2].length-1]!==we[we.length-1]:q===(Qe[2].length===1))&&(Xe=_e.slice(ae+1).join(`
`),ge.raw=ge.raw.substring(0,ge.raw.length-Xe.length),ae=Se-1);et=Qe}Ge=Oe.length,Oe=Oe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Oe.indexOf(`
 `)&&(Ge-=Oe.length,Oe=this.options.pedantic?Oe.replace(/^ {1,4}/gm,""):Oe.replace(new RegExp("^ {1,"+Ge+"}","gm"),"")),lt=Te||/\n\n(?!\s*$)/.test(Oe),ae!==Se-1&&(Te=Oe.charAt(Oe.length-1)===`
`,lt||(lt=Te)),lt&&(ge.loose=!0),this.options.gfm&&(ut=/^\[[ xX]\] /.test(Oe),Ee=void 0,ut&&(Ee=Oe[1]!==" ",Oe=Oe.replace(/^\[[ xX]\] +/,""))),ge.items.push({type:"list_item",raw:me,task:ut,checked:Ee,loose:lt,text:Oe})}return ge}},Ce.html=function(se){var le=this.rules.block.html.exec(se);if(le)return{type:this.options.sanitize?"paragraph":"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):H(le[0]):le[0]}},Ce.def=function(se){var le=this.rules.block.def.exec(se);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var me=le[1].toLowerCase().replace(/\s+/g," ");return{tag:me,raw:le[0],href:le[2],title:le[3]}}},Ce.table=function(se){var le=this.rules.block.table.exec(se);if(le){var me={type:"table",header:Q(le[1].replace(/^ *| *\| *$/g,"")),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:le[3]?le[3].replace(/\n$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=le[0];var we=me.align.length,q;for(q=0;q<we;q++)/^ *-+: *$/.test(me.align[q])?me.align[q]="right":/^ *:-+: *$/.test(me.align[q])?me.align[q]="center":/^ *:-+ *$/.test(me.align[q])?me.align[q]="left":me.align[q]=null;for(we=me.cells.length,q=0;q<we;q++)me.cells[q]=Q(me.cells[q].replace(/^ *\| *| *\| *$/g,""),me.header.length);return me}}},Ce.lheading=function(se){var le=this.rules.block.lheading.exec(se);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1]}},Ce.paragraph=function(se){var le=this.rules.block.paragraph.exec(se);if(le)return{type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1]}},Ce.text=function(se){var le=this.rules.block.text.exec(se);if(le)return{type:"text",raw:le[0],text:le[0]}},Ce.escape=function(se){var le=this.rules.inline.escape.exec(se);if(le)return{type:"escape",raw:le[0],text:H(le[1])}},Ce.tag=function(se,le,me){var we=this.rules.inline.tag.exec(se);if(we)return!le&&/^<a /i.test(we[0])?le=!0:le&&/^<\/a>/i.test(we[0])&&(le=!1),!me&&/^<(pre|code|kbd|script)(\s|>)/i.test(we[0])?me=!0:me&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(we[0])&&(me=!1),{type:this.options.sanitize?"text":"html",raw:we[0],inLink:le,inRawBlock:me,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):H(we[0]):we[0]}},Ce.link=function(se){var le=this.rules.inline.link.exec(se);if(le){var me=le[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var we=W(me.slice(0,-1),"\\");if((me.length-we.length)%2==0)return}else{var q=N(le[2],"()");if(q>-1){var ge=le[0].indexOf("!")===0?5:4,_e=ge+le[1].length+q;le[2]=le[2].substring(0,q),le[0]=le[0].substring(0,_e).trim(),le[3]=""}}var Te=le[2],Oe="";if(this.options.pedantic){var Ge=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Te);Ge&&(Te=Ge[1],Oe=Ge[3])}else Oe=le[3]?le[3].slice(1,-1):"";return Te=Te.trim(),/^</.test(Te)&&(this.options.pedantic&&!/>$/.test(me)?Te=Te.slice(1):Te=Te.slice(1,-1)),x(le,{href:Te&&Te.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},le[0])}},Ce.reflink=function(se,le){var me;if((me=this.rules.inline.reflink.exec(se))||(me=this.rules.inline.nolink.exec(se))){var we=(me[2]||me[1]).replace(/\s+/g," ");if(we=le[we.toLowerCase()],!we||!we.href){var q=me[0].charAt(0);return{type:"text",raw:q,text:q}}return x(me,we,me[0])}},Ce.emStrong=function(se,le,me){me===void 0&&(me="");var we=this.rules.inline.emStrong.lDelim.exec(se);if(!!we&&!(we[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var q=we[1]||we[2]||"";if(!q||q&&(me===""||this.rules.inline.punctuation.exec(me))){var ge=we[0].length-1,_e,Te,Oe=ge,Ge=0,et=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(et.lastIndex=0,le=le.slice(-1*se.length+ge);(we=et.exec(le))!=null;)if(_e=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!_e){if(Te=_e.length,we[3]||we[4]){Oe+=Te;continue}else if((we[5]||we[6])&&ge%3&&!((ge+Te)%3)){Ge+=Te;continue}if(Oe-=Te,!(Oe>0)){if(Oe+Ge-Te<=0&&!le.slice(et.lastIndex).match(et)&&(Te=Math.min(Te,Te+Oe+Ge)),Math.min(ge,Te)%2)return{type:"em",raw:se.slice(0,ge+we.index+Te+1),text:se.slice(1,ge+we.index+Te)};if(Math.min(ge,Te)%2==0)return{type:"strong",raw:se.slice(0,ge+we.index+Te+1),text:se.slice(2,ge+we.index+Te-1)}}}}}},Ce.codespan=function(se){var le=this.rules.inline.code.exec(se);if(le){var me=le[2].replace(/\n/g," "),we=/[^ ]/.test(me),q=/^ /.test(me)&&/ $/.test(me);return we&&q&&(me=me.substring(1,me.length-1)),me=H(me,!0),{type:"codespan",raw:le[0],text:me}}},Ce.br=function(se){var le=this.rules.inline.br.exec(se);if(le)return{type:"br",raw:le[0]}},Ce.del=function(se){var le=this.rules.inline.del.exec(se);if(le)return{type:"del",raw:le[0],text:le[2]}},Ce.autolink=function(se,le){var me=this.rules.inline.autolink.exec(se);if(me){var we,q;return me[2]==="@"?(we=H(this.options.mangle?le(me[1]):me[1]),q="mailto:"+we):(we=H(me[1]),q=we),{type:"link",raw:me[0],text:we,href:q,tokens:[{type:"text",raw:we,text:we}]}}},Ce.url=function(se,le){var me;if(me=this.rules.inline.url.exec(se)){var we,q;if(me[2]==="@")we=H(this.options.mangle?le(me[0]):me[0]),q="mailto:"+we;else{var ge;do ge=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(ge!==me[0]);we=H(me[0]),me[1]==="www."?q="http://"+we:q=we}return{type:"link",raw:me[0],text:we,href:q,tokens:[{type:"text",raw:we,text:we}]}}},Ce.inlineText=function(se,le,me){var we=this.rules.inline.text.exec(se);if(we){var q;return le?q=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):H(we[0]):we[0]:q=H(this.options.smartypants?me(we[0]):we[0]),{type:"text",raw:we[0],text:q}}},Pe}(),M=F.noopTest,O=F.edit,B=F.merge,z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=O(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,z.item=O(z.item,"gm").replace(/bull/g,z.bullet).getRegex(),z.listItemStart=O(/^( *)(bull)/).replace("bull",z.bullet).getRegex(),z.list=O(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=O(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=O(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.blockquote=O(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=B({},z),z.gfm=B({},z.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.nptable=O(z.gfm.nptable).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.gfm.table=O(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.pedantic=B({},z.normal,{html:O(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:O(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var J={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};J._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",J.punctuation=O(J.punctuation).replace(/punctuation/g,J._punctuation).getRegex(),J.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,J.escapedEmSt=/\\\*|\\_/g,J._comment=O(z._comment).replace("(?:-->|$)","-->").getRegex(),J.emStrong.lDelim=O(J.emStrong.lDelim).replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimAst=O(J.emStrong.rDelimAst,"g").replace(/punct/g,J._punctuation).getRegex(),J.emStrong.rDelimUnd=O(J.emStrong.rDelimUnd,"g").replace(/punct/g,J._punctuation).getRegex(),J._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,J._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,J._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,J.autolink=O(J.autolink).replace("scheme",J._scheme).replace("email",J._email).getRegex(),J._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,J.tag=O(J.tag).replace("comment",J._comment).replace("attribute",J._attribute).getRegex(),J._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,J._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,J._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,J.link=O(J.link).replace("label",J._label).replace("href",J._href).replace("title",J._title).getRegex(),J.reflink=O(J.reflink).replace("label",J._label).getRegex(),J.reflinkSearch=O(J.reflinkSearch,"g").replace("reflink",J.reflink).replace("nolink",J.nolink).getRegex(),J.normal=B({},J),J.pedantic=B({},J.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:O(/^!?\[(label)\]\((.*?)\)/).replace("label",J._label).getRegex(),reflink:O(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",J._label).getRegex()}),J.gfm=B({},J.normal,{escape:O(J.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),J.gfm.url=O(J.gfm.url,"i").replace("email",J.gfm._extended_email).getRegex(),J.breaks=B({},J.gfm,{br:O(J.br).replace("{2,}","*").getRegex(),text:O(J.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ce={block:z,inline:J},ye=T.defaults,Fe=ce.block,Re=ce.inline,Ne=F.repeatString;function Ve(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ze(Pe){var Ce="",Ae,se,le=Pe.length;for(Ae=0;Ae<le;Ae++)se=Pe.charCodeAt(Ae),Math.random()>.5&&(se="x"+se.toString(16)),Ce+="&#"+se+";";return Ce}var j=function(){function Pe(Ae){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ae||ye,this.options.tokenizer=this.options.tokenizer||new G,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var se={block:Fe.normal,inline:Re.normal};this.options.pedantic?(se.block=Fe.pedantic,se.inline=Re.pedantic):this.options.gfm&&(se.block=Fe.gfm,this.options.breaks?se.inline=Re.breaks:se.inline=Re.gfm),this.tokenizer.rules=se}Pe.lex=function(se,le){var me=new Pe(le);return me.lex(se)},Pe.lexInline=function(se,le){var me=new Pe(le);return me.inlineTokens(se)};var Ce=Pe.prototype;return Ce.lex=function(se){return se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens,!0),this.inline(this.tokens),this.tokens},Ce.blockTokens=function(se,le,me){le===void 0&&(le=[]),me===void 0&&(me=!0),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var we,q,ge,_e;se;){if(we=this.tokenizer.space(se)){se=se.substring(we.raw.length),we.type&&le.push(we);continue}if(we=this.tokenizer.code(se)){se=se.substring(we.raw.length),_e=le[le.length-1],_e&&_e.type==="paragraph"?(_e.raw+=`
`+we.raw,_e.text+=`
`+we.text):le.push(we);continue}if(we=this.tokenizer.fences(se)){se=se.substring(we.raw.length),le.push(we);continue}if(we=this.tokenizer.heading(se)){se=se.substring(we.raw.length),le.push(we);continue}if(we=this.tokenizer.nptable(se)){se=se.substring(we.raw.length),le.push(we);continue}if(we=this.tokenizer.hr(se)){se=se.substring(we.raw.length),le.push(we);continue}if(we=this.tokenizer.blockquote(se)){se=se.substring(we.raw.length),we.tokens=this.blockTokens(we.text,[],me),le.push(we);continue}if(we=this.tokenizer.list(se)){for(se=se.substring(we.raw.length),ge=we.items.length,q=0;q<ge;q++)we.items[q].tokens=this.blockTokens(we.items[q].text,[],!1);le.push(we);continue}if(we=this.tokenizer.html(se)){se=se.substring(we.raw.length),le.push(we);continue}if(me&&(we=this.tokenizer.def(se))){se=se.substring(we.raw.length),this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(se)){se=se.substring(we.raw.length),le.push(we);continue}if(we=this.tokenizer.lheading(se)){se=se.substring(we.raw.length),le.push(we);continue}if(me&&(we=this.tokenizer.paragraph(se))){se=se.substring(we.raw.length),le.push(we);continue}if(we=this.tokenizer.text(se)){se=se.substring(we.raw.length),_e=le[le.length-1],_e&&_e.type==="text"?(_e.raw+=`
`+we.raw,_e.text+=`
`+we.text):le.push(we);continue}if(se){var Te="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return le},Ce.inline=function(se){var le,me,we,q,ge,_e,Te=se.length;for(le=0;le<Te;le++)switch(_e=se[le],_e.type){case"paragraph":case"text":case"heading":{_e.tokens=[],this.inlineTokens(_e.text,_e.tokens);break}case"table":{for(_e.tokens={header:[],cells:[]},q=_e.header.length,me=0;me<q;me++)_e.tokens.header[me]=[],this.inlineTokens(_e.header[me],_e.tokens.header[me]);for(q=_e.cells.length,me=0;me<q;me++)for(ge=_e.cells[me],_e.tokens.cells[me]=[],we=0;we<ge.length;we++)_e.tokens.cells[me][we]=[],this.inlineTokens(ge[we],_e.tokens.cells[me][we]);break}case"blockquote":{this.inline(_e.tokens);break}case"list":{for(q=_e.items.length,me=0;me<q;me++)this.inline(_e.items[me].tokens);break}}return se},Ce.inlineTokens=function(se,le,me,we){le===void 0&&(le=[]),me===void 0&&(me=!1),we===void 0&&(we=!1);var q,ge,_e=se,Te,Oe,Ge;if(this.tokens.links){var et=Object.keys(this.tokens.links);if(et.length>0)for(;(Te=this.tokenizer.rules.inline.reflinkSearch.exec(_e))!=null;)et.includes(Te[0].slice(Te[0].lastIndexOf("[")+1,-1))&&(_e=_e.slice(0,Te.index)+"["+Ne("a",Te[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Te=this.tokenizer.rules.inline.blockSkip.exec(_e))!=null;)_e=_e.slice(0,Te.index)+"["+Ne("a",Te[0].length-2)+"]"+_e.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Te=this.tokenizer.rules.inline.escapedEmSt.exec(_e))!=null;)_e=_e.slice(0,Te.index)+"++"+_e.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;){if(Oe||(Ge=""),Oe=!1,q=this.tokenizer.escape(se)){se=se.substring(q.raw.length),le.push(q);continue}if(q=this.tokenizer.tag(se,me,we)){se=se.substring(q.raw.length),me=q.inLink,we=q.inRawBlock;var Qe=le[le.length-1];Qe&&q.type==="text"&&Qe.type==="text"?(Qe.raw+=q.raw,Qe.text+=q.text):le.push(q);continue}if(q=this.tokenizer.link(se)){se=se.substring(q.raw.length),q.type==="link"&&(q.tokens=this.inlineTokens(q.text,[],!0,we)),le.push(q);continue}if(q=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(q.raw.length);var Xe=le[le.length-1];q.type==="link"?(q.tokens=this.inlineTokens(q.text,[],!0,we),le.push(q)):Xe&&q.type==="text"&&Xe.type==="text"?(Xe.raw+=q.raw,Xe.text+=q.text):le.push(q);continue}if(q=this.tokenizer.emStrong(se,_e,Ge)){se=se.substring(q.raw.length),q.tokens=this.inlineTokens(q.text,[],me,we),le.push(q);continue}if(q=this.tokenizer.codespan(se)){se=se.substring(q.raw.length),le.push(q);continue}if(q=this.tokenizer.br(se)){se=se.substring(q.raw.length),le.push(q);continue}if(q=this.tokenizer.del(se)){se=se.substring(q.raw.length),q.tokens=this.inlineTokens(q.text,[],me,we),le.push(q);continue}if(q=this.tokenizer.autolink(se,ze)){se=se.substring(q.raw.length),le.push(q);continue}if(!me&&(q=this.tokenizer.url(se,ze))){se=se.substring(q.raw.length),le.push(q);continue}if(q=this.tokenizer.inlineText(se,we,Ve)){se=se.substring(q.raw.length),q.raw.slice(-1)!=="_"&&(Ge=q.raw.slice(-1)),Oe=!0,ge=le[le.length-1],ge&&ge.type==="text"?(ge.raw+=q.raw,ge.text+=q.text):le.push(q);continue}if(se){var lt="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(lt);break}else throw new Error(lt)}}return le},e(Pe,null,[{key:"rules",get:function(){return{block:Fe,inline:Re}}}]),Pe}(),Z=T.defaults,ie=F.cleanUrl,oe=F.escape,ve=function(){function Pe(Ae){this.options=Ae||Z}var Ce=Pe.prototype;return Ce.code=function(se,le,me){var we=(le||"").match(/\S*/)[0];if(this.options.highlight){var q=this.options.highlight(se,we);q!=null&&q!==se&&(me=!0,se=q)}return se=se.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+oe(we,!0)+'">'+(me?se:oe(se,!0))+`</code></pre>
`:"<pre><code>"+(me?se:oe(se,!0))+`</code></pre>
`},Ce.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Ce.html=function(se){return se},Ce.heading=function(se,le,me,we){return this.options.headerIds?"<h"+le+' id="'+this.options.headerPrefix+we.slug(me)+'">'+se+"</h"+le+`>
`:"<h"+le+">"+se+"</h"+le+`>
`},Ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ce.list=function(se,le,me){var we=le?"ol":"ul",q=le&&me!==1?' start="'+me+'"':"";return"<"+we+q+`>
`+se+"</"+we+`>
`},Ce.listitem=function(se){return"<li>"+se+`</li>
`},Ce.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ce.paragraph=function(se){return"<p>"+se+`</p>
`},Ce.table=function(se,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+le+`</table>
`},Ce.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Ce.tablecell=function(se,le){var me=le.header?"th":"td",we=le.align?"<"+me+' align="'+le.align+'">':"<"+me+">";return we+se+"</"+me+`>
`},Ce.strong=function(se){return"<strong>"+se+"</strong>"},Ce.em=function(se){return"<em>"+se+"</em>"},Ce.codespan=function(se){return"<code>"+se+"</code>"},Ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ce.del=function(se){return"<del>"+se+"</del>"},Ce.link=function(se,le,me){if(se=ie(this.options.sanitize,this.options.baseUrl,se),se===null)return me;var we='<a href="'+oe(se)+'"';return le&&(we+=' title="'+le+'"'),we+=">"+me+"</a>",we},Ce.image=function(se,le,me){if(se=ie(this.options.sanitize,this.options.baseUrl,se),se===null)return me;var we='<img src="'+se+'" alt="'+me+'"';return le&&(we+=' title="'+le+'"'),we+=this.options.xhtml?"/>":">",we},Ce.text=function(se){return se},Pe}(),ee=function(){function Pe(){}var Ce=Pe.prototype;return Ce.strong=function(se){return se},Ce.em=function(se){return se},Ce.codespan=function(se){return se},Ce.del=function(se){return se},Ce.html=function(se){return se},Ce.text=function(se){return se},Ce.link=function(se,le,me){return""+me},Ce.image=function(se,le,me){return""+me},Ce.br=function(){return""},Pe}(),ue=function(){function Pe(){this.seen={}}var Ce=Pe.prototype;return Ce.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ce.getNextSafeSlug=function(se,le){var me=se,we=0;if(this.seen.hasOwnProperty(me)){we=this.seen[se];do we++,me=se+"-"+we;while(this.seen.hasOwnProperty(me))}return le||(this.seen[se]=we,this.seen[me]=0),me},Ce.slug=function(se,le){le===void 0&&(le={});var me=this.serialize(se);return this.getNextSafeSlug(me,le.dryrun)},Pe}(),Ie=T.defaults,$e=F.unescape,qe=function(){function Pe(Ae){this.options=Ae||Ie,this.options.renderer=this.options.renderer||new ve,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ee,this.slugger=new ue}Pe.parse=function(se,le){var me=new Pe(le);return me.parse(se)},Pe.parseInline=function(se,le){var me=new Pe(le);return me.parseInline(se)};var Ce=Pe.prototype;return Ce.parse=function(se,le){le===void 0&&(le=!0);var me="",we,q,ge,_e,Te,Oe,Ge,et,Qe,Xe,lt,ut,Ee,Se,ae,Y,Be,De,Je=se.length;for(we=0;we<Je;we++)switch(Xe=se[we],Xe.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(Xe.tokens),Xe.depth,$e(this.parseInline(Xe.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(Xe.text,Xe.lang,Xe.escaped);continue}case"table":{for(et="",Ge="",_e=Xe.header.length,q=0;q<_e;q++)Ge+=this.renderer.tablecell(this.parseInline(Xe.tokens.header[q]),{header:!0,align:Xe.align[q]});for(et+=this.renderer.tablerow(Ge),Qe="",_e=Xe.cells.length,q=0;q<_e;q++){for(Oe=Xe.tokens.cells[q],Ge="",Te=Oe.length,ge=0;ge<Te;ge++)Ge+=this.renderer.tablecell(this.parseInline(Oe[ge]),{header:!1,align:Xe.align[ge]});Qe+=this.renderer.tablerow(Ge)}me+=this.renderer.table(et,Qe);continue}case"blockquote":{Qe=this.parse(Xe.tokens),me+=this.renderer.blockquote(Qe);continue}case"list":{for(lt=Xe.ordered,ut=Xe.start,Ee=Xe.loose,_e=Xe.items.length,Qe="",q=0;q<_e;q++)ae=Xe.items[q],Y=ae.checked,Be=ae.task,Se="",ae.task&&(De=this.renderer.checkbox(Y),Ee?ae.tokens.length>0&&ae.tokens[0].type==="text"?(ae.tokens[0].text=De+" "+ae.tokens[0].text,ae.tokens[0].tokens&&ae.tokens[0].tokens.length>0&&ae.tokens[0].tokens[0].type==="text"&&(ae.tokens[0].tokens[0].text=De+" "+ae.tokens[0].tokens[0].text)):ae.tokens.unshift({type:"text",text:De}):Se+=De),Se+=this.parse(ae.tokens,Ee),Qe+=this.renderer.listitem(Se,Be,Y);me+=this.renderer.list(Qe,lt,ut);continue}case"html":{me+=this.renderer.html(Xe.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(Xe.tokens));continue}case"text":{for(Qe=Xe.tokens?this.parseInline(Xe.tokens):Xe.text;we+1<Je&&se[we+1].type==="text";)Xe=se[++we],Qe+=`
`+(Xe.tokens?this.parseInline(Xe.tokens):Xe.text);me+=le?this.renderer.paragraph(Qe):Qe;continue}default:{var Ye='Token with "'+Xe.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}return me},Ce.parseInline=function(se,le){le=le||this.renderer;var me="",we,q,ge=se.length;for(we=0;we<ge;we++)switch(q=se[we],q.type){case"escape":{me+=le.text(q.text);break}case"html":{me+=le.html(q.text);break}case"link":{me+=le.link(q.href,q.title,this.parseInline(q.tokens,le));break}case"image":{me+=le.image(q.href,q.title,q.text);break}case"strong":{me+=le.strong(this.parseInline(q.tokens,le));break}case"em":{me+=le.em(this.parseInline(q.tokens,le));break}case"codespan":{me+=le.codespan(q.text);break}case"br":{me+=le.br();break}case"del":{me+=le.del(this.parseInline(q.tokens,le));break}case"text":{me+=le.text(q.text);break}default:{var _e='Token with "'+q.type+'" type was not found.';if(this.options.silent){console.error(_e);return}else throw new Error(_e)}}return me},Pe}(),be=F.merge,tt=F.checkSanitizeDeprecation,K=F.escape,te=T.getDefaults,pe=T.changeDefaults,Ue=T.defaults;function We(Pe,Ce,Ae){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Ce=="function"&&(Ae=Ce,Ce=null),Ce=be({},We.defaults,Ce||{}),tt(Ce),Ae){var se=Ce.highlight,le;try{le=j.lex(Pe,Ce)}catch(ge){return Ae(ge)}var me=function(_e){var Te;if(!_e)try{Te=qe.parse(le,Ce)}catch(Oe){_e=Oe}return Ce.highlight=se,_e?Ae(_e):Ae(null,Te)};if(!se||se.length<3||(delete Ce.highlight,!le.length))return me();var we=0;We.walkTokens(le,function(ge){ge.type==="code"&&(we++,setTimeout(function(){se(ge.text,ge.lang,function(_e,Te){if(_e)return me(_e);Te!=null&&Te!==ge.text&&(ge.text=Te,ge.escaped=!0),we--,we===0&&me()})},0))}),we===0&&me();return}try{var q=j.lex(Pe,Ce);return Ce.walkTokens&&We.walkTokens(q,Ce.walkTokens),qe.parse(q,Ce)}catch(ge){if(ge.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+K(ge.message+"",!0)+"</pre>";throw ge}}We.options=We.setOptions=function(Pe){return be(We.defaults,Pe),pe(We.defaults),We},We.getDefaults=te,We.defaults=Ue,We.use=function(Pe){var Ce=be({},Pe);if(Pe.renderer&&function(){var se=We.defaults.renderer||new ve,le=function(q){var ge=se[q];se[q]=function(){for(var _e=arguments.length,Te=new Array(_e),Oe=0;Oe<_e;Oe++)Te[Oe]=arguments[Oe];var Ge=Pe.renderer[q].apply(se,Te);return Ge===!1&&(Ge=ge.apply(se,Te)),Ge}};for(var me in Pe.renderer)le(me);Ce.renderer=se}(),Pe.tokenizer&&function(){var se=We.defaults.tokenizer||new G,le=function(q){var ge=se[q];se[q]=function(){for(var _e=arguments.length,Te=new Array(_e),Oe=0;Oe<_e;Oe++)Te[Oe]=arguments[Oe];var Ge=Pe.tokenizer[q].apply(se,Te);return Ge===!1&&(Ge=ge.apply(se,Te)),Ge}};for(var me in Pe.tokenizer)le(me);Ce.tokenizer=se}(),Pe.walkTokens){var Ae=We.defaults.walkTokens;Ce.walkTokens=function(se){Pe.walkTokens(se),Ae&&Ae(se)}}We.setOptions(Ce)},We.walkTokens=function(Pe,Ce){for(var Ae=k(Pe),se;!(se=Ae()).done;){var le=se.value;switch(Ce(le),le.type){case"table":{for(var me=k(le.tokens.header),we;!(we=me()).done;){var q=we.value;We.walkTokens(q,Ce)}for(var ge=k(le.tokens.cells),_e;!(_e=ge()).done;)for(var Te=_e.value,Oe=k(Te),Ge;!(Ge=Oe()).done;){var et=Ge.value;We.walkTokens(et,Ce)}break}case"list":{We.walkTokens(le.items,Ce);break}default:le.tokens&&We.walkTokens(le.tokens,Ce)}}},We.parseInline=function(Pe,Ce){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Ce=be({},We.defaults,Ce||{}),tt(Ce);try{var Ae=j.lexInline(Pe,Ce);return Ce.walkTokens&&We.walkTokens(Ae,Ce.walkTokens),qe.parseInline(Ae,Ce)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+K(se.message+"",!0)+"</pre>";throw se}},We.Parser=qe,We.parser=qe.parse,We.Renderer=ve,We.TextRenderer=ee,We.Lexer=j,We.lexer=j.lex,We.Tokenizer=G,We.Slugger=ue,We.parse=We;var Ze=We;return Ze}),define(he[72],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(T,I,D){return Math.min(Math.max(T,I),D)}e.clamp=g;function R(T,I){return(I+T%I)%I}e.rot=R;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class y{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function X(k){const y=[];typeof k=="number"&&y.push("code/timeOrigin",k);function T(D){y.push(D,Date.now())}function I(){const D=[];for(let C=0;C<y.length;C+=2)D.push({name:y[C],startTime:y[C+1]});return D}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))y.push({name:T.name,startTime:Math.round(k+T.startTime)});return y}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function g(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=g(R))}(),define(he[11],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const g="en";let R=!1,k=!1,y=!1,T=!1,I=!1,D=!1,C=!1,i,P=g,u,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?l=e.globals.vscode.process:typeof process!="undefined"&&(l=process);const c=typeof l?.versions?.electron=="string"&&l.type==="renderer";if(e.isElectronSandboxed=c&&l?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=l?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!c)p=navigator.userAgent,R=p.indexOf("Windows")>=0,k=p.indexOf("Macintosh")>=0,C=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=p.indexOf("Linux")>=0,D=!0,i=navigator.language,P=i;else if(typeof l=="object"){R=l.platform==="win32",k=l.platform==="darwin",y=l.platform==="linux",T=y&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,i=g,P=g;const r=l.env.VSCODE_NLS_CONFIG;if(r)try{const n=JSON.parse(r),a=n.availableLanguages["*"];i=n.locale,P=a||g,u=n._translationsConfigFile}catch(n){}I=!0}else console.error("Unable to resolve platform.");var S;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function w(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let E=0;k?E=1:R?E=3:y&&(E=2),e.isWindows=R,e.isMacintosh=k,e.isLinux=y,e.isLinuxSnap=T,e.isNative=I,e.isWeb=D,e.isIOS=C,e.platform=E,e.userAgent=p,e.language=P;var d;(function(r){function n(){return e.language}r.value=n;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=a;function f(){return e.language==="en"}r.isDefault=f})(d=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=u,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeSetImmediateId)for(let b=0,_=a.length;b<_;b++){const o=a[b];if(o.id===m.data.vscodeSetImmediateId){a.splice(b,1),o.callback();return}}});let f=0;return m=>{const b=++f;a.push({id:b,callback:m}),e.globals.postMessage({vscodeSetImmediateId:b},"*")}}if(typeof l?.nextTick=="function")return l.nextTick.bind(l);const n=Promise.resolve();return a=>n.then(a)}();var h;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(h=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||C?2:R?1:3;let v=!0,t=!1;function s(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,v=new Uint16Array(r.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=s}),define(he[37],fe([0,1,11]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const k=g.globals.vscode.process;R={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(y){return(0,g.setImmediate)(y)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:R={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},nextTick(k){return(0,g.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(he[9],fe([0,1,37]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,k=97,y=90,T=122,I=46,D=47,C=92,i=58,P=63;class u extends Error{constructor(h,v,t){let s;typeof v=="string"&&v.indexOf("not ")===0?(s="must not be",v=v.replace(/^not /,"")):s="must be";const r=h.indexOf(".")!==-1?"property":"argument";let n=`The "${h}" ${r} ${s} of type ${v}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function p(d,h){if(typeof d!="string")throw new u(h,"string",d)}function l(d){return d===D||d===C}function c(d){return d===D}function S(d){return d>=R&&d<=y||d>=k&&d<=T}function w(d,h,v,t){let s="",r=0,n=-1,a=0,f=0;for(let m=0;m<=d.length;++m){if(m<d.length)f=d.charCodeAt(m);else{if(t(f))break;f=D}if(t(f)){if(!(n===m-1||a===1))if(a===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==I||s.charCodeAt(s.length-2)!==I){if(s.length>2){const b=s.lastIndexOf(v);b===-1?(s="",r=0):(s=s.slice(0,b),r=s.length-1-s.lastIndexOf(v)),n=m,a=0;continue}else if(s.length!==0){s="",r=0,n=m,a=0;continue}}h&&(s+=s.length>0?`${v}..`:"..",r=2)}else s.length>0?s+=`${v}${d.slice(n+1,m)}`:s=d.slice(n+1,m),r=m-n-1;n=m,a=0}else f===I&&a!==-1?++a:a=-1}return s}function E(d,h){if(h===null||typeof h!="object")throw new u("pathObject","Object",h);const v=h.dir||h.root,t=h.base||`${h.name||""}${h.ext||""}`;return v?v===h.root?`${v}${t}`:`${v}${d}${t}`:t}e.win32={resolve(...d){let h="",v="",t=!1;for(let s=d.length-1;s>=-1;s--){let r;if(s>=0){if(r=d[s],p(r,"path"),r.length===0)continue}else h.length===0?r=g.cwd():(r=g.env[`=${h}`]||g.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==h.toLowerCase()&&r.charCodeAt(2)===C)&&(r=`${h}\\`));const n=r.length;let a=0,f="",m=!1;const b=r.charCodeAt(0);if(n===1)l(b)&&(a=1,m=!0);else if(l(b))if(m=!0,l(r.charCodeAt(1))){let _=2,o=_;for(;_<n&&!l(r.charCodeAt(_));)_++;if(_<n&&_!==o){const A=r.slice(o,_);for(o=_;_<n&&l(r.charCodeAt(_));)_++;if(_<n&&_!==o){for(o=_;_<n&&!l(r.charCodeAt(_));)_++;(_===n||_!==o)&&(f=`\\\\${A}\\${r.slice(o,_)}`,a=_)}}}else a=1;else S(b)&&r.charCodeAt(1)===i&&(f=r.slice(0,2),a=2,n>2&&l(r.charCodeAt(2))&&(m=!0,a=3));if(f.length>0)if(h.length>0){if(f.toLowerCase()!==h.toLowerCase())continue}else h=f;if(t){if(h.length>0)break}else if(v=`${r.slice(a)}\\${v}`,t=m,m&&h.length>0)break}return v=w(v,!t,"\\",l),t?`${h}\\${v}`:`${h}${v}`||"."},normalize(d){p(d,"path");const h=d.length;if(h===0)return".";let v=0,t,s=!1;const r=d.charCodeAt(0);if(h===1)return c(r)?"\\":d;if(l(r))if(s=!0,l(d.charCodeAt(1))){let a=2,f=a;for(;a<h&&!l(d.charCodeAt(a));)a++;if(a<h&&a!==f){const m=d.slice(f,a);for(f=a;a<h&&l(d.charCodeAt(a));)a++;if(a<h&&a!==f){for(f=a;a<h&&!l(d.charCodeAt(a));)a++;if(a===h)return`\\\\${m}\\${d.slice(f)}\\`;a!==f&&(t=`\\\\${m}\\${d.slice(f,a)}`,v=a)}}}else v=1;else S(r)&&d.charCodeAt(1)===i&&(t=d.slice(0,2),v=2,h>2&&l(d.charCodeAt(2))&&(s=!0,v=3));let n=v<h?w(d.slice(v),!s,"\\",l):"";return n.length===0&&!s&&(n="."),n.length>0&&l(d.charCodeAt(h-1))&&(n+="\\"),t===void 0?s?`\\${n}`:n:s?`${t}\\${n}`:`${t}${n}`},isAbsolute(d){p(d,"path");const h=d.length;if(h===0)return!1;const v=d.charCodeAt(0);return l(v)||h>2&&S(v)&&d.charCodeAt(1)===i&&l(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let h,v;for(let r=0;r<d.length;++r){const n=d[r];p(n,"path"),n.length>0&&(h===void 0?h=v=n:h+=`\\${n}`)}if(h===void 0)return".";let t=!0,s=0;if(typeof v=="string"&&l(v.charCodeAt(0))){++s;const r=v.length;r>1&&l(v.charCodeAt(1))&&(++s,r>2&&(l(v.charCodeAt(2))?++s:t=!1))}if(t){for(;s<h.length&&l(h.charCodeAt(s));)s++;s>=2&&(h=`\\${h.slice(s)}`)}return e.win32.normalize(h)},relative(d,h){if(p(d,"from"),p(h,"to"),d===h)return"";const v=e.win32.resolve(d),t=e.win32.resolve(h);if(v===t||(d=v.toLowerCase(),h=t.toLowerCase(),d===h))return"";let s=0;for(;s<d.length&&d.charCodeAt(s)===C;)s++;let r=d.length;for(;r-1>s&&d.charCodeAt(r-1)===C;)r--;const n=r-s;let a=0;for(;a<h.length&&h.charCodeAt(a)===C;)a++;let f=h.length;for(;f-1>a&&h.charCodeAt(f-1)===C;)f--;const m=f-a,b=n<m?n:m;let _=-1,o=0;for(;o<b;o++){const F=d.charCodeAt(s+o);if(F!==h.charCodeAt(a+o))break;F===C&&(_=o)}if(o!==b){if(_===-1)return t}else{if(m>b){if(h.charCodeAt(a+o)===C)return t.slice(a+o+1);if(o===2)return t.slice(a+o)}n>b&&(d.charCodeAt(s+o)===C?_=o:o===2&&(_=3)),_===-1&&(_=0)}let A="";for(o=s+_+1;o<=r;++o)(o===r||d.charCodeAt(o)===C)&&(A+=A.length===0?"..":"\\..");return a+=_,A.length>0?`${A}${t.slice(a,f)}`:(t.charCodeAt(a)===C&&++a,t.slice(a,f))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const h=e.win32.resolve(d);if(h.length<=2)return d;if(h.charCodeAt(0)===C){if(h.charCodeAt(1)===C){const v=h.charCodeAt(2);if(v!==P&&v!==I)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(S(h.charCodeAt(0))&&h.charCodeAt(1)===i&&h.charCodeAt(2)===C)return`\\\\?\\${h}`;return d},dirname(d){p(d,"path");const h=d.length;if(h===0)return".";let v=-1,t=0;const s=d.charCodeAt(0);if(h===1)return l(s)?d:".";if(l(s)){if(v=t=1,l(d.charCodeAt(1))){let a=2,f=a;for(;a<h&&!l(d.charCodeAt(a));)a++;if(a<h&&a!==f){for(f=a;a<h&&l(d.charCodeAt(a));)a++;if(a<h&&a!==f){for(f=a;a<h&&!l(d.charCodeAt(a));)a++;if(a===h)return d;a!==f&&(v=t=a+1)}}}}else S(s)&&d.charCodeAt(1)===i&&(v=h>2&&l(d.charCodeAt(2))?3:2,t=v);let r=-1,n=!0;for(let a=h-1;a>=t;--a)if(l(d.charCodeAt(a))){if(!n){r=a;break}}else n=!1;if(r===-1){if(v===-1)return".";r=v}return d.slice(0,r)},basename(d,h){h!==void 0&&p(h,"ext"),p(d,"path");let v=0,t=-1,s=!0,r;if(d.length>=2&&S(d.charCodeAt(0))&&d.charCodeAt(1)===i&&(v=2),h!==void 0&&h.length>0&&h.length<=d.length){if(h===d)return"";let n=h.length-1,a=-1;for(r=d.length-1;r>=v;--r){const f=d.charCodeAt(r);if(l(f)){if(!s){v=r+1;break}}else a===-1&&(s=!1,a=r+1),n>=0&&(f===h.charCodeAt(n)?--n==-1&&(t=r):(n=-1,t=a))}return v===t?t=a:t===-1&&(t=d.length),d.slice(v,t)}for(r=d.length-1;r>=v;--r)if(l(d.charCodeAt(r))){if(!s){v=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":d.slice(v,t)},extname(d){p(d,"path");let h=0,v=-1,t=0,s=-1,r=!0,n=0;d.length>=2&&d.charCodeAt(1)===i&&S(d.charCodeAt(0))&&(h=t=2);for(let a=d.length-1;a>=h;--a){const f=d.charCodeAt(a);if(l(f)){if(!r){t=a+1;break}continue}s===-1&&(r=!1,s=a+1),f===I?v===-1?v=a:n!==1&&(n=1):v!==-1&&(n=-1)}return v===-1||s===-1||n===0||n===1&&v===s-1&&v===t+1?"":d.slice(v,s)},format:E.bind(null,"\\"),parse(d){p(d,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return h;const v=d.length;let t=0,s=d.charCodeAt(0);if(v===1)return l(s)?(h.root=h.dir=d,h):(h.base=h.name=d,h);if(l(s)){if(t=1,l(d.charCodeAt(1))){let _=2,o=_;for(;_<v&&!l(d.charCodeAt(_));)_++;if(_<v&&_!==o){for(o=_;_<v&&l(d.charCodeAt(_));)_++;if(_<v&&_!==o){for(o=_;_<v&&!l(d.charCodeAt(_));)_++;_===v?t=_:_!==o&&(t=_+1)}}}}else if(S(s)&&d.charCodeAt(1)===i){if(v<=2)return h.root=h.dir=d,h;if(t=2,l(d.charCodeAt(2))){if(v===3)return h.root=h.dir=d,h;t=3}}t>0&&(h.root=d.slice(0,t));let r=-1,n=t,a=-1,f=!0,m=d.length-1,b=0;for(;m>=t;--m){if(s=d.charCodeAt(m),l(s)){if(!f){n=m+1;break}continue}a===-1&&(f=!1,a=m+1),s===I?r===-1?r=m:b!==1&&(b=1):r!==-1&&(b=-1)}return a!==-1&&(r===-1||b===0||b===1&&r===a-1&&r===n+1?h.base=h.name=d.slice(n,a):(h.name=d.slice(n,r),h.base=d.slice(n,a),h.ext=d.slice(r,a))),n>0&&n!==t?h.dir=d.slice(0,n-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let h="",v=!1;for(let t=d.length-1;t>=-1&&!v;t--){const s=t>=0?d[t]:g.cwd();p(s,"path"),s.length!==0&&(h=`${s}/${h}`,v=s.charCodeAt(0)===D)}return h=w(h,!v,"/",c),v?`/${h}`:h.length>0?h:"."},normalize(d){if(p(d,"path"),d.length===0)return".";const h=d.charCodeAt(0)===D,v=d.charCodeAt(d.length-1)===D;return d=w(d,!h,"/",c),d.length===0?h?"/":v?"./":".":(v&&(d+="/"),h?`/${d}`:d)},isAbsolute(d){return p(d,"path"),d.length>0&&d.charCodeAt(0)===D},join(...d){if(d.length===0)return".";let h;for(let v=0;v<d.length;++v){const t=d[v];p(t,"path"),t.length>0&&(h===void 0?h=t:h+=`/${t}`)}return h===void 0?".":e.posix.normalize(h)},relative(d,h){if(p(d,"from"),p(h,"to"),d===h||(d=e.posix.resolve(d),h=e.posix.resolve(h),d===h))return"";const v=1,t=d.length,s=t-v,r=1,n=h.length-r,a=s<n?s:n;let f=-1,m=0;for(;m<a;m++){const _=d.charCodeAt(v+m);if(_!==h.charCodeAt(r+m))break;_===D&&(f=m)}if(m===a)if(n>a){if(h.charCodeAt(r+m)===D)return h.slice(r+m+1);if(m===0)return h.slice(r+m)}else s>a&&(d.charCodeAt(v+m)===D?f=m:m===0&&(f=0));let b="";for(m=v+f+1;m<=t;++m)(m===t||d.charCodeAt(m)===D)&&(b+=b.length===0?"..":"/..");return`${b}${h.slice(r+f)}`},toNamespacedPath(d){return d},dirname(d){if(p(d,"path"),d.length===0)return".";const h=d.charCodeAt(0)===D;let v=-1,t=!0;for(let s=d.length-1;s>=1;--s)if(d.charCodeAt(s)===D){if(!t){v=s;break}}else t=!1;return v===-1?h?"/":".":h&&v===1?"//":d.slice(0,v)},basename(d,h){h!==void 0&&p(h,"ext"),p(d,"path");let v=0,t=-1,s=!0,r;if(h!==void 0&&h.length>0&&h.length<=d.length){if(h===d)return"";let n=h.length-1,a=-1;for(r=d.length-1;r>=0;--r){const f=d.charCodeAt(r);if(f===D){if(!s){v=r+1;break}}else a===-1&&(s=!1,a=r+1),n>=0&&(f===h.charCodeAt(n)?--n==-1&&(t=r):(n=-1,t=a))}return v===t?t=a:t===-1&&(t=d.length),d.slice(v,t)}for(r=d.length-1;r>=0;--r)if(d.charCodeAt(r)===D){if(!s){v=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":d.slice(v,t)},extname(d){p(d,"path");let h=-1,v=0,t=-1,s=!0,r=0;for(let n=d.length-1;n>=0;--n){const a=d.charCodeAt(n);if(a===D){if(!s){v=n+1;break}continue}t===-1&&(s=!1,t=n+1),a===I?h===-1?h=n:r!==1&&(r=1):h!==-1&&(r=-1)}return h===-1||t===-1||r===0||r===1&&h===t-1&&h===v+1?"":d.slice(h,t)},format:E.bind(null,"/"),parse(d){p(d,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return h;const v=d.charCodeAt(0)===D;let t;v?(h.root="/",t=1):t=0;let s=-1,r=0,n=-1,a=!0,f=d.length-1,m=0;for(;f>=t;--f){const b=d.charCodeAt(f);if(b===D){if(!a){r=f+1;break}continue}n===-1&&(a=!1,n=f+1),b===I?s===-1?s=f:m!==1&&(m=1):s!==-1&&(m=-1)}if(n!==-1){const b=r===0&&v?1:r;s===-1||m===0||m===1&&s===n-1&&s===r+1?h.base=h.name=d.slice(b,n):(h.name=d.slice(b,s),h.base=d.slice(b,n),h.ext=d.slice(s,n))}return r>0?h.dir=d.slice(0,r-1):v&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(he[136],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var R;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(y,...T){const I=T.reduce((i,P)=>(i[P]=!0,i),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(i=>!I[i]).forEach(i=>{for(let P=0;P<D.length;P++)if(i.search(D[P])!==-1){delete y[i];break}})}e.sanitizeProcessEnvironment=k}),define(he[44],fe([0,1,11]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=g.globals.performance&&typeof g.globals.performance.now=="function";class k{constructor(T){this._highResolution=R&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new k(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=k}),define(he[3],fe([0,1,15,70,6,91,44]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(d){d.None=()=>k.Disposable.None;function h(H){return(N,x=null,L)=>{let G=!1,M;return M=H(O=>{if(!G)return M?M.dispose():G=!0,N.call(x,O)},null,L),G&&M.dispose(),M}}d.once=h;function v(H,N){return f((x,L=null,G)=>H(M=>x.call(L,N(M)),null,G))}d.map=v;function t(H,N){return f((x,L=null,G)=>H(M=>{N(M),x.call(L,M)},null,G))}d.forEach=t;function s(H,N){return f((x,L=null,G)=>H(M=>N(M)&&x.call(L,M),null,G))}d.filter=s;function r(H){return H}d.signal=r;function n(...H){return(N,x=null,L)=>(0,k.combinedDisposable)(...H.map(G=>G(M=>N.call(x,M),null,L)))}d.any=n;function a(H,N,x){let L=x;return v(H,G=>(L=N(L,G),L))}d.reduce=a;function f(H){let N;const x=new u({onFirstListenerAdd(){N=H(x.fire,x)},onLastListenerRemove(){N.dispose()}});return x.event}function m(H,N,x=100,L=!1,G){let M,O,B,z=0;const J=new u({leakWarningThreshold:G,onFirstListenerAdd(){M=H(ce=>{z++,O=N(O,ce),L&&!B&&(J.fire(O),O=void 0),clearTimeout(B),B=setTimeout(()=>{const ye=O;O=void 0,B=void 0,(!L||z>1)&&J.fire(ye),z=0},x)})},onLastListenerRemove(){M.dispose()}});return J.event}d.debounce=m;function b(H,N=(x,L)=>x===L){let x=!0,L;return s(H,G=>{const M=x||!N(G,L);return x=!1,L=G,M})}d.latch=b;function _(H,N){return[d.filter(H,N),d.filter(H,x=>!N(x))]}d.split=_;function o(H,N=!1,x=[]){let L=x.slice(),G=H(B=>{L?L.push(B):O.fire(B)});const M=()=>{L&&L.forEach(B=>O.fire(B)),L=null},O=new u({onFirstListenerAdd(){G||(G=H(B=>O.fire(B)))},onFirstListenerDidAdd(){L&&(N?setTimeout(M):M())},onLastListenerRemove(){G&&G.dispose(),G=null}});return O.event}d.buffer=o;class A{constructor(N){this.event=N}map(N){return new A(v(this.event,N))}forEach(N){return new A(t(this.event,N))}filter(N){return new A(s(this.event,N))}reduce(N,x){return new A(a(this.event,N,x))}latch(){return new A(b(this.event))}debounce(N,x=100,L=!1,G){return new A(m(this.event,N,x,L,G))}on(N,x,L){return this.event(N,x,L)}once(N,x,L){return h(this.event)(N,x,L)}}function F(H){return new A(H)}d.chain=F;function $(H,N,x=L=>L){const L=(...B)=>O.fire(x(...B)),G=()=>H.on(N,L),M=()=>H.removeListener(N,L),O=new u({onFirstListenerAdd:G,onLastListenerRemove:M});return O.event}d.fromNodeEventEmitter=$;function W(H,N,x=L=>L){const L=(...B)=>O.fire(x(...B)),G=()=>H.addEventListener(N,L),M=()=>H.removeEventListener(N,L),O=new u({onFirstListenerAdd:G,onLastListenerRemove:M});return O.event}d.fromDOMEventEmitter=W;function Q(H){return new Promise(N=>h(H)(N))}d.toPromise=Q})(I=e.Event||(e.Event={}));class D{constructor(h){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${h}_${D._idPool++}`}start(h){this._stopWatch=new T.StopWatch(!0),this._listenerCount=h}stop(){if(this._stopWatch){const h=this._stopWatch.elapsed();this._elapsedOverall+=h,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${h.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let C=-1;function i(d){const h=C;return C=d,{dispose(){C=h}}}e.setGlobalLeakWarningThreshold=i;class P{constructor(h,v=Math.random().toString(18).slice(2,5)){this.customThreshold=h,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(h){let v=C;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||h<v)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(t)||0;if(this._stacks.set(t,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let r,n=0;for(const[a,f]of this._stacks)(!r||n<f)&&(r=a,n=f);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${n}):`),console.warn(r)}return()=>{const r=this._stacks.get(t)||0;this._stacks.set(t,r-1)}}}class u{constructor(h){this._disposed=!1,this._options=h,this._leakageMon=C>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(h,v,t)=>{this._listeners||(this._listeners=new y.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(v?[h,v]:h);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,h,v);const n=this._leakageMon?.check(this._listeners.size),a=(0,k.toDisposable)(()=>{n&&n(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof k.DisposableStore?t.add(a):Array.isArray(t)&&t.push(a),a}),this._event}fire(h){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let v of this._listeners)this._deliveryQueue.push([v,h]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[v,t]=this._deliveryQueue.shift();try{typeof v=="function"?v.call(void 0,t):v[0].call(v[1],t)}catch(s){(0,g.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=u;class p extends u{async fireAsync(h,v,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,h]);for(;this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),n=[],a={...r,waitUntil:f=>{if(Object.isFrozen(n))throw new Error("waitUntil can NOT be called asynchronous");t&&(f=t(f,typeof s=="function"?s:s[0])),n.push(f)}};try{typeof s=="function"?s.call(void 0,a):s[0].call(s[1],a)}catch(f){(0,g.onUnexpectedError)(f);continue}Object.freeze(n),await Promise.allSettled(n).then(f=>{for(const m of f)m.status==="rejected"&&(0,g.onUnexpectedError)(m.reason)})}}}}e.AsyncEmitter=p;class l extends u{constructor(h){super(h);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=h?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const h=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(h))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(h){this._listeners&&(this._isPaused!==0?this._eventQueue.push(h):super.fire(h))}}e.PauseableEmitter=l;class c extends l{constructor(h){super(h);this._delay=h.delay??100}fire(h){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(h)}}e.DebounceEmitter=c;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new u({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(h){const v={event:h,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const t=()=>{this.hasListeners&&this.unhook(v);const s=this.events.indexOf(v);this.events.splice(s,1)};return(0,k.toDisposable)((0,R.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(h=>this.hook(h))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(h=>this.unhook(h))}hook(h){h.listener=h.event(v=>this.emitter.fire(v))}unhook(h){h.listener&&h.listener.dispose(),h.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=S;class w{constructor(){this.buffers=[]}wrapEvent(h){return(v,t,s)=>h(r=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>v.call(t,r)):v.call(t,r)},void 0,s)}bufferEvents(h){const v=[];this.buffers.push(v);const t=h();return this.buffers.pop(),v.forEach(s=>s()),t}}e.EventBufferer=w;class E{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=k.Disposable.None,this.emitter=new u({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(h){this.inputEvent=h,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=h(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(he[21],fe([0,1,3]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(I,D){const C=setTimeout(I.bind(D),0);return{dispose(){clearTimeout(C)}}});var k;(function(I){function D(C){return C===I.None||C===I.Cancelled||C instanceof y?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}I.isCancellationToken=D,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(k=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=k.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=T}),define(he[73],fe([0,1,3]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(P){const u=this._icons.get(P.id);u?P.description?u.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new R;e.iconRegistry=k;function y(i,P){return new I(i,P)}e.registerCodicon=y;function T(i){return i?i.replace(/\$\((.*?)\)/g,(P,u)=>` ${u} `).trim():""}e.getCodiconAriaLabel=T;class I{constructor(P,u,p){this.id=P,this.definition=u,this.description=p,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=I;function D(i,P){const u=["codicon","codicon-"+i];return P&&u.push("codicon-modifier-"+P),u}e.getClassNamesArray=D;var C;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function u(c){if(c instanceof I)return["codicon","codicon-"+c.id];const S=P.exec(c.id);if(!S)return u(I.error);let[,w,E]=S;const d=["codicon","codicon-"+w];return E&&d.push("codicon-modifier-"+E.substr(1)),d}i.asClassNameArray=u;function p(c){return u(c).join(" ")}i.asClassName=p;function l(c){return"."+u(c).join(".")}i.asCSSSelector=l})(C=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(I=e.Codicon||(e.Codicon={}))}),define(he[92],fe([0,1,15,6]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(d){const h=d;return h?[h.on,h.pause,h.resume,h.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=k;function y(d){const h=d;return h?k(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=y;function T(d,h){return new I(d,h)}e.newWriteableStream=T;class I{constructor(h,v){this.reducer=h,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(v=>v(h))}emitError(h){this.listeners.error.length===0?(0,g.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(v=>v(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,v){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(h,v){if(this.state.destroyed)return;let t;switch(h){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(v);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(d,h){const v=[];let t;for(;(t=d.read())!==null;)v.push(t);return h(v)}e.consumeReadable=D;function C(d,h,v){const t=[];let s;for(;(s=d.read())!==null&&t.length<v;)t.push(s);return s===null&&t.length>0?h(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return d.read()}}}e.peekReadable=C;function i(d,h){return new Promise((v,t)=>{const s=[];P(d,{onData:r=>{h&&s.push(r)},onError:r=>{h?t(r):v(void 0)},onEnd:()=>{v(h?h(s):void 0)}})})}e.consumeStream=i;function P(d,h){d.on("error",v=>h.onError(v)),d.on("end",()=>h.onEnd()),d.on("data",v=>h.onData(v))}e.listenStream=P;function u(d,h){return new Promise((v,t)=>{const s=new R.DisposableStore,r=[],n=m=>{if(r.push(m),r.length>h)return s.dispose(),d.pause(),v({stream:d,buffer:r,ended:!1})},a=m=>t(m),f=()=>v({stream:d,buffer:r,ended:!0});s.add((0,R.toDisposable)(()=>d.removeListener("error",a))),d.on("error",a),s.add((0,R.toDisposable)(()=>d.removeListener("end",f))),d.on("end",f),s.add((0,R.toDisposable)(()=>d.removeListener("data",n))),d.on("data",n)})}e.peekStream=u;function p(d,h){const v=T(h);return v.end(d),v}e.toStream=p;function l(){const d=T(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=l;function c(d){let h=!1;return{read:()=>h?null:(h=!0,d)}}e.toReadable=c;function S(d,h,v){const t=T(v);return P(d,{onData:s=>t.write(h.data(s)),onError:s=>t.error(h.error?h.error(s):s),onEnd:()=>t.end()}),t}e.transform=S;function w(d,h,v){let t=!1;return{read:()=>{const s=h.read();return t?s:(t=!0,s!==null?v([d,s]):d)}}}e.prefixedReadable=w;function E(d,h,v){let t=!1;const s=T(v);return P(h,{onData:r=>t?s.write(r):(t=!0,s.write(v([d,r]))),onError:r=>s.error(r),onEnd:()=>{t||(t=!0,s.write(d)),s.end()}}),s}e.prefixedStream=E}),define(he[8],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(q){return!q||typeof q!="string"?!0:q.trim().length===0}e.isFalsyOrWhitespace=g;const R=/{(\d+)}/g;function k(q,...ge){return ge.length===0?q:q.replace(R,function(_e,Te){const Oe=parseInt(Te,10);return isNaN(Oe)||Oe<0||Oe>=ge.length?_e:ge[Oe]})}e.format=k;const y=/{([^}]+)}/g;function T(q,ge){return q.replace(y,(_e,Te)=>ge[Te]??_e)}e.format2=T;function I(q){return q.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}e.escape=I;function D(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function C(q,ge){let _e=0;const Te=ge.charCodeAt(0);for(let Oe=q.length-1;Oe>=0;Oe--)q.charCodeAt(Oe)===Te&&_e++;return _e}e.count=C;function i(q,ge,_e="\u2026"){return q.length<=ge?q:`${q.substr(0,ge)}${_e}`}e.truncate=i;function P(q,ge=" "){const _e=u(q,ge);return p(_e,ge)}e.trim=P;function u(q,ge){if(!q||!ge)return q;const _e=ge.length;if(_e===0||q.length===0)return q;let Te=0;for(;q.indexOf(ge,Te)===Te;)Te=Te+_e;return q.substring(Te)}e.ltrim=u;function p(q,ge){if(!q||!ge)return q;const _e=ge.length,Te=q.length;if(_e===0||Te===0)return q;let Oe=Te,Ge=-1;for(;Ge=q.lastIndexOf(ge,Oe-1),!(Ge===-1||Ge+_e!==Oe);){if(Ge===0)return"";Oe=Ge}return q.substring(0,Oe)}e.rtrim=p;function l(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function c(q){return q.replace(/\*/g,"")}e.stripWildcards=c;function S(q,ge,_e={}){if(!q)throw new Error("Cannot create regex from empty string");ge||(q=D(q)),_e.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let Te="";return _e.global&&(Te+="g"),_e.matchCase||(Te+="i"),_e.multiline&&(Te+="m"),_e.unicode&&(Te+="u"),new RegExp(q,Te)}e.createRegExp=S;function w(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function E(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function d(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}e.regExpFlags=d;function h(q){return q.split(/\r\n|\r|\n/)}e.splitLines=h;function v(q){for(let ge=0,_e=q.length;ge<_e;ge++){const Te=q.charCodeAt(ge);if(Te!==32&&Te!==9)return ge}return-1}e.firstNonWhitespaceIndex=v;function t(q,ge=0,_e=q.length){for(let Te=ge;Te<_e;Te++){const Oe=q.charCodeAt(Te);if(Oe!==32&&Oe!==9)return q.substring(ge,Te)}return q.substring(ge,_e)}e.getLeadingWhitespace=t;function s(q,ge=q.length-1){for(let _e=ge;_e>=0;_e--){const Te=q.charCodeAt(_e);if(Te!==32&&Te!==9)return _e}return-1}e.lastNonWhitespaceIndex=s;function r(q,ge){return q<ge?-1:q>ge?1:0}e.compare=r;function n(q,ge,_e=0,Te=q.length,Oe=0,Ge=ge.length){for(;_e<Te&&Oe<Ge;_e++,Oe++){let Xe=q.charCodeAt(_e),lt=ge.charCodeAt(Oe);if(Xe<lt)return-1;if(Xe>lt)return 1}const et=Te-_e,Qe=Ge-Oe;return et<Qe?-1:et>Qe?1:0}e.compareSubstring=n;function a(q,ge){return f(q,ge,0,q.length,0,ge.length)}e.compareIgnoreCase=a;function f(q,ge,_e=0,Te=q.length,Oe=0,Ge=ge.length){for(;_e<Te&&Oe<Ge;_e++,Oe++){let Xe=q.charCodeAt(_e),lt=ge.charCodeAt(Oe);if(Xe===lt)continue;const ut=Xe-lt;if(!(ut===32&&b(lt))&&!(ut===-32&&b(Xe)))return m(Xe)&&m(lt)?ut:n(q.toLowerCase(),ge.toLowerCase(),_e,Te,Oe,Ge)}const et=Te-_e,Qe=Ge-Oe;return et<Qe?-1:et>Qe?1:0}e.compareSubstringIgnoreCase=f;function m(q){return q>=97&&q<=122}e.isLowerAsciiLetter=m;function b(q){return q>=65&&q<=90}e.isUpperAsciiLetter=b;function _(q){return m(q)||b(q)}function o(q,ge){return q.length===ge.length&&A(q,ge)}e.equalsIgnoreCase=o;function A(q,ge,_e=q.length){for(let Te=0;Te<_e;Te++){const Oe=q.charCodeAt(Te),Ge=ge.charCodeAt(Te);if(Oe!==Ge){if(_(Oe)&&_(Ge)){const et=Math.abs(Oe-Ge);if(et!==0&&et!==32)return!1}else if(String.fromCharCode(Oe).toLowerCase()!==String.fromCharCode(Ge).toLowerCase())return!1}}return!0}function F(q,ge){const _e=ge.length;return ge.length>q.length?!1:A(q,ge,_e)}e.startsWithIgnoreCase=F;function $(q,ge){let _e,Te=Math.min(q.length,ge.length);for(_e=0;_e<Te;_e++)if(q.charCodeAt(_e)!==ge.charCodeAt(_e))return _e;return Te}e.commonPrefixLength=$;function W(q,ge){let _e,Te=Math.min(q.length,ge.length);const Oe=q.length-1,Ge=ge.length-1;for(_e=0;_e<Te;_e++)if(q.charCodeAt(Oe-_e)!==ge.charCodeAt(Ge-_e))return _e;return Te}e.commonSuffixLength=W;function Q(q){return 55296<=q&&q<=56319}e.isHighSurrogate=Q;function H(q){return 56320<=q&&q<=57343}e.isLowSurrogate=H;function N(q,ge){return(q-55296<<10)+(ge-56320)+65536}e.computeCodePoint=N;function x(q,ge,_e){const Te=q.charCodeAt(_e);if(Q(Te)&&_e+1<ge){const Oe=q.charCodeAt(_e+1);if(H(Oe))return N(Te,Oe)}return Te}e.getNextCodePoint=x;function L(q,ge){const _e=q.charCodeAt(ge-1);if(H(_e)&&ge>1){const Te=q.charCodeAt(ge-2);if(Q(Te))return N(Te,_e)}return _e}function G(q,ge){const _e=Pe.getInstance(),Te=ge,Oe=q.length,Ge=x(q,Oe,ge);ge+=Ge>=65536?2:1;let et=_e.getGraphemeBreakType(Ge);for(;ge<Oe;){const Qe=x(q,Oe,ge),Xe=_e.getGraphemeBreakType(Qe);if(We(et,Xe))break;ge+=Qe>=65536?2:1,et=Xe}return ge-Te}e.nextCharLength=G;function M(q,ge){const _e=Pe.getInstance(),Te=ge,Oe=L(q,ge);ge-=Oe>=65536?2:1;let Ge=_e.getGraphemeBreakType(Oe);for(;ge>0;){const et=L(q,ge),Qe=_e.getGraphemeBreakType(et);if(We(Qe,Ge))break;ge-=et>=65536?2:1,Ge=Qe}return Te-ge}e.prevCharLength=M;function O(q,ge){const _e=Pe.getInstance(),Te=q.length,Oe=ge,Ge=x(q,Te,ge),et=_e.getGraphemeBreakType(Ge);ge+=Ge>=65536?2:1;let Qe=et;for(;ge<Te;){const lt=x(q,Te,ge),ut=_e.getGraphemeBreakType(lt);if(We(Qe,ut))break;ge+=lt>=65536?2:1,Qe=ut}const Xe=ge;for(ge=Oe,Qe=et;ge>0;){const lt=L(q,ge),ut=_e.getGraphemeBreakType(lt);if(We(ut,Qe))break;ge-=lt>=65536?2:1,Qe=ut}return[ge,Xe]}function B(q,ge){return ge>0&&H(q.charCodeAt(ge))?O(q,ge-1):O(q,ge)}e.getCharContainingOffset=B;function z(q){const ge=q.length;let _e=0,Te=0;for(;Te<ge;){const et=x(q,ge,Te);Te+=et>=65536?2:1,et<128?_e+=1:et<2048?_e+=2:et<65536?_e+=3:_e+=4}const Oe=new Uint8Array(_e);Te=0;let Ge=0;for(;Te<ge;){const et=x(q,ge,Te);Te+=et>=65536?2:1,et<128?Oe[Ge++]=et:et<2048?(Oe[Ge++]=192|(et&1984)>>>6,Oe[Ge++]=128|(et&63)>>>0):et<65536?(Oe[Ge++]=224|(et&61440)>>>12,Oe[Ge++]=128|(et&4032)>>>6,Oe[Ge++]=128|(et&63)>>>0):(Oe[Ge++]=240|(et&1835008)>>>18,Oe[Ge++]=128|(et&258048)>>>12,Oe[Ge++]=128|(et&4032)>>>6,Oe[Ge++]=128|(et&63)>>>0)}return Oe}e.encodeUTF8=z;function J(q){const ge=q.byteLength,_e=[];let Te=0;for(;Te<ge;){const Oe=q[Te];let Ge;if(Oe>=240&&Te+3<ge?Ge=(q[Te++]&7)<<18>>>0|(q[Te++]&63)<<12>>>0|(q[Te++]&63)<<6>>>0|(q[Te++]&63)<<0>>>0:Oe>=224&&Te+2<ge?Ge=(q[Te++]&15)<<12>>>0|(q[Te++]&63)<<6>>>0|(q[Te++]&63)<<0>>>0:Oe>=192&&Te+1<ge?Ge=(q[Te++]&31)<<6>>>0|(q[Te++]&63)<<0>>>0:Ge=q[Te++],Ge>=0&&Ge<=55295||Ge>=57344&&Ge<=65535)_e.push(String.fromCharCode(Ge));else if(Ge>=65536&&Ge<=1114111){const et=Ge-65536,Qe=55296+((et&1047552)>>>10),Xe=56320+((et&1023)>>>0);_e.push(String.fromCharCode(Qe)),_e.push(String.fromCharCode(Xe))}else _e.push(String.fromCharCode(65533))}return _e.join("")}e.decodeUTF8=J;const ce=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ye(q){return ce.test(q)}e.containsRTL=ye;const Fe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Re(q){return Fe.test(q)}e.containsEmoji=Re;const Ne=/^[\t\n\r\x20-\x7E]*$/;function Ve(q){return Ne.test(q)}e.isBasicASCII=Ve,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ze(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}e.containsUnusualLineTerminators=ze;function j(q){for(let ge=0,_e=q.length;ge<_e;ge++)if(Z(q.charCodeAt(ge)))return!0;return!1}e.containsFullWidthCharacter=j;function Z(q){return q=+q,q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}e.isFullWidthCharacter=Z;function ie(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129003||q>=129280&&q<=129535||q>=129648&&q<=129750}e.isEmojiImprecise=ie;function oe(q,ge){if(q.length<ge)return q;const _e=/\b/g;let Te=0;for(;_e.test(q)&&!(q.length-_e.lastIndex<ge);)Te=_e.lastIndex,_e.lastIndex+=1;return q.substring(Te).replace(/^\s/,"")}e.lcut=oe;const ve=/\x1B\x5B[12]?K/g,ee=/\x1b\[\d+m/g,ue=/\x1b\[0?m/g;function Ie(q){return q&&(q=q.replace(ve,""),q=q.replace(ee,""),q=q.replace(ue,"")),q}e.removeAnsiEscapeCodes=Ie,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function $e(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=$e;function qe(q){return $e(q)?q.substr(1):q}e.stripUTF8BOM=qe;function be(q,ge){if(!q||!ge||q.length<ge.length)return!1;const _e=ge.length,Te=q.toLowerCase();let Oe=0,Ge=-1;for(;Oe<_e;){const et=Te.indexOf(ge[Oe],Ge+1);if(et<0)return!1;Ge=et,Oe++}return!0}e.fuzzyContains=be;function tt(q,ge=!1){return q?(ge&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}e.containsUppercaseCharacter=tt;function K(q){return q.charAt(0).toUpperCase()+q.slice(1)}e.uppercaseFirstLetter=K;function te(q,ge=1){if(ge===0)return"";let _e=-1;do _e=q.indexOf(`
`,_e+1),ge--;while(ge>0&&_e>=0);return _e===-1?q:(q[_e-1]==="\r"&&_e--,q.substr(0,_e))}e.getNLines=te;function pe(q){const ge=90-65+1;return q=q%(2*ge),q<ge?String.fromCharCode(97+q):String.fromCharCode(65+q-ge)}e.singleLetterHash=pe;function Ue(q){return Pe.getInstance().getGraphemeBreakType(q)}e.getGraphemeBreakType=Ue;function We(q,ge){return q===0?ge!==5&&ge!==7:q===2&&ge===3?!1:q===4||q===2||q===3||ge===4||ge===2||ge===3?!0:!(q===8&&(ge===8||ge===9||ge===11||ge===12)||(q===11||q===9)&&(ge===9||ge===10)||(q===12||q===10)&&ge===10||ge===5||ge===13||ge===7||q===1||q===13&&ge===14||q===6&&ge===6)}e.breakBetweenGraphemeBreakType=We;var Ze;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(Ze=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Pe{constructor(){this._data=Ce()}static getInstance(){return Pe._INSTANCE||(Pe._INSTANCE=new Pe),Pe._INSTANCE}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const _e=this._data,Te=_e.length/3;let Oe=1;for(;Oe<=Te;)if(ge<_e[3*Oe])Oe=2*Oe;else if(ge>_e[3*Oe+1])Oe=2*Oe+1;else return _e[3*Oe+2];return 0}}Pe._INSTANCE=null;function Ce(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ae(q,ge){if(q===0)return 0;const _e=se(q,ge);if(_e!==void 0)return _e;const Te=L(ge,q);return q-=le(Te),q}e.getLeftDeleteOffset=Ae;function se(q,ge){let _e=L(ge,q);for(q-=le(_e);me(_e)||_e===65039||_e===8419;){if(q===0)return;_e=L(ge,q),q-=le(_e)}if(!!ie(_e)){if(q>=0){const Te=L(ge,q);Te===8205&&(q-=le(Te))}return q}}function le(q){return q>=65536?2:1}function me(q){return 127995<=q&&q<=127999}var we;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(we||(we={}))}),define(he[22],fe([0,1,8,92]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let I,D;class C{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return k?new C(Buffer.allocUnsafe(m)):new C(new Uint8Array(m))}static wrap(m){return k&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new C(m)}static fromString(m,b){return!(b?.dontUseNodeBuffer||!1)&&k?new C(Buffer.from(m)):y?(I||(I=new TextEncoder),new C(I.encode(m))):new C(g.encodeUTF8(m))}static concat(m,b){if(typeof b=="undefined"){b=0;for(let A=0,F=m.length;A<F;A++)b+=m[A].byteLength}const _=C.alloc(b);let o=0;for(let A=0,F=m.length;A<F;A++){const $=m[A];_.set($,o),o+=$.byteLength}return _}toString(){return k?this.buffer.toString():T?(D||(D=new TextDecoder),D.decode(this.buffer)):g.decodeUTF8(this.buffer)}slice(m,b){return new C(this.buffer.subarray(m,b))}set(m,b){m instanceof C?this.buffer.set(m.buffer,b):this.buffer.set(m,b)}readUInt32BE(m){return u(this.buffer,m)}writeUInt32BE(m,b){p(this.buffer,m,b)}readUInt32LE(m){return l(this.buffer,m)}writeUInt32LE(m,b){c(this.buffer,m,b)}readUInt8(m){return S(this.buffer,m)}writeUInt8(m,b){w(this.buffer,m,b)}}e.VSBuffer=C;function i(f,m){return f[m+0]<<0>>>0|f[m+1]<<8>>>0}e.readUInt16LE=i;function P(f,m,b){f[b+0]=m&255,m=m>>>8,f[b+1]=m&255}e.writeUInt16LE=P;function u(f,m){return f[m]*2**24+f[m+1]*2**16+f[m+2]*2**8+f[m+3]}e.readUInt32BE=u;function p(f,m,b){f[b+3]=m,m=m>>>8,f[b+2]=m,m=m>>>8,f[b+1]=m,m=m>>>8,f[b]=m}e.writeUInt32BE=p;function l(f,m){return f[m+0]<<0>>>0|f[m+1]<<8>>>0|f[m+2]<<16>>>0|f[m+3]<<24>>>0}e.readUInt32LE=l;function c(f,m,b){f[b+0]=m&255,m=m>>>8,f[b+1]=m&255,m=m>>>8,f[b+2]=m&255,m=m>>>8,f[b+3]=m&255}e.writeUInt32LE=c;function S(f,m){return f[m]}e.readUInt8=S;function w(f,m,b){f[b]=m}e.writeUInt8=w;function E(f){return R.consumeReadable(f,m=>C.concat(m))}e.readableToBuffer=E;function d(f){return R.toReadable(f)}e.bufferToReadable=d;function h(f){return R.consumeStream(f,m=>C.concat(m))}e.streamToBuffer=h;async function v(f){return f.ended?C.concat(f.buffer):C.concat([...f.buffer,await h(f.stream)])}e.bufferedStreamToBuffer=v;function t(f){return R.toStream(f,m=>C.concat(m))}e.bufferToStream=t;function s(f){return R.transform(f,{data:m=>typeof m=="string"?C.fromString(m):C.wrap(m)},m=>C.concat(m))}e.streamToBufferReadableStream=s;function r(f){return R.newWriteableStream(m=>C.concat(m),f)}e.newWriteableBufferStream=r;function n(f,m){return R.prefixedReadable(f,m,b=>C.concat(b))}e.prefixedBufferReadable=n;function a(f,m){return R.prefixedStream(f,m,b=>C.concat(b))}e.prefixedBufferStream=a}),define(he[74],fe([0,1,8]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(w){return k(w,0)}e.hash=R;function k(w,E){switch(typeof w){case"object":return w===null?y(349,E):Array.isArray(w)?D(w,E):C(w,E);case"string":return I(w,E);case"boolean":return T(w,E);case"number":return y(w,E);case"undefined":return y(937,E);default:return y(617,E)}}e.doHash=k;function y(w,E){return(E<<5)-E+w|0}function T(w,E){return y(w?433:863,E)}function I(w,E){E=y(149417,E);for(let d=0,h=w.length;d<h;d++)E=y(w.charCodeAt(d),E);return E}e.stringHash=I;function D(w,E){return E=y(104579,E),w.reduce((d,h)=>k(h,d),E)}function C(w,E){return E=y(181387,E),Object.keys(w).sort().reduce((d,h)=>(d=I(h,d),k(w[h],d)),E)}class i{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=k(E,this._value),this._value}}e.Hasher=i;var P;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function u(w,E,d=32){const h=d-E,v=~((1<<h)-1);return(w<<E|(v&w)>>>h)>>>0}function p(w,E=0,d=w.byteLength,h=0){for(let v=0;v<d;v++)w[E+v]=h}function l(w,E,d="0"){for(;w.length<E;)w=d+w;return w}function c(w,E=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(d=>d.toString(16).padStart(2,"0")).join(""):l((w>>>0).toString(16),E/4)}e.toHexString=c;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const d=E.length;if(d===0)return;const h=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,s,r;for(t!==0?(s=t,r=-1,t=0):(s=E.charCodeAt(0),r=0);;){let n=s;if(g.isHighSurrogate(s))if(r+1<d){const a=E.charCodeAt(r+1);g.isLowSurrogate(a)?(r++,n=g.computeCodePoint(s,a)):n=65533}else{t=s;break}else g.isLowSurrogate(s)&&(n=65533);if(v=this._push(h,v,n),r++,r<d)s=E.charCodeAt(r);else break}this._buffLen=v,this._leftoverHighSurrogate=t}_push(E,d,h){return h<128?E[d++]=h:h<2048?(E[d++]=192|(h&1984)>>>6,E[d++]=128|(h&63)>>>0):h<65536?(E[d++]=224|(h&61440)>>>12,E[d++]=128|(h&4032)>>>6,E[d++]=128|(h&63)>>>0):(E[d++]=240|(h&1835008)>>>18,E[d++]=128|(h&258048)>>>12,E[d++]=128|(h&4032)>>>6,E[d++]=128|(h&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),c(this._h0)+c(this._h1)+c(this._h2)+c(this._h3)+c(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=S._bigBlock32,d=this._buffDV;for(let m=0;m<64;m+=4)E.setUint32(m,d.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)E.setUint32(m,u(E.getUint32(m-12,!1)^E.getUint32(m-32,!1)^E.getUint32(m-56,!1)^E.getUint32(m-64,!1),1),!1);let h=this._h0,v=this._h1,t=this._h2,s=this._h3,r=this._h4,n,a,f;for(let m=0;m<80;m++)m<20?(n=v&t|~v&s,a=1518500249):m<40?(n=v^t^s,a=1859775393):m<60?(n=v&t|v&s|t&s,a=2400959708):(n=v^t^s,a=3395469782),f=u(h,5)+n+r+a+E.getUint32(m*4,!1)&4294967295,r=s,s=t,t=u(v,30),v=h,h=f;this._h0=this._h0+h&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(he[56],fe([0,1,8]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(R||(R={})),function(k){const y="error",T="warning",I="warn",D="info",C="ignore";function i(u){return u?g.equalsIgnoreCase(y,u)?k.Error:g.equalsIgnoreCase(T,u)||g.equalsIgnoreCase(I,u)?k.Warning:g.equalsIgnoreCase(D,u)?k.Info:k.Ignore:k.Ignore}k.fromValue=i;function P(u){switch(u){case k.Error:return y;case k.Warning:return T;case k.Info:return D;default:return C}}k.toString=P}(R||(R={})),e.default=R}),define(he[14],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(m){return Array.isArray(m)}e.isArray=g;function R(m){return typeof m=="string"}e.isString=R;function k(m){return Array.isArray(m)&&m.every(b=>R(b))}e.isStringArray=k;function y(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=y;function T(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=T;function I(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=I;function D(m){return m===!0||m===!1}e.isBoolean=D;function C(m){return typeof m=="undefined"}e.isUndefined=C;function i(m){return!P(m)}e.isDefined=i;function P(m){return C(m)||m===null}e.isUndefinedOrNull=P;function u(m,b){if(!m)throw new Error(b?`Unexpected type, expected '${b}'`:"Unexpected type")}e.assertType=u;function p(m){if(P(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=p;function l(...m){const b=[];for(let _=0;_<m.length;_++){const o=m[_];if(P(o))throw new Error(`Assertion Failed: argument at index ${_} is undefined or null`);b.push(o)}return b}e.assertAllDefined=l;const c=Object.prototype.hasOwnProperty;function S(m){if(!y(m))return!1;for(let b in m)if(c.call(m,b))return!1;return!0}e.isEmptyObject=S;function w(m){return typeof m=="function"}e.isFunction=w;function E(...m){return m.length>0&&m.every(w)}e.areFunctions=E;function d(m,b){const _=Math.min(m.length,b.length);for(let o=0;o<_;o++)h(m[o],b[o])}e.validateConstraints=d;function h(m,b){if(R(b)){if(typeof m!==b)throw new Error(`argument does not match constraint: typeof ${b}`)}else if(w(b)){try{if(m instanceof b)return}catch{}if(!P(m)&&m.constructor===b||b.length===1&&b.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function v(m){let b=[],_=Object.getPrototypeOf(m);for(;Object.prototype!==_;)b=b.concat(Object.getOwnPropertyNames(_)),_=Object.getPrototypeOf(_);return b}e.getAllPropertyNames=v;function t(m){const b=[];for(const _ of v(m))typeof m[_]=="function"&&b.push(_);return b}e.getAllMethodNames=t;function s(m,b){const _=A=>function(){const F=Array.prototype.slice.call(arguments,0);return b(A,F)};let o={};for(const A of m)o[A]=_(A);return o}e.createProxyObject=s;function r(m){return m===null?void 0:m}e.withNullAsUndefined=r;function n(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=n;function a(m){return class{constructor(){return new Proxy({},{get(b,_){if(b[_])return b[_];throw new Error(`Not Implemented: ${m}->${String(_)}`)}})}}}e.NotImplementedProxy=a;function f(m){throw new Error("Unreachable")}e.assertNever=f}),define(he[29],fe([0,1,11,8,9,14]),function(X,e,g,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(r){return r===47||r===92}e.isPathSeparator=T;function I(r){return r.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=I;function D(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=D;function C(r,n=k.posix.sep){if(!r)return"";const a=r.length,f=r.charCodeAt(0);if(T(f)){if(T(r.charCodeAt(1))&&!T(r.charCodeAt(2))){let b=3;const _=b;for(;b<a&&!T(r.charCodeAt(b));b++);if(_!==b&&!T(r.charCodeAt(b+1))){for(b+=1;b<a;b++)if(T(r.charCodeAt(b)))return r.slice(0,b+1).replace(/[\\/]/g,n)}}return n}else if(w(f)&&r.charCodeAt(1)===58)return T(r.charCodeAt(2))?r.slice(0,2)+n:r.slice(0,2);let m=r.indexOf("://");if(m!==-1){for(m+=3;m<a;m++)if(T(r.charCodeAt(m)))return r.slice(0,m+1)}return""}e.getRoot=C;function i(r){if(!g.isWindows||!r||r.length<5)return!1;let n=r.charCodeAt(0);if(n!==92||(n=r.charCodeAt(1),n!==92))return!1;let a=2;const f=a;for(;a<r.length&&(n=r.charCodeAt(a),n!==92);a++);return!(f===a||(n=r.charCodeAt(a+1),isNaN(n)||n===92))}e.isUNC=i;const P=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(r,n=g.isWindows){const a=n?P:u;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||n&&p.test(r)||r==="."||r===".."||n&&r[r.length-1]==="."||n&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=l;function c(r,n,a){const f=r===n;return!a||f?f:!r||!n?!1:(0,R.equalsIgnoreCase)(r,n)}e.isEqual=c;function S(r,n,a,f=k.sep){if(r===n)return!0;if(!r||!n||n.length>r.length)return!1;if(a){if(!(0,R.startsWithIgnoreCase)(r,n))return!1;if(n.length===r.length)return!0;let b=n.length;return n.charAt(n.length-1)===f&&b--,r.charAt(b)===f}return n.charAt(n.length-1)!==f&&(n+=f),r.indexOf(n)===0}e.isEqualOrParent=S;function w(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=w;function E(r,n){return g.isWindows&&r.endsWith(":")&&(r+=k.sep),(0,k.isAbsolute)(r)||(r=(0,k.join)(n,r)),r=(0,k.normalize)(r),g.isWindows?(r=(0,R.rtrim)(r,k.sep),r.endsWith(":")&&(r+=k.sep)):(r=(0,R.rtrim)(r,k.sep),r||(r=k.sep)),r}e.sanitizeFilePath=E;function d(r){const n=(0,k.normalize)(r);return g.isWindows?r.length>3?!1:h(n)&&(r.length===2||n.charCodeAt(2)===92):n===k.posix.sep}e.isRootOrDriveLetter=d;function h(r){return g.isWindows?w(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function v(r){return h(r)?r[0]:void 0}e.getDriveLetter=v;function t(r,n,a){return n.length>r.length?-1:r===n?0:(a&&(r=r.toLowerCase(),n=n.toLowerCase()),r.indexOf(n))}e.indexOfPath=t;function s(r){const n=r.split(":");let a,f,m;if(n.forEach(b=>{const _=Number(b);(0,y.isNumber)(_)?f===void 0?f=_:m===void 0&&(m=_):a=a?[a,b].join(":"):b}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:f!==void 0?f:void 0,column:m!==void 0?m:f!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(he[25],fe([0,1,14]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const S=Array.isArray(c)?[]:{};return Object.keys(c).forEach(w=>{c[w]&&typeof c[w]=="object"?S[w]=R(c[w]):S[w]=c[w]}),S}e.deepClone=R;function k(c){if(!c||typeof c!="object")return c;const S=[c];for(;S.length>0;){const w=S.shift();Object.freeze(w);for(const E in w)if(y.call(w,E)){const d=w[E];typeof d=="object"&&!Object.isFrozen(d)&&S.push(d)}}return c}e.deepFreeze=k;const y=Object.prototype.hasOwnProperty;function T(c,S){return I(c,S,new Set)}e.cloneAndChange=T;function I(c,S,w){if((0,g.isUndefinedOrNull)(c))return c;const E=S(c);if(typeof E!="undefined")return E;if((0,g.isArray)(c)){const d=[];for(const h of c)d.push(I(h,S,w));return d}if((0,g.isObject)(c)){if(w.has(c))throw new Error("Cannot clone recursive data-structure");w.add(c);const d={};for(let h in c)y.call(c,h)&&(d[h]=I(c[h],S,w));return w.delete(c),d}return c}function D(c,S,w=!0){return(0,g.isObject)(c)?((0,g.isObject)(S)&&Object.keys(S).forEach(E=>{E in c?w&&((0,g.isObject)(c[E])&&(0,g.isObject)(S[E])?D(c[E],S[E],w):c[E]=S[E]):c[E]=S[E]}),c):S}e.mixin=D;function C(c,S){if(c===S)return!0;if(c==null||S===null||S===void 0||typeof c!=typeof S||typeof c!="object"||Array.isArray(c)!==Array.isArray(S))return!1;let w,E;if(Array.isArray(c)){if(c.length!==S.length)return!1;for(w=0;w<c.length;w++)if(!C(c[w],S[w]))return!1}else{const d=[];for(E in c)d.push(E);d.sort();const h=[];for(E in S)h.push(E);if(h.sort(),!C(d,h))return!1;for(w=0;w<d.length;w++)if(!C(c[d[w]],S[d[w]]))return!1}return!0}e.equals=C;function i(c){const S=new Set;return JSON.stringify(c,(w,E)=>{if((0,g.isObject)(E)||Array.isArray(E)){if(S.has(E))return"[Circular]";S.add(E)}return E})}e.safeStringify=i;function P(c,S,w){const E=S(c);return typeof E=="undefined"?w:E}e.getOrDefault=P;function u(c,S){const w=Object.create(null);return!c||!S||Object.keys(S).forEach(d=>{const h=c[d],v=S[d];C(h,v)||(w[d]=v)}),w}e.distinct=u;function p(c,S){const w=S.toLowerCase(),E=Object.keys(c).find(d=>d.toLowerCase()===w);return E?c[E]:c[S]}e.getCaseInsensitive=p;function l(c,S){const w=Object.create(null);for(const E of Object.keys(c))S(E,c[E])&&(w[E]=c[E]);return w}e.filter=l}),define(he[93],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function R(y){return y<0?0:y>255?255:y|0}e.toUint8=R;function k(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=k}),define(he[2],fe([0,1,11,9]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,y=/^\//,T=/^\/\//;function I(r,n){if(!r.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!y.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(r,n){return!r&&!n?"file":r}function C(r,n){switch(r){case"https":case"http":case"file":n?n[0]!==P&&(n=P+n):n=P;break}return n}const i="",P="/",u=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(n,a,f,m,b,_=!1){typeof n=="object"?(this.scheme=n.scheme||i,this.authority=n.authority||i,this.path=n.path||i,this.query=n.query||i,this.fragment=n.fragment||i):(this.scheme=D(n,_),this.authority=a||i,this.path=C(this.scheme,f||i),this.query=m||i,this.fragment=b||i,I(this,_))}static isUri(n){return n instanceof p?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return d(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:f,path:m,query:b,fragment:_}=n;return a===void 0?a=this.scheme:a===null&&(a=i),f===void 0?f=this.authority:f===null&&(f=i),m===void 0?m=this.path:m===null&&(m=i),b===void 0?b=this.query:b===null&&(b=i),_===void 0?_=this.fragment:_===null&&(_=i),a===this.scheme&&f===this.authority&&m===this.path&&b===this.query&&_===this.fragment?this:new c(a,f,m,b,_)}static parse(n,a=!1){const f=u.exec(n);return f?new c(f[2]||i,s(f[4]||i),s(f[5]||i),s(f[7]||i),s(f[9]||i),a):new c(i,i,i,i,i)}static file(n){let a=i;if(g.isWindows&&(n=n.replace(/\\/g,P)),n[0]===P&&n[1]===P){const f=n.indexOf(P,2);f===-1?(a=n.substring(2),n=P):(a=n.substring(2,f),n=n.substring(f)||P)}return new c("file",a,n,i,i)}static from(n){const a=new c(n.scheme,n.authority,n.path,n.query,n.fragment);return I(a,!0),a}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return g.isWindows&&n.scheme==="file"?f=p.file(R.win32.join(d(n,!0),...a)).path:f=R.posix.join(n.path,...a),n.with({path:f})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof p)return n;{const a=new c(n);return a._formatted=n.external,a._fsPath=n._sep===l?n.fsPath:null,a}}else return n}}e.URI=p;const l=g.isWindows?1:void 0;class c extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=l),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(r,n){let a,f=-1;for(let m=0;m<r.length;m++){const b=r.charCodeAt(m);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||n&&b===47)f!==-1&&(a+=encodeURIComponent(r.substring(f,m)),f=-1),a!==void 0&&(a+=r.charAt(m));else{a===void 0&&(a=r.substr(0,m));const _=S[b];_!==void 0?(f!==-1&&(a+=encodeURIComponent(r.substring(f,m)),f=-1),a+=_):f===-1&&(f=m)}}return f!==-1&&(a+=encodeURIComponent(r.substring(f))),a!==void 0?a:r}function E(r){let n;for(let a=0;a<r.length;a++){const f=r.charCodeAt(a);f===35||f===63?(n===void 0&&(n=r.substr(0,a)),n+=S[f]):n!==void 0&&(n+=r[a])}return n!==void 0?n:r}function d(r,n){let a;return r.authority&&r.path.length>1&&r.scheme==="file"?a=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?n?a=r.path.substr(1):a=r.path[1].toLowerCase()+r.path.substr(2):a=r.path,g.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=d;function h(r,n){const a=n?E:w;let f="",{scheme:m,authority:b,path:_,query:o,fragment:A}=r;if(m&&(f+=m,f+=":"),(b||m==="file")&&(f+=P,f+=P),b){let F=b.indexOf("@");if(F!==-1){const $=b.substr(0,F);b=b.substr(F+1),F=$.indexOf(":"),F===-1?f+=a($,!1):(f+=a($.substr(0,F),!1),f+=":",f+=a($.substr(F+1),!1)),f+="@"}b=b.toLowerCase(),F=b.indexOf(":"),F===-1?f+=a(b,!1):(f+=a(b.substr(0,F),!1),f+=b.substr(F))}if(_){if(_.length>=3&&_.charCodeAt(0)===47&&_.charCodeAt(2)===58){const F=_.charCodeAt(1);F>=65&&F<=90&&(_=`/${String.fromCharCode(F+32)}:${_.substr(3)}`)}else if(_.length>=2&&_.charCodeAt(1)===58){const F=_.charCodeAt(0);F>=65&&F<=90&&(_=`${String.fromCharCode(F+32)}:${_.substr(2)}`)}f+=a(_,!0)}return o&&(f+="?",f+=a(o,!1)),A&&(f+="#",f+=n?A:w(A,!1)),f}function v(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+v(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,n=>v(n)):r}});var it=this&&this.__classPrivateFieldSet||function(X,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,g):k?k.value=g:e.set(X,g),g},xe=this&&this.__classPrivateFieldGet||function(X,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(X):R?R.value:e.get(X)};define(he[23],fe([0,1,2,8]),function(X,e,g,R){"use strict";var k,y,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(t,s,r){let n=t.get(s);return n===void 0&&(n=r,t.set(s,n)),n}e.getOrSet=I;function D(t){const s=[];return t.forEach((r,n)=>{s.push(`${n} => ${r}`)}),`Map(${t.size}) {${s.join(", ")}}`}e.mapToString=D;function C(t){const s=[];return t.forEach(r=>{s.push(r)}),`Set(${t.size}) {${s.join(", ")}}`}e.setToString=C;class i{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const r=s.charCodeAt(0),n=this._value.charCodeAt(this._pos);return r-n}value(){return this._value[this._pos]}}e.StringIterator=i;class P{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,R.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class u{constructor(s=!0,r=!0){this._splitOnBackslash=s,this._caseSensitive=r}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,R.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=u;var p;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(p||(p={}));class l{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new u(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,R.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class c{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class S{constructor(s){this._iter=s}static forUris(s=()=>!1){return new S(new l(s))}static forPaths(){return new S(new u)}static forStrings(){return new S(new i)}static forConfigKeys(){return new S(new P)}clear(){this._root=void 0}set(s,r){const n=this._iter.reset(s);let a;for(this._root||(this._root=new c,this._root.segment=n.value()),a=this._root;;){const m=n.cmp(a.segment);if(m>0)a.left||(a.left=new c,a.left.segment=n.value()),a=a.left;else if(m<0)a.right||(a.right=new c,a.right.segment=n.value()),a=a.right;else if(n.hasNext())n.next(),a.mid||(a.mid=new c,a.mid.segment=n.value()),a=a.mid;else break}const f=a.value;return a.value=r,a.key=s,f}get(s){return this._getNode(s)?.value}_getNode(s){const r=this._iter.reset(s);let n=this._root;for(;n;){const a=r.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(r.hasNext())r.next(),n=n.mid;else break}return n}has(s){const r=this._getNode(s);return!(r?.value===void 0&&r?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,r){const n=this._iter.reset(s),a=[];let f=this._root;for(;f;){const m=n.cmp(f.segment);if(m>0)a.push([1,f]),f=f.left;else if(m<0)a.push([-1,f]),f=f.right;else if(n.hasNext())n.next(),a.push([0,f]),f=f.mid;else{for(r?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;a.length>0&&f.isEmpty();){let[b,_]=a.pop();switch(b){case 1:_.left=void 0;break;case 0:_.mid=void 0;break;case-1:_.right=void 0;break}f=_}break}}}findSubstr(s){const r=this._iter.reset(s);let n=this._root,a;for(;n;){const f=r.cmp(n.segment);if(f>0)n=n.left;else if(f<0)n=n.right;else if(r.hasNext())r.next(),a=n.value||a,n=n.mid;else break}return n&&n.value||a}findSuperstr(s){const r=this._iter.reset(s);let n=this._root;for(;n;){const a=r.cmp(n.segment);if(a>0)n=n.left;else if(a<0)n=n.right;else if(r.hasNext())r.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(s){for(const[r,n]of this)s(n,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const r=[s];for(;r.length>0;){const n=r.pop();n&&(n.value&&(yield[n.key,n.value]),n.left&&r.push(n.left),n.mid&&r.push(n.mid),n.right&&r.push(n.right))}}}e.TernarySearchTree=S;class w{constructor(s,r){this[k]="ResourceMap",s instanceof w?(this.map=new Map(s.map),this.toKey=r??w.defaultToKey):(this.map=new Map,this.toKey=s??w.defaultToKey)}set(s,r){return this.map.set(this.toKey(s),r),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,r){typeof r!="undefined"&&(s=s.bind(r));for(let[n,a]of this.map)s(a,g.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield g.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[g.URI.parse(s[0]),s[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[g.URI.parse(s[0]),s[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class d{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,r=0){const n=this._map.get(s);if(!!n)return r!==0&&this.touch(n,r),n.value}set(s,r,n=0){let a=this._map.get(s);if(a)a.value=r,n!==0&&this.touch(a,n);else{switch(a={key:s,value:r,next:void 0,previous:void 0},n){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(s,a),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const r=this._map.get(s);if(!!r)return this._map.delete(s),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,r){const n=this._state;let a=this._head;for(;a;){if(r?s.bind(r)(a.value,a.key,this):s(a.value,a.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const s=this,r=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const f={value:n.key,done:!1};return n=n.next,f}else return{value:void 0,done:!0}}};return a}values(){const s=this,r=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const f={value:n.value,done:!1};return n=n.next,f}else return{value:void 0,done:!0}}};return a}entries(){const s=this,r=this._state;let n=this._head;const a={[Symbol.iterator](){return a},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const f={value:[n.key,n.value],done:!1};return n=n.next,f}else return{value:void 0,done:!0}}};return a}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let r=this._head,n=this.size;for(;r&&n>s;)this._map.delete(r.key),r=r.next,n--;this._head=r,this._size=n,r&&(r.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const r=s.next,n=s.previous;if(!r||!n)throw new Error("Invalid list");r.previous=n,n.next=r}s.next=void 0,s.previous=void 0,this._state++}touch(s,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(s===this._head)return;const n=s.next,a=s.previous;s===this._tail?(a.next=void 0,this._tail=a):(n.previous=a,a.next=n),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(r===2){if(s===this._tail)return;const n=s.next,a=s.previous;s===this._head?(n.previous=void 0,this._head=n):(n.previous=a,a.next=n),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((r,n)=>{s.push([n,r])}),s}fromJSON(s){this.clear();for(const[r,n]of s)this.set(r,n)}}e.LinkedMap=d;class h extends d{constructor(s,r=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,r=2){return super.get(s,r)}peek(s){return super.get(s,0)}set(s,r){return super.set(s,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=h;class v{constructor(s){T.set(this,void 0),it(this,T,s,"f")}get size(){return xe(this,T,"f").size}forEach(s,r){xe(this,T,"f").forEach(s,r)}get(s){return xe(this,T,"f").get(s)}has(s){return xe(this,T,"f").has(s)}entries(){return xe(this,T,"f").entries()}keys(){return xe(this,T,"f").keys()}values(){return xe(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return xe(this,T,"f").entries()}}e.ReadonlyMapView=v}),define(he[94],fe([0,1,23,8]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...ee){return function(ue,Ie){for(let $e=0,qe=ee.length;$e<qe;$e++){const be=ee[$e](ue,Ie);if(be)return be}return null}}e.or=k,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(ee,ue,Ie){if(!Ie||Ie.length<ue.length)return null;let $e;return ee?$e=R.startsWithIgnoreCase(Ie,ue):$e=Ie.indexOf(ue)===0,$e?ue.length>0?[{start:0,end:ue.length}]:[]:null}function T(ee,ue){const Ie=ue.toLowerCase().indexOf(ee.toLowerCase());return Ie===-1?null:[{start:Ie,end:Ie+ee.length}]}e.matchesContiguousSubString=T;function I(ee,ue){return D(ee.toLowerCase(),ue.toLowerCase(),0,0)}e.matchesSubString=I;function D(ee,ue,Ie,$e){if(Ie===ee.length)return[];if($e===ue.length)return null;if(ee[Ie]===ue[$e]){let qe=null;return(qe=D(ee,ue,Ie+1,$e+1))?w({start:$e,end:$e+1},qe):null}return D(ee,ue,Ie,$e+1)}function C(ee){return 97<=ee&&ee<=122}function i(ee){return 65<=ee&&ee<=90}e.isUpper=i;function P(ee){return 48<=ee&&ee<=57}function u(ee){return ee===32||ee===9||ee===10||ee===13}const p=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ee=>p.add(ee.charCodeAt(0)));function l(ee){return u(ee)||p.has(ee)}function c(ee,ue){return ee===ue||l(ee)&&l(ue)}function S(ee){return C(ee)||i(ee)||P(ee)}function w(ee,ue){return ue.length===0?ue=[ee]:ee.end===ue[0].start?ue[0].start=ee.start:ue.unshift(ee),ue}function E(ee,ue){for(let Ie=ue;Ie<ee.length;Ie++){const $e=ee.charCodeAt(Ie);if(i($e)||P($e)||Ie>0&&!S(ee.charCodeAt(Ie-1)))return Ie}return ee.length}function d(ee,ue,Ie,$e){if(Ie===ee.length)return[];if($e===ue.length)return null;if(ee[Ie]!==ue[$e].toLowerCase())return null;{let qe=null,be=$e+1;for(qe=d(ee,ue,Ie+1,$e+1);!qe&&(be=E(ue,be))<ue.length;)qe=d(ee,ue,Ie+1,be),be++;return qe===null?null:w({start:$e,end:$e+1},qe)}}function h(ee){let ue=0,Ie=0,$e=0,qe=0,be=0;for(let Ue=0;Ue<ee.length;Ue++)be=ee.charCodeAt(Ue),i(be)&&ue++,C(be)&&Ie++,S(be)&&$e++,P(be)&&qe++;const tt=ue/ee.length,K=Ie/ee.length,te=$e/ee.length,pe=qe/ee.length;return{upperPercent:tt,lowerPercent:K,alphaPercent:te,numericPercent:pe}}function v(ee){const{upperPercent:ue,lowerPercent:Ie}=ee;return Ie===0&&ue>.6}function t(ee){const{upperPercent:ue,lowerPercent:Ie,alphaPercent:$e,numericPercent:qe}=ee;return Ie>.2&&ue<.8&&$e>.6&&qe<.2}function s(ee){let ue=0,Ie=0,$e=0,qe=0;for(let be=0;be<ee.length;be++)$e=ee.charCodeAt(be),i($e)&&ue++,C($e)&&Ie++,u($e)&&qe++;return(ue===0||Ie===0)&&qe===0?ee.length<=30:ue<=5}function r(ee,ue){if(!ue||(ue=ue.trim(),ue.length===0)||!s(ee)||ue.length>60)return null;const Ie=h(ue);if(!t(Ie)){if(!v(Ie))return null;ue=ue.toLowerCase()}let $e=null,qe=0;for(ee=ee.toLowerCase();qe<ue.length&&($e=d(ee,ue,0,qe))===null;)qe=E(ue,qe+1);return $e}e.matchesCamelCase=r;function n(ee,ue,Ie=!1){if(!ue||ue.length===0)return null;let $e=null,qe=0;for(ee=ee.toLowerCase(),ue=ue.toLowerCase();qe<ue.length&&($e=a(ee,ue,0,qe,Ie))===null;)qe=f(ue,qe+1);return $e}e.matchesWords=n;function a(ee,ue,Ie,$e,qe){if(Ie===ee.length)return[];if($e===ue.length)return null;if(c(ee.charCodeAt(Ie),ue.charCodeAt($e))){let be=null,tt=$e+1;if(be=a(ee,ue,Ie+1,$e+1,qe),!qe)for(;!be&&(tt=f(ue,tt))<ue.length;)be=a(ee,ue,Ie+1,tt,qe),tt++;return be===null?null:w({start:$e,end:$e+1},be)}else return null}function f(ee,ue){for(let Ie=ue;Ie<ee.length;Ie++)if(l(ee.charCodeAt(Ie))||Ie>0&&l(ee.charCodeAt(Ie-1)))return Ie;return ee.length}const m=k(e.matchesPrefix,r,T),b=k(e.matchesPrefix,r,I),_=new g.LRUCache(1e4);function o(ee,ue,Ie=!1){if(typeof ee!="string"||typeof ue!="string")return null;let $e=_.get(ee);$e||($e=new RegExp(R.convertSimple2RegExpPattern(ee),"i"),_.set(ee,$e));const qe=$e.exec(ue);return qe?[{start:qe.index,end:qe.index+qe[0].length}]:Ie?b(ee,ue):m(ee,ue)}e.matchesFuzzy=o;function A(ee,ue){const Ie=Ve(ee,ee.toLowerCase(),0,ue,ue.toLowerCase(),0,!0);return Ie?$(Ie):null}e.matchesFuzzy2=A;function F(ee,ue,Ie,$e,qe,be){const tt=Math.min(13,ee.length);for(;Ie<tt;Ie++){const K=Ve(ee,ue,Ie,$e,qe,be,!1);if(K)return K}return[0,be]}e.anyScore=F;function $(ee){if(typeof ee=="undefined")return[];const ue=[],Ie=ee[1];for(let $e=ee.length-1;$e>1;$e--){const qe=ee[$e]+Ie,be=ue[ue.length-1];be&&be.end===qe?be.end=qe+1:ue.push({start:qe,end:qe+1})}return ue}e.createMatches=$;const W=128;function Q(){const ee=[],ue=[];for(let Ie=0;Ie<=W;Ie++)ue[Ie]=0;for(let Ie=0;Ie<=W;Ie++)ee.push(ue.slice(0));return ee}function H(ee){const ue=[];for(let Ie=0;Ie<=ee;Ie++)ue[Ie]=0;return ue}const N=H(2*W),x=H(2*W),L=Q(),G=Q(),M=Q(),O=!1;function B(ee,ue,Ie,$e,qe){function be(K,te,pe=" "){for(;K.length<te;)K=pe+K;return K}let tt=` |   |${$e.split("").map(K=>be(K,3)).join("|")}
`;for(let K=0;K<=Ie;K++)K===0?tt+=" |":tt+=`${ue[K-1]}|`,tt+=ee[K].slice(0,qe+1).map(te=>be(te.toString(),3)).join("|")+`
`;return tt}function z(ee,ue,Ie,$e){ee=ee.substr(ue),Ie=Ie.substr($e),console.log(B(G,ee,ee.length,Ie,Ie.length)),console.log(B(M,ee,ee.length,Ie,Ie.length)),console.log(B(L,ee,ee.length,Ie,Ie.length))}function J(ee,ue){if(ue<0||ue>=ee.length)return!1;const Ie=ee.codePointAt(ue);switch(Ie){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(Ie)}}function ce(ee,ue){if(ue<0||ue>=ee.length)return!1;switch(ee.charCodeAt(ue)){case 32:case 9:return!0;default:return!1}}function ye(ee,ue,Ie){return ue[ee]!==Ie[ee]}function Fe(ee,ue,Ie,$e,qe,be,tt=!1){for(;ue<Ie&&qe<be;)ee[ue]===$e[qe]&&(tt&&(N[ue]=qe),ue+=1),qe+=1;return ue===Ie}e.isPatternInWord=Fe;var Re;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(Re||(Re={}));var Ne;(function(ee){ee.Default=[-100,0];function ue(Ie){return!Ie||Ie.length===2&&Ie[0]===-100&&Ie[1]===0}ee.isDefault=ue})(Ne=e.FuzzyScore||(e.FuzzyScore={}));function Ve(ee,ue,Ie,$e,qe,be,tt){const K=ee.length>W?W:ee.length,te=$e.length>W?W:$e.length;if(Ie>=K||be>=te||K-Ie>te-be||!Fe(ue,Ie,K,qe,be,te,!0))return;ze(K,te,Ie,be,ue,qe);let pe=1,Ue=1,We=Ie,Ze=be;const Pe=[!1];for(pe=1,We=Ie;We<K;pe++,We++){const me=N[We],we=x[We],q=We+1<K?x[We+1]:te;for(Ue=me-be+1,Ze=me;Ze<q;Ue++,Ze++){let ge=Number.MIN_SAFE_INTEGER,_e=!1;Ze<=we&&(ge=j(ee,ue,We,Ie,$e,qe,Ze,te,be,L[pe-1][Ue-1]===0,Pe));let Te=0;ge!==Number.MAX_SAFE_INTEGER&&(_e=!0,Te=ge+G[pe-1][Ue-1]);const Oe=Ze>me,Ge=Oe?G[pe][Ue-1]+(L[pe][Ue-1]>0?-5:0):0,et=Ze>me+1&&L[pe][Ue-1]>0,Qe=et?G[pe][Ue-2]+(L[pe][Ue-2]>0?-5:0):0;if(et&&(!Oe||Qe>=Ge)&&(!_e||Qe>=Te))G[pe][Ue]=Qe,M[pe][Ue]=3,L[pe][Ue]=0;else if(Oe&&(!_e||Ge>=Te))G[pe][Ue]=Ge,M[pe][Ue]=2,L[pe][Ue]=0;else if(_e)G[pe][Ue]=Te,M[pe][Ue]=1,L[pe][Ue]=L[pe-1][Ue-1]+1;else throw new Error("not possible")}}if(O&&z(ee,Ie,$e,be),!Pe[0]&&!tt)return;pe--,Ue--;const Ce=[G[pe][Ue],be];let Ae=0,se=0;for(;pe>=1;){let me=Ue;do{const we=M[pe][me];if(we===3)me=me-2;else if(we===2)me=me-1;else break}while(me>=1);Ae>1&&ue[Ie+pe-1]===qe[be+Ue-1]&&!ye(me+be-1,$e,qe)&&Ae+1>L[pe][me]&&(me=Ue),me===Ue?Ae++:Ae=1,se||(se=me),pe--,Ue=me-1,Ce.push(Ue)}te===K&&(Ce[0]+=2);const le=se-K;return Ce[0]-=le,Ce}e.fuzzyScore=Ve;function ze(ee,ue,Ie,$e,qe,be){let tt=ee-1,K=ue-1;for(;tt>=Ie&&K>=$e;)qe[tt]===be[K]&&(x[tt]=K,tt--),K--}function j(ee,ue,Ie,$e,qe,be,tt,K,te,pe,Ue){if(ue[Ie]!==be[tt])return Number.MIN_SAFE_INTEGER;let We=1,Ze=!1;return tt===Ie-$e?We=ee[Ie]===qe[tt]?7:5:ye(tt,qe,be)&&(tt===0||!ye(tt-1,qe,be))?(We=ee[Ie]===qe[tt]?7:5,Ze=!0):J(be,tt)&&(tt===0||!J(be,tt-1))?We=5:(J(be,tt-1)||ce(be,tt-1))&&(We=5,Ze=!0),We>1&&Ie===$e&&(Ue[0]=!0),Ze||(Ze=ye(tt,qe,be)||J(be,tt-1)||ce(be,tt-1)),Ie===$e?tt>te&&(We-=Ze?3:5):pe?We+=Ze?2:0:We+=Ze?0:1,tt+1===K&&(We-=Ze?3:5),We}function Z(ee,ue,Ie,$e,qe,be,tt){return oe(ee,ue,Ie,$e,qe,be,!0,tt)}e.fuzzyScoreGracefulAggressive=Z;function ie(ee,ue,Ie,$e,qe,be,tt){return oe(ee,ue,Ie,$e,qe,be,!1,tt)}e.fuzzyScoreGraceful=ie;function oe(ee,ue,Ie,$e,qe,be,tt,K){let te=Ve(ee,ue,Ie,$e,qe,be,K);if(te&&!tt)return te;if(ee.length>=3){const pe=Math.min(7,ee.length-1);for(let Ue=Ie+1;Ue<pe;Ue++){const We=ve(ee,Ue);if(We){const Ze=Ve(We,We.toLowerCase(),Ie,$e,qe,be,K);Ze&&(Ze[0]-=3,(!te||Ze[0]>te[0])&&(te=Ze))}}}return te}function ve(ee,ue){if(ue+1>=ee.length)return;const Ie=ee[ue],$e=ee[ue+1];if(Ie!==$e)return ee.slice(0,ue)+$e+Ie+ee.slice(ue+2)}}),define(he[137],fe([0,1,73,94,8]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${y.source}`,"g");function I(c){return c.replace(T,(S,w)=>w?S:`\\${S}`)}e.escapeIcons=I;const D=new RegExp(`\\\\${y.source}`,"g");function C(c){return c.replace(D,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=C;const i=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function P(c){return c.indexOf(e.iconStartMarker)===-1?c:c.replace(i,(S,w,E,d)=>E?S:w||d||"")}e.stripIcons=P;function u(c){const S=c.indexOf(e.iconStartMarker);return S===-1?{text:c}:p(c,S)}e.parseLabelWithIcons=u;function p(c,S){const w=[];let E="";function d(f){if(f){E+=f;for(const m of f)w.push(t)}}let h=-1,v="",t=0,s,r,n=S;const a=c.length;for(d(c.substr(0,S));n<a;)s=c[n],r=c[n+1],s===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(h=n,d(v),v=e.iconStartMarker,n++):s===")"&&h!==-1?(t+=n-h+1,h=-1,v=""):h!==-1?/^[a-z0-9\-]$/i.test(s)?v+=s:(d(v),h=-1,v=""):d(s),n++;return d(v),{text:E,iconOffsets:w}}function l(c,S,w=!1){const{text:E,iconOffsets:d}=S;if(!d||d.length===0)return(0,R.matchesFuzzy)(c,E,w);const h=(0,k.ltrim)(E," "),v=E.length-h.length,t=(0,R.matchesFuzzy)(c,h,w);if(t)for(const s of t){const r=d[s.start+v]+v;s.start+=r,s.end+=r}return t}e.matchesFuzzyIconAware=l}),define(he[95],fe([0,1,137,15]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(p="",l=!1){if(this.value=p,typeof this.value!="string")throw(0,R.illegalArgument)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1)}appendText(p,l=0){return this.value+=C(this.supportThemeIcons?(0,g.escapeIcons)(p):p).replace(/([ \t]+)/g,(c,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,l){return this.value+="\n```",this.value+=p,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}}e.MarkdownString=y;function T(u){return I(u)?!u.value:Array.isArray(u)?u.every(T):!0}e.isEmptyMarkdownString=T;function I(u){return u instanceof y?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function D(u,p){return u===p?!0:!u||!p?!1:u.value===p.value&&u.isTrusted===p.isTrusted&&u.supportThemeIcons===p.supportThemeIcons}e.markdownStringEqual=D;function C(u){return u.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function i(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function P(u){const p=[],l=u.split("|").map(S=>S.trim());u=l[0];const c=l[1];if(c){const S=/height=(\d+)/.exec(c),w=/width=(\d+)/.exec(c),E=S?S[1]:"",d=w?w[1]:"",h=isFinite(parseInt(d)),v=isFinite(parseInt(E));h&&p.push(`width="${d}"`),v&&p.push(`height="${E}"`)}return{href:u,dimensions:p}}e.parseHrefAndDimensions=P}),define(he[57],fe([0,1,22,8,2]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function y(i){return JSON.stringify(i,D)}e.stringify=y;function T(i){let P=JSON.parse(i);return P=C(P),P}e.parse=T;var I;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function D(i,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,R.regExpFlags)(P)}:P}function C(i,P=0){if(!i||P>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return k.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof g.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let u=0;u<i.length;++u)i[u]=C(i[u],P+1);else for(const u in i)Object.hasOwnProperty.call(i,u)&&(i[u]=C(i[u],P+1))}return i}e.revive=C}),define(he[10],fe([0,1,2,11]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,C,i){this._hosts[D]=C,this._ports[D]=i}setConnectionToken(D,C){this._connectionTokens[D]=C}rewrite(D){if(this._delegate)return this._delegate(D);const C=D.authority;let i=this._hosts[C];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const P=this._ports[C],u=this._connectionTokens[C];let p=`path=${encodeURIComponent(D.path)}`;return typeof u=="string"&&(p+=`&tkn=${encodeURIComponent(u)}`),g.URI.from({scheme:R.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${i}:${P}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new y;class T{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,C,i){const P=this.toUri(D,C);if(P.scheme===k.vscodeRemote)return e.RemoteAuthorities.rewrite(P);let u=!1;return R.isNative&&(i||R.isPreferringBrowserCodeLoad)&&P.scheme===k.file&&(u=!0),P.scheme===k.file&&typeof R.globals.importScripts=="function"&&R.globals.origin==="vscode-file://vscode-app"&&(u=!0),u?P.with({scheme:k.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(D,C){const i=this.toUri(D,C);return i.scheme===k.vscodeFileResource?i.with({scheme:k.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(D,C){return g.URI.isUri(D)?D:g.URI.parse(C.toUrl(D))}}e.FileAccess=new T}),define(he[75],fe([0,1,23]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new g.LRUCache(1e4);function k(C){return D(C,"NFC",R)}e.normalizeNFC=k;const y=new g.LRUCache(1e4);function T(C){return D(C,"NFD",y)}e.normalizeNFD=T;const I=/[^\u0000-\u0080]/;function D(C,i,P){if(!C)return C;const u=P.get(C);if(u)return u;let p;return I.test(C)?p=C.normalize(i):p=C,P.set(C,p),p}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(i){return T(i).replace(C,"")}}()}),define(he[24],fe([0,1,29,9,2,8,10,11]),function(X,e,g,R,k,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(p){return(0,k.uriToFsPath)(p,!0)}e.originalFSPath=D;class C{constructor(l){this._ignorePathCasing=l}compare(l,c,S=!1){return l===c?0:(0,y.compare)(this.getComparisonKey(l,S),this.getComparisonKey(c,S))}isEqual(l,c,S=!1){return l===c?!0:!l||!c?!1:this.getComparisonKey(l,S)===this.getComparisonKey(c,S)}getComparisonKey(l,c=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,c,S=!1){if(l.scheme===c.scheme){if(l.scheme===T.Schemas.file)return g.isEqualOrParent(D(l),D(c),this._ignorePathCasing(l))&&l.query===c.query&&(S||l.fragment===c.fragment);if((0,e.isEqualAuthority)(l.authority,c.authority))return g.isEqualOrParent(l.path,c.path,this._ignorePathCasing(l),"/")&&l.query===c.query&&(S||l.fragment===c.fragment)}return!1}joinPath(l,...c){return k.URI.joinPath(l,...c)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return R.posix.basename(l.path)}extname(l){return R.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let c;return l.scheme===T.Schemas.file?c=k.URI.file(R.dirname(D(l))).path:(c=R.posix.dirname(l.path),l.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),c="/")),l.with({path:c})}normalizePath(l){if(!l.path.length)return l;let c;return l.scheme===T.Schemas.file?c=k.URI.file(R.normalize(D(l))).path:c=R.posix.normalize(l.path),l.with({path:c})}relativePath(l,c){if(l.scheme!==c.scheme||!(0,e.isEqualAuthority)(l.authority,c.authority))return;if(l.scheme===T.Schemas.file){const E=R.relative(D(l),D(c));return I.isWindows?g.toSlashes(E):E}let S=l.path||"/",w=c.path||"/";if(this._ignorePathCasing(l)){let E=0;for(const d=Math.min(S.length,w.length);E<d&&!(S.charCodeAt(E)!==w.charCodeAt(E)&&S.charAt(E).toLowerCase()!==w.charAt(E).toLowerCase());E++);S=w.substr(0,E)+S.substr(E)}return R.posix.relative(S,w)}resolvePath(l,c){if(l.scheme===T.Schemas.file){const S=k.URI.file(R.resolve(D(l),c));return l.with({authority:S.authority,path:S.path})}return c=g.toPosixPath(c),l.with({path:R.posix.resolve(l.path,c)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,c){return l===c||(0,y.equalsIgnoreCase)(l,c)}hasTrailingPathSeparator(l,c=R.sep){if(l.scheme===T.Schemas.file){const S=D(l);return S.length>g.getRoot(S).length&&S[S.length-1]===c}else{const S=l.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,c=R.sep){return(0,e.hasTrailingPathSeparator)(l,c)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,c=R.sep){let S=!1;if(l.scheme===T.Schemas.file){const w=D(l);S=w!==void 0&&w.length===g.getRoot(w).length&&w[w.length-1]===c}else{c="/";const w=l.path;S=w.length===1&&w.charCodeAt(w.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(l,c)?l.with({path:l.path+"/"}):l}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(p=>p.scheme===T.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new C(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,l){const c=[];for(let S=0;S<p.length;S++){const w=l(p[S]);p.some((E,d)=>d===S?!1:(0,e.isEqualOrParent)(w,l(E)))||c.push(p[S])}return c}e.distinctParents=i;var P;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function l(c){const S=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(d=>{const[h,v]=d.split(":");h&&v&&S.set(h,v)});const E=c.path.substring(0,c.path.indexOf(";"));return E&&S.set(p.META_DATA_MIME,E),S}p.parseMetaData=l})(P=e.DataUri||(e.DataUri={}));function u(p,l,c){if(l){let S=p.path;return S&&S[0]!==R.posix.sep&&(S=R.posix.sep+S),p.with({scheme:c,authority:l,path:S})}return p.with({scheme:c})}e.toLocalResource=u}),define(he[17],fe([0,1,21,15,3,6,24]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(x){return!!x&&typeof x.then=="function"}e.isThenable=I;function D(x){const L=new g.CancellationTokenSource,G=x(L.token),M=new Promise((O,B)=>{const z=L.token.onCancellationRequested(()=>{z.dispose(),L.dispose(),B((0,R.canceled)())});Promise.resolve(G).then(J=>{z.dispose(),L.dispose(),O(J)},J=>{z.dispose(),L.dispose(),B(J)})});return new class{cancel(){L.cancel()}then(O,B){return M.then(O,B)}catch(O){return this.then(void 0,O)}finally(O){return M.finally(O)}}}e.createCancelablePromise=D;function C(x,L,G){return Promise.race([x,new Promise(M=>L.onCancellationRequested(()=>M(G)))])}e.raceCancellation=C;async function i(x){let L=-1;const G=x.map((O,B)=>O.then(z=>(L=B,z))),M=await Promise.race(G);return x.forEach((O,B)=>{B!==L&&O.cancel()}),M}e.raceCancellablePromises=i;function P(x,L,G){let M;const O=setTimeout(()=>{M?.(void 0),G?.()},L);return Promise.race([x.finally(()=>clearTimeout(O)),new Promise(B=>M=B)])}e.raceTimeout=P;function u(x){return new Promise((L,G)=>{const M=x();I(M)?M.then(L,G):L(M)})}e.asPromise=u;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const G=()=>{this.queuedPromise=null;const M=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,M};this.queuedPromise=new Promise(M=>{this.activePromise.then(G,G).then(M)})}return new Promise((G,M)=>{this.queuedPromise.then(G,M)})}return this.activePromise=L(),new Promise((G,M)=>{this.activePromise.then(O=>{this.activePromise=null,G(O)},O=>{this.activePromise=null,M(O)})})}}e.Throttler=p;class l{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=l;class c{constructor(){this.promiseMap=new Map}queue(L,G){const O=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.promiseMap.get(L)===O&&this.promiseMap.delete(L)});return this.promiseMap.set(L,O),O}}e.SequencerByKey=c;class S{constructor(L){this.defaultDelay=L,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,G=this.defaultDelay){return this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((M,O)=>{this.doResolve=M,this.doReject=O}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const M=this.task;return this.task=null,M()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},G),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=S;class w{constructor(L){this.delayer=new S(L),this.throttler=new p}trigger(L,G){return this.delayer.trigger(()=>this.throttler.queue(L),G)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class E{constructor(){this._isOpen=!1,this._promise=new Promise((L,G)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=E;class d extends E{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function h(x,L){return L?new Promise((G,M)=>{const O=setTimeout(()=>{B.dispose(),G()},x),B=L.onCancellationRequested(()=>{clearTimeout(O),B.dispose(),M((0,R.canceled)())})}):D(G=>h(x,G))}e.timeout=h;function v(x,L=0){const G=setTimeout(x,L);return(0,y.toDisposable)(()=>clearTimeout(G))}e.disposableTimeout=v;function t(x){const L=[];let G=0;const M=x.length;function O(){return G<M?x[G++]():null}function B(z){z!=null&&L.push(z);const J=O();return J?J.then(B):Promise.resolve(L)}return Promise.resolve(null).then(B)}e.sequence=t;function s(x,L=M=>!!M,G=null){let M=0;const O=x.length,B=()=>{if(M>=O)return Promise.resolve(G);const z=x[M++];return Promise.resolve(z()).then(ce=>L(ce)?Promise.resolve(ce):B())};return B()}e.first=s;function r(x,L=M=>!!M,G=null){if(x.length===0)return Promise.resolve(G);let M=x.length;const O=()=>{M=-1;for(const B of x)B.cancel?.()};return new Promise((B,z)=>{for(const J of x)J.then(ce=>{--M>=0&&L(ce)?(O(),B(ce)):M===0&&B(G)}).catch(ce=>{--M>=0&&(O(),z(ce))})})}e.firstParallel=r;class n{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(L){return this._size++,new Promise((G,M)=>{this.outstandingPromises.push({factory:L,c:G,e:M}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const G=L.factory();G.then(L.c,L.e),G.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=n;class a extends n{constructor(){super(1)}}e.Queue=a;class f{constructor(){this.queues=new Map}queueFor(L,G=T.extUri){const M=G.getComparisonKey(L);let O=this.queues.get(M);return O||(O=new a,k.Event.once(O.onFinished)(()=>{O?.dispose(),this.queues.delete(M)}),this.queues.set(M,O)),O}dispose(){this.queues.forEach(L=>L.dispose()),this.queues.clear()}}e.ResourceQueue=f;class m{constructor(L,G){this._token=-1,typeof L=="function"&&typeof G=="number"&&this.setIfNotSet(L,G)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,G){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},G)}setIfNotSet(L,G){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},G))}}e.TimeoutTimer=m;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,G){this.cancel(),this._token=setInterval(()=>{L()},G)}}e.IntervalTimer=b;class _{constructor(L,G){this.timeoutToken=-1,this.runner=L,this.timeout=G,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=_;class o extends _{constructor(L,G){super(L,G);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner&&this.runner(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=o;class A extends y.Disposable{constructor(L,G,M,O){super();this.maxWorkChunkSize=L,this.maxPendingWork=G,this.throttleDelay=M,this.handler=O,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.maxPendingWork)return!1}else if(this.pending+L.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new _(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=A,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const x=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=L=>{const G=setTimeout(()=>L(x));let M=!1;return{dispose(){M||(M=!0,clearTimeout(G))}}}}else e.runWhenIdle=(x,L)=>{const G=requestIdleCallback(x,typeof L=="number"?{timeout:L}:void 0);let M=!1;return{dispose(){M||(M=!0,cancelIdleCallback(G))}}}}();class F{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(G){this._error=G}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=F;async function $(x,L,G){let M;for(let O=0;O<G;O++)try{return await x()}catch(B){M=B,await h(L)}throw M}e.retry=$;class W{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(L,G,M){return this._pending={taskId:L,cancel:()=>M?.(),promise:G},G.then(()=>this.donePending(L),()=>this.donePending(L)),G}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let G,M;const O=new Promise((B,z)=>{G=B,M=z});this._next={run:L,promise:O,promiseResolve:G,promiseReject:M}}return this._next.promise}}e.TaskSequentializer=W;class Q{constructor(L){this.interval=L,this.lastIncrementTime=0,this.value=0}increment(){const L=Date.now();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;class H{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,G)=>{this.completeCallback=L,this.errorCallback=G})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(G=>{this.completeCallback(L),this.resolved=!0,G()})}error(L){return new Promise(G=>{this.errorCallback(L),this.rejected=!0,G()})}cancel(){new Promise(L=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,L()})}}e.DeferredPromise=H;var N;(function(x){async function L(G){let M;const O=await Promise.all(G.map(B=>B.then(z=>z,z=>{M||(M=z)})));if(typeof M!="undefined")throw M;return O}x.settled=L})(N=e.Promises||(e.Promises={}))}),define(he[96],fe([0,1,9,17]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new R.IdleValue(()=>{const _=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:_,collatorIsNumeric:_.resolvedOptions().numeric}}),y=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),T=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(_,o,A=!1){const F=_||"",$=o||"",W=k.value.collator.compare(F,$);return k.value.collatorIsNumeric&&W===0&&F!==$?F<$?-1:1:W}e.compareFileNames=I;function D(_,o){const A=y.value.collator;return _=_||"",o=o||"",v(A,_,o)}e.compareFileNamesDefault=D;function C(_,o){const A=y.value.collator;return _=_||"",o=o||"",n(_,o)||v(A,_,o)}e.compareFileNamesUpper=C;function i(_,o){const A=y.value.collator;return _=_||"",o=o||"",r(_,o)||v(A,_,o)}e.compareFileNamesLower=i;function P(_,o){return _=_||"",o=o||"",_===o?0:_<o?-1:1}e.compareFileNamesUnicode=P;function u(_,o,A=!1){A||(_=_&&_.toLowerCase(),o=o&&o.toLowerCase());const[F,$]=d(_),[W,Q]=d(o);return F!==W?F<W?-1:1:$===Q?0:$<Q?-1:1}e.noIntlCompareFileNames=u;function p(_,o){const[A,F]=d(_),[$,W]=d(o);let Q=k.value.collator.compare(F,W);if(Q===0){if(k.value.collatorIsNumeric&&F!==W)return F<W?-1:1;if(Q=k.value.collator.compare(A,$),k.value.collatorIsNumeric&&Q===0&&A!==$)return A<$?-1:1}return Q}e.compareFileExtensions=p;function l(_,o){_=_||"",o=o||"";const A=h(_),F=h(o),$=y.value.collator,W=T.value.collator;return v(W,A,F)||v($,_,o)}e.compareFileExtensionsDefault=l;function c(_,o){_=_||"",o=o||"";const A=h(_),F=h(o),$=y.value.collator,W=T.value.collator;return v(W,A,F)||n(_,o)||v($,_,o)}e.compareFileExtensionsUpper=c;function S(_,o){_=_||"",o=o||"";const A=h(_),F=h(o),$=y.value.collator,W=T.value.collator;return v(W,A,F)||r(_,o)||v($,_,o)}e.compareFileExtensionsLower=S;function w(_,o){_=_||"",o=o||"";const A=h(_).toLowerCase(),F=h(o).toLowerCase();return A!==F?A<F?-1:1:_!==o?_<o?-1:1:0}e.compareFileExtensionsUnicode=w;const E=/^(.*?)(\.([^.]*))?$/;function d(_,o=!1){const A=_?E.exec(_):[];let F=[A&&A[1]||"",A&&A[3]||""];return o&&(!F[0]&&F[1]||F[0]&&F[0].charAt(0)===".")&&(F=[F[0]+"."+F[1],""]),F}function h(_){const o=_?E.exec(_):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function v(_,o,A){let F=_.compare(o,A);return F!==0?F:o.length!==A.length?o.length<A.length?-1:1:0}function t(_){const o=_.charAt(0);return o.toLocaleUpperCase()!==o}function s(_){const o=_.charAt(0);return o.toLocaleLowerCase()!==o}function r(_,o){return t(_)&&s(o)?-1:s(_)&&t(o)?1:0}function n(_,o){return s(_)&&t(o)?-1:t(_)&&s(o)?1:0}function a(_,o,A=!1){return A||(_=_&&_.toLowerCase(),o=o&&o.toLowerCase()),_===o?0:_<o?-1:1}function f(_,o,A=!1){const F=_.split(g.sep),$=o.split(g.sep),W=F.length-1,Q=$.length-1;let H,N;for(let x=0;;x++){if(H=W===x,N=Q===x,H&&N)return I(F[x],$[x],A);if(H)return-1;if(N)return 1;const L=a(F[x],$[x],A);if(L!==0)return L}}e.comparePaths=f;function m(_,o,A){const F=_.toLowerCase(),$=o.toLowerCase(),W=b(_,o,A);if(W)return W;const Q=F.endsWith(A),H=$.endsWith(A);if(Q!==H)return Q?-1:1;const N=I(F,$);return N!==0?N:F.localeCompare($)}e.compareAnything=m;function b(_,o,A){const F=_.toLowerCase(),$=o.toLowerCase(),W=F.startsWith(A),Q=$.startsWith(A);if(W!==Q)return W?-1:1;if(W&&Q){if(F.length<$.length)return-1;if(F.length>$.length)return 1}return 0}e.compareByPrefix=b}),define(he[97],fe([0,1,96,94,9,11,8]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const I=0,D=[I,[]];function C(H,N,x,L){if(!H||!N)return D;const G=H.length,M=N.length;if(G<M)return D;const O=H.toLowerCase();return!L&&!O.includes(x)?D:i(N,x,M,H,O,G)}e.scoreFuzzy=C;function i(H,N,x,L,G,M){const O=[],B=[];for(let ye=0;ye<x;ye++){const Fe=ye*M,Re=Fe-M,Ne=ye>0,Ve=H[ye],ze=N[ye];for(let j=0;j<M;j++){const Z=j>0,ie=Fe+j,oe=ie-1,ve=Re+j-1,ee=Z?O[oe]:0,ue=Ne&&Z?O[ve]:0,Ie=Ne&&Z?B[ve]:0;let $e;!ue&&Ne?$e=0:$e=P(Ve,ze,L,G,j,Ie),$e&&ue+$e>=ee?(B[ie]=Ie+1,O[ie]=ue+$e):(B[ie]=I,O[ie]=ee)}}const z=[];let J=x-1,ce=M-1;for(;J>=0&&ce>=0;){const ye=J*M+ce;B[ye]===I||(z.push(ce),J--),ce--}return[O[x*M-1],z.reverse()]}function P(H,N,x,L,G,M){let O=0;if(!u(N,L[G]))return O;if(O+=1,M>0&&(O+=M*5),H===x[G]&&(O+=1),G===0)O+=8;else{const B=p(x.charCodeAt(G-1));B?O+=B:(0,R.isUpper)(x.charCodeAt(G))&&(O+=2)}return O}function u(H,N){return H===N?!0:H==="/"||H==="\\"?N==="/"||N==="\\":!1}function p(H){switch(H){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function c(H,N,x=0,L=0){const G=N;return G.values&&G.values.length>1?S(H,G.values,x,L):w(H,N,x,L)}e.scoreFuzzy2=c;function S(H,N,x,L){let G=0;const M=[];for(const O of N){const[B,z]=w(H,O,x,L);if(typeof B!="number")return l;G+=B,M.push(...z)}return[G,f(M)]}function w(H,N,x,L){const G=(0,R.fuzzyScore)(N.original,N.originalLowercase,x,H,H.toLowerCase(),L,!0);return G?[G[0],(0,R.createMatches)(G)]:l}const E=Object.freeze({score:0}),d=1<<18,h=1<<17,v=1<<16;function t(H,N,x,L,G){if(!H||!N.normalized)return E;const M=L.getItemLabel(H);if(!M)return E;const O=L.getItemDescription(H);let B;O?B=`${M}${O}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${x}`:B=`${M}${N.normalized}${Array.isArray(N.values)?N.values.length:""}${x}`;const z=G[B];if(z)return z;const J=s(M,O,L.getItemPath(H),N,x);return G[B]=J,J}e.scoreItemFuzzy=t;function s(H,N,x,L,G){const M=!x||!L.containsPathSeparator;return x&&(y.isLinux?L.pathNormalized===x:(0,T.equalsIgnoreCase)(L.pathNormalized,x))?{score:d,labelMatch:[{start:0,end:H.length}],descriptionMatch:N?[{start:0,end:N.length}]:void 0}:L.values&&L.values.length>1?r(H,N,x,L.values,M,G):n(H,N,x,L,M,G)}function r(H,N,x,L,G,M){let O=0;const B=[],z=[];for(const J of L){const{score:ce,labelMatch:ye,descriptionMatch:Fe}=n(H,N,x,J,G,M);if(ce===I)return E;O+=ce,ye&&B.push(...ye),Fe&&z.push(...Fe)}return{score:O,labelMatch:f(B),descriptionMatch:f(z)}}function n(H,N,x,L,G,M){if(G||!N){const[O,B]=C(H,L.normalized,L.normalizedLowercase,M);if(O){const z=(0,R.matchesPrefix)(L.normalized,H);let J;return z?(J=h,J+=Math.round(L.normalized.length/H.length*100)):J=v,{score:J+O,labelMatch:z||a(B)}}}if(N){let O=N;x&&(O=`${N}${k.sep}`);const B=O.length,z=`${O}${H}`,[J,ce]=C(z,L.normalized,L.normalizedLowercase,M);if(J){const ye=a(ce),Fe=[],Re=[];return ye.forEach(Ne=>{Ne.start<B&&Ne.end>B?(Fe.push({start:0,end:Ne.end-B}),Re.push({start:Ne.start,end:B})):Ne.start>=B?Fe.push({start:Ne.start-B,end:Ne.end-B}):Re.push(Ne)}),{score:J,labelMatch:Fe,descriptionMatch:Re}}}return E}function a(H){const N=[];if(!H)return N;let x;for(const L of H)x&&x.end===L?x.end+=1:(x={start:L,end:L+1},N.push(x));return N}function f(H){const N=H.sort((G,M)=>G.start-M.start),x=[];let L;for(const G of N)!L||!m(L,G)?(L=G,x.push(G)):(L.start=Math.min(L.start,G.start),L.end=Math.max(L.end,G.end));return x}function m(H,N){return!(H.end<N.start||N.end<H.start)}function b(H,N,x,L,G,M){const O=t(H,x,L,G,M),B=t(N,x,L,G,M),z=O.score,J=B.score;if((z===d||J===d)&&z!==J)return z===d?-1:1;if(z>v||J>v){if(z!==J)return z>J?-1:1;if(z<h&&J<h){const ze=o(O.labelMatch,B.labelMatch);if(ze!==0)return ze}const Ne=G.getItemLabel(H)||"",Ve=G.getItemLabel(N)||"";if(Ne.length!==Ve.length)return Ne.length-Ve.length}if(z!==J)return z>J?-1:1;const ce=Array.isArray(O.labelMatch)&&O.labelMatch.length>0,ye=Array.isArray(B.labelMatch)&&B.labelMatch.length>0;if(ce&&!ye)return-1;if(ye&&!ce)return 1;const Fe=_(H,O,G),Re=_(N,B,G);return Fe&&Re&&Fe!==Re?Re>Fe?-1:1:A(H,N,x,G)}e.compareItemsByFuzzyScore=b;function _(H,N,x){let L=-1,G=-1;if(N.descriptionMatch&&N.descriptionMatch.length?L=N.descriptionMatch[0].start:N.labelMatch&&N.labelMatch.length&&(L=N.labelMatch[0].start),N.labelMatch&&N.labelMatch.length){if(G=N.labelMatch[N.labelMatch.length-1].end,N.descriptionMatch&&N.descriptionMatch.length){const M=x.getItemDescription(H);M&&(G+=M.length)}}else N.descriptionMatch&&N.descriptionMatch.length&&(G=N.descriptionMatch[N.descriptionMatch.length-1].end);return G-L}function o(H,N){if(!H&&!N||(!H||!H.length)&&(!N||!N.length))return 0;if(!N||!N.length)return-1;if(!H||!H.length)return 1;const x=H[0].start,G=H[H.length-1].end-x,M=N[0].start,B=N[N.length-1].end-M;return G===B?0:B<G?1:-1}function A(H,N,x,L){const G=L.getItemLabel(H)||"",M=L.getItemLabel(N)||"",O=L.getItemDescription(H),B=L.getItemDescription(N),z=G.length+(O?O.length:0),J=M.length+(B?B.length:0);if(z!==J)return z-J;const ce=L.getItemPath(H),ye=L.getItemPath(N);return ce&&ye&&ce.length!==ye.length?ce.length-ye.length:G!==M?(0,g.compareAnything)(G,M,x.normalized):O&&B&&O!==B?(0,g.compareAnything)(O,B,x.normalized):ce&&ye&&ce!==ye?(0,g.compareAnything)(ce,ye,x.normalized):0}const F=" ";function $(H){typeof H!="string"&&(H="");const N=H.toLowerCase(),{pathNormalized:x,normalized:L,normalizedLowercase:G}=W(H),M=x.indexOf(k.sep)>=0;let O;const B=H.split(F);if(B.length>1)for(const z of B){const{pathNormalized:J,normalized:ce,normalizedLowercase:ye}=W(z);ce&&(O||(O=[]),O.push({original:z,originalLowercase:z.toLowerCase(),pathNormalized:J,normalized:ce,normalizedLowercase:ye}))}return{original:H,originalLowercase:N,pathNormalized:x,normalized:L,normalizedLowercase:G,values:O,containsPathSeparator:M}}e.prepareQuery=$;function W(H){let N;y.isWindows?N=H.replace(/\//g,k.sep):N=H.replace(/\\/g,k.sep);const x=(0,T.stripWildcards)(N).replace(/\s/g,"");return{pathNormalized:N,normalized:x,normalizedLowercase:x.toLowerCase()}}function Q(H){return Array.isArray(H)?$(H.map(N=>N.original).join(F)):$(H.original)}e.pieceToQuery=Q}),define(he[30],fe([0,1,8,29,9,23,17]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const D="**",C="/",i="[/\\\\]",P="[^/\\\\]",u=/\//g;function p(O){switch(O){case 0:return"";case 1:return`${P}*?`;default:return`(?:${i}|${P}+${i}|${i}${P}+)*?`}}function l(O,B){if(!O)return[];const z=[];let J=!1,ce=!1,ye="";for(const Fe of O){switch(Fe){case B:if(!J&&!ce){z.push(ye),ye="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}ye+=Fe}return ye&&z.push(ye),z}e.splitGlobAware=l;function c(O){if(!O)return"";let B="";const z=l(O,C);if(z.every(J=>J===D))B=".*";else{let J=!1;z.forEach((ce,ye)=>{if(ce===D){J||(B+=p(2),J=!0);return}let Fe=!1,Re="",Ne=!1,Ve="";for(const ze of ce){if(ze!=="}"&&Fe){Re+=ze;continue}if(Ne&&(ze!=="]"||!Ve)){let j;ze==="-"?j=ze:(ze==="^"||ze==="!")&&!Ve?j="^":ze===C?j="":j=g.escapeRegExpCharacters(ze),Ve+=j;continue}switch(ze){case"{":Fe=!0;continue;case"[":Ne=!0;continue;case"}":B+=`(?:${l(Re,",").map(ie=>c(ie)).join("|")})`,Fe=!1,Re="";break;case"]":B+="["+Ve+"]",Ne=!1,Ve="";break;case"?":B+=P;continue;case"*":B+=p(1);continue;default:B+=g.escapeRegExpCharacters(ze)}}ye<z.length-1&&(z[ye+1]!==D||ye+2<z.length)&&(B+=i),J=!1})}return B}const S=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),s=function(){return!1},r=function(){return null};function n(O,B){if(!O)return r;let z;typeof O!="string"?z=O.pattern:z=O,z=z.trim();const J=`${z}_${!!B.trimForExclusions}`;let ce=t.get(J);if(ce)return a(ce,O);let ye;if(S.test(z)){const Fe=z.substr(4);ce=function(Re,Ne){return typeof Re=="string"&&Re.endsWith(Fe)?z:null}}else(ye=w.exec(f(z,B)))?ce=m(ye[1],z):(B.trimForExclusions?d:E).test(z)?ce=b(z,B):(ye=h.exec(f(z,B)))?ce=_(ye[1].substr(1),z,!0):(ye=v.exec(f(z,B)))?ce=_(ye[1],z,!1):ce=o(z);return t.set(J,ce),a(ce,O)}function a(O,B){return typeof B=="string"?O:function(z,J){return R.isEqualOrParent(z,B.base)?O(k.relative(B.base,z),J):null}}function f(O,B){return B.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function m(O,B){const z=`/${O}`,J=`\\${O}`,ce=function(Fe,Re){return typeof Fe!="string"?null:Re?Re===O?B:null:Fe===O||Fe.endsWith(z)||Fe.endsWith(J)?B:null},ye=[O];return ce.basenames=ye,ce.patterns=[B],ce.allBasenames=ye,ce}function b(O,B){const z=M(O.slice(1,-1).split(",").map(Re=>n(Re,B)).filter(Re=>Re!==r),O),J=z.length;if(!J)return r;if(J===1)return z[0];const ce=function(Re,Ne){for(let Ve=0,ze=z.length;Ve<ze;Ve++)if(z[Ve](Re,Ne))return O;return null},ye=z.find(Re=>!!Re.allBasenames);ye&&(ce.allBasenames=ye.allBasenames);const Fe=z.reduce((Re,Ne)=>Ne.allPaths?Re.concat(Ne.allPaths):Re,[]);return Fe.length&&(ce.allPaths=Fe),ce}function _(O,B,z){const J=k.sep===k.posix.sep,ce=J?O:O.replace(u,k.sep),ye=k.sep+ce,Fe=k.posix.sep+O,Re=z?function(Ne,Ve){return typeof Ne=="string"&&(Ne===ce||Ne.endsWith(ye)||!J&&(Ne===O||Ne.endsWith(Fe)))?B:null}:function(Ne,Ve){return typeof Ne=="string"&&(Ne===ce||!J&&Ne===O)?B:null};return Re.allPaths=[(z?"*/":"./")+O],Re}function o(O){try{const B=new RegExp(`^${c(O)}$`);return function(z){return B.lastIndex=0,typeof z=="string"&&B.test(z)?O:null}}catch(B){return r}}function A(O,B,z){return!O||typeof B!="string"?!1:F(O)(B,void 0,z)}e.match=A;function F(O,B={}){if(!O)return s;if(typeof O=="string"||H(O)){const z=n(O,B);if(z===r)return s;const J=function(ce,ye){return!!z(ce,ye)};return z.allBasenames&&(J.allBasenames=z.allBasenames),z.allPaths&&(J.allPaths=z.allPaths),J}return L(O,B)}e.parse=F;function $(O){if(!O)return;let B;return z=>(B||(B=(O()||Promise.resolve([])).then(J=>J?Q(J):{})),B.then(J=>!!J[z]))}e.hasSiblingPromiseFn=$;function W(O){if(!O)return;let B;return z=>{if(!B){const J=O();B=J?Q(J):{}}return!!B[z]}}e.hasSiblingFn=W;function Q(O){const B={};for(const z of O)B[z]=!0;return B}function H(O){const B=O;return B&&typeof B.base=="string"&&typeof B.pattern=="string"}e.isRelativePattern=H;function N(O){return O.allBasenames||[]}e.getBasenameTerms=N;function x(O){return O.allPaths||[]}e.getPathTerms=x;function L(O,B){const z=M(Object.getOwnPropertyNames(O).map(Re=>G(Re,O[Re],B)).filter(Re=>Re!==r)),J=z.length;if(!J)return r;if(!z.some(Re=>!!Re.requiresSiblings)){if(J===1)return z[0];const Re=function(ze,j){for(let Z=0,ie=z.length;Z<ie;Z++){const oe=z[Z](ze,j);if(oe)return oe}return null},Ne=z.find(ze=>!!ze.allBasenames);Ne&&(Re.allBasenames=Ne.allBasenames);const Ve=z.reduce((ze,j)=>j.allPaths?ze.concat(j.allPaths):ze,[]);return Ve.length&&(Re.allPaths=Ve),Re}const ce=function(Re,Ne,Ve){let ze;for(let j=0,Z=z.length;j<Z;j++){const ie=z[j];ie.requiresSiblings&&Ve&&(Ne||(Ne=k.basename(Re)),ze||(ze=Ne.substr(0,Ne.length-k.extname(Re).length)));const oe=ie(Re,Ne,ze,Ve);if(oe)return oe}return null},ye=z.find(Re=>!!Re.allBasenames);ye&&(ce.allBasenames=ye.allBasenames);const Fe=z.reduce((Re,Ne)=>Ne.allPaths?Re.concat(Ne.allPaths):Re,[]);return Fe.length&&(ce.allPaths=Fe),ce}function G(O,B,z){if(B===!1)return r;const J=n(O,z);if(J===r)return r;if(typeof B=="boolean")return J;if(B){const ce=B.when;if(typeof ce=="string"){const ye=(Fe,Re,Ne,Ve)=>{if(!Ve||!J(Fe,Re))return null;const ze=ce.replace("$(basename)",Ne),j=Ve(ze);return(0,T.isThenable)(j)?j.then(Z=>Z?O:null):j?O:null};return ye.requiresSiblings=!0,ye}}return J}function M(O,B){const z=O.filter(Re=>!!Re.basenames);if(z.length<2)return O;const J=z.reduce((Re,Ne)=>{const Ve=Ne.basenames;return Ve?Re.concat(Ve):Re},[]);let ce;if(B){ce=[];for(let Re=0,Ne=J.length;Re<Ne;Re++)ce.push(B)}else ce=z.reduce((Re,Ne)=>{const Ve=Ne.patterns;return Ve?Re.concat(Ve):Re},[]);const ye=function(Re,Ne){if(typeof Re!="string")return null;if(!Ne){let ze;for(ze=Re.length;ze>0;ze--){const j=Re.charCodeAt(ze-1);if(j===47||j===92)break}Ne=Re.substr(ze)}const Ve=J.indexOf(Ne);return Ve!==-1?ce[Ve]:null};ye.basenames=J,ye.patterns=ce,ye.allBasenames=J;const Fe=O.filter(Re=>!Re.basenames);return Fe.push(ye),Fe}}),define(he[76],fe([0,1,2,9,8,10,11,24,29]),function(X,e,g,R,k,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(n,a,f){if(typeof n=="string"&&(n=g.URI.file(n)),f){const b=f.getWorkspaceFolder(n);if(b){const _=f.getWorkspace().folders.length>1;let o;if((0,I.isEqual)(b.uri,n)?o="":o=(0,I.relativePath)(b.uri,n),_){const A=b.name?b.name:(0,I.basename)(b.uri);o=o?A+" \u2022 "+o:A}return o}}if(n.scheme!==y.Schemas.file&&n.scheme!==y.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(n.fsPath))return(0,R.normalize)(P(n.fsPath));let m=(0,R.normalize)(n.fsPath);return!T.isWindows&&a?.userHome&&(m=p(m,a.userHome.fsPath)),m}e.getPathLabel=C;function i(n){if(!n)return;typeof n=="string"&&(n=g.URI.file(n));const a=(0,I.basename)(n)||(n.scheme===y.Schemas.file?n.fsPath:n.path);return T.isWindows&&(0,D.isRootOrDriveLetter)(a)?P(a):a}e.getBaseLabel=i;function P(n){return(0,D.hasDriveLetter)(n)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=P;let u=Object.create(null);function p(n,a){if(T.isWindows||!n||!a)return n;let f=u.original===a?u.normalized:void 0;return f||(f=`${(0,k.rtrim)(a,R.posix.sep)}${R.posix.sep}`,u={original:a,normalized:f}),(T.isLinux?n.startsWith(f):(0,k.startsWithIgnoreCase)(n,f))&&(n=`~/${n.substr(f.length)}`),n}e.tildify=p;function l(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=l;const c="\u2026",S="\\\\",w="~";function E(n,a=R.sep){const f=new Array(n.length);let m=!1;for(let b=0;b<n.length;b++){let _=n[b];if(_===""){f[b]=`.${a}`;continue}if(!_){f[b]=_;continue}m=!0;let o="";_.indexOf(S)===0?(o=_.substr(0,_.indexOf(S)+S.length),_=_.substr(_.indexOf(S)+S.length)):_.indexOf(a)===0?(o=_.substr(0,_.indexOf(a)+a.length),_=_.substr(_.indexOf(a)+a.length)):_.indexOf(w)===0&&(o=_.substr(0,_.indexOf(w)+w.length),_=_.substr(_.indexOf(w)+w.length));const A=_.split(a);for(let F=1;m&&F<=A.length;F++)for(let $=A.length-F;m&&$>=0;$--){m=!1;let W=A.slice($,$+F).join(a);for(let Q=0;!m&&Q<n.length;Q++)if(Q!==b&&n[Q]&&n[Q].indexOf(W)>-1){const H=$+F===A.length,N=$>0&&n[Q].indexOf(a)>-1?a+W:W,x=n[Q].endsWith(N);m=!H||x}if(!m){let Q="";(A[0].endsWith(":")||o!=="")&&($===1&&($=0,F++,W=A[0]+a+W),$>0&&(Q=A[0]+a),Q=o+Q),$>0&&(Q=Q+c+a),Q=Q+W,$+F<A.length&&(Q=Q+a+c),f[b]=Q}}m&&(f[b]=_)}return f}e.shorten=E;var d;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function h(n,a=Object.create(null)){const f=[];let m=!1,b="";for(const _ of n)if(_==="$"||m&&_==="{")b&&f.push({value:b,type:d.TEXT}),b="",m=!0;else if(_==="}"&&m){const o=a[b];if(typeof o=="string")o.length&&f.push({value:o,type:d.VARIABLE});else if(o){const A=f[f.length-1];(!A||A.type!==d.SEPARATOR)&&f.push({value:o.label,type:d.SEPARATOR})}b="",m=!1}else b+=_;return b&&!m&&f.push({value:b,type:d.TEXT}),f.filter((_,o)=>{if(_.type===d.SEPARATOR){const A=f[o-1],F=f[o+1];return[A,F].every($=>$&&($.type===d.VARIABLE||$.type===d.TEXT)&&$.value.length>0)}return!0}).map(_=>_.value).join("")}e.template=h;function v(n,a){return T.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):n.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(n,a){return T.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,""):T.isWindows?n.replace(/&&|&/g,f=>f==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function s(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(n){const a=n.indexOf("/")!==-1?R.posix:R.win32,f=a.basename(n),m=a.dirname(n);return f.length?{name:f,parentPath:m}:{name:m,parentPath:""}}e.splitName=r}),define(he[98],fe([0,1,9,8,30,10,24]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var I;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown"})(I=e.Mimes||(e.Mimes={}));let D=[],C=[],i=[];function P(s,r=!1){const n=u(s);D.push(n),n.userConfigured?i.push(n):C.push(n),r&&!n.userConfigured&&D.forEach(a=>{a.mime===n.mime||a.userConfigured||(n.extension&&a.extension===n.extension&&console.warn(`Overwriting extension <<${n.extension}>> to now point to mime <<${n.mime}>>`),n.filename&&a.filename===n.filename&&console.warn(`Overwriting filename <<${n.filename}>> to now point to mime <<${n.mime}>>`),n.filepattern&&a.filepattern===n.filepattern&&console.warn(`Overwriting filepattern <<${n.filepattern}>> to now point to mime <<${n.mime}>>`),n.firstline&&a.firstline===n.firstline&&console.warn(`Overwriting firstline <<${n.firstline}>> to now point to mime <<${n.mime}>>`))})}e.registerTextMime=P;function u(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?s.filepattern.toLowerCase():void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(g.posix.sep)>=0:!1}}function p(s){s?(D=D.filter(r=>!r.userConfigured),i=[]):(D=[],C=[],i=[])}e.clearTextMimes=p;function l(s,r){let n;if(s)switch(s.scheme){case y.Schemas.file:n=s.fsPath;break;case y.Schemas.data:n=T.DataUri.parseMetaData(s).get(T.DataUri.META_DATA_LABEL);break;default:n=s.path}if(!n)return[I.unknown];n=n.toLowerCase();const a=(0,g.basename)(n),f=c(n,a,i);if(f)return[f,I.text];const m=c(n,a,C);if(m)return[m,I.text];if(r){const b=S(r);if(b)return[b,I.text]}return[I.unknown]}e.guessMimeTypes=l;function c(s,r,n){let a=null,f=null,m=null;for(let b=n.length-1;b>=0;b--){const _=n[b];if(r===_.filenameLowercase){a=_;break}if(_.filepattern&&(!f||_.filepattern.length>f.filepattern.length)){const o=_.filepatternOnPath?s:r;(0,k.match)(_.filepatternLowercase,o)&&(f=_)}_.extension&&(!m||_.extension.length>m.extension.length)&&r.endsWith(_.extensionLowercase)&&(m=_)}return a?a.mime:f?f.mime:m?m.mime:null}function S(s){if((0,R.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let r=D.length-1;r>=0;r--){const n=D[r];if(!n.firstline)continue;const a=s.match(n.firstline);if(a&&a.length>0)return n.mime}return null}function w(s){return s?typeof s=="string"?s===I.binary||s===I.text||s===I.unknown:s.length===1&&w(s[0]):!0}e.isUnspecific=w;const E={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function d(s){const r=(0,g.extname)(s);return E[r.toLowerCase()]}e.getMediaMime=d;function h(s){for(const r in E)if(E[r]===s)return r}e.getExtensionForMimeType=h;const v=/^(.+)\/(.+?)(;.+)?$/;function t(s,r){const n=v.exec(s);return n?`${n[1].toLowerCase()}/${n[2].toLowerCase()}${n[3]??""}`:r?void 0:s}e.normalizeMimeType=t}),define(he[99],fe([0,1,2]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(i){return i.toJSON()}class k{constructor(P){this._uriTransformer=P}transformIncoming(P){const u=this._uriTransformer.transformIncoming(P);return u===P?P:R(g.URI.from(u))}transformOutgoing(P){const u=this._uriTransformer.transformOutgoing(P);return u===P?P:R(g.URI.from(u))}transformOutgoingURI(P){const u=this._uriTransformer.transformOutgoing(P);return u===P?P:g.URI.from(u)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function y(i,P,u){if(!i||u>200)return null;if(typeof i=="object"){if(i instanceof g.URI)return P.transformOutgoing(i);for(let p in i)if(Object.hasOwnProperty.call(i,p)){const l=y(i[p],P,u+1);l!==null&&(i[p]=l)}}return null}function T(i,P){const u=y(i,P,0);return u===null?i:u}e.transformOutgoingURIs=T;function I(i,P,u,p){if(!i||p>200)return null;if(typeof i=="object"){if(i.$mid===1)return u?g.URI.revive(P.transformIncoming(i)):P.transformIncoming(i);for(let l in i)if(Object.hasOwnProperty.call(i,l)){const c=I(i[l],P,u,p+1);c!==null&&(i[l]=c)}}return null}function D(i,P){const u=I(i,P,!1,0);return u===null?i:u}e.transformIncomingURIs=D;function C(i,P){const u=I(i,P,!0,0);return u===null?i:u}e.transformAndReviveIncomingURIs=C}),define(he[32],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(D){return g.test(D)}e.isUUID=R;const k=new Uint8Array(16),y=[];for(let D=0;D<256;D++)y.push(D.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(D){for(let C=0;C<D.length;C++)D[C]=Math.floor(Math.random()*256);return D};function I(){T(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let D=0,C="";return C+=y[k[D++]],C+=y[k[D++]],C+=y[k[D++]],C+=y[k[D++]],C+="-",C+=y[k[D++]],C+=y[k[D++]],C+="-",C+=y[k[D++]],C+=y[k[D++]],C+="-",C+=y[k[D++]],C+=y[k[D++]],C+="-",C+=y[k[D++]],C+=y[k[D++]],C+=y[k[D++]],C+=y[k[D++]],C+=y[k[D++]],C+=y[k[D++]],C}e.generateUuid=I}),define(he[138],fe([0,1,100]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(y="utf8"){this.stringDecoder=new g.StringDecoder(y),this.remaining=null}write(y){const T=[],I=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(I.length<1)return T;let D=0,C,i=D;for(;i<I.length;)if(C=I.charCodeAt(i),C===13||C===10){if(T.push(I.substring(D,i)),i++,i<I.length){const P=C;C=I.charCodeAt(i),(P===13&&C===10||P===10&&C===13)&&i++}D=i}else i++;return this.remaining=D<I.length?I.substr(D):null,T}end(){return this.remaining}}e.LineDecoder=R}),define(he[28],fe([0,1,45,101,283,9,17,11,29,32,75,24,2]),function(X,e,g,R,k,y,T,I,D,C,i,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function l(N,x=p.UNLINK){if((0,D.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return x===p.UNLINK?S(N):c(N)}async function c(N){try{const x=(0,y.join)((0,R.tmpdir)(),(0,C.generateUuid)());try{await e.Promises.rename(N,x)}catch(L){return S(N)}S(x).catch(L=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function S(N){return e.Promises.rmdir(N,{recursive:!0,maxRetries:3})}function w(N){if((0,D.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(N,{recursive:!0})}e.rimrafSync=w;async function E(N,x){return v(await(x?d(N):(0,k.promisify)(g.readdir)(N)))}async function d(N){try{return await(0,k.promisify)(g.readdir)(N,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const x=[],L=await E(N);for(const G of L){let M=!1,O=!1,B=!1;try{const z=await e.Promises.lstat((0,y.join)(N,G));M=z.isFile(),O=z.isDirectory(),B=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}x.push({name:G,isFile:()=>M,isDirectory:()=>O,isSymbolicLink:()=>B})}return x}function h(N){return v(g.readdirSync(N))}e.readdirSync=h;function v(N){return N.map(x=>typeof x=="string"?I.isMacintosh?(0,i.normalizeNFC)(x):x:(x.name=I.isMacintosh?(0,i.normalizeNFC)(x.name):x.name,x))}async function t(N){const x=await E(N),L=[];for(const G of x)await r.existsDirectory((0,y.join)(N,G))&&L.push(G);return L}function s(N,x=1e3){return new Promise(L=>{let G=!1;const M=setInterval(()=>{G||(G=!0,g.access(N,O=>{G=!1,O&&(clearInterval(M),L(void 0))}))},x)})}e.whenDeleted=s;var r;(function(N){async function x(M){let O;try{if(O=await e.Promises.lstat(M),!O.isSymbolicLink())return{stat:O}}catch(B){}try{return{stat:await e.Promises.stat(M),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(I.isWindows&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw z}throw B}}N.stat=x;async function L(M){try{const{stat:O,symbolicLink:B}=await N.stat(M);return O.isFile()&&B?.dangling!==!0}catch(O){}return!1}N.existsFile=L;async function G(M){try{const{stat:O,symbolicLink:B}=await N.stat(M);return O.isDirectory()&&B?.dangling!==!0}catch(O){}return!1}N.existsDirectory=G})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new T.ResourceQueue;function a(N,x,L){return n.queueFor(u.URI.file(N),P.extUriBiasedIgnorePathCase).queue(()=>{const G=_(L);return new Promise((M,O)=>m(N,x,G,B=>B?O(B):M()))})}let f=!0;function m(N,x,L,G){if(!f)return g.writeFile(N,x,{mode:L.mode,flag:L.flag},G);g.open(N,L.flag,L.mode,(M,O)=>{if(M)return G(M);g.writeFile(O,x,B=>{if(B)return g.close(O,()=>G(B));g.fdatasync(O,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),f=!1),g.close(O,J=>G(J))))})})}function b(N,x,L){const G=_(L);if(!f)return g.writeFileSync(N,x,{mode:G.mode,flag:G.flag});const M=g.openSync(N,G.flag,G.mode);try{g.writeFileSync(M,x);try{g.fdatasyncSync(M)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),f=!1}}finally{g.closeSync(M)}}e.writeFileSync=b;function _(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function o(N,x){if(N===x)return;async function L(G){try{const M=await e.Promises.lstat(G);if(M.isDirectory()||M.isSymbolicLink())return;await e.Promises.utimes(G,M.atime,new Date)}catch(M){}}try{await e.Promises.rename(N,x),await L(x)}catch(G){if(N.toLowerCase()!==x.toLowerCase()&&G.code==="EXDEV"||N.endsWith("."))await A(N,x,{preserveSymlinks:!1}),await l(N,p.MOVE),await L(x);else throw G}}async function A(N,x,L){return $(N,x,{root:{source:N,target:x},options:L,handledSourcePaths:new Set})}const F=511;async function $(N,x,L){if(L.handledSourcePaths.has(N))return;L.handledSourcePaths.add(N);const{stat:G,symbolicLink:M}=await r.stat(N);if(M){if(L.options.preserveSymlinks)try{return await H(N,x,L)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(M.dangling)return}return G.isDirectory()?W(N,x,G.mode&F,L):Q(N,x,G.mode&F)}async function W(N,x,L,G){await e.Promises.mkdir(x,{recursive:!0,mode:L});const M=await E(N);for(const O of M)await $((0,y.join)(N,O),(0,y.join)(x,O),G)}async function Q(N,x,L){await e.Promises.copyFile(N,x),await e.Promises.chmod(x,L)}async function H(N,x,L){let G=await e.Promises.readlink(N);(0,D.isEqualOrParent)(G,L.root.source,!I.isLinux)&&(G=(0,y.join)(L.root.target,G.substr(L.root.source.length+1))),await e.Promises.symlink(G,x)}e.Promises=new class{get access(){return(0,k.promisify)(g.access)}get stat(){return(0,k.promisify)(g.stat)}get lstat(){return(0,k.promisify)(g.lstat)}get utimes(){return(0,k.promisify)(g.utimes)}get read(){return(0,k.promisify)(g.read)}get readFile(){return(0,k.promisify)(g.readFile)}get write(){return(0,k.promisify)(g.write)}get appendFile(){return(0,k.promisify)(g.appendFile)}get fdatasync(){return(0,k.promisify)(g.fdatasync)}get truncate(){return(0,k.promisify)(g.truncate)}get rename(){return(0,k.promisify)(g.rename)}get copyFile(){return(0,k.promisify)(g.copyFile)}get open(){return(0,k.promisify)(g.open)}get close(){return(0,k.promisify)(g.close)}get symlink(){return(0,k.promisify)(g.symlink)}get readlink(){return(0,k.promisify)(g.readlink)}get chmod(){return(0,k.promisify)(g.chmod)}get mkdir(){return(0,k.promisify)(g.mkdir)}get unlink(){return(0,k.promisify)(g.unlink)}get rmdir(){return(0,k.promisify)(g.rmdir)}get realpath(){return(0,k.promisify)(g.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return E}get readDirsInDir(){return t}get writeFile(){return a}get rm(){return l}get move(){return o}get copy(){return A}}}),define(he[102],fe([0,1,45,8,9,28]),function(X,e,g,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function T(i){const P=(0,k.dirname)(i);if(i===P)return i;const u=((0,k.basename)(i)||i).toLowerCase();try{const l=(0,y.readdirSync)(P).filter(c=>c.toLowerCase()===u);if(l.length===1){const c=T(P);if(c)return(0,k.join)(c,l[0])}else if(l.length>1){const c=l.indexOf(u);if(c>=0){const S=T(P);if(S)return(0,k.join)(S,l[c])}}}catch(p){}return null}e.realcaseSync=T;async function I(i){try{return await y.Promises.realpath(i)}catch(P){const u=C(i);return await y.Promises.access(u,g.constants.R_OK),u}}e.realpath=I;function D(i){try{return g.realpathSync(i)}catch(P){const u=C(i);return g.accessSync(u,g.constants.R_OK),u}}e.realpathSync=D;function C(i){return(0,R.rtrim)((0,k.normalize)(i),k.sep)}});var je=this&&this.__decorate||function(X,e,g,R){var k=arguments.length,y=k<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,g):R,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(X,e,g,R);else for(var I=X.length-1;I>=0;I--)(T=X[I])&&(y=(k<3?T(y):k>3?T(e,g,y):T(e,g))||y);return k>3&&y&&Object.defineProperty(e,g,y),y};define(he[103],fe([0,1,3,6,17,21,15,22,18,14,57,8,53]),function(X,e,g,R,k,y,T,I,D,C,i,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function l(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(c=e.ResponseType||(e.ResponseType={}));function S(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(w||(w={}));class E{constructor(O){this.buffer=O,this.pos=0}read(O){const B=this.buffer.slice(this.pos,this.pos+O);return this.pos+=B.byteLength,B}}class d{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var h;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(h||(h={}));function v(M){const O=I.VSBuffer.alloc(4);return O.writeUInt32BE(M,0),O}function t(M){return M.read(4).readUInt32BE(0)}function s(M){const O=I.VSBuffer.alloc(1);return O.writeUInt8(M,0),O}const r={Undefined:s(h.Undefined),String:s(h.String),Buffer:s(h.Buffer),VSBuffer:s(h.VSBuffer),Array:s(h.Array),Object:s(h.Object)},n=typeof Buffer!="undefined";function a(M,O){if(typeof O=="undefined")M.write(r.Undefined);else if(typeof O=="string"){const B=I.VSBuffer.fromString(O);M.write(r.String),M.write(v(B.byteLength)),M.write(B)}else if(n&&Buffer.isBuffer(O)){const B=I.VSBuffer.wrap(O);M.write(r.Buffer),M.write(v(B.byteLength)),M.write(B)}else if(O instanceof I.VSBuffer)M.write(r.VSBuffer),M.write(v(O.byteLength)),M.write(O);else if(Array.isArray(O)){M.write(r.Array),M.write(v(O.length));for(const B of O)a(M,B)}else{const B=I.VSBuffer.fromString(JSON.stringify(O));M.write(r.Object),M.write(v(B.byteLength)),M.write(B)}}function f(M){switch(M.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return M.read(t(M)).toString();case h.Buffer:return M.read(t(M)).buffer;case h.VSBuffer:return M.read(t(M));case h.Array:{const B=t(M),z=[];for(let J=0;J<B;J++)z.push(f(M));return z}case h.Object:return JSON.parse(M.read(t(M)).toString())}}class m{constructor(O,B,z=null,J=1e3){this.protocol=O,this.ctx=B,this.logger=z,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ce=>this.onRawMessage(ce)),this.sendResponse({type:200})}registerChannel(O,B){this.channels.set(O,B),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const B=this.send([O.type]);this.logger&&this.logger.logOutgoing(B,0,1,S(O.type));return}case 201:case 202:case 204:case 203:{const B=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(B,O.id,1,S(O.type),O.data);return}}}send(O,B=void 0){const z=new d;return a(z,O),a(z,B),this.sendBuffer(z.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(B){return 0}}onRawMessage(O){const B=new E(O),z=f(B),J=f(B),ce=z[0];switch(ce){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],1,`${l(ce)}: ${z[2]}.${z[3]}`,J),this.onPromise({type:ce,id:z[1],channelName:z[2],name:z[3],arg:J});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],1,`${l(ce)}: ${z[2]}.${z[3]}`,J),this.onEventListen({type:ce,id:z[1],channelName:z[2],name:z[3],arg:J});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],1,`${l(ce)}`),this.disposeActiveRequest({type:ce,id:z[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],1,`${l(ce)}`),this.disposeActiveRequest({type:ce,id:z[1]})}}onPromise(O){const B=this.channels.get(O.channelName);if(!B){this.collectPendingRequest(O);return}const z=new y.CancellationTokenSource;let J;try{J=B.call(this.ctx,O.name,O.arg,z.token)}catch(Fe){J=Promise.reject(Fe)}const ce=O.id;J.then(Fe=>{this.sendResponse({id:ce,data:Fe,type:201}),this.activeRequests.delete(O.id)},Fe=>{Fe instanceof Error?this.sendResponse({id:ce,data:{message:Fe.message,name:Fe.name,stack:Fe.stack?Fe.stack.split?Fe.stack.split(`
`):Fe.stack:void 0},type:202}):this.sendResponse({id:ce,data:Fe,type:203}),this.activeRequests.delete(O.id)});const ye=(0,R.toDisposable)(()=>z.cancel());this.activeRequests.set(O.id,ye)}onEventListen(O){const B=this.channels.get(O.channelName);if(!B){this.collectPendingRequest(O);return}const z=O.id,ce=B.listen(this.ctx,O.name,O.arg)(ye=>this.sendResponse({id:z,data:ye,type:204}));this.activeRequests.set(O.id,ce)}disposeActiveRequest(O){const B=this.activeRequests.get(O.id);B&&(B.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let B=this.pendingRequests.get(O.channelName);B||(B=[],this.pendingRequests.set(O.channelName,B));const z=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);B.push({request:O,timeoutTimer:z})}flushPendingRequests(O){const B=this.pendingRequests.get(O);if(B){for(const z of B)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=m;var b;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class _{constructor(O,B=null){this.protocol=O,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=B}getChannel(O){const B=this;return{call(z,J,ce){return B.isDisposed?Promise.reject(T.canceled()):B.requestPromise(O,z,J,ce)},listen(z,J){return B.isDisposed?Promise.reject(T.canceled()):B.requestEvent(O,z,J)}}}requestPromise(O,B,z,J=y.CancellationToken.None){const ce=this.lastRequestId++,Fe={id:ce,type:100,channelName:O,name:B,arg:z};if(J.isCancellationRequested)return Promise.reject(T.canceled());let Re;return new Promise((Ve,ze)=>{if(J.isCancellationRequested)return ze(T.canceled());const j=()=>{const ve=ee=>{switch(ee.type){case 201:this.handlers.delete(ce),Ve(ee.data);break;case 202:this.handlers.delete(ce);const ue=new Error(ee.data.message);ue.stack=ee.data.stack,ue.name=ee.data.name,ze(ue);break;case 203:this.handlers.delete(ce),ze(ee.data);break}};this.handlers.set(ce,ve),this.sendRequest(Fe)};let Z=null;this.state===w.Idle?j():(Z=(0,k.createCancelablePromise)(ve=>this.whenInitialized()),Z.then(()=>{Z=null,j()}));const ie=()=>{Z?(Z.cancel(),Z=null):this.sendRequest({id:ce,type:101}),ze(T.canceled())},oe=J.onCancellationRequested(ie);Re=(0,R.combinedDisposable)((0,R.toDisposable)(ie),oe),this.activeRequests.add(Re)}).finally(()=>{this.activeRequests.delete(Re)})}requestEvent(O,B,z){const J=this.lastRequestId++,ye={id:J,type:102,channelName:O,name:B,arg:z};let Fe=null;const Re=new g.Emitter({onFirstListenerAdd:()=>{Fe=(0,k.createCancelablePromise)(Ve=>this.whenInitialized()),Fe.then(()=>{Fe=null,this.activeRequests.add(Re),this.sendRequest(ye)})},onLastListenerRemove:()=>{Fe?(Fe.cancel(),Fe=null):(this.activeRequests.delete(Re),this.sendRequest({id:J,type:103}))}}),Ne=Ve=>Re.fire(Ve.data);return this.handlers.set(J,Ne),Re.event}sendRequest(O){switch(O.type){case 100:case 102:{const B=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(B,O.id,0,`${l(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const B=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(B,O.id,0,l(O.type));return}}}send(O,B=void 0){const z=new d;return a(z,O),a(z,B),this.sendBuffer(z.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(B){return 0}}onBuffer(O){const B=new E(O),z=f(B),J=f(B),ce=z[0];switch(ce){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,S(ce)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,z[1],0,S(ce),J),this.onResponse({type:z[0],id:z[1],data:J})}}onResponse(O){if(O.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const B=this.handlers.get(O.id);B&&B(O)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}je([u.memoize],_.prototype,"onDidInitializePromise",null),e.ChannelClient=_;class o{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:B,onDidClientDisconnect:z})=>{g.Event.once(B.onMessage)(ce=>{const ye=new E(ce),Fe=f(ye),Re=new m(B,Fe),Ne=new _(B);this.channels.forEach((ze,j)=>Re.registerChannel(j,ze));const Ve={channelServer:Re,channelClient:Ne,ctx:Fe};this._connections.add(Ve),this._onDidAddConnection.fire(Ve),z(()=>{Re.dispose(),Ne.dispose(),this._connections.delete(Ve),this._onDidRemoveConnection.fire(Ve)})})})}get connections(){const O=[];return this._connections.forEach(B=>O.push(B)),O}getChannel(O,B){const z=this;return{call(J,ce,ye){let Fe;if((0,C.isFunction)(B)){let Ne=(0,D.getRandomElement)(z.connections.filter(B));Fe=Ne?Promise.resolve(Ne):g.Event.toPromise(g.Event.filter(z.onDidAddConnection,B))}else Fe=B.routeCall(z,J,ce);const Re=Fe.then(Ne=>Ne.channelClient.getChannel(O));return F(Re).call(J,ce,ye)},listen(J,ce){if((0,C.isFunction)(B))return z.getMulticastEvent(O,B,J,ce);const ye=B.routeEvent(z,J,ce).then(Fe=>Fe.channelClient.getChannel(O));return F(ye).listen(J,ce)}}}getMulticastEvent(O,B,z,J){const ce=this;let ye=new R.DisposableStore;const Fe=new g.Emitter({onFirstListenerAdd:()=>{ye=new R.DisposableStore;const Re=new g.EventMultiplexer,Ne=new Map,Ve=j=>{const ie=j.channelClient.getChannel(O).listen(z,J),oe=Re.add(ie);Ne.set(j,oe)},ze=j=>{const Z=Ne.get(j);!Z||(Z.dispose(),Ne.delete(j))};ce.connections.filter(B).forEach(Ve),g.Event.filter(ce.onDidAddConnection,B)(Ve,void 0,ye),ce.onDidRemoveConnection(ze,void 0,ye),Re.event(Fe.fire,Fe,ye),ye.add(Re)},onLastListenerRemove:()=>{ye.dispose()}});return Fe.event}registerChannel(O,B){this.channels.set(O,B),this._connections.forEach(z=>{z.channelServer.registerChannel(O,B)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=o;class A{constructor(O,B,z=null){const J=new d;a(J,B),O.send(J.buffer),this.channelClient=new _(O,z),this.channelServer=new m(O,B,z)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,B){this.channelServer.registerChannel(O,B)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function F(M){return{call(O,B,z){return M.then(J=>J.call(O,B,z))},listen(O,B){const z=new g.Relay;return M.then(J=>z.input=J.listen(O,B)),z.event}}}e.getDelayedChannel=F;function $(M){let O=!1;return{call(B,z,J){return O?M.call(B,z,J):(0,k.timeout)(0).then(()=>O=!0).then(()=>M.call(B,z,J))},listen(B,z){if(O)return M.listen(B,z);const J=new g.Relay;return(0,k.timeout)(0).then(()=>O=!0).then(()=>J.input=M.listen(B,z)),J.event}}}e.getNextTickChannel=$;class W{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const B of O.connections)if(await Promise.resolve(this.fn(B.ctx)))return Promise.resolve(B);return await g.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=W;var Q;(function(M){function O(J,ce){const ye=J,Fe=ce&&ce.disableMarshalling,Re=new Map;for(const Ne in ye)z(Ne)&&Re.set(Ne,g.Event.buffer(ye[Ne],!0));return new class{listen(Ne,Ve){const ze=Re.get(Ve);if(ze)return ze;throw new Error(`Event not found: ${Ve}`)}call(Ne,Ve,ze){const j=ye[Ve];if(typeof j=="function"){if(!Fe&&Array.isArray(ze))for(let Z=0;Z<ze.length;Z++)ze[Z]=(0,i.revive)(ze[Z]);return j.apply(ye,ze)}throw new Error(`Method not found: ${Ve}`)}}}M.fromService=O;function B(J,ce){const ye=ce&&ce.disableMarshalling;return new Proxy({},{get(Fe,Re){if(typeof Re=="string")return ce?.properties?.has(Re)?ce.properties.get(Re):z(Re)?J.listen(Re):async function(...Ne){let Ve;ce&&!(0,C.isUndefinedOrNull)(ce.context)?Ve=[ce.context,...Ne]:Ve=Ne;const ze=await J.call(Re,Ve);return ye?ze:(0,i.revive)(ze)};throw new Error(`Property not found: ${String(Re)}`)}})}M.toService=B;function z(J){return J[0]==="o"&&J[1]==="n"&&P.isUpperAsciiLetter(J.charCodeAt(2))}})(Q=e.ProxyChannel||(e.ProxyChannel={}));const H=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let O=M.toString();if(O!=="[object Object]")return O}return M}function x(M){return Array.isArray(M)?M.map(N):N(M)}function L(M,O,B,z,J,ce,ye){ye=x(ye);const Fe=H[J],Re=Fe[z%Fe.length];let Ne=[`%c[${M}]%c[${String(O).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${Re}`];/\($/.test(ce)?(Ne=Ne.concat(ye),Ne.push(")")):Ne.push(ye),console.log.apply(console,Ne)}e.logWithColors=L;class G{constructor(O,B){this._outgoingPrefix=O,this._incomingPrefix=B,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,B,z,J,ce){this._totalOutgoing+=O,L(this._outgoingPrefix,this._totalOutgoing,O,B,z,J,ce)}logIncoming(O,B,z,J,ce){this._totalIncoming+=O,L(this._incomingPrefix,this._totalIncoming,O,B,z,J,ce)}}e.IPCLogger=G}),define(he[104],fe([0,1,3,103,6,22,11,37]),function(X,e,g,R,k,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var D;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(D=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function i(){return C||(C=y.VSBuffer.alloc(0)),C}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,a){if(n===0)return i();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const _=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=n),_}if(this._chunks[0].byteLength>n){const _=this._chunks[0].slice(0,n);return a&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),_}let f=y.VSBuffer.alloc(n),m=0,b=0;for(;n>0;){const _=this._chunks[b];if(_.byteLength>n){const o=_.slice(0,n);f.set(o,m),m+=n,a&&(this._chunks[b]=_.slice(n),this._totalLength-=n),n-=n}else f.set(_,m),m+=_.byteLength,a?(this._chunks.shift(),this._totalLength-=_.byteLength):b++,n-=_.byteLength}return f}}e.ChunkStream=P;var u;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(u||(u={}));var p;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class l{constructor(n,a,f,m){this.type=n,this.id=a,this.ack=f,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends k.Disposable{constructor(n){super();this._onMessage=this._register(new g.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const f=this._state.messageType,m=this._state.id,b=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new l(f,m,b,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class S{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=y.VSBuffer.alloc(13);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this._writeSoon(a,n.data)}_bufferAdd(n,a){const f=this._totalLength===0;return this._data.push(n,a),this._totalLength+=n.byteLength+a.byteLength,f}_bufferTake(){const n=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,a){this._bufferAdd(n,a)&&T.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class w extends k.Disposable{constructor(n){super();this._onMessage=new g.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new g.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new S(this._socket)),this._socketReader=this._register(new c(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new l(1,0,0,n))}}e.Protocol=w;class E extends R.IPCClient{constructor(n,a,f=null){super(n,a,f);this.protocol=n}static fromSocket(n,a){return new E(new w(n),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=E;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new g.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,I.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class h{constructor(n){this.data=n,this.next=null}}class v{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],a=0,f=this._first;for(;f;)n[a++]=f.data,f=f.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const a=new h(n);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let a=0;a<t._HISTORY_LENGTH;a++)this.lastRuns[a]=n-1e3*a;setInterval(()=>{for(let a=t._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),a=(1+t._HISTORY_LENGTH)*1e3;let f=0;for(let m=0;m<t._HISTORY_LENGTH;m++)n-this.lastRuns[m]<=a&&f++;return 1-f/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(n,a=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new v,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new l(5,0,0,i());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const a=new l(4,0,0,i());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,a){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let a=0,f=n.length;a<f;a++)this._socketWriter.write(n[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new l(6,0,0,i())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const a=this._outgoingUnackMsg.toArray();for(let f=0,m=a.length;f<m;f++)this._socketWriter.write(a[f]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const f=new l(1,a,this._incomingAckId,n);this._outgoingUnackMsg.push(f),this._isReconnecting||(this._socketWriter.write(f),this._recvAckCheck())}sendControl(n){const a=new l(2,0,0,n);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const n=this._outgoingUnackMsg.peek(),a=Date.now()-n.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new l(3,0,this._incomingAckId,i());this._socketWriter.write(n)}}e.PersistentProtocol=s}),define(he[105],fe([0,1,93]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(I){let D=(0,g.toUint8)(I);this._defaultValue=D,this._asciiMap=R._createAsciiMap(D),this._map=new Map}static _createAsciiMap(I){let D=new Uint8Array(256);for(let C=0;C<256;C++)D[C]=I;return D}set(I,D){let C=(0,g.toUint8)(D);I>=0&&I<256?this._asciiMap[I]=C:this._map.set(I,C)}get(I){return I>=0&&I<256?this._asciiMap[I]:this._map.get(I)||this._defaultValue}}e.CharacterClassifier=R;var k;(function(T){T[T.False=0]="False",T[T.True=1]="True"})(k||(k={}));class y{constructor(){this._actual=new R(0)}add(I){this._actual.set(I,1)}has(I){return this._actual.get(I)===1}}e.CharacterSet=y}),define(he[139],fe([0,1,105]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(T){T[T.Regular=0]="Regular",T[T.Whitespace=1]="Whitespace",T[T.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends g.CharacterClassifier{constructor(I){super(0);for(let D=0,C=I.length;D<C;D++)this.set(I.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function y(T){let I={};return D=>(I.hasOwnProperty(D)||(I[D]=T(D)),I[D])}e.getMapForWordSeparators=y(T=>new k(T))}),define(he[46],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(k,y){this.lineNumber=k,this.column=y}with(k=this.lineNumber,y=this.column){return k===this.lineNumber&&y===this.column?this:new g(k,y)}delta(k=0,y=0){return this.with(this.lineNumber+k,this.column+y)}equals(k){return g.equals(this,k)}static equals(k,y){return!k&&!y?!0:!!k&&!!y&&k.lineNumber===y.lineNumber&&k.column===y.column}isBefore(k){return g.isBefore(this,k)}static isBefore(k,y){return k.lineNumber<y.lineNumber?!0:y.lineNumber<k.lineNumber?!1:k.column<y.column}isBeforeOrEqual(k){return g.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,y){return k.lineNumber<y.lineNumber?!0:y.lineNumber<k.lineNumber?!1:k.column<=y.column}static compare(k,y){let T=k.lineNumber|0,I=y.lineNumber|0;if(T===I){let D=k.column|0,C=y.column|0;return D-C}return T-I}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new g(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=g}),define(he[40],fe([0,1,46]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(y,T,I,D){y>I||y===I&&T>D?(this.startLineNumber=I,this.startColumn=D,this.endLineNumber=y,this.endColumn=T):(this.startLineNumber=y,this.startColumn=T,this.endLineNumber=I,this.endColumn=D)}isEmpty(){return R.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return R.containsPosition(this,y)}static containsPosition(y,T){return!(T.lineNumber<y.startLineNumber||T.lineNumber>y.endLineNumber||T.lineNumber===y.startLineNumber&&T.column<y.startColumn||T.lineNumber===y.endLineNumber&&T.column>y.endColumn)}containsRange(y){return R.containsRange(this,y)}static containsRange(y,T){return!(T.startLineNumber<y.startLineNumber||T.endLineNumber<y.startLineNumber||T.startLineNumber>y.endLineNumber||T.endLineNumber>y.endLineNumber||T.startLineNumber===y.startLineNumber&&T.startColumn<y.startColumn||T.endLineNumber===y.endLineNumber&&T.endColumn>y.endColumn)}strictContainsRange(y){return R.strictContainsRange(this,y)}static strictContainsRange(y,T){return!(T.startLineNumber<y.startLineNumber||T.endLineNumber<y.startLineNumber||T.startLineNumber>y.endLineNumber||T.endLineNumber>y.endLineNumber||T.startLineNumber===y.startLineNumber&&T.startColumn<=y.startColumn||T.endLineNumber===y.endLineNumber&&T.endColumn>=y.endColumn)}plusRange(y){return R.plusRange(this,y)}static plusRange(y,T){let I,D,C,i;return T.startLineNumber<y.startLineNumber?(I=T.startLineNumber,D=T.startColumn):T.startLineNumber===y.startLineNumber?(I=T.startLineNumber,D=Math.min(T.startColumn,y.startColumn)):(I=y.startLineNumber,D=y.startColumn),T.endLineNumber>y.endLineNumber?(C=T.endLineNumber,i=T.endColumn):T.endLineNumber===y.endLineNumber?(C=T.endLineNumber,i=Math.max(T.endColumn,y.endColumn)):(C=y.endLineNumber,i=y.endColumn),new R(I,D,C,i)}intersectRanges(y){return R.intersectRanges(this,y)}static intersectRanges(y,T){let I=y.startLineNumber,D=y.startColumn,C=y.endLineNumber,i=y.endColumn,P=T.startLineNumber,u=T.startColumn,p=T.endLineNumber,l=T.endColumn;return I<P?(I=P,D=u):I===P&&(D=Math.max(D,u)),C>p?(C=p,i=l):C===p&&(i=Math.min(i,l)),I>C||I===C&&D>i?null:new R(I,D,C,i)}equalsRange(y){return R.equalsRange(this,y)}static equalsRange(y,T){return!!y&&!!T&&y.startLineNumber===T.startLineNumber&&y.startColumn===T.startColumn&&y.endLineNumber===T.endLineNumber&&y.endColumn===T.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(y){return new g.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(y){return new g.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,T){return new R(this.startLineNumber,this.startColumn,y,T)}setStartPosition(y,T){return new R(y,T,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(y){return new R(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,T=y){return new R(y.lineNumber,y.column,T.lineNumber,T.column)}static lift(y){return y?new R(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,T){return!(y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<T.startColumn||T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<y.startColumn)}static areIntersecting(y,T){return!(y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<=T.startColumn||T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,T){if(y&&T){const C=y.startLineNumber|0,i=T.startLineNumber|0;if(C===i){const P=y.startColumn|0,u=T.startColumn|0;if(P===u){const p=y.endLineNumber|0,l=T.endLineNumber|0;if(p===l){const c=y.endColumn|0,S=T.endColumn|0;return c-S}return p-l}return P-u}return C-i}return(y?1:0)-(T?1:0)}static compareRangesUsingEnds(y,T){return y.endLineNumber===T.endLineNumber?y.endColumn===T.endColumn?y.startLineNumber===T.startLineNumber?y.startColumn-T.startColumn:y.startLineNumber-T.startLineNumber:y.endColumn-T.endColumn:y.endLineNumber-T.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=R}),define(he[140],fe([0,1,46,40]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(T){T[T.LTR=0]="LTR",T[T.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class y extends R.Range{constructor(I,D,C,i){super(I,D,C,i);this.selectionStartLineNumber=I,this.selectionStartColumn=D,this.positionLineNumber=C,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(I){return y.selectionsEqual(this,I)}static selectionsEqual(I,D){return I.selectionStartLineNumber===D.selectionStartLineNumber&&I.selectionStartColumn===D.selectionStartColumn&&I.positionLineNumber===D.positionLineNumber&&I.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(I,D){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,I,D):new y(I,D,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(I,D){return this.getDirection()===0?new y(I,D,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,I,D)}static fromPositions(I,D=I){return new y(I.lineNumber,I.column,D.lineNumber,D.column)}static liftSelection(I){return new y(I.selectionStartLineNumber,I.selectionStartColumn,I.positionLineNumber,I.positionColumn)}static selectionsArrEqual(I,D){if(I&&!D||!I&&D)return!1;if(!I&&!D)return!0;if(I.length!==D.length)return!1;for(let C=0,i=I.length;C<i;C++)if(!this.selectionsEqual(I[C],D[C]))return!1;return!0}static isISelection(I){return I&&typeof I.selectionStartLineNumber=="number"&&typeof I.selectionStartColumn=="number"&&typeof I.positionLineNumber=="number"&&typeof I.positionColumn=="number"}static createWithDirection(I,D,C,i,P){return P===0?new y(I,D,C,i):new y(C,i,I,D)}}e.Selection=y}),define(he[106],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var g;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(g=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var k;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(k=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var T;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(T=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),this.indentSize=c.tabSize|0,this.insertSpaces=Boolean(c.insertSpaces),this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=Boolean(c.trimAutoWhitespace)}equals(c){return this.tabSize===c.tabSize&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class D{constructor(c,S){this._findMatchBrand=void 0,this.range=c,this.matches=S}}e.FindMatch=D;var C;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None"})(i=e.PositionAffinity||(e.PositionAffinity={}));var P;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(P=e.ModelConstants||(e.ModelConstants={}));class u{constructor(c,S,w,E,d,h){this.identifier=c,this.range=S,this.text=w,this.forceMoveMarkers=E,this.isAutoWhitespaceEdit=d,this._isTracked=h}}e.ValidAnnotatedEditOperation=u;class p{constructor(c,S,w){this.reverseEdits=c,this.changes=S,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=p}),define(he[141],fe([0,1,8,139,46,40,106]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class D{constructor(d,h,v,t){this.searchString=d,this.isRegex=h,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=C(this.searchString):d=this.searchString.indexOf(`
`)>=0;let h=null;try{h=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch(t){return null}if(!h)return null;let v=!this.isRegex&&!d;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new i(h,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=D;function C(E){if(!E||E.length===0)return!1;for(let d=0,h=E.length;d<h;d++)if(E.charCodeAt(d)===92){if(d++,d>=h)break;const t=E.charCodeAt(d);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class i{constructor(d,h,v){this.regex=d,this.wordSeparators=h,this.simpleSearch=v}}e.SearchData=i;function P(E,d,h){if(!h)return new T.FindMatch(E,null);let v=[];for(let t=0,s=d.length;t<s;t++)v[t]=d[t];return new T.FindMatch(E,v)}e.createFindMatch=P;class u{constructor(d){let h=[],v=0;for(let t=0,s=d.length;t<s;t++)d.charCodeAt(t)===10&&(h[v++]=t);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(d){const h=this._lineFeedsOffsets;let v=0,t=h.length-1;if(t===-1||d<=h[0])return 0;for(;v<t;){const s=v+((t-v)/2>>0);h[s]>=d?t=s-1:h[s+1]>=d?(v=s,t=s):v=s+1}return v+1}}class p{static findMatches(d,h,v,t,s){const r=h.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(d,v,new w(r.wordSeparators,r.regex),t,s):this._doFindMatchesLineByLine(d,v,r,t,s):[]}static _getMultilineMatchRange(d,h,v,t,s,r){let n,a=0;t?(a=t.findLineFeedCountBeforeOffset(s),n=h+s+a):n=h+s;let f;if(t){let o=t.findLineFeedCountBeforeOffset(s+r.length)-a;f=n+r.length+o}else f=n+r.length;const m=d.getPositionAt(n),b=d.getPositionAt(f);return new y.Range(m.lineNumber,m.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(d,h,v,t,s){const r=d.getOffsetAt(h.getStartPosition()),n=d.getValueInRange(h,1),a=d.getEOL()===`\r
`?new u(n):null,f=[];let m=0,b;for(v.reset(0);b=v.next(n);)if(f[m++]=P(this._getMultilineMatchRange(d,r,n,a,b.index,b[0]),b,t),m>=s)return f;return f}static _doFindMatchesLineByLine(d,h,v,t,s){const r=[];let n=0;if(h.startLineNumber===h.endLineNumber){const f=d.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return n=this._findMatchesInLine(v,f,h.startLineNumber,h.startColumn-1,n,r,t,s),r}const a=d.getLineContent(h.startLineNumber).substring(h.startColumn-1);n=this._findMatchesInLine(v,a,h.startLineNumber,h.startColumn-1,n,r,t,s);for(let f=h.startLineNumber+1;f<h.endLineNumber&&n<s;f++)n=this._findMatchesInLine(v,d.getLineContent(f),f,0,n,r,t,s);if(n<s){const f=d.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);n=this._findMatchesInLine(v,f,h.endLineNumber,0,n,r,t,s)}return r}static _findMatchesInLine(d,h,v,t,s,r,n,a){const f=d.wordSeparators;if(!n&&d.simpleSearch){const _=d.simpleSearch,o=_.length,A=h.length;let F=-o;for(;(F=h.indexOf(_,F+o))!==-1;)if((!f||S(f,h,A,F,o))&&(r[s++]=new T.FindMatch(new y.Range(v,F+1+t,v,F+1+o+t),null),s>=a))return s;return s}const m=new w(d.wordSeparators,d.regex);let b;m.reset(0);do if(b=m.next(h),b&&(r[s++]=P(new y.Range(v,b.index+1+t,v,b.index+1+b[0].length+t),b,n),s>=a))return s;while(b);return s}static findNextMatch(d,h,v,t){const s=h.parseSearchRequest();if(!s)return null;const r=new w(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(d,v,r,t):this._doFindNextMatchLineByLine(d,v,r,t)}static _doFindNextMatchMultiline(d,h,v,t){const s=new k.Position(h.lineNumber,1),r=d.getOffsetAt(s),n=d.getLineCount(),a=d.getValueInRange(new y.Range(s.lineNumber,s.column,n,d.getLineMaxColumn(n)),1),f=d.getEOL()===`\r
`?new u(a):null;v.reset(h.column-1);let m=v.next(a);return m?P(this._getMultilineMatchRange(d,r,a,f,m.index,m[0]),m,t):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(d,new k.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(d,h,v,t){const s=d.getLineCount(),r=h.lineNumber,n=d.getLineContent(r),a=this._findFirstMatchInLine(v,n,r,h.column,t);if(a)return a;for(let f=1;f<=s;f++){const m=(r+f-1)%s,b=d.getLineContent(m+1),_=this._findFirstMatchInLine(v,b,m+1,1,t);if(_)return _}return null}static _findFirstMatchInLine(d,h,v,t,s){d.reset(t-1);const r=d.next(h);return r?P(new y.Range(v,r.index+1,v,r.index+1+r[0].length),r,s):null}static findPreviousMatch(d,h,v,t){const s=h.parseSearchRequest();if(!s)return null;const r=new w(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(d,v,r,t):this._doFindPreviousMatchLineByLine(d,v,r,t)}static _doFindPreviousMatchMultiline(d,h,v,t){const s=this._doFindMatchesMultiline(d,new y.Range(1,1,h.lineNumber,h.column),v,t,10*I);if(s.length>0)return s[s.length-1];const r=d.getLineCount();return h.lineNumber!==r||h.column!==d.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(d,new k.Position(r,d.getLineMaxColumn(r)),v,t):null}static _doFindPreviousMatchLineByLine(d,h,v,t){const s=d.getLineCount(),r=h.lineNumber,n=d.getLineContent(r).substring(0,h.column-1),a=this._findLastMatchInLine(v,n,r,t);if(a)return a;for(let f=1;f<=s;f++){const m=(s+r-f-1)%s,b=d.getLineContent(m+1),_=this._findLastMatchInLine(v,b,m+1,t);if(_)return _}return null}static _findLastMatchInLine(d,h,v,t){let s=null,r;for(d.reset(0);r=d.next(h);)s=P(new y.Range(v,r.index+1,v,r.index+1+r[0].length),r,t);return s}}e.TextModelSearch=p;function l(E,d,h,v,t){if(v===0)return!0;const s=d.charCodeAt(v-1);if(E.get(s)!==0||s===13||s===10)return!0;if(t>0){const r=d.charCodeAt(v);if(E.get(r)!==0)return!0}return!1}function c(E,d,h,v,t){if(v+t===h)return!0;const s=d.charCodeAt(v+t);if(E.get(s)!==0||s===13||s===10)return!0;if(t>0){const r=d.charCodeAt(v+t-1);if(E.get(r)!==0)return!0}return!1}function S(E,d,h,v,t){return l(E,d,h,v,t)&&c(E,d,h,v,t)}e.isValidMatch=S;class w{constructor(d,h){this._wordSeparators=d,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(d){this._searchRegex.lastIndex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(d){const h=d.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(v=this._searchRegex.exec(d),!v))return null;const t=v.index,s=v[0].length;if(t===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){g.getNextCodePoint(d,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=s,!this._wordSeparators||S(this._wordSeparators,d,h,t,s))return v}while(v);return null}}e.Searcher=w}),define(he[107],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(I=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)I.indexOf(C)>=0||(D+="\\"+C);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=g();function R(I){let D=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)D=I;else{let C="g";I.ignoreCase&&(C+="i"),I.multiline&&(C+="m"),I.unicode&&(C+="u"),D=new RegExp(I.source,C)}return D.lastIndex=0,D}e.ensureValidWordDefinition=R;const k={maxLen:1e3,windowSize:15,timeBudget:150};function y(I,D,C,i,P=k){if(C.length>P.maxLen){let S=I-P.maxLen/2;return S<0?S=0:i+=S,C=C.substring(S,I+P.maxLen/2),y(I,D,C,i,P)}const u=Date.now(),p=I-1-i;let l=-1,c=null;for(let S=1;!(Date.now()-u>=P.timeBudget);S++){const w=p-P.windowSize*S;D.lastIndex=Math.max(0,w);const E=T(D,C,p,l);if(!E&&c||(c=E,w<=0))break;l=w}if(c){let S={word:c[0],startColumn:i+1+c.index,endColumn:i+1+c.index+c[0].length};return D.lastIndex=0,S}return null}e.getWordAtText=y;function T(I,D,C,i){let P;for(;P=I.exec(D);){const u=P.index||0;if(u<=C&&I.lastIndex>=C)return P;if(i>0&&u>i)return null}return null}}),define(he[142],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(T){T[T.None=0]="None",T[T.Indent=1]="Indent",T[T.IndentOutdent=2]="IndentOutdent",T[T.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class R{constructor(I){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=I.open,this.close=I.close,this._standardTokenMask=0,Array.isArray(I.notIn))for(let D=0,C=I.notIn.length;D<C;D++)switch(I.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(I){return(this._standardTokenMask&I)==0}}e.StandardAutoClosingPairConditional=R;class k{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of I)y(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),y(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),y(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),y(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&y(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=k;function y(T,I,D){T.has(I)?T.get(I).push(D):T.set(I,[D])}}),define(he[77],fe([0,1,30,9]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(y,T,I,D){if(Array.isArray(y)){let C=0;for(const i of y){const P=k(i,T,I,D);if(P===10)return P;P>C&&(C=P)}return C}else{if(typeof y=="string")return D?y==="*"?5:y===I?10:0:0;if(y){const{language:C,pattern:i,scheme:P,hasAccessToAllModels:u}=y;if(!D&&!u)return 0;let p=0;if(P)if(P===T.scheme)p=10;else if(P==="*")p=5;else return 0;if(C)if(C===I)p=10;else if(C==="*")p=Math.max(p,5);else return 0;if(i){let l;if(typeof i=="string"?l=i:l={...i,base:(0,R.normalize)(i.base)},l===T.fsPath||(0,g.match)(l,T.fsPath))p=10;else return 0}return p}else return 0}}e.score=k}),define(he[143],fe([0,1,105]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class k{constructor(l,c,S){const w=new Uint8Array(l*c);for(let E=0,d=l*c;E<d;E++)w[E]=S;this._data=w,this.rows=l,this.cols=c}get(l,c){return this._data[l*this.cols+c]}set(l,c,S){this._data[l*this.cols+c]=S}}e.Uint8Matrix=k;class y{constructor(l){let c=0,S=0;for(let E=0,d=l.length;E<d;E++){let[h,v,t]=l[E];v>c&&(c=v),h>S&&(S=h),t>S&&(S=t)}c++,S++;let w=new k(S,c,0);for(let E=0,d=l.length;E<d;E++){let[h,v,t]=l[E];w.set(h,v,t)}this._states=w,this._maxCharCode=c}nextState(l,c){return c<0||c>=this._maxCharCode?0:this._states.get(l,c)}}e.StateMachine=y;let T=null;function I(){return T===null&&(T=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),T}var D;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let C=null;function i(){if(C===null){C=new g.CharacterClassifier(0);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let c=0;c<p.length;c++)C.set(p.charCodeAt(c),1);const l=".,;";for(let c=0;c<l.length;c++)C.set(l.charCodeAt(c),2)}return C}class P{static _createLink(l,c,S,w,E){let d=E-1;do{const h=c.charCodeAt(d);if(l.get(h)!==2)break;d--}while(d>w);if(w>0){const h=c.charCodeAt(w-1),v=c.charCodeAt(d);(h===40&&v===41||h===91&&v===93||h===123&&v===125)&&d--}return{range:{startLineNumber:S,startColumn:w+1,endLineNumber:S,endColumn:d+2},url:c.substring(w,d+1)}}static computeLinks(l,c=I()){const S=i();let w=[];for(let E=1,d=l.getLineCount();E<=d;E++){const h=l.getLineContent(E),v=h.length;let t=0,s=0,r=0,n=1,a=!1,f=!1,m=!1,b=!1;for(;t<v;){let _=!1;const o=h.charCodeAt(t);if(n===13){let A;switch(o){case 40:a=!0,A=0;break;case 41:A=a?0:1;break;case 91:m=!0,f=!0,A=0;break;case 93:m=!1,A=f?0:1;break;case 123:b=!0,A=0;break;case 125:A=b?0:1;break;case 39:A=r===34||r===96?0:1;break;case 34:A=r===39||r===96?0:1;break;case 96:A=r===39||r===34?0:1;break;case 42:A=r===42?1:0;break;case 124:A=r===124?1:0;break;case 32:A=m?0:1;break;default:A=S.get(o)}A===1&&(w.push(P._createLink(S,h,E,s,t)),_=!0)}else if(n===12){let A;o===91?(f=!0,A=0):A=S.get(o),A===1?_=!0:n=13}else n=c.nextState(n,o),n===0&&(_=!0);_&&(n=1,a=!1,f=!1,b=!1,s=t+1,r=o),t++}n===13&&w.push(P._createLink(S,h,E,s,v))}return w}}e.LinkComputer=P;function u(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:P.computeLinks(p)}e.computeLinks=u}),define(he[144],fe([0,1,3,6]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class k{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(T){this._onDidChange.fire({changedLanguages:T,changedColorMap:!1})}register(T,I){return this._map.set(T,I),this.fire([T]),(0,R.toDisposable)(()=>{this._map.get(T)===I&&(this._map.delete(T),this.fire([T]))})}registerPromise(T,I){let D=null,C=!1;return this._promises.set(T,I.then(i=>{this._promises.delete(T),!(C||!i)&&(D=this.register(T,i))})),(0,R.toDisposable)(()=>{C=!0,D&&D.dispose()})}getPromise(T){const I=this.get(T);if(I)return Promise.resolve(I);const D=this._promises.get(T);return D?D.then(C=>this.get(T)):null}get(T){return this._map.get(T)||null}setColorMap(T){this._colorMap=T,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=k}),define(he[108],fe([0,1,22,11]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(k||(k={}));function y(P){for(let u=0,p=P.length;u<p;u+=4){const l=P[u+0],c=P[u+1],S=P[u+2],w=P[u+3];P[u+0]=w,P[u+1]=S,P[u+2]=c,P[u+3]=l}}function T(P){const u=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return R.isLittleEndian()||y(u),g.VSBuffer.wrap(u)}function I(P){const u=P.buffer;if(R.isLittleEndian()||y(u),u.byteOffset%4==0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const p=new Uint8Array(u.byteLength);return p.set(u),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function D(P){const u=new Uint32Array(C(P));let p=0;if(u[p++]=P.id,P.type==="full")u[p++]=1,u[p++]=P.data.length,u.set(P.data,p),p+=P.data.length;else{u[p++]=2,u[p++]=P.deltas.length;for(const l of P.deltas)u[p++]=l.start,u[p++]=l.deleteCount,l.data?(u[p++]=l.data.length,u.set(l.data,p),p+=l.data.length):u[p++]=0}return T(u)}e.encodeSemanticTokensDto=D;function C(P){let u=0;if(u+=1+1,P.type==="full")u+=1+P.data.length;else{u+=1,u+=(1+1+1)*P.deltas.length;for(const p of P.deltas)p.data&&(u+=p.data.length)}return u}function i(P){const u=I(P);let p=0;const l=u[p++];if(u[p++]===1){const E=u[p++],d=u.subarray(p,p+E);return p+=E,{id:l,type:"full",data:d}}const S=u[p++];let w=[];for(let E=0;E<S;E++){const d=u[p++],h=u[p++],v=u[p++];let t;v>0&&(t=u.subarray(p,p+v),p+=v),w[E]={start:d,deleteCount:h,data:t}}return{id:l,type:"delta",deltas:w}}e.decodeSemanticTokensDto=i}),define(he[109],fe([0,1,93]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(T,I){this._prefixSumIndexOfResultBrand=void 0,this.index=T,this.remainder=I}}e.PrefixSumIndexOfResult=R;class k{constructor(T){this.values=T,this.prefixSum=new Uint32Array(T.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(T,I){T=(0,g.toUint32)(T);const D=this.values,C=this.prefixSum,i=I.length;return i===0?!1:(this.values=new Uint32Array(D.length+i),this.values.set(D.subarray(0,T),0),this.values.set(D.subarray(T),T+i),this.values.set(I,T),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(T,I){return T=(0,g.toUint32)(T),I=(0,g.toUint32)(I),this.values[T]===I?!1:(this.values[T]=I,T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),!0)}removeValues(T,I){T=(0,g.toUint32)(T),I=(0,g.toUint32)(I);const D=this.values,C=this.prefixSum;if(T>=D.length)return!1;let i=D.length-T;return I>=i&&(I=i),I===0?!1:(this.values=new Uint32Array(D.length-I),this.values.set(D.subarray(0,T),0),this.values.set(D.subarray(T+I),T),this.prefixSum=new Uint32Array(this.values.length),T-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=T-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(T){return T<0?0:(T=(0,g.toUint32)(T),this._getPrefixSum(T))}_getPrefixSum(T){if(T<=this.prefixSumValidIndex[0])return this.prefixSum[T];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),T>=this.values.length&&(T=this.values.length-1);for(let D=I;D<=T;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],T),this.prefixSum[T]}getIndexOf(T){T=Math.floor(T),this.getTotalSum();let I=0,D=this.values.length-1,C=0,i=0,P=0;for(;I<=D;)if(C=I+(D-I)/2|0,i=this.prefixSum[C],P=i-this.values[C],T<P)D=C-1;else if(T>=i)I=C+1;else break;return new R(C,T-P)}}e.PrefixSumComputer=k}),define(he[145],fe([0,1,8,46,109]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(I,D,C,i){this._uri=I,this._lines=D,this._eol=C,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(I){I.eol&&I.eol!==this._eol&&(this._eol=I.eol,this._lineStarts=null);const D=I.changes;for(const C of D)this._acceptDeleteRange(C.range),this._acceptInsertText(new R.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=I.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const I=this._eol.length,D=this._lines.length,C=new Uint32Array(D);for(let i=0;i<D;i++)C[i]=this._lines[i].length+I;this._lineStarts=new k.PrefixSumComputer(C)}}_setLineText(I,D){this._lines[I]=D,this._lineStarts&&this._lineStarts.changeValue(I,this._lines[I].length+this._eol.length)}_acceptDeleteRange(I){if(I.startLineNumber===I.endLineNumber){if(I.startColumn===I.endColumn)return;this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.startLineNumber-1].substring(I.endColumn-1));return}this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.endLineNumber-1].substring(I.endColumn-1)),this._lines.splice(I.startLineNumber,I.endLineNumber-I.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(I.startLineNumber,I.endLineNumber-I.startLineNumber)}_acceptInsertText(I,D){if(D.length===0)return;let C=(0,g.splitLines)(D);if(C.length===1){this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+C[0]+this._lines[I.lineNumber-1].substring(I.column-1));return}C[C.length-1]+=this._lines[I.lineNumber-1].substring(I.column-1),this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+C[0]);let i=new Uint32Array(C.length-1);for(let P=1;P<C.length;P++)this._lines.splice(I.lineNumber+P-1,0,C[P]),i[P-1]=C[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(I.lineNumber,i)}}e.MirrorTextModel=y}),define(he[146],fe([19,20]),function(X,e){return X.create("vs/base/common/date",e)}),define(he[147],fe([0,1,146]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,k=R*60,y=k*24,T=y*7,I=y*30,D=y*365;function C(P,u){typeof P!="number"&&(P=P.getTime());const p=Math.round((new Date().getTime()-P)/1e3);if(p<-30)return(0,g.localize)(0,null,C(new Date().getTime()+p*1e3,!1));if(p<30)return(0,g.localize)(1,null);let l;return p<R?(l=p,u?l===1?(0,g.localize)(2,null,l):(0,g.localize)(3,null,l):l===1?(0,g.localize)(4,null,l):(0,g.localize)(5,null,l)):p<k?(l=Math.floor(p/R),u?l===1?(0,g.localize)(6,null,l):(0,g.localize)(7,null,l):l===1?(0,g.localize)(8,null,l):(0,g.localize)(9,null,l)):p<y?(l=Math.floor(p/k),u?l===1?(0,g.localize)(10,null,l):(0,g.localize)(11,null,l):l===1?(0,g.localize)(12,null,l):(0,g.localize)(13,null,l)):p<T?(l=Math.floor(p/y),u?l===1?(0,g.localize)(14,null,l):(0,g.localize)(15,null,l):l===1?(0,g.localize)(16,null,l):(0,g.localize)(17,null,l)):p<I?(l=Math.floor(p/T),u?l===1?(0,g.localize)(18,null,l):(0,g.localize)(19,null,l):l===1?(0,g.localize)(20,null,l):(0,g.localize)(21,null,l)):p<D?(l=Math.floor(p/I),u?l===1?(0,g.localize)(22,null,l):(0,g.localize)(23,null,l):l===1?(0,g.localize)(24,null,l):(0,g.localize)(25,null,l)):(l=Math.floor(p/D),u?l===1?(0,g.localize)(26,null,l):(0,g.localize)(27,null,l):l===1?(0,g.localize)(28,null,l):(0,g.localize)(29,null,l))}e.fromNow=C;function i(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(he[148],fe([19,20]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(he[58],fe([0,1,148,14,18]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(C,i){return i&&(C.stack||C.stacktrace)?g.localize(0,null,I(C),T(C.stack)||T(C.stacktrace)):I(C)}function T(C){return Array.isArray(C)?C.join(`
`):C}function I(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?g.localize(1,null,C.message):C.message||g.localize(2,null)}function D(C=null,i=!1){if(!C)return g.localize(3,null);if(Array.isArray(C)){const P=k.coalesce(C),u=D(P[0],i);return P.length>1?g.localize(4,null,u,P.length):u}if(R.isString(C))return C;if(C.detail){const P=C.detail;if(P.error)return y(P.error,i);if(P.exception)return y(P.exception,i)}return C.stack?y(C,i):C.message?C.message:g.localize(5,null)}e.toErrorMessage=D}),define(he[149],fe([19,20]),function(X,e){return X.create("vs/base/node/processes",e)}),define(he[110],fe([0,1,9,28,38,149,37,14,25,29,11,138,10]),function(X,e,g,R,k,y,T,I,D,C,i,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function p(h){switch(h){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function l(h,v){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};v&&(t.cwd=v);const s=k.execFile("taskkill",["/T","/F","/PID",h.pid.toString()],t);return new Promise(r=>{s.once("error",n=>{r({success:!1,error:n})}),s.once("exit",(n,a)=>{r(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?p(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=u.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(s=>{k.execFile(t,[h.pid.toString()],{encoding:"utf8",shell:!0},(r,n,a)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else h.kill("SIGKILL");return Promise.resolve({success:!0})}function c(h=T.env){return h.comspec||"cmd.exe"}e.getWindowsShell=c;class S{constructor(v,t,s,r){if(t!==void 0&&s!==void 0&&r!==void 0)this.cmd=v,this.args=t,this.shell=s,this.options=r;else{const n=v;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(T.env).forEach(a=>{n[a]=T.env[a]}),Object.keys(this.options.env).forEach(a=>{n[a]=this.options.env[a]}),this.options.env=n}}getSanitizedCommand(){let v=this.cmd.toLowerCase();const t=v.lastIndexOf(g.sep);return t!==-1&&(v=v.substring(t+1)),S.WellKnowCommands[v]?v:"other"}start(v){return i.isWindows&&(this.options&&this.options.cwd&&C.isUNC(this.options.cwd)||!this.options&&C.isUNC(T.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(t=>{let s,r;const n=new Promise((a,f)=>{s=a,r=f});if(t){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=k.exec(a,this.options,(f,m,b)=>{this.childProcess=null;const _=f;_&&_.killed?r({killed:this.terminateRequested,stdout:m.toString(),stderr:b.toString()}):this.handleExec(s,v,f,m,b)})}else{let a=null;const f=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,s,v,r);const b={terminated:this.terminateRequested};I.isNumber(m)&&(b.cmdCode=m),s(b)};if(this.shell&&i.isWindows){const m=D.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let b=!1,_=!1;const o=[];let A=this.ensureQuotes(this.cmd);o.push(A.value),b=A.quoted,this.args&&this.args.forEach($=>{A=this.ensureQuotes($),o.push(A.value),_=_&&A.quoted});const F=["/s","/c"];b?_?F.push('"'+o.join(" ")+'"'):o.length>1?F.push('"'+o[0]+'" '+o.slice(1).join(" ")):F.push('"'+o[0]+'"'):F.push(o.join(" ")),a=k.spawn(c(),F,m)}else this.cmd&&(a=k.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(I.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",m=>{this.childProcess=null,r({terminated:this.terminateRequested,error:m})}),a.pid&&(this.childProcess.on("close",f),this.handleSpawn(a,s,v,r,!0)))}return n})}handleClose(v,t,s,r){}ensureQuotes(v){return S.regexp.test(v)?{value:'"'+v+'"',quoted:!0}:{value:v,quoted:v.length>0&&v[0]==='"'&&v[v.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(v=>v.pid,v=>-1):new Promise(v=>{this.pidResolve=v})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(v=>(this.terminateRequested=!0,l(v,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),v=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(v=>{if(!this.shell||!i.isWindows)return v(!1);const t=k.spawn(c(),["/s","/c"]);t.on("error",s=>v(!0)),t.on("exit",s=>v(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class w extends S{constructor(v,t,s,r){super(v,t,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(v,t,s,r,n){[r,n].forEach((a,f)=>{const m=new P.LineDecoder;m.write(a).forEach(o=>{t({line:o,source:f===0?0:1})});const _=m.end();_&&t({line:_,source:f===0?0:1})}),v({terminated:this.terminateRequested,error:s})}handleSpawn(v,t,s,r,n){const a=new P.LineDecoder,f=new P.LineDecoder;v.stdout.on("data",m=>{a.write(m).forEach(_=>s({line:_,source:0}))}),v.stderr.on("data",m=>{f.write(m).forEach(_=>s({line:_,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=f}handleClose(v,t,s,r){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&s({line:n,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&s({line:a,source:1})}}e.LineProcess=w;function E(h){let v=[],t=!1;const s=function(r){if(t){v.push(r);return}(!h.send(r,a=>{if(a&&console.error(a),t=!1,v.length>0){const f=v.slice(0);v=[],f.forEach(m=>s(m))}})||i.isWindows)&&(t=!0)};return{send:s}}e.createQueuedSender=E;var d;(function(h){async function v(t,s,r){if(g.isAbsolute(t))return t;if(s===void 0&&(s=T.cwd()),g.dirname(t)!=="."||(r===void 0&&I.isString(T.env.PATH)&&(r=T.env.PATH.split(g.delimiter)),r===void 0||r.length===0))return g.join(s,t);async function a(f){return await R.Promises.exists(f)?!(await R.Promises.stat(f)).isDirectory():!1}for(let f of r){let m;if(g.isAbsolute(f)?m=g.join(f,t):m=g.join(s,f,t),await a(m))return m;let b=m+".com";if(await a(b)||(b=m+".exe",await a(b)))return b}return g.join(s,t)}h.findExecutable=v})(d=e.win32||(e.win32={}))}),define(he[150],fe([19,20]),function(X,e){return X.create("vs/editor/common/config/editorOptions",e)}),define(he[151],fe([0,1,150,11,107]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(K){K[K.None=0]="None",K[K.Keep=1]="Keep",K[K.Brackets=2]="Brackets",K[K.Advanced=3]="Advanced",K[K.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=T;class I{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,pe){this._values[te]=pe}}e.ValidatedEditorOptions=I;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class C{constructor(te,pe,Ue,We){this.id=te,this.name=pe,this.defaultValue=Ue,this.schema=We}compute(te,pe,Ue){return Ue}}class i{constructor(te,pe=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(te){return this.defaultValue}}class P{constructor(te,pe,Ue,We){this.id=te,this.name=pe,this.defaultValue=Ue,this.schema=We}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,pe,Ue){return Ue}}function u(K,te){return typeof K=="undefined"?te:K==="false"?!1:Boolean(K)}e.boolean=u;class p extends P{constructor(te,pe,Ue,We=void 0){typeof We!="undefined"&&(We.type="boolean",We.default=Ue),super(te,pe,Ue,We)}validate(te){return u(te,this.defaultValue)}}class l extends P{constructor(te,pe,Ue,We,Ze,Pe=void 0){typeof Pe!="undefined"&&(Pe.type="integer",Pe.default=Ue,Pe.minimum=We,Pe.maximum=Ze),super(te,pe,Ue,Pe),this.minimum=We,this.maximum=Ze}static clampedInt(te,pe,Ue,We){if(typeof te=="undefined")return pe;let Ze=parseInt(te,10);return isNaN(Ze)?pe:(Ze=Math.max(Ue,Ze),Ze=Math.min(We,Ze),Ze|0)}validate(te){return l.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class c extends P{constructor(te,pe,Ue,We,Ze){typeof Ze!="undefined"&&(Ze.type="number",Ze.default=Ue),super(te,pe,Ue,Ze),this.validationFn=We}static clamp(te,pe,Ue){return te<pe?pe:te>Ue?Ue:te}static float(te,pe){if(typeof te=="number")return te;if(typeof te=="undefined")return pe;const Ue=parseFloat(te);return isNaN(Ue)?pe:Ue}validate(te){return this.validationFn(c.float(te,this.defaultValue))}}class S extends P{static string(te,pe){return typeof te!="string"?pe:te}constructor(te,pe,Ue,We=void 0){typeof We!="undefined"&&(We.type="string",We.default=Ue),super(te,pe,Ue,We)}validate(te){return S.string(te,this.defaultValue)}}function w(K,te,pe){return typeof K!="string"||pe.indexOf(K)===-1?te:K}e.stringSet=w;class E extends P{constructor(te,pe,Ue,We,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="string",Ze.enum=We,Ze.default=Ue),super(te,pe,Ue,Ze),this._allowedValues=We}validate(te){return w(te,this.defaultValue,this._allowedValues)}}class d extends C{constructor(te,pe,Ue,We,Ze,Pe,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="string",Ce.enum=Ze,Ce.default=We),super(te,pe,Ue,Ce),this._allowedValues=Ze,this._convert=Pe}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function h(K){switch(K){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,pe,Ue){return Ue===0?te.accessibilitySupport:Ue}}class t extends C{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:g.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertSpace:u(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(K){K[K.Hidden=0]="Hidden",K[K.Blink=1]="Blink",K[K.Smooth=2]="Smooth",K[K.Phase=3]="Phase",K[K.Expand=4]="Expand",K[K.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(K){switch(K){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var n;(function(K){K[K.Line=1]="Line",K[K.Block=2]="Block",K[K.Underline=3]="Underline",K[K.LineThin=4]="LineThin",K[K.BlockOutline=5]="BlockOutline",K[K.UnderlineThin=6]="UnderlineThin"})(n=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(K){switch(K){case n.Line:return"line";case n.Block:return"block";case n.Underline:return"underline";case n.LineThin:return"line-thin";case n.BlockOutline:return"block-outline";case n.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function f(K){switch(K){case"line":return n.Line;case"block":return n.Block;case"underline":return n.Underline;case"line-thin":return n.LineThin;case"block-outline":return n.BlockOutline;case"underline-thin":return n.UnderlineThin}}class m extends i{constructor(){super(125,[63,31])}compute(te,pe,Ue){const We=["monaco-editor"];return pe.get(31)&&We.push(pe.get(31)),te.extraEditorClassName&&We.push(te.extraEditorClassName),pe.get(63)==="default"?We.push("mouse-default"):pe.get(63)==="copy"&&We.push("mouse-copy"),pe.get(98)&&We.push("showUnused"),pe.get(123)&&We.push("showDeprecated"),We.join(" ")}}class b extends p{constructor(){super(30,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(te,pe,Ue){return Ue&&te.emptySelectionClipboard}}class _ extends C{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:te.seedSearchStringFromSelection,description:g.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[g.localize(9,null),g.localize(10,null),g.localize(11,null)],description:g.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:g.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:g.localize(14,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:g.localize(15,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{cursorMoveOnType:u(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:u(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":w(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(pe.loop,this.defaultValue.loop)}}}class o extends C{constructor(){super(41,"fontLigatures",o.OFF,{anyOf:[{type:"boolean",description:g.localize(16,null)},{type:"string",description:g.localize(17,null)}],description:g.localize(18,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?o.OFF:te==="true"?o.ON:te:Boolean(te)?o.ON:o.OFF}}e.EditorFontLigatures=o,o.OFF='"liga" off, "calt" off',o.ON='"liga" on, "calt" on';class A extends i{constructor(){super(40)}compute(te,pe,Ue){return te.fontInfo}}class F extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(19,null)})}validate(te){let pe=c.float(te,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(pe,6,100)}compute(te,pe,Ue){return te.fontInfo.fontSize}}class $ extends C{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:g.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(21,null)})}validate(te){return te==="normal"||te==="bold"?te:String(l.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class W extends C{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[g.localize(22,null),g.localize(23,null),g.localize(24,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(25,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(26,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(27,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:g.localize(28,null),...pe},"editor.gotoLocation.multipleImplementations":{description:g.localize(29,null),...pe},"editor.gotoLocation.multipleReferences":{description:g.localize(30,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:Ue,description:g.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:Ue,description:g.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:Ue,description:g.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:Ue,description:g.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:Ue,description:g.localize(35,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{multiple:w(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??w(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??w(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??w(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??w(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??w(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Q extends C{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(50,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:g.localize(36,null)},"editor.hover.delay":{type:"number",default:te.delay,description:g.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:g.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:u(pe.enabled,this.defaultValue.enabled),delay:l.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:u(pe.sticky,this.defaultValue.sticky)}}}var H;(function(K){K[K.None=0]="None",K[K.Text=1]="Text",K[K.Blocks=2]="Blocks"})(H=e.RenderMinimap||(e.RenderMinimap={}));class N extends i{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(te,pe,Ue){return N.computeLayout(pe,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const pe=te.height/te.lineHeight,Ue=te.scrollBeyondLastLine?pe-1:0,We=(te.viewLineCount+Ue)/(te.pixelRatio*te.height),Ze=Math.floor(te.viewLineCount/We);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:Ue,desiredRatio:We,minimapLineCount:Ze}}static _computeMinimapLayout(te,pe){const Ue=te.outerWidth,We=te.outerHeight,Ze=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*We),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:We};const Pe=pe.stableMinimapLayoutInput,Ce=Pe&&te.outerHeight===Pe.outerHeight&&te.lineHeight===Pe.lineHeight&&te.typicalHalfwidthCharacterWidth===Pe.typicalHalfwidthCharacterWidth&&te.pixelRatio===Pe.pixelRatio&&te.scrollBeyondLastLine===Pe.scrollBeyondLastLine&&te.minimap.enabled===Pe.minimap.enabled&&te.minimap.side===Pe.minimap.side&&te.minimap.size===Pe.minimap.size&&te.minimap.showSlider===Pe.minimap.showSlider&&te.minimap.renderCharacters===Pe.minimap.renderCharacters&&te.minimap.maxColumn===Pe.minimap.maxColumn&&te.minimap.scale===Pe.minimap.scale&&te.verticalScrollbarWidth===Pe.verticalScrollbarWidth&&te.isViewportWrapping===Pe.isViewportWrapping,Ae=te.lineHeight,se=te.typicalHalfwidthCharacterWidth,le=te.scrollBeyondLastLine,me=te.minimap.renderCharacters;let we=Ze>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const q=te.minimap.maxColumn,ge=te.minimap.size,_e=te.minimap.side,Te=te.verticalScrollbarWidth,Oe=te.viewLineCount,Ge=te.remainingWidth,et=te.isViewportWrapping,Qe=me?2:3;let Xe=Math.floor(Ze*We);const lt=Xe/Ze;let ut=!1,Ee=!1,Se=Qe*we,ae=we/Ze,Y=1;if(ge==="fill"||ge==="fit"){const{typicalViewportLineCount:bt,extraLinesBeyondLastLine:wt,desiredRatio:Ct,minimapLineCount:yt}=N.computeContainedMinimapLineCount({viewLineCount:Oe,scrollBeyondLastLine:le,height:We,lineHeight:Ae,pixelRatio:Ze});if(Oe/yt>1)ut=!0,Ee=!0,we=1,Se=1,ae=we/Ze;else{let gt=!1,dt=we+1;if(ge==="fit"){const pt=Math.ceil((Oe+wt)*Se);et&&Ce&&Ge<=pe.stableFitRemainingWidth?(gt=!0,dt=pe.stableFitMaxMinimapScale):gt=pt>Xe}if(ge==="fill"||gt){ut=!0;const pt=we;Se=Math.min(Ae*Ze,Math.max(1,Math.floor(1/Ct))),et&&Ce&&Ge<=pe.stableFitRemainingWidth&&(dt=pe.stableFitMaxMinimapScale),we=Math.min(dt,Math.max(1,Math.floor(Se/Qe))),we>pt&&(Y=Math.min(2,we/pt)),ae=we/Ze/Y,Xe=Math.ceil(Math.max(bt,Oe+wt)*Se),et?(pe.stableMinimapLayoutInput=te,pe.stableFitRemainingWidth=Ge,pe.stableFitMaxMinimapScale=we):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const Be=Math.floor(q*ae),De=Math.min(Be,Math.max(0,Math.floor((Ge-Te-2)*ae/(se+ae)))+e.MINIMAP_GUTTER_WIDTH);let Je=Math.floor(Ze*De);const Ye=Je/Ze;Je=Math.floor(Je*Y);const rt=me?1:2,mt=_e==="left"?0:Ue-De-Te;return{renderMinimap:rt,minimapLeft:mt,minimapWidth:De,minimapHeightIsEditorHeight:ut,minimapIsSampling:Ee,minimapScale:we,minimapLineHeight:Se,minimapCanvasInnerWidth:Je,minimapCanvasInnerHeight:Xe,minimapCanvasOuterWidth:Ye,minimapCanvasOuterHeight:lt}}static computeLayout(te,pe){const Ue=pe.outerWidth|0,We=pe.outerHeight|0,Ze=pe.lineHeight|0,Pe=pe.lineNumbersDigitCount|0,Ce=pe.typicalHalfwidthCharacterWidth,Ae=pe.maxDigitWidth,se=pe.pixelRatio,le=pe.viewLineCount,me=te.get(120),we=me==="inherit"?te.get(119):me,q=we==="inherit"?te.get(115):we,ge=te.get(118),_e=te.get(2),Te=pe.isDominatedByLongLines,Oe=te.get(46),Ge=te.get(57).renderType!==0,et=te.get(58),Qe=te.get(92),Xe=te.get(62),lt=te.get(90),ut=lt.verticalScrollbarSize,Ee=lt.verticalHasArrows,Se=lt.arrowSize,ae=lt.horizontalScrollbarSize,Y=te.get(55),Be=te.get(35);let De;if(typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)){const kt=parseFloat(Y.substr(0,Y.length-2));De=l.clampedInt(kt*Ce,0,0,1e3)}else De=l.clampedInt(Y,0,0,1e3);Be&&(De+=16);let Je=0;if(Ge){const kt=Math.max(Pe,et);Je=Math.round(kt*Ae)}let Ye=0;Oe&&(Ye=Ze);let rt=0,mt=rt+Ye,bt=mt+Je,wt=bt+De;const Ct=Ue-Ye-Je-De;let yt=!1,Tt=!1,gt=-1;_e!==2&&(we==="inherit"&&Te?(yt=!0,Tt=!0):q==="on"||q==="bounded"?Tt=!0:q==="wordWrapColumn"&&(gt=ge));const dt=N._computeMinimapLayout({outerWidth:Ue,outerHeight:We,lineHeight:Ze,typicalHalfwidthCharacterWidth:Ce,pixelRatio:se,scrollBeyondLastLine:Qe,minimap:Xe,verticalScrollbarWidth:ut,viewLineCount:le,remainingWidth:Ct,isViewportWrapping:Tt},pe.memory||new D);dt.renderMinimap!==0&&dt.minimapLeft===0&&(rt+=dt.minimapWidth,mt+=dt.minimapWidth,bt+=dt.minimapWidth,wt+=dt.minimapWidth);const pt=Ct-dt.minimapWidth,Et=Math.max(1,Math.floor((pt-ut-2)/Ce)),At=Ee?Se:0;return Tt&&(gt=Math.max(1,Et),q==="bounded"&&(gt=Math.min(gt,ge))),{width:Ue,height:We,glyphMarginLeft:rt,glyphMarginWidth:Ye,lineNumbersLeft:mt,lineNumbersWidth:Je,decorationsLeft:bt,decorationsWidth:De,contentLeft:wt,contentWidth:pt,minimap:dt,viewportColumn:Et,isWordWrapMinified:yt,isViewportWrapping:Tt,wrappingColumn:gt,verticalScrollbarWidth:ut,horizontalScrollbarHeight:ae,overviewRuler:{top:At,width:ut,height:We-2*At,right:0}}}}e.EditorLayoutInfoComputer=N;class x extends C{constructor(){const te={enabled:!0};super(54,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:g.localize(39,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:u(te.enabled,this.defaultValue.enabled)}}}class L extends C{constructor(){const te={enabled:!0,fontSize:0,fontFamily:""};super(124,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:g.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,markdownDescription:g.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,description:g.localize(42,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:u(pe.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class G extends c{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,te=>c.clamp(te,0,150),{markdownDescription:g.localize(43,null)})}compute(te,pe,Ue){return te.fontInfo.lineHeight}}class M extends C{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:g.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(45,null),g.localize(46,null),g.localize(47,null)],default:te.size,description:g.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:g.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:g.localize(50,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:g.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:g.localize(53,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:u(pe.enabled,this.defaultValue.enabled),size:w(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(pe.side,this.defaultValue.side,["right","left"]),showSlider:w(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(pe.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(pe.scale,1,1,3),maxColumn:l.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function O(K){return K==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class B extends C{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(55,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{top:l.clampedInt(pe.top,0,0,1e3),bottom:l.clampedInt(pe.bottom,0,0,1e3)}}}class z extends C{constructor(){const te={enabled:!0,cycle:!1};super(73,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:g.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:g.localize(57,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:u(pe.enabled,this.defaultValue.enabled),cycle:u(pe.cycle,this.defaultValue.cycle)}}}class J extends i{constructor(){super(126)}compute(te,pe,Ue){return te.pixelRatio}}class ce extends C{constructor(){const te={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:g.localize(58,null)},comments:{type:"boolean",default:te.comments,description:g.localize(59,null)},other:{type:"boolean",default:te.other,description:g.localize(60,null)}}}],default:te,description:g.localize(61,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const pe=te,Ue={other:u(pe.other,this.defaultValue.other),comments:u(pe.comments,this.defaultValue.comments),strings:u(pe.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var ye;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval",K[K.Custom=4]="Custom"})(ye=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Fe extends C{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(62,null),g.localize(63,null),g.localize(64,null),g.localize(65,null)],default:"on",description:g.localize(66,null)})}validate(te){let pe=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(pe=4,Ue=te):te==="interval"?pe=3:te==="relative"?pe=2:te==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ue}}}function Re(K){const te=K.get(85);return te==="editable"?K.get(78):te!=="on"}e.filterValidationDecorations=Re;class Ne extends C{constructor(){const te=[],pe={type:"number",description:g.localize(67,null)};super(89,"rulers",te,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:g.localize(68,null),format:"color-hex"}}}]},default:te,description:g.localize(69,null)})}validate(te){if(Array.isArray(te)){let pe=[];for(let Ue of te)if(typeof Ue=="number")pe.push({column:l.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const We=Ue;pe.push({column:l.clampedInt(We.column,0,0,1e4),color:We.color})}return pe.sort((Ue,We)=>Ue.column-We.column),pe}return this.defaultValue}}function Ve(K,te){if(typeof K!="string")return te;switch(K){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends C{constructor(){const te={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(90,"scrollbar",te,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(70,null),g.localize(71,null),g.localize(72,null)],default:"auto",description:g.localize(73,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(74,null),g.localize(75,null),g.localize(76,null)],default:"auto",description:g.localize(77,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:te.verticalScrollbarSize,description:g.localize(78,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:te.horizontalScrollbarSize,description:g.localize(79,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:te.scrollByPage,description:g.localize(80,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te,Ue=l.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),We=l.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ve(pe.vertical,this.defaultValue.vertical),horizontal:Ve(pe.horizontal,this.defaultValue.horizontal),useShadows:u(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:l.clampedInt(pe.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:We,verticalSliderSize:l.clampedInt(pe.verticalSliderSize,We,0,1e3),scrollByPage:u(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class j extends C{constructor(){const te={enabled:!1,mode:"subwordSmart"};super(52,"inlineSuggest",te,{"editor.inlineSuggest.enabled":{type:"boolean",default:te.enabled,description:g.localize(81,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(82,null),g.localize(83,null),g.localize(84,null)],default:te.mode,description:g.localize(85,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:u(pe.enabled,this.defaultValue.enabled),mode:w(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Z extends C{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(86,null),g.localize(87,null)],default:te.insertMode,description:g.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:g.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:g.localize(90,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:g.localize(91,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:g.localize(92,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:g.localize(93,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:g.localize(94,null)},"editor.suggest.preview":{type:"boolean",default:te.preview,description:g.localize(95,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[g.localize(96,null),g.localize(97,null),g.localize(98,null)],default:te.previewMode,description:g.localize(99,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:g.localize(100,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(101,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(102,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(103,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(104,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(105,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(106,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertMode:w(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:u(pe.showIcons,this.defaultValue.showIcons),showStatusBar:u(pe.showStatusBar,this.defaultValue.showStatusBar),preview:u(pe.preview,this.defaultValue.preview),previewMode:w(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(pe.showMethods,this.defaultValue.showMethods),showFunctions:u(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:u(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:u(pe.showFields,this.defaultValue.showFields),showVariables:u(pe.showVariables,this.defaultValue.showVariables),showClasses:u(pe.showClasses,this.defaultValue.showClasses),showStructs:u(pe.showStructs,this.defaultValue.showStructs),showInterfaces:u(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:u(pe.showModules,this.defaultValue.showModules),showProperties:u(pe.showProperties,this.defaultValue.showProperties),showEvents:u(pe.showEvents,this.defaultValue.showEvents),showOperators:u(pe.showOperators,this.defaultValue.showOperators),showUnits:u(pe.showUnits,this.defaultValue.showUnits),showValues:u(pe.showValues,this.defaultValue.showValues),showConstants:u(pe.showConstants,this.defaultValue.showConstants),showEnums:u(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:u(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(pe.showKeywords,this.defaultValue.showKeywords),showWords:u(pe.showWords,this.defaultValue.showWords),showColors:u(pe.showColors,this.defaultValue.showColors),showFiles:u(pe.showFiles,this.defaultValue.showFiles),showReferences:u(pe.showReferences,this.defaultValue.showReferences),showFolders:u(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:u(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(pe.showSnippets,this.defaultValue.showSnippets),showUsers:u(pe.showUsers,this.defaultValue.showUsers),showIssues:u(pe.showIssues,this.defaultValue.showIssues)}}}class ie extends C{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(132,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class oe extends i{constructor(){super(127,[78])}compute(te,pe,Ue){return pe.get(78)?!0:te.tabFocusMode}}var ve;(function(K){K[K.None=0]="None",K[K.Same=1]="Same",K[K.Indent=2]="Indent",K[K.DeepIndent=3]="DeepIndent"})(ve=e.WrappingIndent||(e.WrappingIndent={}));function ee(K){switch(K){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ue extends i{constructor(){super(129,[128])}compute(te,pe,Ue){const We=pe.get(128);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:We.isWordWrapMinified,isViewportWrapping:We.isViewportWrapping,wrappingColumn:We.wrappingColumn}}}const Ie="Consolas, 'Courier New', monospace",$e="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?$e:R.isLinux?qe:Ie,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(K){return e.editorOptionsRegistry[K.id]=K,K}var tt;(function(K){K[K.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",K[K.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",K[K.accessibilitySupport=2]="accessibilitySupport",K[K.accessibilityPageSize=3]="accessibilityPageSize",K[K.ariaLabel=4]="ariaLabel",K[K.autoClosingBrackets=5]="autoClosingBrackets",K[K.autoClosingDelete=6]="autoClosingDelete",K[K.autoClosingOvertype=7]="autoClosingOvertype",K[K.autoClosingQuotes=8]="autoClosingQuotes",K[K.autoIndent=9]="autoIndent",K[K.automaticLayout=10]="automaticLayout",K[K.autoSurround=11]="autoSurround",K[K.codeLens=12]="codeLens",K[K.codeLensFontFamily=13]="codeLensFontFamily",K[K.codeLensFontSize=14]="codeLensFontSize",K[K.colorDecorators=15]="colorDecorators",K[K.columnSelection=16]="columnSelection",K[K.comments=17]="comments",K[K.contextmenu=18]="contextmenu",K[K.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",K[K.cursorBlinking=20]="cursorBlinking",K[K.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",K[K.cursorStyle=22]="cursorStyle",K[K.cursorSurroundingLines=23]="cursorSurroundingLines",K[K.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",K[K.cursorWidth=25]="cursorWidth",K[K.disableLayerHinting=26]="disableLayerHinting",K[K.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",K[K.domReadOnly=28]="domReadOnly",K[K.dragAndDrop=29]="dragAndDrop",K[K.emptySelectionClipboard=30]="emptySelectionClipboard",K[K.extraEditorClassName=31]="extraEditorClassName",K[K.fastScrollSensitivity=32]="fastScrollSensitivity",K[K.find=33]="find",K[K.fixedOverflowWidgets=34]="fixedOverflowWidgets",K[K.folding=35]="folding",K[K.foldingStrategy=36]="foldingStrategy",K[K.foldingHighlight=37]="foldingHighlight",K[K.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",K[K.fontFamily=39]="fontFamily",K[K.fontInfo=40]="fontInfo",K[K.fontLigatures=41]="fontLigatures",K[K.fontSize=42]="fontSize",K[K.fontWeight=43]="fontWeight",K[K.formatOnPaste=44]="formatOnPaste",K[K.formatOnType=45]="formatOnType",K[K.glyphMargin=46]="glyphMargin",K[K.gotoLocation=47]="gotoLocation",K[K.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",K[K.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",K[K.hover=50]="hover",K[K.inDiffEditor=51]="inDiffEditor",K[K.inlineSuggest=52]="inlineSuggest",K[K.letterSpacing=53]="letterSpacing",K[K.lightbulb=54]="lightbulb",K[K.lineDecorationsWidth=55]="lineDecorationsWidth",K[K.lineHeight=56]="lineHeight",K[K.lineNumbers=57]="lineNumbers",K[K.lineNumbersMinChars=58]="lineNumbersMinChars",K[K.linkedEditing=59]="linkedEditing",K[K.links=60]="links",K[K.matchBrackets=61]="matchBrackets",K[K.minimap=62]="minimap",K[K.mouseStyle=63]="mouseStyle",K[K.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",K[K.mouseWheelZoom=65]="mouseWheelZoom",K[K.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",K[K.multiCursorModifier=67]="multiCursorModifier",K[K.multiCursorPaste=68]="multiCursorPaste",K[K.occurrencesHighlight=69]="occurrencesHighlight",K[K.overviewRulerBorder=70]="overviewRulerBorder",K[K.overviewRulerLanes=71]="overviewRulerLanes",K[K.padding=72]="padding",K[K.parameterHints=73]="parameterHints",K[K.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",K[K.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",K[K.quickSuggestions=76]="quickSuggestions",K[K.quickSuggestionsDelay=77]="quickSuggestionsDelay",K[K.readOnly=78]="readOnly",K[K.renameOnType=79]="renameOnType",K[K.renderControlCharacters=80]="renderControlCharacters",K[K.renderIndentGuides=81]="renderIndentGuides",K[K.renderFinalNewline=82]="renderFinalNewline",K[K.renderLineHighlight=83]="renderLineHighlight",K[K.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",K[K.renderValidationDecorations=85]="renderValidationDecorations",K[K.renderWhitespace=86]="renderWhitespace",K[K.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",K[K.roundedSelection=88]="roundedSelection",K[K.rulers=89]="rulers",K[K.scrollbar=90]="scrollbar",K[K.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",K[K.scrollBeyondLastLine=92]="scrollBeyondLastLine",K[K.scrollPredominantAxis=93]="scrollPredominantAxis",K[K.selectionClipboard=94]="selectionClipboard",K[K.selectionHighlight=95]="selectionHighlight",K[K.selectOnLineNumbers=96]="selectOnLineNumbers",K[K.showFoldingControls=97]="showFoldingControls",K[K.showUnused=98]="showUnused",K[K.snippetSuggestions=99]="snippetSuggestions",K[K.smartSelect=100]="smartSelect",K[K.smoothScrolling=101]="smoothScrolling",K[K.stickyTabStops=102]="stickyTabStops",K[K.stopRenderingLineAfter=103]="stopRenderingLineAfter",K[K.suggest=104]="suggest",K[K.suggestFontSize=105]="suggestFontSize",K[K.suggestLineHeight=106]="suggestLineHeight",K[K.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",K[K.suggestSelection=108]="suggestSelection",K[K.tabCompletion=109]="tabCompletion",K[K.tabIndex=110]="tabIndex",K[K.unusualLineTerminators=111]="unusualLineTerminators",K[K.useShadowDOM=112]="useShadowDOM",K[K.useTabStops=113]="useTabStops",K[K.wordSeparators=114]="wordSeparators",K[K.wordWrap=115]="wordWrap",K[K.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",K[K.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",K[K.wordWrapColumn=118]="wordWrapColumn",K[K.wordWrapOverride1=119]="wordWrapOverride1",K[K.wordWrapOverride2=120]="wordWrapOverride2",K[K.wrappingIndent=121]="wrappingIndent",K[K.wrappingStrategy=122]="wrappingStrategy",K[K.showDeprecated=123]="showDeprecated",K[K.inlayHints=124]="inlayHints",K[K.editorClassName=125]="editorClassName",K[K.pixelRatio=126]="pixelRatio",K[K.tabFocusMode=127]="tabFocusMode",K[K.layoutInfo=128]="layoutInfo",K[K.wrappingInfo=129]="wrappingInfo"})(tt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new p(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(133,null)})),acceptSuggestionOnEnter:be(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(134,null),""],markdownDescription:g.localize(135,null)})),accessibilitySupport:be(new v),accessibilityPageSize:be(new l(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(136,null)})),ariaLabel:be(new S(4,"ariaLabel",g.localize(137,null))),autoClosingBrackets:be(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(138,null),g.localize(139,null),""],description:g.localize(140,null)})),autoClosingDelete:be(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(141,null),""],description:g.localize(142,null)})),autoClosingOvertype:be(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(143,null),""],description:g.localize(144,null)})),autoClosingQuotes:be(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(145,null),g.localize(146,null),""],description:g.localize(147,null)})),autoIndent:be(new d(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[g.localize(148,null),g.localize(149,null),g.localize(150,null),g.localize(151,null),g.localize(152,null)],description:g.localize(153,null)})),automaticLayout:be(new p(10,"automaticLayout",!1)),autoSurround:be(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(154,null),g.localize(155,null),g.localize(156,null),""],description:g.localize(157,null)})),stickyTabStops:be(new p(102,"stickyTabStops",!1,{description:g.localize(158,null)})),codeLens:be(new p(12,"codeLens",!0,{description:g.localize(159,null)})),codeLensFontFamily:be(new S(13,"codeLensFontFamily","",{description:g.localize(160,null)})),codeLensFontSize:be(new l(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(161,null)})),colorDecorators:be(new p(15,"colorDecorators",!0,{description:g.localize(162,null)})),columnSelection:be(new p(16,"columnSelection",!1,{description:g.localize(163,null)})),comments:be(new t),contextmenu:be(new p(18,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new p(19,"copyWithSyntaxHighlighting",!0,{description:g.localize(164,null)})),cursorBlinking:be(new d(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:g.localize(165,null)})),cursorSmoothCaretAnimation:be(new p(21,"cursorSmoothCaretAnimation",!1,{description:g.localize(166,null)})),cursorStyle:be(new d(22,"cursorStyle",n.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],f,{description:g.localize(167,null)})),cursorSurroundingLines:be(new l(23,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(168,null)})),cursorSurroundingLinesStyle:be(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(169,null),g.localize(170,null)],description:g.localize(171,null)})),cursorWidth:be(new l(25,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(172,null)})),disableLayerHinting:be(new p(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new p(27,"disableMonospaceOptimizations",!1)),domReadOnly:be(new p(28,"domReadOnly",!1)),dragAndDrop:be(new p(29,"dragAndDrop",!0,{description:g.localize(173,null)})),emptySelectionClipboard:be(new b),extraEditorClassName:be(new S(31,"extraEditorClassName","")),fastScrollSensitivity:be(new c(32,"fastScrollSensitivity",5,K=>K<=0?5:K,{markdownDescription:g.localize(174,null)})),find:be(new _),fixedOverflowWidgets:be(new p(34,"fixedOverflowWidgets",!1)),folding:be(new p(35,"folding",!0,{description:g.localize(175,null)})),foldingStrategy:be(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(176,null),g.localize(177,null)],description:g.localize(178,null)})),foldingHighlight:be(new p(37,"foldingHighlight",!0,{description:g.localize(179,null)})),unfoldOnClickAfterEndOfLine:be(new p(38,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(180,null)})),fontFamily:be(new S(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(181,null)})),fontInfo:be(new A),fontLigatures2:be(new o),fontSize:be(new F),fontWeight:be(new $),formatOnPaste:be(new p(44,"formatOnPaste",!1,{description:g.localize(182,null)})),formatOnType:be(new p(45,"formatOnType",!1,{description:g.localize(183,null)})),glyphMargin:be(new p(46,"glyphMargin",!0,{description:g.localize(184,null)})),gotoLocation:be(new W),hideCursorInOverviewRuler:be(new p(48,"hideCursorInOverviewRuler",!1,{description:g.localize(185,null)})),highlightActiveIndentGuide:be(new p(49,"highlightActiveIndentGuide",!0,{description:g.localize(186,null)})),hover:be(new Q),inDiffEditor:be(new p(51,"inDiffEditor",!1)),letterSpacing:be(new c(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,K=>c.clamp(K,-5,20),{description:g.localize(187,null)})),lightbulb:be(new x),lineDecorationsWidth:be(new P(55,"lineDecorationsWidth",10)),lineHeight:be(new G),lineNumbers:be(new Fe),lineNumbersMinChars:be(new l(58,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new p(59,"linkedEditing",!1,{description:g.localize(188,null)})),links:be(new p(60,"links",!0,{description:g.localize(189,null)})),matchBrackets:be(new E(61,"matchBrackets","always",["always","near","never"],{description:g.localize(190,null)})),minimap:be(new M),mouseStyle:be(new E(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new c(64,"mouseWheelScrollSensitivity",1,K=>K===0?1:K,{markdownDescription:g.localize(191,null)})),mouseWheelZoom:be(new p(65,"mouseWheelZoom",!1,{markdownDescription:g.localize(192,null)})),multiCursorMergeOverlapping:be(new p(66,"multiCursorMergeOverlapping",!0,{description:g.localize(193,null)})),multiCursorModifier:be(new d(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],O,{markdownEnumDescriptions:[g.localize(194,null),g.localize(195,null)],markdownDescription:g.localize(196,null)})),multiCursorPaste:be(new E(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(197,null),g.localize(198,null)],markdownDescription:g.localize(199,null)})),occurrencesHighlight:be(new p(69,"occurrencesHighlight",!0,{description:g.localize(200,null)})),overviewRulerBorder:be(new p(70,"overviewRulerBorder",!0,{description:g.localize(201,null)})),overviewRulerLanes:be(new l(71,"overviewRulerLanes",3,0,3)),padding:be(new B),parameterHints:be(new z),peekWidgetDefaultFocus:be(new E(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(202,null),g.localize(203,null)],description:g.localize(204,null)})),definitionLinkOpensInPeek:be(new p(75,"definitionLinkOpensInPeek",!1,{description:g.localize(205,null)})),quickSuggestions:be(new ce),quickSuggestionsDelay:be(new l(77,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(206,null)})),readOnly:be(new p(78,"readOnly",!1)),renameOnType:be(new p(79,"renameOnType",!1,{description:g.localize(207,null),markdownDeprecationMessage:g.localize(208,null)})),renderControlCharacters:be(new p(80,"renderControlCharacters",!1,{description:g.localize(209,null)})),renderIndentGuides:be(new p(81,"renderIndentGuides",!0,{description:g.localize(210,null)})),renderFinalNewline:be(new p(82,"renderFinalNewline",!0,{description:g.localize(211,null)})),renderLineHighlight:be(new E(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(212,null)],description:g.localize(213,null)})),renderLineHighlightOnlyWhenFocus:be(new p(84,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(214,null)})),renderValidationDecorations:be(new E(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new E(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(215,null),g.localize(216,null),g.localize(217,null),""],description:g.localize(218,null)})),revealHorizontalRightPadding:be(new l(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new p(88,"roundedSelection",!0,{description:g.localize(219,null)})),rulers:be(new Ne),scrollbar:be(new ze),scrollBeyondLastColumn:be(new l(91,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(220,null)})),scrollBeyondLastLine:be(new p(92,"scrollBeyondLastLine",!0,{description:g.localize(221,null)})),scrollPredominantAxis:be(new p(93,"scrollPredominantAxis",!0,{description:g.localize(222,null)})),selectionClipboard:be(new p(94,"selectionClipboard",!0,{description:g.localize(223,null),included:R.isLinux})),selectionHighlight:be(new p(95,"selectionHighlight",!0,{description:g.localize(224,null)})),selectOnLineNumbers:be(new p(96,"selectOnLineNumbers",!0)),showFoldingControls:be(new E(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(225,null),g.localize(226,null)],description:g.localize(227,null)})),showUnused:be(new p(98,"showUnused",!0,{description:g.localize(228,null)})),showDeprecated:be(new p(123,"showDeprecated",!0,{description:g.localize(229,null)})),inlayHints:be(new L),snippetSuggestions:be(new E(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(230,null),g.localize(231,null),g.localize(232,null),g.localize(233,null)],description:g.localize(234,null)})),smartSelect:be(new ie),smoothScrolling:be(new p(101,"smoothScrolling",!1,{description:g.localize(235,null)})),stopRenderingLineAfter:be(new l(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new Z),inlineSuggest:be(new j),suggestFontSize:be(new l(105,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(236,null)})),suggestLineHeight:be(new l(106,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(237,null)})),suggestOnTriggerCharacters:be(new p(107,"suggestOnTriggerCharacters",!0,{description:g.localize(238,null)})),suggestSelection:be(new E(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(239,null),g.localize(240,null),g.localize(241,null)],description:g.localize(242,null)})),tabCompletion:be(new E(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(243,null),g.localize(244,null),g.localize(245,null)],description:g.localize(246,null)})),tabIndex:be(new l(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new E(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(247,null),g.localize(248,null),g.localize(249,null)],description:g.localize(250,null)})),useShadowDOM:be(new p(112,"useShadowDOM",!0)),useTabStops:be(new p(113,"useTabStops",!0,{description:g.localize(251,null)})),wordSeparators:be(new S(114,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:g.localize(252,null)})),wordWrap:be(new E(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(253,null),g.localize(254,null),g.localize(255,null),g.localize(256,null)],description:g.localize(257,null)})),wordWrapBreakAfterCharacters:be(new S(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new S(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new l(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(258,null)})),wordWrapOverride1:be(new E(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new E(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new d(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ee,{enumDescriptions:[g.localize(259,null),g.localize(260,null),g.localize(261,null),g.localize(262,null)],description:g.localize(263,null)})),wrappingStrategy:be(new E(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(264,null),g.localize(265,null)],description:g.localize(266,null)})),editorClassName:be(new m),pixelRatio:be(new J),tabFocusMode:be(new oe),layoutInfo:be(new N),wrappingInfo:be(new ue)}}),define(he[152],fe([19,20]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(he[153],fe([19,20]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(he[154],fe([19,20]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(he[155],fe([19,20]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(he[156],fe([19,20]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(he[157],fe([19,20]),function(X,e){return X.create("vs/platform/markers/common/markers",e)}),define(he[158],fe([19,20]),function(X,e){return X.create("vs/platform/workspaces/common/workspaces",e)}),define(he[159],fe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(he[160],fe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostExtensionService",e)}),define(he[161],fe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostProgress",e)}),define(he[162],fe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostStatusBar",e)}),define(he[163],fe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTerminalService",e)}),define(he[164],fe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTreeViews",e)}),define(he[165],fe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostWorkspace",e)}),define(he[166],fe([19,20]),function(X,e){return X.create("vs/workbench/api/node/extHostDebugService",e)}),define(he[167],fe([19,20]),function(X,e){return X.create("vs/workbench/common/editor",e)}),define(he[168],fe([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(he[169],fe([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(he[170],fe([19,20]),function(X,e){return X.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(he[171],fe([19,20]),function(X,e){return X.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(he[172],fe([19,20]),function(X,e){return X.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(he[173],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var R;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(R=e.EditorResolution||(e.EditorResolution={}));var k;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var y;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(y=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(he[174],fe([0,1,154]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function y(u){return u=u.trim(),u==="*"||R.test(u)}e.isValidVersionStr=y;function T(u){if(!y(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=u.match(R);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=T;function I(u){if(!u)return null;let p=u.majorBase,l=u.majorMustEqual,c=u.minorBase,S=u.minorMustEqual,w=u.patchBase,E=u.patchMustEqual;u.hasCaret&&(p===0||(S=!1),E=!1);let d=0;if(u.preRelease){const h=k.exec(u.preRelease);if(h){const[,v,t,s]=h;d=Date.UTC(Number(v),Number(t)-1,Number(s))}}return{majorBase:p,majorMustEqual:l,minorBase:c,minorMustEqual:S,patchBase:w,patchMustEqual:E,isMinimum:u.hasGreaterEquals,notBefore:d}}e.normalizeVersion=I;function D(u,p,l){let c;typeof u=="string"?c=I(T(u)):c=u;let S;p instanceof Date?S=p.getTime():typeof p=="string"&&(S=new Date(p).getTime());let w;if(typeof l=="string"?w=I(T(l)):w=l,!c||!w)return!1;let E=c.majorBase,d=c.minorBase,h=c.patchBase,v=w.majorBase,t=w.minorBase,s=w.patchBase,r=w.notBefore,n=w.majorMustEqual,a=w.minorMustEqual,f=w.patchMustEqual;return w.isMinimum?E>v?!0:E<v?!1:d>t?!0:d<t||S&&S<r?!1:h>=s:(E===1&&v===0&&(!n||!a||!f)&&(v=1,t=0,s=0,n=!0,a=!1,f=!1),E<v?!1:E>v?!n:d<t?!1:d>t?!a:h<s?!1:h>s?!f:!(S&&S<r))}e.isValidVersion=D;function C(u,p,l,c){return l.isBuiltin||typeof l.main=="undefined"?!0:P(u,p,l.engines.vscode,c)}e.isValidExtensionVersion=C;function i(u,p,l){return u==="*"||P(p,l,u)}e.isEngineValid=i;function P(u,p,l,c=[]){let S=I(T(l));if(!S)return c.push(g.localize(0,null,l)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return c.push(g.localize(1,null,l)),!1}else if(!S.majorMustEqual)return c.push(g.localize(2,null,l)),!1;return D(u,p,S)?!0:(c.push(g.localize(3,null,u,l)),!1)}}),define(he[111],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(k,y=[],T=!1){this.ctor=k,this.staticArguments=y,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=g}),define(he[78],fe([0,1,111]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function k(T,I,D){I instanceof g.SyncDescriptor||(I=new g.SyncDescriptor(I,[],D)),R.push([T,I])}e.registerSingleton=k;function y(){return R}e.getSingletonServiceDescriptors=y}),define(he[175],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=g;class R{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let T of this._nodes.values())T.outgoing.size===0&&y.push(T);return y}insertEdge(y,T){const I=this.lookupOrInsertNode(y),D=this.lookupOrInsertNode(T);I.outgoing.set(this._hashFn(T),D),D.incoming.set(this._hashFn(y),I)}removeNode(y){const T=this._hashFn(y);this._nodes.delete(T);for(let I of this._nodes.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(y){const T=this._hashFn(y);let I=this._nodes.get(T);return I||(I=new g(y),this._nodes.set(T,I)),I}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[T,I]of this._nodes)y.push(`${T}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,T]of this._nodes){const I=new Set([y]),D=this._findCycle(T,I);if(D)return D}}_findCycle(y,T){for(let[I,D]of y.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const C=this._findCycle(D,T);if(C)return C;T.delete(I)}}}e.Graph=R}),define(he[4],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function D(C){return C[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=D})(g=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function R(I,D,C,i){D[g.DI_TARGET]===D?D[g.DI_DEPENDENCIES].push({id:I,index:C,optional:i}):(D[g.DI_DEPENDENCIES]=[{id:I,index:C,optional:i}],D[g.DI_TARGET]=D)}function k(I){if(g.serviceIds.has(I))return g.serviceIds.get(I);const D=function(C,i,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(D,C,P,!1)};return D.toString=()=>I,g.serviceIds.set(I,D),D}e.createDecorator=k;function y(I){return I}e.refineServiceDecorator=y;function T(I){return function(D,C,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(I,D,i,!0)}}e.optional=T}),define(he[176],fe([0,1,4]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function R(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(he[177],fe([0,1,3,74,6,23,72,77,176]),function(X,e,g,R,k,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(u){return typeof u=="string"?!1:Array.isArray(u)?u.every(C):!!u.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(p,l){let c={selector:p,provider:l,_score:-1,_time:this._clock++};return this._entries.push(c),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,k.toDisposable)(()=>{if(c){let S=this._entries.indexOf(c);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),c=void 0)}})}has(p){return this.all(p).length>0}all(p){if(!p)return[];this._updateScores(p);const l=[];for(let c of this._entries)c._score>0&&l.push(c.provider);return l}ordered(p){const l=[];return this._orderedForEach(p,c=>l.push(c.provider)),l}orderedGroups(p){const l=[];let c,S;return this._orderedForEach(p,w=>{c&&S===w._score?c.push(w.provider):(S=w._score,c=[w.provider],l.push(c))}),l}_orderedForEach(p,l){if(!!p){this._updateScores(p);for(const c of this._entries)c._score>0&&l(c)}}_updateScores(p){let l={uri:p.uri.toString(),language:p.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===l.language&&this._lastCandidate.uri===l.uri)){this._lastCandidate=l;for(let c of this._entries)if(c._score=(0,I.score)(c.selector,p.uri,p.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(p)),C(c.selector)&&c._score>0){for(let S of this._entries)S._score=0;c._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(p,l){return p._score<l._score?1:p._score>l._score?-1:p._time<l._time?1:p._time>l._time?-1:0}}e.LanguageFeatureRegistry=i;class P{constructor(p,l,c=Number.MAX_SAFE_INTEGER){this._registry=p,this.min=l,this.max=c,this._cache=new y.LRUCache(50,.7)}_key(p){return p.id+(0,R.hash)(this._registry.all(p))}_clamp(p){return p===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(p*1.3)))}get(p){const l=this._key(p),c=this._cache.get(l);return this._clamp(c?.value)}update(p,l){const c=this._key(p);let S=this._cache.get(c);return S||(S=new T.MovingAverage,this._cache.set(c,S)),S.update(l),this.get(p)}}e.LanguageFeatureRequestDelays=P}),define(he[79],fe([0,1,2,40,177,144,73]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var I;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));class D{constructor(A,F){this.language=A,this.id=F}}e.LanguageIdentifier=D;var C;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var i;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var P;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var u;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(u=e.MetadataConsts||(e.MetadataConsts={}));class p{static getLanguageId(A){return(A&255)>>>0}static getTokenType(A){return(A&1792)>>>8}static getFontStyle(A){return(A&14336)>>>11}static getForeground(A){return(A&8372224)>>>14}static getBackground(A){return(A&4286578688)>>>23}static getClassNameFromMetadata(A){let F=this.getForeground(A),$="mtk"+F,W=this.getFontStyle(A);return W&1&&($+=" mtki"),W&2&&($+=" mtkb"),W&4&&($+=" mtku"),$}static getInlineStyleFromMetadata(A,F){const $=this.getForeground(A),W=this.getFontStyle(A);let Q=`color: ${F[$]};`;return W&1&&(Q+="font-style: italic;"),W&2&&(Q+="font-weight: bold;"),W&4&&(Q+="text-decoration: underline;"),Q}}e.TokenMetadata=p;var l;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(l=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(A){const F=o[A];let $=F&&T.iconRegistry.get(F);return $||(console.info("No codicon found for CompletionItemKind "+A),$=T.Codicon.symbolProperty),$.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(A,F){let $=o[A];return typeof $=="undefined"&&!F&&($=9),$}}();var c;(function(o){o[o.Deprecated=1]="Deprecated"})(c=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var d;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(d=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var v;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(v=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&g.URI.isUri(o.uri)&&R.Range.isIRange(o.range)&&(R.Range.isIRange(o.originSelectionRange)||R.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var s;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var r;(function(o){o[o.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var n;(function(o){const A=new Map;A.set("file",0),A.set("module",1),A.set("namespace",2),A.set("package",3),A.set("class",4),A.set("method",5),A.set("property",6),A.set("field",7),A.set("constructor",8),A.set("enum",9),A.set("interface",10),A.set("function",11),A.set("variable",12),A.set("constant",13),A.set("string",14),A.set("number",15),A.set("boolean",16),A.set("array",17),A.set("object",18),A.set("key",19),A.set("null",20),A.set("enum-member",21),A.set("struct",22),A.set("event",23),A.set("operator",24),A.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function $(H){return A.get(H)}o.fromString=$;function W(H){return F.get(H)}o.toString=W;function Q(H,N){const x=F.get(H);let L=x&&T.iconRegistry.get("symbol-"+x);return L||(console.info("No codicon found for SymbolKind "+H),L=T.Codicon.symbolProperty),`${N?"inline":"block"} ${L.classNames}`}o.toCssClassName=Q})(n=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(A){this.value=A}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var f;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(f=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var b;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var _;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(_=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(he[80],fe([0,1,8,4,11]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=k.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",k.isMacintosh),T.set("isLinux",k.isLinux),T.set("isWindows",k.isWindows),T.set("isWeb",k.isWeb),T.set("isMacNative",k.isMacintosh&&!k.isWeb),T.set("isEdge",y.indexOf("Edg/")>=0),T.set("isFirefox",y.indexOf("Firefox")>=0),T.set("isChrome",y.indexOf("Chrome")>=0),T.set("isSafari",y.indexOf("Safari")>=0);const I=Object.prototype.hasOwnProperty;var D;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return P.INSTANCE}static true(){return u.INSTANCE}static has(o){return p.create(o)}static equals(o,A){return l.create(o,A)}static notEquals(o,A){return w.create(o,A)}static regex(o,A){return s.create(o,A)}static in(o,A){return c.create(o,A)}static not(o){return E.create(o)}static and(...o){return n.create(o)}static or(...o){return a.create(o)}static greater(o,A){return d.create(o,A)}static less(o,A){return v.create(o,A)}static deserialize(o,A=!1){if(!!o)return this._deserializeOrExpression(o,A)}static _deserializeOrExpression(o,A){let F=o.split("||");return a.create(F.map($=>this._deserializeAndExpression($,A)))}static _deserializeAndExpression(o,A){let F=o.split("&&");return n.create(F.map($=>this._deserializeOne($,A)))}static _deserializeOne(o,A){if(o=o.trim(),o.indexOf("!=")>=0){let F=o.split("!=");return w.create(F[0].trim(),this._deserializeValue(F[1],A))}if(o.indexOf("==")>=0){let F=o.split("==");return l.create(F[0].trim(),this._deserializeValue(F[1],A))}if(o.indexOf("=~")>=0){let F=o.split("=~");return s.create(F[0].trim(),this._deserializeRegexValue(F[1],A))}if(o.indexOf(" in ")>=0){let F=o.split(" in ");return c.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const F=o.split(">=");return h.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const F=o.split(">");return d.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const F=o.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const F=o.split("<");return v.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(o)?E.create(o.substr(1).trim()):p.create(o)}static _deserializeValue(o,A){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let F=/^'([^']*)'$/.exec(o);return F?F[1].trim():o}static _deserializeRegexValue(o,A){if((0,g.isFalsyOrWhitespace)(o)){if(A)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=o.indexOf("/"),$=o.lastIndexOf("/");if(F===$||F<0){if(A)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let W=o.slice(F+1,$),Q=o[$+1]==="i"?"i":"";try{return new RegExp(W,Q)}catch(H){if(A)throw new Error(`bad regexp-value '${o}', parse error: ${H}`);return console.warn(`bad regexp-value '${o}', parse error: ${H}`),null}}}e.ContextKeyExpr=C;function i(_,o){return _.cmp(o)}class P{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class u{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=u,u.INSTANCE=new u;class p{constructor(o){this.key=o,this.type=2}static create(o){const A=T.get(o);return typeof A=="boolean"?A?u.INSTANCE:P.INSTANCE:new p(o)}cmp(o){return o.type!==this.type?this.type-o.type:m(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=p;class l{constructor(o,A){this.key=o,this.value=A,this.type=4}static create(o,A){if(typeof A=="boolean")return A?p.create(o):E.create(o);const F=T.get(o);return typeof F=="boolean"?A===(F?"true":"false")?u.INSTANCE:P.INSTANCE:new l(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=l;class c{constructor(o,A){this.key=o,this.valueKey=A,this.type=10}static create(o,A){return new c(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const A=o.getValue(this.valueKey),F=o.getValue(this.key);return Array.isArray(A)?A.indexOf(F)>=0:typeof F=="string"&&typeof A=="object"&&A!==null?I.call(A,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=c;class S{constructor(o){this._actual=o,this.type=11}static create(o){return new S(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new S(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class w{constructor(o,A){this.key=o,this.value=A,this.type=5}static create(o,A){if(typeof A=="boolean")return A?E.create(o):p.create(o);const F=T.get(o);return typeof F=="boolean"?A===(F?"true":"false")?P.INSTANCE:u.INSTANCE:new w(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class E{constructor(o){this.key=o,this.type=3}static create(o){const A=T.get(o);return typeof A=="boolean"?A?P.INSTANCE:u.INSTANCE:new E(o)}cmp(o){return o.type!==this.type?this.type-o.type:m(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return p.create(this.key)}}e.ContextKeyNotExpr=E;class d{constructor(o,A){this.key=o,this.value=A,this.type=12}static create(o,A){return new d(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class h{constructor(o,A){this.key=o,this.value=A,this.type=13}static create(o,A){return new h(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=h;class v{constructor(o,A){this.key=o,this.value=A,this.type=14}static create(o,A){return new v(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeySmallerExpr=v;class t{constructor(o,A){this.key=o,this.value=A,this.type=15}static create(o,A){return new t(o,A)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(o,A){this.key=o,this.regexp=A,this.type=7}static create(o,A){return new s(o,A)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const A=this.regexp?this.regexp.source:"",F=o.regexp?o.regexp.source:"";return A<F?-1:A>F?1:0}equals(o){if(o.type===this.type){const A=this.regexp?this.regexp.source:"",F=o.regexp?o.regexp.source:"";return this.key===o.key&&A===F}return!1}evaluate(o){let A=o.getValue(this.key);return this.regexp?this.regexp.test(A):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return r.create(this)}}e.ContextKeyRegexExpr=s;class r{constructor(o){this._actual=o,this.type=8}static create(o){return new r(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new r(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class n{constructor(o){this.expr=o,this.type=6}static create(o){return n._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let A=0,F=this.expr.length;A<F;A++){const $=i(this.expr[A],o.expr[A]);if($!==0)return $}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].equals(o.expr[A]))return!1;return!0}return!1}evaluate(o){for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].evaluate(o))return!1;return!0}static _normalizeArr(o){const A=[];let F=!1;for(const $ of o)if(!!$){if($.type===1){F=!0;continue}if($.type===0)return P.INSTANCE;if($.type===6){A.push(...$.expr);continue}A.push($)}if(A.length===0&&F)return u.INSTANCE;if(A.length!==0){if(A.length===1)return A[0];for(A.sort(i);A.length>1;){const $=A[A.length-1];if($.type!==9)break;A.pop();const W=A.pop(),Q=a.create($.expr.map(H=>n.create([H,W])));Q&&(A.push(Q),A.sort(i))}return A.length===1?A[0]:new n(A)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let A of this.expr)o.push(...A.keys());return o}map(o){return new n(this.expr.map(A=>A.map(o)))}negate(){let o=[];for(let A of this.expr)o.push(A.negate());return a.create(o)}}e.ContextKeyAndExpr=n;class a{constructor(o){this.expr=o,this.type=9}static create(o){const A=a._normalizeArr(o);if(A.length!==0)return A.length===1?A[0]:new a(A)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let A=0,F=this.expr.length;A<F;A++){const $=i(this.expr[A],o.expr[A]);if($!==0)return $}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let A=0,F=this.expr.length;A<F;A++)if(!this.expr[A].equals(o.expr[A]))return!1;return!0}return!1}evaluate(o){for(let A=0,F=this.expr.length;A<F;A++)if(this.expr[A].evaluate(o))return!0;return!1}static _normalizeArr(o){let A=[],F=!1;if(o){for(let $=0,W=o.length;$<W;$++){const Q=o[$];if(!!Q){if(Q.type===0){F=!0;continue}if(Q.type===1)return[u.INSTANCE];if(Q.type===9){A=A.concat(Q.expr);continue}A.push(Q)}}if(A.length===0&&F)return[P.INSTANCE];A.sort(i)}return A}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let A of this.expr)o.push(...A.keys());return o}map(o){return new a(this.expr.map(A=>A.map(o)))}negate(){let o=[];for(let F of this.expr)o.push(F.negate());const A=F=>F.type===9?F.expr:[F];for(;o.length>1;){const F=o.shift(),$=o.shift(),W=[];for(const Q of A(F))for(const H of A($))W.push(C.and(Q,H));o.unshift(C.or(...W))}return o[0]}}e.ContextKeyOrExpr=a;class f extends p{constructor(o,A,F){super(o);this._defaultValue=A,typeof F=="object"?f._info.push({...F,key:o}):F!==!0&&f._info.push({key:o,description:F,type:A!=null?typeof A:void 0})}static all(){return f._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(o){return C.equals(this.key,o)}notEqualsTo(o){return C.notEquals(this.key,o)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(_,o){return _<o?-1:_>o?1:0}function b(_,o,A,F){return _<A?-1:_>A?1:o<F?-1:o>F?1:0}}),define(he[178],fe([0,1,4]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(he[179],fe([0,1,153,4,10]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(P){return P&&typeof P=="object"&&typeof P.id=="string"&&(!P.uuid||typeof P.uuid=="string")}e.isIExtensionIdentifier=y;var T;(function(P){P[P.NoneOrRelevance=0]="NoneOrRelevance",P[P.LastUpdatedDate=1]="LastUpdatedDate",P[P.Title=2]="Title",P[P.PublisherName=3]="PublisherName",P[P.InstallCount=4]="InstallCount",P[P.PublishedDate=5]="PublishedDate",P[P.AverageRating=6]="AverageRating",P[P.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var I;(function(P){P[P.Default=0]="Default",P[P.Ascending=1]="Ascending",P[P.Descending=2]="Descending"})(I=e.SortOrder||(e.SortOrder={}));var D;(function(P){P.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var C;(function(P){P[P.None=0]="None",P[P.Install=1]="Install",P[P.Update=2]="Update"})(C=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(u,p){super(u);this.code=p,this.name=p}}e.ExtensionManagementError=i,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=(0,g.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,g.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(he[26],fe([0,1,8,4]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function k(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=k;function y(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class I{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,u){if(typeof P=="undefined"||P===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof P=="string"||typeof u=="string"){let p=typeof P=="string"?P:P.value,l=typeof u=="string"?u:u.value;return g.equalsIgnoreCase(p,l)}return P._lower===u._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=I;function D(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function C(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=C,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(he[180],fe([0,1,8,26]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(l,c){return l.uuid&&c.uuid?l.uuid===c.uuid:l.id===c.id?!0:(0,g.compareIgnoreCase)(l.id,c.id)===0}e.areSameExtensions=k;class y{constructor(c,S){this.version=S,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof y?k(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=y;function T(l,c){return`${l}.${c}`}e.getExtensionId=T;function I(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function D(l,c){return I(T(l,c))}e.getGalleryExtensionId=D;function C(l,c){const S=[],w=E=>{for(const d of S)if(d.some(h=>k(c(h),c(E))))return d;return null};for(const E of l){const d=w(E);d?d.push(E):S.push([E])}return S}e.groupByExtension=C;function i(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function P(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function u(l){const c=new Set;for(const S of l)S.malicious&&c.add(S.id.id);return c}e.getMaliciousExtensionsSet=u;function p(l,c){const S=[],w=c.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const E=w.shift();if(E&&S.every(d=>!k(d.identifier,{id:E}))){const d=l.filter(h=>k(h.identifier,{id:E}));d.length===1&&(S.push(d[0]),w.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}e.getExtensionDependencies=p}),define(he[181],fe([0,1,4]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(he[182],fe([0,1,38,9,110,155,28,11,181,10,136]),function(X,e,g,R,k,y,T,I,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=y.localize(0,null);class u{async getDefaultTerminalForPlatforms(){const h=await c.getDefaultTerminalLinuxReady();return{windows:p.getDefaultTerminalWindows(),linux:h,osx:"xterm"}}}class p extends u{openTerminal(h,v){return this.spawnTerminal(g,h,k.getWindowsShell(),v)}spawnTerminal(h,v,t,s){const r=v.windowsExec||p.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const n=R.basename(r).toLowerCase();if(n==="cmder"||n==="cmder.exe")return h.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return r.indexOf(" ")>=0&&a.push('""'),a.push(r),(n==="wt"||n==="wt.exe")&&a.push("-d ."),new Promise((f,m)=>{const b=S(process),_=h.spawn(t,a,{cwd:s,env:b});_.on("error",m),_.on("exit",()=>f())})}runInTerminal(h,v,t,s,r){const n="windowsExec"in r&&r.windowsExec?r.windowsExec:p.getDefaultTerminalWindows();return new Promise((a,f)=>{const m=`"${v} - ${P}"`,b=`""${t.join('" "')}" & pause"`,_=["/c","start",m,"/wait",n,"/c",b],o=Object.assign({},S(process),s);Object.keys(o).filter($=>o[$]===null).forEach($=>delete o[$]);const A={cwd:v,env:o,windowsVerbatimArguments:!0};g.spawn(p.CMD,_,A).on("error",$=>{f(w($))}),a(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class l extends u{openTerminal(h,v){return this.spawnTerminal(g,h,v)}runInTerminal(h,v,t,s,r){const n=r.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((a,f)=>{if(n===D.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const m=n===D.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",_=[C.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${m}.scpt`,X).fsPath,"-t",h||P,"-w",v];for(let F of t)_.push("-a"),_.push(F);if(s)for(let F in s){const $=s[F];$===null?(_.push("-u"),_.push(F)):(_.push("-e"),_.push(`${F}=${$}`))}let o="";const A=g.spawn(l.OSASCRIPT,_);A.on("error",F=>{f(w(F))}),A.stderr.on("data",F=>{o+=F.toString()}),A.on("exit",F=>{if(F===0)a(void 0);else if(o){const $=o.split(`
`,1);f(new Error($[0]))}else f(new Error(y.localize(1,null,m,F)))})}else f(new Error(y.localize(2,null,n)))})}spawnTerminal(h,v,t){const s=v.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((r,n)=>{const a=["-a",s];t&&a.push(t);const f=h.spawn("/usr/bin/open",a);f.on("error",n),f.on("exit",()=>r())})}}e.MacExternalTerminalService=l,l.OSASCRIPT="/usr/bin/osascript";class c extends u{openTerminal(h,v){return this.spawnTerminal(g,h,v)}runInTerminal(h,v,t,s,r){const n=r.linuxExec?Promise.resolve(r.linuxExec):c.getDefaultTerminalLinuxReady();return new Promise((a,f)=>{let m=[];n.then(b=>{b.indexOf("gnome-terminal")>=0?m.push("-x"):m.push("-e"),m.push("bash"),m.push("-c");const _=`${E(t)}; echo; read -p "${c.WAIT_MESSAGE}" -n1;`;m.push(`''${_}''`);const o=Object.assign({},process.env,s);Object.keys(o).filter(W=>o[W]===null).forEach(W=>delete o[W]);const A={cwd:v,env:o};let F="";const $=g.spawn(b,m,A);$.on("error",W=>{f(w(W))}),$.stderr.on("data",W=>{F+=W.toString()}),$.on("exit",W=>{if(W===0)a(void 0);else if(F){const Q=F.split(`
`,1);f(new Error(Q[0]))}else f(new Error(y.localize(4,null,b,W)))})})})}static async getDefaultTerminalLinuxReady(){return c._DEFAULT_TERMINAL_LINUX_READY||(c._DEFAULT_TERMINAL_LINUX_READY=new Promise(async h=>{I.isLinux?await T.Promises.exists("/etc/debian_version")?h("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?h("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?h("konsole"):process.env.COLORTERM?h(process.env.COLORTERM):process.env.TERM?h(process.env.TERM):h("xterm"):h("xterm")})),c._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(h,v,t){const s=v.linuxExec?Promise.resolve(v.linuxExec):c.getDefaultTerminalLinuxReady();return new Promise((r,n)=>{s.then(a=>{const f=S(process),m=h.spawn(a,[],{cwd:t,env:f});m.on("error",n),m.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=c,c.WAIT_MESSAGE=y.localize(3,null);function S(d){const h=d.env;return(0,i.sanitizeProcessEnvironment)(h),h}function w(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(y.localize(5,null,d.path)):d}function E(d){let h="";for(let v of d)v.indexOf(" ")>=0?h+='"'+v+'"':h+=v,h+=" ";return h}}),define(he[41],fe([0,1,156,9,2,4,8,14,23]),function(X,e,g,R,k,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function C(N){return N.create===!0}e.isFileOpenForWriteOptions=C;var i;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var P;(function(N){N[N.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var u;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(u=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=p;function l(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=l;function c(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function S(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=S;var w;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(x,L){super(x);this.code=L}}e.FileSystemProviderError=E;function d(N,x){const L=new E(N.toString(),x);return v(L,x),L}e.createFileSystemProviderError=d;function h(N){return N||d((0,g.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=h;function v(N,x){return N.name=x?`${x} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=v;function t(N){if(!N)return w.Unknown;if(N instanceof E)return N.code;const x=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!x)return w.Unknown;switch(x[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function s(N){if(N instanceof b)return N.fileOperationResult;switch(t(N)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class n{constructor(x,L,G){this.resource=x,this.operation=L,this.target=G}isOperation(x){return this.operation===x}}e.FileOperationEvent=n;var a;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class f{constructor(x,L){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const G of x)switch(G.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>L)),this.added.set(G.resource,G);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>L)),this.updated.set(G.resource,G);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>L)),this.deleted.set(G.resource,G);break}}contains(x,...L){return this.doContains(x,{includeChildren:!1},...L)}affects(x,...L){return this.doContains(x,{includeChildren:!0},...L)}doContains(x,L,...G){if(!x)return!1;const M=G.length>0;return!!((!M||G.includes(1))&&(this.added?.get(x)||L.includeChildren&&this.added?.findSuperstr(x))||(!M||G.includes(0))&&(this.updated?.get(x)||L.includeChildren&&this.updated?.findSuperstr(x))||(!M||G.includes(2))&&(this.deleted?.findSubstr(x)||L.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function m(N,x,L){return!N||!x||N===x||x.length>N.length?!1:(x.charAt(x.length-1)!==R.sep&&(x+=R.sep),L?(0,T.startsWithIgnoreCase)(N,x):N.indexOf(x)===0)}e.isParent=m;class b extends Error{constructor(x,L,G){super(x);this.fileOperationResult=L,this.options=G}}e.FileOperationError=b;class _ extends b{constructor(x,L,G){super(x,2,G);this.stat=L}}e.NotModifiedSinceFileOperationError=_;var o;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=F;async function $(N,x){if(!x.canHandleResource(k.URI.from({scheme:N.scheme})))return new Promise(L=>{const G=x.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===N.scheme&&M.added&&(G.dispose(),L())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class W{static formatSize(x){return(0,I.isNumber)(x)||(x=0),x<W.KB?(0,g.localize)(1,null,x.toFixed(0)):x<W.MB?(0,g.localize)(2,null,(x/W.KB).toFixed(2)):x<W.GB?(0,g.localize)(3,null,(x/W.MB).toFixed(2)):x<W.TB?(0,g.localize)(4,null,(x/W.GB).toFixed(2)):(0,g.localize)(5,null,(x/W.TB).toFixed(2))}}e.ByteSize=W,W.KB=1024,W.MB=W.KB*W.KB,W.GB=W.MB*W.KB,W.TB=W.GB*W.KB;var Q;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(Q=e.Arch||(e.Arch={}));function H(N){return{maxFileSize:N===0?300*W.MB:16*W.GB,maxHeapSize:N===0?700*W.MB:2*700*W.MB}}e.getPlatformLimits=H}),define(he[81],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...k){this._entries=new Map;for(let[y,T]of k)this.set(y,T)}set(k,y){const T=this._entries.get(k);return this._entries.set(k,y),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=g}),define(he[183],fe([0,1,15,175,111,4,81,17]),function(X,e,g,R,k,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class C extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class i{constructor(l=new T.ServiceCollection,c=!1,S){this._activeInstantiations=new Set,this._services=l,this._strict=c,this._parent=S,this._services.set(y.IInstantiationService,this)}createChild(l){return new i(l,this._strict,this)}invokeFunction(l,...c){let S=u.traceInvocation(l),w=!1;try{return l({get:(d,h)=>{if(w)throw(0,g.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(d,S);if(!v&&h!==y.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return v}},...c)}finally{w=!0,S.stop()}}createInstance(l,...c){let S,w;return l instanceof k.SyncDescriptor?(S=u.traceCreation(l.ctor),w=this._createInstance(l.ctor,l.staticArguments.concat(c),S)):(S=u.traceCreation(l),w=this._createInstance(l,c,S)),S.stop(),w}_createInstance(l,c=[],S){let w=y._util.getServiceDependencies(l).sort((h,v)=>h.index-v.index),E=[];for(const h of w){let v=this._getOrCreateServiceInstance(h.id,S);if(!v&&this._strict&&!h.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${h.id}.`);E.push(v)}let d=w.length>0?w[0].index:c.length;if(c.length!==d){console.warn(`[createInstance] First service dependency of ${l.name} at position ${d+1} conflicts with ${c.length} static arguments`);let h=d-c.length;h>0?c=c.concat(new Array(h)):c=c.slice(0,d)}return new l(...[...c,...E])}_setServiceInstance(l,c){if(this._services.get(l)instanceof k.SyncDescriptor)this._services.set(l,c);else if(this._parent)this._parent._setServiceInstance(l,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let c=this._services.get(l);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):c}_getOrCreateServiceInstance(l,c){let S=this._getServiceInstanceOrDescriptor(l);return S instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,S,c.branch(l,!0)):(c.branch(l,!1),S)}_safeCreateAndCacheServiceInstance(l,c,S){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,c,S)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,c,S){const w=new R.Graph(h=>h.id.toString());let E=0;const d=[{id:l,desc:c,_trace:S}];for(;d.length;){const h=d.pop();if(w.lookupOrInsertNode(h),E++>1e3)throw new C(w);for(let v of y._util.getServiceDependencies(h.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${l} depends on ${v.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const s={id:v.id,desc:t,_trace:h._trace.branch(v.id,!0)};w.insertEdge(h,s),d.push(s)}}}for(;;){const h=w.roots();if(h.length===0){if(!w.isEmpty())throw new C(w);break}for(const{data:v}of h){if(this._getServiceInstanceOrDescriptor(v.id)instanceof k.SyncDescriptor){const s=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,s)}w.removeNode(v)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,c,S=[],w,E){if(this._services.get(l)instanceof k.SyncDescriptor)return this._createServiceInstance(c,S,w,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,c,S,w,E);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(l,c=[],S,w){if(S){const E=new I.IdleValue(()=>this._createInstance(l,c,w));return new Proxy(Object.create(null),{get(d,h){if(h in d)return d[h];let v=E.value,t=v[h];return typeof t!="function"||(t=t.bind(v),d[h]=t),t},set(d,h,v){return E.value[h]=v,!0}})}else return this._createInstance(l,c,w)}}e.InstantiationService=i;var P;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(P||(P={}));class u{constructor(l,c){this.type=l,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return D?new u(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):u._None}static traceCreation(l){return D?new u(0,l.name):u._None}branch(l,c){let S=new u(2,l.toString());return this._dep.push([l,c,S]),S}stop(){let l=Date.now()-this._start;u._totals+=l;let c=!1;function S(E,d){let h=[],v=new Array(E+1).join("	");for(const[t,s,r]of d._dep)if(s&&r){c=!0,h.push(`${v}CREATES -> ${t}`);let n=S(E+1,r);n&&h.push(n)}else h.push(`${v}uses -> ${t}`);return h.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${u._totals.toFixed(2)}ms)`];(l>2||c)&&console.log(w.join(`
`))}}u._None=new class extends u{constructor(){super(-1,null)}stop(){}branch(){return this}},u._totals=0}),define(he[12],fe([0,1,4,6,11,3,58]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function I(){return new Date().toISOString()}var D;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class C extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class i extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(D.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(D.Error,this.format(r))}else this.log(D.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let r=0;r<t.length;r++){let n=t[r];if(typeof n=="object")try{n=JSON.stringify(n)}catch(a){}s+=(r>0?" ":"")+n}return s}}e.AbstractMessageLogger=i;class P extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...s){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...s):console.log(`[main ${I()}]`,t,...s))}debug(t,...s){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...s):console.log(`[main ${I()}]`,t,...s))}info(t,...s){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,t,...s):console.log(`[main ${I()}]`,t,...s))}warn(t,...s){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,t,...s):console.warn(`[main ${I()}]`,t,...s))}error(t,...s){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,t,...s):console.error(`[main ${I()}]`,t,...s))}critical(t,...s){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,t,...s):console.error(`[main ${I()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class u extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=u;class p extends C{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,T.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class l extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const r of this.logServices)r.trace(t,...s)}debug(t,...s){for(const r of this.logServices)r.debug(t,...s)}info(t,...s){for(const r of this.logServices)r.info(t,...s)}warn(t,...s){for(const r of this.logServices)r.warn(t,...s)}error(t,...s){for(const r of this.logServices)r.error(t,...s)}critical(t,...s){for(const r of this.logServices)r.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=l;class c extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=c;class S extends R.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(r))}))}createLogger(t,s){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,s?.always?D.Trace:this.logLevel,s),this.loggers.set(t.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class w{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=w;function E(v){if(v.verbose)return D.Trace;if(typeof v.logLevel=="string"){const t=d(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function d(v){switch(v){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=d;function h(v){switch(v){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=h}),define(he[112],fe([0,1,12,41]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(D,C,i,P){try{const u=await new Promise((p,l)=>{X(["spdlog"],p,l)});return u.setFlushOn(g.LogLevel.Trace),u.createAsyncRotatingLogger(D,C,i,P)}catch(u){console.error(u)}return null}function y(D,C,i,P){const u=X.__$__nodeRequire("spdlog");return u.setFlushOn(g.LogLevel.Trace),u.createRotatingLogger(D,C,i,P)}e.createRotatingLogger=y;function T(D,C,i){switch(C){case g.LogLevel.Trace:D.trace(i);break;case g.LogLevel.Debug:D.debug(i);break;case g.LogLevel.Info:D.info(i);break;case g.LogLevel.Warning:D.warn(i);break;case g.LogLevel.Error:D.error(i);break;case g.LogLevel.Critical:D.critical(i);break;default:throw new Error("Invalid log level")}}class I extends g.AbstractMessageLogger{constructor(C,i,P,u){super();this.name=C,this.filepath=i,this.rotating=P,this.buffer=[],this.setLevel(u),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const C=this.rotating?6:1,i=30/C*R.ByteSize.MB;return k(this.name,this.filepath,i,C).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:u,message:p}of this.buffer)T(this._logger,u,p);this.buffer=[]}})}log(C,i){this._logger?T(this._logger,C,i):this.getLevel()<=C&&this.buffer.push({level:C,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=I}),define(he[113],fe([0,1,4,157,56]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var T;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(T=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function C(l,c){return c-l}D.compare=C;const i=Object.create(null);i[D.Error]=(0,R.localize)(0,null),i[D.Warning]=(0,R.localize)(1,null),i[D.Info]=(0,R.localize)(2,null);function P(l){return i[l]||""}D.toString=P;function u(l){switch(l){case k.default.Error:return D.Error;case k.default.Warning:return D.Warning;case k.default.Info:return D.Info;case k.default.Ignore:return D.Hint}}D.fromSeverity=u;function p(l){switch(l){case D.Error:return k.default.Error;case D.Warning:return k.default.Warning;case D.Info:return k.default.Info;case D.Hint:return k.default.Ignore}}D.toSeverity=p}(T=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(D){const C="";function i(u){return P(u,!0)}D.makeKey=i;function P(u,p){let l=[C];return u.source?l.push(u.source.replace("\xA6","\\\xA6")):l.push(C),u.code?typeof u.code=="string"?l.push(u.code.replace("\xA6","\\\xA6")):l.push(u.code.value.replace("\xA6","\\\xA6")):l.push(C),u.severity!==void 0&&u.severity!==null?l.push(T.toString(u.severity)):l.push(C),u.message&&p?l.push(u.message.replace("\xA6","\\\xA6")):l.push(C),u.startLineNumber!==void 0&&u.startLineNumber!==null?l.push(u.startLineNumber.toString()):l.push(C),u.startColumn!==void 0&&u.startColumn!==null?l.push(u.startColumn.toString()):l.push(C),u.endLineNumber!==void 0&&u.endLineNumber!==null?l.push(u.endLineNumber.toString()):l.push(C),u.endColumn!==void 0&&u.endColumn!==null?l.push(u.endColumn.toString()):l.push(C),l.push(C),l.join("\xA6")}D.makeKeyOptionalMessage=P})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,g.createDecorator)("markerService")}),define(he[184],fe([0,1,56,4,3]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=g.default,e.INotificationService=(0,R.createDecorator)("notificationService");var y;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var T;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(T=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new D,this.onDidClose=k.Event.None,this.onDidChangeVisibility=k.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=I;class D{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=D}),define(he[185],fe([0,1,6,8,2,4]),function(X,e,g,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(I){return{resolved:I,dispose(){}}}});function T(I,D){return k.URI.isUri(I)?(0,R.equalsIgnoreCase)(I.scheme,D):(0,R.startsWithIgnoreCase)(I,D+":")}e.matchesScheme=T}),define(he[186],fe([0,1,10,11,37,24]),function(X,e,g,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const I=R.globals.vscode.context.configuration();if(I)T=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const I=(0,y.dirname)(g.FileAccess.asFileUri("",X));T=X.__$__nodeRequire((0,y.joinPath)(I,"product.json").fsPath);const D=X.__$__nodeRequire((0,y.joinPath)(I,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:D.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.59.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T});var He=this&&this.__param||function(X,e){return function(g,R){e(g,R,X)}};define(he[114],fe([0,1,4,21,6,17]),function(X,e,g,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,g.createDecorator)("progressService");var T;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(T=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let D=class extends k.Disposable{constructor(P,u){super();this.deferred=new y.DeferredPromise,u.withProgress(P,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,k.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};D=je([He(1,e.IProgressService)],D),e.UnmanagedProgress=D;class C extends k.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(P){this.stop();const u=++this.currentOperationId,p=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{u===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,k.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,k.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,k.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:u,token:p.token,stop:()=>this.doStop(u),isCurrent:()=>this.currentOperationId===u}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,g.createDecorator)("editorProgressService")}),define(he[42],fe([0,1,14,52]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,I){R.ok(g.isString(T)),R.ok(g.isObject(I)),R.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,I)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(he[187],fe([0,1,42,3]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class y{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,C){this.schemasById[k(D)]=C,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new y;g.Registry.add(e.Extensions.JSONContribution,T)}),define(he[82],fe([0,1,152,3,42,14,187]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const C=k.Registry.as(T.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:g.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,d=!0){this.registerConfigurations([E],d)}registerConfigurations(E,d=!0){const h=[];E.forEach(v=>{h.push(...this.validateAndRegisterProperties(v,d,v.extensionInfo)),this.configurationContributors.push(v),this.registerJSONConfiguration(v)}),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterConfigurations(E){const d=[],h=v=>{if(v.properties)for(const t in v.properties)d.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,v.properties[t]);v.allOf&&v.allOf.forEach(t=>h(t))};for(const v of E){h(v);const t=this.configurationContributors.indexOf(v);t!==-1&&this.configurationContributors.splice(t,1)}C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}registerDefaultConfigurations(E){const d=[],h=[];for(const v of E)for(const t in v)if(d.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...v[t]};const s={type:"object",default:this.defaultValues[t],description:g.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};h.push(u(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.defaultValues[t]=v[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterDefaultConfigurations(E){const d=[];for(const h of E)for(const v in h)if(d.push(v),delete this.defaultValues[v],e.OVERRIDE_PROPERTY_PATTERN.test(v))delete this.configurationProperties[v],delete this.defaultLanguageConfigurationOverridesNode.properties[v];else{const t=this.configurationProperties[v];t&&(this.updatePropertyDefaultValue(v,t),this.updateSchema(v,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const d of E)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,d=!0,h,v=3){v=y.isUndefinedOrNull(E.scope)?v:E.scope;let t=[],s=E.properties;if(s)for(let n in s){if(d&&c(n)){delete s[n];continue}const a=s[n];if(this.updatePropertyDefaultValue(n,a),e.OVERRIDE_PROPERTY_PATTERN.test(n)?a.scope=void 0:(a.scope=y.isUndefinedOrNull(a.scope)?v:a.scope,a.restricted=y.isUndefinedOrNull(a.restricted)?!!h?.restrictedConfigurations?.includes(n):a.restricted),s[n].hasOwnProperty("included")&&!s[n].included){this.excludedConfigurationProperties[n]=s[n],delete s[n];continue}else this.configurationProperties[n]=s[n];!s[n].deprecationMessage&&s[n].markdownDeprecationMessage&&(s[n].deprecationMessage=s[n].markdownDeprecationMessage),t.push(n)}let r=E.allOf;if(r)for(let n of r)t.push(...this.validateAndRegisterProperties(n,d,h,v));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const d=h=>{let v=h.properties;if(v)for(const s in v)this.updateSchema(s,v[s]);let t=h.allOf;t&&t.forEach(d)};d(E)}updateSchema(E,d){switch(e.allSettings.properties[E]=d,d.scope){case 1:e.applicationSettings.properties[E]=d;break;case 2:e.machineSettings.properties[E]=d;break;case 6:e.machineOverridableSettings.properties[E]=d;break;case 3:e.windowSettings.properties[E]=d;break;case 4:e.resourceSettings.properties[E]=d;break;case 5:e.resourceSettings.properties[E]=d,this.resourceLanguageSettingsSchema.properties[E]=d;break}}removeFromSchema(E,d){switch(delete e.allSettings.properties[E],d.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const d=`[${E}]`,h={type:"object",description:g.localize(2,null),errorMessage:g.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,h),e.allSettings.properties[d]=h,e.applicationSettings.properties[d]=h,e.machineSettings.properties[d]=h,e.machineOverridableSettings.properties[d]=h,e.windowSettings.properties[d]=h,e.resourceSettings.properties[d]=h}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,d){let h=this.defaultValues[E];y.isUndefined(h)&&(h=d.default),y.isUndefined(h)&&(h=p(d.type)),d.default=h}}const P="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(P);function u(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=u;function p(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const l=new i;k.Registry.add(e.Extensions.Configuration,l);function c(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?g.localize(5,null,w):l.getConfigurationProperties()[w]!==void 0?g.localize(6,null,w):null:g.localize(4,null)}e.validateProperty=c;function S(){const w=[],E=l.getConfigurationProperties();for(const d of Object.keys(E))w.push([d,E[d].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=S}),define(he[115],fe([0,1,25,14,2,42,4,82]),function(X,e,g,R,k,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function D(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof k.URI)}e.isConfigurationOverrides=D;var C;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function P(s,r){const n=r?s?r.keys.filter(A=>s.keys.indexOf(A)===-1):[...r.keys]:[],a=s?r?s.keys.filter(A=>r.keys.indexOf(A)===-1):[...s.keys]:[],f=[];if(r&&s){for(const A of s.keys)if(r.keys.indexOf(A)!==-1){const F=w(s.contents,A),$=w(r.contents,A);g.equals(F,$)||f.push(A)}}const m=[],b=A=>{const F={};for(const $ of A)for(const W of $.identifiers)F[v(W)]=$;return F},_=r?b(r.overrides):{},o=s?b(s.overrides):{};if(Object.keys(_).length)for(const A of n){const F=_[A];F&&m.push([(0,I.overrideIdentifierFromKey)(A),F.keys])}if(Object.keys(o).length)for(const A of a){const F=o[A];F&&m.push([(0,I.overrideIdentifierFromKey)(A),F.keys])}if(Object.keys(_).length&&Object.keys(o).length)for(const A of f){const F=o[A],$=_[A];if(F&&$){const W=P({contents:F.contents,keys:F.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});m.push([(0,I.overrideIdentifierFromKey)(A),[...W.added,...W.removed,...W.updated]])}}return{added:n,removed:a,updated:f,overrides:m}}e.compare=P;function u(s,r){const n=[];for(const a of Object.keys(s))if(I.OVERRIDE_PROPERTY_PATTERN.test(a)){const f={};for(const m in s[a])f[m]=s[a][m];n.push({identifiers:[(0,I.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(f),contents:p(f,r)})}return n}e.toOverrides=u;function p(s,r){const n=Object.create(null);for(let a in s)l(n,a,s[a],r);return n}e.toValuesTree=p;function l(s,r,n,a){const f=r.split("."),m=f.pop();let b=s;for(let _=0;_<f.length;_++){let o=f[_],A=b[o];switch(typeof A){case"undefined":A=b[o]=Object.create(null);break;case"object":break;default:a(`Ignoring ${r} as ${f.slice(0,_+1).join(".")} is ${JSON.stringify(A)}`);return}b=A}if(typeof b=="object"&&b!==null)try{b[m]=n}catch(_){a(`Ignoring ${r} as ${f.join(".")} is ${JSON.stringify(b)}`)}else a(`Ignoring ${r} as ${f.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=l;function c(s,r){const n=r.split(".");S(s,n)}e.removeFromValueTree=c;function S(s,r){const n=r.shift();if(r.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const a=s[n];typeof a=="object"&&!Array.isArray(a)&&(S(a,r),Object.keys(a).length===0&&delete s[n])}}function w(s,r,n){function a(b,_){let o=b;for(const A of _){if(typeof o!="object"||o===null)return;o=o[A]}return o}const f=r.split("."),m=a(s,f);return typeof m=="undefined"?n:m}e.getConfigurationValue=w;function E(s,r,n){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in s?R.isObject(s[a])&&R.isObject(r[a])?E(s[a],r[a],n):n&&(s[a]=r[a]):s[a]=r[a])})}e.merge=E;function d(){const s=y.Registry.as(I.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=d;function h(){const s=Object.create(null),r=y.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(let n in r){let a=r[n].default;l(s,n,a,f=>console.error(`Conflict in default settings: ${f}`))}return s}e.getDefaultValues=h;function v(s){return`[${s}]`}e.keyFromOverrideIdentifier=v;function t(s,r,n){const a=s.inspect(r),f=s.inspect(n);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:a.defaultValue}e.getMigratedSettingValue=t}),define(he[188],fe([0,1,55,23,18,14,25,2,82,115,42,6,3]),function(X,e,g,R,k,y,T,I,D,C,i,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},s=[],r=[]){this._contents=t,this._keys=s,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,C.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const r=this.getContentsForOverrideIdentifer(s);return r?t?(0,C.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const n of k.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[n],f=s[n];f&&(typeof a=="object"&&typeof f=="object"?(a=T.deepClone(a),this.mergeContents(a,f)):a=f),r[n]=a}return new p(r,this.keys,this.overrides)}merge(...t){const s=T.deepClone(this.contents),r=T.deepClone(this.overrides),n=[...this.keys];for(const a of t){this.mergeContents(s,a.contents);for(const f of a.overrides){const[m]=r.filter(b=>k.equals(b.identifiers,f.identifiers));m?this.mergeContents(m.contents,f.contents):r.push(T.deepClone(f))}for(const f of a.keys)n.indexOf(f)===-1&&n.push(f)}return new p(s,n,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const r of Object.keys(s)){if(r in t&&y.isObject(t[r])&&y.isObject(s[r])){this.mergeContents(t[r],s[r]);continue}t[r]=T.deepClone(s[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?T.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,C.addToValueTree)(this.contents,t,s,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,C.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let r=0;r<s;r++)t.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=p;class l extends p{constructor(){const t=(0,C.getDefaultValues)(),s=(0,C.getConfigurationKeys)(),r=[];for(const n of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(n)&&r.push({identifiers:[(0,D.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(t[n]),contents:(0,C.toValuesTree)(t[n],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,s,r)}}e.DefaultConfigurationModel=l;class c{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!y.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:r,keys:n,overrides:a,restricted:f}=this.doParseRaw(t,s);this._configurationModel=new p(r,n,a),this._restrictedConfigurations=f||[]}doParseContent(t){let s={},r=null,n=[],a=[],f=[];function m(_){Array.isArray(n)?n.push(_):r&&(n[r]=_)}let b={onObjectBegin:()=>{let _={};m(_),a.push(n),n=_,r=null},onObjectProperty:_=>{r=_},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{let _=[];m(_),a.push(n),n=_,r=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:m,onError:(_,o,A)=>{f.push({error:_,offset:o,length:A})}};if(t)try{g.visit(t,b),s=n[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return s}doParseRaw(t,s){const r=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,r,!0,s);t=n.raw;const a=(0,C.toValuesTree)(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),f=Object.keys(t),m=(0,C.toOverrides)(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:a,keys:f,overrides:m,restricted:n.restricted}}filter(t,s,r,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[]};const a={},f=[];for(let m in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(m)&&r){const b=this.filter(t[m],s,!1,n);a[m]=b.raw,f.push(...b.restricted)}else{const b=s[m],_=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&f.push(m),(_===void 0||n.scopes===void 0||n.scopes.includes(_))&&(n.skipRestricted&&b?.restricted||(a[m]=t[m]))}return{raw:a,restricted:f}}}e.ConfigurationModelParser=c;class S extends P.Disposable{constructor(t,s,r,n){super();this.userSettingsResource=t,this.scopes=s,this.fileService=n,this._onDidChange=this._register(new u.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(u.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class w{constructor(t,s,r=new p,n=new p,a=new R.ResourceMap,f=new p,m=new R.ResourceMap,b=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=n,this._folderConfigurations=a,this._memoryConfiguration=f,this._memoryConfigurationByResource=m,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(t)}updateValue(t,s,r={}){let n;r.resource?(n=this._memoryConfigurationByResource.get(r.resource),n||(n=new p,this._memoryConfigurationByResource.set(r.resource,n))):n=this._memoryConfiguration,s===void 0?n.removeValue(t):n.setValue(t,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,r){const n=this.getConsolidateConfigurationModel(s,r),a=this.getFolderConfigurationModelForResource(s.resource,r),f=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,m=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),b=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),_=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),A=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=a?s.overrideIdentifier?a.freeze().override(s.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,$=s.overrideIdentifier?f.override(s.overrideIdentifier).getValue(t):f.getValue(t),W=n.getValue(t),Q=k.distinct(k.flatten(n.overrides.map(H=>H.identifiers))).filter(H=>n.getOverrideValue(t,H)!==void 0);return{defaultValue:m,userValue:b,userLocalValue:_,userRemoteValue:o,workspaceValue:A,workspaceFolderValue:F,memoryValue:$,value:W,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:a?.freeze().getValue(t),override:s.overrideIdentifier?a?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:f.getValue(t),override:s.overrideIdentifier?f.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Q.length?Q:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=s.filter(n=>D.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const a=(0,D.overrideIdentifierFromKey)(n),f=this._defaultConfiguration.getKeysForOverrideIdentifier(a),m=t.getKeysForOverrideIdentifier(a),b=[...m.filter(_=>f.indexOf(_)===-1),...f.filter(_=>m.indexOf(_)===-1),...f.filter(_=>!T.equals(this._defaultConfiguration.override(a).getValue(_),t.override(a).getValue(_)))];return[a,b]});return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:n,overrides:a}=(0,C.compare)(this.localUserConfiguration,t),f=[...s,...r,...n];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:n,overrides:a}=(0,C.compare)(this.remoteUserConfiguration,t);let f=[...s,...r,...n];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:n,overrides:a}=(0,C.compare)(this.workspaceConfiguration,t);let f=[...s,...r,...n];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:a}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:n,updated:a,removed:f,overrides:m}=(0,C.compare)(r,s);let b=[...n,...a,...f];return(b.length||!r)&&this.updateFolderConfiguration(t,s),{keys:b,overrides:m}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:n,removed:a,overrides:f}=(0,C.compare)(s,void 0);return{keys:[...r,...n,...a],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let r=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const n=s.getFolder(t);n&&(r=this.getFolderConsolidatedConfiguration(n.uri)||r);const a=this._memoryConfigurationByResource.get(t);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(s=r.merge(n),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=r}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:r,overrides:n,keys:a}=this._folderConfigurations.get(s);return t.push([s,{contents:r,overrides:n,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(n=>s.add(n))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((f,m)=>(f.set(I.URI.revive(m[0]),this.parseConfigurationModel(m[1])),f),new R.ResourceMap);return new w(s,r,new p,n,a,new p,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function E(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,s=new Map;for(const n of v)n.keys.forEach(a=>t.add(a)),n.overrides.forEach(([a,f])=>{const m=(0,R.getOrSet)(s,a,new Set);f.forEach(b=>m.add(b))});const r=[];return s.forEach((n,a)=>r.push([a,[...n.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=E;class d{constructor(t,s,r,n){this.change=t,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=n,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(m=>a.add(m)),t.overrides.forEach(([,m])=>m.forEach(b=>a.add(b))),this.affectedKeys=[...a.values()];const f=new p;this.affectedKeys.forEach(m=>f.setValue(m,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!T.equals(r,n)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let r=(0,C.toValuesTree)({[s]:!0},()=>{}),n;for(;typeof r=="object"&&(n=Object.keys(r)[0]);){if(t=t[n],!t)return!1;r=r[n]}return!0}}e.ConfigurationChangeEvent=d;class h extends d{constructor(t,s,r,n){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=r,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=h}),define(he[116],fe([0,1,4]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var R;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(T,I=R.Unknown,D){super(T);this._message=T,this._code=I,this._detail=D,this.isHandled=I===R.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(T){return T instanceof k&&T._code===R.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof k&&T._code===R.NoResolverFound}static isHandled(T){return T instanceof k&&T.isHandled}}e.RemoteAuthorityResolverError=k}),define(he[83],fe([0,1,10]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(C){return C.scheme===g.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=R;function k(C){if(!C)return;const i=C.indexOf("+");return i<0?C:C.substr(0,i)}e.getRemoteName=k;function y(C){return C.scheme!==g.Schemas.file&&C.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=y;function T(C){if(C.folders.length)return C.folders.every(i=>y(i.uri))?C.folders[0].uri:void 0;if(C.configuration&&y(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=T;function I(C){return T(C)?.scheme}e.getVirtualWorkspaceScheme=I;function D(C){return T(C)!==void 0}e.isVirtualWorkspace=D}),define(he[189],fe([0,1,3,11,4,12]),function(X,e,g,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var T;(function(p){p.Http="http",p.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!l)return{address:l[1],port:+l[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=i;function P(p,l){return l?l!==1&&p<1024:!R.isWindows&&p<1024}e.isPortPrivileged=P;let u=class{constructor(l){this.logService=l,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(l,c){return this._tunnelProvider=l,l?(this._canElevate=c.elevation,this._canMakePublic=c.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async l=>{const c=[],S=Array.from(this._tunnels.values());for(let w of S){const E=Array.from(w.values());for(let d of E){const h=await d.value;h&&c.push(h)}}l(c)})}async dispose(){for(const l of this._tunnels.values()){for(const{value:c}of l.values())await c.then(S=>S?.dispose());l.clear()}this._tunnels.clear()}openTunnel(l,c,S,w,E=!1,d=!1,h){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${S} on local port ${w}.`),!l)return;c||(c="localhost");const v=this.retainOrCreateTunnel(l,c,S,w,E,d,h);return v?v.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(c,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(t);return(t.tunnelRemoteHost!==c||t.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}makeTunnel(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,public:l.public,protocol:l.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const c=this._tunnels.get(l.tunnelRemoteHost);if(c){const S=c.get(l.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(l.tunnelRemoteHost,l.tunnelRemotePort,S))}}}}async tryDisposeTunnel(l,c,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${c}.`);const w=S.value.then(async E=>{E&&(await E.dispose(!0),this._onTunnelClosed.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this._tunnels.has(l)&&this._tunnels.get(l).delete(c),w}}async closeTunnel(l,c){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${c} `);const S=this._tunnels.get(l);if(S&&S.has(c)){const w=S.get(c);w.refcount=0,await this.tryDisposeTunnel(l,c,w)}}addTunnelToMap(l,c,S){this._tunnels.has(l)||this._tunnels.set(l,new Map),this._tunnels.get(l).set(c,{refcount:1,value:S})}async removeEmptyTunnelFromMap(l,c){const S=this._tunnels.get(l);S&&(await S.get(c)||S.delete(c),S.size===0&&this._tunnels.delete(l))}getTunnelFromMap(l,c){let S=[l];C(l)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):i(l)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const w=S.map(E=>this._tunnels.get(E));for(const E of w){const d=E?.get(c);if(d)return d}}canTunnel(l){return!!D(l)}createWithProvider(l,c,S,w,E,d,h){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${S} on local port ${w}.`);const t={elevationRequired:E?P(w===void 0?S:w):!1},s={remoteAddress:{host:c,port:S},localAddressPort:w,public:d,protocol:h},r=l.forwardPort(s,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(c,S,r),r}};u=je([He(0,y.ILogService)],u),e.AbstractTunnelService=u}),define(he[190],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{vsda(){return new Promise((k,y)=>X(["vsda"],k,y))}async sign(k){try{const y=await this.vsda(),T=new y.signer;if(T)return T.sign(k)}catch(y){}return k}}e.SignService=g}),define(he[191],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,y,T=5){let I;return I=y(D=>{const C=typeof D=="string"?D:D.data;let i=this._terminalBufferMap.get(k);if(i){i.data.push(C);return}const P=setTimeout(()=>this.flushBuffer(k),T);i={data:[C],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(k),I.dispose()}},this._terminalBufferMap.set(k,i)}),I}stopBuffering(k){const y=this._terminalBufferMap.get(k);y&&y.dispose()}flushBuffer(k){const y=this._terminalBufferMap.get(k);y&&(this._terminalBufferMap.delete(k),this._callback(k,y.data.join("")))}}e.TerminalDataBufferer=g}),define(he[192],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(he[193],fe([0,1,4,6,42,3,192,73]),function(X,e,g,R,k,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,g.createDecorator)("themeService");var D;(function(S){function w(E){return E&&typeof E=="object"&&typeof E.id=="string"}S.isThemeColor=w})(D=e.ThemeColor||(e.ThemeColor={}));function C(S){return{id:S}}e.themeColorFromId=C;var i;(function(S){function w(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||D.isThemeColor(s.color))}S.isThemeIcon=w;const E=new RegExp(`^\\$\\((${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?)\\)$`);function d(s){const r=E.exec(s);if(!r)return;let[,n]=r;return{id:n}}S.fromString=d;function h(s,r){let n=s.id;const a=n.lastIndexOf("~");return a!==-1&&(n=n.substring(0,a)),r&&(n=`${n}~${r}`),{id:n}}S.modify=h;function v(s,r){return s.id===r.id&&s.color?.id===r.color?.id}S.isEqual=v;function t(s,r){return{id:s.id,color:r?C(r):void 0}}S.asThemeIcon=t,S.asClassNameArray=I.CSSIcon.asClassNameArray,S.asClassName=I.CSSIcon.asClassName,S.asCSSSelector=I.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=I.Codicon.file,e.FolderThemeIcon=I.Codicon.folder;function P(S){switch(S){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class u{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new y.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,R.toDisposable)(()=>{const E=this.themingParticipants.indexOf(w);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new u;k.Registry.add(e.Extensions.ThemingContribution,p);function l(S){return p.onColorThemeChange(S)}e.registerThemingParticipant=l;class c extends R.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,E){let d=this.theme.getColor(w);return d&&E&&(d=E(d,this.theme)),d?d.toString():null}}e.Themable=c}),define(he[47],fe([0,1,2,24,4,23]),function(X,e,g,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");var T;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function I(u){const p=u;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=I;function D(u){const p=u;return!!(p&&typeof p=="object"&&g.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=D;class C{constructor(p,l,c,S){this._id=p,this._configuration=c,this._ignorePathCasing=S,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(p){this._id=p.id,this._configuration=p.configuration,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class i{constructor(p,l){this.raw=l,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,R.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function P(u){return new i({uri:u,index:0,name:(0,R.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=P}),define(he[194],fe([0,1,4,158,47,2,11,9,24,134,55,10,76,29,83]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const c=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(N){return(typeof N=="string"?(0,I.extname)(N):(0,D.extname)(N))===c}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,g.createDecorator)("workspacesService");function w(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function E(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=E;function d(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=d;function h(N){const x=N;return typeof x?.id=="string"&&y.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=h;function v(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=v;function t(N){const x=N;return typeof x?.id=="string"&&y.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=t;function s(N){const x=N;if(x?.uri)return{id:x.id,uri:y.URI.revive(x.uri)};const L=N;if(L?.configPath)return{id:L.id,configPath:y.URI.revive(L.configPath)};if(N?.id)return{id:N.id}}e.reviveIdentifier=s;function r(N,x){return D.extUriBiasedIgnorePathCase.isEqualOrParent(N,x.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function n(N){return a(N)||f(N)}e.isStoredWorkspaceFolder=n;function a(N){const x=N;return typeof x?.path=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=a;function f(N){const x=N;return typeof x?.uri=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=f;function m(N,x,L,G,M=!T.isWindows,O){if(N.scheme!==G.scheme)return{name:L,uri:N.toString(!0)};let B=x?void 0:O.relativePath(G,N);if(B!==void 0)B.length===0?B=".":T.isWindows&&N.scheme===P.Schemas.file&&!M&&(B=B.replace(/\//g,"\\"));else if(N.scheme===P.Schemas.file)B=N.fsPath,T.isWindows&&(B=(0,u.normalizeDriveLetter)(B),M&&(B=(0,p.toSlashes)(B)));else{if(!O.isEqualAuthority(N.authority,G.authority))return{name:L,uri:N.toString(!0)};B=N.path}return{name:L,path:B}}e.getStoredWorkspaceFolder=m;function b(N,x,L){let G=[],M=new Set;const O=L.dirname(x);for(let B of N){let z;if(a(B))B.path&&(z=L.resolvePath(O,B.path));else if(f(B))try{z=y.URI.parse(B.uri),z.path[0]!=="/"&&(z=z.with({path:"/"+z.path}))}catch(J){console.warn(J)}if(z){let J=L.getComparisonKey(z);if(!M.has(J)){M.add(J);const ce=B.name||L.basenameOrAuthority(z);G.push(new k.WorkspaceFolder({uri:z,name:ce,index:G.length},B))}}}return G}e.toWorkspaceFolders=b;function _(N,x,L,G,M){let O=o(x,N);const B=M.dirname(x),z=M.dirname(G),J=[],ce=A(O.folders);for(const Ne of O.folders){const Ve=a(Ne)?M.resolvePath(B,Ne.path):y.URI.parse(Ne.uri);let ze;L?ze=!1:ze=!a(Ne)||(0,I.isAbsolute)(Ne.path),J.push(m(Ve,ze,Ne.name,z,ce,M))}const ye={insertSpaces:!1,tabSize:4,eol:T.isLinux||T.isMacintosh?`
`:`\r
`},Fe=C.setProperty(N,["folders"],J,ye);let Re=C.applyEdits(N,Fe);return O.remoteAuthority===(0,l.getRemoteAuthority)(G)&&(Re=C.applyEdits(Re,C.removeProperty(Re,["remoteAuthority"],ye))),Re}e.rewriteWorkspaceFileForNewLocation=_;function o(N,x){let L=i.parse(x);if(L&&Array.isArray(L.folders))L.folders=L.folders.filter(G=>n(G));else throw new Error(`${N} looks like an invalid workspace file.`);return L}function A(N){return T.isWindows?N.some(x=>a(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=A;function F(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function $(N){return typeof N.folderUri=="string"}function W(N){return typeof N.fileUri=="string"}function Q(N,x){const L={workspaces:[],files:[]};if(N){const G=function(O,B){for(let z=0;z<O.length;z++)try{B(O[z],z)}catch(J){x.warn(`Error restoring recent entry ${JSON.stringify(O[z])}: ${J.toString()}. Skip entry.`)}},M=N;if(Array.isArray(M.entries))G(M.entries,O=>{const B=O.label,z=O.remoteAuthority;F(O)?L.workspaces.push({label:B,remoteAuthority:z,workspace:{id:O.workspace.id,configPath:y.URI.parse(O.workspace.configPath)}}):$(O)?L.workspaces.push({label:B,remoteAuthority:z,folderUri:y.URI.parse(O.folderUri)}):W(O)&&L.files.push({label:B,remoteAuthority:z,fileUri:y.URI.parse(O.fileUri)})});else{const O=N;Array.isArray(O.workspaces3)&&G(O.workspaces3,(B,z)=>{const J=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[z]||void 0;typeof B=="object"&&typeof B.id=="string"&&typeof B.configURIPath=="string"?L.workspaces.push({label:J,workspace:{id:B.id,configPath:y.URI.parse(B.configURIPath)}}):typeof B=="string"&&L.workspaces.push({label:J,folderUri:y.URI.parse(B)})}),Array.isArray(O.files2)&&G(O.files2,(B,z)=>{const J=Array.isArray(O.fileLabels)&&O.fileLabels[z]||void 0;typeof B=="string"&&L.files.push({label:J,fileUri:y.URI.parse(B)})})}}return L}e.restoreRecentlyOpened=Q;function H(N){const x={entries:[]};for(const L of N.workspaces)E(L)?x.entries.push({folderUri:L.folderUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority}):x.entries.push({workspace:{id:L.workspace.id,configPath:L.workspace.configPath.toString()},label:L.label,remoteAuthority:L.remoteAuthority});for(const L of N.files)x.entries.push({fileUri:L.fileUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority});return x}e.toStoreData=H}),define(he[84],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const y=this._idPool++;return this._data.set(y,k),this.logDebugInfo(),y}get(k,y){return this._data.has(k)?this._data.get(k)[y]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(he[48],fe([0,1,2,3,4]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");class y{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(I){this._tabs=I.map(D=>({name:D.name,group:D.group,resource:g.URI.revive(D.resource),isActive:D.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=y}),define(he[59],fe([0,1,10,4]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class k{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(T,I){I===null?this._providerInfo.delete(T):this._providerInfo.set(T,I)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=k,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(he[27],fe([0,1,4]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(he[195],fe([0,1,2]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class R{constructor(y,T,I){this._extHostNotebooks=T,this._textDocumentsAndEditors=I}$willAddInteractiveDocument(y,T,I,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],modeId:I,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=R}),define(he[196],fe([0,1,17]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(T,I,D){this._deferredPromises=new Map,this._id=T,this._shared=I,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of C.values())i.complete()}catch(i){for(const P of C.values())P.error(i)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,T])=>T!==void 0).map(([T])=>T)}get whenReady(){return this._init}get(T,I){let D=this._value[T];return typeof D=="undefined"&&(D=I),D}update(T,I){this._value[T]=I;let D=this._deferredPromises.get(T);if(D!==void 0)return D.p;const C=new g.DeferredPromise;return this._deferredPromises.set(T,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class k extends R{constructor(T,I){super(T.identifier.value,!0,I);this._extension=T}setKeysForSync(T){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},T)}}e.ExtensionGlobalMemento=k}),define(he[197],fe([0,1,3,2,12]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let y=class{constructor(I,D){this._logService=I,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,D,C){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(I)).acceptModelChanged(D,C)}$acceptDirtyStateChanged(I,D){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(I)).acceptDirty(D)}$acceptModelSaved(I){const D=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(I));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(I,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,D);const C=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(I));C.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};y=je([He(0,k.ILogService)],y),e.ExtHostNotebookDocuments=y}),define(he[13],fe([0,1,4]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class R{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=R});var it=this&&this.__classPrivateFieldSet||function(X,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,g):k?k.value=g:e.set(X,g),g},xe=this&&this.__classPrivateFieldGet||function(X,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(X):R?R.value:e.get(X)};define(he[198],fe([0,1,26,3]),function(X,e,g,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(I,D){k.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(I.identifier),it(this,k,D,"f"),xe(this,k,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(I){return xe(this,k,"f").get(this._id,I)}store(I,D){return xe(this,k,"f").store(this._id,I,D)}delete(I){return xe(this,k,"f").delete(this._id,I)}}e.ExtensionSecrets=y,k=new WeakMap}),define(he[117],fe([0,1,4,3]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(T){this._enabled=T}$onDidChangeTelemetryEnabled(T){this._enabled=T,this._onDidChangeTelemetryEnabled.fire(T)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(he[118],fe([0,1,3]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(T){T[T.NewChild=0]="NewChild",T[T.Disposed=1]="Disposed",T[T.Invalidated=2]="Invalidated",T[T.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const k=new WeakMap,y=T=>{let I=k.get(T);return I||(I={children:new Map,bus:new g.Emitter},k.set(T,I)),I};e.getPrivateApiFor=y}),define(he[49],fe([0,1,4,3,13]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var y;(function(I){function D(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,protocol:i.protocol}}I.fromApiTunnel=D;function C(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public,protocol:i.protocol}}I.fromServiceTunnel=C})(y=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let T=class{constructor(D){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,C){return{dispose:()=>{}}}async $providePortAttributes(D,C,i,P,u){return[]}async $forwardPort(D,C){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=je([He(0,k.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var it=this&&this.__classPrivateFieldSet||function(X,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,g):k?k.value=g:e.set(X,g),g},xe=this&&this.__classPrivateFieldGet||function(X,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(X):R?R.value:e.get(X)};define(he[7],fe([0,1,18,15,95,23,98,14,2,32,41,116,118]),function(X,e,g,R,k,y,T,I,D,C,i,P,u){"use strict";var p,l,c,S,w,E,d,h,v,t,s,r,n,a,f,m,b,_,o,A;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestMessage=e.TestItemImpl=e.TestRunRequest=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function F(V){function U(){return Reflect.construct(V,arguments,this.constructor)}return Object.defineProperty(U,"name",Object.getOwnPropertyDescriptor(V,"name")),Object.setPrototypeOf(U,V),Object.setPrototypeOf(U.prototype,V.prototype),U}let $=w=class{constructor(U){p.set(this,void 0),it(this,p,U,"f")}static from(...U){let re=U;return new w(function(){if(re){for(const ke of re)ke&&typeof ke.dispose=="function"&&ke.dispose();re=void 0}})}dispose(){typeof xe(this,p,"f")=="function"&&(xe(this,p,"f").call(this),it(this,p,void 0,"f"))}};p=new WeakMap,$=w=je([F],$),e.Disposable=$;let W=E=class{constructor(U,re){if(U<0)throw(0,R.illegalArgument)("line must be non-negative");if(re<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=U,this._character=re}static Min(...U){if(U.length===0)throw new TypeError;let re=U[0];for(let ke=1;ke<U.length;ke++){const Ke=U[ke];Ke.isBefore(re)&&(re=Ke)}return re}static Max(...U){if(U.length===0)throw new TypeError;let re=U[0];for(let ke=1;ke<U.length;ke++){const Ke=U[ke];Ke.isAfter(re)&&(re=Ke)}return re}static isPosition(U){if(!U)return!1;if(U instanceof E)return!0;let{line:re,character:ke}=U;return typeof re=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<U._character}isBeforeOrEqual(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<=U._character}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this._line===U._line&&this._character===U._character}compareTo(U){return this._line<U._line?-1:this._line>U.line?1:this._character<U._character?-1:this._character>U._character?1:0}translate(U,re=0){if(U===null||re===null)throw(0,R.illegalArgument)();let ke;return typeof U=="undefined"?ke=0:typeof U=="number"?ke=U:(ke=typeof U.lineDelta=="number"?U.lineDelta:0,re=typeof U.characterDelta=="number"?U.characterDelta:0),ke===0&&re===0?this:new E(this.line+ke,this.character+re)}with(U,re=this.character){if(U===null||re===null)throw(0,R.illegalArgument)();let ke;return typeof U=="undefined"?ke=this.line:typeof U=="number"?ke=U:(ke=typeof U.line=="number"?U.line:this.line,re=typeof U.character=="number"?U.character:this.character),ke===this.line&&re===this.character?this:new E(ke,re)}toJSON(){return{line:this.line,character:this.character}}};W=E=je([F],W),e.Position=W;let Q=d=class{constructor(U,re,ke,Ke){let nt,st;if(typeof U=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ke=="number"?(nt=new W(U,re),st=new W(ke,Ke)):U instanceof W&&re instanceof W&&(nt=U,st=re),!nt||!st)throw new Error("Invalid arguments");nt.isBefore(st)?(this._start=nt,this._end=st):(this._start=st,this._end=nt)}static isRange(U){return U instanceof d?!0:U?W.isPosition(U.start)&&W.isPosition(U.end):!1}get start(){return this._start}get end(){return this._end}contains(U){return U instanceof d?this.contains(U._start)&&this.contains(U._end):U instanceof W?!(U.isBefore(this._start)||this._end.isBefore(U)):!1}isEqual(U){return this._start.isEqual(U._start)&&this._end.isEqual(U._end)}intersection(U){const re=W.Max(U.start,this._start),ke=W.Min(U.end,this._end);if(!re.isAfter(ke))return new d(re,ke)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const re=W.Min(U.start,this._start),ke=W.Max(U.end,this.end);return new d(re,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(U,re=this.end){if(U===null||re===null)throw(0,R.illegalArgument)();let ke;return U?W.isPosition(U)?ke=U:(ke=U.start||this.start,re=U.end||this.end):ke=this.start,ke.isEqual(this._start)&&re.isEqual(this.end)?this:new d(ke,re)}toJSON(){return[this.start,this.end]}};Q=d=je([F],Q),e.Range=Q;let H=h=class extends Q{constructor(U,re,ke,Ke){let nt,st;if(typeof U=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ke=="number"?(nt=new W(U,re),st=new W(ke,Ke)):U instanceof W&&re instanceof W&&(nt=U,st=re),!nt||!st)throw new Error("Invalid arguments");super(nt,st);this._anchor=nt,this._active=st}static isSelection(U){return U instanceof h?!0:U?Q.isRange(U)&&W.isPosition(U.anchor)&&W.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};H=h=je([F],H),e.Selection=H;class N{constructor(U,re,ke){if(typeof U!="string"||U.length===0)throw(0,R.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,R.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,R.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(re),this.connectionToken=ke}}e.ResolvedAuthority=N;class x extends Error{constructor(U,re=P.RemoteAuthorityResolverErrorCode.Unknown,ke){super(U);this._message=U,this._code=re,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,x.prototype)}static NotAvailable(U,re){return new x(U,P.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(U){return new x(U,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=x;var L;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(L=e.EndOfLine||(e.EndOfLine={}));var G;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(G=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let M=v=class{constructor(U,re){this._range=U,this._newText=re}static isTextEdit(U){return U instanceof v?!0:U?Q.isRange(U)&&typeof U.newText=="string":!1}static replace(U,re){return new v(U,re)}static insert(U,re){return v.replace(new Q(U,U),re)}static delete(U){return v.replace(U,"")}static setEndOfLine(U){const re=new v(new Q(new W(0,0),new W(0,0)),"");return re.newEol=U,re}get range(){return this._range}set range(U){if(U&&!Q.isRange(U))throw(0,R.illegalArgument)("range");this._range=U}get newText(){return this._newText||""}set newText(U){if(U&&typeof U!="string")throw(0,R.illegalArgument)("newText");this._newText=U}get newEol(){return this._newEol}set newEol(U){if(U&&typeof U!="number")throw(0,R.illegalArgument)("newEol");this._newEol=U}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};M=v=je([F],M),e.TextEdit=M;var O;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace"})(O=e.FileEditType||(e.FileEditType={}));let B=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(U,re,ke,Ke){this._edits.push({_type:1,from:U,to:re,options:ke,metadata:Ke})}createFile(U,re,ke){this._edits.push({_type:1,from:void 0,to:U,options:re,metadata:ke})}deleteFile(U,re,ke){this._edits.push({_type:1,from:U,to:void 0,options:re,metadata:ke})}replaceNotebookMetadata(U,re,ke){this._edits.push({_type:3,metadata:ke,uri:U,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(U,re,ke,Ke,nt){let st,ot,Dt=[],Pt;if($t.isNotebookRange(re)&&Lt.isNotebookCellDataArray(ke)&&!Lt.isNotebookCellDataArray(Ke)?(st=re.start,ot=re.end,Dt=ke,Pt=Ke):typeof re=="number"&&typeof ke=="number"&&Lt.isNotebookCellDataArray(Ke)&&(st=re,ot=ke,Dt=Ke,Pt=nt),st===void 0||ot===void 0)throw new Error("Invalid arguments");(st!==ot||Dt.length>0)&&this._edits.push({_type:5,uri:U,index:st,count:ot-st,cells:Dt,metadata:Pt})}replaceNotebookCellMetadata(U,re,ke,Ke){this._edits.push({_type:3,metadata:Ke,uri:U,edit:{editType:8,index:re,metadata:ke}})}replace(U,re,ke,Ke){this._edits.push({_type:2,uri:U,edit:new M(re,ke),metadata:Ke})}insert(U,re,ke,Ke){this.replace(U,new Q(re,re),ke,Ke)}delete(U,re,ke){this.replace(U,re,"",ke)}has(U){return this._edits.some(re=>re._type===2&&re.uri.toString()===U.toString())}set(U,re){if(re)for(const ke of re)ke&&this._edits.push({_type:2,uri:U,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Ke=this._edits[ke];Ke._type===2&&Ke.uri.toString()===U.toString()&&(this._edits[ke]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get(U){const re=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===U.toString()&&re.push(ke.edit);return re}entries(){const U=new y.ResourceMap;for(let re of this._edits)if(re._type===2){let ke=U.get(re.uri);ke||(ke=[re.uri,[]],U.set(re.uri,ke)),ke[1].push(re.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};B=je([F],B),e.WorkspaceEdit=B;let z=t=class{constructor(U){this._tabstop=1,this.value=U||""}static isSnippetString(U){return U instanceof t?!0:U?typeof U.value=="string":!1}static _escape(U){return U.replace(/\$|}|\\/g,"\\$&")}appendText(U){return this.value+=t._escape(U),this}appendTabstop(U=this._tabstop++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,re=this._tabstop++){if(typeof U=="function"){const ke=new t;ke._tabstop=this._tabstop,U(ke),this._tabstop=ke._tabstop,U=ke.value}else U=t._escape(U);return this.value+="${",this.value+=re,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,re=this._tabstop++){const ke=U.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(U,re){if(typeof re=="function"){const ke=new t;ke._tabstop=this._tabstop,re(ke),this._tabstop=ke._tabstop,re=ke.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,re&&(this.value+=":",this.value+=re),this.value+="}",this}};z=t=je([F],z),e.SnippetString=z;var J;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(J=e.DiagnosticTag||(e.DiagnosticTag={}));var ce;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(ce=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ye=s=class{constructor(U,re){if(this.uri=U,re)if(re instanceof Q)this.range=re;else if(re instanceof W)this.range=new Q(re,re);else throw new Error("Illegal argument")}static isLocation(U){return U instanceof s?!0:U?Q.isRange(U.range)&&D.URI.isUri(U.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ye=s=je([F],ye),e.Location=ye;let Fe=class{constructor(U,re){this.location=U,this.message=re}static is(U){return U?typeof U.message=="string"&&U.location&&Q.isRange(U.location.range)&&D.URI.isUri(U.location.uri):!1}static isEqual(U,re){return U===re?!0:!U||!re?!1:U.message===re.message&&U.location.range.isEqual(re.location.range)&&U.location.uri.toString()===re.location.uri.toString()}};Fe=je([F],Fe),e.DiagnosticRelatedInformation=Fe;let Re=class{constructor(U,re,ke=ce.Error){if(!Q.isRange(U))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=U,this.message=re,this.severity=ke}toJSON(){return{severity:ce[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,re){return U===re?!0:!U||!re?!1:U.message===re.message&&U.severity===re.severity&&U.code===re.code&&U.severity===re.severity&&U.source===re.source&&U.range.isEqual(re.range)&&(0,g.equals)(U.tags,re.tags)&&(0,g.equals)(U.relatedInformation,re.relatedInformation,Fe.isEqual)}};Re=je([F],Re),e.Diagnostic=Re;let Ne=class{constructor(U,re){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=re}};Ne=je([F],Ne),e.Hover=Ne;var Ve;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(Ve=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ze=class{constructor(U,re=Ve.Text){this.range=U,this.kind=re}toJSON(){return{range:this.range,kind:Ve[this.kind]}}};ze=je([F],ze),e.DocumentHighlight=ze;var j;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(j=e.SymbolKind||(e.SymbolKind={}));var Z;(function(V){V[V.Deprecated=1]="Deprecated"})(Z=e.SymbolTag||(e.SymbolTag={}));let ie=r=class{constructor(U,re,ke,Ke,nt){this.name=U,this.kind=re,this.containerName=nt,typeof ke=="string"&&(this.containerName=ke),Ke instanceof ye?this.location=Ke:ke instanceof Q&&(this.location=new ye(Ke,ke)),r.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:j[this.kind],location:this.location,containerName:this.containerName}}};ie=r=je([F],ie),e.SymbolInformation=ie;let oe=n=class{constructor(U,re,ke,Ke,nt){this.name=U,this.detail=re,this.kind=ke,this.range=Ke,this.selectionRange=nt,this.children=[],n.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children&&U.children.forEach(n.validate)}};oe=n=je([F],oe),e.DocumentSymbol=oe;var ve;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(ve=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ee=class{constructor(U,re){this.title=U,this.kind=re}};ee=je([F],ee),e.CodeAction=ee;let ue=a=class{constructor(U){this.value=U}append(U){return new a(this.value?this.value+a.sep+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+a.sep)}};ue.sep=".",ue=a=je([F],ue),e.CodeActionKind=ue,ue.Empty=new ue(""),ue.QuickFix=ue.Empty.append("quickfix"),ue.Refactor=ue.Empty.append("refactor"),ue.RefactorExtract=ue.Refactor.append("extract"),ue.RefactorInline=ue.Refactor.append("inline"),ue.RefactorRewrite=ue.Refactor.append("rewrite"),ue.Source=ue.Empty.append("source"),ue.SourceOrganizeImports=ue.Source.append("organizeImports"),ue.SourceFixAll=ue.Source.append("fixAll");let Ie=class{constructor(U,re){if(this.range=U,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ie=je([F],Ie),e.SelectionRange=Ie;class $e{constructor(U,re,ke,Ke,nt,st){this.kind=U,this.name=re,this.detail=ke,this.uri=Ke,this.range=nt,this.selectionRange=st}}e.CallHierarchyItem=$e;class qe{constructor(U,re){this.fromRanges=re,this.from=U}}e.CallHierarchyIncomingCall=qe;class be{constructor(U,re){this.fromRanges=re,this.to=U}}e.CallHierarchyOutgoingCall=be;let tt=class{constructor(U,re){this.range=U,this.command=re}get isResolved(){return!!this.command}};tt=je([F],tt),e.CodeLens=tt;let K=f=class{constructor(U,re=!1){l.set(this,void 0),it(this,l,new k.MarkdownString(U,{supportThemeIcons:re}),"f")}static isMarkdownString(U){return U instanceof f?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}get value(){return xe(this,l,"f").value}set value(U){xe(this,l,"f").value=U}get isTrusted(){return xe(this,l,"f").isTrusted}set isTrusted(U){xe(this,l,"f").isTrusted=U}get supportThemeIcons(){return xe(this,l,"f").supportThemeIcons}set supportThemeIcons(U){xe(this,l,"f").supportThemeIcons=U}appendText(U){return xe(this,l,"f").appendText(U),this}appendMarkdown(U){return xe(this,l,"f").appendMarkdown(U),this}appendCodeblock(U,re){return xe(this,l,"f").appendCodeblock(re??"",U),this}};l=new WeakMap,K=f=je([F],K),e.MarkdownString=K;let te=class{constructor(U,re){this.label=U,this.documentation=re}};te=je([F],te),e.ParameterInformation=te;let pe=class{constructor(U,re){this.label=U,this.documentation=re,this.parameters=[]}};pe=je([F],pe),e.SignatureInformation=pe;let Ue=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ue=je([F],Ue),e.SignatureHelp=Ue;var We;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(We=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ze;(function(V){V[V.Other=0]="Other",V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(Ze=e.InlayHintKind||(e.InlayHintKind={}));let Pe=class{constructor(U,re,ke){this.text=U,this.position=re,this.kind=ke}};Pe=je([F],Pe),e.InlayHint=Pe;var Ce;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ae;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(Ae=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(V){V[V.Deprecated=1]="Deprecated"})(se=e.CompletionItemTag||(e.CompletionItemTag={}));let le=class{constructor(U,re){this.label=U,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&Ae[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};le=je([F],le),e.CompletionItem=le;let me=class{constructor(U=[],re=!1){this.items=U,this.isIncomplete=re}};me=je([F],me),e.CompletionList=me;let we=class{constructor(U,re,ke){this.text=U,this.range=re,this.command=ke}};we=je([F],we),e.InlineSuggestion=we;let q=class{constructor(U){this.items=U}};q=je([F],q),e.InlineSuggestions=q;var ge;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(ge=e.ViewColumn||(e.ViewColumn={}));var _e;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(_e=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Te;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(Te=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Oe;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Oe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ge;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Ge=e.TextEditorRevealType||(e.TextEditorRevealType={}));var et;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(et=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(Qe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Xe;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(Xe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(V){function U(re){switch(re){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=U}(et=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let lt=class{constructor(U,re){if(re&&!D.URI.isUri(re))throw(0,R.illegalArgument)("target");if(!Q.isRange(U)||U.isEmpty)throw(0,R.illegalArgument)("range");this.range=U,this.target=re}};lt=je([F],lt),e.DocumentLink=lt;let ut=class{constructor(U,re,ke,Ke){this.red=U,this.green=re,this.blue=ke,this.alpha=Ke}};ut=je([F],ut),e.Color=ut;let Ee=class{constructor(U,re){if(re&&!(re instanceof ut))throw(0,R.illegalArgument)("color");if(!Q.isRange(U)||U.isEmpty)throw(0,R.illegalArgument)("range");this.range=U,this.color=re}};Ee=je([F],Ee),e.ColorInformation=Ee;let Se=class{constructor(U){if(!U||typeof U!="string")throw(0,R.illegalArgument)("label");this.label=U}};Se=je([F],Se),e.ColorPresentation=Se;var ae;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(ae=e.ColorFormat||(e.ColorFormat={}));var Y;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(Y=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Be{constructor(U,re,ke){if(this.startIndex=U,this.length=re,this.tooltip=ke,typeof U!="number"||U<0)throw(0,R.illegalArgument)("startIndex");if(typeof re!="number"||re<1)throw(0,R.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=Be;class De{constructor(U){this.options=U,typeof U!="object"&&(0,R.illegalArgument)("options")}}e.TerminalProfile=De;var Je;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(Je=e.TaskRevealKind||(e.TaskRevealKind={}));var Ye;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(Ye=e.TaskPanelKind||(e.TaskPanelKind={}));let rt=m=class{constructor(U,re){if(typeof U!="string"||typeof re!="string")throw(0,R.illegalArgument)("name");this._id=U}static from(U){switch(U){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}get id(){return this._id}};rt.Clean=new m("clean","Clean"),rt.Build=new m("build","Build"),rt.Rebuild=new m("rebuild","Rebuild"),rt.Test=new m("test","Test"),rt=m=je([F],rt),e.TaskGroup=rt;function mt(V){let U="";for(let re=0;re<V.length;re++)U+=V[re].replace(/,/g,",,")+",";return U}let bt=class{constructor(U,re,ke){if(typeof U!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=U,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=ke):this._options=re)}get process(){return this._process}set process(U){if(typeof U!="string")throw(0,R.illegalArgument)("process");this._process=U}get args(){return this._args}set args(U){Array.isArray(U)||(U=[]),this._args=U}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("process"),this._process!==void 0&&U.push(this._process),this._args&&this._args.length>0)for(let re of this._args)U.push(re);return mt(U)}};bt=je([F],bt),e.ProcessExecution=bt;let wt=class{constructor(U,re,ke){if(this._args=[],Array.isArray(re)){if(!U)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,R.illegalArgument)("command");this._command=U,this._args=re,this._options=ke}else{if(typeof U!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=U,this._options=re}}get commandLine(){return this._commandLine}set commandLine(U){if(typeof U!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=U}get command(){return this._command?this._command:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,R.illegalArgument)("command");this._command=U}get args(){return this._args}set args(U){this._args=U||[]}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("shell"),this._commandLine!==void 0&&U.push(this._commandLine),this._command!==void 0&&U.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)U.push(typeof re=="string"?re:re.value);return mt(U)}};wt=je([F],wt),e.ShellExecution=wt;var Ct;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(Ct=e.ShellQuoting||(e.ShellQuoting={}));var yt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(yt=e.TaskScope||(e.TaskScope={}));class Tt{constructor(U){this._callback=U}computeId(){return"customExecution"+(0,C.generateUuid)()}set callback(U){this._callback=U}get callback(){return this._callback}}e.CustomExecution=Tt;let gt=b=class{constructor(U,re,ke,Ke,nt,st){this.__deprecated=!1,this._definition=this.definition=U;let ot;typeof re=="string"?(this._name=this.name=re,this._source=this.source=ke,this.execution=Ke,ot=nt,this.__deprecated=!0):re===yt.Global||re===yt.Workspace?(this.target=re,this._name=this.name=ke,this._source=this.source=Ke,this.execution=nt,ot=st):(this.target=re,this._name=this.name=ke,this._source=this.source=Ke,this.execution=nt,ot=st),typeof ot=="string"?(this._problemMatchers=[ot],this._hasDefinedMatchers=!0):Array.isArray(ot)?(this._problemMatchers=ot,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(U){this.__id=U}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof bt?this._definition={type:b.ProcessType,id:this._execution.computeId()}:this._execution instanceof wt?this._definition={type:b.ShellType,id:this._execution.computeId()}:this._execution instanceof Tt?this._definition={type:b.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:b.EmptyType,id:(0,C.generateUuid)()}}get definition(){return this._definition}set definition(U){if(U==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=U}get scope(){return this._scope}set target(U){this.clear(),this._scope=U}get name(){return this._name}set name(U){if(typeof U!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=U}get execution(){return this._execution}set execution(U){U===null&&(U=void 0),this.clear(),this._execution=U;const re=this._definition.type;(b.EmptyType===re||b.ProcessType===re||b.ShellType===re||b.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(U){if(Array.isArray(U))this.clear(),this._problemMatchers=U,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.clear(),this._isBackground=U}get source(){return this._source}set source(U){if(typeof U!="string"||U.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=U}get group(){return this._group}set group(U){U===null&&(U=void 0),this.clear(),this._group=U}get detail(){return this._detail}set detail(U){U===null&&(U=void 0),this._detail=U}get presentationOptions(){return this._presentationOptions}set presentationOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._presentationOptions=U}get runOptions(){return this._runOptions}set runOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._runOptions=U}};gt.ExtensionCallbackType="customExecution",gt.ProcessType="process",gt.ShellType="shell",gt.EmptyType="$empty",gt=b=je([F],gt),e.Task=gt;var dt;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(dt=e.ProgressLocation||(e.ProgressLocation={}));let pt=class{constructor(U,re=Et.None){this.collapsibleState=re,D.URI.isUri(U)?this.resourceUri=U:this.label=U}};pt=je([F],pt),e.TreeItem=pt;var Et;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let At=class{constructor(U,re){this.id=U,this.color=re}};At=je([F],At),e.ThemeIcon=At,At.File=new At("file"),At.Folder=new At("folder");let kt=class{constructor(U){this.id=U}};kt=je([F],kt),e.ThemeColor=kt;var _n;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(_n=e.ConfigurationTarget||(e.ConfigurationTarget={}));let jt=class{constructor(U,re){if(typeof U!="string"&&(!U||!D.URI.isUri(U)&&!D.URI.isUri(U.uri)))throw(0,R.illegalArgument)("base");if(typeof re!="string")throw(0,R.illegalArgument)("pattern");typeof U=="string"?(this.baseFolder=D.URI.file(U),this.base=U):D.URI.isUri(U)?(this.baseFolder=U,this.base=U.fsPath):(this.baseFolder=U.uri,this.base=U.uri.fsPath),this.pattern=re}};jt=je([F],jt),e.RelativePattern=jt;let St=class{constructor(U,re,ke,Ke){this.enabled=typeof U=="boolean"?U:!0,typeof re=="string"&&(this.condition=re),typeof ke=="string"&&(this.hitCondition=ke),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,C.generateUuid)()),this._id}};St=je([F],St),e.Breakpoint=St;let Xt=class extends St{constructor(U,re,ke,Ke,nt){super(re,ke,Ke,nt);if(U===null)throw(0,R.illegalArgument)("location");this.location=U}};Xt=je([F],Xt),e.SourceBreakpoint=Xt;let Yt=class extends St{constructor(U,re,ke,Ke,nt){super(re,ke,Ke,nt);this.functionName=U}};Yt=je([F],Yt),e.FunctionBreakpoint=Yt;let ht=class extends St{constructor(U,re,ke,Ke,nt,st,ot){super(Ke,nt,st,ot);if(!re)throw(0,R.illegalArgument)("dataId");this.label=U,this.dataId=re,this.canPersist=ke}};ht=je([F],ht),e.DataBreakpoint=ht;let qt=class{constructor(U,re,ke){this.command=U,this.args=re||[],this.options=ke}};qt=je([F],qt),e.DebugAdapterExecutable=qt;let Ht=class{constructor(U,re){this.port=U,this.host=re}};Ht=je([F],Ht),e.DebugAdapterServer=Ht;let Jt=class{constructor(U){this.path=U}};Jt=je([F],Jt),e.DebugAdapterNamedPipeServer=Jt;let Zt=class{constructor(U){this.implementation=U}};Zt=je([F],Zt),e.DebugAdapterInlineImplementation=Zt;let It=class{constructor(U,re){this.range=U,this.expression=re}};It=je([F],It),e.EvaluatableExpression=It;var hn;(function(V){V[V.Automatic=0]="Automatic",V[V.Explicit=1]="Explicit"})(hn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let en=class{constructor(U,re){this.range=U,this.text=re}};en=je([F],en),e.InlineValueText=en;let Bt=class{constructor(U,re,ke=!0){this.range=U,this.variableName=re,this.caseSensitiveLookup=ke}};Bt=je([F],Bt),e.InlineValueVariableLookup=Bt;let ct=class{constructor(U,re){this.range=U,this.expression=re}};ct=je([F],ct),e.InlineValueEvaluatableExpression=ct;let tn=class{constructor(U,re){this.frameId=U,this.stoppedLocation=re}};tn=je([F],tn),e.InlineValueContext=tn;var Ot;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=_=class extends Error{constructor(U,re=i.FileSystemProviderErrorCode.Unknown,ke){super(D.URI.isUri(U)?U.toString(!0):U);this.code=ke?.name??"Unknown",(0,i.markAsFileSystemProviderError)(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(U){return new _(U,i.FileSystemProviderErrorCode.FileExists,_.FileExists)}static FileNotFound(U){return new _(U,i.FileSystemProviderErrorCode.FileNotFound,_.FileNotFound)}static FileNotADirectory(U){return new _(U,i.FileSystemProviderErrorCode.FileNotADirectory,_.FileNotADirectory)}static FileIsADirectory(U){return new _(U,i.FileSystemProviderErrorCode.FileIsADirectory,_.FileIsADirectory)}static NoPermissions(U){return new _(U,i.FileSystemProviderErrorCode.NoPermissions,_.NoPermissions)}static Unavailable(U){return new _(U,i.FileSystemProviderErrorCode.Unavailable,_.Unavailable)}};Nt=_=je([F],Nt),e.FileSystemError=Nt;let Gt=class{constructor(U,re,ke){this.start=U,this.end=re,this.kind=ke}};Gt=je([F],Gt),e.FoldingRange=Gt;var Sn;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(Sn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var yn;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(yn=e.CommentMode||(e.CommentMode={}));class mn{constructor(U,re=[]){this.tokenTypes=U,this.tokenModifiers=re}}e.SemanticTokensLegend=mn;function nn(V){return typeof V=="undefined"||(0,I.isStringArray)(V)}class rn{constructor(U){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,U){this._hasLegend=!0;for(let re=0,ke=U.tokenTypes.length;re<ke;re++)this._tokenTypeStrToInt.set(U.tokenTypes[re],re);for(let re=0,ke=U.tokenModifiers.length;re<ke;re++)this._tokenModifierStrToInt.set(U.tokenModifiers[re],re)}}push(U,re,ke,Ke,nt){if(typeof U=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ke=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(U,re,ke,Ke,nt);if(Q.isRange(U)&&typeof re=="string"&&nn(ke))return this._push(U,re,ke);throw(0,R.illegalArgument)()}_push(U,re,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const Ke=U.start.line,nt=U.start.character,st=U.end.character-U.start.character,ot=this._tokenTypeStrToInt.get(re);let Dt=0;if(ke)for(const Pt of ke){if(!this._tokenModifierStrToInt.has(Pt))throw new Error("`tokenModifier` is not in the provided legend");const Rt=this._tokenModifierStrToInt.get(Pt);Dt|=1<<Rt>>>0}this._pushEncoded(Ke,nt,st,ot,Dt)}_pushEncoded(U,re,ke,Ke,nt){if(this._dataIsSortedAndDeltaEncoded&&(U<this._prevLine||U===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Pt=0,Rt=0;for(let Mt=0;Mt<Dt;Mt++){let Ut=this._data[5*Mt],un=this._data[5*Mt+1];Ut===0?(Ut=Pt,un+=Rt):Ut+=Pt,this._data[5*Mt]=Ut,this._data[5*Mt+1]=un,Pt=Ut,Rt=un}}let st=U,ot=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ot-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ot,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=nt,this._prevLine=U,this._prevChar=re}static _sortAndDeltaEncode(U){let re=[];const ke=U.length/5|0;for(let ot=0;ot<ke;ot++)re[ot]=ot;re.sort((ot,Dt)=>{const Pt=U[5*ot],Rt=U[5*Dt];if(Pt===Rt){const Mt=U[5*ot+1],Ut=U[5*Dt+1];return Mt-Ut}return Pt-Rt});const Ke=new Uint32Array(U.length);let nt=0,st=0;for(let ot=0;ot<ke;ot++){const Dt=5*re[ot],Pt=U[Dt+0],Rt=U[Dt+1],Mt=U[Dt+2],Ut=U[Dt+3],un=U[Dt+4],$n=Pt-nt,Kn=$n===0?Rt-st:Rt,dn=5*ot;Ke[dn+0]=$n,Ke[dn+1]=Kn,Ke[dn+2]=Mt,Ke[dn+3]=Ut,Ke[dn+4]=un,nt=Pt,st=Rt}return Ke}build(U){return this._dataIsSortedAndDeltaEncoded?new zt(new Uint32Array(this._data),U):new zt(rn._sortAndDeltaEncode(this._data),U)}}e.SemanticTokensBuilder=rn;class zt{constructor(U,re){this.resultId=re,this.data=U}}e.SemanticTokens=zt;class sn{constructor(U,re,ke){this.start=U,this.deleteCount=re,this.data=ke}}e.SemanticTokensEdit=sn;class Dn{constructor(U,re){this.resultId=re,this.edits=U}}e.SemanticTokensEdits=Dn;var Cn;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(Cn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Vt;(function(V){V[V.Initial=1]="Initial",V[V.Dynamic=2]="Dynamic"})(Vt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Kt=class{constructor(){}};Kt.Back={iconPath:new At("arrow-left")},Kt=je([F],Kt),e.QuickInputButtons=Kt;var kn;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(kn=e.ExtensionKind||(e.ExtensionKind={}));class In{constructor(U,re,ke){this.badge=U,this.tooltip=re,this.color=ke}static validate(U){if(U.badge&&U.badge.length!==1&&U.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=In;let on=class{constructor(U){this.kind=U}};on=je([F],on),e.ColorTheme=on;var an;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(U,re){if(U<0)throw(0,R.illegalArgument)("start must be positive");if(re<0)throw(0,R.illegalArgument)("end must be positive");U<=re?(this._start=U,this._end=re):(this._start=re,this._end=U)}static isNotebookRange(U){return U instanceof $t?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(U){let re=this._start,ke=this._end;return U.start!==void 0&&(re=U.start),U.end!==void 0&&(ke=U.end),re===this._start&&ke===this._end?this:new $t(re,ke)}}e.NotebookRange=$t;class Lt{constructor(U,re,ke,Ke,nt,st,ot){this.kind=U,this.value=re,this.languageId=ke,this.mime=Ke,this.outputs=nt??[],this.metadata=st,this.executionSummary=ot,Lt.validate(this)}static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(re=>Lt.isNotebookCellData(re))}static isNotebookCellData(U){return!0}}e.NotebookCellData=Lt;class ln{constructor(U){this.cells=U}}e.NotebookData=ln;class Me{constructor(U,re){this.data=U,this.mime=re;const ke=(0,T.normalizeMimeType)(re,!0);if(!ke)throw new Error("INVALID mime type, must not be empty or falsy: "+re);this.mime=ke}static isNotebookCellOutputItem(U){return U instanceof Me?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const re={name:U.name,message:U.message,stack:U.stack};return Me.json(re,"application/vnd.code.notebook.error")}static stdout(U){return Me.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Me.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,re="application/octet-stream"){return new Me(U,re)}static text(U,re=T.Mimes.text){const ke=xe(Me,c,"f",S).encode(String(U));return new Me(ke,re)}static json(U,re="application/json"){const ke=JSON.stringify(U,void 0,"	");return Me.text(ke,re)}}e.NotebookCellOutputItem=Me,c=Me,S={value:new TextEncoder};class Wt{constructor(U,re,ke){this.items=Wt.ensureUniqueMimeTypes(U,!0),typeof re=="string"?(this.id=re,this.metadata=ke):(this.id=(0,C.generateUuid)(),this.metadata=re??ke)}static isNotebookCellOutput(U){return U instanceof Wt?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&(0,I.isArray)(U.items)}static ensureUniqueMimeTypes(U,re=!1){const ke=new Set,Ke=new Set;for(let nt=0;nt<U.length;nt++){const st=U[nt],ot=(0,T.normalizeMimeType)(st.mime);if(!ke.has(ot)){ke.add(ot);continue}Ke.add(nt),re&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Ke.size===0?U:U.filter((nt,st)=>!Ke.has(st))}}e.NotebookCellOutput=Wt;var gn;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(gn=e.NotebookCellKind||(e.NotebookCellKind={}));var ft;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(ft=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Pn;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(Pn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var An;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(An=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pn{constructor(U,re){this.text=U,this.alignment=re}}e.NotebookCellStatusBarItem=pn;var vn;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(vn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Tn{constructor(U,re=[]){this.uri=U,this.provides=(0,g.asArray)(re)}}e.NotebookRendererScript=Tn;let cn=class{constructor(U,re){this.label=U,this.timestamp=re}};cn=je([F],cn),e.TimelineItem=cn;var Rn;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(Rn=e.ExtensionMode||(e.ExtensionMode={}));var Ln;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(Ln=e.ExtensionRuntime||(e.ExtensionRuntime={}));var wn;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=4]="RegEx"})(wn=e.StandardTokenType||(e.StandardTokenType={}));class Fn{constructor(U,re){this.ranges=U,this.wordPattern=re}}e.LinkedEditingRanges=Fn;class Mn{constructor(U,re){this._port=U,this._autoForwardAction=re}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mn;var On;(function(V){V[V.Unset=0]="Unset",V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(On=e.TestResultState||(e.TestResultState={}));var bn;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information",V[V.Hint=3]="Hint"})(bn=e.TestMessageSeverity||(e.TestMessageSeverity={}));const Ft=(V,U,re,ke)=>{let Ke=re;return{enumerable:!0,configurable:!1,get(){return Ke},set(nt){ke(Ke,nt)||(Ke=nt,V.bus.fire([3,U,nt]))}}},ne=(V,U)=>V===U,de=(V,U)=>V===U?!0:!V||!U?!1:V.isEqual(U);class Le{constructor(U,re,ke=!1){this.tests=U,this.exclude=re,this.debug=ke}}e.TestRunRequest=Le;class at{constructor(U,re,ke,Ke,nt){this.data=Ke;const st=(0,u.getPrivateApiFor)(this);if(Object.defineProperties(this,{id:{value:U,enumerable:!0,writable:!1},uri:{value:ke,enumerable:!0,writable:!1},parent:{enumerable:!1,value:nt,writable:!1},children:{value:new y.ReadonlyMapView(st.children),enumerable:!0,writable:!1},range:Ft(st,"range",void 0,de),label:Ft(st,"label",re,ne),description:Ft(st,"description",void 0,ne),runnable:Ft(st,"runnable",!0,ne),debuggable:Ft(st,"debuggable",!1,ne),canResolveChildren:Ft(st,"canResolveChildren",!1,ne),busy:Ft(st,"busy",!1,ne),error:Ft(st,"error",void 0,ne)}),nt){if(!(nt instanceof at))throw new Error(`The "parent" passed in for TestItem ${U} is invalid`);const ot=(0,u.getPrivateApiFor)(nt);if(ot.children.has(U))throw new Error(`Attempted to insert a duplicate test item ID ${U}`);ot.children.set(U,this),ot.bus.fire([0,this])}}invalidate(){return this.invalidateResults()}invalidateResults(){(0,u.getPrivateApiFor)(this).bus.fire([2])}dispose(){this.parent&&(0,u.getPrivateApiFor)(this.parent).children.delete(this.id),(0,u.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemImpl=at;let vt=o=class{constructor(U){this.message=U,this.severity=bn.Error}static diff(U,re,ke){const Ke=new o(U);return Ke.expectedOutput=re,Ke.actualOutput=ke,Ke}};vt=o=je([F],vt),e.TestMessage=vt;let _t=class{constructor(U,re){this.covered=U,this.total=re}};_t=je([F],_t),e.CoveredCount=_t;let Nn=A=class{constructor(U,re,ke,Ke){this.uri=U,this.statementCoverage=re,this.branchCoverage=ke,this.functionCoverage=Ke}static fromDetails(U,re){const ke=new _t(0,0),Ke=new _t(0,0),nt=new _t(0,0);for(const ot of re)if("branches"in ot){ke.total+=1,ke.covered+=ot.executionCount>0?1:0;for(const Dt of ot.branches)Ke.total+=1,Ke.covered+=Dt.executionCount>0?1:0}else nt.total+=1,nt.covered+=ot.executionCount>0?1:0;const st=new A(U,ke,Ke.total>0?Ke:void 0,nt.total>0?nt:void 0);return st.detailedCoverage=re,st}};Nn=A=je([F],Nn),e.FileCoverage=Nn;let Un=class{constructor(U,re,ke=[]){this.executionCount=U,this.location=re,this.branches=ke}};Un=je([F],Un),e.StatementCoverage=Un;let xn=class{constructor(U,re){this.executionCount=U,this.location=re}};xn=je([F],xn),e.BranchCoverage=xn;let Bn=class{constructor(U,re){this.executionCount=U,this.location=re}};Bn=je([F],Bn),e.FunctionCoverage=Bn;var jn;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(jn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var qn;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(qn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Gn;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(Gn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(he[119],fe([0,1,52,10,8,145,107,7,18]),function(X,e,g,R,k,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function i(l,c){c?C.set(l,c):C.delete(l)}e.setWordDefinitionFor=i;function P(l){return C.get(l)}e.getWordDefinitionFor=P;class u extends y.MirrorTextModel{constructor(c,S,w,E,d,h,v,t){super(S,w,E,d);this._proxy=c,this._languageId=h,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(c){return(0,D.equals)(this._lines,c)}get document(){if(!this._document){const c=this;this._document={get uri(){return c._uri},get fileName(){return c._uri.fsPath},get isUntitled(){return c._uri.scheme===R.Schemas.untitled},get languageId(){return c._languageId},get version(){return c._versionId},get isClosed(){return c._isDisposed},get isDirty(){return c._isDirty},get notebook(){return c._notebook},save(){return c._save()},getText(S){return S?c._getTextInRange(S):c.getText()},get eol(){return c._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return c._lines.length},lineAt(S){return c._lineAt(S)},offsetAt(S){return c._offsetAt(S)},positionAt(S){return c._positionAt(S)},validateRange(S){return c._validateRange(S)},validatePosition(S){return c._validatePosition(S)},getWordRangeAtPosition(S,w){return c._getWordRangeAtPosition(S,w)}}}return Object.freeze(this._document)}_acceptLanguageId(c){(0,g.ok)(!this._isDisposed),this._languageId=c}_acceptIsDirty(c){(0,g.ok)(!this._isDisposed),this._isDirty=c}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(c){const S=this._validateRange(c);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const w=this._eol,E=S.start.line,d=S.end.line,h=[];h.push(this._lines[E].substring(S.start.character));for(let v=E+1;v<d;v++)h.push(this._lines[v]);return h.push(this._lines[d].substring(0,S.end.character)),h.join(w)}_lineAt(c){let S;if(c instanceof I.Position?S=c.line:typeof c=="number"&&(S=c),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new p(S,this._lines[S],S===this._lines.length-1)}_offsetAt(c){return c=this._validatePosition(c),this._ensureLineStarts(),this._lineStarts.getPrefixSum(c.line-1)+c.character}_positionAt(c){c=Math.floor(c),c=Math.max(0,c),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(c),w=this._lines[S.index].length;return new I.Position(S.index,Math.min(S.remainder,w))}_validateRange(c){if(!(c instanceof I.Range))throw new Error("Invalid argument");const S=this._validatePosition(c.start),w=this._validatePosition(c.end);return S===c.start&&w===c.end?c:new I.Range(S.line,S.character,w.line,w.character)}_validatePosition(c){if(!(c instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return c.with(0,0);let{line:S,character:w}=c,E=!1;if(S<0)S=0,w=0,E=!0;else if(S>=this._lines.length)S=this._lines.length-1,w=this._lines[S].length,E=!0;else{const d=this._lines[S].length;w<0?(w=0,E=!0):w>d&&(w=d,E=!0)}return E?new I.Position(S,w):c}_getWordRangeAtPosition(c,S){const w=this._validatePosition(c);if(!S)S=P(this._languageId);else if((0,k.regExpLeadsToEndlessLoop)(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const E=(0,T.getWordAtText)(w.character+1,(0,T.ensureValidWordDefinition)(S),this._lines[w.line],0);if(E)return new I.Range(w.line,E.startColumn-1,w.line,E.endColumn-1)}}e.ExtHostDocumentData=u;class p{constructor(c,S,w){this._line=c,this._text=S,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(he[199],fe([0,1,7,3,109,6,77,23,2,32]),function(X,e,g,R,k,y,T,I,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(u,p,l,c){this._notebook=l,this._selector=c,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,C.generateUuid)()}),this._init(),this._disposables.add(p.onDidChangeDocument(w=>{const E=this._cellUris.get(w.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(u.onDidChangeNotebookCells(w=>S(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const u=[],p=[];for(const l of this._notebook.getCells())l.kind===g.NotebookCellKind.Code&&(!this._selector||(0,T.score)(this._selector,l.document.uri,l.document.languageId,!0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),u.push(l.document.getText().length+1),p.push(l.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(u)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(p))}get version(){return this._versionId}getText(u){if(!u){let E="";for(const d of this._cells)E+=d.document.getText()+`
`;return E=E.slice(0,-1),E}if(u.isEmpty)return"";const p=this.locationAt(u.start),l=this.locationAt(u.end),c=this._cellUris.get(p.uri),S=this._cellUris.get(l.uri);if(c===void 0||S===void 0)return"";if(c===S)return this._cells[c].document.getText(new g.Range(p.range.start,l.range.end));const w=[this._cells[c].document.getText(new g.Range(p.range.start,new g.Position(this._cells[c].document.lineCount,0)))];for(let E=c+1;E<S;E++)w.push(this._cells[E].document.getText());return w.push(this._cells[S].document.getText(new g.Range(new g.Position(0,0),l.range.end))),w.join(`
`)}offsetAt(u){const p=this._cellLines.getIndexOf(u.line),l=this._cellLengths.getPrefixSum(p.index-1),c=this._cells[p.index].document.offsetAt(u.with(p.remainder));return l+c}positionAt(u){if(typeof u=="number"){const l=this._cellLengths.getIndexOf(u),c=this._cellLines.getPrefixSum(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(c)}const p=this._cellUris.get(u.uri);if(p!==void 0){const l=this._cellLines.getPrefixSum(p-1);return new g.Position(l+u.range.start.line,u.range.start.character)}return new g.Position(0,0)}locationAt(u){g.Range.isRange(u)||(u=new g.Range(u,u));const p=this._cellLines.getIndexOf(u.start.line);let l=p;u.isEmpty||(l=this._cellLines.getIndexOf(u.end.line));const c=new g.Position(p.remainder,u.start.character),S=new g.Position(l.remainder,u.end.character),w=new g.Range(c,S),E=this._cells[p.index];return new g.Location(E.document.uri,E.document.validateRange(w))}contains(u){return this._cellUris.has(u)}validateRange(u){const p=this.validatePosition(u.start),l=this.validatePosition(u.end);return u.with(p,l)}validatePosition(u){const p=this._cellLines.getIndexOf(u.line),l=new g.Position(p.remainder,u.character),c=this._cells[p.index].document.validatePosition(l),S=this._cellLines.getPrefixSum(p.index-1);return new g.Position(S+c.line,c.character)}}e.ExtHostNotebookConcatDocument=i}),define(he[200],fe([0,1,7,13,3]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(I){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let D=I==="light"?g.ColorThemeKind.Light:I==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=je([He(0,R.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(he[60],fe([0,1,4]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class R{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=T=>T,this.transformOutgoing=T=>T,this.transformOutgoingURI=T=>T,this.transformOutgoingScheme=T=>T)}}e.URITransformerService=R}),define(he[201],fe([0,1,22]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(D){let C=this.buffers.indexOf(D);return C<0&&(C=this.buffers.length,this.buffers.push(D)),C}}function k(I,D){if(D.serializeBuffersForPostMessage){const C=new R,i=(p,l)=>{if(l instanceof ArrayBuffer){const c=C.add(l);return{$$vscode_array_buffer_reference$$:!0,index:c}}else if(ArrayBuffer.isView(l)){const c=y(l);if(c){const S=C.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:c,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},P=JSON.stringify(I,i),u=C.buffers.map(p=>{const l=new Uint8Array(p);return g.VSBuffer.wrap(l)});return{message:P,buffers:u}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=k;function y(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function T(I,D){const C=D.map(u=>{const p=new ArrayBuffer(u.byteLength);return new Uint8Array(p).set(u.buffer),p}),i=D.length?(u,p)=>{if(typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const l=p,{index:c}=l,S=C[c];if(l.view)switch(l.view.type){case 1:return new Int8Array(S,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return p}:void 0;return{message:JSON.parse(I,i),arrayBuffers:C}}e.deserializeWebviewMessage=T}),define(he[85],fe([0,1,10,2]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(y,T){return y.scheme===g.Schemas.http||y.scheme===g.Schemas.https?y:(T&&T.authority&&T.isRemote&&y.scheme===g.Schemas.file&&(y=R.URI.from({scheme:g.Schemas.vscodeRemote,authority:T.authority,path:y.path})),R.URI.from({scheme:g.Schemas.https,authority:`${y.scheme}+${y.authority}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=k}),define(he[202],fe([0,1,3,6,85]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(I,D,C){this._proxy=I,this._editors=D,this._initData=C,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const i=D.getVisibleTextEditors();for(const P of this._insets.values())i.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,D,C,i,P){let u;for(const d of this._editors.getVisibleTextEditors(!0))if(d.value===I){u=d;break}if(!u)throw new Error("not a visible editor");const p=this,l=this._handlePool++,c=new g.Emitter,S=new g.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(d){return(0,k.asWebviewUri)(d,p._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(d){this._options=d,p._proxy.$setOptions(l,d)}get options(){return this._options}set html(d){this._html=d,p._proxy.$setHtml(l,d)}get html(){return this._html}get onDidReceiveMessage(){return c.event}postMessage(d){return p._proxy.$postMessage(l,d)}},E=new class{constructor(){this.editor=I,this.line=D,this.height=C,this.webview=w,this.onDidDispose=S.event}dispose(){p._insets.has(l)&&(p._insets.delete(l),p._proxy.$disposeEditorInset(l),S.fire(),S.dispose(),c.dispose())}};return this._proxy.$createEditorInset(l,u.id,u.value.document.uri,D+1,C,i||{},P.identifier,P.extensionLocation),this._insets.set(l,{editor:I,inset:E,onDidReceiveMessage:c}),E}$onDidDispose(I){const D=this._insets.get(I);D&&D.inset.dispose()}$onDidReceiveMessage(I,D){const C=this._insets.get(I);C&&C.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=y}),define(he[203],fe([0,1,167,14,2,6,4,80,42,18,10]),function(X,e,g,R,k,y,T,I,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new I.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new I.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new I.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new I.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new I.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorContext=new I.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new I.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new I.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new I.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.EditorGroupEditorsCountContext=new I.RawContextKey("groupEditorsCount",0,(0,g.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new I.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(12,null)),e.ActiveEditorGroupIndexContext=new I.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(13,null)),e.ActiveEditorGroupLastContext=new I.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(14,null)),e.MultipleEditorGroupsContext=new I.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new I.RawContextKey("editorIsOpen",!1,(0,g.localize)(16,null)),e.InEditorZenModeContext=new I.RawContextKey("inZenMode",!1,(0,g.localize)(17,null)),e.IsCenteredLayoutContext=new I.RawContextKey("isCenteredLayout",!1,(0,g.localize)(18,null)),e.SplitEditorsVertically=new I.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(19,null)),e.EditorAreaVisibleContext=new I.RawContextKey("editorAreaVisible",!0,(0,g.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function P(o){return typeof o?.getViewState=="function"}e.isTextEditorPane=P;function u(o){if(d(o))return!1;const A=o;return k.URI.isUri(A?.resource)}e.isResourceEditorInput=u;function p(o){if(d(o))return!1;const A=o;return A?.original!==void 0&&A.modified!==void 0}e.isResourceDiffEditorInput=p;function l(o){if(d(o))return!1;const A=o;return A?A?.resource===void 0||A.resource.scheme===i.Schemas.untitled||A.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;var c;(function(o){o[o.SHORT=0]="SHORT",o[o.MEDIUM=1]="MEDIUM",o[o.LONG=2]="LONG"})(c=e.Verbosity||(e.Verbosity={}));var S;(function(o){o[o.EXPLICIT=1]="EXPLICIT",o[o.AUTO=2]="AUTO",o[o.FOCUS_CHANGE=3]="FOCUS_CHANGE",o[o.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(S=e.SaveReason||(e.SaveReason={}));var w;(function(o){o[o.None=0]="None",o[o.Readonly=2]="Readonly",o[o.Untitled=4]="Untitled",o[o.Singleton=8]="Singleton",o[o.RequiresTrust=16]="RequiresTrust"})(w=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class E extends y.Disposable{}e.AbstractEditorInput=E;function d(o){return o instanceof E}e.isEditorInput=d;function h(o){const A=o;return k.URI.isUri(A?.preferredResource)}function v(o){const A=o;return d(A?.primary)&&d(A?.secondary)}e.isSideBySideEditorInput=v;function t(o){return d(o?.editor)}e.isEditorInputWithOptions=t;function s(o){const A=o;return t(o)&&A?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function r(o){const A=o;return typeof A?.groupId=="number"&&d(A.editor)}e.isEditorIdentifier=r;var n;(function(o){o[o.PRIMARY=1]="PRIMARY",o[o.SECONDARY=2]="SECONDARY",o[o.BOTH=3]="BOTH"})(n=e.SideBySideEditor||(e.SideBySideEditor={}));class a{getOriginalUri(A,F){if(!A)return;const $=v(A)?A.primary:p(A)?A.modified:void 0,W=v(A)?A.secondary:p(A)?A.original:void 0;if(F?.supportSideBySide&&$&&W){if(F?.supportSideBySide===n.BOTH)return{primary:this.getOriginalUri($,{filterByScheme:F.filterByScheme}),secondary:this.getOriginalUri(W,{filterByScheme:F.filterByScheme})};A=F.supportSideBySide===n.PRIMARY?$:W}if(p(A))return;const Q=h(A)?A.preferredResource:A.resource;return!Q||!F||!F.filterByScheme?Q:this.filterUri(Q,F.filterByScheme)}getCanonicalUri(A,F){if(!A)return;const $=v(A)?A.primary:p(A)?A.modified:void 0,W=v(A)?A.secondary:p(A)?A.original:void 0;if(F?.supportSideBySide&&$&&W){if(F?.supportSideBySide===n.BOTH)return{primary:this.getCanonicalUri($,{filterByScheme:F.filterByScheme}),secondary:this.getCanonicalUri(W,{filterByScheme:F.filterByScheme})};A=F.supportSideBySide===n.PRIMARY?$:W}if(p(A))return;const Q=A.resource;return!Q||!F||!F.filterByScheme?Q:this.filterUri(Q,F.filterByScheme)}filterUri(A,F){if(Array.isArray(F)){if(F.some($=>A.scheme===$))return A}else if(F===A.scheme)return A}}e.EditorResourceAccessor=new a;var f;(function(o){o[o.LEFT=0]="LEFT",o[o.RIGHT=1]="RIGHT"})(f=e.CloseDirection||(e.CloseDirection={}));class m{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(A){const F=this.instantiationService=A.get(T.IInstantiationService);for(const[$,W]of this.editorSerializerConstructors)this.createEditorSerializer($,W,F);this.editorSerializerConstructors.clear()}createEditorSerializer(A,F,$){const W=$.createInstance(F);this.editorSerializerInstances.set(A,W)}registerFileEditorFactory(A){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=A}getFileEditorFactory(){return(0,R.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(A,F){if(this.editorSerializerConstructors.has(A)||this.editorSerializerInstances.has(A))throw new Error(`A editor serializer with type ID '${A}' was already registered.`);return this.instantiationService?this.createEditorSerializer(A,F,this.instantiationService):this.editorSerializerConstructors.set(A,F),(0,y.toDisposable)(()=>{this.editorSerializerConstructors.delete(A),this.editorSerializerInstances.delete(A)})}getEditorSerializer(A){return this.editorSerializerInstances.get(typeof A=="string"?A:A.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new m);async function b(o,A){if(!o||!o.length)return[];const F=await Promise.all(o.map(async $=>{const W=k.URI.revive($.fileUri);if(!W||!A.canHandleResource(W))return;const Q=typeof $.exists=="boolean"?$.exists:await A.exists(W);if(!Q&&$.openOnlyIfExists)return;const H=Q&&typeof $.lineNumber=="number"?{selection:{startLineNumber:$.lineNumber,startColumn:$.columnNumber||1},pinned:!0,override:$.editorOverrideId}:{pinned:!0,override:$.editorOverrideId};let N;return Q?N={resource:W,options:H,forceFile:!0}:N={resource:W,options:H,forceUntitled:!0},N}));return(0,C.coalesce)(F)}e.pathsToEditors=b;var _;(function(o){o[o.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",o[o.SEQUENTIAL=1]="SEQUENTIAL"})(_=e.EditorsOrder||(e.EditorsOrder={}))}),define(he[120],fe([0,1,3,17,168]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,D,C,i){const P={command:I};if(D&&Object.keys(D).length>0&&(P.arguments=D),this.internalSend("request",P),typeof i=="number"){const u=setTimeout(()=>{clearTimeout(u);const p=this.pendingRequests.get(P.seq);if(p){this.pendingRequests.delete(P.seq);const l={type:"response",seq:0,request_seq:P.seq,success:!1,command:I,message:(0,k.localize)(0,null,i,I)};p(l)}},i)}return C&&this.pendingRequests.set(P.seq,C),P.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,D){return I.type!=="event"||D.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,R.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":const D=I,C=this.pendingRequests.get(D.request_seq);C&&(this.pendingRequests.delete(D.request_seq),C(D));break}}}internalSend(I,D){D.type=I,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((D,C)=>I.set(C,D)),await(0,R.timeout)(500),I.forEach((D,C)=>{D({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(he[204],fe([0,1,8,2,9,25,10]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function D(s,r,n){return s.replace(I,function(a,f){return r&&f.length>0&&f[0]!=="_"?a:n&&n.hasOwnProperty(f)?n[f]:a})}e.formatPII=D;function C(s){const r={};for(const n of Object.keys(s))n.startsWith("!")||(r[n]=s[n]);return r}e.filterExceptionsFromTelemetry=C;function i(s){return s.configuration.request==="attach"&&!P(s)&&(!s.parentSession||i(s.parentSession))}e.isSessionAttach=i;function P(s){let r=s.configuration.type;if(!!r)return r==="vslsShare"&&(r=s.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(r,"extensionhost")||(0,g.equalsIgnoreCase)(r,"pwa-extensionhost")?s:s.parentSession?P(s.parentSession):void 0}e.getExtensionHostDebugSession=P;function u(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=u;function p(s,r,n){let a,f=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,b=null;for(;b=m.exec(s);){let _=b.index+1,o=_+b[0].length;if(_<=r&&o>=n){a=b[0],f=_;break}}if(a){let _=/\w+/g,o=null;for(;(o=_.exec(a))&&!(o.index+1+f+o[0].length>=n););o&&(a=a.substring(0,_.lastIndex))}return a?{start:f,end:f+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(s){return!!(s&&s.match(l))}e.isUri=c;function S(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(c(s.path))return R.URI.parse(s.path);if((0,k.isAbsolute)(s.path))return R.URI.file(s.path)}return s.path}function w(s){if(typeof s.path=="object"){const r=R.URI.revive(s.path);if(r)return r.scheme===T.Schemas.file?r.fsPath:r.toString()}return s.path}function E(s,r){const n=r?S:w,a=(0,y.deepClone)(s);return h(a,(f,m)=>{f&&m&&(m.path=n(m))}),a}e.convertToDAPaths=E;function d(s,r){const n=r?S:w,a=(0,y.deepClone)(s);return h(a,(f,m)=>{!f&&m&&(m.path=n(m))}),a}e.convertToVSCPaths=d;function h(s,r){switch(s.type){case"event":const n=s;switch(n.event){case"output":r(!1,n.body.source);break;case"loadedSource":r(!1,n.body.source);break;case"breakpoint":r(!1,n.body.breakpoint.source);break;default:break}break;case"request":const a=s;switch(a.command){case"setBreakpoints":r(!0,a.arguments.source);break;case"breakpointLocations":r(!0,a.arguments.source);break;case"source":r(!0,a.arguments.source);break;case"gotoTargets":r(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(m=>r(!1,m));break;default:break}break;case"response":const f=s;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(m=>r(!1,m.source));break;case"loadedSources":f.body.sources.forEach(m=>r(!1,m));break;case"scopes":f.body.scopes.forEach(m=>r(!1,m.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(m=>r(!1,m.source));break;case"setBreakpoints":f.body.breakpoints.forEach(m=>r(!1,m.source));break;default:break}break}}function v(s){return s.filter(r=>!r.presentation?.hidden).sort((r,n)=>r.presentation?n.presentation?r.presentation.group?n.presentation.group?r.presentation.group!==n.presentation.group?r.presentation.group.localeCompare(n.presentation.group):t(r.presentation.order,n.presentation.order):-1:n.presentation.group?1:t(r.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=v;function t(s,r){return typeof s!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:s-r}}),define(he[205],fe([0,1,28,38,169,121,9,8,25,11,179,120]),function(X,e,g,R,k,y,T,I,D,C,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class u extends P.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,d){this.outputStream=d,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",h=>this.handleData(h))}sendMessage(E){if(this.outputStream){const d=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(d,"utf8")}${u.TWO_CRLF}${d}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const d=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,d.length>0)try{this.acceptMessage(JSON.parse(d))}catch(h){this._onError.fire(new Error((h.message||h)+`
`+d))}continue}}else{const d=this.rawData.indexOf(u.TWO_CRLF);if(d!==-1){const v=this.rawData.toString("utf8",0,d).split(u.HEADER_LINESEPARATOR);for(const t of v){const s=t.split(u.HEADER_FIELDSEPARATOR);s[0]==="Content-Length"&&(this.contentLength=Number(s[1]))}this.rawData=this.rawData.slice(d+u.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=u,u.TWO_CRLF=`\r
\r
`,u.HEADER_LINESEPARATOR=/\r?\n/,u.HEADER_FIELDSEPARATOR=/: */;class p extends u{startSession(){return new Promise((E,d)=>{let h=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),h=!0}),this.socket.on("close",()=>{h?this._onError.fire(new Error("connection closed")):d(new Error("connection closed"))}),this.socket.on("error",v=>{h?this._onError.fire(v):d(v)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=p;class l extends p{constructor(E){super();this.adapterServer=E}createConnection(E){return y.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=l;class c extends p{constructor(E){super();this.adapterServer=E}createConnection(E){return y.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=c;class S extends u{constructor(E,d,h){super();this.adapterExecutable=E,this.debugType=d,this.outputService=h}async startSession(){const E=this.adapterExecutable.command,d=this.adapterExecutable.args,h=this.adapterExecutable.options||{};try{if(E)if(T.isAbsolute(E)){if(!await g.Promises.exists(E))throw new Error(k.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let v=process.env;if(h.env&&Object.keys(h.env).length>0&&(v=D.mixin(D.deepClone(process.env),h.env)),E==="node")if(Array.isArray(d)&&d.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:v,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};h.cwd&&(r.cwd=h.cwd);const n=R.fork(d[0],d.slice(1),r);if(!n.pid)throw new Error(k.localize(2,null,d[0]));this.serverProcess=n}else throw new Error(k.localize(3,null));else{const s={env:v};h.cwd&&(s.cwd=h.cwd),this.serverProcess=R.spawn(E,d,s)}this.serverProcess.on("error",s=>{this._onError.fire(s)}),this.serverProcess.on("exit",(s,r)=>{this._onExit.fire(s)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",s=>{this._onError.fire(s)}),this.serverProcess.stdin.on("error",s=>{this._onError.fire(s)});const t=this.outputService;if(t){const s=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const n=t.getChannel(i.ExtensionsChannelId);n&&n.append(s(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(v){this._onError.fire(v)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),C.isWindows?new Promise((E,d)=>{const h=R.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(v,t,s){if(v)return d(v)});h.on("exit",E),h.on("error",d)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,d){if(!E)return;const h=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?h.runtime=T.join(d,E.runtime):h.runtime=E.runtime),E.runtimeArgs&&(h.runtimeArgs=E.runtimeArgs),E.program&&(T.isAbsolute(E.program)?h.program=E.program:h.program=T.join(d,E.program)),E.args&&(h.args=E.args);const v=E;return v.win&&(h.win=S.extract(v.win,d)),v.winx86&&(h.winx86=S.extract(v.winx86,d)),v.windows&&(h.windows=S.extract(v.windows,d)),v.osx&&(h.osx=S.extract(v.osx,d)),v.linux&&(h.linux=S.extract(v.linux,d)),h}static platformAdapterExecutable(E,d){let h=Object.create(null);d=d.toLowerCase();for(const a of E)if(a.contributes){const f=a.contributes.debuggers;f&&f.length>0&&f.filter(m=>typeof m.type=="string"&&I.equalsIgnoreCase(m.type,d)).forEach(m=>{const b=S.extract(m,a.extensionLocation.fsPath);h=D.mixin(h,b,a.isBuiltin)})}let v;C.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?v=h.winx86||h.win||h.windows:C.isWindows?v=h.win||h.windows:C.isMacintosh?v=h.osx:C.isLinux&&(v=h.linux),v=v||h;let t=v.program||h.program;const s=v.args||h.args;let r=v.runtime||h.runtime;const n=v.runtimeArgs||h.runtimeArgs;if(r)return{type:"executable",command:r,args:(n||[]).concat(typeof t=="string"?[t]:[]).concat(s||[])};if(t)return{type:"executable",command:t,args:s||[]}}}e.ExecutableDebugAdapter=S}),define(he[206],fe([0,1,38,11,29,182]),function(X,e,g,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function T(u,p){return new Promise((l,c)=>{let S="";const w=g.spawn(u,p);w.pid&&w.stdout.on("data",E=>{S+=E.toString()}),w.on("error",E=>{c(E)}),w.on("close",E=>{l(S)})})}let I;function D(u,p){if(!I)if(R.isWindows)I=new y.WindowsExternalTerminalService;else if(R.isMacintosh)I=new y.MacExternalTerminalService;else if(R.isLinux)I=new y.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const l=p.getConfiguration("terminal");return I.runInTerminal(u.title,u.cwd,u.args,u.env||{},l.external||{})}e.runInExternalTerminal=D;function C(u){return u?R.isWindows?new Promise(async p=>{(await new Promise((c,S)=>{X(["windows-process-tree"],c,S)})).getProcessTree(u,c=>{p(c.children.length>0)})}):T("/usr/bin/pgrep",["-lP",String(u)]).then(p=>{const l=p.trim();return!(l.length===0||l.indexOf(" tmux")>=0)},p=>!0):Promise.resolve(!0)}e.hasChildProcesses=C;var i;(function(u){u[u.cmd=0]="cmd",u[u.powershell=1]="powershell",u[u.bash=2]="bash"})(i||(i={}));function P(u,p,l,c){u=u.trim().toLowerCase();let S;u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0?S=1:u.indexOf("cmd.exe")>=0?S=0:u.indexOf("bash")>=0?S=2:R.isWindows?S=0:S=2;let w,E=" ";switch(S){case 1:if(w=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),l){const h=(0,k.getDriveLetter)(l);h&&(E+=`${h}:; `),E+=`cd ${w(l)}; `}if(c)for(let h in c){const v=c[h];v===null?E+=`Remove-Item env:${h}; `:E+=`\${env:${h}}='${v}'; `}if(p.length>0){const h=w(p.shift());E+=h[0]==="'"?`& ${h} `:`${h} `;for(let v of p)E+=`${w(v)} `}break;case 0:if(w=h=>(h=h.replace(/\"/g,'""'),h.indexOf(" ")>=0||h.indexOf('"')>=0||h.length===0?`"${h}"`:h),l){const h=(0,k.getDriveLetter)(l);h&&(E+=`${h}: && `),E+=`cd ${w(l)} && `}if(c){E+='cmd /C "';for(let h in c){let v=c[h];v===null?E+=`set "${h}=" && `:(v=v.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),E+=`set "${h}=${v}" && `)}}for(let h of p)E+=`${w(h)} `;c&&(E+='"');break;case 2:w=h=>(h=h.replace(/(["'\\\$])/g,"\\$1"),h.indexOf(" ")>=0||h.indexOf(";")>=0||h.length===0?`"${h}"`:h);const d=h=>/[^\w@%\/+=,.:^-]/.test(h)?`'${h.replace(/'/g,"'\\''")}'`:h;if(l&&(E+=`cd ${w(l)} ; `),c){E+="/usr/bin/env";for(let h in c){const v=c[h];v===null?E+=` -u ${d(h)}`:E+=` ${d(`${h}=${v}`)}`}E+=" "}for(let h of p)E+=`${w(h)} `;break}return E}e.prepareCommand=P}),define(he[86],fe([0,1,30,98,10,9,11,80]),function(X,e,g,R,k,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={}));var i;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var P;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(P=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var u;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(u=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var p;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(p=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var l;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(l=e.SelectionStateType||(e.SelectionStateType={}));var c;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(c=e.CellEditType||(e.CellEditType={}));var S;(function(o){o.scheme=k.Schemas.vscodeNotebookCell;const A=/^ch(\d{7,})/;function F(N,x){return N.with({scheme:o.scheme,fragment:`ch${x.toString().padStart(7,"0")}${N.scheme!==k.Schemas.file?N.scheme:""}`})}o.generate=F;function $(N){if(N.scheme!==o.scheme)return;const x=A.exec(N.fragment);return x?{handle:Number(x[1]),notebook:N.with({scheme:N.fragment.substr(x[0].length)||k.Schemas.file,fragment:null})}:void 0}o.parse=$;function W(N){if(N.scheme!==k.Schemas.vscodeNotebookCellMetadata)return;const x=A.exec(N.fragment);return x?{handle:Number(x[1]),notebook:N.with({scheme:N.fragment.substr(x[0].length)||k.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=W;function Q(N,x,L){return N.with({scheme:L,fragment:`ch${x.toString().padStart(7,"0")}${N.scheme!==k.Schemas.file?N.scheme:""}`})}o.generateCellUri=Q;function H(N,x){if(N.scheme!==x)return;const L=A.exec(N.fragment);return L?{handle:Number(L[1]),notebook:N.with({scheme:N.fragment.substr(L[0].length)||k.Schemas.file,fragment:null})}:void 0}o.parseCellUri=H})(S=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(o){return w.get(o)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=E;function d(o){return w.get(o)?.supportedByCore??!1}e.mimeTypeSupportedByCore=d;function h(o){return w.get(o)?.mergeable??!1}e.mimeTypeIsMergeable=h;function v(o,A){return T.isWindows&&(o=o.replace(/\//g,"\\"),A=A.replace(/\//g,"\\")),g.match(o,A)}function t(o,A,F){let $=0;for(let W=0;W<A.length;W++){if(v(A[W],o))return $;$++}for(let W=0;W<F.length;W++){if(v(F[W],o))return $;$++}return $}function s(o,A,F){return o.sort(($,W)=>t($,A,F)-t(W,A,F))}e.sortMimeTypes=s;function r(o,A,F,$=(W,Q)=>W===Q){const W=[];function Q(x,L,G){if(L===0&&G.length===0)return;const M=W[W.length-1];M&&M.start+M.deleteCount===x?(M.deleteCount+=L,M.toInsert.push(...G)):W.push({start:x,deleteCount:L,toInsert:G})}let H=0,N=0;for(;;){if(H===o.length){Q(H,0,A.slice(N));break}if(N===A.length){Q(H,o.length-H,[]);break}const x=o[H],L=A[N];if($(x,L)){H+=1,N+=1;continue}F(L)?(Q(H,1,[]),H+=1):(Q(H,0,[L]),N+=1)}return W}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(o){o.default="default",o.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(o){const A=o;return!!((typeof A.include=="string"||g.isRelativePattern(A.include))&&(typeof A.exclude=="string"||g.isRelativePattern(A.exclude)))}e.isDocumentExcludePattern=a;function f(o,A,F){if(Array.isArray(o.viewType)&&o.viewType.indexOf(A)>=0||o.viewType===A)return!0;if(o.filenamePattern){let $=a(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,W=a(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(g.match($,(0,y.basename)(F.fsPath).toLowerCase()))return!(W&&g.match(W,(0,y.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=f;class m{constructor(A){this.textModel=A}getElements(){const A=new Int32Array(this.textModel.cells.length);for(let F=0;F<this.textModel.cells.length;F++)A[F]=this.textModel.cells[F].getHashValue();return A}}e.CellSequence=m,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var b;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class _{static create(A){return`${_._prefix}${A}`}static parse(A){if(A.startsWith(_._prefix))return A.substr(_._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=_,_._prefix="notebook/"}),define(he[207],fe([0,1,171,4,80]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(he[208],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=g;function R(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=R}),define(he[122],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.identifyTest=void 0;const g=C=>({testId:C.item.extId,controllerId:C.controllerId});e.identifyTest=g;var R;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(R=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(C,i)=>{i.expand!==void 0&&(C.expand=i.expand),i.item!==void 0&&(C.item=C.item?Object.assign(C.item,i.item):i.item)};e.applyTestItemUpdate=k;var y;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(y=e.DetailType||(e.DetailType={}));var T;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.Remove=2]="Remove",C[C.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",C[C.Retire=4]="Retire"})(T=e.TestDiffOpType||(e.TestDiffOpType={}));class I{add(i){}update(i){}remove(i,P){}complete(){}}e.IncrementalChangeCollector=I;class D{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(i){const P=this.createChangeCollector();for(const u of i)switch(u[0]){case 0:{const p=u[1];if(p.parent){if(this.items.has(p.parent)){const l=this.items.get(p.parent);l.children.add(p.item.extId);const c=this.createItem(p,l);this.items.set(p.item.extId,c),P.add(c)}}else{const l=this.createItem(p);this.roots.add(l),this.items.set(p.item.extId,l),P.add(l)}p.expand===2&&this.busyControllerCount++;break}case 1:{const p=u[1],l=this.items.get(p.extId);if(!l)break;p.expand!==void 0&&(l.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(l,p),P.update(l);break}case 2:{const p=this.items.get(u[1]);if(!p)break;p.parent?this.items.get(p.parent).children.delete(p.item.extId):this.roots.delete(p);const l=[[u[1]]];for(;l.length;)for(const c of l.pop()){const S=this.items.get(c);S&&(l.push(S.children),this.items.delete(c),P.remove(S,S!==p),S.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(u[1]);break;case 3:this.updatePendingRoots(u[1]);break}P.complete()}retireTest(i){}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new I}}e.AbstractIncrementalTestCollection=D}),define(he[209],fe([0,1,9,37,14,25,11,76,172]),function(X,e,g,R,k,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(P,u,p){this._contributedVariables=new Map,this._context=P,this._labelService=u,p&&(this._envVariablesPromise=p.then(l=>this.prepareEnv(l)))}prepareEnv(P){if(T.isWindows){const u=Object.create(null);return Object.keys(P).forEach(p=>{u[p.toLowerCase()]=P[p]}),u}return P}resolveWithEnvironment(P,u,p){return this.recursiveResolve(this.prepareEnv(P),u?u.uri:void 0,p)}async resolveAsync(P,u){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,u)}async resolveAnyBase(P,u,p,l){const c=y.deepClone(u);return T.isWindows&&c.windows?Object.keys(c.windows).forEach(S=>c[S]=c.windows[S]):T.isMacintosh&&c.osx?Object.keys(c.osx).forEach(S=>c[S]=c.osx[S]):T.isLinux&&c.linux&&Object.keys(c.linux).forEach(S=>c[S]=c.linux[S]),delete c.windows,delete c.osx,delete c.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,c,p,l)}async resolveAnyAsync(P,u,p){return this.resolveAnyBase(P,u,p)}async resolveAnyMap(P,u,p){const l=new Map;return{newConfig:await this.resolveAnyBase(P,u,p,l),resolvedVariables:l}}resolveWithInteractionReplace(P,u,p,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,u,p,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,u){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,u)}recursiveResolve(P,u,p,l,c){if(k.isString(p))return this.resolveString(P,u,p,l,c);if(k.isArray(p))return p.map(S=>this.recursiveResolve(P,u,S,l,c));if(k.isObject(p)){let S=Object.create(null);return Object.keys(p).forEach(w=>{const E=this.resolveString(P,u,w,l,c);S[E]=this.recursiveResolve(P,u,p[w],l,c)}),S}return p}resolveString(P,u,p,l,c){return p.replace(C.VARIABLE_REGEXP,(w,E)=>{if(E.includes(C.VARIABLE_LHS))return w;let d=this.evaluateSingleVariable(P,w,E,u,l);return c&&c.set(E,d),d!==w&&k.isString(d)&&d.match(C.VARIABLE_REGEXP)&&(d=this.resolveString(P,u,d,l,c)),d})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,u,p,l,c){let S;const w=p.split(":");w.length>1&&(p=w[0],S=w[1]);const E=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,D.localize)(0,null,u))},d=()=>{const v=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,u,g.basename(v)))},h=()=>{if(S){const v=this._context.getFolderUri(S);if(v)return v;throw new Error((0,D.localize)(2,null,u,S))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,u)):new Error((0,D.localize)(4,null,u))};switch(p){case"env":if(S){if(P){const v=P[T.isWindows?S.toLowerCase():S];if(k.isString(v))return v}return""}throw new Error((0,D.localize)(5,null,u));case"config":if(S){const v=this._context.getConfigurationValue(l,S);if(k.isUndefinedOrNull(v))throw new Error((0,D.localize)(6,null,u,S));if(k.isObject(v))throw new Error((0,D.localize)(7,null,u,S));return v}throw new Error((0,D.localize)(8,null,u));case"command":return this.resolveFromMap(u,S,c,"command");case"input":return this.resolveFromMap(u,S,c,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(h()));case"cwd":return l||S?(0,I.normalizeDriveLetter)(this.fsPath(h())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(h()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,D.localize)(9,null,u));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,u));case"file":return E();case"fileWorkspaceFolder":return d();case"relativeFile":return l||S?g.relative(this.fsPath(h()),E()):E();case"relativeFileDirname":const s=g.dirname(E());if(l||S){const f=g.relative(this.fsPath(h()),s);return f.length===0?".":f}return s;case"fileDirname":return g.dirname(E());case"fileExtname":return g.extname(E());case"fileBasename":return g.basename(E());case"fileBasenameNoExtension":const r=g.basename(E());return r.slice(0,r.length-g.extname(r).length);case"fileDirnameBasename":return g.basename(g.dirname(E()));case"execPath":const n=this._context.getExecPath();return n||u;case"execInstallFolder":const a=this._context.getAppRoot();return a||u;case"pathSeparator":return g.sep;default:try{const f=S?`${p}:${S}`:p;return this.resolveFromMap(u,f,c,void 0)}catch(f){return u}}}}resolveFromMap(P,u,p,l){if(u&&p){const c=l===void 0?p[u]:p[l+":"+u];if(typeof c=="string")return c;throw new Error((0,D.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(he[123],fe([0,1,4,203]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var k;(function(c){c[c.UP=0]="UP",c[c.DOWN=1]="DOWN",c[c.LEFT=2]="LEFT",c[c.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var y;(function(c){c[c.HORIZONTAL=0]="HORIZONTAL",c[c.VERTICAL=1]="VERTICAL"})(y=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(c){c[c.FIRST=0]="FIRST",c[c.LAST=1]="LAST",c[c.NEXT=2]="NEXT",c[c.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var I;(function(c){c[c.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",c[c.EVEN=1]="EVEN",c[c.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(c){c[c.COPY_EDITORS=0]="COPY_EDITORS",c[c.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function C(c){const S=c;return(0,R.isEditorInput)(S?.editor)&&(0,R.isEditorInput)(S?.replacement)}e.isEditorReplacement=C;var i;(function(c){c[c.CREATION_TIME=0]="CREATION_TIME",c[c.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",c[c.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(i=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(c){c[c.GROUP_ACTIVE=0]="GROUP_ACTIVE",c[c.GROUP_INDEX=1]="GROUP_INDEX",c[c.EDITOR_OPEN=2]="EDITOR_OPEN",c[c.EDITOR_CLOSE=3]="EDITOR_CLOSE",c[c.EDITOR_MOVE=4]="EDITOR_MOVE",c[c.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",c[c.EDITOR_LABEL=6]="EDITOR_LABEL",c[c.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",c[c.EDITOR_PIN=8]="EDITOR_PIN",c[c.EDITOR_STICKY=9]="EDITOR_STICKY",c[c.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(P=e.GroupChangeKind||(e.GroupChangeKind={}));var u;(function(c){c[c.NEW_EDITOR=1]="NEW_EDITOR",c[c.MOVE_EDITOR=2]="MOVE_EDITOR",c[c.COPY_EDITOR=3]="COPY_EDITOR"})(u=e.OpenEditorContext||(e.OpenEditorContext={}));function p(c){const S=c;return!!S&&typeof S.id=="number"&&Array.isArray(S.editors)}e.isEditorGroup=p;function l(c){return c.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=l}),define(he[210],fe([0,1,4,123]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function k(y){const T=y;return typeof y=="number"||(0,R.isEditorGroup)(T)}e.isPreferredGroup=k}),define(he[16],fe([0,1,18,95,284,57,25,14,2,40,79,173,113,86,210,7]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(Ee){function Se(Y){const{selectionStartLineNumber:Be,selectionStartColumn:De,positionLineNumber:Je,positionColumn:Ye}=Y,rt=new c.Position(Be-1,De-1),mt=new c.Position(Je-1,Ye-1);return new c.Selection(rt,mt)}Ee.to=Se;function ae(Y){const{anchor:Be,active:De}=Y;return{selectionStartLineNumber:Be.line+1,selectionStartColumn:Be.character+1,positionLineNumber:De.line+1,positionColumn:De.character+1}}Ee.from=ae})(S=e.Selection||(e.Selection={}));var w;(function(Ee){function Se(Y){if(!Y)return;const{start:Be,end:De}=Y;return{startLineNumber:Be.line+1,startColumn:Be.character+1,endLineNumber:De.line+1,endColumn:De.character+1}}Ee.from=Se;function ae(Y){if(!Y)return;const{startLineNumber:Be,startColumn:De,endLineNumber:Je,endColumn:Ye}=Y;return new c.Range(Be-1,De-1,Je-1,Ye-1)}Ee.to=ae})(w=e.Range||(e.Range={}));var E;(function(Ee){function Se(ae){switch(ae){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 4:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}Ee.to=Se})(E=e.TokenType||(e.TokenType={}));var d;(function(Ee){function Se(Y){return new c.Position(Y.lineNumber-1,Y.column-1)}Ee.to=Se;function ae(Y){return{lineNumber:Y.line+1,column:Y.character+1}}Ee.from=ae})(d=e.Position||(e.Position={}));var h;(function(Ee){function Se(Y){switch(Y){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}Ee.from=Se;function ae(Y){switch(Y){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}Ee.to=ae})(h=e.DiagnosticTag||(e.DiagnosticTag={}));var v;(function(Ee){function Se(Y){let Be;return Y.code&&((0,I.isString)(Y.code)||(0,I.isNumber)(Y.code)?Be=String(Y.code):Be={value:String(Y.code.value),target:Y.code.target}),{...w.from(Y.range),message:Y.message,source:Y.source,code:Be,severity:s.from(Y.severity),relatedInformation:Y.relatedInformation&&Y.relatedInformation.map(t.from),tags:Array.isArray(Y.tags)?(0,g.coalesce)(Y.tags.map(h.from)):void 0}}Ee.from=Se;function ae(Y){const Be=new c.Diagnostic(w.to(Y),Y.message,s.to(Y.severity));return Be.source=Y.source,Be.code=(0,I.isString)(Y.code)?Y.code:Y.code?.value,Be.relatedInformation=Y.relatedInformation&&Y.relatedInformation.map(t.to),Be.tags=Y.tags&&(0,g.coalesce)(Y.tags.map(h.to)),Be}Ee.to=ae})(v=e.Diagnostic||(e.Diagnostic={}));var t;(function(Ee){function Se(Y){return{...w.from(Y.location.range),message:Y.message,resource:Y.location.uri}}Ee.from=Se;function ae(Y){return new c.DiagnosticRelatedInformation(new c.Location(Y.resource,w.to(Y)),Y.message)}Ee.to=ae})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var s;(function(Ee){function Se(Y){switch(Y){case c.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}Ee.from=Se;function ae(Y){switch(Y){case u.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}Ee.to=ae})(s=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var r;(function(Ee){function Se(Y){return typeof Y=="number"&&Y>=c.ViewColumn.One?Y-1:Y===c.ViewColumn.Beside?l.SIDE_GROUP:l.ACTIVE_GROUP}Ee.from=Se;function ae(Y){if(typeof Y=="number"&&Y>=0)return Y+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=ae})(r=e.ViewColumn||(e.ViewColumn={}));function n(Ee){return typeof Ee.range!="undefined"}function a(Ee){return Ee.length===0?!0:!!n(Ee[0])}e.isDecorationOptionsArr=a;var f;(function(Ee){function Se(Ye){return Ye.map(Ee.from)}Ee.fromMany=Se;function ae(Ye){return Ye&&typeof Ye=="object"&&typeof Ye.language=="string"&&typeof Ye.value=="string"}function Y(Ye){let rt;if(ae(Ye)){const{language:Ct,value:yt}=Ye;rt={value:"```"+Ct+`
`+yt+"\n```\n"}}else c.MarkdownString.isMarkdownString(Ye)?rt={value:Ye.value,isTrusted:Ye.isTrusted,supportThemeIcons:Ye.supportThemeIcons}:typeof Ye=="string"?rt={value:Ye}:rt={value:""};const mt=Object.create(null);rt.uris=mt;const bt=Ct=>{try{let yt=D.URI.parse(Ct,!0);yt=yt.with({query:Be(yt.query,mt)}),mt[Ct]=yt}catch(yt){}return""},wt=new k.Renderer;return wt.link=bt,wt.image=Ct=>bt(R.parseHrefAndDimensions(Ct).href),k(rt.value,{renderer:wt}),rt}Ee.from=Y;function Be(Ye,rt){if(!Ye)return Ye;let mt;try{mt=(0,y.parse)(Ye)}catch(wt){}if(!mt)return Ye;let bt=!1;return mt=(0,T.cloneAndChange)(mt,wt=>{if(D.URI.isUri(wt)){const Ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[Ct]=wt,bt=!0,Ct}else return}),bt?JSON.stringify(mt):Ye}function De(Ye){const rt=new c.MarkdownString(Ye.value,Ye.supportThemeIcons);return rt.isTrusted=Ye.isTrusted,rt}Ee.to=De;function Je(Ye){if(!!Ye)return typeof Ye=="string"?Ye:Ee.from(Ye)}Ee.fromStrict=Je})(f=e.MarkdownString||(e.MarkdownString={}));function m(Ee){return a(Ee)?Ee.map(Se=>({range:w.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?f.fromMany(Se.hoverMessage):Se.hoverMessage?f.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):Ee.map(Se=>({range:w.from(Se)}))}e.fromRangeOrRangeWithMessage=m;function b(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?D.URI.file(Ee):Ee}e.pathOrURIToURI=b;var _;(function(Ee){function Se(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?b(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}Ee.from=Se})(_=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var o;(function(Ee){function Se(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?b(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?_.from(ae.before):void 0,after:ae.after?_.from(ae.after):void 0}}Ee.from=Se})(o=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var A;(function(Ee){function Se(ae){if(typeof ae=="undefined")return ae;switch(ae){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Se})(A=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var F;(function(Ee){function Se(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?A.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?o.from(ae.light):void 0,dark:ae.dark?o.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?b(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?_.from(ae.before):void 0,after:ae.after?_.from(ae.after):void 0}}Ee.from=Se})(F=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var $;(function(Ee){function Se(Y){return{text:Y.newText,eol:Y.newEol&&K.from(Y.newEol),range:w.from(Y.range)}}Ee.from=Se;function ae(Y){const Be=new c.TextEdit(w.to(Y.range),Y.text);return Be.newEol=typeof Y.eol=="undefined"?void 0:K.to(Y.eol),Be}Ee.to=ae})($=e.TextEdit||(e.TextEdit={}));var W;(function(Ee){function Se(Y,Be,De){const Je={edits:[]};if(Y instanceof c.WorkspaceEdit)for(let Ye of Y._allEntries())if(Ye._type===1)Je.edits.push({_type:1,oldUri:Ye.from,newUri:Ye.to,options:Ye.options,metadata:Ye.metadata});else if(Ye._type===2){const rt=Be?.getDocument(Ye.uri);Je.edits.push({_type:2,resource:Ye.uri,edit:$.from(Ye.edit),modelVersionId:rt?.version,metadata:Ye.metadata})}else Ye._type===3?Je.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:Ye.edit,notebookMetadata:Ye.notebookMetadata,notebookVersionId:De?.getNotebookDocument(Ye.uri,!0)?.apiNotebook.version}):Ye._type===5&&Je.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,notebookVersionId:De?.getNotebookDocument(Ye.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ye.index,count:Ye.count,cells:Ye.cells.map(me.from)}});return Je}Ee.from=Se;function ae(Y){const Be=new c.WorkspaceEdit;for(const De of Y.edits)De.edit?Be.replace(D.URI.revive(De.resource),w.to(De.edit.range),De.edit.text):Be.renameFile(D.URI.revive(De.oldUri),D.URI.revive(De.newUri),De.options);return Be}Ee.to=ae})(W=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Q;(function(Ee){const Se=Object.create(null);Se[c.SymbolKind.File]=0,Se[c.SymbolKind.Module]=1,Se[c.SymbolKind.Namespace]=2,Se[c.SymbolKind.Package]=3,Se[c.SymbolKind.Class]=4,Se[c.SymbolKind.Method]=5,Se[c.SymbolKind.Property]=6,Se[c.SymbolKind.Field]=7,Se[c.SymbolKind.Constructor]=8,Se[c.SymbolKind.Enum]=9,Se[c.SymbolKind.Interface]=10,Se[c.SymbolKind.Function]=11,Se[c.SymbolKind.Variable]=12,Se[c.SymbolKind.Constant]=13,Se[c.SymbolKind.String]=14,Se[c.SymbolKind.Number]=15,Se[c.SymbolKind.Boolean]=16,Se[c.SymbolKind.Array]=17,Se[c.SymbolKind.Object]=18,Se[c.SymbolKind.Key]=19,Se[c.SymbolKind.Null]=20,Se[c.SymbolKind.EnumMember]=21,Se[c.SymbolKind.Struct]=22,Se[c.SymbolKind.Event]=23,Se[c.SymbolKind.Operator]=24,Se[c.SymbolKind.TypeParameter]=25;function ae(Be){return typeof Se[Be]=="number"?Se[Be]:6}Ee.from=ae;function Y(Be){for(const De in Se)if(Se[De]===Be)return Number(De);return c.SymbolKind.Property}Ee.to=Y})(Q=e.SymbolKind||(e.SymbolKind={}));var H;(function(Ee){function Se(Y){switch(Y){case c.SymbolTag.Deprecated:return 1}}Ee.from=Se;function ae(Y){switch(Y){case 1:return c.SymbolTag.Deprecated}}Ee.to=ae})(H=e.SymbolTag||(e.SymbolTag={}));var N;(function(Ee){function Se(Y){return{name:Y.name,kind:Q.from(Y.kind),tags:Y.tags&&Y.tags.map(H.from),containerName:Y.containerName,location:O.from(Y.location)}}Ee.from=Se;function ae(Y){const Be=new c.SymbolInformation(Y.name,Q.to(Y.kind),Y.containerName,O.to(Y.location));return Be.tags=Y.tags&&Y.tags.map(H.to),Be}Ee.to=ae})(N=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var x;(function(Ee){function Se(Y){const Be={name:Y.name||"!!MISSING: name!!",detail:Y.detail,range:w.from(Y.range),selectionRange:w.from(Y.selectionRange),kind:Q.from(Y.kind),tags:Y.tags?.map(H.from)??[]};return Y.children&&(Be.children=Y.children.map(Se)),Be}Ee.from=Se;function ae(Y){const Be=new c.DocumentSymbol(Y.name,Y.detail,Q.to(Y.kind),w.to(Y.range),w.to(Y.selectionRange));return(0,g.isNonEmptyArray)(Y.tags)&&(Be.tags=Y.tags.map(H.to)),Y.children&&(Be.children=Y.children.map(ae)),Be}Ee.to=ae})(x=e.DocumentSymbol||(e.DocumentSymbol={}));var L;(function(Ee){function Se(ae){const Y=new c.CallHierarchyItem(Q.to(ae.kind),ae.name,ae.detail||"",D.URI.revive(ae.uri),w.to(ae.range),w.to(ae.selectionRange));return Y._sessionId=ae._sessionId,Y._itemId=ae._itemId,Y}Ee.to=Se})(L=e.CallHierarchyItem||(e.CallHierarchyItem={}));var G;(function(Ee){function Se(ae){return new c.CallHierarchyIncomingCall(L.to(ae.from),ae.fromRanges.map(Y=>w.to(Y)))}Ee.to=Se})(G=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(Ee){function Se(ae){return new c.CallHierarchyOutgoingCall(L.to(ae.to),ae.fromRanges.map(Y=>w.to(Y)))}Ee.to=Se})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var O;(function(Ee){function Se(Y){return{range:Y.range&&w.from(Y.range),uri:Y.uri}}Ee.from=Se;function ae(Y){return new c.Location(D.URI.revive(Y.uri),w.to(Y.range))}Ee.to=ae})(O=e.location||(e.location={}));var B;(function(Ee){function Se(Y){const Be=Y,De=Y;return{originSelectionRange:Be.originSelectionRange?w.from(Be.originSelectionRange):void 0,uri:Be.targetUri?Be.targetUri:De.uri,range:w.from(Be.targetRange?Be.targetRange:De.range),targetSelectionRange:Be.targetSelectionRange?w.from(Be.targetSelectionRange):void 0}}Ee.from=Se;function ae(Y){return{targetUri:D.URI.revive(Y.uri),targetRange:w.to(Y.range),targetSelectionRange:Y.targetSelectionRange?w.to(Y.targetSelectionRange):void 0,originSelectionRange:Y.originSelectionRange?w.to(Y.originSelectionRange):void 0}}Ee.to=ae})(B=e.DefinitionLink||(e.DefinitionLink={}));var z;(function(Ee){function Se(Y){return{range:w.from(Y.range),contents:f.fromMany(Y.contents)}}Ee.from=Se;function ae(Y){return new c.Hover(Y.contents.map(f.to),w.to(Y.range))}Ee.to=ae})(z=e.Hover||(e.Hover={}));var J;(function(Ee){function Se(Y){return{range:w.from(Y.range),expression:Y.expression}}Ee.from=Se;function ae(Y){return new c.EvaluatableExpression(w.to(Y.range),Y.expression)}Ee.to=ae})(J=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ce;(function(Ee){function Se(Y){if(Y instanceof c.InlineValueText)return{type:"text",range:w.from(Y.range),text:Y.text};if(Y instanceof c.InlineValueVariableLookup)return{type:"variable",range:w.from(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};if(Y instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(Y.range),expression:Y.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Se;function ae(Y){switch(Y.type){case"text":return{range:w.to(Y.range),text:Y.text};case"variable":return{range:w.to(Y.range),variableName:Y.variableName,caseSensitiveLookup:Y.caseSensitiveLookup};case"expression":return{range:w.to(Y.range),expression:Y.expression}}}Ee.to=ae})(ce=e.InlineValue||(e.InlineValue={}));var ye;(function(Ee){function Se(Y){return{frameId:Y.frameId,stoppedLocation:w.from(Y.stoppedLocation)}}Ee.from=Se;function ae(Y){return new c.InlineValueContext(Y.frameId,w.to(Y.stoppedLocation))}Ee.to=ae})(ye=e.InlineValueContext||(e.InlineValueContext={}));var Fe;(function(Ee){function Se(Y){return{range:w.from(Y.range),kind:Y.kind}}Ee.from=Se;function ae(Y){return new c.DocumentHighlight(w.to(Y.range),Y.kind)}Ee.to=ae})(Fe=e.DocumentHighlight||(e.DocumentHighlight={}));var Re;(function(Ee){function Se(ae){switch(ae){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}Ee.to=Se})(Re=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ne;(function(Ee){function Se(ae){return{triggerKind:Re.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}Ee.to=Se})(Ne=e.CompletionContext||(e.CompletionContext={}));var Ve;(function(Ee){function Se(Y){switch(Y){case c.CompletionItemTag.Deprecated:return 1}}Ee.from=Se;function ae(Y){switch(Y){case 1:return c.CompletionItemTag.Deprecated}}Ee.to=ae})(Ve=e.CompletionItemTag||(e.CompletionItemTag={}));var ze;(function(Ee){const Se=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function ae(De){return Se.get(De)??9}Ee.from=ae;const Y=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Be(De){return Y.get(De)??c.CompletionItemKind.Property}Ee.to=Be})(ze=e.CompletionItemKind||(e.CompletionItemKind={}));var j;(function(Ee){function Se(ae,Y){const Be=new c.CompletionItem(ae.label);return Be.insertText=ae.insertText,Be.kind=ze.to(ae.kind),Be.tags=ae.tags?.map(Ve.to),Be.detail=ae.detail,Be.documentation=R.isMarkdownString(ae.documentation)?f.to(ae.documentation):ae.documentation,Be.sortText=ae.sortText,Be.filterText=ae.filterText,Be.preselect=ae.preselect,Be.commitCharacters=ae.commitCharacters,C.Range.isIRange(ae.range)?Be.range=w.to(ae.range):typeof ae.range=="object"&&(Be.range={inserting:w.to(ae.range.insert),replacing:w.to(ae.range.replace)}),Be.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Be.insertText=new c.SnippetString(ae.insertText):(Be.insertText=ae.insertText,Be.textEdit=Be.range instanceof c.Range?new c.TextEdit(Be.range,Be.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Be.additionalTextEdits=ae.additionalTextEdits.map(De=>$.to(De))),Be.command=Y&&ae.command?Y.fromInternal(ae.command):void 0,Be}Ee.to=Se})(j=e.CompletionItem||(e.CompletionItem={}));var Z;(function(Ee){function Se(Y){return{label:Y.label,documentation:Y.documentation?f.fromStrict(Y.documentation):void 0}}Ee.from=Se;function ae(Y){return{label:Y.label,documentation:R.isMarkdownString(Y.documentation)?f.to(Y.documentation):Y.documentation}}Ee.to=ae})(Z=e.ParameterInformation||(e.ParameterInformation={}));var ie;(function(Ee){function Se(Y){return{label:Y.label,documentation:Y.documentation?f.fromStrict(Y.documentation):void 0,parameters:Array.isArray(Y.parameters)?Y.parameters.map(Z.from):[],activeParameter:Y.activeParameter}}Ee.from=Se;function ae(Y){return{label:Y.label,documentation:R.isMarkdownString(Y.documentation)?f.to(Y.documentation):Y.documentation,parameters:Array.isArray(Y.parameters)?Y.parameters.map(Z.to):[],activeParameter:Y.activeParameter}}Ee.to=ae})(ie=e.SignatureInformation||(e.SignatureInformation={}));var oe;(function(Ee){function Se(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(ie.from):[]}}Ee.from=Se;function ae(Y){return{activeSignature:Y.activeSignature,activeParameter:Y.activeParameter,signatures:Array.isArray(Y.signatures)?Y.signatures.map(ie.to):[]}}Ee.to=ae})(oe=e.SignatureHelp||(e.SignatureHelp={}));var ve;(function(Ee){function Se(Y){return{text:Y.text,position:d.from(Y.position),kind:ee.from(Y.kind??c.InlayHintKind.Other),whitespaceBefore:Y.whitespaceBefore,whitespaceAfter:Y.whitespaceAfter}}Ee.from=Se;function ae(Y){const Be=new c.InlayHint(Y.text,d.to(Y.position),ee.to(Y.kind));return Be.whitespaceAfter=Y.whitespaceAfter,Be.whitespaceBefore=Y.whitespaceBefore,Be}Ee.to=ae})(ve=e.InlayHint||(e.InlayHint={}));var ee;(function(Ee){function Se(Y){return Y}Ee.from=Se;function ae(Y){return Y}Ee.to=ae})(ee=e.InlayHintKind||(e.InlayHintKind={}));var ue;(function(Ee){function Se(Y){return{range:w.from(Y.range),url:Y.target,tooltip:Y.tooltip}}Ee.from=Se;function ae(Y){let Be;if(Y.url)try{Be=typeof Y.url=="string"?D.URI.parse(Y.url,!0):D.URI.revive(Y.url)}catch(De){}return new c.DocumentLink(w.to(Y.range),Be)}Ee.to=ae})(ue=e.DocumentLink||(e.DocumentLink={}));var Ie;(function(Ee){function Se(Y){const Be=new c.ColorPresentation(Y.label);return Y.textEdit&&(Be.textEdit=$.to(Y.textEdit)),Y.additionalTextEdits&&(Be.additionalTextEdits=Y.additionalTextEdits.map(De=>$.to(De))),Be}Ee.to=Se;function ae(Y){return{label:Y.label,textEdit:Y.textEdit?$.from(Y.textEdit):void 0,additionalTextEdits:Y.additionalTextEdits?Y.additionalTextEdits.map(Be=>$.from(Be)):void 0}}Ee.from=ae})(Ie=e.ColorPresentation||(e.ColorPresentation={}));var $e;(function(Ee){function Se(Y){return new c.Color(Y[0],Y[1],Y[2],Y[3])}Ee.to=Se;function ae(Y){return[Y.red,Y.green,Y.blue,Y.alpha]}Ee.from=ae})($e=e.Color||(e.Color={}));var qe;(function(Ee){function Se(Y){return{range:w.from(Y.range)}}Ee.from=Se;function ae(Y){return new c.SelectionRange(w.to(Y.range))}Ee.to=ae})(qe=e.SelectionRange||(e.SelectionRange={}));var be;(function(Ee){function Se(ae){switch(ae){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}Ee.to=Se})(be=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(Ee){function Se(Y){switch(Y){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Se;function ae(Y){switch(Y){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}Ee.to=ae})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var K;(function(Ee){function Se(Y){if(Y===c.EndOfLine.CRLF)return 1;if(Y===c.EndOfLine.LF)return 0}Ee.from=Se;function ae(Y){if(Y===1)return c.EndOfLine.CRLF;if(Y===0)return c.EndOfLine.LF}Ee.to=ae})(K=e.EndOfLine||(e.EndOfLine={}));var te;(function(Ee){function Se(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Se})(te=e.ProgressLocation||(e.ProgressLocation={}));var pe;(function(Ee){function Se(ae){const Y={start:ae.start+1,end:ae.end+1};return ae.kind&&(Y.kind=Ue.from(ae.kind)),Y}Ee.from=Se})(pe=e.FoldingRange||(e.FoldingRange={}));var Ue;(function(Ee){function Se(ae){if(ae)switch(ae){case c.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}Ee.from=Se})(Ue=e.FoldingRangeKind||(e.FoldingRangeKind={}));var We;(function(Ee){function Se(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?w.from(ae.selection):void 0,override:typeof ae.override=="boolean"?P.EditorResolution.DISABLED:void 0}}Ee.from=Se})(We=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ze;(function(Ee){function Se(Y){return Y instanceof c.RelativePattern||typeof Y=="string"?Y:ae(Y)?new c.RelativePattern(Y.base,Y.pattern):Y}Ee.from=Se;function ae(Y){const Be=Y;return Be&&typeof Be.base=="string"&&typeof Be.pattern=="string"}})(Ze=e.GlobPattern||(e.GlobPattern={}));var Pe;(function(Ee){function Se(ae){if(ae){if(Array.isArray(ae))return ae.map(Se);if(typeof ae=="string")return ae;{const Y=ae;return{language:Y.language,scheme:Y.scheme,pattern:typeof Y.pattern=="undefined"?void 0:Ze.from(Y.pattern),exclusive:Y.exclusive}}}else return}Ee.from=Se})(Pe=e.LanguageSelector||(e.LanguageSelector={}));var Ce;(function(Ee){function Se(Y){return{start:Y.start,end:Y.end}}Ee.from=Se;function ae(Y){return new c.NotebookRange(Y.start,Y.end)}Ee.to=ae})(Ce=e.NotebookRange||(e.NotebookRange={}));var Ae;(function(Ee){function Se(Y){return{timing:typeof Y.runStartTime=="number"&&typeof Y.runEndTime=="number"?{startTime:Y.runStartTime,endTime:Y.runEndTime}:void 0,executionOrder:Y.executionOrder,success:Y.lastRunSuccess}}Ee.to=Se;function ae(Y){return{lastRunSuccess:Y.success,runStartTime:Y.timing?.startTime,runEndTime:Y.timing?.endTime,executionOrder:Y.executionOrder}}Ee.from=ae})(Ae=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var se;(function(Ee){function Se(Y){switch(Y){case c.NotebookCellKind.Markup:return p.CellKind.Markup;case c.NotebookCellKind.Code:default:return p.CellKind.Code}}Ee.from=Se;function ae(Y){switch(Y){case p.CellKind.Markup:return c.NotebookCellKind.Markup;case p.CellKind.Code:default:return c.NotebookCellKind.Code}}Ee.to=ae})(se=e.NotebookCellKind||(e.NotebookCellKind={}));var le;(function(Ee){function Se(Y){const Be={metadata:Y.metadata??Object.create(null),cells:[]};for(let De of Y.cells)c.NotebookCellData.validate(De),Be.cells.push(me.from(De));return Be}Ee.from=Se;function ae(Y){const Be=new c.NotebookData(Y.cells.map(me.to));return(0,I.isEmptyObject)(Y.metadata)||(Be.metadata=Y.metadata),Be}Ee.to=ae})(le=e.NotebookData||(e.NotebookData={}));var me;(function(Ee){function Se(Y){return{cellKind:se.from(Y.kind),language:Y.languageId,mime:Y.mime,source:Y.value,metadata:Y.metadata,internalMetadata:Ae.from(Y.executionSummary??{}),outputs:Y.outputs?Y.outputs.map(q.from):[]}}Ee.from=Se;function ae(Y){return new c.NotebookCellData(se.to(Y.cellKind),Y.source,Y.language,Y.mime,Y.outputs?Y.outputs.map(q.to):void 0,Y.metadata,Y.internalMetadata?Ae.to(Y.internalMetadata):void 0)}Ee.to=ae})(me=e.NotebookCellData||(e.NotebookCellData={}));var we;(function(Ee){function Se(Y){return{mime:Y.mime,valueBytes:Array.from(Y.data)}}Ee.from=Se;function ae(Y){return new c.NotebookCellOutputItem(new Uint8Array(Y.valueBytes),Y.mime)}Ee.to=ae})(we=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var q;(function(Ee){function Se(Y){return{outputId:Y.id,items:Y.items.map(we.from),metadata:Y.metadata}}Ee.from=Se;function ae(Y){const Be=Y.items.map(we.to);return new c.NotebookCellOutput(Be,Y.outputId,Y.metadata)}Ee.to=ae})(q=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ge;(function(Ee){function Se(De){if(De!=null){if(De instanceof c.RelativePattern||typeof De=="string")return De;if(Be(De))return new c.RelativePattern(De.base,De.pattern);if(Y(De))return{include:Ze.from(De.include)||void 0,exclude:Ze.from(De.exclude)||void 0}}}Ee.from=Se;function ae(De){return typeof De=="string"?De:Be(De)?{base:De.base,pattern:De.pattern}:{include:De.include,exclude:De.exclude}}Ee.to=ae;function Y(De){const Je=De,Ye=Ze.from(Je.include);if(!(Ye&&Ye instanceof c.RelativePattern||typeof Ye=="string"))return!1;const rt=Ze.from(Je.exclude);return!!(rt&&rt instanceof c.RelativePattern||typeof rt=="string")}function Be(De){const Je=De;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(ge=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var _e;(function(Ee){function Se(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?_.from(ae.top):void 0}}Ee.from=Se})(_e=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Te;(function(Ee){function Se(ae,Y,Be){const De=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:Y.toInternal(De,Be),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}Ee.from=Se})(Te=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Oe;(function(Ee){function Se(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{}}}Ee.from=Se})(Oe=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ge;(function(Ee){function Se(Y){return{uri:Y.uri,provides:Y.provides}}Ee.from=Se;function ae(Y){return new c.NotebookRendererScript(D.URI.revive(Y.uri),Y.provides)}Ee.to=ae})(Ge=e.NotebookRendererScript||(e.NotebookRendererScript={}));var et;(function(Ee){function Se(Y){return{message:f.fromStrict(Y.message)||"",severity:Y.severity,expectedOutput:Y.expectedOutput,actualOutput:Y.actualOutput,location:Y.location?O.from(Y.location):void 0}}Ee.from=Se;function ae(Y){const Be=new c.TestMessage(typeof Y.message=="string"?Y.message:f.to(Y.message));return Be.severity=Y.severity,Be.actualOutput=Y.actualOutput,Be.expectedOutput=Y.expectedOutput,Be}Ee.to=ae})(et=e.TestMessage||(e.TestMessage={}));var Qe;(function(Ee){function Se(Je){return{extId:Je.id,label:Je.label,uri:Je.uri,range:w.from(Je.range)||null,debuggable:Je.debuggable??!1,description:Je.description||null,runnable:Je.runnable??!0,error:Je.error&&f.fromStrict(Je.error)||null}}Ee.from=Se;function ae(Je){return{extId:Je.id,label:Je.label,uri:Je.uri,range:w.from(Je.range)||null,debuggable:!1,description:Je.description||null,error:null,runnable:!0}}Ee.fromResultSnapshot=ae;function Y(Je){return{id:Je.extId,label:Je.label,uri:D.URI.revive(Je.uri),range:w.to(Je.range||void 0),dispose:()=>{},invalidateResults:()=>{},canResolveChildren:!1,busy:!1,debuggable:Je.debuggable,description:Je.description||void 0,runnable:Je.runnable}}Ee.toPlain=Y;function Be(Je,Ye){const rt=new c.TestItemImpl(Je.extId,Je.label,D.URI.revive(Je.uri),void 0,Ye);return rt.range=w.to(Je.range||void 0),rt.debuggable=Je.debuggable,rt.description=Je.description||void 0,rt.runnable=Je.runnable,rt}Ee.to=Be;function De(Je){let Ye;for(const rt of Je.tests)Ye=Be(rt.item,Ye);return Ye}Ee.toItemFromContext=De})(Qe=e.TestItem||(e.TestItem={}));var Xe;(function(Ee){const Se=(Y,Be)=>({...Qe.toPlain(Y.item),taskStates:Y.tasks.map(De=>({state:De.state,duration:De.duration,messages:De.messages.map(et.to)})),children:Y.children.map(De=>Be.get(De)).filter(I.isDefined).map(De=>Se(De,Be))});function ae(Y){const Be=[],De=new Map;for(const Je of Y.items)De.set(Je.item.extId,Je),Je.direct&&Be.push(Je);return{completedAt:Y.completedAt,results:Be.map(Je=>Se(Je,De))}}Ee.to=ae})(Xe=e.TestResults||(e.TestResults={}));var lt;(function(Ee){function Se(De){return{covered:De.covered,total:De.covered}}function ae(De){return"line"in De?d.from(De):w.from(De)}function Y(De){return"branches"in De?{count:De.executionCount,location:ae(De.location),type:1,branches:De.branches.length?De.branches.map(Je=>({count:Je.executionCount,location:Je.location&&ae(Je.location)})):void 0}:{type:0,count:De.executionCount,location:ae(De.location)}}Ee.fromDetailed=Y;function Be(De){return{uri:De.uri,statement:Se(De.statementCoverage),branch:De.branchCoverage&&Se(De.branchCoverage),function:De.functionCoverage&&Se(De.functionCoverage),details:De.detailedCoverage?.map(Y)}}Ee.fromFile=Be})(lt=e.TestCoverage||(e.TestCoverage={}));var ut;(function(Ee){function Se(ae){switch(ae){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}Ee.to=Se})(ut=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(he[211],fe([0,1,2,15,7,16,91]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(C,i,P,u={timeout:1500,errors:3}){this._logService=C,this._documents=i,this._mainThreadBulkEdits=P,this._thresholds=u,this._callbacks=new T.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(i,P,u)=>{const l={dispose:this._callbacks.push([i,P,C])};return Array.isArray(u)&&u.push(l),l}}async $participateInSave(C,i){const P=g.URI.revive(C);let u=!1;const p=setTimeout(()=>u=!0,this._thresholds.timeout),l=[];try{for(let c of[...this._callbacks]){if(u)break;const S=this._documents.getDocument(P),w=await this._deliverEventAsyncAndBlameBadListeners(c,{document:S,reason:y.TextDocumentSaveReason.to(i)});l.push(w)}}finally{clearTimeout(p)}return l}_deliverEventAsyncAndBlameBadListeners([C,i,P],u){const p=this._badListeners.get(C);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,C,i,u).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const c=this._badListeners.get(C);this._badListeners.set(C,c?c+1:1),typeof c=="number"&&c>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,i,P,u){const p=[],l=Date.now(),{document:c,reason:S}=u,{version:w}=c,E=Object.freeze({document:c,reason:S,waitUntil(d){if(Object.isFrozen(p))throw(0,R.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(d))}});try{i.apply(P,[E])}catch(d){return Promise.reject(d)}return Object.freeze(p),new Promise((d,h)=>{const v=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(v),d(t)}).catch(t=>{clearTimeout(v),h(t)})}).then(d=>{const h={edits:[]};for(const v of d)if(Array.isArray(v)&&v.every(t=>t instanceof k.TextEdit))for(const{newText:t,newEol:s,range:r}of v)h.edits.push({_type:2,resource:c.uri,edit:{range:r&&y.Range.from(r),text:t,eol:s&&y.EndOfLine.from(s)}});if(h.edits.length!==0)return w===c.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(he[212],fe([0,1,3,30,2,16,7]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(i,P,u,p,l){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,u&&(this._config+=1),p&&(this._config+=2),l&&(this._config+=4);const c=(0,R.parse)(P),S=i(w=>{if(!u)for(let E of w.created){const d=k.URI.revive(E);c(d.fsPath)&&this._onDidCreate.fire(d)}if(!p)for(let E of w.changed){const d=k.URI.revive(E);c(d.fsPath)&&this._onDidChange.fire(d)}if(!l)for(let E of w.deleted){const d=k.URI.revive(E);c(d.fsPath)&&this._onDidDelete.fire(d)}});this._disposable=T.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,S)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(i,P,u){this._logService=P,this._extHostDocumentsAndEditors=u,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(i,P,u,p){return new I(this._onFileSystemEvent.event,i,P,u,p)}$onFileEvent(i){this._onFileSystemEvent.fire(i)}$onDidRunFileOperation(i,P){switch(i){case 2:this._onDidRenameFile.fire(Object.freeze({files:P.map(u=>({oldUri:k.URI.revive(u.source),newUri:k.URI.revive(u.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:P.map(u=>k.URI.revive(u.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:P.map(u=>k.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(i){return this._createWillExecuteEvent(i,this._onWillRenameFile)}getOnWillCreateFileEvent(i){return this._createWillExecuteEvent(i,this._onWillCreateFile)}getOnWillDeleteFileEvent(i){return this._createWillExecuteEvent(i,this._onWillDeleteFile)}_createWillExecuteEvent(i,P){return(u,p,l)=>{const c=function(w){u.call(p,w)};return c.extension=i,P.event(c,void 0,l)}}async $onWillRunFileOperation(i,P,u,p){switch(i){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:P.map(l=>({oldUri:k.URI.revive(l.source),newUri:k.URI.revive(l.target)}))},u,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:P.map(l=>k.URI.revive(l.target))},u,p);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:P.map(l=>k.URI.revive(l.target))},u,p)}}async _fireWillEvent(i,P,u,p){const l=new Set,c=[];if(await i.fireAsync(P,p,async(w,E)=>{const d=Date.now(),h=await Promise.resolve(w);h instanceof T.WorkspaceEdit&&(c.push(h),l.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-d>u&&this._logService.warn("SLOW file-participant",E.extension.identifier)}),p.isCancellationRequested||c.length===0)return;const S={edits:[]};for(let w of c){let{edits:E}=y.WorkspaceEdit.from(w,this._extHostDocumentsAndEditors);S.edits=S.edits.concat(E)}return{edit:S,extensionNames:Array.from(l)}}}e.ExtHostFileSystemEventService=D}),define(he[213],fe([0,1,10,25,2,16,7,86]),function(X,e,g,R,k,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(u,p,l,c){this.start=u,this.deletedCount=p,this.deletedItems=l,this.items=c}static asApiEvents(u){return u.map(p=>({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(l=>l.apiCell)}))}}class C{constructor(u,p,l){this.notebook=u,this._extHostDocument=p,this._cellData=l,this.handle=l.handle,this.uri=k.URI.revive(l.uri),this.cellKind=l.cellKind,this._outputs=l.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=l.internalMetadata??{},this._metadata=l.metadata??{},this._previousResult=y.NotebookCellExecutionSummary.to(l.internalMetadata??{})}static asModelAddData(u,p){return{EOL:p.eol,lines:p.source,modeId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:u}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const u=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return u.notebook.getCellIndex(u)},notebook:u.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get mime(){return u._mime},set mime(l){u._mime=l},get outputs(){return u._outputs.slice(0)},get metadata(){return u._metadata},get executionSummary(){return u._previousResult}})}return this._apiCell}setOutputs(u){this._outputs=u.map(y.NotebookCellOutput.to)}setOutputItems(u,p,l){const c=l.map(y.NotebookCellOutputItem.to),S=this._outputs.find(w=>w.id===u);S&&(p||(S.items.length=0),S.items.push(...c))}setMetadata(u){this._metadata=u}setInternalMetadata(u){this._internalMetadata=u,this._previousResult=y.NotebookCellExecutionSummary.to(u)}setMime(u){}}e.ExtHostCell=C;class i{constructor(u,p,l,c,S,w){this._proxy=u,this._textDocumentsAndEditors=p,this._textDocuments=l,this._emitter=c,this.uri=S,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=w.viewType,this._metadata=w.metadata??Object.create(null),this._spliceNotebookCells([[0,0,w.cells]],!0),this._versionId=w.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const u=this;this._notebook={get uri(){return u.uri},get version(){return u._versionId},get notebookType(){return u._notebookType},get isDirty(){return u._isDirty},get isUntitled(){return u.uri.scheme===g.Schemas.untitled},get isClosed(){return u._disposed},get metadata(){return u._metadata},get cellCount(){return u._cells.length},cellAt(p){return p=u._validateIndex(p),u._cells[p].apiCell},getCells(p){return(p?u._getCells(p):u._cells).map(c=>c.apiCell)},save(){return u._save()}}}return this._notebook}updateBackup(u){this._backup?.delete(),this._backup=u}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(u){u.metadata&&(this._metadata={...this._metadata,...u.metadata})}acceptDirty(u){this._isDirty=u}acceptModelChanged(u,p){this._versionId=u.versionId,this._isDirty=p;for(const l of u.rawEvents)l.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1):l.kind===I.NotebookCellsChangeType.Move?this._moveCell(l.index,l.newIdx):l.kind===I.NotebookCellsChangeType.Output?this._setCellOutputs(l.index,l.outputs):l.kind===I.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems):l.kind===I.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(l.index,l.language):l.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(l.index,l.mime):l.kind===I.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(l.index,l.metadata):l.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(l.index,l.internalMetadata)}_validateIndex(u){return u=u|0,u<0?0:u>=this._cells.length?this._cells.length-1:u}_validateRange(u){let p=u.start|0,l=u.end|0;return p<0&&(p=0),l>this._cells.length&&(l=this._cells.length),u.with({start:p,end:l})}_getCells(u){u=this._validateRange(u);const p=[];for(let l=u.start;l<u.end;l++)p.push(this._cells[l]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(u,p){if(this._disposed)return;const l=[],c=[],S=[];u.reverse().forEach(w=>{const d=w[2].map(t=>{const s=new C(this,this._textDocumentsAndEditors,t);return p||c.push(C.asModelAddData(this.apiNotebook,t)),s}),h=new D(w[0],w[1],[],d),v=this._cells.splice(w[0],w[1],...d);for(const t of v)S.push(t.uri),h.deletedItems.push(t.apiCell);l.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:S}),p||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(l)}))}_moveCell(u,p){const l=this._cells.splice(u,1);this._cells.splice(p,0,...l);const c=[new D(u,1,l.map(S=>S.apiCell),[]),new D(p,0,[],l)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(c)}))}_setCellOutputs(u,p){const l=this._cells[u];l.setOutputs(p),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[l.apiCell]}))}_setCellOutputItems(u,p,l,c){const S=this._cells[u];S.setOutputItems(p,l,c),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[S.apiCell]}))}_changeCellLanguage(u,p){const l=this._cells[u];l.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelModeChanged(l.uri,p)}_changeCellMime(u,p){const l=this._cells[u];l.apiCell.mime=p}_changeCellMetadata(u,p){const l=this._cells[u],c=l.apiCell.metadata;l.setMetadata(p);const S=l.apiCell.metadata;(0,R.equals)(c,S)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:l.apiCell}))}_changeCellInternalMetadata(u,p){const l=this._cells[u],c=l.internalMetadata;if(l.setInternalMetadata(p),c.runState!==p.runState){const S=p.runState??T.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:l.apiCell,state:S}))}}getCellFromApiCell(u){return this._cells.find(p=>p.apiCell===u)}getCellFromIndex(u){return this._cells[u]}getCell(u){return this._cells.find(p=>p.handle===u)}getCellIndex(u){return this._cells.indexOf(u)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(he[124],fe([0,1,7,16,15]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class y{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:C})}replaceCells(D,C,i){this._throwIfFinalized(),!(D===C&&i.length===0)&&this._collectedEdits.push({editType:1,index:D,count:C-D,cells:i.map(R.NotebookCellData.from)})}}class T{constructor(D,C,i,P,u,p){this.id=D,this._proxy=C,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=u,this._visibleRanges=P,this._viewColumn=p}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(C){if(!Array.isArray(C)||!C.every(g.NotebookRange.isNotebookRange))throw(0,k.illegalArgument)("selections");D._selections=C,D._trySetSelections(C)},get visibleRanges(){return D._visibleRanges},revealRange(C,i){D._proxy.$tryRevealRange(D.id,R.NotebookRange.from(C),i??g.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(C){const i=new y(this.document.version);return C(i),D._applyEdit(i.finalize())},setDecorations(C,i){return D.setDecorations(C,i)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(R.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const C=[];let i=-1;for(let P=0;P<D.cellEdits.length;P++){if(i<0){C.push(D.cellEdits[P]),i++;continue}const p=C[i],l=D.cellEdits[P];if(p.editType===1&&l.editType===1&&p.index===l.index){p.cells.push(...D.cellEdits[P].cells),p.count+=D.cellEdits[P].count;continue}C.push(D.cellEdits[P]),i++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,C)}setDecorations(D,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return C.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(C),D.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(he[214],fe([0,1,16,114,161,21,53]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class I{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,u,p){const l=this._handles++,{title:c,location:S,cancellable:w}=u,E={label:(0,k.localize)(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(l,{location:g.ProgressLocation.from(S),title:c,source:E,cancellable:w},P),this._withProgress(l,p,!!w)}_withProgress(P,u,p){let l;p&&(l=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,l));const c=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),l&&l.dispose()};let S;try{S=u(new C(this._proxy,P),p&&l?l.token:y.CancellationToken.None)}catch(w){throw c(P),w}return S.then(w=>c(P),w=>c(P)),S}$acceptProgressCanceled(P){const u=this._mapHandleToCancellationSource.get(P);u&&(u.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=I;function D(i,P){return i.message=P.message,typeof P.increment=="number"&&(typeof i.increment=="number"?i.increment+=P.increment:i.increment=P.increment),i}class C extends R.Progress{constructor(P,u){super(p=>this.throttledReport(p));this._proxy=P,this._handle=u}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}je([(0,T.throttle)(100,(i,P)=>D(i,P),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(he[125],fe([0,1,52,15,71,16,7]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(u,p,l){const c=I._Keys.nextId();u.$registerTextEditorDecorationType(p.identifier,c,y.DecorationRenderOptions.from(l)),this.value=Object.freeze({key:c,dispose(){u.$removeTextEditorDecorationType(c)}})}}e.TextEditorDecorationType=I,I._Keys=new k.IdGenerator("TextEditorDecorationType");class D{constructor(u,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=u,this._documentVersionId=u.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(u,p){this._throwIfFinalized();let l=null;if(u instanceof T.Position)l=new T.Range(u,u);else if(u instanceof T.Range)l=u;else throw new Error("Unrecognized location");this._pushEdit(l,p,!1)}insert(u,p){this._throwIfFinalized(),this._pushEdit(new T.Range(u,u),p,!0)}delete(u){this._throwIfFinalized();let p=null;if(u instanceof T.Range)p=u;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(u,p,l){const c=this._document.validateRange(u);this._collectedEdits.push({range:c,text:p,forceMoveMarkers:l})}setEndOfLine(u){if(this._throwIfFinalized(),u!==T.EndOfLine.LF&&u!==T.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=u}}e.TextEditorEdit=D;class C{constructor(u,p,l,c){this._proxy=u,this._id=p,this._accept(l),this._logService=c;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(w){S._setTabSize(w)},get insertSpaces(){return S._insertSpaces},set insertSpaces(w){S._setInsertSpaces(w)},get cursorStyle(){return S._cursorStyle},set cursorStyle(w){S._setCursorStyle(w)},get lineNumbers(){return S._lineNumbers},set lineNumbers(w){S._setLineNumbers(w)}}}_accept(u){this._tabSize=u.tabSize,this._insertSpaces=u.insertSpaces,this._cursorStyle=u.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(u.lineNumbers)}_validateTabSize(u){if(u==="auto")return"auto";if(typeof u=="number"){const p=Math.floor(u);return p>0?p:null}if(typeof u=="string"){const p=parseInt(u,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(u){const p=this._validateTabSize(u);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateInsertSpaces(u){return u==="auto"?"auto":u==="false"?!1:Boolean(u)}_setInsertSpaces(u){const p=this._validateInsertSpaces(u);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(u){this._cursorStyle!==u&&(this._cursorStyle=u,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:u})))}_setLineNumbers(u){this._lineNumbers!==u&&(this._lineNumbers=u,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(u)})))}assign(u){const p={};let l=!1;if(typeof u.tabSize!="undefined"){const c=this._validateTabSize(u.tabSize);c==="auto"?(l=!0,p.tabSize=c):typeof c=="number"&&this._tabSize!==c&&(this._tabSize=c,l=!0,p.tabSize=c)}if(typeof u.insertSpaces!="undefined"){const c=this._validateInsertSpaces(u.insertSpaces);c==="auto"?(l=!0,p.insertSpaces=c):this._insertSpaces!==c&&(this._insertSpaces=c,l=!0,p.insertSpaces=c)}typeof u.cursorStyle!="undefined"&&this._cursorStyle!==u.cursorStyle&&(this._cursorStyle=u.cursorStyle,l=!0,p.cursorStyle=u.cursorStyle),typeof u.lineNumbers!="undefined"&&this._lineNumbers!==u.lineNumbers&&(this._lineNumbers=u.lineNumbers,l=!0,p.lineNumbers=y.TextEditorLineNumbersStyle.from(u.lineNumbers)),l&&this._warnOnError(this._proxy.$trySetOptions(this._id,p))}_warnOnError(u){u.catch(p=>this._logService.warn(p))}}e.ExtHostTextEditorOptions=C;class i{constructor(u,p,l,c,S,w,E,d){this.id=u,this._proxy=p,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new C(this._proxy,this.id,w,l),this._visibleRanges=E,this._viewColumn=d;const h=this;this.value=Object.freeze({get document(){return c.getValue()},set document(v){throw(0,R.readonly)("document")},get selection(){return h._selections&&h._selections[0]},set selection(v){if(!(v instanceof T.Selection))throw(0,R.illegalArgument)("selection");h._selections=[v],h._trySetSelection()},get selections(){return h._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof T.Selection)))throw(0,R.illegalArgument)("selections");h._selections=v,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(v){throw(0,R.readonly)("visibleRanges")},get options(){return h._options.value},set options(v){h._disposed||h._options.assign(v)},get viewColumn(){return h._viewColumn},set viewColumn(v){throw(0,R.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new D(c.getValue(),t);return v(s),h._applyEdit(s)},insertSnippet(v,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=h._selections.map(n=>y.Range.from(n));else if(t instanceof T.Position){const{lineNumber:n,column:a}=y.Position.from(t);r=[{startLineNumber:n,startColumn:a,endLineNumber:n,endColumn:a}]}else if(t instanceof T.Range)r=[y.Range.from(t)];else{r=[];for(const n of t)if(n instanceof T.Range)r.push(y.Range.from(n));else{const{lineNumber:a,column:f}=y.Position.from(n);r.push({startLineNumber:a,startColumn:f,endLineNumber:a,endColumn:f})}}return p.$tryInsertSnippet(u,v.value,r,s)},setDecorations(v,t){const s=t.length===0;s&&!h._hasDecorationsForKey.has(v.key)||(s?h._hasDecorationsForKey.delete(v.key):h._hasDecorationsForKey.add(v.key),h._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return p.$trySetDecorations(u,v.key,y.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let n=0,a=t.length;n<a;n++){const f=t[n];r[4*n]=f.start.line+1,r[4*n+1]=f.start.character+1,r[4*n+2]=f.end.line+1,r[4*n+3]=f.end.character+1}return p.$trySetDecorationsFast(u,v.key,r)}}))},revealRange(v,t){h._runOnProxy(()=>p.$tryRevealRange(u,y.Range.from(v),t||T.TextEditorRevealType.Default))},show(v){p.$tryShowEditor(u,y.ViewColumn.from(v))},hide(){p.$tryHideEditor(u)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(u){(0,g.ok)(!this._disposed),this._options._accept(u)}_acceptVisibleRanges(u){(0,g.ok)(!this._disposed),this._visibleRanges=u}_acceptViewColumn(u){(0,g.ok)(!this._disposed),this._viewColumn=u}_acceptSelections(u){(0,g.ok)(!this._disposed),this._selections=u}async _trySetSelection(){const u=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,u)),this.value}_applyEdit(u){const p=u.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const l=p.edits.map(S=>S.range);l.sort((S,w)=>S.end.line===w.end.line?S.end.character===w.end.character?S.start.line===w.start.line?S.start.character-w.start.character:S.start.line-w.start.line:S.end.character-w.end.character:S.end.line-w.end.line);for(let S=0,w=l.length-1;S<w;S++){const E=l[S].end;if(l[S+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=p.edits.map(S=>({range:y.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,c,{setEndOfLine:typeof p.setEndOfLine=="number"?y.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(u){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=i}),define(he[215],fe([0,1,164,24,2,3,6,17,7,14,18,16,21]),function(X,e,g,R,k,y,T,I,D,C,i,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function p(S,w){if((0,C.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let E;return Array.isArray(S.highlights)&&(E=S.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),E=E.length?E:void 0),{label:S.label,highlights:E}}}class l{constructor(w,E,d){this._proxy=w,this.commands=E,this.logService=d,this.treeViews=new Map;function h(v){return v&&v.$treeViewId&&v.$treeItemHandle}E.registerArgumentProcessor({processArgument:v=>h(v)?this.convertArgument(v):Array.isArray(v)&&v.length>0?v.map(t=>h(t)?this.convertArgument(t):t):v})}registerTreeDataProvider(w,E,d){const h=this.createTreeView(w,{treeDataProvider:E},d);return{dispose:()=>h.dispose()}}createTreeView(w,E,d){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=E.dragAndDropController!==void 0,v=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany,canDragAndDrop:h}),t=this.createExtHostTreeView(w,E,d);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(s){t.message=s},get title(){return t.title},set title(s){t.title=s},get description(){return t.description},set description(s){t.description=s},reveal:(s,r)=>t.reveal(s,r),dispose:async()=>{await v,this.treeViews.delete(w),t.dispose()}}}$getChildren(w,E){const d=this.treeViews.get(w);return d?d.getChildren(E):Promise.reject(new Error((0,g.localize)(0,null,w)))}$onDrop(w,E,d){const h=this.treeViews.get(w);return h?h.onDrop(E,d):Promise.reject(new Error((0,g.localize)(1,null,w)))}async $hasResolve(w){const E=this.treeViews.get(w);if(!E)throw new Error((0,g.localize)(2,null,w));return E.hasResolve}$resolve(w,E,d){const h=this.treeViews.get(w);if(!h)throw new Error((0,g.localize)(3,null,w));return h.resolveTreeItem(E,d)}$setExpanded(w,E,d){const h=this.treeViews.get(w);if(!h)throw new Error((0,g.localize)(4,null,w));h.setExpanded(E,d)}$setSelection(w,E){const d=this.treeViews.get(w);if(!d)throw new Error((0,g.localize)(5,null,w));d.setSelection(E)}$setVisible(w,E){const d=this.treeViews.get(w);if(!d)throw new Error((0,g.localize)(6,null,w));d.setVisible(E)}createExtHostTreeView(w,E,d){const h=new c(w,E,this._proxy,this.commands.converter,this.logService,d);return this.treeViews.set(w,h),h}convertArgument(w){const E=this.treeViews.get(w.$treeViewId);return E?E.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=l;class c extends T.Disposable{constructor(w,E,d,h,v,t){super();if(this.viewId=w,this.proxy=d,this.commands=h,this.logService=v,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new u.CancellationTokenSource,t.contributes&&t.contributes.views)for(const n in t.contributes.views)for(const a of t.contributes.views[n])a.id===w&&(this._title=a.name);this.dataProvider=E.treeDataProvider,this.dndController=E.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(n=>this._onDidChangeData.fire({message:!1,element:n}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let s,r;this._register(y.Event.debounce(this._onDidChangeData.event,(n,a)=>(n||(n={message:!1,elements:[]}),a.element!==!1&&(s||(s=new Promise(f=>r=f),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(a.element)?n.elements.push(...a.element):n.elements.push(a.element)),a.message&&(n.message=!0),n),200,!0)(({message:n,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=r;return s=null,this.refresh(a).then(()=>f())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,C.isUndefinedOrNull)(w))}getChildren(w){const E=w?this.getExtensionElement(w):void 0;if(w&&!E)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const d=this.getChildrenNodes(w);return(d?Promise.resolve(d):this.fetchChildrenNodes(E)).then(h=>h.map(v=>v.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,E){E=E||{select:!0,focus:!1};const d=(0,C.isUndefinedOrNull)(E.select)?!0:E.select,h=(0,C.isUndefinedOrNull)(E.focus)?!1:E.focus,v=(0,C.isUndefinedOrNull)(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:t.map(r=>r.item)},{select:d,focus:h,expand:v})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:h,expand:v})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,E){const d=this.getExtensionElement(w);d&&(E?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelection(w){(0,i.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(w,E){const d=w.map(v=>this.getExtensionElement(v)).filter(v=>!(0,C.isUndefinedOrNull)(v)),h=this.getExtensionElement(E);return d&&h?(0,I.asPromise)(()=>this.dndController?.onDrop(d,h)):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,E){if(!this.dataProvider.resolveTreeItem)return;const d=this.elements.get(w);if(d){const h=this.nodes.get(d);if(h){const v=await this.dataProvider.resolveTreeItem(h.extensionItem,d,E)??h.extensionItem;return h.item.tooltip=this.getTooltip(v.tooltip),h.item.command=this.getCommand(h.disposableStore,v.command),h.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(E=>E?this.resolveUnknownParentChain(E).then(d=>this.resolveTreeNode(E,d[d.length-1]).then(h=>(d.push(h),d))):Promise.resolve([]))}resolveParent(w){const E=this.nodes.get(w);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,E){const d=this.nodes.get(w);return d?Promise.resolve(d):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(h=>this.createHandle(w,h,E,!0)).then(h=>this.getChildren(E?E.item.handle:void 0).then(()=>{const v=this.getExtensionElement(h);if(v){const t=this.nodes.get(v);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${h}`)}))}getChildrenNodes(w){if(w){let E;if(typeof w=="string"){const d=this.getExtensionElement(w);E=d?this.nodes.get(d):void 0}else E=w;return E&&E.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const E=new u.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=w?this.nodes.get(w):void 0,h=await this.dataProvider.getChildren(w);if(E.token.isCancellationRequested)return[];const v=await Promise.all((0,i.coalesce)(h||[]).map(async t=>{const s=await this.dataProvider.getTreeItem(t);return s&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,s,d):null}));return E.token.isCancellationRequested?[]:(0,i.coalesce)(v)}finally{E.dispose()}}refresh(w){if(w.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new u.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(w);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const E=new Set,d=w.map(v=>this.nodes.get(v));for(const v of d)if(v&&!E.has(v.item.handle)){let t=v;for(;t&&t.parent&&d.findIndex(s=>t&&t.parent&&s&&s.item.handle===t.parent.item.handle)===-1;){const s=this.elements.get(t.parent.item.handle);t=s?this.nodes.get(s):void 0}t&&!t.parent&&E.add(v.item.handle)}const h=[];return E.forEach(v=>{const t=this.elements.get(v);if(t){const s=this.nodes.get(t);s&&(!s.parent||!E.has(s.parent.item.handle))&&h.push(v)}}),h}refreshHandles(w){const E={};return Promise.all(w.map(d=>this.refreshNode(d).then(h=>{h&&(E[d]=h.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(w){const E=this.getExtensionElement(w);if(E){const d=this.nodes.get(E);if(d)return this.clearChildren(E),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(h=>{if(h){const v=this.createTreeNode(E,h,d.parent);return this.updateNodeCache(E,v,d,d.parent),d.dispose(),v}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,E,d){const h=this.createTreeNode(w,E,d);if(E.id&&this.elements.has(h.item.handle))throw new Error((0,g.localize)(7,null,E.id));return this.addNodeToCache(w,h),this.addNodeToParentCache(h,d),h}getTooltip(w){return D.MarkdownString.isMarkdownString(w)?P.MarkdownString.from(w):w}getCommand(w,E){return E?this.commands.toInternal(E,w):void 0}createTreeNode(w,E,d){const h=new T.DisposableStore,v=this.createHandle(w,E,d),t=this.getLightIconPath(E);return{item:{handle:v,parentHandle:d?d.item.handle:void 0,label:p(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(h,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:(0,C.isUndefinedOrNull)(E.collapsibleState)?D.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:d,children:void 0,disposableStore:h,dispose(){h.dispose()}}}getThemeIcon(w){return w.iconPath instanceof D.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:E,label:d,resourceUri:h},v,t){if(E)return`${c.ID_HANDLE_PREFIX}/${E}`;const s=p(d,this.extension),r=v?v.item.handle:c.LABEL_HANDLE_PREFIX;let n=s?s.label:h?(0,R.basename)(h):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const a=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,f=this.getChildrenNodes(v)||[];let m,b=0;do{if(m=`${r}/${b}:${n}`,t||!this.elements.has(m)||a===m)break;b++}while(b<=f.length);return m}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon))return typeof w.iconPath=="string"||k.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return k.URI.isUri(w)?w:k.URI.file(w)}addNodeToCache(w,E){this.elements.set(E.item.handle,w),this.nodes.set(w,E)}updateNodeCache(w,E,d,h){this.elements.delete(E.item.handle),this.nodes.delete(w),E.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(w,E);const v=this.getChildrenNodes(h)||[],t=v.filter(s=>s.item.handle===d.item.handle)[0];t&&v.splice(v.indexOf(t),1,E)}addNodeToParentCache(w,E){E?(E.children||(E.children=[]),E.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const E=this.nodes.get(w);if(E){if(E.children)for(const d of E.children){const h=this.elements.get(d.item.handle);h&&this.clear(h)}E.children=void 0}}else this.clearAll()}clear(w){const E=this.nodes.get(w);if(E){if(E.children)for(const d of E.children){const h=this.elements.get(d.item.handle);h&&this.clear(h)}this.nodes.delete(w),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}c.LABEL_HANDLE_PREFIX="0",c.ID_HANDLE_PREFIX="1"}),define(he[216],fe([0,1,17,3,54,6,14,118,16,7,122]),function(X,e,g,R,k,y,T,I,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=void 0;var P;(function(l){l[l.Disconnected=0]="Disconnected",l[l.IsChild=1]="IsChild",l[l.IsParent=2]="IsParent",l[l.IsSame=3]="IsSame"})(P=e.TestPosition||(e.TestPosition={}));class u{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(c){if(this.map.has(c.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${c.item.extId}`);this.map.set(c.item.extId,c),c.parent||this._roots.add(c)}has(c){return this.map.has(c)}delete(c){const S=this.map.get(c);return S?(this.map.delete(c),this._roots.delete(S),!0):!1}get(c){return this.map.get(c)}comparePositions(c,S){const w=typeof c=="string"?this.map.get(c):c,E=typeof S=="string"?this.map.get(S):S;if(!w||!E)return 0;if(w===E)return 3;for(let d=this.map.get(E.parent);d;d=this.map.get(d.parent))if(d===w)return 1;for(let d=this.map.get(w.parent);d;d=this.map.get(d.parent))if(d===E)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=u;class p extends y.Disposable{constructor(c){super();this.controllerId=c,this.testItemToInternal=new Map,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new R.Emitter),this.root=new C.TestItemImpl(`${this.controllerId}Root`,this.controllerId,void 0,void 0,void 0),this.tree=new u,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.addItemInner(this.root,null)}set resolveHandler(c){this._resolveHandler=c;for(const S of this.testItemToInternal.values())this.updateExpandability(S)}get roots(){return k.Iterable.filter(this.testItemToInternal.values(),c=>c.parent===null)}getTestByReference(c){return this.testItemToInternal.get(c)}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){const S=this.diff[this.diff.length-1];if(S&&c[0]===1){if(S[0]===1&&S[1].extId===c[1].extId){(0,i.applyTestItemUpdate)(S[1],c[1]);return}if(S[0]===0&&S[1].item.extId===c[1].extId){(0,i.applyTestItemUpdate)(S[1],c[1]);return}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,S){const w=this.tree.get(c);if(!!w){if((w.expandLevels===void 0||S>w.expandLevels)&&(w.expandLevels=S),w.expand===1){const E=this.resolveChildren(w);return E.isOpen()?this.expandChildren(w,S-1):E.wait().then(()=>this.expandChildren(w,S-1))}else if(w.expand===3)return w.resolveBarrier?.isOpen()===!1?w.resolveBarrier.wait().then(()=>this.expandChildren(w,S-1)):this.expandChildren(w,S-1)}}dispose(){for(const c of this.testItemToInternal.values())(0,I.getPrivateApiFor)(c.actual).bus.dispose();this.diff=[],super.dispose()}onTestItemEvent(c,S){const w=c?.actual.id;switch(S[0]){case 2:this.pushDiff([4,w]);break;case 1:this.removeItem(c);break;case 0:this.addItemInner(S[1],c);break;case 3:const[E,d,h]=S;switch(d){case"canResolveChildren":this.updateExpandability(c);break;case"range":this.pushDiff([1,{extId:w,item:{range:D.Range.from(h)}}]);break;case"error":this.pushDiff([1,{extId:w,item:{error:D.MarkdownString.fromStrict(h)||null}}]);break;default:this.pushDiff([1,{extId:w,item:{[d]:h??null}}]);break}break;default:(0,T.assertNever)(S[0])}}addItemInner(c,S){if(!(c instanceof C.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);if(this.testItemToInternal.has(c))throw new Error(`Attempted to add a single TestItem ${c.id} multiple times to the tree`);if(this.tree.has(c.id))throw new Error(`Attempted to insert a duplicate test item ID ${c.id}`);const w=S?S.item.extId:null,E=S?S.expandLevels:1,d={actual:c,parent:w,item:D.TestItem.from(c),expandLevels:E?E-1:void 0,expand:0,controllerId:this.controllerId};this.tree.add(d),this.testItemToInternal.set(c,d),this.pushDiff([0,{parent:w,controllerId:this.controllerId,expand:d.expand,item:d.item}]);const h=(0,I.getPrivateApiFor)(c);h.bus.event(this.onTestItemEvent.bind(this,d)),this.updateExpandability(d);for(const v of h.children.values())this.testItemToInternal.has(v)||this.addItemInner(v,d)}updateExpandability(c){let S;this._resolveHandler?c.resolveBarrier?S=c.resolveBarrier.isOpen()?3:2:S=c.actual.canResolveChildren?1:0:S=0,S!==c.expand&&(c.expand=S,this.pushDiff([1,{extId:c.actual.id,expand:S}]),S===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,S){if(S<0)return;const w=[...c.actual.children.values()].map(E=>this.expand(E.id,S)).filter(g.isThenable);if(w.length)return Promise.all(w).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const E=new g.Barrier;return E.open(),E}c.expand=2,this.pushExpandStateUpdate(c);const S=c.resolveBarrier=new g.Barrier;let w;try{w=this._resolveHandler(c.actual)}catch(E){c.actual.error=E.stack||E.message}return(0,g.isThenable)(w)?w.catch(E=>c.actual.error=E.stack||E.message).then(()=>{S.open(),this.updateExpandability(c)}):(S.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff([1,{extId:c.actual.id,expand:c.expand}])}removeItem(c){this.pushDiff([2,c.actual.id]);const S=[c];for(;S.length;){const w=S.pop();if(!!w){this.tree.delete(w.item.extId),this.testItemToInternal.delete(w.actual);for(const E of w.actual.children.values())S.push(this.tree.get(E.id))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.SingleUseTestCollection=p}),define(he[217],fe([0,1,4,178]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(R.IEnvironmentService)}),define(he[218],fe([0,1,26,3,9]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=y;class T{constructor(i){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let P of i.activationEvents)P==="onUri"&&(P=`onUri:${g.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(i)}}keepOnly(i){const P=new Set;i.forEach(u=>P.add(g.ExtensionIdentifier.toKey(u))),this._extensionDescriptions=this._extensionDescriptions.filter(u=>P.has(g.ExtensionIdentifier.toKey(u.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,P){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const u=T._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(u.map(p=>p.identifier)),P.length>0){const p=new Set;P.forEach(l=>p.add(g.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!p.has(g.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(u)}static _findLoopingExtensions(i){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,w){this.addNode(S),this.addNode(w),this._arcs.has(S)?this._arcs.get(S).push(w):this._arcs.set(S,[w])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,w){const E=P.getArcs(S);for(let d=0;d<E.length;d++)if(!w.has(E[d]))return!1;return!0}getNodes(){return this._nodesArr}};let u=new Map;for(let S of i){const w=g.ExtensionIdentifier.toKey(S.identifier);if(u.set(w,S),S.extensionDependencies)for(let E of S.extensionDependencies){const d=g.ExtensionIdentifier.toKey(E);P.addArc(w,d)}}let p=new Set;P.getNodes().filter(S=>P.getArcs(S).length===0).forEach(S=>p.add(S));let l=P.getNodes().filter(S=>!p.has(S)),c;do{c=!1;for(let S=0;S<l.length;S++){const w=l[S];P.hasOnlyGoodArcs(w,p)&&(l.splice(S,1),S--,p.add(w),c=!0)}}while(c);return l.map(S=>u.get(S))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const P=this._activationMap.get(i);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const P=this._extensionsMap.get(g.ExtensionIdentifier.toKey(i));return P||void 0}}e.ExtensionDescriptionRegistry=T;var I;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(I||(I={}));function D(C,i){const P=C.isBuiltin?0:C.isUnderDevelopment?2:1,u=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(P!==u)return P-u;const p=k.posix.basename(C.extensionLocation.path),l=k.posix.basename(i.extensionLocation.path);return p<l?-1:p>l?1:0}}),define(he[219],fe([0,1,22]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function y(I){const D=g.VSBuffer.alloc(1);switch(I){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=y;function T(I,D){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=T}),define(he[34],fe([0,1,3,2,4,26,180]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,k.createDecorator)("extensionService");class I{constructor(E){this.dependency=E}}e.MissingExtensionDependency=I;var D;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(E,d,h,v){this.codeLoadingTime=E,this.activateCallTime=d,this.activateResolvedTime=h,this.activationReason=v}}e.ActivationTimes=C;class i{constructor(E,d){this.description=E,this.value=d}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var P;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function u(w){w.enableProposedApi||p(w)}e.checkProposedApiEnabled=u;function p(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=p;function l(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,T.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=l;function c(w,E){return{identifier:new y.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!E,extensionLocation:w.location,...w.manifest,uuid:w.identifier.uuid}}e.toExtensionDescription=c;class S{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(E,d){return Promise.resolve()}_onWillActivateExtension(E){}_onDidActivateExtension(E,d,h,v,t){}_onDidActivateExtensionError(E,d){}_onExtensionRuntimeError(E,d){}_onExtensionHostExit(E){}}e.NullExtensionService=S}),define(he[220],fe([0,1,26,34,12]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class T{constructor(l,c,S,w){this.startup=l,this.codeLoadingTime=c,this.activateCallTime=S,this.activateResolvedTime=w}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class I{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,c){return l===-1||c===-1?-1:c-l}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class D{constructor(l,c,S,w,E,d){this.activationFailed=l,this.activationFailedError=c,this.activationTimes=S,this.module=w,this.exports=E,this.subscriptions=d}}e.ActivatedExtension=D;class C extends D{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class i extends D{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class P extends D{constructor(l){super(!0,l,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=P;let u=class{constructor(l,c,S,w,E){this._logService=E,this._registry=l,this._resolvedExtensionsSet=new Set,c.forEach(d=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(d))),this._hostExtensionsMap=new Map,S.forEach(d=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(d),d)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(l){const c=g.ExtensionIdentifier.toKey(l);return this._activatedExtensions.has(c)}getActivatedExtension(l){const c=g.ExtensionIdentifier.toKey(l),S=this._activatedExtensions.get(c);if(!S)throw new Error("Extension `"+l.value+"` is not known or not activated");return S}activateByEvent(l,c){if(this._alreadyActivatedEvents[l])return y;const S=this._registry.getExtensionDescriptionsForActivationEvent(l);return this._activateExtensions(S.map(w=>({id:w.identifier,reason:{startup:c,extensionId:w.identifier,activationEvent:l}}))).then(()=>{this._alreadyActivatedEvents[l]=!0})}activateById(l,c){const S=this._registry.getExtensionDescription(l);if(!S)throw new Error("Extension `"+l+"` is not known");return this._activateExtensions([{id:S.identifier,reason:c}])}_handleActivateRequest(l,c,S){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(l.id))){c[g.ExtensionIdentifier.toKey(l.id)]=l;return}const w=this._registry.getExtensionDescription(l.id);if(!w){const h=new Error(`Cannot activate unknown extension '${l.id.value}'`);this._host.onExtensionActivationError(l.id,h,new R.MissingExtensionDependency(l.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(l.id),new P(h));return}const E=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let d=!0;for(let h=0,v=E.length;h<v;h++){const t=E[h];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const s=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const f=w.displayName||w.identifier.value,m=this._registry.getExtensionDescription(t),b=m&&m.displayName||t,_=new Error(`Cannot activate the '${f}' extension because its dependency '${b}' failed to activate`);_.detail=s.activationFailedError,this._host.onExtensionActivationError(w.identifier,_,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(w.identifier),new P(_));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){d=!1,c[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:l.reason};continue}const r=this._registry.getExtensionDescription(t);if(r){d=!1,c[g.ExtensionIdentifier.toKey(t)]={id:r.identifier,reason:l.reason};continue}const n=w.displayName||w.identifier.value,a=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,a,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(w.identifier),new P(a));return}d?c[g.ExtensionIdentifier.toKey(w.identifier)]=l:S.push(l)}_activateExtensions(l){if(l.length===0||(l=l.filter(E=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(E.id))),l.length===0))return Promise.resolve(void 0);const c=Object.create(null),S=[];for(let E=0,d=l.length;E<d;E++)this._handleActivateRequest(l[E],c,S);for(let E=0,d=S.length;E<d;E++){const h=g.ExtensionIdentifier.toKey(S[E].id);c[h]&&delete c[h]}const w=Object.keys(c).map(E=>c[E]);return S.length===0?Promise.all(w.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(w).then(E=>this._activateExtensions(S))}_activateExtension(l,c){const S=g.ExtensionIdentifier.toKey(l);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const w=this._activatingExtensions.get(S);if(w)return w;const E=this._host.actualActivateExtension(l,c).then(void 0,d=>{const h=new Error;return d&&d.name&&(h.name=d.name),d&&d.message?h.message=`Activating extension '${l.value}' failed: ${d.message}.`:h.message=`Activating extension '${l.value}' failed: ${d}.`,d&&d.stack&&(h.stack=d.stack),this._host.onExtensionActivationError(l,h,null),this._logService.error(`Activating extension ${l.value} failed due to an error:`),this._logService.error(d),new P(d)}).then(d=>{this._activatedExtensions.set(S,d),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,E),E}};u=je([He(4,k.ILogService)],u),e.ExtensionsActivator=u}),define(he[221],fe([0,1,12,34,27,10,112]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let I=class extends g.LogService{constructor(C){if(C.logFile.scheme!==y.Schemas.file)throw new Error("Only file-logging supported");super(new T.SpdLogLogger(R.ExtensionHostLogFileName,C.logFile.fsPath,!0,C.logLevel))}$setLevel(C){this.setLevel(C)}};I=je([He(0,k.IExtHostInitDataService)],I),e.ExtHostLogService=I}),define(he[222],fe([0,1,15]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,T)=>{this._actualOk=y,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,g.onUnexpectedError)(y))}then(y,T){return this._ensureActual().then(y,T)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=R}),define(he[126],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(D,C){this._proxyIdentifierBrand=void 0,this.isMain=D,this.sid=C,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const R=[];function k(I){const D=new g(!0,I);return R[D.nid]=D,D}e.createMainContextProxyIdentifier=k;function y(I){const D=new g(!1,I);return R[D.nid]=D,D}e.createExtHostContextProxyIdentifier=y;function T(I){return R[I].sid}e.getStringIdentifierForProxy=T}),define(he[5],fe([0,1,57,2,126]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var T;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var u;(function(d){d.name="$ident";function h(t,s){return Object.defineProperty(t,d.name,{value:s,enumerable:!0}),t}d.mixin=h;function v(t){return t[d.name]}d.of=v})(u=e.ObjectIdentifier||(e.ObjectIdentifier={}));class p{static mixin(h){return h._id=p._n++,h}}e.IdObject=p,p._n=0;var l;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var c;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(c=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(d){d[d.File=1]="File",d[d.Text=2]="Text",d[d.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(d){if(d&&d.edits)for(const h of d.edits)typeof h.resource=="object"?h.resource=R.URI.revive(h.resource):(h.newUri=R.URI.revive(h.newUri),h.oldUri=R.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,g.revive)(h.metadata));return d}e.reviveWorkspaceEditDto=w;var E;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,k.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,k.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(he[87],fe([0,1,5,3,4]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(I){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,D){return this._proxy.$getPassword(I,D)}store(I,D,C){return this._proxy.$setPassword(I,D,C)}delete(I,D){return this._proxy.$deletePassword(I,D)}}e.ExtHostSecretState=y,e.IExtHostSecretState=(0,k.createDecorator)("IExtHostSecretState")}),define(he[61],fe([0,1,4,12,5,13]),function(X,e,g,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let T=class{constructor(D,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(k.MainContext.MainThreadTelemetry)}report(D,C,i){const P=this.getUsageKey(D,C);this._reportedUsages.has(P)||(this._reportedUsages.add(P),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:D}))}getUsageKey(D,C){return`${D}-${C.identifier.value}`}};T=je([He(0,y.IExtHostRpcService),He(1,R.ILogService)],T),e.ExtHostApiDeprecationService=T,e.NullApiDeprecationService=Object.freeze(new class{report(I,D,C){}})}),define(he[223],fe([0,1,3,5,7,26]),function(X,e,g,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class T{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,C,i,P={}){const u=y.ExtensionIdentifier.toKey(D.identifier),p=this._inFlightRequests.get(u)||[],l=[...i].sort().join(" ");let c=p.find(S=>S.scopes===l);if(c)return c.result;{const S=this._getSession(D,u,C,i,P);c={scopes:l,result:S},p.push(c),this._inFlightRequests.set(u,p);try{await S}finally{const w=p.findIndex(E=>E.scopes===l);w>-1&&(p.splice(w),this._inFlightRequests.set(u,p))}return S}}async _getSession(D,C,i,P,u={}){await this._proxy.$ensureProvider(i);const p=D.displayName||D.name;return this._proxy.$getSession(i,P,C,p,u)}async removeSession(D,C){const i=this._authenticationProviders.get(D);return i?i.provider.removeSession(C):this._proxy.$removeSession(D,C)}registerAuthenticationProvider(D,C,i,P){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:C,provider:i,options:P??{supportsMultipleAccounts:!1}}),this._providers.find(p=>p.id===D)||this._providers.push({id:D,label:C});const u=i.onDidChangeSessions(p=>{this._proxy.$sendDidChangeSessions(D,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,C,P?.supportsMultipleAccounts??!1),new k.Disposable(()=>{u.dispose(),this._authenticationProviders.delete(D);const p=this._providers.findIndex(l=>l.id===D);p>-1&&this._providers.splice(p),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,C){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,C){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,C){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,C){return this._onDidChangeSessions.fire({provider:{id:D,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=T}),define(he[224],fe([0,1,5,13,16]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(I,D){this._extHostDocumentsAndEditors=D,this._proxy=I.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const D=k.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};y=je([He(0,R.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(he[225],fe([0,1,5]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(y){const T=y.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return T.$readText()},writeText(I){return T.$writeText(I)}})}}e.ExtHostClipboard=R}),define(he[50],fe([0,1,14,7,16,25,5,18,12,57,40,46,2,6,4,13]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,s){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(T.MainContext.MainThreadCommands),this._logService=s,this.converter=new w(this,r=>{const n=this._apiCommands.get(r);return n?.result===d.Void?n:void 0},s),this._argumentProcessors=[{processArgument(r){return(0,C.revive)(r)}},{processArgument(r){return(0,y.cloneAndChange)(r,function(n){if(i.Range.isIRange(n))return k.Range.to(n);if(P.Position.isIPosition(n))return k.Position.to(n);if(i.Range.isIRange(n.range)&&u.URI.isUri(n.uri))return k.location.to(n);if(!Array.isArray(n))return n})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const s=this.registerCommand(!1,t.id,async(...r)=>{const n=t.args.map((f,m)=>{if(!f.validate(r[m]))throw new Error(`Invalid argument '${f.name}' when running '${t.id}', received: ${r[m]}`);return f.convert(r[m])}),a=await this.executeCommand(t.internalId,...n);return t.result.convert(a,r,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{s.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,s,r,n,a){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:r,thisArg:n,description:a}),t&&this._proxy.$registerCommand(s),new R.Disposable(()=>{this._commands.delete(s)&&t&&this._proxy.$unregisterCommand(s)})}executeCommand(t,...s){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,s,!0)}async _doExecuteCommand(t,s,r){if(this._commands.has(t))return this._executeContributedCommand(t,s);{const n=(0,y.cloneAndChange)(s,function(a){if(a instanceof R.Position)return k.Position.from(a);if(a instanceof R.Range)return k.Range.from(a);if(a instanceof R.Location)return k.location.from(a);if(R.NotebookRange.isNotebookRange(a))return k.NotebookRange.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,n,r);return(0,C.revive)(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,s,!1);throw a}}}async _executeContributedCommand(t,s){const r=this._commands.get(t);if(!r)throw new Error("Unknown command");let{callback:n,thisArg:a,description:f}=r;if(f)for(let m=0;m<f.args.length;m++)try{(0,g.validateConstraint)(s[m],f.args[m].constraint)}catch(b){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${f.args[m].name}' - ${f.args[m].description}`)}try{return await n.apply(a,s)}catch(m){if(t===this.converter.delegatingCommandId){const b=this.converter.getActualCommand(...s);b&&(t=b.command)}throw this._logService.error(m,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(s=s.map(r=>this._argumentProcessors.reduce((n,a)=>a.processArgument(n),r)),this._executeContributedCommand(t,s)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(s=>(t&&(s=s.filter(r=>r[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[s,r]of this._commands){let{description:n}=r;n&&(t[s]=n)}return Promise.resolve(t)}};S=je([He(0,c.IExtHostRpcService),He(1,D.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class w{constructor(t,s,r){this._commands=t,this._lookupApiCommand=s,this._logService=r,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,s){if(!t)return;const r={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return r;const n=this._lookupApiCommand(t.command);if(n)r.id=n.internalId,r.arguments=n.args.map((a,f)=>a.convert(t.arguments&&t.arguments[f]));else if((0,I.isNonEmptyArray)(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),s.add((0,p.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),r.$ident=a,r.id=this.delegatingCommandId,r.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return r}fromInternal(t){const s=T.ObjectIdentifier.of(t);return typeof s=="number"?this._cache.get(s):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const s=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class E{constructor(t,s,r,n){this.name=t,this.description=s,this.validate=r,this.convert=n}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,s){return new E(t??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",v=>u.URI.isUri(v),v=>v),E.Position=new E("position","A position in a text document",v=>R.Position.isPosition(v),k.Position.from),E.Range=new E("range","A range in a text document",v=>R.Range.isRange(v),k.Range.from),E.Selection=new E("selection","A selection in a text document",v=>R.Selection.isSelection(v),k.Selection.from),E.Number=new E("number","",v=>typeof v=="number",v=>v),E.String=new E("string","",v=>typeof v=="string",v=>v),E.CallHierarchyItem=new E("item","A call hierarchy item",v=>v instanceof R.CallHierarchyItem,k.CallHierarchyItem.to);class d{constructor(t,s){this.description=t,this.convert=s}}e.ApiCommandResult=d,d.Void=new d("no result",v=>v);class h{constructor(t,s,r,n,a){this.id=t,this.internalId=s,this.description=r,this.args=n,this.result=a}}e.ApiCommand=h}),define(he[226],fe([0,1,16,7,79,50,18,108]),function(X,e,g,R,k,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",i(g.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,p)=>{if((0,T.isFalsyOrEmpty)(u))return;class l extends R.SymbolInformation{static to(S){const w=new l(S.name,g.SymbolKind.to(S.kind),S.containerName||"",new R.Location(p[0],g.Range.to(S.range)));return w.detail=S.detail,w.range=w.location.range,w.selectionRange=g.Range.to(S.selectionRange),w.children=S.children?S.children.map(l.to):[],w}}return u.map(l.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new y.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",i(g.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",i(g.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",u=>Array.isArray(u)&&u.every(p=>R.Position.isPosition(p)),u=>u.map(g.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(p=>{let l;for(const c of p.reverse())l=new R.SelectionRange(g.Range.to(c),l);return l}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>{const p=[];if(Array.isArray(u))for(let l of u)p.push(...l[1].map(g.WorkspaceSymbol.to));return p})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(g.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(g.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",u=>u.map(g.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(!!u){if(u.rejectReason)throw new Error(u.rejectReason);return g.WorkspaceEdit.to(u)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(g.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new R.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const p=(0,I.decodeSemanticTokensDto)(u);if(p.type==="full")return new R.SemanticTokens(p.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new R.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const p=(0,I.decodeSemanticTokensDto)(u);if(p.type==="full")return new R.SemanticTokens(p.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,p,l)=>{if(!u)return new R.CompletionList([]);const c=u.suggestions.map(S=>g.CompletionItem.to(S,l));return new R.CompletionList(c,u.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return g.SignatureHelp.to(u)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,p,l)=>i(c=>new R.CodeLens(g.Range.to(c.range),c.command&&l.fromInternal(c.command)))(u))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>R.Range.isRange(u),u=>R.Selection.isSelection(u)?g.Selection.from(u):g.Range.from(u)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,p,l)=>i(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(c.command)}else{const S=new R.CodeAction(c.title,c.kind?new R.CodeActionKind(c.kind):void 0);return c.edit&&(S.edit=g.WorkspaceEdit.to(c.edit)),c.command&&(S.command=l.fromInternal(c.command)),S.isPreferred=c.isPreferred,S}})(u))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(p=>new R.ColorInformation(g.Range.to(p.range),g.Color.to(p.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",u=>u instanceof R.Color,g.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:g.Range.from(u.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(g.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",u=>u.map(g.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",i(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(p=>g.NotebookExclusiveDocumentPattern.to(p))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",u=>u.map(g.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[g.ViewColumn.from(u.viewColumn),g.TextEditorOpenOptions.from(u)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[u,void 0]:[g.ViewColumn.from(u.viewColumn),g.TextEditorOpenOptions.from(u)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[g.ViewColumn.from(u.viewColumn),g.TextEditorOpenOptions.from(u)]).optional()],y.ApiCommandResult.Void)];class C{static register(p){D.forEach(p.registerApiCommand,p)}}e.ExtHostApiCommands=C;function i(u){return p=>{if(Array.isArray(p))return p.map(u)}}function P(u){if(!Array.isArray(u))return;const p=[];for(const l of u)k.isLocationLink(l)?p.push(g.DefinitionLink.to(l)):p.push(g.location.to(l));return p}}),define(he[227],fe([0,1,17,53,3,6,2,79,26,16,7,5]),function(X,e,g,R,k,y,T,I,D,C,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function u(p,l,c){const S=p.getProxy(P.MainContext.MainThreadComments);class w{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,l.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const a=this._commentControllers.get(n.handle);return a||n}else if(n&&n.$mid===7){const a=this._commentControllers.get(n.commentControlHandle);if(!a)return n;const f=a.getCommentThread(n.commentThreadHandle);return f||n}else if(n&&n.$mid===8){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const f=a.getCommentThread(n.thread.commentThreadHandle);return f?{thread:f,text:n.text}:n}else if(n&&n.$mid===9){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const f=a.getCommentThread(n.thread.commentThreadHandle);if(!f)return n;let m=n.commentUniqueId,b=f.getCommentByUniqueId(m);return b||n}else if(n&&n.$mid===10){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const f=a.getCommentThread(n.thread.commentThreadHandle);if(!f)return n;let m=n.text,b=n.commentUniqueId,_=f.getCommentByUniqueId(b);return _?(_.body=m,_):n}return n}})}createCommentController(n,a,f){const m=w.handlePool++,b=new d(n,m,a,f);this._commentControllers.set(b.handle,b);const _=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(n.identifier))||[];return _.push(b),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(n.identifier),_),b.value}$createCommentThreadTemplate(n,a,f){const m=this._commentControllers.get(n);!m||m.$createCommentThreadTemplate(a,f)}async $updateCommentThreadTemplate(n,a,f){const m=this._commentControllers.get(n);!m||m.$updateCommentThreadTemplate(a,f)}$deleteCommentThread(n,a){const f=this._commentControllers.get(n);f&&f.$deleteCommentThread(a)}$provideCommentingRanges(n,a,f){const m=this._commentControllers.get(n);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const b=c.getDocument(T.URI.revive(a));return(0,g.asPromise)(()=>m.commentingRangeProvider.provideCommentingRanges(b,f)).then(_=>_?_.map(o=>C.Range.from(o)):void 0)}$toggleReaction(n,a,f,m,b){const _=this._commentControllers.get(n);return!_||!_.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const o=_.getCommentThread(a);if(o){const A=o.getCommentByUniqueId(m.uniqueIdInThread);if(_!==void 0&&A&&_.reactionHandler)return _.reactionHandler(A,t(b))}return Promise.resolve(void 0)})}dispose(){}}w.handlePool=0;class E{constructor(n,a,f,m,b,_,o){this._commentControllerHandle=a,this._id=f,this._uri=m,this._range=b,this._comments=_,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${n}.${this.handle}`),S.$createCommentThread(a,this.handle,this._id,this._uri,C.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=_,this._localDisposables.push({dispose:()=>{S.$deleteCommentThread(a,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(F){A.range=F},get comments(){return A.comments},set comments(F){A.comments=F},get collapsibleState(){return A.collapsibleState},set collapsibleState(F){A.collapsibleState=F},get canReply(){return A.canReply},set canReply(F){A.canReply=F},get contextValue(){return A.contextValue},set contextValue(F){A.contextValue=F},get label(){return A.label},set label(F){A.label=F},dispose:()=>{A.dispose()}}}set threadId(n){this._id=n}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(n){n.isEqual(this._range)||(this._range=n,this.modifications.range=n,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(n){this._canReply!==n&&(this._canReply=n,this.modifications.canReply=n,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(n){this._label=n,this.modifications.label=n,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(n){this._contextValue=n,this.modifications.contextValue=n,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(n){this._comments=n,this.modifications.comments=n,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(n){this._collapseState=n,this.modifications.collapsibleState=n,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const n=f=>Object.prototype.hasOwnProperty.call(this.modifications,f),a={};n("range")&&(a.range=C.Range.from(this._range)),n("label")&&(a.label=this.label),n("contextValue")&&(a.contextValue=this.contextValue),n("comments")&&(a.comments=this._comments.map(f=>h(this,f,this._commentsMap))),n("collapsibleState")&&(a.collapseState=s(this._collapseState)),n("canReply")&&(a.canReply=this.canReply),this.modifications={},S.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,a)}getCommentByUniqueId(n){for(let a of this._commentsMap){let f=a[0],m=a[1];if(n===m)return f}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(n=>n.dispose())}}E._handlePool=0,je([(0,R.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class d{constructor(n,a,f,m){this._extension=n,this._handle=a,this._id=f,this._label=m,this._threads=new Map,S.$registerCommentController(this.handle,f,m);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(_){b.options=_},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(_){b.commentingRangeProvider=_},get reactionHandler(){return b.reactionHandler},set reactionHandler(_){b.reactionHandler=_},createCommentThread(_,o,A){return b.createCommentThread(_,o,A).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{S.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(n){this._reactionHandler=n,S.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!n})}get options(){return this._options}set options(n){this._options=n,S.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(n,a,f,m){if(typeof n=="string"){const b=new E(this.id,this.handle,n,a,f,m,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new E(this.id,this.handle,void 0,n,a,f,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(n,a){const f=new E(this.id,this.handle,void 0,T.URI.revive(n),C.Range.to(a),[],this._extension.identifier);return f.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(f.handle,f),f}$updateCommentThreadTemplate(n,a){let f=this._threads.get(n);f&&(f.range=C.Range.to(a))}$deleteCommentThread(n){let a=this._threads.get(n);a&&a.dispose(),this._threads.delete(n)}getCommentThread(n){return this._threads.get(n)}dispose(){this._threads.forEach(n=>{n.dispose()}),this._localDisposables.forEach(n=>n.dispose())}}function h(r,n,a){let f=a.get(n);f||(f=++r.commentHandle,a.set(n,f));const m=n.author&&n.author.iconPath?n.author.iconPath.toString():void 0;return{mode:n.mode,contextValue:n.contextValue,uniqueIdInThread:f,body:C.MarkdownString.from(n.body),userName:n.author.name,userIconPath:m,label:n.label,commentReactions:n.reactions?n.reactions.map(b=>v(b)):void 0}}function v(r){return{label:r.label,iconPath:r.iconPath?C.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function t(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?T.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function s(r){if(r!==void 0)switch(r){case i.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}return new w}e.createExtHostComments=u}),define(he[127],fe([0,1,2,5,7,4,13,12,18,8,9]),function(X,e,g,R,k,y,T,I,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class En{constructor(p,l){this._logService=l,this._provider=new Map,this._proxy=p.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,l){const c=En._handlePool++;this._provider.set(c,{provider:p,extensionId:l}),this._proxy.$registerDecorationProvider(c,l.value);const S=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(c,null);return}let E=(0,D.asArray)(w);if(E.length<=En._maxEventSize){this._proxy.$onDidChange(c,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,E.length);const d=E.map(t=>({uri:t,rank:(0,C.count)(t.path,"/")})),h=(0,D.groupBy)(d,(t,s)=>t.rank-s.rank||(0,C.compare)(t.uri.path,s.uri.path));let v=[];e:for(let t of h){let s;for(let r of t){let n=(0,i.dirname)(r.uri.path);if(s!==n&&(s=n,v.push(r.uri)>=En._maxEventSize))break e}}this._proxy.$onDidChange(c,v)});return new k.Disposable(()=>{S?.dispose(),this._proxy.$unregisterDecorationProvider(c),this._provider.delete(c)})}async $provideDecorations(p,l,c){if(!this._provider.has(p))return Object.create(null);const S=Object.create(null),{provider:w,extensionId:E}=this._provider.get(p);return await Promise.all(l.map(async d=>{try{const{uri:h,id:v}=d,t=await Promise.resolve(w.provideFileDecoration(g.URI.revive(h),c));if(!t)return;try{k.FileDecoration.validate(t),S[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${E.value}': ${s}`)}}catch(h){this._logService.error(h)}})),S}};P._handlePool=0,P._maxEventSize=250,P=je([He(0,T.IExtHostRpcService),He(1,I.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,y.createDecorator)("IExtHostDecorations")}),define(he[228],fe([0,1,159,113,2,5,7,16,3,12,23]),function(X,e,g,R,k,y,T,I,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(l,c,S,w,E){this._name=l,this._owner=c,this._maxDiagnosticsPerFile=S,this._proxy=w,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(l,c){if(!l){this.clear();return}this._checkDisposed();let S=[];if(k.URI.isUri(l)){if(!c){this.delete(l);return}this._data.set(l,c.slice()),S=[l]}else if(Array.isArray(l)){S=[];let E;l=[...l].sort(P._compareIndexedTuplesByUri);for(const d of l){const[h,v]=d;if((!E||h.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=h,S.push(h),this._data.set(h,[])),v){const t=this._data.get(h);t&&t.push(...v)}else{const t=this._data.get(h);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(S),!this._proxy)return;const w=[];for(let E of S){let d=[];const h=this._data.get(E);if(h)if(h.length>this._maxDiagnosticsPerFile){d=[];const v=[T.DiagnosticSeverity.Error,T.DiagnosticSeverity.Warning,T.DiagnosticSeverity.Information,T.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let s of h)if(s.severity===v[t]&&d.push(I.Diagnostic.from(s))===this._maxDiagnosticsPerFile)break e;d.push({severity:R.MarkerSeverity.Info,message:(0,g.localize)(0,null,h.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=h.map(v=>I.Diagnostic.from(v));w.push([E,d])}this._proxy.$changeMany(this._owner,w)}delete(l){this._checkDisposed(),this._onDidChangeDiagnostics.fire([l]),this._data.delete(l),this._proxy&&this._proxy.$changeMany(this._owner,[[l,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(l,c){this._checkDisposed();for(let S of this._data.keys())l.apply(c,[S,this.get(S),this])}get(l){this._checkDisposed();const c=this._data.get(l);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(l){return this._checkDisposed(),Array.isArray(this._data.get(l))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(l,c){return l[0].toString()<c[0].toString()?-1:l[0].toString()>c[0].toString()?1:0}}e.DiagnosticCollection=P;let u=class Qt{constructor(l,c){this._logService=c,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:S=>S.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,Qt._mapper),this._proxy=l.getProxy(y.MainContext.MainThreadDiagnostics)}static _mapper(l){const c=new i.ResourceMap;for(const S of l)c.set(S,S);return{uris:Object.freeze(Array.from(c.values()))}}createDiagnosticCollection(l,c){const{_collections:S,_proxy:w,_onDidChangeDiagnostics:E,_logService:d}=this,h=new class{$changeMany(s,r){w.$changeMany(s,r),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,s,r.length===0?"CLEARING":r)}$clear(s){w.$clear(s),d.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,s)}dispose(){w.dispose()}};let v;if(!c)c="_generated_diagnostic_collection_name_#"+Qt._idPool++,v=c;else if(!S.has(c))v=c;else{this._logService.warn(`DiagnosticCollection with name '${c}' does already exist.`);do v=c+Qt._idPool++;while(S.has(v))}return new class extends P{constructor(){super(c,v,Qt._maxDiagnosticsPerFile,h,E);S.set(v,this)}dispose(){super.dispose(),S.delete(v)}}}getDiagnostics(l){if(l)return this._getDiagnostics(l);{const c=new Map,S=[];for(const w of this._collections.values())w.forEach((E,d)=>{let h=c.get(E.toString());typeof h=="undefined"&&(h=S.length,c.set(E.toString(),h),S.push([E,[]])),S[h][1]=S[h][1].concat(...d)});return S}}_getDiagnostics(l){let c=[];for(let S of this._collections.values())S.has(l)&&(c=c.concat(S.get(l)));return c}$acceptMarkersChange(l){if(!this._mirrorCollection){const c="_generated_mirror",S=new P(c,c,Qt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(c,S),this._mirrorCollection=S}for(const[c,S]of l)this._mirrorCollection.set(k.URI.revive(c),S.map(I.Diagnostic.to))}};u._idPool=0,u._maxDiagnosticsPerFile=1e3,u=je([He(1,C.ILogService)],u),e.ExtHostDiagnostics=u}),define(he[229],fe([0,1,2,5]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(T){this._proxy=T.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(T){return this._proxy.$showOpenDialog(T).then(I=>I?I.map(D=>g.URI.revive(D)):void 0)}showSaveDialog(T){return this._proxy.$showSaveDialog(T).then(I=>I?g.URI.revive(I):void 0)}}e.ExtHostDialogs=k}),define(he[230],fe([0,1,15,2,7,5,10,21,8]),function(X,e,g,R,k,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(P,u,p){this._documentsAndEditors=u,this._logService=p,this._documentContentProviders=new Map,this._proxy=P.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,u){if(Object.keys(T.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const p=C._handlePool++;this._documentContentProviders.set(p,u),this._proxy.$registerTextContentProvider(p,P);let l;return typeof u.onDidChange=="function"&&(l=u.onDidChange(c=>{if(c.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(c)&&this.$provideTextDocumentContent(p,c).then(S=>{if(!S&&typeof S!="string")return;const w=this._documentsAndEditors.getDocument(c);if(!w)return;const E=(0,D.splitLines)(S);if(!w.equalLines(E))return this._proxy.$onVirtualDocumentChange(c,S)},g.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(P,u){const p=this._documentContentProviders.get(P);return p?Promise.resolve(p.provideTextDocumentContent(R.URI.revive(u),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(he[231],fe([0,1,3,6,2,5,119,16,14,25,7]),function(X,e,g,R,k,y,T,I,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(p,l){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=p.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=l,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const S of c)this._onDidRemoveDocument.fire(S.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const S of c)this._onDidAddDocument.fire(S.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(p){if(!p)return;const l=this._documentsAndEditors.getDocument(p);if(l)return l}getDocument(p){const l=this.getDocumentData(p);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return l.document}ensureDocumentData(p){const l=this._documentsAndEditors.getDocument(p);if(l)return Promise.resolve(l);let c=this._documentLoader.get(p.toString());return c||(c=this._proxy.$tryOpenDocument(p).then(S=>{this._documentLoader.delete(p.toString());const w=k.URI.revive(S);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(w))},S=>(this._documentLoader.delete(p.toString()),Promise.reject(S))),this._documentLoader.set(p.toString(),c)),c}createDocumentData(p){return this._proxy.$tryCreateDocument(p).then(l=>k.URI.revive(l))}$acceptModelModeChanged(p,l){const c=k.URI.revive(p),S=this._documentsAndEditors.getDocument(c);if(!S)throw new Error("unknown document");this._onDidRemoveDocument.fire(S.document),S._acceptLanguageId(l),this._onDidAddDocument.fire(S.document)}$acceptModelSaved(p){const l=k.URI.revive(p),c=this._documentsAndEditors.getDocument(l);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(p,l){const c=k.URI.revive(p),S=this._documentsAndEditors.getDocument(c);if(!S)throw new Error("unknown document");S._acceptIsDirty(l),this._onDidChangeDocument.fire({document:S.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,l,c){const S=k.URI.revive(p),w=this._documentsAndEditors.getDocument(S);if(!w)throw new Error("unknown document");w._acceptIsDirty(c),w.onEvents(l);let E;l.isUndoing?E=i.TextDocumentChangeReason.Undo:l.isRedoing&&(E=i.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:w.document,contentChanges:l.changes.map(d=>({range:I.Range.to(d.range),rangeOffset:d.rangeOffset,rangeLength:d.rangeLength,text:d.text})),reason:E}))}setWordDefinitionFor(p,l){(0,T.setWordDefinitionFor)(p,l)}}e.ExtHostDocuments=P}),define(he[43],fe([0,1,52,3,6,2,4,5,119,13,125,16,12,23,10,54,135]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(h,v){this._extHostRpc=h,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const v=[],t=[],s=[];if(h.removedDocuments)for(const r of h.removedDocuments){const n=y.URI.revive(r),a=this._documents.get(n);a?.unref()&&(this._documents.delete(n),v.push(a.value))}if(h.addedDocuments)for(const r of h.addedDocuments){const n=y.URI.revive(r.uri);let a=this._documents.get(n);if(a&&n.scheme!==l.Schemas.vscodeNotebookCell&&n.scheme!==l.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);a||(a=new w(new D.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),n,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(n,a),t.push(a.value)),a.ref()}if(h.removedEditors)for(const r of h.removedEditors){const n=this._editors.get(r);this._editors.delete(r),n&&s.push(n)}if(h.addedEditors)for(const r of h.addedEditors){const n=y.URI.revive(r.documentUri);g.ok(this._documents.has(n),`document '${n}' does not exist`),g.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const a=this._documents.get(n).value,f=new i.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>a.document),r.selections.map(P.Selection.to),r.options,r.visibleRanges.map(m=>P.Range.to(m)),typeof r.editorPosition=="number"?P.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,f)}h.newActiveEditor!==void 0&&(g.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,k.dispose)(v),(0,k.dispose)(s),h.removedDocuments&&this._onDidRemoveDocuments.fire(v),h.addedDocuments&&this._onDidAddDocuments.fire(t),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){return this._documents.get(h)?.value}allDocuments(){return c.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return h?v:v?.value}allEditors(){return[...this._editors.values()]}};E=je([He(0,C.IExtHostRpcService),He(1,u.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,T.createDecorator)("IExtHostDocumentsAndEditors")}),define(he[232],fe([0,1,2,5,6,7,16,143,8,22]),function(X,e,g,R,k,y,T,I,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const l=this._schemes.indexOf(p);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),l=[];let c,S,w=14,E=14;for(const d of p){let h=c?(0,D.commonPrefixLength)(c,d):0;for(h===0?S=1:S=E;h<d.length;h++)h+1===d.length?(w=E,E=9):E+=1,l.push([S,d.toUpperCase().charCodeAt(h),E]),l.push([S,d.toLowerCase().charCodeAt(h),E]),S=E;c=d,E=w}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new I.StateMachine(l)}}provideDocumentLinks(p){this._initStateMachine();const l=[],c=I.LinkComputer.computeLinks({getLineContent(S){return p.lineAt(S-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const S of c){const w=T.DocumentLink.to(S);w.target&&l.push(w)}return l}}class P{constructor(p,l){this._extHostLanguageFeatures=l,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=p.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(p,l,c,S={},w){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const E=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(E,c),this._enableProposedApi.set(E,w??!1);let d=2;S.isCaseSensitive&&(d+=1024),S.isReadonly&&(d+=2048),typeof c.copy=="function"&&(d+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&(d+=4),this._proxy.$registerFileSystemProvider(E,l,d).catch(v=>{console.error(`FAILED to register filesystem provider of ${p.value}-extension for the scheme ${l}`),console.error(v)});const h=c.onDidChangeFile(v=>{const t=[];for(const s of v){let{uri:r,type:n}=s;if(r.scheme!==l)continue;let a;switch(n){case y.FileChangeType.Changed:a=0;break;case y.FileChangeType.Created:a=1;break;case y.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:a})}this._proxy.$onFileSystemChange(E,t)});return(0,k.toDisposable)(()=>{h.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(E),this._enableProposedApi.delete(E),this._proxy.$unregisterProvider(E)})}static _asIStat(p,l){const{type:c,ctime:S,mtime:w,size:E,permissions:d}=p;return l?{type:c,ctime:S,mtime:w,size:E,permissions:d}:{type:c,ctime:S,mtime:w,size:E}}$stat(p,l){return Promise.resolve(this._getFsProvider(p).stat(g.URI.revive(l))).then(c=>P._asIStat(c,this._enableProposedApi.get(p)??!1))}$readdir(p,l){return Promise.resolve(this._getFsProvider(p).readDirectory(g.URI.revive(l)))}$readFile(p,l){return Promise.resolve(this._getFsProvider(p).readFile(g.URI.revive(l))).then(c=>C.VSBuffer.wrap(c))}$writeFile(p,l,c,S){return Promise.resolve(this._getFsProvider(p).writeFile(g.URI.revive(l),c.buffer,S))}$delete(p,l,c){return Promise.resolve(this._getFsProvider(p).delete(g.URI.revive(l),c))}$rename(p,l,c,S){return Promise.resolve(this._getFsProvider(p).rename(g.URI.revive(l),g.URI.revive(c),S))}$copy(p,l,c,S){const w=this._getFsProvider(p);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(g.URI.revive(l),g.URI.revive(c),S))}$mkdir(p,l){return Promise.resolve(this._getFsProvider(p).createDirectory(g.URI.revive(l)))}$watch(p,l,c,S){const w=this._getFsProvider(p).watch(g.URI.revive(c),S);this._watches.set(l,w)}$unwatch(p,l){const c=this._watches.get(l);c&&(c.dispose(),this._watches.delete(l))}$open(p,l,c){const S=this._getFsProvider(p);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(g.URI.revive(l),c))}$close(p,l){const c=this._getFsProvider(p);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(l))}$read(p,l,c,S){const w=this._getFsProvider(p);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const E=C.VSBuffer.alloc(S);return Promise.resolve(w.read(l,c,E.buffer,0,S)).then(d=>E.slice(0,d))}$write(p,l,c,S){const w=this._getFsProvider(p);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(l,c,S.buffer,0,S.byteLength))}_getFsProvider(p){const l=this._fsProvider.get(p);if(!l){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return l}}e.ExtHostFileSystem=P}),define(he[88],fe([0,1,5,41,7,22,4,13,59]),function(X,e,g,R,k,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class xt{constructor(P,u){const p=P.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(l){return p.$stat(l).catch(xt._handleError)},readDirectory(l){return p.$readdir(l).catch(xt._handleError)},createDirectory(l){return p.$mkdir(l).catch(xt._handleError)},async readFile(l){return p.$readFile(l).then(c=>c.buffer).catch(xt._handleError)},writeFile(l,c){return p.$writeFile(l,y.VSBuffer.wrap(c)).catch(xt._handleError)},delete(l,c){return p.$delete(l,{recursive:!1,useTrash:!1,...c}).catch(xt._handleError)},rename(l,c,S){return p.$rename(l,c,{overwrite:!1,...S}).catch(xt._handleError)},copy(l,c,S){return p.$copy(l,c,{overwrite:!1,...S}).catch(xt._handleError)},isWritableFileSystem(l){const c=u.getCapabilities(l);if(typeof c=="number")return!(c&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new k.FileSystemError(String(P));if(P.name==="ENOPRO")throw k.FileSystemError.Unavailable(P.message);switch(P.name){case R.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(P.message);case R.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(P.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(P.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(P.message);case R.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(P.message);case R.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(P.message);default:throw new k.FileSystemError(P.message,P.name)}}};C=je([He(0,I.IExtHostRpcService),He(1,D.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=(0,T.createDecorator)("IExtHostConsumerFileSystem")}),define(he[233],fe([0,1,6,5]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(T){this._handlePool=0,this._proxy=T.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(T){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,T),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=k}),define(he[234],fe([0,1,2,25,16,7,5,8,40,18,14,140,6,108,71,84,44,15,3]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c,S,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(j,Z){this._documents=j,this._provider=Z}async provideDocumentSymbols(j,Z){const ie=this._documents.getDocument(j),oe=await this._provider.provideDocumentSymbols(ie,Z);if(!(0,C.isFalsyOrEmpty)(oe))return oe[0]instanceof y.DocumentSymbol?oe.map(k.DocumentSymbol.from):d._asDocumentSymbolTree(oe)}static _asDocumentSymbolTree(j){j=j.slice(0).sort((oe,ve)=>{let ee=oe.location.range.start.compareTo(ve.location.range.start);return ee===0&&(ee=ve.location.range.end.compareTo(oe.location.range.end)),ee});const Z=[],ie=[];for(const oe of j){const ve={name:oe.name||"!!MISSING: name!!",kind:k.SymbolKind.from(oe.kind),tags:oe.tags?.map(k.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:k.Range.from(oe.location.range),selectionRange:k.Range.from(oe.location.range),children:[]};for(;;){if(ie.length===0){ie.push(ve),Z.push(ve);break}const ee=ie[ie.length-1];if(D.Range.containsRange(ee.range,ve.range)&&!D.Range.equalsRange(ee.range,ve.range)){ee.children&&ee.children.push(ve),ie.push(ve);break}ie.pop()}}return Z}}class h{constructor(j,Z,ie){this._documents=j,this._commands=Z,this._provider=ie,this._cache=new c.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(j,Z){const ie=this._documents.getDocument(j),oe=await this._provider.provideCodeLenses(ie,Z);if(!oe||Z.isCancellationRequested)return;const ve=this._cache.add(oe),ee=new u.DisposableStore;this._disposables.set(ve,ee);const ue={cacheId:ve,lenses:[]};for(let Ie=0;Ie<oe.length;Ie++)ue.lenses.push({cacheId:[ve,Ie],range:k.Range.from(oe[Ie].range),command:this._commands.toInternal(oe[Ie].command,ee)});return ue}async resolveCodeLens(j,Z){const ie=j.cacheId&&this._cache.get(...j.cacheId);if(!ie)return;let oe;if(typeof this._provider.resolveCodeLens!="function"||ie.isResolved?oe=ie:oe=await this._provider.resolveCodeLens(ie,Z),oe||(oe=ie),Z.isCancellationRequested)return;const ve=j.cacheId&&this._disposables.get(j.cacheId[0]);if(!!ve)return j.command=this._commands.toInternal(oe.command??h._badCmd,ve),j}releaseCodeLenses(j){this._disposables.get(j)?.dispose(),this._disposables.delete(j),this._cache.delete(j)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(ze){return Array.isArray(ze)?ze.map(k.DefinitionLink.from):ze?[k.DefinitionLink.from(ze)]:[]}class t{constructor(j,Z){this._documents=j,this._provider=Z}async provideDefinition(j,Z,ie){const oe=this._documents.getDocument(j),ve=k.Position.to(Z),ee=await this._provider.provideDefinition(oe,ve,ie);return v(ee)}}class s{constructor(j,Z){this._documents=j,this._provider=Z}async provideDeclaration(j,Z,ie){const oe=this._documents.getDocument(j),ve=k.Position.to(Z),ee=await this._provider.provideDeclaration(oe,ve,ie);return v(ee)}}class r{constructor(j,Z){this._documents=j,this._provider=Z}async provideImplementation(j,Z,ie){const oe=this._documents.getDocument(j),ve=k.Position.to(Z),ee=await this._provider.provideImplementation(oe,ve,ie);return v(ee)}}class n{constructor(j,Z){this._documents=j,this._provider=Z}async provideTypeDefinition(j,Z,ie){const oe=this._documents.getDocument(j),ve=k.Position.to(Z),ee=await this._provider.provideTypeDefinition(oe,ve,ie);return v(ee)}}class a{constructor(j,Z){this._documents=j,this._provider=Z}async provideHover(j,Z,ie){const oe=this._documents.getDocument(j),ve=k.Position.to(Z),ee=await this._provider.provideHover(oe,ve,ie);if(!(!ee||(0,C.isFalsyOrEmpty)(ee.contents)))return ee.range||(ee.range=oe.getWordRangeAtPosition(ve)),ee.range||(ee.range=new y.Range(ve,ve)),k.Hover.from(ee)}}class f{constructor(j,Z){this._documents=j,this._provider=Z}async provideEvaluatableExpression(j,Z,ie){const oe=this._documents.getDocument(j),ve=k.Position.to(Z),ee=await this._provider.provideEvaluatableExpression(oe,ve,ie);if(ee)return k.EvaluatableExpression.from(ee)}}class m{constructor(j,Z){this._documents=j,this._provider=Z}async provideInlineValues(j,Z,ie,oe){const ve=this._documents.getDocument(j),ee=await this._provider.provideInlineValues(ve,k.Range.to(Z),k.InlineValueContext.to(ie),oe);if(Array.isArray(ee))return ee.map(ue=>k.InlineValue.from(ue))}}class b{constructor(j,Z){this._documents=j,this._provider=Z}async provideDocumentHighlights(j,Z,ie){const oe=this._documents.getDocument(j),ve=k.Position.to(Z),ee=await this._provider.provideDocumentHighlights(oe,ve,ie);if(Array.isArray(ee))return ee.map(k.DocumentHighlight.from)}}class _{constructor(j,Z){this._documents=j,this._provider=Z}async provideLinkedEditingRanges(j,Z,ie){const oe=this._documents.getDocument(j),ve=k.Position.to(Z),ee=await this._provider.provideLinkedEditingRanges(oe,ve,ie);if(ee&&Array.isArray(ee.ranges))return{ranges:(0,C.coalesce)(ee.ranges.map(k.Range.from)),wordPattern:ee.wordPattern}}}class o{constructor(j,Z){this._documents=j,this._provider=Z}async provideReferences(j,Z,ie,oe){const ve=this._documents.getDocument(j),ee=k.Position.to(Z),ue=await this._provider.provideReferences(ve,ee,ie,oe);if(Array.isArray(ue))return ue.map(k.location.from)}}class A{constructor(j,Z,ie,oe,ve,ee,ue){this._documents=j,this._commands=Z,this._diagnostics=ie,this._provider=oe,this._logService=ve,this._extension=ee,this._apiDeprecation=ue,this._cache=new c.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(j,Z,ie,oe){const ve=this._documents.getDocument(j),ee=P.Selection.isISelection(Z)?k.Selection.to(Z):k.Range.to(Z),ue=[];for(const K of this._diagnostics.getDiagnostics(j))if(ee.intersection(K.range)&&ue.push(K)>A._maxCodeActionsPerFile)break;const Ie={diagnostics:ue,only:ie.only?new y.CodeActionKind(ie.only):void 0,triggerKind:k.CodeActionTriggerKind.to(ie.trigger)},$e=await this._provider.provideCodeActions(ve,ee,Ie,oe);if(!(0,C.isNonEmptyArray)($e)||oe.isCancellationRequested)return;const qe=this._cache.add($e),be=new u.DisposableStore;this._disposables.set(qe,be);const tt=[];for(let K=0;K<$e.length;K++){const te=$e[K];!te||(A._isCommand(te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:te.title,command:this._commands.toInternal(te,be)})):(Ie.only&&(te.kind?Ie.only.contains(te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ie.only.value} 'requested but returned code action is of kind '${te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ie.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[qe,K],title:te.title,command:te.command&&this._commands.toInternal(te.command,be),diagnostics:te.diagnostics&&te.diagnostics.map(k.Diagnostic.from),edit:te.edit&&k.WorkspaceEdit.from(te.edit),kind:te.kind&&te.kind.value,isPreferred:te.isPreferred,disabled:te.disabled?.reason})))}return{cacheId:qe,actions:tt}}async resolveCodeAction(j,Z){const[ie,oe]=j,ve=this._cache.get(ie,oe);if(!ve||A._isCommand(ve)||!this._provider.resolveCodeAction)return;const ee=await this._provider.resolveCodeAction(ve,Z)??ve;return ee?.edit?k.WorkspaceEdit.from(ee.edit):void 0}releaseCodeActions(j){this._disposables.get(j)?.dispose(),this._disposables.delete(j),this._cache.delete(j)}static _isCommand(j){return typeof j.command=="string"&&typeof j.title=="string"}}A._maxCodeActionsPerFile=1e3;class F{constructor(j,Z){this._documents=j,this._provider=Z}async provideDocumentFormattingEdits(j,Z,ie){const oe=this._documents.getDocument(j),ve=await this._provider.provideDocumentFormattingEdits(oe,Z,ie);if(Array.isArray(ve))return ve.map(k.TextEdit.from)}}class ${constructor(j,Z){this._documents=j,this._provider=Z}async provideDocumentRangeFormattingEdits(j,Z,ie,oe){const ve=this._documents.getDocument(j),ee=k.Range.to(Z),ue=await this._provider.provideDocumentRangeFormattingEdits(ve,ee,ie,oe);if(Array.isArray(ue))return ue.map(k.TextEdit.from)}}class W{constructor(j,Z){this._documents=j,this._provider=Z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,Z,ie,oe,ve){const ee=this._documents.getDocument(j),ue=k.Position.to(Z),Ie=await this._provider.provideOnTypeFormattingEdits(ee,ue,ie,oe,ve);if(Array.isArray(Ie))return Ie.map(k.TextEdit.from)}}class Q{constructor(j,Z){this._provider=j,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(j,Z){const ie=T.IdObject.mixin({symbols:[]}),oe=await this._provider.provideWorkspaceSymbols(j,Z);if((0,C.isNonEmptyArray)(oe))for(const ve of oe){if(!ve)continue;if(!ve.name){this._logService.warn("INVALID SymbolInformation, lacks name",ve);continue}const ee=T.IdObject.mixin(k.WorkspaceSymbol.from(ve));this._symbolCache.set(ee._id,ve),ie.symbols.push(ee)}return ie.symbols.length>0&&this._resultCache.set(ie._id,[ie.symbols[0]._id,ie.symbols[ie.symbols.length-1]._id]),ie}async resolveWorkspaceSymbol(j,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return j;const ie=this._symbolCache.get(j._id);if(ie){const oe=await this._provider.resolveWorkspaceSymbol(ie,Z);return oe&&(0,R.mixin)(j,k.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(j){const Z=this._resultCache.get(j);if(Z){for(let[ie,oe]=Z;ie<=oe;ie++)this._symbolCache.delete(ie);this._resultCache.delete(j)}}}class H{constructor(j,Z,ie){this._documents=j,this._provider=Z,this._logService=ie}static supportsResolving(j){return typeof j.prepareRename=="function"}async provideRenameEdits(j,Z,ie,oe){const ve=this._documents.getDocument(j),ee=k.Position.to(Z);try{const ue=await this._provider.provideRenameEdits(ve,ee,ie,oe);return ue?k.WorkspaceEdit.from(ue):void 0}catch(ue){const Ie=H._asMessage(ue);return Ie?{rejectReason:Ie,edits:void 0}:Promise.reject(ue)}}async resolveRenameLocation(j,Z,ie){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(j),ve=k.Position.to(Z);try{const ee=await this._provider.prepareRename(oe,ve,ie);let ue,Ie;if(y.Range.isRange(ee)?(ue=ee,Ie=oe.getText(ee)):(0,i.isObject)(ee)&&(ue=ee.range,Ie=ee.placeholder),!ue||!Ie)return;if(ue.start.line>ve.line||ue.end.line<ve.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(ue),text:Ie}}catch(ee){const ue=H._asMessage(ee);return ue?{rejectReason:ue,range:void 0,text:void 0}:Promise.reject(ee)}}static _asMessage(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class N{constructor(j,Z){this.resultId=j,this.tokens=Z}}class x{constructor(j,Z){this._documents=j,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(j,Z,ie){const oe=this._documents.getDocument(j),ve=Z!==0?this._previousResults.get(Z):null;let ee=typeof ve?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(oe,ve.resultId,ie):await this._provider.provideDocumentSemanticTokens(oe,ie);return ve&&this._previousResults.delete(Z),ee?(ee=x._fixProvidedSemanticTokens(ee),this._send(x._convertToEdits(ve,ee),ee)):null}async releaseDocumentSemanticColoring(j){this._previousResults.delete(j)}static _fixProvidedSemanticTokens(j){return x._isSemanticTokens(j)?x._isCorrectSemanticTokens(j)?j:new y.SemanticTokens(new Uint32Array(j.data),j.resultId):x._isSemanticTokensEdits(j)?x._isCorrectSemanticTokensEdits(j)?j:new y.SemanticTokensEdits(j.edits.map(Z=>new y.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),j.resultId):j}static _isSemanticTokens(j){return j&&!!j.data}static _isCorrectSemanticTokens(j){return j.data instanceof Uint32Array}static _isSemanticTokensEdits(j){return j&&Array.isArray(j.edits)}static _isCorrectSemanticTokensEdits(j){for(const Z of j.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(j,Z){if(!x._isSemanticTokens(Z)||!j||!j.tokens)return Z;const ie=j.tokens,oe=ie.length,ve=Z.data,ee=ve.length;let ue=0;const Ie=Math.min(oe,ee);for(;ue<Ie&&ie[ue]===ve[ue];)ue++;if(ue===oe&&ue===ee)return new y.SemanticTokensEdits([],Z.resultId);let $e=0;const qe=Ie-ue;for(;$e<qe&&ie[oe-$e-1]===ve[ee-$e-1];)$e++;return new y.SemanticTokensEdits([{start:ue,deleteCount:oe-ue-$e,data:ve.subarray(ue,ee-$e)}],Z.resultId)}_send(j,Z){if(x._isSemanticTokens(j)){const ie=this._nextResultId++;return this._previousResults.set(ie,new N(j.resultId,j.data)),(0,p.encodeSemanticTokensDto)({id:ie,type:"full",data:j.data})}if(x._isSemanticTokensEdits(j)){const ie=this._nextResultId++;return x._isSemanticTokens(Z)?this._previousResults.set(ie,new N(Z.resultId,Z.data)):this._previousResults.set(ie,new N(j.resultId)),(0,p.encodeSemanticTokensDto)({id:ie,type:"delta",deltas:(j.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=x;class L{constructor(j,Z){this._documents=j,this._provider=Z}async provideDocumentRangeSemanticTokens(j,Z,ie){const oe=this._documents.getDocument(j),ve=await this._provider.provideDocumentRangeSemanticTokens(oe,k.Range.to(Z),ie);return ve?this._send(ve):null}_send(j){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:j.data})}}e.DocumentRangeSemanticTokensAdapter=L;class G{constructor(j,Z,ie,oe,ve){this._documents=j,this._commands=Z,this._provider=ie,this._apiDeprecation=oe,this._extension=ve,this._cache=new c.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}async provideCompletionItems(j,Z,ie,oe){const ve=this._documents.getDocument(j),ee=k.Position.to(Z),ue=ve.getWordRangeAtPosition(ee)||new y.Range(ee,ee),Ie=ue.with({end:ee}),$e=new S.StopWatch(!0),qe=await this._provider.provideCompletionItems(ve,ee,oe,k.CompletionContext.to(ie));if(!qe||oe.isCancellationRequested)return;const be=Array.isArray(qe)?new y.CompletionList(qe):qe,tt=G.supportsResolving(this._provider)?this._cache.add(be.items):this._cache.add([]),K=new u.DisposableStore;this._disposables.set(tt,K);const te=[],pe={x:tt,b:te,a:{replace:k.Range.from(ue),insert:k.Range.from(Ie)},c:be.isIncomplete||void 0,d:$e.elapsed()};for(let Ue=0;Ue<be.items.length;Ue++){const We=be.items[Ue],Ze=this._convertCompletionItem(We,[tt,Ue],Ie,ue);te.push(Ze)}return pe}async resolveCompletionItem(j,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const ie=this._cache.get(...j);if(!ie)return;const oe=await this._provider.resolveCompletionItem(ie,Z);if(!!oe)return this._convertCompletionItem(oe,j)}releaseCompletionItems(j){this._disposables.get(j)?.dispose(),this._disposables.delete(j),this._cache.delete(j)}_convertCompletionItem(j,Z,ie,oe){const ve=this._disposables.get(Z[0]);if(!ve)throw Error("DisposableStore is missing...");const ee={x:Z,a:j.label,b:j.kind!==void 0?k.CompletionItemKind.from(j.kind):void 0,n:j.tags&&j.tags.map(k.CompletionItemTag.from),c:j.detail,d:typeof j.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters,l:j.additionalTextEdits&&j.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(j.command,ve)};j.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ee.h=j.textEdit.newText):typeof j.insertText=="string"?ee.h=j.insertText:j.insertText instanceof y.SnippetString&&(ee.h=j.insertText.value,ee.i|=4);let ue;return j.textEdit?ue=j.textEdit.range:j.range&&(ue=j.range),y.Range.isRange(ue)?ee.j=k.Range.from(ue):ue&&(!ie?.isEqual(ue.inserting)||!oe?.isEqual(ue.replacing))&&(ee.j={insert:k.Range.from(ue.inserting),replace:k.Range.from(ue.replacing)}),ee}}class M{constructor(j,Z,ie){this._documents=j,this._provider=Z,this._commands=ie,this._cache=new c.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(j,Z,ie,oe){const ve=this._documents.getDocument(j),ee=k.Position.to(Z),ue=await this._provider.provideInlineCompletionItems(ve,ee,ie,oe);if(!ue||oe.isCancellationRequested)return;const Ie=(0,i.isArray)(ue)?{items:ue}:ue,$e=this._cache.add(Ie.items);let qe;return{pid:$e,items:Ie.items.map((be,tt)=>{let K;return be.command&&(qe||(qe=new u.DisposableStore,this._disposables.set($e,qe)),K=this._commands.toInternal(be.command,qe)),{text:be.text,range:be.range?k.Range.from(be.range):void 0,command:K,idx:tt}})}}disposeCompletions(j){this._cache.delete(j);const Z=this._disposables.get(j);Z&&Z.clear(),this._disposables.delete(j)}handleDidShowCompletionItem(j,Z){const ie=this._cache.get(j,Z);ie&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:ie})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new E.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(j){let Z=O.map.get(j);return Z||(Z=new O,O.map.set(j,Z)),Z}fireOnDidShowCompletionItem(j){this._onDidShowCompletionItemEmitter.fire(j)}}e.InlineCompletionController=O,O.map=new WeakMap;class B{constructor(j,Z){this._documents=j,this._provider=Z,this._cache=new c.Cache("SignatureHelp")}async provideSignatureHelp(j,Z,ie,oe){const ve=this._documents.getDocument(j),ee=k.Position.to(Z),ue=this.reviveContext(ie),Ie=await this._provider.provideSignatureHelp(ve,ee,oe,ue);if(Ie){const $e=this._cache.add([Ie]);return{...k.SignatureHelp.from(Ie),id:$e}}}reviveContext(j){let Z;if(j.activeSignatureHelp){const ie=k.SignatureHelp.to(j.activeSignatureHelp),oe=this._cache.get(j.activeSignatureHelp.id,0);oe?(Z=oe,Z.activeSignature=ie.activeSignature,Z.activeParameter=ie.activeParameter):Z=ie}return{...j,activeSignatureHelp:Z}}releaseSignatureHelp(j){this._cache.delete(j)}}class z{constructor(j,Z){this._documents=j,this._provider=Z}async provideInlayHints(j,Z,ie){const oe=this._documents.getDocument(j),ve=await this._provider.provideInlayHints(oe,k.Range.to(Z),ie);return ve?{hints:ve.map(k.InlayHint.from)}:void 0}}class J{constructor(j,Z){this._documents=j,this._provider=Z,this._cache=new c.Cache("DocumentLink")}async provideLinks(j,Z){const ie=this._documents.getDocument(j),oe=await this._provider.provideDocumentLinks(ie,Z);if(!(!Array.isArray(oe)||oe.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.filter(J._validateLink).map(k.DocumentLink.from)};{const ve=this._cache.add(oe),ee={links:[],id:ve};for(let ue=0;ue<oe.length;ue++){if(!J._validateLink(oe[ue]))continue;const Ie=k.DocumentLink.from(oe[ue]);Ie.cacheId=[ve,ue],ee.links.push(Ie)}return ee}}}static _validateLink(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const ie=this._cache.get(...j);if(!ie)return;const oe=await this._provider.resolveDocumentLink(ie,Z);if(!(!oe||!J._validateLink(oe)))return k.DocumentLink.from(oe)}releaseLinks(j){this._cache.delete(j)}}class ce{constructor(j,Z){this._documents=j,this._provider=Z}async provideColors(j,Z){const ie=this._documents.getDocument(j),oe=await this._provider.provideDocumentColors(ie,Z);return Array.isArray(oe)?oe.map(ee=>({color:k.Color.from(ee.color),range:k.Range.from(ee.range)})):[]}async provideColorPresentations(j,Z,ie){const oe=this._documents.getDocument(j),ve=k.Range.to(Z.range),ee=k.Color.to(Z.color),ue=await this._provider.provideColorPresentations(ee,{document:oe,range:ve},ie);if(!!Array.isArray(ue))return ue.map(k.ColorPresentation.from)}}class ye{constructor(j,Z){this._documents=j,this._provider=Z}async provideFoldingRanges(j,Z,ie){const oe=this._documents.getDocument(j),ve=await this._provider.provideFoldingRanges(oe,Z,ie);if(!!Array.isArray(ve))return ve.map(k.FoldingRange.from)}}class Fe{constructor(j,Z,ie){this._documents=j,this._provider=Z,this._logService=ie}async provideSelectionRanges(j,Z,ie){const oe=this._documents.getDocument(j),ve=Z.map(k.Position.to),ee=await this._provider.provideSelectionRanges(oe,ve,ie);if(!(0,C.isNonEmptyArray)(ee))return[];if(ee.length!==ve.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ue=[];for(let Ie=0;Ie<ve.length;Ie++){const $e=[];ue.push($e);let qe=ve[Ie],be=ee[Ie];for(;;){if(!be.range.contains(qe))throw new Error("INVALID selection range, must contain the previous range");if($e.push(k.SelectionRange.from(be)),!be.parent)break;qe=be.range,be=be.parent}}return ue}}class Re{constructor(j,Z){this._documents=j,this._provider=Z,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(j,Z,ie){const oe=this._documents.getDocument(j),ve=k.Position.to(Z),ee=await this._provider.prepareCallHierarchy(oe,ve,ie);if(!ee)return;const ue=this._idPool.nextId();return this._cache.set(ue,new Map),Array.isArray(ee)?ee.map(Ie=>this._cacheAndConvertItem(ue,Ie)):[this._cacheAndConvertItem(ue,ee)]}async provideCallsTo(j,Z,ie){const oe=this._itemFromCache(j,Z);if(!oe)throw new Error("missing call hierarchy item");const ve=await this._provider.provideCallHierarchyIncomingCalls(oe,ie);if(!!ve)return ve.map(ee=>({from:this._cacheAndConvertItem(j,ee.from),fromRanges:ee.fromRanges.map(ue=>k.Range.from(ue))}))}async provideCallsFrom(j,Z,ie){const oe=this._itemFromCache(j,Z);if(!oe)throw new Error("missing call hierarchy item");const ve=await this._provider.provideCallHierarchyOutgoingCalls(oe,ie);if(!!ve)return ve.map(ee=>({to:this._cacheAndConvertItem(j,ee.to),fromRanges:ee.fromRanges.map(ue=>k.Range.from(ue))}))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,Z){const ie=this._cache.get(j),oe={_sessionId:j,_itemId:ie.size.toString(36),name:Z.name,detail:Z.detail,kind:k.SymbolKind.from(Z.kind),uri:Z.uri,range:k.Range.from(Z.range),selectionRange:k.Range.from(Z.selectionRange),tags:Z.tags?.map(k.SymbolTag.from)};return ie.set(oe._itemId,Z),oe}_itemFromCache(j,Z){return this._cache.get(j)?.get(Z)}}class Ne{constructor(j,Z){this.adapter=j,this.extension=Z}}class Ve{constructor(j,Z,ie,oe,ve,ee,ue){this._adapter=new Map,this._uriTransformer=Z,this._proxy=j.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=ie,this._commands=oe,this._diagnostics=ve,this._logService=ee,this._apiDeprecation=ue}_transformDocumentSelector(j){return(0,C.coalesce)((0,C.asArray)(j).map(Z=>this._doTransformDocumentSelector(Z)))}_doTransformDocumentSelector(j){if(typeof j=="string")return{$serialized:!0,language:j};if(j)return{$serialized:!0,language:j.language,scheme:this._transformScheme(j.scheme),pattern:typeof j.pattern=="undefined"?void 0:k.GlobPattern.from(j.pattern),exclusive:j.exclusive}}_transformScheme(j){return this._uriTransformer&&typeof j=="string"?this._uriTransformer.transformOutgoingScheme(j):j}_createDisposable(j){return new y.Disposable(()=>{this._adapter.delete(j),this._proxy.$unregister(j)})}_nextHandle(){return Ve._handlePool++}_withAdapter(j,Z,ie,oe,ve=!1){const ee=this._adapter.get(j);if(!ee)return Promise.resolve(oe);if(ee.adapter instanceof Z){let ue;ee.extension&&(ue=Date.now(),this._logService.trace(`[${ee.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Ie=ie(ee.adapter,ee.extension),$e=ee.extension;return $e&&Promise.resolve(Ie).then(()=>this._logService.trace(`[${$e.identifier.value}] provider DONE after ${Date.now()-ue}ms`),qe=>{ve&&qe instanceof w.CancellationError||(this._logService.error(`[${$e.identifier.value}] provider FAILED`),this._logService.error(qe))}),Ie}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(j,Z){const ie=this._nextHandle();return this._adapter.set(ie,new Ne(j,Z)),ie}static _extLabel(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,Z,ie,oe){const ve=this._addNewAdapter(new d(this._documents,ie),j),ee=oe&&oe.label||Ve._extLabel(j);return this._proxy.$registerDocumentSymbolProvider(ve,this._transformDocumentSelector(Z),ee),this._createDisposable(ve)}$provideDocumentSymbols(j,Z,ie){return this._withAdapter(j,d,oe=>oe.provideDocumentSymbols(g.URI.revive(Z),ie),void 0)}registerCodeLensProvider(j,Z,ie){const oe=this._nextHandle(),ve=typeof ie.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Ne(new h(this._documents,this._commands.converter,ie),j)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(Z),ve);let ee=this._createDisposable(oe);if(ve!==void 0){const ue=ie.onDidChangeCodeLenses(Ie=>this._proxy.$emitCodeLensEvent(ve));ee=y.Disposable.from(ee,ue)}return ee}$provideCodeLenses(j,Z,ie){return this._withAdapter(j,h,oe=>oe.provideCodeLenses(g.URI.revive(Z),ie),void 0)}$resolveCodeLens(j,Z,ie){return this._withAdapter(j,h,oe=>oe.resolveCodeLens(Z,ie),void 0)}$releaseCodeLenses(j,Z){this._withAdapter(j,h,ie=>Promise.resolve(ie.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(j,Z,ie){const oe=this._addNewAdapter(new t(this._documents,ie),j);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideDefinition(j,Z,ie,oe){return this._withAdapter(j,t,ve=>ve.provideDefinition(g.URI.revive(Z),ie,oe),[])}registerDeclarationProvider(j,Z,ie){const oe=this._addNewAdapter(new s(this._documents,ie),j);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideDeclaration(j,Z,ie,oe){return this._withAdapter(j,s,ve=>ve.provideDeclaration(g.URI.revive(Z),ie,oe),[])}registerImplementationProvider(j,Z,ie){const oe=this._addNewAdapter(new r(this._documents,ie),j);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideImplementation(j,Z,ie,oe){return this._withAdapter(j,r,ve=>ve.provideImplementation(g.URI.revive(Z),ie,oe),[])}registerTypeDefinitionProvider(j,Z,ie){const oe=this._addNewAdapter(new n(this._documents,ie),j);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideTypeDefinition(j,Z,ie,oe){return this._withAdapter(j,n,ve=>ve.provideTypeDefinition(g.URI.revive(Z),ie,oe),[])}registerHoverProvider(j,Z,ie,oe){const ve=this._addNewAdapter(new a(this._documents,ie),j);return this._proxy.$registerHoverProvider(ve,this._transformDocumentSelector(Z)),this._createDisposable(ve)}$provideHover(j,Z,ie,oe){return this._withAdapter(j,a,ve=>ve.provideHover(g.URI.revive(Z),ie,oe),void 0)}registerEvaluatableExpressionProvider(j,Z,ie,oe){const ve=this._addNewAdapter(new f(this._documents,ie),j);return this._proxy.$registerEvaluatableExpressionProvider(ve,this._transformDocumentSelector(Z)),this._createDisposable(ve)}$provideEvaluatableExpression(j,Z,ie,oe){return this._withAdapter(j,f,ve=>ve.provideEvaluatableExpression(g.URI.revive(Z),ie,oe),void 0)}registerInlineValuesProvider(j,Z,ie,oe){const ve=typeof ie.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ee=this._addNewAdapter(new m(this._documents,ie),j);this._proxy.$registerInlineValuesProvider(ee,this._transformDocumentSelector(Z),ve);let ue=this._createDisposable(ee);if(ve!==void 0){const Ie=ie.onDidChangeInlineValues($e=>this._proxy.$emitInlineValuesEvent(ve));ue=y.Disposable.from(ue,Ie)}return ue}$provideInlineValues(j,Z,ie,oe,ve){return this._withAdapter(j,m,ee=>ee.provideInlineValues(g.URI.revive(Z),ie,oe,ve),void 0)}registerDocumentHighlightProvider(j,Z,ie){const oe=this._addNewAdapter(new b(this._documents,ie),j);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideDocumentHighlights(j,Z,ie,oe){return this._withAdapter(j,b,ve=>ve.provideDocumentHighlights(g.URI.revive(Z),ie,oe),void 0)}registerLinkedEditingRangeProvider(j,Z,ie){const oe=this._addNewAdapter(new _(this._documents,ie),j);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideLinkedEditingRanges(j,Z,ie,oe){return this._withAdapter(j,_,async ve=>{const ee=await ve.provideLinkedEditingRanges(g.URI.revive(Z),ie,oe);if(ee)return{ranges:ee.ranges,wordPattern:ee.wordPattern?Ve._serializeRegExp(ee.wordPattern):void 0}},void 0)}registerReferenceProvider(j,Z,ie){const oe=this._addNewAdapter(new o(this._documents,ie),j);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideReferences(j,Z,ie,oe,ve){return this._withAdapter(j,o,ee=>ee.provideReferences(g.URI.revive(Z),ie,oe,ve),void 0)}registerCodeActionProvider(j,Z,ie,oe){const ve=new u.DisposableStore,ee=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,ie,this._logService,j,this._apiDeprecation),j);return this._proxy.$registerQuickFixSupport(ee,this._transformDocumentSelector(Z),{providedKinds:oe?.providedCodeActionKinds?.map(ue=>ue.value),documentation:oe?.documentation?.map(ue=>({kind:ue.kind.value,command:this._commands.converter.toInternal(ue.command,ve)}))},Ve._extLabel(j),Boolean(ie.resolveCodeAction)),ve.add(this._createDisposable(ee)),ve}$provideCodeActions(j,Z,ie,oe,ve){return this._withAdapter(j,A,ee=>ee.provideCodeActions(g.URI.revive(Z),ie,oe,ve),void 0)}$resolveCodeAction(j,Z,ie){return this._withAdapter(j,A,oe=>oe.resolveCodeAction(Z,ie),void 0)}$releaseCodeActions(j,Z){this._withAdapter(j,A,ie=>Promise.resolve(ie.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(j,Z,ie){const oe=this._addNewAdapter(new F(this._documents,ie),j);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(Z),j.identifier,j.displayName||j.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(j,Z,ie,oe){return this._withAdapter(j,F,ve=>ve.provideDocumentFormattingEdits(g.URI.revive(Z),ie,oe),void 0)}registerDocumentRangeFormattingEditProvider(j,Z,ie){const oe=this._addNewAdapter(new $(this._documents,ie),j);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(Z),j.identifier,j.displayName||j.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(j,Z,ie,oe,ve){return this._withAdapter(j,$,ee=>ee.provideDocumentRangeFormattingEdits(g.URI.revive(Z),ie,oe,ve),void 0)}registerOnTypeFormattingEditProvider(j,Z,ie,oe){const ve=this._addNewAdapter(new W(this._documents,ie),j);return this._proxy.$registerOnTypeFormattingSupport(ve,this._transformDocumentSelector(Z),oe,j.identifier),this._createDisposable(ve)}$provideOnTypeFormattingEdits(j,Z,ie,oe,ve,ee){return this._withAdapter(j,W,ue=>ue.provideOnTypeFormattingEdits(g.URI.revive(Z),ie,oe,ve,ee),void 0)}registerWorkspaceSymbolProvider(j,Z){const ie=this._addNewAdapter(new Q(Z,this._logService),j);return this._proxy.$registerNavigateTypeSupport(ie),this._createDisposable(ie)}$provideWorkspaceSymbols(j,Z,ie){return this._withAdapter(j,Q,oe=>oe.provideWorkspaceSymbols(Z,ie),{symbols:[]})}$resolveWorkspaceSymbol(j,Z,ie){return this._withAdapter(j,Q,oe=>oe.resolveWorkspaceSymbol(Z,ie),void 0)}$releaseWorkspaceSymbols(j,Z){this._withAdapter(j,Q,ie=>ie.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(j,Z,ie){const oe=this._addNewAdapter(new H(this._documents,ie,this._logService),j);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(Z),H.supportsResolving(ie)),this._createDisposable(oe)}$provideRenameEdits(j,Z,ie,oe,ve){return this._withAdapter(j,H,ee=>ee.provideRenameEdits(g.URI.revive(Z),ie,oe,ve),void 0)}$resolveRenameLocation(j,Z,ie,oe){return this._withAdapter(j,H,ve=>ve.resolveRenameLocation(g.URI.revive(Z),ie,oe),void 0)}registerDocumentSemanticTokensProvider(j,Z,ie,oe){const ve=this._nextHandle(),ee=typeof ie.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(ve,new Ne(new x(this._documents,ie),j)),this._proxy.$registerDocumentSemanticTokensProvider(ve,this._transformDocumentSelector(Z),oe,ee);let ue=this._createDisposable(ve);if(ee){const Ie=ie.onDidChangeSemanticTokens($e=>this._proxy.$emitDocumentSemanticTokensEvent(ee));ue=y.Disposable.from(ue,Ie)}return ue}$provideDocumentSemanticTokens(j,Z,ie,oe){return this._withAdapter(j,x,ve=>ve.provideDocumentSemanticTokens(g.URI.revive(Z),ie,oe),null,!0)}$releaseDocumentSemanticTokens(j,Z){this._withAdapter(j,x,ie=>ie.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(j,Z,ie,oe){const ve=this._addNewAdapter(new L(this._documents,ie),j);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ve,this._transformDocumentSelector(Z),oe),this._createDisposable(ve)}$provideDocumentRangeSemanticTokens(j,Z,ie,oe){return this._withAdapter(j,L,ve=>ve.provideDocumentRangeSemanticTokens(g.URI.revive(Z),ie,oe),null,!0)}registerCompletionItemProvider(j,Z,ie,oe){const ve=this._addNewAdapter(new G(this._documents,this._commands.converter,ie,this._apiDeprecation,j),j);return this._proxy.$registerSuggestSupport(ve,this._transformDocumentSelector(Z),oe,G.supportsResolving(ie),`${j.identifier.value}(${oe.join("")})`),this._createDisposable(ve)}$provideCompletionItems(j,Z,ie,oe,ve){return this._withAdapter(j,G,ee=>ee.provideCompletionItems(g.URI.revive(Z),ie,oe,ve),void 0)}$resolveCompletionItem(j,Z,ie){return this._withAdapter(j,G,oe=>oe.resolveCompletionItem(Z,ie),void 0)}$releaseCompletionItems(j,Z){this._withAdapter(j,G,ie=>ie.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(j,Z,ie){const oe=this._addNewAdapter(new M(this._documents,ie,this._commands.converter),j);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideInlineCompletions(j,Z,ie,oe,ve){return this._withAdapter(j,M,ee=>ee.provideInlineCompletions(g.URI.revive(Z),ie,oe,ve),void 0)}$handleInlineCompletionDidShow(j,Z,ie){this._withAdapter(j,M,async oe=>{oe.handleDidShowCompletionItem(Z,ie)},void 0)}$freeInlineCompletionsList(j,Z){this._withAdapter(j,M,async ie=>{ie.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(j,Z,ie,oe){const ve=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,ee=this._addNewAdapter(new B(this._documents,ie),j);return this._proxy.$registerSignatureHelpProvider(ee,this._transformDocumentSelector(Z),ve),this._createDisposable(ee)}$provideSignatureHelp(j,Z,ie,oe,ve){return this._withAdapter(j,B,ee=>ee.provideSignatureHelp(g.URI.revive(Z),ie,oe,ve),void 0)}$releaseSignatureHelp(j,Z){this._withAdapter(j,B,ie=>ie.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(j,Z,ie){const oe=typeof ie.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ve=this._addNewAdapter(new z(this._documents,ie),j);this._proxy.$registerInlayHintsProvider(ve,this._transformDocumentSelector(Z),oe);let ee=this._createDisposable(ve);if(oe!==void 0){const ue=ie.onDidChangeInlayHints(Ie=>this._proxy.$emitInlayHintsEvent(oe));ee=y.Disposable.from(ee,ue)}return ee}$provideInlayHints(j,Z,ie,oe){return this._withAdapter(j,z,ve=>ve.provideInlayHints(g.URI.revive(Z),ie,oe),void 0)}registerDocumentLinkProvider(j,Z,ie){const oe=this._addNewAdapter(new J(this._documents,ie),j);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(Z),typeof ie.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(j,Z,ie){return this._withAdapter(j,J,oe=>oe.provideLinks(g.URI.revive(Z),ie),void 0)}$resolveDocumentLink(j,Z,ie){return this._withAdapter(j,J,oe=>oe.resolveLink(Z,ie),void 0)}$releaseDocumentLinks(j,Z){this._withAdapter(j,J,ie=>ie.releaseLinks(Z),void 0)}registerColorProvider(j,Z,ie){const oe=this._addNewAdapter(new ce(this._documents,ie),j);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideDocumentColors(j,Z,ie){return this._withAdapter(j,ce,oe=>oe.provideColors(g.URI.revive(Z),ie),[])}$provideColorPresentations(j,Z,ie,oe){return this._withAdapter(j,ce,ve=>ve.provideColorPresentations(g.URI.revive(Z),ie,oe),void 0)}registerFoldingRangeProvider(j,Z,ie){const oe=this._nextHandle(),ve=typeof ie.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Ne(new ye(this._documents,ie),j)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(Z),ve);let ee=this._createDisposable(oe);if(ve!==void 0){const ue=ie.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ve));ee=y.Disposable.from(ee,ue)}return ee}$provideFoldingRanges(j,Z,ie,oe){return this._withAdapter(j,ye,ve=>ve.provideFoldingRanges(g.URI.revive(Z),ie,oe),void 0)}registerSelectionRangeProvider(j,Z,ie){const oe=this._addNewAdapter(new Fe(this._documents,ie,this._logService),j);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$provideSelectionRanges(j,Z,ie,oe){return this._withAdapter(j,Fe,ve=>ve.provideSelectionRanges(g.URI.revive(Z),ie,oe),[])}registerCallHierarchyProvider(j,Z,ie){const oe=this._addNewAdapter(new Re(this._documents,ie),j);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(Z)),this._createDisposable(oe)}$prepareCallHierarchy(j,Z,ie,oe){return this._withAdapter(j,Re,ve=>Promise.resolve(ve.prepareSession(g.URI.revive(Z),ie,oe)),void 0)}$provideCallHierarchyIncomingCalls(j,Z,ie,oe){return this._withAdapter(j,Re,ve=>ve.provideCallsTo(Z,ie,oe),void 0)}$provideCallHierarchyOutgoingCalls(j,Z,ie,oe){return this._withAdapter(j,Re,ve=>ve.provideCallsFrom(Z,ie,oe),void 0)}$releaseCallHierarchy(j,Z){this._withAdapter(j,Re,ie=>Promise.resolve(ie.releaseSession(Z)),void 0)}static _serializeRegExp(j){return{pattern:j.source,flags:(0,I.regExpFlags)(j)}}static _serializeIndentationRule(j){return{decreaseIndentPattern:Ve._serializeRegExp(j.decreaseIndentPattern),increaseIndentPattern:Ve._serializeRegExp(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Ve._serializeRegExp(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Ve._serializeRegExp(j.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(j){return{beforeText:Ve._serializeRegExp(j.beforeText),afterText:j.afterText?Ve._serializeRegExp(j.afterText):void 0,previousLineText:j.previousLineText?Ve._serializeRegExp(j.previousLineText):void 0,action:j.action}}static _serializeOnEnterRules(j){return j.map(Ve._serializeOnEnterRule)}setLanguageConfiguration(j,Z,ie){let{wordPattern:oe}=ie;if(oe&&(0,I.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(Z,oe):this._documents.setWordDefinitionFor(Z,void 0),ie.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),ie.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const ve=this._nextHandle(),ee={comments:ie.comments,brackets:ie.brackets,wordPattern:ie.wordPattern?Ve._serializeRegExp(ie.wordPattern):void 0,indentationRules:ie.indentationRules?Ve._serializeIndentationRule(ie.indentationRules):void 0,onEnterRules:ie.onEnterRules?Ve._serializeOnEnterRules(ie.onEnterRules):void 0,__electricCharacterSupport:ie.__electricCharacterSupport,__characterPairSupport:ie.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ve,Z,ee),this._createDisposable(ve)}$setWordDefinitions(j){for(const Z of j)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=Ve,Ve._handlePool=0}),define(he[235],fe([0,1,5,16,7]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(I,D){this._proxy=I.getProxy(g.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(I,D){await this._proxy.$changeLanguage(I,D);const C=this._documents.getDocumentData(I);if(!C)throw new Error(`document '${I.toString}' NOT found`);return C.document}async tokenAtPosition(I,D){const C=I.version,i=R.Position.from(D),P=await this._proxy.$tokensAtPosition(I.uri,i),u={type:k.StandardTokenType.Other,range:I.getWordRangeAtPosition(D)??new k.Range(D.line,D.character,D.line,D.character)};if(!P)return u;const p={range:R.Range.to(P.range),type:R.TokenType.to(P.type)};return!p.range.contains(D)||C!==I.version?u:p}}e.ExtHostLanguages=y}),define(he[236],fe([0,1,5,12,34]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(I){return I&&I.title}let T=class{constructor(D,C){this._logService=C,this._proxy=D.getProxy(g.MainContext.MainThreadMessageService)}showMessage(D,C,i,P,u){const p={extension:D};let l;typeof P=="string"||y(P)?l=[P,...u]:(p.modal=P?.modal,p.useCustom=P?.useCustom,p.detail=P?.detail,l=u),p.useCustom&&(0,k.checkProposedApiEnabled)(D);const c=[];for(let S=0;S<l.length;S++){const w=l[S];if(typeof w=="string")c.push({title:w,handle:S,isCloseAffordance:!1});else if(typeof w=="object"){let{title:E,isCloseAffordance:d}=w;c.push({title:E,isCloseAffordance:!!d,handle:S})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(C,i,p,c).then(S=>{if(typeof S=="number")return l[S]})}};T=je([He(1,R.ILogService)],T),e.ExtHostMessageService=T}),define(he[237],fe([0,1,22,3,74,6,23,8,14,2,84,5,16,7,213,124]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class S{constructor(E,d,h,v,t){this._textDocumentsAndEditors=h,this._textDocuments=v,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new T.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new i.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=E.getProxy(P.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=E.getProxy(P.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=E.getProxy(P.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const r=s.notebookEditor?.notebookUri,n=s.cell.handle,f=this._documents.get(r)?.getCell(n);if(f)return f.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(E=>E.apiEditor)}getEditorById(E){const d=this._editors.get(E);if(!d)throw new Error(`unknown text editor: ${E}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(E){for(const[d,h]of this._editors)if(h.apiEditor===E)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(E,d){const h=this._documents.get(E);if(!h&&!d)throw new Error(`NO notebook document for '${E}'`);return h}_getProviderData(E){const d=this._notebookContentProviders.get(E);if(!d)throw new Error(`NO provider for '${E}'`);return d}registerNotebookContentProvider(E,d,h,v,t){if((0,I.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(d))throw new Error(`Notebook provider for '${d}' already registered`);this._notebookContentProviders.set(d,{extension:E,provider:h});let s;return h.onDidChangeNotebookContentOptions&&(s=h.onDidChangeNotebookContentOptions(()=>{const r=u.NotebookDocumentContentOptions.from(h.options);this._notebookProxy.$updateNotebookProviderOptions(d,r)})),this._notebookProxy.$registerNotebookProvider({id:E.identifier,location:E.extensionLocation},d,u.NotebookDocumentContentOptions.from(v),S._convertNotebookRegistrationData(E,t)),new p.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(d),this._notebookProxy.$unregisterNotebookProvider(d)})}static _convertNotebookRegistrationData(E,d){if(!d)return;const h=d.filenamePattern.map(v=>u.NotebookExclusiveDocumentPattern.from(v)).filter(v=>v!==void 0);if(d.filenamePattern&&!h){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:d.displayName,filenamePattern:h,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,d,h){const v=S._notebookStatusBarItemProviderHandlePool++,t=typeof h.onDidChangeCellStatusBarItems=="function"?S._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(v,h),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(v,t,d);let s;return t!==void 0&&(s=h.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(t))),new p.Disposable(()=>{this._notebookStatusBarItemProviders.delete(v),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(v,t),s&&s.dispose()})}async createNotebookDocument(E){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:E.viewType,content:E.content&&u.NotebookData.from(E.content)});return C.URI.revive(d)}async openNotebookDocument(E){const d=this._documents.get(E);if(d)return d.apiNotebook;const h=await this._notebookDocumentsProxy.$tryOpenNotebook(E),v=this._documents.get(C.URI.revive(h));return(0,D.assertIsDefined)(v?.apiNotebook)}async showNotebookDocument(E,d){C.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let h;typeof d=="object"?h={position:u.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(u.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:h={preserveFocus:!1};const v=await this._notebookEditorsProxy.$tryShowNotebookDocument(E.uri,E.notebookType,h),t=v&&this._editors.get(v)?.apiEditor;if(t)return t;throw v?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,d,h,v){const t=this._notebookStatusBarItemProviders.get(E),s=C.URI.revive(d),r=this._documents.get(s);if(!r||!t)return;const n=r.getCellFromIndex(h);if(!n)return;const a=await t.provideCellStatusBarItems(n.apiCell,v);if(!a)return;const f=new y.DisposableStore,m=this._statusBarCache.add([f]),_=(Array.isArray(a)?a:[a]).map(o=>u.NotebookStatusBarItem.from(o,this._commandsConverter,f));return{cacheId:m,items:_}}$releaseNotebookCellStatusBarItems(E){this._statusBarCache.delete(E)}registerNotebookSerializer(E,d,h,v,t){if((0,I.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,h),this._notebookProxy.$registerNotebookSerializer(s,{id:E.identifier,location:E.extensionLocation},d,u.NotebookDocumentContentOptions.from(v),S._convertNotebookRegistrationData(E,t)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(E,d,h){const v=this._notebookSerializer.get(E);if(!v)throw new Error("NO serializer found");const t=await v.deserializeNotebook(d.buffer,h);return u.NotebookData.from(t)}async $notebookToData(E,d,h){const v=this._notebookSerializer.get(E);if(!v)throw new Error("NO serializer found");const t=await v.serializeNotebook(u.NotebookData.to(d),h);return g.VSBuffer.wrap(t)}async $openNotebook(E,d,h,v,t){const{provider:s}=this._getProviderData(E),r=await s.openNotebook(C.URI.revive(d),{backupId:h,untitledDocumentData:v?.buffer},t);return{metadata:r.metadata??Object.create(null),cells:r.cells.map(u.NotebookCellData.from)}}async $saveNotebook(E,d,h){const v=this.getNotebookDocument(C.URI.revive(d)),{provider:t}=this._getProviderData(E);return await t.saveNotebook(v.apiNotebook,h),!0}async $saveNotebookAs(E,d,h,v){const t=this.getNotebookDocument(C.URI.revive(d)),{provider:s}=this._getProviderData(E);return await s.saveNotebookAs(C.URI.revive(h),t.apiNotebook,v),!0}async $backupNotebook(E,d,h){const v=this.getNotebookDocument(C.URI.revive(d)),t=this._getProviderData(E),s=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),r=String((0,k.hash)([v.uri.toString(),this._backupIdPool++])),n=C.URI.joinPath(s,r),a=await t.provider.backupNotebook(v.apiNotebook,{destination:n},h);return v.updateBackup(a),a.id}_createExtHostEditor(E,d,h){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const v=new c.ExtHostNotebookEditor(d,this._notebookEditorsProxy,E,h.visibleRanges.map(u.NotebookRange.to),h.selections.map(u.NotebookRange.to),typeof h.viewColumn=="number"?u.ViewColumn.to(h.viewColumn):void 0);this._editors.set(d,v)}$acceptDocumentAndEditorsDelta(E){if(E.removedDocuments)for(const h of E.removedDocuments){const v=C.URI.revive(h),t=this._documents.get(v);t&&(t.dispose(),this._documents.delete(v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===v.toString()&&this._editors.delete(s.id)}if(E.addedDocuments){const h=[];for(const v of E.addedDocuments){const t=C.URI.revive(v.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const s=this,r=new l.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(n){s._onDidChangeNotebookCells.fire(n)},emitCellOutputsChange(n){s._onDidChangeCellOutputs.fire(n)},emitCellMetadataChange(n){s._onDidChangeCellMetadata.fire(n)},emitCellExecutionStateChange(n){s._onDidChangeCellExecutionState.fire(n)}},t,v);h.push(...v.cells.map(n=>l.ExtHostCell.asModelAddData(r.apiNotebook,n))),this._documents.get(t)?.dispose(),this._documents.set(t,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:h}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(E.addedEditors)for(const h of E.addedEditors){if(this._editors.has(h.id))return;const v=C.URI.revive(h.documentUri),t=this._documents.get(v);t&&this._createExtHostEditor(t,h.id,h)}const d=[];if(E.removedEditors)for(const h of E.removedEditors){const v=this._editors.get(h);v&&(this._editors.delete(h),this._activeNotebookEditor?.id===v.id&&(this._activeNotebookEditor=void 0),d.push(v))}if(E.visibleEditors){this._visibleNotebookEditors=E.visibleEditors.map(v=>this._editors.get(v)).filter(v=>!!v);const h=new Set;this._visibleNotebookEditors.forEach(v=>h.add(v.id));for(const v of this._editors.values()){const t=h.has(v.id);v._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(v=>v).filter(v=>v.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}E.newActiveEditor===null?this._activeNotebookEditor=void 0:E.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(E.newActiveEditor)),E.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=S,S._notebookStatusBarItemProviderHandlePool=0}),define(he[238],fe([0,1,3,71,12,5,13,16]),function(X,e,g,R,k,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(P,u){const p=D._Keys.nextId();P.$registerNotebookEditorDecorationType(p,I.NotebookDecorationRenderOptions.from(u)),this.value={key:p,dispose(){P.$removeNotebookEditorDecorationType(p)}}}}D._Keys=new R.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(P,u,p){this._logService=P,this._extHostRpc=u,this._notebooksAndEditors=p,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(P){return new D(this._extHostRpc.getProxy(y.MainContext.MainThreadNotebookEditors),P).value}$acceptEditorPropertiesChanged(P,u){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,u);const p=this._notebooksAndEditors.getEditorById(P);u.visibleRanges&&p._acceptVisibleRanges(u.visibleRanges.ranges.map(I.NotebookRange.to)),u.selections&&p._acceptSelections(u.selections.selections.map(I.NotebookRange.to)),u.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:p.apiEditor,visibleRanges:p.apiEditor.visibleRanges}),u.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:p.apiEditor,selections:p.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const u in P)this._notebooksAndEditors.getEditorById(u)._acceptViewColumn(I.ViewColumn.to(P[u]))}};C=je([He(0,k.ILogService),He(1,T.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(he[239],fe([0,1,3,6,5,26,2,16,85,23,17,86,21,18,12,7,34]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,s,r,n){this._initData=s,this._extHostNotebook=r,this._logService=n,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(k.MainContext.MainThreadNotebookKernels)}createNotebookController(t,s,r,n,a,f){for(let M of this._kernelData.values())if(M.controller.id===s&&y.ExtensionIdentifier.equals(t.identifier,M.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const m=this._handlePool++,b=this;this._logService.trace(`NotebookController[${m}], CREATED by ${t.identifier.value}, ${s}`);const _=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${t.identifier}'`);let o=!1;const A=new R.DisposableStore,F=new g.Emitter,$=new g.Emitter,W={id:`${t.identifier.value}/${s}`,notebookType:r,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:n||t.identifier.value,preloads:f?f.map(I.NotebookRendererScript.from):[]};let Q=a??_,H;this._proxy.$addKernel(m,W).catch(M=>{console.log(M),o=!0});let N=0;const x=()=>{if(o)return;const M=++N;Promise.resolve().then(()=>{M===N&&this._proxy.$updateKernel(m,W)})},L=new C.ResourceMap,G={get id(){return s},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return W.label},set label(M){W.label=M??t.displayName??t.name,x()},get detail(){return W.detail??""},set detail(M){W.detail=M,x()},get description(){return W.description??""},set description(M){W.description=M,x()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages(M){W.supportedLanguages=M,x()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder(M){W.supportsExecutionOrder=M,x()},get rendererScripts(){return W.preloads?W.preloads.map(I.NotebookRendererScript.to):[]},get executeHandler(){return Q},set executeHandler(M){Q=M??_},get interruptHandler(){return H},set interruptHandler(M){H=M,W.supportsInterrupt=Boolean(M),x()},createNotebookCellExecution(M){if(o)throw new Error("notebook controller is DISPOSED");if(!L.has(M.notebook.uri))throw b._logService.trace(`NotebookController[${m}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(L.keys()).map(O=>O.toString())),new Error(`notebook controller is NOT associated to notebook: ${M.notebook.uri.toString()}`);return b._createNotebookCellExecution(M)},dispose:()=>{o||(this._logService.trace(`NotebookController[${m}], DISPOSED`),o=!0,this._kernelData.delete(m),A.dispose(),F.dispose(),$.dispose(),this._proxy.$removeKernel(m))},updateNotebookAffinity(M,O){b._proxy.$updateNotebookPriority(m,M.uri,O)},onDidReceiveMessage:$.event,postMessage(M,O){return(0,S.checkProposedApiEnabled)(t),b._proxy.$postMessage(m,O&&b._extHostNotebook.getIdByEditor(O),M)},asWebviewUri(M){return(0,S.checkProposedApiEnabled)(t),(0,D.asWebviewUri)(M,b._initData.remote)}};return this._kernelData.set(m,{extensionId:t.identifier,controller:G,onDidReceiveMessage:$,onDidChangeSelection:F,associatedNotebooks:L}),G}$acceptNotebookAssociation(t,s,r){const n=this._kernelData.get(t);if(n){const a=this._extHostNotebook.getNotebookDocument(T.URI.revive(s));r?n.associatedNotebooks.set(a.uri,!0):n.associatedNotebooks.delete(a.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,a.uri.toString(),r),n.onDidChangeSelection.fire({selected:r,notebook:a.apiNotebook})}}async $executeCells(t,s,r){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getNotebookDocument(T.URI.revive(s)),f=[];for(let m of r){const b=a.getCell(m);b&&f.push(b.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,a.uri.toString(),f.length),await n.controller.executeHandler.call(n.controller,f,a.apiNotebook,n.controller)}catch(m){this._logService.error(`NotebookController[${t}] execute cells FAILED`,m),console.error(m)}}async $cancelCells(t,s,r){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getNotebookDocument(T.URI.revive(s));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,a.apiNotebook);else for(let f of r){const m=a.getCell(f);m&&this._activeExecutions.get(m.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,s,r){const n=this._kernelData.get(t);if(!n)return;const a=this._extHostNotebook.getEditorById(s);n.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:r}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!r)throw new Error("invalid cell");if(this._activeExecutions.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const n=new d(r.notebook,r,this._proxy);this._activeExecutions.set(r.uri,n);const a=n.onDidChangeState(()=>{n.state===E.Resolved&&(n.dispose(),a.dispose(),this._activeExecutions.delete(r.uri))});return n.asApiObject()}};w=je([He(3,l.ILogService)],w),e.ExtHostNotebookKernels=w;var E;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(E||(E={}));class d extends R.Disposable{constructor(t,s,r){super();this._document=t,this._cell=s,this._proxy=r,this._onDidChangeState=new g.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=E.Init,this._tokenSource=this._register(new u.CancellationTokenSource),this._collector=new h(10,n=>this.applyEdits(n)),this._executionOrder=s.internalMetadata.executionOrder,this.mixinMetadata({runState:P.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===E.Init)throw new Error("Must call start before modifying cell output");if(this._state===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let s=this._cell;if(t&&(s=this._document.getCellFromApiCell(t)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(t){return t.map(s=>{const r=c.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return r===s.items?I.NotebookCellOutput.from(s):I.NotebookCellOutput.from({items:r,id:s.id,metadata:s.metadata})})}async updateOutputs(t,s,r){const n=this.cellIndexToHandle(s),a=this.validateAndConvertOutputs((0,p.asArray)(t));return this.applyEditSoon({editType:2,handle:n,append:r,outputs:a})}async updateOutputItems(t,s,r){return t=c.NotebookCellOutput.ensureUniqueMimeTypes((0,p.asArray)(t),!0),this.applyEditSoon({editType:7,items:t.map(I.NotebookCellOutputItem.from),outputId:s.id,append:r})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(r){t._executionOrder=r,t.mixinMetadata({executionOrder:r})},start(r){if(t._state===E.Resolved||t._state===E.Started)throw new Error("Cannot call start again");t._state=E.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:P.NotebookCellExecutionState.Executing,runStartTime:r??null})},end(r,n){if(t._state===E.Resolved)throw new Error("Cannot call resolve twice");t._state=E.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:r??null,runEndTime:n??null})},clearOutput(r){return t.verifyStateForOutput(),t.updateOutputs([],r,!1)},appendOutput(r,n){return t.verifyStateForOutput(),t.updateOutputs(r,n,!0)},replaceOutput(r,n){return t.verifyStateForOutput(),t.updateOutputs(r,n,!1)},appendOutputItems(r,n){return t.verifyStateForOutput(),t.updateOutputItems(r,n,!0)},replaceOutputItems(r,n){return t.verifyStateForOutput(),t.updateOutputItems(r,n,!1)}})}}class h{constructor(t,s){this.delay=t,this.callback=s,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,i.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const s=this.batch;return this.batch=[],this.callback(s)})),this.waitPromise}}}),define(he[240],fe([0,1,3,5,124]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(I,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=I.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(I,D,C){const i=this._extHostNotebook.getEditorById(I);this._rendererMessageEmitters.get(D)?.fire({editor:i.apiEditor,message:C})}createRendererMessaging(I){return{onDidReceiveMessage:(...C)=>this.getOrCreateEmitterFor(I).event(...C),postMessage:(C,i)=>{const P=k.ExtHostNotebookEditor.apiEditorsToExtHost.get(C);if(!P)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(P.id,I,i)}}}getOrCreateEmitterFor(I){let D=this._rendererMessageEmitters.get(I);return D||(D=new g.Emitter({onLastListenerRemove:()=>{D?.dispose(),this._rendererMessageEmitters.delete(I)}}),this._rendererMessageEmitters.set(I,D),D)}}e.ExtHostNotebookRenderers=y}),define(he[62],fe([0,1,5,3,6,22,4,13]),function(X,e,g,R,k,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends k.Disposable{constructor(l,c,S,w,E){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=l,this._proxy=E,this._id=E.$register(this.name,c,S,w),this._disposed=!1,this._offset=0}get name(){return this._name}append(l){this.validate(),this._offset+=l?y.VSBuffer.fromString(l).byteLength:0}update(){this._id.then(l=>this._proxy.$update(l))}appendLine(l){this.validate(),this.append(l+`
`)}clear(){this.validate();const l=this._offset;this._id.then(c=>this._proxy.$clear(c,l))}show(l,c){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof l=="boolean"?l:c)))}hide(){this.validate(),this._id.then(l=>this._proxy.$close(l))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(l=>this._proxy.$dispose(l)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class C extends D{constructor(l,c,S){super(l,!1,void 0,c,S)}append(l){super.append(l),this._id.then(c=>this._proxy.$append(c,l)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class i extends D{constructor(l,c,S){super(l,!0,c,void 0,S)}append(l){throw new Error("Not supported")}}class P{constructor(l,c){this.name=l,this._channel=c}append(l){this._channel.then(c=>c.append(l))}appendLine(l){this._channel.then(c=>c.appendLine(l))}clear(){this._channel.then(l=>l.clear())}show(l,c){this._channel.then(S=>S.show(l,c))}hide(){this._channel.then(l=>l.hide())}dispose(){this._channel.then(l=>l.dispose())}}e.LazyOutputChannel=P;let u=class{constructor(l){this._proxy=l.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(l){}createOutputChannel(l,c){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");return new C(c.identifier.value,l,this._proxy)}createOutputChannelFromLogFile(l,c){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");if(!c)throw new Error("illegal argument `file`. must not be falsy");return new i(l,c,this._proxy)}};u=je([He(0,I.IExtHostRpcService)],u),e.ExtHostOutputService=u,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(he[241],fe([0,1,17,21,3,6,5,2,7,15,18,56]),function(X,e,g,R,k,y,T,I,D,C,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function u(p,l,c){const S=p.getProxy(T.MainContext.MainThreadQuickOpen);class w{constructor(n,a){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=a}showQuickPick(n,a,f,m=R.CancellationToken.None){this._onDidSelectItem=void 0;const b=Promise.resolve(n),_=++this._instances,o=S.$show(_,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},m),A={},F=o.then(()=>A);return Promise.race([F,b]).then($=>{if($!==A)return b.then(W=>{const Q=[];for(let H=0;H<W.length;H++){const N=W[H];let x,L,G,M,O;typeof N=="string"?x=N:(x=N.label,L=N.description,G=N.detail,M=N.picked,O=N.alwaysShow),Q.push({label:x,description:L,handle:H,detail:G,picked:M,alwaysShow:O})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{f.onDidSelectItem(W[H])}),S.$setItems(_,Q),o.then(H=>{if(typeof H=="number")return W[H];if(Array.isArray(H))return H.map(N=>W[N])})})}).then(void 0,$=>{if(!(0,C.isPromiseCanceledError)($))return S.$setError(_,$),Promise.reject($)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,a=R.CancellationToken.None){return this._validateInput=n?n.validateInput:void 0,S.$input(n,typeof this._validateInput=="function",a).then(void 0,f=>{if(!(0,C.isPromiseCanceledError)(f))return Promise.reject(f)})}$validateInput(n){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(n)):Promise.resolve(void 0)}async showWorkspaceFolderPick(n,a=R.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!f)return;const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(b=>b.uri.toString()===f.uri.toString())}createQuickPick(n,a){const f=new t(n,a,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(n){const a=new s(n,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(n,a){const f=this._sessions.get(n);f&&f._fireDidChangeValue(a)}$onDidAccept(n){const a=this._sessions.get(n);a&&a._fireDidAccept()}$onDidChangeActive(n,a){const f=this._sessions.get(n);f instanceof t&&f._fireDidChangeActive(a)}$onDidChangeSelection(n,a){const f=this._sessions.get(n);f instanceof t&&f._fireDidChangeSelection(a)}$onDidTriggerButton(n,a){const f=this._sessions.get(n);f&&f._fireDidTriggerButton(a)}$onDidHide(n){const a=this._sessions.get(n);a&&a._fireDidHide()}}class E{constructor(n,a){this._extensionId=n,this._onDidDispose=a,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((a,f)=>{const m=a===D.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(m,a)}),this.update({buttons:n.map((a,f)=>({iconPath:d(a.iconPath),tooltip:a.tooltip,handle:a===D.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const a=this._handlesToButtons.get(n);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,y.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(n){if(!this._disposed){for(const a of Object.keys(n)){const f=n[a];this._pendingUpdate[a]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function d(r){if(r instanceof D.ThemeIcon)return{id:r.id};const n=v(r),a=h(r);return{dark:typeof n=="string"?I.URI.file(n):n,light:typeof a=="string"?I.URI.file(a):a}}function h(r){return typeof r=="object"&&"light"in r?r.light:r}function v(r){return typeof r=="object"&&"dark"in r?r.dark:r}class t extends E{constructor(n,a,f){super(n,f);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((a,f)=>{this._handlesToItems.set(f,a),this._itemsToHandles.set(a,f)}),this.update({items:n.map((a,f)=>({label:a.label,description:a.description,handle:f,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(n){const a=(0,i.coalesce)(n.map(f=>this._handlesToItems.get(f)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(n){const a=(0,i.coalesce)(n.map(f=>this._handlesToItems.get(f)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class s extends E{constructor(n,a){super(n,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,this.update({validationMessage:n,severity:n?P.default.Error:P.default.Ignore})}}return new w(l,c)}e.createExtHostQuickOpen=u}),define(he[242],fe([0,1,2,3,53,6,17,5,18,96,12,26,34,193]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(a){if(a)return typeof a.iconPath=="string"?g.URI.file(a.iconPath):g.URI.isUri(a.iconPath)||p.ThemeIcon.isThemeIcon(a.iconPath)?a.iconPath:void 0}function c(a,f){if(!a.iconPath&&!f.iconPath)return 0;if(a.iconPath){if(!f.iconPath)return 1}else return-1;const m=typeof a.iconPath=="string"?a.iconPath:g.URI.isUri(a.iconPath)?a.iconPath.fsPath:a.iconPath.id,b=typeof f.iconPath=="string"?f.iconPath:g.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,C.comparePaths)(m,b)}function S(a,f){let m=0;if(a.strikeThrough!==f.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==f.faded)return a.faded?1:-1;if(a.tooltip!==f.tooltip)return(a.tooltip||"").localeCompare(f.tooltip||"");if(m=c(a,f),m!==0)return m;if(a.light&&f.light)m=c(a.light,f.light);else{if(a.light)return 1;if(f.light)return-1}if(m!==0)return m;if(a.dark&&f.dark)m=c(a.dark,f.dark);else{if(a.dark)return 1;if(f.dark)return-1}return m}function w(a,f){if(a.command!==f.command)return a.command<f.command?-1:1;if(a.title!==f.title)return a.title<f.title?-1:1;if(a.tooltip!==f.tooltip){if(a.tooltip!==void 0&&f.tooltip!==void 0)return a.tooltip<f.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(a.arguments===f.arguments)return 0;if(a.arguments)if(f.arguments){if(a.arguments.length!==f.arguments.length)return a.arguments.length-f.arguments.length}else return 1;else return-1;for(let m=0;m<a.arguments.length;m++){const b=a.arguments[m],_=f.arguments[m];if(b!==_)return b<_?-1:1}return 0}function E(a,f){let m=(0,C.comparePaths)(a.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(m!==0)return m;if(a.command&&f.command)m=w(a.command,f.command);else{if(a.command)return 1;if(f.command)return-1}if(m!==0)return m;if(a.decorations&&f.decorations)m=S(a.decorations,f.decorations);else{if(a.decorations)return 1;if(f.decorations)return-1}return m}function d(a,f){for(let m=0;m<a.length;m++)if(a[m]!==f[m])return!1;return!0}function h(a,f){return a.command===f.command&&a.title===f.title&&a.tooltip===f.tooltip&&(a.arguments&&f.arguments?d(a.arguments,f.arguments):a.arguments===f.arguments)}function v(a,f){return(0,D.equals)(a,f,h)}class t{constructor(f,m,b){this._extension=f,this._proxy=m,this._sourceControlHandle=b,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(f){this._proxy.$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,u.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(f){if((0,u.checkProposedApiEnabled)(this._extension),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,f))}focus(){(0,u.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(f,m){(0,u.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,f,m)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=t;class s{constructor(f,m,b,_,o){this._proxy=f,this._commands=m,this._sourceControlHandle=b,this._id=_,this._label=o,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,m){const b=this._resourceStatesCommandsMap.get(f);return b?(0,T.asPromise)(()=>this._commands.executeCommand(b.command,...b.arguments||[],m)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(E),b=(0,D.sortedDiff)(this._resourceSnapshot,f,E).map(A=>{const F=A.toInsert.map($=>{const W=this._resourceHandlePool++;this._resourceStatesMap.set(W,$);const Q=$.resourceUri;let H;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const ce=new y.DisposableStore;H=this._commands.converter.toInternal($.command,ce),this._resourceStatesDisposablesMap.set(W,ce)}else this._resourceStatesCommandsMap.set(W,$.command);const N=l($.decorations),x=$.decorations&&l($.decorations.light)||N,L=$.decorations&&l($.decorations.dark)||N,G=[x,L],M=$.decorations&&$.decorations.tooltip||"",O=$.decorations&&!!$.decorations.strikeThrough,B=$.decorations&&!!$.decorations.faded,z=$.contextValue||"";return{rawResource:[W,Q,G,M,O,B,z,H],handle:W}});return{start:A.start,deleteCount:A.deleteCount,toInsert:F}}),_=b.map(({start:A,deleteCount:F,toInsert:$})=>[A,F,$.map(W=>W.rawResource)]),o=b.reverse();for(const{start:A,deleteCount:F,toInsert:$}of o){const W=$.map(H=>H.handle),Q=this._handlesSnapshot.splice(A,F,...W);for(const H of Q)this._resourceStatesMap.delete(H),this._resourceStatesCommandsMap.delete(H),this._resourceStatesDisposablesMap.get(H)?.dispose(),this._resourceStatesDisposablesMap.delete(H)}return this._resourceSnapshot=f,_}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class r{constructor(f,m,b,_,o,A){this._proxy=m,this._commands=b,this._id=_,this._label=o,this._rootUri=A,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new t(f,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,_,o,A)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,this._proxy.$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,this._proxy.$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=f;const m=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:m})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&v(this._statusBarCommands,f))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=f;const m=(f||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:m})}get selected(){return this._selected}createResourceGroup(f,m){const b=new s(this._proxy,this._commands,this.handle,f,m),_=R.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,_),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const f=[],m=[];for(const[b,_]of this.createdResourceGroups){_.dispose();const o=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});R.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),o.dispose(),this._groups.delete(b.handle),this._proxy.$unregisterGroup(this.handle,b.handle)}),f.push([b.handle,b.id,b.label,b.features]);const A=b._takeResourceStateSnapshot();A.length>0&&m.push([b.handle,A]),this._groups.set(b.handle,b)}this._proxy.$registerGroups(this.handle,f,m),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(m=>{const b=m._takeResourceStateSnapshot();b.length!==0&&f.push([m.handle,b])}),f.length>0&&this._proxy.$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,je([(0,k.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),je([(0,k.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let n=class Wn{constructor(f,m,b){this._commands=m,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=f.getProxy(I.MainContext.MainThreadSCM),this._telemetry=f.getProxy(I.MainContext.MainThreadTelemetry),m.registerArgumentProcessor({processArgument:_=>{if(_&&_.$mid===3){const o=this._sourceControls.get(_.sourceControlHandle);if(!o)return _;const A=o.getResourceGroup(_.groupHandle);return A?A.getResourceState(_.handle):_}else if(_&&_.$mid===4){const o=this._sourceControls.get(_.sourceControlHandle);return o?o.getResourceGroup(_.groupHandle):_}else if(_&&_.$mid===5){const o=this._sourceControls.get(_.handle);return o||_}return _}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(f,m,b,_){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,m,b,_),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const o=Wn._handlePool++,A=new r(f,this._proxy,this._commands,m,b,_);this._sourceControls.set(o,A);const F=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(f.identifier))||[];return F.push(A),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(f.identifier),F),A}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const m=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(f.identifier)),b=m&&m[m.length-1];return b&&b.inputBox}$provideOriginalResource(f,m,b){const _=g.URI.revive(m);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,_.toString());const o=this._sourceControls.get(f);return!o||!o.quickDiffProvider||!o.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,T.asPromise)(()=>o.quickDiffProvider.provideOriginalResource(_,b)).then(A=>A||null)}$onInputBoxValueChange(f,m){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const b=this._sourceControls.get(f);return b&&b.inputBox.$onInputBoxValueChange(m),Promise.resolve(void 0)}$executeResourceCommand(f,m,b,_){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,m,b);const o=this._sourceControls.get(f);if(!o)return Promise.resolve(void 0);const A=o.getResourceGroup(m);return A?A.$executeResourceCommand(b,_):Promise.resolve(void 0)}$validateInput(f,m,b){this.logService.trace("ExtHostSCM#$validateInput",f);const _=this._sourceControls.get(f);return!_||!_.inputBox.validateInput?Promise.resolve(void 0):(0,T.asPromise)(()=>_.inputBox.validateInput(m,b)).then(o=>o?Promise.resolve([o.message,o.type]):Promise.resolve(void 0))}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};n._handlePool=0,n=je([He(2,i.ILogService)],n),e.ExtHostSCM=n});var it=this&&this.__classPrivateFieldSet||function(X,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,g):k?k.value=g:e.set(X,g),g},xe=this&&this.__classPrivateFieldGet||function(X,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(X):R?R.value:e.get(X)};define(he[243],fe([0,1,7,5,162,6,16]),function(X,e,g,R,k,y,T){"use strict";var I,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class C{constructor(p,l,c,S,w=g.StatusBarAlignment.Left,E){I.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,it(this,I,p,"f"),it(this,D,l,"f"),this._entryId=C.ID_GEN++,this._extension=c,this._id=S,this._alignment=w,this._priority=E}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(p){this._text=p,this.update()}set name(p){this._name=p,this.update()}set tooltip(p){this._tooltip=p,this.update()}set color(p){this._color=p,this.update()}set backgroundColor(p){p&&!C.ALLOWED_BACKGROUND_COLORS.has(p.id)&&(p=void 0),this._backgroundColor=p,this.update()}set command(p){this._command?.fromApi!==p&&(this._internalCommandRegistration.clear(),typeof p=="string"?this._command={fromApi:p,internal:xe(this,D,"f").toInternal({title:"",command:p},this._internalCommandRegistration)}:p?this._command={fromApi:p,internal:xe(this,D,"f").toInternal(p,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(p){this._accessibilityInformation=p,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,xe(this,I,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let p;this._extension?this._id?p=`${this._extension.identifier.value}.${this._id}`:p=this._extension.identifier.value:p=this._id;let l;this._name?l=this._name:l=(0,k.localize)(0,null,this._extension.displayName||this._extension.name);let c=this._color;this._backgroundColor&&(c=C.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const S=this._tooltip?T.MarkdownString.fromStrict(this._tooltip):void 0;xe(this,I,"f").$setEntry(this._entryId,p,l,this._text,S,this._command?.internal,c,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=C,I=new WeakMap,D=new WeakMap,C.ID_GEN=0,C.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")]]);class i{constructor(p){this._messages=[],this._item=p.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,k.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(p){const l={message:p};return this._messages.unshift(l),this._update(),new g.Disposable(()=>{const c=this._messages.indexOf(l);c>=0&&(this._messages.splice(c,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class P{constructor(p,l){this._proxy=p.getProxy(R.MainContext.MainThreadStatusBar),this._commands=l,this._statusMessage=new i(this)}createStatusBarEntry(p,l,c,S){return new C(this._proxy,this._commands,p,l,c,S)}setStatusBarMessage(p,l){const c=this._statusMessage.setMessage(p);let S;return typeof l=="number"?S=setTimeout(()=>c.dispose(),l):typeof l!="undefined"&&l.then(()=>c.dispose(),()=>c.dispose()),new g.Disposable(()=>{c.dispose(),clearTimeout(S)})}}e.ExtHostStatusBar=P}),define(he[89],fe([0,1,5,3,4]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(I){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,D){this._proxy.$registerExtensionStorageKeysToSync(I,D)}getValue(I,D,C){return this._proxy.$getValue(I,D).then(i=>i||C)}setValue(I,D,C){return this._proxy.$setValue(I,D,C)}$acceptValue(I,D,C){this._onDidChangeStorage.fire({shared:I,key:D,value:C})}}e.ExtHostStorage=y,e.IExtHostStorage=(0,k.createDecorator)("IExtHostStorage")}),define(he[63],fe([0,1,4,27,12,88,2]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let I=class{constructor(C,i,P){this._logService=i,this._extHostFileSystem=P,this._workspace=C.workspace??void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(u=>this._value=u)}async _getWorkspaceStorageURI(C){return T.URI.joinPath(this._environment.workspaceStorageHome,C)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const C=this._workspace.id,i=await this._getWorkspaceStorageURI(C);try{return await this._extHostFileSystem.value.stat(i),this._logService.trace("[ExtHostStorage] storage dir already exists",i),i}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",i),await this._extHostFileSystem.value.createDirectory(i),await this._extHostFileSystem.value.writeFile(T.URI.joinPath(i,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:T.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),i}catch(P){this._logService.error("[ExtHostStorage]",P);return}}workspaceValue(C){if(this._value)return T.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return T.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=je([He(0,R.IExtHostInitDataService),He(1,k.ILogService),He(2,y.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(he[33],fe([0,1,3,5,4,2,13,6,7,163,15,208,21,32,191,14]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,k.createDecorator)("IExtHostTerminalService");class S{constructor(r,n,a,f){this._proxy=r,this._id=n,this._creationOptions=a,this._name=f,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(b=>this._pidPromiseComplete=b);const m=this;this.value={get name(){return m._name||""},get processId(){return m._pidPromise},get creationOptions(){return m._creationOptions},get exitStatus(){return m._exitStatus},sendText(b,_=!0){m._checkDisposed(),m._proxy.$sendText(m._id,b,_)},show(b){m._checkDisposed(),m._proxy.$show(m._id,b)},hide(){m._checkDisposed(),m._proxy.$hide(m._id)},dispose(){m._disposed||(m._disposed=!0,m._proxy.$dispose(m._id))},get dimensions(){if(!(m._cols===void 0||m._rows===void 0))return{columns:m._cols,rows:m._rows}}}}async create(r,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:r.name,shellPath:(0,c.withNullAsUndefined)(r.shellPath),shellArgs:(0,c.withNullAsUndefined)(r.shellArgs),cwd:(0,c.withNullAsUndefined)(r.cwd),env:(0,c.withNullAsUndefined)(r.env),icon:(0,c.withNullAsUndefined)(t(r.iconPath)),initialText:(0,c.withNullAsUndefined)(r.message),strictEnv:(0,c.withNullAsUndefined)(r.strictEnv),hideFromUser:(0,c.withNullAsUndefined)(r.hideFromUser),isFeatureTerminal:(0,c.withNullAsUndefined)(n?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,c.withNullAsUndefined)(n?.useShellEnvironment),isSplitTerminal:n?.isSplitTerminal,target:n?.target})}async createExtensionTerminal(r,n,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:a,isSplitTerminal:r,target:n}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(r){this._name=r}setExitCode(r){this._exitStatus=Object.freeze({code:r})}setDimensions(r,n){return r===this._cols&&n===this._rows||r===0||n===0?!1:(this._cols=r,this._rows=n,!0)}_setProcessId(r){this._pidPromiseComplete?(this._pidPromiseComplete(r),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==r&&(this._pidPromise=Promise.resolve(r))})}}e.ExtHostTerminal=S;class w{constructor(r){this._pty=r,this.id=0,this.shouldPersist=!1,this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(r){this._pty.handleInput&&this._pty.handleInput(r)}resize(r,n){this._pty.setDimensions&&this._pty.setDimensions({columns:r,rows:n})}async processBinary(r){}acknowledgeDataEvent(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(r){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(r||void 0),this._pty.setDimensions&&r&&this._pty.setDimensions(r),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=w;let E=1,d=class extends I.Disposable{constructor(r,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this._onDidOpenTerminal=new g.Emitter,this._onDidChangeActiveTerminal=new g.Emitter,this._onDidChangeTerminalDimensions=new g.Emitter,this._proxy=n.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(r),this._register({dispose:()=>{for(const[a,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(r=>r.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(r){return(r?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(r,n){const a=new S(this._proxy,(0,p.generateUuid)(),r,r.name),f=new w(r.pty);return a.createExtensionTerminal(n?.isSplitTerminal,n?.target,t(r.iconPath)).then(m=>{const b=this._setupExtHostProcessListeners(m,f);this._terminalProcessDisposables[m]=b}),this._terminals.push(a),a.value}attachPtyToTerminal(r,n){if(!this._getTerminalById(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const f=new w(n),m=this._setupExtHostProcessListeners(r,f);this._terminalProcessDisposables[r]=m}async $acceptActiveTerminalChanged(r){const n=this._activeTerminal;if(r===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const a=this._getTerminalById(r);a&&(this._activeTerminal=a,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(r,n){const a=this._getTerminalById(r);a&&this._onDidWriteTerminalData.fire({terminal:a.value,data:n})}async $acceptTerminalDimensions(r,n,a){const f=this._getTerminalById(r);f&&f.setDimensions(n,a)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(r,n,a){this._terminalProcesses.get(r)?.resize(n,a)}async $acceptTerminalTitleChange(r,n){const a=this._getTerminalById(r);a&&(a.name=n)}async $acceptTerminalClosed(r,n){const a=this._getTerminalObjectIndexById(this._terminals,r);if(a!==null){const f=this._terminals.splice(a,1)[0];f.setExitCode(n),this._onDidCloseTerminal.fire(f.value)}}$acceptTerminalOpened(r,n,a,f){if(n){const _=this._getTerminalObjectIndexById(this._terminals,n);if(_!==null){this._terminals[_]._id=r,this._onDidOpenTerminal.fire(this.terminals[_]),this._terminals[_].isOpen=!0;return}}const m={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:y.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},b=new S(this._proxy,r,m,a);this._terminals.push(b),this._onDidOpenTerminal.fire(b.value),b.isOpen=!0}async $acceptTerminalProcessId(r,n){const a=this._getTerminalById(r);a&&a._setProcessId(n)}async $startExtensionTerminal(r,n){const a=this._getTerminalById(r);if(!a)return{message:(0,C.localize)(0,null,r)};a.isOpen||await new Promise(m=>{const b=this.onDidOpenTerminal(async _=>{_===a.value&&(b.dispose(),m())})});const f=this._terminalProcesses.get(r);f?f.startSendingEvents(n):this._extensionTerminalAwaitingStart[r]={initialDimensions:n}}_setupExtHostProcessListeners(r,n){const a=new I.DisposableStore;a.add(n.onProcessReady(m=>this._proxy.$sendProcessReady(r,m.pid,m.cwd))),a.add(n.onProcessTitleChanged(m=>this._proxy.$sendProcessTitle(r,m))),this._bufferer.startBuffering(r,n.onProcessData),a.add(n.onProcessExit(m=>this._onProcessExit(r,m))),n.onProcessOverrideDimensions&&a.add(n.onProcessOverrideDimensions(m=>this._proxy.$sendOverrideDimensions(r,m))),this._terminalProcesses.set(r,n);const f=this._extensionTerminalAwaitingStart[r];return f&&n instanceof w&&(n.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[r]),a}$acceptProcessAckDataEvent(r,n){this._terminalProcesses.get(r)?.acknowledgeDataEvent(n)}$acceptProcessInput(r,n){this._terminalProcesses.get(r)?.input(n)}$acceptProcessResize(r,n,a){try{this._terminalProcesses.get(r)?.resize(n,a)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(r,n){this._terminalProcesses.get(r)?.shutdown(n)}$acceptProcessRequestInitialCwd(r){this._terminalProcesses.get(r)?.getInitialCwd().then(n=>this._proxy.$sendProcessInitialCwd(r,n))}$acceptProcessRequestCwd(r){this._terminalProcesses.get(r)?.getCwd().then(n=>this._proxy.$sendProcessCwd(r,n))}$acceptProcessRequestLatency(r){return r}registerLinkProvider(r){return this._linkProviders.add(r),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(r),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(r,n,a){if(this._profileProviders.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this._profileProviders.set(n,a),this._proxy.$registerProfileProvider(n,r.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(n),this._proxy.$unregisterProfileProvider(n)})}async $createContributedProfileTerminal(r,n){const a=new u.CancellationTokenSource().token,f=await this._profileProviders.get(r)?.provideTerminalProfile(a);if(!a.isCancellationRequested){if(!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,n);return}this.createTerminalFromOptions(f.options,n)}}async $provideLinks(r,n){const a=this._getTerminalById(r);if(!a)return[];this._terminalLinkCache.delete(r);const f=this._terminalLinkCancellationSource.get(r);f&&f.dispose(!0);const m=new u.CancellationTokenSource;this._terminalLinkCancellationSource.set(r,m);const b=[],_={terminal:a.value,line:n},o=[];for(const $ of this._linkProviders)o.push(new Promise(async W=>{m.token.onCancellationRequested(()=>W({provider:$,links:[]}));const Q=await $.provideTerminalLinks(_,m.token)||[];m.token.isCancellationRequested||W({provider:$,links:Q})}));const A=await Promise.all(o);if(m.token.isCancellationRequested)return[];const F=new Map;for(const $ of A)$&&$.links.length>0&&b.push(...$.links.map(W=>{const Q={id:E++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return F.set(Q.id,{provider:$.provider,link:W}),Q}));return this._terminalLinkCache.set(r,F),b}$activateLink(r,n){const a=this._terminalLinkCache.get(r)?.get(n);!a||a.provider.handleTerminalLink(a.link)}_onProcessExit(r,n){this._bufferer.stopBuffering(r),this._terminalProcesses.delete(r),delete this._extensionTerminalAwaitingStart[r];const a=this._terminalProcessDisposables[r];a&&(a.dispose(),delete this._terminalProcessDisposables[r]),this._proxy.$sendProcessExit(r,n)}_getTerminalById(r){return this._getTerminalObjectById(this._terminals,r)}_getTerminalObjectById(r,n){const a=this._getTerminalObjectIndexById(r,n);return a!==null?r[a]:null}_getTerminalObjectIndexById(r,n){let a=null;return r.some((f,m)=>f._id===n?(a=m,!0):!1),a}getEnvironmentVariableCollection(r){let n=this._environmentVariableCollections.get(r.identifier.value);return n||(n=new h,this._setEnvironmentVariableCollection(r.identifier.value,n)),n}_syncEnvironmentVariableCollection(r,n){const a=(0,P.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(r,n.persistent,a.length===0?void 0:a)}$initEnvironmentVariableCollections(r){r.forEach(n=>{const a=n[0],f=new h(n[1]);this._setEnvironmentVariableCollection(a,f)})}$acceptDefaultProfile(r,n){this._defaultProfile=r,this._defaultAutomationProfile=n}_setEnvironmentVariableCollection(r,n){this._environmentVariableCollections.set(r,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(r,n)})}};d=je([He(1,T.IExtHostRpcService)],d),e.BaseExtHostTerminalService=d;class h{constructor(r){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(r)}get persistent(){return this._persistent}set persistent(r){this._persistent=r,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(r,n){this._setIfDiffers(r,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(r,n){this._setIfDiffers(r,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(r,n){this._setIfDiffers(r,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(r,n){const a=this.map.get(r);(!a||a.value!==n.value||a.type!==n.type)&&(this.map.set(r,n),this._onDidChangeCollection.fire())}get(r){return this.map.get(r)}forEach(r,n){this.map.forEach((a,f)=>r.call(n,f,a,this))}delete(r){this.map.delete(r),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=h;let v=class extends d{constructor(r){super(!1,r)}createTerminal(r,n,a){throw new i.NotSupportedError}createTerminalFromOptions(r,n){throw new i.NotSupportedError}};v=je([He(0,T.IExtHostRpcService)],v),e.WorkerExtHostTerminalService=v;function t(s){if(!!s)return typeof s=="string"||!("id"in s)?s:{id:s.id,color:s.color}}});var it=this&&this.__classPrivateFieldSet||function(X,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,g):k?k.value=g:e.set(X,g),g},xe=this&&this.__classPrivateFieldGet||function(X,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(X):R?R.value:e.get(X)};define(he[244],fe([0,1,18,17,22,21,3,70,54,6,25,14,32,5,13,16,7,216,122]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c,S,w,E){"use strict";var d,h,v,t,s,r;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let n=class{constructor(W,Q){this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=W.getProxy(p.MainContext.MainThreadTesting),this.observer=new F(this.proxy),this.runTracker=new f(this.proxy),Q.registerArgumentProcessor({processArgument:H=>H?.$mid===13?c.TestItem.toItemFromContext(H):H})}createTestController(W){const Q=new C.DisposableStore,H=Q.add(new w.SingleUseTestCollection(W)),N=Q.add(new R.RunOnceScheduler(()=>H.expand(H.root.id,0),0)),x={root:H.root,get id(){return W},createTestRun:(L,G,M=!0)=>this.runTracker.createTestRun(W,L,G,M),createTestItem(L,G,M,O,B){if(!(M instanceof S.TestItemImpl))throw new Error(`The "parent" passed in for TestItem ${L} is invalid`);return new S.TestItemImpl(L,G,O,B,M)},set resolveChildrenHandler(L){H.resolveHandler=L,L&&N.schedule()},get resolveChildrenHandler(){return H.resolveHandler},dispose:()=>{Q.dispose()}};return this.proxy.$registerTestController(W),Q.add((0,C.toDisposable)(()=>this.proxy.$unregisterTestController(W))),this.controllers.set(W,{controller:x,collection:H}),Q.add((0,C.toDisposable)(()=>this.controllers.delete(W))),Q.add(H.onDidGenerateDiff(L=>this.proxy.$publishDiff(W,L))),x}createTestObserver(){return this.observer.checkout()}async runTests(W,Q=y.CancellationToken.None){const H=N=>N.map(this.getInternalTestForReference,this).filter(P.isDefined).map(x=>({controllerId:x.controllerId,testId:x.item.extId}));await this.proxy.$runTests({exclude:W.exclude?H(W.exclude).map(N=>N.testId):void 0,tests:H(W.tests),debug:W.debug},Q)}$provideFileCoverage(W,Q,H){return D.Iterable.find(this.runTracker.trackers,N=>N.id===W)?.getCoverage(Q)?.provideFileCoverage(H)??Promise.resolve([])}$resolveFileCoverage(W,Q,H,N){return D.Iterable.find(this.runTracker.trackers,x=>x.id===W)?.getCoverage(Q)?.resolveFileCoverage(H,N)??Promise.resolve([])}$publishTestResults(W){this.results=Object.freeze(W.map(Q=>(0,i.deepFreeze)(c.TestResults.to(Q))).concat(this.results).sort((Q,H)=>H.completedAt-Q.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:W,testId:Q},H){const N=this.controllers.get(W)?.collection;N&&(await N.expand(Q,H<0?Infinity:H),N.flushDiff())}$acceptDiff(W){this.observer.applyDiff(W)}async $runControllerTests(W,Q){const H=this.controllers.get(W.controllerId);if(!H)return;const{controller:N,collection:x}=H,L=W.testIds.map(B=>x.tree.get(B)).filter(P.isDefined),G=W.excludeExtIds.map(B=>H.collection.tree.get(B)).filter(P.isDefined).filter(B=>L.some(z=>x.tree.comparePositions(z,B)===1));if(!L.length)return;const M={tests:L.map(B=>B.actual),exclude:G.map(B=>B.actual),debug:W.debug},O=this.runTracker.prepareForMainThreadTestRun(M,m.fromInternal(W),Q);try{await N.runHandler?.(M,Q)}finally{O.isRunning&&!Q.isCancellationRequested&&await T.Event.toPromise(O.onEnd),this.runTracker.cancelRunById(W.runId)}}$cancelExtensionTestRun(W){W===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(W)}getInternalTestForReference(W){return(0,g.mapFind)(this.controllers.values(),({collection:Q})=>Q.getTestByReference(W))??this.observer.getMirroredTestDataByReference(W)}};n=je([He(0,l.IExtHostRpcService)],n),e.ExtHostTesting=n;class a extends C.Disposable{constructor(W,Q,H){super();this.dto=W,this.proxy=Q,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(H)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:N}of this.tasks.values())N.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(W){return this.tasks.get(W)?.coverage}createRun(W){const Q=(0,u.generateUuid)(),H=new b(this.proxy,this.dto.id,Q),N=new _(W,this.cts.token,Q,H,this.dto,this.sharedTestIds,this.proxy,()=>{this.tasks.delete(N.taskId),this.isRunning||this.dispose()});return this.tasks.set(N.taskId,{run:N,coverage:H}),N}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}}class f{constructor(W){this.proxy=W,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(W,Q,H){return this.getTracker(W,Q,H)}cancelRunById(W){for(const Q of this.tracked.values())if(Q.id===W){Q.dispose();return}}cancelAllRuns(){for(const W of this.tracked.values())W.dispose()}createTestRun(W,Q,H,N){const x=this.tracked.get(Q);if(x)return x.createRun(H);const L=m.fromPublic(W,Q);this.proxy.$startedExtensionTestRun({debug:Q.debug,exclude:Q.exclude?.map(M=>M.id)??[],id:L.id,tests:Q.tests.map(M=>M.id),persist:N});const G=this.getTracker(Q,L);return G.onEnd(()=>this.proxy.$finishedExtensionTestRun(L.id)),G.createRun(H)}getTracker(W,Q,H){const N=new a(Q,this.proxy,H);return this.tracked.set(W,N),N.onEnd(()=>this.tracked.delete(W)),N}}e.TestRunCoordinator=f;class m{constructor(W,Q,H,N){this.controllerId=W,this.id=Q,this.include=H,this.exclude=N}static fromPublic(W,Q){return new m(W,(0,u.generateUuid)(),new Set(Q.tests.map(H=>H.id)),new Set(Q.exclude?.map(H=>H.id)??D.Iterable.empty()))}static fromInternal(W){return new m(W.controllerId,W.runId,new Set(W.testIds),new Set(W.excludeExtIds))}isIncluded(W){for(let Q=W;Q;Q=Q.parent){if(this.include.has(Q.id))return!0;if(this.exclude.has(Q.id))return!1}return!1}}e.TestRunDto=m;class b{constructor(W,Q,H){this.proxy=W,this.runId=Q,this.taskId=H}set coverageProvider(W){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!W||(this._coverageProvider=W,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(W){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(W))());try{return(await this.fileCoverage)?.map(c.TestCoverage.fromFile)??[]}catch(Q){throw this.fileCoverage=void 0,Q}}async resolveFileCoverage(W,Q){const H=await this.fileCoverage;let N=H?.[W];return!this._coverageProvider||!H||!N?[]:(N.detailedCoverage||(N=H[W]=await this._coverageProvider.resolveFileCoverage?.(N,Q)??N),N.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class _{constructor(W,Q,H,N,x,L,G,M){this.name=W,this.token=Q,this.taskId=H,d.set(this,void 0),h.set(this,void 0),v.set(this,void 0),t.set(this,void 0),s.set(this,void 0),r.set(this,!1),it(this,t,M,"f"),it(this,d,G,"f"),it(this,h,x,"f"),it(this,s,N,"f"),it(this,v,L,"f"),G.$startedTestRunTask(x.id,{id:this.taskId,name:W,running:!0})}set coverageProvider(W){xe(this,s,"f").coverageProvider=W}get coverageProvider(){return xe(this,s,"f").coverageProvider}setState(W,Q,H){!xe(this,r,"f")&&xe(this,h,"f").isIncluded(W)&&(this.ensureTestIsKnown(W),xe(this,d,"f").$updateTestStateInRun(xe(this,h,"f").id,this.taskId,W.id,Q,H))}appendMessage(W,Q){!xe(this,r,"f")&&xe(this,h,"f").isIncluded(W)&&(this.ensureTestIsKnown(W),xe(this,d,"f").$appendTestMessageInRun(xe(this,h,"f").id,this.taskId,W.id,c.TestMessage.from(Q)))}appendOutput(W){xe(this,r,"f")||xe(this,d,"f").$appendOutputToRun(xe(this,h,"f").id,this.taskId,k.VSBuffer.fromString(W))}end(){xe(this,r,"f")||(it(this,r,!0,"f"),xe(this,d,"f").$finishedTestRunTask(xe(this,h,"f").id,this.taskId),xe(this,t,"f").call(this))}ensureTestIsKnown(W){const Q=xe(this,v,"f");if(Q.has(W.id))return;const H=[];for(;H.unshift(c.TestItem.from(W)),!(Q.has(W.id)||(Q.add(W.id),!W.parent));)W=W.parent;xe(this,d,"f").$addTestsToRun(xe(this,h,"f").controllerId,xe(this,h,"f").id,H)}}d=new WeakMap,h=new WeakMap,v=new WeakMap,t=new WeakMap,s=new WeakMap,r=new WeakMap;class o extends E.IncrementalChangeCollector{constructor(W){super();this.emitter=W,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(W){this.added.add(W)}update(W){Object.assign(W.revived,c.TestItem.toPlain(W.item)),this.added.has(W)||this.updated.add(W)}remove(W){if(this.added.has(W)){this.added.delete(W);return}if(this.updated.delete(W),W.parent&&this.alreadyRemoved.has(W.parent)){this.alreadyRemoved.add(W.item.extId);return}this.removed.add(W)}getChangeEvent(){const{added:W,updated:Q,removed:H}=this;return{get added(){return[...W].map(N=>N.revived)},get updated(){return[...Q].map(N=>N.revived)},get removed(){return[...H].map(N=>N.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class A extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(W){return this.items.get(W)}getMirroredTestDataByReference(W){return this.items.get(W.id)}createItem(W,Q){return{...W,revived:c.TestItem.toPlain(W.item),depth:Q?Q.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=A;class F{constructor(W){this.proxy=W}checkout(){this.current||(this.current=this.createObserverData());const W=this.current;return W.observers++,{onDidChangeTest:W.tests.onDidChangeTests,get tests(){return[...W.tests.rootTests].map(Q=>Q.revived)},dispose:(0,I.once)(()=>{--W.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(W){return this.current?.tests.getMirroredTestDataByReference(W)}applyDiff(W){this.current?.tests.apply(W)}createObserverData(){const W=new A;return this.proxy.$subscribeToDiffs(),{observers:0,tests:W}}}}),define(he[245],fe([0,1,3,18,5,125,16,7]),function(X,e,g,R,k,y,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(i,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(u=>this._onDidChangeVisibleTextEditors.fire(u)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(u=>this._onDidChangeActiveTextEditor.fire(u))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const P=this._extHostDocumentsAndEditors.allEditors();return i?P:P.map(u=>u.value)}async showTextDocument(i,P,u){let p;typeof P=="number"?p={position:T.ViewColumn.from(P),preserveFocus:u}:typeof P=="object"?p={position:T.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?T.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:p={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(i.uri,p),c=l&&this._extHostDocumentsAndEditors.getEditor(l);if(c)return c.value;throw l?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,P){return new y.TextEditorDecorationType(this._proxy,i,P).value}$acceptEditorPropertiesChanged(i,P){const u=this._extHostDocumentsAndEditors.getEditor(i);if(!u)throw new Error("unknown text editor");if(P.options&&u._acceptOptions(P.options),P.selections){const p=P.selections.selections.map(T.Selection.to);u._acceptSelections(p)}if(P.visibleRanges){const p=R.coalesce(P.visibleRanges.map(T.Range.to));u._acceptVisibleRanges(p)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:u.value,options:{...P.options,lineNumbers:T.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const p=I.TextEditorSelectionChangeKind.fromValue(P.selections.source),l=P.selections.selections.map(T.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:u.value,selections:l,kind:p})}if(P.visibleRanges){const p=R.coalesce(P.visibleRanges.map(T.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:u.value,visibleRanges:p})}}$acceptEditorPositionData(i){for(const P in i){const u=this._extHostDocumentsAndEditors.getEditor(P);if(!u)throw new Error("Unknown text editor");const p=T.ViewColumn.to(i[P]);u.value.viewColumn!==p&&(u._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:u.value,viewColumn:p}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=D}),define(he[246],fe([0,1,2,4,5,6,7]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class I{constructor(i,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(k.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===11){const p=u.uri===void 0?void 0:g.URI.revive(u.uri);return this._itemsBySourceAndUriMap.get(u.source)?.get(D(p))?.get(u.handle)}return u}})}async $getTimeline(i,P,u,p,l){return this._providers.get(i)?.provideTimeline(g.URI.revive(P),u,p,l)}registerTimelineProvider(i,P,u,p){const l=new y.DisposableStore,c=this.convertTimelineItem(P.id,p,l).bind(this);let S;P.onDidChange&&(S=P.onDidChange(E=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...E,id:P.id}),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...P,scheme:i,onDidChange:void 0,async provideTimeline(E,d,h,v){v?.resetCache&&(l.clear(),w.get(P.id)?.clear());const t=await P.provideTimeline(E,d,h);if(t==null)return;const s=c(E,v);return{...t,source:P.id,items:t.items.map(s)}},dispose(){for(const E of w.values())E.get(P.id)?.clear();S?.dispose(),l.dispose()}})}convertTimelineItem(i,P,u){return(p,l)=>{let c;if(l?.cacheResults){let S=this._itemsBySourceAndUriMap.get(i);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(i,S));const w=D(p);c=S.get(w),c===void 0&&(c=new Map,S.set(w,c))}return S=>{const{iconPath:w,...E}=S,d=`${i}|${S.id??S.timestamp}`;c?.set(d,S);let h,v,t;return S.iconPath&&(w instanceof T.ThemeIcon?t={id:w.id,color:w.color}:g.URI.isUri(w)?(h=w,v=w):{light:h,dark:v}=w),{...E,id:E.id??void 0,handle:d,source:i,command:S.command?P.toInternal(S.command,u):void 0,icon:h,iconDark:v,themeIcon:t,accessibilityInformation:S.accessibilityInformation}}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,y.toDisposable)(()=>{for(const u of this._itemsBySourceAndUriMap.values())u.get(i.id)?.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=I;function D(C){return C?.toString()}}),define(he[247],fe([0,1,6,10,2,5]),function(X,e,g,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class T{constructor(D){this._openers=new Map,this._proxy=D.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,C,i,P){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const u=P.schemes.find(p=>!T.supportedSchemes.has(p));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,i),this._proxy.$registerUriOpener(C,P.schemes,D,P.label),(0,g.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(D,C,i){const P=this._openers.get(D);if(!P)throw new Error(`Unknown opener with id: ${D}`);const u=k.URI.revive(C);return P.canOpenExternalUri(u,i)}async $openUri(D,C,i){const P=this._openers.get(D);if(!P)throw new Error(`Unknown opener id: '${D}'`);return P.openExternalUri(k.URI.revive(C.resolvedUri),{sourceUri:k.URI.revive(C.sourceUri)},i)}}e.ExtHostUriOpeners=T,T.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(he[248],fe([0,1,5,2,6,15,26]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(C,i){if(this.handles.has(T.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const P=I.HandlePool++;return this.handles.add(T.ExtensionIdentifier.toKey(C)),this.handlers.set(P,i),this._proxy.$registerUriHandler(P,C),(0,k.toDisposable)(()=>{this.handles.delete(T.ExtensionIdentifier.toKey(C)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(C,i){const P=this.handlers.get(C);if(!P)return Promise.resolve(void 0);try{P.handleUri(R.URI.revive(i))}catch(u){(0,y.onUnexpectedError)(u)}return Promise.resolve(void 0)}async createAppUri(C){return R.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=I,I.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(X,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,g):k?k.value=g:e.set(X,g),g},xe=this&&this.__classPrivateFieldGet||function(X,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(X):R?R.value:e.get(X)};define(he[64],fe([0,1,3,2,174,201,85,5]),function(X,e,g,R,k,y,T,I){"use strict";var D,C,i,P,u,p,l,c,S,w,E,d;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class h{constructor(m,b,_,o,A,F,$){D.set(this,void 0),C.set(this,void 0),i.set(this,void 0),P.set(this,void 0),u.set(this,void 0),p.set(this,void 0),l.set(this,""),c.set(this,void 0),S.set(this,!1),w.set(this,!1),E.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new g.Emitter),this._onDidDispose=xe(this,d,"f").event,it(this,D,m,"f"),it(this,C,b,"f"),it(this,c,_,"f"),it(this,P,o,"f"),it(this,u,A,"f"),it(this,p,F,"f"),it(this,E,v(F),"f"),it(this,i,$,"f")}dispose(){it(this,S,!0,"f"),xe(this,d,"f").fire(),xe(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return it(this,w,!0,"f"),(0,T.asWebviewUri)(m,xe(this,P,"f").remote)}get cspSource(){return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),xe(this,l,"f")}set html(m){this.assertNotDisposed(),xe(this,l,"f")!==m&&(it(this,l,m,"f"),!xe(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(it(this,w,!0,"f"),xe(this,i,"f").report("Webview vscode-resource: uris",xe(this,p,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),xe(this,C,"f").$setHtml(xe(this,D,"f"),m))}get options(){return this.assertNotDisposed(),xe(this,c,"f")}set options(m){this.assertNotDisposed(),xe(this,C,"f").$setOptions(xe(this,D,"f"),r(xe(this,p,"f"),xe(this,u,"f"),m)),it(this,c,m,"f")}async postMessage(m){if(xe(this,S,"f"))return!1;const b=(0,y.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:xe(this,E,"f")});return xe(this,C,"f").$postMessage(xe(this,D,"f"),b.message,...b.buffers)}assertNotDisposed(){if(xe(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=h,D=new WeakMap,C=new WeakMap,i=new WeakMap,P=new WeakMap,u=new WeakMap,p=new WeakMap,l=new WeakMap,c=new WeakMap,S=new WeakMap,w=new WeakMap,E=new WeakMap,d=new WeakMap;function v(f){try{const m=(0,k.normalizeVersion)((0,k.parseVersion)(f.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;class t{constructor(m,b,_,o,A){this.initData=b,this.workspace=_,this._logService=o,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=m.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(m,b,..._){const o=this.getWebview(m);if(o){const{message:A}=(0,y.deserializeWebviewMessage)(b,_);o._onMessageEmitter.fire(A)}}$onMissingCsp(m,b){this._logService.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,b,_){const o=new h(m,this._webviewProxy,n(b),this.initData,this.workspace,_,this._deprecationService);return this._webviews.set(m,o),o._onDidDispose(()=>{this._webviews.delete(m)}),o}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=t;function s(f){return{id:f.identifier,location:f.extensionLocation}}e.toExtensionData=s;function r(f,m,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||a(f,m)}}e.serializeWebviewOptions=r;function n(f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots?.map(m=>R.URI.from(m))}}e.reviveOptions=n;function a(f,m){return[...(m?.getWorkspaceFolders()||[]).map(b=>b.uri),f.extensionLocation]}}),define(he[249],fe([0,1,21,74,6,10,24,2,16,64,84,5,7]),function(X,e,g,R,k,y,T,I,D,C,i,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(t,s){this.document=t,this._storagePath=s,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,s){await this.getEdit(t).undo(),s||this.disposeBackup()}async redo(t,s){await this.getEdit(t).redo(),s||this.disposeBackup()}disposeEdits(t){for(const s of t)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=h(this.document.uri)+this._backupCounter++;return(0,T.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const s=this._edits.get(t,0);if(!s)throw new Error("No edit found");return s}}class l{constructor(){this._documents=new Map}get(t,s){return this._documents.get(this.key(t,s))}add(t,s,r){const n=this.key(t,s.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${s.uri}`);const a=new p(s,r);return this._documents.set(n,a),a}delete(t,s){const r=this.key(t,s.uri);this._documents.delete(r)}key(t,s){return`${t}@@@${s}`}}var c;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(c||(c={}));class S{constructor(){this._providers=new Map}addTextProvider(t,s,r){return this.add(0,t,s,r)}addCustomProvider(t,s,r){return this.add(1,t,s,r)}get(t){return this._providers.get(t)}add(t,s,r,n){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:t,extension:r,provider:n}),new u.Disposable(()=>this._providers.delete(s))}}class w{constructor(t,s,r,n,a){this._extHostDocuments=s,this._extensionStoragePaths=r,this._extHostWebview=n,this._extHostWebviewPanels=a,this._editorProviders=new S,this._documents=new l,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,s,r,n){const a=new k.DisposableStore;return E(r)?(a.add(this._editorProviders.addTextProvider(s,t,r)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(t),s,n.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(t))):(a.add(this._editorProviders.addCustomProvider(s,t,r)),this.supportEditing(r)&&a.add(r.onDidChangeCustomDocument(f=>{const m=this.getCustomDocumentEntry(s,f.document.uri);if(d(f)){const b=m.addEdit(f);this._proxy.$onDidEdit(f.document.uri,s,b,f.label)}else this._proxy.$onContentChange(f.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(t),s,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(t))),u.Disposable.from(a,new u.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(t,s,r,n,a){const f=this._editorProviders.get(s);if(!f)throw new Error(`No provider found for '${s}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${s}'`);const m=I.URI.revive(t),b=await f.provider.openCustomDocument(m,{backupId:r,untitledDocumentData:n?.buffer},a);let _;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(_=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(s,b,_),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(t,s){const r=this._editorProviders.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${s}'`);const n=I.URI.revive(t),{document:a}=this.getCustomDocumentEntry(s,n);this._documents.delete(s,a),a.dispose()}async $resolveWebviewEditor(t,s,r,n,a,f){const m=this._editorProviders.get(r);if(!m)throw new Error(`No provider found for '${r}'`);const b=D.ViewColumn.to(a),_=this._extHostWebview.createNewWebview(s,n.webviewOptions,m.extension),o=this._extHostWebviewPanels.createNewWebviewPanel(s,r,n.title,b,n.panelOptions,_),A=I.URI.revive(t);switch(m.type){case 1:{const{document:F}=this.getCustomDocumentEntry(r,A);return m.provider.resolveCustomEditor(F,o,f)}case 0:{const F=this._extHostDocuments.getDocument(A);return m.provider.resolveCustomTextEditor(F,o,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,s,r){this.getCustomDocumentEntry(s,t).disposeEdits(r)}async $onMoveCustomEditor(t,s,r){const n=this._editorProviders.get(r);if(!n)throw new Error(`No provider found for '${r}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const f=I.URI.revive(s),m=this._extHostDocuments.getDocument(f);await n.provider.moveCustomTextEditor(m,a,g.CancellationToken.None)}async $undo(t,s,r,n){return this.getCustomDocumentEntry(s,t).undo(r,n)}async $redo(t,s,r,n){return this.getCustomDocumentEntry(s,t).redo(r,n)}async $revert(t,s,r){const n=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).revertCustomDocument(n.document,r),n.disposeBackup()}async $onSave(t,s,r){const n=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).saveCustomDocument(n.document,r),n.disposeBackup()}async $onSaveAs(t,s,r,n){const a=this.getCustomDocumentEntry(s,t);return this.getCustomEditorProvider(s).saveCustomDocumentAs(a.document,I.URI.revive(r),n)}async $backup(t,s,r){const n=this.getCustomDocumentEntry(s,t),f=await this.getCustomEditorProvider(s).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},r);return n.updateBackup(f),f.id}getCustomDocumentEntry(t,s){const r=this._documents.get(t,I.URI.revive(s));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(t){const r=this._editorProviders.get(t)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function E(v){return typeof v.resolveCustomTextEditor=="function"}function d(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function h(v){const t=v.scheme===y.Schemas.file||v.scheme===y.Schemas.untitled?v.fsPath:v.toString();return(0,R.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(X,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,g):k?k.value=g:e.set(X,g),g},xe=this&&this.__classPrivateFieldGet||function(X,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(X):R?R.value:e.get(X)};define(he[250],fe([0,1,3,6,2,32,16,64,5,7]),function(X,e,g,R,k,y,T,I,D,C){"use strict";var i,P,u,p,l,c,S,w,E,d,h,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends R.Disposable{constructor(f,m,b,_,o,A,F){super();i.set(this,void 0),P.set(this,void 0),u.set(this,void 0),p.set(this,void 0),l.set(this,void 0),c.set(this,void 0),S.set(this,void 0),w.set(this,void 0),E.set(this,!0),d.set(this,!0),h.set(this,!1),v.set(this,this._register(new g.Emitter)),this.onDidDispose=xe(this,v,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=xe(this,t,"f").event,it(this,i,f,"f"),it(this,P,m,"f"),it(this,u,b,"f"),it(this,l,A,"f"),it(this,w,o,"f"),it(this,c,_,"f"),it(this,p,F,"f")}dispose(){xe(this,h,"f")||(it(this,h,!0,"f"),xe(this,v,"f").fire(),xe(this,P,"f").$disposeWebview(xe(this,i,"f")),xe(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),xe(this,p,"f")}get viewType(){return this.assertNotDisposed(),xe(this,u,"f")}get title(){return this.assertNotDisposed(),xe(this,c,"f")}set title(f){this.assertNotDisposed(),xe(this,c,"f")!==f&&(it(this,c,f,"f"),xe(this,P,"f").$setTitle(xe(this,i,"f"),f))}get iconPath(){return this.assertNotDisposed(),xe(this,S,"f")}set iconPath(f){this.assertNotDisposed(),xe(this,S,"f")!==f&&(it(this,S,f,"f"),xe(this,P,"f").$setIconPath(xe(this,i,"f"),k.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return xe(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof xe(this,w,"f")=="number"&&xe(this,w,"f")<0))return xe(this,w,"f")}get active(){return this.assertNotDisposed(),xe(this,d,"f")}get visible(){return this.assertNotDisposed(),xe(this,E,"f")}_updateViewState(f){xe(this,h,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(it(this,d,f.active,"f"),it(this,E,f.visible,"f"),it(this,w,f.viewColumn,"f"),xe(this,t,"f").fire({webviewPanel:this}))}reveal(f,m){this.assertNotDisposed(),xe(this,P,"f").$reveal(xe(this,i,"f"),{viewColumn:f?T.ViewColumn.from(f):void 0,preserveFocus:!!m})}assertNotDisposed(){if(xe(this,h,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,P=new WeakMap,u=new WeakMap,p=new WeakMap,l=new WeakMap,c=new WeakMap,S=new WeakMap,w=new WeakMap,E=new WeakMap,d=new WeakMap,h=new WeakMap,v=new WeakMap,t=new WeakMap;class r{constructor(f,m,b){this.webviews=m,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,y.generateUuid)()}createWebviewPanel(f,m,b,_,o={}){const A=typeof _=="object"?_.viewColumn:_,F={viewColumn:T.ViewColumn.from(A),preserveFocus:typeof _=="object"&&!!_.preserveFocus},$=(0,I.shouldSerializeBuffersForPostMessage)(f),W=r.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(f),W,m,{title:b,panelOptions:n(o),webviewOptions:(0,I.serializeWebviewOptions)(f,this.workspace,o),serializeBuffersForPostMessage:$},F);const Q=this.webviews.createNewWebview(W,o,f);return this.createNewWebviewPanel(W,m,b,A,o,Q)}$onDidChangeWebviewPanelViewStates(f){const m=Object.keys(f);m.sort((b,_)=>{const o=f[b],A=f[_];return o.active?1:A.active?-1:+o.visible-+A.visible});for(const b of m){const _=this.getWebviewPanel(b);if(!_)continue;const o=f[b];_._updateViewState({active:o.active,visible:o.visible,viewColumn:T.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,m,b){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:b,extension:f}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(f)}),new C.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(f,m,b,_){const o=this._serializers.get(m);if(!o)throw new Error(`No serializer found for '${m}'`);const{serializer:A,extension:F}=o,$=this.webviews.createNewWebview(f,b.webviewOptions,F),W=this.createNewWebviewPanel(f,m,b.title,_,b.panelOptions,$);await A.deserializeWebviewPanel(W,b.state)}createNewWebviewPanel(f,m,b,_,o,A){const F=new s(f,this._proxy,m,b,_,o,A);return this._webviewPanels.set(f,F),F}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=r;function n(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(X,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,g):k?k.value=g:e.set(X,g),g},xe=this&&this.__classPrivateFieldGet||function(X,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(X):R?R.value:e.get(X)};define(he[251],fe([0,1,3,6,64,5,7]),function(X,e,g,R,k,y,T){"use strict";var I,D,C,i,P,u,p,l,c,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends R.Disposable{constructor(h,v,t,s,r,n){super();I.set(this,void 0),D.set(this,void 0),C.set(this,void 0),i.set(this,void 0),P.set(this,!1),u.set(this,void 0),p.set(this,void 0),l.set(this,void 0),c.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=xe(this,c,"f").event,S.set(this,this._register(new g.Emitter)),this.onDidDispose=xe(this,S,"f").event,it(this,C,t,"f"),it(this,p,s,"f"),it(this,I,h,"f"),it(this,D,v,"f"),it(this,i,r,"f"),it(this,u,n,"f")}dispose(){xe(this,P,"f")||(it(this,P,!0,"f"),xe(this,S,"f").fire(),xe(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),xe(this,p,"f")}set title(h){this.assertNotDisposed(),xe(this,p,"f")!==h&&(it(this,p,h,"f"),xe(this,D,"f").$setWebviewViewTitle(xe(this,I,"f"),h))}get description(){return this.assertNotDisposed(),xe(this,l,"f")}set description(h){this.assertNotDisposed(),xe(this,l,"f")!==h&&(it(this,l,h,"f"),xe(this,D,"f").$setWebviewViewDescription(xe(this,I,"f"),h))}get visible(){return xe(this,u,"f")}get webview(){return xe(this,i,"f")}get viewType(){return xe(this,C,"f")}_setVisible(h){h===xe(this,u,"f")||xe(this,P,"f")||(it(this,u,h,"f"),xe(this,c,"f").fire())}show(h){this.assertNotDisposed(),xe(this,D,"f").$show(xe(this,I,"f"),!!h)}assertNotDisposed(){if(xe(this,P,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,D=new WeakMap,C=new WeakMap,i=new WeakMap,P=new WeakMap,u=new WeakMap,p=new WeakMap,l=new WeakMap,c=new WeakMap,S=new WeakMap;class E{constructor(h,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,v,t,s){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:h}),this._proxy.$registerWebviewViewProvider((0,k.toExtensionData)(h),v,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new T.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(h,v,t,s,r){const n=this._viewProviders.get(v);if(!n)throw new Error(`No view provider found for '${v}'`);const{provider:a,extension:f}=n,m=this._extHostWebview.createNewWebview(h,{},f),b=new w(h,this._proxy,v,t,m,!0);this._webviewViews.set(h,b),await a.resolveWebviewView(b,{state:s},r)}async $onDidChangeWebviewViewVisibility(h,v){this.getWebviewView(h)._setVisible(v)}async $disposeWebviewView(h){const v=this.getWebviewView(h);this._webviewViews.delete(h),v.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const v=this._webviewViews.get(h);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=E}),define(he[128],fe([0,1,3,5,2,10,8,4,13]),function(X,e,g,R,k,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class Hn{constructor(P){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Hn.InitialState,this._proxy=P.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(u=>this.$onDidChangeWindowFocus(u))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state={...this._state,focused:P},this._onDidChangeWindowState.fire(this._state))}openUri(P,u){let p;if(typeof P=="string"){p=P;try{P=k.URI.parse(P)}catch(l){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,T.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,p,u)}async asExternalUri(P,u){if((0,T.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this._proxy.$asExternalUri(P,u);return k.URI.from(p)}};C.InitialState={focused:!0},C=je([He(0,D.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(he[252],fe([0,1,9,101,32,50,6,5,2,13]),function(X,e,g,R,k,y,T,I,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends T.Disposable{constructor(u,p){super();const l=u.getProxy(I.MainContext.MainThreadDownloadService);p.registerCommand(!1,"_workbench.downloadResource",async c=>{const S=D.URI.file((0,g.join)((0,R.tmpdir)(),(0,k.generateUuid)()));return await l.$download(c,S),S})}};i=je([He(0,C.IExtHostRpcService),He(1,y.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(he[253],fe([0,1,2,9,147,28,62,27,13,6,12,112,41]),function(X,e,g,R,k,y,T,I,D,C,i,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class p{constructor(w,E,d){this.name=w,this.file=E,this.appender=d}static async create(w,E){const d=await(0,P.createRotatingLogger)(w,E,30*u.ByteSize.MB,1);return d.clearFormatters(),new p(w,E,d)}append(w){this.appender.critical(w)}flush(){this.appender.flush()}}class l extends T.AbstractExtHostOutputChannel{constructor(w,E,d,h){super(w,!1,g.URI.file(E.file),d,h);this._appender=E}append(w){super.append(w),this._appender.append(w),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(w,E){this._appender.flush(),super.show(w,E)}clear(){this._appender.flush(),super.clear()}}let c=class extends T.ExtHostOutputService{constructor(w,E,d){super(w);this.logService=E,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new C.MutableDisposable,this._logsLocation=d.logsLocation}$setVisibleChannel(w){if(w){const E=this._channels.get(w);E&&(this._visibleChannelDisposable.value=E.onDidAppend(()=>E.update()))}}createOutputChannel(w,E){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const d=this._doCreateOutChannel(w,E);return d.then(h=>h._id.then(v=>this._channels.set(v,h))),new T.LazyOutputChannel(w,d)}async _doCreateOutChannel(w,E){try{const d=(0,R.join)(this._logsLocation.fsPath,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await y.SymlinkSupport.existsDirectory(d)||await y.Promises.mkdir(d,{recursive:!0});const v=`${this._namePool++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=g.URI.file((0,R.join)(d,`${v}.log`)),s=await p.create(v,t.fsPath);return new l(w,s,E.identifier.value,this._proxy)}catch(d){return this.logService.error(d),new T.ExtHostPushOutputChannel(w,E.identifier.value,this._proxy)}}};c=je([He(0,D.IExtHostRpcService),He(1,i.ILogService),He(2,I.IExtHostInitDataService)],c),e.ExtHostOutputService2=c}),define(he[254],fe([0,1,45,285,2,63,6,10,17]),function(X,e,g,R,k,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class C extends y.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(v){const t=await super._getWorkspaceStorageURI(v);if(t.scheme!==I.Schemas.file)return t;const s=t.fsPath;let r=0;do{let n;r===0?n=s:n=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${r}`:`${s}-${r}`,await i(n);const a=R.join(n,"vscode.lock"),f=await l(this._logService,a,!1);if(f)return this._workspaceStorageLock=f,process.on("exit",()=>{f.dispose()}),k.URI.file(n);r++}while(r<10);return t}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=C;async function i(h){try{await g.promises.stat(h);return}catch{}try{await g.promises.mkdir(h,{recursive:!0})}catch{}}const P=1e3,u=10*60*1e3;class p extends T.Disposable{constructor(v,t){super();this.logService=v,this.filename=t,this._timer=this._register(new D.IntervalTimer),this._timer.cancelAndSet(async()=>{const s=await c(v,t);(!s||s.pid!==process.pid)&&(v.info(`Lock '${t}': The lock was lost unexpectedly.`),this._timer.cancel());try{await g.promises.utimes(t,new Date,new Date)}catch(r){v.error(r),v.info(`Lock '${t}': Could not update mtime.`)}},P)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch(v){}}async setWillRelease(v){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${v} ms.`);try{const t={pid:process.pid,willReleaseAt:Date.now()+v};await g.promises.writeFile(this.filename,JSON.stringify(t),{flag:"w"})}catch(t){this.logService.error(t)}}}async function l(h,v,t){try{const r={pid:process.pid,willReleaseAt:0};await g.promises.writeFile(v,JSON.stringify(r),{flag:"wx"})}catch(r){h.error(r)}const s=await c(h,v);return!s||s.pid!==process.pid?t?(h.info(`Lock '${v}': Could not acquire lock, giving up.`),null):(h.info(`Lock '${v}': Could not acquire lock, checking if the file is stale.`),E(h,v)):(h.info(`Lock '${v}': Lock acquired.`),new p(h,v))}async function c(h,v){let t;try{t=await g.promises.readFile(v)}catch(s){return h.error(s),null}try{return JSON.parse(String(t))}catch(s){return h.error(s),null}}async function S(h,v){let t;try{t=await g.promises.stat(v)}catch(s){return h.error(s),0}return t.mtime.getTime()}function w(h){try{return process.kill(h,0),!0}catch(v){return!1}}async function E(h,v){const t=await c(h,v);if(!t)return h.info(`Lock '${v}': Could not read pid of lock holder.`),d(h,v);if(t.willReleaseAt){let f=t.willReleaseAt-Date.now();if(f<5e3){for(f>0?h.info(`Lock '${v}': The lockfile is scheduled to be released in ${f} ms.`):h.info(`Lock '${v}': The lockfile is scheduled to have been released.`);f>0;){if(await(0,D.timeout)(Math.min(100,f)),await S(h,v)===0)return d(h,v);f=t.willReleaseAt-Date.now()}return d(h,v)}}if(!w(t.pid))return h.info(`Lock '${v}': The pid ${t.pid} appears to be gone.`),d(h,v);const s=await S(h,v),r=Date.now()-s;if(r<=u)return h.info(`Lock '${v}': The lock does not look stale, elapsed: ${r} ms, giving up.`),null;h.info(`Lock '${v}': The lock looks stale, waiting for 2s.`),await(0,D.timeout)(2e3);const n=await S(h,v),a=Date.now()-n;return a<=u?(h.info(`Lock '${v}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null):(h.info(`Lock '${v}': The lock looks stale even after waiting for 2s.`),d(h,v))}async function d(h,v){h.info(`Lock '${v}': Deleting a stale lock.`);try{await g.promises.unlink(v)}catch(t){}return l(h,v,!0)}}),define(he[255],fe([0,1,32,13,33]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends k.BaseExtHostTerminalService{constructor(I){super(!0,I)}createTerminal(I,D,C){return this.createTerminalFromOptions({name:I,shellPath:D,shellArgs:C})}createTerminalFromOptions(I,D){const C=new k.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),I,I.name);return this._terminals.push(C),C.create(I,D),C.value}};y=je([He(0,R.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(he[256],fe([0,1,5,13,6,27,2,38,24,28,7,11,49,3,189,72,12]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(m,b,_){this.remoteAddress=m,this.localAddress=b,this._dispose=_,this._onDispose=new p.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function E(f){const m=f.trim().split(`
`),b=[];return m.forEach(o=>{const A=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(o);A&&A.length>=3&&b.push({pid:parseInt(A[1],10),socket:parseInt(A[2],10)})}),b.reduce((o,A)=>(o[A.socket]=A,o),{})}e.getSockets=E;function d(...f){const m=[].concat(...f.map(v));return[...new Map(m.filter(b=>b.st==="0A").map(b=>{const _=b.local_address.split(":");return{socket:parseInt(b.inode,10),ip:h(_[0]),port:parseInt(_[1],16)}}).map(b=>[b.ip+":"+b.port,b])).values()]}e.loadListeningPorts=d;function h(f){let m="";if(f.length===8)for(let b=f.length-2;b>=0;b-=2)m+=parseInt(f.substr(b,2),16),b!==0&&(m+=".");else for(let b=f.length-4;b>=0;b-=4)m+=parseInt(f.substr(b,4),16).toString(16),b!==0&&(m+=":");return m}e.parseIpAddress=h;function v(f){const m=f.trim().split(`
`),b=m.shift().trim().split(/\s+/).filter(o=>o!=="rx_queue"&&o!=="tm->when");return m.map(o=>o.trim().split(/\s+/).reduce((A,F,$)=>(A[b[$]||$]=F,A),{}))}e.loadConnectionTable=v;function t(f){return!!f.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||f.indexOf("out/vs/server/main.js")!==-1||f.indexOf("_productName=VSCode")!==-1}function s(f){const m=f.trim().split(`
`),b=[];return m.forEach(_=>{const o=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(_);o&&o.length>=4&&b.push({pid:parseInt(o[1],10),ppid:parseInt(o[2]),cmd:o[3]})}),b}e.getRootProcesses=s;async function r(f,m,b){const _=b.reduce((A,F)=>(A[F.pid]=F,A),{}),o=[];return f.forEach(({socket:A,ip:F,port:$})=>{const W=m[A]?m[A].pid:void 0,Q=W?_[W]?.cmd:void 0;W&&Q&&!t(Q)&&o.push({host:F,port:$,detail:Q,pid:W})}),o}e.findPorts=r;function n(f,m,b){const _=new Map,o=s(m);for(const A of f){const F=b.get(A.port);if(F){_.set(A.port,F);continue}const $=o.find(W=>W.cmd.includes(`${A.port}`));if($){let W=$,Q;do Q=o.find(H=>H.ppid===W.pid),Q&&(W=Q);while(Q);_.set(A.port,{host:A.ip,port:A.port,pid:W.pid,detail:W.cmd,ppid:W.ppid})}else _.set(A.port,{host:A.ip,port:A.port,ppid:Number.MAX_VALUE})}return _}e.tryFindRootPorts=n;let a=class extends k.Disposable{constructor(m,b,_){super();this.logService=_,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new p.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(g.MainContext.MainThreadTunnelService),P.isLinux&&b.remote.isRemote&&b.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,b){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${b.remoteAddress.host}:${b.remoteAddress.port}.`);const _=await this._proxy.$openTunnel(b,m.displayName);if(_){const o=new w(_.remoteAddress,_.localAddress,()=>this._proxy.$closeTunnel(_.remoteAddress));return this._register(o),o}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,b){const _=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(_,{selector:m,provider:b}),this._proxy.$registerPortsAttributesProvider(m,_),new i.Disposable(()=>{this._portAttributesProviders.delete(_),this._proxy.$unregisterPortsAttributesProvider(_)})}async $providePortAttributes(m,b,_,o,A){const F=[];for(const W of m){const Q=this._portAttributesProviders.get(W);if(!Q)return[];F.push(...await Promise.all(b.map(async H=>Q.provider.providePortAttributes(H,_,o,A))))}const $=F.filter(W=>!!W);return $.length>0?$.map(W=>({autoForwardAction:W.autoForwardAction,port:W.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let b=new c.MovingAverage,_;for(;this._candidateFindingEnabled;){const o=new Date().getTime(),A=(await this.findCandidatePorts()).filter($=>(0,l.isLocalhost)($.host)||(0,l.isAllInterfaces)($.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${A.map($=>$.port).join(", ")}`);const F=new Date().getTime()-o;b.update(F),(!_||JSON.stringify(_)!==JSON.stringify(A))&&(_=A,await this._proxy.$onFoundNewCandidates(_)),await new Promise($=>setTimeout(()=>$(),this.calculateDelay(b.value)))}}async setTunnelExtensionFunctions(m){return m?(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory&&(this._forwardPortProvider=m.tunnelFactory,this._proxy.$setTunnelProvider(m.tunnelFeatures??{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,k.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,b){if(this._extensionTunnels.has(m.host)){const _=this._extensionTunnels.get(m.host);_.has(m.port)&&(b&&_.get(m.port).disposeListener.dispose(),await _.get(m.port).tunnel.dispose(),_.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,b){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const _=this._forwardPortProvider(m,b);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),_!==void 0){const o=await _;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const A=this._register(o.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(o.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:o,disposeListener:A}),u.TunnelDto.fromApiTunnel(o)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(_){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const b=await Promise.all(m.map(o=>this._showCandidatePort(o.host,o.port,o.detail??""))),_=m.filter((o,A)=>b[A]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(o=>o.port).join(", ")} to ${_.map(o=>o.port).join(", ")}`),_}async findCandidatePorts(){let m="",b="";try{m=await C.Promises.readFile("/proc/net/tcp","utf8"),b=await C.Promises.readFile("/proc/net/tcp6","utf8")}catch(x){}const _=d(m,b),o=await new Promise(x=>{(0,I.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(L,G,M)=>{x(G)})}),A=E(o),F=await C.Promises.readdir("/proc"),$=[];for(let x of F)try{const L=Number(x),G=D.joinPath(T.URI.file("/proc"),x);if((await C.Promises.stat(G.fsPath)).isDirectory()&&!isNaN(L)){const O=await C.Promises.readlink(D.joinPath(G,"cwd").fsPath),B=await C.Promises.readFile(D.joinPath(G,"cmdline").fsPath,"utf8");$.push({pid:L,cwd:O,cmd:B})}}catch(L){}const W=[],Q=_.filter(x=>{const L=A[x.socket];return L||W.push(x),L}),H=r(Q,A,$);let N;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${W.length}`),W.length>0){const x=await new Promise(L=>{(0,I.exec)("ps -F -A -l | grep root",(G,M,O)=>{L(M)})});this._foundRootPorts=n(W,x,this._foundRootPorts),N=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${N.join(", ")}`)}return H.then(x=>N?x.concat(N):x)}};a=je([He(0,R.IExtHostRpcService),He(1,y.IExtHostInitDataService),He(2,S.ILogService)],a),e.ExtHostTunnelService=a}),define(he[257],fe([0,1,17,21,15,3,6,99,222,126,22]),function(X,e,g,R,k,y,T,I,D,C,i){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function u(n,a){try{return JSON.stringify(n,a)}catch(f){return"null"}}function p(n,a){return JSON.stringify(n,a)}function l(n){return n?(a,f)=>f&&f.$mid===1?n.transformOutgoing(f):f:null}var c;(function(n){n[n.LocalSide=0]="LocalSide",n[n.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(n){n[n.Responsive=0]="Responsive",n[n.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},E=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class h extends T.Disposable{constructor(a,f=null,m=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=f,this._uriTransformer=m,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let b=0,_=C.ProxyIdentifier.count;b<_;b++)this._locals[b]=null,this._proxies[b]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(b=>this._receiveOneMessage(b))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(k.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+h.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?(0,I.transformIncomingURIs)(a,this._uriTransformer):a}getProxy(a){const{nid:f,sid:m}=a;return this._proxies[f]||(this._proxies[f]=this._createProxy(f,m)),this._proxies[f]}_createProxy(a,f){let m={get:(b,_)=>(typeof _=="string"&&!b[_]&&_.charCodeAt(0)===36&&(b[_]=(...o)=>this._remoteCall(a,_,o)),_===d?f:b[_])};return new Proxy(Object.create(null),m)}set(a,f){return this._locals[a.nid]=f,f}assertRegistered(a){for(let f=0,m=a.length;f<m;f++){const b=a[f];if(!this._locals[b.nid])throw new Error(`Missing actor ${b.sid} (isMain: ${b.isMain})`)}}_receiveOneMessage(a){if(this._isDisposed)return;const f=a.byteLength,m=v.read(a,0),b=m.readUInt8(),_=m.readUInt32();switch(b){case 1:case 2:{let{rpcId:o,method:A,args:F}=t.deserializeRequestJSONArgs(m);this._uriTransformer&&(F=(0,I.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(f,_,o,A,F,b===2);break}case 3:case 4:{let{rpcId:o,method:A,args:F}=t.deserializeRequestMixedArgs(m);this._uriTransformer&&(F=(0,I.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(f,_,o,A,F,b===4);break}case 5:{this._logger&&this._logger.logIncoming(f,_,0,"ack"),this._onDidReceiveAcknowledge(_);break}case 6:{this._receiveCancel(f,_);break}case 7:{this._receiveReply(f,_,void 0);break}case 9:{let o=t.deserializeReplyOKJSON(m);this._uriTransformer&&(o=(0,I.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReply(f,_,o);break}case 8:{let o=t.deserializeReplyOKVSBuffer(m);this._receiveReply(f,_,o);break}case 10:{let o=t.deserializeReplyErrError(m);this._uriTransformer&&(o=(0,I.transformIncomingURIs)(o,this._uriTransformer)),this._receiveReplyErr(f,_,o);break}case 11:{this._receiveReplyErr(f,_,void 0);break}default:console.error("received unexpected message"),console.error(a)}}_receiveRequest(a,f,m,b,_,o){this._logger&&this._logger.logIncoming(a,f,1,`receiveRequest ${(0,C.getStringIdentifierForProxy)(m)}.${b}(`,_);const A=String(f);let F,$;if(o){const Q=new R.CancellationTokenSource;_.push(Q.token),F=this._invokeHandler(m,b,_),$=()=>Q.cancel()}else F=this._invokeHandler(m,b,_),$=w;this._cancelInvokedHandlers[A]=$;const W=t.serializeAcknowledged(f);this._logger&&this._logger.logOutgoing(W.byteLength,f,1,"ack"),this._protocol.send(W),F.then(Q=>{delete this._cancelInvokedHandlers[A];const H=t.serializeReplyOK(f,Q,this._uriReplacer);this._logger&&this._logger.logOutgoing(H.byteLength,f,1,"reply:",Q),this._protocol.send(H)},Q=>{delete this._cancelInvokedHandlers[A];const H=t.serializeReplyErr(f,Q);this._logger&&this._logger.logOutgoing(H.byteLength,f,1,"replyErr:",Q),this._protocol.send(H)})}_receiveCancel(a,f){this._logger&&this._logger.logIncoming(a,f,1,"receiveCancel");const m=String(f);this._cancelInvokedHandlers[m]&&this._cancelInvokedHandlers[m]()}_receiveReply(a,f,m){this._logger&&this._logger.logIncoming(a,f,0,"receiveReply:",m);const b=String(f);if(!this._pendingRPCReplies.hasOwnProperty(b))return;const _=this._pendingRPCReplies[b];delete this._pendingRPCReplies[b],_.resolveOk(m)}_receiveReplyErr(a,f,m){this._logger&&this._logger.logIncoming(a,f,0,"receiveReplyErr:",m);const b=String(f);if(!this._pendingRPCReplies.hasOwnProperty(b))return;const _=this._pendingRPCReplies[b];delete this._pendingRPCReplies[b];let o;m&&(m.$isError?(o=new Error,o.name=m.name,o.message=m.message,o.stack=m.stack):o=m),_.resolveErr(o)}_invokeHandler(a,f,m){try{return Promise.resolve(this._doInvokeHandler(a,f,m))}catch(b){return Promise.reject(b)}}_doInvokeHandler(a,f,m){const b=this._locals[a];if(!b)throw new Error("Unknown actor "+(0,C.getStringIdentifierForProxy)(a));let _=b[f];if(typeof _!="function")throw new Error("Unknown method "+f+" on actor "+(0,C.getStringIdentifierForProxy)(a));return _.apply(b,m)}_remoteCall(a,f,m){if(this._isDisposed)return Promise.reject(k.canceled());let b=null;if(m.length>0&&R.CancellationToken.isCancellationToken(m[m.length-1])&&(b=m.pop()),b&&b.isCancellationRequested)return Promise.reject(k.canceled());const _=t.serializeRequestArguments(m,this._uriReplacer),o=++this._lastMessageId,A=String(o),F=new D.LazyPromise;b&&b.onCancellationRequested(()=>{const W=t.serializeCancel(o);this._logger&&this._logger.logOutgoing(W.byteLength,o,0,"cancel"),this._protocol.send(t.serializeCancel(o))}),this._pendingRPCReplies[A]=F,this._onWillSendRequest(o);const $=t.serializeRequest(o,a,f,_,!!b);return this._logger&&this._logger.logOutgoing($.byteLength,o,0,`request: ${(0,C.getStringIdentifierForProxy)(a)}.${f}(`,m),this._protocol.send($),F}}e.RPCProtocol=h,P=E,h.UNRESPONSIVE_TIME=3*1e3;class v{constructor(a,f){this._buff=a,this._offset=f}static alloc(a,f,m){let b=new v(i.VSBuffer.alloc(m+1+4),0);return b.writeUInt8(a),b.writeUInt32(f),b}static read(a,f){return new v(a,f)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const m=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,m}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,m}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,f}static sizeMixedArray(a,f){let m=0;m+=1;for(let b=0,_=a.length;b<_;b++){const o=a[b],A=f[b];switch(m+=1,A){case 1:m+=this.sizeLongString(o);break;case 2:m+=this.sizeVSBuffer(o);break;case 3:break}}return m}writeMixedArray(a,f){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let m=0,b=a.length;m<b;m++){const _=a[m];switch(f[m]){case 1:this.writeUInt8(1),this.writeLongString(_);break;case 2:this.writeUInt8(2),this.writeVSBuffer(_);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let f=new Array(a);for(let m=0;m<a;m++)switch(this.readUInt8()){case 1:f[m]=this.readLongString();break;case 2:f[m]=this.readVSBuffer();break;case 3:f[m]=void 0;break}return f}}class t{static _arrayContainsBufferOrUndefined(a){for(let f=0,m=a.length;f<m;f++)if(a[f]instanceof i.VSBuffer||typeof a[f]=="undefined")return!0;return!1}static serializeRequestArguments(a,f){if(this._arrayContainsBufferOrUndefined(a)){let m=[],b=[];for(let _=0,o=a.length;_<o;_++){const A=a[_];A instanceof i.VSBuffer?(m[_]=A,b[_]=2):typeof A=="undefined"?(m[_]=i.VSBuffer.alloc(0),b[_]=3):(m[_]=i.VSBuffer.fromString(p(A,f)),b[_]=1)}return{type:"mixed",args:m,argsType:b}}return{type:"simple",args:p(a,f)}}static serializeRequest(a,f,m,b,_){return b.type==="mixed"?this._requestMixedArgs(a,f,m,b.args,b.argsType,_):this._requestJSONArgs(a,f,m,b.args,_)}static _requestJSONArgs(a,f,m,b,_){const o=i.VSBuffer.fromString(m),A=i.VSBuffer.fromString(b);let F=0;F+=v.sizeUInt8(),F+=v.sizeShortString(o),F+=v.sizeLongString(A);let $=v.alloc(_?2:1,a,F);return $.writeUInt8(f),$.writeShortString(o),$.writeLongString(A),$.buffer}static deserializeRequestJSONArgs(a){const f=a.readUInt8(),m=a.readShortString(),b=a.readLongString();return{rpcId:f,method:m,args:JSON.parse(b)}}static _requestMixedArgs(a,f,m,b,_,o){const A=i.VSBuffer.fromString(m);let F=0;F+=v.sizeUInt8(),F+=v.sizeShortString(A),F+=v.sizeMixedArray(b,_);let $=v.alloc(o?4:3,a,F);return $.writeUInt8(f),$.writeShortString(A),$.writeMixedArray(b,_),$.buffer}static deserializeRequestMixedArgs(a){const f=a.readUInt8(),m=a.readShortString(),b=a.readMixedArray(),_=new Array(b.length);for(let o=0,A=b.length;o<A;o++){const F=b[o];typeof F=="string"?_[o]=JSON.parse(F):_[o]=F}return{rpcId:f,method:m,args:_}}static serializeAcknowledged(a){return v.alloc(5,a,0).buffer}static serializeCancel(a){return v.alloc(6,a,0).buffer}static serializeReplyOK(a,f,m){return typeof f=="undefined"?this._serializeReplyOKEmpty(a):f instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(a,f):this._serializeReplyOKJSON(a,u(f,m))}static _serializeReplyOKEmpty(a){return v.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,f){let m=0;m+=v.sizeVSBuffer(f);let b=v.alloc(8,a,m);return b.writeVSBuffer(f),b.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,f){const m=i.VSBuffer.fromString(f);let b=0;b+=v.sizeLongString(m);let _=v.alloc(9,a,b);return _.writeLongString(m),_.buffer}static deserializeReplyOKJSON(a){const f=a.readLongString();return JSON.parse(f)}static serializeReplyErr(a,f){return f?this._serializeReplyErrEror(a,f):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,f){const m=i.VSBuffer.fromString(u(k.transformErrorForSerialization(f),null));let b=0;b+=v.sizeLongString(m);let _=v.alloc(10,a,b);return _.writeLongString(m),_.buffer}static deserializeReplyErrError(a){const f=a.readLongString();return JSON.parse(f)}static _serializeReplyErrEmpty(a){return v.alloc(11,a,0).buffer}}var s;(function(n){n[n.RequestJSONArgs=1]="RequestJSONArgs",n[n.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",n[n.RequestMixedArgs=3]="RequestMixedArgs",n[n.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",n[n.Acknowledged=5]="Acknowledged",n[n.Cancel=6]="Cancel",n[n.ReplyOKEmpty=7]="ReplyOKEmpty",n[n.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",n[n.ReplyOKJSON=9]="ReplyOKJSON",n[n.ReplyErrError=10]="ReplyErrError",n[n.ReplyErrEmpty=11]="ReplyErrEmpty"})(s||(s={}));var r;(function(n){n[n.String=1]="String",n[n.VSBuffer=2]="VSBuffer",n[n.Undefined=3]="Undefined"})(r||(r={}))}),define(he[258],fe([0,1,4]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(he[259],fe([0,1,10,9,11,2,4,83,47,217,258]),function(X,e,g,R,k,y,T,I,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,T.createDecorator)("pathService");let P=class zn{constructor(p,l,c,S){this.localUserHome=p,this.remoteAgentService=l,this.environmentService=c,this.contextService=S,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||k.OS)(),this.resolveUserHome=(async()=>{const w=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=w?.userHome||p})()}get defaultUriScheme(){return zn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(p,l){if(p.remoteAuthority)return g.Schemas.vscodeRemote;const c=(0,I.getVirtualWorkspaceScheme)(l.getWorkspace());if(c)return c;const S=l.getWorkspace().folders[0];if(S)return S.uri.scheme;const w=l.getWorkspace().configuration;return w?w.scheme:g.Schemas.file}async userHome(p){return p?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(p=>p===1?R.win32:R.posix)}async fileURI(p){let l="";if(await this.resolveOS===1&&(p=p.replace(/\\/g,"/")),p[0]==="/"&&p[1]==="/"){const S=p.indexOf("/",2);S===-1?(l=p.substring(2),p="/"):(l=p.substring(2,S),p=p.substring(S)||"/")}return y.URI.from({scheme:g.Schemas.file,authority:l,path:p,query:"",fragment:""})}};P=je([He(1,i.IRemoteAgentService),He(2,C.IWorkbenchEnvironmentService),He(3,D.IWorkspaceContextService)],P),e.AbstractPathService=P}),define(he[65],fe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(T,I){this.line=T,this.character=I}isBefore(T){return!1}isBeforeOrEqual(T){return!1}isAfter(T){return!1}isAfterOrEqual(T){return!1}isEqual(T){return!1}compareTo(T){return 0}translate(T,I){return new g(0,0)}with(T){return new g(0,0)}}e.Position=g;class R{constructor(T,I,D,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(T,I),this.end=new g(D,C)}contains(T){return!1}isEqual(T){return!1}intersection(T){}union(T){return new R(0,0,0,0)}with(T){return new R(0,0,0,0)}}e.Range=R;var k;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(he[31],fe([0,1,18,30,25,29,8,4,9,15,65]),function(X,e,g,R,k,y,T,I,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",u=" characters skipped \u27EB",p=(P.length+u.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var l;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var c;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(c=e.QueryType||(e.QueryType={}));function S(L){return!!L.preview}e.resultIsMatch=S;function w(L){return!!L.resource}e.isFileMatch=w;function E(L){return!!L.message}e.isProgressMessage=E;var d;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class h{constructor(G){this.resource=G,this.results=[]}}e.FileMatch=h;class v{constructor(G,M,O){this.ranges=M;const B=Array.isArray(M)?M:[M];if(O&&O.matchLines===1&&t(B)){G=(0,T.getNLines)(G,O.matchLines);let z="",J=0,ce=0;const ye=Math.floor(O.charsPerLine/5),Fe=[];for(const Re of B){const Ne=Math.max(Re.startColumn-ye,0),Ve=Re.startColumn+O.charsPerLine;if(Ne>ce+ye+p){const ze=P+(Ne-ce)+u;z+=ze+G.slice(Ne,Ve),J+=Ne-(ce+ze.length)}else z+=G.slice(ce,Ve);Fe.push(new r(0,Re.startColumn-J,Re.endColumn-J)),ce=Ve}this.preview={text:z,matches:Array.isArray(this.ranges)?Fe:Fe[0]}}else{const z=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:G,matches:(0,g.mapArrayOrNot)(M,J=>new s(J.startLineNumber-z,J.startColumn,J.endLineNumber-z,J.endColumn))}}}}e.TextSearchMatch=v;function t(L){const G=L[0].startLineNumber;for(const M of L)if(M.startLineNumber!==G||M.endLineNumber!==G)return!1;return!0}class s{constructor(G,M,O,B){this.startLineNumber=G,this.startColumn=M,this.endLineNumber=O,this.endColumn=B}}e.SearchRange=s;class r extends s{constructor(G,M,O){super(G,M,G,O)}}e.OneLineRange=r;var n;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function a(L,G=!0){const M=L&&L.files&&L.files.exclude,O=G&&L&&L.search&&L.search.exclude;if(!M&&!O)return;if(!M||!O)return M||O;let B=Object.create(null);return B=k.mixin(B,k.deepClone(M)),B=k.mixin(B,k.deepClone(O),!0),B}e.getExcludes=a;function f(L,G){return L.excludePattern&&R.match(L.excludePattern,G)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&R.match(L.includePattern,G)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(M=>{const O=M.folder.fsPath;if(y.isEqualOrParent(G,O)){const B=D.relative(O,G);return!M.includePattern||!!R.match(M.includePattern,B)}else return!1}):!1:!0}e.pathIncludedInQuery=f;var m;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class b extends Error{constructor(G,M){super(G);this.code=M}}e.SearchError=b;function _(L){const G=L.message;if((0,C.isPromiseCanceledError)(L))return new b(G,m.canceled);try{const M=JSON.parse(G);return new b(M.message,M.code)}catch(M){return new b(G,m.other)}}e.deserializeSearchError=_;function o(L){const G={message:L.message,code:L.code};return new Error(JSON.stringify(G))}e.serializeSearchError=o;function A(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=A;function F(L){return L.type==="success"}e.isSerializedSearchSuccess=F;function $(L){return!!L.path}e.isSerializedFileMatch=$;function W(L,G){const M=L.searchPath?L.searchPath:L.relativePath;return(0,T.fuzzyContains)(M,G)}e.isFilePatternMatch=W;class Q{constructor(G){this.path=G,this.results=[]}addMatch(G){this.results.push(G)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=Q;function H(L,G){const M={...L||{},...G||{}};return Object.keys(M).filter(O=>{const B=M[O];return typeof B=="boolean"&&B})}e.resolvePatternsForProvider=H;class N{constructor(G,M){this._parsedIncludeExpression=null,this._excludeExpression={...G.excludePattern||{},...M.excludePattern||{}},this._parsedExcludeExpression=R.parse(this._excludeExpression);let O=G.includePattern;M.includePattern&&(O?O={...O,...M.includePattern}:O=M.includePattern),O&&(this._parsedIncludeExpression=R.parse(O))}includedInQuerySync(G,M,O){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(G,M,O)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(G,M,O))}includedInQuery(G,M,O){return Promise.resolve(this._parsedExcludeExpression(G,M,O)).then(z=>!!z).then(z=>z?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(G,M,O)).then(J=>!!J):Promise.resolve(!0)).then(z=>z)}hasSiblingExcludeClauses(){return x(this._excludeExpression)}}e.QueryGlobTester=N;function x(L){for(const G in L)if(typeof L[G]!="boolean")return!0;return!1}}),define(he[35],fe([0,1,18,17,21,3,23,10,72,24,8,14,2,165,4,12,184,47,59,27,13,7,31,5]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c,S,w,E,d,h,v,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(A,F,$){return new C.ExtUri(W=>m(W,$)).isEqual(A,F)}function n(A,F,$){return r(A.uri,F.uri,$)?0:(0,i.compare)(A.uri.toString(),F.uri.toString())}function a(A,F,$){return A.index!==F.index?A.index<F.index?-1:1:r(A.uri,F.uri,$)?(0,i.compare)(A.name,F.name):(0,i.compare)(A.uri.toString(),F.uri.toString())}function f(A,F,$,W){const Q=A.slice(0).sort((N,x)=>$(N,x,W)),H=F.slice(0).sort((N,x)=>$(N,x,W));return(0,g.delta)(Q,H,(N,x)=>$(N,x,W))}function m(A,F){const $=F.getCapabilities(A.scheme);return!($&&$&1024)}class b extends w.Workspace{constructor(F,$,W,Q,H,N){super(F,W.map(x=>new w.WorkspaceFolder(x)),Q,N);this._name=$,this._isUntitled=H,this._workspaceFolders=[],this._structure=T.TernarySearchTree.forUris(N),W.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}static toExtHostWorkspace(F,$,W,Q){if(!F)return{workspace:null,added:[],removed:[]};const{id:H,name:N,folders:x,configuration:L,isUntitled:G}=F,M=[],O=$;$?x.forEach((ce,ye)=>{const Fe=u.URI.revive(ce.uri),Re=b._findFolder(W||$,Fe,Q);Re?(Re.name=ce.name,Re.index=ce.index,M.push(Re)):M.push({uri:Fe,name:ce.name,index:ye})}):M.push(...x.map(({uri:ce,name:ye,index:Fe})=>({uri:u.URI.revive(ce),name:ye,index:Fe}))),M.sort((ce,ye)=>ce.index<ye.index?-1:1);const B=new b(H,N,M,L?u.URI.revive(L):null,!!G,ce=>m(ce,Q)),{added:z,removed:J}=f(O?O.workspaceFolders:[],B.workspaceFolders,n,Q);return{workspace:B,added:z,removed:J}}static _findFolder(F,$,W){for(let Q=0;Q<F.folders.length;Q++){const H=F.workspaceFolders[Q];if(r(H.uri,$,W))return H}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,$){return $&&this._structure.get(F)&&(F=(0,C.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let _=class{constructor(F,$,W,Q){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=Q,this._extHostFileSystemInfo=W,this._requestIdProvider=new D.Counter,this._barrier=new R.Barrier,this._proxy=F.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(s.MainContext.MainThreadMessageService);const H=$.workspace;this._confirmedWorkspace=H?new b(H.id,H.name,[],H.configuration?u.URI.revive(H.configuration):null,!!H.isUntitled,N=>m(N,W)):void 0}$initializeWorkspace(F,$){this._trusted=$,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?u.URI.from({scheme:I.Schemas.untitled,path:(0,C.basename)((0,C.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,$,W,...Q){const H=[];if(Array.isArray(Q)&&Q.forEach(M=>{u.URI.isUri(M.uri)&&!H.some(O=>r(O.uri,M.uri,this._extHostFileSystemInfo))&&H.push({uri:M.uri,name:M.name||(0,C.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[$,W].some(M=>typeof M!="number"||M<0)||W===0&&H.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+W>N.length)return!1;const x=N.slice(0);x.splice($,W,...H.map(M=>({uri:M.uri,name:M.name||(0,C.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<x.length;M++){const O=x[M];if(x.some((B,z)=>z!==M&&r(O.uri,B.uri,this._extHostFileSystemInfo)))return!1}x.forEach((M,O)=>M.index=O);const{added:L,removed:G}=f(N,x,a,this._extHostFileSystemInfo);if(L.length===0&&G.length===0)return!1;if(this._proxy){const M=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(M,$,W,H).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,(0,p.localize)(0,null,M,O.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(F,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,$)}async getWorkspaceFolder2(F,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,$)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!this._actualWorkspace)return;const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,$){let W,Q="";if(typeof F=="string"?(W=u.URI.file(F),Q=F):typeof F!="undefined"&&(W=F,Q=F.fsPath),!W)return Q;const H=this.getWorkspaceFolder(W,!0);if(!H)return Q;typeof $=="undefined"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let N=(0,C.relativePath)(H.uri,W);return $&&H.name&&(N=`${H.name}/${N}`),N}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:$,added:W,removed:Q}=b.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:W,removed:Q}))}findFiles(F,$,W,Q,H=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${Q.value}, entryPoint: findFiles`);let N;if($===null?N=!1:$&&(typeof $=="string"?N=$:N=$.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:L}=o(F);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)(x),(0,P.withUndefinedAsNull)(L),(0,P.withUndefinedAsNull)(N),(0,P.withUndefinedAsNull)(W),H).then(G=>Array.isArray(G)?G.map(M=>u.URI.revive(M)):[])}async findTextInFiles(F,$,W,Q,H=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${Q.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),x=typeof $.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:L,folder:G}=o($.include),M=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,O={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:x,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:L,excludePattern:M},B=!1;if(this._activeSearchCallbacks[N]=z=>{if(B)return;const J=u.URI.revive(z.resource);z.results.forEach(ce=>{(0,t.resultIsMatch)(ce)?W({uri:J,preview:{text:ce.preview.text,matches:(0,g.mapArrayOrNot)(ce.preview.matches,ye=>new v.Range(ye.startLineNumber,ye.startColumn,ye.endLineNumber,ye.endColumn))},ranges:(0,g.mapArrayOrNot)(ce.ranges,ye=>new v.Range(ye.startLineNumber,ye.startColumn,ye.endLineNumber,ye.endColumn))}):W({uri:J,text:ce.text,lineNumber:ce.lineNumber})})},H.isCancellationRequested)return{};try{const z=await this._proxy.$startTextSearch(F,(0,P.withUndefinedAsNull)(G),O,N,H);return delete this._activeSearchCallbacks[N],z||{}}catch(z){throw delete this._activeSearchCallbacks[N],z}}$handleTextSearchResult(F,$){this._activeSearchCallbacks[$]&&this._activeSearchCallbacks[$](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trusted(){return this._trusted}requestWorkspaceTrust(F){return this._proxy.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};_=je([He(0,h.IExtHostRpcService),He(1,d.IExtHostInitDataService),He(2,E.IExtHostFileSystemInfo),He(3,c.ILogService)],_),e.ExtHostWorkspace=_,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function o(A){let F,$;return A&&(typeof A=="string"?F=A:(F=A.pattern,$=A.baseFolder||u.URI.file(A.base))),{includePattern:F,folder:$}}}),define(he[36],fe([0,1,25,3,35,5,7,188,82,14,17,4,13,12,2]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function c(s,r){if(r){const n=r.split(".");let a=s;for(let f=0;a&&f<n.length;f++)a=a[n[f]];return a}}function S(s){return s instanceof l.URI}function w(s){return s&&s.uri instanceof l.URI&&s.languageId&&typeof s.languageId=="string"}function E(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function d(s){return s&&s.uri instanceof l.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function h(s){if(S(s))return{resource:s};if(w(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(E(s))return{overrideIdentifier:s.languageId};if(d(s))return{resource:s.uri};if(s===null)return{resource:null}}let v=class{constructor(r,n,a){this._proxy=r.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=a,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,n){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(r,n))}};v=je([He(0,u.IExtHostRpcService),He(1,k.IExtHostWorkspace),He(2,p.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(r,n,a,f){this._onDidChangeConfiguration=new R.Emitter,this._proxy=r,this._logService=f,this._extHostWorkspace=n,this._configuration=I.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,n){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,a))}getConfiguration(r,n,a){const f=h(n)||{},m=this._toReadonlyValue(r?c(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,f,a?.identifier);function b(o){if(o==null)return null;if(typeof o=="boolean")return o?1:4;switch(o){case T.ConfigurationTarget.Global:return 1;case T.ConfigurationTarget.Workspace:return 4;case T.ConfigurationTarget.WorkspaceFolder:return 5}}const _={has(o){return typeof c(m,o)!="undefined"},get:(o,A)=>{this._validateConfigurationAccess(r?`${r}.${o}`:o,f,a?.identifier);let F=c(m,o);if(typeof F=="undefined")F=A;else{let $;const W=(Q,H)=>{let N;const x=()=>{$=$||(0,g.deepClone)(m),N=N||c($,H)};return(0,C.isObject)(Q)?new Proxy(Q,{get:(L,G)=>{if(typeof G=="string"&&G.toLowerCase()==="tojson")return x(),()=>N;if($)return N=N||c($,H),N[G];const M=L[G];return typeof G=="string"?W(M,`${H}.${G}`):M},set:(L,G,M)=>(x(),N&&(N[G]=M),!0),deleteProperty:(L,G)=>(x(),N&&delete N[G],!0),defineProperty:(L,G,M)=>(x(),N&&Object.defineProperty(N,G,M),!0)}):Q};F=W(F,o)}return F},update:(o,A,F,$)=>{o=r?`${r}.${o}`:o;const W=b(F);return A!==void 0?this._proxy.$updateConfigurationOption(W,o,A,f,$):this._proxy.$removeConfigurationOption(W,o,f,$)},inspect:o=>{o=r?`${r}.${o}`:o;const A=(0,g.deepClone)(this._configuration.inspect(o,f,this._extHostWorkspace.workspace));if(A)return{key:o,defaultValue:A.default?.value,globalValue:A.user?.value,workspaceValue:A.workspace?.value,workspaceFolderValue:A.workspaceFolder?.value,defaultLanguageValue:A.default?.override,globalLanguageValue:A.user?.override,workspaceLanguageValue:A.workspace?.override,workspaceFolderLanguageValue:A.workspaceFolder?.override,languageIds:A.overrideIdentifiers}}};return typeof m=="object"&&(0,g.mixin)(_,m,!1),Object.freeze(_)}_toReadonlyValue(r){const n=a=>(0,C.isObject)(a)?new Proxy(a,{get:(f,m)=>n(f[m]),set:(f,m,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(f,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(f,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return n(r)}_validateConfigurationAccess(r,n,a){const f=D.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),m=a?`[${a.value}] `:"";if(f===4){typeof n?.resource=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){n?.resource&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,n){const a=new I.ConfigurationChangeEvent(r,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,m)=>a.affectsConfiguration(f,h(m))})}_toMap(r){return r.reduce((n,a)=>(n.set(a[0],a[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(X,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,g):k?k.value=g:e.set(X,g),g},xe=this&&this.__classPrivateFieldGet||function(X,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(X):R?R.value:e.get(X)};define(he[66],fe([0,1,2,17,3,5,7,35,43,36,21,33,13,27,4,10,11,12,61,207,15]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c,S,w,E,d,h){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(Q){function H(x){if(x!=null)return x}Q.from=H;function N(x){if(x!=null)return x}Q.to=N})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var s;(function(Q){function H(x){if(x!=null)return x}Q.from=H;function N(x){if(x!=null)return x}Q.to=N})(s=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(Q){function H(x){if(x!=null)return x}Q.from=H;function N(x){if(x!=null)return x}Q.to=N})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(Q){function H(L){if(L){const G=L;return G&&!!G.process}else return!1}Q.is=H;function N(L){if(L==null)return;const G={process:L.process,args:L.args};return L.options&&(G.options=r.from(L.options)),G}Q.from=N;function x(L){if(L!=null)return new T.ProcessExecution(L.process,L.args,L.options)}Q.to=x})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var a;(function(Q){function H(x){if(x!=null)return x}Q.from=H;function N(x){if(x!=null)return x}Q.to=N})(a=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(Q){function H(L){if(L){const G=L;return G&&(!!G.commandLine||!!G.command)}else return!1}Q.is=H;function N(L){if(L==null)return;const G={};return L.commandLine!==void 0?G.commandLine=L.commandLine:(G.command=L.command,G.args=L.args),L.options&&(G.options=a.from(L.options)),G}Q.from=N;function x(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new T.ShellExecution(L.commandLine,L.options):new T.ShellExecution(L.command,L.args?L.args:[],L.options)}Q.to=x})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function(Q){function H(L){if(L){let G=L;return G&&G.customExecution==="customExecution"}else return!1}Q.is=H;function N(L){return{customExecution:"customExecution"}}Q.from=N;function x(L,G){return G.get(L)}Q.to=x})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(Q){function H(N,x){let L;return N.scope!==void 0&&typeof N.scope!="number"?L=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===T.TaskScope.Workspace&&x&&x.workspaceFile?L=x.workspaceFile:L=d.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:L}}Q.from=H})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var _;(function(Q){function H(L,G){if(L==null)return[];const M=[];for(let O of L){const B=N(O,G);B&&M.push(B)}return M}Q.fromMany=H;function N(L,G){if(L==null)return;let M;L.execution instanceof T.ProcessExecution?M=n.from(L.execution):L.execution instanceof T.ShellExecution?M=f.from(L.execution):L.execution&&L.execution instanceof T.CustomExecution&&(M=m.from(L.execution));const O=t.from(L.definition);let B;if(L.scope?typeof L.scope=="number"?B=L.scope:B=L.scope.uri:B=T.TaskScope.Workspace,!O||!B)return;const z=L.group?L.group.id:void 0;return{_id:L._id,definition:O,name:L.name,source:{extensionId:G.identifier.value,label:L.source,scope:B},execution:M,isBackground:L.isBackground,group:z,presentationOptions:s.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}Q.from=N;async function x(L,G,M){if(L==null)return;let O;n.is(L.execution)?O=n.to(L.execution):f.is(L.execution)?O=f.to(L.execution):m.is(L.execution)&&(O=m.to(L._id,M));const B=t.to(L.definition);let z;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?z=L.source.scope:z=await G.resolveWorkspaceFolder(g.URI.revive(L.source.scope)):z=T.TaskScope.Workspace),!B||!z)return;const J=new T.Task(B,z,L.name,L.source.label,O,L.problemMatchers);return L.isBackground!==void 0&&(J.isBackground=L.isBackground),L.group!==void 0&&(J.group=T.TaskGroup.from(L.group)),L.presentationOptions&&(J.presentationOptions=s.to(L.presentationOptions)),L._id&&(J._id=L._id),L.detail&&(J.detail=L.detail),J}Q.to=x})(_=e.TaskDTO||(e.TaskDTO={}));var o;(function(Q){function H(x){return x}Q.from=H;function N(x){if(!!x)return Object.assign(Object.create(null),x)}Q.to=N})(o=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(H,N,x){this._id=N,this._task=x,v.set(this,void 0),it(this,v,H,"f")}get task(){return this._task}terminate(){xe(this,v,"f").terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}v=new WeakMap;var F;(function(Q){function H(N){return{id:N._id,task:void 0}}Q.from=H})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let $=class{constructor(H,N,x,L,G,M,O,B){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=H.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=x,this._editorService=L,this._configurationService=G,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=O,this._deprecationService=B,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,N,x){if(!x)return new T.Disposable(()=>{});const L=this.nextHandle();return this._handlers.set(L,{type:N,provider:x,extension:H}),this._proxy.$registerTaskProvider(L,N),new T.Disposable(()=>{this._handlers.delete(L),this._proxy.$unregisterTaskProvider(L)})}registerTaskSystem(H,N){this._proxy.$registerTaskSystem(H,N)}fetchTasks(H){return this._proxy.$fetchTasks(o.from(H)).then(async N=>{const x=[];for(let L of N){const G=await _.to(L,this._workspaceProvider,this._providedCustomExecutions2);G&&x.push(G)}return x})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(N=>H.push(N)),H}terminateTask(H){if(!(H instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,N,x){const L=this._providedCustomExecutions2.get(H.id);if(L){if(this._activeCustomExecutions2.get(H.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(H.id,L),this._terminalService.attachPtyToTerminal(N,await L.callback(x))}this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const N=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:N})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const N=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:N,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const N=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:N,exitCode:H.exitCode})}$provideTasks(H,N){const x=this._handlers.get(H);if(!x)return Promise.reject(new Error("no handler found"));const L=[],G=(0,R.asPromise)(()=>x.provider.provideTasks(i.CancellationToken.None)).then(M=>this.provideTasksInternal(N,L,x,M));return new Promise(M=>{G.then(O=>{Promise.all(L).then(()=>{M(O)})})})}async $resolveTask(H,N){const x=this._handlers.get(H);if(!x)return Promise.reject(new Error("no handler found"));if(N.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${x.type}].`);const L=await _.to(N,this._workspaceProvider,this._providedCustomExecutions2);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const G=await x.provider.resolveTask(L,i.CancellationToken.None);if(!G)return;this.checkDeprecation(G,x);const M=_.from(G,x.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(M.execution)&&await this.addCustomExecution(M,G,!0),await this.resolveTaskInternal(M)}nextHandle(){return this._handleCounter++}async addCustomExecution(H,N,x){const L=await this._proxy.$createTaskId(H);!x&&!this._providedCustomExecutions2.has(L)&&this._notProvidedCustomExecutions.add(L),this._providedCustomExecutions2.set(L,N.execution)}async getTaskExecution(H,N){if(typeof H=="string"){const G=this._taskExecutionPromises.get(H);if(!G)throw new Error("Unexpected: The specified task is missing an execution");return G}let x=this._taskExecutionPromises.get(H.id);if(x)return x;const L=new Promise(async(G,M)=>{const O=N||await _.to(H.task,this._workspaceProvider,this._providedCustomExecutions2);O?G(new A(this,H.id,O)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(H.id,L),L.then(G=>(this._taskExecutions.set(H.id,G),G),G=>Promise.reject(G))}checkDeprecation(H,N){H._deprecated&&this._deprecationService.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));let x=this._notProvidedCustomExecutions.values(),L=x.next();for(;!L.done;)!this._activeCustomExecutions2.has(L.value)&&this._lastStartedTask!==L.value&&(this._providedCustomExecutions2.delete(L.value),this._notProvidedCustomExecutions.delete(L.value)),L=x.next()}};$=je([He(0,u.IExtHostRpcService),He(1,p.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,C.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,w.ILogService),He(7,E.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let W=class extends ${constructor(H,N,x,L,G,M,O,B){super(H,N,x,L,G,M,O,B);this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(H,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const x=_.from(N,H);if(x===void 0)throw new Error("Task is not valid");if(m.is(x.execution))await this.addCustomExecution(x,N,!1);else throw new h.NotSupportedError;const L=await this.getTaskExecution(await this._proxy.$getTaskExecution(x),N);return this._proxy.$executeTask(x).catch(G=>{throw new Error(G)}),L}provideTasksInternal(H,N,x,L){const G=[];if(L)for(let M of L){this.checkDeprecation(M,x),(!M.definition||!H[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const O=_.from(M,x.extension);O&&m.is(O.execution)?(G.push(O),N.push(this.addCustomExecution(O,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:G,extension:x.extension}}async resolveTaskInternal(H){if(m.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(H,N,x){}};W=je([He(0,u.IExtHostRpcService),He(1,p.IExtHostInitDataService),He(2,I.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,C.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,w.ILogService),He(7,E.IExtHostApiDeprecationService)],W),e.WorkerExtHostTask=W,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")}),define(he[260],fe([0,1,18,69,30,76,23,10,9,24,8,14,2,141,170,115,47,123,259,31]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c,S,w,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(b,_,o,A){this.configurationService=b,this.workspaceContextService=_,this.editorGroupsService=o,this.pathService=A}text(b,_,o={}){b=this.getContentPattern(b,o);const A=this.configurationService.getValue(),F=_&&_.some(W=>!this.configurationService.getValue({resource:W}).search.useRipgrep);return{...this.commonQuery(_?.map(S.toWorkspaceFolder),o),type:2,contentPattern:b,previewOptions:o.previewOptions,maxFileSize:o.maxFileSize,usePCRE2:A.search.usePCRE2||F||!1,beforeContext:o.beforeContext,afterContext:o.afterContext,userDisabledExcludesAndIgnoreFiles:o.disregardExcludeSettings&&o.disregardIgnoreFiles}}getContentPattern(b,_){const o=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const A={...b,wordSeparators:o.editor.wordSeparators};return this.isCaseSensitive(b,_)&&(A.isCaseSensitive=!0),this.isMultiline(b)&&(A.isMultiline=!0),A}file(b,_={}){return{...this.commonQuery(b,_),type:1,filePattern:_.filePattern?_.filePattern.trim():_.filePattern,exists:_.exists,sortByScore:_.sortByScore,cacheKey:_.cacheKey}}handleIncludeExclude(b,_){return b?(b=Array.isArray(b)?b.map(n):n(b),_?this.parseSearchPaths(b):{pattern:t(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],_={}){const o=this.handleIncludeExclude(_.includePattern,_.expandPatterns),A=this.handleIncludeExclude(_.excludePattern,_.expandPatterns),F=b.length>1,$=(o.searchPaths&&o.searchPaths.length?o.searchPaths.map(H=>this.getFolderQueryForSearchPath(H,_,A)):b.map(H=>this.getFolderQueryForRoot(H,_,A,F))).filter(H=>!!H),W={_reason:_._reason,folderQueries:$,usingSearchPaths:!!(o.searchPaths&&o.searchPaths.length),extraFileResources:_.extraFileResources,excludePattern:A.pattern,includePattern:o.pattern,onlyOpenEditors:_.onlyOpenEditors,maxResults:_.maxResults};if(_.onlyOpenEditors){const N=g.coalesce(g.flatten(this.editorGroupsService.groups.map(L=>L.editors.map(G=>G.resource)))).filter(L=>(0,d.pathIncludedInQuery)(W,L.fsPath)),x=this.commonQueryFromFileList(N);return{...W,...x}}const Q=_.extraFileResources&&_.extraFileResources.filter(H=>(0,d.pathIncludedInQuery)(W,H.fsPath));return W.extraFileResources=Q&&Q.length?Q:void 0,W}commonQueryFromFileList(b){const _=[],o=new T.ResourceMap,A={};let F=!1;return b.forEach($=>{if($.scheme===I.Schemas.walkThrough)return;if((0,C.isAbsolutePath)($)){const Q=this.workspaceContextService.getWorkspaceFolder($)?.uri??$.with({path:D.dirname($.fsPath)});let H=o.get(Q);H||(F=!0,H={folder:Q,includePattern:{}},_.push(H),o.set(Q,H));const N=D.relative(Q.fsPath,$.fsPath);(0,P.assertIsDefined)(H.includePattern)[N.replace(/\\/g,"/")]=!0}else $.fsPath&&(F=!0,A[$.fsPath]=!0)}),{folderQueries:_,includePattern:A,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(b,_){if(_.isSmartCase){if(b.isRegExp){if(i.containsUppercaseCharacter(b.pattern,!0))return!0}else if(i.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,p.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const _=x=>D.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),A=(Array.isArray(b)?b:s(b)).map(x=>{const L=this.pathService.resolvedUserHome;return L?(0,y.untildify)(x,L.scheme===I.Schemas.file?L.fsPath:L.path):x}),F=R.groupBy(A,x=>_(x)?"searchPaths":"exprSegments"),$=(F.exprSegments||[]).map(x=>i.rtrim(x,"/")).map(x=>i.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),r(x))),W={},Q=this.expandSearchPathPatterns(F.searchPaths||[]);Q&&Q.length&&(W.searchPaths=Q);const H=g.flatten($),N=t(...H);return N&&(W.pattern=N),W}getExcludesForFolder(b,_){return _.disregardExcludeSettings?void 0:(0,d.getExcludes)(b,!_.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const _=g.flatten(b.map(A=>{let{pathPortion:F,globPortion:$}=v(A);$&&($=a($));const W=this.expandOneSearchPath(F);return g.flatten(W.map(Q=>this.resolveOneSearchPathPattern(Q,$)))})),o=new Map;return _.forEach(A=>{const F=A.searchPath.toString(),$=o.get(F);$?A.pattern&&($.pattern=$.pattern||{},$.pattern[A.pattern]=!0):o.set(F,{searchPath:A.searchPath,pattern:A.pattern?t(A.pattern):void 0})}),Array.from(o.values())}expandOneSearchPath(b){if(D.isAbsolute(b)){const _=this.workspaceContextService.getWorkspace().folders;return _[0]&&_[0].uri.scheme!==I.Schemas.file?[{searchPath:_[0].uri.with({path:b})}]:[{searchPath:u.URI.file(D.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const _=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=n(b),b.startsWith("../")||b===".."){const A=D.posix.resolve(_.path,b);return[{searchPath:_.with({path:A})}]}const o=a(b);return[{searchPath:_,pattern:o}]}else{if(b==="./"||b===".\\")return[];{const _=b.replace(/^\.[\/\\]/,""),A=this.workspaceContextService.getWorkspace().folders.map(F=>{const $=_.match(new RegExp(`^${i.escapeRegExpCharacters(F.name)}(?:/(.*)|$)`));return $?{match:$,folder:F}:null}).filter(P.isDefined);if(A.length)return A.map(F=>{const $=F.match[1];return{searchPath:F.folder.uri,pattern:$&&a($)}});{const F=b.match(/\.[\/\\](.+)[\/\\]?/),$=F?F[1]:b,W=l.localize(0,null,$);throw new Error(W)}}}}resolveOneSearchPathPattern(b,_){const o=b.pattern&&_?`${b.pattern}/${_}`:b.pattern||_,A=[{searchPath:b.searchPath,pattern:o}];return o&&!o.endsWith("**")&&A.push({searchPath:b.searchPath,pattern:o+"/**"}),A}getFolderQueryForSearchPath(b,_,o){const A=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(b.searchPath),_,o,!1);return A?{...A,includePattern:b.pattern}:null}getFolderQueryForRoot(b,_,o,A){let F;const $=u.URI.isUri(b)?b:b.uri;if(o.searchPaths){const x=o.searchPaths.filter(L=>(0,C.isEqual)(L.searchPath,$))[0];if(x&&!x.pattern)return null;x&&(F=x.pattern)}const W=this.configurationService.getValue({resource:$}),H={...this.getExcludesForFolder(W,_)||{},...F||{}},N=u.URI.isUri(b)?(0,C.basename)(b):b.name;return{folder:$,folderName:A?N:void 0,excludePattern:Object.keys(H).length>0?H:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof _.disregardIgnoreFiles=="boolean"?_.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof _.disregardGlobalIgnoreFiles=="boolean"?_.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof _.ignoreSymlinks=="boolean"?_.ignoreSymlinks:!W.search.followSymlinks}}};h=je([He(0,c.IConfigurationService),He(1,S.IWorkspaceContextService),He(2,w.IEditorGroupsService),He(3,E.IPathService)],h),e.QueryBuilder=h;function v(m){const b=m.match(/[\*\{\}\(\)\[\]\?]/);if(b){const _=b.index,o=m.substr(0,_).match(/[/|\\][^/\\]*$/);if(o){let A=m.substr(0,o.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:m.substr((o.index||0)+1)}}}return{pathPortion:m}}function t(...m){return m.length?m.reduce((b,_)=>(b[_]=!0,b),Object.create(null)):void 0}function s(m){return k.splitGlobAware(m,",").map(b=>b.trim()).filter(b=>!!b.length)}function r(m){return[`**/${m}/**`,`**/${m}`].map(_=>_.replace(/\*\*\/\*\*/g,"**"))}function n(m){return m.replace(/\\/g,"/")}function a(m){return n(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(m,b){m=g.distinct(m,A=>A.toString());const _=[],o=b.getWorkspace();return m&&m.forEach(A=>{let F;if(b.getWorkbenchState()===2)F=(0,C.relativePath)(o.folders[0].uri,A),F&&F!=="."&&(F="./"+F);else{const $=b.getWorkspaceFolder(A);if($){const W=$.name;if(o.folders.filter(H=>H.name===W).length===1){const H=(0,C.relativePath)($.uri,A);H===""?F=`./${$.name}`:F=`./${$.name}/${H}`}else F=A.fsPath}}F&&_.push(F)}),_}e.resolveResourcesForSearchIncludes=f}),define(he[261],fe([0,1,24,2,21,15,4,260,31,47]),function(X,e,g,R,k,y,T,I,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function P(c,S){const w=S.activationEvents;if(!w)return Promise.resolve(void 0);const E=[],d=[];for(const n of w)if(/^workspaceContains:/.test(n)){const a=n.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||c.forceUsingSearch?d.push(a):E.push(a)}if(E.length===0&&d.length===0)return Promise.resolve(void 0);let h;const v=new Promise((n,a)=>{h=n}),t=n=>h({activationEvent:n}),s=Promise.all(E.map(n=>u(c,n,t))).then(()=>{}),r=p(c,S.identifier,d,t);return Promise.all([s,r]).then(()=>{h(void 0)}),v}e.checkActivateWorkspaceContainsExtension=P;async function u(c,S,w){for(const E of c.folders)if(await c.exists(g.joinPath(R.URI.revive(E),S))){w(`workspaceContains:${S}`);return}}async function p(c,S,w,E){if(w.length===0)return Promise.resolve(void 0);const d=new k.CancellationTokenSource,h=c.checkExists(c.folders,w,d.token),v=setTimeout(async()=>{d.cancel(),E(`workspaceContainsTimeout:${w.join(",")}`)},i);let t=!1;try{t=await h}catch(s){y.isPromiseCanceledError(s)||y.onUnexpectedError(s)}d.dispose(),clearTimeout(v),t&&E(`workspaceContains:${w.join(",")}`)}function l(c,S,w,E){const d=c.get(T.IInstantiationService),h=c.get(D.ISearchService),t=d.createInstance(I.QueryBuilder).file(S.map(s=>(0,C.toWorkspaceFolder)(R.URI.revive(s))),{_reason:"checkExists",includePattern:w,exists:!0});return h.fileSearch(t,E).then(s=>!!s.limitHit,s=>y.isPromiseCanceledError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=l});var it=this&&this.__classPrivateFieldSet||function(X,e,g,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,g):k?k.value=g:e.set(X,g),g},xe=this&&this.__classPrivateFieldGet||function(X,e,g,R){if(g==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?R:g==="a"?R.call(X):R?R.value:e.get(X)};define(he[39],fe([0,1,160,9,67,24,17,6,23,2,12,5,36,220,89,35,34,218,15,26,22,196,7,116,4,27,63,13,81,49,33,3,261,87,198]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c,S,w,E,d,h,v,t,s,r,n,a,f,m,b,_,o,A,F,$){"use strict";var W,Q,H;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let N=class Vn extends I.Disposable{constructor(M,O,B,z,J,ce,ye,Fe,Re,Ne){super();this._onDidChangeRemoteConnectionData=this._register(new o.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=O,this._extHostContext=B,this._initData=ye,this._extHostWorkspace=z,this._extHostConfiguration=J,this._logService=ce,this._extHostTunnelService=Re,this._extHostTerminalService=Ne,this._disposables=new I.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new T.Barrier,this._readyToStartExtensionHost=new T.Barrier,this._readyToRunExtensions=new T.Barrier,this._eagerExtensionsActivated=new T.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new F.ExtHostSecretState(this._extHostContext),this._storagePath=Fe,this._instaService=M.createChild(new m.ServiceCollection([l.IExtHostStorage,this._storage],[F.IExtHostSecretState,this._secretState]));const Ve=new Set;this._initData.hostExtensions.forEach(ze=>Ve.add(d.ExtensionIdentifier.toKey(ze))),this._activator=new p.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,j,Z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,E.transformErrorForSerialization(j),Z)},actualActivateExtension:async(ze,j)=>{if(Ve.has(d.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,j),new p.HostExtension;const Z=this._registry.getExtensionDescription(ze);return this._activateExtension(Z,j)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){E.onUnexpectedError(M)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let M=[];try{M=this._registry.getAllExtensionDescriptions().map(J=>J.identifier).filter(J=>this.isActivated(J)).map(J=>this._deactivate(J))}catch(O){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,O){return this._activator.activateByEvent(M,O)}_activateById(M,O){return this._activator.activateById(M,O)}activateByIdWithErrors(M,O){return this._activateById(M,O).then(()=>{const B=this._activator.getActivatedExtension(M);if(B.activationFailed)return Promise.reject(B.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=D.TernarySearchTree.forPaths(),O=this._registry.getAllExtensionDescriptions().map(B=>{if(!!this._getEntryPoint(B))return this._hostUtils.realpath(B.extensionLocation.fsPath).then(z=>M.set(C.URI.file(z).fsPath,B))});this._extensionPathIndex=Promise.all(O).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let O=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return O;const B=this._activator.getActivatedExtension(M);if(!B)return O;try{typeof B.module.deactivate=="function"&&(O=Promise.resolve(B.module.deactivate()).then(void 0,z=>(this._logService.error(z),Promise.resolve(void 0))))}catch(z){this._logService.error(z)}try{(0,I.dispose)(B.subscriptions)}catch(z){this._logService.error(z)}return O}async _activateExtension(M,O){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,O).then(B=>{const z=B.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,z.codeLoadingTime,z.activateCallTime,z.activateResolvedTime,O),this._logExtensionActivationTimes(M,O,"success",z),B},B=>{throw this._logExtensionActivationTimes(M,O,"failure"),B})}_logExtensionActivationTimes(M,O,B,z){const J=x(M,O);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...J,...z||{},outcome:B})}_doActivateExtension(M,O){const B=x(M,O);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",B);const z=this._getEntryPoint(M);if(!z)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(O)}`),this._logService.flush();const J=new p.ExtensionActivationTimesBuilder(O.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,y.joinPath)(M.extensionLocation,z),J),this._loadExtensionContext(M)]).then(ce=>(k.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Vn._callActivate(this._logService,M.identifier,ce[0],ce[1],J))).then(ce=>(k.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),ce))}_loadExtensionContext(M){const O=new v.ExtensionGlobalMemento(M,this._storage),B=new v.ExtensionMemento(M.identifier.value,!1,this._storage),z=new $.ExtensionSecrets(M,this._secretState),J=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ce=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([O.whenReady,B.whenReady,this._storagePath.whenReady]).then(()=>{const ye=this;let Fe;return Object.freeze({globalState:O,workspaceState:B,secrets:z,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Re){return R.join(M.extensionLocation.fsPath,Re)},get storagePath(){return ye._storagePath.workspaceValue(M)?.fsPath},get globalStoragePath(){return ye._storagePath.globalValue(M).fsPath},get logPath(){return R.join(ye._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return C.URI.joinPath(ye._initData.logsLocation,M.identifier.value)},get storageUri(){return ye._storagePath.workspaceValue(M)},get globalStorageUri(){return ye._storagePath.globalValue(M)},get extensionMode(){return J},get extension(){return Fe===void 0&&(Fe=new L(ye,M.identifier,M,ce)),Fe},get extensionRuntime(){return(0,S.checkProposedApiEnabled)(M),ye.extensionRuntime},get environmentVariableCollection(){return ye._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,O,B,z,J){return B=B||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,O,B,z,J).then(ce=>new p.ActivatedExtension(!1,null,J.build(),B,ce,z.subscriptions))}static _callActivateOptional(M,O,B,z,J){if(typeof B.activate=="function")try{J.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${O.value}`);const ce=typeof global=="object"?global:self,ye=B.activate.apply(ce,[z]);return J.activateCallStop(),J.activateResolveStart(),Promise.resolve(ye).then(Fe=>(J.activateResolveStop(),Fe))}catch(ce){return Promise.reject(ce)}else return Promise.resolve(B)}_activateOneStartupFinished(M,O){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:O}).then(void 0,B=>{this._logService.error(B)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const O of M.activationEvents)O==="onStartupFinished"&&this._activateOneStartupFinished(M,O)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,J=>{this._logService.error(J)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(J=>this._handleWorkspaceContainsEagerExtensions(J.added)));const O=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],B=this._handleWorkspaceContainsEagerExtensions(O),z=Promise.all([M,B]).then(()=>{});return Promise.race([z,(0,T.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),z}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(O=>this._handleWorkspaceContainsEagerExtension(M,O))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,O){if(this.isActivated(O.identifier))return;const B=!this._initData.remote.isRemote&&!!this._initData.remote.authority,z={folders:M.map(ce=>ce.uri),forceUsingSearch:B,exists:ce=>this._hostUtils.exists(ce.fsPath),checkExists:(ce,ye,Fe)=>this._mainThreadWorkspaceProxy.$checkExists(ce,ye,Fe)},J=await(0,A.checkActivateWorkspaceContainsExtension)(z,O);if(!!J)return this._activateById(O.identifier,{startup:!0,extensionId:O.identifier,activationEvent:J.activationEvent}).then(void 0,ce=>this._logService.error(ce))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:O}=this._initData.environment;if(!M||!O)throw new Error(g.localize(0,null));const B=await this._loadCommonJSModule(null,O,new p.ExtensionActivationTimesBuilder(!1));if(!B||typeof B.run!="function")throw new Error(g.localize(1,null,O.toString()));return new Promise((z,J)=>{const ce=(Re,Ne)=>{Re?J(Re):z(typeof Ne=="number"&&Ne>0?1:0)},ye=(0,y.originalFSPath)(O),Fe=B.run(ye,ce);Fe&&Fe.then&&Fe.then(()=>{z(0)}).catch(Re=>{J(Re.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,O){return this._resolvers[M]=O,(0,I.toDisposable)(()=>{delete this._resolvers[M]})}async _activateAndGetResolver(M){const O=M.indexOf("+");if(O===-1)throw new Error("Not an authority that can be resolved!");const B=M.substr(0,O);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${B}`,!1),{authorityPrefix:B,resolver:this._resolvers[B]}}async $resolveAuthority(M,O){const{authorityPrefix:B,resolver:z}=await this._activateAndGetResolver(M);if(!z)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${B}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(z)),k.mark(`code/extHost/willResolveAuthority/${B}`);const J=await z.resolve(M,{resolveAttempt:O});k.mark(`code/extHost/didResolveAuthorityOK/${B}`);const ce={authority:M,host:J.host,port:J.port,connectionToken:J.connectionToken},ye={extensionHostEnv:J.extensionHostEnv,isTrusted:J.isTrusted};return{type:"ok",value:{authority:ce,options:ye,tunnelInformation:{environmentTunnels:J.environmentTunnels}}}}catch(J){if(k.mark(`code/extHost/didResolveAuthorityError/${B}`),J instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J}}async $getCanonicalURI(M,O){const{authorityPrefix:B,resolver:z}=await this._activateAndGetResolver(M);if(!z)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${B}`);const J=C.URI.revive(O);if(typeof z.getCanonicalURI=="undefined")return J;const ce=await(0,T.asPromise)(()=>z.getCanonicalURI(J));return ce||J}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,O){return O===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(B=>this._activateByEvent(M,!1))}async $activate(M,O){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,O),!0):!1}async $deltaExtensions(M,O){M.forEach(z=>z.extensionLocation=C.URI.revive(z.extensionLocation));const B=await this.getExtensionPathIndex();return await Promise.all(O.map(async z=>{const J=this._registry.getExtensionDescription(z);if(!J)return;const ce=await this._hostUtils.realpath(J.extensionLocation.fsPath);B.delete(C.URI.file(ce).fsPath)})),await Promise.all(M.map(async z=>{const J=await this._hostUtils.realpath(z.extensionLocation.fsPath);B.set(C.URI.file(J).fsPath,z)})),this._registry.deltaExtensions(M,O),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let O=h.VSBuffer.alloc(M),B=Math.random()%256;for(let z=0;z<M;z++)O.writeUInt8(B,z);return O}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};N=je([He(0,r.IInstantiationService),He(1,e.IHostUtils),He(2,f.IExtHostRpcService),He(3,c.IExtHostWorkspace),He(4,u.IExtHostConfiguration),He(5,i.ILogService),He(6,n.IExtHostInitDataService),He(7,a.IExtensionStoragePaths),He(8,b.IExtHostTunnelService),He(9,_.IExtHostTerminalService)],N),e.AbstractExtHostExtensionService=N;function x(G,M){return{id:G.identifier.value,name:G.name,extensionVersion:G.version,publisherDisplayName:G.publisher,activationEvents:G.activationEvents?G.activationEvents.join(","):null,isBuiltin:G.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class L{constructor(M,O,B,z){W.set(this,void 0),Q.set(this,void 0),H.set(this,void 0),it(this,W,M,"f"),it(this,Q,O,"f"),it(this,H,B.identifier,"f"),this.id=B.identifier.value,this.extensionUri=B.extensionLocation,this.extensionPath=R.normalize((0,y.originalFSPath)(B.extensionLocation)),this.packageJSON=B,this.extensionKind=z}get isActive(){return xe(this,W,"f").isActivated(xe(this,H,"f"))}get exports(){if(this.packageJSON.api!=="none")return xe(this,W,"f").getExtensionExports(xe(this,H,"f"))}activate(){return xe(this,W,"f").activateByIdWithErrors(xe(this,H,"f"),{startup:!1,extensionId:xe(this,Q,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=L,W=new WeakMap,Q=new WeakMap,H=new WeakMap}),define(he[51],fe([0,1,9,2,3,17,5,7,120,35,39,43,209,36,204,13,4,14,37,48]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c,S,w,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let h=class{constructor(m,b,_,o,A,F){this._workspaceService=b,this._extensionService=_,this._editorsService=o,this._configurationService=A,this._editorTabs=F,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=m.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then($=>{$.onDidChange(W=>{this.registerAllDebugTypes($)}),this.registerAllDebugTypes($)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,b){const _=m;if(typeof _.sourceReference=="number"&&_.sourceReference>0){let o=`debug:${encodeURIComponent(_.path||"")}`,A="?";return b&&(o+=`${A}session=${encodeURIComponent(b.id)}`,A="&"),o+=`${A}ref=${_.sourceReference}`,R.URI.parse(o)}else{if(_.path)return R.URI.file(_.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const b=[];for(const _ of m.getAllExtensionDescriptions())if(_.contributes){const o=_.contributes.debuggers;if(o&&o.length>0)for(const A of o)(0,l.isDebuggerMainContribution)(A)&&b.push(A.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(b=>m.push(b)),m}addBreakpoints(m){this.startBreakpoints();const b=m.filter(A=>{const F=A.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,A),!0)});this.fireBreakpointChanges(b,[],[]);const _=[],o=new Map;for(const A of b)if(A instanceof I.SourceBreakpoint){let F=o.get(A.location.uri.toString());F||(F={type:"sourceMulti",uri:A.location.uri,lines:[]},o.set(A.location.uri.toString(),F),_.push(F)),F.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character})}else A instanceof I.FunctionBreakpoint&&_.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName});return this._debugServiceProxy.$registerBreakpoints(_)}removeBreakpoints(m){this.startBreakpoints();const b=m.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],b,[]);const _=b.filter(F=>F instanceof I.SourceBreakpoint).map(F=>F.id),o=b.filter(F=>F instanceof I.FunctionBreakpoint).map(F=>F.id),A=b.filter(F=>F instanceof I.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(_,o,A)}startDebugging(m,b,_){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,b,{parentSessionID:_.parentSession?_.parentSession.id:void 0,repl:_.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:_.noDebug,compact:_.compact})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,b,_){if(!b)return new I.Disposable(()=>{});const o=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:o,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,_,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,o),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(A=>A.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(o)})}registerDebugAdapterDescriptorFactory(m,b,_){if(!_)return new I.Disposable(()=>{});if(!this.definesDebugType(m,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const o=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:o,factory:_}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,o),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(A=>A.factory!==_),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(o)})}registerDebugAdapterTrackerFactory(m,b){if(!b)return new I.Disposable(()=>{});const _=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:_,factory:b}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(o=>o.factory!==b)})}async $runInTerminal(m,b){return Promise.resolve(void 0)}async $substituteVariables(m,b){if(!this._variableResolver){const[A,F]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(A||[],this._editorsService,F)}let _;const o=await this.getFolder(m);return o&&(_={uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(_,b)}createDebugAdapter(m,b){if(m.type==="implementation")return new n(m.implementation)}createSignService(){}async $startDASession(m,b){const _=this,o=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(o.type),o).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}' (extension might have failed to activate)`);const F=this.convertToDto(A),$=this.createDebugAdapter(F,o);if(!$)throw new Error(`Couldn't create a debug adapter for type '${o.type}'.`);const W=$;return this._debugAdapters.set(m,W),this.getDebugAdapterTrackers(o).then(Q=>(Q&&this._debugAdaptersTrackers.set(m,Q),W.onMessage(async H=>{if(H.type==="request"&&H.command==="handshake"){const N=H,x={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(N.arguments.value);x.body={signature:L},W.sendResponse(x)}else throw new Error("no signer")}catch(L){x.success=!1,x.message=L.message,W.sendResponse(x)}}else Q&&Q.onDidSendMessage&&Q.onDidSendMessage(H),H=(0,l.convertToVSCPaths)(H,!0),_._debugServiceProxy.$acceptDAMessage(m,H)}),W.onError(H=>{Q&&Q.onError&&Q.onError(H),this._debugServiceProxy.$acceptDAError(m,H.name,H.message,H.stack)}),W.onExit(H=>{Q&&Q.onExit&&Q.onExit((0,w.withNullAsUndefined)(H),void 0),this._debugServiceProxy.$acceptDAExit(m,(0,w.withNullAsUndefined)(H),void 0)}),Q&&Q.onWillStartSession&&Q.onWillStartSession(),W.startSession()))})}$sendDAMessage(m,b){b=(0,l.convertToDAPaths)(b,!1);const _=this._debugAdaptersTrackers.get(m);_&&_.onWillReceiveMessage&&_.onWillReceiveMessage(b);const o=this._debugAdapters.get(m);o&&o.sendMessage(b)}$stopDASession(m){const b=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),b&&b.onWillStopSession&&b.onWillStopSession();const _=this._debugAdapters.get(m);return this._debugAdapters.delete(m),_?_.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const b=[],_=[],o=[];if(m.added)for(const A of m.added){const F=A.id;if(F&&!this._breakpoints.has(F)){let $;if(A.type==="function")$=new I.FunctionBreakpoint(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage);else if(A.type==="data")$=new I.DataBreakpoint(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage);else{const W=R.URI.revive(A.uri);$=new I.SourceBreakpoint(new I.Location(W,new I.Position(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage)}$._id=F,this._breakpoints.set(F,$),b.push($)}}if(m.removed)for(const A of m.removed){const F=this._breakpoints.get(A);F&&(this._breakpoints.delete(A),_.push(F))}if(m.changed){for(const A of m.changed)if(A.id){const F=this._breakpoints.get(A.id);if(F){if(F instanceof I.FunctionBreakpoint&&A.type==="function"){const $=F;$.enabled=A.enabled,$.condition=A.condition,$.hitCondition=A.hitCondition,$.logMessage=A.logMessage,$.functionName=A.functionName}else if(F instanceof I.SourceBreakpoint&&A.type==="source"){const $=F;$.enabled=A.enabled,$.condition=A.condition,$.hitCondition=A.hitCondition,$.logMessage=A.logMessage,$.location=new I.Location(R.URI.revive(A.uri),new I.Position(A.line,A.character))}o.push(F)}}}this.fireBreakpointChanges(b,_,o)}$provideDebugConfigurations(m,b,_){return(0,y.asPromise)(async()=>{const o=this.getConfigProviderByHandle(m);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.getFolder(b);return o.provideDebugConfigurations(A,_)}).then(o=>{if(!o)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return o})}$resolveDebugConfiguration(m,b,_,o){return(0,y.asPromise)(async()=>{const A=this.getConfigProviderByHandle(m);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(b);return A.resolveDebugConfiguration(F,_,o)})}$resolveDebugConfigurationWithSubstitutedVariables(m,b,_,o){return(0,y.asPromise)(async()=>{const A=this.getConfigProviderByHandle(m);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(b);return A.resolveDebugConfigurationWithSubstitutedVariables(F,_,o)})}async $provideDebugAdapter(m,b){const _=this.getAdapterDescriptorFactoryByHandle(m);if(!_)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const o=await this.getSession(b);return this.getAdapterDescriptor(_,o).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}'`);return this.convertToDto(A)})}async $acceptDebugSessionStarted(m){const b=await this.getSession(m);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(m){const b=await this.getSession(m);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,b){const _=await this.getSession(m);_&&_._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(m,b){const o={session:await this.getSession(m),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(o)}convertToDto(m){if(m instanceof I.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof I.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const b=this._adapterFactories.filter(_=>_.type===m);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(m){const b=this._adapterFactories.filter(_=>_.handle===m);if(b.length>0)return b[0].factory}getConfigProviderByHandle(m){const b=this._configProviders.filter(_=>_.handle===m);if(b.length>0)return b[0].provider}definesDebugType(m,b){if(m.contributes){const _=m.contributes.debuggers;if(_&&_.length>0){for(const o of _)if(o.label&&o.type&&o.type===b)return!0}}return!1}getDebugAdapterTrackers(m){const _=m.configuration.type,o=this._trackerFactories.filter(A=>A.type===_||A.type==="*").map(A=>(0,y.asPromise)(()=>A.factory.createDebugAdapterTracker(m)).then(F=>F,F=>null));return Promise.race([Promise.all(o).then(A=>{const F=A.filter($=>!!$);if(F.length>0)return new r(F)}),new Promise((A,F)=>{const $=setTimeout(()=>{clearTimeout($),F(new Error("timeout"))},1e3)})]).catch(A=>{})}async getAdapterDescriptor(m,b){const _=b.configuration.debugServer;if(typeof _=="number")return Promise.resolve(new I.DebugAdapterServer(_));if(m){const A=await this._extensionService.getExtensionRegistry();return(0,y.asPromise)(()=>m.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,A))).then(F=>{if(F)return F})}const o=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,o))}daExecutableFromPackage(m,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,b,_){(m.length>0||b.length>0||_.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:b,changed:_}))}async getSession(m){if(m)if(typeof m=="string"){const b=this._debugSessions.get(m);if(b)return b}else{let b=this._debugSessions.get(m.id);if(!b){const _=await this.getFolder(m.folderUri),o=m.parent?this._debugSessions.get(m.parent):void 0;b=new v(this._debugServiceProxy,m.id,m.type,m.name,_,m.configuration,o),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(m){if(m){const b=R.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};h=je([He(0,c.IExtHostRpcService),He(1,C.IExtHostWorkspace),He(2,i.IExtHostExtensionService),He(3,P.IExtHostDocumentsAndEditors),He(4,p.IExtHostConfiguration),He(5,d.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class v{constructor(m,b,_,o,A,F,$){this._debugServiceProxy=m,this._id=b,this._type=_,this._name=o,this._workspaceFolder=A,this._configuration=F,this._parentSession=$}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}get parentSession(){return this._parentSession}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,b)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=v;class t{constructor(m){this.value=Object.freeze({append(b){m.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=t;class s extends u.AbstractVariableResolverService{constructor(m,b,_,o,A){function F(){if(b){const $=b.activeEditor();if($)return $.document.uri;const W=o.tabs.filter(Q=>Q.isActive);if(W.length>0)return W[0].resource}}super({getFolderUri:$=>{const W=m.filter(Q=>Q.name===$);if(W&&W.length>0)return W[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:($,W)=>_.getConfiguration(void 0,$).get(W),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=F();if($)return g.normalize($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(A){const $=F();if($){const W=A.getWorkspaceFolder($);if(W)return g.normalize(W.uri.fsPath)}}},getSelectedText:()=>{if(b){const $=b.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(b){const $=b.activeEditor();if($)return String($.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=s;class r{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(b=>b.onError?b.onError(m):void 0)}onExit(m,b){this.trackers.forEach(_=>_.onExit?_.onExit(m,b):void 0)}}class n extends D.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends h{constructor(m,b,_,o,A,F){super(m,b,_,o,A,F)}createVariableResolver(m,b,_){return new s(m,b,_,this._editorTabs)}};a=je([He(0,c.IExtHostRpcService),He(1,C.IExtHostWorkspace),He(2,i.IExtHostExtensionService),He(3,P.IExtHostDocumentsAndEditors),He(4,p.IExtHostConfiguration),He(5,d.IExtHostEditorTabs)],a),e.WorkerExtHostDebugService=a}),define(he[262],fe([0,1,67,2,5,36,34,26,13,27,4,39,37,12]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(d,h,v,t,s,r,n){this._apiFactory=d,this._extensionRegistry=h,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=s,this._initData=r,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const d=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new c(this._apiFactory,h,this._extensionRegistry,d,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,h,this._initData.environment.appUriScheme))}register(d){if(Array.isArray(d.nodeModuleName))for(let h of d.nodeModuleName)this._factories.set(h,d);else this._factories.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this._alternatives.push(h=>d.alternativeModuleName(h))}};l=je([He(2,i.IInstantiationService),He(3,y.IExtHostConfiguration),He(4,P.IExtHostExtensionService),He(5,C.IExtHostInitDataService),He(6,p.ILogService)],l),e.RequireInterceptor=l;class c{constructor(d,h,v,t,s){this._apiFactory=d,this._extensionPaths=h,this._extensionRegistry=v,this._configProvider=t,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(d,h){const v=this._extensionPaths.findSubstr(h.fsPath);if(v){let t=this._extApiImpl.get(I.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((s,r)=>t+=`	${r} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(T.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(d,h){this.nodeModuleName="keytar";const{environment:v}=h,t=d.getProxy(k.MainContext.MainThreadKeytar);if(v.appRoot){let s=v.appRoot.fsPath;u.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,r)=>t.$getPassword(s,r),setPassword:(s,r,n)=>t.$setPassword(s,r,n),deletePassword:(s,r)=>t.$deletePassword(s,r),findPassword:s=>t.$findPassword(s),findCredentials(s){return t.$findCredentials(s)}}}load(d,h){return this._impl}alternativeModuleName(d){const h=d.length;if(h<=7||!this.alternativeNames)return;const v=h-7;if((d.charAt(v)==="/"||d.charAt(v)==="\\")&&d.endsWith("keytar")&&(d=d.replace(/\\/g,"/"),this.alternativeNames.has(d)))return"keytar"}};S=je([He(0,D.IExtHostRpcService),He(1,C.IExtHostInitDataService)],S);let w=class{constructor(d,h,v){this._extensionPaths=d,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(k.MainContext.MainThreadTelemetry);const t=v.getProxy(k.MainContext.MainThreadWindow);this._impl=(s,r)=>{const n=R.URI.parse(s);return r?this.callOriginal(s,r):n.scheme==="http"||n.scheme==="https"?t.$openUri(n,s,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?t.$openUri(n,s,{}):this.callOriginal(s,r)}}load(d,h,v){const t=this._extensionPaths.findSubstr(h.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(d),this._impl}callOriginal(d,h){return this.sendNoForwardTelemetry(),this._original(d,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=je([He(2,D.IExtHostRpcService)],w)}),define(he[263],fe([0,1,166,11,7,205,35,39,43,36,33,13,51,190,17,206,48]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends u.ExtHostDebugServiceBase{constructor(h,v,t,s,r,n,a){super(h,v,t,s,r,a);this._terminalService=n,this._integratedTerminalInstances=new E}createDebugAdapter(h,v){switch(h.type){case"server":return new y.SocketDebugAdapter(h);case"pipeServer":return new y.NamedPipeDebugAdapter(h);case"executable":return new y.ExecutableDebugAdapter(h,v.type)}return super.createDebugAdapter(h,v)}daExecutableFromPackage(h,v){const t=y.ExecutableDebugAdapter.platformAdapterExecutable(v.getAllExtensionDescriptions(),h.type);if(t)return new k.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new p.SignService}async $runInTerminal(h,v){if(h.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(F=>{this._integratedTerminalInstances.onTerminalClosed(F)}));const t=await this._configurationService.getConfigProvider(),s=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),n=h.title||g.localize(0,null),a=JSON.stringify({shell:s,shellArgs:r});let f=await this._integratedTerminalInstances.checkout(a,n),m,b=!1;if(f)m=h.cwd;else{const F={shellPath:s,shellArgs:r,cwd:h.cwd,name:n,iconPath:new k.ThemeIcon("debug")};b=!0,f=this._terminalService.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(f,a)}f.show(!0);const _=await f.processId;b?await new Promise(F=>setTimeout(F,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(s.indexOf("powershell")>=0||s.indexOf("pwsh")>=0||s.indexOf("cmd.exe")>=0?f.sendText("cls"):s.indexOf("bash")>=0?f.sendText("clear"):R.isWindows?f.sendText("cls"):f.sendText("clear"));const o=(0,c.prepareCommand)(s,h.args,m,h.env);f.sendText(o);const A=this.onDidTerminateDebugSession(F=>{F.id===v&&(this._integratedTerminalInstances.free(f),A.dispose())});return _}else if(h.kind==="external")return(0,c.runInExternalTerminal)(h,await this._configurationService.getConfigProvider());return super.$runInTerminal(h,v)}createVariableResolver(h,v,t){return new u.ExtHostVariableResolverService(h,v,t,this._editorTabs,this._workspaceService)}};w=je([He(0,P.IExtHostRpcService),He(1,T.IExtHostWorkspace),He(2,I.IExtHostExtensionService),He(3,D.IExtHostDocumentsAndEditors),He(4,C.IExtHostConfiguration),He(5,i.IExtHostTerminalService),He(6,S.IExtHostEditorTabs)],w),e.ExtHostDebugService=w;class E{constructor(){this._terminalInstances=new Map}async checkout(h,v){const s=[...this._terminalInstances.entries()].map(([r,n])=>(0,l.createCancelablePromise)(async a=>{if(r.name!==v||n.lastUsedAt!==-1&&await(0,c.hasChildProcesses)(await r.processId))return null;const f=Date.now();return n.lastUsedAt+E.minUseDelay>f||a.isCancellationRequested||n.config!==h?null:(n.lastUsedAt=f,r)}));return await(0,l.firstParallel)(s,r=>!!r)}insert(h,v){this._terminalInstances.set(h,{lastUsedAt:Date.now(),config:v})}free(h){const v=this._terminalInstances.get(h);v&&(v.lastUsedAt=-1)}onTerminalClosed(h){this._terminalInstances.delete(h)}}E.minUseDelay=1e3}),define(he[264],fe([0,1,9,2,110,35,51,43,36,33,13,27,66,10,12,61,48]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let w=class extends u.ExtHostTaskBase{constructor(d,h,v,t,s,r,n,a,f){super(d,h,v,t,s,r,n,a);this.workspaceService=v,this.editorTabs=f,h.remote.isRemote&&h.remote.authority?this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:h.remote.authority,platform:process.platform}):this.registerTaskSystem(p.Schemas.file,{scheme:p.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(d,h){const v=h;if(!h.execution&&v._id===void 0)throw new Error("Tasks to execute must include an execution");if(v._id!==void 0){const t=u.TaskHandleDTO.from(v,this.workspaceService),s=await this._proxy.$getTaskExecution(t);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.getTaskExecution(s,h);return this._proxy.$executeTask(t).catch(()=>{}),r}else{const t=u.TaskDTO.from(h,d);if(t===void 0)return Promise.reject(new Error("Task is not valid"));u.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,h,!1);const s=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),h);return this._proxy.$executeTask(t).catch(()=>{}),s}}provideTasksInternal(d,h,v,t){const s=[];if(t)for(let r of t){this.checkDeprecation(r,v),(!r.definition||!d[r.definition.type])&&this._logService.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const n=u.TaskDTO.from(r,v.extension);n&&(s.push(n),u.CustomExecutionDTO.is(n.execution)&&h.push(this.addCustomExecution(n,r,!0)))}return{tasks:s,extension:v.extension}}async resolveTaskInternal(d){return d}async getVariableResolver(d){if(this._variableResolver===void 0){const h=await this._configurationService.getConfigProvider();this._variableResolver=new T.ExtHostVariableResolverService(d,this._editorService,h,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(d,h){const v=R.URI.revive(d),t={process:void 0,variables:Object.create(null)},s=await this._workspaceProvider.resolveWorkspaceFolder(v),r=await this._workspaceProvider.getWorkspaceFolders2();if(!r||!s)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const n=await this.getVariableResolver(r),a={uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}};for(let f of h.variables)t.variables[f]=await n.resolveAsync(a,f);if(h.process!==void 0){let f;if(h.process.path!==void 0){f=h.process.path.split(g.delimiter);for(let m=0;m<f.length;m++)f[m]=await n.resolveAsync(a,f[m])}t.process=await k.win32.findExecutable(await n.resolveAsync(a,h.process.name),h.process.cwd!==void 0?await n.resolveAsync(a,h.process.cwd):void 0,f)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(d,h,v){return k.win32.findExecutable(d,h,v)}};w=je([He(0,i.IExtHostRpcService),He(1,P.IExtHostInitDataService),He(2,y.IExtHostWorkspace),He(3,I.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,C.IExtHostTerminalService),He(6,l.ILogService),He(7,c.IExtHostApiDeprecationService),He(8,S.IExtHostEditorTabs)],w),e.ExtHostTask=w}),define(he[265],fe([0,1,17,15,67,6,2,5,257,12,78,81,27,183,13,60,39,33]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(h,v,t,s){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new D.RPCProtocol(h,null,s),v=E._transform(v,this._rpcProtocol);const r=new P.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());r.set(u.IExtHostInitDataService,{_serviceBrand:void 0,...v}),r.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),r.set(c.IURITransformerService,new c.URITransformerService(s)),r.set(S.IHostUtils,t);const n=new p.InstantiationService(r,!0),a=n.invokeFunction(_=>_.get(w.IExtHostTerminalService));this._disposables.add(a),this._logService=n.invokeFunction(_=>_.get(C.ILogService)),k.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=n.invokeFunction(_=>_.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const f=new WeakMap;this._extensionService.getExtensionPathIndex().then(_=>{Error.prepareStackTrace=(o,A)=>{let F="",$,W;for(const Q of A)F+=`
	at ${Q.toString()}`,W=Q.getFileName(),!$&&W&&($=_.findSubstr(W));return f.set(o,$),`${o.name||"Error"}: ${o.message||""}${F}`}});const m=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),b=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(_=>{const o=R.transformErrorForSerialization(_),A=f.get(_);A?m.$onExtensionRuntimeError(A.identifier,o):b.$onUnexpectedError(o)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(h,v){h.extensions.forEach(s=>s.extensionLocation=T.URI.revive(v.transformIncomingURIs(s.extensionLocation))),h.environment.appRoot=T.URI.revive(v.transformIncomingURIs(h.environment.appRoot));const t=h.environment.extensionDevelopmentLocationURI;return t&&(h.environment.extensionDevelopmentLocationURI=t.map(s=>T.URI.revive(v.transformIncomingURIs(s)))),h.environment.extensionTestsLocationURI=T.URI.revive(v.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=T.URI.revive(v.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=T.URI.revive(v.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=T.URI.revive(v.transformIncomingURIs(h.logsLocation)),h.logFile=T.URI.revive(v.transformIncomingURIs(h.logFile)),h.workspace=v.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=E}),define(he[266],fe([0,1,9,21,58,30,24,44,31]),function(X,e,g,R,k,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(u,p,l){this.config=u,this.provider=p,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=u.filePattern,this.includePattern=u.includePattern&&y.parse(u.includePattern),this.maxResults=u.maxResults||void 0,this.exists=u.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=u.excludePattern&&y.parse(u.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(u=>u.cancel()),this.activeCancellationTokens=new Set}search(u){const p=this.config.folderQueries||[];return new Promise((l,c)=>{const S=w=>{this.resultCount++,u(w)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const E=w.toString(),d=g.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,d)||this.matchFile(S,{base:w,basename:d})}),Promise.all(p.map(w=>this.searchInFolder(w,S))).then(w=>{l({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{c(new Error((0,k.toErrorMessage)(w)))})})}async searchInFolder(u,p){const l=new R.CancellationTokenSource,c=this.getSearchOptionsForFolder(u),S=this.initDirectoryTree(),w=new D.QueryGlobTester(this.config,u),E=!w.hasSiblingExcludeClauses();let d;try{this.activeCancellationTokens.add(l),d=I.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},c,l.token),v=d.elapsed(),t=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(s=>{const r=g.posix.relative(u.folder.path,s.path);if(E){const n=g.basename(s.path);this.matchFile(p,{base:u.folder,relativePath:r,basename:n});return}this.addDirectoryEntries(S,u.folder,r,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(S,w,p),{providerTime:v,postProcessTime:t.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(u){const p=(0,D.resolvePatternsForProvider)(this.config.includePattern,u.includePattern),l=(0,D.resolvePatternsForProvider)(this.config.excludePattern,u.excludePattern);return{folder:u.folder,excludes:l,includes:p,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}addDirectoryEntries({pathToEntries:u},p,l,c){if(l===this.filePattern){const w=g.basename(this.filePattern);this.matchFile(c,{base:p,relativePath:this.filePattern,basename:w})}function S(w){const E=g.basename(w),d=g.dirname(w);let h=u[d];h||(h=u[d]=[],S(d)),h.push({base:p,relativePath:w,basename:E})}S(l)}matchDirectoryTree({rootEntries:u,pathToEntries:p},l,c){const S=this,w=this.filePattern;function E(d){const h=y.hasSiblingFn(()=>d.map(v=>v.basename));for(let v=0,t=d.length;v<t;v++){const s=d[v],{relativePath:r,basename:n}=s;if(!l.includedInQuerySync(r,n,w!==n?h:void 0))continue;const a=p[r];if(a)E(a);else{if(r===w)continue;S.matchFile(c,s)}if(S.isLimitHit)break}}E(u)}matchFile(u,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||u(p))}}class i{constructor(){this.sessions=new Map}fileSearch(u,p,l,c){const S=this.getSessionTokenSource(u.cacheKey),w=new C(u,p,S&&S.token);let E=0;const d=h=>{E+=h.length,l(h.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(w,i.BATCH_SIZE,d,c).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:h.stats}}))}clearCache(u){const p=this.getSessionTokenSource(u);p&&p.cancel()}getSessionTokenSource(u){if(!!u)return this.sessions.has(u)||this.sessions.set(u,new R.CancellationTokenSource),this.sessions.get(u)}rawMatchToSearchItem(u){return u.relativePath?{resource:T.joinPath(u.base,u.relativePath)}:{resource:u.base}}doSearch(u,p,l,c){c.onCancellationRequested(()=>{u.cancel()});const S=E=>{E&&(w.push(E),p>0&&w.length>=p&&(l(w),w=[]))};let w=[];return u.search(S).then(E=>(w.length&&l(w),E),E=>(w.length&&l(w),Promise.reject(E)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(he[129],fe([0,1,9,18,21,58,24,30,2,31,10,14]),function(X,e,g,R,k,y,T,I,D,C,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class u{constructor(d,h,v){this.query=d,this.provider=h,this.fileUtils=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,h){const v=this.query.folderQueries||[],t=new k.CancellationTokenSource;return h.onCancellationRequested(()=>t.cancel()),new Promise((s,r)=>{this.collector=new l(d);let n=!1;const a=(f,m)=>{if(!n&&!this.isLimitHit){const b=this.resultSize(f);S(f)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,n=!0,t.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const _=this.resultSize(f);this.resultCount+=_,(_>0||!S(f))&&this.collector.add(f,m)}};Promise.all(v.map((f,m)=>this.searchInFolder(f,b=>a(b,m),t.token))).then(f=>{t.dispose(),this.collector.flush();const m=f.some(b=>!!b&&!!b.limitHit);s({limitHit:this.isLimitHit||m,messages:(0,R.flatten)(f.map(b=>b?.message?(0,P.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:"textSearchProvider"}})},f=>{t.dispose();const m=(0,y.toErrorMessage)(f);r(new Error(m))})})}resultSize(d){return S(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,h){const v=Array.isArray(d.ranges)?d.ranges:[d.ranges],t=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:v.slice(0,h),preview:{matches:t.slice(0,h),text:d.preview.text},uri:d.uri}}async searchInFolder(d,h,v){const t=new C.QueryGlobTester(this.query,d),s=[],r={report:f=>{if(!this.validateProviderResult(f))return;const m=d.folder.scheme===i.Schemas.file?I.hasSiblingPromiseFn(()=>this.fileUtils.readdir(T.dirname(f.uri))):void 0,b=T.relativePath(d.folder,f.uri);b&&s.push(t.includedInQuery(b,g.basename(b),m).then(_=>{_&&h(f)}))}},n=this.getSearchOptionsForFolder(d),a=await this.provider.provideTextSearchResults(p(this.query.contentPattern),n,r,v);return await Promise.all(s),a}validateProviderResult(d){if(S(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const h=(0,C.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),v=(0,C.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),t={folder:D.URI.from(d.folder),excludes:v,includes:h,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=u;function p(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class l{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,h=>this.sendItems(h))}add(d,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!T.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(c(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=l;function c(E){return S(E)?{preview:{matches:(0,R.mapArrayOrNot)(E.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:E.preview.text},ranges:(0,R.mapArrayOrNot)(E.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function S(E){return!!E.preview}e.extensionResultIsMatch=S;class w{constructor(d,h){this.maxBatchSize=d,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,h){!d||this.addItemToBatch(d,h)}addItems(d,h){!d||this.addItemsToBatch(d,h)}addItemToBatch(d,h){this.batch.push(d),this.batchSize+=h,this.onUpdate()}addItemsToBatch(d,h){this.batch=this.batch.concat(d),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(he[68],fe([0,1,6,5,4,266,13,60,12,2,129]),function(X,e,g,R,k,y,T,I,D,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,k.createDecorator)("IExtHostSearch");let P=class{constructor(c,S,w){this.extHostRpc=c,this._uriTransformer=S,this._logService=w,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(c){return this._uriTransformer.transformOutgoingScheme(c)}registerTextSearchProvider(c,S){if(this._textSearchUsedSchemes.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this._textSearchUsedSchemes.add(c);const w=this._handlePool++;return this._textSearchProvider.set(w,S),this._proxy.$registerTextSearchProvider(w,this._transformScheme(c)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(c),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(c,S){if(this._fileSearchUsedSchemes.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this._fileSearchUsedSchemes.add(c);const w=this._handlePool++;return this._fileSearchProvider.set(w,S),this._proxy.$registerFileSearchProvider(w,this._transformScheme(c)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(c),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(c,S,w,E){const d=u(w),h=this._fileSearchProvider.get(c);if(h)return this._fileSearchManager.fileSearch(d,h,v=>{this._proxy.$handleFileMatch(c,S,v.map(t=>t.resource))},E);throw new Error("unknown provider: "+c)}$clearCache(c){return this._fileSearchManager.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,S,w,E){const d=this._textSearchProvider.get(c);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const h=u(w);return this.createTextSearchManager(h,d).search(t=>this._proxy.$handleTextMatch(c,S,t),E)}createTextSearchManager(c,S){return new i.TextSearchManager(c,S,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};P=je([He(0,T.IExtHostRpcService),He(1,I.IURITransformerService),He(2,D.ILogService)],P),e.ExtHostSearch=P;function u(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(p),extraFileResources:l.extraFileResources&&l.extraFileResources.map(c=>C.URI.revive(c))}}e.reviveQuery=u;function p(l){return{...l,folder:C.URI.revive(l.folder)}}}),define(he[267],fe([0,1,21,15,3,56,2,151,106,142,77,41,5,226,225,50,227,36,228,229,230,211,231,43,39,232,212,234,235,236,62,214,241,242,243,89,33,245,215,16,7,248,64,128,35,34,69,202,233,83,127,66,51,68,12,60,13,27,237,200,49,61,223,246,199,63,88,251,249,250,224,59,244,247,87,48,117,239,65,240,10,185,238,197,195]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c,S,w,E,d,h,v,t,s,r,n,a,f,m,b,_,o,A,F,$,W,Q,H,N,x,L,G,M,O,B,z,J,ce,ye,Fe,Re,Ne,Ve,ze,j,Z,ie,oe,ve,ee,ue,Ie,$e,qe,be,tt,K,te,pe,Ue,We,Ze,Pe,Ce,Ae,se,le,me,we,q,ge,_e,Te,Oe,Ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function et(Qe){const Xe=Qe.get(oe.IExtHostInitDataService),lt=Qe.get(Ze.IExtHostFileSystemInfo),ut=Qe.get(K.IExtHostConsumerFileSystem),Ee=Qe.get(r.IExtHostExtensionService),Se=Qe.get(B.IExtHostWorkspace),ae=Qe.get(le.IExtHostTelemetry),Y=Qe.get(w.IExtHostConfiguration),Be=Qe.get(Z.IURITransformerService),De=Qe.get(ie.IExtHostRpcService),Je=Qe.get(W.IExtHostStorage),Ye=Qe.get(tt.IExtensionStoragePaths),rt=Qe.get(j.ILogService),mt=Qe.get(ue.IExtHostTunnelService),bt=Qe.get(Ie.IExtHostApiDeprecationService),wt=Qe.get(O.IExtHostWindow),Ct=Qe.get(Ae.IExtHostSecretState),yt=Qe.get(se.IExtHostEditorTabs);De.set(u.ExtHostContext.ExtHostFileSystemInfo,lt),De.set(u.ExtHostContext.ExtHostLogService,rt),De.set(u.ExtHostContext.ExtHostWorkspace,Se),De.set(u.ExtHostContext.ExtHostConfiguration,Y),De.set(u.ExtHostContext.ExtHostExtensionService,Ee),De.set(u.ExtHostContext.ExtHostStorage,Je),De.set(u.ExtHostContext.ExtHostTunnelService,mt),De.set(u.ExtHostContext.ExtHostWindow,wt),De.set(u.ExtHostContext.ExtHostSecretState,Ct),De.set(u.ExtHostContext.ExtHostTelemetry,ae),De.set(u.ExtHostContext.ExtHostEditorTabs,yt);const Tt=De.set(u.ExtHostContext.ExtHostDecorations,Qe.get(Re.IExtHostDecorations)),gt=De.set(u.ExtHostContext.ExtHostDocumentsAndEditors,Qe.get(s.IExtHostDocumentsAndEditors)),dt=De.set(u.ExtHostContext.ExtHostCommands,Qe.get(c.IExtHostCommands)),pt=De.set(u.ExtHostContext.ExtHostTerminalService,Qe.get(Q.IExtHostTerminalService)),Et=De.set(u.ExtHostContext.ExtHostDebugService,Qe.get(Ve.IExtHostDebugService)),At=De.set(u.ExtHostContext.ExtHostSearch,Qe.get(ze.IExtHostSearch)),kt=De.set(u.ExtHostContext.ExtHostTask,Qe.get(Ne.IExtHostTask)),_n=De.set(u.ExtHostContext.ExtHostOutputService,Qe.get(_.IExtHostOutputService)),jt=De.set(u.ExtHostContext.ExtHostUrls,new G.ExtHostUrls(De)),St=De.set(u.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(De,gt)),Xt=De.set(u.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(De,gt,rt)),Yt=De.set(u.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(rt,St,De.getProxy(u.MainContext.MainThreadBulkEdits))),ht=De.set(u.ExtHostContext.ExtHostNotebook,new ve.ExtHostNotebookController(De,dt,gt,St,Ye)),qt=De.set(u.ExtHostContext.ExtHostNotebookDocuments,new Oe.ExtHostNotebookDocuments(rt,ht)),Ht=De.set(u.ExtHostContext.ExtHostNotebookEditors,new Te.ExtHostNotebookEditors(rt,De,ht)),Jt=De.set(u.ExtHostContext.ExtHostNotebookKernels,new me.ExtHostNotebookKernels(De,Xe,ht,rt)),Zt=De.set(u.ExtHostContext.ExtHostNotebookRenderers,new q.ExtHostNotebookRenderers(De,ht)),It=De.set(u.ExtHostContext.ExtHostEditors,new H.ExtHostEditors(De,gt)),hn=De.set(u.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(De.getProxy(u.MainContext.MainThreadTreeViews),dt,rt)),en=De.set(u.ExtHostContext.ExtHostEditorInsets,new ce.ExtHostEditorInsets(De.getProxy(u.MainContext.MainThreadEditorInsets),It,Xe)),Bt=De.set(u.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(De,rt)),ct=De.set(u.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(De,Be,St,dt,Bt,rt,bt)),tn=De.set(u.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(De,ct)),Ot=De.set(u.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(De,rt,gt)),Nt=De.set(u.ExtHostContext.ExtHostQuickOpen,(0,A.createExtHostQuickOpen)(De,Se,dt)),Gt=De.set(u.ExtHostContext.ExtHostSCM,new F.ExtHostSCM(De,dt,rt)),Sn=De.set(u.ExtHostContext.ExtHostComments,(0,S.createExtHostComments)(De,dt,St)),fn=De.set(u.ExtHostContext.ExtHostProgress,new o.ExtHostProgress(De.getProxy(u.MainContext.MainThreadProgress))),yn=De.set(u.ExtHostContext.ExtHosLabelService,new ye.ExtHostLabelService(De)),mn=De.set(u.ExtHostContext.ExtHostTheming,new ee.ExtHostTheming(De)),nn=De.set(u.ExtHostContext.ExtHostAuthentication,new $e.ExtHostAuthentication(De)),rn=De.set(u.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(De,dt)),zt=De.set(u.ExtHostContext.ExtHostWebviews,new M.ExtHostWebviews(De,{remote:Xe.remote},Se,rt,bt)),sn=De.set(u.ExtHostContext.ExtHostWebviewPanels,new Ue.ExtHostWebviewPanels(De,zt,Se)),Dn=De.set(u.ExtHostContext.ExtHostCustomEditors,new pe.ExtHostCustomEditors(De,St,Ye,zt,sn)),Cn=De.set(u.ExtHostContext.ExtHostWebviewViews,new te.ExtHostWebviewViews(De,zt)),Vt=De.set(u.ExtHostContext.ExtHostTesting,new Pe.ExtHostTesting(De,dt)),Kt=De.set(u.ExtHostContext.ExtHostUriOpeners,new Ce.ExtHostUriOpeners(De));De.set(u.ExtHostContext.ExtHostInteractive,new Ge.ExtHostInteractive(De,ht,gt));const kn=(0,J.values)(u.ExtHostContext);De.assertRegistered(kn);const In=new We.ExtHostBulkEdits(De,gt),on=new l.ExtHostClipboard(De),an=new b.ExtHostMessageService(De,rt),$t=new d.ExtHostDialogs(De),Lt=new $.ExtHostStatusBar(De,dt.converter),ln=new m.ExtHostLanguages(De,St);return p.ExtHostApiCommands.register(dt),function(Me,Wt,gn){const ft=function(){let ne=!Me.isUnderDevelopment;function de(Le){ne||(rt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Le(at){if(Array.isArray(at))at.forEach(Le);else if(typeof at=="string")de(at);else{const vt=at;typeof vt.scheme=="undefined"&&de(at),!Me.enableProposedApi&&typeof vt.exclusive=="boolean"&&(0,z.throwProposedApiError)(Me)}return at}}(),Pn={getSession(ne,de,Le){return nn.getSession(Me,ne,de,Le)},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(ne,de,Le,at){return nn.registerAuthenticationProvider(ne,de,Le,at)}},An={registerCommand(ne,de,Le){return dt.registerCommand(!0,ne,de,Le)},registerTextEditorCommand(ne,de,Le){return dt.registerCommand(!0,ne,(...at)=>{const vt=It.getActiveTextEditor();if(!vt){rt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return vt.edit(_t=>{de.apply(Le,[vt,_t,...at])}).then(_t=>{_t||rt.warn("Edits from command "+ne+" were not applied.")},_t=>{rt.warn("An error occurred while running command "+ne,_t)})})},registerDiffInformationCommand:(ne,de,Le)=>((0,z.checkProposedApiEnabled)(Me),dt.registerCommand(!0,ne,async(...at)=>{const vt=gt.activeEditor(!0);if(!vt){rt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const _t=await It.getDiffInformation(vt.id);de.apply(Le,[_t,...at])})),executeCommand(ne,...de){return dt.executeCommand(ne,...de)},getCommands(ne=!1){return dt.getCommands(ne)}},pn={get machineId(){return Xe.telemetryInfo.machineId},get sessionId(){return Xe.telemetryInfo.sessionId},get language(){return Xe.environment.appLanguage},get appName(){return Xe.environment.appName},get appRoot(){return Xe.environment.appRoot?.fsPath??""},get uriScheme(){return Xe.environment.appUriScheme},get clipboard(){return on.value},get shell(){return pt.getDefaultShell(!1)},get isTelemetryEnabled(){return ae.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ae.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ne=Date.now()-new Date(Xe.telemetryInfo.firstSessionDate).getTime();return isNaN(ne)?!1:ne<1e3*60*60*24},openExternal(ne,de){return wt.openUri(ne,{allowTunneling:!!Xe.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===Xe.environment.appUriScheme)return jt.createAppUri(ne);try{return await wt.asExternalUri(ne,{allowTunneling:!!Xe.remote.authority})}catch(de){if((0,_e.matchesScheme)(ne,ge.Schemas.http)||(0,_e.matchesScheme)(ne,ge.Schemas.https))return ne;throw de}},get remoteName(){return(0,Fe.getRemoteName)(Xe.remote.authority)},get uiKind(){return Xe.uiKind}};Xe.environment.extensionTestsLocationURI||Object.freeze(pn);const vn=Xe.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,Tn={createTestController(ne){return(0,z.checkProposedApiEnabled)(Me),Vt.createTestController(ne)},createTestObserver(){return(0,z.checkProposedApiEnabled)(Me),Vt.createTestObserver()},runTests(ne){return(0,z.checkProposedApiEnabled)(Me),Vt.runTests(ne)},get onDidChangeTestResults(){return(0,z.checkProposedApiEnabled)(Me),Vt.onResultsChanged},get testResults(){return(0,z.checkProposedApiEnabled)(Me),Vt.results}},cn={getExtension(ne){const de=Wt.getExtensionDescription(ne);if(de)return new r.Extension(Ee,Me.identifier,de,vn)},get all(){return Wt.getAllExtensionDescriptions().map(ne=>new r.Extension(Ee,Me.identifier,ne,vn))},get onDidChange(){return Wt.onDidChange}},Rn={createDiagnosticCollection(ne){return Bt.createDiagnosticCollection(Me.identifier,ne)},get onDidChangeDiagnostics(){return Bt.onDidChangeDiagnostics},getDiagnostics:ne=>Bt.getDiagnostics(ne),getLanguages(){return ln.getLanguages()},setTextDocumentLanguage(ne,de){return ln.changeLanguage(ne.uri,de)},match(ne,de){return(0,i.score)(x.LanguageSelector.from(ne),de.uri,de.languageId,!0)},registerCodeActionsProvider(ne,de,Le){return ct.registerCodeActionProvider(Me,ft(ne),de,Le)},registerCodeLensProvider(ne,de){return ct.registerCodeLensProvider(Me,ft(ne),de)},registerDefinitionProvider(ne,de){return ct.registerDefinitionProvider(Me,ft(ne),de)},registerDeclarationProvider(ne,de){return ct.registerDeclarationProvider(Me,ft(ne),de)},registerImplementationProvider(ne,de){return ct.registerImplementationProvider(Me,ft(ne),de)},registerTypeDefinitionProvider(ne,de){return ct.registerTypeDefinitionProvider(Me,ft(ne),de)},registerHoverProvider(ne,de){return ct.registerHoverProvider(Me,ft(ne),de,Me.identifier)},registerEvaluatableExpressionProvider(ne,de){return ct.registerEvaluatableExpressionProvider(Me,ft(ne),de,Me.identifier)},registerInlineValuesProvider(ne,de){return ct.registerInlineValuesProvider(Me,ft(ne),de,Me.identifier)},registerDocumentHighlightProvider(ne,de){return ct.registerDocumentHighlightProvider(Me,ft(ne),de)},registerLinkedEditingRangeProvider(ne,de){return ct.registerLinkedEditingRangeProvider(Me,ft(ne),de)},registerReferenceProvider(ne,de){return ct.registerReferenceProvider(Me,ft(ne),de)},registerRenameProvider(ne,de){return ct.registerRenameProvider(Me,ft(ne),de)},registerDocumentSymbolProvider(ne,de,Le){return ct.registerDocumentSymbolProvider(Me,ft(ne),de,Le)},registerWorkspaceSymbolProvider(ne){return ct.registerWorkspaceSymbolProvider(Me,ne)},registerDocumentFormattingEditProvider(ne,de){return ct.registerDocumentFormattingEditProvider(Me,ft(ne),de)},registerDocumentRangeFormattingEditProvider(ne,de){return ct.registerDocumentRangeFormattingEditProvider(Me,ft(ne),de)},registerOnTypeFormattingEditProvider(ne,de,Le,...at){return ct.registerOnTypeFormattingEditProvider(Me,ft(ne),de,[Le].concat(at))},registerDocumentSemanticTokensProvider(ne,de,Le){return ct.registerDocumentSemanticTokensProvider(Me,ft(ne),de,Le)},registerDocumentRangeSemanticTokensProvider(ne,de,Le){return ct.registerDocumentRangeSemanticTokensProvider(Me,ft(ne),de,Le)},registerSignatureHelpProvider(ne,de,Le,...at){return typeof Le=="object"?ct.registerSignatureHelpProvider(Me,ft(ne),de,Le):ct.registerSignatureHelpProvider(Me,ft(ne),de,typeof Le=="undefined"?[]:[Le,...at])},registerCompletionItemProvider(ne,de,...Le){return ct.registerCompletionItemProvider(Me,ft(ne),de,Le)},registerInlineCompletionItemProvider(ne,de){return(0,z.checkProposedApiEnabled)(Me),ct.registerInlineCompletionsProvider(Me,ft(ne),de)},registerDocumentLinkProvider(ne,de){return ct.registerDocumentLinkProvider(Me,ft(ne),de)},registerColorProvider(ne,de){return ct.registerColorProvider(Me,ft(ne),de)},registerFoldingRangeProvider(ne,de){return ct.registerFoldingRangeProvider(Me,ft(ne),de)},registerSelectionRangeProvider(ne,de){return ct.registerSelectionRangeProvider(Me,ne,de)},registerCallHierarchyProvider(ne,de){return ct.registerCallHierarchyProvider(Me,ne,de)},setLanguageConfiguration:(ne,de)=>ct.setLanguageConfiguration(Me,ne,de),getTokenInformationAtPosition(ne,de){return(0,z.checkProposedApiEnabled)(Me),ln.tokenAtPosition(ne,de)},registerInlayHintsProvider(ne,de){return(0,z.checkProposedApiEnabled)(Me),ct.registerInlayHintsProvider(Me,ne,de)}},Ln={get activeTextEditor(){return It.getActiveTextEditor()},get visibleTextEditors(){return It.getVisibleTextEditors()},get activeTerminal(){return pt.activeTerminal},get terminals(){return pt.terminals},async showTextDocument(ne,de,Le){const at=await(T.URI.isUri(ne)?Promise.resolve(wn.openTextDocument(ne)):Promise.resolve(ne));return It.showTextDocument(at,de,Le)},createTextEditorDecorationType(ne){return It.createTextEditorDecorationType(Me,ne)},onDidChangeActiveTextEditor(ne,de,Le){return It.onDidChangeActiveTextEditor(ne,de,Le)},onDidChangeVisibleTextEditors(ne,de,Le){return It.onDidChangeVisibleTextEditors(ne,de,Le)},onDidChangeTextEditorSelection(ne,de,Le){return It.onDidChangeTextEditorSelection(ne,de,Le)},onDidChangeTextEditorOptions(ne,de,Le){return It.onDidChangeTextEditorOptions(ne,de,Le)},onDidChangeTextEditorVisibleRanges(ne,de,Le){return It.onDidChangeTextEditorVisibleRanges(ne,de,Le)},onDidChangeTextEditorViewColumn(ne,de,Le){return It.onDidChangeTextEditorViewColumn(ne,de,Le)},onDidCloseTerminal(ne,de,Le){return pt.onDidCloseTerminal(ne,de,Le)},onDidOpenTerminal(ne,de,Le){return pt.onDidOpenTerminal(ne,de,Le)},onDidChangeActiveTerminal(ne,de,Le){return pt.onDidChangeActiveTerminal(ne,de,Le)},onDidChangeTerminalDimensions(ne,de,Le){return(0,z.checkProposedApiEnabled)(Me),pt.onDidChangeTerminalDimensions(ne,de,Le)},onDidWriteTerminalData(ne,de,Le){return(0,z.checkProposedApiEnabled)(Me),pt.onDidWriteTerminalData(ne,de,Le)},get state(){return wt.state},onDidChangeWindowState(ne,de,Le){return wt.onDidChangeWindowState(ne,de,Le)},showInformationMessage(ne,...de){return an.showMessage(Me,y.default.Info,ne,de[0],de.slice(1))},showWarningMessage(ne,...de){return an.showMessage(Me,y.default.Warning,ne,de[0],de.slice(1))},showErrorMessage(ne,...de){return an.showMessage(Me,y.default.Error,ne,de[0],de.slice(1))},showQuickPick(ne,de,Le){return Nt.showQuickPick(ne,!!Me.enableProposedApi,de,Le)},showWorkspaceFolderPick(ne){return Nt.showWorkspaceFolderPick(ne)},showInputBox(ne,de){return Nt.showInput(ne,de)},showOpenDialog(ne){return $t.showOpenDialog(ne)},showSaveDialog(ne){return $t.showSaveDialog(ne)},createStatusBarItem(ne,de,Le){let at,vt,_t;return typeof ne=="string"?(at=ne,vt=de,_t=Le):(vt=ne,_t=de),Lt.createStatusBarEntry(Me,at,vt,_t)},setStatusBarMessage(ne,de){return Lt.setStatusBarMessage(ne,de)},withScmProgress(ne){return bt.report("window.withScmProgress",Me,"Use 'withProgress' instead."),fn.withProgress(Me,{location:L.ProgressLocation.SourceControl},(de,Le)=>ne({report(at){}}))},withProgress(ne,de){return fn.withProgress(Me,ne,de)},createOutputChannel(ne){return _n.createOutputChannel(ne,Me)},createWebviewPanel(ne,de,Le,at){return sn.createWebviewPanel(Me,ne,de,Le,at)},createWebviewTextEditorInset(ne,de,Le,at){return(0,z.checkProposedApiEnabled)(Me),en.createWebviewEditorInset(ne,de,Le,at,Me)},createTerminal(ne,de,Le){return typeof ne=="object"?"pty"in ne?pt.createExtensionTerminal(ne):pt.createTerminalFromOptions(ne):pt.createTerminal(ne,de,Le)},registerTerminalLinkProvider(ne){return pt.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,de){return pt.registerProfileProvider(Me,ne,de)},registerTreeDataProvider(ne,de){return hn.registerTreeDataProvider(ne,de,Me)},createTreeView(ne,de){return hn.createTreeView(ne,de,Me)},registerWebviewPanelSerializer:(ne,de)=>sn.registerWebviewPanelSerializer(Me,ne,de),registerCustomEditorProvider:(ne,de,Le={})=>Dn.registerCustomEditorProvider(Me,ne,de,Le),registerFileDecorationProvider(ne){return Tt.registerFileDecorationProvider(ne,Me.identifier)},registerUriHandler(ne){return jt.registerUriHandler(Me.identifier,ne)},createQuickPick(){return Nt.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return Nt.createInputBox(Me.identifier)},get activeColorTheme(){return mn.activeColorTheme},onDidChangeActiveColorTheme(ne,de,Le){return mn.onDidChangeActiveColorTheme(ne,de,Le)},registerWebviewViewProvider(ne,de,Le){return Cn.registerWebviewViewProvider(Me,ne,de,Le?.webviewOptions)},get activeNotebookEditor(){return(0,z.checkProposedApiEnabled)(Me),ht.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,de,Le){return(0,z.checkProposedApiEnabled)(Me),ht.onDidChangeActiveNotebookEditor(ne,de,Le)},get visibleNotebookEditors(){return(0,z.checkProposedApiEnabled)(Me),ht.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,z.checkProposedApiEnabled)(Me),ht.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,de,Le){return(0,z.checkProposedApiEnabled)(Me),Ht.onDidChangeNotebookEditorSelection(ne,de,Le)},onDidChangeNotebookEditorVisibleRanges(ne,de,Le){return(0,z.checkProposedApiEnabled)(Me),Ht.onDidChangeNotebookEditorVisibleRanges(ne,de,Le)},showNotebookDocument(ne,de){return(0,z.checkProposedApiEnabled)(Me),ht.showNotebookDocument(ne,de)},registerExternalUriOpener(ne,de,Le){return(0,z.checkProposedApiEnabled)(Me),Kt.registerExternalUriOpener(Me.identifier,ne,de,Le)},get openEditors(){return(0,z.checkProposedApiEnabled)(Me),yt.tabs},get onDidChangeOpenEditors(){return(0,z.checkProposedApiEnabled)(Me),yt.onDidChangeTabs},getInlineCompletionItemController(ne){return(0,z.checkProposedApiEnabled)(Me),f.InlineCompletionController.get(ne)}},wn={get rootPath(){return bt.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Se.getPath()},set rootPath(ne){throw R.readonly()},getWorkspaceFolder(ne){return Se.getWorkspaceFolder(ne)},get workspaceFolders(){return Se.getWorkspaceFolders()},get name(){return Se.name},set name(ne){throw R.readonly()},get workspaceFile(){return Se.workspaceFile},set workspaceFile(ne){throw R.readonly()},updateWorkspaceFolders:(ne,de,...Le)=>Se.updateWorkspaceFolders(Me,ne,de||0,...Le),onDidChangeWorkspaceFolders:function(ne,de,Le){return Se.onDidChangeWorkspace(ne,de,Le)},asRelativePath:(ne,de)=>Se.getRelativePath(ne,de),findFiles:(ne,de,Le,at)=>Se.findFiles(x.GlobPattern.from(ne),x.GlobPattern.from(de),Le,Me.identifier,at),findTextInFiles:(ne,de,Le,at)=>{let vt,_t;return typeof de=="object"?(vt=de,_t=Le):(vt={},_t=de,at=Le),Se.findTextInFiles(ne,vt||{},_t,Me.identifier,at)},saveAll:ne=>Se.saveAll(ne),applyEdit(ne){return In.applyWorkspaceEdit(ne)},createFileSystemWatcher:(ne,de,Le,at)=>Ot.createFileSystemWatcher(x.GlobPattern.from(ne),de,Le,at),get textDocuments(){return St.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw R.readonly()},openTextDocument(ne){let de;const Le=ne;if(typeof ne=="string")de=Promise.resolve(T.URI.file(ne));else if(T.URI.isUri(ne))de=Promise.resolve(ne);else if(!Le||typeof Le=="object")de=St.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(at=>St.ensureDocumentData(at).then(vt=>vt.document))},onDidOpenTextDocument:(ne,de,Le)=>St.onDidAddDocument(ne,de,Le),onDidCloseTextDocument:(ne,de,Le)=>St.onDidRemoveDocument(ne,de,Le),onDidChangeTextDocument:(ne,de,Le)=>St.onDidChangeDocument(ne,de,Le),onDidSaveTextDocument:(ne,de,Le)=>St.onDidSaveDocument(ne,de,Le),onWillSaveTextDocument:(ne,de,Le)=>Yt.getOnWillSaveTextDocumentEvent(Me)(ne,de,Le),get notebookDocuments(){return ht.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,de){let Le;if(T.URI.isUri(ne))Le=ne,await ht.openNotebookDocument(ne);else if(typeof ne=="string")Le=T.URI.revive(await ht.createNotebookDocument({viewType:ne,content:de}));else throw new Error("Invalid arguments");return ht.getNotebookDocument(Le).apiNotebook},get onDidOpenNotebookDocument(){return ht.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return ht.onDidCloseNotebookDocument},registerNotebookSerializer(ne,de,Le,at){return ht.registerNotebookSerializer(Me,ne,de,Le,Me.enableProposedApi?at:void 0)},registerNotebookContentProvider:(ne,de,Le,at)=>((0,z.checkProposedApiEnabled)(Me),ht.registerNotebookContentProvider(Me,ne,de,Le,Me.enableProposedApi?at:void 0)),onDidChangeConfiguration:(ne,de,Le)=>gn.onDidChangeConfiguration(ne,de,Le),getConfiguration(ne,de){return de=arguments.length===1?void 0:de,gn.getConfiguration(ne,de,Me)},registerTextDocumentContentProvider(ne,de){return Xt.registerTextDocumentContentProvider(ne,de)},registerTaskProvider:(ne,de)=>(bt.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),kt.registerTaskProvider(Me,ne,de)),registerFileSystemProvider(ne,de,Le){return tn.registerFileSystemProvider(Me.identifier,ne,de,Le,Me.enableProposedApi)},get fs(){return ut.value},registerFileSearchProvider:(ne,de)=>((0,z.checkProposedApiEnabled)(Me),At.registerFileSearchProvider(ne,de)),registerTextSearchProvider:(ne,de)=>((0,z.checkProposedApiEnabled)(Me),At.registerTextSearchProvider(ne,de)),registerRemoteAuthorityResolver:(ne,de)=>((0,z.checkProposedApiEnabled)(Me),Ee.registerRemoteAuthorityResolver(ne,de)),registerResourceLabelFormatter:ne=>((0,z.checkProposedApiEnabled)(Me),yn.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,de,Le)=>Ot.onDidCreateFile(ne,de,Le),onDidDeleteFiles:(ne,de,Le)=>Ot.onDidDeleteFile(ne,de,Le),onDidRenameFiles:(ne,de,Le)=>Ot.onDidRenameFile(ne,de,Le),onWillCreateFiles:(ne,de,Le)=>Ot.getOnWillCreateFileEvent(Me)(ne,de,Le),onWillDeleteFiles:(ne,de,Le)=>Ot.getOnWillDeleteFileEvent(Me)(ne,de,Le),onWillRenameFiles:(ne,de,Le)=>Ot.getOnWillRenameFileEvent(Me)(ne,de,Le),openTunnel:ne=>((0,z.checkProposedApiEnabled)(Me),mt.openTunnel(Me,ne).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,z.checkProposedApiEnabled)(Me),mt.getTunnels()},onDidChangeTunnels:(ne,de,Le)=>((0,z.checkProposedApiEnabled)(Me),mt.onDidChangeTunnels(ne,de,Le)),registerPortAttributesProvider:(ne,de)=>((0,z.checkProposedApiEnabled)(Me),mt.registerPortsAttributesProvider(ne,de)),registerTimelineProvider:(ne,de)=>((0,z.checkProposedApiEnabled)(Me),rn.registerTimelineProvider(ne,de,Me.identifier,dt.converter)),get isTrusted(){return Se.trusted},requestWorkspaceTrust:ne=>((0,z.checkProposedApiEnabled)(Me),Se.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,de,Le)=>Se.onDidGrantWorkspaceTrust(ne,de,Le)},Fn={get inputBox(){return bt.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),Gt.getLastInputBox(Me)},createSourceControl(ne,de,Le){return Gt.createSourceControl(Me,ne,de,Le)}},Mn={createCommentController(ne,de){return Sn.createCommentController(Me,ne,de)}},On={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},onDidStartDebugSession(ne,de,Le){return Et.onDidStartDebugSession(ne,de,Le)},onDidTerminateDebugSession(ne,de,Le){return Et.onDidTerminateDebugSession(ne,de,Le)},onDidChangeActiveDebugSession(ne,de,Le){return Et.onDidChangeActiveDebugSession(ne,de,Le)},onDidReceiveDebugSessionCustomEvent(ne,de,Le){return Et.onDidReceiveDebugSessionCustomEvent(ne,de,Le)},onDidChangeBreakpoints(ne,de,Le){return Et.onDidChangeBreakpoints(ne,de,Le)},registerDebugConfigurationProvider(ne,de,Le){return Et.registerDebugConfigurationProvider(ne,de,Le||L.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,de){return Et.registerDebugAdapterDescriptorFactory(Me,ne,de)},registerDebugAdapterTrackerFactory(ne,de){return Et.registerDebugAdapterTrackerFactory(ne,de)},startDebugging(ne,de,Le){return!Le||typeof Le=="object"&&"configuration"in Le?Et.startDebugging(ne,de,{parentSession:Le}):Et.startDebugging(ne,de,Le||{})},stopDebugging(ne){return Et.stopDebugging(ne)},addBreakpoints(ne){return Et.addBreakpoints(ne)},removeBreakpoints(ne){return Et.removeBreakpoints(ne)},asDebugSourceUri(ne,de){return Et.asDebugSourceUri(ne,de)}},bn={registerTaskProvider:(ne,de)=>kt.registerTaskProvider(Me,ne,de),fetchTasks:ne=>kt.fetchTasks(ne),executeTask:ne=>kt.executeTask(Me,ne),get taskExecutions(){return kt.taskExecutions},onDidStartTask:(ne,de,Le)=>kt.onDidStartTask(ne,de,Le),onDidEndTask:(ne,de,Le)=>kt.onDidEndTask(ne,de,Le),onDidStartTaskProcess:(ne,de,Le)=>kt.onDidStartTaskProcess(ne,de,Le),onDidEndTaskProcess:(ne,de,Le)=>kt.onDidEndTaskProcess(ne,de,Le)},Ft={createNotebookController(ne,de,Le,at,vt){return Jt.createNotebookController(Me,ne,de,Le,at,Me.enableProposedApi?vt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,de)=>ht.registerNotebookCellStatusBarItemProvider(Me,ne,de),get onDidSaveNotebookDocument(){return(0,z.checkProposedApiEnabled)(Me),qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ne){return(0,z.checkProposedApiEnabled)(Me),Ht.createNotebookEditorDecorationType(ne)},createRendererMessaging(ne){return(0,z.checkProposedApiEnabled)(Me),Zt.createRendererMessaging(ne)},onDidChangeNotebookDocumentMetadata(ne,de,Le){return(0,z.checkProposedApiEnabled)(Me),qt.onDidChangeNotebookDocumentMetadata(ne,de,Le)},onDidChangeNotebookCells(ne,de,Le){return(0,z.checkProposedApiEnabled)(Me),ht.onDidChangeNotebookCells(ne,de,Le)},onDidChangeNotebookCellExecutionState(ne,de,Le){return(0,z.checkProposedApiEnabled)(Me),ht.onDidChangeNotebookCellExecutionState(ne,de,Le)},onDidChangeCellOutputs(ne,de,Le){return(0,z.checkProposedApiEnabled)(Me),ht.onDidChangeCellOutputs(ne,de,Le)},onDidChangeCellMetadata(ne,de,Le){return(0,z.checkProposedApiEnabled)(Me),ht.onDidChangeCellMetadata(ne,de,Le)},createConcatTextDocument(ne,de){return(0,z.checkProposedApiEnabled)(Me),new be.ExtHostNotebookConcatDocument(ht,St,ne,de)}};return{version:Xe.version,authentication:Pn,commands:An,comments:Mn,debug:On,env:pn,extensions:cn,languages:Rn,notebooks:Ft,scm:Fn,tasks:bn,test:Tn,window:Ln,workspace:wn,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:u.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:L.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:L.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,InlineCompletionItem:L.InlineSuggestion,InlineCompletionList:L.InlineSuggestions,Hover:L.Hover,IndentAction:C.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,TaskGroup:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TerminalLink:L.TerminalLink,TerminalProfile:L.TerminalProfile,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,TextDocumentChangeReason:L.TextDocumentChangeReason,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,UIKind:u.UIKind,Uri:T.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlayHint:L.InlayHint,InlayHintKind:L.InlayHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookRendererScript:L.NotebookRendererScript,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,NotebookControllerAffinity:L.NotebookControllerAffinity,PortAttributes:L.PortAttributes,LinkedEditingRanges:L.LinkedEditingRanges,TestResultState:L.TestResultState,TestRunRequest:L.TestRunRequest,TestMessage:L.TestMessage,TextSearchCompleteMessageType:we.TextSearchCompleteMessageType,TestMessageSeverity:L.TestMessageSeverity,CoveredCount:L.CoveredCount,FileCoverage:L.FileCoverage,StatementCoverage:L.StatementCoverage,BranchCoverage:L.BranchCoverage,FunctionCoverage:L.FunctionCoverage,WorkspaceTrustState:L.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=et}),define(he[268],fe([0,1,78,62,35,127,36,50,43,33,66,51,68,89,49,61,128,88,59,87,117,48]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c,S,w,E,d,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(c.IExtHostApiDeprecationService,c.ExtHostApiDeprecationService),(0,g.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,g.registerSingleton)(T.IExtHostConfiguration,T.ExtHostConfiguration),(0,g.registerSingleton)(w.IExtHostConsumerFileSystem,w.ExtHostConsumerFileSystem),(0,g.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,g.registerSingleton)(y.IExtHostDecorations,y.ExtHostDecorations),(0,g.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo),(0,g.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,g.registerSingleton)(u.IExtHostSearch,u.ExtHostSearch),(0,g.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage),(0,g.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,g.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),(0,g.registerSingleton)(l.IExtHostTunnelService,l.ExtHostTunnelService),(0,g.registerSingleton)(S.IExtHostWindow,S.ExtHostWindow),(0,g.registerSingleton)(k.IExtHostWorkspace,k.ExtHostWorkspace),(0,g.registerSingleton)(d.IExtHostSecretState,d.ExtHostSecretState),(0,g.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry),(0,g.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(he[90],fe([0,1,18,12,31,65]),function(X,e,g,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function T(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=T;function I(P,u,p,l){const c=(0,g.mapArrayOrNot)(p,D),S=new k.TextSearchMatch(u,c,l),w=S.preview.matches;return{ranges:(0,g.mapArrayOrNot)(c,C),uri:P,preview:{text:S.preview.text,matches:(0,g.mapArrayOrNot)(w,C)}}}e.createTextSearchResult=I;function D(P){return new k.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function C(P){return new y.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let i=class{constructor(u,p){this.prefix=u,this.logService=p}appendLine(u){this.logService.debug(`${this.prefix}#search`,u)}};i=je([He(1,R.ILogService)],i),e.OutputChannel=i}),define(he[269],fe([0,1,92,22]),function(X,e,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(s=>s===t)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const y=512,T=512,I=512*8,D=512*128;class C{constructor(s){this.iconvLiteDecoder=s}static async create(s){let r;if(s!==e.UTF8)r=(await new Promise((a,f)=>{X(["iconv-lite-umd"],a,f)})).getDecoder(p(s));else{const n=new TextDecoder;r={write(a){return n.decode(a,{stream:!0})},end(){return n.decode()}}}return new C(r)}write(s){return this.iconvLiteDecoder.write(s)}end(){return this.iconvLiteDecoder.end()}}function i(t,s){const r=s.minBytesRequiredForDetection??s.guessEncoding?I:T;return new Promise((n,a)=>{const f=(0,g.newWriteableStream)(A=>A.join("")),m=[];let b=0,_;const o=async()=>{try{const A=await v({buffer:R.VSBuffer.concat(m),bytesRead:b},s.guessEncoding);A.encoding=await s.overwriteEncoding(A.encoding),_=await C.create(A.encoding);const F=_.write(R.VSBuffer.concat(m).buffer);f.write(F),m.length=0,b=0,n({stream:f,detected:A})}catch(A){a(A)}};(0,g.listenStream)(t,{onData:async A=>{_?f.write(_.write(A.buffer)):(m.push(A),b+=A.byteLength,b>=r&&(t.pause(),await o(),setTimeout(()=>t.resume())))},onError:A=>f.error(A),onEnd:async()=>{_||await o(),f.end(_?.end())}})})}e.toDecodeStream=i;async function P(t,s,r){const a=(await new Promise((b,_)=>{X(["iconv-lite-umd"],b,_)})).getEncoder(p(s),r);let f=!1,m=!1;return{read(){if(m)return null;const b=t.read();if(typeof b!="string"){if(m=!0,!f&&r?.addBOM)switch(s){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const _=a.end();return _&&_.length>0?(f=!0,R.VSBuffer.wrap(_)):null}return f=!0,R.VSBuffer.wrap(a.write(b))}}}e.toEncodeReadable=P;async function u(t){return(await new Promise((r,n)=>{X(["iconv-lite-umd"],r,n)})).encodingExists(p(t))}e.encodingExists=u;function p(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=p;function l(t,s){if(!t||s<e.UTF16be_BOM.length)return null;const r=t.readUInt8(0),n=t.readUInt8(1);if(r===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(s<e.UTF8_BOM.length)return null;const a=t.readUInt8(2);return r===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=l;const c=["ascii","utf-16","utf-32"];async function S(t){const s=await new Promise((m,b)=>{X(["jschardet"],m,b)}),r=t.slice(0,D),n=d(r.buffer),a=s.detect(n);if(!a||!a.encoding)return null;const f=a.encoding.toLowerCase();return 0<=c.indexOf(f)?null:E(a.encoding)}const w={ibm866:"cp866",big5:"cp950"};function E(t){const s=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[s]||s}function d(t){let s="";for(let r=0;r<t.length;r++)s+=String.fromCharCode(t[r]);return s}function h(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const s=t.match(/windows(\d+)/);return s?"windows-"+s[1]:t}}e.toCanonicalName=h;function v({buffer:t,bytesRead:s},r){let n=l(t,s),a=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&t){let f=!0,m=!0,b=!1;for(let _=0;_<s&&_<y;_++){const o=_%2==1,A=t.readUInt8(_)===0;if(A&&(b=!0),f&&(o&&!A||!o&&A)&&(f=!1),m&&(o&&A||!o&&!A)&&(m=!1),A&&!f&&!m)break}b&&(f?n=e.UTF16le:m?n=e.UTF16be:a=!0)}return r&&!a&&!n&&t?S(t.slice(0,s)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:a,encoding:n}}e.detectEncodingFromBuffer=v,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(he[130],fe([0,1,269,28,129]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class y extends k.TextSearchManager{constructor(I,D,C=R){super(I,D,{readdir:i=>C.Promises.readdir(i.fsPath),toCanonicalName:i=>(0,g.toCanonicalName)(i)})}}e.NativeTextSearchManager=y}),define(he[270],fe([0,1,271,286,287,2,288]),function(X,e,g,R,k,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function I(P,u,p,l,c,S){const w=S.environment.useHostProxy,E=typeof w=="boolean"?w:!S.remote.isRemote,d=(0,T.createProxyResolver)({resolveProxy:v=>P.resolveProxy(v),getHttpProxySetting:()=>u.getConfiguration("http").get("proxy"),log:(v,t,...s)=>{switch(v){case T.LogLevel.Trace:l.trace(t,...s);break;case T.LogLevel.Debug:l.debug(t,...s);break;case T.LogLevel.Info:l.info(t,...s);break;case T.LogLevel.Warning:l.warn(t,...s);break;case T.LogLevel.Error:l.error(t,...s);break;case T.LogLevel.Critical:l.critical(t,...s);break;case T.LogLevel.Off:break;default:r(v,t,s);break}function r(n,a,...f){l.error("Unknown log level",n),l.error(a,...f)}},getLogLevel:()=>l.getLevel(),proxyResolveTelemetry:v=>{c.$publicLog2("resolveProxy",v)},useHostProxy:E,env:process.env}),h=D(u,d);return i(p,h)}e.connectProxyResolver=I;function D(P,u){const p={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(c=>{p.config=P.getConfiguration("http").get("proxySupport")||"off"});const l={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(c=>{l.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,T.createHttpPatch)(g,u,{config:"off"},l,!0)),on:Object.assign({},g,(0,T.createHttpPatch)(g,u,{config:"on"},l,!0)),override:Object.assign({},g,(0,T.createHttpPatch)(g,u,{config:"override"},l,!0)),onRequest:Object.assign({},g,(0,T.createHttpPatch)(g,u,p,l,!0)),default:Object.assign(g,(0,T.createHttpPatch)(g,u,p,l,!1))},https:{off:Object.assign({},R,(0,T.createHttpPatch)(R,u,{config:"off"},l,!0)),on:Object.assign({},R,(0,T.createHttpPatch)(R,u,{config:"on"},l,!0)),override:Object.assign({},R,(0,T.createHttpPatch)(R,u,{config:"override"},l,!0)),onRequest:Object.assign({},R,(0,T.createHttpPatch)(R,u,p,l,!0)),default:Object.assign(R,(0,T.createHttpPatch)(R,u,p,l,!1))},tls:Object.assign(k,(0,T.createTlsPatch)(k))}}const C=new Map;function i(P,u){return P.getExtensionPathIndex().then(p=>{const l=X.__$__nodeRequire("module"),c=l._load;l._load=function(w,E,d){if(w==="tls")return u.tls;if(w!=="http"&&w!=="https")return c.apply(this,arguments);const h=u[w],v=p.findSubstr(y.URI.file(E.filename).fsPath);let t=C.get(v);if(t||C.set(v,t={}),!t[w]){let s=h.default;v&&v.enableProposedApi&&(s=h[v.proxySupport]||h.onRequest),t[w]={...s}}return t[w]}})}}),define(he[272],fe([0,1,38,9,75,29,11,8,90,273]),function(X,e,g,R,k,y,T,I,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(d,h,v,t){const s=u(d,h,v,t),r=h.folder.fsPath;return{cmd:g.spawn(i,s.args,{cwd:r}),rgDiskPath:i,siblingClauses:s.siblingClauses,rgArgs:s,cwd:r}}e.spawnRipgrepCmd=P;function u(d,h,v,t){const s=["--files","--hidden","--case-sensitive"];l([h],v,!1).forEach(n=>{const a=(0,D.anchorGlob)(n);if(s.push("-g",a),T.isMacintosh){const f=(0,k.normalizeNFD)(a);f!==a&&s.push("-g",f)}});const r=p([h],t,void 0,!1);return r.globArgs.forEach(n=>{const a=`!${(0,D.anchorGlob)(n)}`;if(s.push("-g",a),T.isMacintosh){const f=(0,k.normalizeNFD)(a);f!==a&&s.push("-g",f)}}),h.disregardIgnoreFiles!==!1?s.push("--no-ignore"):s.push("--no-ignore-parent"),h.ignoreSymlinks||s.push("--follow"),d.exists&&s.push("--quiet"),s.push("--no-config"),h.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:r.siblingClauses}}function p(d,h,v,t=!0){const s=[];let r={};return d.forEach(n=>{const a=Object.assign({},n.excludePattern||{},h||{}),f=c(a,t?n.folder.fsPath:void 0,v);s.push(...f.globArgs),f.siblingClauses&&(r=Object.assign(r,f.siblingClauses))}),{globArgs:s,siblingClauses:r}}e.foldersToRgExcludeGlobs=p;function l(d,h,v=!0){const t=[];return d.forEach(s=>{const r=Object.assign({},h||{},s.includePattern||{}),n=c(r,v?s.folder.fsPath:void 0);t.push(...n.globArgs)}),t}e.foldersToIncludeGlobs=l;function c(d,h,v){const t=[],s={};return Object.keys(d).forEach(r=>{if(v&&v.has(r)||!r)return;const n=d[r];r=w(h?S(h,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof n=="boolean"&&n?(r.startsWith("\\\\")&&(r+="**"),t.push(E(r))):n&&n.when&&(s[r]=n)}),{globArgs:t,siblingClauses:s}}function S(d,h){return R.isAbsolute(h)?h:R.join(d,h)}e.getAbsoluteGlob=S;function w(d){return d=I.rtrim(d,"\\"),I.rtrim(d,"/")}function E(d){return y.getRoot(d).toLowerCase()==="c:/"?d.replace(/^c:[/\\]/i,"/"):d}e.fixDriveC=E}),define(he[274],fe([0,1,38,45,9,100,18,58,30,75,29,11,44,8,14,28,31,272,97]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c,S,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const d=new Set;process.on("exit",()=>{d.forEach(r=>r())});class h{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&D.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,E.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&D.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(a=>{const f=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),m=a.folder.fsPath;n.folderQueries.map(b=>b.folder.fsPath).filter(b=>b!==m).forEach(b=>{(0,i.isEqualOrParent)(b,m)&&(f[k.relative(m,b)]=!0)}),this.folderExcludePatterns.set(m,new t(f,m))})}cancel(){this.isCanceled=!0}walk(n,a,f,m,b){if(this.fileWalkSW=u.StopWatch.create(!1),this.isCanceled)return b(null,this.isLimitHit);a.forEach(_=>{const o=k.basename(_.fsPath);this.globalExcludePattern&&this.globalExcludePattern(_.fsPath,o)||this.matchFile(f,{relativePath:_.fsPath,searchPath:void 0})}),this.cmdSW=u.StopWatch.create(!1),this.parallel(n,(_,o)=>{this.call(this.cmdTraversal,this,_,f,m,A=>{if(A){const F=(0,I.toErrorMessage)(A);console.error(F),this.errors.push(F),o(A,void 0)}else o(null,void 0)})},(_,o)=>{this.fileWalkSW.stop();const A=_?T.coalesce(_)[0]:null;b(A,this.isLimitHit)})}parallel(n,a,f){const m=new Array(n.length),b=new Array(n.length);let _=!1,o=0;if(n.length===0)return f(null,[]);n.forEach((A,F)=>{a(A,($,W)=>{if($?(_=!0,m[F]=null,b[F]=$):(m[F]=W,b[F]=null),++o===n.length)return f(_?b:null,m)})})}call(n,a,...f){try{n.apply(a,f)}catch(m){f[f.length-1](m)}}cmdTraversal(n,a,f,m){const b=n.folder.fsPath,_=P.isMacintosh;let o;const A=()=>o&&o.kill();d.add(A);let F=L=>{d.delete(A),F=()=>{},m(L)},$="";const W=this.initDirectoryTree();let Q;const H=(0,w.spawnRipgrepCmd)(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);o=H.cmd,Q=!Object.keys(H.siblingClauses).length;const N=H.rgArgs.args.map(L=>L.match(/^-/)?L:`'${L}'`).join(" ");let x=`${H.rgDiskPath} ${N}
 - cwd: ${H.cwd}`;H.rgArgs.siblingClauses&&(x+=`
 - Sibling clauses: ${JSON.stringify(H.rgArgs.siblingClauses)}`),f({message:x}),this.cmdResultCount=0,this.collectStdout(o,"utf8",f,(L,G,M)=>{if(L){F(L);return}if(this.isLimitHit){F();return}const B=($+(_?C.normalizeNFC(G||""):G)).split(`
`);if(M){const z=B.length;B[z-1]=B[z-1].trim(),B[z-1]||B.pop()}else $=B.pop()||"";if(B.length&&B[0].indexOf(`
`)!==-1){F(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=B.length,Q){for(const z of B)if(this.matchFile(a,{base:b,relativePath:z,searchPath:this.getSearchPath(n,z)}),this.isLimitHit){A();break}(M||this.isLimitHit)&&F();return}this.addDirectoryEntries(n,W,b,B,a),M&&(this.matchDirectoryTree(W,b,a),F())})}spawnFindCmd(n){const a=this.folderExcludePatterns.get(n.folder.fsPath),f=a.getBasenameTerms(),m=a.getPathTerms(),b=["-L","."];if(f.length||m.length){b.push("-not","(","(");for(const _ of f)b.push("-name",_),b.push("-o");for(const _ of m)b.push("-path",_),b.push("-o");b.pop(),b.push(")","-prune",")")}return b.push("-type","f"),g.spawn("find",b,{cwd:n.folder.fsPath})}readStdout(n,a,f){let m="";this.collectStdout(n,a,()=>{},(b,_,o)=>{if(b){f(b);return}m+=_,o&&f(null,m)})}collectStdout(n,a,f,m){let b=(A,F,$)=>{(A||$)&&(b=()=>{},this.cmdSW&&this.cmdSW.stop()),m(A,F,$)},_=!1;n.stdout?(this.forwardData(n.stdout,a,b),n.stdout.once("data",()=>_=!0)):f({message:"stdout is null"});let o;n.stderr?o=this.collectData(n.stderr):f({message:"stderr is null"}),n.on("error",A=>{b(A)}),n.on("close",A=>{let F;!_&&(F=this.decodeData(o,a))&&s(F)?b(new Error(`command failed with error code ${A}: ${this.decodeData(o,a)}`)):(this.exists&&A===0&&(this.isLimitHit=!0),b(null,"",!0))})}forwardData(n,a,f){const m=new y.StringDecoder(a);return n.on("data",b=>{f(null,m.write(b))}),m}collectData(n){const a=[];return n.on("data",f=>{a.push(f)}),a}decodeData(n,a){const f=new y.StringDecoder(a);return n.map(m=>f.write(m)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:a},f,m,b){m.indexOf(this.filePattern)!==-1&&this.matchFile(b,{base:f,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const _=o=>{const A=k.basename(o),F=k.dirname(o);let $=a[F];$||($=a[F]=[],_(F)),$.push({base:f,relativePath:o,basename:A,searchPath:this.getSearchPath(n,o)})};m.forEach(_)}matchDirectoryTree({rootEntries:n,pathToEntries:a},f,m){const b=this,_=this.folderExcludePatterns.get(f),o=this.filePattern;function A(F){b.directoriesWalked++;const $=D.hasSiblingFn(()=>F.map(W=>W.basename));for(let W=0,Q=F.length;W<Q;W++){const H=F[W],{relativePath:N,basename:x}=H;if(_.test(N,x,o!==x?$:void 0))continue;const L=a[N];if(L)A(L);else{if(b.filesWalked++,N===o)continue;b.matchFile(m,H)}if(b.isLimitHit)break}}A(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,a,f,m,b){const _=n.folder,o=D.hasSiblingFn(()=>f);this.parallel(f,(A,F)=>{if(this.isCanceled||this.isLimitHit)return F(null);const $=a?[a,A].join(k.sep):A;if(this.folderExcludePatterns.get(n.folder.fsPath).test($,A,this.config.filePattern!==A?o:void 0))return F(null);const W=[_.fsPath,$].join(k.sep);R.lstat(W,(Q,H)=>{if(Q||this.isCanceled||this.isLimitHit)return F(null);this.statLinkIfNeeded(W,H,(N,x)=>N||this.isCanceled||this.isLimitHit?F(null):x.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(W,H,(L,G)=>L||this.isCanceled||this.isLimitHit||(G=G||"",this.walkedPaths[G])?F(null):(this.walkedPaths[G]=!0,c.Promises.readdir(W).then(M=>{if(this.isCanceled||this.isLimitHit)return F(null);this.doWalk(n,$,M,m,O=>F(O||null))},M=>{F(null)})))):(this.filesWalked++,$===this.filePattern||this.maxFilesize&&l.isNumber(x.size)&&x.size>this.maxFilesize||this.matchFile(m,{base:_.fsPath,relativePath:$,searchPath:this.getSearchPath(n,$)}),F(null,void 0)))})},A=>{const F=A&&T.coalesce(A);return b(F&&F.length>0?F[0]:void 0)})}matchFile(n,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,k.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(a))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,S.isFilePatternMatch)(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,a,f){return a.isSymbolicLink()?R.stat(n,f):f(null,a)}realPathIfNeeded(n,a,f){return a.isSymbolicLink()?R.realpath(n,(m,b)=>m?f(m):f(null,b)):f(null,n)}getSearchPath(n,a){return n.folderName?k.join(n.folderName,a):a}}e.FileWalker=h;class v{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new h(n)}search(n,a,f){this.walker.walk(this.folderQueries,this.extraFiles,n,a,(m,b)=>{f(m,{limitHit:b,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=v;class t{constructor(n,a){this.expression=n,this.root=a,this.init(n)}init(n){let a,f;Object.keys(n).filter(m=>n[m]).forEach(m=>{k.isAbsolute(m)?(a=a||D.getEmptyExpression(),a[m]=n[m]):(f=f||D.getEmptyExpression(),f[m]=n[m])}),this.absoluteParsedExpr=a&&D.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=f&&D.parse(f,{trimForExclusions:!0})}test(n,a,f){return this.relativeParsedExpr&&this.relativeParsedExpr(n,a,f)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,n),a,f)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...D.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(...D.getPathTerms(this.relativeParsedExpr)),n}}function s(r){const n=r.trim().split(`
`),a=n[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return p.uppercaseFirstLetter(n[n.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=s}),define(he[131],fe([0,1,38,289,100,18,69,30,9,8,2,31,65,290,273,90]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(_){this.outputChannel=_}provideTextSearchResults(_,o,A,F){return this.outputChannel.appendLine(`provideTextSearchResults ${_.pattern}, ${JSON.stringify({...o,folder:o.folder.toString()})}`),new Promise(($,W)=>{F.onCancellationRequested(()=>O());const Q=s(_,o),H=o.folder.fsPath,N=Q.map(ye=>ye.match(/^-/)?ye:`'${ye}'`).join(" ");this.outputChannel.appendLine(`${S} ${N}
 - cwd: ${H}`);let x=g.spawn(S,Q,{cwd:H});x.on("error",ye=>{console.error(ye),this.outputChannel.appendLine("Error: "+(ye&&ye.message)),W((0,P.serializeSearchError)(new P.SearchError(ye&&ye.message,P.SearchErrorCode.rgProcessError)))});let L=!1;const G=new h(o.maxResults,H,o.previewOptions);G.on("result",ye=>{L=!0,z="",A.report(ye)});let M=!1;const O=()=>{M=!0,x&&x.kill(),G&&G.cancel()};let B=!1;G.on("hitLimit",()=>{B=!0,O()});let z="";x.stdout.on("data",ye=>{G.handleData(ye),L||(z+=ye)});let J=!1;x.stdout.once("data",()=>J=!0);let ce="";x.stderr.on("data",ye=>{const Fe=ye.toString();this.outputChannel.appendLine(Fe),ce+=Fe}),x.on("close",()=>{if(this.outputChannel.appendLine(J?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(L?"Got result from parser":"No result from parser"),z&&this.outputChannel.appendLine(`Got data without result: ${z}`),this.outputChannel.appendLine(""),M)$({limitHit:B});else{G.flush(),x=null;let ye;ce&&!J&&(ye=E(ce))?W((0,P.serializeSearchError)(new P.SearchError(ye.message,ye.code))):$({limitHit:B})}})})}}e.RipgrepTextSearchEngine=w;function E(b){const _=b.split(`
`),o=_[0].trim();if(_.some(F=>F.startsWith("regex parse error")))return new P.SearchError(d(_),P.SearchErrorCode.regexParseError);const A=o.match(/grep config error: unknown encoding: (.*)/);if(A)return new P.SearchError(`Unknown encoding: ${A[1]}`,P.SearchErrorCode.unknownEncoding);if(o.startsWith("error parsing glob"))return new P.SearchError(o.charAt(0).toUpperCase()+o.substr(1),P.SearchErrorCode.globParseError);if(o.startsWith("the literal"))return new P.SearchError(o.charAt(0).toUpperCase()+o.substr(1),P.SearchErrorCode.invalidLiteral);if(o.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(o,P.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function d(b){const _=["Regex parse error"],o=b.filter(A=>A.startsWith("PCRE2:"));if(o.length>=1){const A=o[0].replace("PCRE2:","");if(A.indexOf(":")!==-1&&A.split(":").length>=2){const F=A.split(":")[1];_.push(":"+F)}}return _.join("")}e.buildRegexParseError=d;class h extends R.EventEmitter{constructor(_,o,A){super();this.maxResults=_,this.rootFolder=o,this.previewOptions=A,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(_,o){return super.on(_,o),this}handleData(_){if(this.isDone)return;const o=typeof _=="string"?_:this.stringDecoder.write(_);this.handleDecodedData(o)}handleDecodedData(_){let o=_.indexOf(`
`);const A=this.remainder+_;if(o>=0)o+=this.remainder.length;else{this.remainder=A;return}let F=0;for(;o>=0;)this.handleLine(A.substring(F,o).trim()),F=o+1,o=A.indexOf(`
`,F);this.remainder=A.substring(F)}handleLine(_){if(this.isDone||!_)return;let o;try{o=JSON.parse(_)}catch(A){throw new Error(`malformed line from rg: ${_}`)}if(o.type==="match"){const A=v(o.data.path),F=i.URI.file(D.join(this.rootFolder,A)),$=this.createTextSearchMatch(o.data,F);this.onResult($),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(o.type==="context"){const A=v(o.data.path),F=i.URI.file(D.join(this.rootFolder,A));this.createTextSearchContext(o.data,F).forEach(W=>this.onResult(W))}}createTextSearchMatch(_,o){const A=_.line_number-1,F=v(_.lines),$=Buffer.from(F);let W=0,Q=0,H=A;_.submatches.length===0&&_.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const N=(0,y.coalesce)(_.submatches.map((x,L)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const G=v(x.match),M=$.slice(W,x.start).toString().length,O=Q+M,B=t(G),z=H,J=B.numLines+z,ce=B.numLines>0?B.lastLineLength:B.lastLineLength+O;return W=x.end,Q=ce,H=J,new u.Range(z,O,J,ce)}));return(0,c.createTextSearchResult)(o,F,N,this.previewOptions)}createTextSearchContext(_,o){const A=v(_.lines),F=_.line_number;return A.replace(/\r?\n$/,"").split(`
`).map(($,W)=>({text:$,uri:o,lineNumber:F+W}))}onResult(_){this.emit("result",_)}}e.RipgrepParser=h;function v(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const _=/\n/g;let o=0,A=-1,F;for(;F=_.exec(b);)o++,A=F.index;const $=A>=0?b.length-A-1:b.length;return{numLines:o,lastLineLength:$}}function s(b,_){const o=["--hidden"];o.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:A,otherIncludes:F}=(0,T.groupBy)(_.includes,W=>W.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const W=new Set;F.forEach(Q=>{W.add(Q)}),o.push("-g","!*"),W.forEach(Q=>{r(Q).map(c.anchorGlob).forEach(H=>{o.push("-g",H)})})}A&&A.length&&A.forEach(W=>{o.push("-g",W)}),_.excludes.map(c.anchorGlob).forEach(W=>o.push("-g",`!${W}`)),_.maxFileSize&&o.push("--max-filesize",_.maxFileSize+""),_.useIgnoreFiles?o.push("--no-ignore-parent"):o.push("--no-ignore"),_.followSymlinks&&o.push("--follow"),_.encoding&&_.encoding!=="utf8"&&o.push("--encoding",_.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,C.escapeRegExpCharacters)(b.pattern),b.isRegExp=!0),_.usePCRE2&&o.push("--pcre2"),o.push("--crlf"),b.isRegExp&&(b.pattern=n(b.pattern),o.push("--auto-hybrid-regex"));let $;if(b.isWordMatch){const Q=(0,C.createRegExp)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");o.push("--regexp",Q)}else if(b.isRegExp){let W=f(b.pattern);W=m(W),o.push("--regexp",W)}else $=b.pattern,o.push("--fixed-strings");return o.push("--no-config"),_.useGlobalIgnoreFiles||o.push("--no-ignore-global"),o.push("--json"),b.isMultiline&&o.push("--multiline"),_.beforeContext&&o.push("--before-context",_.beforeContext+""),_.afterContext&&o.push("--after-context",_.afterContext+""),o.push("--"),$&&o.push($),o.push("."),o}function r(b){const _=(0,I.splitGlobAware)(b,"/");return _.map((o,A)=>_.slice(0,A+1).join("/"))}e.spreadGlobComponents=r;function n(b){const _=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(_);)b=b.replace(_,"$1\\x{$2}");const o=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(o);)b=b.replace(o,"$1\\x{$2}");return b}e.unicodeEscapesToPCRE2=n;const a=b=>b.type==="Assertion"&&b.kind==="lookbehind";function f(b){let _;try{_=new p.RegExpParser().parsePattern(b)}catch{return b}let o="",A=0;const F=(Q,H,N)=>{o+=b.slice(A,Q)+N,A=H},$=[];return new p.RegExpVisitor({onCharacterEnter(Q){if(Q.raw!=="\\n")return;const H=$[0];if(!H)F(Q.start,Q.end,"\\r?\\n");else if(!$.some(a))if(H.type==="CharacterClass")if(H.negate){const N=b.slice(H.start+2,Q.start)+b.slice(Q.end,H.end-1);F(H.start,H.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=b.slice(H.start+1,Q.start)+b.slice(Q.end,H.end-1);F(H.start,H.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else H.type==="Quantifier"&&F(Q.start,Q.end,"(?:\\r?\\n)")},onQuantifierEnter(Q){$.unshift(Q)},onQuantifierLeave(){$.shift()},onCharacterClassRangeEnter(Q){$.unshift(Q)},onCharacterClassRangeLeave(){$.shift()},onCharacterClassEnter(Q){$.unshift(Q)},onCharacterClassLeave(){$.shift()},onAssertionEnter(Q){a(Q)&&$.push(Q)},onAssertionLeave(Q){$[0]===Q&&$.shift()}}).visit(_),o+=b.slice(A),o}e.fixRegexNewline=f;function m(b){return b.replace(/\n/g,"\\r?\\n")}e.fixNewline=m}),define(he[275],fe([0,1,21,131,114,10]),function(X,e,g,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class T{constructor(C){this.outputChannel=C,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(C,i,P,u){const p=new R.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===y.Schemas.userData){const l={...i,folder:i.folder.with({scheme:y.Schemas.file})},c=new k.Progress(S=>P.report({...S,uri:S.uri.with({scheme:i.folder.scheme})}));return this.withToken(u,S=>p.provideTextSearchResults(C,l,c,S))}else return this.withToken(u,l=>p.provideTextSearchResults(C,i,P,l))}async withToken(C,i){const P=I(C);this.inProgress.add(P);const u=await i(P.token);return this.inProgress.delete(P),u}dispose(){this.inProgress.forEach(C=>C.cancel())}}e.RipgrepSearchProvider=T;function I(D){const C=new g.CancellationTokenSource;return D.onCancellationRequested(()=>C.cancel()),C}}),define(he[276],fe([0,1,28,131,130]),function(X,e,g,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class y{constructor(D){this.query=D}search(D,C,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(p){i({message:p})}},u=new k.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(P),g);return new Promise((p,l)=>u.search(c=>{C(c.map(T))},D).then(c=>p({limitHit:c.limitHit,type:"success"}),l))}}e.TextSearchEngineAdapter=y;function T(I){return{path:I.resource&&I.resource.fsPath,results:I.results,numMatches:(I.results||[]).reduce((D,C)=>{if(C.ranges){const i=C;return D+(Array.isArray(i.ranges)?i.ranges.length:1)}else return D+1},0)}}}),define(he[277],fe([0,1,45,291,18,17,15,3,97,9,44,2,41,31,274,276]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,R.gracefulify(g);class S{constructor(){this.caches=Object.create(null)}fileSearch(t){let s;const r=d(t),n=new I.Emitter({onFirstListenerDidAdd:()=>{s=(0,y.createCancelablePromise)(a=>this.doFileSearchWithEngine(l.Engine,r,f=>n.fire(f),a)),s.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{s.cancel()}});return n.event}textSearch(t){let s;const r=d(t),n=new I.Emitter({onFirstListenerDidAdd:()=>{s=(0,y.createCancelablePromise)(a=>this.ripgrepTextSearch(r,f=>n.fire(f),a)),s.then(a=>n.fire(a),a=>n.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{s.cancel()}});return n.event}ripgrepTextSearch(t,s,r){return t.maxFileSize=(0,u.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new c.TextSearchEngineAdapter(t).search(r,s,s)}doFileSearch(t,s,r){return this.doFileSearchWithEngine(l.Engine,t,s,r)}doFileSearchWithEngine(t,s,r,n,a=S.BATCH_SIZE){let f=0;const m=_=>{Array.isArray(_)?(f+=_.length,r(_.map(o=>this.rawMatchToSearchItem(o)))):_.relativePath?(f++,r(this.rawMatchToSearchItem(_))):r(_)};if(s.sortByScore){let _=this.trySortedSearchFromCache(s,m,n);if(!_){const o=s.maxResults?Object.assign({},s,{maxResults:null}):s,A=new t(o);_=this.doSortedSearch(A,s,r,m,n)}return new Promise((o,A)=>{_.then(([F,$])=>{const W=$.map(Q=>this.rawMatchToSearchItem(Q));this.sendProgress(W,r,a),o(F)},A)})}const b=new t(s);return this.doSearch(b,m,a,n).then(_=>({limitHit:_.limitHit,type:"success",stats:{detailStats:_.stats,type:"searchProcess",fromCache:!1,resultCount:f,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,C.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,s,r,n,a){const f=new I.Emitter;let m=(0,y.createCancelablePromise)(_=>{let o=[];const A=F=>{Array.isArray(F)?o=F:(n(F),f.fire(F))};return this.doSearch(t,A,-1,_).then(F=>[F,o])}),b;if(s.cacheKey){b=this.getOrCreateCache(s.cacheKey);const _={promise:m,event:f.event,resolved:!1};b.resultsToSearchCache[s.filePattern||""]=_,m.then(()=>{_.resolved=!0},o=>{delete b.resultsToSearchCache[s.filePattern||""]}),m=this.preventCancellation(m)}return m.then(([_,o])=>{const A=b?b.scorerCache:Object.create(null),F=(typeof s.maxResults!="number"||s.maxResults>0)&&i.StopWatch.create(!1);return this.sortResults(s,o,A,a).then($=>{const W=F?F.elapsed():-1;return[{type:"success",stats:{detailStats:_.stats,sortingTime:W,fromCache:!1,type:"searchProcess",workspaceFolderCount:s.folderQueries.length,resultCount:$.length},messages:_.messages,limitHit:_.limitHit||typeof s.maxResults=="number"&&o.length>s.maxResults},$]})})}getOrCreateCache(t){const s=this.caches[t];return s||(this.caches[t]=new w)}trySortedSearchFromCache(t,s,r){const n=t.cacheKey&&this.caches[t.cacheKey];if(!n)return;const a=this.getResultsFromCache(n,t.filePattern||"",s,r);if(a)return a.then(([f,m,b])=>{const _=i.StopWatch.create(!1);return this.sortResults(t,m,n.scorerCache,r).then(o=>{const A=_.elapsed(),F={fromCache:!0,detailStats:b,type:"searchProcess",resultCount:m.length,sortingTime:A};return[{type:"success",limitHit:f.limitHit||typeof t.maxResults=="number"&&m.length>t.maxResults,stats:F},o]})})}sortResults(t,s,r,n){const a=(0,D.prepareQuery)(t.filePattern||""),f=(b,_)=>(0,D.compareItemsByFuzzyScore)(b,_,a,!0,E,r),m=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return k.topAsync(s,f,m,1e4,n)}sendProgress(t,s,r){if(r&&r>0)for(let n=0;n<t.length;n+=r)s(t.slice(n,n+r));else s(t)}getResultsFromCache(t,s,r,n){const a=i.StopWatch.create(!1),f=s.indexOf(C.sep)>=0;let m;for(const A in t.resultsToSearchCache)if(s.startsWith(A)){if(f&&A.indexOf(C.sep)<0&&A!=="")continue;const F=t.resultsToSearchCache[A];m={promise:this.preventCancellation(F.promise),event:F.event,resolved:F.resolved};break}if(!m)return null;const b=a.elapsed(),_=i.StopWatch.create(!1),o=m.event(r);return n&&n.onCancellationRequested(()=>{o.dispose()}),m.promise.then(([A,F])=>{if(n&&n.isCancellationRequested)throw(0,T.canceled)();const $=[],W=(0,D.prepareQuery)(s).normalizedLowercase;for(const Q of F)!(0,p.isFilePatternMatch)(Q,W)||$.push(Q);return[A,$,{cacheWasResolved:m.resolved,cacheLookupTime:b,cacheFilterTime:_.elapsed(),cacheEntryCount:F.length}]})}doSearch(t,s,r,n){return new Promise((a,f)=>{let m=[];n&&n.onCancellationRequested(()=>t.cancel()),t.search(b=>{b&&(r?(m.push(b),r>0&&m.length>=r&&(s(m),m=[])):s(b))},b=>{s(b)},(b,_)=>{m.length&&s(m),b?f(b):a(_)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,r){return t.then(s,r)}catch(s){return this.then(void 0,s)}finally(s){return t.finally(s)}}}}e.SearchService=S,S.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(v){return(0,C.basename)(v.relativePath)}getItemDescription(v){return(0,C.dirname)(v.relativePath)}getItemPath(v){return v.relativePath}};function d(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(h),extraFileResources:v.extraFileResources&&v.extraFileResources.map(t=>P.URI.revive(t))}}function h(v){return{...v,folder:P.URI.revive(v.folder)}}}),define(he[278],fe([0,1,6,2,28,12,31,277,275,90,13,60,27,68,10,130]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends p.ExtHostSearch{constructor(E,d,h,v){super(E,h,v);this._pfs=k,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new C.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(l.Schemas.userData,new D.RipgrepSearchProvider(t)),d.remote.isRemote&&d.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const E=new C.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(l.Schemas.file,new D.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(l.Schemas.file,new I.SearchService)}registerInternalFileSearchProvider(E,d){const h=this._handlePool++;return this._internalFileSearchProvider=d,this._internalFileSearchHandle=h,this._proxy.$registerFileSearchProvider(h,this._transformScheme(E)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(E,d,h,v){const t=(0,p.reviveQuery)(h);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,d,t,v):super.$provideFileSearchResults(E,d,h,v)}doInternalFileSearch(E,d,h,v){const t=s=>{if((0,T.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this._proxy.$handleFileMatch(E,d,s.map(r=>R.URI.file(r.path)));return}s.message&&this._logService.debug("ExtHostSearch",s.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(h,t,v)}$clearCache(E){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,d){return new c.NativeTextSearchManager(E,d)}};S=je([He(0,i.IExtHostRpcService),He(1,u.IExtHostInitDataService),He(2,P.IURITransformerService),He(3,y.ILogService)],S),e.NativeExtHostSearch=S}),define(he[132],fe([0,1,292,121,293,3,103,9,101,32,6,22,104,15,11]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class c{constructor(m){this.socket=m,this._errorListener=b=>{if(b){if(b.code==="EPIPE")return;(0,p.onUnexpectedError)(b)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(m){const b=_=>m(P.VSBuffer.wrap(_));return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(m){const b=_=>{m({type:0,hadError:_,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(m){return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(m){if(!this.socket.destroyed)try{this.socket.write(m.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,p.onUnexpectedError)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,p.onUnexpectedError)(b)}}end(){this.socket.end()}drain(){return new Promise((m,b)=>{if(this.socket.bufferSize===0){m();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),m()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=c;var S;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var w;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(w||(w={}));class E extends i.Disposable{constructor(m,b,_,o){super();this._onDidZlibFlush=this._register(new y.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=m,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=b,this._recordInflateBytes=o,b?(this._zlibInflate=k.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",A=>{console.error(A),(0,p.onUnexpectedError)(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibInflate.on("data",A=>{this._pendingInflateData.push(A)}),_&&(this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=k.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{console.error(A),(0,p.onUnexpectedError)(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibDeflate.on("data",A=>{this._pendingDeflateData.push(A)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new u.ChunkStream,this._register(this.socket.onData(A=>this._acceptChunk(A))),this._register(this.socket.onClose(A=>this._onClose.fire(A)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?P.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):P.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){this._totalOutgoingDataBytes+=m.byteLength,this._zlibDeflate?(this._zlibDeflate.write(m.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let b=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.length-4),this._isEnded||this._write(P.VSBuffer.wrap(b),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(m,!1)}_write(m,b){let _=2;m.byteLength<126?_+=0:m.byteLength<2**16?_+=2:_+=8;const o=P.VSBuffer.alloc(_);if(b?o.writeUInt8(194,0):o.writeUInt8(130,0),m.byteLength<126)o.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){o.writeUInt8(126,1);let A=1;o.writeUInt8(m.byteLength>>>8&255,++A),o.writeUInt8(m.byteLength>>>0&255,++A)}else{o.writeUInt8(127,1);let A=1;o.writeUInt8(0,++A),o.writeUInt8(0,++A),o.writeUInt8(0,++A),o.writeUInt8(0,++A),o.writeUInt8(m.byteLength>>>24&255,++A),o.writeUInt8(m.byteLength>>>16&255,++A),o.writeUInt8(m.byteLength>>>8&255,++A),o.writeUInt8(m.byteLength>>>0&255,++A)}this._totalOutgoingWireBytes+=o.byteLength+m.byteLength,this.socket.write(P.VSBuffer.concat([o,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._totalIncomingWireBytes+=m.byteLength,this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const b=this._incomingData.peek(this._state.readLen),o=(b.readUInt8(0)&128)>>>7,A=b.readUInt8(1),F=(A&128)>>>7,$=A&127;this._state.state=2,this._state.readLen=2+(F?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=o,this._state.mask=0}else if(this._state.state===2){const b=this._incomingData.read(this._state.readLen),_=b.readUInt8(1),o=(_&128)>>>7;let A=_&127,F=1;A===126?A=b.readUInt8(++F)*2**8+b.readUInt8(++F):A===127&&(A=b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*2**24+b.readUInt8(++F)*2**16+b.readUInt8(++F)*2**8+b.readUInt8(++F));let $=0;o&&($=b.readUInt8(++F)*2**24+b.readUInt8(++F)*2**16+b.readUInt8(++F)*2**8+b.readUInt8(++F)),this._state.state=3,this._state.readLen=A,this._state.mask=$}else if(this._state.state===3){const b=this._incomingData.read(this._state.readLen);d(b,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(b.buffer)),this._zlibInflate.write(b.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const _=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=_.length,this._onData.fire(P.VSBuffer.wrap(_))})):(this._totalIncomingDataBytes+=b.byteLength,this._onData.fire(b))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await y.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=E;function d(f,m){if(m===0)return;let b=f.byteLength>>>2;for(let W=0;W<b;W++){const Q=f.readUInt32BE(W*4);f.writeUInt32BE(Q^m,W*4)}let _=b*4,o=f.byteLength-_;const A=m>>>24&255,F=m>>>16&255,$=m>>>8&255;o>=1&&f.writeUInt8(f.readUInt8(_)^A,_),o>=2&&f.writeUInt8(f.readUInt8(_+1)^F,_+1),o>=3&&f.writeUInt8(f.readUInt8(_+2)^$,_+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const h={[2]:107,[1]:103};function v(){const f=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let m;return e.XDG_RUNTIME_DIR?m=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):m=(0,I.join)((0,D.tmpdir)(),`vscode-ipc-${f}.sock`),s(m),m}e.createRandomIPCHandle=v;function t(f,m,b){const _=(0,g.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${_}-${b}-${m}-sock`;let o;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?o=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${_.substr(0,8)}-${b}-${m}.sock`):o=(0,I.join)(f,`${b}-${m}.sock`),s(o),o}e.createStaticIPCHandle=t;function s(f){const m=h[l.platform];typeof m=="number"&&f.length>=m&&console.warn(`WARNING: IPC handle "${f}" is longer than ${m} chars, try a shorter --user-data-dir`)}class r extends T.IPCServer{constructor(m){super(r.toClientConnectionEvent(m));this.server=m}static toClientConnectionEvent(m){const b=y.Event.fromNodeEventEmitter(m,"connection");return y.Event.map(b,_=>({protocol:new u.Protocol(new c(_)),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(_,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function n(f){return new Promise((m,b)=>{const _=(0,R.createServer)();_.on("error",b),_.listen(f,()=>{_.removeListener("error",b),m(new r(_))})})}e.serve=n;function a(f,m){return new Promise((b,_)=>{const o=(0,R.createConnection)(f,()=>{o.removeListener("error",_),b(u.Client.fromSocket(new c(o),m))});o.once("error",_)})}e.connect=a}),define(he[279],fe([0,1,132,271,45,50,2,194,12]),function(X,e,g,R,k,y,T,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(u,p,l){this._commands=u,this.logService=p,this._ipcHandlePath=l,this._server=R.createServer((c,S)=>this.onRequest(c,S)),this.setup().catch(c=>(p.error(c),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",u=>this.logService.error(u))}catch(u){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(u,p){const l=[];u.setEncoding("utf8"),u.on("data",c=>l.push(c)),u.on("end",()=>{const c=JSON.parse(l.join(""));switch(c.type){case"open":this.open(c,p);break;case"openExternal":this.openExternal(c,p);break;case"status":this.getStatus(c,p);break;case"extensionManagement":this.manageExtensions(c,p).catch(this.logService.error);break;default:p.writeHead(404),p.write(`Unknown message type: ${c.type}`,S=>{S&&this.logService.error(S)}),p.end();break}})}open(u,p){let{fileURIs:l,folderURIs:c,forceNewWindow:S,diffMode:w,addMode:E,forceReuseWindow:d,gotoLineMode:h,waitMarkerFilePath:v}=u;const t=[];if(Array.isArray(c))for(const s of c)try{t.push({folderUri:T.URI.parse(s)})}catch(r){}if(Array.isArray(l))for(const s of l)try{(0,I.hasWorkspaceFileExtension)(s)?t.push({workspaceUri:T.URI.parse(s)}):t.push({fileUri:T.URI.parse(s)})}catch(r){}if(t.length){const s=v?T.URI.file(v):void 0,n={forceNewWindow:S,diffMode:w,addMode:E,gotoLineMode:h,forceReuseWindow:d,preferNewWindow:!d&&!s&&!E,waitMarkerFileURI:s};this._commands.executeCommand("_remoteCLI.windowOpen",t,n)}p.writeHead(200),p.end()}async openExternal(u,p){for(const l of u.uris){const c=T.URI.parse(l),S=c.scheme==="file"?c:l;await this._commands.executeCommand("_remoteCLI.openExternal",S)}p.writeHead(200),p.end()}async manageExtensions(u,p){try{const l=w=>w?.map(E=>/\.vsix$/i.test(E)?T.URI.parse(E):E),c={list:u.list,install:l(u.install),uninstall:l(u.uninstall),force:u.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",c);p.writeHead(200),p.write(S)}catch(l){p.writeHead(500),p.write(String(l),c=>{c&&this.logService.error(c)})}p.end()}async getStatus(u,p){try{const l=await this._commands.executeCommand("_remoteCLI.getSystemStatus");p.writeHead(200),p.write(l),p.end()}catch(l){p.writeHead(500),p.write(String(l),c=>{c&&this.logService.error(c)}),p.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=C;let i=class extends C{constructor(u,p){super(u,p,(0,g.createRandomIPCHandle)())}};i=je([He(0,y.IExtHostCommands),He(1,D.ILogService)],i),e.CLIServer=i}),define(he[280],fe([0,1,67,267,262,5,270,39,252,2,10,7,279,102]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class l extends k.RequireInterceptor{_installInterceptor(){const w=this,E=X.__$__nodeRequire("module"),d=E._load;E._load=function(v,t,s){for(let r of w._alternatives){let n=r(v);if(n){v=n;break}}return w._factories.has(v)?w._factories.get(v).load(v,C.URI.file((0,p.realpathSync)(t.filename)),r=>d.apply(this,[r,t,s])):d.apply(this,arguments)}}}class c extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(u.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(l,w,this._registry).install(),g.mark("code/extHost/didInitAPI");const d=await this._extHostConfiguration.getConfigProvider();await(0,T.connectProxyResolver)(this._extHostWorkspace,d,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const h=process.send,v=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?h.apply(process,t):(v.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,E,d){if(E.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let h=null;d.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{w&&g.mark(`code/extHost/willLoadExtensionCode/${w.value}`),h=X.__$__nodeRequire(E.fsPath)}catch(v){return Promise.reject(v)}finally{w&&g.mark(`code/extHost/didLoadExtensionCode/${w.value}`),d.codeLoadingStop()}return Promise.resolve(h)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const E in w){const d=w[E];d===null?delete process.env[E]:process.env[E]=d}}}e.ExtHostExtensionService=c}),define(he[281],fe([0,1,78,253,255,264,263,278,280,221,256,51,39,62,68,66,33,49,12,63,254]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c,S,w,E,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(u.IExtHostExtensionService,D.ExtHostExtensionService),(0,g.registerSingleton)(E.ILogService,C.ExtHostLogService),(0,g.registerSingleton)(d.IExtensionStoragePaths,h.ExtensionStoragePaths),(0,g.registerSingleton)(P.IExtHostDebugService,T.ExtHostDebugService),(0,g.registerSingleton)(p.IExtHostOutputService,R.ExtHostOutputService2),(0,g.registerSingleton)(l.IExtHostSearch,I.NativeExtHostSearch),(0,g.registerSingleton)(c.IExtHostTask,y.ExtHostTask),(0,g.registerSingleton)(S.IExtHostTerminalService,k.ExtHostTerminalService),(0,g.registerSingleton)(w.IExtHostTunnelService,i.ExtHostTunnelService)}),define(he[282],fe([0,1,121,294,67,15,104,132,186,219,265,22,99,28,102,17,268,281]),function(X,e,g,R,k,y,T,I,D,C,i,P,u,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const S=R(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const r=X.__$__nodeRequire("module"),n=r._load;r._load=function(a){if(a==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return n.apply(this,arguments)}})();const w=process.exit.bind(process);function E(r){process.exit=function(n){if(r)w(n);else{const a=new Error("An extension called process.exit() and this was prevented.");console.warn(a.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)}}let d=function(r){w()};function h(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((r,n)=>{let a=null,f=setTimeout(()=>{d("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,b=3e5,_=new c.RunOnceScheduler(()=>d("renderer disconnected for too long (1)"),m),o=new c.RunOnceScheduler(()=>d("renderer disconnected for too long (2)"),b);process.on("message",(F,$)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){const W=P.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let Q;if(F.skipWebSocketFrames)Q=new I.NodeSocket($);else{const H=P.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));Q=new I.WebSocketNodeSocket(new I.NodeSocket($),F.permessageDeflate,H,!1)}a?(_.cancel(),o.cancel(),a.beginAcceptReconnection(Q,W),a.endAcceptReconnection()):(clearTimeout(f),a=new T.PersistentProtocol(Q,W),a.onDidDispose(()=>d("renderer disconnected")),r(a),a.onSocketClose(()=>{_.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(o.isScheduled())return;_.isScheduled()&&o.schedule()}});const A={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(A)});{const r=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((n,a)=>{const f=g.createConnection(r,()=>{f.removeListener("error",a),n(new T.PersistentProtocol(new I.NodeSocket(f)))});f.once("error",a),f.on("close",()=>{d("renderer closed the socket")})})}}async function v(){const r=await h();return new class{constructor(){this._onMessage=new T.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,r.onMessage(n=>{(0,C.isMessageOfType)(n,2)?(this._terminating=!0,d("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||r.send(n)}drain(){return r.drain()}}}function t(r){return new Promise(n=>{const a=r.onMessage(f=>{a.dispose();const m=JSON.parse(f.toString()),b=m.commit,_=D.default.commit;b&&_&&b!==_&&w(55);const o=[];process.on("unhandledRejection",($,W)=>{o.push(W),setTimeout(()=>{const Q=o.indexOf(W);Q>=0&&W.catch(H=>{o.splice(Q,1),(0,y.isPromiseCanceledError)(H)||(console.warn(`rejected promise not handled within 1 second: ${H}`),H&&H.stack&&console.warn(`stack trace: ${H.stack}`),(0,y.onUnexpectedError)($))})},1e3)}),process.on("rejectionHandled",$=>{const W=o.indexOf($);W>=0&&o.splice(W,1)}),process.on("uncaughtException",function($){(0,y.onUnexpectedError)($)});let A=0;setInterval(function(){try{process.kill(m.parentPid,0),A=0}catch($){$&&$.code==="EPERM"?(A++,A>=3&&d(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${$.message} (code: ${$.code}) (errno: ${$.errno})`)):d(`parent process ${m.parentPid} does not exist anymore: ${$.message} (code: ${$.code}) (errno: ${$.errno})`)}},1e3);let F;try{F=X.__$__nodeRequire("native-watchdog"),F.start(m.parentPid)}catch($){(0,y.onUnexpectedError)($)}r.send((0,C.createMessageOfType)(0)),n({protocol:r,initData:m})});r.send((0,C.createMessageOfType)(1))})}async function s(){k.mark("code/extHost/willConnectToRenderer");const r=await v();k.mark("code/extHost/didConnectToRenderer");const n=await t(r);k.mark("code/extHost/didWaitForInitData");const{initData:a}=n;E(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=S.useHostProxy!==void 0?S.useHostProxy!=="false":void 0;const f=new class{exit(o){w(o)}exists(o){return p.Promises.exists(o)}realpath(o){return(0,l.realpath)(o)}};let m=null;if(a.remote.authority&&S.uriTransformerPath)try{const o=X.__$__nodeRequire(S.uriTransformerPath)(a.remote.authority);m=new u.URITransformer(o)}catch(_){console.error(_)}const b=new i.ExtensionHostMain(n.protocol,a,f,m);d=_=>b.terminate(_)}e.startExtensionHostProcess=s}),define(he[295],fe([0,1,282]),function(X,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(R=>console.log(R))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/807dfb817fef0d0c5729c1924bd4889b04fa405b/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
