/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/network","vs/base/common/errors","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/platform/log/common/log","vs/base/common/async","vs/base/common/arrays","vs/base/common/cancellation","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/process","vs/base/common/severity","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(te){for(var e=[],h=0,R=te.length;h<R;h++)e[h]=Ee[te[h]];return e};define(Ee[39],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function h(R,D){if(!R)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=h}),define(Ee[76],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const h=Object.prototype.hasOwnProperty;function R(n){const P=[];for(let c in n)h.call(n,c)&&P.push(n[c]);return P}e.values=R;function D(n,P){for(let c in n)if(h.call(n,c)&&P({key:c,value:n[c]},function(){delete n[c]})===!1)return}e.forEach=D;function y(n,P){const c=Object.create(null);for(const f of n){const l=P(f);let o=c[l];o||(o=c[l]=[]),o.push(f)}return c}e.groupBy=y;function k(n){const P=Object.create(null);return n&&n.forEach((c,f)=>{P[f]=c}),P}e.fromMap=k;function S(n,P){const c=[],f=[];for(let l of n)P.has(l)||c.push(l);for(let l of P)n.has(l)||f.push(l);return{removed:c,added:f}}e.diffSets=S;function _(n,P){const c=[],f=[];for(let[l,o]of n)P.has(l)||c.push(o);for(let[l,o]of P)n.has(l)||f.push(o);return{removed:c,added:f}}e.diffMaps=_;class C{constructor(){this.map=new Map}add(P,c){let f=this.map.get(P);f||(f=new Set,this.map.set(P,f)),f.add(c)}delete(P,c){const f=this.map.get(P);!f||(f.delete(c),f.size===0&&this.map.delete(P))}forEach(P,c){const f=this.map.get(P);!f||f.forEach(c)}}e.SetMap=C}),define(Ee[48],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function h(k){return(S,_,C)=>{let n=null,P=null;if(typeof C.value=="function"?(n="value",P=C.value):typeof C.get=="function"&&(n="get",P=C.get),!P)throw new Error("not supported");C[n]=k(P,_)}}e.createDecorator=h;function R(k,S,_){let C=null,n=null;if(typeof _.value=="function"?(C="value",n=_.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(C="get",n=_.get),!n)throw new Error("not supported");const P=`$memoize$${S}`;_[C]=function(...c){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,c)}),this[P]}}e.memoize=R;function D(k,S,_){return h((C,n)=>{const P=`$debounce$${n}`,c=`$debounce$result$${n}`;return function(...f){this[c]||(this[c]=_?_():void 0),clearTimeout(this[P]),S&&(this[c]=S(this[c],...f),f=[this[c]]),this[P]=setTimeout(()=>{C.apply(this,f),this[c]=_?_():void 0},k)}})}e.debounce=D;function y(k,S,_){return h((C,n)=>{const P=`$throttle$timer$${n}`,c=`$throttle$result$${n}`,f=`$throttle$lastRun$${n}`,l=`$throttle$pending$${n}`;return function(...o){if(this[c]||(this[c]=_?_():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),S&&(this[c]=S(this[c],...o)),this[l])return;const w=this[f]+k;w<=Date.now()?(this[f]=Date.now(),C.apply(this,[this[c]]),this[c]=_?_():void 0):(this[l]=!0,this[P]=setTimeout(()=>{this[l]=!1,this[f]=Date.now(),C.apply(this,[this[c]]),this[c]=_?_():void 0},w-Date.now()))}})}e.throttle=y}),define(Ee[12],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class h{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=h,e.errorHandler=new h;function R(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=R;function D(v){_(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=D;function y(v){_(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=y;function k(v){if(v instanceof Error){let{name:t,message:s}=v;const i=v.stacktrace||v.stack;return{$isError:!0,name:t,message:s,stack:i}}return v}e.transformErrorForSerialization=k;const S="Canceled";function _(v){return v instanceof Error&&v.name===S&&v.message===S}e.isPromiseCanceledError=_;class C extends Error{constructor(){super(S);this.name=this.message}}e.CancellationError=C;function n(){const v=new Error(S);return v.name=v.message,v}e.canceled=n;function P(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=P;function c(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=c;function f(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function l(v){const t=new Error(`${v} has been disposed`);return t.name="DISPOSED",t}e.disposed=l;function o(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=o;class w extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=w;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function u(v){const t=v;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function g(v,t=Object.create(null)){const s=new Error(v);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=g}),define(Ee[17],_e([0,1,12]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(N,H=0){return N[N.length-(1+H)]}e.tail=R;function D(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=D;function y(N,H,J=(K,le)=>K===le){if(N===H)return!0;if(!N||!H||N.length!==H.length)return!1;for(let K=0,le=N.length;K<le;K++)if(!J(N[K],H[K]))return!1;return!0}e.equals=y;function k(N,H,J){let K=0,le=N.length-1;for(;K<=le;){const Ie=(K+le)/2|0,Me=J(N[Ie],H);if(Me<0)K=Ie+1;else if(Me>0)le=Ie-1;else return Ie}return-(K+1)}e.binarySearch=k;function S(N,H){let J=0,K=N.length;if(K===0)return 0;for(;J<K;){const le=Math.floor((J+K)/2);H(N[le])?K=le:J=le+1}return J}e.findFirstInSorted=S;function _(N,H,J){if(N=N|0,N>=H.length)throw new TypeError("invalid index");let K=H[Math.floor(H.length*Math.random())],le=[],Ie=[],Me=[];for(let Ve of H){const xe=J(Ve,K);xe<0?le.push(Ve):xe>0?Ie.push(Ve):Me.push(Ve)}return N<le.length?_(N,le,J):N<le.length+Me.length?Me[0]:_(N-(le.length+Me.length),Ie,J)}e.quickSelect=_;function C(N,H){const J=[];let K;for(const le of N.slice(0).sort(H))!K||H(K[0],le)!==0?(K=[le],J.push(K)):K.push(le);return J}e.groupBy=C;function n(N,H,J){const K=[];function le(Ve,xe,Ge){if(xe===0&&Ge.length===0)return;const Ke=K[K.length-1];Ke&&Ke.start+Ke.deleteCount===Ve?(Ke.deleteCount+=xe,Ke.toInsert.push(...Ge)):K.push({start:Ve,deleteCount:xe,toInsert:Ge})}let Ie=0,Me=0;for(;;){if(Ie===N.length){le(Ie,0,H.slice(Me));break}if(Me===H.length){le(Ie,N.length-Ie,[]);break}const Ve=N[Ie],xe=H[Me],Ge=J(Ve,xe);Ge===0?(Ie+=1,Me+=1):Ge<0?(le(Ie,1,[]),Ie+=1):Ge>0&&(le(Ie,0,[xe]),Me+=1)}return K}e.sortedDiff=n;function P(N,H,J){const K=n(N,H,J),le=[],Ie=[];for(const Me of K)le.push(...N.slice(Me.start,Me.start+Me.deleteCount)),Ie.push(...Me.toInsert);return{removed:le,added:Ie}}e.delta=P;function c(N,H,J){if(J===0)return[];const K=N.slice(0,J).sort(H);return l(N,H,K,J,N.length),K}e.top=c;function f(N,H,J,K,le){return J===0?Promise.resolve([]):new Promise((Ie,Me)=>{(async()=>{const Ve=N.length,xe=N.slice(0,J).sort(H);for(let Ge=J,Ke=Math.min(J+K,Ve);Ge<Ve;Ge=Ke,Ke=Math.min(Ke+K,Ve)){if(Ge>J&&await new Promise(qe=>setTimeout(qe)),le&&le.isCancellationRequested)throw(0,h.canceled)();l(N,H,xe,Ge,Ke)}return xe})().then(Ie,Me)})}e.topAsync=f;function l(N,H,J,K,le){for(const Ie=J.length;K<le;K++){const Me=N[K];if(H(Me,J[Ie-1])<0){J.pop();const Ve=S(J,xe=>H(Me,xe)<0);J.splice(Ve,0,Me)}}}function o(N){return N.filter(H=>!!H)}e.coalesce=o;function w(N){let H=0;for(let J=0;J<N.length;J++)N[J]&&(N[H]=N[J],H+=1);N.length=H}e.coalesceInPlace=w;function b(N,H,J){N.splice(J,0,N.splice(H,1)[0])}e.move=b;function E(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=E;function u(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=u;function g(N,H){if(!H)return N.filter((K,le)=>N.indexOf(K)===le);const J=Object.create(null);return N.filter(K=>{const le=H(K);return J[le]?!1:(J[le]=!0,!0)})}e.distinct=g;function v(N){const H=new Set;return N.filter(J=>H.has(J)?!1:(H.add(J),!0))}e.distinctES6=v;function t(N){const H=Object.create(null);return J=>{const K=N(J);return H[K]?!1:(H[K]=!0,!0)}}e.uniqueFilter=t;function s(N,H){for(let J=N.length-1;J>=0;J--){const K=N[J];if(H(K))return J}return-1}e.lastIndex=s;function i(N,H){return N.length>0?N[0]:H}e.firstOrDefault=i;function r(N,H,J=(K,le)=>K===le){let K=0;for(let le=0,Ie=Math.min(N.length,H.length);le<Ie&&J(N[le],H[le]);le++)K++;return K}e.commonPrefixLength=r;function d(N){return[].concat(...N)}e.flatten=d;function m(N,H){let J=typeof H=="number"?N:0;typeof H=="number"?J=N:(J=0,H=N);const K=[];if(J<=H)for(let le=J;le<H;le++)K.push(le);else for(let le=J;le>H;le--)K.push(le);return K}e.range=m;function p(N,H,J){return N.reduce((K,le)=>(K[H(le)]=J?J(le):le,K),Object.create(null))}e.index=p;function I(N,H){return N.push(H),()=>A(N,H)}e.insert=I;function A(N,H){const J=N.indexOf(H);if(J>-1)return N.splice(J,1),H}e.remove=A;function a(N,H,J){const K=N.slice(0,H),le=N.slice(H);return K.concat(J,le)}e.arrayInsert=a;function T(N,H){let J;if(typeof H=="number"){let K=H;J=()=>{const le=Math.sin(K++)*179426549;return le-Math.floor(le)}}else J=Math.random;for(let K=N.length-1;K>0;K-=1){const le=Math.floor(J()*(K+1)),Ie=N[K];N[K]=N[le],N[le]=Ie}}e.shuffle=T;function M(N,H){const J=N.indexOf(H);J>-1&&(N.splice(J,1),N.unshift(H))}e.pushToStart=M;function W(N,H){const J=N.indexOf(H);J>-1&&(N.splice(J,1),N.push(H))}e.pushToEnd=W;function B(N,H){return Array.isArray(N)?N.map(H):H(N)}e.mapArrayOrNot=B;function Z(N){return Array.isArray(N)?N:[N]}e.asArray=Z;function q(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=q;function $(N,H){for(const J of N){const K=H(J);if(K!==void 0)return K}}e.mapFind=$;function V(N,H){let J=Number.MAX_SAFE_INTEGER,K=0;return N.forEach((le,Ie)=>{const Me=H(le);Me<J&&(J=Me,K=Ie)}),K}e.minIndex=V;function F(N,H){let J=Number.MIN_SAFE_INTEGER,K=0;return N.forEach((le,Ie)=>{const Me=H(le);Me>J&&(J=Me,K=Ie)}),K}e.maxIndex=F;class re{constructor(H){this.items=H,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(H){let J=this.firstIdx;for(;J<this.items.length&&H(this.items[J]);)J++;const K=J===this.firstIdx?null:this.items.slice(this.firstIdx,J);return this.firstIdx=J,K}takeFromEndWhile(H){let J=this.lastIdx;for(;J>=0&&H(this.items[J]);)J--;const K=J===this.lastIdx?null:this.items.slice(J+1,this.lastIdx+1);return this.lastIdx=J,K}}e.ArrayQueue=re}),define(Ee[49],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function h(R){const D=this;let y=!1,k;return function(){return y||(y=!0,k=R.apply(D,arguments)),k}}e.once=h}),define(Ee[50],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class h{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=h,e.defaultGenerator=new h("id#")}),define(Ee[40],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var h;(function(R){function D(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}R.is=D;const y=Object.freeze([]);function k(){return y}R.empty=k;function*S(v){yield v}R.single=S;function _(v){return v||y}R.from=_;function C(v){return!v||v[Symbol.iterator]().next().done===!0}R.isEmpty=C;function n(v){return v[Symbol.iterator]().next().value}R.first=n;function P(v,t){for(const s of v)if(t(s))return!0;return!1}R.some=P;function c(v,t){for(const s of v)if(t(s))return s}R.find=c;function*f(v,t){for(const s of v)t(s)&&(yield s)}R.filter=f;function*l(v,t){let s=0;for(const i of v)yield t(i,s++)}R.map=l;function*o(...v){for(const t of v)for(const s of t)yield s}R.concat=o;function*w(v){for(const t of v)for(const s of t)yield s}R.concatNested=w;function b(v,t,s){let i=s;for(const r of v)i=t(i,r);return i}R.reduce=b;function*E(v,t,s=v.length){for(t<0&&(t+=v.length),s<0?s+=v.length:s>v.length&&(s=v.length);t<s;t++)yield v[t]}R.slice=E;function u(v,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,v];const i=v[Symbol.iterator]();for(let r=0;r<t;r++){const d=i.next();if(d.done)return[s,R.empty()];s.push(d.value)}return[s,{[Symbol.iterator](){return i}}]}R.consume=u;function g(v,t,s=(i,r)=>i===r){const i=v[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const d=i.next(),m=r.next();if(d.done!==m.done)return!1;if(d.done)return!0;if(!s(d.value,m.value))return!1}}R.equals=g})(h=e.Iterable||(e.Iterable={}))}),define(Ee[108],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var h;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(h=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function k(t,s=!1){let i=0,r=t.length,d="",m=0,p=16,I=0;function A(q){let $=0,V=0;for(;$<q;){const F=t.charCodeAt(i);if(F>=48&&F<=57)V=V*16+F-48;else if(F>=65&&F<=70)V=V*16+F-65+10;else if(F>=97&&F<=102)V=V*16+F-97+10;else break;i++,$++}return $<q&&(V=-1),V}function a(q){i=q,d="",m=0,p=16,I=0}function T(){const q=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&C(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&C(t.charCodeAt(i)))for(i++;i<t.length&&C(t.charCodeAt(i));)i++;else return I=3,t.substring(q,i);let $=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&C(t.charCodeAt(i))){for(i++;i<t.length&&C(t.charCodeAt(i));)i++;$=i}else I=3;return t.substring(q,$)}function M(){let q="",$=i;for(;;){if(i>=r){q+=t.substring($,i),I=2;break}const V=t.charCodeAt(i);if(V===34){q+=t.substring($,i),i++;break}if(V===92){if(q+=t.substring($,i),i++,i>=r){I=2;break}switch(t.charCodeAt(i++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:const re=A(4);re>=0?q+=String.fromCharCode(re):I=4;break;default:I=5}$=i;continue}if(V>=0&&V<=31)if(_(V)){q+=t.substring($,i),I=2;break}else I=6;i++}return q}function W(){if(d="",I=0,m=i,i>=r)return m=r,p=17;let q=t.charCodeAt(i);if(S(q)){do i++,d+=String.fromCharCode(q),q=t.charCodeAt(i);while(S(q));return p=15}if(_(q))return i++,d+=String.fromCharCode(q),q===13&&t.charCodeAt(i)===10&&(i++,d+=`
`),p=14;switch(q){case 123:return i++,p=1;case 125:return i++,p=2;case 91:return i++,p=3;case 93:return i++,p=4;case 58:return i++,p=6;case 44:return i++,p=5;case 34:return i++,d=M(),p=10;case 47:const $=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!_(t.charCodeAt(i));)i++;return d=t.substring($,i),p=12}if(t.charCodeAt(i+1)===42){i+=2;const V=r-1;let F=!1;for(;i<V;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,F=!0;break}i++}return F||(i++,I=1),d=t.substring($,i),p=13}return d+=String.fromCharCode(q),i++,p=16;case 45:if(d+=String.fromCharCode(q),i++,i===r||!C(t.charCodeAt(i)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return d+=T(),p=11;default:for(;i<r&&B(q);)i++,q=t.charCodeAt(i);if(m!==i){switch(d=t.substring(m,i),d){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return d+=String.fromCharCode(q),i++,p=16}}function B(q){if(S(q)||_(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Z(){let q;do q=W();while(q>=12&&q<=15);return q}return{setPosition:a,getPosition:()=>i,scan:s?Z:W,getToken:()=>p,getTokenValue:()=>d,getTokenOffset:()=>m,getTokenLength:()=>i-m,getTokenError:()=>I}}e.createScanner=k;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function _(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function P(t,s){const i=[],r=new Object;let d;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function I(A,a,T,M){m.value=A,m.offset=a,m.length=T,m.type=M,m.colonOffset=void 0,d=m}try{u(t,{onObjectBegin:(A,a)=>{if(s<=A)throw r;d=void 0,p=s>A,i.push("")},onObjectProperty:(A,a,T)=>{if(s<a||(I(A,a,T,"property"),i[i.length-1]=A,s<=a+T))throw r},onObjectEnd:(A,a)=>{if(s<=A)throw r;d=void 0,i.pop()},onArrayBegin:(A,a)=>{if(s<=A)throw r;d=void 0,i.push(0)},onArrayEnd:(A,a)=>{if(s<=A)throw r;d=void 0,i.pop()},onLiteralValue:(A,a,T)=>{if(s<a||(I(A,a,T,v(A)),s<=a+T))throw r},onSeparator:(A,a,T)=>{if(s<=a)throw r;if(A===":"&&d&&d.type==="property")d.colonOffset=a,p=!1,d=void 0;else if(A===","){const M=i[i.length-1];typeof M=="number"?i[i.length-1]=M+1:(p=!0,i[i.length-1]=""),d=void 0}}})}catch(A){if(A!==r)throw A}return{path:i,previousNode:d,isAtPropertyKey:p,matches:A=>{let a=0;for(let T=0;a<A.length&&T<i.length;T++)if(A[a]===i[T]||A[a]==="*")a++;else if(A[a]!=="**")return!1;return a===A.length}}}e.getLocation=P;function c(t,s=[],i=y.DEFAULT){let r=null,d=[];const m=[];function p(A){Array.isArray(d)?d.push(A):r!==null&&(d[r]=A)}return u(t,{onObjectBegin:()=>{const A={};p(A),m.push(d),d=A,r=null},onObjectProperty:A=>{r=A},onObjectEnd:()=>{d=m.pop()},onArrayBegin:()=>{const A=[];p(A),m.push(d),d=A,r=null},onArrayEnd:()=>{d=m.pop()},onLiteralValue:p,onError:(A,a,T)=>{s.push({error:A,offset:a,length:T})}},i),d[0]}e.parse=c;function f(t,s=[],i=y.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function d(A){r.type==="property"&&(r.length=A-r.offset,r=r.parent)}function m(A){return r.children.push(A),A}u(t,{onObjectBegin:A=>{r=m({type:"object",offset:A,length:-1,parent:r,children:[]})},onObjectProperty:(A,a,T)=>{r=m({type:"property",offset:a,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:A,offset:a,length:T,parent:r})},onObjectEnd:(A,a)=>{r.length=A+a-r.offset,r=r.parent,d(A+a)},onArrayBegin:(A,a)=>{r=m({type:"array",offset:A,length:-1,parent:r,children:[]})},onArrayEnd:(A,a)=>{r.length=A+a-r.offset,r=r.parent,d(A+a)},onLiteralValue:(A,a,T)=>{m({type:v(A),offset:a,length:T,parent:r,value:A}),d(a+T)},onSeparator:(A,a,T)=>{r.type==="property"&&(A===":"?r.colonOffset=a:A===","&&d(a))},onError:(A,a,T)=>{s.push({error:A,offset:a,length:T})}},i);const I=r.children[0];return I&&delete I.parent,I}e.parseTree=f;function l(t,s){if(!t)return;let i=t;for(let r of s)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let d=!1;for(const m of i.children)if(Array.isArray(m.children)&&m.children[0].value===r){i=m.children[1],d=!0;break}if(!d)return}else{const d=r;if(i.type!=="array"||d<0||!Array.isArray(i.children)||d>=i.children.length)return;i=i.children[d]}return i}e.findNodeAtLocation=l;function o(t){if(!t.parent||!t.parent.children)return[];const s=o(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;s.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&s.push(i)}return s}e.getNodePath=o;function w(t){switch(t.type){case"array":return t.children.map(w);case"object":const s=Object.create(null);for(let i of t.children){const r=i.children[1];r&&(s[i.children[0].value]=w(r))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=w;function b(t,s,i=!1){return s>=t.offset&&s<t.offset+t.length||i&&s===t.offset+t.length}e.contains=b;function E(t,s,i=!1){if(b(t,s,i)){const r=t.children;if(Array.isArray(r))for(let d=0;d<r.length&&r[d].offset<=s;d++){const m=E(r[d],s,i);if(m)return m}return t}}e.findNodeAtOffset=E;function u(t,s,i=y.DEFAULT){const r=k(t,!1);function d(Ie){return Ie?()=>Ie(r.getTokenOffset(),r.getTokenLength()):()=>!0}function m(Ie){return Ie?Me=>Ie(Me,r.getTokenOffset(),r.getTokenLength()):()=>!0}const p=d(s.onObjectBegin),I=m(s.onObjectProperty),A=d(s.onObjectEnd),a=d(s.onArrayBegin),T=d(s.onArrayEnd),M=m(s.onLiteralValue),W=m(s.onSeparator),B=d(s.onComment),Z=m(s.onError),q=i&&i.disallowComments,$=i&&i.allowTrailingComma;function V(){for(;;){const Ie=r.scan();switch(r.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:q||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(Ie){case 12:case 13:q?F(10):B();break;case 16:F(1);break;case 15:case 14:break;default:return Ie}}}function F(Ie,Me=[],Ve=[]){if(Z(Ie),Me.length+Ve.length>0){let xe=r.getToken();for(;xe!==17;){if(Me.indexOf(xe)!==-1){V();break}else if(Ve.indexOf(xe)!==-1)break;xe=V()}}}function re(Ie){const Me=r.getTokenValue();return Ie?M(Me):I(Me),V(),!0}function N(){switch(r.getToken()){case 11:let Ie=0;try{Ie=JSON.parse(r.getTokenValue()),typeof Ie!="number"&&(F(2),Ie=0)}catch(Me){F(2)}M(Ie);break;case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return V(),!0}function H(){return r.getToken()!==10?(F(3,[],[2,5]),!1):(re(!1),r.getToken()===6?(W(":"),V(),le()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function J(){p(),V();let Ie=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(Ie||F(4,[],[]),W(","),V(),r.getToken()===2&&$)break}else Ie&&F(6,[],[]);H()||F(4,[],[2,5]),Ie=!0}return A(),r.getToken()!==2?F(7,[2],[]):V(),!0}function K(){a(),V();let Ie=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(Ie||F(4,[],[]),W(","),V(),r.getToken()===4&&$)break}else Ie&&F(6,[],[]);le()||F(4,[],[4,5]),Ie=!0}return T(),r.getToken()!==4?F(8,[4],[]):V(),!0}function le(){switch(r.getToken()){case 3:return K();case 1:return J();case 10:return re(!0);default:return N()}}return V(),r.getToken()===17?i.allowEmptyContent?!0:(F(4,[],[]),!1):le()?(r.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=u;function g(t,s){let i=k(t),r=[],d,m=0,p;do switch(p=i.getPosition(),d=i.scan(),d){case 12:case 13:case 17:m!==p&&r.push(t.substring(m,p)),s!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,s)),m=i.getPosition();break}while(d!==17);return r.join("")}e.stripComments=g;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(Ee[109],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class h{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new h(()=>D(this.getValue()))}}e.Lazy=h}),define(Ee[7],_e([0,1,49,40]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let y=null;function k(s){y=s}if(e.setDisposableTracker=k,D){const s="__is_disposable_tracked__";k(new class{trackDisposable(i){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[s]||console.log(r)},3e3)}setParent(i,r){if(i&&i!==E.None)try{i[s]=!0}catch{}}markAsDisposed(i){if(i&&i!==E.None)try{i[s]=!0}catch{}}markAsSingleton(i){}})}function S(s){return y?.trackDisposable(s),s}function _(s){y?.markAsDisposed(s)}function C(s,i){y?.setParent(s,i)}function n(s,i){if(!!y)for(const r of s)y.setParent(r,i)}function P(s){return y?.markAsSingleton(s),s}e.markAsSingleton=P;class c extends Error{constructor(i){super(`Encountered errors while disposing of store. Errors: [${i.join(", ")}]`);this.errors=i}}e.MultiDisposeError=c;function f(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=f;function l(s){if(R.Iterable.is(s)){let i=[];for(const r of s)if(r)try{r.dispose()}catch(d){i.push(d)}if(i.length===1)throw i[0];if(i.length>1)throw new c(i);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}e.dispose=l;function o(...s){const i=w(()=>l(s));return n(s,i),i}e.combinedDisposable=o;function w(s){const i=S({dispose:(0,h.once)(()=>{_(i),s()})});return i}e.toDisposable=w;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,S(this)}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}clear(){try{l(this._toDispose.values())}finally{this._toDispose.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return C(i,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(i),i}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class E{constructor(){this._store=new b,S(this),C(this._store,this)}dispose(){_(this),this._store.dispose()}_register(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(i)}}e.Disposable=E,E.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(i){this._isDisposed||i===this._value||(this._value?.dispose(),i&&C(i,this),this._value=i)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,_(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const i=this._value;return this._value=void 0,i&&C(i,null),i}}e.MutableDisposable=u;class g{constructor(){this.references=new Map}acquire(i,...r){let d=this.references.get(i);d||(d={counter:0,object:this.createReferencedObject(i,...r)},this.references.set(i,d));const{object:m}=d,p=(0,h.once)(()=>{--d.counter==0&&(this.destroyReferencedObject(i,d.object),this.references.delete(i))});return d.counter++,{object:m,dispose:p}}}e.ReferenceCollection=g;class v{constructor(i){this.referenceCollection=i}async acquire(i,...r){const d=this.referenceCollection.acquire(i,...r);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(m){throw d.dispose(),m}}}e.AsyncReferenceCollection=v;class t{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=t}),define(Ee[77],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class h{constructor(y){this.element=y,this.next=h.Undefined,this.prev=h.Undefined}}h.Undefined=new h(void 0);class R{constructor(){this._first=h.Undefined,this._last=h.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===h.Undefined}clear(){let y=this._first;for(;y!==h.Undefined;){const k=y.next;y.prev=h.Undefined,y.next=h.Undefined,y=k}this._first=h.Undefined,this._last=h.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,k){const S=new h(y);if(this._first===h.Undefined)this._first=S,this._last=S;else if(k){const C=this._last;this._last=S,S.prev=C,C.next=S}else{const C=this._first;this._first=S,S.next=C,C.prev=S}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(S))}}shift(){if(this._first!==h.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==h.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==h.Undefined&&y.next!==h.Undefined){const k=y.prev;k.next=y.next,y.next.prev=k}else y.prev===h.Undefined&&y.next===h.Undefined?(this._first=h.Undefined,this._last=h.Undefined):y.next===h.Undefined?(this._last=this._last.prev,this._last.next=h.Undefined):y.prev===h.Undefined&&(this._first=this._first.next,this._first.prev=h.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==h.Undefined;)yield y.element,y=y.next}}e.LinkedList=R}),function(te,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(te=typeof globalThis!="undefined"?globalThis:te||self,te.marked=e())}(this,function(){"use strict";function te(Ce,Se){for(var Pe=0;Pe<Se.length;Pe++){var ie=Se[Pe];ie.enumerable=ie.enumerable||!1,ie.configurable=!0,"value"in ie&&(ie.writable=!0),Object.defineProperty(Ce,ie.key,ie)}}function e(Ce,Se,Pe){return Se&&te(Ce.prototype,Se),Pe&&te(Ce,Pe),Ce}function h(Ce,Se){if(!!Ce){if(typeof Ce=="string")return R(Ce,Se);var Pe=Object.prototype.toString.call(Ce).slice(8,-1);if(Pe==="Object"&&Ce.constructor&&(Pe=Ce.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(Ce);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return R(Ce,Se)}}function R(Ce,Se){(Se==null||Se>Ce.length)&&(Se=Ce.length);for(var Pe=0,ie=new Array(Se);Pe<Se;Pe++)ie[Pe]=Ce[Pe];return ie}function D(Ce,Se){var Pe;if(typeof Symbol=="undefined"||Ce[Symbol.iterator]==null){if(Array.isArray(Ce)||(Pe=h(Ce))||Se&&Ce&&typeof Ce.length=="number"){Pe&&(Ce=Pe);var ie=0;return function(){return ie>=Ce.length?{done:!0}:{done:!1,value:Ce[ie++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Pe=Ce[Symbol.iterator](),Pe.next.bind(Pe)}function y(Ce){var Se={exports:{}};return Ce(Se,Se.exports),Se.exports}var k=y(function(Ce){function Se(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Pe(ie){Ce.exports.defaults=ie}Ce.exports={defaults:Se(),getDefaults:Se,changeDefaults:Pe}}),S=/[&<>"']/,_=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},c=function(Se){return P[Se]};function f(Ce,Se){if(Se){if(S.test(Ce))return Ce.replace(_,c)}else if(C.test(Ce))return Ce.replace(n,c);return Ce}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Ce){return Ce.replace(l,function(Se,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var w=/(^|[^\[])\^/g;function b(Ce,Se){Ce=Ce.source||Ce,Se=Se||"";var Pe={replace:function(ae,de){return de=de.source||de,de=de.replace(w,"$1"),Ce=Ce.replace(ae,de),Pe},getRegex:function(){return new RegExp(Ce,Se)}};return Pe}var E=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(Ce,Se,Pe){if(Ce){var ie;try{ie=decodeURIComponent(o(Pe)).replace(E,"").toLowerCase()}catch(ae){return null}if(ie.indexOf("javascript:")===0||ie.indexOf("vbscript:")===0||ie.indexOf("data:")===0)return null}Se&&!u.test(Pe)&&(Pe=r(Se,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(ae){return null}return Pe}var v={},t=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Ce,Se){v[" "+Ce]||(t.test(Ce)?v[" "+Ce]=Ce+"/":v[" "+Ce]=I(Ce,"/",!0)),Ce=v[" "+Ce];var Pe=Ce.indexOf(":")===-1;return Se.substring(0,2)==="//"?Pe?Se:Ce.replace(s,"$1")+Se:Se.charAt(0)==="/"?Pe?Se:Ce.replace(i,"$1")+Se:Ce+Se}var d={exec:function(){}};function m(Ce){for(var Se=1,Pe,ie;Se<arguments.length;Se++){Pe=arguments[Se];for(ie in Pe)Object.prototype.hasOwnProperty.call(Pe,ie)&&(Ce[ie]=Pe[ie])}return Ce}function p(Ce,Se){var Pe=Ce.replace(/\|/g,function(de,me,x){for(var he=!1,be=me;--be>=0&&x[be]==="\\";)he=!he;return he?"|":" |"}),ie=Pe.split(/ \|/),ae=0;if(ie.length>Se)ie.splice(Se);else for(;ie.length<Se;)ie.push("");for(;ae<ie.length;ae++)ie[ae]=ie[ae].trim().replace(/\\\|/g,"|");return ie}function I(Ce,Se,Pe){var ie=Ce.length;if(ie===0)return"";for(var ae=0;ae<ie;){var de=Ce.charAt(ie-ae-1);if(de===Se&&!Pe)ae++;else if(de!==Se&&Pe)ae++;else break}return Ce.substr(0,ie-ae)}function A(Ce,Se){if(Ce.indexOf(Se[1])===-1)return-1;for(var Pe=Ce.length,ie=0,ae=0;ae<Pe;ae++)if(Ce[ae]==="\\")ae++;else if(Ce[ae]===Se[0])ie++;else if(Ce[ae]===Se[1]&&(ie--,ie<0))return ae;return-1}function a(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(Ce,Se){if(Se<1)return"";for(var Pe="";Se>1;)Se&1&&(Pe+=Ce),Se>>=1,Ce+=Ce;return Pe+Ce}var M={escape:f,unescape:o,edit:b,cleanUrl:g,resolveUrl:r,noopTest:d,merge:m,splitCells:p,rtrim:I,findClosingBracket:A,checkSanitizeDeprecation:a,repeatString:T},W=k.defaults,B=M.rtrim,Z=M.splitCells,q=M.escape,$=M.findClosingBracket;function V(Ce,Se,Pe){var ie=Se.href,ae=Se.title?q(Se.title):null,de=Ce[1].replace(/\\([\[\]])/g,"$1");return Ce[0].charAt(0)!=="!"?{type:"link",raw:Pe,href:ie,title:ae,text:de}:{type:"image",raw:Pe,href:ie,title:ae,text:q(de)}}function F(Ce,Se){var Pe=Ce.match(/^(\s+)(?:```)/);if(Pe===null)return Se;var ie=Pe[1];return Se.split(`
`).map(function(ae){var de=ae.match(/^\s+/);if(de===null)return ae;var me=de[0];return me.length>=ie.length?ae.slice(ie.length):ae}).join(`
`)}var re=function(){function Ce(Pe){this.options=Pe||W}var Se=Ce.prototype;return Se.space=function(ie){var ae=this.rules.block.newline.exec(ie);if(ae)return ae[0].length>1?{type:"space",raw:ae[0]}:{raw:`
`}},Se.code=function(ie){var ae=this.rules.block.code.exec(ie);if(ae){var de=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?de:B(de,`
`)}}},Se.fences=function(ie){var ae=this.rules.block.fences.exec(ie);if(ae){var de=ae[0],me=F(de,ae[3]||"");return{type:"code",raw:de,lang:ae[2]?ae[2].trim():ae[2],text:me}}},Se.heading=function(ie){var ae=this.rules.block.heading.exec(ie);if(ae){var de=ae[2].trim();if(/#$/.test(de)){var me=B(de,"#");(this.options.pedantic||!me||/ $/.test(me))&&(de=me.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:de}}},Se.nptable=function(ie){var ae=this.rules.block.nptable.exec(ie);if(ae){var de={type:"table",header:Z(ae[1].replace(/^ *| *\| *$/g,"")),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[],raw:ae[0]};if(de.header.length===de.align.length){var me=de.align.length,x;for(x=0;x<me;x++)/^ *-+: *$/.test(de.align[x])?de.align[x]="right":/^ *:-+: *$/.test(de.align[x])?de.align[x]="center":/^ *:-+ *$/.test(de.align[x])?de.align[x]="left":de.align[x]=null;for(me=de.cells.length,x=0;x<me;x++)de.cells[x]=Z(de.cells[x],de.header.length);return de}}},Se.hr=function(ie){var ae=this.rules.block.hr.exec(ie);if(ae)return{type:"hr",raw:ae[0]}},Se.blockquote=function(ie){var ae=this.rules.block.blockquote.exec(ie);if(ae){var de=ae[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ae[0],text:de}}},Se.list=function(ie){var ae=this.rules.block.list.exec(ie);if(ae){var de=ae[0],me=ae[2],x=me.length>1,he={type:"list",raw:de,ordered:x,start:x?+me.slice(0,-1):"",loose:!1,items:[]},be=ae[0].match(this.rules.block.item),Ae=!1,Fe,We,et,Qe,Ye,lt,ct,ve,we=be.length;et=this.rules.block.listItemStart.exec(be[0]);for(var oe=0;oe<we;oe++){if(Fe=be[oe],de=Fe,oe!==we-1){if(Qe=this.rules.block.listItemStart.exec(be[oe+1]),this.options.pedantic?Qe[1].length>et[1].length:Qe[1].length>et[0].length||Qe[1].length>3){be.splice(oe,2,be[oe]+`
`+be[oe+1]),oe--,we--;continue}else(!this.options.pedantic||this.options.smartLists?Qe[2][Qe[2].length-1]!==me[me.length-1]:x===(Qe[2].length===1))&&(Ye=be.slice(oe+1).join(`
`),he.raw=he.raw.substring(0,he.raw.length-Ye.length),oe=we-1);et=Qe}We=Fe.length,Fe=Fe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Fe.indexOf(`
 `)&&(We-=Fe.length,Fe=this.options.pedantic?Fe.replace(/^ {1,4}/gm,""):Fe.replace(new RegExp("^ {1,"+We+"}","gm"),"")),lt=Ae||/\n\n(?!\s*$)/.test(Fe),oe!==we-1&&(Ae=Fe.charAt(Fe.length-1)===`
`,lt||(lt=Ae)),lt&&(he.loose=!0),this.options.gfm&&(ct=/^\[[ xX]\] /.test(Fe),ve=void 0,ct&&(ve=Fe[1]!==" ",Fe=Fe.replace(/^\[[ xX]\] +/,""))),he.items.push({type:"list_item",raw:de,task:ct,checked:ve,loose:lt,text:Fe})}return he}},Se.html=function(ie){var ae=this.rules.block.html.exec(ie);if(ae)return{type:this.options.sanitize?"paragraph":"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):q(ae[0]):ae[0]}},Se.def=function(ie){var ae=this.rules.block.def.exec(ie);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var de=ae[1].toLowerCase().replace(/\s+/g," ");return{tag:de,raw:ae[0],href:ae[2],title:ae[3]}}},Se.table=function(ie){var ae=this.rules.block.table.exec(ie);if(ae){var de={type:"table",header:Z(ae[1].replace(/^ *| *\| *$/g,"")),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ae[3]?ae[3].replace(/\n$/,"").split(`
`):[]};if(de.header.length===de.align.length){de.raw=ae[0];var me=de.align.length,x;for(x=0;x<me;x++)/^ *-+: *$/.test(de.align[x])?de.align[x]="right":/^ *:-+: *$/.test(de.align[x])?de.align[x]="center":/^ *:-+ *$/.test(de.align[x])?de.align[x]="left":de.align[x]=null;for(me=de.cells.length,x=0;x<me;x++)de.cells[x]=Z(de.cells[x].replace(/^ *\| *| *\| *$/g,""),de.header.length);return de}}},Se.lheading=function(ie){var ae=this.rules.block.lheading.exec(ie);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1]}},Se.paragraph=function(ie){var ae=this.rules.block.paragraph.exec(ie);if(ae)return{type:"paragraph",raw:ae[0],text:ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1]}},Se.text=function(ie){var ae=this.rules.block.text.exec(ie);if(ae)return{type:"text",raw:ae[0],text:ae[0]}},Se.escape=function(ie){var ae=this.rules.inline.escape.exec(ie);if(ae)return{type:"escape",raw:ae[0],text:q(ae[1])}},Se.tag=function(ie,ae,de){var me=this.rules.inline.tag.exec(ie);if(me)return!ae&&/^<a /i.test(me[0])?ae=!0:ae&&/^<\/a>/i.test(me[0])&&(ae=!1),!de&&/^<(pre|code|kbd|script)(\s|>)/i.test(me[0])?de=!0:de&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(me[0])&&(de=!1),{type:this.options.sanitize?"text":"html",raw:me[0],inLink:ae,inRawBlock:de,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):q(me[0]):me[0]}},Se.link=function(ie){var ae=this.rules.inline.link.exec(ie);if(ae){var de=ae[2].trim();if(!this.options.pedantic&&/^</.test(de)){if(!/>$/.test(de))return;var me=B(de.slice(0,-1),"\\");if((de.length-me.length)%2==0)return}else{var x=$(ae[2],"()");if(x>-1){var he=ae[0].indexOf("!")===0?5:4,be=he+ae[1].length+x;ae[2]=ae[2].substring(0,x),ae[0]=ae[0].substring(0,be).trim(),ae[3]=""}}var Ae=ae[2],Fe="";if(this.options.pedantic){var We=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);We&&(Ae=We[1],Fe=We[3])}else Fe=ae[3]?ae[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(de)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),V(ae,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Fe&&Fe.replace(this.rules.inline._escapes,"$1")},ae[0])}},Se.reflink=function(ie,ae){var de;if((de=this.rules.inline.reflink.exec(ie))||(de=this.rules.inline.nolink.exec(ie))){var me=(de[2]||de[1]).replace(/\s+/g," ");if(me=ae[me.toLowerCase()],!me||!me.href){var x=de[0].charAt(0);return{type:"text",raw:x,text:x}}return V(de,me,de[0])}},Se.emStrong=function(ie,ae,de){de===void 0&&(de="");var me=this.rules.inline.emStrong.lDelim.exec(ie);if(!!me&&!(me[3]&&de.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var x=me[1]||me[2]||"";if(!x||x&&(de===""||this.rules.inline.punctuation.exec(de))){var he=me[0].length-1,be,Ae,Fe=he,We=0,et=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(et.lastIndex=0,ae=ae.slice(-1*ie.length+he);(me=et.exec(ae))!=null;)if(be=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!be){if(Ae=be.length,me[3]||me[4]){Fe+=Ae;continue}else if((me[5]||me[6])&&he%3&&!((he+Ae)%3)){We+=Ae;continue}if(Fe-=Ae,!(Fe>0)){if(Fe+We-Ae<=0&&!ae.slice(et.lastIndex).match(et)&&(Ae=Math.min(Ae,Ae+Fe+We)),Math.min(he,Ae)%2)return{type:"em",raw:ie.slice(0,he+me.index+Ae+1),text:ie.slice(1,he+me.index+Ae)};if(Math.min(he,Ae)%2==0)return{type:"strong",raw:ie.slice(0,he+me.index+Ae+1),text:ie.slice(2,he+me.index+Ae-1)}}}}}},Se.codespan=function(ie){var ae=this.rules.inline.code.exec(ie);if(ae){var de=ae[2].replace(/\n/g," "),me=/[^ ]/.test(de),x=/^ /.test(de)&&/ $/.test(de);return me&&x&&(de=de.substring(1,de.length-1)),de=q(de,!0),{type:"codespan",raw:ae[0],text:de}}},Se.br=function(ie){var ae=this.rules.inline.br.exec(ie);if(ae)return{type:"br",raw:ae[0]}},Se.del=function(ie){var ae=this.rules.inline.del.exec(ie);if(ae)return{type:"del",raw:ae[0],text:ae[2]}},Se.autolink=function(ie,ae){var de=this.rules.inline.autolink.exec(ie);if(de){var me,x;return de[2]==="@"?(me=q(this.options.mangle?ae(de[1]):de[1]),x="mailto:"+me):(me=q(de[1]),x=me),{type:"link",raw:de[0],text:me,href:x,tokens:[{type:"text",raw:me,text:me}]}}},Se.url=function(ie,ae){var de;if(de=this.rules.inline.url.exec(ie)){var me,x;if(de[2]==="@")me=q(this.options.mangle?ae(de[0]):de[0]),x="mailto:"+me;else{var he;do he=de[0],de[0]=this.rules.inline._backpedal.exec(de[0])[0];while(he!==de[0]);me=q(de[0]),de[1]==="www."?x="http://"+me:x=me}return{type:"link",raw:de[0],text:me,href:x,tokens:[{type:"text",raw:me,text:me}]}}},Se.inlineText=function(ie,ae,de){var me=this.rules.inline.text.exec(ie);if(me){var x;return ae?x=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):q(me[0]):me[0]:x=q(this.options.smartypants?de(me[0]):me[0]),{type:"text",raw:me[0],text:x}}},Ce}(),N=M.noopTest,H=M.edit,J=M.merge,K={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:N,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};K._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,K._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,K.def=H(K.def).replace("label",K._label).replace("title",K._title).getRegex(),K.bullet=/(?:[*+-]|\d{1,9}[.)])/,K.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,K.item=H(K.item,"gm").replace(/bull/g,K.bullet).getRegex(),K.listItemStart=H(/^( *)(bull)/).replace("bull",K.bullet).getRegex(),K.list=H(K.list).replace(/bull/g,K.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+K.def.source+")").getRegex(),K._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",K._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,K.html=H(K.html,"i").replace("comment",K._comment).replace("tag",K._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),K.paragraph=H(K._paragraph).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",K._tag).getRegex(),K.blockquote=H(K.blockquote).replace("paragraph",K.paragraph).getRegex(),K.normal=J({},K),K.gfm=J({},K.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),K.gfm.nptable=H(K.gfm.nptable).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",K._tag).getRegex(),K.gfm.table=H(K.gfm.table).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",K._tag).getRegex(),K.pedantic=J({},K.normal,{html:H(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",K._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:H(K.normal._paragraph).replace("hr",K.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",K.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var le={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};le._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",le.punctuation=H(le.punctuation).replace(/punctuation/g,le._punctuation).getRegex(),le.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,le.escapedEmSt=/\\\*|\\_/g,le._comment=H(K._comment).replace("(?:-->|$)","-->").getRegex(),le.emStrong.lDelim=H(le.emStrong.lDelim).replace(/punct/g,le._punctuation).getRegex(),le.emStrong.rDelimAst=H(le.emStrong.rDelimAst,"g").replace(/punct/g,le._punctuation).getRegex(),le.emStrong.rDelimUnd=H(le.emStrong.rDelimUnd,"g").replace(/punct/g,le._punctuation).getRegex(),le._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,le._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,le._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,le.autolink=H(le.autolink).replace("scheme",le._scheme).replace("email",le._email).getRegex(),le._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,le.tag=H(le.tag).replace("comment",le._comment).replace("attribute",le._attribute).getRegex(),le._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,le._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,le._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,le.link=H(le.link).replace("label",le._label).replace("href",le._href).replace("title",le._title).getRegex(),le.reflink=H(le.reflink).replace("label",le._label).getRegex(),le.reflinkSearch=H(le.reflinkSearch,"g").replace("reflink",le.reflink).replace("nolink",le.nolink).getRegex(),le.normal=J({},le),le.pedantic=J({},le.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:H(/^!?\[(label)\]\((.*?)\)/).replace("label",le._label).getRegex(),reflink:H(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",le._label).getRegex()}),le.gfm=J({},le.normal,{escape:H(le.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),le.gfm.url=H(le.gfm.url,"i").replace("email",le.gfm._extended_email).getRegex(),le.breaks=J({},le.gfm,{br:H(le.br).replace("{2,}","*").getRegex(),text:H(le.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Ie={block:K,inline:le},Me=k.defaults,Ve=Ie.block,xe=Ie.inline,Ge=M.repeatString;function Ke(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function qe(Ce){var Se="",Pe,ie,ae=Ce.length;for(Pe=0;Pe<ae;Pe++)ie=Ce.charCodeAt(Pe),Math.random()>.5&&(ie="x"+ie.toString(16)),Se+="&#"+ie+";";return Se}var U=function(){function Ce(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||Me,this.options.tokenizer=this.options.tokenizer||new re,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ie={block:Ve.normal,inline:xe.normal};this.options.pedantic?(ie.block=Ve.pedantic,ie.inline=xe.pedantic):this.options.gfm&&(ie.block=Ve.gfm,this.options.breaks?ie.inline=xe.breaks:ie.inline=xe.gfm),this.tokenizer.rules=ie}Ce.lex=function(ie,ae){var de=new Ce(ae);return de.lex(ie)},Ce.lexInline=function(ie,ae){var de=new Ce(ae);return de.inlineTokens(ie)};var Se=Ce.prototype;return Se.lex=function(ie){return ie=ie.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ie,this.tokens,!0),this.inline(this.tokens),this.tokens},Se.blockTokens=function(ie,ae,de){ae===void 0&&(ae=[]),de===void 0&&(de=!0),this.options.pedantic&&(ie=ie.replace(/^ +$/gm,""));for(var me,x,he,be;ie;){if(me=this.tokenizer.space(ie)){ie=ie.substring(me.raw.length),me.type&&ae.push(me);continue}if(me=this.tokenizer.code(ie)){ie=ie.substring(me.raw.length),be=ae[ae.length-1],be&&be.type==="paragraph"?(be.raw+=`
`+me.raw,be.text+=`
`+me.text):ae.push(me);continue}if(me=this.tokenizer.fences(ie)){ie=ie.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.heading(ie)){ie=ie.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.nptable(ie)){ie=ie.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.hr(ie)){ie=ie.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.blockquote(ie)){ie=ie.substring(me.raw.length),me.tokens=this.blockTokens(me.text,[],de),ae.push(me);continue}if(me=this.tokenizer.list(ie)){for(ie=ie.substring(me.raw.length),he=me.items.length,x=0;x<he;x++)me.items[x].tokens=this.blockTokens(me.items[x].text,[],!1);ae.push(me);continue}if(me=this.tokenizer.html(ie)){ie=ie.substring(me.raw.length),ae.push(me);continue}if(de&&(me=this.tokenizer.def(ie))){ie=ie.substring(me.raw.length),this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(ie)){ie=ie.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.lheading(ie)){ie=ie.substring(me.raw.length),ae.push(me);continue}if(de&&(me=this.tokenizer.paragraph(ie))){ie=ie.substring(me.raw.length),ae.push(me);continue}if(me=this.tokenizer.text(ie)){ie=ie.substring(me.raw.length),be=ae[ae.length-1],be&&be.type==="text"?(be.raw+=`
`+me.raw,be.text+=`
`+me.text):ae.push(me);continue}if(ie){var Ae="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return ae},Se.inline=function(ie){var ae,de,me,x,he,be,Ae=ie.length;for(ae=0;ae<Ae;ae++)switch(be=ie[ae],be.type){case"paragraph":case"text":case"heading":{be.tokens=[],this.inlineTokens(be.text,be.tokens);break}case"table":{for(be.tokens={header:[],cells:[]},x=be.header.length,de=0;de<x;de++)be.tokens.header[de]=[],this.inlineTokens(be.header[de],be.tokens.header[de]);for(x=be.cells.length,de=0;de<x;de++)for(he=be.cells[de],be.tokens.cells[de]=[],me=0;me<he.length;me++)be.tokens.cells[de][me]=[],this.inlineTokens(he[me],be.tokens.cells[de][me]);break}case"blockquote":{this.inline(be.tokens);break}case"list":{for(x=be.items.length,de=0;de<x;de++)this.inline(be.items[de].tokens);break}}return ie},Se.inlineTokens=function(ie,ae,de,me){ae===void 0&&(ae=[]),de===void 0&&(de=!1),me===void 0&&(me=!1);var x,he,be=ie,Ae,Fe,We;if(this.tokens.links){var et=Object.keys(this.tokens.links);if(et.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(be))!=null;)et.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(be=be.slice(0,Ae.index)+"["+Ge("a",Ae[0].length-2)+"]"+be.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(be))!=null;)be=be.slice(0,Ae.index)+"["+Ge("a",Ae[0].length-2)+"]"+be.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(be))!=null;)be=be.slice(0,Ae.index)+"++"+be.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ie;){if(Fe||(We=""),Fe=!1,x=this.tokenizer.escape(ie)){ie=ie.substring(x.raw.length),ae.push(x);continue}if(x=this.tokenizer.tag(ie,de,me)){ie=ie.substring(x.raw.length),de=x.inLink,me=x.inRawBlock;var Qe=ae[ae.length-1];Qe&&x.type==="text"&&Qe.type==="text"?(Qe.raw+=x.raw,Qe.text+=x.text):ae.push(x);continue}if(x=this.tokenizer.link(ie)){ie=ie.substring(x.raw.length),x.type==="link"&&(x.tokens=this.inlineTokens(x.text,[],!0,me)),ae.push(x);continue}if(x=this.tokenizer.reflink(ie,this.tokens.links)){ie=ie.substring(x.raw.length);var Ye=ae[ae.length-1];x.type==="link"?(x.tokens=this.inlineTokens(x.text,[],!0,me),ae.push(x)):Ye&&x.type==="text"&&Ye.type==="text"?(Ye.raw+=x.raw,Ye.text+=x.text):ae.push(x);continue}if(x=this.tokenizer.emStrong(ie,be,We)){ie=ie.substring(x.raw.length),x.tokens=this.inlineTokens(x.text,[],de,me),ae.push(x);continue}if(x=this.tokenizer.codespan(ie)){ie=ie.substring(x.raw.length),ae.push(x);continue}if(x=this.tokenizer.br(ie)){ie=ie.substring(x.raw.length),ae.push(x);continue}if(x=this.tokenizer.del(ie)){ie=ie.substring(x.raw.length),x.tokens=this.inlineTokens(x.text,[],de,me),ae.push(x);continue}if(x=this.tokenizer.autolink(ie,qe)){ie=ie.substring(x.raw.length),ae.push(x);continue}if(!de&&(x=this.tokenizer.url(ie,qe))){ie=ie.substring(x.raw.length),ae.push(x);continue}if(x=this.tokenizer.inlineText(ie,me,Ke)){ie=ie.substring(x.raw.length),x.raw.slice(-1)!=="_"&&(We=x.raw.slice(-1)),Fe=!0,he=ae[ae.length-1],he&&he.type==="text"?(he.raw+=x.raw,he.text+=x.text):ae.push(x);continue}if(ie){var lt="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(lt);break}else throw new Error(lt)}}return ae},e(Ce,null,[{key:"rules",get:function(){return{block:Ve,inline:xe}}}]),Ce}(),G=k.defaults,ne=M.cleanUrl,se=M.escape,ge=function(){function Ce(Pe){this.options=Pe||G}var Se=Ce.prototype;return Se.code=function(ie,ae,de){var me=(ae||"").match(/\S*/)[0];if(this.options.highlight){var x=this.options.highlight(ie,me);x!=null&&x!==ie&&(de=!0,ie=x)}return ie=ie.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+se(me,!0)+'">'+(de?ie:se(ie,!0))+`</code></pre>
`:"<pre><code>"+(de?ie:se(ie,!0))+`</code></pre>
`},Se.blockquote=function(ie){return`<blockquote>
`+ie+`</blockquote>
`},Se.html=function(ie){return ie},Se.heading=function(ie,ae,de,me){return this.options.headerIds?"<h"+ae+' id="'+this.options.headerPrefix+me.slug(de)+'">'+ie+"</h"+ae+`>
`:"<h"+ae+">"+ie+"</h"+ae+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(ie,ae,de){var me=ae?"ol":"ul",x=ae&&de!==1?' start="'+de+'"':"";return"<"+me+x+`>
`+ie+"</"+me+`>
`},Se.listitem=function(ie){return"<li>"+ie+`</li>
`},Se.checkbox=function(ie){return"<input "+(ie?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(ie){return"<p>"+ie+`</p>
`},Se.table=function(ie,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+ie+`</thead>
`+ae+`</table>
`},Se.tablerow=function(ie){return`<tr>
`+ie+`</tr>
`},Se.tablecell=function(ie,ae){var de=ae.header?"th":"td",me=ae.align?"<"+de+' align="'+ae.align+'">':"<"+de+">";return me+ie+"</"+de+`>
`},Se.strong=function(ie){return"<strong>"+ie+"</strong>"},Se.em=function(ie){return"<em>"+ie+"</em>"},Se.codespan=function(ie){return"<code>"+ie+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(ie){return"<del>"+ie+"</del>"},Se.link=function(ie,ae,de){if(ie=ne(this.options.sanitize,this.options.baseUrl,ie),ie===null)return de;var me='<a href="'+se(ie)+'"';return ae&&(me+=' title="'+ae+'"'),me+=">"+de+"</a>",me},Se.image=function(ie,ae,de){if(ie=ne(this.options.sanitize,this.options.baseUrl,ie),ie===null)return de;var me='<img src="'+ie+'" alt="'+de+'"';return ae&&(me+=' title="'+ae+'"'),me+=this.options.xhtml?"/>":">",me},Se.text=function(ie){return ie},Ce}(),X=function(){function Ce(){}var Se=Ce.prototype;return Se.strong=function(ie){return ie},Se.em=function(ie){return ie},Se.codespan=function(ie){return ie},Se.del=function(ie){return ie},Se.html=function(ie){return ie},Se.text=function(ie){return ie},Se.link=function(ie,ae,de){return""+de},Se.image=function(ie,ae,de){return""+de},Se.br=function(){return""},Ce}(),ce=function(){function Ce(){this.seen={}}var Se=Ce.prototype;return Se.serialize=function(ie){return ie.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(ie,ae){var de=ie,me=0;if(this.seen.hasOwnProperty(de)){me=this.seen[ie];do me++,de=ie+"-"+me;while(this.seen.hasOwnProperty(de))}return ae||(this.seen[ie]=me,this.seen[de]=0),de},Se.slug=function(ie,ae){ae===void 0&&(ae={});var de=this.serialize(ie);return this.getNextSafeSlug(de,ae.dryrun)},Ce}(),ke=k.defaults,Be=M.unescape,$e=function(){function Ce(Pe){this.options=Pe||ke,this.options.renderer=this.options.renderer||new ge,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new X,this.slugger=new ce}Ce.parse=function(ie,ae){var de=new Ce(ae);return de.parse(ie)},Ce.parseInline=function(ie,ae){var de=new Ce(ae);return de.parseInline(ie)};var Se=Ce.prototype;return Se.parse=function(ie,ae){ae===void 0&&(ae=!0);var de="",me,x,he,be,Ae,Fe,We,et,Qe,Ye,lt,ct,ve,we,oe,j,Oe,ye,Xe=ie.length;for(me=0;me<Xe;me++)switch(Ye=ie[me],Ye.type){case"space":continue;case"hr":{de+=this.renderer.hr();continue}case"heading":{de+=this.renderer.heading(this.parseInline(Ye.tokens),Ye.depth,Be(this.parseInline(Ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{de+=this.renderer.code(Ye.text,Ye.lang,Ye.escaped);continue}case"table":{for(et="",We="",be=Ye.header.length,x=0;x<be;x++)We+=this.renderer.tablecell(this.parseInline(Ye.tokens.header[x]),{header:!0,align:Ye.align[x]});for(et+=this.renderer.tablerow(We),Qe="",be=Ye.cells.length,x=0;x<be;x++){for(Fe=Ye.tokens.cells[x],We="",Ae=Fe.length,he=0;he<Ae;he++)We+=this.renderer.tablecell(this.parseInline(Fe[he]),{header:!1,align:Ye.align[he]});Qe+=this.renderer.tablerow(We)}de+=this.renderer.table(et,Qe);continue}case"blockquote":{Qe=this.parse(Ye.tokens),de+=this.renderer.blockquote(Qe);continue}case"list":{for(lt=Ye.ordered,ct=Ye.start,ve=Ye.loose,be=Ye.items.length,Qe="",x=0;x<be;x++)oe=Ye.items[x],j=oe.checked,Oe=oe.task,we="",oe.task&&(ye=this.renderer.checkbox(j),ve?oe.tokens.length>0&&oe.tokens[0].type==="text"?(oe.tokens[0].text=ye+" "+oe.tokens[0].text,oe.tokens[0].tokens&&oe.tokens[0].tokens.length>0&&oe.tokens[0].tokens[0].type==="text"&&(oe.tokens[0].tokens[0].text=ye+" "+oe.tokens[0].tokens[0].text)):oe.tokens.unshift({type:"text",text:ye}):we+=ye),we+=this.parse(oe.tokens,ve),Qe+=this.renderer.listitem(we,Oe,j);de+=this.renderer.list(Qe,lt,ct);continue}case"html":{de+=this.renderer.html(Ye.text);continue}case"paragraph":{de+=this.renderer.paragraph(this.parseInline(Ye.tokens));continue}case"text":{for(Qe=Ye.tokens?this.parseInline(Ye.tokens):Ye.text;me+1<Xe&&ie[me+1].type==="text";)Ye=ie[++me],Qe+=`
`+(Ye.tokens?this.parseInline(Ye.tokens):Ye.text);de+=ae?this.renderer.paragraph(Qe):Qe;continue}default:{var Je='Token with "'+Ye.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}return de},Se.parseInline=function(ie,ae){ae=ae||this.renderer;var de="",me,x,he=ie.length;for(me=0;me<he;me++)switch(x=ie[me],x.type){case"escape":{de+=ae.text(x.text);break}case"html":{de+=ae.html(x.text);break}case"link":{de+=ae.link(x.href,x.title,this.parseInline(x.tokens,ae));break}case"image":{de+=ae.image(x.href,x.title,x.text);break}case"strong":{de+=ae.strong(this.parseInline(x.tokens,ae));break}case"em":{de+=ae.em(this.parseInline(x.tokens,ae));break}case"codespan":{de+=ae.codespan(x.text);break}case"br":{de+=ae.br();break}case"del":{de+=ae.del(this.parseInline(x.tokens,ae));break}case"text":{de+=ae.text(x.text);break}default:{var be='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(be);return}else throw new Error(be)}}return de},Ce}(),pe=M.merge,tt=M.checkSanitizeDeprecation,z=M.escape,Q=k.getDefaults,fe=k.changeDefaults,Le=k.defaults;function Ue(Ce,Se,Pe){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof Se=="function"&&(Pe=Se,Se=null),Se=pe({},Ue.defaults,Se||{}),tt(Se),Pe){var ie=Se.highlight,ae;try{ae=U.lex(Ce,Se)}catch(he){return Pe(he)}var de=function(be){var Ae;if(!be)try{Ae=$e.parse(ae,Se)}catch(Fe){be=Fe}return Se.highlight=ie,be?Pe(be):Pe(null,Ae)};if(!ie||ie.length<3||(delete Se.highlight,!ae.length))return de();var me=0;Ue.walkTokens(ae,function(he){he.type==="code"&&(me++,setTimeout(function(){ie(he.text,he.lang,function(be,Ae){if(be)return de(be);Ae!=null&&Ae!==he.text&&(he.text=Ae,he.escaped=!0),me--,me===0&&de()})},0))}),me===0&&de();return}try{var x=U.lex(Ce,Se);return Se.walkTokens&&Ue.walkTokens(x,Se.walkTokens),$e.parse(x,Se)}catch(he){if(he.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+z(he.message+"",!0)+"</pre>";throw he}}Ue.options=Ue.setOptions=function(Ce){return pe(Ue.defaults,Ce),fe(Ue.defaults),Ue},Ue.getDefaults=Q,Ue.defaults=Le,Ue.use=function(Ce){var Se=pe({},Ce);if(Ce.renderer&&function(){var ie=Ue.defaults.renderer||new ge,ae=function(x){var he=ie[x];ie[x]=function(){for(var be=arguments.length,Ae=new Array(be),Fe=0;Fe<be;Fe++)Ae[Fe]=arguments[Fe];var We=Ce.renderer[x].apply(ie,Ae);return We===!1&&(We=he.apply(ie,Ae)),We}};for(var de in Ce.renderer)ae(de);Se.renderer=ie}(),Ce.tokenizer&&function(){var ie=Ue.defaults.tokenizer||new re,ae=function(x){var he=ie[x];ie[x]=function(){for(var be=arguments.length,Ae=new Array(be),Fe=0;Fe<be;Fe++)Ae[Fe]=arguments[Fe];var We=Ce.tokenizer[x].apply(ie,Ae);return We===!1&&(We=he.apply(ie,Ae)),We}};for(var de in Ce.tokenizer)ae(de);Se.tokenizer=ie}(),Ce.walkTokens){var Pe=Ue.defaults.walkTokens;Se.walkTokens=function(ie){Ce.walkTokens(ie),Pe&&Pe(ie)}}Ue.setOptions(Se)},Ue.walkTokens=function(Ce,Se){for(var Pe=D(Ce),ie;!(ie=Pe()).done;){var ae=ie.value;switch(Se(ae),ae.type){case"table":{for(var de=D(ae.tokens.header),me;!(me=de()).done;){var x=me.value;Ue.walkTokens(x,Se)}for(var he=D(ae.tokens.cells),be;!(be=he()).done;)for(var Ae=be.value,Fe=D(Ae),We;!(We=Fe()).done;){var et=We.value;Ue.walkTokens(et,Se)}break}case"list":{Ue.walkTokens(ae.items,Se);break}default:ae.tokens&&Ue.walkTokens(ae.tokens,Se)}}},Ue.parseInline=function(Ce,Se){if(typeof Ce=="undefined"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");Se=pe({},Ue.defaults,Se||{}),tt(Se);try{var Pe=U.lexInline(Ce,Se);return Se.walkTokens&&Ue.walkTokens(Pe,Se.walkTokens),$e.parseInline(Pe,Se)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+z(ie.message+"",!0)+"</pre>";throw ie}},Ue.Parser=$e,Ue.parser=$e.parse,Ue.Renderer=ge,Ue.TextRenderer=X,Ue.Lexer=U,Ue.lexer=U.lex,Ue.Tokenizer=re,Ue.Slugger=ce,Ue.parse=Ue;var Ze=Ue;return Ze}),define(Ee[78],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function h(k,S,_){return Math.min(Math.max(k,S),_)}e.clamp=h;function R(k,S){return(S+k%S)%S}e.rot=R;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class y{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function te(D){const y=[];typeof D=="number"&&y.push("code/timeOrigin",D);function k(_){y.push(_,Date.now())}function S(){const _=[];for(let C=0;C<y.length;C+=2)_.push({name:y[C],startTime:y[C+1]});return _}return{mark:k,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const k of performance.getEntriesByType("mark"))y.push({name:k.name,startTime:Math.round(D+k.startTime)});return y}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function h(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return h(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=h(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=h(R))}(),define(Ee[21],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const h="en";let R=!1,D=!1,y=!1,k=!1,S=!1,_=!1,C=!1,n,P=h,c,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?l=e.globals.vscode.process:typeof process!="undefined"&&(l=process);const o=typeof l?.versions?.electron=="string"&&l.type==="renderer";if(e.isElectronSandboxed=o&&l?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=l?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!o)f=navigator.userAgent,R=f.indexOf("Windows")>=0,D=f.indexOf("Macintosh")>=0,C=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=f.indexOf("Linux")>=0,_=!0,n=navigator.language,P=n;else if(typeof l=="object"){R=l.platform==="win32",D=l.platform==="darwin",y=l.platform==="linux",k=y&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,n=h,P=h;const i=l.env.VSCODE_NLS_CONFIG;if(i)try{const r=JSON.parse(i),d=r.availableLanguages["*"];n=r.locale,P=d||h,c=r._translationsConfigFile}catch(r){}S=!0}else console.error("Unable to resolve platform.");var w;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function b(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let E=0;D?E=1:R?E=3:y&&(E=2),e.isWindows=R,e.isMacintosh=D,e.isLinux=y,e.isLinuxSnap=k,e.isNative=S,e.isWeb=_,e.isIOS=C,e.platform=E,e.userAgent=f,e.language=P;var u;(function(i){function r(){return e.language}i.value=r;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=d;function m(){return e.language==="en"}i.isDefault=m})(u=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=c,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let d=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeSetImmediateId)for(let I=0,A=d.length;I<A;I++){const a=d[I];if(a.id===p.data.vscodeSetImmediateId){d.splice(I,1),a.callback();return}}});let m=0;return p=>{const I=++m;d.push({id:I,callback:p}),e.globals.postMessage({vscodeSetImmediateId:I},"*")}}if(typeof l?.nextTick=="function")return l.nextTick.bind(l);const r=Promise.resolve();return d=>r.then(d)}();var g;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(g=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||C?2:R?1:3;let v=!0,t=!1;function s(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,v=new Uint16Array(i.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=s}),define(Ee[41],_e([0,1,21]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof h.globals.vscode!="undefined"&&typeof h.globals.vscode.process!="undefined"){const D=h.globals.vscode.process;R={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(y){return(0,h.setImmediate)(y)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:R={get platform(){return h.isWindows?"win32":h.isMacintosh?"darwin":"linux"},nextTick(D){return(0,h.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(Ee[14],_e([0,1,41]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,D=97,y=90,k=122,S=46,_=47,C=92,n=58,P=63;class c extends Error{constructor(g,v,t){let s;typeof v=="string"&&v.indexOf("not ")===0?(s="must not be",v=v.replace(/^not /,"")):s="must be";const i=g.indexOf(".")!==-1?"property":"argument";let r=`The "${g}" ${i} ${s} of type ${v}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function f(u,g){if(typeof u!="string")throw new c(g,"string",u)}function l(u){return u===_||u===C}function o(u){return u===_}function w(u){return u>=R&&u<=y||u>=D&&u<=k}function b(u,g,v,t){let s="",i=0,r=-1,d=0,m=0;for(let p=0;p<=u.length;++p){if(p<u.length)m=u.charCodeAt(p);else{if(t(m))break;m=_}if(t(m)){if(!(r===p-1||d===1))if(d===2){if(s.length<2||i!==2||s.charCodeAt(s.length-1)!==S||s.charCodeAt(s.length-2)!==S){if(s.length>2){const I=s.lastIndexOf(v);I===-1?(s="",i=0):(s=s.slice(0,I),i=s.length-1-s.lastIndexOf(v)),r=p,d=0;continue}else if(s.length!==0){s="",i=0,r=p,d=0;continue}}g&&(s+=s.length>0?`${v}..`:"..",i=2)}else s.length>0?s+=`${v}${u.slice(r+1,p)}`:s=u.slice(r+1,p),i=p-r-1;r=p,d=0}else m===S&&d!==-1?++d:d=-1}return s}function E(u,g){if(g===null||typeof g!="object")throw new c("pathObject","Object",g);const v=g.dir||g.root,t=g.base||`${g.name||""}${g.ext||""}`;return v?v===g.root?`${v}${t}`:`${v}${u}${t}`:t}e.win32={resolve(...u){let g="",v="",t=!1;for(let s=u.length-1;s>=-1;s--){let i;if(s>=0){if(i=u[s],f(i,"path"),i.length===0)continue}else g.length===0?i=h.cwd():(i=h.env[`=${g}`]||h.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==g.toLowerCase()&&i.charCodeAt(2)===C)&&(i=`${g}\\`));const r=i.length;let d=0,m="",p=!1;const I=i.charCodeAt(0);if(r===1)l(I)&&(d=1,p=!0);else if(l(I))if(p=!0,l(i.charCodeAt(1))){let A=2,a=A;for(;A<r&&!l(i.charCodeAt(A));)A++;if(A<r&&A!==a){const T=i.slice(a,A);for(a=A;A<r&&l(i.charCodeAt(A));)A++;if(A<r&&A!==a){for(a=A;A<r&&!l(i.charCodeAt(A));)A++;(A===r||A!==a)&&(m=`\\\\${T}\\${i.slice(a,A)}`,d=A)}}}else d=1;else w(I)&&i.charCodeAt(1)===n&&(m=i.slice(0,2),d=2,r>2&&l(i.charCodeAt(2))&&(p=!0,d=3));if(m.length>0)if(g.length>0){if(m.toLowerCase()!==g.toLowerCase())continue}else g=m;if(t){if(g.length>0)break}else if(v=`${i.slice(d)}\\${v}`,t=p,p&&g.length>0)break}return v=b(v,!t,"\\",l),t?`${g}\\${v}`:`${g}${v}`||"."},normalize(u){f(u,"path");const g=u.length;if(g===0)return".";let v=0,t,s=!1;const i=u.charCodeAt(0);if(g===1)return o(i)?"\\":u;if(l(i))if(s=!0,l(u.charCodeAt(1))){let d=2,m=d;for(;d<g&&!l(u.charCodeAt(d));)d++;if(d<g&&d!==m){const p=u.slice(m,d);for(m=d;d<g&&l(u.charCodeAt(d));)d++;if(d<g&&d!==m){for(m=d;d<g&&!l(u.charCodeAt(d));)d++;if(d===g)return`\\\\${p}\\${u.slice(m)}\\`;d!==m&&(t=`\\\\${p}\\${u.slice(m,d)}`,v=d)}}}else v=1;else w(i)&&u.charCodeAt(1)===n&&(t=u.slice(0,2),v=2,g>2&&l(u.charCodeAt(2))&&(s=!0,v=3));let r=v<g?b(u.slice(v),!s,"\\",l):"";return r.length===0&&!s&&(r="."),r.length>0&&l(u.charCodeAt(g-1))&&(r+="\\"),t===void 0?s?`\\${r}`:r:s?`${t}\\${r}`:`${t}${r}`},isAbsolute(u){f(u,"path");const g=u.length;if(g===0)return!1;const v=u.charCodeAt(0);return l(v)||g>2&&w(v)&&u.charCodeAt(1)===n&&l(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let g,v;for(let i=0;i<u.length;++i){const r=u[i];f(r,"path"),r.length>0&&(g===void 0?g=v=r:g+=`\\${r}`)}if(g===void 0)return".";let t=!0,s=0;if(typeof v=="string"&&l(v.charCodeAt(0))){++s;const i=v.length;i>1&&l(v.charCodeAt(1))&&(++s,i>2&&(l(v.charCodeAt(2))?++s:t=!1))}if(t){for(;s<g.length&&l(g.charCodeAt(s));)s++;s>=2&&(g=`\\${g.slice(s)}`)}return e.win32.normalize(g)},relative(u,g){if(f(u,"from"),f(g,"to"),u===g)return"";const v=e.win32.resolve(u),t=e.win32.resolve(g);if(v===t||(u=v.toLowerCase(),g=t.toLowerCase(),u===g))return"";let s=0;for(;s<u.length&&u.charCodeAt(s)===C;)s++;let i=u.length;for(;i-1>s&&u.charCodeAt(i-1)===C;)i--;const r=i-s;let d=0;for(;d<g.length&&g.charCodeAt(d)===C;)d++;let m=g.length;for(;m-1>d&&g.charCodeAt(m-1)===C;)m--;const p=m-d,I=r<p?r:p;let A=-1,a=0;for(;a<I;a++){const M=u.charCodeAt(s+a);if(M!==g.charCodeAt(d+a))break;M===C&&(A=a)}if(a!==I){if(A===-1)return t}else{if(p>I){if(g.charCodeAt(d+a)===C)return t.slice(d+a+1);if(a===2)return t.slice(d+a)}r>I&&(u.charCodeAt(s+a)===C?A=a:a===2&&(A=3)),A===-1&&(A=0)}let T="";for(a=s+A+1;a<=i;++a)(a===i||u.charCodeAt(a)===C)&&(T+=T.length===0?"..":"\\..");return d+=A,T.length>0?`${T}${t.slice(d,m)}`:(t.charCodeAt(d)===C&&++d,t.slice(d,m))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const g=e.win32.resolve(u);if(g.length<=2)return u;if(g.charCodeAt(0)===C){if(g.charCodeAt(1)===C){const v=g.charCodeAt(2);if(v!==P&&v!==S)return`\\\\?\\UNC\\${g.slice(2)}`}}else if(w(g.charCodeAt(0))&&g.charCodeAt(1)===n&&g.charCodeAt(2)===C)return`\\\\?\\${g}`;return u},dirname(u){f(u,"path");const g=u.length;if(g===0)return".";let v=-1,t=0;const s=u.charCodeAt(0);if(g===1)return l(s)?u:".";if(l(s)){if(v=t=1,l(u.charCodeAt(1))){let d=2,m=d;for(;d<g&&!l(u.charCodeAt(d));)d++;if(d<g&&d!==m){for(m=d;d<g&&l(u.charCodeAt(d));)d++;if(d<g&&d!==m){for(m=d;d<g&&!l(u.charCodeAt(d));)d++;if(d===g)return u;d!==m&&(v=t=d+1)}}}}else w(s)&&u.charCodeAt(1)===n&&(v=g>2&&l(u.charCodeAt(2))?3:2,t=v);let i=-1,r=!0;for(let d=g-1;d>=t;--d)if(l(u.charCodeAt(d))){if(!r){i=d;break}}else r=!1;if(i===-1){if(v===-1)return".";i=v}return u.slice(0,i)},basename(u,g){g!==void 0&&f(g,"ext"),f(u,"path");let v=0,t=-1,s=!0,i;if(u.length>=2&&w(u.charCodeAt(0))&&u.charCodeAt(1)===n&&(v=2),g!==void 0&&g.length>0&&g.length<=u.length){if(g===u)return"";let r=g.length-1,d=-1;for(i=u.length-1;i>=v;--i){const m=u.charCodeAt(i);if(l(m)){if(!s){v=i+1;break}}else d===-1&&(s=!1,d=i+1),r>=0&&(m===g.charCodeAt(r)?--r==-1&&(t=i):(r=-1,t=d))}return v===t?t=d:t===-1&&(t=u.length),u.slice(v,t)}for(i=u.length-1;i>=v;--i)if(l(u.charCodeAt(i))){if(!s){v=i+1;break}}else t===-1&&(s=!1,t=i+1);return t===-1?"":u.slice(v,t)},extname(u){f(u,"path");let g=0,v=-1,t=0,s=-1,i=!0,r=0;u.length>=2&&u.charCodeAt(1)===n&&w(u.charCodeAt(0))&&(g=t=2);for(let d=u.length-1;d>=g;--d){const m=u.charCodeAt(d);if(l(m)){if(!i){t=d+1;break}continue}s===-1&&(i=!1,s=d+1),m===S?v===-1?v=d:r!==1&&(r=1):v!==-1&&(r=-1)}return v===-1||s===-1||r===0||r===1&&v===s-1&&v===t+1?"":u.slice(v,s)},format:E.bind(null,"\\"),parse(u){f(u,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return g;const v=u.length;let t=0,s=u.charCodeAt(0);if(v===1)return l(s)?(g.root=g.dir=u,g):(g.base=g.name=u,g);if(l(s)){if(t=1,l(u.charCodeAt(1))){let A=2,a=A;for(;A<v&&!l(u.charCodeAt(A));)A++;if(A<v&&A!==a){for(a=A;A<v&&l(u.charCodeAt(A));)A++;if(A<v&&A!==a){for(a=A;A<v&&!l(u.charCodeAt(A));)A++;A===v?t=A:A!==a&&(t=A+1)}}}}else if(w(s)&&u.charCodeAt(1)===n){if(v<=2)return g.root=g.dir=u,g;if(t=2,l(u.charCodeAt(2))){if(v===3)return g.root=g.dir=u,g;t=3}}t>0&&(g.root=u.slice(0,t));let i=-1,r=t,d=-1,m=!0,p=u.length-1,I=0;for(;p>=t;--p){if(s=u.charCodeAt(p),l(s)){if(!m){r=p+1;break}continue}d===-1&&(m=!1,d=p+1),s===S?i===-1?i=p:I!==1&&(I=1):i!==-1&&(I=-1)}return d!==-1&&(i===-1||I===0||I===1&&i===d-1&&i===r+1?g.base=g.name=u.slice(r,d):(g.name=u.slice(r,i),g.base=u.slice(r,d),g.ext=u.slice(i,d))),r>0&&r!==t?g.dir=u.slice(0,r-1):g.dir=g.root,g},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let g="",v=!1;for(let t=u.length-1;t>=-1&&!v;t--){const s=t>=0?u[t]:h.cwd();f(s,"path"),s.length!==0&&(g=`${s}/${g}`,v=s.charCodeAt(0)===_)}return g=b(g,!v,"/",o),v?`/${g}`:g.length>0?g:"."},normalize(u){if(f(u,"path"),u.length===0)return".";const g=u.charCodeAt(0)===_,v=u.charCodeAt(u.length-1)===_;return u=b(u,!g,"/",o),u.length===0?g?"/":v?"./":".":(v&&(u+="/"),g?`/${u}`:u)},isAbsolute(u){return f(u,"path"),u.length>0&&u.charCodeAt(0)===_},join(...u){if(u.length===0)return".";let g;for(let v=0;v<u.length;++v){const t=u[v];f(t,"path"),t.length>0&&(g===void 0?g=t:g+=`/${t}`)}return g===void 0?".":e.posix.normalize(g)},relative(u,g){if(f(u,"from"),f(g,"to"),u===g||(u=e.posix.resolve(u),g=e.posix.resolve(g),u===g))return"";const v=1,t=u.length,s=t-v,i=1,r=g.length-i,d=s<r?s:r;let m=-1,p=0;for(;p<d;p++){const A=u.charCodeAt(v+p);if(A!==g.charCodeAt(i+p))break;A===_&&(m=p)}if(p===d)if(r>d){if(g.charCodeAt(i+p)===_)return g.slice(i+p+1);if(p===0)return g.slice(i+p)}else s>d&&(u.charCodeAt(v+p)===_?m=p:p===0&&(m=0));let I="";for(p=v+m+1;p<=t;++p)(p===t||u.charCodeAt(p)===_)&&(I+=I.length===0?"..":"/..");return`${I}${g.slice(i+m)}`},toNamespacedPath(u){return u},dirname(u){if(f(u,"path"),u.length===0)return".";const g=u.charCodeAt(0)===_;let v=-1,t=!0;for(let s=u.length-1;s>=1;--s)if(u.charCodeAt(s)===_){if(!t){v=s;break}}else t=!1;return v===-1?g?"/":".":g&&v===1?"//":u.slice(0,v)},basename(u,g){g!==void 0&&f(g,"ext"),f(u,"path");let v=0,t=-1,s=!0,i;if(g!==void 0&&g.length>0&&g.length<=u.length){if(g===u)return"";let r=g.length-1,d=-1;for(i=u.length-1;i>=0;--i){const m=u.charCodeAt(i);if(m===_){if(!s){v=i+1;break}}else d===-1&&(s=!1,d=i+1),r>=0&&(m===g.charCodeAt(r)?--r==-1&&(t=i):(r=-1,t=d))}return v===t?t=d:t===-1&&(t=u.length),u.slice(v,t)}for(i=u.length-1;i>=0;--i)if(u.charCodeAt(i)===_){if(!s){v=i+1;break}}else t===-1&&(s=!1,t=i+1);return t===-1?"":u.slice(v,t)},extname(u){f(u,"path");let g=-1,v=0,t=-1,s=!0,i=0;for(let r=u.length-1;r>=0;--r){const d=u.charCodeAt(r);if(d===_){if(!s){v=r+1;break}continue}t===-1&&(s=!1,t=r+1),d===S?g===-1?g=r:i!==1&&(i=1):g!==-1&&(i=-1)}return g===-1||t===-1||i===0||i===1&&g===t-1&&g===v+1?"":u.slice(g,t)},format:E.bind(null,"/"),parse(u){f(u,"path");const g={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return g;const v=u.charCodeAt(0)===_;let t;v?(g.root="/",t=1):t=0;let s=-1,i=0,r=-1,d=!0,m=u.length-1,p=0;for(;m>=t;--m){const I=u.charCodeAt(m);if(I===_){if(!d){i=m+1;break}continue}r===-1&&(d=!1,r=m+1),I===S?s===-1?s=m:p!==1&&(p=1):s!==-1&&(p=-1)}if(r!==-1){const I=i===0&&v?1:i;s===-1||p===0||p===1&&s===r-1&&s===i+1?g.base=g.name=u.slice(I,r):(g.name=u.slice(I,s),g.base=u.slice(I,r),g.ext=u.slice(s,r))}return i>0?g.dir=u.slice(0,i-1):v&&(g.dir="/"),g},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=h.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=h.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=h.platform==="win32"?e.win32.join:e.posix.join,e.resolve=h.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=h.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=h.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=h.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=h.platform==="win32"?e.win32.extname:e.posix.extname,e.format=h.platform==="win32"?e.win32.format:e.posix.format,e.parse=h.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=h.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=h.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=h.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Ee[51],_e([0,1,21]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=h.globals.performance&&typeof h.globals.performance.now=="function";class D{constructor(k){this._highResolution=R&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new D(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?h.globals.performance.now():Date.now()}}e.StopWatch=D}),define(Ee[3],_e([0,1,12,49,7,77,51]),function(te,e,h,R,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var S;(function(u){u.None=()=>D.Disposable.None;function g(q){return($,V=null,F)=>{let re=!1,N;return N=q(H=>{if(!re)return N?N.dispose():re=!0,$.call(V,H)},null,F),re&&N.dispose(),N}}u.once=g;function v(q,$){return m((V,F=null,re)=>q(N=>V.call(F,$(N)),null,re))}u.map=v;function t(q,$){return m((V,F=null,re)=>q(N=>{$(N),V.call(F,N)},null,re))}u.forEach=t;function s(q,$){return m((V,F=null,re)=>q(N=>$(N)&&V.call(F,N),null,re))}u.filter=s;function i(q){return q}u.signal=i;function r(...q){return($,V=null,F)=>(0,D.combinedDisposable)(...q.map(re=>re(N=>$.call(V,N),null,F)))}u.any=r;function d(q,$,V){let F=V;return v(q,re=>(F=$(F,re),F))}u.reduce=d;function m(q){let $;const V=new c({onFirstListenerAdd(){$=q(V.fire,V)},onLastListenerRemove(){$.dispose()}});return V.event}function p(q,$,V=100,F=!1,re){let N,H,J,K=0;const le=new c({leakWarningThreshold:re,onFirstListenerAdd(){N=q(Ie=>{K++,H=$(H,Ie),F&&!J&&(le.fire(H),H=void 0),clearTimeout(J),J=setTimeout(()=>{const Me=H;H=void 0,J=void 0,(!F||K>1)&&le.fire(Me),K=0},V)})},onLastListenerRemove(){N.dispose()}});return le.event}u.debounce=p;function I(q,$=(V,F)=>V===F){let V=!0,F;return s(q,re=>{const N=V||!$(re,F);return V=!1,F=re,N})}u.latch=I;function A(q,$){return[u.filter(q,$),u.filter(q,V=>!$(V))]}u.split=A;function a(q,$=!1,V=[]){let F=V.slice(),re=q(J=>{F?F.push(J):H.fire(J)});const N=()=>{F&&F.forEach(J=>H.fire(J)),F=null},H=new c({onFirstListenerAdd(){re||(re=q(J=>H.fire(J)))},onFirstListenerDidAdd(){F&&($?setTimeout(N):N())},onLastListenerRemove(){re&&re.dispose(),re=null}});return H.event}u.buffer=a;class T{constructor($){this.event=$}map($){return new T(v(this.event,$))}forEach($){return new T(t(this.event,$))}filter($){return new T(s(this.event,$))}reduce($,V){return new T(d(this.event,$,V))}latch(){return new T(I(this.event))}debounce($,V=100,F=!1,re){return new T(p(this.event,$,V,F,re))}on($,V,F){return this.event($,V,F)}once($,V,F){return g(this.event)($,V,F)}}function M(q){return new T(q)}u.chain=M;function W(q,$,V=F=>F){const F=(...J)=>H.fire(V(...J)),re=()=>q.on($,F),N=()=>q.removeListener($,F),H=new c({onFirstListenerAdd:re,onLastListenerRemove:N});return H.event}u.fromNodeEventEmitter=W;function B(q,$,V=F=>F){const F=(...J)=>H.fire(V(...J)),re=()=>q.addEventListener($,F),N=()=>q.removeEventListener($,F),H=new c({onFirstListenerAdd:re,onLastListenerRemove:N});return H.event}u.fromDOMEventEmitter=B;function Z(q){return new Promise($=>g(q)($))}u.toPromise=Z})(S=e.Event||(e.Event={}));class _{constructor(g){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${g}_${_._idPool++}`}start(g){this._stopWatch=new k.StopWatch(!0),this._listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this._elapsedOverall+=g,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${g.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let C=-1;function n(u){const g=C;return C=u,{dispose(){C=g}}}e.setGlobalLeakWarningThreshold=n;class P{constructor(g,v=Math.random().toString(18).slice(2,5)){this.customThreshold=g,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(g){let v=C;if(typeof this.customThreshold=="number"&&(v=this.customThreshold),v<=0||g<v)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(t)||0;if(this._stacks.set(t,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=v*.5;let i,r=0;for(const[d,m]of this._stacks)(!i||r<m)&&(i=d,r=m);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${r}):`),console.warn(i)}return()=>{const i=this._stacks.get(t)||0;this._stacks.set(t,i-1)}}}class c{constructor(g){this._disposed=!1,this._options=g,this._leakageMon=C>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(g,v,t)=>{this._listeners||(this._listeners=new y.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(v?[g,v]:g);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,g,v);const r=this._leakageMon?.check(this._listeners.size),d=(0,D.toDisposable)(()=>{r&&r(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof D.DisposableStore?t.add(d):Array.isArray(t)&&t.push(d),d}),this._event}fire(g){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let v of this._listeners)this._deliveryQueue.push([v,g]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[v,t]=this._deliveryQueue.shift();try{typeof v=="function"?v.call(void 0,t):v[0].call(v[1],t)}catch(s){(0,h.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=c;class f extends c{async fireAsync(g,v,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,g]);for(;this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[s,i]=this._asyncDeliveryQueue.shift(),r=[],d={...i,waitUntil:m=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");t&&(m=t(m,typeof s=="function"?s:s[0])),r.push(m)}};try{typeof s=="function"?s.call(void 0,d):s[0].call(s[1],d)}catch(m){(0,h.onUnexpectedError)(m);continue}Object.freeze(r),await Promise.allSettled(r).then(m=>{for(const p of m)p.status==="rejected"&&(0,h.onUnexpectedError)(p.reason)})}}}}e.AsyncEmitter=f;class l extends c{constructor(g){super(g);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._listeners&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}e.PauseableEmitter=l;class o extends l{constructor(g){super(g);this._delay=g.delay??100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}e.DebounceEmitter=o;class w{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const v={event:g,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const t=()=>{this.hasListeners&&this.unhook(v);const s=this.events.indexOf(v);this.events.splice(s,1)};return(0,D.toDisposable)((0,R.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(v=>this.emitter.fire(v))}unhook(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=w;class b{constructor(){this.buffers=[]}wrapEvent(g){return(v,t,s)=>g(i=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>v.call(t,i)):v.call(t,i)},void 0,s)}bufferEvents(g){const v=[];this.buffers.push(v);const t=g();return this.buffers.pop(),v.forEach(s=>s()),t}}e.EventBufferer=b;class E{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=D.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(Ee[18],_e([0,1,3]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(S,_){const C=setTimeout(S.bind(_),0);return{dispose(){clearTimeout(C)}}});var D;(function(S){function _(C){return C===S.None||C===S.Cancelled||C instanceof y?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}S.isCancellationToken=_,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:h.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(D=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new h.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=D.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=k}),define(Ee[52],_e([0,1,3]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new h.Emitter}add(P){const c=this._icons.get(P.id);c?P.description?c.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new R;e.iconRegistry=D;function y(n,P){return new S(n,P)}e.registerCodicon=y;function k(n){return n?n.replace(/\$\((.*?)\)/g,(P,c)=>` ${c} `).trim():""}e.getCodiconAriaLabel=k;class S{constructor(P,c,f){this.id=P,this.definition=c,this.description=f,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=S;function _(n,P){const c=["codicon","codicon-"+n];return P&&c.push("codicon-modifier-"+P),c}e.getClassNamesArray=_;var C;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function c(o){if(o instanceof S)return["codicon","codicon-"+o.id];const w=P.exec(o.id);if(!w)return c(S.error);let[,b,E]=w;const u=["codicon","codicon-"+b];return E&&u.push("codicon-modifier-"+E.substr(1)),u}n.asClassNameArray=c;function f(o){return c(o).join(" ")}n.asClassName=f;function l(o){return"."+c(o).join(".")}n.asCSSSelector=l})(C=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(S=e.Codicon||(e.Codicon={}))}),define(Ee[110],_e([0,1,12,7]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(u){const g=u;return g?[g.on,g.pause,g.resume,g.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=D;function y(u){const g=u;return g?D(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=y;function k(u,g){return new S(u,g)}e.newWriteableStream=k;class S{constructor(g,v){this.reducer=g,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g!="undefined"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(v=>v(g))}emitError(g){this.listeners.error.length===0?(0,h.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(v=>v(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,v){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(g,v){if(this.state.destroyed)return;let t;switch(g){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(v);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(u,g){const v=[];let t;for(;(t=u.read())!==null;)v.push(t);return g(v)}e.consumeReadable=_;function C(u,g,v){const t=[];let s;for(;(s=u.read())!==null&&t.length<v;)t.push(s);return s===null&&t.length>0?g(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const i=s;return s=void 0,i}return u.read()}}}e.peekReadable=C;function n(u,g){return new Promise((v,t)=>{const s=[];P(u,{onData:i=>{g&&s.push(i)},onError:i=>{g?t(i):v(void 0)},onEnd:()=>{v(g?g(s):void 0)}})})}e.consumeStream=n;function P(u,g){u.on("error",v=>g.onError(v)),u.on("end",()=>g.onEnd()),u.on("data",v=>g.onData(v))}e.listenStream=P;function c(u,g){return new Promise((v,t)=>{const s=new R.DisposableStore,i=[],r=p=>{if(i.push(p),i.length>g)return s.dispose(),u.pause(),v({stream:u,buffer:i,ended:!1})},d=p=>t(p),m=()=>v({stream:u,buffer:i,ended:!0});s.add((0,R.toDisposable)(()=>u.removeListener("error",d))),u.on("error",d),s.add((0,R.toDisposable)(()=>u.removeListener("end",m))),u.on("end",m),s.add((0,R.toDisposable)(()=>u.removeListener("data",r))),u.on("data",r)})}e.peekStream=c;function f(u,g){const v=k(g);return v.end(u),v}e.toStream=f;function l(){const u=k(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=l;function o(u){let g=!1;return{read:()=>g?null:(g=!0,u)}}e.toReadable=o;function w(u,g,v){const t=k(v);return P(u,{onData:s=>t.write(g.data(s)),onError:s=>t.error(g.error?g.error(s):s),onEnd:()=>t.end()}),t}e.transform=w;function b(u,g,v){let t=!1;return{read:()=>{const s=g.read();return t?s:(t=!0,s!==null?v([u,s]):u)}}}e.prefixedReadable=b;function E(u,g,v){let t=!1;const s=k(v);return P(g,{onData:i=>t?s.write(i):(t=!0,s.write(v([u,i]))),onError:i=>s.error(i),onEnd:()=>{t||(t=!0,s.write(u)),s.end()}}),s}e.prefixedStream=E}),define(Ee[8],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function h(x){return!x||typeof x!="string"?!0:x.trim().length===0}e.isFalsyOrWhitespace=h;const R=/{(\d+)}/g;function D(x,...he){return he.length===0?x:x.replace(R,function(be,Ae){const Fe=parseInt(Ae,10);return isNaN(Fe)||Fe<0||Fe>=he.length?be:he[Fe]})}e.format=D;const y=/{([^}]+)}/g;function k(x,he){return x.replace(y,(be,Ae)=>he[Ae]??be)}e.format2=k;function S(x){return x.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=S;function _(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=_;function C(x,he){let be=0;const Ae=he.charCodeAt(0);for(let Fe=x.length-1;Fe>=0;Fe--)x.charCodeAt(Fe)===Ae&&be++;return be}e.count=C;function n(x,he,be="\u2026"){return x.length<=he?x:`${x.substr(0,he)}${be}`}e.truncate=n;function P(x,he=" "){const be=c(x,he);return f(be,he)}e.trim=P;function c(x,he){if(!x||!he)return x;const be=he.length;if(be===0||x.length===0)return x;let Ae=0;for(;x.indexOf(he,Ae)===Ae;)Ae=Ae+be;return x.substring(Ae)}e.ltrim=c;function f(x,he){if(!x||!he)return x;const be=he.length,Ae=x.length;if(be===0||Ae===0)return x;let Fe=Ae,We=-1;for(;We=x.lastIndexOf(he,Fe-1),!(We===-1||We+be!==Fe);){if(We===0)return"";Fe=We}return x.substring(0,Fe)}e.rtrim=f;function l(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function o(x){return x.replace(/\*/g,"")}e.stripWildcards=o;function w(x,he,be={}){if(!x)throw new Error("Cannot create regex from empty string");he||(x=_(x)),be.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Ae="";return be.global&&(Ae+="g"),be.matchCase||(Ae+="i"),be.multiline&&(Ae+="m"),be.unicode&&(Ae+="u"),new RegExp(x,Ae)}e.createRegExp=w;function b(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function E(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function u(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}e.regExpFlags=u;function g(x){return x.split(/\r\n|\r|\n/)}e.splitLines=g;function v(x){for(let he=0,be=x.length;he<be;he++){const Ae=x.charCodeAt(he);if(Ae!==32&&Ae!==9)return he}return-1}e.firstNonWhitespaceIndex=v;function t(x,he=0,be=x.length){for(let Ae=he;Ae<be;Ae++){const Fe=x.charCodeAt(Ae);if(Fe!==32&&Fe!==9)return x.substring(he,Ae)}return x.substring(he,be)}e.getLeadingWhitespace=t;function s(x,he=x.length-1){for(let be=he;be>=0;be--){const Ae=x.charCodeAt(be);if(Ae!==32&&Ae!==9)return be}return-1}e.lastNonWhitespaceIndex=s;function i(x,he){return x<he?-1:x>he?1:0}e.compare=i;function r(x,he,be=0,Ae=x.length,Fe=0,We=he.length){for(;be<Ae&&Fe<We;be++,Fe++){let Ye=x.charCodeAt(be),lt=he.charCodeAt(Fe);if(Ye<lt)return-1;if(Ye>lt)return 1}const et=Ae-be,Qe=We-Fe;return et<Qe?-1:et>Qe?1:0}e.compareSubstring=r;function d(x,he){return m(x,he,0,x.length,0,he.length)}e.compareIgnoreCase=d;function m(x,he,be=0,Ae=x.length,Fe=0,We=he.length){for(;be<Ae&&Fe<We;be++,Fe++){let Ye=x.charCodeAt(be),lt=he.charCodeAt(Fe);if(Ye===lt)continue;const ct=Ye-lt;if(!(ct===32&&I(lt))&&!(ct===-32&&I(Ye)))return p(Ye)&&p(lt)?ct:r(x.toLowerCase(),he.toLowerCase(),be,Ae,Fe,We)}const et=Ae-be,Qe=We-Fe;return et<Qe?-1:et>Qe?1:0}e.compareSubstringIgnoreCase=m;function p(x){return x>=97&&x<=122}e.isLowerAsciiLetter=p;function I(x){return x>=65&&x<=90}e.isUpperAsciiLetter=I;function A(x){return p(x)||I(x)}function a(x,he){return x.length===he.length&&T(x,he)}e.equalsIgnoreCase=a;function T(x,he,be=x.length){for(let Ae=0;Ae<be;Ae++){const Fe=x.charCodeAt(Ae),We=he.charCodeAt(Ae);if(Fe!==We){if(A(Fe)&&A(We)){const et=Math.abs(Fe-We);if(et!==0&&et!==32)return!1}else if(String.fromCharCode(Fe).toLowerCase()!==String.fromCharCode(We).toLowerCase())return!1}}return!0}function M(x,he){const be=he.length;return he.length>x.length?!1:T(x,he,be)}e.startsWithIgnoreCase=M;function W(x,he){let be,Ae=Math.min(x.length,he.length);for(be=0;be<Ae;be++)if(x.charCodeAt(be)!==he.charCodeAt(be))return be;return Ae}e.commonPrefixLength=W;function B(x,he){let be,Ae=Math.min(x.length,he.length);const Fe=x.length-1,We=he.length-1;for(be=0;be<Ae;be++)if(x.charCodeAt(Fe-be)!==he.charCodeAt(We-be))return be;return Ae}e.commonSuffixLength=B;function Z(x){return 55296<=x&&x<=56319}e.isHighSurrogate=Z;function q(x){return 56320<=x&&x<=57343}e.isLowSurrogate=q;function $(x,he){return(x-55296<<10)+(he-56320)+65536}e.computeCodePoint=$;function V(x,he,be){const Ae=x.charCodeAt(be);if(Z(Ae)&&be+1<he){const Fe=x.charCodeAt(be+1);if(q(Fe))return $(Ae,Fe)}return Ae}e.getNextCodePoint=V;function F(x,he){const be=x.charCodeAt(he-1);if(q(be)&&he>1){const Ae=x.charCodeAt(he-2);if(Z(Ae))return $(Ae,be)}return be}function re(x,he){const be=Ce.getInstance(),Ae=he,Fe=x.length,We=V(x,Fe,he);he+=We>=65536?2:1;let et=be.getGraphemeBreakType(We);for(;he<Fe;){const Qe=V(x,Fe,he),Ye=be.getGraphemeBreakType(Qe);if(Ue(et,Ye))break;he+=Qe>=65536?2:1,et=Ye}return he-Ae}e.nextCharLength=re;function N(x,he){const be=Ce.getInstance(),Ae=he,Fe=F(x,he);he-=Fe>=65536?2:1;let We=be.getGraphemeBreakType(Fe);for(;he>0;){const et=F(x,he),Qe=be.getGraphemeBreakType(et);if(Ue(Qe,We))break;he-=et>=65536?2:1,We=Qe}return Ae-he}e.prevCharLength=N;function H(x,he){const be=Ce.getInstance(),Ae=x.length,Fe=he,We=V(x,Ae,he),et=be.getGraphemeBreakType(We);he+=We>=65536?2:1;let Qe=et;for(;he<Ae;){const lt=V(x,Ae,he),ct=be.getGraphemeBreakType(lt);if(Ue(Qe,ct))break;he+=lt>=65536?2:1,Qe=ct}const Ye=he;for(he=Fe,Qe=et;he>0;){const lt=F(x,he),ct=be.getGraphemeBreakType(lt);if(Ue(ct,Qe))break;he-=lt>=65536?2:1,Qe=ct}return[he,Ye]}function J(x,he){return he>0&&q(x.charCodeAt(he))?H(x,he-1):H(x,he)}e.getCharContainingOffset=J;function K(x){const he=x.length;let be=0,Ae=0;for(;Ae<he;){const et=V(x,he,Ae);Ae+=et>=65536?2:1,et<128?be+=1:et<2048?be+=2:et<65536?be+=3:be+=4}const Fe=new Uint8Array(be);Ae=0;let We=0;for(;Ae<he;){const et=V(x,he,Ae);Ae+=et>=65536?2:1,et<128?Fe[We++]=et:et<2048?(Fe[We++]=192|(et&1984)>>>6,Fe[We++]=128|(et&63)>>>0):et<65536?(Fe[We++]=224|(et&61440)>>>12,Fe[We++]=128|(et&4032)>>>6,Fe[We++]=128|(et&63)>>>0):(Fe[We++]=240|(et&1835008)>>>18,Fe[We++]=128|(et&258048)>>>12,Fe[We++]=128|(et&4032)>>>6,Fe[We++]=128|(et&63)>>>0)}return Fe}e.encodeUTF8=K;function le(x){const he=x.byteLength,be=[];let Ae=0;for(;Ae<he;){const Fe=x[Ae];let We;if(Fe>=240&&Ae+3<he?We=(x[Ae++]&7)<<18>>>0|(x[Ae++]&63)<<12>>>0|(x[Ae++]&63)<<6>>>0|(x[Ae++]&63)<<0>>>0:Fe>=224&&Ae+2<he?We=(x[Ae++]&15)<<12>>>0|(x[Ae++]&63)<<6>>>0|(x[Ae++]&63)<<0>>>0:Fe>=192&&Ae+1<he?We=(x[Ae++]&31)<<6>>>0|(x[Ae++]&63)<<0>>>0:We=x[Ae++],We>=0&&We<=55295||We>=57344&&We<=65535)be.push(String.fromCharCode(We));else if(We>=65536&&We<=1114111){const et=We-65536,Qe=55296+((et&1047552)>>>10),Ye=56320+((et&1023)>>>0);be.push(String.fromCharCode(Qe)),be.push(String.fromCharCode(Ye))}else be.push(String.fromCharCode(65533))}return be.join("")}e.decodeUTF8=le;const Ie=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Me(x){return Ie.test(x)}e.containsRTL=Me;const Ve=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function xe(x){return Ve.test(x)}e.containsEmoji=xe;const Ge=/^[\t\n\r\x20-\x7E]*$/;function Ke(x){return Ge.test(x)}e.isBasicASCII=Ke,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function qe(x){return e.UNUSUAL_LINE_TERMINATORS.test(x)}e.containsUnusualLineTerminators=qe;function U(x){for(let he=0,be=x.length;he<be;he++)if(G(x.charCodeAt(he)))return!0;return!1}e.containsFullWidthCharacter=U;function G(x){return x=+x,x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}e.isFullWidthCharacter=G;function ne(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129003||x>=129280&&x<=129535||x>=129648&&x<=129750}e.isEmojiImprecise=ne;function se(x,he){if(x.length<he)return x;const be=/\b/g;let Ae=0;for(;be.test(x)&&!(x.length-be.lastIndex<he);)Ae=be.lastIndex,be.lastIndex+=1;return x.substring(Ae).replace(/^\s/,"")}e.lcut=se;const ge=/\x1B\x5B[12]?K/g,X=/\x1b\[\d+m/g,ce=/\x1b\[0?m/g;function ke(x){return x&&(x=x.replace(ge,""),x=x.replace(X,""),x=x.replace(ce,"")),x}e.removeAnsiEscapeCodes=ke,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Be(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Be;function $e(x){return Be(x)?x.substr(1):x}e.stripUTF8BOM=$e;function pe(x,he){if(!x||!he||x.length<he.length)return!1;const be=he.length,Ae=x.toLowerCase();let Fe=0,We=-1;for(;Fe<be;){const et=Ae.indexOf(he[Fe],We+1);if(et<0)return!1;We=et,Fe++}return!0}e.fuzzyContains=pe;function tt(x,he=!1){return x?(he&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}e.containsUppercaseCharacter=tt;function z(x){return x.charAt(0).toUpperCase()+x.slice(1)}e.uppercaseFirstLetter=z;function Q(x,he=1){if(he===0)return"";let be=-1;do be=x.indexOf(`
`,be+1),he--;while(he>0&&be>=0);return be===-1?x:(x[be-1]==="\r"&&be--,x.substr(0,be))}e.getNLines=Q;function fe(x){const he=90-65+1;return x=x%(2*he),x<he?String.fromCharCode(97+x):String.fromCharCode(65+x-he)}e.singleLetterHash=fe;function Le(x){return Ce.getInstance().getGraphemeBreakType(x)}e.getGraphemeBreakType=Le;function Ue(x,he){return x===0?he!==5&&he!==7:x===2&&he===3?!1:x===4||x===2||x===3||he===4||he===2||he===3?!0:!(x===8&&(he===8||he===9||he===11||he===12)||(x===11||x===9)&&(he===9||he===10)||(x===12||x===10)&&he===10||he===5||he===13||he===7||x===1||x===13&&he===14||x===6&&he===6)}e.breakBetweenGraphemeBreakType=Ue;var Ze;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(Ze=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ce{constructor(){this._data=Se()}static getInstance(){return Ce._INSTANCE||(Ce._INSTANCE=new Ce),Ce._INSTANCE}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const be=this._data,Ae=be.length/3;let Fe=1;for(;Fe<=Ae;)if(he<be[3*Fe])Fe=2*Fe;else if(he>be[3*Fe+1])Fe=2*Fe+1;else return be[3*Fe+2];return 0}}Ce._INSTANCE=null;function Se(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Pe(x,he){if(x===0)return 0;const be=ie(x,he);if(be!==void 0)return be;const Ae=F(he,x);return x-=ae(Ae),x}e.getLeftDeleteOffset=Pe;function ie(x,he){let be=F(he,x);for(x-=ae(be);de(be)||be===65039||be===8419;){if(x===0)return;be=F(he,x),x-=ae(be)}if(!!ne(be)){if(x>=0){const Ae=F(he,x);Ae===8205&&(x-=ae(Ae))}return x}}function ae(x){return x>=65536?2:1}function de(x){return 127995<=x&&x<=127999}var me;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(me||(me={}))}),define(Ee[23],_e([0,1,8,110]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",k=typeof TextDecoder!="undefined";let S,_;class C{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return D?new C(Buffer.allocUnsafe(p)):new C(new Uint8Array(p))}static wrap(p){return D&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new C(p)}static fromString(p,I){return!(I?.dontUseNodeBuffer||!1)&&D?new C(Buffer.from(p)):y?(S||(S=new TextEncoder),new C(S.encode(p))):new C(h.encodeUTF8(p))}static concat(p,I){if(typeof I=="undefined"){I=0;for(let T=0,M=p.length;T<M;T++)I+=p[T].byteLength}const A=C.alloc(I);let a=0;for(let T=0,M=p.length;T<M;T++){const W=p[T];A.set(W,a),a+=W.byteLength}return A}toString(){return D?this.buffer.toString():k?(_||(_=new TextDecoder),_.decode(this.buffer)):h.decodeUTF8(this.buffer)}slice(p,I){return new C(this.buffer.subarray(p,I))}set(p,I){p instanceof C?this.buffer.set(p.buffer,I):this.buffer.set(p,I)}readUInt32BE(p){return c(this.buffer,p)}writeUInt32BE(p,I){f(this.buffer,p,I)}readUInt32LE(p){return l(this.buffer,p)}writeUInt32LE(p,I){o(this.buffer,p,I)}readUInt8(p){return w(this.buffer,p)}writeUInt8(p,I){b(this.buffer,p,I)}}e.VSBuffer=C;function n(m,p){return m[p+0]<<0>>>0|m[p+1]<<8>>>0}e.readUInt16LE=n;function P(m,p,I){m[I+0]=p&255,p=p>>>8,m[I+1]=p&255}e.writeUInt16LE=P;function c(m,p){return m[p]*2**24+m[p+1]*2**16+m[p+2]*2**8+m[p+3]}e.readUInt32BE=c;function f(m,p,I){m[I+3]=p,p=p>>>8,m[I+2]=p,p=p>>>8,m[I+1]=p,p=p>>>8,m[I]=p}e.writeUInt32BE=f;function l(m,p){return m[p+0]<<0>>>0|m[p+1]<<8>>>0|m[p+2]<<16>>>0|m[p+3]<<24>>>0}e.readUInt32LE=l;function o(m,p,I){m[I+0]=p&255,p=p>>>8,m[I+1]=p&255,p=p>>>8,m[I+2]=p&255,p=p>>>8,m[I+3]=p&255}e.writeUInt32LE=o;function w(m,p){return m[p]}e.readUInt8=w;function b(m,p,I){m[I]=p}e.writeUInt8=b;function E(m){return R.consumeReadable(m,p=>C.concat(p))}e.readableToBuffer=E;function u(m){return R.toReadable(m)}e.bufferToReadable=u;function g(m){return R.consumeStream(m,p=>C.concat(p))}e.streamToBuffer=g;async function v(m){return m.ended?C.concat(m.buffer):C.concat([...m.buffer,await g(m.stream)])}e.bufferedStreamToBuffer=v;function t(m){return R.toStream(m,p=>C.concat(p))}e.bufferToStream=t;function s(m){return R.transform(m,{data:p=>typeof p=="string"?C.fromString(p):C.wrap(p)},p=>C.concat(p))}e.streamToBufferReadableStream=s;function i(m){return R.newWriteableStream(p=>C.concat(p),m)}e.newWriteableBufferStream=i;function r(m,p){return R.prefixedReadable(m,p,I=>C.concat(I))}e.prefixedBufferReadable=r;function d(m,p){return R.prefixedStream(m,p,I=>C.concat(I))}e.prefixedBufferStream=d}),define(Ee[53],_e([0,1,8]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(b){return D(b,0)}e.hash=R;function D(b,E){switch(typeof b){case"object":return b===null?y(349,E):Array.isArray(b)?_(b,E):C(b,E);case"string":return S(b,E);case"boolean":return k(b,E);case"number":return y(b,E);case"undefined":return y(937,E);default:return y(617,E)}}e.doHash=D;function y(b,E){return(E<<5)-E+b|0}function k(b,E){return y(b?433:863,E)}function S(b,E){E=y(149417,E);for(let u=0,g=b.length;u<g;u++)E=y(b.charCodeAt(u),E);return E}e.stringHash=S;function _(b,E){return E=y(104579,E),b.reduce((u,g)=>D(g,u),E)}function C(b,E){return E=y(181387,E),Object.keys(b).sort().reduce((u,g)=>(u=S(g,u),D(b[g],u)),E)}class n{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=D(E,this._value),this._value}}e.Hasher=n;var P;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function c(b,E,u=32){const g=u-E,v=~((1<<g)-1);return(b<<E|(v&b)>>>g)>>>0}function f(b,E=0,u=b.byteLength,g=0){for(let v=0;v<u;v++)b[E+v]=g}function l(b,E,u="0"){for(;b.length<E;)b=u+b;return b}function o(b,E=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(u=>u.toString(16).padStart(2,"0")).join(""):l((b>>>0).toString(16),E/4)}e.toHexString=o;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const u=E.length;if(u===0)return;const g=this._buff;let v=this._buffLen,t=this._leftoverHighSurrogate,s,i;for(t!==0?(s=t,i=-1,t=0):(s=E.charCodeAt(0),i=0);;){let r=s;if(h.isHighSurrogate(s))if(i+1<u){const d=E.charCodeAt(i+1);h.isLowSurrogate(d)?(i++,r=h.computeCodePoint(s,d)):r=65533}else{t=s;break}else h.isLowSurrogate(s)&&(r=65533);if(v=this._push(g,v,r),i++,i<u)s=E.charCodeAt(i);else break}this._buffLen=v,this._leftoverHighSurrogate=t}_push(E,u,g){return g<128?E[u++]=g:g<2048?(E[u++]=192|(g&1984)>>>6,E[u++]=128|(g&63)>>>0):g<65536?(E[u++]=224|(g&61440)>>>12,E[u++]=128|(g&4032)>>>6,E[u++]=128|(g&63)>>>0):(E[u++]=240|(g&1835008)>>>18,E[u++]=128|(g&258048)>>>12,E[u++]=128|(g&4032)>>>6,E[u++]=128|(g&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),o(this._h0)+o(this._h1)+o(this._h2)+o(this._h3)+o(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=w._bigBlock32,u=this._buffDV;for(let p=0;p<64;p+=4)E.setUint32(p,u.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)E.setUint32(p,c(E.getUint32(p-12,!1)^E.getUint32(p-32,!1)^E.getUint32(p-56,!1)^E.getUint32(p-64,!1),1),!1);let g=this._h0,v=this._h1,t=this._h2,s=this._h3,i=this._h4,r,d,m;for(let p=0;p<80;p++)p<20?(r=v&t|~v&s,d=1518500249):p<40?(r=v^t^s,d=1859775393):p<60?(r=v&t|v&s|t&s,d=2400959708):(r=v^t^s,d=3395469782),m=c(g,5)+r+i+d+E.getUint32(p*4,!1)&4294967295,i=s,s=t,t=c(v,30),v=g,g=m;this._h0=this._h0+g&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Ee[42],_e([0,1,8]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(R||(R={})),function(D){const y="error",k="warning",S="warn",_="info",C="ignore";function n(c){return c?h.equalsIgnoreCase(y,c)?D.Error:h.equalsIgnoreCase(k,c)||h.equalsIgnoreCase(S,c)?D.Warning:h.equalsIgnoreCase(_,c)?D.Info:D.Ignore:D.Ignore}D.fromValue=n;function P(c){switch(c){case D.Error:return y;case D.Warning:return k;case D.Info:return _;default:return C}}D.toString=P}(R||(R={})),e.default=R}),define(Ee[10],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function h(p){return Array.isArray(p)}e.isArray=h;function R(p){return typeof p=="string"}e.isString=R;function D(p){return Array.isArray(p)&&p.every(I=>R(I))}e.isStringArray=D;function y(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}e.isObject=y;function k(p){return typeof p=="number"&&!isNaN(p)}e.isNumber=k;function S(p){return!!p&&typeof p[Symbol.iterator]=="function"}e.isIterable=S;function _(p){return p===!0||p===!1}e.isBoolean=_;function C(p){return typeof p=="undefined"}e.isUndefined=C;function n(p){return!P(p)}e.isDefined=n;function P(p){return C(p)||p===null}e.isUndefinedOrNull=P;function c(p,I){if(!p)throw new Error(I?`Unexpected type, expected '${I}'`:"Unexpected type")}e.assertType=c;function f(p){if(P(p))throw new Error("Assertion Failed: argument is undefined or null");return p}e.assertIsDefined=f;function l(...p){const I=[];for(let A=0;A<p.length;A++){const a=p[A];if(P(a))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);I.push(a)}return I}e.assertAllDefined=l;const o=Object.prototype.hasOwnProperty;function w(p){if(!y(p))return!1;for(let I in p)if(o.call(p,I))return!1;return!0}e.isEmptyObject=w;function b(p){return typeof p=="function"}e.isFunction=b;function E(...p){return p.length>0&&p.every(b)}e.areFunctions=E;function u(p,I){const A=Math.min(p.length,I.length);for(let a=0;a<A;a++)g(p[a],I[a])}e.validateConstraints=u;function g(p,I){if(R(I)){if(typeof p!==I)throw new Error(`argument does not match constraint: typeof ${I}`)}else if(b(I)){try{if(p instanceof I)return}catch{}if(!P(p)&&p.constructor===I||I.length===1&&I.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=g;function v(p){let I=[],A=Object.getPrototypeOf(p);for(;Object.prototype!==A;)I=I.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return I}e.getAllPropertyNames=v;function t(p){const I=[];for(const A of v(p))typeof p[A]=="function"&&I.push(A);return I}e.getAllMethodNames=t;function s(p,I){const A=T=>function(){const M=Array.prototype.slice.call(arguments,0);return I(T,M)};let a={};for(const T of p)a[T]=A(T);return a}e.createProxyObject=s;function i(p){return p===null?void 0:p}e.withNullAsUndefined=i;function r(p){return typeof p=="undefined"?null:p}e.withUndefinedAsNull=r;function d(p){return class{constructor(){return new Proxy({},{get(I,A){if(I[A])return I[A];throw new Error(`Not Implemented: ${p}->${String(A)}`)}})}}}e.NotImplementedProxy=d;function m(p){throw new Error("Unreachable")}e.assertNever=m}),define(Ee[43],_e([0,1,21,8,14,10]),function(te,e,h,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(i){return i===47||i===92}e.isPathSeparator=k;function S(i){return i.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=S;function _(i){return i.indexOf("/")===-1&&(i=S(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=_;function C(i,r=D.posix.sep){if(!i)return"";const d=i.length,m=i.charCodeAt(0);if(k(m)){if(k(i.charCodeAt(1))&&!k(i.charCodeAt(2))){let I=3;const A=I;for(;I<d&&!k(i.charCodeAt(I));I++);if(A!==I&&!k(i.charCodeAt(I+1))){for(I+=1;I<d;I++)if(k(i.charCodeAt(I)))return i.slice(0,I+1).replace(/[\\/]/g,r)}}return r}else if(b(m)&&i.charCodeAt(1)===58)return k(i.charCodeAt(2))?i.slice(0,2)+r:i.slice(0,2);let p=i.indexOf("://");if(p!==-1){for(p+=3;p<d;p++)if(k(i.charCodeAt(p)))return i.slice(0,p+1)}return""}e.getRoot=C;function n(i){if(!h.isWindows||!i||i.length<5)return!1;let r=i.charCodeAt(0);if(r!==92||(r=i.charCodeAt(1),r!==92))return!1;let d=2;const m=d;for(;d<i.length&&(r=i.charCodeAt(d),r!==92);d++);return!(m===d||(r=i.charCodeAt(d+1),isNaN(r)||r===92))}e.isUNC=n;const P=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(i,r=h.isWindows){const d=r?P:c;return!(!i||i.length===0||/^\s+$/.test(i)||(d.lastIndex=0,d.test(i))||r&&f.test(i)||i==="."||i===".."||r&&i[i.length-1]==="."||r&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=l;function o(i,r,d){const m=i===r;return!d||m?m:!i||!r?!1:(0,R.equalsIgnoreCase)(i,r)}e.isEqual=o;function w(i,r,d,m=D.sep){if(i===r)return!0;if(!i||!r||r.length>i.length)return!1;if(d){if(!(0,R.startsWithIgnoreCase)(i,r))return!1;if(r.length===i.length)return!0;let I=r.length;return r.charAt(r.length-1)===m&&I--,i.charAt(I)===m}return r.charAt(r.length-1)!==m&&(r+=m),i.indexOf(r)===0}e.isEqualOrParent=w;function b(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=b;function E(i,r){return h.isWindows&&i.endsWith(":")&&(i+=D.sep),(0,D.isAbsolute)(i)||(i=(0,D.join)(r,i)),i=(0,D.normalize)(i),h.isWindows?(i=(0,R.rtrim)(i,D.sep),i.endsWith(":")&&(i+=D.sep)):(i=(0,R.rtrim)(i,D.sep),i||(i=D.sep)),i}e.sanitizeFilePath=E;function u(i){const r=(0,D.normalize)(i);return h.isWindows?i.length>3?!1:g(r)&&(i.length===2||r.charCodeAt(2)===92):r===D.posix.sep}e.isRootOrDriveLetter=u;function g(i){return h.isWindows?b(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function v(i){return g(i)?i[0]:void 0}e.getDriveLetter=v;function t(i,r,d){return r.length>i.length?-1:i===r?0:(d&&(i=i.toLowerCase(),r=r.toLowerCase()),i.indexOf(r))}e.indexOfPath=t;function s(i){const r=i.split(":");let d,m,p;if(r.forEach(I=>{const A=Number(I);(0,y.isNumber)(A)?m===void 0?m=A:p===void 0&&(p=A):d=d?[d,I].join(":"):I}),!d)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:d,line:m!==void 0?m:void 0,column:p!==void 0?p:m!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(Ee[24],_e([0,1,10]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const w=Array.isArray(o)?[]:{};return Object.keys(o).forEach(b=>{o[b]&&typeof o[b]=="object"?w[b]=R(o[b]):w[b]=o[b]}),w}e.deepClone=R;function D(o){if(!o||typeof o!="object")return o;const w=[o];for(;w.length>0;){const b=w.shift();Object.freeze(b);for(const E in b)if(y.call(b,E)){const u=b[E];typeof u=="object"&&!Object.isFrozen(u)&&w.push(u)}}return o}e.deepFreeze=D;const y=Object.prototype.hasOwnProperty;function k(o,w){return S(o,w,new Set)}e.cloneAndChange=k;function S(o,w,b){if((0,h.isUndefinedOrNull)(o))return o;const E=w(o);if(typeof E!="undefined")return E;if((0,h.isArray)(o)){const u=[];for(const g of o)u.push(S(g,w,b));return u}if((0,h.isObject)(o)){if(b.has(o))throw new Error("Cannot clone recursive data-structure");b.add(o);const u={};for(let g in o)y.call(o,g)&&(u[g]=S(o[g],w,b));return b.delete(o),u}return o}function _(o,w,b=!0){return(0,h.isObject)(o)?((0,h.isObject)(w)&&Object.keys(w).forEach(E=>{E in o?b&&((0,h.isObject)(o[E])&&(0,h.isObject)(w[E])?_(o[E],w[E],b):o[E]=w[E]):o[E]=w[E]}),o):w}e.mixin=_;function C(o,w){if(o===w)return!0;if(o==null||w===null||w===void 0||typeof o!=typeof w||typeof o!="object"||Array.isArray(o)!==Array.isArray(w))return!1;let b,E;if(Array.isArray(o)){if(o.length!==w.length)return!1;for(b=0;b<o.length;b++)if(!C(o[b],w[b]))return!1}else{const u=[];for(E in o)u.push(E);u.sort();const g=[];for(E in w)g.push(E);if(g.sort(),!C(u,g))return!1;for(b=0;b<u.length;b++)if(!C(o[u[b]],w[u[b]]))return!1}return!0}e.equals=C;function n(o){const w=new Set;return JSON.stringify(o,(b,E)=>{if((0,h.isObject)(E)||Array.isArray(E)){if(w.has(E))return"[Circular]";w.add(E)}return E})}e.safeStringify=n;function P(o,w,b){const E=w(o);return typeof E=="undefined"?b:E}e.getOrDefault=P;function c(o,w){const b=Object.create(null);return!o||!w||Object.keys(w).forEach(u=>{const g=o[u],v=w[u];C(g,v)||(b[u]=v)}),b}e.distinct=c;function f(o,w){const b=w.toLowerCase(),E=Object.keys(o).find(u=>u.toLowerCase()===b);return E?o[E]:o[w]}e.getCaseInsensitive=f;function l(o,w){const b=Object.create(null);for(const E of Object.keys(o))w(E,o[E])&&(b[E]=o[E]);return b}e.filter=l}),define(Ee[79],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var h;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(h=e.Constants||(e.Constants={}));function R(y){return y<0?0:y>255?255:y|0}e.toUint8=R;function D(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=D}),define(Ee[2],_e([0,1,21,14]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,y=/^\//,k=/^\/\//;function S(i,r){if(!i.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!D.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!y.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(i,r){return!i&&!r?"file":i}function C(i,r){switch(i){case"https":case"http":case"file":r?r[0]!==P&&(r=P+r):r=P;break}return r}const n="",P="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(r,d,m,p,I,A=!1){typeof r=="object"?(this.scheme=r.scheme||n,this.authority=r.authority||n,this.path=r.path||n,this.query=r.query||n,this.fragment=r.fragment||n):(this.scheme=_(r,A),this.authority=d||n,this.path=C(this.scheme,m||n),this.query=p||n,this.fragment=I||n,S(this,A))}static isUri(r){return r instanceof f?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return u(this,!1)}with(r){if(!r)return this;let{scheme:d,authority:m,path:p,query:I,fragment:A}=r;return d===void 0?d=this.scheme:d===null&&(d=n),m===void 0?m=this.authority:m===null&&(m=n),p===void 0?p=this.path:p===null&&(p=n),I===void 0?I=this.query:I===null&&(I=n),A===void 0?A=this.fragment:A===null&&(A=n),d===this.scheme&&m===this.authority&&p===this.path&&I===this.query&&A===this.fragment?this:new o(d,m,p,I,A)}static parse(r,d=!1){const m=c.exec(r);return m?new o(m[2]||n,s(m[4]||n),s(m[5]||n),s(m[7]||n),s(m[9]||n),d):new o(n,n,n,n,n)}static file(r){let d=n;if(h.isWindows&&(r=r.replace(/\\/g,P)),r[0]===P&&r[1]===P){const m=r.indexOf(P,2);m===-1?(d=r.substring(2),r=P):(d=r.substring(2,m),r=r.substring(m)||P)}return new o("file",d,r,n,n)}static from(r){const d=new o(r.scheme,r.authority,r.path,r.query,r.fragment);return S(d,!0),d}static joinPath(r,...d){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return h.isWindows&&r.scheme==="file"?m=f.file(R.win32.join(u(r,!0),...d)).path:m=R.posix.join(r.path,...d),r.with({path:m})}toString(r=!1){return g(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof f)return r;{const d=new o(r);return d._formatted=r.external,d._fsPath=r._sep===l?r.fsPath:null,d}}else return r}}e.URI=f;const l=h.isWindows?1:void 0;class o extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(r=!1){return r?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=l),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(i,r){let d,m=-1;for(let p=0;p<i.length;p++){const I=i.charCodeAt(p);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||r&&I===47)m!==-1&&(d+=encodeURIComponent(i.substring(m,p)),m=-1),d!==void 0&&(d+=i.charAt(p));else{d===void 0&&(d=i.substr(0,p));const A=w[I];A!==void 0?(m!==-1&&(d+=encodeURIComponent(i.substring(m,p)),m=-1),d+=A):m===-1&&(m=p)}}return m!==-1&&(d+=encodeURIComponent(i.substring(m))),d!==void 0?d:i}function E(i){let r;for(let d=0;d<i.length;d++){const m=i.charCodeAt(d);m===35||m===63?(r===void 0&&(r=i.substr(0,d)),r+=w[m]):r!==void 0&&(r+=i[d])}return r!==void 0?r:i}function u(i,r){let d;return i.authority&&i.path.length>1&&i.scheme==="file"?d=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?r?d=i.path.substr(1):d=i.path[1].toLowerCase()+i.path.substr(2):d=i.path,h.isWindows&&(d=d.replace(/\//g,"\\")),d}e.uriToFsPath=u;function g(i,r){const d=r?E:b;let m="",{scheme:p,authority:I,path:A,query:a,fragment:T}=i;if(p&&(m+=p,m+=":"),(I||p==="file")&&(m+=P,m+=P),I){let M=I.indexOf("@");if(M!==-1){const W=I.substr(0,M);I=I.substr(M+1),M=W.indexOf(":"),M===-1?m+=d(W,!1):(m+=d(W.substr(0,M),!1),m+=":",m+=d(W.substr(M+1),!1)),m+="@"}I=I.toLowerCase(),M=I.indexOf(":"),M===-1?m+=d(I,!1):(m+=d(I.substr(0,M),!1),m+=I.substr(M))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const M=A.charCodeAt(1);M>=65&&M<=90&&(A=`/${String.fromCharCode(M+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const M=A.charCodeAt(0);M>=65&&M<=90&&(A=`${String.fromCharCode(M+32)}:${A.substr(2)}`)}m+=d(A,!0)}return a&&(m+="?",m+=d(a,!1)),T&&(m+="#",m+=r?T:b(T,!1)),m}function v(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+v(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(t)?i.replace(t,r=>v(r)):i}});var it=this&&this.__classPrivateFieldSet||function(te,e,h,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(te,h):D?D.value=h:e.set(te,h),h},Ne=this&&this.__classPrivateFieldGet||function(te,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(te):R?R.value:e.get(te)};define(Ee[22],_e([0,1,2,8]),function(te,e,h,R){"use strict";var D,y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(t,s,i){let r=t.get(s);return r===void 0&&(r=i,t.set(s,r)),r}e.getOrSet=S;function _(t){const s=[];return t.forEach((i,r)=>{s.push(`${r} => ${i}`)}),`Map(${t.size}) {${s.join(", ")}}`}e.mapToString=_;function C(t){const s=[];return t.forEach(i=>{s.push(i)}),`Set(${t.size}) {${s.join(", ")}}`}e.setToString=C;class n{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const i=s.charCodeAt(0),r=this._value.charCodeAt(this._pos);return i-r}value(){return this._value[this._pos]}}e.StringIterator=n;class P{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,R.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class c{constructor(s=!0,i=!0){this._splitOnBackslash=s,this._caseSensitive=i}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,R.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var f;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(f||(f={}));class l{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,R.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class o{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class w{constructor(s){this._iter=s}static forUris(s=()=>!1){return new w(new l(s))}static forPaths(){return new w(new c)}static forStrings(){return new w(new n)}static forConfigKeys(){return new w(new P)}clear(){this._root=void 0}set(s,i){const r=this._iter.reset(s);let d;for(this._root||(this._root=new o,this._root.segment=r.value()),d=this._root;;){const p=r.cmp(d.segment);if(p>0)d.left||(d.left=new o,d.left.segment=r.value()),d=d.left;else if(p<0)d.right||(d.right=new o,d.right.segment=r.value()),d=d.right;else if(r.hasNext())r.next(),d.mid||(d.mid=new o,d.mid.segment=r.value()),d=d.mid;else break}const m=d.value;return d.value=i,d.key=s,m}get(s){return this._getNode(s)?.value}_getNode(s){const i=this._iter.reset(s);let r=this._root;for(;r;){const d=i.cmp(r.segment);if(d>0)r=r.left;else if(d<0)r=r.right;else if(i.hasNext())i.next(),r=r.mid;else break}return r}has(s){const i=this._getNode(s);return!(i?.value===void 0&&i?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,i){const r=this._iter.reset(s),d=[];let m=this._root;for(;m;){const p=r.cmp(m.segment);if(p>0)d.push([1,m]),m=m.left;else if(p<0)d.push([-1,m]),m=m.right;else if(r.hasNext())r.next(),d.push([0,m]),m=m.mid;else{for(i?(m.left=void 0,m.mid=void 0,m.right=void 0):m.value=void 0;d.length>0&&m.isEmpty();){let[I,A]=d.pop();switch(I){case 1:A.left=void 0;break;case 0:A.mid=void 0;break;case-1:A.right=void 0;break}m=A}break}}}findSubstr(s){const i=this._iter.reset(s);let r=this._root,d;for(;r;){const m=i.cmp(r.segment);if(m>0)r=r.left;else if(m<0)r=r.right;else if(i.hasNext())i.next(),d=r.value||d,r=r.mid;else break}return r&&r.value||d}findSuperstr(s){const i=this._iter.reset(s);let r=this._root;for(;r;){const d=i.cmp(r.segment);if(d>0)r=r.left;else if(d<0)r=r.right;else if(i.hasNext())i.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(s){for(const[i,r]of this)s(r,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const i=[s];for(;i.length>0;){const r=i.pop();r&&(r.value&&(yield[r.key,r.value]),r.left&&i.push(r.left),r.mid&&i.push(r.mid),r.right&&i.push(r.right))}}}e.TernarySearchTree=w;class b{constructor(s,i){this[D]="ResourceMap",s instanceof b?(this.map=new Map(s.map),this.toKey=i??b.defaultToKey):(this.map=new Map,this.toKey=s??b.defaultToKey)}set(s,i){return this.map.set(this.toKey(s),i),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,i){typeof i!="undefined"&&(s=s.bind(i));for(let[r,d]of this.map)s(d,h.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield h.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[h.URI.parse(s[0]),s[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[h.URI.parse(s[0]),s[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class u{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,i=0){const r=this._map.get(s);if(!!r)return i!==0&&this.touch(r,i),r.value}set(s,i,r=0){let d=this._map.get(s);if(d)d.value=i,r!==0&&this.touch(d,r);else{switch(d={key:s,value:i,next:void 0,previous:void 0},r){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(s,d),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const i=this._map.get(s);if(!!i)return this._map.delete(s),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,i){const r=this._state;let d=this._head;for(;d;){if(i?s.bind(i)(d.value,d.key,this):s(d.value,d.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const s=this,i=this._state;let r=this._head;const d={[Symbol.iterator](){return d},next(){if(s._state!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const m={value:r.key,done:!1};return r=r.next,m}else return{value:void 0,done:!0}}};return d}values(){const s=this,i=this._state;let r=this._head;const d={[Symbol.iterator](){return d},next(){if(s._state!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const m={value:r.value,done:!1};return r=r.next,m}else return{value:void 0,done:!0}}};return d}entries(){const s=this,i=this._state;let r=this._head;const d={[Symbol.iterator](){return d},next(){if(s._state!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const m={value:[r.key,r.value],done:!1};return r=r.next,m}else return{value:void 0,done:!0}}};return d}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let i=this._head,r=this.size;for(;i&&r>s;)this._map.delete(i.key),i=i.next,r--;this._head=i,this._size=r,i&&(i.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const i=s.next,r=s.previous;if(!i||!r)throw new Error("Invalid list");i.previous=r,r.next=i}s.next=void 0,s.previous=void 0,this._state++}touch(s,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(s===this._head)return;const r=s.next,d=s.previous;s===this._tail?(d.next=void 0,this._tail=d):(r.previous=d,d.next=r),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(i===2){if(s===this._tail)return;const r=s.next,d=s.previous;s===this._head?(r.previous=void 0,this._head=r):(r.previous=d,d.next=r),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((i,r)=>{s.push([r,i])}),s}fromJSON(s){this.clear();for(const[i,r]of s)this.set(i,r)}}e.LinkedMap=u;class g extends u{constructor(s,i=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,i=2){return super.get(s,i)}peek(s){return super.get(s,0)}set(s,i){return super.set(s,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=g;class v{constructor(s){k.set(this,void 0),it(this,k,s,"f")}get size(){return Ne(this,k,"f").size}forEach(s,i){Ne(this,k,"f").forEach(s,i)}get(s){return Ne(this,k,"f").get(s)}has(s){return Ne(this,k,"f").has(s)}entries(){return Ne(this,k,"f").entries()}keys(){return Ne(this,k,"f").keys()}values(){return Ne(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Ne(this,k,"f").entries()}}e.ReadonlyMapView=v}),define(Ee[111],_e([0,1,22,8]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...X){return function(ce,ke){for(let Be=0,$e=X.length;Be<$e;Be++){const pe=X[Be](ce,ke);if(pe)return pe}return null}}e.or=D,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(X,ce,ke){if(!ke||ke.length<ce.length)return null;let Be;return X?Be=R.startsWithIgnoreCase(ke,ce):Be=ke.indexOf(ce)===0,Be?ce.length>0?[{start:0,end:ce.length}]:[]:null}function k(X,ce){const ke=ce.toLowerCase().indexOf(X.toLowerCase());return ke===-1?null:[{start:ke,end:ke+X.length}]}e.matchesContiguousSubString=k;function S(X,ce){return _(X.toLowerCase(),ce.toLowerCase(),0,0)}e.matchesSubString=S;function _(X,ce,ke,Be){if(ke===X.length)return[];if(Be===ce.length)return null;if(X[ke]===ce[Be]){let $e=null;return($e=_(X,ce,ke+1,Be+1))?b({start:Be,end:Be+1},$e):null}return _(X,ce,ke,Be+1)}function C(X){return 97<=X&&X<=122}function n(X){return 65<=X&&X<=90}e.isUpper=n;function P(X){return 48<=X&&X<=57}function c(X){return X===32||X===9||X===10||X===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(X=>f.add(X.charCodeAt(0)));function l(X){return c(X)||f.has(X)}function o(X,ce){return X===ce||l(X)&&l(ce)}function w(X){return C(X)||n(X)||P(X)}function b(X,ce){return ce.length===0?ce=[X]:X.end===ce[0].start?ce[0].start=X.start:ce.unshift(X),ce}function E(X,ce){for(let ke=ce;ke<X.length;ke++){const Be=X.charCodeAt(ke);if(n(Be)||P(Be)||ke>0&&!w(X.charCodeAt(ke-1)))return ke}return X.length}function u(X,ce,ke,Be){if(ke===X.length)return[];if(Be===ce.length)return null;if(X[ke]!==ce[Be].toLowerCase())return null;{let $e=null,pe=Be+1;for($e=u(X,ce,ke+1,Be+1);!$e&&(pe=E(ce,pe))<ce.length;)$e=u(X,ce,ke+1,pe),pe++;return $e===null?null:b({start:Be,end:Be+1},$e)}}function g(X){let ce=0,ke=0,Be=0,$e=0,pe=0;for(let Le=0;Le<X.length;Le++)pe=X.charCodeAt(Le),n(pe)&&ce++,C(pe)&&ke++,w(pe)&&Be++,P(pe)&&$e++;const tt=ce/X.length,z=ke/X.length,Q=Be/X.length,fe=$e/X.length;return{upperPercent:tt,lowerPercent:z,alphaPercent:Q,numericPercent:fe}}function v(X){const{upperPercent:ce,lowerPercent:ke}=X;return ke===0&&ce>.6}function t(X){const{upperPercent:ce,lowerPercent:ke,alphaPercent:Be,numericPercent:$e}=X;return ke>.2&&ce<.8&&Be>.6&&$e<.2}function s(X){let ce=0,ke=0,Be=0,$e=0;for(let pe=0;pe<X.length;pe++)Be=X.charCodeAt(pe),n(Be)&&ce++,C(Be)&&ke++,c(Be)&&$e++;return(ce===0||ke===0)&&$e===0?X.length<=30:ce<=5}function i(X,ce){if(!ce||(ce=ce.trim(),ce.length===0)||!s(X)||ce.length>60)return null;const ke=g(ce);if(!t(ke)){if(!v(ke))return null;ce=ce.toLowerCase()}let Be=null,$e=0;for(X=X.toLowerCase();$e<ce.length&&(Be=u(X,ce,0,$e))===null;)$e=E(ce,$e+1);return Be}e.matchesCamelCase=i;function r(X,ce,ke=!1){if(!ce||ce.length===0)return null;let Be=null,$e=0;for(X=X.toLowerCase(),ce=ce.toLowerCase();$e<ce.length&&(Be=d(X,ce,0,$e,ke))===null;)$e=m(ce,$e+1);return Be}e.matchesWords=r;function d(X,ce,ke,Be,$e){if(ke===X.length)return[];if(Be===ce.length)return null;if(o(X.charCodeAt(ke),ce.charCodeAt(Be))){let pe=null,tt=Be+1;if(pe=d(X,ce,ke+1,Be+1,$e),!$e)for(;!pe&&(tt=m(ce,tt))<ce.length;)pe=d(X,ce,ke+1,tt,$e),tt++;return pe===null?null:b({start:Be,end:Be+1},pe)}else return null}function m(X,ce){for(let ke=ce;ke<X.length;ke++)if(l(X.charCodeAt(ke))||ke>0&&l(X.charCodeAt(ke-1)))return ke;return X.length}const p=D(e.matchesPrefix,i,k),I=D(e.matchesPrefix,i,S),A=new h.LRUCache(1e4);function a(X,ce,ke=!1){if(typeof X!="string"||typeof ce!="string")return null;let Be=A.get(X);Be||(Be=new RegExp(R.convertSimple2RegExpPattern(X),"i"),A.set(X,Be));const $e=Be.exec(ce);return $e?[{start:$e.index,end:$e.index+$e[0].length}]:ke?I(X,ce):p(X,ce)}e.matchesFuzzy=a;function T(X,ce){const ke=Ke(X,X.toLowerCase(),0,ce,ce.toLowerCase(),0,!0);return ke?W(ke):null}e.matchesFuzzy2=T;function M(X,ce,ke,Be,$e,pe){const tt=Math.min(13,X.length);for(;ke<tt;ke++){const z=Ke(X,ce,ke,Be,$e,pe,!1);if(z)return z}return[0,pe]}e.anyScore=M;function W(X){if(typeof X=="undefined")return[];const ce=[],ke=X[1];for(let Be=X.length-1;Be>1;Be--){const $e=X[Be]+ke,pe=ce[ce.length-1];pe&&pe.end===$e?pe.end=$e+1:ce.push({start:$e,end:$e+1})}return ce}e.createMatches=W;const B=128;function Z(){const X=[],ce=[];for(let ke=0;ke<=B;ke++)ce[ke]=0;for(let ke=0;ke<=B;ke++)X.push(ce.slice(0));return X}function q(X){const ce=[];for(let ke=0;ke<=X;ke++)ce[ke]=0;return ce}const $=q(2*B),V=q(2*B),F=Z(),re=Z(),N=Z(),H=!1;function J(X,ce,ke,Be,$e){function pe(z,Q,fe=" "){for(;z.length<Q;)z=fe+z;return z}let tt=` |   |${Be.split("").map(z=>pe(z,3)).join("|")}
`;for(let z=0;z<=ke;z++)z===0?tt+=" |":tt+=`${ce[z-1]}|`,tt+=X[z].slice(0,$e+1).map(Q=>pe(Q.toString(),3)).join("|")+`
`;return tt}function K(X,ce,ke,Be){X=X.substr(ce),ke=ke.substr(Be),console.log(J(re,X,X.length,ke,ke.length)),console.log(J(N,X,X.length,ke,ke.length)),console.log(J(F,X,X.length,ke,ke.length))}function le(X,ce){if(ce<0||ce>=X.length)return!1;const ke=X.codePointAt(ce);switch(ke){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(ke)}}function Ie(X,ce){if(ce<0||ce>=X.length)return!1;switch(X.charCodeAt(ce)){case 32:case 9:return!0;default:return!1}}function Me(X,ce,ke){return ce[X]!==ke[X]}function Ve(X,ce,ke,Be,$e,pe,tt=!1){for(;ce<ke&&$e<pe;)X[ce]===Be[$e]&&(tt&&($[ce]=$e),ce+=1),$e+=1;return ce===ke}e.isPatternInWord=Ve;var xe;(function(X){X[X.Diag=1]="Diag",X[X.Left=2]="Left",X[X.LeftLeft=3]="LeftLeft"})(xe||(xe={}));var Ge;(function(X){X.Default=[-100,0];function ce(ke){return!ke||ke.length===2&&ke[0]===-100&&ke[1]===0}X.isDefault=ce})(Ge=e.FuzzyScore||(e.FuzzyScore={}));function Ke(X,ce,ke,Be,$e,pe,tt){const z=X.length>B?B:X.length,Q=Be.length>B?B:Be.length;if(ke>=z||pe>=Q||z-ke>Q-pe||!Ve(ce,ke,z,$e,pe,Q,!0))return;qe(z,Q,ke,pe,ce,$e);let fe=1,Le=1,Ue=ke,Ze=pe;const Ce=[!1];for(fe=1,Ue=ke;Ue<z;fe++,Ue++){const de=$[Ue],me=V[Ue],x=Ue+1<z?V[Ue+1]:Q;for(Le=de-pe+1,Ze=de;Ze<x;Le++,Ze++){let he=Number.MIN_SAFE_INTEGER,be=!1;Ze<=me&&(he=U(X,ce,Ue,ke,Be,$e,Ze,Q,pe,F[fe-1][Le-1]===0,Ce));let Ae=0;he!==Number.MAX_SAFE_INTEGER&&(be=!0,Ae=he+re[fe-1][Le-1]);const Fe=Ze>de,We=Fe?re[fe][Le-1]+(F[fe][Le-1]>0?-5:0):0,et=Ze>de+1&&F[fe][Le-1]>0,Qe=et?re[fe][Le-2]+(F[fe][Le-2]>0?-5:0):0;if(et&&(!Fe||Qe>=We)&&(!be||Qe>=Ae))re[fe][Le]=Qe,N[fe][Le]=3,F[fe][Le]=0;else if(Fe&&(!be||We>=Ae))re[fe][Le]=We,N[fe][Le]=2,F[fe][Le]=0;else if(be)re[fe][Le]=Ae,N[fe][Le]=1,F[fe][Le]=F[fe-1][Le-1]+1;else throw new Error("not possible")}}if(H&&K(X,ke,Be,pe),!Ce[0]&&!tt)return;fe--,Le--;const Se=[re[fe][Le],pe];let Pe=0,ie=0;for(;fe>=1;){let de=Le;do{const me=N[fe][de];if(me===3)de=de-2;else if(me===2)de=de-1;else break}while(de>=1);Pe>1&&ce[ke+fe-1]===$e[pe+Le-1]&&!Me(de+pe-1,Be,$e)&&Pe+1>F[fe][de]&&(de=Le),de===Le?Pe++:Pe=1,ie||(ie=de),fe--,Le=de-1,Se.push(Le)}Q===z&&(Se[0]+=2);const ae=ie-z;return Se[0]-=ae,Se}e.fuzzyScore=Ke;function qe(X,ce,ke,Be,$e,pe){let tt=X-1,z=ce-1;for(;tt>=ke&&z>=Be;)$e[tt]===pe[z]&&(V[tt]=z,tt--),z--}function U(X,ce,ke,Be,$e,pe,tt,z,Q,fe,Le){if(ce[ke]!==pe[tt])return Number.MIN_SAFE_INTEGER;let Ue=1,Ze=!1;return tt===ke-Be?Ue=X[ke]===$e[tt]?7:5:Me(tt,$e,pe)&&(tt===0||!Me(tt-1,$e,pe))?(Ue=X[ke]===$e[tt]?7:5,Ze=!0):le(pe,tt)&&(tt===0||!le(pe,tt-1))?Ue=5:(le(pe,tt-1)||Ie(pe,tt-1))&&(Ue=5,Ze=!0),Ue>1&&ke===Be&&(Le[0]=!0),Ze||(Ze=Me(tt,$e,pe)||le(pe,tt-1)||Ie(pe,tt-1)),ke===Be?tt>Q&&(Ue-=Ze?3:5):fe?Ue+=Ze?2:0:Ue+=Ze?0:1,tt+1===z&&(Ue-=Ze?3:5),Ue}function G(X,ce,ke,Be,$e,pe,tt){return se(X,ce,ke,Be,$e,pe,!0,tt)}e.fuzzyScoreGracefulAggressive=G;function ne(X,ce,ke,Be,$e,pe,tt){return se(X,ce,ke,Be,$e,pe,!1,tt)}e.fuzzyScoreGraceful=ne;function se(X,ce,ke,Be,$e,pe,tt,z){let Q=Ke(X,ce,ke,Be,$e,pe,z);if(Q&&!tt)return Q;if(X.length>=3){const fe=Math.min(7,X.length-1);for(let Le=ke+1;Le<fe;Le++){const Ue=ge(X,Le);if(Ue){const Ze=Ke(Ue,Ue.toLowerCase(),ke,Be,$e,pe,z);Ze&&(Ze[0]-=3,(!Q||Ze[0]>Q[0])&&(Q=Ze))}}}return Q}function ge(X,ce){if(ce+1>=X.length)return;const ke=X[ce],Be=X[ce+1];if(ke!==Be)return X.slice(0,ce)+Be+ke+X.slice(ce+2)}}),define(Ee[112],_e([0,1,52,111,8]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${y.source}`,"g");function S(o){return o.replace(k,(w,b)=>b?w:`\\${w}`)}e.escapeIcons=S;const _=new RegExp(`\\\\${y.source}`,"g");function C(o){return o.replace(_,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=C;const n=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function P(o){return o.indexOf(e.iconStartMarker)===-1?o:o.replace(n,(w,b,E,u)=>E?w:b||u||"")}e.stripIcons=P;function c(o){const w=o.indexOf(e.iconStartMarker);return w===-1?{text:o}:f(o,w)}e.parseLabelWithIcons=c;function f(o,w){const b=[];let E="";function u(m){if(m){E+=m;for(const p of m)b.push(t)}}let g=-1,v="",t=0,s,i,r=w;const d=o.length;for(u(o.substr(0,w));r<d;)s=o[r],i=o[r+1],s===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(g=r,u(v),v=e.iconStartMarker,r++):s===")"&&g!==-1?(t+=r-g+1,g=-1,v=""):g!==-1?/^[a-z0-9\-]$/i.test(s)?v+=s:(u(v),g=-1,v=""):u(s),r++;return u(v),{text:E,iconOffsets:b}}function l(o,w,b=!1){const{text:E,iconOffsets:u}=w;if(!u||u.length===0)return(0,R.matchesFuzzy)(o,E,b);const g=(0,D.ltrim)(E," "),v=E.length-g.length,t=(0,R.matchesFuzzy)(o,g,b);if(t)for(const s of t){const i=u[s.start+v]+v;s.start+=i,s.end+=i}return t}e.matchesFuzzyIconAware=l}),define(Ee[80],_e([0,1,112,12]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(f="",l=!1){if(this.value=f,typeof this.value!="string")throw(0,R.illegalArgument)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1)}appendText(f,l=0){return this.value+=C(this.supportThemeIcons?(0,h.escapeIcons)(f):f).replace(/([ \t]+)/g,(o,w)=>"&nbsp;".repeat(w.length)).replace(/^>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,l){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}}e.MarkdownString=y;function k(c){return S(c)?!c.value:Array.isArray(c)?c.every(k):!0}e.isEmptyMarkdownString=k;function S(c){return c instanceof y?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=S;function _(c,f){return c===f?!0:!c||!f?!1:c.value===f.value&&c.isTrusted===f.isTrusted&&c.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=_;function C(c){return c.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function n(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function P(c){const f=[],l=c.split("|").map(w=>w.trim());c=l[0];const o=l[1];if(o){const w=/height=(\d+)/.exec(o),b=/width=(\d+)/.exec(o),E=w?w[1]:"",u=b?b[1]:"",g=isFinite(parseInt(u)),v=isFinite(parseInt(E));g&&f.push(`width="${u}"`),v&&f.push(`height="${E}"`)}return{href:c,dimensions:f}}e.parseHrefAndDimensions=P}),define(Ee[54],_e([0,1,23,8,2]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function y(n){return JSON.stringify(n,_)}e.stringify=y;function k(n){let P=JSON.parse(n);return P=C(P),P}e.parse=k;var S;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(S=e.MarshalledId||(e.MarshalledId={}));function _(n,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,R.regExpFlags)(P)}:P}function C(n,P=0){if(!n||P>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return D.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof h.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let c=0;c<n.length;++c)n[c]=C(n[c],P+1);else for(const c in n)Object.hasOwnProperty.call(n,c)&&(n[c]=C(n[c],P+1))}return n}e.revive=C}),define(Ee[11],_e([0,1,2,21]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.userData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,C,n){this._hosts[_]=C,this._ports[_]=n}setConnectionToken(_,C){this._connectionTokens[_]=C}rewrite(_){if(this._delegate)return this._delegate(_);const C=_.authority;let n=this._hosts[C];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const P=this._ports[C],c=this._connectionTokens[C];let f=`path=${encodeURIComponent(_.path)}`;return typeof c=="string"&&(f+=`&tkn=${encodeURIComponent(c)}`),h.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${n}:${P}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new y;class k{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(_,C,n){const P=this.toUri(_,C);if(P.scheme===D.vscodeRemote)return e.RemoteAuthorities.rewrite(P);let c=!1;return R.isNative&&(n||R.isPreferringBrowserCodeLoad)&&P.scheme===D.file&&(c=!0),P.scheme===D.file&&typeof R.globals.importScripts=="function"&&R.globals.origin==="vscode-file://vscode-app"&&(c=!0),c?P.with({scheme:D.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(_,C){const n=this.toUri(_,C);return n.scheme===D.vscodeFileResource?n.with({scheme:D.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(_,C){return h.URI.isUri(_)?_:h.URI.parse(C.toUrl(_))}}e.FileAccess=new k}),define(Ee[25],_e([0,1,43,14,2,8,11,21]),function(te,e,h,R,D,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(f){return(0,D.uriToFsPath)(f,!0)}e.originalFSPath=_;class C{constructor(l){this._ignorePathCasing=l}compare(l,o,w=!1){return l===o?0:(0,y.compare)(this.getComparisonKey(l,w),this.getComparisonKey(o,w))}isEqual(l,o,w=!1){return l===o?!0:!l||!o?!1:this.getComparisonKey(l,w)===this.getComparisonKey(o,w)}getComparisonKey(l,o=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,o,w=!1){if(l.scheme===o.scheme){if(l.scheme===k.Schemas.file)return h.isEqualOrParent(_(l),_(o),this._ignorePathCasing(l))&&l.query===o.query&&(w||l.fragment===o.fragment);if((0,e.isEqualAuthority)(l.authority,o.authority))return h.isEqualOrParent(l.path,o.path,this._ignorePathCasing(l),"/")&&l.query===o.query&&(w||l.fragment===o.fragment)}return!1}joinPath(l,...o){return D.URI.joinPath(l,...o)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return R.posix.basename(l.path)}extname(l){return R.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let o;return l.scheme===k.Schemas.file?o=D.URI.file(R.dirname(_(l))).path:(o=R.posix.dirname(l.path),l.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),o="/")),l.with({path:o})}normalizePath(l){if(!l.path.length)return l;let o;return l.scheme===k.Schemas.file?o=D.URI.file(R.normalize(_(l))).path:o=R.posix.normalize(l.path),l.with({path:o})}relativePath(l,o){if(l.scheme!==o.scheme||!(0,e.isEqualAuthority)(l.authority,o.authority))return;if(l.scheme===k.Schemas.file){const E=R.relative(_(l),_(o));return S.isWindows?h.toSlashes(E):E}let w=l.path||"/",b=o.path||"/";if(this._ignorePathCasing(l)){let E=0;for(const u=Math.min(w.length,b.length);E<u&&!(w.charCodeAt(E)!==b.charCodeAt(E)&&w.charAt(E).toLowerCase()!==b.charAt(E).toLowerCase());E++);w=b.substr(0,E)+w.substr(E)}return R.posix.relative(w,b)}resolvePath(l,o){if(l.scheme===k.Schemas.file){const w=D.URI.file(R.resolve(_(l),o));return l.with({authority:w.authority,path:w.path})}return o=h.toPosixPath(o),l.with({path:R.posix.resolve(l.path,o)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,o){return l===o||(0,y.equalsIgnoreCase)(l,o)}hasTrailingPathSeparator(l,o=R.sep){if(l.scheme===k.Schemas.file){const w=_(l);return w.length>h.getRoot(w).length&&w[w.length-1]===o}else{const w=l.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,o=R.sep){return(0,e.hasTrailingPathSeparator)(l,o)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,o=R.sep){let w=!1;if(l.scheme===k.Schemas.file){const b=_(l);w=b!==void 0&&b.length===h.getRoot(b).length&&b[b.length-1]===o}else{o="/";const b=l.path;w=b.length===1&&b.charCodeAt(b.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(l,o)?l.with({path:l.path+"/"}):l}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(f=>f.scheme===k.Schemas.file?!S.isLinux:!0),e.extUriIgnorePathCase=new C(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(f,l){const o=[];for(let w=0;w<f.length;w++){const b=l(f[w]);f.some((E,u)=>u===w?!1:(0,e.isEqualOrParent)(b,l(E)))||o.push(f[w])}return o}e.distinctParents=n;var P;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function l(o){const w=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(u=>{const[g,v]=u.split(":");g&&v&&w.set(g,v)});const E=o.path.substring(0,o.path.indexOf(";"));return E&&w.set(f.META_DATA_MIME,E),w}f.parseMetaData=l})(P=e.DataUri||(e.DataUri={}));function c(f,l,o){if(l){let w=f.path;return w&&w[0]!==R.posix.sep&&(w=R.posix.sep+w),f.with({scheme:o,authority:l,path:w})}return f.with({scheme:o})}e.toLocalResource=c}),define(Ee[16],_e([0,1,18,12,3,7,25]),function(te,e,h,R,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(V){return!!V&&typeof V.then=="function"}e.isThenable=S;function _(V){const F=new h.CancellationTokenSource,re=V(F.token),N=new Promise((H,J)=>{const K=F.token.onCancellationRequested(()=>{K.dispose(),F.dispose(),J((0,R.canceled)())});Promise.resolve(re).then(le=>{K.dispose(),F.dispose(),H(le)},le=>{K.dispose(),F.dispose(),J(le)})});return new class{cancel(){F.cancel()}then(H,J){return N.then(H,J)}catch(H){return this.then(void 0,H)}finally(H){return N.finally(H)}}}e.createCancelablePromise=_;function C(V,F,re){return Promise.race([V,new Promise(N=>F.onCancellationRequested(()=>N(re)))])}e.raceCancellation=C;async function n(V){let F=-1;const re=V.map((H,J)=>H.then(K=>(F=J,K))),N=await Promise.race(re);return V.forEach((H,J)=>{J!==F&&H.cancel()}),N}e.raceCancellablePromises=n;function P(V,F,re){let N;const H=setTimeout(()=>{N?.(void 0),re?.()},F);return Promise.race([V.finally(()=>clearTimeout(H)),new Promise(J=>N=J)])}e.raceTimeout=P;function c(V){return new Promise((F,re)=>{const N=V();S(N)?N.then(F,re):F(N)})}e.asPromise=c;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const re=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(re,re).then(N)})}return new Promise((re,N)=>{this.queuedPromise.then(re,N)})}return this.activePromise=F(),new Promise((re,N)=>{this.activePromise.then(H=>{this.activePromise=null,re(H)},H=>{this.activePromise=null,N(H)})})}}e.Throttler=f;class l{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=l;class o{constructor(){this.promiseMap=new Map}queue(F,re){const H=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(re).finally(()=>{this.promiseMap.get(F)===H&&this.promiseMap.delete(F)});return this.promiseMap.set(F,H),H}}e.SequencerByKey=o;class w{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,re=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,H)=>{this.doResolve=N,this.doReject=H}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},re),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=w;class b{constructor(F){this.delayer=new w(F),this.throttler=new f}trigger(F,re){return this.delayer.trigger(()=>this.throttler.queue(F),re)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class E{constructor(){this._isOpen=!1,this._promise=new Promise((F,re)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=E;class u extends E{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function g(V,F){return F?new Promise((re,N)=>{const H=setTimeout(()=>{J.dispose(),re()},V),J=F.onCancellationRequested(()=>{clearTimeout(H),J.dispose(),N((0,R.canceled)())})}):_(re=>g(V,re))}e.timeout=g;function v(V,F=0){const re=setTimeout(V,F);return(0,y.toDisposable)(()=>clearTimeout(re))}e.disposableTimeout=v;function t(V){const F=[];let re=0;const N=V.length;function H(){return re<N?V[re++]():null}function J(K){K!=null&&F.push(K);const le=H();return le?le.then(J):Promise.resolve(F)}return Promise.resolve(null).then(J)}e.sequence=t;function s(V,F=N=>!!N,re=null){let N=0;const H=V.length,J=()=>{if(N>=H)return Promise.resolve(re);const K=V[N++];return Promise.resolve(K()).then(Ie=>F(Ie)?Promise.resolve(Ie):J())};return J()}e.first=s;function i(V,F=N=>!!N,re=null){if(V.length===0)return Promise.resolve(re);let N=V.length;const H=()=>{N=-1;for(const J of V)J.cancel?.()};return new Promise((J,K)=>{for(const le of V)le.then(Ie=>{--N>=0&&F(Ie)?(H(),J(Ie)):N===0&&J(re)}).catch(Ie=>{--N>=0&&(H(),K(Ie))})})}e.firstParallel=i;class r{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((re,N)=>{this.outstandingPromises.push({factory:F,c:re,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const re=F.factory();re.then(F.c,F.e),re.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class d extends r{constructor(){super(1)}}e.Queue=d;class m{constructor(){this.queues=new Map}queueFor(F,re=k.extUri){const N=re.getComparisonKey(F);let H=this.queues.get(N);return H||(H=new d,D.Event.once(H.onFinished)(()=>{H?.dispose(),this.queues.delete(N)}),this.queues.set(N,H)),H}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=m;class p{constructor(F,re){this._token=-1,typeof F=="function"&&typeof re=="number"&&this.setIfNotSet(F,re)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,re){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},re)}setIfNotSet(F,re){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},re))}}e.TimeoutTimer=p;class I{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,re){this.cancel(),this._token=setInterval(()=>{F()},re)}}e.IntervalTimer=I;class A{constructor(F,re){this.timeoutToken=-1,this.runner=F,this.timeout=re,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=A;class a extends A{constructor(F,re){super(F,re);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=a;class T extends y.Disposable{constructor(F,re,N,H){super();this.maxWorkChunkSize=F,this.maxPendingWork=re,this.throttleDelay=N,this.handler=H,this.pendingWork=[],this.throttler=this._register(new y.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new A(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=T,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const V=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const re=setTimeout(()=>F(V));let N=!1;return{dispose(){N||(N=!0,clearTimeout(re))}}}}else e.runWhenIdle=(V,F)=>{const re=requestIdleCallback(V,typeof F=="number"?{timeout:F}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(re))}}}}();class M{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(re){this._error=re}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=M;async function W(V,F,re){let N;for(let H=0;H<re;H++)try{return await V()}catch(J){N=J,await g(F)}throw N}e.retry=W;class B{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,re,N){return this._pending={taskId:F,cancel:()=>N?.(),promise:re},re.then(()=>this.donePending(F),()=>this.donePending(F)),re}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let re,N;const H=new Promise((J,K)=>{re=J,N=K});this._next={run:F,promise:H,promiseResolve:re,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=B;class Z{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=Z;class q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,re)=>{this.completeCallback=F,this.errorCallback=re})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(re=>{this.completeCallback(F),this.resolved=!0,re()})}error(F){return new Promise(re=>{this.errorCallback(F),this.rejected=!0,re()})}cancel(){new Promise(F=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=q;var $;(function(V){async function F(re){let N;const H=await Promise.all(re.map(J=>J.then(K=>K,K=>{N||(N=K)})));if(typeof N!="undefined")throw N;return H}V.settled=F})($=e.Promises||(e.Promises={}))}),define(Ee[113],_e([0,1,14,16]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new R.IdleValue(()=>{const A=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:A,collatorIsNumeric:A.resolvedOptions().numeric}}),y=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function S(A,a,T=!1){const M=A||"",W=a||"",B=D.value.collator.compare(M,W);return D.value.collatorIsNumeric&&B===0&&M!==W?M<W?-1:1:B}e.compareFileNames=S;function _(A,a){const T=y.value.collator;return A=A||"",a=a||"",v(T,A,a)}e.compareFileNamesDefault=_;function C(A,a){const T=y.value.collator;return A=A||"",a=a||"",r(A,a)||v(T,A,a)}e.compareFileNamesUpper=C;function n(A,a){const T=y.value.collator;return A=A||"",a=a||"",i(A,a)||v(T,A,a)}e.compareFileNamesLower=n;function P(A,a){return A=A||"",a=a||"",A===a?0:A<a?-1:1}e.compareFileNamesUnicode=P;function c(A,a,T=!1){T||(A=A&&A.toLowerCase(),a=a&&a.toLowerCase());const[M,W]=u(A),[B,Z]=u(a);return M!==B?M<B?-1:1:W===Z?0:W<Z?-1:1}e.noIntlCompareFileNames=c;function f(A,a){const[T,M]=u(A),[W,B]=u(a);let Z=D.value.collator.compare(M,B);if(Z===0){if(D.value.collatorIsNumeric&&M!==B)return M<B?-1:1;if(Z=D.value.collator.compare(T,W),D.value.collatorIsNumeric&&Z===0&&T!==W)return T<W?-1:1}return Z}e.compareFileExtensions=f;function l(A,a){A=A||"",a=a||"";const T=g(A),M=g(a),W=y.value.collator,B=k.value.collator;return v(B,T,M)||v(W,A,a)}e.compareFileExtensionsDefault=l;function o(A,a){A=A||"",a=a||"";const T=g(A),M=g(a),W=y.value.collator,B=k.value.collator;return v(B,T,M)||r(A,a)||v(W,A,a)}e.compareFileExtensionsUpper=o;function w(A,a){A=A||"",a=a||"";const T=g(A),M=g(a),W=y.value.collator,B=k.value.collator;return v(B,T,M)||i(A,a)||v(W,A,a)}e.compareFileExtensionsLower=w;function b(A,a){A=A||"",a=a||"";const T=g(A).toLowerCase(),M=g(a).toLowerCase();return T!==M?T<M?-1:1:A!==a?A<a?-1:1:0}e.compareFileExtensionsUnicode=b;const E=/^(.*?)(\.([^.]*))?$/;function u(A,a=!1){const T=A?E.exec(A):[];let M=[T&&T[1]||"",T&&T[3]||""];return a&&(!M[0]&&M[1]||M[0]&&M[0].charAt(0)===".")&&(M=[M[0]+"."+M[1],""]),M}function g(A){const a=A?E.exec(A):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function v(A,a,T){let M=A.compare(a,T);return M!==0?M:a.length!==T.length?a.length<T.length?-1:1:0}function t(A){const a=A.charAt(0);return a.toLocaleUpperCase()!==a}function s(A){const a=A.charAt(0);return a.toLocaleLowerCase()!==a}function i(A,a){return t(A)&&s(a)?-1:s(A)&&t(a)?1:0}function r(A,a){return s(A)&&t(a)?-1:t(A)&&s(a)?1:0}function d(A,a,T=!1){return T||(A=A&&A.toLowerCase(),a=a&&a.toLowerCase()),A===a?0:A<a?-1:1}function m(A,a,T=!1){const M=A.split(h.sep),W=a.split(h.sep),B=M.length-1,Z=W.length-1;let q,$;for(let V=0;;V++){if(q=B===V,$=Z===V,q&&$)return S(M[V],W[V],T);if(q)return-1;if($)return 1;const F=d(M[V],W[V],T);if(F!==0)return F}}e.comparePaths=m;function p(A,a,T){const M=A.toLowerCase(),W=a.toLowerCase(),B=I(A,a,T);if(B)return B;const Z=M.endsWith(T),q=W.endsWith(T);if(Z!==q)return Z?-1:1;const $=S(M,W);return $!==0?$:M.localeCompare(W)}e.compareAnything=p;function I(A,a,T){const M=A.toLowerCase(),W=a.toLowerCase(),B=M.startsWith(T),Z=W.startsWith(T);if(B!==Z)return B?-1:1;if(B&&Z){if(M.length<W.length)return-1;if(M.length>W.length)return 1}return 0}e.compareByPrefix=I}),define(Ee[27],_e([0,1,8,43,14,22,16]),function(te,e,h,R,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S;const _="**",C="/",n="[/\\\\]",P="[^/\\\\]",c=/\//g;function f(H){switch(H){case 0:return"";case 1:return`${P}*?`;default:return`(?:${n}|${P}+${n}|${n}${P}+)*?`}}function l(H,J){if(!H)return[];const K=[];let le=!1,Ie=!1,Me="";for(const Ve of H){switch(Ve){case J:if(!le&&!Ie){K.push(Me),Me="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":Ie=!0;break;case"]":Ie=!1;break}Me+=Ve}return Me&&K.push(Me),K}e.splitGlobAware=l;function o(H){if(!H)return"";let J="";const K=l(H,C);if(K.every(le=>le===_))J=".*";else{let le=!1;K.forEach((Ie,Me)=>{if(Ie===_){le||(J+=f(2),le=!0);return}let Ve=!1,xe="",Ge=!1,Ke="";for(const qe of Ie){if(qe!=="}"&&Ve){xe+=qe;continue}if(Ge&&(qe!=="]"||!Ke)){let U;qe==="-"?U=qe:(qe==="^"||qe==="!")&&!Ke?U="^":qe===C?U="":U=h.escapeRegExpCharacters(qe),Ke+=U;continue}switch(qe){case"{":Ve=!0;continue;case"[":Ge=!0;continue;case"}":J+=`(?:${l(xe,",").map(ne=>o(ne)).join("|")})`,Ve=!1,xe="";break;case"]":J+="["+Ke+"]",Ge=!1,Ke="";break;case"?":J+=P;continue;case"*":J+=f(1);continue;default:J+=h.escapeRegExpCharacters(qe)}}Me<K.length-1&&(K[Me+1]!==_||Me+2<K.length)&&(J+=n),le=!1})}return J}const w=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),s=function(){return!1},i=function(){return null};function r(H,J){if(!H)return i;let K;typeof H!="string"?K=H.pattern:K=H,K=K.trim();const le=`${K}_${!!J.trimForExclusions}`;let Ie=t.get(le);if(Ie)return d(Ie,H);let Me;if(w.test(K)){const Ve=K.substr(4);Ie=function(xe,Ge){return typeof xe=="string"&&xe.endsWith(Ve)?K:null}}else(Me=b.exec(m(K,J)))?Ie=p(Me[1],K):(J.trimForExclusions?u:E).test(K)?Ie=I(K,J):(Me=g.exec(m(K,J)))?Ie=A(Me[1].substr(1),K,!0):(Me=v.exec(m(K,J)))?Ie=A(Me[1],K,!1):Ie=a(K);return t.set(le,Ie),d(Ie,H)}function d(H,J){return typeof J=="string"?H:function(K,le){return R.isEqualOrParent(K,J.base)?H(D.relative(J.base,K),le):null}}function m(H,J){return J.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function p(H,J){const K=`/${H}`,le=`\\${H}`,Ie=function(Ve,xe){return typeof Ve!="string"?null:xe?xe===H?J:null:Ve===H||Ve.endsWith(K)||Ve.endsWith(le)?J:null},Me=[H];return Ie.basenames=Me,Ie.patterns=[J],Ie.allBasenames=Me,Ie}function I(H,J){const K=N(H.slice(1,-1).split(",").map(xe=>r(xe,J)).filter(xe=>xe!==i),H),le=K.length;if(!le)return i;if(le===1)return K[0];const Ie=function(xe,Ge){for(let Ke=0,qe=K.length;Ke<qe;Ke++)if(K[Ke](xe,Ge))return H;return null},Me=K.find(xe=>!!xe.allBasenames);Me&&(Ie.allBasenames=Me.allBasenames);const Ve=K.reduce((xe,Ge)=>Ge.allPaths?xe.concat(Ge.allPaths):xe,[]);return Ve.length&&(Ie.allPaths=Ve),Ie}function A(H,J,K){const le=D.sep===D.posix.sep,Ie=le?H:H.replace(c,D.sep),Me=D.sep+Ie,Ve=D.posix.sep+H,xe=K?function(Ge,Ke){return typeof Ge=="string"&&(Ge===Ie||Ge.endsWith(Me)||!le&&(Ge===H||Ge.endsWith(Ve)))?J:null}:function(Ge,Ke){return typeof Ge=="string"&&(Ge===Ie||!le&&Ge===H)?J:null};return xe.allPaths=[(K?"*/":"./")+H],xe}function a(H){try{const J=new RegExp(`^${o(H)}$`);return function(K){return J.lastIndex=0,typeof K=="string"&&J.test(K)?H:null}}catch(J){return i}}function T(H,J,K){return!H||typeof J!="string"?!1:M(H)(J,void 0,K)}e.match=T;function M(H,J={}){if(!H)return s;if(typeof H=="string"||q(H)){const K=r(H,J);if(K===i)return s;const le=function(Ie,Me){return!!K(Ie,Me)};return K.allBasenames&&(le.allBasenames=K.allBasenames),K.allPaths&&(le.allPaths=K.allPaths),le}return F(H,J)}e.parse=M;function W(H){if(!H)return;let J;return K=>(J||(J=(H()||Promise.resolve([])).then(le=>le?Z(le):{})),J.then(le=>!!le[K]))}e.hasSiblingPromiseFn=W;function B(H){if(!H)return;let J;return K=>{if(!J){const le=H();J=le?Z(le):{}}return!!J[K]}}e.hasSiblingFn=B;function Z(H){const J={};for(const K of H)J[K]=!0;return J}function q(H){const J=H;return J&&typeof J.base=="string"&&typeof J.pattern=="string"}e.isRelativePattern=q;function $(H){return H.allBasenames||[]}e.getBasenameTerms=$;function V(H){return H.allPaths||[]}e.getPathTerms=V;function F(H,J){const K=N(Object.getOwnPropertyNames(H).map(xe=>re(xe,H[xe],J)).filter(xe=>xe!==i)),le=K.length;if(!le)return i;if(!K.some(xe=>!!xe.requiresSiblings)){if(le===1)return K[0];const xe=function(qe,U){for(let G=0,ne=K.length;G<ne;G++){const se=K[G](qe,U);if(se)return se}return null},Ge=K.find(qe=>!!qe.allBasenames);Ge&&(xe.allBasenames=Ge.allBasenames);const Ke=K.reduce((qe,U)=>U.allPaths?qe.concat(U.allPaths):qe,[]);return Ke.length&&(xe.allPaths=Ke),xe}const Ie=function(xe,Ge,Ke){let qe;for(let U=0,G=K.length;U<G;U++){const ne=K[U];ne.requiresSiblings&&Ke&&(Ge||(Ge=D.basename(xe)),qe||(qe=Ge.substr(0,Ge.length-D.extname(xe).length)));const se=ne(xe,Ge,qe,Ke);if(se)return se}return null},Me=K.find(xe=>!!xe.allBasenames);Me&&(Ie.allBasenames=Me.allBasenames);const Ve=K.reduce((xe,Ge)=>Ge.allPaths?xe.concat(Ge.allPaths):xe,[]);return Ve.length&&(Ie.allPaths=Ve),Ie}function re(H,J,K){if(J===!1)return i;const le=r(H,K);if(le===i)return i;if(typeof J=="boolean")return le;if(J){const Ie=J.when;if(typeof Ie=="string"){const Me=(Ve,xe,Ge,Ke)=>{if(!Ke||!le(Ve,xe))return null;const qe=Ie.replace("$(basename)",Ge),U=Ke(qe);return(0,k.isThenable)(U)?U.then(G=>G?H:null):U?H:null};return Me.requiresSiblings=!0,Me}}return le}function N(H,J){const K=H.filter(xe=>!!xe.basenames);if(K.length<2)return H;const le=K.reduce((xe,Ge)=>{const Ke=Ge.basenames;return Ke?xe.concat(Ke):xe},[]);let Ie;if(J){Ie=[];for(let xe=0,Ge=le.length;xe<Ge;xe++)Ie.push(J)}else Ie=K.reduce((xe,Ge)=>{const Ke=Ge.patterns;return Ke?xe.concat(Ke):xe},[]);const Me=function(xe,Ge){if(typeof xe!="string")return null;if(!Ge){let qe;for(qe=xe.length;qe>0;qe--){const U=xe.charCodeAt(qe-1);if(U===47||U===92)break}Ge=xe.substr(qe)}const Ke=le.indexOf(Ge);return Ke!==-1?Ie[Ke]:null};Me.basenames=le,Me.patterns=Ie,Me.allBasenames=le;const Ve=H.filter(xe=>!xe.basenames);return Ve.push(Me),Ve}}),define(Ee[81],_e([0,1,2,14,8,11,21,25,43]),function(te,e,h,R,D,y,k,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(r,d,m){if(typeof r=="string"&&(r=h.URI.file(r)),m){const I=m.getWorkspaceFolder(r);if(I){const A=m.getWorkspace().folders.length>1;let a;if((0,S.isEqual)(I.uri,r)?a="":a=(0,S.relativePath)(I.uri,r),A){const T=I.name?I.name:(0,S.basename)(I.uri);a=a?T+" \u2022 "+a:T}return a}}if(r.scheme!==y.Schemas.file&&r.scheme!==y.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,_.hasDriveLetter)(r.fsPath))return(0,R.normalize)(P(r.fsPath));let p=(0,R.normalize)(r.fsPath);return!k.isWindows&&d?.userHome&&(p=f(p,d.userHome.fsPath)),p}e.getPathLabel=C;function n(r){if(!r)return;typeof r=="string"&&(r=h.URI.file(r));const d=(0,S.basename)(r)||(r.scheme===y.Schemas.file?r.fsPath:r.path);return k.isWindows&&(0,_.isRootOrDriveLetter)(d)?P(d):d}e.getBaseLabel=n;function P(r){return(0,_.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=P;let c=Object.create(null);function f(r,d){if(k.isWindows||!r||!d)return r;let m=c.original===d?c.normalized:void 0;return m||(m=`${(0,D.rtrim)(d,R.posix.sep)}${R.posix.sep}`,c={original:d,normalized:m}),(k.isLinux?r.startsWith(m):(0,D.startsWithIgnoreCase)(r,m))&&(r=`~/${r.substr(m.length)}`),r}e.tildify=f;function l(r,d){return r.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=l;const o="\u2026",w="\\\\",b="~";function E(r,d=R.sep){const m=new Array(r.length);let p=!1;for(let I=0;I<r.length;I++){let A=r[I];if(A===""){m[I]=`.${d}`;continue}if(!A){m[I]=A;continue}p=!0;let a="";A.indexOf(w)===0?(a=A.substr(0,A.indexOf(w)+w.length),A=A.substr(A.indexOf(w)+w.length)):A.indexOf(d)===0?(a=A.substr(0,A.indexOf(d)+d.length),A=A.substr(A.indexOf(d)+d.length)):A.indexOf(b)===0&&(a=A.substr(0,A.indexOf(b)+b.length),A=A.substr(A.indexOf(b)+b.length));const T=A.split(d);for(let M=1;p&&M<=T.length;M++)for(let W=T.length-M;p&&W>=0;W--){p=!1;let B=T.slice(W,W+M).join(d);for(let Z=0;!p&&Z<r.length;Z++)if(Z!==I&&r[Z]&&r[Z].indexOf(B)>-1){const q=W+M===T.length,$=W>0&&r[Z].indexOf(d)>-1?d+B:B,V=r[Z].endsWith($);p=!q||V}if(!p){let Z="";(T[0].endsWith(":")||a!=="")&&(W===1&&(W=0,M++,B=T[0]+d+B),W>0&&(Z=T[0]+d),Z=a+Z),W>0&&(Z=Z+o+d),Z=Z+B,W+M<T.length&&(Z=Z+d+o),m[I]=Z}}p&&(m[I]=A)}return m}e.shorten=E;var u;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function g(r,d=Object.create(null)){const m=[];let p=!1,I="";for(const A of r)if(A==="$"||p&&A==="{")I&&m.push({value:I,type:u.TEXT}),I="",p=!0;else if(A==="}"&&p){const a=d[I];if(typeof a=="string")a.length&&m.push({value:a,type:u.VARIABLE});else if(a){const T=m[m.length-1];(!T||T.type!==u.SEPARATOR)&&m.push({value:a.label,type:u.SEPARATOR})}I="",p=!1}else I+=A;return I&&!p&&m.push({value:I,type:u.TEXT}),m.filter((A,a)=>{if(A.type===u.SEPARATOR){const T=m[a-1],M=m[a+1];return[T,M].every(W=>W&&(W.type===u.VARIABLE||W.type===u.TEXT)&&W.value.length>0)}return!0}).map(A=>A.value).join("")}e.template=g;function v(r,d){return k.isMacintosh||d?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):r.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function t(r,d){return k.isMacintosh||d?r.replace(/\(&&\w\)|&&/g,""):k.isWindows?r.replace(/&&|&/g,m=>m==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function s(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=s;function i(r){const d=r.indexOf("/")!==-1?R.posix:R.win32,m=d.basename(r),p=d.dirname(r);return m.length?{name:m,parentPath:p}:{name:p,parentPath:""}}e.splitName=i}),define(Ee[82],_e([0,1,14,8,27,11,25]),function(te,e,h,R,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var S;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown"})(S=e.Mimes||(e.Mimes={}));let _=[],C=[],n=[];function P(s,i=!1){const r=c(s);_.push(r),r.userConfigured?n.push(r):C.push(r),i&&!r.userConfigured&&_.forEach(d=>{d.mime===r.mime||d.userConfigured||(r.extension&&d.extension===r.extension&&console.warn(`Overwriting extension <<${r.extension}>> to now point to mime <<${r.mime}>>`),r.filename&&d.filename===r.filename&&console.warn(`Overwriting filename <<${r.filename}>> to now point to mime <<${r.mime}>>`),r.filepattern&&d.filepattern===r.filepattern&&console.warn(`Overwriting filepattern <<${r.filepattern}>> to now point to mime <<${r.mime}>>`),r.firstline&&d.firstline===r.firstline&&console.warn(`Overwriting firstline <<${r.firstline}>> to now point to mime <<${r.mime}>>`))})}e.registerTextMime=P;function c(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?s.filepattern.toLowerCase():void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(h.posix.sep)>=0:!1}}function f(s){s?(_=_.filter(i=>!i.userConfigured),n=[]):(_=[],C=[],n=[])}e.clearTextMimes=f;function l(s,i){let r;if(s)switch(s.scheme){case y.Schemas.file:r=s.fsPath;break;case y.Schemas.data:r=k.DataUri.parseMetaData(s).get(k.DataUri.META_DATA_LABEL);break;default:r=s.path}if(!r)return[S.unknown];r=r.toLowerCase();const d=(0,h.basename)(r),m=o(r,d,n);if(m)return[m,S.text];const p=o(r,d,C);if(p)return[p,S.text];if(i){const I=w(i);if(I)return[I,S.text]}return[S.unknown]}e.guessMimeTypes=l;function o(s,i,r){let d=null,m=null,p=null;for(let I=r.length-1;I>=0;I--){const A=r[I];if(i===A.filenameLowercase){d=A;break}if(A.filepattern&&(!m||A.filepattern.length>m.filepattern.length)){const a=A.filepatternOnPath?s:i;(0,D.match)(A.filepatternLowercase,a)&&(m=A)}A.extension&&(!p||A.extension.length>p.extension.length)&&i.endsWith(A.extensionLowercase)&&(p=A)}return d?d.mime:m?m.mime:p?p.mime:null}function w(s){if((0,R.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let i=_.length-1;i>=0;i--){const r=_[i];if(!r.firstline)continue;const d=s.match(r.firstline);if(d&&d.length>0)return r.mime}return null}function b(s){return s?typeof s=="string"?s===S.binary||s===S.text||s===S.unknown:s.length===1&&b(s[0]):!0}e.isUnspecific=b;const E={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function u(s){const i=(0,h.extname)(s);return E[i.toLowerCase()]}e.getMediaMime=u;function g(s){for(const i in E)if(E[i]===s)return i}e.getExtensionForMimeType=g;const v=/^(.+)\/(.+?)(;.+)?$/;function t(s,i){const r=v.exec(s);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${r[3]??""}`:i?void 0:s}e.normalizeMimeType=t}),define(Ee[114],_e([0,1,2]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(n){return n.toJSON()}class D{constructor(P){this._uriTransformer=P}transformIncoming(P){const c=this._uriTransformer.transformIncoming(P);return c===P?P:R(h.URI.from(c))}transformOutgoing(P){const c=this._uriTransformer.transformOutgoing(P);return c===P?P:R(h.URI.from(c))}transformOutgoingURI(P){const c=this._uriTransformer.transformOutgoing(P);return c===P?P:h.URI.from(c)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function y(n,P,c){if(!n||c>200)return null;if(typeof n=="object"){if(n instanceof h.URI)return P.transformOutgoing(n);for(let f in n)if(Object.hasOwnProperty.call(n,f)){const l=y(n[f],P,c+1);l!==null&&(n[f]=l)}}return null}function k(n,P){const c=y(n,P,0);return c===null?n:c}e.transformOutgoingURIs=k;function S(n,P,c,f){if(!n||f>200)return null;if(typeof n=="object"){if(n.$mid===1)return c?h.URI.revive(P.transformIncoming(n)):P.transformIncoming(n);for(let l in n)if(Object.hasOwnProperty.call(n,l)){const o=S(n[l],P,c,f+1);o!==null&&(n[l]=o)}}return null}function _(n,P){const c=S(n,P,!1,0);return c===null?n:c}e.transformIncomingURIs=_;function C(n,P){const c=S(n,P,!0,0);return c===null?n:c}e.transformAndReviveIncomingURIs=C}),define(Ee[35],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const h=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(_){return h.test(_)}e.isUUID=R;const D=new Uint8Array(16),y=[];for(let _=0;_<256;_++)y.push(_.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(_){for(let C=0;C<_.length;C++)_[C]=Math.floor(Math.random()*256);return _};function S(){k(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let _=0,C="";return C+=y[D[_++]],C+=y[D[_++]],C+=y[D[_++]],C+=y[D[_++]],C+="-",C+=y[D[_++]],C+=y[D[_++]],C+="-",C+=y[D[_++]],C+=y[D[_++]],C+="-",C+=y[D[_++]],C+=y[D[_++]],C+="-",C+=y[D[_++]],C+=y[D[_++]],C+=y[D[_++]],C+=y[D[_++]],C+=y[D[_++]],C+=y[D[_++]],C}e.generateUuid=S}),define(Ee[83],_e([0,1,79]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(S){let _=(0,h.toUint8)(S);this._defaultValue=_,this._asciiMap=R._createAsciiMap(_),this._map=new Map}static _createAsciiMap(S){let _=new Uint8Array(256);for(let C=0;C<256;C++)_[C]=S;return _}set(S,_){let C=(0,h.toUint8)(_);S>=0&&S<256?this._asciiMap[S]=C:this._map.set(S,C)}get(S){return S>=0&&S<256?this._asciiMap[S]:this._map.get(S)||this._defaultValue}}e.CharacterClassifier=R;var D;(function(k){k[k.False=0]="False",k[k.True=1]="True"})(D||(D={}));class y{constructor(){this._actual=new R(0)}add(S){this._actual.set(S,1)}has(S){return this._actual.get(S)===1}}e.CharacterSet=y}),define(Ee[115],_e([0,1,83]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(k){k[k.Regular=0]="Regular",k[k.Whitespace=1]="Whitespace",k[k.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends h.CharacterClassifier{constructor(S){super(0);for(let _=0,C=S.length;_<C;_++)this.set(S.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function y(k){let S={};return _=>(S.hasOwnProperty(_)||(S[_]=k(_)),S[_])}e.getMapForWordSeparators=y(k=>new D(k))}),define(Ee[36],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class h{constructor(D,y){this.lineNumber=D,this.column=y}with(D=this.lineNumber,y=this.column){return D===this.lineNumber&&y===this.column?this:new h(D,y)}delta(D=0,y=0){return this.with(this.lineNumber+D,this.column+y)}equals(D){return h.equals(this,D)}static equals(D,y){return!D&&!y?!0:!!D&&!!y&&D.lineNumber===y.lineNumber&&D.column===y.column}isBefore(D){return h.isBefore(this,D)}static isBefore(D,y){return D.lineNumber<y.lineNumber?!0:y.lineNumber<D.lineNumber?!1:D.column<y.column}isBeforeOrEqual(D){return h.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,y){return D.lineNumber<y.lineNumber?!0:y.lineNumber<D.lineNumber?!1:D.column<=y.column}static compare(D,y){let k=D.lineNumber|0,S=y.lineNumber|0;if(k===S){let _=D.column|0,C=y.column|0;return _-C}return k-S}clone(){return new h(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new h(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=h}),define(Ee[30],_e([0,1,36]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(y,k,S,_){y>S||y===S&&k>_?(this.startLineNumber=S,this.startColumn=_,this.endLineNumber=y,this.endColumn=k):(this.startLineNumber=y,this.startColumn=k,this.endLineNumber=S,this.endColumn=_)}isEmpty(){return R.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return R.containsPosition(this,y)}static containsPosition(y,k){return!(k.lineNumber<y.startLineNumber||k.lineNumber>y.endLineNumber||k.lineNumber===y.startLineNumber&&k.column<y.startColumn||k.lineNumber===y.endLineNumber&&k.column>y.endColumn)}containsRange(y){return R.containsRange(this,y)}static containsRange(y,k){return!(k.startLineNumber<y.startLineNumber||k.endLineNumber<y.startLineNumber||k.startLineNumber>y.endLineNumber||k.endLineNumber>y.endLineNumber||k.startLineNumber===y.startLineNumber&&k.startColumn<y.startColumn||k.endLineNumber===y.endLineNumber&&k.endColumn>y.endColumn)}strictContainsRange(y){return R.strictContainsRange(this,y)}static strictContainsRange(y,k){return!(k.startLineNumber<y.startLineNumber||k.endLineNumber<y.startLineNumber||k.startLineNumber>y.endLineNumber||k.endLineNumber>y.endLineNumber||k.startLineNumber===y.startLineNumber&&k.startColumn<=y.startColumn||k.endLineNumber===y.endLineNumber&&k.endColumn>=y.endColumn)}plusRange(y){return R.plusRange(this,y)}static plusRange(y,k){let S,_,C,n;return k.startLineNumber<y.startLineNumber?(S=k.startLineNumber,_=k.startColumn):k.startLineNumber===y.startLineNumber?(S=k.startLineNumber,_=Math.min(k.startColumn,y.startColumn)):(S=y.startLineNumber,_=y.startColumn),k.endLineNumber>y.endLineNumber?(C=k.endLineNumber,n=k.endColumn):k.endLineNumber===y.endLineNumber?(C=k.endLineNumber,n=Math.max(k.endColumn,y.endColumn)):(C=y.endLineNumber,n=y.endColumn),new R(S,_,C,n)}intersectRanges(y){return R.intersectRanges(this,y)}static intersectRanges(y,k){let S=y.startLineNumber,_=y.startColumn,C=y.endLineNumber,n=y.endColumn,P=k.startLineNumber,c=k.startColumn,f=k.endLineNumber,l=k.endColumn;return S<P?(S=P,_=c):S===P&&(_=Math.max(_,c)),C>f?(C=f,n=l):C===f&&(n=Math.min(n,l)),S>C||S===C&&_>n?null:new R(S,_,C,n)}equalsRange(y){return R.equalsRange(this,y)}static equalsRange(y,k){return!!y&&!!k&&y.startLineNumber===k.startLineNumber&&y.startColumn===k.startColumn&&y.endLineNumber===k.endLineNumber&&y.endColumn===k.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(y){return new h.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(y){return new h.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,k){return new R(this.startLineNumber,this.startColumn,y,k)}setStartPosition(y,k){return new R(y,k,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(y){return new R(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,k=y){return new R(y.lineNumber,y.column,k.lineNumber,k.column)}static lift(y){return y?new R(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,k){return!(y.endLineNumber<k.startLineNumber||y.endLineNumber===k.startLineNumber&&y.endColumn<k.startColumn||k.endLineNumber<y.startLineNumber||k.endLineNumber===y.startLineNumber&&k.endColumn<y.startColumn)}static areIntersecting(y,k){return!(y.endLineNumber<k.startLineNumber||y.endLineNumber===k.startLineNumber&&y.endColumn<=k.startColumn||k.endLineNumber<y.startLineNumber||k.endLineNumber===y.startLineNumber&&k.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,k){if(y&&k){const C=y.startLineNumber|0,n=k.startLineNumber|0;if(C===n){const P=y.startColumn|0,c=k.startColumn|0;if(P===c){const f=y.endLineNumber|0,l=k.endLineNumber|0;if(f===l){const o=y.endColumn|0,w=k.endColumn|0;return o-w}return f-l}return P-c}return C-n}return(y?1:0)-(k?1:0)}static compareRangesUsingEnds(y,k){return y.endLineNumber===k.endLineNumber?y.endColumn===k.endColumn?y.startLineNumber===k.startLineNumber?y.startColumn-k.startColumn:y.startLineNumber-k.startLineNumber:y.endColumn-k.endColumn:y.endLineNumber-k.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=R}),define(Ee[116],_e([0,1,36,30]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(k){k[k.LTR=0]="LTR",k[k.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class y extends R.Range{constructor(S,_,C,n){super(S,_,C,n);this.selectionStartLineNumber=S,this.selectionStartColumn=_,this.positionLineNumber=C,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(S){return y.selectionsEqual(this,S)}static selectionsEqual(S,_){return S.selectionStartLineNumber===_.selectionStartLineNumber&&S.selectionStartColumn===_.selectionStartColumn&&S.positionLineNumber===_.positionLineNumber&&S.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(S,_){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,S,_):new y(S,_,this.startLineNumber,this.startColumn)}getPosition(){return new h.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(S,_){return this.getDirection()===0?new y(S,_,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,S,_)}static fromPositions(S,_=S){return new y(S.lineNumber,S.column,_.lineNumber,_.column)}static liftSelection(S){return new y(S.selectionStartLineNumber,S.selectionStartColumn,S.positionLineNumber,S.positionColumn)}static selectionsArrEqual(S,_){if(S&&!_||!S&&_)return!1;if(!S&&!_)return!0;if(S.length!==_.length)return!1;for(let C=0,n=S.length;C<n;C++)if(!this.selectionsEqual(S[C],_[C]))return!1;return!0}static isISelection(S){return S&&typeof S.selectionStartLineNumber=="number"&&typeof S.selectionStartColumn=="number"&&typeof S.positionLineNumber=="number"&&typeof S.positionColumn=="number"}static createWithDirection(S,_,C,n,P){return P===0?new y(S,_,C,n):new y(C,n,S,_)}}e.Selection=y}),define(Ee[84],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var h;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(h=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var D;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace)}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class _{constructor(o,w){this._findMatchBrand=void 0,this.range=o,this.matches=w}}e.FindMatch=_;var C;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None"})(n=e.PositionAffinity||(e.PositionAffinity={}));var P;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(P=e.ModelConstants||(e.ModelConstants={}));class c{constructor(o,w,b,E,u,g){this.identifier=o,this.range=w,this.text=b,this.forceMoveMarkers=E,this.isAutoWhitespaceEdit=u,this._isTracked=g}}e.ValidAnnotatedEditOperation=c;class f{constructor(o,w,b){this.reverseEdits=o,this.changes=w,this.trimAutoWhitespaceLineNumbers=b}}e.ApplyEditsResult=f}),define(Ee[117],_e([0,1,8,115,36,30,84]),function(te,e,h,R,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const S=999;class _{constructor(u,g,v,t){this.searchString=u,this.isRegex=g,this.matchCase=v,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=C(this.searchString):u=this.searchString.indexOf(`
`)>=0;let g=null;try{g=h.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(t){return null}if(!g)return null;let v=!this.isRegex&&!u;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new n(g,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=_;function C(E){if(!E||E.length===0)return!1;for(let u=0,g=E.length;u<g;u++)if(E.charCodeAt(u)===92){if(u++,u>=g)break;const t=E.charCodeAt(u);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class n{constructor(u,g,v){this.regex=u,this.wordSeparators=g,this.simpleSearch=v}}e.SearchData=n;function P(E,u,g){if(!g)return new k.FindMatch(E,null);let v=[];for(let t=0,s=u.length;t<s;t++)v[t]=u[t];return new k.FindMatch(E,v)}e.createFindMatch=P;class c{constructor(u){let g=[],v=0;for(let t=0,s=u.length;t<s;t++)u.charCodeAt(t)===10&&(g[v++]=t);this._lineFeedsOffsets=g}findLineFeedCountBeforeOffset(u){const g=this._lineFeedsOffsets;let v=0,t=g.length-1;if(t===-1||u<=g[0])return 0;for(;v<t;){const s=v+((t-v)/2>>0);g[s]>=u?t=s-1:g[s+1]>=u?(v=s,t=s):v=s+1}return v+1}}class f{static findMatches(u,g,v,t,s){const i=g.parseSearchRequest();return i?i.regex.multiline?this._doFindMatchesMultiline(u,v,new b(i.wordSeparators,i.regex),t,s):this._doFindMatchesLineByLine(u,v,i,t,s):[]}static _getMultilineMatchRange(u,g,v,t,s,i){let r,d=0;t?(d=t.findLineFeedCountBeforeOffset(s),r=g+s+d):r=g+s;let m;if(t){let a=t.findLineFeedCountBeforeOffset(s+i.length)-d;m=r+i.length+a}else m=r+i.length;const p=u.getPositionAt(r),I=u.getPositionAt(m);return new y.Range(p.lineNumber,p.column,I.lineNumber,I.column)}static _doFindMatchesMultiline(u,g,v,t,s){const i=u.getOffsetAt(g.getStartPosition()),r=u.getValueInRange(g,1),d=u.getEOL()===`\r
`?new c(r):null,m=[];let p=0,I;for(v.reset(0);I=v.next(r);)if(m[p++]=P(this._getMultilineMatchRange(u,i,r,d,I.index,I[0]),I,t),p>=s)return m;return m}static _doFindMatchesLineByLine(u,g,v,t,s){const i=[];let r=0;if(g.startLineNumber===g.endLineNumber){const m=u.getLineContent(g.startLineNumber).substring(g.startColumn-1,g.endColumn-1);return r=this._findMatchesInLine(v,m,g.startLineNumber,g.startColumn-1,r,i,t,s),i}const d=u.getLineContent(g.startLineNumber).substring(g.startColumn-1);r=this._findMatchesInLine(v,d,g.startLineNumber,g.startColumn-1,r,i,t,s);for(let m=g.startLineNumber+1;m<g.endLineNumber&&r<s;m++)r=this._findMatchesInLine(v,u.getLineContent(m),m,0,r,i,t,s);if(r<s){const m=u.getLineContent(g.endLineNumber).substring(0,g.endColumn-1);r=this._findMatchesInLine(v,m,g.endLineNumber,0,r,i,t,s)}return i}static _findMatchesInLine(u,g,v,t,s,i,r,d){const m=u.wordSeparators;if(!r&&u.simpleSearch){const A=u.simpleSearch,a=A.length,T=g.length;let M=-a;for(;(M=g.indexOf(A,M+a))!==-1;)if((!m||w(m,g,T,M,a))&&(i[s++]=new k.FindMatch(new y.Range(v,M+1+t,v,M+1+a+t),null),s>=d))return s;return s}const p=new b(u.wordSeparators,u.regex);let I;p.reset(0);do if(I=p.next(g),I&&(i[s++]=P(new y.Range(v,I.index+1+t,v,I.index+1+I[0].length+t),I,r),s>=d))return s;while(I);return s}static findNextMatch(u,g,v,t){const s=g.parseSearchRequest();if(!s)return null;const i=new b(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(u,v,i,t):this._doFindNextMatchLineByLine(u,v,i,t)}static _doFindNextMatchMultiline(u,g,v,t){const s=new D.Position(g.lineNumber,1),i=u.getOffsetAt(s),r=u.getLineCount(),d=u.getValueInRange(new y.Range(s.lineNumber,s.column,r,u.getLineMaxColumn(r)),1),m=u.getEOL()===`\r
`?new c(d):null;v.reset(g.column-1);let p=v.next(d);return p?P(this._getMultilineMatchRange(u,i,d,m,p.index,p[0]),p,t):g.lineNumber!==1||g.column!==1?this._doFindNextMatchMultiline(u,new D.Position(1,1),v,t):null}static _doFindNextMatchLineByLine(u,g,v,t){const s=u.getLineCount(),i=g.lineNumber,r=u.getLineContent(i),d=this._findFirstMatchInLine(v,r,i,g.column,t);if(d)return d;for(let m=1;m<=s;m++){const p=(i+m-1)%s,I=u.getLineContent(p+1),A=this._findFirstMatchInLine(v,I,p+1,1,t);if(A)return A}return null}static _findFirstMatchInLine(u,g,v,t,s){u.reset(t-1);const i=u.next(g);return i?P(new y.Range(v,i.index+1,v,i.index+1+i[0].length),i,s):null}static findPreviousMatch(u,g,v,t){const s=g.parseSearchRequest();if(!s)return null;const i=new b(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(u,v,i,t):this._doFindPreviousMatchLineByLine(u,v,i,t)}static _doFindPreviousMatchMultiline(u,g,v,t){const s=this._doFindMatchesMultiline(u,new y.Range(1,1,g.lineNumber,g.column),v,t,10*S);if(s.length>0)return s[s.length-1];const i=u.getLineCount();return g.lineNumber!==i||g.column!==u.getLineMaxColumn(i)?this._doFindPreviousMatchMultiline(u,new D.Position(i,u.getLineMaxColumn(i)),v,t):null}static _doFindPreviousMatchLineByLine(u,g,v,t){const s=u.getLineCount(),i=g.lineNumber,r=u.getLineContent(i).substring(0,g.column-1),d=this._findLastMatchInLine(v,r,i,t);if(d)return d;for(let m=1;m<=s;m++){const p=(s+i-m-1)%s,I=u.getLineContent(p+1),A=this._findLastMatchInLine(v,I,p+1,t);if(A)return A}return null}static _findLastMatchInLine(u,g,v,t){let s=null,i;for(u.reset(0);i=u.next(g);)s=P(new y.Range(v,i.index+1,v,i.index+1+i[0].length),i,t);return s}}e.TextModelSearch=f;function l(E,u,g,v,t){if(v===0)return!0;const s=u.charCodeAt(v-1);if(E.get(s)!==0||s===13||s===10)return!0;if(t>0){const i=u.charCodeAt(v);if(E.get(i)!==0)return!0}return!1}function o(E,u,g,v,t){if(v+t===g)return!0;const s=u.charCodeAt(v+t);if(E.get(s)!==0||s===13||s===10)return!0;if(t>0){const i=u.charCodeAt(v+t-1);if(E.get(i)!==0)return!0}return!1}function w(E,u,g,v,t){return l(E,u,g,v,t)&&o(E,u,g,v,t)}e.isValidMatch=w;class b{constructor(u,g){this._wordSeparators=u,this._searchRegex=g,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const g=u.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===g||(v=this._searchRegex.exec(u),!v))return null;const t=v.index,s=v[0].length;if(t===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){h.getNextCodePoint(u,g,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=s,!this._wordSeparators||w(this._wordSeparators,u,g,t,s))return v}while(v);return null}}e.Searcher=b}),define(Ee[85],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function h(S=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)S.indexOf(C)>=0||(_+="\\"+C);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=h();function R(S){let _=e.DEFAULT_WORD_REGEXP;if(S&&S instanceof RegExp)if(S.global)_=S;else{let C="g";S.ignoreCase&&(C+="i"),S.multiline&&(C+="m"),S.unicode&&(C+="u"),_=new RegExp(S.source,C)}return _.lastIndex=0,_}e.ensureValidWordDefinition=R;const D={maxLen:1e3,windowSize:15,timeBudget:150};function y(S,_,C,n,P=D){if(C.length>P.maxLen){let w=S-P.maxLen/2;return w<0?w=0:n+=w,C=C.substring(w,S+P.maxLen/2),y(S,_,C,n,P)}const c=Date.now(),f=S-1-n;let l=-1,o=null;for(let w=1;!(Date.now()-c>=P.timeBudget);w++){const b=f-P.windowSize*w;_.lastIndex=Math.max(0,b);const E=k(_,C,f,l);if(!E&&o||(o=E,b<=0))break;l=b}if(o){let w={word:o[0],startColumn:n+1+o.index,endColumn:n+1+o.index+o[0].length};return _.lastIndex=0,w}return null}e.getWordAtText=y;function k(S,_,C,n){let P;for(;P=S.exec(_);){const c=P.index||0;if(c<=C&&S.lastIndex>=C)return P;if(n>0&&c>n)return null}return null}}),define(Ee[118],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var h;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(h=e.IndentAction||(e.IndentAction={}));class R{constructor(S){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=S.open,this.close=S.close,this._standardTokenMask=0,Array.isArray(S.notIn))for(let _=0,C=S.notIn.length;_<C;_++)switch(S.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(S){return(this._standardTokenMask&S)==0}}e.StandardAutoClosingPairConditional=R;class D{constructor(S){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of S)y(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),y(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),y(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),y(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&y(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=D;function y(k,S,_){k.has(S)?k.get(S).push(_):k.set(S,[_])}}),define(Ee[55],_e([0,1,27,14]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(y,k,S,_){if(Array.isArray(y)){let C=0;for(const n of y){const P=D(n,k,S,_);if(P===10)return P;P>C&&(C=P)}return C}else{if(typeof y=="string")return _?y==="*"?5:y===S?10:0:0;if(y){const{language:C,pattern:n,scheme:P,hasAccessToAllModels:c}=y;if(!_&&!c)return 0;let f=0;if(P)if(P===k.scheme)f=10;else if(P==="*")f=5;else return 0;if(C)if(C===S)f=10;else if(C==="*")f=Math.max(f,5);else return 0;if(n){let l;if(typeof n=="string"?l=n:l={...n,base:(0,R.normalize)(n.base)},l===k.fsPath||(0,h.match)(l,k.fsPath))f=10;else return 0}return f}else return 0}}e.score=D}),define(Ee[119],_e([0,1,83]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class D{constructor(l,o,w){const b=new Uint8Array(l*o);for(let E=0,u=l*o;E<u;E++)b[E]=w;this._data=b,this.rows=l,this.cols=o}get(l,o){return this._data[l*this.cols+o]}set(l,o,w){this._data[l*this.cols+o]=w}}e.Uint8Matrix=D;class y{constructor(l){let o=0,w=0;for(let E=0,u=l.length;E<u;E++){let[g,v,t]=l[E];v>o&&(o=v),g>w&&(w=g),t>w&&(w=t)}o++,w++;let b=new D(w,o,0);for(let E=0,u=l.length;E<u;E++){let[g,v,t]=l[E];b.set(g,v,t)}this._states=b,this._maxCharCode=o}nextState(l,o){return o<0||o>=this._maxCharCode?0:this._states.get(l,o)}}e.StateMachine=y;let k=null;function S(){return k===null&&(k=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),k}var _;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let C=null;function n(){if(C===null){C=new h.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let o=0;o<f.length;o++)C.set(f.charCodeAt(o),1);const l=".,;";for(let o=0;o<l.length;o++)C.set(l.charCodeAt(o),2)}return C}class P{static _createLink(l,o,w,b,E){let u=E-1;do{const g=o.charCodeAt(u);if(l.get(g)!==2)break;u--}while(u>b);if(b>0){const g=o.charCodeAt(b-1),v=o.charCodeAt(u);(g===40&&v===41||g===91&&v===93||g===123&&v===125)&&u--}return{range:{startLineNumber:w,startColumn:b+1,endLineNumber:w,endColumn:u+2},url:o.substring(b,u+1)}}static computeLinks(l,o=S()){const w=n();let b=[];for(let E=1,u=l.getLineCount();E<=u;E++){const g=l.getLineContent(E),v=g.length;let t=0,s=0,i=0,r=1,d=!1,m=!1,p=!1,I=!1;for(;t<v;){let A=!1;const a=g.charCodeAt(t);if(r===13){let T;switch(a){case 40:d=!0,T=0;break;case 41:T=d?0:1;break;case 91:p=!0,m=!0,T=0;break;case 93:p=!1,T=m?0:1;break;case 123:I=!0,T=0;break;case 125:T=I?0:1;break;case 39:T=i===34||i===96?0:1;break;case 34:T=i===39||i===96?0:1;break;case 96:T=i===39||i===34?0:1;break;case 42:T=i===42?1:0;break;case 124:T=i===124?1:0;break;case 32:T=p?0:1;break;default:T=w.get(a)}T===1&&(b.push(P._createLink(w,g,E,s,t)),A=!0)}else if(r===12){let T;a===91?(m=!0,T=0):T=w.get(a),T===1?A=!0:r=13}else r=o.nextState(r,a),r===0&&(A=!0);A&&(r=1,d=!1,m=!1,I=!1,s=t+1,i=a),t++}r===13&&b.push(P._createLink(w,g,E,s,v))}return b}}e.LinkComputer=P;function c(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:P.computeLinks(f)}e.computeLinks=c}),define(Ee[120],_e([0,1,3,7]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new h.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,S){return this._map.set(k,S),this.fire([k]),(0,R.toDisposable)(()=>{this._map.get(k)===S&&(this._map.delete(k),this.fire([k]))})}registerPromise(k,S){let _=null,C=!1;return this._promises.set(k,S.then(n=>{this._promises.delete(k),!(C||!n)&&(_=this.register(k,n))})),(0,R.toDisposable)(()=>{C=!0,_&&_.dispose()})}getPromise(k){const S=this.get(k);if(S)return Promise.resolve(S);const _=this._promises.get(k);return _?_.then(C=>this.get(k)):null}get(k){return this._map.get(k)||null}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(Ee[86],_e([0,1,23,21]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(D||(D={}));function y(P){for(let c=0,f=P.length;c<f;c+=4){const l=P[c+0],o=P[c+1],w=P[c+2],b=P[c+3];P[c+0]=b,P[c+1]=w,P[c+2]=o,P[c+3]=l}}function k(P){const c=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return R.isLittleEndian()||y(c),h.VSBuffer.wrap(c)}function S(P){const c=P.buffer;if(R.isLittleEndian()||y(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const f=new Uint8Array(c.byteLength);return f.set(c),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function _(P){const c=new Uint32Array(C(P));let f=0;if(c[f++]=P.id,P.type==="full")c[f++]=1,c[f++]=P.data.length,c.set(P.data,f),f+=P.data.length;else{c[f++]=2,c[f++]=P.deltas.length;for(const l of P.deltas)c[f++]=l.start,c[f++]=l.deleteCount,l.data?(c[f++]=l.data.length,c.set(l.data,f),f+=l.data.length):c[f++]=0}return k(c)}e.encodeSemanticTokensDto=_;function C(P){let c=0;if(c+=1+1,P.type==="full")c+=1+P.data.length;else{c+=1,c+=(1+1+1)*P.deltas.length;for(const f of P.deltas)f.data&&(c+=f.data.length)}return c}function n(P){const c=S(P);let f=0;const l=c[f++];if(c[f++]===1){const E=c[f++],u=c.subarray(f,f+E);return f+=E,{id:l,type:"full",data:u}}const w=c[f++];let b=[];for(let E=0;E<w;E++){const u=c[f++],g=c[f++],v=c[f++];let t;v>0&&(t=c.subarray(f,f+v),f+=v),b[E]={start:u,deleteCount:g,data:t}}return{id:l,type:"delta",deltas:b}}e.decodeSemanticTokensDto=n}),define(Ee[87],_e([0,1,79]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(k,S){this._prefixSumIndexOfResultBrand=void 0,this.index=k,this.remainder=S}}e.PrefixSumIndexOfResult=R;class D{constructor(k){this.values=k,this.prefixSum=new Uint32Array(k.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(k,S){k=(0,h.toUint32)(k);const _=this.values,C=this.prefixSum,n=S.length;return n===0?!1:(this.values=new Uint32Array(_.length+n),this.values.set(_.subarray(0,k),0),this.values.set(_.subarray(k),k+n),this.values.set(S,k),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(k,S){return k=(0,h.toUint32)(k),S=(0,h.toUint32)(S),this.values[k]===S?!1:(this.values[k]=S,k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),!0)}removeValues(k,S){k=(0,h.toUint32)(k),S=(0,h.toUint32)(S);const _=this.values,C=this.prefixSum;if(k>=_.length)return!1;let n=_.length-k;return S>=n&&(S=n),S===0?!1:(this.values=new Uint32Array(_.length-S),this.values.set(_.subarray(0,k),0),this.values.set(_.subarray(k+S),k),this.prefixSum=new Uint32Array(this.values.length),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(k){return k<0?0:(k=(0,h.toUint32)(k),this._getPrefixSum(k))}_getPrefixSum(k){if(k<=this.prefixSumValidIndex[0])return this.prefixSum[k];let S=this.prefixSumValidIndex[0]+1;S===0&&(this.prefixSum[0]=this.values[0],S++),k>=this.values.length&&(k=this.values.length-1);for(let _=S;_<=k;_++)this.prefixSum[_]=this.prefixSum[_-1]+this.values[_];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],k),this.prefixSum[k]}getIndexOf(k){k=Math.floor(k),this.getTotalSum();let S=0,_=this.values.length-1,C=0,n=0,P=0;for(;S<=_;)if(C=S+(_-S)/2|0,n=this.prefixSum[C],P=n-this.values[C],k<P)_=C-1;else if(k>=n)S=C+1;else break;return new R(C,k-P)}}e.PrefixSumComputer=D}),define(Ee[121],_e([0,1,8,36,87]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(S,_,C,n){this._uri=S,this._lines=_,this._eol=C,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(S){S.eol&&S.eol!==this._eol&&(this._eol=S.eol,this._lineStarts=null);const _=S.changes;for(const C of _)this._acceptDeleteRange(C.range),this._acceptInsertText(new R.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=S.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const S=this._eol.length,_=this._lines.length,C=new Uint32Array(_);for(let n=0;n<_;n++)C[n]=this._lines[n].length+S;this._lineStarts=new D.PrefixSumComputer(C)}}_setLineText(S,_){this._lines[S]=_,this._lineStarts&&this._lineStarts.changeValue(S,this._lines[S].length+this._eol.length)}_acceptDeleteRange(S){if(S.startLineNumber===S.endLineNumber){if(S.startColumn===S.endColumn)return;this._setLineText(S.startLineNumber-1,this._lines[S.startLineNumber-1].substring(0,S.startColumn-1)+this._lines[S.startLineNumber-1].substring(S.endColumn-1));return}this._setLineText(S.startLineNumber-1,this._lines[S.startLineNumber-1].substring(0,S.startColumn-1)+this._lines[S.endLineNumber-1].substring(S.endColumn-1)),this._lines.splice(S.startLineNumber,S.endLineNumber-S.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(S.startLineNumber,S.endLineNumber-S.startLineNumber)}_acceptInsertText(S,_){if(_.length===0)return;let C=(0,h.splitLines)(_);if(C.length===1){this._setLineText(S.lineNumber-1,this._lines[S.lineNumber-1].substring(0,S.column-1)+C[0]+this._lines[S.lineNumber-1].substring(S.column-1));return}C[C.length-1]+=this._lines[S.lineNumber-1].substring(S.column-1),this._setLineText(S.lineNumber-1,this._lines[S.lineNumber-1].substring(0,S.column-1)+C[0]);let n=new Uint32Array(C.length-1);for(let P=1;P<C.length;P++)this._lines.splice(S.lineNumber+P-1,0,C[P]),n[P-1]=C[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(S.lineNumber,n)}}e.MirrorTextModel=y}),define(Ee[122],_e([19,20]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Ee[56],_e([0,1,122,10,17]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(C,n){return n&&(C.stack||C.stacktrace)?h.localize(0,null,S(C),k(C.stack)||k(C.stacktrace)):S(C)}function k(C){return Array.isArray(C)?C.join(`
`):C}function S(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?h.localize(1,null,C.message):C.message||h.localize(2,null)}function _(C=null,n=!1){if(!C)return h.localize(3,null);if(Array.isArray(C)){const P=D.coalesce(C),c=_(P[0],n);return P.length>1?h.localize(4,null,c,P.length):c}if(R.isString(C))return C;if(C.detail){const P=C.detail;if(P.error)return y(P.error,n);if(P.exception)return y(P.exception,n)}return C.stack?y(C,n):C.message?C.message:h.localize(5,null)}e.toErrorMessage=_}),define(Ee[123],_e([19,20]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Ee[124],_e([0,1,123,21,85]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=k;class S{constructor(){this._values=[]}_read(Q){return this._values[Q]}get(Q){return this._values[Q]}_write(Q,fe){this._values[Q]=fe}}e.ValidatedEditorOptions=S;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class C{constructor(Q,fe,Le,Ue){this.id=Q,this.name=fe,this.defaultValue=Le,this.schema=Ue}compute(Q,fe,Le){return Le}}class n{constructor(Q,fe=null){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0,this.deps=fe}validate(Q){return this.defaultValue}}class P{constructor(Q,fe,Le,Ue){this.id=Q,this.name=fe,this.defaultValue=Le,this.schema=Ue}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,fe,Le){return Le}}function c(z,Q){return typeof z=="undefined"?Q:z==="false"?!1:Boolean(z)}e.boolean=c;class f extends P{constructor(Q,fe,Le,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="boolean",Ue.default=Le),super(Q,fe,Le,Ue)}validate(Q){return c(Q,this.defaultValue)}}class l extends P{constructor(Q,fe,Le,Ue,Ze,Ce=void 0){typeof Ce!="undefined"&&(Ce.type="integer",Ce.default=Le,Ce.minimum=Ue,Ce.maximum=Ze),super(Q,fe,Le,Ce),this.minimum=Ue,this.maximum=Ze}static clampedInt(Q,fe,Le,Ue){if(typeof Q=="undefined")return fe;let Ze=parseInt(Q,10);return isNaN(Ze)?fe:(Ze=Math.max(Le,Ze),Ze=Math.min(Ue,Ze),Ze|0)}validate(Q){return l.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class o extends P{constructor(Q,fe,Le,Ue,Ze){typeof Ze!="undefined"&&(Ze.type="number",Ze.default=Le),super(Q,fe,Le,Ze),this.validationFn=Ue}static clamp(Q,fe,Le){return Q<fe?fe:Q>Le?Le:Q}static float(Q,fe){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return fe;const Le=parseFloat(Q);return isNaN(Le)?fe:Le}validate(Q){return this.validationFn(o.float(Q,this.defaultValue))}}class w extends P{static string(Q,fe){return typeof Q!="string"?fe:Q}constructor(Q,fe,Le,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="string",Ue.default=Le),super(Q,fe,Le,Ue)}validate(Q){return w.string(Q,this.defaultValue)}}function b(z,Q,fe){return typeof z!="string"||fe.indexOf(z)===-1?Q:z}e.stringSet=b;class E extends P{constructor(Q,fe,Le,Ue,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="string",Ze.enum=Ue,Ze.default=Le),super(Q,fe,Le,Ze),this._allowedValues=Ue}validate(Q){return b(Q,this.defaultValue,this._allowedValues)}}class u extends C{constructor(Q,fe,Le,Ue,Ze,Ce,Se=void 0){typeof Se!="undefined"&&(Se.type="string",Se.enum=Ze,Se.default=Ue),super(Q,fe,Le,Se),this._allowedValues=Ze,this._convert=Ce}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function g(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class v extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",description:h.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,fe,Le){return Le===0?Q.accessibilitySupport:Le}}class t extends C{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:h.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{insertSpace:c(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function d(z){switch(z){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function m(z){switch(z){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class p extends n{constructor(){super(125,[63,31])}compute(Q,fe,Le){const Ue=["monaco-editor"];return fe.get(31)&&Ue.push(fe.get(31)),Q.extraEditorClassName&&Ue.push(Q.extraEditorClassName),fe.get(63)==="default"?Ue.push("mouse-default"):fe.get(63)==="copy"&&Ue.push("mouse-copy"),fe.get(98)&&Ue.push("showUnused"),fe.get(123)&&Ue.push("showDeprecated"),Ue.join(" ")}}class I extends f{constructor(){super(30,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(Q,fe,Le){return Le&&Q.emptySelectionClipboard}}class A extends C{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:Q.seedSearchStringFromSelection,description:h.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[h.localize(9,null),h.localize(10,null),h.localize(11,null)],description:h.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:h.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:h.localize(14,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:h.localize(15,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{cursorMoveOnType:c(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:c(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":b(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(fe.loop,this.defaultValue.loop)}}}class a extends C{constructor(){super(41,"fontLigatures",a.OFF,{anyOf:[{type:"boolean",description:h.localize(16,null)},{type:"string",description:h.localize(17,null)}],description:h.localize(18,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?a.OFF:Q==="true"?a.ON:Q:Boolean(Q)?a.ON:a.OFF}}e.EditorFontLigatures=a,a.OFF='"liga" off, "calt" off',a.ON='"liga" on, "calt" on';class T extends n{constructor(){super(40)}compute(Q,fe,Le){return Q.fontInfo}}class M extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(19,null)})}validate(Q){let fe=o.float(Q,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(fe,6,100)}compute(Q,fe,Le){return Q.fontInfo.fontSize}}class W extends C{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:h.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(21,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(l.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class B extends C{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[h.localize(22,null),h.localize(23,null),h.localize(24,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(25,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(26,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(27,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:h.localize(28,null),...fe},"editor.gotoLocation.multipleImplementations":{description:h.localize(29,null),...fe},"editor.gotoLocation.multipleReferences":{description:h.localize(30,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Le,description:h.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Le,description:h.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Le,description:h.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Le,description:h.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Le,description:h.localize(35,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{multiple:b(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??b(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??b(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??b(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??b(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??b(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends C{constructor(){const Q={enabled:!0,delay:300,sticky:!0};super(50,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:h.localize(36,null)},"editor.hover.delay":{type:"number",default:Q.delay,description:h.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:h.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:c(fe.enabled,this.defaultValue.enabled),delay:l.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:c(fe.sticky,this.defaultValue.sticky)}}}var q;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(q=e.RenderMinimap||(e.RenderMinimap={}));class $ extends n{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(Q,fe,Le){return $.computeLayout(fe,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const fe=Q.height/Q.lineHeight,Le=Q.scrollBeyondLastLine?fe-1:0,Ue=(Q.viewLineCount+Le)/(Q.pixelRatio*Q.height),Ze=Math.floor(Q.viewLineCount/Ue);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:Le,desiredRatio:Ue,minimapLineCount:Ze}}static _computeMinimapLayout(Q,fe){const Le=Q.outerWidth,Ue=Q.outerHeight,Ze=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Ue),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ue};const Ce=fe.stableMinimapLayoutInput,Se=Ce&&Q.outerHeight===Ce.outerHeight&&Q.lineHeight===Ce.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ce.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ce.pixelRatio&&Q.scrollBeyondLastLine===Ce.scrollBeyondLastLine&&Q.minimap.enabled===Ce.minimap.enabled&&Q.minimap.side===Ce.minimap.side&&Q.minimap.size===Ce.minimap.size&&Q.minimap.showSlider===Ce.minimap.showSlider&&Q.minimap.renderCharacters===Ce.minimap.renderCharacters&&Q.minimap.maxColumn===Ce.minimap.maxColumn&&Q.minimap.scale===Ce.minimap.scale&&Q.verticalScrollbarWidth===Ce.verticalScrollbarWidth&&Q.isViewportWrapping===Ce.isViewportWrapping,Pe=Q.lineHeight,ie=Q.typicalHalfwidthCharacterWidth,ae=Q.scrollBeyondLastLine,de=Q.minimap.renderCharacters;let me=Ze>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const x=Q.minimap.maxColumn,he=Q.minimap.size,be=Q.minimap.side,Ae=Q.verticalScrollbarWidth,Fe=Q.viewLineCount,We=Q.remainingWidth,et=Q.isViewportWrapping,Qe=de?2:3;let Ye=Math.floor(Ze*Ue);const lt=Ye/Ze;let ct=!1,ve=!1,we=Qe*me,oe=me/Ze,j=1;if(he==="fill"||he==="fit"){const{typicalViewportLineCount:wt,extraLinesBeyondLastLine:bt,desiredRatio:Ct,minimapLineCount:St}=$.computeContainedMinimapLineCount({viewLineCount:Fe,scrollBeyondLastLine:ae,height:Ue,lineHeight:Pe,pixelRatio:Ze});if(Fe/St>1)ct=!0,ve=!0,me=1,we=1,oe=me/Ze;else{let gt=!1,dt=me+1;if(he==="fit"){const pt=Math.ceil((Fe+bt)*we);et&&Se&&We<=fe.stableFitRemainingWidth?(gt=!0,dt=fe.stableFitMaxMinimapScale):gt=pt>Ye}if(he==="fill"||gt){ct=!0;const pt=me;we=Math.min(Pe*Ze,Math.max(1,Math.floor(1/Ct))),et&&Se&&We<=fe.stableFitRemainingWidth&&(dt=fe.stableFitMaxMinimapScale),me=Math.min(dt,Math.max(1,Math.floor(we/Qe))),me>pt&&(j=Math.min(2,me/pt)),oe=me/Ze/j,Ye=Math.ceil(Math.max(wt,Fe+bt)*we),et?(fe.stableMinimapLayoutInput=Q,fe.stableFitRemainingWidth=We,fe.stableFitMaxMinimapScale=me):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const Oe=Math.floor(x*oe),ye=Math.min(Oe,Math.max(0,Math.floor((We-Ae-2)*oe/(ie+oe)))+e.MINIMAP_GUTTER_WIDTH);let Xe=Math.floor(Ze*ye);const Je=Xe/Ze;Xe=Math.floor(Xe*j);const rt=de?1:2,mt=be==="left"?0:Le-ye-Ae;return{renderMinimap:rt,minimapLeft:mt,minimapWidth:ye,minimapHeightIsEditorHeight:ct,minimapIsSampling:ve,minimapScale:me,minimapLineHeight:we,minimapCanvasInnerWidth:Xe,minimapCanvasInnerHeight:Ye,minimapCanvasOuterWidth:Je,minimapCanvasOuterHeight:lt}}static computeLayout(Q,fe){const Le=fe.outerWidth|0,Ue=fe.outerHeight|0,Ze=fe.lineHeight|0,Ce=fe.lineNumbersDigitCount|0,Se=fe.typicalHalfwidthCharacterWidth,Pe=fe.maxDigitWidth,ie=fe.pixelRatio,ae=fe.viewLineCount,de=Q.get(120),me=de==="inherit"?Q.get(119):de,x=me==="inherit"?Q.get(115):me,he=Q.get(118),be=Q.get(2),Ae=fe.isDominatedByLongLines,Fe=Q.get(46),We=Q.get(57).renderType!==0,et=Q.get(58),Qe=Q.get(92),Ye=Q.get(62),lt=Q.get(90),ct=lt.verticalScrollbarSize,ve=lt.verticalHasArrows,we=lt.arrowSize,oe=lt.horizontalScrollbarSize,j=Q.get(55),Oe=Q.get(35);let ye;if(typeof j=="string"&&/^\d+(\.\d+)?ch$/.test(j)){const kt=parseFloat(j.substr(0,j.length-2));ye=l.clampedInt(kt*Se,0,0,1e3)}else ye=l.clampedInt(j,0,0,1e3);Oe&&(ye+=16);let Xe=0;if(We){const kt=Math.max(Ce,et);Xe=Math.round(kt*Pe)}let Je=0;Fe&&(Je=Ze);let rt=0,mt=rt+Je,wt=mt+Xe,bt=wt+ye;const Ct=Le-Je-Xe-ye;let St=!1,Tt=!1,gt=-1;be!==2&&(me==="inherit"&&Ae?(St=!0,Tt=!0):x==="on"||x==="bounded"?Tt=!0:x==="wordWrapColumn"&&(gt=he));const dt=$._computeMinimapLayout({outerWidth:Le,outerHeight:Ue,lineHeight:Ze,typicalHalfwidthCharacterWidth:Se,pixelRatio:ie,scrollBeyondLastLine:Qe,minimap:Ye,verticalScrollbarWidth:ct,viewLineCount:ae,remainingWidth:Ct,isViewportWrapping:Tt},fe.memory||new _);dt.renderMinimap!==0&&dt.minimapLeft===0&&(rt+=dt.minimapWidth,mt+=dt.minimapWidth,wt+=dt.minimapWidth,bt+=dt.minimapWidth);const pt=Ct-dt.minimapWidth,Et=Math.max(1,Math.floor((pt-ct-2)/Se)),At=ve?we:0;return Tt&&(gt=Math.max(1,Et),x==="bounded"&&(gt=Math.min(gt,he))),{width:Le,height:Ue,glyphMarginLeft:rt,glyphMarginWidth:Je,lineNumbersLeft:mt,lineNumbersWidth:Xe,decorationsLeft:wt,decorationsWidth:ye,contentLeft:bt,contentWidth:pt,minimap:dt,viewportColumn:Et,isWordWrapMinified:St,isViewportWrapping:Tt,wrappingColumn:gt,verticalScrollbarWidth:ct,horizontalScrollbarHeight:oe,overviewRuler:{top:At,width:ct,height:Ue-2*At,right:0}}}}e.EditorLayoutInfoComputer=$;class V extends C{constructor(){const Q={enabled:!0};super(54,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:h.localize(39,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:c(Q.enabled,this.defaultValue.enabled)}}}class F extends C{constructor(){const Q={enabled:!0,fontSize:0,fontFamily:""};super(124,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"boolean",default:Q.enabled,description:h.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:h.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,description:h.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:c(fe.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(fe.fontFamily,this.defaultValue.fontFamily)}}}class re extends o{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>o.clamp(Q,0,150),{markdownDescription:h.localize(43,null)})}compute(Q,fe,Le){return Q.fontInfo.lineHeight}}class N extends C{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:h.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(45,null),h.localize(46,null),h.localize(47,null)],default:Q.size,description:h.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:h.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:h.localize(50,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:h.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:h.localize(53,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:c(fe.enabled,this.defaultValue.enabled),size:b(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(fe.side,this.defaultValue.side,["right","left"]),showSlider:b(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(fe.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(fe.scale,1,1,3),maxColumn:l.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function H(z){return z==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class J extends C{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(55,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{top:l.clampedInt(fe.top,0,0,1e3),bottom:l.clampedInt(fe.bottom,0,0,1e3)}}}class K extends C{constructor(){const Q={enabled:!0,cycle:!1};super(73,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:h.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:h.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:c(fe.enabled,this.defaultValue.enabled),cycle:c(fe.cycle,this.defaultValue.cycle)}}}class le extends n{constructor(){super(126)}compute(Q,fe,Le){return Q.pixelRatio}}class Ie extends C{constructor(){const Q={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",Q,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Q.strings,description:h.localize(58,null)},comments:{type:"boolean",default:Q.comments,description:h.localize(59,null)},other:{type:"boolean",default:Q.other,description:h.localize(60,null)}}}],default:Q,description:h.localize(61,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean")return Q;if(Q&&typeof Q=="object"){const fe=Q,Le={other:c(fe.other,this.defaultValue.other),comments:c(fe.comments,this.defaultValue.comments),strings:c(fe.strings,this.defaultValue.strings)};return Le.other&&Le.comments&&Le.strings?!0:!Le.other&&!Le.comments&&!Le.strings?!1:Le}return this.defaultValue}}var Me;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(Me=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ve extends C{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(62,null),h.localize(63,null),h.localize(64,null),h.localize(65,null)],default:"on",description:h.localize(66,null)})}validate(Q){let fe=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(fe=4,Le=Q):Q==="interval"?fe=3:Q==="relative"?fe=2:Q==="on"?fe=1:fe=0),{renderType:fe,renderFn:Le}}}function xe(z){const Q=z.get(85);return Q==="editable"?z.get(78):Q!=="on"}e.filterValidationDecorations=xe;class Ge extends C{constructor(){const Q=[],fe={type:"number",description:h.localize(67,null)};super(89,"rulers",Q,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:h.localize(68,null),format:"color-hex"}}}]},default:Q,description:h.localize(69,null)})}validate(Q){if(Array.isArray(Q)){let fe=[];for(let Le of Q)if(typeof Le=="number")fe.push({column:l.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const Ue=Le;fe.push({column:l.clampedInt(Ue.column,0,0,1e4),color:Ue.color})}return fe.sort((Le,Ue)=>Le.column-Ue.column),fe}return this.defaultValue}}function Ke(z,Q){if(typeof z!="string")return Q;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class qe extends C{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(90,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(70,null),h.localize(71,null),h.localize(72,null)],default:"auto",description:h.localize(73,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(74,null),h.localize(75,null),h.localize(76,null)],default:"auto",description:h.localize(77,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:h.localize(78,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:h.localize(79,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:h.localize(80,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q,Le=l.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ue=l.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ke(fe.vertical,this.defaultValue.vertical),horizontal:Ke(fe.horizontal,this.defaultValue.horizontal),useShadows:c(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:l.clampedInt(fe.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:Ue,verticalSliderSize:l.clampedInt(fe.verticalSliderSize,Ue,0,1e3),scrollByPage:c(fe.scrollByPage,this.defaultValue.scrollByPage)}}}class U extends C{constructor(){const Q={enabled:!1,mode:"subwordSmart"};super(52,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:h.localize(81,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[h.localize(82,null),h.localize(83,null),h.localize(84,null)],default:Q.mode,description:h.localize(85,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{enabled:c(fe.enabled,this.defaultValue.enabled),mode:b(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class G extends C{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(86,null),h.localize(87,null)],default:Q.insertMode,description:h.localize(88,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:h.localize(89,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:h.localize(90,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:h.localize(91,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:h.localize(92,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:h.localize(93,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:h.localize(94,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:h.localize(95,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[h.localize(96,null),h.localize(97,null),h.localize(98,null)],default:Q.previewMode,description:h.localize(99,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:h.localize(100,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(101,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(102,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(103,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(104,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(105,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(106,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(107,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(108,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(109,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(110,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(111,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(112,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(113,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(114,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(115,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(116,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(117,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(118,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(119,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(120,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(121,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(122,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(123,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(124,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(125,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(126,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(127,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(128,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(129,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(130,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(131,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const fe=Q;return{insertMode:b(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(fe.showIcons,this.defaultValue.showIcons),showStatusBar:c(fe.showStatusBar,this.defaultValue.showStatusBar),preview:c(fe.preview,this.defaultValue.preview),previewMode:b(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(fe.showMethods,this.defaultValue.showMethods),showFunctions:c(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:c(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(fe.showDeprecated,this.defaultValue.showDeprecated),showFields:c(fe.showFields,this.defaultValue.showFields),showVariables:c(fe.showVariables,this.defaultValue.showVariables),showClasses:c(fe.showClasses,this.defaultValue.showClasses),showStructs:c(fe.showStructs,this.defaultValue.showStructs),showInterfaces:c(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:c(fe.showModules,this.defaultValue.showModules),showProperties:c(fe.showProperties,this.defaultValue.showProperties),showEvents:c(fe.showEvents,this.defaultValue.showEvents),showOperators:c(fe.showOperators,this.defaultValue.showOperators),showUnits:c(fe.showUnits,this.defaultValue.showUnits),showValues:c(fe.showValues,this.defaultValue.showValues),showConstants:c(fe.showConstants,this.defaultValue.showConstants),showEnums:c(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:c(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(fe.showKeywords,this.defaultValue.showKeywords),showWords:c(fe.showWords,this.defaultValue.showWords),showColors:c(fe.showColors,this.defaultValue.showColors),showFiles:c(fe.showFiles,this.defaultValue.showFiles),showReferences:c(fe.showReferences,this.defaultValue.showReferences),showFolders:c(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:c(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(fe.showSnippets,this.defaultValue.showSnippets),showUsers:c(fe.showUsers,this.defaultValue.showUsers),showIssues:c(fe.showIssues,this.defaultValue.showIssues)}}}class ne extends C{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(132,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class se extends n{constructor(){super(127,[78])}compute(Q,fe,Le){return fe.get(78)?!0:Q.tabFocusMode}}var ge;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(ge=e.WrappingIndent||(e.WrappingIndent={}));function X(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ce extends n{constructor(){super(129,[128])}compute(Q,fe,Le){const Ue=fe.get(128);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Ue.isWordWrapMinified,isViewportWrapping:Ue.isViewportWrapping,wrappingColumn:Ue.wrappingColumn}}}const ke="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Be:R.isLinux?$e:ke,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function pe(z){return e.editorOptionsRegistry[z.id]=z,z}var tt;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.autoClosingDelete=6]="autoClosingDelete",z[z.autoClosingOvertype=7]="autoClosingOvertype",z[z.autoClosingQuotes=8]="autoClosingQuotes",z[z.autoIndent=9]="autoIndent",z[z.automaticLayout=10]="automaticLayout",z[z.autoSurround=11]="autoSurround",z[z.codeLens=12]="codeLens",z[z.codeLensFontFamily=13]="codeLensFontFamily",z[z.codeLensFontSize=14]="codeLensFontSize",z[z.colorDecorators=15]="colorDecorators",z[z.columnSelection=16]="columnSelection",z[z.comments=17]="comments",z[z.contextmenu=18]="contextmenu",z[z.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",z[z.cursorBlinking=20]="cursorBlinking",z[z.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",z[z.cursorStyle=22]="cursorStyle",z[z.cursorSurroundingLines=23]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",z[z.cursorWidth=25]="cursorWidth",z[z.disableLayerHinting=26]="disableLayerHinting",z[z.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",z[z.domReadOnly=28]="domReadOnly",z[z.dragAndDrop=29]="dragAndDrop",z[z.emptySelectionClipboard=30]="emptySelectionClipboard",z[z.extraEditorClassName=31]="extraEditorClassName",z[z.fastScrollSensitivity=32]="fastScrollSensitivity",z[z.find=33]="find",z[z.fixedOverflowWidgets=34]="fixedOverflowWidgets",z[z.folding=35]="folding",z[z.foldingStrategy=36]="foldingStrategy",z[z.foldingHighlight=37]="foldingHighlight",z[z.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=39]="fontFamily",z[z.fontInfo=40]="fontInfo",z[z.fontLigatures=41]="fontLigatures",z[z.fontSize=42]="fontSize",z[z.fontWeight=43]="fontWeight",z[z.formatOnPaste=44]="formatOnPaste",z[z.formatOnType=45]="formatOnType",z[z.glyphMargin=46]="glyphMargin",z[z.gotoLocation=47]="gotoLocation",z[z.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",z[z.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",z[z.hover=50]="hover",z[z.inDiffEditor=51]="inDiffEditor",z[z.inlineSuggest=52]="inlineSuggest",z[z.letterSpacing=53]="letterSpacing",z[z.lightbulb=54]="lightbulb",z[z.lineDecorationsWidth=55]="lineDecorationsWidth",z[z.lineHeight=56]="lineHeight",z[z.lineNumbers=57]="lineNumbers",z[z.lineNumbersMinChars=58]="lineNumbersMinChars",z[z.linkedEditing=59]="linkedEditing",z[z.links=60]="links",z[z.matchBrackets=61]="matchBrackets",z[z.minimap=62]="minimap",z[z.mouseStyle=63]="mouseStyle",z[z.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=65]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",z[z.multiCursorModifier=67]="multiCursorModifier",z[z.multiCursorPaste=68]="multiCursorPaste",z[z.occurrencesHighlight=69]="occurrencesHighlight",z[z.overviewRulerBorder=70]="overviewRulerBorder",z[z.overviewRulerLanes=71]="overviewRulerLanes",z[z.padding=72]="padding",z[z.parameterHints=73]="parameterHints",z[z.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",z[z.quickSuggestions=76]="quickSuggestions",z[z.quickSuggestionsDelay=77]="quickSuggestionsDelay",z[z.readOnly=78]="readOnly",z[z.renameOnType=79]="renameOnType",z[z.renderControlCharacters=80]="renderControlCharacters",z[z.renderIndentGuides=81]="renderIndentGuides",z[z.renderFinalNewline=82]="renderFinalNewline",z[z.renderLineHighlight=83]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=85]="renderValidationDecorations",z[z.renderWhitespace=86]="renderWhitespace",z[z.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",z[z.roundedSelection=88]="roundedSelection",z[z.rulers=89]="rulers",z[z.scrollbar=90]="scrollbar",z[z.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=92]="scrollBeyondLastLine",z[z.scrollPredominantAxis=93]="scrollPredominantAxis",z[z.selectionClipboard=94]="selectionClipboard",z[z.selectionHighlight=95]="selectionHighlight",z[z.selectOnLineNumbers=96]="selectOnLineNumbers",z[z.showFoldingControls=97]="showFoldingControls",z[z.showUnused=98]="showUnused",z[z.snippetSuggestions=99]="snippetSuggestions",z[z.smartSelect=100]="smartSelect",z[z.smoothScrolling=101]="smoothScrolling",z[z.stickyTabStops=102]="stickyTabStops",z[z.stopRenderingLineAfter=103]="stopRenderingLineAfter",z[z.suggest=104]="suggest",z[z.suggestFontSize=105]="suggestFontSize",z[z.suggestLineHeight=106]="suggestLineHeight",z[z.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",z[z.suggestSelection=108]="suggestSelection",z[z.tabCompletion=109]="tabCompletion",z[z.tabIndex=110]="tabIndex",z[z.unusualLineTerminators=111]="unusualLineTerminators",z[z.useShadowDOM=112]="useShadowDOM",z[z.useTabStops=113]="useTabStops",z[z.wordSeparators=114]="wordSeparators",z[z.wordWrap=115]="wordWrap",z[z.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=118]="wordWrapColumn",z[z.wordWrapOverride1=119]="wordWrapOverride1",z[z.wordWrapOverride2=120]="wordWrapOverride2",z[z.wrappingIndent=121]="wrappingIndent",z[z.wrappingStrategy=122]="wrappingStrategy",z[z.showDeprecated=123]="showDeprecated",z[z.inlayHints=124]="inlayHints",z[z.editorClassName=125]="editorClassName",z[z.pixelRatio=126]="pixelRatio",z[z.tabFocusMode=127]="tabFocusMode",z[z.layoutInfo=128]="layoutInfo",z[z.wrappingInfo=129]="wrappingInfo"})(tt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:pe(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(133,null)})),acceptSuggestionOnEnter:pe(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(134,null),""],markdownDescription:h.localize(135,null)})),accessibilitySupport:pe(new v),accessibilityPageSize:pe(new l(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(136,null)})),ariaLabel:pe(new w(4,"ariaLabel",h.localize(137,null))),autoClosingBrackets:pe(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(138,null),h.localize(139,null),""],description:h.localize(140,null)})),autoClosingDelete:pe(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(141,null),""],description:h.localize(142,null)})),autoClosingOvertype:pe(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(143,null),""],description:h.localize(144,null)})),autoClosingQuotes:pe(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(145,null),h.localize(146,null),""],description:h.localize(147,null)})),autoIndent:pe(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],g,{enumDescriptions:[h.localize(148,null),h.localize(149,null),h.localize(150,null),h.localize(151,null),h.localize(152,null)],description:h.localize(153,null)})),automaticLayout:pe(new f(10,"automaticLayout",!1)),autoSurround:pe(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(154,null),h.localize(155,null),h.localize(156,null),""],description:h.localize(157,null)})),stickyTabStops:pe(new f(102,"stickyTabStops",!1,{description:h.localize(158,null)})),codeLens:pe(new f(12,"codeLens",!0,{description:h.localize(159,null)})),codeLensFontFamily:pe(new w(13,"codeLensFontFamily","",{description:h.localize(160,null)})),codeLensFontSize:pe(new l(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(161,null)})),colorDecorators:pe(new f(15,"colorDecorators",!0,{description:h.localize(162,null)})),columnSelection:pe(new f(16,"columnSelection",!1,{description:h.localize(163,null)})),comments:pe(new t),contextmenu:pe(new f(18,"contextmenu",!0)),copyWithSyntaxHighlighting:pe(new f(19,"copyWithSyntaxHighlighting",!0,{description:h.localize(164,null)})),cursorBlinking:pe(new u(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:h.localize(165,null)})),cursorSmoothCaretAnimation:pe(new f(21,"cursorSmoothCaretAnimation",!1,{description:h.localize(166,null)})),cursorStyle:pe(new u(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],m,{description:h.localize(167,null)})),cursorSurroundingLines:pe(new l(23,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(168,null)})),cursorSurroundingLinesStyle:pe(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(169,null),h.localize(170,null)],description:h.localize(171,null)})),cursorWidth:pe(new l(25,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(172,null)})),disableLayerHinting:pe(new f(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:pe(new f(27,"disableMonospaceOptimizations",!1)),domReadOnly:pe(new f(28,"domReadOnly",!1)),dragAndDrop:pe(new f(29,"dragAndDrop",!0,{description:h.localize(173,null)})),emptySelectionClipboard:pe(new I),extraEditorClassName:pe(new w(31,"extraEditorClassName","")),fastScrollSensitivity:pe(new o(32,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:h.localize(174,null)})),find:pe(new A),fixedOverflowWidgets:pe(new f(34,"fixedOverflowWidgets",!1)),folding:pe(new f(35,"folding",!0,{description:h.localize(175,null)})),foldingStrategy:pe(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(176,null),h.localize(177,null)],description:h.localize(178,null)})),foldingHighlight:pe(new f(37,"foldingHighlight",!0,{description:h.localize(179,null)})),unfoldOnClickAfterEndOfLine:pe(new f(38,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(180,null)})),fontFamily:pe(new w(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(181,null)})),fontInfo:pe(new T),fontLigatures2:pe(new a),fontSize:pe(new M),fontWeight:pe(new W),formatOnPaste:pe(new f(44,"formatOnPaste",!1,{description:h.localize(182,null)})),formatOnType:pe(new f(45,"formatOnType",!1,{description:h.localize(183,null)})),glyphMargin:pe(new f(46,"glyphMargin",!0,{description:h.localize(184,null)})),gotoLocation:pe(new B),hideCursorInOverviewRuler:pe(new f(48,"hideCursorInOverviewRuler",!1,{description:h.localize(185,null)})),highlightActiveIndentGuide:pe(new f(49,"highlightActiveIndentGuide",!0,{description:h.localize(186,null)})),hover:pe(new Z),inDiffEditor:pe(new f(51,"inDiffEditor",!1)),letterSpacing:pe(new o(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>o.clamp(z,-5,20),{description:h.localize(187,null)})),lightbulb:pe(new V),lineDecorationsWidth:pe(new P(55,"lineDecorationsWidth",10)),lineHeight:pe(new re),lineNumbers:pe(new Ve),lineNumbersMinChars:pe(new l(58,"lineNumbersMinChars",5,1,300)),linkedEditing:pe(new f(59,"linkedEditing",!1,{description:h.localize(188,null)})),links:pe(new f(60,"links",!0,{description:h.localize(189,null)})),matchBrackets:pe(new E(61,"matchBrackets","always",["always","near","never"],{description:h.localize(190,null)})),minimap:pe(new N),mouseStyle:pe(new E(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:pe(new o(64,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:h.localize(191,null)})),mouseWheelZoom:pe(new f(65,"mouseWheelZoom",!1,{markdownDescription:h.localize(192,null)})),multiCursorMergeOverlapping:pe(new f(66,"multiCursorMergeOverlapping",!0,{description:h.localize(193,null)})),multiCursorModifier:pe(new u(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],H,{markdownEnumDescriptions:[h.localize(194,null),h.localize(195,null)],markdownDescription:h.localize(196,null)})),multiCursorPaste:pe(new E(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(197,null),h.localize(198,null)],markdownDescription:h.localize(199,null)})),occurrencesHighlight:pe(new f(69,"occurrencesHighlight",!0,{description:h.localize(200,null)})),overviewRulerBorder:pe(new f(70,"overviewRulerBorder",!0,{description:h.localize(201,null)})),overviewRulerLanes:pe(new l(71,"overviewRulerLanes",3,0,3)),padding:pe(new J),parameterHints:pe(new K),peekWidgetDefaultFocus:pe(new E(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(202,null),h.localize(203,null)],description:h.localize(204,null)})),definitionLinkOpensInPeek:pe(new f(75,"definitionLinkOpensInPeek",!1,{description:h.localize(205,null)})),quickSuggestions:pe(new Ie),quickSuggestionsDelay:pe(new l(77,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(206,null)})),readOnly:pe(new f(78,"readOnly",!1)),renameOnType:pe(new f(79,"renameOnType",!1,{description:h.localize(207,null),markdownDeprecationMessage:h.localize(208,null)})),renderControlCharacters:pe(new f(80,"renderControlCharacters",!1,{description:h.localize(209,null)})),renderIndentGuides:pe(new f(81,"renderIndentGuides",!0,{description:h.localize(210,null)})),renderFinalNewline:pe(new f(82,"renderFinalNewline",!0,{description:h.localize(211,null)})),renderLineHighlight:pe(new E(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(212,null)],description:h.localize(213,null)})),renderLineHighlightOnlyWhenFocus:pe(new f(84,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(214,null)})),renderValidationDecorations:pe(new E(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:pe(new E(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(215,null),h.localize(216,null),h.localize(217,null),""],description:h.localize(218,null)})),revealHorizontalRightPadding:pe(new l(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:pe(new f(88,"roundedSelection",!0,{description:h.localize(219,null)})),rulers:pe(new Ge),scrollbar:pe(new qe),scrollBeyondLastColumn:pe(new l(91,"scrollBeyondLastColumn",5,0,1073741824,{description:h.localize(220,null)})),scrollBeyondLastLine:pe(new f(92,"scrollBeyondLastLine",!0,{description:h.localize(221,null)})),scrollPredominantAxis:pe(new f(93,"scrollPredominantAxis",!0,{description:h.localize(222,null)})),selectionClipboard:pe(new f(94,"selectionClipboard",!0,{description:h.localize(223,null),included:R.isLinux})),selectionHighlight:pe(new f(95,"selectionHighlight",!0,{description:h.localize(224,null)})),selectOnLineNumbers:pe(new f(96,"selectOnLineNumbers",!0)),showFoldingControls:pe(new E(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[h.localize(225,null),h.localize(226,null)],description:h.localize(227,null)})),showUnused:pe(new f(98,"showUnused",!0,{description:h.localize(228,null)})),showDeprecated:pe(new f(123,"showDeprecated",!0,{description:h.localize(229,null)})),inlayHints:pe(new F),snippetSuggestions:pe(new E(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(230,null),h.localize(231,null),h.localize(232,null),h.localize(233,null)],description:h.localize(234,null)})),smartSelect:pe(new ne),smoothScrolling:pe(new f(101,"smoothScrolling",!1,{description:h.localize(235,null)})),stopRenderingLineAfter:pe(new l(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:pe(new G),inlineSuggest:pe(new U),suggestFontSize:pe(new l(105,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(236,null)})),suggestLineHeight:pe(new l(106,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(237,null)})),suggestOnTriggerCharacters:pe(new f(107,"suggestOnTriggerCharacters",!0,{description:h.localize(238,null)})),suggestSelection:pe(new E(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(239,null),h.localize(240,null),h.localize(241,null)],description:h.localize(242,null)})),tabCompletion:pe(new E(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(243,null),h.localize(244,null),h.localize(245,null)],description:h.localize(246,null)})),tabIndex:pe(new l(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:pe(new E(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(247,null),h.localize(248,null),h.localize(249,null)],description:h.localize(250,null)})),useShadowDOM:pe(new f(112,"useShadowDOM",!0)),useTabStops:pe(new f(113,"useTabStops",!0,{description:h.localize(251,null)})),wordSeparators:pe(new w(114,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:h.localize(252,null)})),wordWrap:pe(new E(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(253,null),h.localize(254,null),h.localize(255,null),h.localize(256,null)],description:h.localize(257,null)})),wordWrapBreakAfterCharacters:pe(new w(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:pe(new w(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:pe(new l(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(258,null)})),wordWrapOverride1:pe(new E(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:pe(new E(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:pe(new u(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],X,{enumDescriptions:[h.localize(259,null),h.localize(260,null),h.localize(261,null),h.localize(262,null)],description:h.localize(263,null)})),wrappingStrategy:pe(new E(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[h.localize(264,null),h.localize(265,null)],description:h.localize(266,null)})),editorClassName:pe(new p),pixelRatio:pe(new le),tabFocusMode:pe(new se),layoutInfo:pe(new $),wrappingInfo:pe(new ce)}}),define(Ee[125],_e([19,20]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[126],_e([19,20]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[127],_e([19,20]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Ee[128],_e([19,20]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Ee[129],_e([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[130],_e([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[131],_e([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[132],_e([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[133],_e([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[134],_e([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[135],_e([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[136],_e([19,20]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Ee[137],_e([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[138],_e([19,20]),function(te,e){return te.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(Ee[139],_e([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ee[140],_e([19,20]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[141],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var h;(function(k){k[k.ACTIVATE=1]="ACTIVATE",k[k.RESTORE=2]="RESTORE",k[k.PRESERVE=3]="PRESERVE"})(h=e.EditorActivation||(e.EditorActivation={}));var R;(function(k){k[k.PICK=0]="PICK",k[k.DISABLED=1]="DISABLED",k[k.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(R=e.EditorResolution||(e.EditorResolution={}));var D;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var y;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(y=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(Ee[142],_e([0,1,126]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function y(c){return c=c.trim(),c==="*"||R.test(c)}e.isValidVersionStr=y;function k(c){if(!y(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=c.match(R);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=k;function S(c){if(!c)return null;let f=c.majorBase,l=c.majorMustEqual,o=c.minorBase,w=c.minorMustEqual,b=c.patchBase,E=c.patchMustEqual;c.hasCaret&&(f===0||(w=!1),E=!1);let u=0;if(c.preRelease){const g=D.exec(c.preRelease);if(g){const[,v,t,s]=g;u=Date.UTC(Number(v),Number(t)-1,Number(s))}}return{majorBase:f,majorMustEqual:l,minorBase:o,minorMustEqual:w,patchBase:b,patchMustEqual:E,isMinimum:c.hasGreaterEquals,notBefore:u}}e.normalizeVersion=S;function _(c,f,l){let o;typeof c=="string"?o=S(k(c)):o=c;let w;f instanceof Date?w=f.getTime():typeof f=="string"&&(w=new Date(f).getTime());let b;if(typeof l=="string"?b=S(k(l)):b=l,!o||!b)return!1;let E=o.majorBase,u=o.minorBase,g=o.patchBase,v=b.majorBase,t=b.minorBase,s=b.patchBase,i=b.notBefore,r=b.majorMustEqual,d=b.minorMustEqual,m=b.patchMustEqual;return b.isMinimum?E>v?!0:E<v?!1:u>t?!0:u<t||w&&w<i?!1:g>=s:(E===1&&v===0&&(!r||!d||!m)&&(v=1,t=0,s=0,r=!0,d=!1,m=!1),E<v?!1:E>v?!r:u<t?!1:u>t?!d:g<s?!1:g>s?!m:!(w&&w<i))}e.isValidVersion=_;function C(c,f,l,o){return l.isBuiltin||typeof l.main=="undefined"?!0:P(c,f,l.engines.vscode,o)}e.isValidExtensionVersion=C;function n(c,f,l){return c==="*"||P(f,l,c)}e.isEngineValid=n;function P(c,f,l,o=[]){let w=S(k(l));if(!w)return o.push(h.localize(0,null,l)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return o.push(h.localize(1,null,l)),!1}else if(!w.majorMustEqual)return o.push(h.localize(2,null,l)),!1;return _(c,f,w)?!0:(o.push(h.localize(3,null,c,l)),!1)}}),define(Ee[88],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class h{constructor(D,y=[],k=!1){this.ctor=D,this.staticArguments=y,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=h}),define(Ee[57],_e([0,1,88]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function D(k,S,_){S instanceof h.SyncDescriptor||(S=new h.SyncDescriptor(S,[],_)),R.push([k,S])}e.registerSingleton=D;function y(){return R}e.getSingletonServiceDescriptors=y}),define(Ee[143],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class h{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=h;class R{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let k of this._nodes.values())k.outgoing.size===0&&y.push(k);return y}insertEdge(y,k){const S=this.lookupOrInsertNode(y),_=this.lookupOrInsertNode(k);S.outgoing.set(this._hashFn(k),_),_.incoming.set(this._hashFn(y),S)}removeNode(y){const k=this._hashFn(y);this._nodes.delete(k);for(let S of this._nodes.values())S.outgoing.delete(k),S.incoming.delete(k)}lookupOrInsertNode(y){const k=this._hashFn(y);let S=this._nodes.get(k);return S||(S=new h(y),this._nodes.set(k,S)),S}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[k,S]of this._nodes)y.push(`${k}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,k]of this._nodes){const S=new Set([y]),_=this._findCycle(k,S);if(_)return _}}_findCycle(y,k){for(let[S,_]of y.outgoing){if(k.has(S))return[...k,S].join(" -> ");k.add(S);const C=this._findCycle(_,k);if(C)return C;k.delete(S)}}}e.Graph=R}),define(Ee[4],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var h;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function _(C){return C[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=_})(h=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function R(S,_,C,n){_[h.DI_TARGET]===_?_[h.DI_DEPENDENCIES].push({id:S,index:C,optional:n}):(_[h.DI_DEPENDENCIES]=[{id:S,index:C,optional:n}],_[h.DI_TARGET]=_)}function D(S){if(h.serviceIds.has(S))return h.serviceIds.get(S);const _=function(C,n,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(_,C,P,!1)};return _.toString=()=>S,h.serviceIds.set(S,_),_}e.createDecorator=D;function y(S){return S}e.refineServiceDecorator=y;function k(S){return function(_,C,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(S,_,n,!0)}}e.optional=k}),define(Ee[144],_e([0,1,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,h.createDecorator)("modelService");function R(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(Ee[145],_e([0,1,3,53,7,22,78,55,144]),function(te,e,h,R,D,y,k,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(c){return typeof c=="string"?!1:Array.isArray(c)?c.every(C):!!c.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new h.Emitter}get onDidChange(){return this._onDidChange.event}register(f,l){let o={selector:f,provider:l,_score:-1,_time:this._clock++};return this._entries.push(o),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,D.toDisposable)(()=>{if(o){let w=this._entries.indexOf(o);w>=0&&(this._entries.splice(w,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),o=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const l=[];for(let o of this._entries)o._score>0&&l.push(o.provider);return l}ordered(f){const l=[];return this._orderedForEach(f,o=>l.push(o.provider)),l}orderedGroups(f){const l=[];let o,w;return this._orderedForEach(f,b=>{o&&w===b._score?o.push(b.provider):(w=b._score,o=[b.provider],l.push(o))}),l}_orderedForEach(f,l){if(!!f){this._updateScores(f);for(const o of this._entries)o._score>0&&l(o)}}_updateScores(f){let l={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===l.language&&this._lastCandidate.uri===l.uri)){this._lastCandidate=l;for(let o of this._entries)if(o._score=(0,S.score)(o.selector,f.uri,f.getLanguageIdentifier().language,(0,_.shouldSynchronizeModel)(f)),C(o.selector)&&o._score>0){for(let w of this._entries)w._score=0;o._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(f,l){return f._score<l._score?1:f._score>l._score?-1:f._time<l._time?1:f._time>l._time?-1:0}}e.LanguageFeatureRegistry=n;class P{constructor(f,l,o=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=l,this.max=o,this._cache=new y.LRUCache(50,.7)}_key(f){return f.id+(0,R.hash)(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const l=this._key(f),o=this._cache.get(l);return this._clamp(o?.value)}update(f,l){const o=this._key(f);let w=this._cache.get(o);return w||(w=new k.MovingAverage,this._cache.set(o,w)),w.update(l),this.get(f)}}e.LanguageFeatureRequestDelays=P}),define(Ee[58],_e([0,1,2,30,145,120,52]),function(te,e,h,R,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var S;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(S=e.LanguageId||(e.LanguageId={}));class _{constructor(T,M){this.language=T,this.id=M}}e.LanguageIdentifier=_;var C;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var n;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var P;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var c;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(c=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(T){return(T&255)>>>0}static getTokenType(T){return(T&1792)>>>8}static getFontStyle(T){return(T&14336)>>>11}static getForeground(T){return(T&8372224)>>>14}static getBackground(T){return(T&4286578688)>>>23}static getClassNameFromMetadata(T){let M=this.getForeground(T),W="mtk"+M,B=this.getFontStyle(T);return B&1&&(W+=" mtki"),B&2&&(W+=" mtkb"),B&4&&(W+=" mtku"),W}static getInlineStyleFromMetadata(T,M){const W=this.getForeground(T),B=this.getFontStyle(T);let Z=`color: ${M[W]};`;return B&1&&(Z+="font-style: italic;"),B&2&&(Z+="font-weight: bold;"),B&4&&(Z+="text-decoration: underline;"),Z}}e.TokenMetadata=f;var l;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(l=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let a=Object.create(null);return a[0]="symbol-method",a[1]="symbol-function",a[2]="symbol-constructor",a[3]="symbol-field",a[4]="symbol-variable",a[5]="symbol-class",a[6]="symbol-struct",a[7]="symbol-interface",a[8]="symbol-module",a[9]="symbol-property",a[10]="symbol-event",a[11]="symbol-operator",a[12]="symbol-unit",a[13]="symbol-value",a[14]="symbol-constant",a[15]="symbol-enum",a[16]="symbol-enum-member",a[17]="symbol-keyword",a[27]="symbol-snippet",a[18]="symbol-text",a[19]="symbol-color",a[20]="symbol-file",a[21]="symbol-reference",a[22]="symbol-customcolor",a[23]="symbol-folder",a[24]="symbol-type-parameter",a[25]="account",a[26]="issues",function(T){const M=a[T];let W=M&&k.iconRegistry.get(M);return W||(console.info("No codicon found for CompletionItemKind "+T),W=k.Codicon.symbolProperty),W.classNames}}(),e.completionKindFromString=function(){let a=Object.create(null);return a.method=0,a.function=1,a.constructor=2,a.field=3,a.variable=4,a.class=5,a.struct=6,a.interface=7,a.module=8,a.property=9,a.event=10,a.operator=11,a.unit=12,a.value=13,a.constant=14,a.enum=15,a["enum-member"]=16,a.enumMember=16,a.keyword=17,a.snippet=27,a.text=18,a.color=19,a.file=20,a.reference=21,a.customcolor=22,a.folder=23,a["type-parameter"]=24,a.typeParameter=24,a.account=25,a.issue=26,function(T,M){let W=a[T];return typeof W=="undefined"&&!M&&(W=9),W}}();var o;(function(a){a[a.Deprecated=1]="Deprecated"})(o=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var b;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var v;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(v=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(a){return a&&h.URI.isUri(a.uri)&&R.Range.isIRange(a.range)&&(R.Range.isIRange(a.originSelectionRange)||R.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=t;var s;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var i;(function(a){a[a.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var r;(function(a){const T=new Map;T.set("file",0),T.set("module",1),T.set("namespace",2),T.set("package",3),T.set("class",4),T.set("method",5),T.set("property",6),T.set("field",7),T.set("constructor",8),T.set("enum",9),T.set("interface",10),T.set("function",11),T.set("variable",12),T.set("constant",13),T.set("string",14),T.set("number",15),T.set("boolean",16),T.set("array",17),T.set("object",18),T.set("key",19),T.set("null",20),T.set("enum-member",21),T.set("struct",22),T.set("event",23),T.set("operator",24),T.set("type-parameter",25);const M=new Map;M.set(0,"file"),M.set(1,"module"),M.set(2,"namespace"),M.set(3,"package"),M.set(4,"class"),M.set(5,"method"),M.set(6,"property"),M.set(7,"field"),M.set(8,"constructor"),M.set(9,"enum"),M.set(10,"interface"),M.set(11,"function"),M.set(12,"variable"),M.set(13,"constant"),M.set(14,"string"),M.set(15,"number"),M.set(16,"boolean"),M.set(17,"array"),M.set(18,"object"),M.set(19,"key"),M.set(20,"null"),M.set(21,"enum-member"),M.set(22,"struct"),M.set(23,"event"),M.set(24,"operator"),M.set(25,"type-parameter");function W(q){return T.get(q)}a.fromString=W;function B(q){return M.get(q)}a.toString=B;function Z(q,$){const V=M.get(q);let F=V&&k.iconRegistry.get("symbol-"+V);return F||(console.info("No codicon found for SymbolKind "+q),F=k.Codicon.symbolProperty),`${$?"inline":"block"} ${F.classNames}`}a.toCssClassName=Z})(r=e.SymbolKinds||(e.SymbolKinds={}));class d{constructor(T){this.value=T}}e.FoldingRangeKind=d,d.Comment=new d("comment"),d.Imports=new d("imports"),d.Region=new d("region");var m;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(m=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var p;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(p=e.CommentMode||(e.CommentMode={}));var I;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(I=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var A;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(A=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ee[59],_e([0,1,8,4,21]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=D.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",D.isMacintosh),k.set("isLinux",D.isLinux),k.set("isWindows",D.isWindows),k.set("isWeb",D.isWeb),k.set("isMacNative",D.isMacintosh&&!D.isWeb),k.set("isEdge",y.indexOf("Edg/")>=0),k.set("isFirefox",y.indexOf("Firefox")>=0),k.set("isChrome",y.indexOf("Chrome")>=0),k.set("isSafari",y.indexOf("Safari")>=0);const S=Object.prototype.hasOwnProperty;var _;(function(A){A[A.False=0]="False",A[A.True=1]="True",A[A.Defined=2]="Defined",A[A.Not=3]="Not",A[A.Equals=4]="Equals",A[A.NotEquals=5]="NotEquals",A[A.And=6]="And",A[A.Regex=7]="Regex",A[A.NotRegex=8]="NotRegex",A[A.Or=9]="Or",A[A.In=10]="In",A[A.NotIn=11]="NotIn",A[A.Greater=12]="Greater",A[A.GreaterEquals=13]="GreaterEquals",A[A.Smaller=14]="Smaller",A[A.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return P.INSTANCE}static true(){return c.INSTANCE}static has(a){return f.create(a)}static equals(a,T){return l.create(a,T)}static notEquals(a,T){return b.create(a,T)}static regex(a,T){return s.create(a,T)}static in(a,T){return o.create(a,T)}static not(a){return E.create(a)}static and(...a){return r.create(a)}static or(...a){return d.create(a)}static greater(a,T){return u.create(a,T)}static less(a,T){return v.create(a,T)}static deserialize(a,T=!1){if(!!a)return this._deserializeOrExpression(a,T)}static _deserializeOrExpression(a,T){let M=a.split("||");return d.create(M.map(W=>this._deserializeAndExpression(W,T)))}static _deserializeAndExpression(a,T){let M=a.split("&&");return r.create(M.map(W=>this._deserializeOne(W,T)))}static _deserializeOne(a,T){if(a=a.trim(),a.indexOf("!=")>=0){let M=a.split("!=");return b.create(M[0].trim(),this._deserializeValue(M[1],T))}if(a.indexOf("==")>=0){let M=a.split("==");return l.create(M[0].trim(),this._deserializeValue(M[1],T))}if(a.indexOf("=~")>=0){let M=a.split("=~");return s.create(M[0].trim(),this._deserializeRegexValue(M[1],T))}if(a.indexOf(" in ")>=0){let M=a.split(" in ");return o.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(a)){const M=a.split(">=");return g.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(a)){const M=a.split(">");return u.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(a)){const M=a.split("<=");return t.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(a)){const M=a.split("<");return v.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(a)?E.create(a.substr(1).trim()):f.create(a)}static _deserializeValue(a,T){if(a=a.trim(),a==="true")return!0;if(a==="false")return!1;let M=/^'([^']*)'$/.exec(a);return M?M[1].trim():a}static _deserializeRegexValue(a,T){if((0,h.isFalsyOrWhitespace)(a)){if(T)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=a.indexOf("/"),W=a.lastIndexOf("/");if(M===W||M<0){if(T)throw new Error(`bad regexp-value '${a}', missing /-enclosure`);return console.warn(`bad regexp-value '${a}', missing /-enclosure`),null}let B=a.slice(M+1,W),Z=a[W+1]==="i"?"i":"";try{return new RegExp(B,Z)}catch(q){if(T)throw new Error(`bad regexp-value '${a}', parse error: ${q}`);return console.warn(`bad regexp-value '${a}', parse error: ${q}`),null}}}e.ContextKeyExpr=C;function n(A,a){return A.cmp(a)}class P{constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class c{constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=c,c.INSTANCE=new c;class f{constructor(a){this.key=a,this.type=2}static create(a){const T=k.get(a);return typeof T=="boolean"?T?c.INSTANCE:P.INSTANCE:new f(a)}cmp(a){return a.type!==this.type?this.type-a.type:p(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=f;class l{constructor(a,T){this.key=a,this.value=T,this.type=4}static create(a,T){if(typeof T=="boolean")return T?f.create(a):E.create(a);const M=k.get(a);return typeof M=="boolean"?T===(M?"true":"false")?c.INSTANCE:P.INSTANCE:new l(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:I(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(a){return a.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=l;class o{constructor(a,T){this.key=a,this.valueKey=T,this.type=10}static create(a,T){return new o(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:I(this.key,this.valueKey,a.key,a.valueKey)}equals(a){return a.type===this.type?this.key===a.key&&this.valueKey===a.valueKey:!1}evaluate(a){const T=a.getValue(this.valueKey),M=a.getValue(this.key);return Array.isArray(T)?T.indexOf(M)>=0:typeof M=="string"&&typeof T=="object"&&T!==null?S.call(T,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(a){return a.mapIn(this.key,this.valueKey)}negate(){return w.create(this)}}e.ContextKeyInExpr=o;class w{constructor(a){this._actual=a,this.type=11}static create(a){return new w(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new w(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class b{constructor(a,T){this.key=a,this.value=T,this.type=5}static create(a,T){if(typeof T=="boolean")return T?E.create(a):f.create(a);const M=k.get(a);return typeof M=="boolean"?T===(M?"true":"false")?P.INSTANCE:c.INSTANCE:new b(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:I(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(a){return a.mapNotEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class E{constructor(a){this.key=a,this.type=3}static create(a){const T=k.get(a);return typeof T=="boolean"?T?P.INSTANCE:c.INSTANCE:new E(a)}cmp(a){return a.type!==this.type?this.type-a.type:p(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!a.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(a){return a.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=E;class u{constructor(a,T){this.key=a,this.value=T,this.type=12}static create(a,T){return new u(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:I(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class g{constructor(a,T){this.key=a,this.value=T,this.type=13}static create(a,T){return new g(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:I(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreaterEquals(this.key,this.value)}negate(){return v.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=g;class v{constructor(a,T){this.key=a,this.value=T,this.type=14}static create(a,T){return new v(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:I(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmaller(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeySmallerExpr=v;class t{constructor(a,T){this.key=a,this.value=T,this.type=15}static create(a,T){return new t(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:I(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class s{constructor(a,T){this.key=a,this.regexp=T,this.type=7}static create(a,T){return new s(a,T)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.key<a.key)return-1;if(this.key>a.key)return 1;const T=this.regexp?this.regexp.source:"",M=a.regexp?a.regexp.source:"";return T<M?-1:T>M?1:0}equals(a){if(a.type===this.type){const T=this.regexp?this.regexp.source:"",M=a.regexp?a.regexp.source:"";return this.key===a.key&&T===M}return!1}evaluate(a){let T=a.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const a=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${a}`}keys(){return[this.key]}map(a){return a.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=s;class i{constructor(a){this._actual=a,this.type=8}static create(a){return new i(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new i(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class r{constructor(a){this.expr=a,this.type=6}static create(a){return r._normalizeArr(a)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let T=0,M=this.expr.length;T<M;T++){const W=n(this.expr[T],a.expr[T]);if(W!==0)return W}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let T=0,M=this.expr.length;T<M;T++)if(!this.expr[T].equals(a.expr[T]))return!1;return!0}return!1}evaluate(a){for(let T=0,M=this.expr.length;T<M;T++)if(!this.expr[T].evaluate(a))return!1;return!0}static _normalizeArr(a){const T=[];let M=!1;for(const W of a)if(!!W){if(W.type===1){M=!0;continue}if(W.type===0)return P.INSTANCE;if(W.type===6){T.push(...W.expr);continue}T.push(W)}if(T.length===0&&M)return c.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];for(T.sort(n);T.length>1;){const W=T[T.length-1];if(W.type!==9)break;T.pop();const B=T.pop(),Z=d.create(W.expr.map(q=>r.create([q,B])));Z&&(T.push(Z),T.sort(n))}return T.length===1?T[0]:new r(T)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(let T of this.expr)a.push(...T.keys());return a}map(a){return new r(this.expr.map(T=>T.map(a)))}negate(){let a=[];for(let T of this.expr)a.push(T.negate());return d.create(a)}}e.ContextKeyAndExpr=r;class d{constructor(a){this.expr=a,this.type=9}static create(a){const T=d._normalizeArr(a);if(T.length!==0)return T.length===1?T[0]:new d(T)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let T=0,M=this.expr.length;T<M;T++){const W=n(this.expr[T],a.expr[T]);if(W!==0)return W}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let T=0,M=this.expr.length;T<M;T++)if(!this.expr[T].equals(a.expr[T]))return!1;return!0}return!1}evaluate(a){for(let T=0,M=this.expr.length;T<M;T++)if(this.expr[T].evaluate(a))return!0;return!1}static _normalizeArr(a){let T=[],M=!1;if(a){for(let W=0,B=a.length;W<B;W++){const Z=a[W];if(!!Z){if(Z.type===0){M=!0;continue}if(Z.type===1)return[c.INSTANCE];if(Z.type===9){T=T.concat(Z.expr);continue}T.push(Z)}}if(T.length===0&&M)return[P.INSTANCE];T.sort(n)}return T}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(let T of this.expr)a.push(...T.keys());return a}map(a){return new d(this.expr.map(T=>T.map(a)))}negate(){let a=[];for(let M of this.expr)a.push(M.negate());const T=M=>M.type===9?M.expr:[M];for(;a.length>1;){const M=a.shift(),W=a.shift(),B=[];for(const Z of T(M))for(const q of T(W))B.push(C.and(Z,q));a.unshift(C.or(...B))}return a[0]}}e.ContextKeyOrExpr=d;class m extends f{constructor(a,T,M){super(a);this._defaultValue=T,typeof M=="object"?m._info.push({...M,key:a}):M!==!0&&m._info.push({key:a,description:M,type:T!=null?typeof T:void 0})}static all(){return m._info.values()}bindTo(a){return a.createKey(this.key,this._defaultValue)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(a){return C.equals(this.key,a)}notEqualsTo(a){return C.notEquals(this.key,a)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(A,a){return A<a?-1:A>a?1:0}function I(A,a,T,M){return A<T?-1:A>T?1:a<M?-1:a>M?1:0}}),define(Ee[146],_e([0,1,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,h.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,h.refineServiceDecorator)(e.IEnvironmentService)}),define(Ee[26],_e([0,1,8,4]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=D;function y(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class S{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,c){if(typeof P=="undefined"||P===null)return typeof c=="undefined"||c===null;if(typeof c=="undefined"||c===null)return!1;if(typeof P=="string"||typeof c=="string"){let f=typeof P=="string"?P:P.value,l=typeof c=="string"?c:c.value;return h.equalsIgnoreCase(f,l)}return P._lower===c._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=S;function _(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function C(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=C,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ee[147],_e([0,1,8,26]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(l,o){return l.uuid&&o.uuid?l.uuid===o.uuid:l.id===o.id?!0:(0,h.compareIgnoreCase)(l.id,o.id)===0}e.areSameExtensions=D;class y{constructor(o,w){this.version=w,this.id=o.id,this.uuid=o.uuid}key(){return`${this.id}-${this.version}`}equals(o){return o instanceof y?D(this,o)&&this.version===o.version:!1}}e.ExtensionIdentifierWithVersion=y;function k(l,o){return`${l}.${o}`}e.getExtensionId=k;function S(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function _(l,o){return S(k(l,o))}e.getGalleryExtensionId=_;function C(l,o){const w=[],b=E=>{for(const u of w)if(u.some(g=>D(o(g),o(E))))return u;return null};for(const E of l){const u=b(E);u?u.push(E):w.push([E])}return w}e.groupByExtension=C;function n(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function P(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function c(l){const o=new Set;for(const w of l)w.malicious&&o.add(w.id.id);return o}e.getMaliciousExtensionsSet=c;function f(l,o){const w=[],b=o.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const E=b.shift();if(E&&w.every(u=>!D(u.identifier,{id:E}))){const u=l.filter(g=>D(g.identifier,{id:E}));u.length===1&&(w.push(u[0]),b.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.getExtensionDependencies=f}),define(Ee[60],_e([0,1,127,14,2,4,8,10,22]),function(te,e,h,R,D,y,k,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function C($){return $.create===!0}e.isFileOpenForWriteOptions=C;var n;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var P;(function($){$[$.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var c;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f($){return!!($.capabilities&2)}e.hasReadWriteCapability=f;function l($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=l;function o($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=o;function w($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=w;var b;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(V,F){super(V);this.code=F}}e.FileSystemProviderError=E;function u($,V){const F=new E($.toString(),V);return v(F,V),F}e.createFileSystemProviderError=u;function g($){return $||u((0,h.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=g;function v($,V){return $.name=V?`${V} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=v;function t($){if(!$)return b.Unknown;if($ instanceof E)return $.code;const V=/^(.+) \(FileSystemError\)$/.exec($.name);if(!V)return b.Unknown;switch(V[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function s($){if($ instanceof I)return $.fileOperationResult;switch(t($)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var i;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(V,F,re){this.resource=V,this.operation=F,this.target=re}isOperation(V){return this.operation===V}}e.FileOperationEvent=r;var d;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(d=e.FileChangeType||(e.FileChangeType={}));class m{constructor(V,F){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const re of V)switch(re.type){case 1:this.added||(this.added=_.TernarySearchTree.forUris(()=>F)),this.added.set(re.resource,re);break;case 0:this.updated||(this.updated=_.TernarySearchTree.forUris(()=>F)),this.updated.set(re.resource,re);break;case 2:this.deleted||(this.deleted=_.TernarySearchTree.forUris(()=>F)),this.deleted.set(re.resource,re);break}}contains(V,...F){return this.doContains(V,{includeChildren:!1},...F)}affects(V,...F){return this.doContains(V,{includeChildren:!0},...F)}doContains(V,F,...re){if(!V)return!1;const N=re.length>0;return!!((!N||re.includes(1))&&(this.added?.get(V)||F.includeChildren&&this.added?.findSuperstr(V))||(!N||re.includes(0))&&(this.updated?.get(V)||F.includeChildren&&this.updated?.findSuperstr(V))||(!N||re.includes(2))&&(this.deleted?.findSubstr(V)||F.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=m;function p($,V,F){return!$||!V||$===V||V.length>$.length?!1:(V.charAt(V.length-1)!==R.sep&&(V+=R.sep),F?(0,k.startsWithIgnoreCase)($,V):$.indexOf(V)===0)}e.isParent=p;class I extends Error{constructor(V,F,re){super(V);this.fileOperationResult=F,this.options=re}}e.FileOperationError=I;class A extends I{constructor(V,F,re){super(V,2,re);this.stat=F}}e.NotModifiedSinceFileOperationError=A;var a;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(a=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function M($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=M;async function W($,V){if(!V.canHandleResource(D.URI.from({scheme:$.scheme})))return new Promise(F=>{const re=V.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===$.scheme&&N.added&&(re.dispose(),F())})})}e.whenProviderRegistered=W,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(V){return(0,S.isNumber)(V)||(V=0),V<B.KB?(0,h.localize)(1,null,V.toFixed(0)):V<B.MB?(0,h.localize)(2,null,(V/B.KB).toFixed(2)):V<B.GB?(0,h.localize)(3,null,(V/B.MB).toFixed(2)):V<B.TB?(0,h.localize)(4,null,(V/B.GB).toFixed(2)):(0,h.localize)(5,null,(V/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var Z;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(Z=e.Arch||(e.Arch={}));function q($){return{maxFileSize:$===0?300*B.MB:16*B.GB,maxHeapSize:$===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=q}),define(Ee[61],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class h{constructor(...D){this._entries=new Map;for(let[y,k]of D)this.set(y,k)}set(D,y){const k=this._entries.get(D);return this._entries.set(D,y),k}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=h}),define(Ee[148],_e([0,1,12,143,88,4,61,16]),function(te,e,h,R,D,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class C extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class n{constructor(l=new k.ServiceCollection,o=!1,w){this._activeInstantiations=new Set,this._services=l,this._strict=o,this._parent=w,this._services.set(y.IInstantiationService,this)}createChild(l){return new n(l,this._strict,this)}invokeFunction(l,...o){let w=c.traceInvocation(l),b=!1;try{return l({get:(u,g)=>{if(b)throw(0,h.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(u,w);if(!v&&g!==y.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return v}},...o)}finally{b=!0,w.stop()}}createInstance(l,...o){let w,b;return l instanceof D.SyncDescriptor?(w=c.traceCreation(l.ctor),b=this._createInstance(l.ctor,l.staticArguments.concat(o),w)):(w=c.traceCreation(l),b=this._createInstance(l,o,w)),w.stop(),b}_createInstance(l,o=[],w){let b=y._util.getServiceDependencies(l).sort((g,v)=>g.index-v.index),E=[];for(const g of b){let v=this._getOrCreateServiceInstance(g.id,w);if(!v&&this._strict&&!g.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${g.id}.`);E.push(v)}let u=b.length>0?b[0].index:o.length;if(o.length!==u){console.warn(`[createInstance] First service dependency of ${l.name} at position ${u+1} conflicts with ${o.length} static arguments`);let g=u-o.length;g>0?o=o.concat(new Array(g)):o=o.slice(0,u)}return new l(...[...o,...E])}_setServiceInstance(l,o){if(this._services.get(l)instanceof D.SyncDescriptor)this._services.set(l,o);else if(this._parent)this._parent._setServiceInstance(l,o);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let o=this._services.get(l);return!o&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):o}_getOrCreateServiceInstance(l,o){let w=this._getServiceInstanceOrDescriptor(l);return w instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,w,o.branch(l,!0)):(o.branch(l,!1),w)}_safeCreateAndCacheServiceInstance(l,o,w){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,o,w)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,o,w){const b=new R.Graph(g=>g.id.toString());let E=0;const u=[{id:l,desc:o,_trace:w}];for(;u.length;){const g=u.pop();if(b.lookupOrInsertNode(g),E++>1e3)throw new C(b);for(let v of y._util.getServiceDependencies(g.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(v.id);if(!t&&!v.optional&&console.warn(`[createInstance] ${l} depends on ${v.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const s={id:v.id,desc:t,_trace:g._trace.branch(v.id,!0)};b.insertEdge(g,s),u.push(s)}}}for(;;){const g=b.roots();if(g.length===0){if(!b.isEmpty())throw new C(b);break}for(const{data:v}of g){if(this._getServiceInstanceOrDescriptor(v.id)instanceof D.SyncDescriptor){const s=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,s)}b.removeNode(v)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,o,w=[],b,E){if(this._services.get(l)instanceof D.SyncDescriptor)return this._createServiceInstance(o,w,b,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,o,w,b,E);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}_createServiceInstance(l,o=[],w,b){if(w){const E=new S.IdleValue(()=>this._createInstance(l,o,b));return new Proxy(Object.create(null),{get(u,g){if(g in u)return u[g];let v=E.value,t=v[g];return typeof t!="function"||(t=t.bind(v),u[g]=t),t},set(u,g,v){return E.value[g]=v,!0}})}else return this._createInstance(l,o,b)}}e.InstantiationService=n;var P;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(P||(P={}));class c{constructor(l,o){this.type=l,this.name=o,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return _?new c(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(l){return _?new c(0,l.name):c._None}branch(l,o){let w=new c(2,l.toString());return this._dep.push([l,o,w]),w}stop(){let l=Date.now()-this._start;c._totals+=l;let o=!1;function w(E,u){let g=[],v=new Array(E+1).join("	");for(const[t,s,i]of u._dep)if(s&&i){o=!0,g.push(`${v}CREATES -> ${t}`);let r=w(E+1,i);r&&g.push(r)}else g.push(`${v}uses -> ${t}`);return g.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(l>2||o)&&console.log(b.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(Ee[15],_e([0,1,4,7,21,3,56]),function(te,e,h,R,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,h.createDecorator)("logService"),e.ILoggerService=(0,h.createDecorator)("loggerService");function S(){return new Date().toISOString()}var _;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class C extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class n extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(_.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(_.Error,this.format(i))}else this.log(_.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let i=0;i<t.length;i++){let r=t[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch(d){}s+=(i>0?" ":"")+r}return s}}e.AbstractMessageLogger=n;class P extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!D.isWindows}trace(t,...s){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...s):console.log(`[main ${S()}]`,t,...s))}debug(t,...s){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...s):console.log(`[main ${S()}]`,t,...s))}info(t,...s){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...s):console.log(`[main ${S()}]`,t,...s))}warn(t,...s){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${S()}][0m`,t,...s):console.warn(`[main ${S()}]`,t,...s))}error(t,...s){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${S()}][0m`,t,...s):console.error(`[main ${S()}]`,t,...s))}critical(t,...s){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${S()}][0m`,t,...s):console.error(`[main ${S()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class c extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=c;class f extends C{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,k.toErrorMessage)(t,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class l extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const i of this.logServices)i.trace(t,...s)}debug(t,...s){for(const i of this.logServices)i.debug(t,...s)}info(t,...s){for(const i of this.logServices)i.info(t,...s)}warn(t,...s){for(const i of this.logServices)i.warn(t,...s)}error(t,...s){for(const i of this.logServices)i.error(t,...s)}critical(t,...s){for(const i of this.logServices)i.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=l;class o extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=o;class w extends R.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(i))}))}createLogger(t,s){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,s?.always?_.Trace:this.logLevel,s),this.loggers.set(t.toString(),i),s?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class b{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(t){}getLevel(){return _.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=b;function E(v){if(v.verbose)return _.Trace;if(typeof v.logLevel=="string"){const t=u(v.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function u(v){switch(v){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=u;function g(v){switch(v){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=g}),define(Ee[89],_e([0,1,4,128,42]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var k;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function C(l,o){return o-l}_.compare=C;const n=Object.create(null);n[_.Error]=(0,R.localize)(0,null),n[_.Warning]=(0,R.localize)(1,null),n[_.Info]=(0,R.localize)(2,null);function P(l){return n[l]||""}_.toString=P;function c(l){switch(l){case D.default.Error:return _.Error;case D.default.Warning:return _.Warning;case D.default.Info:return _.Info;case D.default.Ignore:return _.Hint}}_.fromSeverity=c;function f(l){switch(l){case _.Error:return D.default.Error;case _.Warning:return D.default.Warning;case _.Info:return D.default.Info;case _.Hint:return D.default.Ignore}}_.toSeverity=f}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var S;(function(_){const C="";function n(c){return P(c,!0)}_.makeKey=n;function P(c,f){let l=[C];return c.source?l.push(c.source.replace("\xA6","\\\xA6")):l.push(C),c.code?typeof c.code=="string"?l.push(c.code.replace("\xA6","\\\xA6")):l.push(c.code.value.replace("\xA6","\\\xA6")):l.push(C),c.severity!==void 0&&c.severity!==null?l.push(k.toString(c.severity)):l.push(C),c.message&&f?l.push(c.message.replace("\xA6","\\\xA6")):l.push(C),c.startLineNumber!==void 0&&c.startLineNumber!==null?l.push(c.startLineNumber.toString()):l.push(C),c.startColumn!==void 0&&c.startColumn!==null?l.push(c.startColumn.toString()):l.push(C),c.endLineNumber!==void 0&&c.endLineNumber!==null?l.push(c.endLineNumber.toString()):l.push(C),c.endColumn!==void 0&&c.endColumn!==null?l.push(c.endColumn.toString()):l.push(C),l.push(C),l.join("\xA6")}_.makeKeyOptionalMessage=P})(S=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,h.createDecorator)("markerService")}),define(Ee[149],_e([0,1,42,4,3]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=h.default,e.INotificationService=(0,R.createDecorator)("notificationService");var y;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class S{constructor(){this.progress=new _,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=S;class _{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=_}),define(Ee[150],_e([0,1,7,8,2,4]),function(te,e,h,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return h.Disposable.None},registerValidator(){return h.Disposable.None},registerExternalUriResolver(){return h.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return h.Disposable.None},async open(){return!1},async resolveExternalUri(S){return{resolved:S,dispose(){}}}});function k(S,_){return D.URI.isUri(S)?(0,R.equalsIgnoreCase)(S.scheme,_):(0,R.startsWithIgnoreCase)(S,_+":")}e.matchesScheme=k});var He=this&&this.__decorate||function(te,e,h,R){var D=arguments.length,y=D<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,h):R,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(te,e,h,R);else for(var S=te.length-1;S>=0;S--)(k=te[S])&&(y=(D<3?k(y):D>3?k(e,h,y):k(e,h))||y);return D>3&&y&&Object.defineProperty(e,h,y),y},ze=this&&this.__param||function(te,e){return function(h,R){e(h,R,te)}};define(Ee[151],_e([0,1,4,18,7,16]),function(te,e,h,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,h.createDecorator)("progressService");var k;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class S{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=S,S.None=Object.freeze({report(){}});let _=class extends D.Disposable{constructor(P,c){super();this.deferred=new y.DeferredPromise,c.withProgress(P,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};_=He([ze(1,e.IProgressService)],_),e.UnmanagedProgress=_;class C extends D.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(P){this.stop();const c=++this.currentOperationId,f=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:f.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,h.createDecorator)("editorProgressService")}),define(Ee[31],_e([0,1,10,39]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(k,S){R.ok(h.isString(k)),R.ok(h.isObject(S)),R.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,S)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new D}),define(Ee[152],_e([0,1,31,3]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class y{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,C){this.schemasById[D(_)]=C,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new y;h.Registry.add(e.Extensions.JSONContribution,k)}),define(Ee[62],_e([0,1,125,3,31,10,152]),function(te,e,h,R,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var _;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(_=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const C=D.Registry.as(k.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:h.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,u=!0){this.registerConfigurations([E],u)}registerConfigurations(E,u=!0){const g=[];E.forEach(v=>{g.push(...this.validateAndRegisterProperties(v,u,v.extensionInfo)),this.configurationContributors.push(v),this.registerJSONConfiguration(v)}),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(g)}deregisterConfigurations(E){const u=[],g=v=>{if(v.properties)for(const t in v.properties)u.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,v.properties[t]);v.allOf&&v.allOf.forEach(t=>g(t))};for(const v of E){g(v);const t=this.configurationContributors.indexOf(v);t!==-1&&this.configurationContributors.splice(t,1)}C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}registerDefaultConfigurations(E){const u=[],g=[];for(const v of E)for(const t in v)if(u.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...v[t]};const s={type:"object",default:this.defaultValues[t],description:h.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};g.push(c(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.defaultValues[t]=v[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterDefaultConfigurations(E){const u=[];for(const g of E)for(const v in g)if(u.push(v),delete this.defaultValues[v],e.OVERRIDE_PROPERTY_PATTERN.test(v))delete this.configurationProperties[v],delete this.defaultLanguageConfigurationOverridesNode.properties[v];else{const t=this.configurationProperties[v];t&&(this.updatePropertyDefaultValue(v,t),this.updateSchema(v,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const u of E)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,u=!0,g,v=3){v=y.isUndefinedOrNull(E.scope)?v:E.scope;let t=[],s=E.properties;if(s)for(let r in s){if(u&&o(r)){delete s[r];continue}const d=s[r];if(this.updatePropertyDefaultValue(r,d),e.OVERRIDE_PROPERTY_PATTERN.test(r)?d.scope=void 0:(d.scope=y.isUndefinedOrNull(d.scope)?v:d.scope,d.restricted=y.isUndefinedOrNull(d.restricted)?!!g?.restrictedConfigurations?.includes(r):d.restricted),s[r].hasOwnProperty("included")&&!s[r].included){this.excludedConfigurationProperties[r]=s[r],delete s[r];continue}else this.configurationProperties[r]=s[r];!s[r].deprecationMessage&&s[r].markdownDeprecationMessage&&(s[r].deprecationMessage=s[r].markdownDeprecationMessage),t.push(r)}let i=E.allOf;if(i)for(let r of i)t.push(...this.validateAndRegisterProperties(r,u,g,v));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const u=g=>{let v=g.properties;if(v)for(const s in v)this.updateSchema(s,v[s]);let t=g.allOf;t&&t.forEach(u)};u(E)}updateSchema(E,u){switch(e.allSettings.properties[E]=u,u.scope){case 1:e.applicationSettings.properties[E]=u;break;case 2:e.machineSettings.properties[E]=u;break;case 6:e.machineOverridableSettings.properties[E]=u;break;case 3:e.windowSettings.properties[E]=u;break;case 4:e.resourceSettings.properties[E]=u;break;case 5:e.resourceSettings.properties[E]=u,this.resourceLanguageSettingsSchema.properties[E]=u;break}}removeFromSchema(E,u){switch(delete e.allSettings.properties[E],u.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const u=`[${E}]`,g={type:"object",description:h.localize(2,null),errorMessage:h.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,g),e.allSettings.properties[u]=g,e.applicationSettings.properties[u]=g,e.machineSettings.properties[u]=g,e.machineOverridableSettings.properties[u]=g,e.windowSettings.properties[u]=g,e.resourceSettings.properties[u]=g}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,u){let g=this.defaultValues[E];y.isUndefined(g)&&(g=u.default),y.isUndefined(g)&&(g=f(u.type)),u.default=g}}const P="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(P);function c(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=c;function f(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const l=new n;D.Registry.add(e.Extensions.Configuration,l);function o(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?h.localize(5,null,b):l.getConfigurationProperties()[b]!==void 0?h.localize(6,null,b):null:h.localize(4,null)}e.validateProperty=o;function w(){const b=[],E=l.getConfigurationProperties();for(const u of Object.keys(E))b.push([u,E[u].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=w}),define(Ee[90],_e([0,1,24,10,2,31,4,62]),function(te,e,h,R,D,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function _(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof D.URI)}e.isConfigurationOverrides=_;var C;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function P(s,i){const r=i?s?i.keys.filter(T=>s.keys.indexOf(T)===-1):[...i.keys]:[],d=s?i?s.keys.filter(T=>i.keys.indexOf(T)===-1):[...s.keys]:[],m=[];if(i&&s){for(const T of s.keys)if(i.keys.indexOf(T)!==-1){const M=b(s.contents,T),W=b(i.contents,T);h.equals(M,W)||m.push(T)}}const p=[],I=T=>{const M={};for(const W of T)for(const B of W.identifiers)M[v(B)]=W;return M},A=i?I(i.overrides):{},a=s?I(s.overrides):{};if(Object.keys(A).length)for(const T of r){const M=A[T];M&&p.push([(0,S.overrideIdentifierFromKey)(T),M.keys])}if(Object.keys(a).length)for(const T of d){const M=a[T];M&&p.push([(0,S.overrideIdentifierFromKey)(T),M.keys])}if(Object.keys(A).length&&Object.keys(a).length)for(const T of m){const M=a[T],W=A[T];if(M&&W){const B=P({contents:M.contents,keys:M.keys,overrides:[]},{contents:W.contents,keys:W.keys,overrides:[]});p.push([(0,S.overrideIdentifierFromKey)(T),[...B.added,...B.removed,...B.updated]])}}return{added:r,removed:d,updated:m,overrides:p}}e.compare=P;function c(s,i){const r=[];for(const d of Object.keys(s))if(S.OVERRIDE_PROPERTY_PATTERN.test(d)){const m={};for(const p in s[d])m[p]=s[d][p];r.push({identifiers:[(0,S.overrideIdentifierFromKey)(d).trim()],keys:Object.keys(m),contents:f(m,i)})}return r}e.toOverrides=c;function f(s,i){const r=Object.create(null);for(let d in s)l(r,d,s[d],i);return r}e.toValuesTree=f;function l(s,i,r,d){const m=i.split("."),p=m.pop();let I=s;for(let A=0;A<m.length;A++){let a=m[A],T=I[a];switch(typeof T){case"undefined":T=I[a]=Object.create(null);break;case"object":break;default:d(`Ignoring ${i} as ${m.slice(0,A+1).join(".")} is ${JSON.stringify(T)}`);return}I=T}if(typeof I=="object"&&I!==null)try{I[p]=r}catch(A){d(`Ignoring ${i} as ${m.join(".")} is ${JSON.stringify(I)}`)}else d(`Ignoring ${i} as ${m.join(".")} is ${JSON.stringify(I)}`)}e.addToValueTree=l;function o(s,i){const r=i.split(".");w(s,r)}e.removeFromValueTree=o;function w(s,i){const r=i.shift();if(i.length===0){delete s[r];return}if(Object.keys(s).indexOf(r)!==-1){const d=s[r];typeof d=="object"&&!Array.isArray(d)&&(w(d,i),Object.keys(d).length===0&&delete s[r])}}function b(s,i,r){function d(I,A){let a=I;for(const T of A){if(typeof a!="object"||a===null)return;a=a[T]}return a}const m=i.split("."),p=d(s,m);return typeof p=="undefined"?r:p}e.getConfigurationValue=b;function E(s,i,r){Object.keys(i).forEach(d=>{d!=="__proto__"&&(d in s?R.isObject(s[d])&&R.isObject(i[d])?E(s[d],i[d],r):r&&(s[d]=i[d]):s[d]=i[d])})}e.merge=E;function u(){const s=y.Registry.as(S.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=u;function g(){const s=Object.create(null),i=y.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(let r in i){let d=i[r].default;l(s,r,d,m=>console.error(`Conflict in default settings: ${m}`))}return s}e.getDefaultValues=g;function v(s){return`[${s}]`}e.keyFromOverrideIdentifier=v;function t(s,i,r){const d=s.inspect(i),m=s.inspect(r);return typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:d.defaultValue}e.getMigratedSettingValue=t}),define(Ee[153],_e([0,1,108,22,17,10,24,2,62,90,31,7,3]),function(te,e,h,R,D,y,k,S,_,C,n,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},s=[],i=[]){this._contents=t,this._keys=s,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,C.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const i=this.getContentsForOverrideIdentifer(s);return i?t?(0,C.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let i={};for(const r of D.distinct([...Object.keys(this.contents),...Object.keys(s)])){let d=this.contents[r],m=s[r];m&&(typeof d=="object"&&typeof m=="object"?(d=k.deepClone(d),this.mergeContents(d,m)):d=m),i[r]=d}return new f(i,this.keys,this.overrides)}merge(...t){const s=k.deepClone(this.contents),i=k.deepClone(this.overrides),r=[...this.keys];for(const d of t){this.mergeContents(s,d.contents);for(const m of d.overrides){const[p]=i.filter(I=>D.equals(I.identifiers,m.identifiers));p?this.mergeContents(p.contents,m.contents):i.push(k.deepClone(m))}for(const m of d.keys)r.indexOf(m)===-1&&r.push(m)}return new f(s,r,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,s){for(const i of Object.keys(s)){if(i in t&&y.isObject(t[i])&&y.isObject(s[i])){this.mergeContents(t[i],s[i]);continue}t[i]=k.deepClone(s[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?k.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,C.addToValueTree)(this.contents,t,s,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,C.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let i=0;i<s;i++)t.indexOf(this.keys[i])===0&&(s=i);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=f;class l extends f{constructor(){const t=(0,C.getDefaultValues)(),s=(0,C.getConfigurationKeys)(),i=[];for(const r of Object.keys(t))_.OVERRIDE_PROPERTY_PATTERN.test(r)&&i.push({identifiers:[(0,_.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,C.toValuesTree)(t[r],d=>console.error(`Conflict in default settings file: ${d}`))});super(t,s,i)}}e.DefaultConfigurationModel=l;class o{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!y.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:i,keys:r,overrides:d,restricted:m}=this.doParseRaw(t,s);this._configurationModel=new f(i,r,d),this._restrictedConfigurations=m||[]}doParseContent(t){let s={},i=null,r=[],d=[],m=[];function p(A){Array.isArray(r)?r.push(A):i&&(r[i]=A)}let I={onObjectBegin:()=>{let A={};p(A),d.push(r),r=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{r=d.pop()},onArrayBegin:()=>{let A=[];p(A),d.push(r),r=A,i=null},onArrayEnd:()=>{r=d.pop()},onLiteralValue:p,onError:(A,a,T)=>{m.push({error:A,offset:a,length:T})}};if(t)try{h.visit(t,I),s=r[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return s}doParseRaw(t,s){const i=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,i,!0,s);t=r.raw;const d=(0,C.toValuesTree)(t,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),m=Object.keys(t),p=(0,C.toOverrides)(t,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:d,keys:m,overrides:p,restricted:r.restricted}}filter(t,s,i,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:t,restricted:[]};const d={},m=[];for(let p in t)if(_.OVERRIDE_PROPERTY_PATTERN.test(p)&&i){const I=this.filter(t[p],s,!1,r);d[p]=I.raw,m.push(...I.restricted)}else{const I=s[p],A=I?typeof I.scope!="undefined"?I.scope:3:void 0;I?.restricted&&m.push(p),(A===void 0||r.scopes===void 0||r.scopes.includes(A))&&(r.skipRestricted&&I?.restricted||(d[p]=t[p]))}return{raw:d,restricted:m}}}e.ConfigurationModelParser=o;class w extends P.Disposable{constructor(t,s,i,r){super();this.userSettingsResource=t,this.scopes=s,this.fileService=r,this._onDidChange=this._register(new c.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new o(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(c.Event.filter(this.fileService.onDidFilesChange,d=>d.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class b{constructor(t,s,i=new f,r=new f,d=new R.ResourceMap,m=new f,p=new R.ResourceMap,I=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=i,this._workspaceConfiguration=r,this._folderConfigurations=d,this._memoryConfiguration=m,this._memoryConfigurationByResource=p,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,s,i){return this.getConsolidateConfigurationModel(s,i).getValue(t)}updateValue(t,s,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new f,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,s===void 0?r.removeValue(t):r.setValue(t,s),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,i){const r=this.getConsolidateConfigurationModel(s,i),d=this.getFolderConfigurationModelForResource(s.resource,i),m=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,p=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),I=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),A=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),a=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=i?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,M=d?s.overrideIdentifier?d.freeze().override(s.overrideIdentifier).getValue(t):d.freeze().getValue(t):void 0,W=s.overrideIdentifier?m.override(s.overrideIdentifier).getValue(t):m.getValue(t),B=r.getValue(t),Z=D.distinct(D.flatten(r.overrides.map(q=>q.identifiers))).filter(q=>r.getOverrideValue(t,q)!==void 0);return{defaultValue:p,userValue:I,userLocalValue:A,userRemoteValue:a,workspaceValue:T,workspaceFolderValue:M,memoryValue:W,value:B,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:a!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:M!==void 0?{value:d?.freeze().getValue(t),override:s.overrideIdentifier?d?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:W!==void 0?{value:m.getValue(t),override:s.overrideIdentifier?m.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Z.length?Z:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const i=s.filter(r=>_.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const d=(0,_.overrideIdentifierFromKey)(r),m=this._defaultConfiguration.getKeysForOverrideIdentifier(d),p=t.getKeysForOverrideIdentifier(d),I=[...p.filter(A=>m.indexOf(A)===-1),...m.filter(A=>p.indexOf(A)===-1),...m.filter(A=>!k.equals(this._defaultConfiguration.override(d).getValue(A),t.override(d).getValue(A)))];return[d,I]});return this.updateDefaultConfiguration(t),{keys:s,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:i,removed:r,overrides:d}=(0,C.compare)(this.localUserConfiguration,t),m=[...s,...i,...r];return m.length&&this.updateLocalUserConfiguration(t),{keys:m,overrides:d}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:i,removed:r,overrides:d}=(0,C.compare)(this.remoteUserConfiguration,t);let m=[...s,...i,...r];return m.length&&this.updateRemoteUserConfiguration(t),{keys:m,overrides:d}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:i,removed:r,overrides:d}=(0,C.compare)(this.workspaceConfiguration,t);let m=[...s,...i,...r];return m.length&&this.updateWorkspaceConfiguration(t),{keys:m,overrides:d}}compareAndUpdateFolderConfiguration(t,s){const i=this.folderConfigurations.get(t),{added:r,updated:d,removed:m,overrides:p}=(0,C.compare)(i,s);let I=[...r,...d,...m];return(I.length||!i)&&this.updateFolderConfiguration(t,s),{keys:I,overrides:p}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:r,removed:d,overrides:m}=(0,C.compare)(s,void 0);return{keys:[...i,...r,...d],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let i=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},s){let i=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const r=s.getFolder(t);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const d=this._memoryConfigurationByResource.get(t);d&&(i=i.merge(d))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(s=i.merge(r),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=i}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const i=s.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:i,overrides:r,keys:d}=this._folderConfigurations.get(s);return t.push([s,{contents:i,overrides:r,keys:d}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),d=t.folders.reduce((m,p)=>(m.set(S.URI.revive(p[0]),this.parseConfigurationModel(p[1])),m),new R.ResourceMap);return new b(s,i,new f,r,d,new f,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function E(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const t=new Set,s=new Map;for(const r of v)r.keys.forEach(d=>t.add(d)),r.overrides.forEach(([d,m])=>{const p=(0,R.getOrSet)(s,d,new Set);m.forEach(I=>p.add(I))});const i=[];return s.forEach((r,d)=>i.push([d,[...r.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=E;class u{constructor(t,s,i,r){this.change=t,this.previous=s,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const d=new Set;t.keys.forEach(p=>d.add(p)),t.overrides.forEach(([,p])=>p.forEach(I=>d.add(I))),this.affectedKeys=[...d.values()];const m=new f;this.affectedKeys.forEach(p=>m.setValue(p,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!k.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let i=(0,C.toValuesTree)({[s]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(t=t[r],!t)return!1;i=i[r]}return!0}}e.ConfigurationChangeEvent=u;class g extends u{constructor(t,s,i,r){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=i,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=g}),define(Ee[91],_e([0,1,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,h.createDecorator)("remoteAuthorityResolverService");var R;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(k,S=R.Unknown,_){super(k);this._message=k,this._code=S,this._detail=_,this.isHandled=S===R.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===R.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===R.NoResolverFound}static isHandled(k){return k instanceof D&&k.isHandled}}e.RemoteAuthorityResolverError=D}),define(Ee[92],_e([0,1,11]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(C){return C.scheme===h.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=R;function D(C){if(!C)return;const n=C.indexOf("+");return n<0?C:C.substr(0,n)}e.getRemoteName=D;function y(C){return C.scheme!==h.Schemas.file&&C.scheme!==h.Schemas.vscodeRemote}e.isVirtualResource=y;function k(C){if(C.folders.length)return C.folders.every(n=>y(n.uri))?C.folders[0].uri:void 0;if(C.configuration&&y(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=k;function S(C){return k(C)?.scheme}e.getVirtualWorkspaceScheme=S;function _(C){return k(C)!==void 0}e.isVirtualWorkspace=_}),define(Ee[154],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class h{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,y,k=5){let S;return S=y(_=>{const C=typeof _=="string"?_:_.data;let n=this._terminalBufferMap.get(D);if(n){n.data.push(C);return}const P=setTimeout(()=>this.flushBuffer(D),k);n={data:[C],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(D),S.dispose()}},this._terminalBufferMap.set(D,n)}),S}stopBuffering(D){const y=this._terminalBufferMap.get(D);y&&y.dispose()}flushBuffer(D){const y=this._terminalBufferMap.get(D);y&&(this._terminalBufferMap.delete(D),this._callback(D,y.data.join("")))}}e.TerminalDataBufferer=h}),define(Ee[155],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var h;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(h=e.ColorScheme||(e.ColorScheme={}))}),define(Ee[156],_e([0,1,4,7,31,3,155,52]),function(te,e,h,R,D,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,h.createDecorator)("themeService");var _;(function(w){function b(E){return E&&typeof E=="object"&&typeof E.id=="string"}w.isThemeColor=b})(_=e.ThemeColor||(e.ThemeColor={}));function C(w){return{id:w}}e.themeColorFromId=C;var n;(function(w){function b(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||_.isThemeColor(s.color))}w.isThemeIcon=b;const E=new RegExp(`^\\$\\((${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?)\\)$`);function u(s){const i=E.exec(s);if(!i)return;let[,r]=i;return{id:r}}w.fromString=u;function g(s,i){let r=s.id;const d=r.lastIndexOf("~");return d!==-1&&(r=r.substring(0,d)),i&&(r=`${r}~${i}`),{id:r}}w.modify=g;function v(s,i){return s.id===i.id&&s.color?.id===i.color?.id}w.isEqual=v;function t(s,i){return{id:s.id,color:i?C(i):void 0}}w.asThemeIcon=t,w.asClassNameArray=S.CSSIcon.asClassNameArray,w.asClassName=S.CSSIcon.asClassName,w.asCSSSelector=S.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=S.Codicon.file,e.FolderThemeIcon=S.Codicon.folder;function P(w){switch(w){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new y.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,R.toDisposable)(()=>{const E=this.themingParticipants.indexOf(b);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new c;D.Registry.add(e.Extensions.ThemingContribution,f);function l(w){return f.onColorThemeChange(w)}e.registerThemingParticipant=l;class o extends R.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,E){let u=this.theme.getColor(b);return u&&E&&(u=E(u,this.theme)),u?u.toString():null}}e.Themable=o}),define(Ee[44],_e([0,1,2,25,4,22]),function(te,e,h,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var k;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function S(c){const f=c;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=S;function _(c){const f=c;return!!(f&&typeof f=="object"&&h.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=_;class C{constructor(f,l,o,w){this._id=f,this._configuration=o,this._ignorePathCasing=w,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class n{constructor(f,l){this.raw=l,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,R.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function P(c){return new n({uri:c,index:0,name:(0,R.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=P}),define(Ee[63],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class h{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const y=this._idPool++;return this._data.set(y,D),this.logDebugInfo(),y}get(D,y){return this._data.has(D)?this._data.get(D)[y]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!h.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=h,h.enableDebugLogging=!1}),define(Ee[64],_e([0,1,2,3,4]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class y{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(S){this._tabs=S.map(_=>({name:_.name,group:_.group,resource:h.URI.revive(_.resource),isActive:_.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=y}),define(Ee[45],_e([0,1,11,4]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class D{constructor(){this._systemSchemes=new Set(Object.keys(h.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(k,S){S===null?this._providerInfo.delete(k):this._providerInfo.set(k,S)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=D,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(Ee[28],_e([0,1,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,h.createDecorator)("IExtHostInitDataService")}),define(Ee[157],_e([0,1,2]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class R{constructor(y,k,S){this._extHostNotebooks=k,this._textDocumentsAndEditors=S}$willAddInteractiveDocument(y,k,S,_){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],modeId:S,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(h.URI.revive(_))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=R}),define(Ee[158],_e([0,1,16]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(k,S,_){this._deferredPromises=new Map,this._id=k,this._shared=S,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new h.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of C.values())n.complete()}catch(n){for(const P of C.values())P.error(n)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,k])=>k!==void 0).map(([k])=>k)}get whenReady(){return this._init}get(k,S){let _=this._value[k];return typeof _=="undefined"&&(_=S),_}update(k,S){this._value[k]=S;let _=this._deferredPromises.get(k);if(_!==void 0)return _.p;const C=new h.DeferredPromise;return this._deferredPromises.set(k,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class D extends R{constructor(k,S){super(k.identifier.value,!0,S);this._extension=k}setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}}e.ExtensionGlobalMemento=D}),define(Ee[159],_e([0,1,3,2,15]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let y=class{constructor(S,_){this._logService=S,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new h.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new h.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(S,_,C){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(S)).acceptModelChanged(_,C)}$acceptDirtyStateChanged(S,_){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(S)).acceptDirty(_)}$acceptModelSaved(S){const _=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(S));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(S,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",S.path,_);const C=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(S));C.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};y=He([ze(0,D.ILogService)],y),e.ExtHostNotebookDocuments=y}),define(Ee[13],_e([0,1,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,h.createDecorator)("IExtHostRpcService");class R{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=R});var it=this&&this.__classPrivateFieldSet||function(te,e,h,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(te,h):D?D.value=h:e.set(te,h),h},Ne=this&&this.__classPrivateFieldGet||function(te,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(te):R?R.value:e.get(te)};define(Ee[160],_e([0,1,26,3]),function(te,e,h,R){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(S,_){D.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=h.ExtensionIdentifier.toKey(S.identifier),it(this,D,_,"f"),Ne(this,D,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(S){return Ne(this,D,"f").get(this._id,S)}store(S,_){return Ne(this,D,"f").store(this._id,S,_)}delete(S){return Ne(this,D,"f").delete(this._id,S)}}e.ExtensionSecrets=y,D=new WeakMap}),define(Ee[93],_e([0,1,4,3]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(k){this._enabled=k}$onDidChangeTelemetryEnabled(k){this._enabled=k,this._onDidChangeTelemetryEnabled.fire(k)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,h.createDecorator)("IExtHostTelemetry")}),define(Ee[94],_e([0,1,3]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(k){k[k.NewChild=0]="NewChild",k[k.Disposed=1]="Disposed",k[k.Invalidated=2]="Invalidated",k[k.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const D=new WeakMap,y=k=>{let S=D.get(k);return S||(S={children:new Map,bus:new h.Emitter},D.set(k,S)),S};e.getPrivateApiFor=y}),define(Ee[65],_e([0,1,4,3,13]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var y;(function(S){function _(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,protocol:n.protocol}}S.fromApiTunnel=_;function C(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public,protocol:n.protocol}}S.fromServiceTunnel=C})(y=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,h.createDecorator)("IExtHostTunnelService");let k=class{constructor(_){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,C){return{dispose:()=>{}}}async $providePortAttributes(_,C,n,P,c){return[]}async $forwardPort(_,C){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=He([ze(0,D.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var it=this&&this.__classPrivateFieldSet||function(te,e,h,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(te,h):D?D.value=h:e.set(te,h),h},Ne=this&&this.__classPrivateFieldGet||function(te,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(te):R?R.value:e.get(te)};define(Ee[6],_e([0,1,17,12,80,22,82,10,2,35,60,91,94]),function(te,e,h,R,D,y,k,S,_,C,n,P,c){"use strict";var f,l,o,w,b,E,u,g,v,t,s,i,r,d,m,p,I,A,a,T;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestMessage=e.TestItemImpl=e.TestRunRequest=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function M(O){function L(){return Reflect.construct(O,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(O,"name")),Object.setPrototypeOf(L,O),Object.setPrototypeOf(L.prototype,O.prototype),L}let W=b=class{constructor(L){f.set(this,void 0),it(this,f,L,"f")}static from(...L){let ee=L;return new b(function(){if(ee){for(const De of ee)De&&typeof De.dispose=="function"&&De.dispose();ee=void 0}})}dispose(){typeof Ne(this,f,"f")=="function"&&(Ne(this,f,"f").call(this),it(this,f,void 0,"f"))}};f=new WeakMap,W=b=He([M],W),e.Disposable=W;let B=E=class{constructor(L,ee){if(L<0)throw(0,R.illegalArgument)("line must be non-negative");if(ee<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=L,this._character=ee}static Min(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let De=1;De<L.length;De++){const je=L[De];je.isBefore(ee)&&(ee=je)}return ee}static Max(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let De=1;De<L.length;De++){const je=L[De];je.isAfter(ee)&&(ee=je)}return ee}static isPosition(L){if(!L)return!1;if(L instanceof E)return!0;let{line:ee,character:De}=L;return typeof ee=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ee=0){if(L===null||ee===null)throw(0,R.illegalArgument)();let De;return typeof L=="undefined"?De=0:typeof L=="number"?De=L:(De=typeof L.lineDelta=="number"?L.lineDelta:0,ee=typeof L.characterDelta=="number"?L.characterDelta:0),De===0&&ee===0?this:new E(this.line+De,this.character+ee)}with(L,ee=this.character){if(L===null||ee===null)throw(0,R.illegalArgument)();let De;return typeof L=="undefined"?De=this.line:typeof L=="number"?De=L:(De=typeof L.line=="number"?L.line:this.line,ee=typeof L.character=="number"?L.character:this.character),De===this.line&&ee===this.character?this:new E(De,ee)}toJSON(){return{line:this.line,character:this.character}}};B=E=He([M],B),e.Position=B;let Z=u=class{constructor(L,ee,De,je){let nt,st;if(typeof L=="number"&&typeof ee=="number"&&typeof De=="number"&&typeof je=="number"?(nt=new B(L,ee),st=new B(De,je)):L instanceof B&&ee instanceof B&&(nt=L,st=ee),!nt||!st)throw new Error("Invalid arguments");nt.isBefore(st)?(this._start=nt,this._end=st):(this._start=st,this._end=nt)}static isRange(L){return L instanceof u?!0:L?B.isPosition(L.start)&&B.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof u?this.contains(L._start)&&this.contains(L._end):L instanceof B?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ee=B.Max(L.start,this._start),De=B.Min(L.end,this._end);if(!ee.isAfter(De))return new u(ee,De)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ee=B.Min(L.start,this._start),De=B.Max(L.end,this.end);return new u(ee,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ee=this.end){if(L===null||ee===null)throw(0,R.illegalArgument)();let De;return L?B.isPosition(L)?De=L:(De=L.start||this.start,ee=L.end||this.end):De=this.start,De.isEqual(this._start)&&ee.isEqual(this.end)?this:new u(De,ee)}toJSON(){return[this.start,this.end]}};Z=u=He([M],Z),e.Range=Z;let q=g=class extends Z{constructor(L,ee,De,je){let nt,st;if(typeof L=="number"&&typeof ee=="number"&&typeof De=="number"&&typeof je=="number"?(nt=new B(L,ee),st=new B(De,je)):L instanceof B&&ee instanceof B&&(nt=L,st=ee),!nt||!st)throw new Error("Invalid arguments");super(nt,st);this._anchor=nt,this._active=st}static isSelection(L){return L instanceof g?!0:L?Z.isRange(L)&&B.isPosition(L.anchor)&&B.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};q=g=He([M],q),e.Selection=q;class ${constructor(L,ee,De){if(typeof L!="string"||L.length===0)throw(0,R.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,R.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,R.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(ee),this.connectionToken=De}}e.ResolvedAuthority=$;class V extends Error{constructor(L,ee=P.RemoteAuthorityResolverErrorCode.Unknown,De){super(L);this._message=L,this._code=ee,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(L,ee){return new V(L,P.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(L){return new V(L,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var F;(function(O){O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(F=e.EndOfLine||(e.EndOfLine={}));var re;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(re=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let N=v=class{constructor(L,ee){this._range=L,this._newText=ee}static isTextEdit(L){return L instanceof v?!0:L?Z.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ee){return new v(L,ee)}static insert(L,ee){return v.replace(new Z(L,L),ee)}static delete(L){return v.replace(L,"")}static setEndOfLine(L){const ee=new v(new Z(new B(0,0),new B(0,0)),"");return ee.newEol=L,ee}get range(){return this._range}set range(L){if(L&&!Z.isRange(L))throw(0,R.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,R.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,R.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};N=v=He([M],N),e.TextEdit=N;var H;(function(O){O[O.File=1]="File",O[O.Text=2]="Text",O[O.Cell=3]="Cell",O[O.CellReplace=5]="CellReplace"})(H=e.FileEditType||(e.FileEditType={}));let J=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ee,De,je){this._edits.push({_type:1,from:L,to:ee,options:De,metadata:je})}createFile(L,ee,De){this._edits.push({_type:1,from:void 0,to:L,options:ee,metadata:De})}deleteFile(L,ee,De){this._edits.push({_type:1,from:L,to:void 0,options:ee,metadata:De})}replaceNotebookMetadata(L,ee,De){this._edits.push({_type:3,metadata:De,uri:L,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(L,ee,De,je,nt){let st,ot,Dt=[],Pt;if($t.isNotebookRange(ee)&&Ft.isNotebookCellDataArray(De)&&!Ft.isNotebookCellDataArray(je)?(st=ee.start,ot=ee.end,Dt=De,Pt=je):typeof ee=="number"&&typeof De=="number"&&Ft.isNotebookCellDataArray(je)&&(st=ee,ot=De,Dt=je,Pt=nt),st===void 0||ot===void 0)throw new Error("Invalid arguments");(st!==ot||Dt.length>0)&&this._edits.push({_type:5,uri:L,index:st,count:ot-st,cells:Dt,metadata:Pt})}replaceNotebookCellMetadata(L,ee,De,je){this._edits.push({_type:3,metadata:je,uri:L,edit:{editType:8,index:ee,metadata:De}})}replace(L,ee,De,je){this._edits.push({_type:2,uri:L,edit:new N(ee,De),metadata:je})}insert(L,ee,De,je){this.replace(L,new Z(ee,ee),De,je)}delete(L,ee,De){this.replace(L,ee,"",De)}has(L){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===L.toString())}set(L,ee){if(ee)for(const De of ee)De&&this._edits.push({_type:2,uri:L,edit:De});else{for(let De=0;De<this._edits.length;De++){const je=this._edits[De];je._type===2&&je.uri.toString()===L.toString()&&(this._edits[De]=void 0)}(0,h.coalesceInPlace)(this._edits)}}get(L){const ee=[];for(let De of this._edits)De._type===2&&De.uri.toString()===L.toString()&&ee.push(De.edit);return ee}entries(){const L=new y.ResourceMap;for(let ee of this._edits)if(ee._type===2){let De=L.get(ee.uri);De||(De=[ee.uri,[]],L.set(ee.uri,De)),De[1].push(ee.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};J=He([M],J),e.WorkspaceEdit=J;let K=t=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof t?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=t._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ee=this._tabstop++){if(typeof L=="function"){const De=new t;De._tabstop=this._tabstop,L(De),this._tabstop=De._tabstop,L=De.value}else L=t._escape(L);return this.value+="${",this.value+=ee,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ee=this._tabstop++){const De=L.map(je=>je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(L,ee){if(typeof ee=="function"){const De=new t;De._tabstop=this._tabstop,ee(De),this._tabstop=De._tabstop,ee=De.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};K=t=He([M],K),e.SnippetString=K;var le;(function(O){O[O.Unnecessary=1]="Unnecessary",O[O.Deprecated=2]="Deprecated"})(le=e.DiagnosticTag||(e.DiagnosticTag={}));var Ie;(function(O){O[O.Hint=3]="Hint",O[O.Information=2]="Information",O[O.Warning=1]="Warning",O[O.Error=0]="Error"})(Ie=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Me=s=class{constructor(L,ee){if(this.uri=L,ee)if(ee instanceof Z)this.range=ee;else if(ee instanceof B)this.range=new Z(ee,ee);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof s?!0:L?Z.isRange(L.range)&&_.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Me=s=He([M],Me),e.Location=Me;let Ve=class{constructor(L,ee){this.location=L,this.message=ee}static is(L){return L?typeof L.message=="string"&&L.location&&Z.isRange(L.location.range)&&_.URI.isUri(L.location.uri):!1}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.location.range.isEqual(ee.location.range)&&L.location.uri.toString()===ee.location.uri.toString()}};Ve=He([M],Ve),e.DiagnosticRelatedInformation=Ve;let xe=class{constructor(L,ee,De=Ie.Error){if(!Z.isRange(L))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=L,this.message=ee,this.severity=De}toJSON(){return{severity:Ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.severity===ee.severity&&L.code===ee.code&&L.severity===ee.severity&&L.source===ee.source&&L.range.isEqual(ee.range)&&(0,h.equals)(L.tags,ee.tags)&&(0,h.equals)(L.relatedInformation,ee.relatedInformation,Ve.isEqual)}};xe=He([M],xe),e.Diagnostic=xe;let Ge=class{constructor(L,ee){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ee}};Ge=He([M],Ge),e.Hover=Ge;var Ke;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(Ke=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let qe=class{constructor(L,ee=Ke.Text){this.range=L,this.kind=ee}toJSON(){return{range:this.range,kind:Ke[this.kind]}}};qe=He([M],qe),e.DocumentHighlight=qe;var U;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(U=e.SymbolKind||(e.SymbolKind={}));var G;(function(O){O[O.Deprecated=1]="Deprecated"})(G=e.SymbolTag||(e.SymbolTag={}));let ne=i=class{constructor(L,ee,De,je,nt){this.name=L,this.kind=ee,this.containerName=nt,typeof De=="string"&&(this.containerName=De),je instanceof Me?this.location=je:De instanceof Z&&(this.location=new Me(je,De)),i.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:U[this.kind],location:this.location,containerName:this.containerName}}};ne=i=He([M],ne),e.SymbolInformation=ne;let se=r=class{constructor(L,ee,De,je,nt){this.name=L,this.detail=ee,this.kind=De,this.range=je,this.selectionRange=nt,this.children=[],r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(r.validate)}};se=r=He([M],se),e.DocumentSymbol=se;var ge;(function(O){O[O.Invoke=1]="Invoke",O[O.Automatic=2]="Automatic"})(ge=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let X=class{constructor(L,ee){this.title=L,this.kind=ee}};X=He([M],X),e.CodeAction=X;let ce=d=class{constructor(L){this.value=L}append(L){return new d(this.value?this.value+d.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+d.sep)}};ce.sep=".",ce=d=He([M],ce),e.CodeActionKind=ce,ce.Empty=new ce(""),ce.QuickFix=ce.Empty.append("quickfix"),ce.Refactor=ce.Empty.append("refactor"),ce.RefactorExtract=ce.Refactor.append("extract"),ce.RefactorInline=ce.Refactor.append("inline"),ce.RefactorRewrite=ce.Refactor.append("rewrite"),ce.Source=ce.Empty.append("source"),ce.SourceOrganizeImports=ce.Source.append("organizeImports"),ce.SourceFixAll=ce.Source.append("fixAll");let ke=class{constructor(L,ee){if(this.range=L,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=He([M],ke),e.SelectionRange=ke;class Be{constructor(L,ee,De,je,nt,st){this.kind=L,this.name=ee,this.detail=De,this.uri=je,this.range=nt,this.selectionRange=st}}e.CallHierarchyItem=Be;class $e{constructor(L,ee){this.fromRanges=ee,this.from=L}}e.CallHierarchyIncomingCall=$e;class pe{constructor(L,ee){this.fromRanges=ee,this.to=L}}e.CallHierarchyOutgoingCall=pe;let tt=class{constructor(L,ee){this.range=L,this.command=ee}get isResolved(){return!!this.command}};tt=He([M],tt),e.CodeLens=tt;let z=m=class{constructor(L,ee=!1){l.set(this,void 0),it(this,l,new D.MarkdownString(L,{supportThemeIcons:ee}),"f")}static isMarkdownString(L){return L instanceof m?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Ne(this,l,"f").value}set value(L){Ne(this,l,"f").value=L}get isTrusted(){return Ne(this,l,"f").isTrusted}set isTrusted(L){Ne(this,l,"f").isTrusted=L}get supportThemeIcons(){return Ne(this,l,"f").supportThemeIcons}set supportThemeIcons(L){Ne(this,l,"f").supportThemeIcons=L}appendText(L){return Ne(this,l,"f").appendText(L),this}appendMarkdown(L){return Ne(this,l,"f").appendMarkdown(L),this}appendCodeblock(L,ee){return Ne(this,l,"f").appendCodeblock(ee??"",L),this}};l=new WeakMap,z=m=He([M],z),e.MarkdownString=z;let Q=class{constructor(L,ee){this.label=L,this.documentation=ee}};Q=He([M],Q),e.ParameterInformation=Q;let fe=class{constructor(L,ee){this.label=L,this.documentation=ee,this.parameters=[]}};fe=He([M],fe),e.SignatureInformation=fe;let Le=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Le=He([M],Le),e.SignatureHelp=Le;var Ue;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(Ue=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ze;(function(O){O[O.Other=0]="Other",O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(Ze=e.InlayHintKind||(e.InlayHintKind={}));let Ce=class{constructor(L,ee,De){this.text=L,this.position=ee,this.kind=De}};Ce=He([M],Ce),e.InlayHint=Ce;var Se;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Pe;(function(O){O[O.Text=0]="Text",O[O.Method=1]="Method",O[O.Function=2]="Function",O[O.Constructor=3]="Constructor",O[O.Field=4]="Field",O[O.Variable=5]="Variable",O[O.Class=6]="Class",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Unit=10]="Unit",O[O.Value=11]="Value",O[O.Enum=12]="Enum",O[O.Keyword=13]="Keyword",O[O.Snippet=14]="Snippet",O[O.Color=15]="Color",O[O.File=16]="File",O[O.Reference=17]="Reference",O[O.Folder=18]="Folder",O[O.EnumMember=19]="EnumMember",O[O.Constant=20]="Constant",O[O.Struct=21]="Struct",O[O.Event=22]="Event",O[O.Operator=23]="Operator",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue"})(Pe=e.CompletionItemKind||(e.CompletionItemKind={}));var ie;(function(O){O[O.Deprecated=1]="Deprecated"})(ie=e.CompletionItemTag||(e.CompletionItemTag={}));let ae=class{constructor(L,ee){this.label=L,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&Pe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ae=He([M],ae),e.CompletionItem=ae;let de=class{constructor(L=[],ee=!1){this.items=L,this.isIncomplete=ee}};de=He([M],de),e.CompletionList=de;let me=class{constructor(L,ee,De){this.text=L,this.range=ee,this.command=De}};me=He([M],me),e.InlineSuggestion=me;let x=class{constructor(L){this.items=L}};x=He([M],x),e.InlineSuggestions=x;var he;(function(O){O[O.Active=-1]="Active",O[O.Beside=-2]="Beside",O[O.One=1]="One",O[O.Two=2]="Two",O[O.Three=3]="Three",O[O.Four=4]="Four",O[O.Five=5]="Five",O[O.Six=6]="Six",O[O.Seven=7]="Seven",O[O.Eight=8]="Eight",O[O.Nine=9]="Nine"})(he=e.ViewColumn||(e.ViewColumn={}));var be;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(be=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(O){O[O.Off=0]="Off",O[O.On=1]="On",O[O.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Fe;(function(O){O[O.Manual=1]="Manual",O[O.AfterDelay=2]="AfterDelay",O[O.FocusOut=3]="FocusOut"})(Fe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var We;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(We=e.TextEditorRevealType||(e.TextEditorRevealType={}));var et;(function(O){O[O.Keyboard=1]="Keyboard",O[O.Mouse=2]="Mouse",O[O.Command=3]="Command"})(et=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(O){O[O.Undo=1]="Undo",O[O.Redo=2]="Redo"})(Qe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ye;(function(O){O[O.OpenOpen=0]="OpenOpen",O[O.ClosedClosed=1]="ClosedClosed",O[O.OpenClosed=2]="OpenClosed",O[O.ClosedOpen=3]="ClosedOpen"})(Ye=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(O){function L(ee){switch(ee){case"keyboard":return O.Keyboard;case"mouse":return O.Mouse;case"api":return O.Command}}O.fromValue=L}(et=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let lt=class{constructor(L,ee){if(ee&&!_.URI.isUri(ee))throw(0,R.illegalArgument)("target");if(!Z.isRange(L)||L.isEmpty)throw(0,R.illegalArgument)("range");this.range=L,this.target=ee}};lt=He([M],lt),e.DocumentLink=lt;let ct=class{constructor(L,ee,De,je){this.red=L,this.green=ee,this.blue=De,this.alpha=je}};ct=He([M],ct),e.Color=ct;let ve=class{constructor(L,ee){if(ee&&!(ee instanceof ct))throw(0,R.illegalArgument)("color");if(!Z.isRange(L)||L.isEmpty)throw(0,R.illegalArgument)("range");this.range=L,this.color=ee}};ve=He([M],ve),e.ColorInformation=ve;let we=class{constructor(L){if(!L||typeof L!="string")throw(0,R.illegalArgument)("label");this.label=L}};we=He([M],we),e.ColorPresentation=we;var oe;(function(O){O[O.RGB=0]="RGB",O[O.HEX=1]="HEX",O[O.HSL=2]="HSL"})(oe=e.ColorFormat||(e.ColorFormat={}));var j;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information"})(j=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Oe{constructor(L,ee,De){if(this.startIndex=L,this.length=ee,this.tooltip=De,typeof L!="number"||L<0)throw(0,R.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,R.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=Oe;class ye{constructor(L){this.options=L,typeof L!="object"&&(0,R.illegalArgument)("options")}}e.TerminalProfile=ye;var Xe;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(Xe=e.TaskRevealKind||(e.TaskRevealKind={}));var Je;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(Je=e.TaskPanelKind||(e.TaskPanelKind={}));let rt=p=class{constructor(L,ee){if(typeof L!="string"||typeof ee!="string")throw(0,R.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}get id(){return this._id}};rt.Clean=new p("clean","Clean"),rt.Build=new p("build","Build"),rt.Rebuild=new p("rebuild","Rebuild"),rt.Test=new p("test","Test"),rt=p=He([M],rt),e.TaskGroup=rt;function mt(O){let L="";for(let ee=0;ee<O.length;ee++)L+=O[ee].replace(/,/g,",,")+",";return L}let wt=class{constructor(L,ee,De){if(typeof L!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=L,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=De):this._options=ee)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,R.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)L.push(ee);return mt(L)}};wt=He([M],wt),e.ProcessExecution=wt;let bt=class{constructor(L,ee,De){if(this._args=[],Array.isArray(ee)){if(!L)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,R.illegalArgument)("command");this._command=L,this._args=ee,this._options=De}else{if(typeof L!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=L,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,R.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)L.push(typeof ee=="string"?ee:ee.value);return mt(L)}};bt=He([M],bt),e.ShellExecution=bt;var Ct;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(Ct=e.ShellQuoting||(e.ShellQuoting={}));var St;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace"})(St=e.TaskScope||(e.TaskScope={}));class Tt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,C.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=Tt;let gt=I=class{constructor(L,ee,De,je,nt,st){this.__deprecated=!1,this._definition=this.definition=L;let ot;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=De,this.execution=je,ot=nt,this.__deprecated=!0):ee===St.Global||ee===St.Workspace?(this.target=ee,this._name=this.name=De,this._source=this.source=je,this.execution=nt,ot=st):(this.target=ee,this._name=this.name=De,this._source=this.source=je,this.execution=nt,ot=st),typeof ot=="string"?(this._problemMatchers=[ot],this._hasDefinedMatchers=!0):Array.isArray(ot)?(this._problemMatchers=ot,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof wt?this._definition={type:I.ProcessType,id:this._execution.computeId()}:this._execution instanceof bt?this._definition={type:I.ShellType,id:this._execution.computeId()}:this._execution instanceof Tt?this._definition={type:I.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:I.EmptyType,id:(0,C.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ee=this._definition.type;(I.EmptyType===ee||I.ProcessType===ee||I.ShellType===ee||I.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};gt.ExtensionCallbackType="customExecution",gt.ProcessType="process",gt.ShellType="shell",gt.EmptyType="$empty",gt=I=He([M],gt),e.Task=gt;var dt;(function(O){O[O.SourceControl=1]="SourceControl",O[O.Window=10]="Window",O[O.Notification=15]="Notification"})(dt=e.ProgressLocation||(e.ProgressLocation={}));let pt=class{constructor(L,ee=Et.None){this.collapsibleState=ee,_.URI.isUri(L)?this.resourceUri=L:this.label=L}};pt=He([M],pt),e.TreeItem=pt;var Et;(function(O){O[O.None=0]="None",O[O.Collapsed=1]="Collapsed",O[O.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let At=class{constructor(L,ee){this.id=L,this.color=ee}};At=He([M],At),e.ThemeIcon=At,At.File=new At("file"),At.Folder=new At("folder");let kt=class{constructor(L){this.id=L}};kt=He([M],kt),e.ThemeColor=kt;var _n;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.WorkspaceFolder=3]="WorkspaceFolder"})(_n=e.ConfigurationTarget||(e.ConfigurationTarget={}));let qt=class{constructor(L,ee){if(typeof L!="string"&&(!L||!_.URI.isUri(L)&&!_.URI.isUri(L.uri)))throw(0,R.illegalArgument)("base");if(typeof ee!="string")throw(0,R.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=_.URI.file(L),this.base=L):_.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=ee}};qt=He([M],qt),e.RelativePattern=qt;let yt=class{constructor(L,ee,De,je){this.enabled=typeof L=="boolean"?L:!0,typeof ee=="string"&&(this.condition=ee),typeof De=="string"&&(this.hitCondition=De),typeof je=="string"&&(this.logMessage=je)}get id(){return this._id||(this._id=(0,C.generateUuid)()),this._id}};yt=He([M],yt),e.Breakpoint=yt;let Yt=class extends yt{constructor(L,ee,De,je,nt){super(ee,De,je,nt);if(L===null)throw(0,R.illegalArgument)("location");this.location=L}};Yt=He([M],Yt),e.SourceBreakpoint=Yt;let Jt=class extends yt{constructor(L,ee,De,je,nt){super(ee,De,je,nt);this.functionName=L}};Jt=He([M],Jt),e.FunctionBreakpoint=Jt;let ht=class extends yt{constructor(L,ee,De,je,nt,st,ot){super(je,nt,st,ot);if(!ee)throw(0,R.illegalArgument)("dataId");this.label=L,this.dataId=ee,this.canPersist=De}};ht=He([M],ht),e.DataBreakpoint=ht;let jt=class{constructor(L,ee,De){this.command=L,this.args=ee||[],this.options=De}};jt=He([M],jt),e.DebugAdapterExecutable=jt;let Ht=class{constructor(L,ee){this.port=L,this.host=ee}};Ht=He([M],Ht),e.DebugAdapterServer=Ht;let Xt=class{constructor(L){this.path=L}};Xt=He([M],Xt),e.DebugAdapterNamedPipeServer=Xt;let Zt=class{constructor(L){this.implementation=L}};Zt=He([M],Zt),e.DebugAdapterInlineImplementation=Zt;let It=class{constructor(L,ee){this.range=L,this.expression=ee}};It=He([M],It),e.EvaluatableExpression=It;var hn;(function(O){O[O.Automatic=0]="Automatic",O[O.Explicit=1]="Explicit"})(hn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let en=class{constructor(L,ee){this.range=L,this.text=ee}};en=He([M],en),e.InlineValueText=en;let Bt=class{constructor(L,ee,De=!0){this.range=L,this.variableName=ee,this.caseSensitiveLookup=De}};Bt=He([M],Bt),e.InlineValueVariableLookup=Bt;let ut=class{constructor(L,ee){this.range=L,this.expression=ee}};ut=He([M],ut),e.InlineValueEvaluatableExpression=ut;let tn=class{constructor(L,ee){this.frameId=L,this.stoppedLocation=ee}};tn=He([M],tn),e.InlineValueContext=tn;var Nt;(function(O){O[O.Changed=1]="Changed",O[O.Created=2]="Created",O[O.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let Ot=A=class extends Error{constructor(L,ee=n.FileSystemProviderErrorCode.Unknown,De){super(_.URI.isUri(L)?L.toString(!0):L);this.code=De?.name??"Unknown",(0,n.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(L){return new A(L,n.FileSystemProviderErrorCode.FileExists,A.FileExists)}static FileNotFound(L){return new A(L,n.FileSystemProviderErrorCode.FileNotFound,A.FileNotFound)}static FileNotADirectory(L){return new A(L,n.FileSystemProviderErrorCode.FileNotADirectory,A.FileNotADirectory)}static FileIsADirectory(L){return new A(L,n.FileSystemProviderErrorCode.FileIsADirectory,A.FileIsADirectory)}static NoPermissions(L){return new A(L,n.FileSystemProviderErrorCode.NoPermissions,A.NoPermissions)}static Unavailable(L){return new A(L,n.FileSystemProviderErrorCode.Unavailable,A.Unavailable)}};Ot=A=He([M],Ot),e.FileSystemError=Ot;let Gt=class{constructor(L,ee,De){this.start=L,this.end=ee,this.kind=De}};Gt=He([M],Gt),e.FoldingRange=Gt;var yn;(function(O){O[O.Comment=1]="Comment",O[O.Imports=2]="Imports",O[O.Region=3]="Region"})(yn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Sn;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(Sn=e.CommentMode||(e.CommentMode={}));class mn{constructor(L,ee=[]){this.tokenTypes=L,this.tokenModifiers=ee}}e.SemanticTokensLegend=mn;function nn(O){return typeof O=="undefined"||(0,S.isStringArray)(O)}class rn{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ee=0,De=L.tokenTypes.length;ee<De;ee++)this._tokenTypeStrToInt.set(L.tokenTypes[ee],ee);for(let ee=0,De=L.tokenModifiers.length;ee<De;ee++)this._tokenModifierStrToInt.set(L.tokenModifiers[ee],ee)}}push(L,ee,De,je,nt){if(typeof L=="number"&&typeof ee=="number"&&typeof De=="number"&&typeof je=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(L,ee,De,je,nt);if(Z.isRange(L)&&typeof ee=="string"&&nn(De))return this._push(L,ee,De);throw(0,R.illegalArgument)()}_push(L,ee,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const je=L.start.line,nt=L.start.character,st=L.end.character-L.start.character,ot=this._tokenTypeStrToInt.get(ee);let Dt=0;if(De)for(const Pt of De){if(!this._tokenModifierStrToInt.has(Pt))throw new Error("`tokenModifier` is not in the provided legend");const Rt=this._tokenModifierStrToInt.get(Pt);Dt|=1<<Rt>>>0}this._pushEncoded(je,nt,st,ot,Dt)}_pushEncoded(L,ee,De,je,nt){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Pt=0,Rt=0;for(let Lt=0;Lt<Dt;Lt++){let Ut=this._data[5*Lt],cn=this._data[5*Lt+1];Ut===0?(Ut=Pt,cn+=Rt):Ut+=Pt,this._data[5*Lt]=Ut,this._data[5*Lt+1]=cn,Pt=Ut,Rt=cn}}let st=L,ot=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ot-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ot,this._data[this._dataLen++]=De,this._data[this._dataLen++]=je,this._data[this._dataLen++]=nt,this._prevLine=L,this._prevChar=ee}static _sortAndDeltaEncode(L){let ee=[];const De=L.length/5|0;for(let ot=0;ot<De;ot++)ee[ot]=ot;ee.sort((ot,Dt)=>{const Pt=L[5*ot],Rt=L[5*Dt];if(Pt===Rt){const Lt=L[5*ot+1],Ut=L[5*Dt+1];return Lt-Ut}return Pt-Rt});const je=new Uint32Array(L.length);let nt=0,st=0;for(let ot=0;ot<De;ot++){const Dt=5*ee[ot],Pt=L[Dt+0],Rt=L[Dt+1],Lt=L[Dt+2],Ut=L[Dt+3],cn=L[Dt+4],$n=Pt-nt,Kn=$n===0?Rt-st:Rt,dn=5*ot;je[dn+0]=$n,je[dn+1]=Kn,je[dn+2]=Lt,je[dn+3]=Ut,je[dn+4]=cn,nt=Pt,st=Rt}return je}build(L){return this._dataIsSortedAndDeltaEncoded?new zt(new Uint32Array(this._data),L):new zt(rn._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=rn;class zt{constructor(L,ee){this.resultId=ee,this.data=L}}e.SemanticTokens=zt;class sn{constructor(L,ee,De){this.start=L,this.deleteCount=ee,this.data=De}}e.SemanticTokensEdit=sn;class Dn{constructor(L,ee){this.resultId=ee,this.edits=L}}e.SemanticTokensEdits=Dn;var Cn;(function(O){O[O.Separate=0]="Separate",O[O.MergeWithParent=1]="MergeWithParent"})(Cn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Vt;(function(O){O[O.Initial=1]="Initial",O[O.Dynamic=2]="Dynamic"})(Vt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Kt=class{constructor(){}};Kt.Back={iconPath:new At("arrow-left")},Kt=He([M],Kt),e.QuickInputButtons=Kt;var kn;(function(O){O[O.UI=1]="UI",O[O.Workspace=2]="Workspace"})(kn=e.ExtensionKind||(e.ExtensionKind={}));class In{constructor(L,ee,De){this.badge=L,this.tooltip=ee,this.color=De}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=In;let on=class{constructor(L){this.kind=L}};on=He([M],on),e.ColorTheme=on;var an;(function(O){O[O.Light=1]="Light",O[O.Dark=2]="Dark",O[O.HighContrast=3]="HighContrast"})(an=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(L,ee){if(L<0)throw(0,R.illegalArgument)("start must be positive");if(ee<0)throw(0,R.illegalArgument)("end must be positive");L<=ee?(this._start=L,this._end=ee):(this._start=ee,this._end=L)}static isNotebookRange(L){return L instanceof $t?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let ee=this._start,De=this._end;return L.start!==void 0&&(ee=L.start),L.end!==void 0&&(De=L.end),ee===this._start&&De===this._end?this:new $t(ee,De)}}e.NotebookRange=$t;class Ft{constructor(L,ee,De,je,nt,st,ot){this.kind=L,this.value=ee,this.languageId=De,this.mime=je,this.outputs=nt??[],this.metadata=st,this.executionSummary=ot,Ft.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ee=>Ft.isNotebookCellData(ee))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Ft;class ln{constructor(L){this.cells=L}}e.NotebookData=ln;class Re{constructor(L,ee){this.data=L,this.mime=ee;const De=(0,k.normalizeMimeType)(ee,!0);if(!De)throw new Error("INVALID mime type, must not be empty or falsy: "+ee);this.mime=De}static isNotebookCellOutputItem(L){return L instanceof Re?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ee={name:L.name,message:L.message,stack:L.stack};return Re.json(ee,"application/vnd.code.notebook.error")}static stdout(L){return Re.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Re.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ee="application/octet-stream"){return new Re(L,ee)}static text(L,ee=k.Mimes.text){const De=Ne(Re,o,"f",w).encode(String(L));return new Re(De,ee)}static json(L,ee="application/json"){const De=JSON.stringify(L,void 0,"	");return Re.text(De,ee)}}e.NotebookCellOutputItem=Re,o=Re,w={value:new TextEncoder};class Wt{constructor(L,ee,De){this.items=Wt.ensureUniqueMimeTypes(L,!0),typeof ee=="string"?(this.id=ee,this.metadata=De):(this.id=(0,C.generateUuid)(),this.metadata=ee??De)}static isNotebookCellOutput(L){return L instanceof Wt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,S.isArray)(L.items)}static ensureUniqueMimeTypes(L,ee=!1){const De=new Set,je=new Set;for(let nt=0;nt<L.length;nt++){const st=L[nt],ot=(0,k.normalizeMimeType)(st.mime);if(!De.has(ot)){De.add(ot);continue}je.add(nt),ee&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return je.size===0?L:L.filter((nt,st)=>!je.has(st))}}e.NotebookCellOutput=Wt;var gn;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(gn=e.NotebookCellKind||(e.NotebookCellKind={}));var ft;(function(O){O[O.Idle=1]="Idle",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(ft=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Pn;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(Pn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var An;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(An=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pn{constructor(L,ee){this.text=L,this.alignment=ee}}e.NotebookCellStatusBarItem=pn;var vn;(function(O){O[O.Default=1]="Default",O[O.Preferred=2]="Preferred"})(vn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Tn{constructor(L,ee=[]){this.uri=L,this.provides=(0,h.asArray)(ee)}}e.NotebookRendererScript=Tn;let un=class{constructor(L,ee){this.label=L,this.timestamp=ee}};un=He([M],un),e.TimelineItem=un;var Rn;(function(O){O[O.Production=1]="Production",O[O.Development=2]="Development",O[O.Test=3]="Test"})(Rn=e.ExtensionMode||(e.ExtensionMode={}));var Fn;(function(O){O[O.Node=1]="Node",O[O.Webworker=2]="Webworker"})(Fn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var bn;(function(O){O[O.Other=0]="Other",O[O.Comment=1]="Comment",O[O.String=2]="String",O[O.RegEx=4]="RegEx"})(bn=e.StandardTokenType||(e.StandardTokenType={}));class Mn{constructor(L,ee){this.ranges=L,this.wordPattern=ee}}e.LinkedEditingRanges=Mn;class Ln{constructor(L,ee){this._port=L,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ln;var Nn;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(Nn=e.TestResultState||(e.TestResultState={}));var wn;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information",O[O.Hint=3]="Hint"})(wn=e.TestMessageSeverity||(e.TestMessageSeverity={}));const Mt=(O,L,ee,De)=>{let je=ee;return{enumerable:!0,configurable:!1,get(){return je},set(nt){De(je,nt)||(je=nt,O.bus.fire([3,L,nt]))}}},Y=(O,L)=>O===L,ue=(O,L)=>O===L?!0:!O||!L?!1:O.isEqual(L);class Te{constructor(L,ee,De=!1){this.tests=L,this.exclude=ee,this.debug=De}}e.TestRunRequest=Te;class at{constructor(L,ee,De,je,nt){this.data=je;const st=(0,c.getPrivateApiFor)(this);if(Object.defineProperties(this,{id:{value:L,enumerable:!0,writable:!1},uri:{value:De,enumerable:!0,writable:!1},parent:{enumerable:!1,value:nt,writable:!1},children:{value:new y.ReadonlyMapView(st.children),enumerable:!0,writable:!1},range:Mt(st,"range",void 0,ue),label:Mt(st,"label",ee,Y),description:Mt(st,"description",void 0,Y),runnable:Mt(st,"runnable",!0,Y),debuggable:Mt(st,"debuggable",!1,Y),canResolveChildren:Mt(st,"canResolveChildren",!1,Y),busy:Mt(st,"busy",!1,Y),error:Mt(st,"error",void 0,Y)}),nt){if(!(nt instanceof at))throw new Error(`The "parent" passed in for TestItem ${L} is invalid`);const ot=(0,c.getPrivateApiFor)(nt);if(ot.children.has(L))throw new Error(`Attempted to insert a duplicate test item ID ${L}`);ot.children.set(L,this),ot.bus.fire([0,this])}}invalidate(){return this.invalidateResults()}invalidateResults(){(0,c.getPrivateApiFor)(this).bus.fire([2])}dispose(){this.parent&&(0,c.getPrivateApiFor)(this.parent).children.delete(this.id),(0,c.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemImpl=at;let vt=a=class{constructor(L){this.message=L,this.severity=wn.Error}static diff(L,ee,De){const je=new a(L);return je.expectedOutput=ee,je.actualOutput=De,je}};vt=a=He([M],vt),e.TestMessage=vt;let _t=class{constructor(L,ee){this.covered=L,this.total=ee}};_t=He([M],_t),e.CoveredCount=_t;let On=T=class{constructor(L,ee,De,je){this.uri=L,this.statementCoverage=ee,this.branchCoverage=De,this.functionCoverage=je}static fromDetails(L,ee){const De=new _t(0,0),je=new _t(0,0),nt=new _t(0,0);for(const ot of ee)if("branches"in ot){De.total+=1,De.covered+=ot.executionCount>0?1:0;for(const Dt of ot.branches)je.total+=1,je.covered+=Dt.executionCount>0?1:0}else nt.total+=1,nt.covered+=ot.executionCount>0?1:0;const st=new T(L,De,je.total>0?je:void 0,nt.total>0?nt:void 0);return st.detailedCoverage=ee,st}};On=T=He([M],On),e.FileCoverage=On;let Un=class{constructor(L,ee,De=[]){this.executionCount=L,this.location=ee,this.branches=De}};Un=He([M],Un),e.StatementCoverage=Un;let xn=class{constructor(L,ee){this.executionCount=L,this.location=ee}};xn=He([M],xn),e.BranchCoverage=xn;let Bn=class{constructor(L,ee){this.executionCount=L,this.location=ee}};Bn=He([M],Bn),e.FunctionCoverage=Bn;var qn;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(qn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var jn;(function(O){O[O.Untrusted=0]="Untrusted",O[O.Trusted=1]="Trusted",O[O.Unspecified=2]="Unspecified"})(jn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Gn;(function(O){O[O.Notify=1]="Notify",O[O.OpenBrowser=2]="OpenBrowser",O[O.OpenPreview=3]="OpenPreview",O[O.Silent=4]="Silent",O[O.Ignore=5]="Ignore",O[O.OpenBrowserOnce=6]="OpenBrowserOnce"})(Gn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(Ee[95],_e([0,1,39,11,8,121,85,6,17]),function(te,e,h,R,D,y,k,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function n(l,o){o?C.set(l,o):C.delete(l)}e.setWordDefinitionFor=n;function P(l){return C.get(l)}e.getWordDefinitionFor=P;class c extends y.MirrorTextModel{constructor(o,w,b,E,u,g,v,t){super(w,b,E,u);this._proxy=o,this._languageId=g,this._isDirty=v,this._notebook=t,this._isDisposed=!1}dispose(){(0,h.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(o){return(0,_.equals)(this._lines,o)}get document(){if(!this._document){const o=this;this._document={get uri(){return o._uri},get fileName(){return o._uri.fsPath},get isUntitled(){return o._uri.scheme===R.Schemas.untitled},get languageId(){return o._languageId},get version(){return o._versionId},get isClosed(){return o._isDisposed},get isDirty(){return o._isDirty},get notebook(){return o._notebook},save(){return o._save()},getText(w){return w?o._getTextInRange(w):o.getText()},get eol(){return o._eol===`
`?S.EndOfLine.LF:S.EndOfLine.CRLF},get lineCount(){return o._lines.length},lineAt(w){return o._lineAt(w)},offsetAt(w){return o._offsetAt(w)},positionAt(w){return o._positionAt(w)},validateRange(w){return o._validateRange(w)},validatePosition(w){return o._validatePosition(w)},getWordRangeAtPosition(w,b){return o._getWordRangeAtPosition(w,b)}}}return Object.freeze(this._document)}_acceptLanguageId(o){(0,h.ok)(!this._isDisposed),this._languageId=o}_acceptIsDirty(o){(0,h.ok)(!this._isDisposed),this._isDirty=o}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(o){const w=this._validateRange(o);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const b=this._eol,E=w.start.line,u=w.end.line,g=[];g.push(this._lines[E].substring(w.start.character));for(let v=E+1;v<u;v++)g.push(this._lines[v]);return g.push(this._lines[u].substring(0,w.end.character)),g.join(b)}_lineAt(o){let w;if(o instanceof S.Position?w=o.line:typeof o=="number"&&(w=o),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new f(w,this._lines[w],w===this._lines.length-1)}_offsetAt(o){return o=this._validatePosition(o),this._ensureLineStarts(),this._lineStarts.getPrefixSum(o.line-1)+o.character}_positionAt(o){o=Math.floor(o),o=Math.max(0,o),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(o),b=this._lines[w.index].length;return new S.Position(w.index,Math.min(w.remainder,b))}_validateRange(o){if(!(o instanceof S.Range))throw new Error("Invalid argument");const w=this._validatePosition(o.start),b=this._validatePosition(o.end);return w===o.start&&b===o.end?o:new S.Range(w.line,w.character,b.line,b.character)}_validatePosition(o){if(!(o instanceof S.Position))throw new Error("Invalid argument");if(this._lines.length===0)return o.with(0,0);let{line:w,character:b}=o,E=!1;if(w<0)w=0,b=0,E=!0;else if(w>=this._lines.length)w=this._lines.length-1,b=this._lines[w].length,E=!0;else{const u=this._lines[w].length;b<0?(b=0,E=!0):b>u&&(b=u,E=!0)}return E?new S.Position(w,b):o}_getWordRangeAtPosition(o,w){const b=this._validatePosition(o);if(!w)w=P(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const E=(0,k.getWordAtText)(b.character+1,(0,k.ensureValidWordDefinition)(w),this._lines[b.line],0);if(E)return new S.Range(b.line,E.startColumn-1,b.line,E.endColumn-1)}}e.ExtHostDocumentData=c;class f{constructor(o,w,b){this._line=o,this._text=w,this._isLastLine=b}get lineNumber(){return this._line}get text(){return this._text}get range(){return new S.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new S.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(Ee[161],_e([0,1,6,3,87,7,55,22,2,35]),function(te,e,h,R,D,y,k,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(c,f,l,o){this._notebook=l,this._selector=o,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,C.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(b=>{const E=this._cellUris.get(b.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const w=b=>{b===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(b=>w(b.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new S.ResourceMap;const c=[],f=[];for(const l of this._notebook.getCells())l.kind===h.NotebookCellKind.Code&&(!this._selector||(0,k.score)(this._selector,l.document.uri,l.document.languageId,!0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),c.push(l.document.getText().length+1),f.push(l.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(c){if(!c){let E="";for(const u of this._cells)E+=u.document.getText()+`
`;return E=E.slice(0,-1),E}if(c.isEmpty)return"";const f=this.locationAt(c.start),l=this.locationAt(c.end),o=this._cellUris.get(f.uri),w=this._cellUris.get(l.uri);if(o===void 0||w===void 0)return"";if(o===w)return this._cells[o].document.getText(new h.Range(f.range.start,l.range.end));const b=[this._cells[o].document.getText(new h.Range(f.range.start,new h.Position(this._cells[o].document.lineCount,0)))];for(let E=o+1;E<w;E++)b.push(this._cells[E].document.getText());return b.push(this._cells[w].document.getText(new h.Range(new h.Position(0,0),l.range.end))),b.join(`
`)}offsetAt(c){const f=this._cellLines.getIndexOf(c.line),l=this._cellLengths.getPrefixSum(f.index-1),o=this._cells[f.index].document.offsetAt(c.with(f.remainder));return l+o}positionAt(c){if(typeof c=="number"){const l=this._cellLengths.getIndexOf(c),o=this._cellLines.getPrefixSum(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(o)}const f=this._cellUris.get(c.uri);if(f!==void 0){const l=this._cellLines.getPrefixSum(f-1);return new h.Position(l+c.range.start.line,c.range.start.character)}return new h.Position(0,0)}locationAt(c){h.Range.isRange(c)||(c=new h.Range(c,c));const f=this._cellLines.getIndexOf(c.start.line);let l=f;c.isEmpty||(l=this._cellLines.getIndexOf(c.end.line));const o=new h.Position(f.remainder,c.start.character),w=new h.Position(l.remainder,c.end.character),b=new h.Range(o,w),E=this._cells[f.index];return new h.Location(E.document.uri,E.document.validateRange(b))}contains(c){return this._cellUris.has(c)}validateRange(c){const f=this.validatePosition(c.start),l=this.validatePosition(c.end);return c.with(f,l)}validatePosition(c){const f=this._cellLines.getIndexOf(c.line),l=new h.Position(f.remainder,c.character),o=this._cells[f.index].document.validatePosition(l),w=this._cellLines.getPrefixSum(f.index-1);return new h.Position(w+o.line,o.character)}}e.ExtHostNotebookConcatDocument=n}),define(Ee[162],_e([0,1,6,13,3]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(S){this._actual=new h.ColorTheme(h.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(S){let _=S==="light"?h.ColorThemeKind.Light:S==="dark"?h.ColorThemeKind.Dark:h.ColorThemeKind.HighContrast;this._actual=new h.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=He([ze(0,R.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(Ee[66],_e([0,1,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,h.createDecorator)("IURITransformerService");class R{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=R}),define(Ee[163],_e([0,1,23]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(_){let C=this.buffers.indexOf(_);return C<0&&(C=this.buffers.length,this.buffers.push(_)),C}}function D(S,_){if(_.serializeBuffersForPostMessage){const C=new R,n=(f,l)=>{if(l instanceof ArrayBuffer){const o=C.add(l);return{$$vscode_array_buffer_reference$$:!0,index:o}}else if(ArrayBuffer.isView(l)){const o=y(l);if(o){const w=C.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:o,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},P=JSON.stringify(S,n),c=C.buffers.map(f=>{const l=new Uint8Array(f);return h.VSBuffer.wrap(l)});return{message:P,buffers:c}}else return{message:JSON.stringify(S),buffers:[]}}e.serializeWebviewMessage=D;function y(S){switch(S.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(S,_){const C=_.map(c=>{const f=new ArrayBuffer(c.byteLength);return new Uint8Array(f).set(c.buffer),f}),n=_.length?(c,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const l=f,{index:o}=l,w=C[o];if(l.view)switch(l.view.type){case 1:return new Int8Array(w,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return f}:void 0;return{message:JSON.parse(S,n),arrayBuffers:C}}e.deserializeWebviewMessage=k}),define(Ee[67],_e([0,1,11,2]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function D(y,k){return y.scheme===h.Schemas.http||y.scheme===h.Schemas.https?y:(k&&k.authority&&k.isRemote&&y.scheme===h.Schemas.file&&(y=R.URI.from({scheme:h.Schemas.vscodeRemote,authority:k.authority,path:y.path})),R.URI.from({scheme:h.Schemas.https,authority:`${y.scheme}+${y.authority}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=D}),define(Ee[164],_e([0,1,3,7,67]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(S,_,C){this._proxy=S,this._editors=_,this._initData=C,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const n=_.getVisibleTextEditors();for(const P of this._insets.values())n.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this._insets.forEach(S=>S.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(S,_,C,n,P){let c;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===S){c=u;break}if(!c)throw new Error("not a visible editor");const f=this,l=this._handlePool++,o=new h.Emitter,w=new h.Emitter,b=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,D.asWebviewUri)(u,f._initData.remote)}get cspSource(){return D.webviewGenericCspSource}set options(u){this._options=u,f._proxy.$setOptions(l,u)}get options(){return this._options}set html(u){this._html=u,f._proxy.$setHtml(l,u)}get html(){return this._html}get onDidReceiveMessage(){return o.event}postMessage(u){return f._proxy.$postMessage(l,u)}},E=new class{constructor(){this.editor=S,this.line=_,this.height=C,this.webview=b,this.onDidDispose=w.event}dispose(){f._insets.has(l)&&(f._insets.delete(l),f._proxy.$disposeEditorInset(l),w.fire(),w.dispose(),o.dispose())}};return this._proxy.$createEditorInset(l,c.id,c.value.document.uri,_+1,C,n||{},P.identifier,P.extensionLocation),this._insets.set(l,{editor:S,inset:E,onDidReceiveMessage:o}),E}$onDidDispose(S){const _=this._insets.get(S);_&&_.inset.dispose()}$onDidReceiveMessage(S,_){const C=this._insets.get(S);C&&C.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=y}),define(Ee[165],_e([0,1,136,10,2,7,4,59,31,17,11]),function(te,e,h,R,D,y,k,S,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,h.localize)(0,null),providerDisplayName:(0,h.localize)(1,null)},e.ActiveEditorDirtyContext=new S.RawContextKey("activeEditorIsDirty",!1,(0,h.localize)(2,null)),e.ActiveEditorPinnedContext=new S.RawContextKey("activeEditorIsNotPreview",!1,(0,h.localize)(3,null)),e.ActiveEditorStickyContext=new S.RawContextKey("activeEditorIsPinned",!1,(0,h.localize)(4,null)),e.ActiveEditorReadonlyContext=new S.RawContextKey("activeEditorIsReadonly",!1,(0,h.localize)(5,null)),e.ActiveEditorCanRevertContext=new S.RawContextKey("activeEditorCanRevert",!1,(0,h.localize)(6,null)),e.ActiveEditorContext=new S.RawContextKey("activeEditor",null,{type:"string",description:(0,h.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new S.RawContextKey("activeEditorAvailableEditorIds","",(0,h.localize)(8,null)),e.TextCompareEditorVisibleContext=new S.RawContextKey("textCompareEditorVisible",!1,(0,h.localize)(9,null)),e.TextCompareEditorActiveContext=new S.RawContextKey("textCompareEditorActive",!1,(0,h.localize)(10,null)),e.EditorGroupEditorsCountContext=new S.RawContextKey("groupEditorsCount",0,(0,h.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new S.RawContextKey("activeEditorGroupEmpty",!1,(0,h.localize)(12,null)),e.ActiveEditorGroupIndexContext=new S.RawContextKey("activeEditorGroupIndex",0,(0,h.localize)(13,null)),e.ActiveEditorGroupLastContext=new S.RawContextKey("activeEditorGroupLast",!1,(0,h.localize)(14,null)),e.MultipleEditorGroupsContext=new S.RawContextKey("multipleEditorGroups",!1,(0,h.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new S.RawContextKey("editorIsOpen",!1,(0,h.localize)(16,null)),e.InEditorZenModeContext=new S.RawContextKey("inZenMode",!1,(0,h.localize)(17,null)),e.IsCenteredLayoutContext=new S.RawContextKey("isCenteredLayout",!1,(0,h.localize)(18,null)),e.SplitEditorsVertically=new S.RawContextKey("splitEditorsVertically",!1,(0,h.localize)(19,null)),e.EditorAreaVisibleContext=new S.RawContextKey("editorAreaVisible",!0,(0,h.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function P(a){return typeof a?.getViewState=="function"}e.isTextEditorPane=P;function c(a){if(u(a))return!1;const T=a;return D.URI.isUri(T?.resource)}e.isResourceEditorInput=c;function f(a){if(u(a))return!1;const T=a;return T?.original!==void 0&&T.modified!==void 0}e.isResourceDiffEditorInput=f;function l(a){if(u(a))return!1;const T=a;return T?T?.resource===void 0||T.resource.scheme===n.Schemas.untitled||T.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=l;var o;(function(a){a[a.SHORT=0]="SHORT",a[a.MEDIUM=1]="MEDIUM",a[a.LONG=2]="LONG"})(o=e.Verbosity||(e.Verbosity={}));var w;(function(a){a[a.EXPLICIT=1]="EXPLICIT",a[a.AUTO=2]="AUTO",a[a.FOCUS_CHANGE=3]="FOCUS_CHANGE",a[a.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(w=e.SaveReason||(e.SaveReason={}));var b;(function(a){a[a.None=0]="None",a[a.Readonly=2]="Readonly",a[a.Untitled=4]="Untitled",a[a.Singleton=8]="Singleton",a[a.RequiresTrust=16]="RequiresTrust"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class E extends y.Disposable{}e.AbstractEditorInput=E;function u(a){return a instanceof E}e.isEditorInput=u;function g(a){const T=a;return D.URI.isUri(T?.preferredResource)}function v(a){const T=a;return u(T?.primary)&&u(T?.secondary)}e.isSideBySideEditorInput=v;function t(a){return u(a?.editor)}e.isEditorInputWithOptions=t;function s(a){const T=a;return t(a)&&T?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function i(a){const T=a;return typeof T?.groupId=="number"&&u(T.editor)}e.isEditorIdentifier=i;var r;(function(a){a[a.PRIMARY=1]="PRIMARY",a[a.SECONDARY=2]="SECONDARY",a[a.BOTH=3]="BOTH"})(r=e.SideBySideEditor||(e.SideBySideEditor={}));class d{getOriginalUri(T,M){if(!T)return;const W=v(T)?T.primary:f(T)?T.modified:void 0,B=v(T)?T.secondary:f(T)?T.original:void 0;if(M?.supportSideBySide&&W&&B){if(M?.supportSideBySide===r.BOTH)return{primary:this.getOriginalUri(W,{filterByScheme:M.filterByScheme}),secondary:this.getOriginalUri(B,{filterByScheme:M.filterByScheme})};T=M.supportSideBySide===r.PRIMARY?W:B}if(f(T))return;const Z=g(T)?T.preferredResource:T.resource;return!Z||!M||!M.filterByScheme?Z:this.filterUri(Z,M.filterByScheme)}getCanonicalUri(T,M){if(!T)return;const W=v(T)?T.primary:f(T)?T.modified:void 0,B=v(T)?T.secondary:f(T)?T.original:void 0;if(M?.supportSideBySide&&W&&B){if(M?.supportSideBySide===r.BOTH)return{primary:this.getCanonicalUri(W,{filterByScheme:M.filterByScheme}),secondary:this.getCanonicalUri(B,{filterByScheme:M.filterByScheme})};T=M.supportSideBySide===r.PRIMARY?W:B}if(f(T))return;const Z=T.resource;return!Z||!M||!M.filterByScheme?Z:this.filterUri(Z,M.filterByScheme)}filterUri(T,M){if(Array.isArray(M)){if(M.some(W=>T.scheme===W))return T}else if(M===T.scheme)return T}}e.EditorResourceAccessor=new d;var m;(function(a){a[a.LEFT=0]="LEFT",a[a.RIGHT=1]="RIGHT"})(m=e.CloseDirection||(e.CloseDirection={}));class p{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(T){const M=this.instantiationService=T.get(k.IInstantiationService);for(const[W,B]of this.editorSerializerConstructors)this.createEditorSerializer(W,B,M);this.editorSerializerConstructors.clear()}createEditorSerializer(T,M,W){const B=W.createInstance(M);this.editorSerializerInstances.set(T,B)}registerFileEditorFactory(T){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=T}getFileEditorFactory(){return(0,R.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(T,M){if(this.editorSerializerConstructors.has(T)||this.editorSerializerInstances.has(T))throw new Error(`A editor serializer with type ID '${T}' was already registered.`);return this.instantiationService?this.createEditorSerializer(T,M,this.instantiationService):this.editorSerializerConstructors.set(T,M),(0,y.toDisposable)(()=>{this.editorSerializerConstructors.delete(T),this.editorSerializerInstances.delete(T)})}getEditorSerializer(T){return this.editorSerializerInstances.get(typeof T=="string"?T:T.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new p);async function I(a,T){if(!a||!a.length)return[];const M=await Promise.all(a.map(async W=>{const B=D.URI.revive(W.fileUri);if(!B||!T.canHandleResource(B))return;const Z=typeof W.exists=="boolean"?W.exists:await T.exists(B);if(!Z&&W.openOnlyIfExists)return;const q=Z&&typeof W.lineNumber=="number"?{selection:{startLineNumber:W.lineNumber,startColumn:W.columnNumber||1},pinned:!0,override:W.editorOverrideId}:{pinned:!0,override:W.editorOverrideId};let $;return Z?$={resource:B,options:q,forceFile:!0}:$={resource:B,options:q,forceUntitled:!0},$}));return(0,C.coalesce)(M)}e.pathsToEditors=I;var A;(function(a){a[a.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",a[a.SEQUENTIAL=1]="SEQUENTIAL"})(A=e.EditorsOrder||(e.EditorsOrder={}))}),define(Ee[166],_e([0,1,3,16,137]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new h.Emitter,this._onExit=new h.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(S){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=S}onEvent(S){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=S}onRequest(S){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=S}sendResponse(S){S.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${S.command}`)):this.internalSend("response",S)}sendRequest(S,_,C,n){const P={command:S};if(_&&Object.keys(_).length>0&&(P.arguments=_),this.internalSend("request",P),typeof n=="number"){const c=setTimeout(()=>{clearTimeout(c);const f=this.pendingRequests.get(P.seq);if(f){this.pendingRequests.delete(P.seq);const l={type:"response",seq:0,request_seq:P.seq,success:!1,command:S,message:(0,D.localize)(0,null,n,S)};f(l)}},n)}return C&&this.pendingRequests.set(P.seq,C),P.seq}acceptMessage(S){this.messageCallback?this.messageCallback(S):(this.queue.push(S),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(S,_){return S.type!=="event"||_.type!=="event"}async processQueue(){let S;for(;this.queue.length;){if((!S||this.needsTaskBoundaryBetween(this.queue[0],S))&&await(0,R.timeout)(0),S=this.queue.shift(),!S)return;switch(S.type){case"event":this.eventCallback&&this.eventCallback(S);break;case"request":this.requestCallback&&this.requestCallback(S);break;case"response":const _=S,C=this.pendingRequests.get(_.request_seq);C&&(this.pendingRequests.delete(_.request_seq),C(_));break}}}internalSend(S,_){_.type=S,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const S=new Map;this.pendingRequests.forEach((_,C)=>S.set(C,_)),await(0,R.timeout)(500),S.forEach((_,C)=>{_({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(Ee[167],_e([0,1,8,2,14,24,11]),function(te,e,h,R,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const S=/{([^}]+)}/g;function _(s,i,r){return s.replace(S,function(d,m){return i&&m.length>0&&m[0]!=="_"?d:r&&r.hasOwnProperty(m)?r[m]:d})}e.formatPII=_;function C(s){const i={};for(const r of Object.keys(s))r.startsWith("!")||(i[r]=s[r]);return i}e.filterExceptionsFromTelemetry=C;function n(s){return s.configuration.request==="attach"&&!P(s)&&(!s.parentSession||n(s.parentSession))}e.isSessionAttach=n;function P(s){let i=s.configuration.type;if(!!i)return i==="vslsShare"&&(i=s.configuration.adapterProxy.configuration.type),(0,h.equalsIgnoreCase)(i,"extensionhost")||(0,h.equalsIgnoreCase)(i,"pwa-extensionhost")?s:s.parentSession?P(s.parentSession):void 0}e.getExtensionHostDebugSession=P;function c(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=c;function f(s,i,r){let d,m=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,I=null;for(;I=p.exec(s);){let A=I.index+1,a=A+I[0].length;if(A<=i&&a>=r){d=I[0],m=A;break}}if(d){let A=/\w+/g,a=null;for(;(a=A.exec(d))&&!(a.index+1+m+a[0].length>=r););a&&(d=d.substring(0,A.lastIndex))}return d?{start:m,end:m+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(s){return!!(s&&s.match(l))}e.isUri=o;function w(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(o(s.path))return R.URI.parse(s.path);if((0,D.isAbsolute)(s.path))return R.URI.file(s.path)}return s.path}function b(s){if(typeof s.path=="object"){const i=R.URI.revive(s.path);if(i)return i.scheme===k.Schemas.file?i.fsPath:i.toString()}return s.path}function E(s,i){const r=i?w:b,d=(0,y.deepClone)(s);return g(d,(m,p)=>{m&&p&&(p.path=r(p))}),d}e.convertToDAPaths=E;function u(s,i){const r=i?w:b,d=(0,y.deepClone)(s);return g(d,(m,p)=>{!m&&p&&(p.path=r(p))}),d}e.convertToVSCPaths=u;function g(s,i){switch(s.type){case"event":const r=s;switch(r.event){case"output":i(!1,r.body.source);break;case"loadedSource":i(!1,r.body.source);break;case"breakpoint":i(!1,r.body.breakpoint.source);break;default:break}break;case"request":const d=s;switch(d.command){case"setBreakpoints":i(!0,d.arguments.source);break;case"breakpointLocations":i(!0,d.arguments.source);break;case"source":i(!0,d.arguments.source);break;case"gotoTargets":i(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(p=>i(!1,p));break;default:break}break;case"response":const m=s;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(p=>i(!1,p.source));break;case"loadedSources":m.body.sources.forEach(p=>i(!1,p));break;case"scopes":m.body.scopes.forEach(p=>i(!1,p.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(p=>i(!1,p.source));break;case"setBreakpoints":m.body.breakpoints.forEach(p=>i(!1,p.source));break;default:break}break}}function v(s){return s.filter(i=>!i.presentation?.hidden).sort((i,r)=>i.presentation?r.presentation?i.presentation.group?r.presentation.group?i.presentation.group!==r.presentation.group?i.presentation.group.localeCompare(r.presentation.group):t(i.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(i.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=v;function t(s,i){return typeof s!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:s-i}}),define(Ee[68],_e([0,1,27,82,11,14,21,59]),function(te,e,h,R,D,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var _;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(_=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(a){a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var P;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(P=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var c;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(c=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.ChangeLanguage=5]="ChangeLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.ChangeCellMime=13]="ChangeCellMime",a[a.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var l;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(l=e.SelectionStateType||(e.SelectionStateType={}));var o;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(o=e.CellEditType||(e.CellEditType={}));var w;(function(a){a.scheme=D.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function M($,V){return $.with({scheme:a.scheme,fragment:`ch${V.toString().padStart(7,"0")}${$.scheme!==D.Schemas.file?$.scheme:""}`})}a.generate=M;function W($){if($.scheme!==a.scheme)return;const V=T.exec($.fragment);return V?{handle:Number(V[1]),notebook:$.with({scheme:$.fragment.substr(V[0].length)||D.Schemas.file,fragment:null})}:void 0}a.parse=W;function B($){if($.scheme!==D.Schemas.vscodeNotebookCellMetadata)return;const V=T.exec($.fragment);return V?{handle:Number(V[1]),notebook:$.with({scheme:$.fragment.substr(V[0].length)||D.Schemas.file,fragment:null})}:void 0}a.parseCellMetadataUri=B;function Z($,V,F){return $.with({scheme:F,fragment:`ch${V.toString().padStart(7,"0")}${$.scheme!==D.Schemas.file?$.scheme:""}`})}a.generateCellUri=Z;function q($,V){if($.scheme!==V)return;const F=T.exec($.fragment);return F?{handle:Number(F[1]),notebook:$.with({scheme:$.fragment.substr(F[0].length)||D.Schemas.file,fragment:null})}:void 0}a.parseCellUri=q})(w=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(a){return b.get(a)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=E;function u(a){return b.get(a)?.supportedByCore??!1}e.mimeTypeSupportedByCore=u;function g(a){return b.get(a)?.mergeable??!1}e.mimeTypeIsMergeable=g;function v(a,T){return k.isWindows&&(a=a.replace(/\//g,"\\"),T=T.replace(/\//g,"\\")),h.match(a,T)}function t(a,T,M){let W=0;for(let B=0;B<T.length;B++){if(v(T[B],a))return W;W++}for(let B=0;B<M.length;B++){if(v(M[B],a))return W;W++}return W}function s(a,T,M){return a.sort((W,B)=>t(W,T,M)-t(B,T,M))}e.sortMimeTypes=s;function i(a,T,M,W=(B,Z)=>B===Z){const B=[];function Z(V,F,re){if(F===0&&re.length===0)return;const N=B[B.length-1];N&&N.start+N.deleteCount===V?(N.deleteCount+=F,N.toInsert.push(...re)):B.push({start:V,deleteCount:F,toInsert:re})}let q=0,$=0;for(;;){if(q===a.length){Z(q,0,T.slice($));break}if($===T.length){Z(q,a.length-q,[]);break}const V=a[q],F=T[$];if(W(V,F)){q+=1,$+=1;continue}M(F)?(Z(q,1,[]),q+=1):(Z(q,0,[F]),$+=1)}return B}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(a){a.default="default",a.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(a){const T=a;return!!((typeof T.include=="string"||h.isRelativePattern(T.include))&&(typeof T.exclude=="string"||h.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=d;function m(a,T,M){if(Array.isArray(a.viewType)&&a.viewType.indexOf(T)>=0||a.viewType===T)return!0;if(a.filenamePattern){let W=d(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,B=d(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(h.match(W,(0,y.basename)(M.fsPath).toLowerCase()))return!(B&&h.match(B,(0,y.basename)(M.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=m;class p{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let M=0;M<this.textModel.cells.length;M++)T[M]=this.textModel.cells[M].getHashValue();return T}}e.CellSequence=p,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var I;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(I=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class A{static create(T){return`${A._prefix}${T}`}static parse(T){if(T.startsWith(A._prefix))return T.substr(A._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=A,A._prefix="notebook/"}),define(Ee[168],_e([0,1,139,4,59]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,h.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,h.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,h.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ee[169],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function h(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=h;function R(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=R}),define(Ee[96],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.identifyTest=void 0;const h=C=>({testId:C.item.extId,controllerId:C.controllerId});e.identifyTest=h;var R;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(R=e.TestItemExpandState||(e.TestItemExpandState={}));const D=(C,n)=>{n.expand!==void 0&&(C.expand=n.expand),n.item!==void 0&&(C.item=C.item?Object.assign(C.item,n.item):n.item)};e.applyTestItemUpdate=D;var y;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(y=e.DetailType||(e.DetailType={}));var k;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.Remove=2]="Remove",C[C.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",C[C.Retire=4]="Retire"})(k=e.TestDiffOpType||(e.TestDiffOpType={}));class S{add(n){}update(n){}remove(n,P){}complete(){}}e.IncrementalChangeCollector=S;class _{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(n){const P=this.createChangeCollector();for(const c of n)switch(c[0]){case 0:{const f=c[1];if(f.parent){if(this.items.has(f.parent)){const l=this.items.get(f.parent);l.children.add(f.item.extId);const o=this.createItem(f,l);this.items.set(f.item.extId,o),P.add(o)}}else{const l=this.createItem(f);this.roots.add(l),this.items.set(f.item.extId,l),P.add(l)}f.expand===2&&this.busyControllerCount++;break}case 1:{const f=c[1],l=this.items.get(f.extId);if(!l)break;f.expand!==void 0&&(l.expand===2&&this.busyControllerCount--,f.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(l,f),P.update(l);break}case 2:{const f=this.items.get(c[1]);if(!f)break;f.parent?this.items.get(f.parent).children.delete(f.item.extId):this.roots.delete(f);const l=[[c[1]]];for(;l.length;)for(const o of l.pop()){const w=this.items.get(o);w&&(l.push(w.children),this.items.delete(o),P.remove(w,w!==f),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(c[1]);break;case 3:this.updatePendingRoots(c[1]);break}P.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new S}}e.AbstractIncrementalTestCollection=_}),define(Ee[170],_e([0,1,14,41,10,24,21,81,140]),function(te,e,h,R,D,y,k,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(P,c,f){this._contributedVariables=new Map,this._context=P,this._labelService=c,f&&(this._envVariablesPromise=f.then(l=>this.prepareEnv(l)))}prepareEnv(P){if(k.isWindows){const c=Object.create(null);return Object.keys(P).forEach(f=>{c[f.toLowerCase()]=P[f]}),c}return P}resolveWithEnvironment(P,c,f){return this.recursiveResolve(this.prepareEnv(P),c?c.uri:void 0,f)}async resolveAsync(P,c){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,c)}async resolveAnyBase(P,c,f,l){const o=y.deepClone(c);return k.isWindows&&o.windows?Object.keys(o.windows).forEach(w=>o[w]=o.windows[w]):k.isMacintosh&&o.osx?Object.keys(o.osx).forEach(w=>o[w]=o.osx[w]):k.isLinux&&o.linux&&Object.keys(o.linux).forEach(w=>o[w]=o.linux[w]),delete o.windows,delete o.osx,delete o.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,o,f,l)}async resolveAnyAsync(P,c,f){return this.resolveAnyBase(P,c,f)}async resolveAnyMap(P,c,f){const l=new Map;return{newConfig:await this.resolveAnyBase(P,c,f,l),resolvedVariables:l}}resolveWithInteractionReplace(P,c,f,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,c,f,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,c){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,c)}recursiveResolve(P,c,f,l,o){if(D.isString(f))return this.resolveString(P,c,f,l,o);if(D.isArray(f))return f.map(w=>this.recursiveResolve(P,c,w,l,o));if(D.isObject(f)){let w=Object.create(null);return Object.keys(f).forEach(b=>{const E=this.resolveString(P,c,b,l,o);w[E]=this.recursiveResolve(P,c,f[b],l,o)}),w}return f}resolveString(P,c,f,l,o){return f.replace(C.VARIABLE_REGEXP,(b,E)=>{if(E.includes(C.VARIABLE_LHS))return b;let u=this.evaluateSingleVariable(P,b,E,c,l);return o&&o.set(E,u),u!==b&&D.isString(u)&&u.match(C.VARIABLE_REGEXP)&&(u=this.resolveString(P,c,u,l,o)),u})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,c,f,l,o){let w;const b=f.split(":");b.length>1&&(f=b[0],w=b[1]);const E=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,_.localize)(0,null,c))},u=()=>{const v=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,_.localize)(1,null,c,h.basename(v)))},g=()=>{if(w){const v=this._context.getFolderUri(w);if(v)return v;throw new Error((0,_.localize)(2,null,c,w))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,c)):new Error((0,_.localize)(4,null,c))};switch(f){case"env":if(w){if(P){const v=P[k.isWindows?w.toLowerCase():w];if(D.isString(v))return v}return""}throw new Error((0,_.localize)(5,null,c));case"config":if(w){const v=this._context.getConfigurationValue(l,w);if(D.isUndefinedOrNull(v))throw new Error((0,_.localize)(6,null,c,w));if(D.isObject(v))throw new Error((0,_.localize)(7,null,c,w));return v}throw new Error((0,_.localize)(8,null,c));case"command":return this.resolveFromMap(c,w,o,"command");case"input":return this.resolveFromMap(c,w,o,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,S.normalizeDriveLetter)(this.fsPath(g()));case"cwd":return l||w?(0,S.normalizeDriveLetter)(this.fsPath(g())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return h.basename(this.fsPath(g()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,_.localize)(9,null,c));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,_.localize)(10,null,c));case"file":return E();case"fileWorkspaceFolder":return u();case"relativeFile":return l||w?h.relative(this.fsPath(g()),E()):E();case"relativeFileDirname":const s=h.dirname(E());if(l||w){const m=h.relative(this.fsPath(g()),s);return m.length===0?".":m}return s;case"fileDirname":return h.dirname(E());case"fileExtname":return h.extname(E());case"fileBasename":return h.basename(E());case"fileBasenameNoExtension":const i=h.basename(E());return i.slice(0,i.length-h.extname(i).length);case"fileDirnameBasename":return h.basename(h.dirname(E()));case"execPath":const r=this._context.getExecPath();return r||c;case"execInstallFolder":const d=this._context.getAppRoot();return d||c;case"pathSeparator":return h.sep;default:try{const m=w?`${f}:${w}`:f;return this.resolveFromMap(c,m,o,void 0)}catch(m){return c}}}}resolveFromMap(P,c,f,l){if(c&&f){const o=l===void 0?f[c]:f[l+":"+c];if(typeof o=="string")return o;throw new Error((0,_.localize)(11,null,P))}return P}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[97],_e([0,1,4,165]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,h.createDecorator)("editorGroupsService");var D;(function(o){o[o.UP=0]="UP",o[o.DOWN=1]="DOWN",o[o.LEFT=2]="LEFT",o[o.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var y;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(y=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(o){o[o.FIRST=0]="FIRST",o[o.LAST=1]="LAST",o[o.NEXT=2]="NEXT",o[o.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var S;(function(o){o[o.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",o[o.EVEN=1]="EVEN",o[o.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(o){o[o.COPY_EDITORS=0]="COPY_EDITORS",o[o.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function C(o){const w=o;return(0,R.isEditorInput)(w?.editor)&&(0,R.isEditorInput)(w?.replacement)}e.isEditorReplacement=C;var n;(function(o){o[o.CREATION_TIME=0]="CREATION_TIME",o[o.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",o[o.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(n=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(o){o[o.GROUP_ACTIVE=0]="GROUP_ACTIVE",o[o.GROUP_INDEX=1]="GROUP_INDEX",o[o.EDITOR_OPEN=2]="EDITOR_OPEN",o[o.EDITOR_CLOSE=3]="EDITOR_CLOSE",o[o.EDITOR_MOVE=4]="EDITOR_MOVE",o[o.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",o[o.EDITOR_LABEL=6]="EDITOR_LABEL",o[o.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",o[o.EDITOR_PIN=8]="EDITOR_PIN",o[o.EDITOR_STICKY=9]="EDITOR_STICKY",o[o.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(P=e.GroupChangeKind||(e.GroupChangeKind={}));var c;(function(o){o[o.NEW_EDITOR=1]="NEW_EDITOR",o[o.MOVE_EDITOR=2]="MOVE_EDITOR",o[o.COPY_EDITOR=3]="COPY_EDITOR"})(c=e.OpenEditorContext||(e.OpenEditorContext={}));function f(o){const w=o;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.isEditorGroup=f;function l(o){return o.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=l}),define(Ee[171],_e([0,1,4,97]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,h.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(y){const k=y;return typeof y=="number"||(0,R.isEditorGroup)(k)}e.isPreferredGroup=D}),define(Ee[9],_e([0,1,17,80,227,54,24,10,2,30,58,141,89,68,171,6]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var w;(function(ve){function we(j){const{selectionStartLineNumber:Oe,selectionStartColumn:ye,positionLineNumber:Xe,positionColumn:Je}=j,rt=new o.Position(Oe-1,ye-1),mt=new o.Position(Xe-1,Je-1);return new o.Selection(rt,mt)}ve.to=we;function oe(j){const{anchor:Oe,active:ye}=j;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:ye.line+1,positionColumn:ye.character+1}}ve.from=oe})(w=e.Selection||(e.Selection={}));var b;(function(ve){function we(j){if(!j)return;const{start:Oe,end:ye}=j;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:ye.line+1,endColumn:ye.character+1}}ve.from=we;function oe(j){if(!j)return;const{startLineNumber:Oe,startColumn:ye,endLineNumber:Xe,endColumn:Je}=j;return new o.Range(Oe-1,ye-1,Xe-1,Je-1)}ve.to=oe})(b=e.Range||(e.Range={}));var E;(function(ve){function we(oe){switch(oe){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 4:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}ve.to=we})(E=e.TokenType||(e.TokenType={}));var u;(function(ve){function we(j){return new o.Position(j.lineNumber-1,j.column-1)}ve.to=we;function oe(j){return{lineNumber:j.line+1,column:j.character+1}}ve.from=oe})(u=e.Position||(e.Position={}));var g;(function(ve){function we(j){switch(j){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}ve.from=we;function oe(j){switch(j){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}ve.to=oe})(g=e.DiagnosticTag||(e.DiagnosticTag={}));var v;(function(ve){function we(j){let Oe;return j.code&&((0,S.isString)(j.code)||(0,S.isNumber)(j.code)?Oe=String(j.code):Oe={value:String(j.code.value),target:j.code.target}),{...b.from(j.range),message:j.message,source:j.source,code:Oe,severity:s.from(j.severity),relatedInformation:j.relatedInformation&&j.relatedInformation.map(t.from),tags:Array.isArray(j.tags)?(0,h.coalesce)(j.tags.map(g.from)):void 0}}ve.from=we;function oe(j){const Oe=new o.Diagnostic(b.to(j),j.message,s.to(j.severity));return Oe.source=j.source,Oe.code=(0,S.isString)(j.code)?j.code:j.code?.value,Oe.relatedInformation=j.relatedInformation&&j.relatedInformation.map(t.to),Oe.tags=j.tags&&(0,h.coalesce)(j.tags.map(g.to)),Oe}ve.to=oe})(v=e.Diagnostic||(e.Diagnostic={}));var t;(function(ve){function we(j){return{...b.from(j.location.range),message:j.message,resource:j.location.uri}}ve.from=we;function oe(j){return new o.DiagnosticRelatedInformation(new o.Location(j.resource,b.to(j)),j.message)}ve.to=oe})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var s;(function(ve){function we(j){switch(j){case o.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}ve.from=we;function oe(j){switch(j){case c.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}ve.to=oe})(s=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var i;(function(ve){function we(j){return typeof j=="number"&&j>=o.ViewColumn.One?j-1:j===o.ViewColumn.Beside?l.SIDE_GROUP:l.ACTIVE_GROUP}ve.from=we;function oe(j){if(typeof j=="number"&&j>=0)return j+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=oe})(i=e.ViewColumn||(e.ViewColumn={}));function r(ve){return typeof ve.range!="undefined"}function d(ve){return ve.length===0?!0:!!r(ve[0])}e.isDecorationOptionsArr=d;var m;(function(ve){function we(Je){return Je.map(ve.from)}ve.fromMany=we;function oe(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function j(Je){let rt;if(oe(Je)){const{language:Ct,value:St}=Je;rt={value:"```"+Ct+`
`+St+"\n```\n"}}else o.MarkdownString.isMarkdownString(Je)?rt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons}:typeof Je=="string"?rt={value:Je}:rt={value:""};const mt=Object.create(null);rt.uris=mt;const wt=Ct=>{try{let St=_.URI.parse(Ct,!0);St=St.with({query:Oe(St.query,mt)}),mt[Ct]=St}catch(St){}return""},bt=new D.Renderer;return bt.link=wt,bt.image=Ct=>wt(R.parseHrefAndDimensions(Ct).href),D(rt.value,{renderer:bt}),rt}ve.from=j;function Oe(Je,rt){if(!Je)return Je;let mt;try{mt=(0,y.parse)(Je)}catch(bt){}if(!mt)return Je;let wt=!1;return mt=(0,k.cloneAndChange)(mt,bt=>{if(_.URI.isUri(bt)){const Ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[Ct]=bt,wt=!0,Ct}else return}),wt?JSON.stringify(mt):Je}function ye(Je){const rt=new o.MarkdownString(Je.value,Je.supportThemeIcons);return rt.isTrusted=Je.isTrusted,rt}ve.to=ye;function Xe(Je){if(!!Je)return typeof Je=="string"?Je:ve.from(Je)}ve.fromStrict=Xe})(m=e.MarkdownString||(e.MarkdownString={}));function p(ve){return d(ve)?ve.map(we=>({range:b.from(we.range),hoverMessage:Array.isArray(we.hoverMessage)?m.fromMany(we.hoverMessage):we.hoverMessage?m.from(we.hoverMessage):void 0,renderOptions:we.renderOptions})):ve.map(we=>({range:b.from(we)}))}e.fromRangeOrRangeWithMessage=p;function I(ve){return typeof ve=="undefined"?ve:typeof ve=="string"?_.URI.file(ve):ve}e.pathOrURIToURI=I;var A;(function(ve){function we(oe){return typeof oe=="undefined"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?I(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}ve.from=we})(A=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var a;(function(ve){function we(oe){return typeof oe=="undefined"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?I(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?A.from(oe.before):void 0,after:oe.after?A.from(oe.after):void 0}}ve.from=we})(a=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var T;(function(ve){function we(oe){if(typeof oe=="undefined")return oe;switch(oe){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}ve.from=we})(T=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var M;(function(ve){function we(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?T.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?a.from(oe.light):void 0,dark:oe.dark?a.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?I(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?A.from(oe.before):void 0,after:oe.after?A.from(oe.after):void 0}}ve.from=we})(M=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var W;(function(ve){function we(j){return{text:j.newText,eol:j.newEol&&z.from(j.newEol),range:b.from(j.range)}}ve.from=we;function oe(j){const Oe=new o.TextEdit(b.to(j.range),j.text);return Oe.newEol=typeof j.eol=="undefined"?void 0:z.to(j.eol),Oe}ve.to=oe})(W=e.TextEdit||(e.TextEdit={}));var B;(function(ve){function we(j,Oe,ye){const Xe={edits:[]};if(j instanceof o.WorkspaceEdit)for(let Je of j._allEntries())if(Je._type===1)Xe.edits.push({_type:1,oldUri:Je.from,newUri:Je.to,options:Je.options,metadata:Je.metadata});else if(Je._type===2){const rt=Oe?.getDocument(Je.uri);Xe.edits.push({_type:2,resource:Je.uri,edit:W.from(Je.edit),modelVersionId:rt?.version,metadata:Je.metadata})}else Je._type===3?Xe.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:ye?.getNotebookDocument(Je.uri,!0)?.apiNotebook.version}):Je._type===5&&Xe.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,notebookVersionId:ye?.getNotebookDocument(Je.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(de.from)}});return Xe}ve.from=we;function oe(j){const Oe=new o.WorkspaceEdit;for(const ye of j.edits)ye.edit?Oe.replace(_.URI.revive(ye.resource),b.to(ye.edit.range),ye.edit.text):Oe.renameFile(_.URI.revive(ye.oldUri),_.URI.revive(ye.newUri),ye.options);return Oe}ve.to=oe})(B=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Z;(function(ve){const we=Object.create(null);we[o.SymbolKind.File]=0,we[o.SymbolKind.Module]=1,we[o.SymbolKind.Namespace]=2,we[o.SymbolKind.Package]=3,we[o.SymbolKind.Class]=4,we[o.SymbolKind.Method]=5,we[o.SymbolKind.Property]=6,we[o.SymbolKind.Field]=7,we[o.SymbolKind.Constructor]=8,we[o.SymbolKind.Enum]=9,we[o.SymbolKind.Interface]=10,we[o.SymbolKind.Function]=11,we[o.SymbolKind.Variable]=12,we[o.SymbolKind.Constant]=13,we[o.SymbolKind.String]=14,we[o.SymbolKind.Number]=15,we[o.SymbolKind.Boolean]=16,we[o.SymbolKind.Array]=17,we[o.SymbolKind.Object]=18,we[o.SymbolKind.Key]=19,we[o.SymbolKind.Null]=20,we[o.SymbolKind.EnumMember]=21,we[o.SymbolKind.Struct]=22,we[o.SymbolKind.Event]=23,we[o.SymbolKind.Operator]=24,we[o.SymbolKind.TypeParameter]=25;function oe(Oe){return typeof we[Oe]=="number"?we[Oe]:6}ve.from=oe;function j(Oe){for(const ye in we)if(we[ye]===Oe)return Number(ye);return o.SymbolKind.Property}ve.to=j})(Z=e.SymbolKind||(e.SymbolKind={}));var q;(function(ve){function we(j){switch(j){case o.SymbolTag.Deprecated:return 1}}ve.from=we;function oe(j){switch(j){case 1:return o.SymbolTag.Deprecated}}ve.to=oe})(q=e.SymbolTag||(e.SymbolTag={}));var $;(function(ve){function we(j){return{name:j.name,kind:Z.from(j.kind),tags:j.tags&&j.tags.map(q.from),containerName:j.containerName,location:H.from(j.location)}}ve.from=we;function oe(j){const Oe=new o.SymbolInformation(j.name,Z.to(j.kind),j.containerName,H.to(j.location));return Oe.tags=j.tags&&j.tags.map(q.to),Oe}ve.to=oe})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var V;(function(ve){function we(j){const Oe={name:j.name||"!!MISSING: name!!",detail:j.detail,range:b.from(j.range),selectionRange:b.from(j.selectionRange),kind:Z.from(j.kind),tags:j.tags?.map(q.from)??[]};return j.children&&(Oe.children=j.children.map(we)),Oe}ve.from=we;function oe(j){const Oe=new o.DocumentSymbol(j.name,j.detail,Z.to(j.kind),b.to(j.range),b.to(j.selectionRange));return(0,h.isNonEmptyArray)(j.tags)&&(Oe.tags=j.tags.map(q.to)),j.children&&(Oe.children=j.children.map(oe)),Oe}ve.to=oe})(V=e.DocumentSymbol||(e.DocumentSymbol={}));var F;(function(ve){function we(oe){const j=new o.CallHierarchyItem(Z.to(oe.kind),oe.name,oe.detail||"",_.URI.revive(oe.uri),b.to(oe.range),b.to(oe.selectionRange));return j._sessionId=oe._sessionId,j._itemId=oe._itemId,j}ve.to=we})(F=e.CallHierarchyItem||(e.CallHierarchyItem={}));var re;(function(ve){function we(oe){return new o.CallHierarchyIncomingCall(F.to(oe.from),oe.fromRanges.map(j=>b.to(j)))}ve.to=we})(re=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var N;(function(ve){function we(oe){return new o.CallHierarchyOutgoingCall(F.to(oe.to),oe.fromRanges.map(j=>b.to(j)))}ve.to=we})(N=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var H;(function(ve){function we(j){return{range:j.range&&b.from(j.range),uri:j.uri}}ve.from=we;function oe(j){return new o.Location(_.URI.revive(j.uri),b.to(j.range))}ve.to=oe})(H=e.location||(e.location={}));var J;(function(ve){function we(j){const Oe=j,ye=j;return{originSelectionRange:Oe.originSelectionRange?b.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:ye.uri,range:b.from(Oe.targetRange?Oe.targetRange:ye.range),targetSelectionRange:Oe.targetSelectionRange?b.from(Oe.targetSelectionRange):void 0}}ve.from=we;function oe(j){return{targetUri:_.URI.revive(j.uri),targetRange:b.to(j.range),targetSelectionRange:j.targetSelectionRange?b.to(j.targetSelectionRange):void 0,originSelectionRange:j.originSelectionRange?b.to(j.originSelectionRange):void 0}}ve.to=oe})(J=e.DefinitionLink||(e.DefinitionLink={}));var K;(function(ve){function we(j){return{range:b.from(j.range),contents:m.fromMany(j.contents)}}ve.from=we;function oe(j){return new o.Hover(j.contents.map(m.to),b.to(j.range))}ve.to=oe})(K=e.Hover||(e.Hover={}));var le;(function(ve){function we(j){return{range:b.from(j.range),expression:j.expression}}ve.from=we;function oe(j){return new o.EvaluatableExpression(b.to(j.range),j.expression)}ve.to=oe})(le=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ie;(function(ve){function we(j){if(j instanceof o.InlineValueText)return{type:"text",range:b.from(j.range),text:j.text};if(j instanceof o.InlineValueVariableLookup)return{type:"variable",range:b.from(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};if(j instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:b.from(j.range),expression:j.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=we;function oe(j){switch(j.type){case"text":return{range:b.to(j.range),text:j.text};case"variable":return{range:b.to(j.range),variableName:j.variableName,caseSensitiveLookup:j.caseSensitiveLookup};case"expression":return{range:b.to(j.range),expression:j.expression}}}ve.to=oe})(Ie=e.InlineValue||(e.InlineValue={}));var Me;(function(ve){function we(j){return{frameId:j.frameId,stoppedLocation:b.from(j.stoppedLocation)}}ve.from=we;function oe(j){return new o.InlineValueContext(j.frameId,b.to(j.stoppedLocation))}ve.to=oe})(Me=e.InlineValueContext||(e.InlineValueContext={}));var Ve;(function(ve){function we(j){return{range:b.from(j.range),kind:j.kind}}ve.from=we;function oe(j){return new o.DocumentHighlight(b.to(j.range),j.kind)}ve.to=oe})(Ve=e.DocumentHighlight||(e.DocumentHighlight={}));var xe;(function(ve){function we(oe){switch(oe){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}ve.to=we})(xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ge;(function(ve){function we(oe){return{triggerKind:xe.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}ve.to=we})(Ge=e.CompletionContext||(e.CompletionContext={}));var Ke;(function(ve){function we(j){switch(j){case o.CompletionItemTag.Deprecated:return 1}}ve.from=we;function oe(j){switch(j){case 1:return o.CompletionItemTag.Deprecated}}ve.to=oe})(Ke=e.CompletionItemTag||(e.CompletionItemTag={}));var qe;(function(ve){const we=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function oe(ye){return we.get(ye)??9}ve.from=oe;const j=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Oe(ye){return j.get(ye)??o.CompletionItemKind.Property}ve.to=Oe})(qe=e.CompletionItemKind||(e.CompletionItemKind={}));var U;(function(ve){function we(oe,j){const Oe=new o.CompletionItem(oe.label);return Oe.insertText=oe.insertText,Oe.kind=qe.to(oe.kind),Oe.tags=oe.tags?.map(Ke.to),Oe.detail=oe.detail,Oe.documentation=R.isMarkdownString(oe.documentation)?m.to(oe.documentation):oe.documentation,Oe.sortText=oe.sortText,Oe.filterText=oe.filterText,Oe.preselect=oe.preselect,Oe.commitCharacters=oe.commitCharacters,C.Range.isIRange(oe.range)?Oe.range=b.to(oe.range):typeof oe.range=="object"&&(Oe.range={inserting:b.to(oe.range.insert),replacing:b.to(oe.range.replace)}),Oe.keepWhitespace=typeof oe.insertTextRules=="undefined"?!1:Boolean(oe.insertTextRules&1),typeof oe.insertTextRules!="undefined"&&oe.insertTextRules&4?Oe.insertText=new o.SnippetString(oe.insertText):(Oe.insertText=oe.insertText,Oe.textEdit=Oe.range instanceof o.Range?new o.TextEdit(Oe.range,Oe.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(Oe.additionalTextEdits=oe.additionalTextEdits.map(ye=>W.to(ye))),Oe.command=j&&oe.command?j.fromInternal(oe.command):void 0,Oe}ve.to=we})(U=e.CompletionItem||(e.CompletionItem={}));var G;(function(ve){function we(j){return{label:j.label,documentation:j.documentation?m.fromStrict(j.documentation):void 0}}ve.from=we;function oe(j){return{label:j.label,documentation:R.isMarkdownString(j.documentation)?m.to(j.documentation):j.documentation}}ve.to=oe})(G=e.ParameterInformation||(e.ParameterInformation={}));var ne;(function(ve){function we(j){return{label:j.label,documentation:j.documentation?m.fromStrict(j.documentation):void 0,parameters:Array.isArray(j.parameters)?j.parameters.map(G.from):[],activeParameter:j.activeParameter}}ve.from=we;function oe(j){return{label:j.label,documentation:R.isMarkdownString(j.documentation)?m.to(j.documentation):j.documentation,parameters:Array.isArray(j.parameters)?j.parameters.map(G.to):[],activeParameter:j.activeParameter}}ve.to=oe})(ne=e.SignatureInformation||(e.SignatureInformation={}));var se;(function(ve){function we(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(ne.from):[]}}ve.from=we;function oe(j){return{activeSignature:j.activeSignature,activeParameter:j.activeParameter,signatures:Array.isArray(j.signatures)?j.signatures.map(ne.to):[]}}ve.to=oe})(se=e.SignatureHelp||(e.SignatureHelp={}));var ge;(function(ve){function we(j){return{text:j.text,position:u.from(j.position),kind:X.from(j.kind??o.InlayHintKind.Other),whitespaceBefore:j.whitespaceBefore,whitespaceAfter:j.whitespaceAfter}}ve.from=we;function oe(j){const Oe=new o.InlayHint(j.text,u.to(j.position),X.to(j.kind));return Oe.whitespaceAfter=j.whitespaceAfter,Oe.whitespaceBefore=j.whitespaceBefore,Oe}ve.to=oe})(ge=e.InlayHint||(e.InlayHint={}));var X;(function(ve){function we(j){return j}ve.from=we;function oe(j){return j}ve.to=oe})(X=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(ve){function we(j){return{range:b.from(j.range),url:j.target,tooltip:j.tooltip}}ve.from=we;function oe(j){let Oe;if(j.url)try{Oe=typeof j.url=="string"?_.URI.parse(j.url,!0):_.URI.revive(j.url)}catch(ye){}return new o.DocumentLink(b.to(j.range),Oe)}ve.to=oe})(ce=e.DocumentLink||(e.DocumentLink={}));var ke;(function(ve){function we(j){const Oe=new o.ColorPresentation(j.label);return j.textEdit&&(Oe.textEdit=W.to(j.textEdit)),j.additionalTextEdits&&(Oe.additionalTextEdits=j.additionalTextEdits.map(ye=>W.to(ye))),Oe}ve.to=we;function oe(j){return{label:j.label,textEdit:j.textEdit?W.from(j.textEdit):void 0,additionalTextEdits:j.additionalTextEdits?j.additionalTextEdits.map(Oe=>W.from(Oe)):void 0}}ve.from=oe})(ke=e.ColorPresentation||(e.ColorPresentation={}));var Be;(function(ve){function we(j){return new o.Color(j[0],j[1],j[2],j[3])}ve.to=we;function oe(j){return[j.red,j.green,j.blue,j.alpha]}ve.from=oe})(Be=e.Color||(e.Color={}));var $e;(function(ve){function we(j){return{range:b.from(j.range)}}ve.from=we;function oe(j){return new o.SelectionRange(b.to(j.range))}ve.to=oe})($e=e.SelectionRange||(e.SelectionRange={}));var pe;(function(ve){function we(oe){switch(oe){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}ve.to=we})(pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(ve){function we(j){switch(j){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}ve.from=we;function oe(j){switch(j){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}ve.to=oe})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var z;(function(ve){function we(j){if(j===o.EndOfLine.CRLF)return 1;if(j===o.EndOfLine.LF)return 0}ve.from=we;function oe(j){if(j===1)return o.EndOfLine.CRLF;if(j===0)return o.EndOfLine.LF}ve.to=oe})(z=e.EndOfLine||(e.EndOfLine={}));var Q;(function(ve){function we(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ve.from=we})(Q=e.ProgressLocation||(e.ProgressLocation={}));var fe;(function(ve){function we(oe){const j={start:oe.start+1,end:oe.end+1};return oe.kind&&(j.kind=Le.from(oe.kind)),j}ve.from=we})(fe=e.FoldingRange||(e.FoldingRange={}));var Le;(function(ve){function we(oe){if(oe)switch(oe){case o.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}ve.from=we})(Le=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ue;(function(ve){function we(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?b.from(oe.selection):void 0,override:typeof oe.override=="boolean"?P.EditorResolution.DISABLED:void 0}}ve.from=we})(Ue=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ze;(function(ve){function we(j){return j instanceof o.RelativePattern||typeof j=="string"?j:oe(j)?new o.RelativePattern(j.base,j.pattern):j}ve.from=we;function oe(j){const Oe=j;return Oe&&typeof Oe.base=="string"&&typeof Oe.pattern=="string"}})(Ze=e.GlobPattern||(e.GlobPattern={}));var Ce;(function(ve){function we(oe){if(oe){if(Array.isArray(oe))return oe.map(we);if(typeof oe=="string")return oe;{const j=oe;return{language:j.language,scheme:j.scheme,pattern:typeof j.pattern=="undefined"?void 0:Ze.from(j.pattern),exclusive:j.exclusive}}}else return}ve.from=we})(Ce=e.LanguageSelector||(e.LanguageSelector={}));var Se;(function(ve){function we(j){return{start:j.start,end:j.end}}ve.from=we;function oe(j){return new o.NotebookRange(j.start,j.end)}ve.to=oe})(Se=e.NotebookRange||(e.NotebookRange={}));var Pe;(function(ve){function we(j){return{timing:typeof j.runStartTime=="number"&&typeof j.runEndTime=="number"?{startTime:j.runStartTime,endTime:j.runEndTime}:void 0,executionOrder:j.executionOrder,success:j.lastRunSuccess}}ve.to=we;function oe(j){return{lastRunSuccess:j.success,runStartTime:j.timing?.startTime,runEndTime:j.timing?.endTime,executionOrder:j.executionOrder}}ve.from=oe})(Pe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ie;(function(ve){function we(j){switch(j){case o.NotebookCellKind.Markup:return f.CellKind.Markup;case o.NotebookCellKind.Code:default:return f.CellKind.Code}}ve.from=we;function oe(j){switch(j){case f.CellKind.Markup:return o.NotebookCellKind.Markup;case f.CellKind.Code:default:return o.NotebookCellKind.Code}}ve.to=oe})(ie=e.NotebookCellKind||(e.NotebookCellKind={}));var ae;(function(ve){function we(j){const Oe={metadata:j.metadata??Object.create(null),cells:[]};for(let ye of j.cells)o.NotebookCellData.validate(ye),Oe.cells.push(de.from(ye));return Oe}ve.from=we;function oe(j){const Oe=new o.NotebookData(j.cells.map(de.to));return(0,S.isEmptyObject)(j.metadata)||(Oe.metadata=j.metadata),Oe}ve.to=oe})(ae=e.NotebookData||(e.NotebookData={}));var de;(function(ve){function we(j){return{cellKind:ie.from(j.kind),language:j.languageId,mime:j.mime,source:j.value,metadata:j.metadata,internalMetadata:Pe.from(j.executionSummary??{}),outputs:j.outputs?j.outputs.map(x.from):[]}}ve.from=we;function oe(j){return new o.NotebookCellData(ie.to(j.cellKind),j.source,j.language,j.mime,j.outputs?j.outputs.map(x.to):void 0,j.metadata,j.internalMetadata?Pe.to(j.internalMetadata):void 0)}ve.to=oe})(de=e.NotebookCellData||(e.NotebookCellData={}));var me;(function(ve){function we(j){return{mime:j.mime,valueBytes:Array.from(j.data)}}ve.from=we;function oe(j){return new o.NotebookCellOutputItem(new Uint8Array(j.valueBytes),j.mime)}ve.to=oe})(me=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var x;(function(ve){function we(j){return{outputId:j.id,items:j.items.map(me.from),metadata:j.metadata}}ve.from=we;function oe(j){const Oe=j.items.map(me.to);return new o.NotebookCellOutput(Oe,j.outputId,j.metadata)}ve.to=oe})(x=e.NotebookCellOutput||(e.NotebookCellOutput={}));var he;(function(ve){function we(ye){if(ye!=null){if(ye instanceof o.RelativePattern||typeof ye=="string")return ye;if(Oe(ye))return new o.RelativePattern(ye.base,ye.pattern);if(j(ye))return{include:Ze.from(ye.include)||void 0,exclude:Ze.from(ye.exclude)||void 0}}}ve.from=we;function oe(ye){return typeof ye=="string"?ye:Oe(ye)?{base:ye.base,pattern:ye.pattern}:{include:ye.include,exclude:ye.exclude}}ve.to=oe;function j(ye){const Xe=ye,Je=Ze.from(Xe.include);if(!(Je&&Je instanceof o.RelativePattern||typeof Je=="string"))return!1;const rt=Ze.from(Xe.exclude);return!!(rt&&rt instanceof o.RelativePattern||typeof rt=="string")}function Oe(ye){const Xe=ye;return Xe&&typeof Xe.base=="string"&&typeof Xe.pattern=="string"}})(he=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var be;(function(ve){function we(oe){return{backgroundColor:oe.backgroundColor,borderColor:oe.borderColor,top:oe.top?A.from(oe.top):void 0}}ve.from=we})(be=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ae;(function(ve){function we(oe,j,Oe){const ye=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:j.toInternal(ye,Oe),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}ve.from=we})(Ae=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Fe;(function(ve){function we(oe){return{transientOutputs:oe?.transientOutputs??!1,transientCellMetadata:oe?.transientCellMetadata??{},transientDocumentMetadata:oe?.transientDocumentMetadata??{}}}ve.from=we})(Fe=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var We;(function(ve){function we(j){return{uri:j.uri,provides:j.provides}}ve.from=we;function oe(j){return new o.NotebookRendererScript(_.URI.revive(j.uri),j.provides)}ve.to=oe})(We=e.NotebookRendererScript||(e.NotebookRendererScript={}));var et;(function(ve){function we(j){return{message:m.fromStrict(j.message)||"",severity:j.severity,expectedOutput:j.expectedOutput,actualOutput:j.actualOutput,location:j.location?H.from(j.location):void 0}}ve.from=we;function oe(j){const Oe=new o.TestMessage(typeof j.message=="string"?j.message:m.to(j.message));return Oe.severity=j.severity,Oe.actualOutput=j.actualOutput,Oe.expectedOutput=j.expectedOutput,Oe}ve.to=oe})(et=e.TestMessage||(e.TestMessage={}));var Qe;(function(ve){function we(Xe){return{extId:Xe.id,label:Xe.label,uri:Xe.uri,range:b.from(Xe.range)||null,debuggable:Xe.debuggable??!1,description:Xe.description||null,runnable:Xe.runnable??!0,error:Xe.error&&m.fromStrict(Xe.error)||null}}ve.from=we;function oe(Xe){return{extId:Xe.id,label:Xe.label,uri:Xe.uri,range:b.from(Xe.range)||null,debuggable:!1,description:Xe.description||null,error:null,runnable:!0}}ve.fromResultSnapshot=oe;function j(Xe){return{id:Xe.extId,label:Xe.label,uri:_.URI.revive(Xe.uri),range:b.to(Xe.range||void 0),dispose:()=>{},invalidateResults:()=>{},canResolveChildren:!1,busy:!1,debuggable:Xe.debuggable,description:Xe.description||void 0,runnable:Xe.runnable}}ve.toPlain=j;function Oe(Xe,Je){const rt=new o.TestItemImpl(Xe.extId,Xe.label,_.URI.revive(Xe.uri),void 0,Je);return rt.range=b.to(Xe.range||void 0),rt.debuggable=Xe.debuggable,rt.description=Xe.description||void 0,rt.runnable=Xe.runnable,rt}ve.to=Oe;function ye(Xe){let Je;for(const rt of Xe.tests)Je=Oe(rt.item,Je);return Je}ve.toItemFromContext=ye})(Qe=e.TestItem||(e.TestItem={}));var Ye;(function(ve){const we=(j,Oe)=>({...Qe.toPlain(j.item),taskStates:j.tasks.map(ye=>({state:ye.state,duration:ye.duration,messages:ye.messages.map(et.to)})),children:j.children.map(ye=>Oe.get(ye)).filter(S.isDefined).map(ye=>we(ye,Oe))});function oe(j){const Oe=[],ye=new Map;for(const Xe of j.items)ye.set(Xe.item.extId,Xe),Xe.direct&&Oe.push(Xe);return{completedAt:j.completedAt,results:Oe.map(Xe=>we(Xe,ye))}}ve.to=oe})(Ye=e.TestResults||(e.TestResults={}));var lt;(function(ve){function we(ye){return{covered:ye.covered,total:ye.covered}}function oe(ye){return"line"in ye?u.from(ye):b.from(ye)}function j(ye){return"branches"in ye?{count:ye.executionCount,location:oe(ye.location),type:1,branches:ye.branches.length?ye.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&oe(Xe.location)})):void 0}:{type:0,count:ye.executionCount,location:oe(ye.location)}}ve.fromDetailed=j;function Oe(ye){return{uri:ye.uri,statement:we(ye.statementCoverage),branch:ye.branchCoverage&&we(ye.branchCoverage),function:ye.functionCoverage&&we(ye.functionCoverage),details:ye.detailedCoverage?.map(j)}}ve.fromFile=Oe})(lt=e.TestCoverage||(e.TestCoverage={}));var ct;(function(ve){function we(oe){switch(oe){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}ve.to=we})(ct=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(Ee[172],_e([0,1,2,12,6,9,77]),function(te,e,h,R,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class S{constructor(C,n,P,c={timeout:1500,errors:3}){this._logService=C,this._documents=n,this._mainThreadBulkEdits=P,this._thresholds=c,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(n,P,c)=>{const l={dispose:this._callbacks.push([n,P,C])};return Array.isArray(c)&&c.push(l),l}}async $participateInSave(C,n){const P=h.URI.revive(C);let c=!1;const f=setTimeout(()=>c=!0,this._thresholds.timeout),l=[];try{for(let o of[...this._callbacks]){if(c)break;const w=this._documents.getDocument(P),b=await this._deliverEventAsyncAndBlameBadListeners(o,{document:w,reason:y.TextDocumentSaveReason.to(n)});l.push(b)}}finally{clearTimeout(f)}return l}_deliverEventAsyncAndBlameBadListeners([C,n,P],c){const f=this._badListeners.get(C);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,C,n,c).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const o=this._badListeners.get(C);this._badListeners.set(C,o?o+1:1),typeof o=="number"&&o>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,n,P,c){const f=[],l=Date.now(),{document:o,reason:w}=c,{version:b}=o,E=Object.freeze({document:o,reason:w,waitUntil(u){if(Object.isFrozen(f))throw(0,R.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(u))}});try{n.apply(P,[E])}catch(u){return Promise.reject(u)}return Object.freeze(f),new Promise((u,g)=>{const v=setTimeout(()=>g(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(v),u(t)}).catch(t=>{clearTimeout(v),g(t)})}).then(u=>{const g={edits:[]};for(const v of u)if(Array.isArray(v)&&v.every(t=>t instanceof D.TextEdit))for(const{newText:t,newEol:s,range:i}of v)g.edits.push({_type:2,resource:o.uri,edit:{range:i&&y.Range.from(i),text:t,eol:s&&y.EndOfLine.from(s)}});if(g.edits.length!==0)return b===o.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(g):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=S}),define(Ee[173],_e([0,1,3,27,2,9,6]),function(te,e,h,R,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(n,P,c,f,l){this._onDidCreate=new h.Emitter,this._onDidChange=new h.Emitter,this._onDidDelete=new h.Emitter,this._config=0,c&&(this._config+=1),f&&(this._config+=2),l&&(this._config+=4);const o=(0,R.parse)(P),w=n(b=>{if(!c)for(let E of b.created){const u=D.URI.revive(E);o(u.fsPath)&&this._onDidCreate.fire(u)}if(!f)for(let E of b.changed){const u=D.URI.revive(E);o(u.fsPath)&&this._onDidChange.fire(u)}if(!l)for(let E of b.deleted){const u=D.URI.revive(E);o(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(n,P,c){this._logService=P,this._extHostDocumentsAndEditors=c,this._onFileSystemEvent=new h.Emitter,this._onDidRenameFile=new h.Emitter,this._onDidCreateFile=new h.Emitter,this._onDidDeleteFile=new h.Emitter,this._onWillRenameFile=new h.AsyncEmitter,this._onWillCreateFile=new h.AsyncEmitter,this._onWillDeleteFile=new h.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(n,P,c,f){return new S(this._onFileSystemEvent.event,n,P,c,f)}$onFileEvent(n){this._onFileSystemEvent.fire(n)}$onDidRunFileOperation(n,P){switch(n){case 2:this._onDidRenameFile.fire(Object.freeze({files:P.map(c=>({oldUri:D.URI.revive(c.source),newUri:D.URI.revive(c.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:P.map(c=>D.URI.revive(c.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:P.map(c=>D.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(n){return this._createWillExecuteEvent(n,this._onWillRenameFile)}getOnWillCreateFileEvent(n){return this._createWillExecuteEvent(n,this._onWillCreateFile)}getOnWillDeleteFileEvent(n){return this._createWillExecuteEvent(n,this._onWillDeleteFile)}_createWillExecuteEvent(n,P){return(c,f,l)=>{const o=function(b){c.call(f,b)};return o.extension=n,P.event(o,void 0,l)}}async $onWillRunFileOperation(n,P,c,f){switch(n){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:P.map(l=>({oldUri:D.URI.revive(l.source),newUri:D.URI.revive(l.target)}))},c,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:P.map(l=>D.URI.revive(l.target))},c,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:P.map(l=>D.URI.revive(l.target))},c,f)}}async _fireWillEvent(n,P,c,f){const l=new Set,o=[];if(await n.fireAsync(P,f,async(b,E)=>{const u=Date.now(),g=await Promise.resolve(b);g instanceof k.WorkspaceEdit&&(o.push(g),l.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-u>c&&this._logService.warn("SLOW file-participant",E.extension.identifier)}),f.isCancellationRequested||o.length===0)return;const w={edits:[]};for(let b of o){let{edits:E}=y.WorkspaceEdit.from(b,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(E)}return{edit:w,extensionNames:Array.from(l)}}}e.ExtHostFileSystemEventService=_}),define(Ee[174],_e([0,1,11,24,2,9,6,68]),function(te,e,h,R,D,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(c,f,l,o){this.start=c,this.deletedCount=f,this.deletedItems=l,this.items=o}static asApiEvents(c){return c.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(l=>l.apiCell)}))}}class C{constructor(c,f,l){this.notebook=c,this._extHostDocument=f,this._cellData=l,this.handle=l.handle,this.uri=D.URI.revive(l.uri),this.cellKind=l.cellKind,this._outputs=l.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=l.internalMetadata??{},this._metadata=l.metadata??{},this._previousResult=y.NotebookCellExecutionSummary.to(l.internalMetadata??{})}static asModelAddData(c,f){return{EOL:f.eol,lines:f.source,modeId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const c=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return c.notebook.getCellIndex(c)},notebook:c.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return c._mime},set mime(l){c._mime=l},get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get executionSummary(){return c._previousResult}})}return this._apiCell}setOutputs(c){this._outputs=c.map(y.NotebookCellOutput.to)}setOutputItems(c,f,l){const o=l.map(y.NotebookCellOutputItem.to),w=this._outputs.find(b=>b.id===c);w&&(f||(w.items.length=0),w.items.push(...o))}setMetadata(c){this._metadata=c}setInternalMetadata(c){this._internalMetadata=c,this._previousResult=y.NotebookCellExecutionSummary.to(c)}setMime(c){}}e.ExtHostCell=C;class n{constructor(c,f,l,o,w,b){this._proxy=c,this._textDocumentsAndEditors=f,this._textDocuments=l,this._emitter=o,this.uri=w,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=b.viewType,this._metadata=b.metadata??Object.create(null),this._spliceNotebookCells([[0,0,b.cells]],!0),this._versionId=b.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get notebookType(){return c._notebookType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===h.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(f){return f=c._validateIndex(f),c._cells[f].apiCell},getCells(f){return(f?c._getCells(f):c._cells).map(o=>o.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata={...this._metadata,...c.metadata})}acceptDirty(c){this._isDirty=c}acceptModelChanged(c,f){this._versionId=c.versionId,this._isDirty=f;for(const l of c.rawEvents)l.kind===S.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1):l.kind===S.NotebookCellsChangeType.Move?this._moveCell(l.index,l.newIdx):l.kind===S.NotebookCellsChangeType.Output?this._setCellOutputs(l.index,l.outputs):l.kind===S.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems):l.kind===S.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(l.index,l.language):l.kind===S.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(l.index,l.mime):l.kind===S.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(l.index,l.metadata):l.kind===S.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(l.index,l.internalMetadata)}_validateIndex(c){return c=c|0,c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){let f=c.start|0,l=c.end|0;return f<0&&(f=0),l>this._cells.length&&(l=this._cells.length),c.with({start:f,end:l})}_getCells(c){c=this._validateRange(c);const f=[];for(let l=c.start;l<c.end;l++)f.push(this._cells[l]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(c,f){if(this._disposed)return;const l=[],o=[],w=[];c.reverse().forEach(b=>{const u=b[2].map(t=>{const s=new C(this,this._textDocumentsAndEditors,t);return f||o.push(C.asModelAddData(this.apiNotebook,t)),s}),g=new _(b[0],b[1],[],u),v=this._cells.splice(b[0],b[1],...u);for(const t of v)w.push(t.uri),g.deletedItems.push(t.apiCell);l.push(g)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:w}),f||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(l)}))}_moveCell(c,f){const l=this._cells.splice(c,1);this._cells.splice(f,0,...l);const o=[new _(c,1,l.map(w=>w.apiCell),[]),new _(f,0,[],l)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(o)}))}_setCellOutputs(c,f){const l=this._cells[c];l.setOutputs(f),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[l.apiCell]}))}_setCellOutputItems(c,f,l,o){const w=this._cells[c];w.setOutputItems(f,l,o),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[w.apiCell]}))}_changeCellLanguage(c,f){const l=this._cells[c];l.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(l.uri,f)}_changeCellMime(c,f){const l=this._cells[c];l.apiCell.mime=f}_changeCellMetadata(c,f){const l=this._cells[c],o=l.apiCell.metadata;l.setMetadata(f);const w=l.apiCell.metadata;(0,R.equals)(o,w)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:l.apiCell}))}_changeCellInternalMetadata(c,f){const l=this._cells[c],o=l.internalMetadata;if(l.setInternalMetadata(f),o.runState!==f.runState){const w=f.runState??k.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:l.apiCell,state:w}))}}getCellFromApiCell(c){return this._cells.find(f=>f.apiCell===c)}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(f=>f.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(Ee[98],_e([0,1,6,9,12]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class y{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:C})}replaceCells(_,C,n){this._throwIfFinalized(),!(_===C&&n.length===0)&&this._collectedEdits.push({editType:1,index:_,count:C-_,cells:n.map(R.NotebookCellData.from)})}}class k{constructor(_,C,n,P,c,f){this.id=_,this._proxy=C,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=P,this._viewColumn=f}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(C){if(!Array.isArray(C)||!C.every(h.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");_._selections=C,_._trySetSelections(C)},get visibleRanges(){return _._visibleRanges},revealRange(C,n){_._proxy.$tryRevealRange(_.id,R.NotebookRange.from(C),n??h.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(C){const n=new y(this.document.version);return C(n),_._applyEdit(n.finalize())},setDecorations(C,n){return _.setDecorations(C,n)}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(R.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const C=[];let n=-1;for(let P=0;P<_.cellEdits.length;P++){if(n<0){C.push(_.cellEdits[P]),n++;continue}const f=C[n],l=_.cellEdits[P];if(f.editType===1&&l.editType===1&&f.index===l.index){f.cells.push(..._.cellEdits[P].cells),f.count+=_.cellEdits[P].count;continue}C.push(_.cellEdits[P]),n++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,C)}setDecorations(_,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return C.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(C),_.key)}}e.ExtHostNotebookEditor=k,k.apiEditorsToExtHost=new WeakMap}),define(Ee[175],_e([0,1,9,151,131,18,48]),function(te,e,h,R,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,c,f){const l=this._handles++,{title:o,location:w,cancellable:b}=c,E={label:(0,D.localize)(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(l,{location:h.ProgressLocation.from(w),title:o,source:E,cancellable:b},P),this._withProgress(l,f,!!b)}_withProgress(P,c,f){let l;f&&(l=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,l));const o=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),l&&l.dispose()};let w;try{w=c(new C(this._proxy,P),f&&l?l.token:y.CancellationToken.None)}catch(b){throw o(P),b}return w.then(b=>o(P),b=>o(P)),w}$acceptProgressCanceled(P){const c=this._mapHandleToCancellationSource.get(P);c&&(c.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=S;function _(n,P){return n.message=P.message,typeof P.increment=="number"&&(typeof n.increment=="number"?n.increment+=P.increment:n.increment=P.increment),n}class C extends R.Progress{constructor(P,c){super(f=>this.throttledReport(f));this._proxy=P,this._handle=c}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}He([(0,k.throttle)(100,(n,P)=>_(n,P),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(Ee[99],_e([0,1,39,12,50,9,6]),function(te,e,h,R,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class S{constructor(c,f,l){const o=S._Keys.nextId();c.$registerTextEditorDecorationType(f.identifier,o,y.DecorationRenderOptions.from(l)),this.value=Object.freeze({key:o,dispose(){c.$removeTextEditorDecorationType(o)}})}}e.TextEditorDecorationType=S,S._Keys=new D.IdGenerator("TextEditorDecorationType");class _{constructor(c,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,f){this._throwIfFinalized();let l=null;if(c instanceof k.Position)l=new k.Range(c,c);else if(c instanceof k.Range)l=c;else throw new Error("Unrecognized location");this._pushEdit(l,f,!1)}insert(c,f){this._throwIfFinalized(),this._pushEdit(new k.Range(c,c),f,!0)}delete(c){this._throwIfFinalized();let f=null;if(c instanceof k.Range)f=c;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(c,f,l){const o=this._document.validateRange(c);this._collectedEdits.push({range:o,text:f,forceMoveMarkers:l})}setEndOfLine(c){if(this._throwIfFinalized(),c!==k.EndOfLine.LF&&c!==k.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=_;class C{constructor(c,f,l,o){this._proxy=c,this._id=f,this._accept(l),this._logService=o;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(b){w._setTabSize(b)},get insertSpaces(){return w._insertSpaces},set insertSpaces(b){w._setInsertSpaces(b)},get cursorStyle(){return w._cursorStyle},set cursorStyle(b){w._setCursorStyle(b)},get lineNumbers(){return w._lineNumbers},set lineNumbers(b){w._setLineNumbers(b)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const f=Math.floor(c);return f>0?f:null}if(typeof c=="string"){const f=parseInt(c,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(c){const f=this._validateTabSize(c);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const f=this._validateInsertSpaces(c);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(c)})))}assign(c){const f={};let l=!1;if(typeof c.tabSize!="undefined"){const o=this._validateTabSize(c.tabSize);o==="auto"?(l=!0,f.tabSize=o):typeof o=="number"&&this._tabSize!==o&&(this._tabSize=o,l=!0,f.tabSize=o)}if(typeof c.insertSpaces!="undefined"){const o=this._validateInsertSpaces(c.insertSpaces);o==="auto"?(l=!0,f.insertSpaces=o):this._insertSpaces!==o&&(this._insertSpaces=o,l=!0,f.insertSpaces=o)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,l=!0,f.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,l=!0,f.lineNumbers=y.TextEditorLineNumbersStyle.from(c.lineNumbers)),l&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(c){c.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=C;class n{constructor(c,f,l,o,w,b,E,u){this.id=c,this._proxy=f,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new C(this._proxy,this.id,b,l),this._visibleRanges=E,this._viewColumn=u;const g=this;this.value=Object.freeze({get document(){return o.getValue()},set document(v){throw(0,R.readonly)("document")},get selection(){return g._selections&&g._selections[0]},set selection(v){if(!(v instanceof k.Selection))throw(0,R.illegalArgument)("selection");g._selections=[v],g._trySetSelection()},get selections(){return g._selections},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof k.Selection)))throw(0,R.illegalArgument)("selections");g._selections=v,g._trySetSelection()},get visibleRanges(){return g._visibleRanges},set visibleRanges(v){throw(0,R.readonly)("visibleRanges")},get options(){return g._options.value},set options(v){g._disposed||g._options.assign(v)},get viewColumn(){return g._viewColumn},set viewColumn(v){throw(0,R.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new _(o.getValue(),t);return v(s),g._applyEdit(s)},insertSnippet(v,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!t||Array.isArray(t)&&t.length===0)i=g._selections.map(r=>y.Range.from(r));else if(t instanceof k.Position){const{lineNumber:r,column:d}=y.Position.from(t);i=[{startLineNumber:r,startColumn:d,endLineNumber:r,endColumn:d}]}else if(t instanceof k.Range)i=[y.Range.from(t)];else{i=[];for(const r of t)if(r instanceof k.Range)i.push(y.Range.from(r));else{const{lineNumber:d,column:m}=y.Position.from(r);i.push({startLineNumber:d,startColumn:m,endLineNumber:d,endColumn:m})}}return f.$tryInsertSnippet(c,v.value,i,s)},setDecorations(v,t){const s=t.length===0;s&&!g._hasDecorationsForKey.has(v.key)||(s?g._hasDecorationsForKey.delete(v.key):g._hasDecorationsForKey.add(v.key),g._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return f.$trySetDecorations(c,v.key,y.fromRangeOrRangeWithMessage(t));{const i=new Array(4*t.length);for(let r=0,d=t.length;r<d;r++){const m=t[r];i[4*r]=m.start.line+1,i[4*r+1]=m.start.character+1,i[4*r+2]=m.end.line+1,i[4*r+3]=m.end.character+1}return f.$trySetDecorationsFast(c,v.key,i)}}))},revealRange(v,t){g._runOnProxy(()=>f.$tryRevealRange(c,y.Range.from(v),t||k.TextEditorRevealType.Default))},show(v){f.$tryShowEditor(c,y.ViewColumn.from(v))},hide(){f.$tryHideEditor(c)}})}dispose(){(0,h.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,h.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,h.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,h.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,h.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const f=c.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const l=f.edits.map(w=>w.range);l.sort((w,b)=>w.end.line===b.end.line?w.end.character===b.end.character?w.start.line===b.start.line?w.start.character-b.start.character:w.start.line-b.start.line:w.end.character-b.end.character:w.end.line-b.end.line);for(let w=0,b=l.length-1;w<b;w++){const E=l[w].end;if(l[w+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const o=f.edits.map(w=>({range:y.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,o,{setEndOfLine:typeof f.setEndOfLine=="number"?y.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=n}),define(Ee[176],_e([0,1,134,25,2,3,7,16,6,10,17,9,18]),function(te,e,h,R,D,y,k,S,_,C,n,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(w,b){if((0,C.isString)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let E;return Array.isArray(w.highlights)&&(E=w.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),E=E.length?E:void 0),{label:w.label,highlights:E}}}class l{constructor(b,E,u){this._proxy=b,this.commands=E,this.logService=u,this.treeViews=new Map;function g(v){return v&&v.$treeViewId&&v.$treeItemHandle}E.registerArgumentProcessor({processArgument:v=>g(v)?this.convertArgument(v):Array.isArray(v)&&v.length>0?v.map(t=>g(t)?this.convertArgument(t):t):v})}registerTreeDataProvider(b,E,u){const g=this.createTreeView(b,{treeDataProvider:E},u);return{dispose:()=>g.dispose()}}createTreeView(b,E,u){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=E.dragAndDropController!==void 0,v=this._proxy.$registerTreeViewDataProvider(b,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany,canDragAndDrop:g}),t=this.createExtHostTreeView(b,E,u);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(s){t.message=s},get title(){return t.title},set title(s){t.title=s},get description(){return t.description},set description(s){t.description=s},reveal:(s,i)=>t.reveal(s,i),dispose:async()=>{await v,this.treeViews.delete(b),t.dispose()}}}$getChildren(b,E){const u=this.treeViews.get(b);return u?u.getChildren(E):Promise.reject(new Error((0,h.localize)(0,null,b)))}$onDrop(b,E,u){const g=this.treeViews.get(b);return g?g.onDrop(E,u):Promise.reject(new Error((0,h.localize)(1,null,b)))}async $hasResolve(b){const E=this.treeViews.get(b);if(!E)throw new Error((0,h.localize)(2,null,b));return E.hasResolve}$resolve(b,E,u){const g=this.treeViews.get(b);if(!g)throw new Error((0,h.localize)(3,null,b));return g.resolveTreeItem(E,u)}$setExpanded(b,E,u){const g=this.treeViews.get(b);if(!g)throw new Error((0,h.localize)(4,null,b));g.setExpanded(E,u)}$setSelection(b,E){const u=this.treeViews.get(b);if(!u)throw new Error((0,h.localize)(5,null,b));u.setSelection(E)}$setVisible(b,E){const u=this.treeViews.get(b);if(!u)throw new Error((0,h.localize)(6,null,b));u.setVisible(E)}createExtHostTreeView(b,E,u){const g=new o(b,E,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(b,g),g}convertArgument(b){const E=this.treeViews.get(b.$treeViewId);return E?E.getExtensionElement(b.$treeItemHandle):null}}e.ExtHostTreeViews=l;class o extends k.Disposable{constructor(b,E,u,g,v,t){super();if(this.viewId=b,this.proxy=u,this.commands=g,this.logService=v,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new c.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const d of t.contributes.views[r])d.id===b&&(this._title=d.name);this.dataProvider=E.treeDataProvider,this.dndController=E.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(r=>this._onDidChangeData.fire({message:!1,element:r}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let s,i;this._register(y.Event.debounce(this._onDidChangeData.event,(r,d)=>(r||(r={message:!1,elements:[]}),d.element!==!1&&(s||(s=new Promise(m=>i=m),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(d.element)?r.elements.push(...d.element):r.elements.push(d.element)),d.message&&(r.message=!0),r),200,!0)(({message:r,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=i;return s=null,this.refresh(d).then(()=>m())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(b=>this.getExtensionElement(b)).filter(b=>!(0,C.isUndefinedOrNull)(b))}getChildren(b){const E=b?this.getExtensionElement(b):void 0;if(b&&!E)return this.logService.error(`No tree item with id '${b}' found.`),Promise.resolve([]);const u=this.getChildrenNodes(b);return(u?Promise.resolve(u):this.fetchChildrenNodes(E)).then(g=>g.map(v=>v.item))}getExtensionElement(b){return this.elements.get(b)}reveal(b,E){E=E||{select:!0,focus:!1};const u=(0,C.isUndefinedOrNull)(E.select)?!0:E.select,g=(0,C.isUndefinedOrNull)(E.focus)?!1:E.focus,v=(0,C.isUndefinedOrNull)(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.refreshPromise.then(()=>this.resolveUnknownParentChain(b)).then(t=>this.resolveTreeNode(b,t[t.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:t.map(i=>i.item)},{select:u,focus:g,expand:v})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:g,expand:v})}get message(){return this._message}set message(b){this._message=b,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(b){this._title=b,this.proxy.$setTitle(this.viewId,b,this._description)}get description(){return this._description}set description(b){this._description=b,this.proxy.$setTitle(this.viewId,this._title,b)}setExpanded(b,E){const u=this.getExtensionElement(b);u&&(E?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(b){(0,n.equals)(this._selectedHandles,b)||(this._selectedHandles=b,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(b){b!==this._visible&&(this._visible=b,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(b,E){const u=b.map(v=>this.getExtensionElement(v)).filter(v=>!(0,C.isUndefinedOrNull)(v)),g=this.getExtensionElement(E);return u&&g?(0,S.asPromise)(()=>this.dndController?.onDrop(u,g)):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(b,E){if(!this.dataProvider.resolveTreeItem)return;const u=this.elements.get(b);if(u){const g=this.nodes.get(u);if(g){const v=await this.dataProvider.resolveTreeItem(g.extensionItem,u,E)??g.extensionItem;return g.item.tooltip=this.getTooltip(v.tooltip),g.item.command=this.getCommand(g.disposableStore,v.command),g.item}}}resolveUnknownParentChain(b){return this.resolveParent(b).then(E=>E?this.resolveUnknownParentChain(E).then(u=>this.resolveTreeNode(E,u[u.length-1]).then(g=>(u.push(g),u))):Promise.resolve([]))}resolveParent(b){const E=this.nodes.get(b);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(b))}resolveTreeNode(b,E){const u=this.nodes.get(b);return u?Promise.resolve(u):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(g=>this.createHandle(b,g,E,!0)).then(g=>this.getChildren(E?E.item.handle:void 0).then(()=>{const v=this.getExtensionElement(g);if(v){const t=this.nodes.get(v);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${g}`)}))}getChildrenNodes(b){if(b){let E;if(typeof b=="string"){const u=this.getExtensionElement(b);E=u?this.nodes.get(u):void 0}else E=b;return E&&E.children||null}return this.roots}async fetchChildrenNodes(b){this.clearChildren(b);const E=new c.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=b?this.nodes.get(b):void 0,g=await this.dataProvider.getChildren(b);if(E.token.isCancellationRequested)return[];const v=await Promise.all((0,n.coalesce)(g||[]).map(async t=>{const s=await this.dataProvider.getTreeItem(t);return s&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,s,u):null}));return E.token.isCancellationRequested?[]:(0,n.coalesce)(v)}finally{E.dispose()}}refresh(b){if(b.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new c.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(b);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(b){const E=new Set,u=b.map(v=>this.nodes.get(v));for(const v of u)if(v&&!E.has(v.item.handle)){let t=v;for(;t&&t.parent&&u.findIndex(s=>t&&t.parent&&s&&s.item.handle===t.parent.item.handle)===-1;){const s=this.elements.get(t.parent.item.handle);t=s?this.nodes.get(s):void 0}t&&!t.parent&&E.add(v.item.handle)}const g=[];return E.forEach(v=>{const t=this.elements.get(v);if(t){const s=this.nodes.get(t);s&&(!s.parent||!E.has(s.parent.item.handle))&&g.push(v)}}),g}refreshHandles(b){const E={};return Promise.all(b.map(u=>this.refreshNode(u).then(g=>{g&&(E[u]=g.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(b){const E=this.getExtensionElement(b);if(E){const u=this.nodes.get(E);if(u)return this.clearChildren(E),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(g=>{if(g){const v=this.createTreeNode(E,g,u.parent);return this.updateNodeCache(E,v,u,u.parent),u.dispose(),v}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(b,E,u){const g=this.createTreeNode(b,E,u);if(E.id&&this.elements.has(g.item.handle))throw new Error((0,h.localize)(7,null,E.id));return this.addNodeToCache(b,g),this.addNodeToParentCache(g,u),g}getTooltip(b){return _.MarkdownString.isMarkdownString(b)?P.MarkdownString.from(b):b}getCommand(b,E){return E?this.commands.toInternal(E,b):void 0}createTreeNode(b,E,u){const g=new k.DisposableStore,v=this.createHandle(b,E,u),t=this.getLightIconPath(E);return{item:{handle:v,parentHandle:u?u.item.handle:void 0,label:f(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(g,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:(0,C.isUndefinedOrNull)(E.collapsibleState)?_.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:u,children:void 0,disposableStore:g,dispose(){g.dispose()}}}getThemeIcon(b){return b.iconPath instanceof _.ThemeIcon?b.iconPath:void 0}createHandle(b,{id:E,label:u,resourceUri:g},v,t){if(E)return`${o.ID_HANDLE_PREFIX}/${E}`;const s=f(u,this.extension),i=v?v.item.handle:o.LABEL_HANDLE_PREFIX;let r=s?s.label:g?(0,R.basename)(g):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const d=this.nodes.has(b)?this.nodes.get(b).item.handle:void 0,m=this.getChildrenNodes(v)||[];let p,I=0;do{if(p=`${i}/${I}:${r}`,t||!this.elements.has(p)||d===p)break;I++}while(I<=m.length);return p}getLightIconPath(b){if(b.iconPath&&!(b.iconPath instanceof _.ThemeIcon))return typeof b.iconPath=="string"||D.URI.isUri(b.iconPath)?this.getIconPath(b.iconPath):this.getIconPath(b.iconPath.light)}getDarkIconPath(b){if(b.iconPath&&!(b.iconPath instanceof _.ThemeIcon)&&b.iconPath.dark)return this.getIconPath(b.iconPath.dark)}getIconPath(b){return D.URI.isUri(b)?b:D.URI.file(b)}addNodeToCache(b,E){this.elements.set(E.item.handle,b),this.nodes.set(b,E)}updateNodeCache(b,E,u,g){this.elements.delete(E.item.handle),this.nodes.delete(b),E.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(b,E);const v=this.getChildrenNodes(g)||[],t=v.filter(s=>s.item.handle===u.item.handle)[0];t&&v.splice(v.indexOf(t),1,E)}addNodeToParentCache(b,E){E?(E.children||(E.children=[]),E.children.push(b)):(this.roots||(this.roots=[]),this.roots.push(b))}clearChildren(b){if(b){const E=this.nodes.get(b);if(E){if(E.children)for(const u of E.children){const g=this.elements.get(u.item.handle);g&&this.clear(g)}E.children=void 0}}else this.clearAll()}clear(b){const E=this.nodes.get(b);if(E){if(E.children)for(const u of E.children){const g=this.elements.get(u.item.handle);g&&this.clear(g)}this.nodes.delete(b),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(b=>b.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}o.LABEL_HANDLE_PREFIX="0",o.ID_HANDLE_PREFIX="1"}),define(Ee[177],_e([0,1,16,3,40,7,10,94,9,6,96]),function(te,e,h,R,D,y,k,S,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=void 0;var P;(function(l){l[l.Disconnected=0]="Disconnected",l[l.IsChild=1]="IsChild",l[l.IsParent=2]="IsParent",l[l.IsSame=3]="IsSame"})(P=e.TestPosition||(e.TestPosition={}));class c{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(o){if(this.map.has(o.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${o.item.extId}`);this.map.set(o.item.extId,o),o.parent||this._roots.add(o)}has(o){return this.map.has(o)}delete(o){const w=this.map.get(o);return w?(this.map.delete(o),this._roots.delete(w),!0):!1}get(o){return this.map.get(o)}comparePositions(o,w){const b=typeof o=="string"?this.map.get(o):o,E=typeof w=="string"?this.map.get(w):w;if(!b||!E)return 0;if(b===E)return 3;for(let u=this.map.get(E.parent);u;u=this.map.get(u.parent))if(u===b)return 1;for(let u=this.map.get(b.parent);u;u=this.map.get(u.parent))if(u===E)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=c;class f extends y.Disposable{constructor(o){super();this.controllerId=o,this.testItemToInternal=new Map,this.debounceSendDiff=this._register(new h.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new R.Emitter),this.root=new C.TestItemImpl(`${this.controllerId}Root`,this.controllerId,void 0,void 0,void 0),this.tree=new c,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.addItemInner(this.root,null)}set resolveHandler(o){this._resolveHandler=o;for(const w of this.testItemToInternal.values())this.updateExpandability(w)}get roots(){return D.Iterable.filter(this.testItemToInternal.values(),o=>o.parent===null)}getTestByReference(o){return this.testItemToInternal.get(o)}collectDiff(){const o=this.diff;return this.diff=[],o}pushDiff(o){const w=this.diff[this.diff.length-1];if(w&&o[0]===1){if(w[0]===1&&w[1].extId===o[1].extId){(0,n.applyTestItemUpdate)(w[1],o[1]);return}if(w[0]===0&&w[1].item.extId===o[1].extId){(0,n.applyTestItemUpdate)(w[1],o[1]);return}}this.diff.push(o),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(o,w){const b=this.tree.get(o);if(!!b){if((b.expandLevels===void 0||w>b.expandLevels)&&(b.expandLevels=w),b.expand===1){const E=this.resolveChildren(b);return E.isOpen()?this.expandChildren(b,w-1):E.wait().then(()=>this.expandChildren(b,w-1))}else if(b.expand===3)return b.resolveBarrier?.isOpen()===!1?b.resolveBarrier.wait().then(()=>this.expandChildren(b,w-1)):this.expandChildren(b,w-1)}}dispose(){for(const o of this.testItemToInternal.values())(0,S.getPrivateApiFor)(o.actual).bus.dispose();this.diff=[],super.dispose()}onTestItemEvent(o,w){const b=o?.actual.id;switch(w[0]){case 2:this.pushDiff([4,b]);break;case 1:this.removeItem(o);break;case 0:this.addItemInner(w[1],o);break;case 3:const[E,u,g]=w;switch(u){case"canResolveChildren":this.updateExpandability(o);break;case"range":this.pushDiff([1,{extId:b,item:{range:_.Range.from(g)}}]);break;case"error":this.pushDiff([1,{extId:b,item:{error:_.MarkdownString.fromStrict(g)||null}}]);break;default:this.pushDiff([1,{extId:b,item:{[u]:g??null}}]);break}break;default:(0,k.assertNever)(w[0])}}addItemInner(o,w){if(!(o instanceof C.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${o.id} did not`);if(this.testItemToInternal.has(o))throw new Error(`Attempted to add a single TestItem ${o.id} multiple times to the tree`);if(this.tree.has(o.id))throw new Error(`Attempted to insert a duplicate test item ID ${o.id}`);const b=w?w.item.extId:null,E=w?w.expandLevels:1,u={actual:o,parent:b,item:_.TestItem.from(o),expandLevels:E?E-1:void 0,expand:0,controllerId:this.controllerId};this.tree.add(u),this.testItemToInternal.set(o,u),this.pushDiff([0,{parent:b,controllerId:this.controllerId,expand:u.expand,item:u.item}]);const g=(0,S.getPrivateApiFor)(o);g.bus.event(this.onTestItemEvent.bind(this,u)),this.updateExpandability(u);for(const v of g.children.values())this.testItemToInternal.has(v)||this.addItemInner(v,u)}updateExpandability(o){let w;this._resolveHandler?o.resolveBarrier?w=o.resolveBarrier.isOpen()?3:2:w=o.actual.canResolveChildren?1:0:w=0,w!==o.expand&&(o.expand=w,this.pushDiff([1,{extId:o.actual.id,expand:w}]),w===1&&o.expandLevels!==void 0&&this.resolveChildren(o))}expandChildren(o,w){if(w<0)return;const b=[...o.actual.children.values()].map(E=>this.expand(E.id,w)).filter(h.isThenable);if(b.length)return Promise.all(b).then(()=>{})}resolveChildren(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this._resolveHandler){const E=new h.Barrier;return E.open(),E}o.expand=2,this.pushExpandStateUpdate(o);const w=o.resolveBarrier=new h.Barrier;let b;try{b=this._resolveHandler(o.actual)}catch(E){o.actual.error=E.stack||E.message}return(0,h.isThenable)(b)?b.catch(E=>o.actual.error=E.stack||E.message).then(()=>{w.open(),this.updateExpandability(o)}):(w.open(),this.updateExpandability(o)),o.resolveBarrier}pushExpandStateUpdate(o){this.pushDiff([1,{extId:o.actual.id,expand:o.expand}])}removeItem(o){this.pushDiff([2,o.actual.id]);const w=[o];for(;w.length;){const b=w.pop();if(!!b){this.tree.delete(b.item.extId),this.testItemToInternal.delete(b.actual);for(const E of b.actual.children.values())w.push(this.tree.get(E.id))}}}flushDiff(){const o=this.collectDiff();o.length&&this.diffOpEmitter.fire(o)}}e.SingleUseTestCollection=f}),define(Ee[178],_e([0,1,4,146]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,h.refineServiceDecorator)(R.IEnvironmentService)}),define(Ee[179],_e([0,1,26,3,14]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=y;class k{constructor(n){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(h.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(h.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let P of n.activationEvents)P==="onUri"&&(P=`onUri:${h.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(n)}}keepOnly(n){const P=new Set;n.forEach(c=>P.add(h.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>P.has(h.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,P){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const c=k._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(c.map(f=>f.identifier)),P.length>0){const f=new Set;P.forEach(l=>f.add(h.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!f.has(h.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(c)}static _findLoopingExtensions(n){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,b){this.addNode(w),this.addNode(b),this._arcs.has(w)?this._arcs.get(w).push(b):this._arcs.set(w,[b])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,b){const E=P.getArcs(w);for(let u=0;u<E.length;u++)if(!b.has(E[u]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let w of n){const b=h.ExtensionIdentifier.toKey(w.identifier);if(c.set(b,w),w.extensionDependencies)for(let E of w.extensionDependencies){const u=h.ExtensionIdentifier.toKey(E);P.addArc(b,u)}}let f=new Set;P.getNodes().filter(w=>P.getArcs(w).length===0).forEach(w=>f.add(w));let l=P.getNodes().filter(w=>!f.has(w)),o;do{o=!1;for(let w=0;w<l.length;w++){const b=l[w];P.hasOnlyGoodArcs(b,f)&&(l.splice(w,1),w--,f.add(b),o=!0)}}while(o);return l.map(w=>c.get(w))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(h.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const P=this._activationMap.get(n);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const P=this._extensionsMap.get(h.ExtensionIdentifier.toKey(n));return P||void 0}}e.ExtensionDescriptionRegistry=k;var S;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(S||(S={}));function _(C,n){const P=C.isBuiltin?0:C.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(P!==c)return P-c;const f=D.posix.basename(C.extensionLocation.path),l=D.posix.basename(n.extensionLocation.path);return f<l?-1:f>l?1:0}}),define(Ee[180],_e([0,1,23]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function y(S){const _=h.VSBuffer.alloc(1);switch(S){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=y;function k(S,_){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=k}),define(Ee[29],_e([0,1,3,2,4,26,147]),function(te,e,h,R,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class S{constructor(E){this.dependency=E}}e.MissingExtensionDependency=S;var _;(function(b){b[b.LocalProcess=0]="LocalProcess",b[b.LocalWebWorker=1]="LocalWebWorker",b[b.Remote=2]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(E,u,g,v){this.codeLoadingTime=E,this.activateCallTime=u,this.activateResolvedTime=g,this.activationReason=v}}e.ActivationTimes=C;class n{constructor(E,u){this.description=E,this.value=u}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var P;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function c(b){b.enableProposedApi||f(b)}e.checkProposedApiEnabled=c;function f(b){throw new Error(`[${b.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.throwProposedApiError=f;function l(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation}}e.toExtension=l;function o(b,E){return{identifier:new y.ExtensionIdentifier(b.identifier.id),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!!E,extensionLocation:b.location,...b.manifest,uuid:b.identifier.uuid}}e.toExtensionDescription=o;class w{constructor(){this.onDidRegisterExtensions=h.Event.None,this.onDidChangeExtensionsStatus=h.Event.None,this.onDidChangeExtensions=h.Event.None,this.onWillActivateByEvent=h.Event.None,this.onDidChangeResponsiveChange=h.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(E,u){return Promise.resolve()}_onWillActivateExtension(E){}_onDidActivateExtension(E,u,g,v,t){}_onDidActivateExtensionError(E,u){}_onExtensionRuntimeError(E,u){}_onExtensionHostExit(E){}}e.NullExtensionService=w}),define(Ee[181],_e([0,1,26,29,15]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class k{constructor(l,o,w,b){this.startup=l,this.codeLoadingTime=o,this.activateCallTime=w,this.activateResolvedTime=b}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class S{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,o){return l===-1||o===-1?-1:o-l}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class _{constructor(l,o,w,b,E,u){this.activationFailed=l,this.activationFailedError=o,this.activationTimes=w,this.module=b,this.exports=E,this.subscriptions=u}}e.ActivatedExtension=_;class C extends _{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class n extends _{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class P extends _{constructor(l){super(!0,l,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=P;let c=class{constructor(l,o,w,b,E){this._logService=E,this._registry=l,this._resolvedExtensionsSet=new Set,o.forEach(u=>this._resolvedExtensionsSet.add(h.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,w.forEach(u=>this._hostExtensionsMap.set(h.ExtensionIdentifier.toKey(u),u)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(l){const o=h.ExtensionIdentifier.toKey(l);return this._activatedExtensions.has(o)}getActivatedExtension(l){const o=h.ExtensionIdentifier.toKey(l),w=this._activatedExtensions.get(o);if(!w)throw new Error("Extension `"+l.value+"` is not known or not activated");return w}activateByEvent(l,o){if(this._alreadyActivatedEvents[l])return y;const w=this._registry.getExtensionDescriptionsForActivationEvent(l);return this._activateExtensions(w.map(b=>({id:b.identifier,reason:{startup:o,extensionId:b.identifier,activationEvent:l}}))).then(()=>{this._alreadyActivatedEvents[l]=!0})}activateById(l,o){const w=this._registry.getExtensionDescription(l);if(!w)throw new Error("Extension `"+l+"` is not known");return this._activateExtensions([{id:w.identifier,reason:o}])}_handleActivateRequest(l,o,w){if(this._hostExtensionsMap.has(h.ExtensionIdentifier.toKey(l.id))){o[h.ExtensionIdentifier.toKey(l.id)]=l;return}const b=this._registry.getExtensionDescription(l.id);if(!b){const g=new Error(`Cannot activate unknown extension '${l.id.value}'`);this._host.onExtensionActivationError(l.id,g,new R.MissingExtensionDependency(l.id.value)),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(l.id),new P(g));return}const E=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let u=!0;for(let g=0,v=E.length;g<v;g++){const t=E[g];if(this._resolvedExtensionsSet.has(h.ExtensionIdentifier.toKey(t)))continue;const s=this._activatedExtensions.get(h.ExtensionIdentifier.toKey(t));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const m=b.displayName||b.identifier.value,p=this._registry.getExtensionDescription(t),I=p&&p.displayName||t,A=new Error(`Cannot activate the '${m}' extension because its dependency '${I}' failed to activate`);A.detail=s.activationFailedError,this._host.onExtensionActivationError(b.identifier,A,null),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(b.identifier),new P(A));return}if(this._hostExtensionsMap.has(h.ExtensionIdentifier.toKey(t))){u=!1,o[h.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(h.ExtensionIdentifier.toKey(t)),reason:l.reason};continue}const i=this._registry.getExtensionDescription(t);if(i){u=!1,o[h.ExtensionIdentifier.toKey(t)]={id:i.identifier,reason:l.reason};continue}const r=b.displayName||b.identifier.value,d=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(b.identifier,d,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(b.identifier),new P(d));return}u?o[h.ExtensionIdentifier.toKey(b.identifier)]=l:w.push(l)}_activateExtensions(l){if(l.length===0||(l=l.filter(E=>!this._activatedExtensions.has(h.ExtensionIdentifier.toKey(E.id))),l.length===0))return Promise.resolve(void 0);const o=Object.create(null),w=[];for(let E=0,u=l.length;E<u;E++)this._handleActivateRequest(l[E],o,w);for(let E=0,u=w.length;E<u;E++){const g=h.ExtensionIdentifier.toKey(w[E].id);o[g]&&delete o[g]}const b=Object.keys(o).map(E=>o[E]);return w.length===0?Promise.all(b.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(b).then(E=>this._activateExtensions(w))}_activateExtension(l,o){const w=h.ExtensionIdentifier.toKey(l);if(this._activatedExtensions.has(w))return Promise.resolve(void 0);const b=this._activatingExtensions.get(w);if(b)return b;const E=this._host.actualActivateExtension(l,o).then(void 0,u=>{const g=new Error;return u&&u.name&&(g.name=u.name),u&&u.message?g.message=`Activating extension '${l.value}' failed: ${u.message}.`:g.message=`Activating extension '${l.value}' failed: ${u}.`,u&&u.stack&&(g.stack=u.stack),this._host.onExtensionActivationError(l,g,null),this._logService.error(`Activating extension ${l.value} failed due to an error:`),this._logService.error(u),new P(u)}).then(u=>{this._activatedExtensions.set(w,u),this._activatingExtensions.delete(w)});return this._activatingExtensions.set(w,E),E}};c=He([ze(4,D.ILogService)],c),e.ExtensionsActivator=c}),define(Ee[182],_e([0,1,12]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,k)=>{this._actualOk=y,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,h.onUnexpectedError)(y))}then(y,k){return this._ensureActual().then(y,k)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=R}),define(Ee[100],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class h{constructor(_,C){this._proxyIdentifierBrand=void 0,this.isMain=_,this.sid=C,this.nid=++h.count}}e.ProxyIdentifier=h,h.count=0;const R=[];function D(S){const _=new h(!0,S);return R[_.nid]=_,_}e.createMainContextProxyIdentifier=D;function y(S){const _=new h(!1,S);return R[_.nid]=_,_}e.createExtHostContextProxyIdentifier=y;function k(S){return R[S].sid}e.getStringIdentifierForProxy=k}),define(Ee[5],_e([0,1,54,2,100]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var k;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(u){u.name="$ident";function g(t,s){return Object.defineProperty(t,u.name,{value:s,enumerable:!0}),t}u.mixin=g;function v(t){return t[u.name]}u.of=v})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(g){return g._id=f._n++,g}}e.IdObject=f,f._n=0;var l;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var o;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(o=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(u){if(u&&u.edits)for(const g of u.edits)typeof g.resource=="object"?g.resource=R.URI.revive(g.resource):(g.newUri=R.URI.revive(g.newUri),g.oldUri=R.URI.revive(g.oldUri)),g.metadata&&g.metadata.iconPath&&(g.metadata=(0,h.revive)(g.metadata));return u}e.reviveWorkspaceEditDto=b;var E;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,D.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,D.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(Ee[69],_e([0,1,5,3,4]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(S){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=S.getProxy(h.MainContext.MainThreadSecretState)}async $onDidChangePassword(S){this._onDidChangePassword.fire(S)}get(S,_){return this._proxy.$getPassword(S,_)}store(S,_,C){return this._proxy.$setPassword(S,_,C)}delete(S,_){return this._proxy.$deletePassword(S,_)}}e.ExtHostSecretState=y,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(Ee[70],_e([0,1,4,15,5,13]),function(te,e,h,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,h.createDecorator)("IExtHostApiDeprecationService");let k=class{constructor(_,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(D.MainContext.MainThreadTelemetry)}report(_,C,n){const P=this.getUsageKey(_,C);this._reportedUsages.has(P)||(this._reportedUsages.add(P),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:_}))}getUsageKey(_,C){return`${_}-${C.identifier.value}`}};k=He([ze(0,y.IExtHostRpcService),ze(1,R.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(S,_,C){}})}),define(Ee[183],_e([0,1,3,5,6,26]),function(te,e,h,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new h.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,C,n,P={}){const c=y.ExtensionIdentifier.toKey(_.identifier),f=this._inFlightRequests.get(c)||[],l=[...n].sort().join(" ");let o=f.find(w=>w.scopes===l);if(o)return o.result;{const w=this._getSession(_,c,C,n,P);o={scopes:l,result:w},f.push(o),this._inFlightRequests.set(c,f);try{await w}finally{const b=f.findIndex(E=>E.scopes===l);b>-1&&(f.splice(b),this._inFlightRequests.set(c,f))}return w}}async _getSession(_,C,n,P,c={}){await this._proxy.$ensureProvider(n);const f=_.displayName||_.name;return this._proxy.$getSession(n,P,C,f,c)}async removeSession(_,C){const n=this._authenticationProviders.get(_);return n?n.provider.removeSession(C):this._proxy.$removeSession(_,C)}registerAuthenticationProvider(_,C,n,P){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:C,provider:n,options:P??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===_)||this._providers.push({id:_,label:C});const c=n.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(_,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,C,P?.supportsMultipleAccounts??!1),new D.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(_);const f=this._providers.findIndex(l=>l.id===_);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,C){return this._onDidChangeSessions.fire({provider:{id:_,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(Ee[184],_e([0,1,5,13,9]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(S,_){this._extHostDocumentsAndEditors=_,this._proxy=S.getProxy(h.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(S){const _=D.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};y=He([ze(0,R.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(Ee[185],_e([0,1,5]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(y){const k=y.getProxy(h.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(S){return k.$writeText(S)}})}}e.ExtHostClipboard=R}),define(Ee[71],_e([0,1,10,6,9,24,5,17,15,54,30,36,2,7,4,13]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let w=class{constructor(t,s){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(k.MainContext.MainThreadCommands),this._logService=s,this.converter=new b(this,i=>{const r=this._apiCommands.get(i);return r?.result===u.Void?r:void 0},s),this._argumentProcessors=[{processArgument(i){return(0,C.revive)(i)}},{processArgument(i){return(0,y.cloneAndChange)(i,function(r){if(n.Range.isIRange(r))return D.Range.to(r);if(P.Position.isIPosition(r))return D.Position.to(r);if(n.Range.isIRange(r.range)&&c.URI.isUri(r.uri))return D.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const s=this.registerCommand(!1,t.id,async(...i)=>{const r=t.args.map((m,p)=>{if(!m.validate(i[p]))throw new Error(`Invalid argument '${m.name}' when running '${t.id}', received: ${i[p]}`);return m.convert(i[p])}),d=await this.executeCommand(t.internalId,...r);return t.result.convert(d,i,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{s.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,s,i,r,d){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:i,thisArg:r,description:d}),t&&this._proxy.$registerCommand(s),new R.Disposable(()=>{this._commands.delete(s)&&t&&this._proxy.$unregisterCommand(s)})}executeCommand(t,...s){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,s,!0)}async _doExecuteCommand(t,s,i){if(this._commands.has(t))return this._executeContributedCommand(t,s);{const r=(0,y.cloneAndChange)(s,function(d){if(d instanceof R.Position)return D.Position.from(d);if(d instanceof R.Range)return D.Range.from(d);if(d instanceof R.Location)return D.location.from(d);if(R.NotebookRange.isNotebookRange(d))return D.NotebookRange.from(d);if(!Array.isArray(d))return d});try{const d=await this._proxy.$executeCommand(t,r,i);return(0,C.revive)(d)}catch(d){if(d instanceof Error&&d.message==="$executeCommand:retry")return this._doExecuteCommand(t,s,!1);throw d}}}async _executeContributedCommand(t,s){const i=this._commands.get(t);if(!i)throw new Error("Unknown command");let{callback:r,thisArg:d,description:m}=i;if(m)for(let p=0;p<m.args.length;p++)try{(0,h.validateConstraint)(s[p],m.args[p].constraint)}catch(I){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${m.args[p].name}' - ${m.args[p].description}`)}try{return await r.apply(d,s)}catch(p){if(t===this.converter.delegatingCommandId){const I=this.converter.getActualCommand(...s);I&&(t=I.command)}throw this._logService.error(p,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(s=s.map(i=>this._argumentProcessors.reduce((r,d)=>d.processArgument(r),i)),this._executeContributedCommand(t,s)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(s=>(t&&(s=s.filter(i=>i[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[s,i]of this._commands){let{description:r}=i;r&&(t[s]=r)}return Promise.resolve(t)}};w=He([ze(0,o.IExtHostRpcService),ze(1,_.ILogService)],w),e.ExtHostCommands=w,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class b{constructor(t,s,i){this._commands=t,this._lookupApiCommand=s,this._logService=i,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,s){if(!t)return;const i={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return i;const r=this._lookupApiCommand(t.command);if(r)i.id=r.internalId,i.arguments=r.args.map((d,m)=>d.convert(t.arguments&&t.arguments[m]));else if((0,S.isNonEmptyArray)(t.arguments)){const d=++this._cachIdPool;this._cache.set(d,t),s.add((0,f.toDisposable)(()=>{this._cache.delete(d),this._logService.trace("CommandsConverter#DISPOSE",d)})),i.$ident=d,i.id=this.delegatingCommandId,i.arguments=[d],this._logService.trace("CommandsConverter#CREATE",t.command,d)}return i}fromInternal(t){const s=k.ObjectIdentifier.of(t);return typeof s=="number"?this._cache.get(s):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const s=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=b;class E{constructor(t,s,i,r){this.name=t,this.description=s,this.validate=i,this.convert=r}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,s){return new E(t??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",v=>c.URI.isUri(v),v=>v),E.Position=new E("position","A position in a text document",v=>R.Position.isPosition(v),D.Position.from),E.Range=new E("range","A range in a text document",v=>R.Range.isRange(v),D.Range.from),E.Selection=new E("selection","A selection in a text document",v=>R.Selection.isSelection(v),D.Selection.from),E.Number=new E("number","",v=>typeof v=="number",v=>v),E.String=new E("string","",v=>typeof v=="string",v=>v),E.CallHierarchyItem=new E("item","A call hierarchy item",v=>v instanceof R.CallHierarchyItem,D.CallHierarchyItem.to);class u{constructor(t,s){this.description=t,this.convert=s}}e.ApiCommandResult=u,u.Void=new u("no result",v=>v);class g{constructor(t,s,i,r,d){this.id=t,this.internalId=s,this.description=i,this.args=r,this.result=d}}e.ApiCommand=g}),define(Ee[186],_e([0,1,9,6,58,71,17,86]),function(te,e,h,R,D,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(h.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,f)=>{if((0,k.isFalsyOrEmpty)(c))return;class l extends R.SymbolInformation{static to(w){const b=new l(w.name,h.SymbolKind.to(w.kind),w.containerName||"",new R.Location(f[0],h.Range.to(w.range)));return b.detail=w.detail,b.range=b.location.range,b.selectionRange=h.Range.to(w.selectionRange),b.children=w.children?w.children.map(l.to):[],b}}return c.map(l.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(h.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(h.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new y.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(h.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(h.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(h.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(f=>R.Position.isPosition(f)),c=>c.map(h.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(f=>{let l;for(const o of f.reverse())l=new R.SelectionRange(h.Range.to(o),l);return l}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>{const f=[];if(Array.isArray(c))for(let l of c)f.push(...l[1].map(h.WorkspaceSymbol.to));return f})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(h.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(h.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(h.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return h.WorkspaceEdit.to(c)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(h.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new R.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const f=(0,S.decodeSemanticTokensDto)(c);if(f.type==="full")return new R.SemanticTokens(f.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new R.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const f=(0,S.decodeSemanticTokensDto)(c);if(f.type==="full")return new R.SemanticTokens(f.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,f,l)=>{if(!c)return new R.CompletionList([]);const o=c.suggestions.map(w=>h.CompletionItem.to(w,l));return new R.CompletionList(o,c.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return h.SignatureHelp.to(c)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,f,l)=>n(o=>new R.CodeLens(h.Range.to(o.range),o.command&&l.fromInternal(o.command)))(c))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>R.Range.isRange(c),c=>R.Selection.isSelection(c)?h.Selection.from(c):h.Range.from(c)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,f,l)=>n(o=>{if(o._isSynthetic){if(!o.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(o.command)}else{const w=new R.CodeAction(o.title,o.kind?new R.CodeActionKind(o.kind):void 0);return o.edit&&(w.edit=h.WorkspaceEdit.to(o.edit)),o.command&&(w.command=l.fromInternal(o.command)),w.isPreferred=o.isPreferred,w}})(c))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(f=>new R.ColorInformation(h.Range.to(f.range),h.Color.to(f.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",c=>c instanceof R.Color,h.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:h.Range.from(c.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(h.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",c=>c.map(h.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(f=>h.NotebookExclusiveDocumentPattern.to(f))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(h.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[h.ViewColumn.from(c.viewColumn),h.TextEditorOpenOptions.from(c)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[h.ViewColumn.from(c.viewColumn),h.TextEditorOpenOptions.from(c)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[h.ViewColumn.from(c.viewColumn),h.TextEditorOpenOptions.from(c)]).optional()],y.ApiCommandResult.Void)];class C{static register(f){_.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=C;function n(c){return f=>{if(Array.isArray(f))return f.map(c)}}function P(c){if(!Array.isArray(c))return;const f=[];for(const l of c)D.isLocationLink(l)?f.push(h.DefinitionLink.to(l)):f.push(h.location.to(l));return f}}),define(Ee[187],_e([0,1,16,48,3,7,2,58,26,9,6,5]),function(te,e,h,R,D,y,k,S,_,C,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(f,l,o){const w=f.getProxy(P.MainContext.MainThreadComments);class b{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,l.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const d=this._commentControllers.get(r.handle);return d||r}else if(r&&r.$mid===7){const d=this._commentControllers.get(r.commentControlHandle);if(!d)return r;const m=d.getCommentThread(r.commentThreadHandle);return m||r}else if(r&&r.$mid===8){const d=this._commentControllers.get(r.thread.commentControlHandle);if(!d)return r;const m=d.getCommentThread(r.thread.commentThreadHandle);return m?{thread:m,text:r.text}:r}else if(r&&r.$mid===9){const d=this._commentControllers.get(r.thread.commentControlHandle);if(!d)return r;const m=d.getCommentThread(r.thread.commentThreadHandle);if(!m)return r;let p=r.commentUniqueId,I=m.getCommentByUniqueId(p);return I||r}else if(r&&r.$mid===10){const d=this._commentControllers.get(r.thread.commentControlHandle);if(!d)return r;const m=d.getCommentThread(r.thread.commentThreadHandle);if(!m)return r;let p=r.text,I=r.commentUniqueId,A=m.getCommentByUniqueId(I);return A?(A.body=p,A):r}return r}})}createCommentController(r,d,m){const p=b.handlePool++,I=new u(r,p,d,m);this._commentControllers.set(I.handle,I);const A=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(r.identifier))||[];return A.push(I),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(r.identifier),A),I.value}$createCommentThreadTemplate(r,d,m){const p=this._commentControllers.get(r);!p||p.$createCommentThreadTemplate(d,m)}async $updateCommentThreadTemplate(r,d,m){const p=this._commentControllers.get(r);!p||p.$updateCommentThreadTemplate(d,m)}$deleteCommentThread(r,d){const m=this._commentControllers.get(r);m&&m.$deleteCommentThread(d)}$provideCommentingRanges(r,d,m){const p=this._commentControllers.get(r);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const I=o.getDocument(k.URI.revive(d));return(0,h.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(I,m)).then(A=>A?A.map(a=>C.Range.from(a)):void 0)}$toggleReaction(r,d,m,p,I){const A=this._commentControllers.get(r);return!A||!A.reactionHandler?Promise.resolve(void 0):(0,h.asPromise)(()=>{const a=A.getCommentThread(d);if(a){const T=a.getCommentByUniqueId(p.uniqueIdInThread);if(A!==void 0&&T&&A.reactionHandler)return A.reactionHandler(T,t(I))}return Promise.resolve(void 0)})}dispose(){}}b.handlePool=0;class E{constructor(r,d,m,p,I,A,a){this._commentControllerHandle=d,this._id=m,this._uri=p,this._range=I,this._comments=A,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${r}.${this.handle}`),w.$createCommentThread(d,this.handle,this._id,this._uri,C.Range.from(this._range),a),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=A,this._localDisposables.push({dispose:()=>{w.$deleteCommentThread(d,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(M){T.range=M},get comments(){return T.comments},set comments(M){T.comments=M},get collapsibleState(){return T.collapsibleState},set collapsibleState(M){T.collapsibleState=M},get canReply(){return T.canReply},set canReply(M){T.canReply=M},get contextValue(){return T.contextValue},set contextValue(M){T.contextValue=M},get label(){return T.label},set label(M){T.label=M},dispose:()=>{T.dispose()}}}set threadId(r){this._id=r}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(r){r.isEqual(this._range)||(this._range=r,this.modifications.range=r,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(r){this._canReply!==r&&(this._canReply=r,this.modifications.canReply=r,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(r){this._label=r,this.modifications.label=r,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(r){this._contextValue=r,this.modifications.contextValue=r,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(r){this._comments=r,this.modifications.comments=r,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(r){this._collapseState=r,this.modifications.collapsibleState=r,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const r=m=>Object.prototype.hasOwnProperty.call(this.modifications,m),d={};r("range")&&(d.range=C.Range.from(this._range)),r("label")&&(d.label=this.label),r("contextValue")&&(d.contextValue=this.contextValue),r("comments")&&(d.comments=this._comments.map(m=>g(this,m,this._commentsMap))),r("collapsibleState")&&(d.collapseState=s(this._collapseState)),r("canReply")&&(d.canReply=this.canReply),this.modifications={},w.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,d)}getCommentByUniqueId(r){for(let d of this._commentsMap){let m=d[0],p=d[1];if(r===p)return m}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(r=>r.dispose())}}E._handlePool=0,He([(0,R.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class u{constructor(r,d,m,p){this._extension=r,this._handle=d,this._id=m,this._label=p,this._threads=new Map,w.$registerCommentController(this.handle,m,p);const I=this;this.value=Object.freeze({id:I.id,label:I.label,get options(){return I.options},set options(A){I.options=A},get commentingRangeProvider(){return I.commentingRangeProvider},set commentingRangeProvider(A){I.commentingRangeProvider=A},get reactionHandler(){return I.reactionHandler},set reactionHandler(A){I.reactionHandler=A},createCommentThread(A,a,T){return I.createCommentThread(A,a,T).value},dispose:()=>{I.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{w.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(r){this._reactionHandler=r,w.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!r})}get options(){return this._options}set options(r){this._options=r,w.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(r,d,m,p){if(typeof r=="string"){const I=new E(this.id,this.handle,r,d,m,p,this._extension.identifier);return this._threads.set(I.handle,I),I}else{const I=new E(this.id,this.handle,void 0,r,d,m,this._extension.identifier);return this._threads.set(I.handle,I),I}}$createCommentThreadTemplate(r,d){const m=new E(this.id,this.handle,void 0,k.URI.revive(r),C.Range.to(d),[],this._extension.identifier);return m.collapsibleState=S.CommentThreadCollapsibleState.Expanded,this._threads.set(m.handle,m),m}$updateCommentThreadTemplate(r,d){let m=this._threads.get(r);m&&(m.range=C.Range.to(d))}$deleteCommentThread(r){let d=this._threads.get(r);d&&d.dispose(),this._threads.delete(r)}getCommentThread(r){return this._threads.get(r)}dispose(){this._threads.forEach(r=>{r.dispose()}),this._localDisposables.forEach(r=>r.dispose())}}function g(i,r,d){let m=d.get(r);m||(m=++i.commentHandle,d.set(r,m));const p=r.author&&r.author.iconPath?r.author.iconPath.toString():void 0;return{mode:r.mode,contextValue:r.contextValue,uniqueIdInThread:m,body:C.MarkdownString.from(r.body),userName:r.author.name,userIconPath:p,label:r.label,commentReactions:r.reactions?r.reactions.map(I=>v(I)):void 0}}function v(i){return{label:i.label,iconPath:i.iconPath?C.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function t(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?k.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function s(i){if(i!==void 0)switch(i){case n.CommentThreadCollapsibleState.Expanded:return S.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return S.CommentThreadCollapsibleState.Collapsed}return S.CommentThreadCollapsibleState.Collapsed}return new b}e.createExtHostComments=c}),define(Ee[101],_e([0,1,2,5,6,4,13,15,17,8,14]),function(te,e,h,R,D,y,k,S,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class En{constructor(f,l){this._logService=l,this._provider=new Map,this._proxy=f.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,l){const o=En._handlePool++;this._provider.set(o,{provider:f,extensionId:l}),this._proxy.$registerDecorationProvider(o,l.value);const w=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(b=>{if(!b){this._proxy.$onDidChange(o,null);return}let E=(0,_.asArray)(b);if(E.length<=En._maxEventSize){this._proxy.$onDidChange(o,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,E.length);const u=E.map(t=>({uri:t,rank:(0,C.count)(t.path,"/")})),g=(0,_.groupBy)(u,(t,s)=>t.rank-s.rank||(0,C.compare)(t.uri.path,s.uri.path));let v=[];e:for(let t of g){let s;for(let i of t){let r=(0,n.dirname)(i.uri.path);if(s!==r&&(s=r,v.push(i.uri)>=En._maxEventSize))break e}}this._proxy.$onDidChange(o,v)});return new D.Disposable(()=>{w?.dispose(),this._proxy.$unregisterDecorationProvider(o),this._provider.delete(o)})}async $provideDecorations(f,l,o){if(!this._provider.has(f))return Object.create(null);const w=Object.create(null),{provider:b,extensionId:E}=this._provider.get(f);return await Promise.all(l.map(async u=>{try{const{uri:g,id:v}=u,t=await Promise.resolve(b.provideFileDecoration(h.URI.revive(g),o));if(!t)return;try{D.FileDecoration.validate(t),w[v]=[t.propagate,t.tooltip,t.badge,t.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${E.value}': ${s}`)}}catch(g){this._logService.error(g)}})),w}};P._handlePool=0,P._maxEventSize=250,P=He([ze(0,k.IExtHostRpcService),ze(1,S.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=(0,y.createDecorator)("IExtHostDecorations")}),define(Ee[188],_e([0,1,129,89,2,5,6,9,3,15,22]),function(te,e,h,R,D,y,k,S,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(l,o,w,b,E){this._name=l,this._owner=o,this._maxDiagnosticsPerFile=w,this._proxy=b,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(l,o){if(!l){this.clear();return}this._checkDisposed();let w=[];if(D.URI.isUri(l)){if(!o){this.delete(l);return}this._data.set(l,o.slice()),w=[l]}else if(Array.isArray(l)){w=[];let E;l=[...l].sort(P._compareIndexedTuplesByUri);for(const u of l){const[g,v]=u;if((!E||g.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=g,w.push(g),this._data.set(g,[])),v){const t=this._data.get(g);t&&t.push(...v)}else{const t=this._data.get(g);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(w),!this._proxy)return;const b=[];for(let E of w){let u=[];const g=this._data.get(E);if(g)if(g.length>this._maxDiagnosticsPerFile){u=[];const v=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let s of g)if(s.severity===v[t]&&u.push(S.Diagnostic.from(s))===this._maxDiagnosticsPerFile)break e;u.push({severity:R.MarkerSeverity.Info,message:(0,h.localize)(0,null,g.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=g.map(v=>S.Diagnostic.from(v));b.push([E,u])}this._proxy.$changeMany(this._owner,b)}delete(l){this._checkDisposed(),this._onDidChangeDiagnostics.fire([l]),this._data.delete(l),this._proxy&&this._proxy.$changeMany(this._owner,[[l,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(l,o){this._checkDisposed();for(let w of this._data.keys())l.apply(o,[w,this.get(w),this])}get(l){this._checkDisposed();const o=this._data.get(l);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(l){return this._checkDisposed(),Array.isArray(this._data.get(l))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(l,o){return l[0].toString()<o[0].toString()?-1:l[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=P;let c=class Qt{constructor(l,o){this._logService=o,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:w=>w.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,Qt._mapper),this._proxy=l.getProxy(y.MainContext.MainThreadDiagnostics)}static _mapper(l){const o=new n.ResourceMap;for(const w of l)o.set(w,w);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(l,o){const{_collections:w,_proxy:b,_onDidChangeDiagnostics:E,_logService:u}=this,g=new class{$changeMany(s,i){b.$changeMany(s,i),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,s,i.length===0?"CLEARING":i)}$clear(s){b.$clear(s),u.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,s)}dispose(){b.dispose()}};let v;if(!o)o="_generated_diagnostic_collection_name_#"+Qt._idPool++,v=o;else if(!w.has(o))v=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do v=o+Qt._idPool++;while(w.has(v))}return new class extends P{constructor(){super(o,v,Qt._maxDiagnosticsPerFile,g,E);w.set(v,this)}dispose(){super.dispose(),w.delete(v)}}}getDiagnostics(l){if(l)return this._getDiagnostics(l);{const o=new Map,w=[];for(const b of this._collections.values())b.forEach((E,u)=>{let g=o.get(E.toString());typeof g=="undefined"&&(g=w.length,o.set(E.toString(),g),w.push([E,[]])),w[g][1]=w[g][1].concat(...u)});return w}}_getDiagnostics(l){let o=[];for(let w of this._collections.values())w.has(l)&&(o=o.concat(w.get(l)));return o}$acceptMarkersChange(l){if(!this._mirrorCollection){const o="_generated_mirror",w=new P(o,o,Qt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(o,w),this._mirrorCollection=w}for(const[o,w]of l)this._mirrorCollection.set(D.URI.revive(o),w.map(S.Diagnostic.to))}};c._idPool=0,c._maxDiagnosticsPerFile=1e3,c=He([ze(1,C.ILogService)],c),e.ExtHostDiagnostics=c}),define(Ee[189],_e([0,1,2,5]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(k){this._proxy=k.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(k){return this._proxy.$showOpenDialog(k).then(S=>S?S.map(_=>h.URI.revive(_)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(S=>S?h.URI.revive(S):void 0)}}e.ExtHostDialogs=D}),define(Ee[190],_e([0,1,12,2,6,5,11,18,8]),function(te,e,h,R,D,y,k,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(P,c,f){this._documentsAndEditors=c,this._logService=f,this._documentContentProviders=new Map,this._proxy=P.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,c){if(Object.keys(k.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const f=C._handlePool++;this._documentContentProviders.set(f,c),this._proxy.$registerTextContentProvider(f,P);let l;return typeof c.onDidChange=="function"&&(l=c.onDidChange(o=>{if(o.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(o)&&this.$provideTextDocumentContent(f,o).then(w=>{if(!w&&typeof w!="string")return;const b=this._documentsAndEditors.getDocument(o);if(!b)return;const E=(0,_.splitLines)(w);if(!b.equalLines(E))return this._proxy.$onVirtualDocumentChange(o,w)},h.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(P,c){const f=this._documentContentProviders.get(P);return f?Promise.resolve(f.provideTextDocumentContent(R.URI.revive(c),S.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(Ee[191],_e([0,1,3,7,2,5,95,9,10,24,6]),function(te,e,h,R,D,y,k,S,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(f,l){this._onDidAddDocument=new h.Emitter,this._onDidRemoveDocument=new h.Emitter,this._onDidChangeDocument=new h.Emitter,this._onDidSaveDocument=new h.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=l,this._documentsAndEditors.onDidRemoveDocuments(o=>{for(const w of o)this._onDidRemoveDocument.fire(w.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(o=>{for(const w of o)this._onDidAddDocument.fire(w.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const l=this._documentsAndEditors.getDocument(f);if(l)return l}getDocument(f){const l=this.getDocumentData(f);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return l.document}ensureDocumentData(f){const l=this._documentsAndEditors.getDocument(f);if(l)return Promise.resolve(l);let o=this._documentLoader.get(f.toString());return o||(o=this._proxy.$tryOpenDocument(f).then(w=>{this._documentLoader.delete(f.toString());const b=D.URI.revive(w);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(b))},w=>(this._documentLoader.delete(f.toString()),Promise.reject(w))),this._documentLoader.set(f.toString(),o)),o}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(l=>D.URI.revive(l))}$acceptModelModeChanged(f,l){const o=D.URI.revive(f),w=this._documentsAndEditors.getDocument(o);if(!w)throw new Error("unknown document");this._onDidRemoveDocument.fire(w.document),w._acceptLanguageId(l),this._onDidAddDocument.fire(w.document)}$acceptModelSaved(f){const l=D.URI.revive(f),o=this._documentsAndEditors.getDocument(l);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(o.document)}$acceptDirtyStateChanged(f,l){const o=D.URI.revive(f),w=this._documentsAndEditors.getDocument(o);if(!w)throw new Error("unknown document");w._acceptIsDirty(l),this._onDidChangeDocument.fire({document:w.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,l,o){const w=D.URI.revive(f),b=this._documentsAndEditors.getDocument(w);if(!b)throw new Error("unknown document");b._acceptIsDirty(o),b.onEvents(l);let E;l.isUndoing?E=n.TextDocumentChangeReason.Undo:l.isRedoing&&(E=n.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:b.document,contentChanges:l.changes.map(u=>({range:S.Range.to(u.range),rangeOffset:u.rangeOffset,rangeLength:u.rangeLength,text:u.text})),reason:E}))}setWordDefinitionFor(f,l){(0,k.setWordDefinitionFor)(f,l)}}e.ExtHostDocuments=P}),define(Ee[46],_e([0,1,39,3,7,2,4,5,95,13,99,9,15,22,11,40,109]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f,l,o,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class b{constructor(g){this.value=g,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(g,v){this._extHostRpc=g,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(g){this.acceptDocumentsAndEditorsDelta(g)}acceptDocumentsAndEditorsDelta(g){const v=[],t=[],s=[];if(g.removedDocuments)for(const i of g.removedDocuments){const r=y.URI.revive(i),d=this._documents.get(r);d?.unref()&&(this._documents.delete(r),v.push(d.value))}if(g.addedDocuments)for(const i of g.addedDocuments){const r=y.URI.revive(i.uri);let d=this._documents.get(r);if(d&&r.scheme!==l.Schemas.vscodeNotebookCell&&r.scheme!==l.Schemas.vscodeInteractiveInput)throw new Error(`document '${r} already exists!'`);d||(d=new b(new _.ExtHostDocumentData(this._extHostRpc.getProxy(S.MainContext.MainThreadDocuments),r,i.lines,i.EOL,i.versionId,i.modeId,i.isDirty,i.notebook)),this._documents.set(r,d),t.push(d.value)),d.ref()}if(g.removedEditors)for(const i of g.removedEditors){const r=this._editors.get(i);this._editors.delete(i),r&&s.push(r)}if(g.addedEditors)for(const i of g.addedEditors){const r=y.URI.revive(i.documentUri);h.ok(this._documents.has(r),`document '${r}' does not exist`),h.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const d=this._documents.get(r).value,m=new n.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(S.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>d.document),i.selections.map(P.Selection.to),i.options,i.visibleRanges.map(p=>P.Range.to(p)),typeof i.editorPosition=="number"?P.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,m)}g.newActiveEditor!==void 0&&(h.ok(g.newActiveEditor===null||this._editors.has(g.newActiveEditor),`active editor '${g.newActiveEditor}' does not exist`),this._activeEditorId=g.newActiveEditor),(0,D.dispose)(v),(0,D.dispose)(s),g.removedDocuments&&this._onDidRemoveDocuments.fire(v),g.addedDocuments&&this._onDidAddDocuments.fire(t),(g.removedEditors||g.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),g.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(g){return this._documents.get(g)?.value}allDocuments(){return o.Iterable.map(this._documents.values(),g=>g.value)}getEditor(g){return this._editors.get(g)}activeEditor(g){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return g?v:v?.value}allEditors(){return[...this._editors.values()]}};E=He([ze(0,C.IExtHostRpcService),ze(1,c.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,k.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ee[192],_e([0,1,2,5,7,6,9,119,8,23]),function(te,e,h,R,D,y,k,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const l=this._schemes.indexOf(f);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),l=[];let o,w,b=14,E=14;for(const u of f){let g=o?(0,_.commonPrefixLength)(o,u):0;for(g===0?w=1:w=E;g<u.length;g++)g+1===u.length?(b=E,E=9):E+=1,l.push([w,u.toUpperCase().charCodeAt(g),E]),l.push([w,u.toLowerCase().charCodeAt(g),E]),w=E;o=u,E=b}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new S.StateMachine(l)}}provideDocumentLinks(f){this._initStateMachine();const l=[],o=S.LinkComputer.computeLinks({getLineContent(w){return f.lineAt(w-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const w of o){const b=k.DocumentLink.to(w);b.target&&l.push(b)}return l}}class P{constructor(f,l){this._extHostLanguageFeatures=l,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=f.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,l,o,w={},b){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const E=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(E,o),this._enableProposedApi.set(E,b??!1);let u=2;w.isCaseSensitive&&(u+=1024),w.isReadonly&&(u+=2048),typeof o.copy=="function"&&(u+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&(u+=4),this._proxy.$registerFileSystemProvider(E,l,u).catch(v=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${l}`),console.error(v)});const g=o.onDidChangeFile(v=>{const t=[];for(const s of v){let{uri:i,type:r}=s;if(i.scheme!==l)continue;let d;switch(r){case y.FileChangeType.Changed:d=0;break;case y.FileChangeType.Created:d=1;break;case y.FileChangeType.Deleted:d=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:i,type:d})}this._proxy.$onFileSystemChange(E,t)});return(0,D.toDisposable)(()=>{g.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(E),this._enableProposedApi.delete(E),this._proxy.$unregisterProvider(E)})}static _asIStat(f,l){const{type:o,ctime:w,mtime:b,size:E,permissions:u}=f;return l?{type:o,ctime:w,mtime:b,size:E,permissions:u}:{type:o,ctime:w,mtime:b,size:E}}$stat(f,l){return Promise.resolve(this._getFsProvider(f).stat(h.URI.revive(l))).then(o=>P._asIStat(o,this._enableProposedApi.get(f)??!1))}$readdir(f,l){return Promise.resolve(this._getFsProvider(f).readDirectory(h.URI.revive(l)))}$readFile(f,l){return Promise.resolve(this._getFsProvider(f).readFile(h.URI.revive(l))).then(o=>C.VSBuffer.wrap(o))}$writeFile(f,l,o,w){return Promise.resolve(this._getFsProvider(f).writeFile(h.URI.revive(l),o.buffer,w))}$delete(f,l,o){return Promise.resolve(this._getFsProvider(f).delete(h.URI.revive(l),o))}$rename(f,l,o,w){return Promise.resolve(this._getFsProvider(f).rename(h.URI.revive(l),h.URI.revive(o),w))}$copy(f,l,o,w){const b=this._getFsProvider(f);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(h.URI.revive(l),h.URI.revive(o),w))}$mkdir(f,l){return Promise.resolve(this._getFsProvider(f).createDirectory(h.URI.revive(l)))}$watch(f,l,o,w){const b=this._getFsProvider(f).watch(h.URI.revive(o),w);this._watches.set(l,b)}$unwatch(f,l){const o=this._watches.get(l);o&&(o.dispose(),this._watches.delete(l))}$open(f,l,o){const w=this._getFsProvider(f);if(!w.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(w.open(h.URI.revive(l),o))}$close(f,l){const o=this._getFsProvider(f);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(l))}$read(f,l,o,w){const b=this._getFsProvider(f);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const E=C.VSBuffer.alloc(w);return Promise.resolve(b.read(l,o,E.buffer,0,w)).then(u=>E.slice(0,u))}$write(f,l,o,w){const b=this._getFsProvider(f);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(l,o,w.buffer,0,w.byteLength))}_getFsProvider(f){const l=this._fsProvider.get(f);if(!l){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return l}}e.ExtHostFileSystem=P}),define(Ee[72],_e([0,1,5,60,6,23,4,13,45]),function(te,e,h,R,D,y,k,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class xt{constructor(P,c){const f=P.getProxy(h.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(l){return f.$stat(l).catch(xt._handleError)},readDirectory(l){return f.$readdir(l).catch(xt._handleError)},createDirectory(l){return f.$mkdir(l).catch(xt._handleError)},async readFile(l){return f.$readFile(l).then(o=>o.buffer).catch(xt._handleError)},writeFile(l,o){return f.$writeFile(l,y.VSBuffer.wrap(o)).catch(xt._handleError)},delete(l,o){return f.$delete(l,{recursive:!1,useTrash:!1,...o}).catch(xt._handleError)},rename(l,o,w){return f.$rename(l,o,{overwrite:!1,...w}).catch(xt._handleError)},copy(l,o,w){return f.$copy(l,o,{overwrite:!1,...w}).catch(xt._handleError)},isWritableFileSystem(l){const o=c.getCapabilities(l);if(typeof o=="number")return!(o&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new D.FileSystemError(String(P));if(P.name==="ENOPRO")throw D.FileSystemError.Unavailable(P.message);switch(P.name){case R.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(P.message);case R.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(P.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(P.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(P.message);case R.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(P.message);case R.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(P.message);default:throw new D.FileSystemError(P.message,P.name)}}};C=He([ze(0,S.IExtHostRpcService),ze(1,_.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=(0,k.createDecorator)("IExtHostConsumerFileSystem")}),define(Ee[193],_e([0,1,7,5]),function(te,e,h,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(k){this._handlePool=0,this._proxy=k.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const S=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(S,k),(0,h.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(S)})}}e.ExtHostLabelService=D}),define(Ee[194],_e([0,1,2,24,9,6,5,8,30,17,10,116,7,86,50,63,51,12,3]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f,l,o,w,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class u{constructor(U,G){this._documents=U,this._provider=G}async provideDocumentSymbols(U,G){const ne=this._documents.getDocument(U),se=await this._provider.provideDocumentSymbols(ne,G);if(!(0,C.isFalsyOrEmpty)(se))return se[0]instanceof y.DocumentSymbol?se.map(D.DocumentSymbol.from):u._asDocumentSymbolTree(se)}static _asDocumentSymbolTree(U){U=U.slice(0).sort((se,ge)=>{let X=se.location.range.start.compareTo(ge.location.range.start);return X===0&&(X=ge.location.range.end.compareTo(se.location.range.end)),X});const G=[],ne=[];for(const se of U){const ge={name:se.name||"!!MISSING: name!!",kind:D.SymbolKind.from(se.kind),tags:se.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:D.Range.from(se.location.range),selectionRange:D.Range.from(se.location.range),children:[]};for(;;){if(ne.length===0){ne.push(ge),G.push(ge);break}const X=ne[ne.length-1];if(_.Range.containsRange(X.range,ge.range)&&!_.Range.equalsRange(X.range,ge.range)){X.children&&X.children.push(ge),ne.push(ge);break}ne.pop()}}return G}}class g{constructor(U,G,ne){this._documents=U,this._commands=G,this._provider=ne,this._cache=new o.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(U,G){const ne=this._documents.getDocument(U),se=await this._provider.provideCodeLenses(ne,G);if(!se||G.isCancellationRequested)return;const ge=this._cache.add(se),X=new c.DisposableStore;this._disposables.set(ge,X);const ce={cacheId:ge,lenses:[]};for(let ke=0;ke<se.length;ke++)ce.lenses.push({cacheId:[ge,ke],range:D.Range.from(se[ke].range),command:this._commands.toInternal(se[ke].command,X)});return ce}async resolveCodeLens(U,G){const ne=U.cacheId&&this._cache.get(...U.cacheId);if(!ne)return;let se;if(typeof this._provider.resolveCodeLens!="function"||ne.isResolved?se=ne:se=await this._provider.resolveCodeLens(ne,G),se||(se=ne),G.isCancellationRequested)return;const ge=U.cacheId&&this._disposables.get(U.cacheId[0]);if(!!ge)return U.command=this._commands.toInternal(se.command??g._badCmd,ge),U}releaseCodeLenses(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}}g._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(qe){return Array.isArray(qe)?qe.map(D.DefinitionLink.from):qe?[D.DefinitionLink.from(qe)]:[]}class t{constructor(U,G){this._documents=U,this._provider=G}async provideDefinition(U,G,ne){const se=this._documents.getDocument(U),ge=D.Position.to(G),X=await this._provider.provideDefinition(se,ge,ne);return v(X)}}class s{constructor(U,G){this._documents=U,this._provider=G}async provideDeclaration(U,G,ne){const se=this._documents.getDocument(U),ge=D.Position.to(G),X=await this._provider.provideDeclaration(se,ge,ne);return v(X)}}class i{constructor(U,G){this._documents=U,this._provider=G}async provideImplementation(U,G,ne){const se=this._documents.getDocument(U),ge=D.Position.to(G),X=await this._provider.provideImplementation(se,ge,ne);return v(X)}}class r{constructor(U,G){this._documents=U,this._provider=G}async provideTypeDefinition(U,G,ne){const se=this._documents.getDocument(U),ge=D.Position.to(G),X=await this._provider.provideTypeDefinition(se,ge,ne);return v(X)}}class d{constructor(U,G){this._documents=U,this._provider=G}async provideHover(U,G,ne){const se=this._documents.getDocument(U),ge=D.Position.to(G),X=await this._provider.provideHover(se,ge,ne);if(!(!X||(0,C.isFalsyOrEmpty)(X.contents)))return X.range||(X.range=se.getWordRangeAtPosition(ge)),X.range||(X.range=new y.Range(ge,ge)),D.Hover.from(X)}}class m{constructor(U,G){this._documents=U,this._provider=G}async provideEvaluatableExpression(U,G,ne){const se=this._documents.getDocument(U),ge=D.Position.to(G),X=await this._provider.provideEvaluatableExpression(se,ge,ne);if(X)return D.EvaluatableExpression.from(X)}}class p{constructor(U,G){this._documents=U,this._provider=G}async provideInlineValues(U,G,ne,se){const ge=this._documents.getDocument(U),X=await this._provider.provideInlineValues(ge,D.Range.to(G),D.InlineValueContext.to(ne),se);if(Array.isArray(X))return X.map(ce=>D.InlineValue.from(ce))}}class I{constructor(U,G){this._documents=U,this._provider=G}async provideDocumentHighlights(U,G,ne){const se=this._documents.getDocument(U),ge=D.Position.to(G),X=await this._provider.provideDocumentHighlights(se,ge,ne);if(Array.isArray(X))return X.map(D.DocumentHighlight.from)}}class A{constructor(U,G){this._documents=U,this._provider=G}async provideLinkedEditingRanges(U,G,ne){const se=this._documents.getDocument(U),ge=D.Position.to(G),X=await this._provider.provideLinkedEditingRanges(se,ge,ne);if(X&&Array.isArray(X.ranges))return{ranges:(0,C.coalesce)(X.ranges.map(D.Range.from)),wordPattern:X.wordPattern}}}class a{constructor(U,G){this._documents=U,this._provider=G}async provideReferences(U,G,ne,se){const ge=this._documents.getDocument(U),X=D.Position.to(G),ce=await this._provider.provideReferences(ge,X,ne,se);if(Array.isArray(ce))return ce.map(D.location.from)}}class T{constructor(U,G,ne,se,ge,X,ce){this._documents=U,this._commands=G,this._diagnostics=ne,this._provider=se,this._logService=ge,this._extension=X,this._apiDeprecation=ce,this._cache=new o.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(U,G,ne,se){const ge=this._documents.getDocument(U),X=P.Selection.isISelection(G)?D.Selection.to(G):D.Range.to(G),ce=[];for(const z of this._diagnostics.getDiagnostics(U))if(X.intersection(z.range)&&ce.push(z)>T._maxCodeActionsPerFile)break;const ke={diagnostics:ce,only:ne.only?new y.CodeActionKind(ne.only):void 0,triggerKind:D.CodeActionTriggerKind.to(ne.trigger)},Be=await this._provider.provideCodeActions(ge,X,ke,se);if(!(0,C.isNonEmptyArray)(Be)||se.isCancellationRequested)return;const $e=this._cache.add(Be),pe=new c.DisposableStore;this._disposables.set($e,pe);const tt=[];for(let z=0;z<Be.length;z++){const Q=Be[z];!Q||(T._isCommand(Q)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:Q.title,command:this._commands.toInternal(Q,pe)})):(ke.only&&(Q.kind?ke.only.contains(Q.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ke.only.value} 'requested but returned code action is of kind '${Q.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ke.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[$e,z],title:Q.title,command:Q.command&&this._commands.toInternal(Q.command,pe),diagnostics:Q.diagnostics&&Q.diagnostics.map(D.Diagnostic.from),edit:Q.edit&&D.WorkspaceEdit.from(Q.edit),kind:Q.kind&&Q.kind.value,isPreferred:Q.isPreferred,disabled:Q.disabled?.reason})))}return{cacheId:$e,actions:tt}}async resolveCodeAction(U,G){const[ne,se]=U,ge=this._cache.get(ne,se);if(!ge||T._isCommand(ge)||!this._provider.resolveCodeAction)return;const X=await this._provider.resolveCodeAction(ge,G)??ge;return X?.edit?D.WorkspaceEdit.from(X.edit):void 0}releaseCodeActions(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}static _isCommand(U){return typeof U.command=="string"&&typeof U.title=="string"}}T._maxCodeActionsPerFile=1e3;class M{constructor(U,G){this._documents=U,this._provider=G}async provideDocumentFormattingEdits(U,G,ne){const se=this._documents.getDocument(U),ge=await this._provider.provideDocumentFormattingEdits(se,G,ne);if(Array.isArray(ge))return ge.map(D.TextEdit.from)}}class W{constructor(U,G){this._documents=U,this._provider=G}async provideDocumentRangeFormattingEdits(U,G,ne,se){const ge=this._documents.getDocument(U),X=D.Range.to(G),ce=await this._provider.provideDocumentRangeFormattingEdits(ge,X,ne,se);if(Array.isArray(ce))return ce.map(D.TextEdit.from)}}class B{constructor(U,G){this._documents=U,this._provider=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,G,ne,se,ge){const X=this._documents.getDocument(U),ce=D.Position.to(G),ke=await this._provider.provideOnTypeFormattingEdits(X,ce,ne,se,ge);if(Array.isArray(ke))return ke.map(D.TextEdit.from)}}class Z{constructor(U,G){this._provider=U,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(U,G){const ne=k.IdObject.mixin({symbols:[]}),se=await this._provider.provideWorkspaceSymbols(U,G);if((0,C.isNonEmptyArray)(se))for(const ge of se){if(!ge)continue;if(!ge.name){this._logService.warn("INVALID SymbolInformation, lacks name",ge);continue}const X=k.IdObject.mixin(D.WorkspaceSymbol.from(ge));this._symbolCache.set(X._id,ge),ne.symbols.push(X)}return ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne}async resolveWorkspaceSymbol(U,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return U;const ne=this._symbolCache.get(U._id);if(ne){const se=await this._provider.resolveWorkspaceSymbol(ne,G);return se&&(0,R.mixin)(U,D.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(U){const G=this._resultCache.get(U);if(G){for(let[ne,se]=G;ne<=se;ne++)this._symbolCache.delete(ne);this._resultCache.delete(U)}}}class q{constructor(U,G,ne){this._documents=U,this._provider=G,this._logService=ne}static supportsResolving(U){return typeof U.prepareRename=="function"}async provideRenameEdits(U,G,ne,se){const ge=this._documents.getDocument(U),X=D.Position.to(G);try{const ce=await this._provider.provideRenameEdits(ge,X,ne,se);return ce?D.WorkspaceEdit.from(ce):void 0}catch(ce){const ke=q._asMessage(ce);return ke?{rejectReason:ke,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(U,G,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(U),ge=D.Position.to(G);try{const X=await this._provider.prepareRename(se,ge,ne);let ce,ke;if(y.Range.isRange(X)?(ce=X,ke=se.getText(X)):(0,n.isObject)(X)&&(ce=X.range,ke=X.placeholder),!ce||!ke)return;if(ce.start.line>ge.line||ce.end.line<ge.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ce),text:ke}}catch(X){const ce=q._asMessage(X);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(X)}}static _asMessage(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class ${constructor(U,G){this.resultId=U,this.tokens=G}}class V{constructor(U,G){this._documents=U,this._provider=G,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(U,G,ne){const se=this._documents.getDocument(U),ge=G!==0?this._previousResults.get(G):null;let X=typeof ge?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(se,ge.resultId,ne):await this._provider.provideDocumentSemanticTokens(se,ne);return ge&&this._previousResults.delete(G),X?(X=V._fixProvidedSemanticTokens(X),this._send(V._convertToEdits(ge,X),X)):null}async releaseDocumentSemanticColoring(U){this._previousResults.delete(U)}static _fixProvidedSemanticTokens(U){return V._isSemanticTokens(U)?V._isCorrectSemanticTokens(U)?U:new y.SemanticTokens(new Uint32Array(U.data),U.resultId):V._isSemanticTokensEdits(U)?V._isCorrectSemanticTokensEdits(U)?U:new y.SemanticTokensEdits(U.edits.map(G=>new y.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),U.resultId):U}static _isSemanticTokens(U){return U&&!!U.data}static _isCorrectSemanticTokens(U){return U.data instanceof Uint32Array}static _isSemanticTokensEdits(U){return U&&Array.isArray(U.edits)}static _isCorrectSemanticTokensEdits(U){for(const G of U.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(U,G){if(!V._isSemanticTokens(G)||!U||!U.tokens)return G;const ne=U.tokens,se=ne.length,ge=G.data,X=ge.length;let ce=0;const ke=Math.min(se,X);for(;ce<ke&&ne[ce]===ge[ce];)ce++;if(ce===se&&ce===X)return new y.SemanticTokensEdits([],G.resultId);let Be=0;const $e=ke-ce;for(;Be<$e&&ne[se-Be-1]===ge[X-Be-1];)Be++;return new y.SemanticTokensEdits([{start:ce,deleteCount:se-ce-Be,data:ge.subarray(ce,X-Be)}],G.resultId)}_send(U,G){if(V._isSemanticTokens(U)){const ne=this._nextResultId++;return this._previousResults.set(ne,new $(U.resultId,U.data)),(0,f.encodeSemanticTokensDto)({id:ne,type:"full",data:U.data})}if(V._isSemanticTokensEdits(U)){const ne=this._nextResultId++;return V._isSemanticTokens(G)?this._previousResults.set(ne,new $(G.resultId,G.data)):this._previousResults.set(ne,new $(U.resultId)),(0,f.encodeSemanticTokensDto)({id:ne,type:"delta",deltas:(U.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class F{constructor(U,G){this._documents=U,this._provider=G}async provideDocumentRangeSemanticTokens(U,G,ne){const se=this._documents.getDocument(U),ge=await this._provider.provideDocumentRangeSemanticTokens(se,D.Range.to(G),ne);return ge?this._send(ge):null}_send(U){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:U.data})}}e.DocumentRangeSemanticTokensAdapter=F;class re{constructor(U,G,ne,se,ge){this._documents=U,this._commands=G,this._provider=ne,this._apiDeprecation=se,this._extension=ge,this._cache=new o.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}async provideCompletionItems(U,G,ne,se){const ge=this._documents.getDocument(U),X=D.Position.to(G),ce=ge.getWordRangeAtPosition(X)||new y.Range(X,X),ke=ce.with({end:X}),Be=new w.StopWatch(!0),$e=await this._provider.provideCompletionItems(ge,X,se,D.CompletionContext.to(ne));if(!$e||se.isCancellationRequested)return;const pe=Array.isArray($e)?new y.CompletionList($e):$e,tt=re.supportsResolving(this._provider)?this._cache.add(pe.items):this._cache.add([]),z=new c.DisposableStore;this._disposables.set(tt,z);const Q=[],fe={x:tt,b:Q,a:{replace:D.Range.from(ce),insert:D.Range.from(ke)},c:pe.isIncomplete||void 0,d:Be.elapsed()};for(let Le=0;Le<pe.items.length;Le++){const Ue=pe.items[Le],Ze=this._convertCompletionItem(Ue,[tt,Le],ke,ce);Q.push(Ze)}return fe}async resolveCompletionItem(U,G){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...U);if(!ne)return;const se=await this._provider.resolveCompletionItem(ne,G);if(!!se)return this._convertCompletionItem(se,U)}releaseCompletionItems(U){this._disposables.get(U)?.dispose(),this._disposables.delete(U),this._cache.delete(U)}_convertCompletionItem(U,G,ne,se){const ge=this._disposables.get(G[0]);if(!ge)throw Error("DisposableStore is missing...");const X={x:G,a:U.label,b:U.kind!==void 0?D.CompletionItemKind.from(U.kind):void 0,n:U.tags&&U.tags.map(D.CompletionItemTag.from),c:U.detail,d:typeof U.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters,l:U.additionalTextEdits&&U.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(U.command,ge)};U.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),X.h=U.textEdit.newText):typeof U.insertText=="string"?X.h=U.insertText:U.insertText instanceof y.SnippetString&&(X.h=U.insertText.value,X.i|=4);let ce;return U.textEdit?ce=U.textEdit.range:U.range&&(ce=U.range),y.Range.isRange(ce)?X.j=D.Range.from(ce):ce&&(!ne?.isEqual(ce.inserting)||!se?.isEqual(ce.replacing))&&(X.j={insert:D.Range.from(ce.inserting),replace:D.Range.from(ce.replacing)}),X}}class N{constructor(U,G,ne){this._documents=U,this._provider=G,this._commands=ne,this._cache=new o.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(U,G,ne,se){const ge=this._documents.getDocument(U),X=D.Position.to(G),ce=await this._provider.provideInlineCompletionItems(ge,X,ne,se);if(!ce||se.isCancellationRequested)return;const ke=(0,n.isArray)(ce)?{items:ce}:ce,Be=this._cache.add(ke.items);let $e;return{pid:Be,items:ke.items.map((pe,tt)=>{let z;return pe.command&&($e||($e=new c.DisposableStore,this._disposables.set(Be,$e)),z=this._commands.toInternal(pe.command,$e)),{text:pe.text,range:pe.range?D.Range.from(pe.range):void 0,command:z,idx:tt}})}}disposeCompletions(U){this._cache.delete(U);const G=this._disposables.get(U);G&&G.clear(),this._disposables.delete(U)}handleDidShowCompletionItem(U,G){const ne=this._cache.get(U,G);ne&&H.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class H{constructor(){this._onDidShowCompletionItemEmitter=new E.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(U){let G=H.map.get(U);return G||(G=new H,H.map.set(U,G)),G}fireOnDidShowCompletionItem(U){this._onDidShowCompletionItemEmitter.fire(U)}}e.InlineCompletionController=H,H.map=new WeakMap;class J{constructor(U,G){this._documents=U,this._provider=G,this._cache=new o.Cache("SignatureHelp")}async provideSignatureHelp(U,G,ne,se){const ge=this._documents.getDocument(U),X=D.Position.to(G),ce=this.reviveContext(ne),ke=await this._provider.provideSignatureHelp(ge,X,se,ce);if(ke){const Be=this._cache.add([ke]);return{...D.SignatureHelp.from(ke),id:Be}}}reviveContext(U){let G;if(U.activeSignatureHelp){const ne=D.SignatureHelp.to(U.activeSignatureHelp),se=this._cache.get(U.activeSignatureHelp.id,0);se?(G=se,G.activeSignature=ne.activeSignature,G.activeParameter=ne.activeParameter):G=ne}return{...U,activeSignatureHelp:G}}releaseSignatureHelp(U){this._cache.delete(U)}}class K{constructor(U,G){this._documents=U,this._provider=G}async provideInlayHints(U,G,ne){const se=this._documents.getDocument(U),ge=await this._provider.provideInlayHints(se,D.Range.to(G),ne);return ge?{hints:ge.map(D.InlayHint.from)}:void 0}}class le{constructor(U,G){this._documents=U,this._provider=G,this._cache=new o.Cache("DocumentLink")}async provideLinks(U,G){const ne=this._documents.getDocument(U),se=await this._provider.provideDocumentLinks(ne,G);if(!(!Array.isArray(se)||se.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(le._validateLink).map(D.DocumentLink.from)};{const ge=this._cache.add(se),X={links:[],id:ge};for(let ce=0;ce<se.length;ce++){if(!le._validateLink(se[ce]))continue;const ke=D.DocumentLink.from(se[ce]);ke.cacheId=[ge,ce],X.links.push(ke)}return X}}}static _validateLink(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,G){if(typeof this._provider.resolveDocumentLink!="function")return;const ne=this._cache.get(...U);if(!ne)return;const se=await this._provider.resolveDocumentLink(ne,G);if(!(!se||!le._validateLink(se)))return D.DocumentLink.from(se)}releaseLinks(U){this._cache.delete(U)}}class Ie{constructor(U,G){this._documents=U,this._provider=G}async provideColors(U,G){const ne=this._documents.getDocument(U),se=await this._provider.provideDocumentColors(ne,G);return Array.isArray(se)?se.map(X=>({color:D.Color.from(X.color),range:D.Range.from(X.range)})):[]}async provideColorPresentations(U,G,ne){const se=this._documents.getDocument(U),ge=D.Range.to(G.range),X=D.Color.to(G.color),ce=await this._provider.provideColorPresentations(X,{document:se,range:ge},ne);if(!!Array.isArray(ce))return ce.map(D.ColorPresentation.from)}}class Me{constructor(U,G){this._documents=U,this._provider=G}async provideFoldingRanges(U,G,ne){const se=this._documents.getDocument(U),ge=await this._provider.provideFoldingRanges(se,G,ne);if(!!Array.isArray(ge))return ge.map(D.FoldingRange.from)}}class Ve{constructor(U,G,ne){this._documents=U,this._provider=G,this._logService=ne}async provideSelectionRanges(U,G,ne){const se=this._documents.getDocument(U),ge=G.map(D.Position.to),X=await this._provider.provideSelectionRanges(se,ge,ne);if(!(0,C.isNonEmptyArray)(X))return[];if(X.length!==ge.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let ke=0;ke<ge.length;ke++){const Be=[];ce.push(Be);let $e=ge[ke],pe=X[ke];for(;;){if(!pe.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(Be.push(D.SelectionRange.from(pe)),!pe.parent)break;$e=pe.range,pe=pe.parent}}return ce}}class xe{constructor(U,G){this._documents=U,this._provider=G,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(U,G,ne){const se=this._documents.getDocument(U),ge=D.Position.to(G),X=await this._provider.prepareCallHierarchy(se,ge,ne);if(!X)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(X)?X.map(ke=>this._cacheAndConvertItem(ce,ke)):[this._cacheAndConvertItem(ce,X)]}async provideCallsTo(U,G,ne){const se=this._itemFromCache(U,G);if(!se)throw new Error("missing call hierarchy item");const ge=await this._provider.provideCallHierarchyIncomingCalls(se,ne);if(!!ge)return ge.map(X=>({from:this._cacheAndConvertItem(U,X.from),fromRanges:X.fromRanges.map(ce=>D.Range.from(ce))}))}async provideCallsFrom(U,G,ne){const se=this._itemFromCache(U,G);if(!se)throw new Error("missing call hierarchy item");const ge=await this._provider.provideCallHierarchyOutgoingCalls(se,ne);if(!!ge)return ge.map(X=>({to:this._cacheAndConvertItem(U,X.to),fromRanges:X.fromRanges.map(ce=>D.Range.from(ce))}))}releaseSession(U){this._cache.delete(U)}_cacheAndConvertItem(U,G){const ne=this._cache.get(U),se={_sessionId:U,_itemId:ne.size.toString(36),name:G.name,detail:G.detail,kind:D.SymbolKind.from(G.kind),uri:G.uri,range:D.Range.from(G.range),selectionRange:D.Range.from(G.selectionRange),tags:G.tags?.map(D.SymbolTag.from)};return ne.set(se._itemId,G),se}_itemFromCache(U,G){return this._cache.get(U)?.get(G)}}class Ge{constructor(U,G){this.adapter=U,this.extension=G}}class Ke{constructor(U,G,ne,se,ge,X,ce){this._adapter=new Map,this._uriTransformer=G,this._proxy=U.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=se,this._diagnostics=ge,this._logService=X,this._apiDeprecation=ce}_transformDocumentSelector(U){return(0,C.coalesce)((0,C.asArray)(U).map(G=>this._doTransformDocumentSelector(G)))}_doTransformDocumentSelector(U){if(typeof U=="string")return{$serialized:!0,language:U};if(U)return{$serialized:!0,language:U.language,scheme:this._transformScheme(U.scheme),pattern:typeof U.pattern=="undefined"?void 0:D.GlobPattern.from(U.pattern),exclusive:U.exclusive}}_transformScheme(U){return this._uriTransformer&&typeof U=="string"?this._uriTransformer.transformOutgoingScheme(U):U}_createDisposable(U){return new y.Disposable(()=>{this._adapter.delete(U),this._proxy.$unregister(U)})}_nextHandle(){return Ke._handlePool++}_withAdapter(U,G,ne,se,ge=!1){const X=this._adapter.get(U);if(!X)return Promise.resolve(se);if(X.adapter instanceof G){let ce;X.extension&&(ce=Date.now(),this._logService.trace(`[${X.extension.identifier.value}] INVOKE provider '${G.name}'`));const ke=ne(X.adapter,X.extension),Be=X.extension;return Be&&Promise.resolve(ke).then(()=>this._logService.trace(`[${Be.identifier.value}] provider DONE after ${Date.now()-ce}ms`),$e=>{ge&&$e instanceof b.CancellationError||(this._logService.error(`[${Be.identifier.value}] provider FAILED`),this._logService.error($e))}),ke}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(U,G){const ne=this._nextHandle();return this._adapter.set(ne,new Ge(U,G)),ne}static _extLabel(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,G,ne,se){const ge=this._addNewAdapter(new u(this._documents,ne),U),X=se&&se.label||Ke._extLabel(U);return this._proxy.$registerDocumentSymbolProvider(ge,this._transformDocumentSelector(G),X),this._createDisposable(ge)}$provideDocumentSymbols(U,G,ne){return this._withAdapter(U,u,se=>se.provideDocumentSymbols(h.URI.revive(G),ne),void 0)}registerCodeLensProvider(U,G,ne){const se=this._nextHandle(),ge=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Ge(new g(this._documents,this._commands.converter,ne),U)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(G),ge);let X=this._createDisposable(se);if(ge!==void 0){const ce=ne.onDidChangeCodeLenses(ke=>this._proxy.$emitCodeLensEvent(ge));X=y.Disposable.from(X,ce)}return X}$provideCodeLenses(U,G,ne){return this._withAdapter(U,g,se=>se.provideCodeLenses(h.URI.revive(G),ne),void 0)}$resolveCodeLens(U,G,ne){return this._withAdapter(U,g,se=>se.resolveCodeLens(G,ne),void 0)}$releaseCodeLenses(U,G){this._withAdapter(U,g,ne=>Promise.resolve(ne.releaseCodeLenses(G)),void 0)}registerDefinitionProvider(U,G,ne){const se=this._addNewAdapter(new t(this._documents,ne),U);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDefinition(U,G,ne,se){return this._withAdapter(U,t,ge=>ge.provideDefinition(h.URI.revive(G),ne,se),[])}registerDeclarationProvider(U,G,ne){const se=this._addNewAdapter(new s(this._documents,ne),U);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDeclaration(U,G,ne,se){return this._withAdapter(U,s,ge=>ge.provideDeclaration(h.URI.revive(G),ne,se),[])}registerImplementationProvider(U,G,ne){const se=this._addNewAdapter(new i(this._documents,ne),U);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideImplementation(U,G,ne,se){return this._withAdapter(U,i,ge=>ge.provideImplementation(h.URI.revive(G),ne,se),[])}registerTypeDefinitionProvider(U,G,ne){const se=this._addNewAdapter(new r(this._documents,ne),U);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideTypeDefinition(U,G,ne,se){return this._withAdapter(U,r,ge=>ge.provideTypeDefinition(h.URI.revive(G),ne,se),[])}registerHoverProvider(U,G,ne,se){const ge=this._addNewAdapter(new d(this._documents,ne),U);return this._proxy.$registerHoverProvider(ge,this._transformDocumentSelector(G)),this._createDisposable(ge)}$provideHover(U,G,ne,se){return this._withAdapter(U,d,ge=>ge.provideHover(h.URI.revive(G),ne,se),void 0)}registerEvaluatableExpressionProvider(U,G,ne,se){const ge=this._addNewAdapter(new m(this._documents,ne),U);return this._proxy.$registerEvaluatableExpressionProvider(ge,this._transformDocumentSelector(G)),this._createDisposable(ge)}$provideEvaluatableExpression(U,G,ne,se){return this._withAdapter(U,m,ge=>ge.provideEvaluatableExpression(h.URI.revive(G),ne,se),void 0)}registerInlineValuesProvider(U,G,ne,se){const ge=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,X=this._addNewAdapter(new p(this._documents,ne),U);this._proxy.$registerInlineValuesProvider(X,this._transformDocumentSelector(G),ge);let ce=this._createDisposable(X);if(ge!==void 0){const ke=ne.onDidChangeInlineValues(Be=>this._proxy.$emitInlineValuesEvent(ge));ce=y.Disposable.from(ce,ke)}return ce}$provideInlineValues(U,G,ne,se,ge){return this._withAdapter(U,p,X=>X.provideInlineValues(h.URI.revive(G),ne,se,ge),void 0)}registerDocumentHighlightProvider(U,G,ne){const se=this._addNewAdapter(new I(this._documents,ne),U);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDocumentHighlights(U,G,ne,se){return this._withAdapter(U,I,ge=>ge.provideDocumentHighlights(h.URI.revive(G),ne,se),void 0)}registerLinkedEditingRangeProvider(U,G,ne){const se=this._addNewAdapter(new A(this._documents,ne),U);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideLinkedEditingRanges(U,G,ne,se){return this._withAdapter(U,A,async ge=>{const X=await ge.provideLinkedEditingRanges(h.URI.revive(G),ne,se);if(X)return{ranges:X.ranges,wordPattern:X.wordPattern?Ke._serializeRegExp(X.wordPattern):void 0}},void 0)}registerReferenceProvider(U,G,ne){const se=this._addNewAdapter(new a(this._documents,ne),U);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideReferences(U,G,ne,se,ge){return this._withAdapter(U,a,X=>X.provideReferences(h.URI.revive(G),ne,se,ge),void 0)}registerCodeActionProvider(U,G,ne,se){const ge=new c.DisposableStore,X=this._addNewAdapter(new T(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,U,this._apiDeprecation),U);return this._proxy.$registerQuickFixSupport(X,this._transformDocumentSelector(G),{providedKinds:se?.providedCodeActionKinds?.map(ce=>ce.value),documentation:se?.documentation?.map(ce=>({kind:ce.kind.value,command:this._commands.converter.toInternal(ce.command,ge)}))},Ke._extLabel(U),Boolean(ne.resolveCodeAction)),ge.add(this._createDisposable(X)),ge}$provideCodeActions(U,G,ne,se,ge){return this._withAdapter(U,T,X=>X.provideCodeActions(h.URI.revive(G),ne,se,ge),void 0)}$resolveCodeAction(U,G,ne){return this._withAdapter(U,T,se=>se.resolveCodeAction(G,ne),void 0)}$releaseCodeActions(U,G){this._withAdapter(U,T,ne=>Promise.resolve(ne.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider(U,G,ne){const se=this._addNewAdapter(new M(this._documents,ne),U);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(G),U.identifier,U.displayName||U.name),this._createDisposable(se)}$provideDocumentFormattingEdits(U,G,ne,se){return this._withAdapter(U,M,ge=>ge.provideDocumentFormattingEdits(h.URI.revive(G),ne,se),void 0)}registerDocumentRangeFormattingEditProvider(U,G,ne){const se=this._addNewAdapter(new W(this._documents,ne),U);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(G),U.identifier,U.displayName||U.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(U,G,ne,se,ge){return this._withAdapter(U,W,X=>X.provideDocumentRangeFormattingEdits(h.URI.revive(G),ne,se,ge),void 0)}registerOnTypeFormattingEditProvider(U,G,ne,se){const ge=this._addNewAdapter(new B(this._documents,ne),U);return this._proxy.$registerOnTypeFormattingSupport(ge,this._transformDocumentSelector(G),se,U.identifier),this._createDisposable(ge)}$provideOnTypeFormattingEdits(U,G,ne,se,ge,X){return this._withAdapter(U,B,ce=>ce.provideOnTypeFormattingEdits(h.URI.revive(G),ne,se,ge,X),void 0)}registerWorkspaceSymbolProvider(U,G){const ne=this._addNewAdapter(new Z(G,this._logService),U);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(U,G,ne){return this._withAdapter(U,Z,se=>se.provideWorkspaceSymbols(G,ne),{symbols:[]})}$resolveWorkspaceSymbol(U,G,ne){return this._withAdapter(U,Z,se=>se.resolveWorkspaceSymbol(G,ne),void 0)}$releaseWorkspaceSymbols(U,G){this._withAdapter(U,Z,ne=>ne.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider(U,G,ne){const se=this._addNewAdapter(new q(this._documents,ne,this._logService),U);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(G),q.supportsResolving(ne)),this._createDisposable(se)}$provideRenameEdits(U,G,ne,se,ge){return this._withAdapter(U,q,X=>X.provideRenameEdits(h.URI.revive(G),ne,se,ge),void 0)}$resolveRenameLocation(U,G,ne,se){return this._withAdapter(U,q,ge=>ge.resolveRenameLocation(h.URI.revive(G),ne,se),void 0)}registerDocumentSemanticTokensProvider(U,G,ne,se){const ge=this._nextHandle(),X=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(ge,new Ge(new V(this._documents,ne),U)),this._proxy.$registerDocumentSemanticTokensProvider(ge,this._transformDocumentSelector(G),se,X);let ce=this._createDisposable(ge);if(X){const ke=ne.onDidChangeSemanticTokens(Be=>this._proxy.$emitDocumentSemanticTokensEvent(X));ce=y.Disposable.from(ce,ke)}return ce}$provideDocumentSemanticTokens(U,G,ne,se){return this._withAdapter(U,V,ge=>ge.provideDocumentSemanticTokens(h.URI.revive(G),ne,se),null,!0)}$releaseDocumentSemanticTokens(U,G){this._withAdapter(U,V,ne=>ne.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider(U,G,ne,se){const ge=this._addNewAdapter(new F(this._documents,ne),U);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ge,this._transformDocumentSelector(G),se),this._createDisposable(ge)}$provideDocumentRangeSemanticTokens(U,G,ne,se){return this._withAdapter(U,F,ge=>ge.provideDocumentRangeSemanticTokens(h.URI.revive(G),ne,se),null,!0)}registerCompletionItemProvider(U,G,ne,se){const ge=this._addNewAdapter(new re(this._documents,this._commands.converter,ne,this._apiDeprecation,U),U);return this._proxy.$registerSuggestSupport(ge,this._transformDocumentSelector(G),se,re.supportsResolving(ne),`${U.identifier.value}(${se.join("")})`),this._createDisposable(ge)}$provideCompletionItems(U,G,ne,se,ge){return this._withAdapter(U,re,X=>X.provideCompletionItems(h.URI.revive(G),ne,se,ge),void 0)}$resolveCompletionItem(U,G,ne){return this._withAdapter(U,re,se=>se.resolveCompletionItem(G,ne),void 0)}$releaseCompletionItems(U,G){this._withAdapter(U,re,ne=>ne.releaseCompletionItems(G),void 0)}registerInlineCompletionsProvider(U,G,ne){const se=this._addNewAdapter(new N(this._documents,ne,this._commands.converter),U);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideInlineCompletions(U,G,ne,se,ge){return this._withAdapter(U,N,X=>X.provideInlineCompletions(h.URI.revive(G),ne,se,ge),void 0)}$handleInlineCompletionDidShow(U,G,ne){this._withAdapter(U,N,async se=>{se.handleDidShowCompletionItem(G,ne)},void 0)}$freeInlineCompletionsList(U,G){this._withAdapter(U,N,async ne=>{ne.disposeCompletions(G)},void 0)}registerSignatureHelpProvider(U,G,ne,se){const ge=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,X=this._addNewAdapter(new J(this._documents,ne),U);return this._proxy.$registerSignatureHelpProvider(X,this._transformDocumentSelector(G),ge),this._createDisposable(X)}$provideSignatureHelp(U,G,ne,se,ge){return this._withAdapter(U,J,X=>X.provideSignatureHelp(h.URI.revive(G),ne,se,ge),void 0)}$releaseSignatureHelp(U,G){this._withAdapter(U,J,ne=>ne.releaseSignatureHelp(G),void 0)}registerInlayHintsProvider(U,G,ne){const se=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ge=this._addNewAdapter(new K(this._documents,ne),U);this._proxy.$registerInlayHintsProvider(ge,this._transformDocumentSelector(G),se);let X=this._createDisposable(ge);if(se!==void 0){const ce=ne.onDidChangeInlayHints(ke=>this._proxy.$emitInlayHintsEvent(se));X=y.Disposable.from(X,ce)}return X}$provideInlayHints(U,G,ne,se){return this._withAdapter(U,K,ge=>ge.provideInlayHints(h.URI.revive(G),ne,se),void 0)}registerDocumentLinkProvider(U,G,ne){const se=this._addNewAdapter(new le(this._documents,ne),U);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(G),typeof ne.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(U,G,ne){return this._withAdapter(U,le,se=>se.provideLinks(h.URI.revive(G),ne),void 0)}$resolveDocumentLink(U,G,ne){return this._withAdapter(U,le,se=>se.resolveLink(G,ne),void 0)}$releaseDocumentLinks(U,G){this._withAdapter(U,le,ne=>ne.releaseLinks(G),void 0)}registerColorProvider(U,G,ne){const se=this._addNewAdapter(new Ie(this._documents,ne),U);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideDocumentColors(U,G,ne){return this._withAdapter(U,Ie,se=>se.provideColors(h.URI.revive(G),ne),[])}$provideColorPresentations(U,G,ne,se){return this._withAdapter(U,Ie,ge=>ge.provideColorPresentations(h.URI.revive(G),ne,se),void 0)}registerFoldingRangeProvider(U,G,ne){const se=this._nextHandle(),ge=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Ge(new Me(this._documents,ne),U)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(G),ge);let X=this._createDisposable(se);if(ge!==void 0){const ce=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ge));X=y.Disposable.from(X,ce)}return X}$provideFoldingRanges(U,G,ne,se){return this._withAdapter(U,Me,ge=>ge.provideFoldingRanges(h.URI.revive(G),ne,se),void 0)}registerSelectionRangeProvider(U,G,ne){const se=this._addNewAdapter(new Ve(this._documents,ne,this._logService),U);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$provideSelectionRanges(U,G,ne,se){return this._withAdapter(U,Ve,ge=>ge.provideSelectionRanges(h.URI.revive(G),ne,se),[])}registerCallHierarchyProvider(U,G,ne){const se=this._addNewAdapter(new xe(this._documents,ne),U);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(G)),this._createDisposable(se)}$prepareCallHierarchy(U,G,ne,se){return this._withAdapter(U,xe,ge=>Promise.resolve(ge.prepareSession(h.URI.revive(G),ne,se)),void 0)}$provideCallHierarchyIncomingCalls(U,G,ne,se){return this._withAdapter(U,xe,ge=>ge.provideCallsTo(G,ne,se),void 0)}$provideCallHierarchyOutgoingCalls(U,G,ne,se){return this._withAdapter(U,xe,ge=>ge.provideCallsFrom(G,ne,se),void 0)}$releaseCallHierarchy(U,G){this._withAdapter(U,xe,ne=>Promise.resolve(ne.releaseSession(G)),void 0)}static _serializeRegExp(U){return{pattern:U.source,flags:(0,S.regExpFlags)(U)}}static _serializeIndentationRule(U){return{decreaseIndentPattern:Ke._serializeRegExp(U.decreaseIndentPattern),increaseIndentPattern:Ke._serializeRegExp(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Ke._serializeRegExp(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Ke._serializeRegExp(U.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(U){return{beforeText:Ke._serializeRegExp(U.beforeText),afterText:U.afterText?Ke._serializeRegExp(U.afterText):void 0,previousLineText:U.previousLineText?Ke._serializeRegExp(U.previousLineText):void 0,action:U.action}}static _serializeOnEnterRules(U){return U.map(Ke._serializeOnEnterRule)}setLanguageConfiguration(U,G,ne){let{wordPattern:se}=ne;if(se&&(0,S.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(G,se):this._documents.setWordDefinitionFor(G,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ge=this._nextHandle(),X={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?Ke._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?Ke._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?Ke._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ge,G,X),this._createDisposable(ge)}$setWordDefinitions(U){for(const G of U)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=Ke,Ke._handlePool=0}),define(Ee[195],_e([0,1,5,9,6]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(S,_){this._proxy=S.getProxy(h.MainContext.MainThreadLanguages),this._documents=_}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(S,_){await this._proxy.$changeLanguage(S,_);const C=this._documents.getDocumentData(S);if(!C)throw new Error(`document '${S.toString}' NOT found`);return C.document}async tokenAtPosition(S,_){const C=S.version,n=R.Position.from(_),P=await this._proxy.$tokensAtPosition(S.uri,n),c={type:D.StandardTokenType.Other,range:S.getWordRangeAtPosition(_)??new D.Range(_.line,_.character,_.line,_.character)};if(!P)return c;const f={range:R.Range.to(P.range),type:R.TokenType.to(P.type)};return!f.range.contains(_)||C!==S.version?c:f}}e.ExtHostLanguages=y}),define(Ee[196],_e([0,1,5,15,29]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(S){return S&&S.title}let k=class{constructor(_,C){this._logService=C,this._proxy=_.getProxy(h.MainContext.MainThreadMessageService)}showMessage(_,C,n,P,c){const f={extension:_};let l;typeof P=="string"||y(P)?l=[P,...c]:(f.modal=P?.modal,f.useCustom=P?.useCustom,f.detail=P?.detail,l=c),f.useCustom&&(0,D.checkProposedApiEnabled)(_);const o=[];for(let w=0;w<l.length;w++){const b=l[w];if(typeof b=="string")o.push({title:b,handle:w,isCloseAffordance:!1});else if(typeof b=="object"){let{title:E,isCloseAffordance:u}=b;o.push({title:E,isCloseAffordance:!!u,handle:w})}else this._logService.warn("Invalid message item:",b)}return this._proxy.$showMessage(C,n,f,o).then(w=>{if(typeof w=="number")return l[w]})}};k=He([ze(1,R.ILogService)],k),e.ExtHostMessageService=k}),define(Ee[197],_e([0,1,23,3,53,7,22,8,10,2,63,5,9,6,174,98]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class w{constructor(E,u,g,v,t){this._textDocumentsAndEditors=g,this._textDocuments=v,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=E.getProxy(P.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=E.getProxy(P.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=E.getProxy(P.MainContext.MainThreadNotebookEditors),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const i=s.notebookEditor?.notebookUri,r=s.cell.handle,m=this._documents.get(i)?.getCell(r);if(m)return m.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(E=>E.apiEditor)}getEditorById(E){const u=this._editors.get(E);if(!u)throw new Error(`unknown text editor: ${E}. known editors: ${[...this._editors.keys()]} `);return u}getIdByEditor(E){for(const[u,g]of this._editors)if(g.apiEditor===E)return u}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(E,u){const g=this._documents.get(E);if(!g&&!u)throw new Error(`NO notebook document for '${E}'`);return g}_getProviderData(E){const u=this._notebookContentProviders.get(E);if(!u)throw new Error(`NO provider for '${E}'`);return u}registerNotebookContentProvider(E,u,g,v,t){if((0,S.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(u))throw new Error(`Notebook provider for '${u}' already registered`);this._notebookContentProviders.set(u,{extension:E,provider:g});let s;return g.onDidChangeNotebookContentOptions&&(s=g.onDidChangeNotebookContentOptions(()=>{const i=c.NotebookDocumentContentOptions.from(g.options);this._notebookProxy.$updateNotebookProviderOptions(u,i)})),this._notebookProxy.$registerNotebookProvider({id:E.identifier,location:E.extensionLocation},u,c.NotebookDocumentContentOptions.from(v),w._convertNotebookRegistrationData(E,t)),new f.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(u),this._notebookProxy.$unregisterNotebookProvider(u)})}static _convertNotebookRegistrationData(E,u){if(!u)return;const g=u.filenamePattern.map(v=>c.NotebookExclusiveDocumentPattern.from(v)).filter(v=>v!==void 0);if(u.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:u.displayName,filenamePattern:g,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,u,g){const v=w._notebookStatusBarItemProviderHandlePool++,t=typeof g.onDidChangeCellStatusBarItems=="function"?w._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(v,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(v,t,u);let s;return t!==void 0&&(s=g.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(t))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(v),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(v,t),s&&s.dispose()})}async createNotebookDocument(E){const u=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:E.viewType,content:E.content&&c.NotebookData.from(E.content)});return C.URI.revive(u)}async openNotebookDocument(E){const u=this._documents.get(E);if(u)return u.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(E),v=this._documents.get(C.URI.revive(g));return(0,_.assertIsDefined)(v?.apiNotebook)}async showNotebookDocument(E,u){C.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let g;typeof u=="object"?g={position:c.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(c.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:g={preserveFocus:!1};const v=await this._notebookEditorsProxy.$tryShowNotebookDocument(E.uri,E.notebookType,g),t=v&&this._editors.get(v)?.apiEditor;if(t)return t;throw v?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,u,g,v){const t=this._notebookStatusBarItemProviders.get(E),s=C.URI.revive(u),i=this._documents.get(s);if(!i||!t)return;const r=i.getCellFromIndex(g);if(!r)return;const d=await t.provideCellStatusBarItems(r.apiCell,v);if(!d)return;const m=new y.DisposableStore,p=this._statusBarCache.add([m]),A=(Array.isArray(d)?d:[d]).map(a=>c.NotebookStatusBarItem.from(a,this._commandsConverter,m));return{cacheId:p,items:A}}$releaseNotebookCellStatusBarItems(E){this._statusBarCache.delete(E)}registerNotebookSerializer(E,u,g,v,t){if((0,S.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,g),this._notebookProxy.$registerNotebookSerializer(s,{id:E.identifier,location:E.extensionLocation},u,c.NotebookDocumentContentOptions.from(v),w._convertNotebookRegistrationData(E,t)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(E,u,g){const v=this._notebookSerializer.get(E);if(!v)throw new Error("NO serializer found");const t=await v.deserializeNotebook(u.buffer,g);return c.NotebookData.from(t)}async $notebookToData(E,u,g){const v=this._notebookSerializer.get(E);if(!v)throw new Error("NO serializer found");const t=await v.serializeNotebook(c.NotebookData.to(u),g);return h.VSBuffer.wrap(t)}async $openNotebook(E,u,g,v,t){const{provider:s}=this._getProviderData(E),i=await s.openNotebook(C.URI.revive(u),{backupId:g,untitledDocumentData:v?.buffer},t);return{metadata:i.metadata??Object.create(null),cells:i.cells.map(c.NotebookCellData.from)}}async $saveNotebook(E,u,g){const v=this.getNotebookDocument(C.URI.revive(u)),{provider:t}=this._getProviderData(E);return await t.saveNotebook(v.apiNotebook,g),!0}async $saveNotebookAs(E,u,g,v){const t=this.getNotebookDocument(C.URI.revive(u)),{provider:s}=this._getProviderData(E);return await s.saveNotebookAs(C.URI.revive(g),t.apiNotebook,v),!0}async $backupNotebook(E,u,g){const v=this.getNotebookDocument(C.URI.revive(u)),t=this._getProviderData(E),s=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension),i=String((0,D.hash)([v.uri.toString(),this._backupIdPool++])),r=C.URI.joinPath(s,i),d=await t.provider.backupNotebook(v.apiNotebook,{destination:r},g);return v.updateBackup(d),d.id}_createExtHostEditor(E,u,g){if(this._editors.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const v=new o.ExtHostNotebookEditor(u,this._notebookEditorsProxy,E,g.visibleRanges.map(c.NotebookRange.to),g.selections.map(c.NotebookRange.to),typeof g.viewColumn=="number"?c.ViewColumn.to(g.viewColumn):void 0);this._editors.set(u,v)}$acceptDocumentAndEditorsDelta(E){if(E.removedDocuments)for(const g of E.removedDocuments){const v=C.URI.revive(g),t=this._documents.get(v);t&&(t.dispose(),this._documents.delete(v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:t.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(t.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===v.toString()&&this._editors.delete(s.id)}if(E.addedDocuments){const g=[];for(const v of E.addedDocuments){const t=C.URI.revive(v.uri);if(this._documents.has(t))throw new Error(`adding EXISTING notebook ${t} `);const s=this,i=new l.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(r){s._onDidChangeNotebookCells.fire(r)},emitCellOutputsChange(r){s._onDidChangeCellOutputs.fire(r)},emitCellMetadataChange(r){s._onDidChangeCellMetadata.fire(r)},emitCellExecutionStateChange(r){s._onDidChangeCellExecutionState.fire(r)}},t,v);g.push(...v.cells.map(r=>l.ExtHostCell.asModelAddData(i.apiNotebook,r))),this._documents.get(t)?.dispose(),this._documents.set(t,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(E.addedEditors)for(const g of E.addedEditors){if(this._editors.has(g.id))return;const v=C.URI.revive(g.documentUri),t=this._documents.get(v);t&&this._createExtHostEditor(t,g.id,g)}const u=[];if(E.removedEditors)for(const g of E.removedEditors){const v=this._editors.get(g);v&&(this._editors.delete(g),this._activeNotebookEditor?.id===v.id&&(this._activeNotebookEditor=void 0),u.push(v))}if(E.visibleEditors){this._visibleNotebookEditors=E.visibleEditors.map(v=>this._editors.get(v)).filter(v=>!!v);const g=new Set;this._visibleNotebookEditors.forEach(v=>g.add(v.id));for(const v of this._editors.values()){const t=g.has(v.id);v._acceptVisibility(t)}this._visibleNotebookEditors=[...this._editors.values()].map(v=>v).filter(v=>v.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}E.newActiveEditor===null?this._activeNotebookEditor=void 0:E.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(E.newActiveEditor)),E.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=w,w._notebookStatusBarItemProviderHandlePool=0}),define(Ee[198],_e([0,1,3,50,15,5,13,9]),function(te,e,h,R,D,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(P,c){const f=_._Keys.nextId();P.$registerNotebookEditorDecorationType(f,S.NotebookDecorationRenderOptions.from(c)),this.value={key:f,dispose(){P.$removeNotebookEditorDecorationType(f)}}}}_._Keys=new R.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(P,c,f){this._logService=P,this._extHostRpc=c,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new h.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new h.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(P){return new _(this._extHostRpc.getProxy(y.MainContext.MainThreadNotebookEditors),P).value}$acceptEditorPropertiesChanged(P,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,c);const f=this._notebooksAndEditors.getEditorById(P);c.visibleRanges&&f._acceptVisibleRanges(c.visibleRanges.ranges.map(S.NotebookRange.to)),c.selections&&f._acceptSelections(c.selections.selections.map(S.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const c in P)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(S.ViewColumn.to(P[c]))}};C=He([ze(0,D.ILogService),ze(1,k.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(Ee[199],_e([0,1,3,7,5,26,2,9,67,22,16,68,18,17,15,6,29]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f,l,o,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let b=class{constructor(t,s,i,r){this._initData=s,this._extHostNotebook=i,this._logService=r,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(D.MainContext.MainThreadNotebookKernels)}createNotebookController(t,s,i,r,d,m){for(let N of this._kernelData.values())if(N.controller.id===s&&y.ExtensionIdentifier.equals(t.identifier,N.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const p=this._handlePool++,I=this;this._logService.trace(`NotebookController[${p}], CREATED by ${t.identifier.value}, ${s}`);const A=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${t.identifier}'`);let a=!1;const T=new R.DisposableStore,M=new h.Emitter,W=new h.Emitter,B={id:`${t.identifier.value}/${s}`,notebookType:i,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:r||t.identifier.value,preloads:m?m.map(S.NotebookRendererScript.from):[]};let Z=d??A,q;this._proxy.$addKernel(p,B).catch(N=>{console.log(N),a=!0});let $=0;const V=()=>{if(a)return;const N=++$;Promise.resolve().then(()=>{N===$&&this._proxy.$updateKernel(p,B)})},F=new C.ResourceMap,re={get id(){return s},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return B.label},set label(N){B.label=N??t.displayName??t.name,V()},get detail(){return B.detail??""},set detail(N){B.detail=N,V()},get description(){return B.description??""},set description(N){B.description=N,V()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(N){B.supportedLanguages=N,V()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(N){B.supportsExecutionOrder=N,V()},get rendererScripts(){return B.preloads?B.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(N){Z=N??A},get interruptHandler(){return q},set interruptHandler(N){q=N,B.supportsInterrupt=Boolean(N),V()},createNotebookCellExecution(N){if(a)throw new Error("notebook controller is DISPOSED");if(!F.has(N.notebook.uri))throw I._logService.trace(`NotebookController[${p}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(F.keys()).map(H=>H.toString())),new Error(`notebook controller is NOT associated to notebook: ${N.notebook.uri.toString()}`);return I._createNotebookCellExecution(N)},dispose:()=>{a||(this._logService.trace(`NotebookController[${p}], DISPOSED`),a=!0,this._kernelData.delete(p),T.dispose(),M.dispose(),W.dispose(),this._proxy.$removeKernel(p))},updateNotebookAffinity(N,H){I._proxy.$updateNotebookPriority(p,N.uri,H)},onDidReceiveMessage:W.event,postMessage(N,H){return(0,w.checkProposedApiEnabled)(t),I._proxy.$postMessage(p,H&&I._extHostNotebook.getIdByEditor(H),N)},asWebviewUri(N){return(0,w.checkProposedApiEnabled)(t),(0,_.asWebviewUri)(N,I._initData.remote)}};return this._kernelData.set(p,{extensionId:t.identifier,controller:re,onDidReceiveMessage:W,onDidChangeSelection:M,associatedNotebooks:F}),re}$acceptNotebookAssociation(t,s,i){const r=this._kernelData.get(t);if(r){const d=this._extHostNotebook.getNotebookDocument(k.URI.revive(s));i?r.associatedNotebooks.set(d.uri,!0):r.associatedNotebooks.delete(d.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,d.uri.toString(),i),r.onDidChangeSelection.fire({selected:i,notebook:d.apiNotebook})}}async $executeCells(t,s,i){const r=this._kernelData.get(t);if(!r)return;const d=this._extHostNotebook.getNotebookDocument(k.URI.revive(s)),m=[];for(let p of i){const I=d.getCell(p);I&&m.push(I.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,d.uri.toString(),m.length),await r.controller.executeHandler.call(r.controller,m,d.apiNotebook,r.controller)}catch(p){this._logService.error(`NotebookController[${t}] execute cells FAILED`,p),console.error(p)}}async $cancelCells(t,s,i){const r=this._kernelData.get(t);if(!r)return;const d=this._extHostNotebook.getNotebookDocument(k.URI.revive(s));if(r.controller.interruptHandler)await r.controller.interruptHandler.call(r.controller,d.apiNotebook);else for(let m of i){const p=d.getCell(m);p&&this._activeExecutions.get(p.uri)?.cancel()}}$acceptKernelMessageFromRenderer(t,s,i){const r=this._kernelData.get(t);if(!r)return;const d=this._extHostNotebook.getEditorById(s);r.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:i}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!i)throw new Error("invalid cell");if(this._activeExecutions.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const r=new u(i.notebook,i,this._proxy);this._activeExecutions.set(i.uri,r);const d=r.onDidChangeState(()=>{r.state===E.Resolved&&(r.dispose(),d.dispose(),this._activeExecutions.delete(i.uri))});return r.asApiObject()}};b=He([ze(3,l.ILogService)],b),e.ExtHostNotebookKernels=b;var E;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(E||(E={}));class u extends R.Disposable{constructor(t,s,i){super();this._document=t,this._cell=s,this._proxy=i,this._onDidChangeState=new h.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=E.Init,this._tokenSource=this._register(new c.CancellationTokenSource),this._collector=new g(10,r=>this.applyEdits(r)),this._executionOrder=s.internalMetadata.executionOrder,this.mixinMetadata({runState:P.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===E.Init)throw new Error("Must call start before modifying cell output");if(this._state===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let s=this._cell;if(t&&(s=this._document.getCellFromApiCell(t)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(t){return t.map(s=>{const i=o.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return i===s.items?S.NotebookCellOutput.from(s):S.NotebookCellOutput.from({items:i,id:s.id,metadata:s.metadata})})}async updateOutputs(t,s,i){const r=this.cellIndexToHandle(s),d=this.validateAndConvertOutputs((0,f.asArray)(t));return this.applyEditSoon({editType:2,handle:r,append:i,outputs:d})}async updateOutputItems(t,s,i){return t=o.NotebookCellOutput.ensureUniqueMimeTypes((0,f.asArray)(t),!0),this.applyEditSoon({editType:7,items:t.map(S.NotebookCellOutputItem.from),outputId:s.id,append:i})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(i){t._executionOrder=i,t.mixinMetadata({executionOrder:i})},start(i){if(t._state===E.Resolved||t._state===E.Started)throw new Error("Cannot call start again");t._state=E.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:P.NotebookCellExecutionState.Executing,runStartTime:i??null})},end(i,r){if(t._state===E.Resolved)throw new Error("Cannot call resolve twice");t._state=E.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:i??null,runEndTime:r??null})},clearOutput(i){return t.verifyStateForOutput(),t.updateOutputs([],i,!1)},appendOutput(i,r){return t.verifyStateForOutput(),t.updateOutputs(i,r,!0)},replaceOutput(i,r){return t.verifyStateForOutput(),t.updateOutputs(i,r,!1)},appendOutputItems(i,r){return t.verifyStateForOutput(),t.updateOutputItems(i,r,!0)},replaceOutputItems(i,r){return t.verifyStateForOutput(),t.updateOutputItems(i,r,!1)}})}}class g{constructor(t,s){this.delay=t,this.callback=s,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=(0,n.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const s=this.batch;return this.batch=[],this.callback(s)})),this.waitPromise}}}),define(Ee[200],_e([0,1,3,5,98]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(S,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,_,C){const n=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(_)?.fire({editor:n.apiEditor,message:C})}createRendererMessaging(S){return{onDidReceiveMessage:(...C)=>this.getOrCreateEmitterFor(S).event(...C),postMessage:(C,n)=>{const P=D.ExtHostNotebookEditor.apiEditorsToExtHost.get(C);if(!P)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(P.id,S,n)}}}getOrCreateEmitterFor(S){let _=this._rendererMessageEmitters.get(S);return _||(_=new h.Emitter({onLastListenerRemove:()=>{_?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,_),_)}}e.ExtHostNotebookRenderers=y}),define(Ee[102],_e([0,1,5,3,7,23,4,13]),function(te,e,h,R,D,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends D.Disposable{constructor(l,o,w,b,E){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=l,this._proxy=E,this._id=E.$register(this.name,o,w,b),this._disposed=!1,this._offset=0}get name(){return this._name}append(l){this.validate(),this._offset+=l?y.VSBuffer.fromString(l).byteLength:0}update(){this._id.then(l=>this._proxy.$update(l))}appendLine(l){this.validate(),this.append(l+`
`)}clear(){this.validate();const l=this._offset;this._id.then(o=>this._proxy.$clear(o,l))}show(l,o){this.validate(),this._id.then(w=>this._proxy.$reveal(w,!!(typeof l=="boolean"?l:o)))}hide(){this.validate(),this._id.then(l=>this._proxy.$close(l))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(l=>this._proxy.$dispose(l)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class C extends _{constructor(l,o,w){super(l,!1,void 0,o,w)}append(l){super.append(l),this._id.then(o=>this._proxy.$append(o,l)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class n extends _{constructor(l,o,w){super(l,!0,o,void 0,w)}append(l){throw new Error("Not supported")}}class P{constructor(l,o){this.name=l,this._channel=o}append(l){this._channel.then(o=>o.append(l))}appendLine(l){this._channel.then(o=>o.appendLine(l))}clear(){this._channel.then(l=>l.clear())}show(l,o){this._channel.then(w=>w.show(l,o))}hide(){this._channel.then(l=>l.hide())}dispose(){this._channel.then(l=>l.dispose())}}e.LazyOutputChannel=P;let c=class{constructor(l){this._proxy=l.getProxy(h.MainContext.MainThreadOutputService)}$setVisibleChannel(l){}createOutputChannel(l,o){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");return new C(o.identifier.value,l,this._proxy)}createOutputChannelFromLogFile(l,o){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");if(!o)throw new Error("illegal argument `file`. must not be falsy");return new n(l,o,this._proxy)}};c=He([ze(0,S.IExtHostRpcService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=(0,k.createDecorator)("IExtHostOutputService")}),define(Ee[201],_e([0,1,16,18,3,7,5,2,6,12,17,42]),function(te,e,h,R,D,y,k,S,_,C,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function c(f,l,o){const w=f.getProxy(k.MainContext.MainThreadQuickOpen);class b{constructor(r,d){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=d}showQuickPick(r,d,m,p=R.CancellationToken.None){this._onDidSelectItem=void 0;const I=Promise.resolve(r),A=++this._instances,a=w.$show(A,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},p),T={},M=a.then(()=>T);return Promise.race([M,I]).then(W=>{if(W!==T)return I.then(B=>{const Z=[];for(let q=0;q<B.length;q++){const $=B[q];let V,F,re,N,H;typeof $=="string"?V=$:(V=$.label,F=$.description,re=$.detail,N=$.picked,H=$.alwaysShow),Z.push({label:V,description:F,handle:q,detail:re,picked:N,alwaysShow:H})}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=q=>{m.onDidSelectItem(B[q])}),w.$setItems(A,Z),a.then(q=>{if(typeof q=="number")return B[q];if(Array.isArray(q))return q.map($=>B[$])})})}).then(void 0,W=>{if(!(0,C.isPromiseCanceledError)(W))return w.$setError(A,W),Promise.reject(W)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,d=R.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,w.$input(r,typeof this._validateInput=="function",d).then(void 0,m=>{if(!(0,C.isPromiseCanceledError)(m))return Promise.reject(m)})}$validateInput(r){return this._validateInput?(0,h.asPromise)(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,d=R.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!m)return;const p=await this._workspace.getWorkspaceFolders2();if(!!p)return p.find(I=>I.uri.toString()===m.uri.toString())}createQuickPick(r,d){const m=new t(r,d,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}createInputBox(r){const d=new s(r,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(r,d){const m=this._sessions.get(r);m&&m._fireDidChangeValue(d)}$onDidAccept(r){const d=this._sessions.get(r);d&&d._fireDidAccept()}$onDidChangeActive(r,d){const m=this._sessions.get(r);m instanceof t&&m._fireDidChangeActive(d)}$onDidChangeSelection(r,d){const m=this._sessions.get(r);m instanceof t&&m._fireDidChangeSelection(d)}$onDidTriggerButton(r,d){const m=this._sessions.get(r);m&&m._fireDidTriggerButton(d)}$onDidHide(r){const d=this._sessions.get(r);d&&d._fireDidHide()}}class E{constructor(r,d){this._extensionId=r,this._onDidDispose=d,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((d,m)=>{const p=d===_.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(p,d)}),this.update({buttons:r.map((d,m)=>({iconPath:u(d.iconPath),tooltip:d.tooltip,handle:d===_.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const d=this._handlesToButtons.get(r);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,y.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),w.$dispose(this._id))}update(r){if(!this._disposed){for(const d of Object.keys(r)){const m=r[d];this._pendingUpdate[d]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){w.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function u(i){if(i instanceof _.ThemeIcon)return{id:i.id};const r=v(i),d=g(i);return{dark:typeof r=="string"?S.URI.file(r):r,light:typeof d=="string"?S.URI.file(d):d}}function g(i){return typeof i=="object"&&"light"in i?i.light:i}function v(i){return typeof i=="object"&&"dark"in i?i.dark:i}class t extends E{constructor(r,d,m){super(r,m);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((d,m)=>{this._handlesToItems.set(m,d),this._itemsToHandles.set(d,m)}),this.update({items:r.map((d,m)=>({label:d.label,description:d.description,handle:m,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(r){const d=(0,n.coalesce)(r.map(m=>this._handlesToItems.get(m)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(r){const d=(0,n.coalesce)(r.map(m=>this._handlesToItems.get(m)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}}class s extends E{constructor(r,d){super(r,d);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?P.default.Error:P.default.Ignore})}}return new b(l,o)}e.createExtHostQuickOpen=c}),define(Ee[202],_e([0,1,2,3,48,7,16,5,17,113,15,26,29,156]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(d){if(d)return typeof d.iconPath=="string"?h.URI.file(d.iconPath):h.URI.isUri(d.iconPath)||f.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function o(d,m){if(!d.iconPath&&!m.iconPath)return 0;if(d.iconPath){if(!m.iconPath)return 1}else return-1;const p=typeof d.iconPath=="string"?d.iconPath:h.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,I=typeof m.iconPath=="string"?m.iconPath:h.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,C.comparePaths)(p,I)}function w(d,m){let p=0;if(d.strikeThrough!==m.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==m.faded)return d.faded?1:-1;if(d.tooltip!==m.tooltip)return(d.tooltip||"").localeCompare(m.tooltip||"");if(p=o(d,m),p!==0)return p;if(d.light&&m.light)p=o(d.light,m.light);else{if(d.light)return 1;if(m.light)return-1}if(p!==0)return p;if(d.dark&&m.dark)p=o(d.dark,m.dark);else{if(d.dark)return 1;if(m.dark)return-1}return p}function b(d,m){if(d.command!==m.command)return d.command<m.command?-1:1;if(d.title!==m.title)return d.title<m.title?-1:1;if(d.tooltip!==m.tooltip){if(d.tooltip!==void 0&&m.tooltip!==void 0)return d.tooltip<m.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(d.arguments===m.arguments)return 0;if(d.arguments)if(m.arguments){if(d.arguments.length!==m.arguments.length)return d.arguments.length-m.arguments.length}else return 1;else return-1;for(let p=0;p<d.arguments.length;p++){const I=d.arguments[p],A=m.arguments[p];if(I!==A)return I<A?-1:1}return 0}function E(d,m){let p=(0,C.comparePaths)(d.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(p!==0)return p;if(d.command&&m.command)p=b(d.command,m.command);else{if(d.command)return 1;if(m.command)return-1}if(p!==0)return p;if(d.decorations&&m.decorations)p=w(d.decorations,m.decorations);else{if(d.decorations)return 1;if(m.decorations)return-1}return p}function u(d,m){for(let p=0;p<d.length;p++)if(d[p]!==m[p])return!1;return!0}function g(d,m){return d.command===m.command&&d.title===m.title&&d.tooltip===m.tooltip&&(d.arguments&&m.arguments?u(d.arguments,m.arguments):d.arguments===m.arguments)}function v(d,m){return(0,_.equals)(d,m,g)}class t{constructor(m,p,I){this._extension=m,this._proxy=p,this._sourceControlHandle=I,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(m){this._proxy.$setInputBoxValue(this._sourceControlHandle,m),this.updateValue(m)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(m){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,m),this._placeholder=m}get validateInput(){return(0,c.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(m){if((0,c.checkProposedApiEnabled)(this._extension),m&&typeof m!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=m,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!m)}get visible(){return this._visible}set visible(m){m=!!m,this._visible!==m&&(this._visible=m,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,m))}focus(){(0,c.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(m,p){(0,c.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,m,p)}$onInputBoxValueChange(m){this.updateValue(m)}updateValue(m){this._value=m,this._onDidChange.fire(m)}}e.ExtHostSCMInputBox=t;class s{constructor(m,p,I,A,a){this._proxy=m,this._commands=p,this._sourceControlHandle=I,this._id=A,this._label=a,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(m){this._label=m,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,m)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(m){this._hideWhenEmpty=m,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(m){this._resourceStates=[...m],this._onDidUpdateResourceStates.fire()}getResourceState(m){return this._resourceStatesMap.get(m)}$executeResourceCommand(m,p){const I=this._resourceStatesCommandsMap.get(m);return I?(0,k.asPromise)(()=>this._commands.executeCommand(I.command,...I.arguments||[],p)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this._resourceStates].sort(E),I=(0,_.sortedDiff)(this._resourceSnapshot,m,E).map(T=>{const M=T.toInsert.map(W=>{const B=this._resourceHandlePool++;this._resourceStatesMap.set(B,W);const Z=W.resourceUri;let q;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"){const Ie=new y.DisposableStore;q=this._commands.converter.toInternal(W.command,Ie),this._resourceStatesDisposablesMap.set(B,Ie)}else this._resourceStatesCommandsMap.set(B,W.command);const $=l(W.decorations),V=W.decorations&&l(W.decorations.light)||$,F=W.decorations&&l(W.decorations.dark)||$,re=[V,F],N=W.decorations&&W.decorations.tooltip||"",H=W.decorations&&!!W.decorations.strikeThrough,J=W.decorations&&!!W.decorations.faded,K=W.contextValue||"";return{rawResource:[B,Z,re,N,H,J,K,q],handle:B}});return{start:T.start,deleteCount:T.deleteCount,toInsert:M}}),A=I.map(({start:T,deleteCount:M,toInsert:W})=>[T,M,W.map(B=>B.rawResource)]),a=I.reverse();for(const{start:T,deleteCount:M,toInsert:W}of a){const B=W.map(q=>q.handle),Z=this._handlesSnapshot.splice(T,M,...B);for(const q of Z)this._resourceStatesMap.delete(q),this._resourceStatesCommandsMap.delete(q),this._resourceStatesDisposablesMap.get(q)?.dispose(),this._resourceStatesDisposablesMap.delete(q)}return this._resourceSnapshot=m,A}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class i{constructor(m,p,I,A,a,T){this._proxy=p,this._commands=I,this._id=A,this._label=a,this._rootUri=T,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new t(m,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,A,a,T)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(m){this._count!==m&&(this._count=m,this._proxy.$updateSourceControl(this.handle,{count:m}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(m){this._quickDiffProvider=m,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this._commitTemplate}set commitTemplate(m){m!==this._commitTemplate&&(this._commitTemplate=m,this._proxy.$updateSourceControl(this.handle,{commitTemplate:m}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(m){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=m;const p=this._commands.converter.toInternal(m,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:p})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(m){if(this._statusBarCommands&&m&&v(this._statusBarCommands,m))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=m;const p=(m||[]).map(I=>this._commands.converter.toInternal(I,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:p})}get selected(){return this._selected}createResourceGroup(m,p){const I=new s(this._proxy,this._commands,this.handle,m,p),A=R.Event.once(I.onDidDispose)(()=>this.createdResourceGroups.delete(I));return this.createdResourceGroups.set(I,A),this.eventuallyAddResourceGroups(),I}eventuallyAddResourceGroups(){const m=[],p=[];for(const[I,A]of this.createdResourceGroups){A.dispose();const a=I.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(I),this.eventuallyUpdateResourceStates()});R.Event.once(I.onDidDispose)(()=>{this.updatedResourceGroups.delete(I),a.dispose(),this._groups.delete(I.handle),this._proxy.$unregisterGroup(this.handle,I.handle)}),m.push([I.handle,I.id,I.label,I.features]);const T=I._takeResourceStateSnapshot();T.length>0&&p.push([I.handle,T]),this._groups.set(I.handle,I)}this._proxy.$registerGroups(this.handle,m,p),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const m=[];this.updatedResourceGroups.forEach(p=>{const I=p._takeResourceStateSnapshot();I.length!==0&&m.push([p.handle,I])}),m.length>0&&this._proxy.$spliceResourceStates(this.handle,m),this.updatedResourceGroups.clear()}getResourceGroup(m){return this._groups.get(m)}setSelectionState(m){this._selected=m,this._onDidChangeSelection.fire(m)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(m=>m.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,He([(0,D.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),He([(0,D.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let r=class Wn{constructor(m,p,I){this._commands=p,this.logService=I,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=m.getProxy(S.MainContext.MainThreadSCM),this._telemetry=m.getProxy(S.MainContext.MainThreadTelemetry),p.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const a=this._sourceControls.get(A.sourceControlHandle);if(!a)return A;const T=a.getResourceGroup(A.groupHandle);return T?T.getResourceState(A.handle):A}else if(A&&A.$mid===4){const a=this._sourceControls.get(A.sourceControlHandle);return a?a.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const a=this._sourceControls.get(A.handle);return a||A}return A}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(m,p,I,A){this.logService.trace("ExtHostSCM#createSourceControl",m.identifier.value,p,I,A),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const a=Wn._handlePool++,T=new i(m,this._proxy,this._commands,p,I,A);this._sourceControls.set(a,T);const M=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(m.identifier))||[];return M.push(T),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(m.identifier),M),T}getLastInputBox(m){this.logService.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const p=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(m.identifier)),I=p&&p[p.length-1];return I&&I.inputBox}$provideOriginalResource(m,p,I){const A=h.URI.revive(p);this.logService.trace("ExtHostSCM#$provideOriginalResource",m,A.toString());const a=this._sourceControls.get(m);return!a||!a.quickDiffProvider||!a.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,k.asPromise)(()=>a.quickDiffProvider.provideOriginalResource(A,I)).then(T=>T||null)}$onInputBoxValueChange(m,p){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",m);const I=this._sourceControls.get(m);return I&&I.inputBox.$onInputBoxValueChange(p),Promise.resolve(void 0)}$executeResourceCommand(m,p,I,A){this.logService.trace("ExtHostSCM#$executeResourceCommand",m,p,I);const a=this._sourceControls.get(m);if(!a)return Promise.resolve(void 0);const T=a.getResourceGroup(p);return T?T.$executeResourceCommand(I,A):Promise.resolve(void 0)}$validateInput(m,p,I){this.logService.trace("ExtHostSCM#$validateInput",m);const A=this._sourceControls.get(m);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):(0,k.asPromise)(()=>A.inputBox.validateInput(p,I)).then(a=>a?Promise.resolve([a.message,a.type]):Promise.resolve(void 0))}$setSelectedSourceControl(m){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this._sourceControls.get(m)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=m,Promise.resolve(void 0)}};r._handlePool=0,r=He([ze(2,n.ILogService)],r),e.ExtHostSCM=r});var it=this&&this.__classPrivateFieldSet||function(te,e,h,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(te,h):D?D.value=h:e.set(te,h),h},Ne=this&&this.__classPrivateFieldGet||function(te,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(te):R?R.value:e.get(te)};define(Ee[203],_e([0,1,6,5,132,7,9]),function(te,e,h,R,D,y,k){"use strict";var S,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class C{constructor(f,l,o,w,b=h.StatusBarAlignment.Left,E){S.set(this,void 0),_.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,it(this,S,f,"f"),it(this,_,l,"f"),this._entryId=C.ID_GEN++,this._extension=o,this._id=w,this._alignment=b,this._priority=E}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!C.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Ne(this,_,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Ne(this,_,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ne(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let l;this._name?l=this._name:l=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let o=this._color;this._backgroundColor&&(o=C.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const w=this._tooltip?k.MarkdownString.fromStrict(this._tooltip):void 0;Ne(this,S,"f").$setEntry(this._entryId,f,l,this._text,w,this._command?.internal,o,this._backgroundColor,this._alignment===h.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=C,S=new WeakMap,_=new WeakMap,C.ID_GEN=0,C.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new h.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",h.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const l={message:f};return this._messages.unshift(l),this._update(),new h.Disposable(()=>{const o=this._messages.indexOf(l);o>=0&&(this._messages.splice(o,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class P{constructor(f,l){this._proxy=f.getProxy(R.MainContext.MainThreadStatusBar),this._commands=l,this._statusMessage=new n(this)}createStatusBarEntry(f,l,o,w){return new C(this._proxy,this._commands,f,l,o,w)}setStatusBarMessage(f,l){const o=this._statusMessage.setMessage(f);let w;return typeof l=="number"?w=setTimeout(()=>o.dispose(),l):typeof l!="undefined"&&l.then(()=>o.dispose(),()=>o.dispose()),new h.Disposable(()=>{o.dispose(),clearTimeout(w)})}}e.ExtHostStatusBar=P}),define(Ee[73],_e([0,1,5,3,4]),function(te,e,h,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(S){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=S.getProxy(h.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(S,_){this._proxy.$registerExtensionStorageKeysToSync(S,_)}getValue(S,_,C){return this._proxy.$getValue(S,_).then(n=>n||C)}setValue(S,_,C){return this._proxy.$setValue(S,_,C)}$acceptValue(S,_,C){this._onDidChangeStorage.fire({shared:S,key:_,value:C})}}e.ExtHostStorage=y,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(Ee[74],_e([0,1,4,28,15,72,2]),function(te,e,h,R,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,h.createDecorator)("IExtensionStoragePaths");let S=class{constructor(C,n,P){this._logService=n,this._extHostFileSystem=P,this._workspace=C.workspace??void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(C){return k.URI.joinPath(this._environment.workspaceStorageHome,C)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const C=this._workspace.id,n=await this._getWorkspaceStorageURI(C);try{return await this._extHostFileSystem.value.stat(n),this._logService.trace("[ExtHostStorage] storage dir already exists",n),n}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",n),await this._extHostFileSystem.value.createDirectory(n),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(n,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:k.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),n}catch(P){this._logService.error("[ExtHostStorage]",P);return}}workspaceValue(C){if(this._value)return k.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return k.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};S=He([ze(0,R.IExtHostInitDataService),ze(1,D.ILogService),ze(2,y.IExtHostConsumerFileSystem)],S),e.ExtensionStoragePaths=S}),define(Ee[37],_e([0,1,3,5,4,2,13,7,6,133,12,169,18,35,154,10]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class w{constructor(i,r,d,m){this._proxy=i,this._id=r,this._creationOptions=d,this._name=m,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(I=>this._pidPromiseComplete=I);const p=this;this.value={get name(){return p._name||""},get processId(){return p._pidPromise},get creationOptions(){return p._creationOptions},get exitStatus(){return p._exitStatus},sendText(I,A=!0){p._checkDisposed(),p._proxy.$sendText(p._id,I,A)},show(I){p._checkDisposed(),p._proxy.$show(p._id,I)},hide(){p._checkDisposed(),p._proxy.$hide(p._id)},dispose(){p._disposed||(p._disposed=!0,p._proxy.$dispose(p._id))},get dimensions(){if(!(p._cols===void 0||p._rows===void 0))return{columns:p._cols,rows:p._rows}}}}async create(i,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:i.name,shellPath:(0,o.withNullAsUndefined)(i.shellPath),shellArgs:(0,o.withNullAsUndefined)(i.shellArgs),cwd:(0,o.withNullAsUndefined)(i.cwd),env:(0,o.withNullAsUndefined)(i.env),icon:(0,o.withNullAsUndefined)(t(i.iconPath)),initialText:(0,o.withNullAsUndefined)(i.message),strictEnv:(0,o.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,o.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,o.withNullAsUndefined)(r?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,o.withNullAsUndefined)(r?.useShellEnvironment),isSplitTerminal:r?.isSplitTerminal,target:r?.target})}async createExtensionTerminal(i,r,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:d,isSplitTerminal:i,target:r}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(i){this._name=i}setExitCode(i){this._exitStatus=Object.freeze({code:i})}setDimensions(i,r){return i===this._cols&&r===this._rows||i===0||r===0?!1:(this._cols=i,this._rows=r,!0)}_setProcessId(i){this._pidPromiseComplete?(this._pidPromiseComplete(i),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==i&&(this._pidPromise=Promise.resolve(i))})}}e.ExtHostTerminal=w;class b{constructor(i){this._pty=i,this.id=0,this.shouldPersist=!1,this._onProcessData=new h.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new h.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new h.Emitter,this._onProcessTitleChanged=new h.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new h.Emitter,this._onProcessShellTypeChanged=new h.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(i){this._pty.handleInput&&this._pty.handleInput(i)}resize(i,r){this._pty.setDimensions&&this._pty.setDimensions({columns:i,rows:r})}async processBinary(i){}acknowledgeDataEvent(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose&&this._pty.onDidClose((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r&&{cols:r.columns,rows:r.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(r=>this._onProcessTitleChanged.fire(r)),this._pty.open(i||void 0),this._pty.setDimensions&&i&&this._pty.setDimensions(i),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=b;let E=1,u=class extends S.Disposable{constructor(i,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new h.Emitter,this._onDidOpenTerminal=new h.Emitter,this._onDidChangeActiveTerminal=new h.Emitter,this._onDidChangeTerminalDimensions=new h.Emitter,this._proxy=r.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new h.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(i),this._register({dispose:()=>{for(const[d,m]of this._terminalProcesses)m.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(i=>i.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(i){return(i?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(i,r){const d=new w(this._proxy,(0,f.generateUuid)(),i,i.name),m=new b(i.pty);return d.createExtensionTerminal(r?.isSplitTerminal,r?.target,t(i.iconPath)).then(p=>{const I=this._setupExtHostProcessListeners(p,m);this._terminalProcessDisposables[p]=I}),this._terminals.push(d),d.value}attachPtyToTerminal(i,r){if(!this._getTerminalById(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const m=new b(r),p=this._setupExtHostProcessListeners(i,m);this._terminalProcessDisposables[i]=p}async $acceptActiveTerminalChanged(i){const r=this._activeTerminal;if(i===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const d=this._getTerminalById(i);d&&(this._activeTerminal=d,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(i,r){const d=this._getTerminalById(i);d&&this._onDidWriteTerminalData.fire({terminal:d.value,data:r})}async $acceptTerminalDimensions(i,r,d){const m=this._getTerminalById(i);m&&m.setDimensions(r,d)&&this._onDidChangeTerminalDimensions.fire({terminal:m.value,dimensions:m.value.dimensions})}async $acceptTerminalMaximumDimensions(i,r,d){this._terminalProcesses.get(i)?.resize(r,d)}async $acceptTerminalTitleChange(i,r){const d=this._getTerminalById(i);d&&(d.name=r)}async $acceptTerminalClosed(i,r){const d=this._getTerminalObjectIndexById(this._terminals,i);if(d!==null){const m=this._terminals.splice(d,1)[0];m.setExitCode(r),this._onDidCloseTerminal.fire(m.value)}}$acceptTerminalOpened(i,r,d,m){if(r){const A=this._getTerminalObjectIndexById(this._terminals,r);if(A!==null){this._terminals[A]._id=i,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const p={name:m.name,shellPath:m.executable,shellArgs:m.args,cwd:typeof m.cwd=="string"?m.cwd:y.URI.revive(m.cwd),env:m.env,hideFromUser:m.hideFromUser},I=new w(this._proxy,i,p,d);this._terminals.push(I),this._onDidOpenTerminal.fire(I.value),I.isOpen=!0}async $acceptTerminalProcessId(i,r){const d=this._getTerminalById(i);d&&d._setProcessId(r)}async $startExtensionTerminal(i,r){const d=this._getTerminalById(i);if(!d)return{message:(0,C.localize)(0,null,i)};d.isOpen||await new Promise(p=>{const I=this.onDidOpenTerminal(async A=>{A===d.value&&(I.dispose(),p())})});const m=this._terminalProcesses.get(i);m?m.startSendingEvents(r):this._extensionTerminalAwaitingStart[i]={initialDimensions:r}}_setupExtHostProcessListeners(i,r){const d=new S.DisposableStore;d.add(r.onProcessReady(p=>this._proxy.$sendProcessReady(i,p.pid,p.cwd))),d.add(r.onProcessTitleChanged(p=>this._proxy.$sendProcessTitle(i,p))),this._bufferer.startBuffering(i,r.onProcessData),d.add(r.onProcessExit(p=>this._onProcessExit(i,p))),r.onProcessOverrideDimensions&&d.add(r.onProcessOverrideDimensions(p=>this._proxy.$sendOverrideDimensions(i,p))),this._terminalProcesses.set(i,r);const m=this._extensionTerminalAwaitingStart[i];return m&&r instanceof b&&(r.startSendingEvents(m.initialDimensions),delete this._extensionTerminalAwaitingStart[i]),d}$acceptProcessAckDataEvent(i,r){this._terminalProcesses.get(i)?.acknowledgeDataEvent(r)}$acceptProcessInput(i,r){this._terminalProcesses.get(i)?.input(r)}$acceptProcessResize(i,r,d){try{this._terminalProcesses.get(i)?.resize(r,d)}catch(m){if(m.code!=="EPIPE"&&m.code!=="ERR_IPC_CHANNEL_CLOSED")throw m}}$acceptProcessShutdown(i,r){this._terminalProcesses.get(i)?.shutdown(r)}$acceptProcessRequestInitialCwd(i){this._terminalProcesses.get(i)?.getInitialCwd().then(r=>this._proxy.$sendProcessInitialCwd(i,r))}$acceptProcessRequestCwd(i){this._terminalProcesses.get(i)?.getCwd().then(r=>this._proxy.$sendProcessCwd(i,r))}$acceptProcessRequestLatency(i){return i}registerLinkProvider(i){return this._linkProviders.add(i),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(i),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(i,r,d){if(this._profileProviders.has(r))throw new Error(`Terminal profile provider "${r}" already registered`);return this._profileProviders.set(r,d),this._proxy.$registerProfileProvider(r,i.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(r),this._proxy.$unregisterProfileProvider(r)})}async $createContributedProfileTerminal(i,r){const d=new c.CancellationTokenSource().token,m=await this._profileProviders.get(i)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(!m||!("options"in m))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in m.options){this.createExtensionTerminal(m.options,r);return}this.createTerminalFromOptions(m.options,r)}}async $provideLinks(i,r){const d=this._getTerminalById(i);if(!d)return[];this._terminalLinkCache.delete(i);const m=this._terminalLinkCancellationSource.get(i);m&&m.dispose(!0);const p=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(i,p);const I=[],A={terminal:d.value,line:r},a=[];for(const W of this._linkProviders)a.push(new Promise(async B=>{p.token.onCancellationRequested(()=>B({provider:W,links:[]}));const Z=await W.provideTerminalLinks(A,p.token)||[];p.token.isCancellationRequested||B({provider:W,links:Z})}));const T=await Promise.all(a);if(p.token.isCancellationRequested)return[];const M=new Map;for(const W of T)W&&W.links.length>0&&I.push(...W.links.map(B=>{const Z={id:E++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return M.set(Z.id,{provider:W.provider,link:B}),Z}));return this._terminalLinkCache.set(i,M),I}$activateLink(i,r){const d=this._terminalLinkCache.get(i)?.get(r);!d||d.provider.handleTerminalLink(d.link)}_onProcessExit(i,r){this._bufferer.stopBuffering(i),this._terminalProcesses.delete(i),delete this._extensionTerminalAwaitingStart[i];const d=this._terminalProcessDisposables[i];d&&(d.dispose(),delete this._terminalProcessDisposables[i]),this._proxy.$sendProcessExit(i,r)}_getTerminalById(i){return this._getTerminalObjectById(this._terminals,i)}_getTerminalObjectById(i,r){const d=this._getTerminalObjectIndexById(i,r);return d!==null?i[d]:null}_getTerminalObjectIndexById(i,r){let d=null;return i.some((m,p)=>m._id===r?(d=p,!0):!1),d}getEnvironmentVariableCollection(i){let r=this._environmentVariableCollections.get(i.identifier.value);return r||(r=new g,this._setEnvironmentVariableCollection(i.identifier.value,r)),r}_syncEnvironmentVariableCollection(i,r){const d=(0,P.serializeEnvironmentVariableCollection)(r.map);this._proxy.$setEnvironmentVariableCollection(i,r.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(i){i.forEach(r=>{const d=r[0],m=new g(r[1]);this._setEnvironmentVariableCollection(d,m)})}$acceptDefaultProfile(i,r){this._defaultProfile=i,this._defaultAutomationProfile=r}_setEnvironmentVariableCollection(i,r){this._environmentVariableCollections.set(i,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(i,r)})}};u=He([ze(1,k.IExtHostRpcService)],u),e.BaseExtHostTerminalService=u;class g{constructor(i){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new h.Emitter,this.map=new Map(i)}get persistent(){return this._persistent}set persistent(i){this._persistent=i,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(i,r){this._setIfDiffers(i,{value:r,type:_.EnvironmentVariableMutatorType.Replace})}append(i,r){this._setIfDiffers(i,{value:r,type:_.EnvironmentVariableMutatorType.Append})}prepend(i,r){this._setIfDiffers(i,{value:r,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(i,r){const d=this.map.get(i);(!d||d.value!==r.value||d.type!==r.type)&&(this.map.set(i,r),this._onDidChangeCollection.fire())}get(i){return this.map.get(i)}forEach(i,r){this.map.forEach((d,m)=>i.call(r,m,d,this))}delete(i){this.map.delete(i),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=g;let v=class extends u{constructor(i){super(!1,i)}createTerminal(i,r,d){throw new n.NotSupportedError}createTerminalFromOptions(i,r){throw new n.NotSupportedError}};v=He([ze(0,k.IExtHostRpcService)],v),e.WorkerExtHostTerminalService=v;function t(s){if(!!s)return typeof s=="string"||!("id"in s)?s:{id:s.id,color:s.color}}});var it=this&&this.__classPrivateFieldSet||function(te,e,h,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(te,h):D?D.value=h:e.set(te,h),h},Ne=this&&this.__classPrivateFieldGet||function(te,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(te):R?R.value:e.get(te)};define(Ee[204],_e([0,1,17,16,23,18,3,49,40,7,24,10,35,5,13,9,6,177,96]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f,l,o,w,b,E){"use strict";var u,g,v,t,s,i;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(B,Z){this.resultsChangedEmitter=new k.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=B.getProxy(f.MainContext.MainThreadTesting),this.observer=new M(this.proxy),this.runTracker=new m(this.proxy),Z.registerArgumentProcessor({processArgument:q=>q?.$mid===13?o.TestItem.toItemFromContext(q):q})}createTestController(B){const Z=new C.DisposableStore,q=Z.add(new b.SingleUseTestCollection(B)),$=Z.add(new R.RunOnceScheduler(()=>q.expand(q.root.id,0),0)),V={root:q.root,get id(){return B},createTestRun:(F,re,N=!0)=>this.runTracker.createTestRun(B,F,re,N),createTestItem(F,re,N,H,J){if(!(N instanceof w.TestItemImpl))throw new Error(`The "parent" passed in for TestItem ${F} is invalid`);return new w.TestItemImpl(F,re,H,J,N)},set resolveChildrenHandler(F){q.resolveHandler=F,F&&$.schedule()},get resolveChildrenHandler(){return q.resolveHandler},dispose:()=>{Z.dispose()}};return this.proxy.$registerTestController(B),Z.add((0,C.toDisposable)(()=>this.proxy.$unregisterTestController(B))),this.controllers.set(B,{controller:V,collection:q}),Z.add((0,C.toDisposable)(()=>this.controllers.delete(B))),Z.add(q.onDidGenerateDiff(F=>this.proxy.$publishDiff(B,F))),V}createTestObserver(){return this.observer.checkout()}async runTests(B,Z=y.CancellationToken.None){const q=$=>$.map(this.getInternalTestForReference,this).filter(P.isDefined).map(V=>({controllerId:V.controllerId,testId:V.item.extId}));await this.proxy.$runTests({exclude:B.exclude?q(B.exclude).map($=>$.testId):void 0,tests:q(B.tests),debug:B.debug},Z)}$provideFileCoverage(B,Z,q){return _.Iterable.find(this.runTracker.trackers,$=>$.id===B)?.getCoverage(Z)?.provideFileCoverage(q)??Promise.resolve([])}$resolveFileCoverage(B,Z,q,$){return _.Iterable.find(this.runTracker.trackers,V=>V.id===B)?.getCoverage(Z)?.resolveFileCoverage(q,$)??Promise.resolve([])}$publishTestResults(B){this.results=Object.freeze(B.map(Z=>(0,n.deepFreeze)(o.TestResults.to(Z))).concat(this.results).sort((Z,q)=>q.completedAt-Z.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest({controllerId:B,testId:Z},q){const $=this.controllers.get(B)?.collection;$&&(await $.expand(Z,q<0?Infinity:q),$.flushDiff())}$acceptDiff(B){this.observer.applyDiff(B)}async $runControllerTests(B,Z){const q=this.controllers.get(B.controllerId);if(!q)return;const{controller:$,collection:V}=q,F=B.testIds.map(J=>V.tree.get(J)).filter(P.isDefined),re=B.excludeExtIds.map(J=>q.collection.tree.get(J)).filter(P.isDefined).filter(J=>F.some(K=>V.tree.comparePositions(K,J)===1));if(!F.length)return;const N={tests:F.map(J=>J.actual),exclude:re.map(J=>J.actual),debug:B.debug},H=this.runTracker.prepareForMainThreadTestRun(N,p.fromInternal(B),Z);try{await $.runHandler?.(N,Z)}finally{H.isRunning&&!Z.isCancellationRequested&&await k.Event.toPromise(H.onEnd),this.runTracker.cancelRunById(B.runId)}}$cancelExtensionTestRun(B){B===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(B)}getInternalTestForReference(B){return(0,h.mapFind)(this.controllers.values(),({collection:Z})=>Z.getTestByReference(B))??this.observer.getMirroredTestDataByReference(B)}};r=He([ze(0,l.IExtHostRpcService)],r),e.ExtHostTesting=r;class d extends C.Disposable{constructor(B,Z,q){super();this.dto=B,this.proxy=Z,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new k.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(q)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:$}of this.tasks.values())$.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(B){return this.tasks.get(B)?.coverage}createRun(B){const Z=(0,c.generateUuid)(),q=new I(this.proxy,this.dto.id,Z),$=new A(B,this.cts.token,Z,q,this.dto,this.sharedTestIds,this.proxy,()=>{this.tasks.delete($.taskId),this.isRunning||this.dispose()});return this.tasks.set($.taskId,{run:$,coverage:q}),$}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}}class m{constructor(B){this.proxy=B,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(B,Z,q){return this.getTracker(B,Z,q)}cancelRunById(B){for(const Z of this.tracked.values())if(Z.id===B){Z.dispose();return}}cancelAllRuns(){for(const B of this.tracked.values())B.dispose()}createTestRun(B,Z,q,$){const V=this.tracked.get(Z);if(V)return V.createRun(q);const F=p.fromPublic(B,Z);this.proxy.$startedExtensionTestRun({debug:Z.debug,exclude:Z.exclude?.map(N=>N.id)??[],id:F.id,tests:Z.tests.map(N=>N.id),persist:$});const re=this.getTracker(Z,F);return re.onEnd(()=>this.proxy.$finishedExtensionTestRun(F.id)),re.createRun(q)}getTracker(B,Z,q){const $=new d(Z,this.proxy,q);return this.tracked.set(B,$),$.onEnd(()=>this.tracked.delete(B)),$}}e.TestRunCoordinator=m;class p{constructor(B,Z,q,$){this.controllerId=B,this.id=Z,this.include=q,this.exclude=$}static fromPublic(B,Z){return new p(B,(0,c.generateUuid)(),new Set(Z.tests.map(q=>q.id)),new Set(Z.exclude?.map(q=>q.id)??_.Iterable.empty()))}static fromInternal(B){return new p(B.controllerId,B.runId,new Set(B.testIds),new Set(B.excludeExtIds))}isIncluded(B){for(let Z=B;Z;Z=Z.parent){if(this.include.has(Z.id))return!0;if(this.exclude.has(Z.id))return!1}return!1}}e.TestRunDto=p;class I{constructor(B,Z,q){this.proxy=B,this.runId=Z,this.taskId=q}set coverageProvider(B){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!B||(this._coverageProvider=B,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(B){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(B))());try{return(await this.fileCoverage)?.map(o.TestCoverage.fromFile)??[]}catch(Z){throw this.fileCoverage=void 0,Z}}async resolveFileCoverage(B,Z){const q=await this.fileCoverage;let $=q?.[B];return!this._coverageProvider||!q||!$?[]:($.detailedCoverage||($=q[B]=await this._coverageProvider.resolveFileCoverage?.($,Z)??$),$.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class A{constructor(B,Z,q,$,V,F,re,N){this.name=B,this.token=Z,this.taskId=q,u.set(this,void 0),g.set(this,void 0),v.set(this,void 0),t.set(this,void 0),s.set(this,void 0),i.set(this,!1),it(this,t,N,"f"),it(this,u,re,"f"),it(this,g,V,"f"),it(this,s,$,"f"),it(this,v,F,"f"),re.$startedTestRunTask(V.id,{id:this.taskId,name:B,running:!0})}set coverageProvider(B){Ne(this,s,"f").coverageProvider=B}get coverageProvider(){return Ne(this,s,"f").coverageProvider}setState(B,Z,q){!Ne(this,i,"f")&&Ne(this,g,"f").isIncluded(B)&&(this.ensureTestIsKnown(B),Ne(this,u,"f").$updateTestStateInRun(Ne(this,g,"f").id,this.taskId,B.id,Z,q))}appendMessage(B,Z){!Ne(this,i,"f")&&Ne(this,g,"f").isIncluded(B)&&(this.ensureTestIsKnown(B),Ne(this,u,"f").$appendTestMessageInRun(Ne(this,g,"f").id,this.taskId,B.id,o.TestMessage.from(Z)))}appendOutput(B){Ne(this,i,"f")||Ne(this,u,"f").$appendOutputToRun(Ne(this,g,"f").id,this.taskId,D.VSBuffer.fromString(B))}end(){Ne(this,i,"f")||(it(this,i,!0,"f"),Ne(this,u,"f").$finishedTestRunTask(Ne(this,g,"f").id,this.taskId),Ne(this,t,"f").call(this))}ensureTestIsKnown(B){const Z=Ne(this,v,"f");if(Z.has(B.id))return;const q=[];for(;q.unshift(o.TestItem.from(B)),!(Z.has(B.id)||(Z.add(B.id),!B.parent));)B=B.parent;Ne(this,u,"f").$addTestsToRun(Ne(this,g,"f").controllerId,Ne(this,g,"f").id,q)}}u=new WeakMap,g=new WeakMap,v=new WeakMap,t=new WeakMap,s=new WeakMap,i=new WeakMap;class a extends E.IncrementalChangeCollector{constructor(B){super();this.emitter=B,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(B){this.added.add(B)}update(B){Object.assign(B.revived,o.TestItem.toPlain(B.item)),this.added.has(B)||this.updated.add(B)}remove(B){if(this.added.has(B)){this.added.delete(B);return}if(this.updated.delete(B),B.parent&&this.alreadyRemoved.has(B.parent)){this.alreadyRemoved.add(B.item.extId);return}this.removed.add(B)}getChangeEvent(){const{added:B,updated:Z,removed:q}=this;return{get added(){return[...B].map($=>$.revived)},get updated(){return[...Z].map($=>$.revived)},get removed(){return[...q].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class T extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new k.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(B){return this.items.get(B)}getMirroredTestDataByReference(B){return this.items.get(B.id)}createItem(B,Z){return{...B,revived:o.TestItem.toPlain(B.item),depth:Z?Z.depth+1:0,children:new Set}}createChangeCollector(){return new a(this.changeEmitter)}}e.MirroredTestCollection=T;class M{constructor(B){this.proxy=B}checkout(){this.current||(this.current=this.createObserverData());const B=this.current;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(Z=>Z.revived)},dispose:(0,S.once)(()=>{--B.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(B){return this.current?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.current?.tests.apply(B)}createObserverData(){const B=new T;return this.proxy.$subscribeToDiffs(),{observers:0,tests:B}}}}),define(Ee[205],_e([0,1,3,17,5,99,9,6]),function(te,e,h,R,D,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(n,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new h.Emitter,this._onDidChangeTextEditorOptions=new h.Emitter,this._onDidChangeTextEditorVisibleRanges=new h.Emitter,this._onDidChangeTextEditorViewColumn=new h.Emitter,this._onDidChangeActiveTextEditor=new h.Emitter,this._onDidChangeVisibleTextEditors=new h.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const P=this._extHostDocumentsAndEditors.allEditors();return n?P:P.map(c=>c.value)}async showTextDocument(n,P,c){let f;typeof P=="number"?f={position:k.ViewColumn.from(P),preserveFocus:c}:typeof P=="object"?f={position:k.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?k.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:f={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(n.uri,f),o=l&&this._extHostDocumentsAndEditors.getEditor(l);if(o)return o.value;throw l?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,P){return new y.TextEditorDecorationType(this._proxy,n,P).value}$acceptEditorPropertiesChanged(n,P){const c=this._extHostDocumentsAndEditors.getEditor(n);if(!c)throw new Error("unknown text editor");if(P.options&&c._acceptOptions(P.options),P.selections){const f=P.selections.selections.map(k.Selection.to);c._acceptSelections(f)}if(P.visibleRanges){const f=R.coalesce(P.visibleRanges.map(k.Range.to));c._acceptVisibleRanges(f)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...P.options,lineNumbers:k.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const f=S.TextEditorSelectionChangeKind.fromValue(P.selections.source),l=P.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:l,kind:f})}if(P.visibleRanges){const f=R.coalesce(P.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:f})}}$acceptEditorPositionData(n){for(const P in n){const c=this._extHostDocumentsAndEditors.getEditor(P);if(!c)throw new Error("Unknown text editor");const f=k.ViewColumn.to(n[P]);c.value.viewColumn!==f&&(c._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:f}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=_}),define(Ee[206],_e([0,1,2,4,5,7,6]),function(te,e,h,R,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class S{constructor(n,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(D.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===11){const f=c.uri===void 0?void 0:h.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(_(f))?.get(c.handle)}return c}})}async $getTimeline(n,P,c,f,l){return this._providers.get(n)?.provideTimeline(h.URI.revive(P),c,f,l)}registerTimelineProvider(n,P,c,f){const l=new y.DisposableStore,o=this.convertTimelineItem(P.id,f,l).bind(this);let w;P.onDidChange&&(w=P.onDidChange(E=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...E,id:P.id}),this));const b=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...P,scheme:n,onDidChange:void 0,async provideTimeline(E,u,g,v){v?.resetCache&&(l.clear(),b.get(P.id)?.clear());const t=await P.provideTimeline(E,u,g);if(t==null)return;const s=o(E,v);return{...t,source:P.id,items:t.items.map(s)}},dispose(){for(const E of b.values())E.get(P.id)?.clear();w?.dispose(),l.dispose()}})}convertTimelineItem(n,P,c){return(f,l)=>{let o;if(l?.cacheResults){let w=this._itemsBySourceAndUriMap.get(n);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(n,w));const b=_(f);o=w.get(b),o===void 0&&(o=new Map,w.set(b,o))}return w=>{const{iconPath:b,...E}=w,u=`${n}|${w.id??w.timestamp}`;o?.set(u,w);let g,v,t;return w.iconPath&&(b instanceof k.ThemeIcon?t={id:b.id,color:b.color}:h.URI.isUri(b)?(g=b,v=b):{light:g,dark:v}=b),{...E,id:E.id??void 0,handle:u,source:n,command:w.command?P.toInternal(w.command,c):void 0,icon:g,iconDark:v,themeIcon:t,accessibilityInformation:w.accessibilityInformation}}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),(0,y.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(n.id)?.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=S;function _(C){return C?.toString()}}),define(Ee[207],_e([0,1,7,11,2,5]),function(te,e,h,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(_){this._openers=new Map,this._proxy=_.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,C,n,P){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const c=P.schemes.find(f=>!k.supportedSchemes.has(f));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,n),this._proxy.$registerUriOpener(C,P.schemes,_,P.label),(0,h.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(_,C,n){const P=this._openers.get(_);if(!P)throw new Error(`Unknown opener with id: ${_}`);const c=D.URI.revive(C);return P.canOpenExternalUri(c,n)}async $openUri(_,C,n){const P=this._openers.get(_);if(!P)throw new Error(`Unknown opener id: '${_}'`);return P.openExternalUri(D.URI.revive(C.resolvedUri),{sourceUri:D.URI.revive(C.sourceUri)},n)}}e.ExtHostUriOpeners=k,k.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(Ee[208],_e([0,1,5,2,7,12,26]),function(te,e,h,R,D,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class S{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(h.MainContext.MainThreadUrls)}registerUriHandler(C,n){if(this.handles.has(k.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const P=S.HandlePool++;return this.handles.add(k.ExtensionIdentifier.toKey(C)),this.handlers.set(P,n),this._proxy.$registerUriHandler(P,C),(0,D.toDisposable)(()=>{this.handles.delete(k.ExtensionIdentifier.toKey(C)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(C,n){const P=this.handlers.get(C);if(!P)return Promise.resolve(void 0);try{P.handleUri(R.URI.revive(n))}catch(c){(0,y.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(C){return R.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=S,S.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(te,e,h,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(te,h):D?D.value=h:e.set(te,h),h},Ne=this&&this.__classPrivateFieldGet||function(te,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(te):R?R.value:e.get(te)};define(Ee[47],_e([0,1,3,2,142,163,67,5]),function(te,e,h,R,D,y,k,S){"use strict";var _,C,n,P,c,f,l,o,w,b,E,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(p,I,A,a,T,M,W){_.set(this,void 0),C.set(this,void 0),n.set(this,void 0),P.set(this,void 0),c.set(this,void 0),f.set(this,void 0),l.set(this,""),o.set(this,void 0),w.set(this,!1),b.set(this,!1),E.set(this,!1),this._onMessageEmitter=new h.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new h.Emitter),this._onDidDispose=Ne(this,u,"f").event,it(this,_,p,"f"),it(this,C,I,"f"),it(this,o,A,"f"),it(this,P,a,"f"),it(this,c,T,"f"),it(this,f,M,"f"),it(this,E,v(M),"f"),it(this,n,W,"f")}dispose(){it(this,w,!0,"f"),Ne(this,u,"f").fire(),Ne(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return it(this,b,!0,"f"),(0,k.asWebviewUri)(p,Ne(this,P,"f").remote)}get cspSource(){return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ne(this,l,"f")}set html(p){this.assertNotDisposed(),Ne(this,l,"f")!==p&&(it(this,l,p,"f"),!Ne(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(it(this,b,!0,"f"),Ne(this,n,"f").report("Webview vscode-resource: uris",Ne(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,C,"f").$setHtml(Ne(this,_,"f"),p))}get options(){return this.assertNotDisposed(),Ne(this,o,"f")}set options(p){this.assertNotDisposed(),Ne(this,C,"f").$setOptions(Ne(this,_,"f"),i(Ne(this,f,"f"),Ne(this,c,"f"),p)),it(this,o,p,"f")}async postMessage(p){if(Ne(this,w,"f"))return!1;const I=(0,y.serializeWebviewMessage)(p,{serializeBuffersForPostMessage:Ne(this,E,"f")});return Ne(this,C,"f").$postMessage(Ne(this,_,"f"),I.message,...I.buffers)}assertNotDisposed(){if(Ne(this,w,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,_=new WeakMap,C=new WeakMap,n=new WeakMap,P=new WeakMap,c=new WeakMap,f=new WeakMap,l=new WeakMap,o=new WeakMap,w=new WeakMap,b=new WeakMap,E=new WeakMap,u=new WeakMap;function v(m){try{const p=(0,D.normalizeVersion)((0,D.parseVersion)(m.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=v;class t{constructor(p,I,A,a,T){this.initData=I,this.workspace=A,this._logService=a,this._deprecationService=T,this._webviews=new Map,this._webviewProxy=p.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(p,I,...A){const a=this.getWebview(p);if(a){const{message:T}=(0,y.deserializeWebviewMessage)(I,A);a._onMessageEmitter.fire(T)}}$onMissingCsp(p,I){this._logService.warn(`${I} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,I,A){const a=new g(p,this._webviewProxy,r(I),this.initData,this.workspace,A,this._deprecationService);return this._webviews.set(p,a),a._onDidDispose(()=>{this._webviews.delete(p)}),a}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=t;function s(m){return{id:m.identifier,location:m.extensionLocation}}e.toExtensionData=s;function i(m,p,I){return{enableCommandUris:I.enableCommandUris,enableScripts:I.enableScripts,portMapping:I.portMapping,localResourceRoots:I.localResourceRoots||d(m,p)}}e.serializeWebviewOptions=i;function r(m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots?.map(p=>R.URI.from(p))}}e.reviveOptions=r;function d(m,p){return[...(p?.getWorkspaceFolders()||[]).map(I=>I.uri),m.extensionLocation]}}),define(Ee[209],_e([0,1,18,53,7,11,25,2,9,47,63,5,6]),function(te,e,h,R,D,y,k,S,_,C,n,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,s){this.document=t,this._storagePath=s,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,s){await this.getEdit(t).undo(),s||this.disposeBackup()}async redo(t,s){await this.getEdit(t).redo(),s||this.disposeBackup()}disposeEdits(t){for(const s of t)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=g(this.document.uri)+this._backupCounter++;return(0,k.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const s=this._edits.get(t,0);if(!s)throw new Error("No edit found");return s}}class l{constructor(){this._documents=new Map}get(t,s){return this._documents.get(this.key(t,s))}add(t,s,i){const r=this.key(t,s.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${s.uri}`);const d=new f(s,i);return this._documents.set(r,d),d}delete(t,s){const i=this.key(t,s.uri);this._documents.delete(i)}key(t,s){return`${t}@@@${s}`}}var o;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(o||(o={}));class w{constructor(){this._providers=new Map}addTextProvider(t,s,i){return this.add(0,t,s,i)}addCustomProvider(t,s,i){return this.add(1,t,s,i)}get(t){return this._providers.get(t)}add(t,s,i,r){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:t,extension:i,provider:r}),new c.Disposable(()=>this._providers.delete(s))}}class b{constructor(t,s,i,r,d){this._extHostDocuments=s,this._extensionStoragePaths=i,this._extHostWebview=r,this._extHostWebviewPanels=d,this._editorProviders=new w,this._documents=new l,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,s,i,r){const d=new D.DisposableStore;return E(i)?(d.add(this._editorProviders.addTextProvider(s,t,i)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(t),s,r.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(t))):(d.add(this._editorProviders.addCustomProvider(s,t,i)),this.supportEditing(i)&&d.add(i.onDidChangeCustomDocument(m=>{const p=this.getCustomDocumentEntry(s,m.document.uri);if(u(m)){const I=p.addEdit(m);this._proxy.$onDidEdit(m.document.uri,s,I,m.label)}else this._proxy.$onContentChange(m.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(t),s,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(t))),c.Disposable.from(d,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(t,s,i,r,d){const m=this._editorProviders.get(s);if(!m)throw new Error(`No provider found for '${s}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${s}'`);const p=S.URI.revive(t),I=await m.provider.openCustomDocument(p,{backupId:i,untitledDocumentData:r?.buffer},d);let A;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(A=this._extensionStoragePaths.workspaceValue(m.extension)??this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(s,I,A),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(t,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${s}'`);const r=S.URI.revive(t),{document:d}=this.getCustomDocumentEntry(s,r);this._documents.delete(s,d),d.dispose()}async $resolveWebviewEditor(t,s,i,r,d,m){const p=this._editorProviders.get(i);if(!p)throw new Error(`No provider found for '${i}'`);const I=_.ViewColumn.to(d),A=this._extHostWebview.createNewWebview(s,r.webviewOptions,p.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(s,i,r.title,I,r.panelOptions,A),T=S.URI.revive(t);switch(p.type){case 1:{const{document:M}=this.getCustomDocumentEntry(i,T);return p.provider.resolveCustomEditor(M,a,m)}case 0:{const M=this._extHostDocuments.getDocument(T);return p.provider.resolveCustomTextEditor(M,a,m)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,s,i){this.getCustomDocumentEntry(s,t).disposeEdits(i)}async $onMoveCustomEditor(t,s,i){const r=this._editorProviders.get(i);if(!r)throw new Error(`No provider found for '${i}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const d=this._extHostWebviewPanels.getWebviewPanel(t);if(!d)throw new Error("No webview found");const m=S.URI.revive(s),p=this._extHostDocuments.getDocument(m);await r.provider.moveCustomTextEditor(p,d,h.CancellationToken.None)}async $undo(t,s,i,r){return this.getCustomDocumentEntry(s,t).undo(i,r)}async $redo(t,s,i,r){return this.getCustomDocumentEntry(s,t).redo(i,r)}async $revert(t,s,i){const r=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).revertCustomDocument(r.document,i),r.disposeBackup()}async $onSave(t,s,i){const r=this.getCustomDocumentEntry(s,t);await this.getCustomEditorProvider(s).saveCustomDocument(r.document,i),r.disposeBackup()}async $onSaveAs(t,s,i,r){const d=this.getCustomDocumentEntry(s,t);return this.getCustomEditorProvider(s).saveCustomDocumentAs(d.document,S.URI.revive(i),r)}async $backup(t,s,i){const r=this.getCustomDocumentEntry(s,t),m=await this.getCustomEditorProvider(s).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},i);return r.updateBackup(m),m.id}getCustomDocumentEntry(t,s){const i=this._documents.get(t,S.URI.revive(s));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(t){const i=this._editorProviders.get(t)?.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=b;function E(v){return typeof v.resolveCustomTextEditor=="function"}function u(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function g(v){const t=v.scheme===y.Schemas.file||v.scheme===y.Schemas.untitled?v.fsPath:v.toString();return(0,R.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(te,e,h,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(te,h):D?D.value=h:e.set(te,h),h},Ne=this&&this.__classPrivateFieldGet||function(te,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(te):R?R.value:e.get(te)};define(Ee[210],_e([0,1,3,7,2,35,9,47,5,6]),function(te,e,h,R,D,y,k,S,_,C){"use strict";var n,P,c,f,l,o,w,b,E,u,g,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends R.Disposable{constructor(m,p,I,A,a,T,M){super();n.set(this,void 0),P.set(this,void 0),c.set(this,void 0),f.set(this,void 0),l.set(this,void 0),o.set(this,void 0),w.set(this,void 0),b.set(this,void 0),E.set(this,!0),u.set(this,!0),g.set(this,!1),v.set(this,this._register(new h.Emitter)),this.onDidDispose=Ne(this,v,"f").event,t.set(this,this._register(new h.Emitter)),this.onDidChangeViewState=Ne(this,t,"f").event,it(this,n,m,"f"),it(this,P,p,"f"),it(this,c,I,"f"),it(this,l,T,"f"),it(this,b,a,"f"),it(this,o,A,"f"),it(this,f,M,"f")}dispose(){Ne(this,g,"f")||(it(this,g,!0,"f"),Ne(this,v,"f").fire(),Ne(this,P,"f").$disposeWebview(Ne(this,n,"f")),Ne(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ne(this,f,"f")}get viewType(){return this.assertNotDisposed(),Ne(this,c,"f")}get title(){return this.assertNotDisposed(),Ne(this,o,"f")}set title(m){this.assertNotDisposed(),Ne(this,o,"f")!==m&&(it(this,o,m,"f"),Ne(this,P,"f").$setTitle(Ne(this,n,"f"),m))}get iconPath(){return this.assertNotDisposed(),Ne(this,w,"f")}set iconPath(m){this.assertNotDisposed(),Ne(this,w,"f")!==m&&(it(this,w,m,"f"),Ne(this,P,"f").$setIconPath(Ne(this,n,"f"),D.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Ne(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ne(this,b,"f")=="number"&&Ne(this,b,"f")<0))return Ne(this,b,"f")}get active(){return this.assertNotDisposed(),Ne(this,u,"f")}get visible(){return this.assertNotDisposed(),Ne(this,E,"f")}_updateViewState(m){Ne(this,g,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(it(this,u,m.active,"f"),it(this,E,m.visible,"f"),it(this,b,m.viewColumn,"f"),Ne(this,t,"f").fire({webviewPanel:this}))}reveal(m,p){this.assertNotDisposed(),Ne(this,P,"f").$reveal(Ne(this,n,"f"),{viewColumn:m?k.ViewColumn.from(m):void 0,preserveFocus:!!p})}assertNotDisposed(){if(Ne(this,g,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,P=new WeakMap,c=new WeakMap,f=new WeakMap,l=new WeakMap,o=new WeakMap,w=new WeakMap,b=new WeakMap,E=new WeakMap,u=new WeakMap,g=new WeakMap,v=new WeakMap,t=new WeakMap;class i{constructor(m,p,I){this.webviews=p,this.workspace=I,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=m.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,y.generateUuid)()}createWebviewPanel(m,p,I,A,a={}){const T=typeof A=="object"?A.viewColumn:A,M={viewColumn:k.ViewColumn.from(T),preserveFocus:typeof A=="object"&&!!A.preserveFocus},W=(0,S.shouldSerializeBuffersForPostMessage)(m),B=i.newHandle();this._proxy.$createWebviewPanel((0,S.toExtensionData)(m),B,p,{title:I,panelOptions:r(a),webviewOptions:(0,S.serializeWebviewOptions)(m,this.workspace,a),serializeBuffersForPostMessage:W},M);const Z=this.webviews.createNewWebview(B,a,m);return this.createNewWebviewPanel(B,p,I,T,a,Z)}$onDidChangeWebviewPanelViewStates(m){const p=Object.keys(m);p.sort((I,A)=>{const a=m[I],T=m[A];return a.active?1:T.active?-1:+a.visible-+T.visible});for(const I of p){const A=this.getWebviewPanel(I);if(!A)continue;const a=m[I];A._updateViewState({active:a.active,visible:a.visible,viewColumn:k.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this._webviewPanels.delete(m),this.webviews.deleteWebview(m)}registerWebviewPanelSerializer(m,p,I){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:I,extension:m}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:(0,S.shouldSerializeBuffersForPostMessage)(m)}),new C.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(m,p,I,A){const a=this._serializers.get(p);if(!a)throw new Error(`No serializer found for '${p}'`);const{serializer:T,extension:M}=a,W=this.webviews.createNewWebview(m,I.webviewOptions,M),B=this.createNewWebviewPanel(m,p,I.title,A,I.panelOptions,W);await T.deserializeWebviewPanel(B,I.state)}createNewWebviewPanel(m,p,I,A,a,T){const M=new s(m,this._proxy,p,I,A,a,T);return this._webviewPanels.set(m,M),M}getWebviewPanel(m){return this._webviewPanels.get(m)}}e.ExtHostWebviewPanels=i;function r(d){return{enableFindWidget:d.enableFindWidget,retainContextWhenHidden:d.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(te,e,h,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(te,h):D?D.value=h:e.set(te,h),h},Ne=this&&this.__classPrivateFieldGet||function(te,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(te):R?R.value:e.get(te)};define(Ee[211],_e([0,1,3,7,47,5,6]),function(te,e,h,R,D,y,k){"use strict";var S,_,C,n,P,c,f,l,o,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends R.Disposable{constructor(g,v,t,s,i,r){super();S.set(this,void 0),_.set(this,void 0),C.set(this,void 0),n.set(this,void 0),P.set(this,!1),c.set(this,void 0),f.set(this,void 0),l.set(this,void 0),o.set(this,this._register(new h.Emitter)),this.onDidChangeVisibility=Ne(this,o,"f").event,w.set(this,this._register(new h.Emitter)),this.onDidDispose=Ne(this,w,"f").event,it(this,C,t,"f"),it(this,f,s,"f"),it(this,S,g,"f"),it(this,_,v,"f"),it(this,n,i,"f"),it(this,c,r,"f")}dispose(){Ne(this,P,"f")||(it(this,P,!0,"f"),Ne(this,w,"f").fire(),Ne(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ne(this,f,"f")}set title(g){this.assertNotDisposed(),Ne(this,f,"f")!==g&&(it(this,f,g,"f"),Ne(this,_,"f").$setWebviewViewTitle(Ne(this,S,"f"),g))}get description(){return this.assertNotDisposed(),Ne(this,l,"f")}set description(g){this.assertNotDisposed(),Ne(this,l,"f")!==g&&(it(this,l,g,"f"),Ne(this,_,"f").$setWebviewViewDescription(Ne(this,S,"f"),g))}get visible(){return Ne(this,c,"f")}get webview(){return Ne(this,n,"f")}get viewType(){return Ne(this,C,"f")}_setVisible(g){g===Ne(this,c,"f")||Ne(this,P,"f")||(it(this,c,g,"f"),Ne(this,o,"f").fire())}show(g){this.assertNotDisposed(),Ne(this,_,"f").$show(Ne(this,S,"f"),!!g)}assertNotDisposed(){if(Ne(this,P,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,_=new WeakMap,C=new WeakMap,n=new WeakMap,P=new WeakMap,c=new WeakMap,f=new WeakMap,l=new WeakMap,o=new WeakMap,w=new WeakMap;class E{constructor(g,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=g.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(g,v,t,s){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:t,extension:g}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(g),v,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new k.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(g,v,t,s,i){const r=this._viewProviders.get(v);if(!r)throw new Error(`No view provider found for '${v}'`);const{provider:d,extension:m}=r,p=this._extHostWebview.createNewWebview(g,{},m),I=new b(g,this._proxy,v,t,p,!0);this._webviewViews.set(g,I),await d.resolveWebviewView(I,{state:s},i)}async $onDidChangeWebviewViewVisibility(g,v){this.getWebviewView(g)._setVisible(v)}async $disposeWebviewView(g){const v=this.getWebviewView(g);this._webviewViews.delete(g),v.dispose(),this._extHostWebview.deleteWebview(g)}getWebviewView(g){const v=this._webviewViews.get(g);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=E}),define(Ee[103],_e([0,1,3,5,2,11,8,4,13]),function(te,e,h,R,D,y,k,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class Hn{constructor(P){this._onDidChangeWindowState=new h.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Hn.InitialState,this._proxy=P.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state={...this._state,focused:P},this._onDidChangeWindowState.fire(this._state))}openUri(P,c){let f;if(typeof P=="string"){f=P;try{P=D.URI.parse(P)}catch(l){return Promise.reject(`Invalid uri - '${P}'`)}}return(0,k.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,f,c)}async asExternalUri(P,c){if((0,k.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(P,c);return D.URI.from(f)}};C.InitialState={focused:!0},C=He([ze(0,_.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,S.createDecorator)("IExtHostWindow")}),define(Ee[212],_e([0,1,15,5,28,13]),function(te,e,h,R,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends h.AbstractLogger{constructor(_,C){super();this._proxy=_.getProxy(R.MainContext.MainThreadLog),this._logFile=C.logFile.toJSON(),this.setLevel(C.logLevel)}$setLevel(_){this.setLevel(_)}trace(_,...C){this.getLevel()<=h.LogLevel.Trace&&this._proxy.$log(this._logFile,h.LogLevel.Trace,Array.from(arguments))}debug(_,...C){this.getLevel()<=h.LogLevel.Debug&&this._proxy.$log(this._logFile,h.LogLevel.Debug,Array.from(arguments))}info(_,...C){this.getLevel()<=h.LogLevel.Info&&this._proxy.$log(this._logFile,h.LogLevel.Info,Array.from(arguments))}warn(_,...C){this.getLevel()<=h.LogLevel.Warning&&this._proxy.$log(this._logFile,h.LogLevel.Warning,Array.from(arguments))}error(_,...C){this.getLevel()<=h.LogLevel.Error&&this._proxy.$log(this._logFile,h.LogLevel.Error,Array.from(arguments))}critical(_,...C){this.getLevel()<=h.LogLevel.Critical&&this._proxy.$log(this._logFile,h.LogLevel.Critical,Array.from(arguments))}flush(){}};k=He([ze(0,y.IExtHostRpcService),ze(1,D.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(Ee[213],_e([0,1,16,18,12,3,7,114,182,100,23]),function(te,e,h,R,D,y,k,S,_,C,n){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function c(r,d){try{return JSON.stringify(r,d)}catch(m){return"null"}}function f(r,d){return JSON.stringify(r,d)}function l(r){return r?(d,m)=>m&&m.$mid===1?r.transformOutgoing(m):m:null}var o;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const b=()=>{},E=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class g extends k.Disposable{constructor(d,m=null,p=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=d,this._logger=m,this._uriTransformer=p,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let I=0,A=C.ProxyIdentifier.count;I<A;I++)this._locals[I]=null,this._proxies[I]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new h.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(I=>this._receiveOneMessage(I))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(d=>{this._pendingRPCReplies[d].resolveErr(D.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(d){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+g.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(d){this._unresponsiveTime=Date.now()+g.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(d){this._responsiveState!==d&&(this._responsiveState=d,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(d){return this._uriTransformer?(0,S.transformIncomingURIs)(d,this._uriTransformer):d}getProxy(d){const{nid:m,sid:p}=d;return this._proxies[m]||(this._proxies[m]=this._createProxy(m,p)),this._proxies[m]}_createProxy(d,m){let p={get:(I,A)=>(typeof A=="string"&&!I[A]&&A.charCodeAt(0)===36&&(I[A]=(...a)=>this._remoteCall(d,A,a)),A===u?m:I[A])};return new Proxy(Object.create(null),p)}set(d,m){return this._locals[d.nid]=m,m}assertRegistered(d){for(let m=0,p=d.length;m<p;m++){const I=d[m];if(!this._locals[I.nid])throw new Error(`Missing actor ${I.sid} (isMain: ${I.isMain})`)}}_receiveOneMessage(d){if(this._isDisposed)return;const m=d.byteLength,p=v.read(d,0),I=p.readUInt8(),A=p.readUInt32();switch(I){case 1:case 2:{let{rpcId:a,method:T,args:M}=t.deserializeRequestJSONArgs(p);this._uriTransformer&&(M=(0,S.transformIncomingURIs)(M,this._uriTransformer)),this._receiveRequest(m,A,a,T,M,I===2);break}case 3:case 4:{let{rpcId:a,method:T,args:M}=t.deserializeRequestMixedArgs(p);this._uriTransformer&&(M=(0,S.transformIncomingURIs)(M,this._uriTransformer)),this._receiveRequest(m,A,a,T,M,I===4);break}case 5:{this._logger&&this._logger.logIncoming(m,A,0,"ack"),this._onDidReceiveAcknowledge(A);break}case 6:{this._receiveCancel(m,A);break}case 7:{this._receiveReply(m,A,void 0);break}case 9:{let a=t.deserializeReplyOKJSON(p);this._uriTransformer&&(a=(0,S.transformIncomingURIs)(a,this._uriTransformer)),this._receiveReply(m,A,a);break}case 8:{let a=t.deserializeReplyOKVSBuffer(p);this._receiveReply(m,A,a);break}case 10:{let a=t.deserializeReplyErrError(p);this._uriTransformer&&(a=(0,S.transformIncomingURIs)(a,this._uriTransformer)),this._receiveReplyErr(m,A,a);break}case 11:{this._receiveReplyErr(m,A,void 0);break}default:console.error("received unexpected message"),console.error(d)}}_receiveRequest(d,m,p,I,A,a){this._logger&&this._logger.logIncoming(d,m,1,`receiveRequest ${(0,C.getStringIdentifierForProxy)(p)}.${I}(`,A);const T=String(m);let M,W;if(a){const Z=new R.CancellationTokenSource;A.push(Z.token),M=this._invokeHandler(p,I,A),W=()=>Z.cancel()}else M=this._invokeHandler(p,I,A),W=b;this._cancelInvokedHandlers[T]=W;const B=t.serializeAcknowledged(m);this._logger&&this._logger.logOutgoing(B.byteLength,m,1,"ack"),this._protocol.send(B),M.then(Z=>{delete this._cancelInvokedHandlers[T];const q=t.serializeReplyOK(m,Z,this._uriReplacer);this._logger&&this._logger.logOutgoing(q.byteLength,m,1,"reply:",Z),this._protocol.send(q)},Z=>{delete this._cancelInvokedHandlers[T];const q=t.serializeReplyErr(m,Z);this._logger&&this._logger.logOutgoing(q.byteLength,m,1,"replyErr:",Z),this._protocol.send(q)})}_receiveCancel(d,m){this._logger&&this._logger.logIncoming(d,m,1,"receiveCancel");const p=String(m);this._cancelInvokedHandlers[p]&&this._cancelInvokedHandlers[p]()}_receiveReply(d,m,p){this._logger&&this._logger.logIncoming(d,m,0,"receiveReply:",p);const I=String(m);if(!this._pendingRPCReplies.hasOwnProperty(I))return;const A=this._pendingRPCReplies[I];delete this._pendingRPCReplies[I],A.resolveOk(p)}_receiveReplyErr(d,m,p){this._logger&&this._logger.logIncoming(d,m,0,"receiveReplyErr:",p);const I=String(m);if(!this._pendingRPCReplies.hasOwnProperty(I))return;const A=this._pendingRPCReplies[I];delete this._pendingRPCReplies[I];let a;p&&(p.$isError?(a=new Error,a.name=p.name,a.message=p.message,a.stack=p.stack):a=p),A.resolveErr(a)}_invokeHandler(d,m,p){try{return Promise.resolve(this._doInvokeHandler(d,m,p))}catch(I){return Promise.reject(I)}}_doInvokeHandler(d,m,p){const I=this._locals[d];if(!I)throw new Error("Unknown actor "+(0,C.getStringIdentifierForProxy)(d));let A=I[m];if(typeof A!="function")throw new Error("Unknown method "+m+" on actor "+(0,C.getStringIdentifierForProxy)(d));return A.apply(I,p)}_remoteCall(d,m,p){if(this._isDisposed)return Promise.reject(D.canceled());let I=null;if(p.length>0&&R.CancellationToken.isCancellationToken(p[p.length-1])&&(I=p.pop()),I&&I.isCancellationRequested)return Promise.reject(D.canceled());const A=t.serializeRequestArguments(p,this._uriReplacer),a=++this._lastMessageId,T=String(a),M=new _.LazyPromise;I&&I.onCancellationRequested(()=>{const B=t.serializeCancel(a);this._logger&&this._logger.logOutgoing(B.byteLength,a,0,"cancel"),this._protocol.send(t.serializeCancel(a))}),this._pendingRPCReplies[T]=M,this._onWillSendRequest(a);const W=t.serializeRequest(a,d,m,A,!!I);return this._logger&&this._logger.logOutgoing(W.byteLength,a,0,`request: ${(0,C.getStringIdentifierForProxy)(d)}.${m}(`,p),this._protocol.send(W),M}}e.RPCProtocol=g,P=E,g.UNRESPONSIVE_TIME=3*1e3;class v{constructor(d,m){this._buff=d,this._offset=m}static alloc(d,m,p){let I=new v(n.VSBuffer.alloc(p+1+4),0);return I.writeUInt8(d),I.writeUInt32(m),I}static read(d,m){return new v(d,m)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(d){this._buff.writeUInt8(d,this._offset),this._offset+=1}readUInt8(){const d=this._buff.readUInt8(this._offset);return this._offset+=1,d}writeUInt32(d){this._buff.writeUInt32BE(d,this._offset),this._offset+=4}readUInt32(){const d=this._buff.readUInt32BE(this._offset);return this._offset+=4,d}static sizeShortString(d){return 1+d.byteLength}writeShortString(d){this._buff.writeUInt8(d.byteLength,this._offset),this._offset+=1,this._buff.set(d,this._offset),this._offset+=d.byteLength}readShortString(){const d=this._buff.readUInt8(this._offset);this._offset+=1;const p=this._buff.slice(this._offset,this._offset+d).toString();return this._offset+=d,p}static sizeLongString(d){return 4+d.byteLength}writeLongString(d){this._buff.writeUInt32BE(d.byteLength,this._offset),this._offset+=4,this._buff.set(d,this._offset),this._offset+=d.byteLength}readLongString(){const d=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+d).toString();return this._offset+=d,p}writeBuffer(d){this._buff.writeUInt32BE(d.byteLength,this._offset),this._offset+=4,this._buff.set(d,this._offset),this._offset+=d.byteLength}static sizeVSBuffer(d){return 4+d.byteLength}writeVSBuffer(d){this._buff.writeUInt32BE(d.byteLength,this._offset),this._offset+=4,this._buff.set(d,this._offset),this._offset+=d.byteLength}readVSBuffer(){const d=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+d);return this._offset+=d,m}static sizeMixedArray(d,m){let p=0;p+=1;for(let I=0,A=d.length;I<A;I++){const a=d[I],T=m[I];switch(p+=1,T){case 1:p+=this.sizeLongString(a);break;case 2:p+=this.sizeVSBuffer(a);break;case 3:break}}return p}writeMixedArray(d,m){this._buff.writeUInt8(d.length,this._offset),this._offset+=1;for(let p=0,I=d.length;p<I;p++){const A=d[p];switch(m[p]){case 1:this.writeUInt8(1),this.writeLongString(A);break;case 2:this.writeUInt8(2),this.writeVSBuffer(A);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const d=this._buff.readUInt8(this._offset);this._offset+=1;let m=new Array(d);for(let p=0;p<d;p++)switch(this.readUInt8()){case 1:m[p]=this.readLongString();break;case 2:m[p]=this.readVSBuffer();break;case 3:m[p]=void 0;break}return m}}class t{static _arrayContainsBufferOrUndefined(d){for(let m=0,p=d.length;m<p;m++)if(d[m]instanceof n.VSBuffer||typeof d[m]=="undefined")return!0;return!1}static serializeRequestArguments(d,m){if(this._arrayContainsBufferOrUndefined(d)){let p=[],I=[];for(let A=0,a=d.length;A<a;A++){const T=d[A];T instanceof n.VSBuffer?(p[A]=T,I[A]=2):typeof T=="undefined"?(p[A]=n.VSBuffer.alloc(0),I[A]=3):(p[A]=n.VSBuffer.fromString(f(T,m)),I[A]=1)}return{type:"mixed",args:p,argsType:I}}return{type:"simple",args:f(d,m)}}static serializeRequest(d,m,p,I,A){return I.type==="mixed"?this._requestMixedArgs(d,m,p,I.args,I.argsType,A):this._requestJSONArgs(d,m,p,I.args,A)}static _requestJSONArgs(d,m,p,I,A){const a=n.VSBuffer.fromString(p),T=n.VSBuffer.fromString(I);let M=0;M+=v.sizeUInt8(),M+=v.sizeShortString(a),M+=v.sizeLongString(T);let W=v.alloc(A?2:1,d,M);return W.writeUInt8(m),W.writeShortString(a),W.writeLongString(T),W.buffer}static deserializeRequestJSONArgs(d){const m=d.readUInt8(),p=d.readShortString(),I=d.readLongString();return{rpcId:m,method:p,args:JSON.parse(I)}}static _requestMixedArgs(d,m,p,I,A,a){const T=n.VSBuffer.fromString(p);let M=0;M+=v.sizeUInt8(),M+=v.sizeShortString(T),M+=v.sizeMixedArray(I,A);let W=v.alloc(a?4:3,d,M);return W.writeUInt8(m),W.writeShortString(T),W.writeMixedArray(I,A),W.buffer}static deserializeRequestMixedArgs(d){const m=d.readUInt8(),p=d.readShortString(),I=d.readMixedArray(),A=new Array(I.length);for(let a=0,T=I.length;a<T;a++){const M=I[a];typeof M=="string"?A[a]=JSON.parse(M):A[a]=M}return{rpcId:m,method:p,args:A}}static serializeAcknowledged(d){return v.alloc(5,d,0).buffer}static serializeCancel(d){return v.alloc(6,d,0).buffer}static serializeReplyOK(d,m,p){return typeof m=="undefined"?this._serializeReplyOKEmpty(d):m instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(d,m):this._serializeReplyOKJSON(d,c(m,p))}static _serializeReplyOKEmpty(d){return v.alloc(7,d,0).buffer}static _serializeReplyOKVSBuffer(d,m){let p=0;p+=v.sizeVSBuffer(m);let I=v.alloc(8,d,p);return I.writeVSBuffer(m),I.buffer}static deserializeReplyOKVSBuffer(d){return d.readVSBuffer()}static _serializeReplyOKJSON(d,m){const p=n.VSBuffer.fromString(m);let I=0;I+=v.sizeLongString(p);let A=v.alloc(9,d,I);return A.writeLongString(p),A.buffer}static deserializeReplyOKJSON(d){const m=d.readLongString();return JSON.parse(m)}static serializeReplyErr(d,m){return m?this._serializeReplyErrEror(d,m):this._serializeReplyErrEmpty(d)}static _serializeReplyErrEror(d,m){const p=n.VSBuffer.fromString(c(D.transformErrorForSerialization(m),null));let I=0;I+=v.sizeLongString(p);let A=v.alloc(10,d,I);return A.writeLongString(p),A.buffer}static deserializeReplyErrError(d){const m=d.readLongString();return JSON.parse(m)}static _serializeReplyErrEmpty(d){return v.alloc(11,d,0).buffer}}var s;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(s||(s={}));var i;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(i||(i={}))}),define(Ee[214],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const h=function(y){const k=S=>{self.removeEventListener("message",k);const _=S.data;Object.defineProperties(self,{postMessage:{value(C,n){_.postMessage(C,n)}},onmessage:{get(){return _.onmessage},set(C){_.onmessage=C}}}),_.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),_.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(y)};self.addEventListener("message",k)}.toString();class R extends EventTarget{constructor(y,k,S){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${h})('${k}'))`,C=new Blob([_],{type:"application/javascript"}),n=URL.createObjectURL(C),P=new MessageChannel,c=n,f={type:"_newWorker",id:c,port:P.port2,url:n,options:S};y(f,[P.port2]),this.postMessage=P.port1.postMessage.bind(P.port1),this.terminate=()=>{const l={type:"_terminateWorker",id:c};P.port1.postMessage(l),URL.revokeObjectURL(n),P.port1.close(),P.port2.close()},Object.defineProperties(this,{onmessage:{get(){return P.port1.onmessage},set(l){P.port1.onmessage=l}},onmessageerror:{get(){return P.port1.onmessageerror},set(l){P.port1.onmessageerror=l}}}),P.port1.addEventListener("messageerror",l=>{const o=new MessageEvent("messageerror",{data:l.data});this.dispatchEvent(o)}),P.port1.addEventListener("message",l=>{const o=new MessageEvent("message",{data:l.data});this.dispatchEvent(o)}),P.port1.start()}}e.NestedWorker=R}),define(Ee[215],_e([0,1,4]),function(te,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,h.createDecorator)("remoteAgentService")}),define(Ee[216],_e([0,1,11,14,21,2,4,92,44,178,215]),function(te,e,h,R,D,y,k,S,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,k.createDecorator)("pathService");let P=class zn{constructor(f,l,o,w){this.localUserHome=f,this.remoteAgentService=l,this.environmentService=o,this.contextService=w,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||D.OS)(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=b?.userHome||f})()}get defaultUriScheme(){return zn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,l){if(f.remoteAuthority)return h.Schemas.vscodeRemote;const o=(0,S.getVirtualWorkspaceScheme)(l.getWorkspace());if(o)return o;const w=l.getWorkspace().folders[0];if(w)return w.uri.scheme;const b=l.getWorkspace().configuration;return b?b.scheme:h.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?R.win32:R.posix)}async fileURI(f){let l="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const w=f.indexOf("/",2);w===-1?(l=f.substring(2),f="/"):(l=f.substring(2,w),f=f.substring(w)||"/")}return y.URI.from({scheme:h.Schemas.file,authority:l,path:f,query:"",fragment:""})}};P=He([ze(1,n.IRemoteAgentService),ze(2,C.IWorkbenchEnvironmentService),ze(3,_.IWorkspaceContextService)],P),e.AbstractPathService=P}),define(Ee[104],_e([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class h{constructor(k,S){this.line=k,this.character=S}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,S){return new h(0,0)}with(k){return new h(0,0)}}e.Position=h;class R{constructor(k,S,_,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new h(k,S),this.end=new h(_,C)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new R(0,0,0,0)}with(k){return new R(0,0,0,0)}}e.Range=R;var D;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ee[38],_e([0,1,17,27,24,43,8,4,14,12,104]),function(te,e,h,R,D,y,k,S,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",c=" characters skipped \u27EB",f=(P.length+c.length+5)*2;e.ISearchService=(0,S.createDecorator)("searchService");var l;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function w(F){return!!F.preview}e.resultIsMatch=w;function b(F){return!!F.resource}e.isFileMatch=b;function E(F){return!!F.message}e.isProgressMessage=E;var u;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(re){this.resource=re,this.results=[]}}e.FileMatch=g;class v{constructor(re,N,H){this.ranges=N;const J=Array.isArray(N)?N:[N];if(H&&H.matchLines===1&&t(J)){re=(0,k.getNLines)(re,H.matchLines);let K="",le=0,Ie=0;const Me=Math.floor(H.charsPerLine/5),Ve=[];for(const xe of J){const Ge=Math.max(xe.startColumn-Me,0),Ke=xe.startColumn+H.charsPerLine;if(Ge>Ie+Me+f){const qe=P+(Ge-Ie)+c;K+=qe+re.slice(Ge,Ke),le+=Ge-(Ie+qe.length)}else K+=re.slice(Ie,Ke);Ve.push(new i(0,xe.startColumn-le,xe.endColumn-le)),Ie=Ke}this.preview={text:K,matches:Array.isArray(this.ranges)?Ve:Ve[0]}}else{const K=Array.isArray(N)?N[0].startLineNumber:N.startLineNumber;this.preview={text:re,matches:(0,h.mapArrayOrNot)(N,le=>new s(le.startLineNumber-K,le.startColumn,le.endLineNumber-K,le.endColumn))}}}}e.TextSearchMatch=v;function t(F){const re=F[0].startLineNumber;for(const N of F)if(N.startLineNumber!==re||N.endLineNumber!==re)return!1;return!0}class s{constructor(re,N,H,J){this.startLineNumber=re,this.startColumn=N,this.endLineNumber=H,this.endColumn=J}}e.SearchRange=s;class i extends s{constructor(re,N,H){super(re,N,re,H)}}e.OneLineRange=i;var r;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function d(F,re=!0){const N=F&&F.files&&F.files.exclude,H=re&&F&&F.search&&F.search.exclude;if(!N&&!H)return;if(!N||!H)return N||H;let J=Object.create(null);return J=D.mixin(J,D.deepClone(N)),J=D.mixin(J,D.deepClone(H),!0),J}e.getExcludes=d;function m(F,re){return F.excludePattern&&R.match(F.excludePattern,re)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&R.match(F.includePattern,re)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(N=>{const H=N.folder.fsPath;if(y.isEqualOrParent(re,H)){const J=_.relative(H,re);return!N.includePattern||!!R.match(N.includePattern,J)}else return!1}):!1:!0}e.pathIncludedInQuery=m;var p;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class I extends Error{constructor(re,N){super(re);this.code=N}}e.SearchError=I;function A(F){const re=F.message;if((0,C.isPromiseCanceledError)(F))return new I(re,p.canceled);try{const N=JSON.parse(re);return new I(N.message,N.code)}catch(N){return new I(re,p.other)}}e.deserializeSearchError=A;function a(F){const re={message:F.message,code:F.code};return new Error(JSON.stringify(re))}e.serializeSearchError=a;function T(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=T;function M(F){return F.type==="success"}e.isSerializedSearchSuccess=M;function W(F){return!!F.path}e.isSerializedFileMatch=W;function B(F,re){const N=F.searchPath?F.searchPath:F.relativePath;return(0,k.fuzzyContains)(N,re)}e.isFilePatternMatch=B;class Z{constructor(re){this.path=re,this.results=[]}addMatch(re){this.results.push(re)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=Z;function q(F,re){const N={...F||{},...re||{}};return Object.keys(N).filter(H=>{const J=N[H];return typeof J=="boolean"&&J})}e.resolvePatternsForProvider=q;class ${constructor(re,N){this._parsedIncludeExpression=null,this._excludeExpression={...re.excludePattern||{},...N.excludePattern||{}},this._parsedExcludeExpression=R.parse(this._excludeExpression);let H=re.includePattern;N.includePattern&&(H?H={...H,...N.includePattern}:H=N.includePattern),H&&(this._parsedIncludeExpression=R.parse(H))}includedInQuerySync(re,N,H){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(re,N,H)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(re,N,H))}includedInQuery(re,N,H){return Promise.resolve(this._parsedExcludeExpression(re,N,H)).then(K=>!!K).then(K=>K?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(re,N,H)).then(le=>!!le):Promise.resolve(!0)).then(K=>K)}hasSiblingExcludeClauses(){return V(this._excludeExpression)}}e.QueryGlobTester=$;function V(F){for(const re in F)if(typeof F[re]!="boolean")return!0;return!1}}),define(Ee[32],_e([0,1,17,16,18,3,22,11,78,25,8,10,2,135,4,15,149,44,45,28,13,6,38,5]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f,l,o,w,b,E,u,g,v,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(T,M,W){return new C.ExtUri(B=>p(B,W)).isEqual(T,M)}function r(T,M,W){return i(T.uri,M.uri,W)?0:(0,n.compare)(T.uri.toString(),M.uri.toString())}function d(T,M,W){return T.index!==M.index?T.index<M.index?-1:1:i(T.uri,M.uri,W)?(0,n.compare)(T.name,M.name):(0,n.compare)(T.uri.toString(),M.uri.toString())}function m(T,M,W,B){const Z=T.slice(0).sort(($,V)=>W($,V,B)),q=M.slice(0).sort(($,V)=>W($,V,B));return(0,h.delta)(Z,q,($,V)=>W($,V,B))}function p(T,M){const W=M.getCapabilities(T.scheme);return!(W&&W&1024)}class I extends b.Workspace{constructor(M,W,B,Z,q,$){super(M,B.map(V=>new b.WorkspaceFolder(V)),Z,$);this._name=W,this._isUntitled=q,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris($),B.forEach(V=>{this._workspaceFolders.push(V),this._structure.set(V.uri,V)})}static toExtHostWorkspace(M,W,B,Z){if(!M)return{workspace:null,added:[],removed:[]};const{id:q,name:$,folders:V,configuration:F,isUntitled:re}=M,N=[],H=W;W?V.forEach((Ie,Me)=>{const Ve=c.URI.revive(Ie.uri),xe=I._findFolder(B||W,Ve,Z);xe?(xe.name=Ie.name,xe.index=Ie.index,N.push(xe)):N.push({uri:Ve,name:Ie.name,index:Me})}):N.push(...V.map(({uri:Ie,name:Me,index:Ve})=>({uri:c.URI.revive(Ie),name:Me,index:Ve}))),N.sort((Ie,Me)=>Ie.index<Me.index?-1:1);const J=new I(q,$,N,F?c.URI.revive(F):null,!!re,Ie=>p(Ie,Z)),{added:K,removed:le}=m(H?H.workspaceFolders:[],J.workspaceFolders,r,Z);return{workspace:J,added:K,removed:le}}static _findFolder(M,W,B){for(let Z=0;Z<M.folders.length;Z++){const q=M.workspaceFolders[Z];if(i(q.uri,W,B))return q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(M,W){return W&&this._structure.get(M)&&(M=(0,C.dirname)(M)),this._structure.findSubstr(M)}resolveWorkspaceFolder(M){return this._structure.get(M)}}let A=class{constructor(M,W,B,Z){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=Z,this._extHostFileSystemInfo=B,this._requestIdProvider=new _.Counter,this._barrier=new R.Barrier,this._proxy=M.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=M.getProxy(s.MainContext.MainThreadMessageService);const q=W.workspace;this._confirmedWorkspace=q?new I(q.id,q.name,[],q.configuration?c.URI.revive(q.configuration):null,!!q.isUntitled,$=>p($,B)):void 0}$initializeWorkspace(M,W){this._trusted=W,this.$acceptWorkspaceData(M),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:S.Schemas.untitled,path:(0,C.basename)((0,C.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(M,W,B,...Z){const q=[];if(Array.isArray(Z)&&Z.forEach(N=>{c.URI.isUri(N.uri)&&!q.some(H=>i(H.uri,N.uri,this._extHostFileSystemInfo))&&q.push({uri:N.uri,name:N.name||(0,C.basenameOrAuthority)(N.uri)})}),this._unconfirmedWorkspace||[W,B].some(N=>typeof N!="number"||N<0)||B===0&&q.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(W+B>$.length)return!1;const V=$.slice(0);V.splice(W,B,...q.map(N=>({uri:N.uri,name:N.name||(0,C.basenameOrAuthority)(N.uri),index:void 0})));for(let N=0;N<V.length;N++){const H=V[N];if(V.some((J,K)=>K!==N&&i(H.uri,J.uri,this._extHostFileSystemInfo)))return!1}V.forEach((N,H)=>N.index=H);const{added:F,removed:re}=m($,V,d,this._extHostFileSystemInfo);if(F.length===0&&re.length===0)return!1;if(this._proxy){const N=M.displayName||M.name;this._proxy.$updateWorkspaceFolders(N,W,B,q).then(void 0,H=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(w.Severity.Error,(0,f.localize)(0,null,N,H.toString()),{extension:M},[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(M,W){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,W)}async getWorkspaceFolder2(M,W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,W)}async resolveWorkspaceFolder(M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(M)}getPath(){if(!this._actualWorkspace)return;const{folders:M}=this._actualWorkspace;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,W){let B,Z="";if(typeof M=="string"?(B=c.URI.file(M),Z=M):typeof M!="undefined"&&(B=M,Z=M.fsPath),!B)return Z;const q=this.getWorkspaceFolder(B,!0);if(!q)return Z;typeof W=="undefined"&&this._actualWorkspace&&(W=this._actualWorkspace.folders.length>1);let $=(0,C.relativePath)(q.uri,B);return W&&q.name&&($=`${q.name}/${$}`),$}trySetWorkspaceFolders(M){this._actualWorkspace&&(this._unconfirmedWorkspace=I.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:M,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:W,added:B,removed:Z}=I.toExtHostWorkspace(M,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=W||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:Z}))}findFiles(M,W,B,Z,q=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${Z.value}, entryPoint: findFiles`);let $;if(W===null?$=!1:W&&(typeof W=="string"?$=W:$=W.pattern),q&&q.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:F}=a(M);return this._proxy.$startFileSearch((0,P.withUndefinedAsNull)(V),(0,P.withUndefinedAsNull)(F),(0,P.withUndefinedAsNull)($),(0,P.withUndefinedAsNull)(B),q).then(re=>Array.isArray(re)?re.map(N=>c.URI.revive(N)):[])}async findTextInFiles(M,W,B,Z,q=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${Z.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),V=typeof W.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:F,folder:re}=a(W.include),N=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,H={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:V,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:F,excludePattern:N},J=!1;if(this._activeSearchCallbacks[$]=K=>{if(J)return;const le=c.URI.revive(K.resource);K.results.forEach(Ie=>{(0,t.resultIsMatch)(Ie)?B({uri:le,preview:{text:Ie.preview.text,matches:(0,h.mapArrayOrNot)(Ie.preview.matches,Me=>new v.Range(Me.startLineNumber,Me.startColumn,Me.endLineNumber,Me.endColumn))},ranges:(0,h.mapArrayOrNot)(Ie.ranges,Me=>new v.Range(Me.startLineNumber,Me.startColumn,Me.endLineNumber,Me.endColumn))}):B({uri:le,text:Ie.text,lineNumber:Ie.lineNumber})})},q.isCancellationRequested)return{};try{const K=await this._proxy.$startTextSearch(M,(0,P.withUndefinedAsNull)(re),H,$,q);return delete this._activeSearchCallbacks[$],K||{}}catch(K){throw delete this._activeSearchCallbacks[$],K}}$handleTextSearchResult(M,W){this._activeSearchCallbacks[W]&&this._activeSearchCallbacks[W](M)}saveAll(M){return this._proxy.$saveAll(M)}resolveProxy(M){return this._proxy.$resolveProxy(M)}get trusted(){return this._trusted}requestWorkspaceTrust(M){return this._proxy.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};A=He([ze(0,g.IExtHostRpcService),ze(1,u.IExtHostInitDataService),ze(2,E.IExtHostFileSystemInfo),ze(3,o.ILogService)],A),e.ExtHostWorkspace=A,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function a(T){let M,W;return T&&(typeof T=="string"?M=T:(M=T.pattern,W=T.baseFolder||c.URI.file(T.base))),{includePattern:M,folder:W}}}),define(Ee[33],_e([0,1,24,3,32,5,6,153,62,10,16,4,13,15,2]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function o(s,i){if(i){const r=i.split(".");let d=s;for(let m=0;d&&m<r.length;m++)d=d[r[m]];return d}}function w(s){return s instanceof l.URI}function b(s){return s&&s.uri instanceof l.URI&&s.languageId&&typeof s.languageId=="string"}function E(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function u(s){return s&&s.uri instanceof l.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function g(s){if(w(s))return{resource:s};if(b(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(E(s))return{overrideIdentifier:s.languageId};if(u(s))return{resource:s.uri};if(s===null)return{resource:null}}let v=class{constructor(i,r,d){this._proxy=i.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=d,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new t(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,r){this.getConfigProvider().then(d=>d.$acceptConfigurationChanged(i,r))}};v=He([ze(0,c.IExtHostRpcService),ze(1,D.IExtHostWorkspace),ze(2,f.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(i,r,d,m){this._onDidChangeConfiguration=new R.Emitter,this._proxy=i,this._logService=m,this._extHostWorkspace=r,this._configuration=S.Configuration.parse(d),this._configurationScopes=this._toMap(d.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,r){const d={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=S.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,d))}getConfiguration(i,r,d){const m=g(r)||{},p=this._toReadonlyValue(i?o(this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,m,d?.identifier);function I(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case k.ConfigurationTarget.Global:return 1;case k.ConfigurationTarget.Workspace:return 4;case k.ConfigurationTarget.WorkspaceFolder:return 5}}const A={has(a){return typeof o(p,a)!="undefined"},get:(a,T)=>{this._validateConfigurationAccess(i?`${i}.${a}`:a,m,d?.identifier);let M=o(p,a);if(typeof M=="undefined")M=T;else{let W;const B=(Z,q)=>{let $;const V=()=>{W=W||(0,h.deepClone)(p),$=$||o(W,q)};return(0,C.isObject)(Z)?new Proxy(Z,{get:(F,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return V(),()=>$;if(W)return $=$||o(W,q),$[re];const N=F[re];return typeof re=="string"?B(N,`${q}.${re}`):N},set:(F,re,N)=>(V(),$&&($[re]=N),!0),deleteProperty:(F,re)=>(V(),$&&delete $[re],!0),defineProperty:(F,re,N)=>(V(),$&&Object.defineProperty($,re,N),!0)}):Z};M=B(M,a)}return M},update:(a,T,M,W)=>{a=i?`${i}.${a}`:a;const B=I(M);return T!==void 0?this._proxy.$updateConfigurationOption(B,a,T,m,W):this._proxy.$removeConfigurationOption(B,a,m,W)},inspect:a=>{a=i?`${i}.${a}`:a;const T=(0,h.deepClone)(this._configuration.inspect(a,m,this._extHostWorkspace.workspace));if(T)return{key:a,defaultValue:T.default?.value,globalValue:T.user?.value,workspaceValue:T.workspace?.value,workspaceFolderValue:T.workspaceFolder?.value,defaultLanguageValue:T.default?.override,globalLanguageValue:T.user?.override,workspaceLanguageValue:T.workspace?.override,workspaceFolderLanguageValue:T.workspaceFolder?.override,languageIds:T.overrideIdentifiers}}};return typeof p=="object"&&(0,h.mixin)(A,p,!1),Object.freeze(A)}_toReadonlyValue(i){const r=d=>(0,C.isObject)(d)?new Proxy(d,{get:(m,p)=>r(m[p]),set:(m,p,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(m,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(m,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):d;return r(i)}_validateConfigurationAccess(i,r,d){const m=_.OVERRIDE_PROPERTY_PATTERN.test(i)?4:this._configurationScopes.get(i),p=d?`[${d.value}] `:"";if(m===4){typeof r?.resource=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){r?.resource&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,r){const d=new S.ConfigurationChangeEvent(i,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(m,p)=>d.affectsConfiguration(m,g(p))})}_toMap(i){return i.reduce((r,d)=>(r.set(d[0],d[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(te,e,h,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(te,h):D?D.value=h:e.set(te,h),h},Ne=this&&this.__classPrivateFieldGet||function(te,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(te):R?R.value:e.get(te)};define(Ee[105],_e([0,1,2,16,3,5,6,32,46,33,18,37,13,28,4,11,21,15,70,168,12]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f,l,o,w,b,E,u,g){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(Z){function q(V){if(V!=null)return V}Z.from=q;function $(V){if(V!=null)return V}Z.to=$})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var s;(function(Z){function q(V){if(V!=null)return V}Z.from=q;function $(V){if(V!=null)return V}Z.to=$})(s=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(Z){function q(V){if(V!=null)return V}Z.from=q;function $(V){if(V!=null)return V}Z.to=$})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(Z){function q(F){if(F){const re=F;return re&&!!re.process}else return!1}Z.is=q;function $(F){if(F==null)return;const re={process:F.process,args:F.args};return F.options&&(re.options=i.from(F.options)),re}Z.from=$;function V(F){if(F!=null)return new k.ProcessExecution(F.process,F.args,F.options)}Z.to=V})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var d;(function(Z){function q(V){if(V!=null)return V}Z.from=q;function $(V){if(V!=null)return V}Z.to=$})(d=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var m;(function(Z){function q(F){if(F){const re=F;return re&&(!!re.commandLine||!!re.command)}else return!1}Z.is=q;function $(F){if(F==null)return;const re={};return F.commandLine!==void 0?re.commandLine=F.commandLine:(re.command=F.command,re.args=F.args),F.options&&(re.options=d.from(F.options)),re}Z.from=$;function V(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new k.ShellExecution(F.commandLine,F.options):new k.ShellExecution(F.command,F.args?F.args:[],F.options)}Z.to=V})(m=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(Z){function q(F){if(F){let re=F;return re&&re.customExecution==="customExecution"}else return!1}Z.is=q;function $(F){return{customExecution:"customExecution"}}Z.from=$;function V(F,re){return re.get(F)}Z.to=V})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var I;(function(Z){function q($,V){let F;return $.scope!==void 0&&typeof $.scope!="number"?F=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===k.TaskScope.Workspace&&V&&V.workspaceFile?F=V.workspaceFile:F=u.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:F}}Z.from=q})(I=e.TaskHandleDTO||(e.TaskHandleDTO={}));var A;(function(Z){function q(F,re){if(F==null)return[];const N=[];for(let H of F){const J=$(H,re);J&&N.push(J)}return N}Z.fromMany=q;function $(F,re){if(F==null)return;let N;F.execution instanceof k.ProcessExecution?N=r.from(F.execution):F.execution instanceof k.ShellExecution?N=m.from(F.execution):F.execution&&F.execution instanceof k.CustomExecution&&(N=p.from(F.execution));const H=t.from(F.definition);let J;if(F.scope?typeof F.scope=="number"?J=F.scope:J=F.scope.uri:J=k.TaskScope.Workspace,!H||!J)return;const K=F.group?F.group.id:void 0;return{_id:F._id,definition:H,name:F.name,source:{extensionId:re.identifier.value,label:F.source,scope:J},execution:N,isBackground:F.isBackground,group:K,presentationOptions:s.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}Z.from=$;async function V(F,re,N){if(F==null)return;let H;r.is(F.execution)?H=r.to(F.execution):m.is(F.execution)?H=m.to(F.execution):p.is(F.execution)&&(H=p.to(F._id,N));const J=t.to(F.definition);let K;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?K=F.source.scope:K=await re.resolveWorkspaceFolder(h.URI.revive(F.source.scope)):K=k.TaskScope.Workspace),!J||!K)return;const le=new k.Task(J,K,F.name,F.source.label,H,F.problemMatchers);return F.isBackground!==void 0&&(le.isBackground=F.isBackground),F.group!==void 0&&(le.group=k.TaskGroup.from(F.group)),F.presentationOptions&&(le.presentationOptions=s.to(F.presentationOptions)),F._id&&(le._id=F._id),F.detail&&(le.detail=F.detail),le}Z.to=V})(A=e.TaskDTO||(e.TaskDTO={}));var a;(function(Z){function q(V){return V}Z.from=q;function $(V){if(!!V)return Object.assign(Object.create(null),V)}Z.to=$})(a=e.TaskFilterDTO||(e.TaskFilterDTO={}));class T{constructor(q,$,V){this._id=$,this._task=V,v.set(this,void 0),it(this,v,q,"f")}get task(){return this._task}terminate(){Ne(this,v,"f").terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}v=new WeakMap;var M;(function(Z){function q($){return{id:$._id,task:void 0}}Z.from=q})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let W=class{constructor(q,$,V,F,re,N,H,J){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=q.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=V,this._editorService=F,this._configurationService=re,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=H,this._deprecationService=J,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(q,$,V){if(!V)return new k.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:$,provider:V,extension:q}),this._proxy.$registerTaskProvider(F,$),new k.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(q,$){this._proxy.$registerTaskSystem(q,$)}fetchTasks(q){return this._proxy.$fetchTasks(a.from(q)).then(async $=>{const V=[];for(let F of $){const re=await A.to(F,this._workspaceProvider,this._providedCustomExecutions2);re&&V.push(re)}return V})}get taskExecutions(){const q=[];return this._taskExecutions.forEach($=>q.push($)),q}terminateTask(q){if(!(q instanceof T))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(q,$,V){const F=this._providedCustomExecutions2.get(q.id);if(F){if(this._activeCustomExecutions2.get(q.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(q.id,F),this._terminalService.attachPtyToTerminal($,await F.callback(V))}this._lastStartedTask=q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(q){const $=await this.getTaskExecution(q);this._taskExecutionPromises.delete(q.id),this._taskExecutions.delete(q.id),this.customExecutionComplete(q),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(q){const $=await this.getTaskExecution(q.id);this._onDidTaskProcessStarted.fire({execution:$,processId:q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(q){const $=await this.getTaskExecution(q.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:q.exitCode})}$provideTasks(q,$){const V=this._handlers.get(q);if(!V)return Promise.reject(new Error("no handler found"));const F=[],re=(0,R.asPromise)(()=>V.provider.provideTasks(n.CancellationToken.None)).then(N=>this.provideTasksInternal($,F,V,N));return new Promise(N=>{re.then(H=>{Promise.all(F).then(()=>{N(H)})})})}async $resolveTask(q,$){const V=this._handlers.get(q);if(!V)return Promise.reject(new Error("no handler found"));if($.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${V.type}].`);const F=await A.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const re=await V.provider.resolveTask(F,n.CancellationToken.None);if(!re)return;this.checkDeprecation(re,V);const N=A.from(re,V.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(re.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(N.execution)&&await this.addCustomExecution(N,re,!0),await this.resolveTaskInternal(N)}nextHandle(){return this._handleCounter++}async addCustomExecution(q,$,V){const F=await this._proxy.$createTaskId(q);!V&&!this._providedCustomExecutions2.has(F)&&this._notProvidedCustomExecutions.add(F),this._providedCustomExecutions2.set(F,$.execution)}async getTaskExecution(q,$){if(typeof q=="string"){const re=this._taskExecutionPromises.get(q);if(!re)throw new Error("Unexpected: The specified task is missing an execution");return re}let V=this._taskExecutionPromises.get(q.id);if(V)return V;const F=new Promise(async(re,N)=>{const H=$||await A.to(q.task,this._workspaceProvider,this._providedCustomExecutions2);H?re(new T(this,q.id,H)):N("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(q.id,F),F.then(re=>(this._taskExecutions.set(q.id,re),re),re=>Promise.reject(re))}checkDeprecation(q,$){q._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(q){this._activeCustomExecutions2.get(q.id)&&this._activeCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.has(q.id)&&this._lastStartedTask!==q.id&&(this._providedCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.delete(q.id));let V=this._notProvidedCustomExecutions.values(),F=V.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=V.next()}};W=He([ze(0,c.IExtHostRpcService),ze(1,f.IExtHostInitDataService),ze(2,S.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,C.IExtHostConfiguration),ze(5,P.IExtHostTerminalService),ze(6,b.ILogService),ze(7,E.IExtHostApiDeprecationService)],W),e.ExtHostTaskBase=W;let B=class extends W{constructor(q,$,V,F,re,N,H,J){super(q,$,V,F,re,N,H,J);this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(q,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const V=A.from($,q);if(V===void 0)throw new Error("Task is not valid");if(p.is(V.execution))await this.addCustomExecution(V,$,!1);else throw new g.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(V),$);return this._proxy.$executeTask(V).catch(re=>{throw new Error(re)}),F}provideTasksInternal(q,$,V,F){const re=[];if(F)for(let N of F){this.checkDeprecation(N,V),(!N.definition||!q[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const H=A.from(N,V.extension);H&&p.is(H.execution)?(re.push(H),$.push(this.addCustomExecution(H,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:re,extension:V.extension}}async resolveTaskInternal(q){if(p.is(q.execution))return q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(q,$){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,$,V){}};B=He([ze(0,c.IExtHostRpcService),ze(1,f.IExtHostInitDataService),ze(2,S.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,C.IExtHostConfiguration),ze(5,P.IExtHostTerminalService),ze(6,b.ILogService),ze(7,E.IExtHostApiDeprecationService)],B),e.WorkerExtHostTask=B,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")}),define(Ee[217],_e([0,1,17,76,27,81,22,11,14,25,8,10,2,117,138,90,44,97,216,38]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f,l,o,w,b,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(I,A,a,T){this.configurationService=I,this.workspaceContextService=A,this.editorGroupsService=a,this.pathService=T}text(I,A,a={}){I=this.getContentPattern(I,a);const T=this.configurationService.getValue(),M=A&&A.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(A?.map(w.toWorkspaceFolder),a),type:2,contentPattern:I,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:T.search.usePCRE2||M||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles}}getContentPattern(I,A){const a=this.configurationService.getValue();I.isRegExp&&(I.pattern=I.pattern.replace(/\r?\n/g,"\\n"));const T={...I,wordSeparators:a.editor.wordSeparators};return this.isCaseSensitive(I,A)&&(T.isCaseSensitive=!0),this.isMultiline(I)&&(T.isMultiline=!0),T}file(I,A={}){return{...this.commonQuery(I,A),type:1,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey}}handleIncludeExclude(I,A){return I?(I=Array.isArray(I)?I.map(r):r(I),A?this.parseSearchPaths(I):{pattern:t(...Array.isArray(I)?I:[I])}):{}}commonQuery(I=[],A={}){const a=this.handleIncludeExclude(A.includePattern,A.expandPatterns),T=this.handleIncludeExclude(A.excludePattern,A.expandPatterns),M=I.length>1,W=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(q=>this.getFolderQueryForSearchPath(q,A,T)):I.map(q=>this.getFolderQueryForRoot(q,A,T,M))).filter(q=>!!q),B={_reason:A._reason,folderQueries:W,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:T.pattern,includePattern:a.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults};if(A.onlyOpenEditors){const $=h.coalesce(h.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(re=>re.resource)))).filter(F=>(0,u.pathIncludedInQuery)(B,F.fsPath)),V=this.commonQueryFromFileList($);return{...B,...V}}const Z=A.extraFileResources&&A.extraFileResources.filter(q=>(0,u.pathIncludedInQuery)(B,q.fsPath));return B.extraFileResources=Z&&Z.length?Z:void 0,B}commonQueryFromFileList(I){const A=[],a=new k.ResourceMap,T={};let M=!1;return I.forEach(W=>{if(W.scheme===S.Schemas.walkThrough)return;if((0,C.isAbsolutePath)(W)){const Z=this.workspaceContextService.getWorkspaceFolder(W)?.uri??W.with({path:_.dirname(W.fsPath)});let q=a.get(Z);q||(M=!0,q={folder:Z,includePattern:{}},A.push(q),a.set(Z,q));const $=_.relative(Z.fsPath,W.fsPath);(0,P.assertIsDefined)(q.includePattern)[$.replace(/\\/g,"/")]=!0}else W.fsPath&&(M=!0,T[W.fsPath]=!0)}),{folderQueries:A,includePattern:T,usingSearchPaths:!0,excludePattern:M?void 0:{"**/*":!0}}}isCaseSensitive(I,A){if(A.isSmartCase){if(I.isRegExp){if(n.containsUppercaseCharacter(I.pattern,!0))return!0}else if(n.containsUppercaseCharacter(I.pattern))return!0}return!!I.isCaseSensitive}isMultiline(I){return I.isMultiline||I.isRegExp&&(0,f.isMultilineRegexSource)(I.pattern)||I.pattern.indexOf(`
`)>=0?!0:!!I.isMultiline}parseSearchPaths(I){const A=V=>_.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),T=(Array.isArray(I)?I:s(I)).map(V=>{const F=this.pathService.resolvedUserHome;return F?(0,y.untildify)(V,F.scheme===S.Schemas.file?F.fsPath:F.path):V}),M=R.groupBy(T,V=>A(V)?"searchPaths":"exprSegments"),W=(M.exprSegments||[]).map(V=>n.rtrim(V,"/")).map(V=>n.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),i(V))),B={},Z=this.expandSearchPathPatterns(M.searchPaths||[]);Z&&Z.length&&(B.searchPaths=Z);const q=h.flatten(W),$=t(...q);return $&&(B.pattern=$),B}getExcludesForFolder(I,A){return A.disregardExcludeSettings?void 0:(0,u.getExcludes)(I,!A.disregardSearchExcludeSettings)}expandSearchPathPatterns(I){if(!I||!I.length)return[];const A=h.flatten(I.map(T=>{let{pathPortion:M,globPortion:W}=v(T);W&&(W=d(W));const B=this.expandOneSearchPath(M);return h.flatten(B.map(Z=>this.resolveOneSearchPathPattern(Z,W)))})),a=new Map;return A.forEach(T=>{const M=T.searchPath.toString(),W=a.get(M);W?T.pattern&&(W.pattern=W.pattern||{},W.pattern[T.pattern]=!0):a.set(M,{searchPath:T.searchPath,pattern:T.pattern?t(T.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(I){if(_.isAbsolute(I)){const A=this.workspaceContextService.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==S.Schemas.file?[{searchPath:A[0].uri.with({path:I})}]:[{searchPath:c.URI.file(_.normalize(I))}]}if(this.workspaceContextService.getWorkbenchState()===2){const A=this.workspaceContextService.getWorkspace().folders[0].uri;if(I=r(I),I.startsWith("../")||I===".."){const T=_.posix.resolve(A.path,I);return[{searchPath:A.with({path:T})}]}const a=d(I);return[{searchPath:A,pattern:a}]}else{if(I==="./"||I===".\\")return[];{const A=I.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map(M=>{const W=A.match(new RegExp(`^${n.escapeRegExpCharacters(M.name)}(?:/(.*)|$)`));return W?{match:W,folder:M}:null}).filter(P.isDefined);if(T.length)return T.map(M=>{const W=M.match[1];return{searchPath:M.folder.uri,pattern:W&&d(W)}});{const M=I.match(/\.[\/\\](.+)[\/\\]?/),W=M?M[1]:I,B=l.localize(0,null,W);throw new Error(B)}}}}resolveOneSearchPathPattern(I,A){const a=I.pattern&&A?`${I.pattern}/${A}`:I.pattern||A,T=[{searchPath:I.searchPath,pattern:a}];return a&&!a.endsWith("**")&&T.push({searchPath:I.searchPath,pattern:a+"/**"}),T}getFolderQueryForSearchPath(I,A,a){const T=this.getFolderQueryForRoot((0,w.toWorkspaceFolder)(I.searchPath),A,a,!1);return T?{...T,includePattern:I.pattern}:null}getFolderQueryForRoot(I,A,a,T){let M;const W=c.URI.isUri(I)?I:I.uri;if(a.searchPaths){const V=a.searchPaths.filter(F=>(0,C.isEqual)(F.searchPath,W))[0];if(V&&!V.pattern)return null;V&&(M=V.pattern)}const B=this.configurationService.getValue({resource:W}),q={...this.getExcludesForFolder(B,A)||{},...M||{}},$=c.URI.isUri(I)?(0,C.basename)(I):I.name;return{folder:W,folderName:T?$:void 0,excludePattern:Object.keys(q).length>0?q:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!B.search.followSymlinks}}};g=He([ze(0,o.IConfigurationService),ze(1,w.IWorkspaceContextService),ze(2,b.IEditorGroupsService),ze(3,E.IPathService)],g),e.QueryBuilder=g;function v(p){const I=p.match(/[\*\{\}\(\)\[\]\?]/);if(I){const A=I.index,a=p.substr(0,A).match(/[/|\\][^/\\]*$/);if(a){let T=p.substr(0,a.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:p.substr((a.index||0)+1)}}}return{pathPortion:p}}function t(...p){return p.length?p.reduce((I,A)=>(I[A]=!0,I),Object.create(null)):void 0}function s(p){return D.splitGlobAware(p,",").map(I=>I.trim()).filter(I=>!!I.length)}function i(p){return[`**/${p}/**`,`**/${p}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function r(p){return p.replace(/\\/g,"/")}function d(p){return r(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function m(p,I){p=h.distinct(p,T=>T.toString());const A=[],a=I.getWorkspace();return p&&p.forEach(T=>{let M;if(I.getWorkbenchState()===2)M=(0,C.relativePath)(a.folders[0].uri,T),M&&M!=="."&&(M="./"+M);else{const W=I.getWorkspaceFolder(T);if(W){const B=W.name;if(a.folders.filter(q=>q.name===B).length===1){const q=(0,C.relativePath)(W.uri,T);q===""?M=`./${W.name}`:M=`./${W.name}/${q}`}else M=T.fsPath}}M&&A.push(M)}),A}e.resolveResourcesForSearchIncludes=m}),define(Ee[218],_e([0,1,25,2,18,12,4,217,38,44]),function(te,e,h,R,D,y,k,S,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function P(o,w){const b=w.activationEvents;if(!b)return Promise.resolve(void 0);const E=[],u=[];for(const r of b)if(/^workspaceContains:/.test(r)){const d=r.substr("workspaceContains:".length);d.indexOf("*")>=0||d.indexOf("?")>=0||o.forceUsingSearch?u.push(d):E.push(d)}if(E.length===0&&u.length===0)return Promise.resolve(void 0);let g;const v=new Promise((r,d)=>{g=r}),t=r=>g({activationEvent:r}),s=Promise.all(E.map(r=>c(o,r,t))).then(()=>{}),i=f(o,w.identifier,u,t);return Promise.all([s,i]).then(()=>{g(void 0)}),v}e.checkActivateWorkspaceContainsExtension=P;async function c(o,w,b){for(const E of o.folders)if(await o.exists(h.joinPath(R.URI.revive(E),w))){b(`workspaceContains:${w}`);return}}async function f(o,w,b,E){if(b.length===0)return Promise.resolve(void 0);const u=new D.CancellationTokenSource,g=o.checkExists(o.folders,b,u.token),v=setTimeout(async()=>{u.cancel(),E(`workspaceContainsTimeout:${b.join(",")}`)},n);let t=!1;try{t=await g}catch(s){y.isPromiseCanceledError(s)||y.onUnexpectedError(s)}u.dispose(),clearTimeout(v),t&&E(`workspaceContains:${b.join(",")}`)}function l(o,w,b,E){const u=o.get(k.IInstantiationService),g=o.get(_.ISearchService),t=u.createInstance(S.QueryBuilder).file(w.map(s=>(0,C.toWorkspaceFolder)(R.URI.revive(s))),{_reason:"checkExists",includePattern:b,exists:!0});return g.fileSearch(t,E).then(s=>!!s.limitHit,s=>y.isPromiseCanceledError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=l});var it=this&&this.__classPrivateFieldSet||function(te,e,h,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(te,h):D?D.value=h:e.set(te,h),h},Ne=this&&this.__classPrivateFieldGet||function(te,e,h,R){if(h==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!R:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?R:h==="a"?R.call(te):R?R.value:e.get(te)};define(Ee[34],_e([0,1,130,14,75,25,16,7,22,2,15,5,33,181,73,32,29,179,12,26,23,158,6,91,4,28,74,13,61,65,37,3,218,69,160]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f,l,o,w,b,E,u,g,v,t,s,i,r,d,m,p,I,A,a,T,M,W){"use strict";var B,Z,q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let $=class Vn extends S.Disposable{constructor(N,H,J,K,le,Ie,Me,Ve,xe,Ge){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=H,this._extHostContext=J,this._initData=Me,this._extHostWorkspace=K,this._extHostConfiguration=le,this._logService=Ie,this._extHostTunnelService=xe,this._extHostTerminalService=Ge,this._disposables=new S.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._registry=new b.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new M.ExtHostSecretState(this._extHostContext),this._storagePath=Ve,this._instaService=N.createChild(new p.ServiceCollection([l.IExtHostStorage,this._storage],[M.IExtHostSecretState,this._secretState]));const Ke=new Set;this._initData.hostExtensions.forEach(qe=>Ke.add(u.ExtensionIdentifier.toKey(qe))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(qe,U,G)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(qe,E.transformErrorForSerialization(U),G)},actualActivateExtension:async(qe,U)=>{if(Ke.has(u.ExtensionIdentifier.toKey(qe)))return await this._mainThreadExtensionsProxy.$activateExtension(qe,U),new f.HostExtension;const G=this._registry.getExtensionDescription(qe);return this._activateExtension(G,U)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(N){E.onUnexpectedError(N)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let N=[];try{N=this._registry.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this._deactivate(le))}catch(H){}await Promise.all(N)}isActivated(N){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(N):!1}_activateByEvent(N,H){return this._activator.activateByEvent(N,H)}_activateById(N,H){return this._activator.activateById(N,H)}activateByIdWithErrors(N,H){return this._activateById(N,H).then(()=>{const J=this._activator.getActivatedExtension(N);if(J.activationFailed)return Promise.reject(J.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(N=>this._registry)}getExtensionExports(N){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(N).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const N=_.TernarySearchTree.forPaths(),H=this._registry.getAllExtensionDescriptions().map(J=>{if(!!this._getEntryPoint(J))return this._hostUtils.realpath(J.extensionLocation.fsPath).then(K=>N.set(C.URI.file(K).fsPath,J))});this._extensionPathIndex=Promise.all(H).then(()=>N)}return this._extensionPathIndex}_deactivate(N){let H=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(N))return H;const J=this._activator.getActivatedExtension(N);if(!J)return H;try{typeof J.module.deactivate=="function"&&(H=Promise.resolve(J.module.deactivate()).then(void 0,K=>(this._logService.error(K),Promise.resolve(void 0))))}catch(K){this._logService.error(K)}try{(0,S.dispose)(J.subscriptions)}catch(K){this._logService.error(K)}return H}async _activateExtension(N,H){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier),this._doActivateExtension(N,H).then(J=>{const K=J.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(N.identifier,K.codeLoadingTime,K.activateCallTime,K.activateResolvedTime,H),this._logExtensionActivationTimes(N,H,"success",K),J},J=>{throw this._logExtensionActivationTimes(N,H,"failure"),J})}_logExtensionActivationTimes(N,H,J,K){const le=V(N,H);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...le,...K||{},outcome:J})}_doActivateExtension(N,H){const J=V(N,H);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",J);const K=this._getEntryPoint(N);if(!K)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${N.identifier.value} ${JSON.stringify(H)}`),this._logService.flush();const le=new f.ExtensionActivationTimesBuilder(H.startup);return Promise.all([this._loadCommonJSModule(N.identifier,(0,y.joinPath)(N.extensionLocation,K),le),this._loadExtensionContext(N)]).then(Ie=>(D.mark(`code/extHost/willActivateExtension/${N.identifier.value}`),Vn._callActivate(this._logService,N.identifier,Ie[0],Ie[1],le))).then(Ie=>(D.mark(`code/extHost/didActivateExtension/${N.identifier.value}`),Ie))}_loadExtensionContext(N){const H=new v.ExtensionGlobalMemento(N,this._storage),J=new v.ExtensionMemento(N.identifier.value,!1,this._storage),K=new W.ExtensionSecrets(N,this._secretState),le=N.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Ie=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${N.identifier.value}`),Promise.all([H.whenReady,J.whenReady,this._storagePath.whenReady]).then(()=>{const Me=this;let Ve;return Object.freeze({globalState:H,workspaceState:J,secrets:K,subscriptions:[],get extensionUri(){return N.extensionLocation},get extensionPath(){return N.extensionLocation.fsPath},asAbsolutePath(xe){return R.join(N.extensionLocation.fsPath,xe)},get storagePath(){return Me._storagePath.workspaceValue(N)?.fsPath},get globalStoragePath(){return Me._storagePath.globalValue(N).fsPath},get logPath(){return R.join(Me._initData.logsLocation.fsPath,N.identifier.value)},get logUri(){return C.URI.joinPath(Me._initData.logsLocation,N.identifier.value)},get storageUri(){return Me._storagePath.workspaceValue(N)},get globalStorageUri(){return Me._storagePath.globalValue(N)},get extensionMode(){return le},get extension(){return Ve===void 0&&(Ve=new F(Me,N.identifier,N,Ie)),Ve},get extensionRuntime(){return(0,w.checkProposedApiEnabled)(N),Me.extensionRuntime},get environmentVariableCollection(){return Me._extHostTerminalService.getEnvironmentVariableCollection(N)}})})}static _callActivate(N,H,J,K,le){return J=J||{activate:void 0,deactivate:void 0},this._callActivateOptional(N,H,J,K,le).then(Ie=>new f.ActivatedExtension(!1,null,le.build(),J,Ie,K.subscriptions))}static _callActivateOptional(N,H,J,K,le){if(typeof J.activate=="function")try{le.activateCallStart(),N.trace(`ExtensionService#_callActivateOptional ${H.value}`);const Ie=typeof global=="object"?global:self,Me=J.activate.apply(Ie,[K]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(Me).then(Ve=>(le.activateResolveStop(),Ve))}catch(Ie){return Promise.reject(Ie)}else return Promise.resolve(J)}_activateOneStartupFinished(N,H){this._activateById(N.identifier,{startup:!1,extensionId:N.identifier,activationEvent:H}).then(void 0,J=>{this._logService.error(J)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const N of this._registry.getAllExtensionDescriptions())if(N.activationEvents)for(const H of N.activationEvents)H==="onStartupFinished"&&this._activateOneStartupFinished(N,H)}_handleEagerExtensions(){const N=this._activateByEvent("*",!0).then(void 0,le=>{this._logService.error(le)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(le=>this._handleWorkspaceContainsEagerExtensions(le.added)));const H=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],J=this._handleWorkspaceContainsEagerExtensions(H),K=Promise.all([N,J]).then(()=>{});return Promise.race([K,(0,k.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),K}_handleWorkspaceContainsEagerExtensions(N){return N.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(H=>this._handleWorkspaceContainsEagerExtension(N,H))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(N,H){if(this.isActivated(H.identifier))return;const J=!this._initData.remote.isRemote&&!!this._initData.remote.authority,K={folders:N.map(Ie=>Ie.uri),forceUsingSearch:J,exists:Ie=>this._hostUtils.exists(Ie.fsPath),checkExists:(Ie,Me,Ve)=>this._mainThreadWorkspaceProxy.$checkExists(Ie,Me,Ve)},le=await(0,T.checkActivateWorkspaceContainsExtension)(K,H);if(!!le)return this._activateById(H.identifier,{startup:!0,extensionId:H.identifier,activationEvent:le.activationEvent}).then(void 0,Ie=>this._logService.error(Ie))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(N){throw console.error(N),N}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:N,extensionTestsLocationURI:H}=this._initData.environment;if(!N||!H)throw new Error(h.localize(0,null));const J=await this._loadCommonJSModule(null,H,new f.ExtensionActivationTimesBuilder(!1));if(!J||typeof J.run!="function")throw new Error(h.localize(1,null,H.toString()));return new Promise((K,le)=>{const Ie=(xe,Ge)=>{xe?le(xe):K(typeof Ge=="number"&&Ge>0?1:0)},Me=(0,y.originalFSPath)(H),Ve=J.run(Me,Ie);Ve&&Ve.then&&Ve.then(()=>{K(0)}).catch(xe=>{le(xe.toString())})})}async $extensionTestsExit(N){this._logService.info(`extension host terminating: test runner requested exit with code ${N}`),this._logService.info(`exiting with code ${N}`),this._logService.flush(),this._hostUtils.exit(N)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(N,H){return this._resolvers[N]=H,(0,S.toDisposable)(()=>{delete this._resolvers[N]})}async _activateAndGetResolver(N){const H=N.indexOf("+");if(H===-1)throw new Error("Not an authority that can be resolved!");const J=N.substr(0,H);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${J}`,!1),{authorityPrefix:J,resolver:this._resolvers[J]}}async $resolveAuthority(N,H){const{authorityPrefix:J,resolver:K}=await this._activateAndGetResolver(N);if(!K)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${J}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(K)),D.mark(`code/extHost/willResolveAuthority/${J}`);const le=await K.resolve(N,{resolveAttempt:H});D.mark(`code/extHost/didResolveAuthorityOK/${J}`);const Ie={authority:N,host:le.host,port:le.port,connectionToken:le.connectionToken},Me={extensionHostEnv:le.extensionHostEnv,isTrusted:le.isTrusted};return{type:"ok",value:{authority:Ie,options:Me,tunnelInformation:{environmentTunnels:le.environmentTunnels}}}}catch(le){if(D.mark(`code/extHost/didResolveAuthorityError/${J}`),le instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}async $getCanonicalURI(N,H){const{authorityPrefix:J,resolver:K}=await this._activateAndGetResolver(N);if(!K)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${J}`);const le=C.URI.revive(H);if(typeof K.getCanonicalURI=="undefined")return le;const Ie=await(0,k.asPromise)(()=>K.getCanonicalURI(le));return Ie||le}$startExtensionHost(N){return this._registry.keepOnly(N),this._startExtensionHost()}$activateByEvent(N,H){return H===1?this._activateByEvent(N,!1):this._readyToRunExtensions.wait().then(J=>this._activateByEvent(N,!1))}async $activate(N,H){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(N)?(await this._activateById(N,H),!0):!1}async $deltaExtensions(N,H){N.forEach(K=>K.extensionLocation=C.URI.revive(K.extensionLocation));const J=await this.getExtensionPathIndex();return await Promise.all(H.map(async K=>{const le=this._registry.getExtensionDescription(K);if(!le)return;const Ie=await this._hostUtils.realpath(le.extensionLocation.fsPath);J.delete(C.URI.file(Ie).fsPath)})),await Promise.all(N.map(async K=>{const le=await this._hostUtils.realpath(K.extensionLocation.fsPath);J.set(C.URI.file(le).fsPath,K)})),this._registry.deltaExtensions(N,H),Promise.resolve(void 0)}async $test_latency(N){return N}async $test_up(N){return N.byteLength}async $test_down(N){let H=g.VSBuffer.alloc(N),J=Math.random()%256;for(let K=0;K<N;K++)H.writeUInt8(J,K);return H}async $updateRemoteConnectionData(N){this._remoteConnectionData=N,this._onDidChangeRemoteConnectionData.fire()}};$=He([ze(0,i.IInstantiationService),ze(1,e.IHostUtils),ze(2,m.IExtHostRpcService),ze(3,o.IExtHostWorkspace),ze(4,c.IExtHostConfiguration),ze(5,n.ILogService),ze(6,r.IExtHostInitDataService),ze(7,d.IExtensionStoragePaths),ze(8,I.IExtHostTunnelService),ze(9,A.IExtHostTerminalService)],$),e.AbstractExtHostExtensionService=$;function V(re,N){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:N.activationEvent,reasonId:N.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class F{constructor(N,H,J,K){B.set(this,void 0),Z.set(this,void 0),q.set(this,void 0),it(this,B,N,"f"),it(this,Z,H,"f"),it(this,q,J.identifier,"f"),this.id=J.identifier.value,this.extensionUri=J.extensionLocation,this.extensionPath=R.normalize((0,y.originalFSPath)(J.extensionLocation)),this.packageJSON=J,this.extensionKind=K}get isActive(){return Ne(this,B,"f").isActivated(Ne(this,q,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ne(this,B,"f").getExtensionExports(Ne(this,q,"f"))}activate(){return Ne(this,B,"f").activateByIdWithErrors(Ne(this,q,"f"),{startup:!1,extensionId:Ne(this,Z,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,B=new WeakMap,Z=new WeakMap,q=new WeakMap}),define(Ee[106],_e([0,1,14,2,3,16,5,6,166,32,34,46,170,33,167,13,4,10,41,64]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f,l,o,w,b,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,w.createDecorator)("IExtHostDebugService");let g=class{constructor(p,I,A,a,T,M){this._workspaceService=I,this._extensionService=A,this._editorsService=a,this._configurationService=T,this._editorTabs=M,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=p.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(W=>{W.onDidChange(B=>{this.registerAllDebugTypes(W)}),this.registerAllDebugTypes(W)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(p,I){const A=p;if(typeof A.sourceReference=="number"&&A.sourceReference>0){let a=`debug:${encodeURIComponent(A.path||"")}`,T="?";return I&&(a+=`${T}session=${encodeURIComponent(I.id)}`,T="&"),a+=`${T}ref=${A.sourceReference}`,R.URI.parse(a)}else{if(A.path)return R.URI.file(A.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(p){const I=[];for(const A of p.getAllExtensionDescriptions())if(A.contributes){const a=A.contributes.debuggers;if(a&&a.length>0)for(const T of a)(0,l.isDebuggerMainContribution)(T)&&I.push(T.type)}this._debugServiceProxy.$registerDebugTypes(I)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const p=[];return this._breakpoints.forEach(I=>p.push(I)),p}addBreakpoints(p){this.startBreakpoints();const I=p.filter(T=>{const M=T.id;return this._breakpoints.has(M)?!1:(this._breakpoints.set(M,T),!0)});this.fireBreakpointChanges(I,[],[]);const A=[],a=new Map;for(const T of I)if(T instanceof S.SourceBreakpoint){let M=a.get(T.location.uri.toString());M||(M={type:"sourceMulti",uri:T.location.uri,lines:[]},a.set(T.location.uri.toString(),M),A.push(M)),M.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof S.FunctionBreakpoint&&A.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(A)}removeBreakpoints(p){this.startBreakpoints();const I=p.filter(M=>this._breakpoints.delete(M.id));this.fireBreakpointChanges([],I,[]);const A=I.filter(M=>M instanceof S.SourceBreakpoint).map(M=>M.id),a=I.filter(M=>M instanceof S.FunctionBreakpoint).map(M=>M.id),T=I.filter(M=>M instanceof S.DataBreakpoint).map(M=>M.id);return this._debugServiceProxy.$unregisterBreakpoints(A,a,T)}startDebugging(p,I,A){return this._debugServiceProxy.$startDebugging(p?p.uri:void 0,I,{parentSessionID:A.parentSession?A.parentSession.id:void 0,repl:A.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:A.noDebug,compact:A.compact})}stopDebugging(p){return this._debugServiceProxy.$stopDebugging(p?p.id:void 0)}registerDebugConfigurationProvider(p,I,A){if(!I)return new S.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:p,handle:a,provider:I}),this._debugServiceProxy.$registerDebugConfigurationProvider(p,A,!!I.provideDebugConfigurations,!!I.resolveDebugConfiguration,!!I.resolveDebugConfigurationWithSubstitutedVariables,a),new S.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==I),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(p,I,A){if(!A)return new S.Disposable(()=>{});if(!this.definesDebugType(p,I))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${I}' debugger.`);if(this.getAdapterDescriptorFactoryByType(I))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:I,handle:a,factory:A}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(I,a),new S.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==A),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(p,I){if(!I)return new S.Disposable(()=>{});const A=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:p,handle:A,factory:I}),new S.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==I)})}async $runInTerminal(p,I){return Promise.resolve(void 0)}async $substituteVariables(p,I){if(!this._variableResolver){const[T,M]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,M)}let A;const a=await this.getFolder(p);return a&&(A={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(A,I)}createDebugAdapter(p,I){if(p.type==="implementation")return new r(p.implementation)}createSignService(){}async $startDASession(p,I){const A=this,a=await this.getSession(I);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const M=this.convertToDto(T),W=this.createDebugAdapter(M,a);if(!W)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const B=W;return this._debugAdapters.set(p,B),this.getDebugAdapterTrackers(a).then(Z=>(Z&&this._debugAdaptersTrackers.set(p,Z),B.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const $=q,V={type:"response",seq:0,command:$.command,request_seq:$.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const F=await this._signService.sign($.arguments.value);V.body={signature:F},B.sendResponse(V)}else throw new Error("no signer")}catch(F){V.success=!1,V.message=F.message,B.sendResponse(V)}}else Z&&Z.onDidSendMessage&&Z.onDidSendMessage(q),q=(0,l.convertToVSCPaths)(q,!0),A._debugServiceProxy.$acceptDAMessage(p,q)}),B.onError(q=>{Z&&Z.onError&&Z.onError(q),this._debugServiceProxy.$acceptDAError(p,q.name,q.message,q.stack)}),B.onExit(q=>{Z&&Z.onExit&&Z.onExit((0,b.withNullAsUndefined)(q),void 0),this._debugServiceProxy.$acceptDAExit(p,(0,b.withNullAsUndefined)(q),void 0)}),Z&&Z.onWillStartSession&&Z.onWillStartSession(),B.startSession()))})}$sendDAMessage(p,I){I=(0,l.convertToDAPaths)(I,!1);const A=this._debugAdaptersTrackers.get(p);A&&A.onWillReceiveMessage&&A.onWillReceiveMessage(I);const a=this._debugAdapters.get(p);a&&a.sendMessage(I)}$stopDASession(p){const I=this._debugAdaptersTrackers.get(p);this._debugAdaptersTrackers.delete(p),I&&I.onWillStopSession&&I.onWillStopSession();const A=this._debugAdapters.get(p);return this._debugAdapters.delete(p),A?A.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(p){const I=[],A=[],a=[];if(p.added)for(const T of p.added){const M=T.id;if(M&&!this._breakpoints.has(M)){let W;if(T.type==="function")W=new S.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")W=new S.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const B=R.URI.revive(T.uri);W=new S.SourceBreakpoint(new S.Location(B,new S.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}W._id=M,this._breakpoints.set(M,W),I.push(W)}}if(p.removed)for(const T of p.removed){const M=this._breakpoints.get(T);M&&(this._breakpoints.delete(T),A.push(M))}if(p.changed){for(const T of p.changed)if(T.id){const M=this._breakpoints.get(T.id);if(M){if(M instanceof S.FunctionBreakpoint&&T.type==="function"){const W=M;W.enabled=T.enabled,W.condition=T.condition,W.hitCondition=T.hitCondition,W.logMessage=T.logMessage,W.functionName=T.functionName}else if(M instanceof S.SourceBreakpoint&&T.type==="source"){const W=M;W.enabled=T.enabled,W.condition=T.condition,W.hitCondition=T.hitCondition,W.logMessage=T.logMessage,W.location=new S.Location(R.URI.revive(T.uri),new S.Position(T.line,T.character))}a.push(M)}}}this.fireBreakpointChanges(I,A,a)}$provideDebugConfigurations(p,I,A){return(0,y.asPromise)(async()=>{const a=this.getConfigProviderByHandle(p);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(I);return a.provideDebugConfigurations(T,A)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(p,I,A,a){return(0,y.asPromise)(async()=>{const T=this.getConfigProviderByHandle(p);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const M=await this.getFolder(I);return T.resolveDebugConfiguration(M,A,a)})}$resolveDebugConfigurationWithSubstitutedVariables(p,I,A,a){return(0,y.asPromise)(async()=>{const T=this.getConfigProviderByHandle(p);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const M=await this.getFolder(I);return T.resolveDebugConfigurationWithSubstitutedVariables(M,A,a)})}async $provideDebugAdapter(p,I){const A=this.getAdapterDescriptorFactoryByHandle(p);if(!A)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(I);return this.getAdapterDescriptor(A,a).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(p){const I=await this.getSession(p);this._onDidStartDebugSession.fire(I)}async $acceptDebugSessionTerminated(p){const I=await this.getSession(p);I&&(this._onDidTerminateDebugSession.fire(I),this._debugSessions.delete(I.id))}async $acceptDebugSessionActiveChanged(p){this._activeDebugSession=p?await this.getSession(p):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(p,I){const A=await this.getSession(p);A&&A._acceptNameChanged(I)}async $acceptDebugSessionCustomEvent(p,I){const a={session:await this.getSession(p),event:I.event,body:I.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(p){if(p instanceof S.DebugAdapterExecutable)return{type:"executable",command:p.command,args:p.args,options:p.options};if(p instanceof S.DebugAdapterServer)return{type:"server",port:p.port,host:p.host};if(p instanceof S.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:p.path};if(p instanceof S.DebugAdapterInlineImplementation)return{type:"implementation",implementation:p.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(p){const I=this._adapterFactories.filter(A=>A.type===p);if(I.length>0)return I[0].factory}getAdapterDescriptorFactoryByHandle(p){const I=this._adapterFactories.filter(A=>A.handle===p);if(I.length>0)return I[0].factory}getConfigProviderByHandle(p){const I=this._configProviders.filter(A=>A.handle===p);if(I.length>0)return I[0].provider}definesDebugType(p,I){if(p.contributes){const A=p.contributes.debuggers;if(A&&A.length>0){for(const a of A)if(a.label&&a.type&&a.type===I)return!0}}return!1}getDebugAdapterTrackers(p){const A=p.configuration.type,a=this._trackerFactories.filter(T=>T.type===A||T.type==="*").map(T=>(0,y.asPromise)(()=>T.factory.createDebugAdapterTracker(p)).then(M=>M,M=>null));return Promise.race([Promise.all(a).then(T=>{const M=T.filter(W=>!!W);if(M.length>0)return new i(M)}),new Promise((T,M)=>{const W=setTimeout(()=>{clearTimeout(W),M(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(p,I){const A=I.configuration.debugServer;if(typeof A=="number")return Promise.resolve(new S.DebugAdapterServer(A));if(p){const T=await this._extensionService.getExtensionRegistry();return(0,y.asPromise)(()=>p.createDebugAdapterDescriptor(I,this.daExecutableFromPackage(I,T))).then(M=>{if(M)return M})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(I,a))}daExecutableFromPackage(p,I){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(p,I,A){(p.length>0||I.length>0||A.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:p,removed:I,changed:A}))}async getSession(p){if(p)if(typeof p=="string"){const I=this._debugSessions.get(p);if(I)return I}else{let I=this._debugSessions.get(p.id);if(!I){const A=await this.getFolder(p.folderUri),a=p.parent?this._debugSessions.get(p.parent):void 0;I=new v(this._debugServiceProxy,p.id,p.type,p.name,A,p.configuration,a),this._debugSessions.set(I.id,I),this._debugServiceProxy.$sessionCached(I.id)}return I}throw new Error("cannot find session")}getFolder(p){if(p){const I=R.URI.revive(p);return this._workspaceService.resolveWorkspaceFolder(I)}return Promise.resolve(void 0)}};g=He([ze(0,o.IExtHostRpcService),ze(1,C.IExtHostWorkspace),ze(2,n.IExtHostExtensionService),ze(3,P.IExtHostDocumentsAndEditors),ze(4,f.IExtHostConfiguration),ze(5,u.IExtHostEditorTabs)],g),e.ExtHostDebugServiceBase=g;class v{constructor(p,I,A,a,T,M,W){this._debugServiceProxy=p,this._id=I,this._type=A,this._name=a,this._workspaceFolder=T,this._configuration=M,this._parentSession=W}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(p){this._name=p,this._debugServiceProxy.$setDebugSessionName(this._id,p)}get parentSession(){return this._parentSession}_acceptNameChanged(p){this._name=p}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(p,I){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,p,I)}getDebugProtocolBreakpoint(p){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,p.id)}}e.ExtHostDebugSession=v;class t{constructor(p){this.value=Object.freeze({append(I){p.$appendDebugConsole(I)},appendLine(I){this.append(I+`
`)}})}}e.ExtHostDebugConsole=t;class s extends c.AbstractVariableResolverService{constructor(p,I,A,a,T){function M(){if(I){const W=I.activeEditor();if(W)return W.document.uri;const B=a.tabs.filter(Z=>Z.isActive);if(B.length>0)return B[0].resource}}super({getFolderUri:W=>{const B=p.filter(Z=>Z.name===W);if(B&&B.length>0)return B[0].uri},getWorkspaceFolderCount:()=>p.length,getConfigurationValue:(W,B)=>A.getConfiguration(void 0,W).get(B),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const W=M();if(W)return h.normalize(W.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const W=M();if(W){const B=T.getWorkspaceFolder(W);if(B)return h.normalize(B.uri.fsPath)}}},getSelectedText:()=>{if(I){const W=I.activeEditor();if(W&&!W.selection.isEmpty)return W.document.getText(W.selection)}},getLineNumber:()=>{if(I){const W=I.activeEditor();if(W)return String(W.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=s;class i{constructor(p){this.trackers=p}onWillStartSession(){this.trackers.forEach(p=>p.onWillStartSession?p.onWillStartSession():void 0)}onWillReceiveMessage(p){this.trackers.forEach(I=>I.onWillReceiveMessage?I.onWillReceiveMessage(p):void 0)}onDidSendMessage(p){this.trackers.forEach(I=>I.onDidSendMessage?I.onDidSendMessage(p):void 0)}onWillStopSession(){this.trackers.forEach(p=>p.onWillStopSession?p.onWillStopSession():void 0)}onError(p){this.trackers.forEach(I=>I.onError?I.onError(p):void 0)}onExit(p,I){this.trackers.forEach(A=>A.onExit?A.onExit(p,I):void 0)}}class r extends _.AbstractDebugAdapter{constructor(p){super();this.implementation=p,p.onDidSendMessage(I=>{this.acceptMessage(I)})}startSession(){return Promise.resolve(void 0)}sendMessage(p){this.implementation.handleMessage(p)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let d=class extends g{constructor(p,I,A,a,T,M){super(p,I,A,a,T,M)}createVariableResolver(p,I,A){return new s(p,I,A,this._editorTabs)}};d=He([ze(0,o.IExtHostRpcService),ze(1,C.IExtHostWorkspace),ze(2,n.IExtHostExtensionService),ze(3,P.IExtHostDocumentsAndEditors),ze(4,f.IExtHostConfiguration),ze(5,u.IExtHostEditorTabs)],d),e.WorkerExtHostDebugService=d}),define(Ee[219],_e([0,1,75,2,5,33,29,26,13,28,4,34,41,15]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(u,g,v,t,s,i,r){this._apiFactory=u,this._extensionRegistry=g,this._instaService=v,this._extHostConfiguration=t,this._extHostExtensionService=s,this._initData=i,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),h.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();h.mark("code/extHost/didWaitForConfig");const g=await this._extHostExtensionService.getExtensionPathIndex();this.register(new o(this._apiFactory,g,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(w)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,g,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let g of u.nodeModuleName)this._factories.set(g,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(g=>u.alternativeModuleName(g))}};l=He([ze(2,n.IInstantiationService),ze(3,y.IExtHostConfiguration),ze(4,P.IExtHostExtensionService),ze(5,C.IExtHostInitDataService),ze(6,f.ILogService)],l),e.RequireInterceptor=l;class o{constructor(u,g,v,t,s){this._apiFactory=u,this._extensionPaths=g,this._extensionRegistry=v,this._configProvider=t,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,g){const v=this._extensionPaths.findSubstr(g.fsPath);if(v){let t=this._extApiImpl.get(S.ExtensionIdentifier.toKey(v.identifier));return t||(t=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(S.ExtensionIdentifier.toKey(v.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((s,i)=>t+=`	${i} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${g.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let w=class{constructor(u,g){this.nodeModuleName="keytar";const{environment:v}=g,t=u.getProxy(D.MainContext.MainThreadKeytar);if(v.appRoot){let s=v.appRoot.fsPath;c.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,i)=>t.$getPassword(s,i),setPassword:(s,i,r)=>t.$setPassword(s,i,r),deletePassword:(s,i)=>t.$deletePassword(s,i),findPassword:s=>t.$findPassword(s),findCredentials(s){return t.$findCredentials(s)}}}load(u,g){return this._impl}alternativeModuleName(u){const g=u.length;if(g<=7||!this.alternativeNames)return;const v=g-7;if((u.charAt(v)==="/"||u.charAt(v)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};w=He([ze(0,_.IExtHostRpcService),ze(1,C.IExtHostInitDataService)],w);let b=class{constructor(u,g,v){this._extensionPaths=u,this._appUriScheme=g,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(D.MainContext.MainThreadTelemetry);const t=v.getProxy(D.MainContext.MainThreadWindow);this._impl=(s,i)=>{const r=R.URI.parse(s);return i?this.callOriginal(s,i):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,s,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,s,{}):this.callOriginal(s,i)}}load(u,g,v){const t=this._extensionPaths.findSubstr(g.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=v(u),this._impl}callOriginal(u,g){return this.sendNoForwardTelemetry(),this._original(u,g)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=He([ze(2,_.IExtHostRpcService)],b)}),define(Ee[220],_e([0,1,16,12,75,7,2,5,213,15,57,61,28,148,13,66,34,37]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f,l,o,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(g,v,t,s){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new _.RPCProtocol(g,null,s),v=E._transform(v,this._rpcProtocol);const i=new P.ServiceCollection(...(0,n.getSingletonServiceDescriptors)());i.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...v}),i.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),i.set(o.IURITransformerService,new o.URITransformerService(s)),i.set(w.IHostUtils,t);const r=new f.InstantiationService(i,!0),d=r.invokeFunction(A=>A.get(b.IExtHostTerminalService));this._disposables.add(d),this._logService=r.invokeFunction(A=>A.get(C.ILogService)),D.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",v),this._extensionService=r.invokeFunction(A=>A.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const m=new WeakMap;this._extensionService.getExtensionPathIndex().then(A=>{Error.prepareStackTrace=(a,T)=>{let M="",W,B;for(const Z of T)M+=`
	at ${Z.toString()}`,B=Z.getFileName(),!W&&B&&(W=A.findSubstr(B));return m.set(a,W),`${a.name||"Error"}: ${a.message||""}${M}`}});const p=this._rpcProtocol.getProxy(S.MainContext.MainThreadExtensionService),I=this._rpcProtocol.getProxy(S.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(A=>{const a=R.transformErrorForSerialization(A),T=m.get(A);T?p.$onExtensionRuntimeError(T.identifier,a):I.$onUnexpectedError(a)})}terminate(g){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${g}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,h.timeout)(4e3),v]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(g,v){g.extensions.forEach(s=>s.extensionLocation=k.URI.revive(v.transformIncomingURIs(s.extensionLocation))),g.environment.appRoot=k.URI.revive(v.transformIncomingURIs(g.environment.appRoot));const t=g.environment.extensionDevelopmentLocationURI;return t&&(g.environment.extensionDevelopmentLocationURI=t.map(s=>k.URI.revive(v.transformIncomingURIs(s)))),g.environment.extensionTestsLocationURI=k.URI.revive(v.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=k.URI.revive(v.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=k.URI.revive(v.transformIncomingURIs(g.environment.workspaceStorageHome)),g.logsLocation=k.URI.revive(v.transformIncomingURIs(g.logsLocation)),g.logFile=k.URI.revive(v.transformIncomingURIs(g.logFile)),g.workspace=v.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=E}),define(Ee[221],_e([0,1,14,18,56,27,25,51,38]),function(te,e,h,R,D,y,k,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(c,f,l){this.config=c,this.provider=f,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&y.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&y.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const f=this.config.folderQueries||[];return new Promise((l,o)=>{const w=b=>{this.resultCount++,c(b)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(b=>{const E=b.toString(),u=h.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,u)||this.matchFile(w,{base:b,basename:u})}),Promise.all(f.map(b=>this.searchInFolder(b,w))).then(b=>{l({limitHit:this.isLimitHit,stats:b[0]||void 0})},b=>{o(new Error((0,D.toErrorMessage)(b)))})})}async searchInFolder(c,f){const l=new R.CancellationTokenSource,o=this.getSearchOptionsForFolder(c),w=this.initDirectoryTree(),b=new _.QueryGlobTester(this.config,c),E=!b.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(l),u=S.StopWatch.create();const g=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},o,l.token),v=u.elapsed(),t=S.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(g&&g.forEach(s=>{const i=h.posix.relative(c.folder.path,s.path);if(E){const r=h.basename(s.path);this.matchFile(f,{base:c.folder,relativePath:i,basename:r});return}this.addDirectoryEntries(w,c.folder,i,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,b,f),{providerTime:v,postProcessTime:t.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(c){const f=(0,_.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),l=(0,_.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:l,includes:f,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},f,l,o){if(l===this.filePattern){const b=h.basename(this.filePattern);this.matchFile(o,{base:f,relativePath:this.filePattern,basename:b})}function w(b){const E=h.basename(b),u=h.dirname(b);let g=c[u];g||(g=c[u]=[],w(u)),g.push({base:f,relativePath:b,basename:E})}w(l)}matchDirectoryTree({rootEntries:c,pathToEntries:f},l,o){const w=this,b=this.filePattern;function E(u){const g=y.hasSiblingFn(()=>u.map(v=>v.basename));for(let v=0,t=u.length;v<t;v++){const s=u[v],{relativePath:i,basename:r}=s;if(!l.includedInQuerySync(i,r,b!==r?g:void 0))continue;const d=f[i];if(d)E(d);else{if(i===b)continue;w.matchFile(o,s)}if(w.isLimitHit)break}}E(c)}matchFile(c,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(f))}}class n{constructor(){this.sessions=new Map}fileSearch(c,f,l,o){const w=this.getSessionTokenSource(c.cacheKey),b=new C(c,f,w&&w.token);let E=0;const u=g=>{E+=g.length,l(g.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(b,n.BATCH_SIZE,u,o).then(g=>({limitHit:g.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:g.stats}}))}clearCache(c){const f=this.getSessionTokenSource(c);f&&f.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new R.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:k.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,f,l,o){o.onCancellationRequested(()=>{c.cancel()});const w=E=>{E&&(b.push(E),f>0&&b.length>=f&&(l(b),b=[]))};let b=[];return c.search(w).then(E=>(b.length&&l(b),E),E=>(b.length&&l(b),Promise.reject(E)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(Ee[222],_e([0,1,14,17,18,56,25,27,2,38,11,10]),function(te,e,h,R,D,y,k,S,_,C,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(u,g,v){this.query=u,this.provider=g,this.fileUtils=v,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,g){const v=this.query.folderQueries||[],t=new D.CancellationTokenSource;return g.onCancellationRequested(()=>t.cancel()),new Promise((s,i)=>{this.collector=new l(u);let r=!1;const d=(m,p)=>{if(!r&&!this.isLimitHit){const I=this.resultSize(m);w(m)&&typeof this.query.maxResults=="number"&&this.resultCount+I>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),m=this.trimResultToSize(m,this.query.maxResults-this.resultCount));const A=this.resultSize(m);this.resultCount+=A,(A>0||!w(m))&&this.collector.add(m,p)}};Promise.all(v.map((m,p)=>this.searchInFolder(m,I=>d(I,p),t.token))).then(m=>{t.dispose(),this.collector.flush();const p=m.some(I=>!!I&&!!I.limitHit);s({limitHit:this.isLimitHit||p,messages:(0,R.flatten)(m.map(I=>I?.message?(0,P.isArray)(I.message)?I.message:[I.message]:[])),stats:{type:"textSearchProvider"}})},m=>{t.dispose();const p=(0,y.toErrorMessage)(m);i(new Error(p))})})}resultSize(u){return w(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,g){const v=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:v.slice(0,g),preview:{matches:t.slice(0,g),text:u.preview.text},uri:u.uri}}async searchInFolder(u,g,v){const t=new C.QueryGlobTester(this.query,u),s=[],i={report:m=>{if(!this.validateProviderResult(m))return;const p=u.folder.scheme===n.Schemas.file?S.hasSiblingPromiseFn(()=>this.fileUtils.readdir(k.dirname(m.uri))):void 0,I=k.relativePath(u.folder,m.uri);I&&s.push(t.includedInQuery(I,h.basename(I),p).then(A=>{A&&g(m)}))}},r=this.getSearchOptionsForFolder(u),d=await this.provider.provideTextSearchResults(f(this.query.contentPattern),r,i,v);return await Promise.all(s),d}validateProviderResult(u){if(w(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const g=(0,C.resolvePatternsForProvider)(this.query.includePattern,u.includePattern),v=(0,C.resolvePatternsForProvider)(this.query.excludePattern,u.excludePattern),t={folder:_.URI.from(u.folder),excludes:v,includes:g,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=c;function f(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class l{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,g=>this.sendItems(g))}add(u,g){this._currentFileMatch&&(this._currentFolderIdx!==g||!k.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=g,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(o(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=l;function o(E){return w(E)?{preview:{matches:(0,R.mapArrayOrNot)(E.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:E.preview.text},ranges:(0,R.mapArrayOrNot)(E.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function w(E){return!!E.preview}e.extensionResultIsMatch=w;class b{constructor(u,g){this.maxBatchSize=u,this.cb=g,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,g){!u||this.addItemToBatch(u,g)}addItems(u,g){!u||this.addItemsToBatch(u,g)}addItemToBatch(u,g){this.batch.push(u),this.batchSize+=g,this.onUpdate()}addItemsToBatch(u,g){this.batch=this.batch.concat(u),this.batchSize+=g,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(Ee[107],_e([0,1,7,5,4,221,13,66,15,2,222]),function(te,e,h,R,D,y,k,S,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let P=class{constructor(o,w,b){this.extHostRpc=o,this._uriTransformer=w,this._logService=b,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(o){return this._uriTransformer.transformOutgoingScheme(o)}registerTextSearchProvider(o,w){if(this._textSearchUsedSchemes.has(o))throw new Error(`a text search provider for the scheme '${o}' is already registered`);this._textSearchUsedSchemes.add(o);const b=this._handlePool++;return this._textSearchProvider.set(b,w),this._proxy.$registerTextSearchProvider(b,this._transformScheme(o)),(0,h.toDisposable)(()=>{this._textSearchUsedSchemes.delete(o),this._textSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}registerFileSearchProvider(o,w){if(this._fileSearchUsedSchemes.has(o))throw new Error(`a file search provider for the scheme '${o}' is already registered`);this._fileSearchUsedSchemes.add(o);const b=this._handlePool++;return this._fileSearchProvider.set(b,w),this._proxy.$registerFileSearchProvider(b,this._transformScheme(o)),(0,h.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(o),this._fileSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}$provideFileSearchResults(o,w,b,E){const u=c(b),g=this._fileSearchProvider.get(o);if(g)return this._fileSearchManager.fileSearch(u,g,v=>{this._proxy.$handleFileMatch(o,w,v.map(t=>t.resource))},E);throw new Error("unknown provider: "+o)}$clearCache(o){return this._fileSearchManager.clearCache(o),Promise.resolve(void 0)}$provideTextSearchResults(o,w,b,E){const u=this._textSearchProvider.get(o);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${o}`);const g=c(b);return this.createTextSearchManager(g,u).search(t=>this._proxy.$handleTextMatch(o,w,t),E)}createTextSearchManager(o,w){return new n.TextSearchManager(o,w,{readdir:b=>Promise.resolve([]),toCanonicalName:b=>b})}};P=He([ze(0,k.IExtHostRpcService),ze(1,S.IURITransformerService),ze(2,_.ILogService)],P),e.ExtHostSearch=P;function c(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(f),extraFileResources:l.extraFileResources&&l.extraFileResources.map(o=>C.URI.revive(o))}}e.reviveQuery=c;function f(l){return{...l,folder:C.URI.revive(l.folder)}}}),define(Ee[223],_e([0,1,18,12,3,42,2,124,84,118,55,60,5,186,185,71,187,33,188,189,190,172,191,46,34,192,173,194,195,196,102,175,201,202,203,73,37,205,176,9,6,208,47,103,32,29,76,164,193,92,101,105,106,107,15,66,13,28,197,162,65,70,183,206,161,74,72,211,209,210,184,45,204,207,69,64,93,199,104,200,11,150,198,159,157]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f,l,o,w,b,E,u,g,v,t,s,i,r,d,m,p,I,A,a,T,M,W,B,Z,q,$,V,F,re,N,H,J,K,le,Ie,Me,Ve,xe,Ge,Ke,qe,U,G,ne,se,ge,X,ce,ke,Be,$e,pe,tt,z,Q,fe,Le,Ue,Ze,Ce,Se,Pe,ie,ae,de,me,x,he,be,Ae,Fe,We){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function et(Qe){const Ye=Qe.get(se.IExtHostInitDataService),lt=Qe.get(Ze.IExtHostFileSystemInfo),ct=Qe.get(z.IExtHostConsumerFileSystem),ve=Qe.get(i.IExtHostExtensionService),we=Qe.get(J.IExtHostWorkspace),oe=Qe.get(ae.IExtHostTelemetry),j=Qe.get(b.IExtHostConfiguration),Oe=Qe.get(G.IURITransformerService),ye=Qe.get(ne.IExtHostRpcService),Xe=Qe.get(B.IExtHostStorage),Je=Qe.get(tt.IExtensionStoragePaths),rt=Qe.get(U.ILogService),mt=Qe.get(ce.IExtHostTunnelService),wt=Qe.get(ke.IExtHostApiDeprecationService),bt=Qe.get(H.IExtHostWindow),Ct=Qe.get(Pe.IExtHostSecretState),St=Qe.get(ie.IExtHostEditorTabs);ye.set(c.ExtHostContext.ExtHostFileSystemInfo,lt),ye.set(c.ExtHostContext.ExtHostLogService,rt),ye.set(c.ExtHostContext.ExtHostWorkspace,we),ye.set(c.ExtHostContext.ExtHostConfiguration,j),ye.set(c.ExtHostContext.ExtHostExtensionService,ve),ye.set(c.ExtHostContext.ExtHostStorage,Xe),ye.set(c.ExtHostContext.ExtHostTunnelService,mt),ye.set(c.ExtHostContext.ExtHostWindow,bt),ye.set(c.ExtHostContext.ExtHostSecretState,Ct),ye.set(c.ExtHostContext.ExtHostTelemetry,oe),ye.set(c.ExtHostContext.ExtHostEditorTabs,St);const Tt=ye.set(c.ExtHostContext.ExtHostDecorations,Qe.get(xe.IExtHostDecorations)),gt=ye.set(c.ExtHostContext.ExtHostDocumentsAndEditors,Qe.get(s.IExtHostDocumentsAndEditors)),dt=ye.set(c.ExtHostContext.ExtHostCommands,Qe.get(o.IExtHostCommands)),pt=ye.set(c.ExtHostContext.ExtHostTerminalService,Qe.get(Z.IExtHostTerminalService)),Et=ye.set(c.ExtHostContext.ExtHostDebugService,Qe.get(Ke.IExtHostDebugService)),At=ye.set(c.ExtHostContext.ExtHostSearch,Qe.get(qe.IExtHostSearch)),kt=ye.set(c.ExtHostContext.ExtHostTask,Qe.get(Ge.IExtHostTask)),_n=ye.set(c.ExtHostContext.ExtHostOutputService,Qe.get(A.IExtHostOutputService)),qt=ye.set(c.ExtHostContext.ExtHostUrls,new re.ExtHostUrls(ye)),yt=ye.set(c.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(ye,gt)),Yt=ye.set(c.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(ye,gt,rt)),Jt=ye.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(rt,yt,ye.getProxy(c.MainContext.MainThreadBulkEdits))),ht=ye.set(c.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(ye,dt,gt,yt,Je)),jt=ye.set(c.ExtHostContext.ExtHostNotebookDocuments,new Fe.ExtHostNotebookDocuments(rt,ht)),Ht=ye.set(c.ExtHostContext.ExtHostNotebookEditors,new Ae.ExtHostNotebookEditors(rt,ye,ht)),Xt=ye.set(c.ExtHostContext.ExtHostNotebookKernels,new de.ExtHostNotebookKernels(ye,Ye,ht,rt)),Zt=ye.set(c.ExtHostContext.ExtHostNotebookRenderers,new x.ExtHostNotebookRenderers(ye,ht)),It=ye.set(c.ExtHostContext.ExtHostEditors,new q.ExtHostEditors(ye,gt)),hn=ye.set(c.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(ye.getProxy(c.MainContext.MainThreadTreeViews),dt,rt)),en=ye.set(c.ExtHostContext.ExtHostEditorInsets,new Ie.ExtHostEditorInsets(ye.getProxy(c.MainContext.MainThreadEditorInsets),It,Ye)),Bt=ye.set(c.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(ye,rt)),ut=ye.set(c.ExtHostContext.ExtHostLanguageFeatures,new m.ExtHostLanguageFeatures(ye,Oe,yt,dt,Bt,rt,wt)),tn=ye.set(c.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(ye,ut)),Nt=ye.set(c.ExtHostContext.ExtHostFileSystemEventService,new d.ExtHostFileSystemEventService(ye,rt,gt)),Ot=ye.set(c.ExtHostContext.ExtHostQuickOpen,(0,T.createExtHostQuickOpen)(ye,we,dt)),Gt=ye.set(c.ExtHostContext.ExtHostSCM,new M.ExtHostSCM(ye,dt,rt)),yn=ye.set(c.ExtHostContext.ExtHostComments,(0,w.createExtHostComments)(ye,dt,yt)),fn=ye.set(c.ExtHostContext.ExtHostProgress,new a.ExtHostProgress(ye.getProxy(c.MainContext.MainThreadProgress))),Sn=ye.set(c.ExtHostContext.ExtHosLabelService,new Me.ExtHostLabelService(ye)),mn=ye.set(c.ExtHostContext.ExtHostTheming,new X.ExtHostTheming(ye)),nn=ye.set(c.ExtHostContext.ExtHostAuthentication,new Be.ExtHostAuthentication(ye)),rn=ye.set(c.ExtHostContext.ExtHostTimeline,new $e.ExtHostTimeline(ye,dt)),zt=ye.set(c.ExtHostContext.ExtHostWebviews,new N.ExtHostWebviews(ye,{remote:Ye.remote},we,rt,wt)),sn=ye.set(c.ExtHostContext.ExtHostWebviewPanels,new Le.ExtHostWebviewPanels(ye,zt,we)),Dn=ye.set(c.ExtHostContext.ExtHostCustomEditors,new fe.ExtHostCustomEditors(ye,yt,Je,zt,sn)),Cn=ye.set(c.ExtHostContext.ExtHostWebviewViews,new Q.ExtHostWebviewViews(ye,zt)),Vt=ye.set(c.ExtHostContext.ExtHostTesting,new Ce.ExtHostTesting(ye,dt)),Kt=ye.set(c.ExtHostContext.ExtHostUriOpeners,new Se.ExtHostUriOpeners(ye));ye.set(c.ExtHostContext.ExtHostInteractive,new We.ExtHostInteractive(ye,ht,gt));const kn=(0,le.values)(c.ExtHostContext);ye.assertRegistered(kn);const In=new Ue.ExtHostBulkEdits(ye,gt),on=new l.ExtHostClipboard(ye),an=new I.ExtHostMessageService(ye,rt),$t=new u.ExtHostDialogs(ye),Ft=new W.ExtHostStatusBar(ye,dt.converter),ln=new p.ExtHostLanguages(ye,yt);return f.ExtHostApiCommands.register(dt),function(Re,Wt,gn){const ft=function(){let Y=!Re.isUnderDevelopment;function ue(Te){Y||(rt.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function Te(at){if(Array.isArray(at))at.forEach(Te);else if(typeof at=="string")ue(at);else{const vt=at;typeof vt.scheme=="undefined"&&ue(at),!Re.enableProposedApi&&typeof vt.exclusive=="boolean"&&(0,K.throwProposedApiError)(Re)}return at}}(),Pn={getSession(Y,ue,Te){return nn.getSession(Re,Y,ue,Te)},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(Y,ue,Te,at){return nn.registerAuthenticationProvider(Y,ue,Te,at)}},An={registerCommand(Y,ue,Te){return dt.registerCommand(!0,Y,ue,Te)},registerTextEditorCommand(Y,ue,Te){return dt.registerCommand(!0,Y,(...at)=>{const vt=It.getActiveTextEditor();if(!vt){rt.warn("Cannot execute "+Y+" because there is no active text editor.");return}return vt.edit(_t=>{ue.apply(Te,[vt,_t,...at])}).then(_t=>{_t||rt.warn("Edits from command "+Y+" were not applied.")},_t=>{rt.warn("An error occurred while running command "+Y,_t)})})},registerDiffInformationCommand:(Y,ue,Te)=>((0,K.checkProposedApiEnabled)(Re),dt.registerCommand(!0,Y,async(...at)=>{const vt=gt.activeEditor(!0);if(!vt){rt.warn("Cannot execute "+Y+" because there is no active text editor.");return}const _t=await It.getDiffInformation(vt.id);ue.apply(Te,[_t,...at])})),executeCommand(Y,...ue){return dt.executeCommand(Y,...ue)},getCommands(Y=!1){return dt.getCommands(Y)}},pn={get machineId(){return Ye.telemetryInfo.machineId},get sessionId(){return Ye.telemetryInfo.sessionId},get language(){return Ye.environment.appLanguage},get appName(){return Ye.environment.appName},get appRoot(){return Ye.environment.appRoot?.fsPath??""},get uriScheme(){return Ye.environment.appUriScheme},get clipboard(){return on.value},get shell(){return pt.getDefaultShell(!1)},get isTelemetryEnabled(){return oe.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return oe.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(Ye.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,ue){return bt.openUri(Y,{allowTunneling:!!Ye.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===Ye.environment.appUriScheme)return qt.createAppUri(Y);try{return await bt.asExternalUri(Y,{allowTunneling:!!Ye.remote.authority})}catch(ue){if((0,be.matchesScheme)(Y,he.Schemas.http)||(0,be.matchesScheme)(Y,he.Schemas.https))return Y;throw ue}},get remoteName(){return(0,Ve.getRemoteName)(Ye.remote.authority)},get uiKind(){return Ye.uiKind}};Ye.environment.extensionTestsLocationURI||Object.freeze(pn);const vn=Ye.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,Tn={createTestController(Y){return(0,K.checkProposedApiEnabled)(Re),Vt.createTestController(Y)},createTestObserver(){return(0,K.checkProposedApiEnabled)(Re),Vt.createTestObserver()},runTests(Y){return(0,K.checkProposedApiEnabled)(Re),Vt.runTests(Y)},get onDidChangeTestResults(){return(0,K.checkProposedApiEnabled)(Re),Vt.onResultsChanged},get testResults(){return(0,K.checkProposedApiEnabled)(Re),Vt.results}},un={getExtension(Y){const ue=Wt.getExtensionDescription(Y);if(ue)return new i.Extension(ve,Re.identifier,ue,vn)},get all(){return Wt.getAllExtensionDescriptions().map(Y=>new i.Extension(ve,Re.identifier,Y,vn))},get onDidChange(){return Wt.onDidChange}},Rn={createDiagnosticCollection(Y){return Bt.createDiagnosticCollection(Re.identifier,Y)},get onDidChangeDiagnostics(){return Bt.onDidChangeDiagnostics},getDiagnostics:Y=>Bt.getDiagnostics(Y),getLanguages(){return ln.getLanguages()},setTextDocumentLanguage(Y,ue){return ln.changeLanguage(Y.uri,ue)},match(Y,ue){return(0,n.score)(V.LanguageSelector.from(Y),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(Y,ue,Te){return ut.registerCodeActionProvider(Re,ft(Y),ue,Te)},registerCodeLensProvider(Y,ue){return ut.registerCodeLensProvider(Re,ft(Y),ue)},registerDefinitionProvider(Y,ue){return ut.registerDefinitionProvider(Re,ft(Y),ue)},registerDeclarationProvider(Y,ue){return ut.registerDeclarationProvider(Re,ft(Y),ue)},registerImplementationProvider(Y,ue){return ut.registerImplementationProvider(Re,ft(Y),ue)},registerTypeDefinitionProvider(Y,ue){return ut.registerTypeDefinitionProvider(Re,ft(Y),ue)},registerHoverProvider(Y,ue){return ut.registerHoverProvider(Re,ft(Y),ue,Re.identifier)},registerEvaluatableExpressionProvider(Y,ue){return ut.registerEvaluatableExpressionProvider(Re,ft(Y),ue,Re.identifier)},registerInlineValuesProvider(Y,ue){return ut.registerInlineValuesProvider(Re,ft(Y),ue,Re.identifier)},registerDocumentHighlightProvider(Y,ue){return ut.registerDocumentHighlightProvider(Re,ft(Y),ue)},registerLinkedEditingRangeProvider(Y,ue){return ut.registerLinkedEditingRangeProvider(Re,ft(Y),ue)},registerReferenceProvider(Y,ue){return ut.registerReferenceProvider(Re,ft(Y),ue)},registerRenameProvider(Y,ue){return ut.registerRenameProvider(Re,ft(Y),ue)},registerDocumentSymbolProvider(Y,ue,Te){return ut.registerDocumentSymbolProvider(Re,ft(Y),ue,Te)},registerWorkspaceSymbolProvider(Y){return ut.registerWorkspaceSymbolProvider(Re,Y)},registerDocumentFormattingEditProvider(Y,ue){return ut.registerDocumentFormattingEditProvider(Re,ft(Y),ue)},registerDocumentRangeFormattingEditProvider(Y,ue){return ut.registerDocumentRangeFormattingEditProvider(Re,ft(Y),ue)},registerOnTypeFormattingEditProvider(Y,ue,Te,...at){return ut.registerOnTypeFormattingEditProvider(Re,ft(Y),ue,[Te].concat(at))},registerDocumentSemanticTokensProvider(Y,ue,Te){return ut.registerDocumentSemanticTokensProvider(Re,ft(Y),ue,Te)},registerDocumentRangeSemanticTokensProvider(Y,ue,Te){return ut.registerDocumentRangeSemanticTokensProvider(Re,ft(Y),ue,Te)},registerSignatureHelpProvider(Y,ue,Te,...at){return typeof Te=="object"?ut.registerSignatureHelpProvider(Re,ft(Y),ue,Te):ut.registerSignatureHelpProvider(Re,ft(Y),ue,typeof Te=="undefined"?[]:[Te,...at])},registerCompletionItemProvider(Y,ue,...Te){return ut.registerCompletionItemProvider(Re,ft(Y),ue,Te)},registerInlineCompletionItemProvider(Y,ue){return(0,K.checkProposedApiEnabled)(Re),ut.registerInlineCompletionsProvider(Re,ft(Y),ue)},registerDocumentLinkProvider(Y,ue){return ut.registerDocumentLinkProvider(Re,ft(Y),ue)},registerColorProvider(Y,ue){return ut.registerColorProvider(Re,ft(Y),ue)},registerFoldingRangeProvider(Y,ue){return ut.registerFoldingRangeProvider(Re,ft(Y),ue)},registerSelectionRangeProvider(Y,ue){return ut.registerSelectionRangeProvider(Re,Y,ue)},registerCallHierarchyProvider(Y,ue){return ut.registerCallHierarchyProvider(Re,Y,ue)},setLanguageConfiguration:(Y,ue)=>ut.setLanguageConfiguration(Re,Y,ue),getTokenInformationAtPosition(Y,ue){return(0,K.checkProposedApiEnabled)(Re),ln.tokenAtPosition(Y,ue)},registerInlayHintsProvider(Y,ue){return(0,K.checkProposedApiEnabled)(Re),ut.registerInlayHintsProvider(Re,Y,ue)}},Fn={get activeTextEditor(){return It.getActiveTextEditor()},get visibleTextEditors(){return It.getVisibleTextEditors()},get activeTerminal(){return pt.activeTerminal},get terminals(){return pt.terminals},async showTextDocument(Y,ue,Te){const at=await(k.URI.isUri(Y)?Promise.resolve(bn.openTextDocument(Y)):Promise.resolve(Y));return It.showTextDocument(at,ue,Te)},createTextEditorDecorationType(Y){return It.createTextEditorDecorationType(Re,Y)},onDidChangeActiveTextEditor(Y,ue,Te){return It.onDidChangeActiveTextEditor(Y,ue,Te)},onDidChangeVisibleTextEditors(Y,ue,Te){return It.onDidChangeVisibleTextEditors(Y,ue,Te)},onDidChangeTextEditorSelection(Y,ue,Te){return It.onDidChangeTextEditorSelection(Y,ue,Te)},onDidChangeTextEditorOptions(Y,ue,Te){return It.onDidChangeTextEditorOptions(Y,ue,Te)},onDidChangeTextEditorVisibleRanges(Y,ue,Te){return It.onDidChangeTextEditorVisibleRanges(Y,ue,Te)},onDidChangeTextEditorViewColumn(Y,ue,Te){return It.onDidChangeTextEditorViewColumn(Y,ue,Te)},onDidCloseTerminal(Y,ue,Te){return pt.onDidCloseTerminal(Y,ue,Te)},onDidOpenTerminal(Y,ue,Te){return pt.onDidOpenTerminal(Y,ue,Te)},onDidChangeActiveTerminal(Y,ue,Te){return pt.onDidChangeActiveTerminal(Y,ue,Te)},onDidChangeTerminalDimensions(Y,ue,Te){return(0,K.checkProposedApiEnabled)(Re),pt.onDidChangeTerminalDimensions(Y,ue,Te)},onDidWriteTerminalData(Y,ue,Te){return(0,K.checkProposedApiEnabled)(Re),pt.onDidWriteTerminalData(Y,ue,Te)},get state(){return bt.state},onDidChangeWindowState(Y,ue,Te){return bt.onDidChangeWindowState(Y,ue,Te)},showInformationMessage(Y,...ue){return an.showMessage(Re,y.default.Info,Y,ue[0],ue.slice(1))},showWarningMessage(Y,...ue){return an.showMessage(Re,y.default.Warning,Y,ue[0],ue.slice(1))},showErrorMessage(Y,...ue){return an.showMessage(Re,y.default.Error,Y,ue[0],ue.slice(1))},showQuickPick(Y,ue,Te){return Ot.showQuickPick(Y,!!Re.enableProposedApi,ue,Te)},showWorkspaceFolderPick(Y){return Ot.showWorkspaceFolderPick(Y)},showInputBox(Y,ue){return Ot.showInput(Y,ue)},showOpenDialog(Y){return $t.showOpenDialog(Y)},showSaveDialog(Y){return $t.showSaveDialog(Y)},createStatusBarItem(Y,ue,Te){let at,vt,_t;return typeof Y=="string"?(at=Y,vt=ue,_t=Te):(vt=Y,_t=ue),Ft.createStatusBarEntry(Re,at,vt,_t)},setStatusBarMessage(Y,ue){return Ft.setStatusBarMessage(Y,ue)},withScmProgress(Y){return wt.report("window.withScmProgress",Re,"Use 'withProgress' instead."),fn.withProgress(Re,{location:F.ProgressLocation.SourceControl},(ue,Te)=>Y({report(at){}}))},withProgress(Y,ue){return fn.withProgress(Re,Y,ue)},createOutputChannel(Y){return _n.createOutputChannel(Y,Re)},createWebviewPanel(Y,ue,Te,at){return sn.createWebviewPanel(Re,Y,ue,Te,at)},createWebviewTextEditorInset(Y,ue,Te,at){return(0,K.checkProposedApiEnabled)(Re),en.createWebviewEditorInset(Y,ue,Te,at,Re)},createTerminal(Y,ue,Te){return typeof Y=="object"?"pty"in Y?pt.createExtensionTerminal(Y):pt.createTerminalFromOptions(Y):pt.createTerminal(Y,ue,Te)},registerTerminalLinkProvider(Y){return pt.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,ue){return pt.registerProfileProvider(Re,Y,ue)},registerTreeDataProvider(Y,ue){return hn.registerTreeDataProvider(Y,ue,Re)},createTreeView(Y,ue){return hn.createTreeView(Y,ue,Re)},registerWebviewPanelSerializer:(Y,ue)=>sn.registerWebviewPanelSerializer(Re,Y,ue),registerCustomEditorProvider:(Y,ue,Te={})=>Dn.registerCustomEditorProvider(Re,Y,ue,Te),registerFileDecorationProvider(Y){return Tt.registerFileDecorationProvider(Y,Re.identifier)},registerUriHandler(Y){return qt.registerUriHandler(Re.identifier,Y)},createQuickPick(){return Ot.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return Ot.createInputBox(Re.identifier)},get activeColorTheme(){return mn.activeColorTheme},onDidChangeActiveColorTheme(Y,ue,Te){return mn.onDidChangeActiveColorTheme(Y,ue,Te)},registerWebviewViewProvider(Y,ue,Te){return Cn.registerWebviewViewProvider(Re,Y,ue,Te?.webviewOptions)},get activeNotebookEditor(){return(0,K.checkProposedApiEnabled)(Re),ht.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,ue,Te){return(0,K.checkProposedApiEnabled)(Re),ht.onDidChangeActiveNotebookEditor(Y,ue,Te)},get visibleNotebookEditors(){return(0,K.checkProposedApiEnabled)(Re),ht.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,K.checkProposedApiEnabled)(Re),ht.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,ue,Te){return(0,K.checkProposedApiEnabled)(Re),Ht.onDidChangeNotebookEditorSelection(Y,ue,Te)},onDidChangeNotebookEditorVisibleRanges(Y,ue,Te){return(0,K.checkProposedApiEnabled)(Re),Ht.onDidChangeNotebookEditorVisibleRanges(Y,ue,Te)},showNotebookDocument(Y,ue){return(0,K.checkProposedApiEnabled)(Re),ht.showNotebookDocument(Y,ue)},registerExternalUriOpener(Y,ue,Te){return(0,K.checkProposedApiEnabled)(Re),Kt.registerExternalUriOpener(Re.identifier,Y,ue,Te)},get openEditors(){return(0,K.checkProposedApiEnabled)(Re),St.tabs},get onDidChangeOpenEditors(){return(0,K.checkProposedApiEnabled)(Re),St.onDidChangeTabs},getInlineCompletionItemController(Y){return(0,K.checkProposedApiEnabled)(Re),m.InlineCompletionController.get(Y)}},bn={get rootPath(){return wt.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),we.getPath()},set rootPath(Y){throw R.readonly()},getWorkspaceFolder(Y){return we.getWorkspaceFolder(Y)},get workspaceFolders(){return we.getWorkspaceFolders()},get name(){return we.name},set name(Y){throw R.readonly()},get workspaceFile(){return we.workspaceFile},set workspaceFile(Y){throw R.readonly()},updateWorkspaceFolders:(Y,ue,...Te)=>we.updateWorkspaceFolders(Re,Y,ue||0,...Te),onDidChangeWorkspaceFolders:function(Y,ue,Te){return we.onDidChangeWorkspace(Y,ue,Te)},asRelativePath:(Y,ue)=>we.getRelativePath(Y,ue),findFiles:(Y,ue,Te,at)=>we.findFiles(V.GlobPattern.from(Y),V.GlobPattern.from(ue),Te,Re.identifier,at),findTextInFiles:(Y,ue,Te,at)=>{let vt,_t;return typeof ue=="object"?(vt=ue,_t=Te):(vt={},_t=ue,at=Te),we.findTextInFiles(Y,vt||{},_t,Re.identifier,at)},saveAll:Y=>we.saveAll(Y),applyEdit(Y){return In.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,ue,Te,at)=>Nt.createFileSystemWatcher(V.GlobPattern.from(Y),ue,Te,at),get textDocuments(){return yt.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw R.readonly()},openTextDocument(Y){let ue;const Te=Y;if(typeof Y=="string")ue=Promise.resolve(k.URI.file(Y));else if(k.URI.isUri(Y))ue=Promise.resolve(Y);else if(!Te||typeof Te=="object")ue=yt.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(at=>yt.ensureDocumentData(at).then(vt=>vt.document))},onDidOpenTextDocument:(Y,ue,Te)=>yt.onDidAddDocument(Y,ue,Te),onDidCloseTextDocument:(Y,ue,Te)=>yt.onDidRemoveDocument(Y,ue,Te),onDidChangeTextDocument:(Y,ue,Te)=>yt.onDidChangeDocument(Y,ue,Te),onDidSaveTextDocument:(Y,ue,Te)=>yt.onDidSaveDocument(Y,ue,Te),onWillSaveTextDocument:(Y,ue,Te)=>Jt.getOnWillSaveTextDocumentEvent(Re)(Y,ue,Te),get notebookDocuments(){return ht.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,ue){let Te;if(k.URI.isUri(Y))Te=Y,await ht.openNotebookDocument(Y);else if(typeof Y=="string")Te=k.URI.revive(await ht.createNotebookDocument({viewType:Y,content:ue}));else throw new Error("Invalid arguments");return ht.getNotebookDocument(Te).apiNotebook},get onDidOpenNotebookDocument(){return ht.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return ht.onDidCloseNotebookDocument},registerNotebookSerializer(Y,ue,Te,at){return ht.registerNotebookSerializer(Re,Y,ue,Te,Re.enableProposedApi?at:void 0)},registerNotebookContentProvider:(Y,ue,Te,at)=>((0,K.checkProposedApiEnabled)(Re),ht.registerNotebookContentProvider(Re,Y,ue,Te,Re.enableProposedApi?at:void 0)),onDidChangeConfiguration:(Y,ue,Te)=>gn.onDidChangeConfiguration(Y,ue,Te),getConfiguration(Y,ue){return ue=arguments.length===1?void 0:ue,gn.getConfiguration(Y,ue,Re)},registerTextDocumentContentProvider(Y,ue){return Yt.registerTextDocumentContentProvider(Y,ue)},registerTaskProvider:(Y,ue)=>(wt.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),kt.registerTaskProvider(Re,Y,ue)),registerFileSystemProvider(Y,ue,Te){return tn.registerFileSystemProvider(Re.identifier,Y,ue,Te,Re.enableProposedApi)},get fs(){return ct.value},registerFileSearchProvider:(Y,ue)=>((0,K.checkProposedApiEnabled)(Re),At.registerFileSearchProvider(Y,ue)),registerTextSearchProvider:(Y,ue)=>((0,K.checkProposedApiEnabled)(Re),At.registerTextSearchProvider(Y,ue)),registerRemoteAuthorityResolver:(Y,ue)=>((0,K.checkProposedApiEnabled)(Re),ve.registerRemoteAuthorityResolver(Y,ue)),registerResourceLabelFormatter:Y=>((0,K.checkProposedApiEnabled)(Re),Sn.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,ue,Te)=>Nt.onDidCreateFile(Y,ue,Te),onDidDeleteFiles:(Y,ue,Te)=>Nt.onDidDeleteFile(Y,ue,Te),onDidRenameFiles:(Y,ue,Te)=>Nt.onDidRenameFile(Y,ue,Te),onWillCreateFiles:(Y,ue,Te)=>Nt.getOnWillCreateFileEvent(Re)(Y,ue,Te),onWillDeleteFiles:(Y,ue,Te)=>Nt.getOnWillDeleteFileEvent(Re)(Y,ue,Te),onWillRenameFiles:(Y,ue,Te)=>Nt.getOnWillRenameFileEvent(Re)(Y,ue,Te),openTunnel:Y=>((0,K.checkProposedApiEnabled)(Re),mt.openTunnel(Re,Y).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,K.checkProposedApiEnabled)(Re),mt.getTunnels()},onDidChangeTunnels:(Y,ue,Te)=>((0,K.checkProposedApiEnabled)(Re),mt.onDidChangeTunnels(Y,ue,Te)),registerPortAttributesProvider:(Y,ue)=>((0,K.checkProposedApiEnabled)(Re),mt.registerPortsAttributesProvider(Y,ue)),registerTimelineProvider:(Y,ue)=>((0,K.checkProposedApiEnabled)(Re),rn.registerTimelineProvider(Y,ue,Re.identifier,dt.converter)),get isTrusted(){return we.trusted},requestWorkspaceTrust:Y=>((0,K.checkProposedApiEnabled)(Re),we.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,ue,Te)=>we.onDidGrantWorkspaceTrust(Y,ue,Te)},Mn={get inputBox(){return wt.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),Gt.getLastInputBox(Re)},createSourceControl(Y,ue,Te){return Gt.createSourceControl(Re,Y,ue,Te)}},Ln={createCommentController(Y,ue){return yn.createCommentController(Re,Y,ue)}},Nn={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},onDidStartDebugSession(Y,ue,Te){return Et.onDidStartDebugSession(Y,ue,Te)},onDidTerminateDebugSession(Y,ue,Te){return Et.onDidTerminateDebugSession(Y,ue,Te)},onDidChangeActiveDebugSession(Y,ue,Te){return Et.onDidChangeActiveDebugSession(Y,ue,Te)},onDidReceiveDebugSessionCustomEvent(Y,ue,Te){return Et.onDidReceiveDebugSessionCustomEvent(Y,ue,Te)},onDidChangeBreakpoints(Y,ue,Te){return Et.onDidChangeBreakpoints(Y,ue,Te)},registerDebugConfigurationProvider(Y,ue,Te){return Et.registerDebugConfigurationProvider(Y,ue,Te||F.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,ue){return Et.registerDebugAdapterDescriptorFactory(Re,Y,ue)},registerDebugAdapterTrackerFactory(Y,ue){return Et.registerDebugAdapterTrackerFactory(Y,ue)},startDebugging(Y,ue,Te){return!Te||typeof Te=="object"&&"configuration"in Te?Et.startDebugging(Y,ue,{parentSession:Te}):Et.startDebugging(Y,ue,Te||{})},stopDebugging(Y){return Et.stopDebugging(Y)},addBreakpoints(Y){return Et.addBreakpoints(Y)},removeBreakpoints(Y){return Et.removeBreakpoints(Y)},asDebugSourceUri(Y,ue){return Et.asDebugSourceUri(Y,ue)}},wn={registerTaskProvider:(Y,ue)=>kt.registerTaskProvider(Re,Y,ue),fetchTasks:Y=>kt.fetchTasks(Y),executeTask:Y=>kt.executeTask(Re,Y),get taskExecutions(){return kt.taskExecutions},onDidStartTask:(Y,ue,Te)=>kt.onDidStartTask(Y,ue,Te),onDidEndTask:(Y,ue,Te)=>kt.onDidEndTask(Y,ue,Te),onDidStartTaskProcess:(Y,ue,Te)=>kt.onDidStartTaskProcess(Y,ue,Te),onDidEndTaskProcess:(Y,ue,Te)=>kt.onDidEndTaskProcess(Y,ue,Te)},Mt={createNotebookController(Y,ue,Te,at,vt){return Xt.createNotebookController(Re,Y,ue,Te,at,Re.enableProposedApi?vt:void 0)},registerNotebookCellStatusBarItemProvider:(Y,ue)=>ht.registerNotebookCellStatusBarItemProvider(Re,Y,ue),get onDidSaveNotebookDocument(){return(0,K.checkProposedApiEnabled)(Re),jt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,K.checkProposedApiEnabled)(Re),Ht.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return(0,K.checkProposedApiEnabled)(Re),Zt.createRendererMessaging(Y)},onDidChangeNotebookDocumentMetadata(Y,ue,Te){return(0,K.checkProposedApiEnabled)(Re),jt.onDidChangeNotebookDocumentMetadata(Y,ue,Te)},onDidChangeNotebookCells(Y,ue,Te){return(0,K.checkProposedApiEnabled)(Re),ht.onDidChangeNotebookCells(Y,ue,Te)},onDidChangeNotebookCellExecutionState(Y,ue,Te){return(0,K.checkProposedApiEnabled)(Re),ht.onDidChangeNotebookCellExecutionState(Y,ue,Te)},onDidChangeCellOutputs(Y,ue,Te){return(0,K.checkProposedApiEnabled)(Re),ht.onDidChangeCellOutputs(Y,ue,Te)},onDidChangeCellMetadata(Y,ue,Te){return(0,K.checkProposedApiEnabled)(Re),ht.onDidChangeCellMetadata(Y,ue,Te)},createConcatTextDocument(Y,ue){return(0,K.checkProposedApiEnabled)(Re),new pe.ExtHostNotebookConcatDocument(ht,yt,Y,ue)}};return{version:Ye.version,authentication:Pn,commands:An,comments:Ln,debug:Nn,env:pn,extensions:un,languages:Rn,notebooks:Mt,scm:Mn,tasks:wn,test:Tn,window:Fn,workspace:bn,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:h.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:F.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionList:F.InlineSuggestions,Hover:F.Hover,IndentAction:C.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,TextDocumentChangeReason:F.TextDocumentChangeReason,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,UIKind:c.UIKind,Uri:k.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,InlayHint:F.InlayHint,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TextSearchCompleteMessageType:me.TextSearchCompleteMessageType,TestMessageSeverity:F.TestMessageSeverity,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=et}),define(Ee[224],_e([0,1,57,102,32,101,33,71,46,37,105,106,107,73,65,70,103,72,45,69,93,64]),function(te,e,h,R,D,y,k,S,_,C,n,P,c,f,l,o,w,b,E,u,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(o.IExtHostApiDeprecationService,o.ExtHostApiDeprecationService),(0,h.registerSingleton)(S.IExtHostCommands,S.ExtHostCommands),(0,h.registerSingleton)(k.IExtHostConfiguration,k.ExtHostConfiguration),(0,h.registerSingleton)(b.IExtHostConsumerFileSystem,b.ExtHostConsumerFileSystem),(0,h.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService),(0,h.registerSingleton)(y.IExtHostDecorations,y.ExtHostDecorations),(0,h.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,h.registerSingleton)(E.IExtHostFileSystemInfo,E.ExtHostFileSystemInfo),(0,h.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,h.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,h.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,h.registerSingleton)(n.IExtHostTask,n.WorkerExtHostTask),(0,h.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),(0,h.registerSingleton)(l.IExtHostTunnelService,l.ExtHostTunnelService),(0,h.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,h.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,h.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,h.registerSingleton)(g.IExtHostTelemetry,g.ExtHostTelemetry),(0,h.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(Ee[225],_e([0,1,223,34,219,6,16,5,11]),function(te,e,h,R,D,y,k,S,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var C;(function(l){const o=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(b,...E)=>{E.forEach(t=>{if(!self.trustedTypes?.isScript(t))throw new Error("TrustedScripts only, please")});const u=E.slice(0,-1).join(","),g=E.pop().toString();return`(function anonymous(${u}) {
${g}
})`}});function w(...b){return o?self.eval(o.createScript("",...b)):new Function(...b)}l.create=w})(C||(C={}));class n extends D.RequireInterceptor{_installInterceptor(){}getModule(o,w){for(let b of this._alternatives){let E=b(o);if(E){o=E;break}}if(this._factories.has(o))return this._factories.get(o).load(o,w,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends R.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=y.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const o=this._extHostContext.getProxy(S.MainContext.MainThreadConsole);f(o,this._initData.environment.isExtensionDevelopmentDebug);const w=this._instaService.invokeFunction(h.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,w,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(o){return o.browser}async _loadCommonJSModule(o,w,b){w=w.with({path:c(w.path,".js")}),o&&performance.mark(`code/extHost/willFetchExtensionCode/${o.value}`);const E=await fetch(_.FileAccess.asBrowserUri(w).toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o.value}`),E.status!==200)throw new Error(E.statusText);const u=await E.text(),g=`${w.toString(!0)}#vscode-extension`,v=`${u}
//# sourceURL=${g}`;let t;try{t=C.create(P._ttpExtensionScripts?.createScript("module")??"module",P._ttpExtensionScripts?.createScript("exports")??"exports",P._ttpExtensionScripts?.createScript("require")??"require",P._ttpExtensionScripts?.createScript(v)??v)}catch(d){throw console.error(o?`Loading code for extension ${o.value} failed: ${d.message}`:`Loading code failed: ${d.message}`),console.error(`${w.toString(!0)}${typeof d.line=="number"?` line ${d.line}`:""}${typeof d.column=="number"?` column ${d.column}`:""}`),console.error(d),d}const s={},i={exports:s},r=d=>{const m=this._fakeModules.getModule(d,w);if(m===void 0)throw new Error(`Cannot load module '${d}'`);return m};try{return b.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o.value}`),t(i,s,r),i.exports!==s?i.exports:s}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o.value}`),b.codeLoadingStop()}}async $setRemoteEnvironment(o){throw new Error("Not supported")}async _waitForDebuggerAttachment(o=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const w=Date.now()+o;for(;Date.now()<w&&!("__jsDebugIsReady"in globalThis);)await(0,k.timeout)(10)}}e.ExtHostExtensionService=P,P._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:l=>l});function c(l,o){return l.endsWith(o)?l:l+o}function f(l,o){w("info","log"),w("log","log"),w("warn","warn"),w("error","error");function w(u,g){const v=console[u];console[u]=function(){l.$logExtensionHostMessage({type:"__$console",severity:g,arguments:E(arguments)}),o&&v.apply(console,arguments)}}const b=1e5;function E(u){const g=[],v=[];if(u.length)for(let t=0;t<u.length;t++){if(typeof u[t]=="undefined")u[t]="undefined";else if(u[t]instanceof Error){const s=u[t];s.stack?u[t]=s.stack:u[t]=s.toString()}v.push(u[t])}try{const t=JSON.stringify(v,function(s,i){if(i&&typeof i=="object"){if(g.indexOf(i)!==-1)return"[Circular]";g.push(i)}return i});return t.length>b?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(Ee[226],_e([0,1,57,15,34,74,225,212]),function(te,e,h,R,D,y,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(D.IExtHostExtensionService,k.ExtHostExtensionService),(0,h.registerSingleton)(R.ILogService,S.ExtHostLogService),(0,h.registerSingleton)(y.IExtensionStoragePaths,y.ExtensionStoragePaths)}),define(Ee[228],_e([0,1,23,3,180,220,214,14,75,11,2,224,226]),function(te,e,h,R,D,y,k,S,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const P=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const c=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const E=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:g=>g}),u=self.Worker;Worker=function(g,v){/^file:/i.test(g.toString())&&(g=C.FileAccess.asBrowserUri(n.URI.parse(g.toString())).toString(!0));const t=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${g}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;v=v||{},v.name=v.name||S.basename(g.toString());const s=new Blob([t],{type:"application/javascript"}),i=URL.createObjectURL(s);return new u(E?E.createScriptURL(i):i,v)}}else self.Worker=class extends k.NestedWorker{constructor(E,u){super(c,E,{name:S.basename(E.toString()),...u})}};const f=new class{exit(E){P()}async exists(E){return!0}async realpath(E){return E}};class l{constructor(){const u=new MessageChannel,g=new R.Emitter;let v=!1;c(u.port2,[u.port2]),u.port1.onmessage=t=>{const{data:s}=t;if(!(s instanceof ArrayBuffer)){console.warn("UNKNOWN data received",s);return}const i=h.VSBuffer.wrap(new Uint8Array(s,0,s.byteLength));if((0,D.isMessageOfType)(i,2)){v=!0,w("received terminate message from renderer");return}g.fire(i)},this.protocol={onMessage:g.event,send:t=>{if(!v){const s=t.buffer.buffer.slice(t.buffer.byteOffset,t.buffer.byteOffset+t.buffer.byteLength);u.port1.postMessage(s,[s])}}}}}function o(E){return new Promise(u=>{const g=E.onMessage(v=>{g.dispose();const t=JSON.parse(v.toString());E.send((0,D.createMessageOfType)(0)),u({protocol:E,initData:t})});E.send((0,D.createMessageOfType)(1))})}let w=E=>P();function b(){const E=new l;_.mark("code/extHost/willConnectToRenderer"),o(E.protocol).then(u=>{_.mark("code/extHost/didWaitForInitData");const g=new y.ExtensionHostMain(u.protocol,u.initData,f,null);w=v=>g.terminate(v)})}e.create=b})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/807dfb817fef0d0c5729c1924bd4889b04fa405b/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
